-- name=int_button_collectibles
--******************************************************************************************
function public.Init ( pos_z )
  
  ObjAttach( "int_button_collectibles", interface.originhub );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG =  -160
  private.MOVE_ANIM_POS_X_END =  138
  private.MOVE_ANIM_TIME      =  0.6;

  private.show  = false; --на экране или нет
  private.timer = 2; --время таймера
  private.count_collect_item = 0;

  private.WideScreenUpdate();

  ObjMultiSet( {
  { "int_button_collectibles", { pos_z = pos_z } },
  { "obj_int_button_collectibles", { pos_x = private.MOVE_ANIM_POS_X_BEG } },
  { "obj_int_button_collectibles_button", { event_mdown  = private.GoCollectibles, 
                                            event_menter = private.MouseEnter,
                                            event_mleave = private.MouseLeave } }, 
  } );
  
end;
--******************************************************************************************
function public.Destroy ()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( number, name )

  private.count_collect_item = number;
  ObjSet( "obj_int_button_collectibles", { active = true, visible = true, input = true } );
  private.show = true;
  private.ShowAnim( "show", name );  
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_button_collectibles", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_button_collectibles" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position + ( direction * offset );
    ObjSet( "int_button_collectibles", { pos_x = posx } );
    local pos_obj = ObjGet( "obj_int_button_collectibles_other" ).pos_x;
    ObjSet( "obj_int_button_collectibles_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  local type = ng_global.currentprogress;

  if ( event_id == "show" ) then

    ObjSet( "obj_int_button_collectibles", { input = true } );

    if type == "std" and ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 and ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_12" ].shown == 0 and
      ( ng_global[ "gamemode" ] == 0 or ( ng_global[ "gamemode" ] == 3 and ng_global[ "gamemode_custom" ][ "tutorial" ] ) ) then

      common_impl.TutorialShow( "tutorial_page_12" );    

    else

      ObjSet( "tmr_int_button_collectibles_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

    end;

    ObjSet( "pfx_int_button_collectibles_anim", { active = true } );

    PartSysStart( "pfx_int_button_collectibles_anim" );

  elseif ( event_id == "hide" ) then


    ObjSet( "obj_int_button_collectibles", { input = false, active = true, visible = false  } );
  
    ObjSet( "pfx_int_button_collectibles_anim", { active = true } );

  end;
  
end;
--******************************************************************************************
function private.GoCollectibles ()

  ObjSet( "tmr_common_anm", { active = false } );
  local func_end = function()

    common_impl.Lock( false );
    common_impl.EnterBonusRm( "rm_collectibles" );

  end;
  
  if ( common.GetCurrentSubRoom() ) then

     common.CloseSubRoom();
     common_impl.Lock( true );
     ObjSet( "tmr_int_button_collectibles_go_to_rm", { endtrig = func_end, time = 0.3, playing = true } );

  else

    func_end();

  end;

  public.Hide();
  
  common_impl.Tutorial_Click( "empty" );

end;
--******************************************************************************************
function private.ShowAnim ( event_id, name )

  local obj       = "obj_int_button_collectibles";
  local func_end  = function () private.EventAnimEnd( event_id ); end;
  local tme       = private.MOVE_ANIM_TIME;
  local level     = common.GetObjectPrefix( name );


  ObjSet( "obj_int_button_collectibles",                 { visible = true } );
  ObjSet( "txt_int_button_collectibles_button_name", { text = "str_collectibles_name_"..name } );
  ObjSet( "spr_int_button_collectibles_icon",        { res = "assets/interface/int_collect/level"..level.."/"..name } );


  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_show", 0, "", 0 );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  end;

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_collectibles";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;  

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_hide", 0, "", 0 );
  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, ObjGet( obj ).pos_x,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_button_collectibles_hide", { playing = false } );

end;
--******************************************************************************************
function private.MouseEnter ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_collectibles_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  ObjSet( "tmr_int_button_collectibles_hide", { active = false } );

end;
--******************************************************************************************
function private.MouseLeave ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_collectibles_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  ObjSet( "tmr_int_button_collectibles_hide", { active = true } );

end;
--******************************************************************************************