-- name=int_button_collectibles2
--******************************************************************************************
function public.Init ( pos_z )
  
  ObjAttach( "int_button_collectibles2", interface.originhub );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG =  1180;
  private.MOVE_ANIM_POS_X_END =  865;
  private.MOVE_ANIM_TIME      =  0.6;

  private.show  = false; --на экране или нет
  private.timer = 2; --время таймера
  private.count_collect_item = 0;

  private.WideScreenUpdate();

  ObjMultiSet( {
  { "int_button_collectibles2", { pos_z = pos_z } },
  { "obj_int_button_collectibles2", { pos_x = private.MOVE_ANIM_POS_X_BEG } },
  { "obj_int_button_collectibles2_button", { event_mdown  = private.GoCollectibles2, 
                                            event_menter = private.MouseEnter,
                                            event_mleave = private.MouseLeave } },
  { "spr_int_button_collectibles2_back", { event_mdown = public.Hide } } 
  } );
  
end;
--******************************************************************************************
function public.Destroy ()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( name, number )

  private.count_collect_item = number;
  ObjSet( "obj_int_button_collectibles2", { active = true, visible = true, input = true } );
  private.show = true;
  private.ShowAnim( "show", name, number );  
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_button_collectibles2", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_button_collectibles2" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position - ( direction * offset );
    ObjSet( "int_button_collectibles2", { pos_x = posx } );
    local pos_obj = ObjGet( "obj_int_button_collectibles2_other" ).pos_x;
    ObjSet( "obj_int_button_collectibles2_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  local type = ng_global.currentprogress;

  if ( event_id == "show" ) then

    ObjSet( "obj_int_button_collectibles2", { input = true } );

--    if type == "std" and ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 and ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_16" ].shown == 0 and
--      ( ng_global[ "gamemode" ] ~= 2 or ( ng_global[ "gamemode" ] == 3 and ng_global[ "gamemode_custom" ][ "tutorial" ] ) ) then
--
--      --common_impl.TutorialShow( "tutorial_page_16" );    
--
--    else
--
      ObjSet( "tmr_int_button_collectibles2_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

    --end;
    
  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_collectibles2", { input = false, active = true, visible = false  } );

  end;
  
end;
--******************************************************************************************
function private.GoCollectibles2 ()

  ObjSet( "tmr_common_anm", { active = false } );
  local func_end = function()

    common_impl.Lock( false );
    common_impl.EnterBonusRm( "rm_collectibles2" );

  end;
  
  if ( common.GetCurrentSubRoom() ) then

     common.CloseSubRoom();
     common_impl.Lock( true );
     ObjSet( "tmr_int_button_collectibles2_go_to_rm", { endtrig = func_end, time = 0.3, playing = true } );

  else

    func_end();

  end;

  public.Hide();

end;
--******************************************************************************************
function private.ShowAnim ( event_id, name, number )

  local obj       = "obj_int_button_collectibles2";
  local func_end  = function () private.EventAnimEnd( event_id ); end;
  local tme       = private.MOVE_ANIM_TIME;

  ObjSet( "obj_int_button_collectibles2",                 { visible = true } );
  ObjSet( "spr_int_button_collectibles2_icon", { res = "assets/interface/int_collect_2/"..name.."/"..number } )
  --ObjSet( "txt_int_button_collectibles2_button_name", { param0 = name.."_"..number } );
  ObjSet( "txt_int_button_collectibles2_button_name", { param0 = "" } );

  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_show", 0, "", 0 );

  ObjSet( "tmr_int_button_collectibles2_hide", { playing = false } );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  end;

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_collectibles2";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;  

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_hide", 0, "", 0 );
  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, ObjGet( obj ).pos_x,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_button_collectibles2_hide", { playing = false } );

end;
--******************************************************************************************
function private.MouseEnter ()

  SetCursor( CURSOR_HAND );

--  local obj = "spr_int_button_collectibles2_button_focus";
--  local alp = ObjGet( obj ).alp;
--  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;
--
--  ObjAnimate( obj, "alp", 0, 0, "",
--  {
--    0.0, 2, alp,
--    tme, 2, 1
--  } );
--
  ObjSet( "tmr_int_button_collectibles2_hide", { active = false } );

end;
--******************************************************************************************
function private.MouseLeave ()

  SetCursor( CURSOR_DEFAULT );
--
--  local obj = "spr_int_button_collectibles2_button_focus";
--  local alp = ObjGet( obj ).alp;
--  local tme = alp * private.MOUSE_OVER_ANIM_TIME;
--
--  ObjAnimate( obj, "alp", 0, 0, "",
--  {
--    0.0, 1, alp,
--    tme, 1, 0
--  } );

  ObjSet( "tmr_int_button_collectibles2_hide", { active = true } );

end;
--******************************************************************************************
--ObjAnimate( "spr_int_button_collectibles2_icon", "alp", 1, 0, "", { 0,0,1, 0.5,0,0.5, 1,0,1 } );
