-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = -1;
  public.POSITION = 70;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

  ObjSet("spr_int_button_map_button", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_map_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_navigate_map_open", 0, "", 0 );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_map_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_navigate_map_close", 0, "", 0 );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_button_map_impl", { pos_x = public.POSITION } );
  
  else

    ObjSet( "int_button_map_impl", { pos_x = public.POSITION - 171 } );

  end;

end;
--******************************************************************************************