-- name=int_button_mini_ho
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_mini_ho", "obj_int_frame_subroom_panel_ho" );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.DIRECTION = 0;
  private.MOVE_ANIM_TIME = 0.6;

  private.hint_array = {};
  private.MOVE_ANIM_POS_X = 150;
  private.WideScreenUpdate();

  ObjMultiSet({
    { "int_button_mini_ho", { pos_z = pos_z }},
    { "obj_int_button_mini_ho_root", { alp = 0 }},
    { "obj_int_button_mini_ho", { pos_x = private.MOVE_ANIM_POS_X_BEG }},
  });

end;

--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate()

end;


--******************************************************************************************
function public.Show ( task, ho_name, item_count, task_name, obj_array, height, noDialog )

  --common_impl.PlayAudio( "env", "aud_new_ho_env" );

  local back_params = ObjGet( "zz_"..ho_name );

  local pos_y = height or -60;
    
  ObjSet( "obj_int_button_mini_ho_crop", {  croprect_x = -( back_params.draw_width / 2 ), pos_x = 0, pos_y = pos_y } );
  ObjSet( "obj_int_button_mini_ho_root", { pos_y = back_params.draw_height / 2 - 55 } );

  private.MOVE_ANIM_POS_X_BEG = -65 - back_params.draw_width / 2;
  private.MOVE_ANIM_POS_X_END = private.MOVE_ANIM_POS_X_BEG + private.MOVE_ANIM_POS_X;

  if not ng_global.progress[ ng_global.currentprogress ][ task ].found then 

    ng_global.progress[ ng_global.currentprogress ][ task ].found = {};

  end; 

  ObjSet( "obj_int_button_mini_ho_root", { alp = 1, visible = true, input = false, active = true, } );

  ObjSet( "txt_int_button_mini_ho_task", { text = task_name } );

  local item_found = ng_global.progress[ ng_global.currentprogress ][ task ].found;
  local text_value = #item_found.."/"..item_count;
  ObjSet( "txt_int_button_mini_ho_count", { text = text_value } );

  for i = 1, #item_found, 1 do

    ObjDelete( item_found[ i ] );

  end;

  private.hint_array = obj_array;
  public.RefreshHint( task );

  private.ShowAnim(); 
  private.CheckWin( task, ho_name, item_count, true, noDialog ); 

end;
--******************************************************************************************
function public.Hide ()

  common_impl.StopAudio( "env", "aud_new_ho_env" );

  local pfx_found_objects = ObjGetRelations( "obj_int_button_mini_ho" );

  if pfx_found_objects.childs then
    
    for i = 1, #pfx_found_objects.childs, 1 do 

      local cur_pfx = pfx_found_objects.childs[ i ];

      if common.GetObjectPrefix( cur_pfx ) == "pfx" then 
      
        ObjDelete( cur_pfx );

      end;
      
    end;
    
  end;

  private.HideAnim(); 

end;
--******************************************************************************************
function public.UpdateLocation ( task, picture_loc, zz_picture_show )

  if ( task ) then

    local item_found = ng_global.progress[ ng_global.currentprogress ][ task ].found;

    if ( item_found ) then

      for i = 1, #item_found, 1 do

        ObjDelete( picture_loc.."_"..private.GetNumberByName( item_found[ i ] ) );
      
      end;

    end;

  end;

end;
--******************************************************************************************
function private.GetNumberByName ( name )

  local reverse_name = string.reverse( name );

  return string.sub( reverse_name, 1, 1 );

end;
--******************************************************************************************
function public.RefreshHint ( task )

  local prefix = common.GetObjectPrefix( task );
  local field = "use_place";

  if prefix == "get" then 

    field = "get_obj";

  end; 

  local item_found = ng_global.progress[ ng_global.currentprogress ][ task ].found;

  for i = 1, #private.hint_array, 1 do 

    local isItemFound = false;

    for j = 1, #item_found, 1 do 

      if private.hint_array[ i ] == item_found[ j ] then 

        isItemFound = true;
        break;

      end; 

    end;

    if not isItemFound then 

      common_impl.hint[ task ][ field ] = private.hint_array[ i ];

      break;

    end;

  end; 

end;


--******************************************************************************************
function public.MiniHoTaskFind ( task, ho_name, item, item_count, picture_loc, noDialog )

  local func_end = function ()

    private.CheckWin( task, ho_name, item_count, nil, noDialog );

  end;

  common_impl.Lock( true );
  
  local sound_number = math.random( 1,3 ); 

  common_impl.PlayAudio( "sfx", "common/audio/aud_hoclk"..sound_number.."_sfx", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_hide", 0, "", 0 );
  
  table.insert( ng_global.progress[ ng_global.currentprogress ][ task ].found, item ); 

  local item_found = ng_global.progress[ ng_global.currentprogress ][ task ].found;
  local textValue = #item_found.."/"..item_count;
  ObjSet( "txt_int_button_mini_ho_count", { text = textValue } );

  ObjAnimate( item, "alp",0,0, func_end, { 0, 0, 1,    0.5, 0, 0 } );
  private.CreateParticles( item ); 

  public.RefreshHint( task );

  if ( picture_loc ) then

    ObjDelete( picture_loc );

  end;

end; 


--******************************************************************************************
function private.CreateParticles ( item )

  local pfx_mini_ho  = "pfx_"..common.GetObjectName( item ).."_mini_ho";
  local pfx_mini_ho_drawoff_x = ObjGet( item ).drawoff_x;
  local pfx_mini_ho_drawoff_y = ObjGet( item ).drawoff_y;

  ObjCreate( pfx_mini_ho, "partsys" );
  
  ObjSet( pfx_mini_ho,
  {
    res = "assets/interface/resources/effects_ho",
    pos_x = pfx_mini_ho_drawoff_x, pos_y = pfx_mini_ho_drawoff_y, pos_z = 10, 
    alp = 1, active = 1, visible = 1, input = 0
  } );

  ObjAttach( pfx_mini_ho, "obj_int_button_mini_ho_items" ); 
  
  ObjSet( pfx_mini_ho,
  {
    blendmode = 2
  } );
  
  local item_pos = GetObjPosByObj( item, "obj_int_button_mini_ho_items" ); 
  ObjSet( item, { input = false, pos_x = item_pos[ 1 ], pos_y = item_pos[ 2 ] } );
  ObjAttach( item, "obj_int_button_mini_ho_items" ); 

  if ( item ) then
    PartSysSetMaskObj( pfx_mini_ho, item ); 
  end;
  
  ObjAnimate( "obj_int_button_mini_ho_items", "alp",0,0, "",
    { 
        0.0, 0, 1,
        0.5, 0, 1,
        1.0, 0, 0
    } );
 
end;
--******************************************************************************************
function private.CheckWin ( task, ho_name, item_count, not_lock, noDialog )

  local item_found = ng_global.progress[ ng_global.currentprogress ][ task ].found;

  if ( #item_found == item_count ) then 

    if ( not cmn.IsEventDone( task ) ) then 

      local noShowDialog = false;
      if ( noDialog == true ) then
        noShowDialog = noDialog;
      end;
      
      if ( noShowDialog ) then
        
        common_impl.Lock( false );

        cmn.SetEventDone( task ); 
        public.Hide(); 
  
        if _G[ GetCurrentRoom() ][ task ] then

          _G[ GetCurrentRoom() ][ task ]();

        end;  
        
        cmn.CallEventHandler( task, GetCurrentRoom() );
       
      else
        
        public.DialogHo_Show( ho_name, task );
        
        if _G[ GetCurrentRoom() ].MiniHoWinFunction then

          _G[ GetCurrentRoom() ].MiniHoWinFunction();

        end;  
          
      end;

    end;

  else 

    if not not_lock then

      common_impl.Lock( false );

    end;

  end; 

end; 
--******************************************************************************************
function public.DialogHo_Show ( ho_name, task )

  cmn.SetEventDone( task ); 

  local ho_win_item = "spr_"..ho_name.."_win";
  int_dialog_ho.Show( ho_win_item );
  public.Hide(); 

  ObjSet( "obj_int_dialog_ho_button", { event_mdown = function() public.DialogHo_Hide( task ); end; } );
  ObjSet( "obj_int_dialog_ho", { event_mdown = function() public.DialogHo_Hide( task ); end; } );
  ObjSet( "obj_int_dialog_ho_focus", { event_mdown = function() public.DialogHo_Hide( task ); end; } );

  common_impl.PlayAudio("sfx","aud_win_miniho");

  local func_end = function ()

    common_impl.Lock( false );

  end; 

  ObjAnimate( "obj_int_button_mini_ho_items", "scale_x",0,0, func_end, { 0, 0, 1,    0.6, 0, 1 } );
 
end;


--******************************************************************************************
function public.DialogHo_Hide ( task )

  common_impl.PlayAudio("sfx","aud_get_inv_sfx");
 
  cmn.CallEventHandler( task, GetCurrentRoom() );
 
  if _G[ GetCurrentRoom() ][ task ] then

    _G[ GetCurrentRoom() ][ task ]();

  end;
  
  int_dialog_ho.Hide(); 

  ObjSet( "obj_int_dialog_ho_button", { event_mdown = function() int_dialog_ho.MouseDown(); end; } );
  ObjSet( "obj_int_dialog_ho", { event_mdown = function() int_dialog_ho.MouseDown(); end; } );
  ObjSet( "obj_int_dialog_ho_focus", { event_mdown = function() int_dialog_ho.MouseDown(); end; } );

end;
--******************************************************************************************
function private.ShowAnim ()

  local obj = "obj_int_button_mini_ho";
  local func_end = "";
  local time = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 2, private.MOVE_ANIM_POS_X_BEG,
    time, 2, private.MOVE_ANIM_POS_X_END
  } );

end;


--******************************************************************************************
function private.HideAnim ()

  local obj = "obj_int_button_mini_ho";
  local time = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  local func_end = function ()

    ObjSet( "obj_int_button_mini_ho_root", { alp = 0, visible = false, input = false, active = false, } );

  end;

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 2, private.DIRECTION*offset + private.MOVE_ANIM_POS_X_END,
    time, 2, private.DIRECTION*offset + private.MOVE_ANIM_POS_X_BEG
  } );

end;

















