-- name=int_button_morph
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_morph", interface.originhub );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.collect_loaded = false;

  private.DIRECTION =  -1;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_POS_X_BEG =   -250;
  private.MOVE_ANIM_POS_X_END =   102;
  private.MOVE_ANIM_TIME      =  0.6;
  private.show  = false; --на экране или нет
  private.timer = 2; --время таймера

  private.WideScreenUpdate();

  ObjMultiSet({
    { "int_button_morph", { pos_z = pos_z } },
    { "obj_int_button_morph", { pos_x = private.MOVE_ANIM_POS_X_BEG }},
  });

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( count )

  ObjSet( "obj_int_button_morph", { active = true, visible = true, input = true } );
  private.show = true;
  ng_global.morph.objects_count = count;
  private.ShowAnim( "show");
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_button_morph", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_button_morph" ) then
   
    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;
    local posx = position + ( direction * offset );
    local pos_obj = ObjGet( "obj_int_button_morph_other" ).pos_x;

    ObjSet( "int_button_morph", { pos_x = posx } );
    ObjSet( "obj_int_button_morph_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  local type = ng_global.currentprogress;

  if ( event_id == "show" ) then

    ObjSet( "obj_int_button_morph", { input = true } );

    if type == "std" and ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 and ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_11" ].shown == 0 and
      ( ng_global[ "gamemode" ] == 0 or ng_global[ "gamemode" ] == 3 and ng_global[ "gamemode_custom" ][ "tutorial" ] ) then

      common_impl.TutorialShow( "tutorial_page_11" );

    else

      ObjSet( "tmr_int_button_morph_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

    end;
    
  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_morph", { input = false, active = true, visible = false } );

  end;
  
end;
--******************************************************************************************
--******************************************************************************************
function private.ShowAnim ( event_id )

  local obj       = "obj_int_button_morph";
  local tme       = private.MOVE_ANIM_TIME;

  private.SetCounter( ng_global.morph.objects_count );

  ObjSet( "obj_int_button_morph", { alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "tmr_int_button_morph_hide", { playing = false } );

  ObjSet( "txt_int_button_morph_num_coins_unit", { pos_y = 0 } );
  ObjSet( "txt_int_button_morph_num_coins_scores", { pos_y = 0 } );

  local func_show_end = function ()

    private.ShowAnimCounter( ng_global.morph.objects_count );
    private.EventAnimEnd( event_id );

  end;

  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_show", 0, "", 0 );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  end;

end;
--******************************************************************************************
function private.SetCounter ( object_count )

  local units_old  = ( object_count - 1 ) % 10;
  local scores_old = ( object_count - 1 - units_old ) / 10;

  ObjSet( "txt_int_button_morph_num_coins_unit",   { text = units_old } );
  ObjSet( "txt_int_button_morph_num_coins_scores", { text = scores_old } );

end;
--******************************************************************************************
function private.ShowAnimCounter ( object_count )

  local units_old  = ( object_count - 1 ) % 10;
  local scores_old = ( object_count - 1 - units_old ) / 10;

  local units_new  = object_count % 10;
  local scores_new = ( object_count - units_new ) / 10;

  ObjClone( "txt_int_button_morph_num_coins_unit", "_2", 1, "obj_int_button_morph_button_crop" );

  ObjSet( "txt_int_button_morph_num_coins_unit",   { text = units_old } );
  ObjSet( "txt_int_button_morph_num_coins_unit_2", { text = units_new } );

  local func_anim_end = function ()

    ObjDelete( "txt_int_button_morph_num_coins_unit_2" );

    ObjSet( "txt_int_button_morph_num_coins_unit",        { pos_y = 0,  } );
    ObjSet( "txt_int_button_morph_num_coins_unit", { text = units_new } );

  end;

  ObjAnimate( "txt_int_button_morph_num_coins_unit",   "pos_y", 0, 0, func_anim_end, { 0,0,0,  0.4,0,70 } );
  ObjAnimate( "txt_int_button_morph_num_coins_unit_2", "pos_y", 0, 0, "", { 0,0,-70,  0.4,0,0 } );

  if ( scores_old ~= scores_new ) then

    ObjClone( "txt_int_button_morph_num_coins_scores", "_2", 1, "obj_int_button_morph_button_crop" );

    ObjSet( "txt_int_button_morph_num_coins_scores",   { text = scores_old } );
    ObjSet( "txt_int_button_morph_num_coins_scores_2", { text = scores_new } );

    local func_anim_2_end = function ()

      ObjDelete( "txt_int_button_morph_num_coins_scores_2" );

      ObjSet( "txt_int_button_morph_num_coins_scores",          { pos_y = 0,  } );
      ObjSet( "txt_int_button_morph_num_coins_scores", { text = scores_new } );

    end;

    ObjAnimate( "txt_int_button_morph_num_coins_scores",   "pos_y", 0, 0, func_anim_2_end, { 0,0,  0,  0.4,0,70 } );
    ObjAnimate( "txt_int_button_morph_num_coins_scores_2", "pos_y", 0, 0, "", { 0,0,-70,  0.4,0,0 } );

  end;

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_morph";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;
  local current_posx  = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_hide", 0, "", 0 );  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, current_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG

  } );

  ObjSet( "tmr_int_button_morph_hide", { playing = false } );

end;
--******************************************************************************************
--******************************************************************************************