-- name=int_button_phone
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_phone", interface.originhub );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.active     = false;
  private.func_mdown = nil;
  private.self_call = false;
  private.contact = "";

  public.show = false;

  private.DIRECTION =  -1;
  public.POSITION = 948;
  private.SHOW_ANIM_TIME = 0.6;

  private.BIGPHONE_ANIM_COORD_START = { -300, 800 };
  private.BIGPHONE_ANIM_COORD_END   = { -441, 208 };

  private.WideScreenUpdate();

  ObjMultiSet({
    { "int_button_phone", { pos_z = 30 } },
  });

  private.functions = { 
                        { room = "rm_hall",           prev_event = "see_intro",       event = "dlg_hall_first_calling",           self = false  },
                       };
 
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show()

  ObjSet( "obj_int_button_phone_button", { active = true, visible = true, input = true } );

  private.ShowAnim();
  
end;
--******************************************************************************************
function public.Hide()

  ObjSet( "obj_int_button_phone", { input = false } );

  private.HideAnim();

end;
--******************************************************************************************
function private.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    ObjSet( "int_button_phone", { pos_x = public.POSITION } );
  else
    ObjSet( "int_button_phone", { pos_x = public.POSITION + 171 } );
  end;

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_button_phone", { input = true } );

    public.CheckFunction();

    public.show = true;
   
  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_phone", { input = false, active = true, visible = false } );

    public.show = false;

  end;
  
end;
--******************************************************************************************
--******************************************************************************************
function private.ShowAnim()

  local obj       = "obj_int_button_phone";
  local tme       = private.SHOW_ANIM_TIME;

  local func_show_end = function ()
   
    private.EventAnimEnd( "show" );

  end;
 
  ObjAnimate( obj, "alp", 0, 0, func_show_end,
  {
    0.0, 2, 0,
    tme, 2, 1

  } );

end;
--******************************************************************************************
function private.HideAnim()

  local obj       = "obj_int_button_phone";
  local tme       = private.SHOW_ANIM_TIME;

  local func_hide_end = function ()

    private.EventAnimEnd( "hide" );

  end;
 
  ObjAnimate( obj, "alp", 0, 0, func_hide_end,
  {
    0.0, 2, 1,
    tme, 2, 0

  } );

end;
--******************************************************************************************
function private.CallAnimStart()
  
  local room = common.GetCurrentRoom();

  ObjMultiSet( { { "spr_int_button_phone_no_active", { visible = false } },
                 { room, { input = false } },
                 { "anm_int_button_phone", { alp = 1 } }
             } );

  common_impl.InterfaceSetVisible( false, true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_call_mobilephone", 1, "", 0 );
  
  AnimPlay( "anm_int_button_phone", "DoAnim", "" );

  private.active = true;

  private.Update();
 
end;
--******************************************************************************************
function private.SelfCallAnimStart()
  
  local room = common.GetCurrentRoom();

  ObjMultiSet( { { "spr_int_button_phone_no_active", { visible = false } },
                 { room, { input = false } },
                 { "anm_int_button_phone_self", { alp = 1 } }
             } );

  common_impl.InterfaceSetVisible( false, true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_call_ready", 1, "", 0 );
  AnimPlay( "anm_int_button_phone_self", "DoAnim", "" );

  private.active = true;
  private.self_call = true;

  private.Update();
 
end;
--******************************************************************************************
--******************************************************************************************
function public.CheckFunction()
  
  local room = common.GetCurrentRoom();

  for i = 1, #private.functions do

    if private.functions[i].room == room and cmn.IsEventDone( private.functions[i].prev_event ) and not cmn.IsEventDone( private.functions[i].event ) then
   
      private.func_mdown = private.functions[i].event;  

      if not private.functions[i].self then     
 
        private.CallAnimStart();

      else

        private.contact = private.functions[i].contact;

        private.SelfCallAnimStart();

      end;

      break;

    end;

  end;

end;
--******************************************************************************************
function private.PhoneMouseDown()

  if private.func_mdown then

    common_impl.StopAudio( "sfx", "common/audio/aud_call_mobilephone", 0.5 );

    AnimStop( "anm_int_button_phone" );

    ObjMultiSet( { { "spr_int_button_phone_no_active", { visible = true } },
                    { "anm_int_button_phone", { alp = 0 } },
                    { "anm_int_button_phone_self", { alp = 0 } }
               } );

    private.active = false;

    private.Update();

    if not private.self_call then

      common_impl.InterfaceSetVisible( false );  
   
      private.PhoneDlgStart();
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_call_shaman", 0, "", 0 );

    else

      common_impl.StopAudio( "sfx", "common/audio/level3/aud_call_ready", 1, "", 0 );
      private.BigPhoneShow();

    end;

    int_blackbartext.MouseDown();

  end;

end;
--******************************************************************************************
function private.PhoneDlgStart()

  local room = common.GetCurrentRoom();

  if private.func_mdown == "dlg_eskimosettlement_4_five_calling" then

    room = "rm_eskimosettlement_4";

  end;
  
  _G[room][private.func_mdown]();

  common_impl.PlayAudio( "sfx", "common/audio/aud_call_get", 0, "", 0 );

  int_phone.Show();

end;
--******************************************************************************************
function private.Update()

  if private.active == false then

    ObjSet( "obj_int_button_phone_answer", { input = false } );

  else

    ObjSet( "obj_int_button_phone_answer", { event_mdown = private.PhoneMouseDown, input = true } );

  end;

end;
--*********************************************************************************************************************
-- function *** BIG PHONE *** () end;
--*********************************************************************************************************************

function private.BigPhoneShow()

  ObjSet( "obj_int_button_phone_big", { alp = 1 } );
  
  ObjSet( GetCurrentRoom(), { input = false } );

  private.BigPhoneShowAnim();

  common_impl.InterfaceSetVisible( false );  

end;
--******************************************************************************************
function private.BigPhoneShowAnim()

  local trg = function() private.BigPhoneEventAnimEnd( 'show' ); end;

  ObjMultiSet( { { "anm_int_button_phone_self", { alp = 0 } },
                 { "spr_int_button_phone_no_active", { alp = 0 } },
                 { "spr_int_button_phone_back", { alp = 0 } }               
              } )

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_take_phone", 0, "", 0 );
  ObjAnimate( "obj_int_button_phone_big", "pos_xy", 0, 0, trg, { 0.0,0,private.BIGPHONE_ANIM_COORD_START[1],private.BIGPHONE_ANIM_COORD_START[2],
                                                                 0.3,0,private.BIGPHONE_ANIM_COORD_END[1],private.BIGPHONE_ANIM_COORD_END[2] } );

end;
--******************************************************************************************
function private.BigPhoneHideAnim( call )

  local trg = function() private.BigPhoneEventAnimEnd( 'hide', call ); end;

  ObjAnimate( "obj_int_button_phone_big", "pos_xy", 0, 0, trg, { 0.0,0,private.BIGPHONE_ANIM_COORD_END[1],private.BIGPHONE_ANIM_COORD_END[2],
                                                                 0.3,0,private.BIGPHONE_ANIM_COORD_START[1],private.BIGPHONE_ANIM_COORD_START[2] } );

end;
--******************************************************************************************
function private.BigPhoneEventAnimEnd( event_id, call )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_button_phone_big", { input = true } );

    if ng_global.phone and ng_global.phone.contacts then

      for i = 1, #ng_global.phone.contacts do

        ObjSet( "obj_int_button_phone_big_contact_"..i, {

          input = true, 
          event_menter = function() private.BigPhoneContactMouseEnter( "spr_int_button_phone_big_"..ng_global.phone.contacts[i].."_focus" ); end,
          event_mleave = function() private.BigPhoneContactMouseLeave( "spr_int_button_phone_big_"..ng_global.phone.contacts[i].."_focus" ); end,
          event_mdown  = function() private.BigPhoneContactMouseDown( ng_global.phone.contacts[i] ) end   } );      

      end;    

    end; 
     
  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_phone_big", { input = false } );
   
    ObjSet( GetCurrentRoom(), { input = true } );

    if call then

      private.PhoneDlgStart();

    end;

  end;
  
end;
--******************************************************************************************
function private.BigPhoneContactMouseDown( contact )

  if contact == private.contact then  

    private.self_call = false;
    private.contact = "";

    private.BigPhoneHideAnim( true )

  end;

end;
--******************************************************************************************
function private.BigPhoneContactMouseEnter( obj )

   local tme = 0.3;

   SetCursor( CURSOR_HAND );

   local alp = ObjGet( obj ).alp;

   common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

   ObjAnimate( obj, "alp", 0, 0, "", 
   { 
     0.0,              0, alp, 
     tme *( 1 - alp ), 0, 1
   } );

end;
--******************************************************************************************
function private.BigPhoneContactMouseLeave( obj )

  local tme = 0.3;

  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp, 
    tme * alp , 0, 0
  } ); 

end;
--******************************************************************************************
--******************************************************************************************