-- name=int_button_skip_impl
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION = 930;

  private.RELOAD_VID_FRAME_COUNT =  3600;
  private.RELOAD_ANIM_FRAME_COUNT = 3600;
  private.RELOAD_BEGIN_ANIM_TIME  = 0;

  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_skip_button", {
    event_mdown = int_button_skip.MouseDown,
    event_menter = function () common_impl.DialogButtonMouseEnter( "int_button_skip_button", true ) end,
    event_mleave = function () common_impl.DialogButtonMouseLeave( "int_button_skip_button" ) end
  });

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    ObjSet( "int_button_skip_impl", { pos_x = public.POSITION } );
  else
    ObjSet( "int_button_skip_impl", { pos_x = public.POSITION + 171 } );
  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_skip_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_skip_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.ChangeToStatic()

    ObjSet( "obj_int_button_skip_reload", { active = false, visible = false } );
    ObjSet( "anm_int_button_skip_active_timer", { frame = 0, active = false, visible = false } );
    ObjSet( "obj_int_button_skip_static", { active = true, visible = true } );
    ObjSet( "anm_int_button_skip_static", { active = true, visible = true } );
    AnimPlay( "anm_int_button_skip_static", "DoAnim", "" );
    ObjSet( "anm_int_button_skip_loader", { active = false, visible = false } );
    ObjSet( "tmr_int_button_skip_reload", { playing = false } );
 
end;
--******************************************************************************************
function public.ChangeToReload( is_begin )

  AnimStop( "anm_int_button_skip_static" );
  ObjSet( "obj_int_button_skip_static", { active = false, visible = false } );
  ObjSet( "anm_int_button_skip_loader", { active = false, visible = false, frame = 0 } );
  ObjSet( "obj_int_button_skip_reload", { active = true, visible = true } );
  ObjSet( "anm_int_button_skip_active_timer", { active = true, visible = true } );

  if ( is_begin ) then

    private.ReloadAnim( true );

  else

    private.ReloadAnim( false );

  end;

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )

  if ( is_hardcore ) then

    ObjSet( "obj_int_button_skip_active",   { visible = false } );
    --ObjSet( "spr_int_button_skip_back",   { visible = false } );
    ObjSet( "obj_int_button_skip_hardcore", { active = true, visible = true } );

  else

    ObjSet( "obj_int_button_skip_hardcore", { active = false, visible = false } );
    --ObjSet( "spr_int_button_skip_back",   { visible = true } );
    ObjSet( "obj_int_button_skip_active",   { visible = true } );

  end;

end;
--******************************************************************************************
function private.ReloadAnim( is_first )

  if ( is_first ) then

    --ObjSet( "anm_int_button_skip_loader",       { active = true, visible = true } );

  end;

  if ( not ObjGet( "tmr_int_button_skip_reload" ) ) then
    return;
  end;

  local time_min    = int_button_skip.GetTimeMin();
  local time_remain = int_button_skip.GetTimeRemain();
  local time_full   = int_button_skip.GetTimeFull();
  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;

  -- время на один фрейм
  local time_frame = time_full / frame_count;
 
  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );

  ObjSet( "anm_int_button_skip_active_timer", { frame = ( frame_current * 275 ) } );

  ObjSet( "anm_int_button_skip_loader", { frame = 0 } );

  ObjSet( "tmr_int_button_skip_reload", { endtrig = "" });
 
  if ( time_current < time_full ) then

    local trg = function ()

      private.ReloadAnim();

    end;

    ObjSet( "tmr_int_button_skip_reload_anim", { endtrig = trg, time = time_min, playing = true } );

  else

    local func_after = function()

      int_button_skip.EventAnimEnd( 'reload' );
      public.ChangeToStatic();

    end;
      
    ObjSet( "anm_int_button_skip_active_timer", { active = false, visible = false } );
    ObjSet( "anm_int_button_skip_loader", { active = true, visible = true } );
    AnimPlay( "anm_int_button_skip_loader", "DoAnim", func_after );

    local is_hardcore = ( common.GetGameMode() == 2 ) or ( common.GetGameMode() == 3 and not ng_global.gamemode_custom[ "skip" ] );

    if not is_hardcore then
  
      PlaySfx( "assets/levels/common/audio/aud_hinton", 0, "", 0 );

    end;
   
  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  if ( GetPerformanceMode() == 0 ) then

    local obj = "anm_int_button_skip_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 0.5
    } );

  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  if ( GetPerformanceMode() == 0 ) then

    local obj = "anm_int_button_skip_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;

end;
--******************************************************************************************
function public.StartAnimReloadBegin()

  ObjSet( "anm_int_button_skip_active_timer", { frame = 0 } );
  ObjSet( "anm_int_button_skip_loader", { active = false, visible = false } );  
  ObjSet( "anm_int_button_skip_close", { active = true, visible = true } );
  ObjSet( "anm_int_button_skip_static", { active = false, visible = false } );    
  ObjSet( "anm_int_button_skip_close", { alp = 1 } );
  AnimStop( "anm_int_button_skip_close" );
 
  local func_after = function()

    ObjSet( 'anm_int_button_skip_close', { active = false, visible = false } );
  
  end;

  AnimPlay( "anm_int_button_skip_close", "DoAnim", func_after );

end;