-- name=int_button_timer
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_timer", interface.originhub );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  ObjSet( "int_button_timer", { pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.5;
  private.DIRECTION =  -1;

  ObjSet( "obj_int_button_timer", 
  {
    event_mdown = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );
  
  private.WideScreenUpdate();
  --private.len_range = 76; --до первой черты на шкале
  --private.len_fill = 2; -- 2 пикселя - ширина заполняемой полоски

  private.len_range = 138; --размер стороны изображения таймера 1, которая кропается
  private.len_range_ex = 64; --размер стороны изображения таймера 2, которая кропается
  private.time_diff = 0.3 --добавляется 30% времени
  
  ObjAttach( "tmr_int_button_timer", "cmn_timers" );
  ObjAttach( "tmr_int_button_timer_extra", "cmn_timers" );

end;
--******************************************************************************************
function public.Destroy ()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_button_timer" ) then
   
    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;
    local posx = position + ( direction * offset );
    ObjSet( "int_button_timer", { pos_x = posx } );

  end;

end;
--******************************************************************************************
function private.MouseDown ()

  --

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  --common_impl.DialogButtonMouseEnter( "int_button_timer" );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  --common_impl.DialogButtonMouseLeave( "int_button_timer" );

end;
--******************************************************************************************
function public.Update ()

  --

end;
--******************************************************************************************
function public.GetTime()

  local time;
  local extra;
  local tme;

  local name_room = GetCurrentRoom();
  local not_prefix = common.GetObjectName( name_room );

  time = math.floor ( ObjGet( "tmr_int_button_timer" ).time );
  extra = math.ceil ( ObjGet( "tmr_int_button_timer_extra" ).time );

  if name_room ~= "rm_mysteryroom" then

    ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.time = time;
    ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.extra = extra;

  else

    return;

  end;
  -------------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------------
  local hours = math.floor( time / 3600 );
  local minuts = math.floor( ( ( time - hours * 3600 ) / 60 ) );
  local seconds = math.ceil( time - hours * 3600 - minuts * 60 );

  ObjSet( "txt_int_button_timer_hours", { text = hours } );
  ObjSet( "txt_int_button_timer_minuts", { text = minuts } );
  ObjSet( "txt_int_button_timer_seconds", { text = seconds } );

  local scale_fill = 1;

  local time_all = ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default + ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default * private.time_diff;
  local koef = extra / ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default;

  local local_time = time / ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default;

  --scale_fill = ( private.len_range / private.len_fill ) * koef;

  --DbgTrace( "scale_fill = "..scale_fill.." koef = "..koef );
  --ObjSet( "spr_int_button_timer_fill", { scale_x = scale_fill } );
  
  --value =  ( ( length * local_time ) - ( length / 2 ) ) * 2 ;    
--                   69                                              

  local t_def = ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default;
  local t_time = ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.time;

  local new_koef = ( ( t_time - ( t_def / 2 ) ) / t_def ) * 2;--формула получения коеффициента диапазона -1..1
  local value = ( private.len_range / 2 ) * new_koef;                                                 


  --DbgTrace( "value = "..value.." koef = "..koef.." new_koef = "..new_koef );
  ObjSet( "spr_int_button_timer_time", { croprect_y = value } );
  
  if koef >= 1 and extra <= time_all then

    local t_def = time_all - ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default;
    local diff = extra - ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default;
    local koef_ex = ( ( ( t_def - diff ) - ( t_def / 2 ) ) / t_def ) * 2;
    
    --DbgTrace( "koef_ex "..koef_ex );

    local value_ex = ( private.len_range_ex / 2 ) * koef_ex;

    --DbgTrace( "value_ex "..value_ex );
    ObjSet( "spr_int_button_timer_time_2", { croprect_y = value_ex } );
  
  end;

  if extra >= time_all then

    local value_ex = ( - 1 ) *( private.len_range_ex / 2 )
    ObjSet( "spr_int_button_timer_time_2", { croprect_y = value_ex } );
    ObjSet( "tmr_int_button_timer_extra", { active = false, playing = false } );
    return;

  else

    --local value_ex = ( private.len_range_ex / 2 )
    --ObjSet( "spr_int_button_timer_time_2", { croprect_y = value_ex } );

  end;

  ObjAnimate( "txt_int_button_timer_seconds", "alp", 0, 0, function () public.GetTime() end,
  {
    0.0, 0, 1.0,
    1.0, 0, 1.0
  } );

end;
--******************************************************************************************
function private.StartTimer()

  local name_room = GetCurrentRoom();
  local not_prefix = common.GetObjectName( name_room );
  local var_time =  ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.time;
  local var_extra = ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.extra;

  ObjSet( "tmr_int_button_timer", { time = var_time } );
  ObjSet( "tmr_int_button_timer_extra", { time = var_extra } );

  local value_ex = ( private.len_range_ex / 2 )
  ObjSet( "spr_int_button_timer_time_2", { croprect_y = value_ex } );
    
  public.GetTime();

end;
--******************************************************************************************
function public.Show ()

  ObjSet( "obj_int_button_timer", { active = true, visible = true, input = true } );
  private.StartTimer();
  private.show = true;
  private.ShowAnim( "show");
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_button_timer", { input = false } );
  private.show = false;
  ObjSet( "tmr_int_button_timer",       { playing = false, active = false } );
  ObjSet( "tmr_int_button_timer_extra", { playing = false, active = false } );
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.ShowAnim ( event_id )

  local obj       = "obj_int_button_timer";
  local tme       = private.MOVE_ANIM_TIME;

  local func_show_end = function ()

    private.EventAnimEnd( event_id );

  end;

  ObjAnimate( obj, "alp", 0, 0, func_show_end, 
  { 
    0.0, 0, 0.0, 
    tme, 0, 1.0 
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_timer";
  local func_end      = function () private.EventAnimEnd( event_id ) end;
  local tme           = private.MOVE_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1.0, 
    tme, 0, 0.0 
  } );

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "tmr_int_button_timer",       { playing = true, active = true } );
    ObjSet( "tmr_int_button_timer_extra", { playing = true, active = true } );
    
  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_timer", { input = false, active = true, visible = false } );

  end;
  
end;
--******************************************************************************************


