-- name=int_deploy_inv
--******************************************************************************************
function public.Init( pos_z )

  ObjAttach( "int_deploy_inv", interface.originhub );
  ObjSet( "int_deploy_inv", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  private.WideScreenUpdate();

  private.SHOW_ANIM_TIME = 0.5;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;

  private.show = false;
  private.show_obj = ""

  ObjSet("spr_int_deploy_inv_close", {
    event_mdown = function () common_impl.HideDeployInv() end,
    event_menter = function () private.CloseMouseEnterAnim(); end,
    event_mleave = function () private.CloseMouseLeaveAnim(); end
  });

  ObjSet("int_deploy_inv_exit", {
    event_mdown = function () common_impl.HideDeployInv() end,
    event_menter = function () private.ExitMouseEnterAnim();SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () private.ExitMouseLeaveAnim();SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("spr_int_deploy_inv_back", {
    event_mdown = function () common_impl.HideDeployInv() end
  });

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  
end;
--******************************************************************************************
function private.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    ObjSet( "spr_int_deploy_inv_close", { pos_y = -250, pos_x = 310 } );

  else

    ObjSet( "spr_int_deploy_inv_close", { pos_y = -272, pos_x = 453 } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  common_impl.Lock(false);

  if ( event_id == "show" ) then

    private.show = true;

    ObjSet( "obj_int_deploy_inv", { input = true } );

    ObjSet( private.show_obj, { input = true, active = true } );

    if ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( 1 );

    end;

  elseif ( event_id == "hide" ) then

    private.show = false;

    ObjSet( "obj_int_deploy_inv", { active = false, visible = false, input = false } );
    local chapter         = ng_global.progress[ ng_global.currentprogress ].common.chapter;
    ObjAttach( private.show_obj, chapter.."_inv_deploy");

    ObjSet( private.show_obj, { input = false, active = false } );

    --ObjDetach( private.show_obj );

    private.show_obj = "";


  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  --interface.InventoryAutoHideSet( 0 );

  common_impl.Lock(true);

  ObjAnimate( "obj_int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  common_impl.Lock(true);
  ObjAnimate( "obj_int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function private.ExitMouseEnterAnim()

  SetCursor( CURSOR_DOWN );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.ExitMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CloseMouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_deploy_inv_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.CloseMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_deploy_inv_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.GetCurrentName()

  return private.show_obj;

end;
--******************************************************************************************
function public.IsOnScreen()

  return private.show;

end;
--******************************************************************************************
function public.Show( inv_obj )

  local inv_obj = inv_obj;
  local event_id = "show";

  private.show_obj = "deploy_"..inv_obj;

  ObjSet( "obj_int_deploy_inv", { active = true, visible = true, alp = 0 } );
  ObjAttach( private.show_obj, "obj_int_deploy_inv" );
  ObjSet( private.show_obj, { pos_x = 0, pos_y = 0 } );

  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide()

  if ( private.show ) then

    private.show = false;

    local event_id = "hide";
    private.HideAnim( event_id ); 

  end;

end;
--******************************************************************************************