-- name=int_dialog_ho_impl
--******************************************************************************************
function public.Init ()

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME       = 0.6;
  public.show = false;

  ObjSet("obj_int_dialog_ho_button", {
    event_mdown = int_dialog_ho.MouseDown,
    event_menter = function () common_impl.DialogButtonMouseEnter( "int_dialog_ho_button" ) end,
    event_mleave = function () common_impl.DialogButtonMouseLeave( "int_dialog_ho_button" ) end
  });

  ObjSet("obj_int_dialog_ho", {
    event_mdown = int_dialog_ho.MouseDown,
    event_menter = function () common_impl.SetCursor( CURSOR_GET ); end,
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
  });

  ObjAttach( "obj_int_dialog_ho_exit", "obj_int_dialog_ho_impl" );

  ObjSet("obj_int_dialog_ho_exit", { pos_z = -1,
    event_mdown = int_dialog_ho.MouseDown,
    event_menter = function () SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_dialog_ho.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  
  interface.Lock( true, tme );
 
  ObjAnimate( "obj_int_dialog_ho_root", "scale_xy", 0, 0, trg,
  {
    ( 0.0 * tme ), 2, 0, 0,
    ( 1.0 * tme ), 2, 1, 1

  } );

  ObjAnimate( "obj_int_dialog_ho_impl", "alp", 0, 0, "",
  {
    ( 0.0 * tme ), 2, 0,
    ( 0.5 * tme ), 2, 0,
    ( 1.0 * tme ), 2, 1 
  });

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_dialog_ho.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_ho_root", "scale_xy", 0, 0, trg,
  {
    ( 0.0 * tme ), 1, 1, 1,
    ( 1.0 * tme ), 1, 0, 0
  } );

  ObjAnimate( "obj_int_dialog_ho_impl", "alp", 0, 0, "",
  {
    ( 0.0 * tme ), 1, 1,
    ( 0.5 * tme ), 1, 0,
    ( 1.0 * tme ), 1, 0
  } );
   
  interface.Lock( true, tme );

  local current_room = GetCurrentRoom();

  if current_room and _G[ current_room ].CompleteAnimFunc  then  
       
      _G[ current_room ].CompleteAnimFunc();

  end;

end;
--******************************************************************************************