-- name=int_effects_impl
--******************************************************************************************
function public.Init()
  private.ho_hint = {};
end;
--******************************************************************************************
function public.Destroy()
end;
--******************************************************************************************
function public.HoHintShowAnim( target_name, hint_pos_x, hint_pos_y, event_id, itempanel )
  
  local hint_name  = "anm_int_effects_ho_hint_"..target_name;
  local timer_name = "tmr_int_effects_ho_hint_"..target_name;

  if ( not private.ho_hint[ target_name ] ) then

    private.ho_hint[ target_name ] = 1;

    ObjCreate( hint_name, "anim" );

    ObjSet( hint_name,
    {
      res = "assets/interface/resources/fx/hint/anm_hint_inventory",
      animfunc = "DoAnim", playing = true,
      pos_x = hint_pos_x, pos_y = hint_pos_y,
      scale_x = 1.4, scale_y = 1.4,
      active = true, visible = true, input = false
    } );

    if common_impl.ho_hint_attach == "" then

      ObjAttach( hint_name, "obj_int_effects_impl" );

    else 

      ObjAttach( hint_name, common_impl.ho_hint_attach );

    end;

    ObjCreate( timer_name, "timer" );
    ObjAttach( timer_name, hint_name );

  else

    ObjSet( timer_name, { playing = 0 } );
    AnimStop( hint_name );
    AnimPlay( hint_name, "DoAnim", "" );

  end;

  if ( itempanel ) then
    
    interface.ItemShowObject( target_name );

    ObjSet( hint_name,
    {
      pos_x = 0, pos_y = 0,
    } );

    ObjAttach( hint_name, target_name );

  end;

  ObjSet( timer_name, 
  {
    endtrig = function () private.HoHintShowAnimEnd( target_name, event_id ); end,
    time    = 3.0,
    playing = true
  } );

end;
--******************************************************************************************
function private.HoHintShowAnimEnd( target_name, event_id )

  local hint_name  = "anm_int_effects_ho_hint_"..target_name;
  local timer_name = "tmr_int_effects_ho_hint_"..target_name;

  ObjDelete( hint_name );
  ObjDelete( timer_name );
  private.ho_hint[ target_name ] = nil;
  int_effects.EventAnimEnd( event_id );

end;
--******************************************************************************************