-- name=int_inventory_impl
--******************************************************************************************
function public.Init()

  public.ITEM_POSITION_OFFSET = 76;

  private.SHOW_ANIM_TIME = 0.4;
  private.SHOW_POS_Y     = 709;
  private.HIDE_POS_Y     = 779;

  public.ITEM_FLY_ANIM_TIME  = 0.5;
  public.ITEM_MOVE_ANIM_TIME = 0.3;
  public.ITEM_DRAG_ANIM_TIME = 0.1;
  public.ITEM_DROP_ANIM_TIME = 0.2;

  private.ITEM_MOUSE_OVER_ANIM_TIME = 0.15;

  public.ITEM_SCALE       = 0.68;
  private.ITEM_SCALE_FOCUS = 0.75;
  private.ITEM_SCALE_FLY   = 1.0;

  private.ARROW_ANIM_TIME  = 0.3;

  public.DONT_DELETE_ITEMS = true;

  ObjSet("obj_int_inventory_btn_left", {
    event_mdown = function () int_inventory.ArrowClick( "left" ); end,
    event_menter = function () private.ArrowMouseEnterAnim( "left" ); end,
    event_mleave = function () private.ArrowMouseLeaveAnim( "left" );  end
  });
  ObjSet("obj_int_inventory_btn_right", {
    event_mdown = function () int_inventory.ArrowClick( "right" ); end,
    event_menter = function () private.ArrowMouseEnterAnim( "right" ); end,
    event_mleave = function () private.ArrowMouseLeaveAnim( "right" ); end
  });
  ObjSet("spr_int_inventory", {
    event_mdown = function () int_inventory.Show( true ); end--,
    --port. fix
    --event_mleave = function () int_inventory.Hide( false ); end
  });

end;
--******************************************************************************************
function public.ForceShow()
  ObjSet( "int_inventory_impl", { pos_y = private.SHOW_POS_Y } );
end;
--******************************************************************************************
function public.ShowAnim( event_id )

  ObjSet( "obj_int_inventory_fairy", { active = true } );

  local obj = "int_inventory_impl";

  local trg = function () 

    int_inventory.EventAnimEnd( event_id );

  end;

  local tme = private.SHOW_ANIM_TIME;
  local cur_y = ObjGet( obj ).pos_y;
  local new_y = private.SHOW_POS_Y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 2, cur_y,
    tme, 2, new_y
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  ObjSet( "obj_int_inventory_fairy", { active = true } );

  local obj = "int_inventory_impl";

  local trg = function ()

    int_inventory.EventAnimEnd( event_id ); 

  end;

  local tme = private.SHOW_ANIM_TIME;
  local cur_y = ObjGet( obj ).pos_y;
  local new_y = private.HIDE_POS_Y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 1, cur_y,
    tme, 1, new_y
  } );

end;
--******************************************************************************************
function public.ItemFlyAnim( fly_name, item_name, item_count, event_id, inv_type, res )

  if not inv_type then
  
    inv_type = "spr"
    
  end;
  
  local first_item = 0;

  if ( item_count == 1 ) then

    first_item = 1;

  end;

  local relations = ObjGetRelations( fly_name );
  
  local anm_name_1 = "anm_"..common.GetObjectName( event_id ).."_1"
  local anm_name_2 = "anm_"..common.GetObjectName( event_id ).."_2"
  local spr_name = "spr_"..common.GetObjectName( fly_name )
  local spr_res_name = ObjGet( "inv_"..common.GetObjectName(common.GetObjectName( common.GetObjectName( item_name ) ) ) ).res;
  if res then
    
    spr_res_name = res;
    
  end;
  ObjCreate( anm_name_1, "anim" );
  ObjCreate( anm_name_2, "anim" );
  ObjCreate( spr_name, inv_type );
  ObjSet( anm_name_1, { res = "assets/interface/resources/fx/inv/fx_flash",
                          playing = true,
                          animfunc = "DoAnim",
                          pos_z = -1 } );
  ObjSet( anm_name_2, { res = "assets/interface/resources/fx/inv/fx_flash",
                          playing = true,
                          animfunc = "DoAnim",
                          pos_z = 3 } );
  ObjSet( spr_name, { res = spr_res_name,
                     scale_x = 0, scale_y = 0,
                     pos_z = 2 } );
  ObjSet( item_name, { scale_x = 0, scale_y = 0,
   } );
  --ObjCreate( "anm" )

  ObjAttach( anm_name_1, fly_name );
  ObjAttach( anm_name_2, fly_name );
  ObjAttach( spr_name, fly_name );  
  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  local func_after = function()
  
    int_inventory.StdItemFlyAnimation( fly_name, item_name, trg, first_item );
    ObjDelete( anm_name_2 );

  end;
  
  DbgTrace( relations.childs[1] );
  ObjAnimate( relations.childs[1], "scale_xy", 0, 0, "",
  { 
  0.0, 0, 1,1,
  0.2, 3, 0,0
  });  
  ObjAnimate( spr_name, "scale_xy", 0, 0, func_after,
  { 
  0.0, 0, 0,0,
  0.2, 3, 1,1
  });
  
end;
--******************************************************************************************
function public.ItemStartDrag( item_name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );
  
end;
--******************************************************************************************
function public.ItemDragAnim( fly_name, item_name, event_id )

  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  int_inventory.StdItemDragAnimation( fly_name, item_name, trg );

end;
--******************************************************************************************
function public.ItemDropAnim( fly_name, item_name, event_id )

  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  int_inventory.StdItemDropAnimation( fly_name, item_name, trg, public.ITEM_SCALE );

end;
--******************************************************************************************
function public.ItemMoveAnim( object_name, move_type, move_pos, event_id )

  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  local tme = public.ITEM_MOVE_ANIM_TIME;

  local obj_params = ObjGet( object_name );

  ObjAnimate( object_name, "pos_x", 0, 0, trg,
  {
    0.0, 3, obj_params.pos_x,
    tme, 3, move_pos
  } );

  if ( move_type == 0 ) then

    --ObjStopAnimate( object_name, 6 );
    --ObjStopAnimate( object_name, 8 );

  elseif ( move_type == 1 ) then

    ObjAnimate( object_name, "scale_xy", 0, 0, "",
    {
      0.0, 2, obj_params.scale_x, obj_params.scale_y,
      tme, 2, 0, 0
    } );

    ObjAnimate( object_name, "alp", 0, 0, "",
    {
      0.0, 2, obj_params.alp,
      tme, 2, 0
    } );

  elseif ( move_type == 2 ) then

    ObjAnimate( object_name, "scale_xy", 0, 0, "",
    {
      0.0, 1, obj_params.scale_x, obj_params.scale_y,
      tme, 1, 1, 1
    } );

    ObjAnimate( object_name, "alp", 0, 0, "",
    {
      0.0, 1, obj_params.alp,
      tme, 1, 1
    } );

  end;

end;
--******************************************************************************************
function public.ItemMouseEnterAnim( item_name, event_id )

  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  local cur_scale_x = ObjGet( item_name ).scale_x;
  local cur_scale_y = ObjGet( item_name ).scale_y;

  local end_scale_x = private.ITEM_SCALE_FOCUS;
  local end_scale_y = private.ITEM_SCALE_FOCUS;

  local tme = private.ITEM_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( item_name, "scale_xy", 0, 0, trg,
  {
    0.0, 3, cur_scale_x, cur_scale_y,
    tme, 3, end_scale_x, end_scale_x
  } );

end;
--******************************************************************************************
function public.ItemMouseLeaveAnim( item_name, event_id )

  local trg = function () int_inventory.EventAnimEnd( event_id ); end;

  local cur_scale_x = ObjGet( item_name ).scale_x;
  local cur_scale_y = ObjGet( item_name ).scale_y;

  local end_scale_x = public.ITEM_SCALE;
  local end_scale_y = public.ITEM_SCALE;

  local tme = private.ITEM_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( item_name, "scale_xy", 0, 0, trg,
  {
    0.0, 3, cur_scale_x, cur_scale_y,
    tme, 3, end_scale_x, end_scale_y
  } );

end;
--******************************************************************************************
function private.ArrowMouseLeaveAnim( arrow )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_inventory_btn_"..arrow.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.ARROW_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.ArrowMouseEnterAnim( arrow )

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_inventory_btn_"..arrow.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.ARROW_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************

