-- name=int_loupe
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_loupe", interface.originhub );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  public.show = false;
 
  public.list = {};
  public.list[ "offstage" ] = { prev_event = "", cur_event = "use_charneddevice",   points_count = 2 };
  public.list[ "corridor" ] = { prev_event = "", cur_event = "use_device_1", points_count = 2 };
  public.list[ "bar_2" ] = { prev_event = "", cur_event = "use_device_2", points_count = 2 };
  public.list[ "studio" ] = { prev_event = "", cur_event = "use_device_3", points_count = 2 };
  
  public.funlist = {};
  public.funlist[ "dungeon" ] = { objects_count = 4 };
  public.funlist[ "lunchroom" ] = { objects_count = 2 };
    
  private.WideScreenUpdate();

end;
--******************************************************************************************
function public.Destroy()
  
  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
--******************************************************************************************
function private.EventAnimEnd( event_id )

  common_impl.Lock( false );

  local current_room = GetCurrentRoom();

  if ( event_id == "show" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_device_env", 1, "", 0.5 );
  
  elseif ( event_id == "hide" ) then
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_device_env", 0.5 );

    public.show = false;
   
    ObjDetach( current_room.."_loupe" );
    ObjSet( current_room.."_loupe", { active = false, visible = false, input = false } );
    ObjSet( "obj_int_loupe", { active = false, visible = false, input = false } );

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  public.show = true;
  
  local obj = "obj_int_loupe";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = 0.3;

  local room = GetCurrentRoom();
  
  --common_impl.LoupeSetCounter( common.GetObjectName( room ) );

  ObjAttach( room.."_loupe", "obj_int_loupe" );
  ObjSet( room.."_loupe", { active = true, visible = true, input = true } );
  
  common_impl.InterfaceSetVisible( false );
  
  interface.Lock( true, tme );
  
  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );
  
  ObjAnimate( room, "color_rgb", 0, 0, "",
  {
    0.0, 2, 1,  1,  1,
    tme, 2, 0.3,0.3,0.3
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local obj = "obj_int_loupe";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = 0.3;
  
  local room = GetCurrentRoom();

  --common_impl.PlayAudio( "sfx", "common/audio/aud_loupe_off", 0, "", 0 );
  
   common_impl.InterfaceSetVisible( true );
   
   interface.Lock( true, tme );
  
  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );
  
   ObjAnimate( room, "color_rgb", 0, 0, "",
  {
    0.0, 2, 0.3,0.3,0.3,
    tme, 2, 1,1,1
  } );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    --
  else
    --
  end;

end;
--******************************************************************************************
function public.Show()

  local room = GetCurrentRoom();

  if ( not string.find( room, "rm_" )  or ( interface.GetCurrentInv() ~= "" ) ) then 

    return;

  end;

  common_impl.Lock( true );
  common.CloseSubRoom();

  ObjSet( "obj_int_loupe", { active = true, visible = true, input = true } );

  local event_id = "show";

  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide(  )

  common_impl.Lock( true );

  local event_id = "hide";
  private.HideAnim( event_id );

end;
--******************************************************************************************
