-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;
  
  private.POPUP_WINDOW_BACK_X = 0;
  private.POPUP_WINDOW_BACK_Y = 0;

  private.HUB_POPUP_WINDOW_X = 100;
  private.HUB_POPUP_WINDOW_Y = 0;

  private.MIN_END_Y = -180;
  private.MIN_END_X = 0;
  private.MAX_END_X = 420;
   
    private.screen = 
    {
      [ "hall"         ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "offstage"     ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "smallroom"    ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "corridor"     ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "lunchroom"    ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "dungeon"      ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      [ "beforepuzzle" ] = { screen = 1, map = 1, visit = false, lock = false, activ = false },
      
      [ "garage"       ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      [ "wheelbarrow"  ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      [ "atbar"        ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      [ "bar_2"        ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      [ "base"         ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      [ "groundfloor"  ] = { screen = 1, map = 2, visit = false, lock = false, activ = false },
      
      [ "storageexit"  ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      [ "street"       ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      [ "underbridge"  ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      [ "attvatation"  ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      [ "studio"       ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      [ "roof"         ] = { screen = 2, map = 2, visit = false, lock = false, activ = false },
      
      [ "hall_4"       ] = { screen = 2, map = 1, visit = false, lock = false, activ = false },
      [ "behindstage"  ] = { screen = 2, map = 1, visit = false, lock = false, activ = false },
      [ "smallroom_4"  ] = { screen = 2, map = 1, visit = false, lock = false, activ = false },
      [ "corridor_4"   ] = { screen = 2, map = 1, visit = false, lock = false, activ = false },
      [ "lunchroom_4"  ] = { screen = 2, map = 1, visit = false, lock = false, activ = false },
      [ "secondfloor"  ] = { screen = 3, map = 1, visit = false, lock = false, activ = false },
      [ "balcony"      ] = { screen = 3, map = 1, visit = false, lock = false, activ = false },
      [ "study"        ] = { screen = 3, map = 1, visit = false, lock = false, activ = false },
      [ "secondroom"   ] = { screen = 3, map = 1, visit = false, lock = false, activ = false },
     
    };
  
    private.pages_crop = { { true, -172, -342, 344, 686 },
                           { true, -516, -342, 690, 686 },
                           { false } };
                           
    private.save_rooms = 
    { 
      [ "wheelbarrow"  ] = { level3 = "wheelbarrow_3" },
      [ "atbar"        ] = { level3 = "atbar_3" },
      [ "bar_2"        ] = { level3 = "bar_3" },
      [ "base"         ] = { level3 = "base_3" },
      [ "groundfloor"  ] = { level3 = "groundfloor_3" },
    }

    private.anim_rooms = 
    { 
      [ "wheelbarrow_3"  ] = "wheelbarrow",
      [ "atbar_3"        ] = "atbar",
      [ "bar_3"          ] = "bar_2",
      [ "base_3"         ] = "base",
      [ "groundfloor_3"  ] = "groundfloor",
    }     

    public.show = false;
    
    private.map_number = 1;
  
 local table_multiset = {

    { "obj_map_btn_close", { 
    event_mdown = function() int_map.Close(); common_impl.PlayAudio( "sfx", "common/audio/aud_closemap", 0, "", 0 ); end ,
        event_menter = function() private.ButtonEnter( "spr_map_btn_close_focus" ) end, 
        event_mleave = function() private.ButtonLeave( "spr_map_btn_close_focus" ) end } }, 

    { "obj_map_back_empty_clk", { 
        event_mdown = int_map.Close ,
        event_menter = function() common_impl.SetCursor( CURSOR_DOWN ) end, 
        event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } }, 
  
    { "obj_map_1_btn_diary", { 
      visible = true, input = true,
      event_mdown = function() interface.DiaryShow(); common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 ); end,
      event_menter = function() private.ButtonEnter( "spr_map_1_btn_diary_focus" ) end , 
      event_mleave = function() private.ButtonLeave( "spr_map_1_btn_diary_focus" ) end } } ,
      
    { "obj_map_2_btn_diary", { 
      visible = true, input = true,
      event_mdown = function() interface.DiaryShow(); common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 ); end,
      event_menter = function() private.ButtonEnter( "spr_map_2_btn_diary_focus" ) end , 
      event_mleave = function() private.ButtonLeave( "spr_map_2_btn_diary_focus" ) end } } ,
  
    { "spr_int_map_1_page_1", { event_mdown = function() private.ClkPage( 1 ); end,
                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end, } },
    
    { "spr_int_map_1_page_2", { event_mdown = function() private.ClkPage( 2 ); end,
                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end, } },
                                  
    { "spr_map_1_screen_2_transition_secondfloor", { event_mdown = function() private.ArrowMDown( 2 ); end,
                                                     event_menter = function() private.ArrowMEnter( "secondfloor", 2 ); end,
                                                     event_mleave = function() private.ArrowMLeave( "secondfloor", 2 ); end, } },
                                                             
    { "spr_map_1_screen_3_transition_firstfloor", { event_mdown = function() private.ArrowMDown( 1 ); end,
                                                    event_menter = function() private.ArrowMEnter( "firstfloor", 3 ); end,
                                                    event_mleave = function() private.ArrowMLeave( "firstfloor", 3 ); end, } },
                                                      
    { "obj_map_2_screen_1_transition_screen_2", { event_mdown = function() private.ArrowMDown( 2 ); end,
                                                  event_menter = function() private.ArrowMEnter( "screen_2", 1 ); end,
                                                  event_mleave = function() private.ArrowMLeave( "screen_2", 1 ); end, } },
    
    { "obj_map_2_screen_2_transition_screen_1", { event_mdown = function() private.ArrowMDown( 1 ); end,
                                                  event_menter = function() private.ArrowMEnter( "screen_1", 2 ); end,
                                                  event_mleave = function() private.ArrowMLeave( "screen_1", 2 ); end, } },

  };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local table_multiset_ce = {

      { "obj_map_1_btn_collectibles_1", { 
          visible = true, input = true,
          event_mdown = function() common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_collectibles" ); end,
          event_menter = function() private.ButtonEnter( "spr_map_1_btn_collectibles_1_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_1_btn_collectibles_1_focus" ) end } }, 

      { "obj_map_1_btn_collectibles_2", { 
          visible = true, input = true,
          event_mdown = function() common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_collectibles2" ); end,
          event_menter = function() private.ButtonEnter( "spr_map_1_btn_collectibles_2_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_1_btn_collectibles_2_focus" ) end } }, 

      { "obj_map_1_btn_achievements", { 
          visible = true, input = true,
          event_mdown = function()  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_achievements" ) end,
          event_menter = function() private.ButtonEnter( "spr_map_1_btn_achievements_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_1_btn_achievements_focus" ) end } },   
          
      { "obj_map_2_btn_collectibles_1", { 
          visible = true, input = true,
          event_mdown = function() common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_collectibles" ); end,
          event_menter = function() private.ButtonEnter( "spr_map_2_btn_collectibles_1_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_2_btn_collectibles_1_focus" ) end } }, 

      { "obj_map_2_btn_collectibles_2", { 
          visible = true, input = true,
          event_mdown = function() common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_collectibles2" ); end,
          event_menter = function() private.ButtonEnter( "spr_map_2_btn_collectibles_2_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_2_btn_collectibles_2_focus" ) end } }, 

      { "obj_map_2_btn_achievements", { 
          visible = true, input = true,
          event_mdown = function()  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 ); private.ButtonDown( "rm_achievements" ) end,
          event_menter = function() private.ButtonEnter( "spr_map_2_btn_achievements_focus" ) end, 
          event_mleave = function() private.ButtonLeave( "spr_map_2_btn_achievements_focus" ) end } },   

    };

    for i = 1, #table_multiset_ce do
    
      table.insert( table_multiset, table_multiset_ce[ i ] );

    end;

  end;

  for room, value in pairs( private.screen ) do    

    local obj = "obj_map_"..private.screen[ room ].map.."_screen_"..private.screen[ room ].screen.."_"..room.."_marker";
    table.insert( table_multiset, { obj, { 
                                      event_mdown = function() private.MarkerMDown( room ) end, 
                                      event_menter = function() private.MarkerMEnter( room ) end, 
                                      event_mleave = function() private.MarkerMLeave( room ) end } } );

  end;
  
  if( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset ); 
  end;  
  
  private.current_screen = 1;
  
  private.current_page = 1;

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  local trg = function () int_map.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );
  
  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter, -1 );

  if lvl == "t" or lvl == "r" then lvl = 4; end;
  
  if tonumber( lvl ) == 2 or tonumber( lvl ) == 3 then
    
    private.map_number = 2;
    
    ObjSet( "obj_int_map_1", { alp = 0 } );
    
  else
  
    private.map_number = 1;
    
    ObjSet( "obj_int_map_1", { alp = 1 } );
  
  end;

  private.current_screen = private.screen[ private.pos_player ].screen;
  private.inside_screen = "";
 
  private.SetCurrentScreen();
  
  ObjSet( "obj_int_map_"..private.map_number, { alp = 1, input = true } );
  
  ObjSet( "spr_map_marker_player_here", { res = "assets/interface/resources/map/layers/map_"..private.map_number.."/player" }  );
  
  local params = ObjGet( "obj_map_"..private.map_number.."_screen_"..private.current_screen.."_"..private.pos_player.."_marker" );
  
  DbgTrace("private.map_number:"..tostring(private.map_number).." private.current_screen:"..tostring(private.current_screen).." private.pos_player:"..tostring(private.pos_player));
  if private.map_number ~= 1 then
 
    local coords = GetObjPosByObj( "obj_map_"..private.map_number.."_screen_"..private.current_screen.."_"..private.pos_player.."_marker", "obj_int_map_impl" );
   
    ObjSet( "obj_map_marker_player_here", { visible = true, pos_x = coords[1], pos_y = coords[2] } );
    ObjSet( "spr_map_marker_player_here", { drawoff_x = 22 } );
    
  else
    
    ObjSet( "obj_map_marker_player_here", { visible = true, ang = - params.ang } );
    
    ObjAttach( "obj_map_marker_player_here", "obj_map_"..private.map_number.."_screen_"..private.current_screen.."_"..private.pos_player.."_marker" );

  end;
    
  
  for room, value in pairs( private.screen ) do
    private.CheckMapRoom( room );
    private.PlayMarkersAnims( room, private.screen[ room ].screen );
  end;
  
   
  private.PlayAnims();
  
end;
--******************************************************************************************
function public.HideAnim ( event_id )

  room_impl.VIA_BLACK_SCREEN = true;

  local trg = function () 
    int_map.EventAnimEnd( event_id ); 
    ObjSet( "tmr_common_anm", { active = true } );
  end;
  local tme = private.HIDE_ANIM_TIME;

  common_impl.PlayAudio( "sfx", "common/audio/aud_closemap", 0, "", 0 );

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
    
  end;

end;
--******************************************************************************************
-- function *** Buttons *** () end;
--******************************************************************************************
  function private.ButtonDown ( room )

    common_impl.EnterBonusRm( room );

  end;
--******************************************************************************************
  function private.ButtonEnter ( obj, alpha )

    local tme = 0.3;

    SetCursor( CURSOR_HAND );

    local alp = ObjGet( obj ).alp;
  
    local alp_end = 1;

    if alpha then 
      alp_end = alpha;
    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,              0, alp, 
      tme *( 1 - alp ), 0, alp_end
    } );

  end;
  --******************************************************************************************
  function private.ButtonLeave ( obj )

    local tme = 0.3;

    SetCursor( CURSOR_DEFAULT );

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0, 0, alp, 
      tme *alp , 0,    0
    } ); 

  end;
--******************************************************************************************
-- function *** Marker *** () end;
--******************************************************************************************
  function private.MarkerMDown ( name )
    
    local prg = ng_global.currentprogress;
    local chapter = ng_global.progress[ prg ].common.chapter;
    local room = name;
    
    if ( prg == "std" and private.save_rooms[name] ) then
      
      if ( chapter == "level3" ) then
        
        room = private.save_rooms[name].level3;
        
      end;
      
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

    if ( GetCurrentRoom() ~= "rm_"..room ) then
      cmn.GotoRoom( "rm_"..room );  
    end;

    int_map.Close();
    
  end;
  --******************************************************************************************
  function private.MarkerMEnter ( name, alp )

    SetCursor( CURSOR_HAND );

    local alpha = 1;

    if alp then

      alpha = alp;

    end;

    local obj = "spr_map_"..private.map_number.."_screen_"..private.current_screen.."_"..name.."_focus";

    if obj and ObjGet( obj ) then

      --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

      local alp_cur = ObjGet( obj ).alp;
      local time = 0.3;
      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0.0,              0,  alp_cur, 
        time*( 1 - alp_cur ), 0, alpha
      } );

    end;
    
    if private.map_number ~= 1 then
    
      --local pos_beg_x = GetZoomCursorPos()[ 1 ] - 512;
      --local pos_beg_y = GetZoomCursorPos()[ 2 ] - 384;
      local coords = GetObjPosByObj( "obj_map_"..private.map_number.."_screen_"..private.current_screen.."_"..name.."_marker" );
      
      local pos_beg_x = coords[1] - 512;
      local pos_beg_y = coords[2] - 384;

      pos_beg_x = pos_beg_x + private.HUB_POPUP_WINDOW_X;
      pos_beg_y = pos_beg_y + private.HUB_POPUP_WINDOW_Y;
      
      if ( pos_beg_x > private.MAX_END_X ) then
        pos_beg_x = private.MAX_END_X;
      end;

      local pos_end_x = pos_beg_x + 0 ;
      local pos_end_y = pos_beg_y - 75 ;
      
      --DbgTrace( pos_end_x );

      if ( pos_end_y < private.MIN_END_Y ) then
        pos_end_y = private.MIN_END_Y;
      end;
      
      if ( pos_end_x < private.MIN_END_X ) then
        pos_end_x = private.MIN_END_X;
      end;
      
      if ( pos_end_x > private.MAX_END_X ) then
        pos_end_x = private.MAX_END_X;
      end;

      local sc_x  = 0;
      local sc_y = 0;

      private.popup_window_beg_anim_x = pos_beg_x;
      private.popup_window_beg_anim_y = pos_beg_y;

      ObjSet( "obj_map_popup_window", { 
              pos_x = pos_beg_x, 
              pos_y = pos_beg_y,
              alp = 0
            } );    

      ObjSet( "spr_map_popup_window_ico", { res = "assets/interface/resources/map/layers/map_"..private.map_number.."/minibacks/"..name } );
    
      local popup_text_id = "pop_"..name;

      if ng_global.currentprogress == "ext" then
        popup_text_id = popup_text_id.."_ce";
      end;

      ObjSet( "txt_map_popup_window_ico_name", { text = popup_text_id } );

      ObjAnimate( "obj_map_popup_window", "alp", 0, 0, "",
      {
        0.0, 1, 0,
        0.2, 0, 1
      } );

      ObjAnimate( "obj_map_popup_window", "pos_xy", 0, 0, "",
      {
        0.0, 1, pos_beg_x, pos_beg_y,
        0.2, 0, pos_end_x, pos_end_y
      } );

      ObjAnimate( "obj_map_popup_window", "scale_xy", 0, 0, "",
      {
        0.0, 1, sc_x, sc_y,
        0.2, 0, 1, 1
      } );
      
    end;

  end;
  --******************************************************************************************
  function private.MarkerMLeave ( name )

    SetCursor( CURSOR_DEFAULT );

    local obj = "spr_map_"..private.map_number.."_screen_"..private.current_screen.."_"..name.."_focus";

    if obj and ObjGet( obj ) then

      local alp = ObjGet( obj ).alp;
      local time = 0.3;
      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0.0,        0, alp,
        time * alp, 0,   0 
      });

    end;
    
    if private.map_number ~= 1 then
      
      ObjStopAnimate( "obj_map_popup_window", "pos_xy" );
      ObjStopAnimate( "obj_map_popup_window", "scale_xy" );
      ObjStopAnimate( "obj_map_popup_window", "alp" );
        
      local pos_beg_x = ObjGet( "obj_map_popup_window" ).pos_x;
      local pos_beg_y = ObjGet( "obj_map_popup_window" ).pos_y;

      local pos_end_x = private.popup_window_beg_anim_x;
      local pos_end_y = private.popup_window_beg_anim_y;
      
      local sc_beg_x = ObjGet( "obj_map_popup_window" ).scale_x;
      local sc_beg_y = ObjGet( "obj_map_popup_window" ).scale_y;
      local sc_end_x = 0;
      local sc_end_y = 0;
      local alph = ObjGet( "obj_map_popup_window" ).alp;

      ObjAnimate( "obj_map_popup_window", "pos_xy", 0, 0, "",
      {
        0.0, 1, pos_beg_x, pos_beg_y,
        0.2, 0, pos_end_x, pos_end_y
      } );

      ObjAnimate( "obj_map_popup_window", "scale_xy", 0, 0, "",
      {
        0.0, 1, sc_beg_x, sc_beg_y,
        0.2, 0, sc_end_x, sc_end_y
      } );

      ObjAnimate( "obj_map_popup_window", "alp", 0, 0, "",
      {
        0.0, 1, alph,
        0.2, 0, 0
      } );
      
    end;

  end;
--******************************************************************************************
-- function *** Arrow *** () end;
--******************************************************************************************
  function private.ArrowMDown ( screen_number )
    --ld.SoundClickBtn();
    
    local old_screen = private.current_screen;
    local new_screen = 0;
    
    if ( screen_number == 1 ) then

      private.current_screen = private.current_screen - 1;

    elseif ( screen_number == 2 ) then

      private.current_screen = private.current_screen + 1;

    end;

    new_screen = private.current_screen;

    private.SetCurrentScreen();

    common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_1", 0, "", 0 );

    ObjSet( "obj_map_"..private.map_number.."_screen_"..old_screen, { alp = 0, input = false } );
    ObjSet( "obj_map_"..private.map_number.."_screen_"..new_screen, { alp = 1, visible = true, input = true } );
  
    if ( private.screen[ private.pos_player ].screen ~= new_screen ) then
      
      ObjSet( "obj_map_marker_player_here", { visible = false } );
      
    else
      
      ObjSet( "obj_map_marker_player_here", { visible = true } );
      
      DbgTrace( "enter" );
      
    end;


  end;
 --******************************************************************************************
 function private.ArrowMEnter ( name, screen )

   SetCursor( CURSOR_HAND );

   local alpha = 1;

   local obj = "spr_map_"..private.map_number.."_screen_"..screen.."_transition_"..name.."_focus";
   
   DbgTrace( obj );

   if obj and ObjGet( obj ) then

    local alp_cur = ObjGet( obj ).alp;
    local time = 0.3;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,              0,  alp_cur, 
      time*( 1 - alp_cur ), 0, alpha
    } );

   end;

 end;
 --******************************************************************************************
 function private.ArrowMLeave ( name, screen )

   SetCursor( CURSOR_DEFAULT );

   local alpha = 0;

   local obj = "spr_map_"..private.map_number.."_screen_"..screen.."_transition_"..name.."_focus";

   if obj and ObjGet( obj ) then

    local alp_cur = ObjGet( obj ).alp;
    local time = 0.3;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,              0,  alp_cur, 
      time*( 1 - alp_cur ), 0, alpha
    } );

   end;

 end;

--******************************************************************************************
-- function *** LOGIC *** () end;
--******************************************************************************************
  function public.VisitMapRoom ( name )
  
    local current_screen = private.screen[ name ].screen;
   
    private.screen[ name ].visit = true;      
    private.pos_player = name;
    
    ObjSet( "obj_map_"..private.screen[ name ].map.."_screen_"..current_screen.."_"..name, { active = true, input = true, visible = true } );
    ObjSet( "spr_map_"..private.screen[ name ].map.."_screen_"..current_screen.."_transition_"..name, { visible = true } );
    ObjSet( "txt_map_"..private.screen[ name ].map.."_screen_"..current_screen.."_"..name, { visible = true } );
    
  end;
  --******************************************************************************************
  function public.LockMapRoom ( name, lock )
 
    local current_screen = private.screen[ name ].screen;

    private.screen[ name ].lock = lock;

  end;
  --******************************************************************************************
  function public.ActiveTaskRoom ( name, active )

    local prg = ng_global.currentprogress;
    local chapter = ng_global.progress[ prg ].common.chapter;

--    if ( chapter ~= "level1" and private.GetMapRoom( name ) ) and
--      ( name ~= "arcticstation_3" and name ~= "stationhall_3" ) then
--  
--      name = private.GetMapRoom( name );
--
--    end;

    local current_screen = private.screen[ name ].screen;
   
    local room = name;
    private.screen[ name ].activ = active;    

  end;
  --******************************************************************************************
  function private.GetMapRoom ( room_name )
 
     for room, value in pairs( private.save_rooms ) do

        if string.sub( room_name, 1, string.len( room ) ) == room then

          return room;

        end;

     end;

  end;
  --******************************************************************************************
  function private.CheckMapRoom ( room_name )

    local prg = ng_global.currentprogress;
    local chapter = ng_global.progress[ prg ].common.chapter;
    local room_name = room_name;
  
    local current_screen = private.screen[ room_name ].screen;
    local current_lock = private.screen[ room_name ].lock;
    local current_visit = private.screen[ room_name ].visit;
    local current_activ = private.screen[ room_name ].activ;
    local table_multiset = {};
    
    if ( current_visit == true ) then

      table.insert( table_multiset, { "obj_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = true } } );        
      
        if ( current_activ == true and not ( ng_global.gamemode == 2 ) ) then
            
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = true } } );
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = false } } );

        elseif not ( ng_global.gamemode == 2 ) then

          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = false } } );
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = true } } );

        else

          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = false } } );
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = false } } );
          

        end;

        if ( current_lock == true ) then
    
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_blocked", { visible = true } } );
          table.insert( table_multiset, { "obj_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { input = false } } );
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = false } } );
          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = false } } );

        else

          table.insert( table_multiset, { "spr_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker_blocked", { visible = false } } );
          table.insert( table_multiset, { "obj_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { input = true } } );
                  
        end;

    else

      table.insert( table_multiset, { "obj_map_"..private.map_number.."_screen_"..current_screen.."_"..room_name.."_marker", { visible = false, input = false } } );        

    end;
    ObjMultiSet( table_multiset );

  end;
  --******************************************************************************************
  function private.SetCurrentScreen( )--

    local table_multiset = {};
    
    if private.map_number == 1 then

      if private.current_page > 1 then
        
        for i = 1, 3 do
          
          if private.current_screen ~= i then
            
            table.insert( table_multiset, {  "obj_map_"..private.map_number.."_screen_"..i, { input = false, visible = false, active = false, alp = 0 } } );
            
          end;
          
        end;

        table.insert( table_multiset, {  "obj_map_"..private.map_number.."_screen_"..private.current_screen, { input = true, visible = true, active = true, alp = 1 } } );
      
      end; 
        
      private.SetCrop ( private.current_page );
      
    else
      
      for i = 1, 2 do
          
        if private.current_screen ~= i then
          
          table.insert( table_multiset, {  "obj_map_"..private.map_number.."_screen_"..i, { input = false, visible = false, active = false, alp = 0 } } );
          
        end;
          
        end;
      
      table.insert( table_multiset, {  "obj_map_"..private.map_number.."_screen_"..private.current_screen, { input = true, visible = true, active = true, alp = 1 } } );
      private.AnmRouteRoom();
      
    end;
  
    if #table_multiset > 0 then
      ObjMultiSet( table_multiset );
    end;    
   
  end;
  --******************************************************************************************
  function private.AnmRouteRoom()
  
    for i = #game.progress_names, 1, -1 do
      
      local event_name = game.progress_names[ i ]
      local name = common.GetObjectName( event_name );

      if ( common.GetObjectPrefix( game.progress_names[ i ] ) == "opn" ) and ( private.screen[name] or private.anim_rooms[name] ) then
   
        local prg = ng_global.currentprogress;
        local chapter = ng_global.progress[ prg ].common.chapter;
        local done_flag = false;
        local save_room = false;
        
        if chapter == "level3" and private.anim_rooms[name] then

          name = private.anim_rooms[name];
          done_flag = true; 
          save_room = true;         

        end;

        local anm_route = "anm_map_"..private.screen[name].map.."_screen_"..private.screen[name].screen.."_"..name;
   
        if ( ObjGet( anm_route ) ) then
           
           AnimStop( anm_route );
           ObjSet( anm_route, { visible = false } );

           if ( cmn.IsEventDone( event_name )or save_room ) then

             ObjSet( anm_route, { visible = true } );

             if ( not ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map and not done_flag ) then

              ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map = true;  
      
              ObjSet( anm_route, { alp = 1, playing = true, frame = 0 } );
            
             elseif ( ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map or done_flag ) then

              ObjSet( anm_route, { alp = 1, playing = false, frame = 200 } );
              done_flag = false;
            
             end;

          end;

        end;

      end;

    end;

 

  end;
--******************************************************************************************
--******************************************************************************************
function private.SetCrop ( page )
  
  local crop_params = private.pages_crop[ page ];
  
  if crop_params[1] then
  
    ObjSet( "obj_int_map_1", { croprect_init = true, croprect_x = crop_params[2],
                                                     croprect_y = crop_params[3],
                                                     croprect_w = crop_params[4],
                                                     croprect_h = crop_params[5] } );
                                                     
  else
       
    ObjSet( "obj_int_map_1", { croprect_init = false } );                                                
                                                     
  end;
  
end;
--******************************************************************************************
--******************************************************************************************
function private.ClkPage ( page )

  local func_after = function()

    common_impl.Lock( false );
    
    ObjSet( "spr_int_map_1_page_"..page, { input = false, visible = false, active = false } );
    ObjSet( "spr_int_map_1_page_"..( page + 1 ), { input = true } );
    
    private.current_page = page + 1;
    
    ObjSet( "obj_map_1_screen_"..private.current_screen, { input = true } );

  end;

  common_impl.Lock( true );
  
  private.SetCrop ( page + 1 );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_map_unfold_"..page, 0, "", 0 );

  ObjAnimate( "spr_int_map_1_page_"..page, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  
  if page == 1 then

    ObjAnimate( "spr_int_map_1_page_3_left", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    ObjSet( "spr_int_map_1_page_2", { alp = 1 } );
    
    ObjAnimate( "obj_map_1_screen_"..private.current_screen, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  elseif page == 2 then

    ObjAnimate( "spr_int_map_1_page_3_right", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  end;
  
end;
--******************************************************************************************
--******************************************************************************************
function private.PlayMarkersAnims ( room, screen )

  local room = room;

  local marker = { "", "_blocked", "_light" };

  for i = 1, #marker do
    
    if ObjGet( "spr_map_"..private.map_number.."_screen_"..screen.."_"..room.."_marker"..marker[i] ) then

      local pos_y = ObjGet( "spr_map_"..private.map_number.."_screen_"..screen.."_"..room.."_marker"..marker[i] ).pos_y;
  
      ObjAnimate( "spr_map_"..private.map_number.."_screen_"..screen.."_"..room.."_marker"..marker[i], "pos_y", 1, 0, "", { 0,0,pos_y, 1,0,( pos_y - 2 ), 2,0,( pos_y + 2 ), 3,0,pos_y } );
      ObjAnimate( "spr_map_"..private.map_number.."_screen_"..screen.."_"..room.."_marker"..marker[i], "scale_xy", 1, 0, "", { 0,0,1,1, 1,0,1.05,1.05, 2,0,0.95,0.95, 3,0,1,1 } );
    
    end;  
        
  end;

end;
--******************************************************************************************
--******************************************************************************************
function private.PlayAnims ()

   local pos_y = ObjGet( "obj_map_marker_player_here" ).pos_y;

   ObjAnimate( "obj_map_marker_player_here", "scale_xy", 1, 0, "", { 0,0,1,1, 1,0,1.05,1.05, 2,0,0.95,0.95, 3,0,1,1 } );
   ObjAnimate( "obj_map_marker_player_here", "pos_y", 1, 0, "", { 0,0,pos_y, 1,0,( pos_y - 2 ), 2,0,( pos_y + 2 ), 3,0,pos_y } );

end;