-- name=int_slider
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_slider", interface.originhub );
  ObjSet( "int_slider", { pos_z = pos_z } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  local arrows = { "left", "right", "down", "up" };

  for i = 1, #arrows do

    ObjSet("obj_int_slider_clk_"..arrows[ i ], {
      event_menter = function ()

        private.MouseEnterAnim( arrows[ i ] );
        private.ClickObj( arrows[ i ] );

      end,
      event_mleave = function () private.MouseLeaveAnim( arrows[ i ] ); end
    });

    ObjSet("spr_focus_arrow_"..arrows[ i ], {
      event_menter = function ()

        private.MouseEnterAnim( arrows[ i ] );
        private.ClickObj( arrows[ i ] );

      end,
      event_mleave = function () private.MouseLeaveAnim( arrows[ i ] ); end
    });

    local param_anim = "pos_y";
    if ( arrows[ i ] == "left" or arrows[ i ] == "right" ) then
      param_anim = "pos_x";
    end;

    ObjAnimate( "spr_focus_arrow_"..arrows[ i ], param_anim, 1, 0, "", { 
      0.0,0,ObjGet("spr_focus_arrow_"..arrows[ i ])[ param_anim ], 1.0,0,
      ObjGet("spr_focus_arrow_"..arrows[ i ])[ param_anim ] + 4, 
      2.0,0,ObjGet("spr_focus_arrow_"..arrows[ i ])[ param_anim ] });
    ObjAnimate( "vid_focus_arrow_"..arrows[ i ].."_off", param_anim, 1, 0, "", { 
      0.0,0,ObjGet("vid_focus_arrow_"..arrows[ i ].."_off")[ param_anim ], 1.0,0,
      ObjGet("vid_focus_arrow_"..arrows[ i ].."_off")[ param_anim ] + 4, 2.0,0,
      ObjGet("vid_focus_arrow_"..arrows[ i ].."_off")[ param_anim ] });
    ObjAnimate( "vid_focus_arrow_"..arrows[ i ].."_on", param_anim, 1, 0, "", { 
      0.0,0,ObjGet("vid_focus_arrow_"..arrows[ i ].."_on")[ param_anim ], 
      1.0,0,ObjGet("vid_focus_arrow_"..arrows[ i ].."_on")[ param_anim ] + 4, 
      2.0,0,ObjGet("vid_focus_arrow_"..arrows[ i ].."_on")[ param_anim ] });
 
  end;

  public.DIRECTION =  -1;

  private.current_room = "";
  public.current_pos = "mid";

  private.MOVE_ANIM_TIME =  0.1;

  private.show_l = false;--на экране или нет
  private.show_r = false;--на экране или нет
  private.show_u = false;--на экране или нет
  private.show_d = false;--на экране или нет
  private.sound = false; --звук при первом показе стрелок
  private.timer = 3; --время таймера

  private.sides = { "left", "right", "up", "down" };
  private.rooms = 
  {
    {
      { "rm_arcticstation", { mid = true, left = false, right = false, up = false, down = false }, { hor = 853 } },
    },
    {
      { "rm_arcticstation_2", { mid = true, left = false, right = false, up = false, down = false }, { hor = 853 } },
      { "rm_eskimosettlement", { mid = true, left = false, right = false, up = false, down = false }, { hor = 658 } },

    },
    {
      { "rm_arcticstation_3", { mid = true, left = false, right = false, up = false, down = false }, { hor = 853 } },
    },
    {
      { "rm_eskimosettlement_4", { mid = false, left = true, right = false, up = false, down = false }, { hor = 658 } },
    },
    {
    }
  };  

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.MoveBbtDown ()

  if private.show_r or private.show_l or private.show_u or private.show_d then

    ObjAnimate( "obj_int_slider", "pos_y", 0, 0, "", { 0,0,ObjGet( "obj_int_slider" ).pos_y, 0.3,0,430 });

  end;
 
end;
--******************************************************************************************
function public.MoveBbtUp ()

  if private.show_r or private.show_l or private.show_u or private.show_d then

    ObjAnimate( "obj_int_slider", "pos_y", 0, 0, "", { 0,0,ObjGet( "obj_int_slider" ).pos_y, 0.3,0,384 });

  else

    ObjSet( "obj_int_slider", { pos_y = 384 } );

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id, name )

  local obj = "obj_int_slider";
  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber( lvl );

  local room = string.sub( private.current_room, 4);

  local number = 0;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      number = i;
      break;

    end;

  end;

  if public.current_pos == "mid" then

      for i = 1, #private.sides do
          
        local event = "show_"..string.sub( private.sides[ i ], 1, 1 ); 
        if private.rooms[ lvl ][ number ][ 2 ][ private.sides[ i ] ] and not private[ event ] then

          local func = function() private.EventAnimEnd( event ); 
                                  private.ClickObjEnd( "left", true );    
                                  private.ClickObjEnd( "up", true ); end;


          ObjSet( "obj_int_slider_clk_"..private.sides[ i ], { alp = 1 } );
          ObjSet( "vid_focus_arrow_"..private.sides[ i ].."_on", { alp = 1 } );
          ObjSet( "vid_focus_arrow_"..private.sides[ i ].."_off", { alp = 0 } );
          VidStop("vid_focus_arrow_"..private.sides[ i ].."_off" );
          VidPlay( "vid_focus_arrow_"..private.sides[ i ].."_on", func );

          private[ event ] = true;
        
        end;

      end;

  elseif public.current_pos == "right" or public.current_pos == "left" then

    local side = "right";
    local side_2 = "left"

    if public.current_pos == "right" then

      side = "left";
      side_2 = "right";

    end;

    local event = "show_"..string.sub( side, 1, 1 );     

    local func = function() private.EventAnimEnd( event ); 
                                  private.ClickObjEnd( "left", true );    
                                  --private.ClickObjEnd( "up", true ); 
                            end;
   
    ObjSet( "obj_int_slider_clk_"..side, { alp = 1 } );
    ObjSet( "vid_focus_arrow_"..side.."_on", { alp = 1 } );
    ObjSet( "vid_focus_arrow_"..side.."_off", { alp = 0 } );
    VidStop("vid_focus_arrow_"..side.."_off" );
    VidPlay( "vid_focus_arrow_"..side.."_on", func );

    ObjSet( "spr_focus_arrow_"..side_2, { alp = 1 } );   

  end;

  --ObjAnimate( obj, "alp", 0, 0, private.CheckMap, { 0,0,1,   0.1,0,1 });

end;
--******************************************************************************************
function private.HideAnim()

  local prg = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local room = string.sub( private.current_room, 4 );

  local number = 0;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      number = i;
      break;

    end;

  end;

  for i = 1, #private.sides do

    local tmp_event = "hide_"..string.sub( private.sides[ i ], 1, 1 );
    local show_event = "show_"..string.sub( private.sides[ i ], 1, 1 );
    if number == 0 or private[ show_event ] or ObjGet( "obj_int_slider_clk_"..private.sides[ i ] ).alp ~= 0 then

      local func = function() private.EventAnimEnd( tmp_event ); end;
      ObjSet( "spr_focus_arrow_"..private.sides[ i ], { alp = 0 } );
      ObjSet( "vid_focus_arrow_"..private.sides[ i ].."_off", { alp = 1 } );
      VidPlay("vid_focus_arrow_"..private.sides[ i ].."_off", func )

      private[ show_event ] = false;

    end;

  end;

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local room = string.sub( private.current_room, 4 );

  local number = 0;
  local sides = { show_r = "right", show_l = "left", show_d = "down", show_u = "up", hide_r = "right", hide_l = "left", hide_d = "down", hide_u = "up" };
  local side = sides[ event_id ];

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      if ( string.find( event_id, "show" ) ) then

        if ( GetCurrentRoom() == "rm_arcticstation" and ObjGet( "obj_arcticstation_center" ).pos_x == 853 ) or 
           ( GetCurrentRoom() == "rm_arcticstation" and ObjGet( "obj_arcticstation_center" ).pos_x == 1024 ) or 
           ( GetCurrentRoom() == "rm_eskimosettlement" and ObjGet( "obj_eskimosettlement_center" ).pos_x == 658 ) or 
           ( GetCurrentRoom() == "rm_eskimosettlement" and ObjGet( "obj_eskimosettlement_center" ).pos_x == 829 )   then

          ObjSet( "obj_int_slider_root", { input = true } );

        else

          ObjSet( "obj_int_slider_root", { input = true } );
          ObjSet( "obj_int_slider_clk_"..side, { input = true, alp = 1 } );
          ObjSet( "spr_focus_arrow_"..side, { alp = 1 } );
          ObjSet( "vid_focus_arrow_"..side.."_on", { alp = 0 } );

        end;

      end;

    elseif ( string.find( event_id, "hide" ) ) then

      ObjSet( "obj_int_slider_clk_"..side, { input = false, alp = 0 } );
      ObjSet( "vid_focus_arrow_"..side.."_off", { alp = 0 } );

    end;

  end;

end;
--******************************************************************************************
function private.ClickObj( stor )

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if ( lvl == "std" ) then

    common_impl.Tutorial_Click( 'empty' );

  elseif lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local room = string.sub( private.current_room, 4 );

  if _G[private.current_room].SwitchSlider then

    _G[private.current_room].SwitchSlider( stor, public.current_pos  );

  end;

  local param_anim = "pos_x";
  if ( stor == "up" or stor == "down" ) then
    param_anim = "pos_y";
  end;

  local pos_beg = ObjGet("obj_"..room.."_center")[ param_anim ];

  local offset = 0.5 * ( GetAppWidth() - 1024 );

  if offset == 0 then

    offset = 171;

  else 

    offset = 0;

  end;

  if ( stor == "up" or stor == "down" ) then
    offset = 0;
  end; 
  
  local width = 0;

  common_impl.PlayAudio( "sfx", "common/audio/aud_display_move", 0, "", 0 );
  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      width = private.rooms[ lvl ][ i ][ 3 ].hor;
      break;

    end;

  end;

  common_impl.Lock(true);

  local pos_end = -171;
  if ( GetCurrentRoom() == "rm_arcticstation") then

    if ( stor == "left" or stor == "up" ) then

      if ( pos_beg > ( -width - offset ) ) then

        pos_end = -171 - offset + width;

      else 

        pos_end = -171 + offset;

      end;

    else 

      if ( pos_beg <= -171 + offset ) then

        pos_end = -width - offset;
      else

        pos_end = offset;

      end;
  --
    end;

  else 

    pos_end = 0;
    if ( stor == "left" or stor == "up" ) then

      if ( pos_beg >= 0 ) then
        pos_end = width+offset;
      end;

    else 

      if ( pos_beg <= 0 ) then
        pos_end = - width - offset;
      end;

    end;

  end;

    
  for i = 1, #private.sides do
    ObjSet( "obj_int_slider_clk_"..private.sides[ i ], { input = false });
  end;

  ObjAnimate( "obj_"..room.."_center", param_anim, 0, 0, function() private.ClickObjEnd( stor ); end, 
  { 
    0.0, 0, pos_beg, 
    2.0, 0, pos_end
  } );
  
  if int_visor.show then

    ObjAnimate( "obj_"..room.."_visor_center", param_anim, 0, 0, "", 
    { 
      0.0, 0, pos_beg, 
      2.0, 0, pos_end
    } );

  end;

  if ( string.find( GetCurrentRoom(), "arcticstation" ) ) then

    local tree_1_coord = ObjGet( "spr_"..room.."_tree" ).pos_x;
    local tree_2_coord = ObjGet( "spr_"..room.."_tree_2" ).pos_x;
    if ( ( pos_end == -171 + offset ) and ( stor == "left" ) ) or ( pos_end == 853 ) or ( pos_end == 1024 ) then

      ObjAnimate( "spr_"..room.."_tree", param_anim, 0, 0, "", 
      { 
        0.0, 0, tree_1_coord, 
        2.0, 0, 551
      } );

      ObjAnimate( "spr_"..room.."_tree_2", param_anim, 0, 0, "", 
      { 
        0.0, 0, tree_2_coord, 
        2.0, 0, 1380
      } );

    else 

      ObjAnimate( "spr_"..room.."_tree", param_anim, 0, 0, "", 
      { 
        0.0, 0, tree_1_coord, 
        2.0, 0, 611
      } );

      ObjAnimate( "spr_"..room.."_tree_2", param_anim, 0, 0, "", 
      { 
        0.0, 0, tree_2_coord, 
        2.0, 0, 1580
      } );

    end;

  end;

end;
--******************************************************************************************
function private.ClickObjEnd( stor, not_unblock )

  local room = string.sub( private.current_room, 4 );
  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber( lvl );

  local room = string.sub( private.current_room, 4 );

  local number = 0;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      number = i;
      break;

    end;

  end;

  common_impl.Lock(false);

  ObjSet( "spr_focus_arrow_"..stor.."_sidefocus", { alp = 0 } );

  if ObjGet("obj_"..room.."_center") then

    if ( stor == "left" or stor == "right" ) then

      local x2 = ObjGet("obj_"..room.."_center").pos_x;

      if ( x2 < -171 ) then

        ObjSet( "obj_int_slider_clk_right",{ input = false, alp = 0 });
        ObjSet( "obj_int_slider_clk_left", { input = true, alp = 1 });
        ObjSet( "spr_focus_arrow_left", { alp = 1 } );

        public.current_pos = "right";

        local type = ng_global.currentprogress;
        if type ~= "ext" then

          local tutorial_name = ng_global.progress[ type ][ "see_tutorial" ].state.currentpage;

          if tutorial_name == "tutorial_page_13" then

            interface.TutorialHide();
            common_impl.TutorialSetShown( "tutorial_page_13" );

          end;

        end;

      elseif (x2 == -171 or x2 == 0 ) then

        if  private.rooms[ lvl ][ number ][ 2 ].left  then

          ObjSet( "obj_int_slider_clk_left", { input = true, alp = 1 } );

        else
     
          ObjSet( "obj_int_slider_clk_left", { input = false, alp = 0 } );

        end;

        if  private.rooms[ lvl ][ number ][ 2 ].right  then

          ObjSet( "obj_int_slider_clk_right",{ input = true, alp = 1 } );

        else 

          ObjSet( "obj_int_slider_clk_right",{ input = false, alp = 0 } );

        end;

        public.current_pos = "mid";

      elseif ( x2 > 0 ) then
   
        ObjSet( "obj_int_slider_clk_left", { input = false, alp = 0 } );
        ObjSet( "spr_focus_arrow_right", { alp = 1 } );
        ObjSet( "obj_int_slider_clk_right",{ input = true, alp = 1 } );

        public.current_pos = "left";

      end;

    elseif stor then

      local y2 = ObjGet("obj_"..room.."_center").pos_y;

      if ( y2 < 0 ) then

        ObjSet( "obj_int_slider_clk_down",{ input = false, alp = 0 });
        ObjSet( "obj_int_slider_clk_up", { input = true, alp = 1 });
        ObjSet( "spr_focus_arrow_up", { alp = 1 } );

        public.current_pos = "down";

      elseif (y2 == 0 ) then

        if  private.rooms[ lvl ][ number ][ 2 ].up  then

          ObjSet( "obj_int_slider_clk_up", { input = true, alp = 1 } );

        else
     
          ObjSet( "obj_int_slider_clk_up", { input = false, alp = 0 } );

        end;

        if  private.rooms[ lvl ][ number ][ 2 ].down  then

          ObjSet( "obj_int_slider_clk_down",{ input = true, alp = 1 } );

        else 

          ObjSet( "obj_int_slider_clk_down",{ input = false, alp = 0 } );

        end;

        public.current_pos = "mid";

      elseif ( y2 > 0 ) then

        ObjSet( "obj_int_slider_clk_up", { input = false, alp = 0 } );
        ObjSet( "spr_focus_arrow_down", { alp = 1 } );
        ObjSet( "obj_int_slider_clk_down",{ input = true, alp = 1 } );

        public.current_pos = "up";

      end;

    end;

  end;

  if ObjGet( "obj_"..room.."_visor_center" ) then

    ObjSet( "obj_"..room.."_visor_center", { pos_x = ObjGet( "obj_"..room.."_center" ).pos_x } );

  end;
  
  for i = 1, #private.sides do

    local event = "show_"..string.sub( private.sides[ i ], 1, 1 );
    if ( ObjGet( "obj_int_slider_clk_"..private.sides[ i ] ).input ) then
      private[ event ] = true;      
    else
      private[ event ] = false;
    end;
  
  end;
 
end;
--******************************************************************************************
function private.WideScreenUpdate()

  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjSet( "obj_int_slider_clk_left",  { pos_x = -459 - offset } );
  ObjSet( "obj_int_slider_clk_right", { pos_x =  459 + offset } );

  local room = string.sub( GetCurrentRoom(), 4);
  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber( lvl );

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then
  
      local width = private.rooms[ lvl ][ i ][ 3 ].hor;
      local x1 = ObjGet( "obj_"..room.."_center" ).pos_x;
      
      if private.rooms[ lvl ][ i ][ 1 ] == "rm_arcticstation" then

        if offset == 0 then 

          if ( x1 < -171 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = - width - 171 });

          elseif ( x1 >= -171 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = 0 });

          end;
        
        else

          if ( x1 >= 0 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = - 171 });  

          elseif ( x1 > 171 + offset ) then

             ObjSet( "obj_"..room.."_center", { pos_x = width }); 

          end;

        end;

      else

        if offset == 0 then 

          if ( x1 < 0 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = - width - 170 });

          elseif ( x1 > 0 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = width + 171 });

          end;
        
        else

          if ( x1 < 0 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = - width });

          elseif ( x1 > 0 ) then

             ObjSet( "obj_"..room.."_center", { pos_x = width });

          end;

        end;
        break;

      end;

      if ObjGet( "obj_"..room.."_visor_center" ) then

        ObjSet( "obj_"..room.."_visor_center", { pos_x = ObjGet( "obj_"..room.."_center").pos_x } );

      end;
  
      break;

    end;

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim( name )

  --common_impl.PlayAudio( "sfx", "audio/aud_menter" );
  SetCursor( CURSOR_HAND );

  local obj = "fx_focus_arrow_"..name;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.3;

  ObjSet( "spr_focus_arrow_"..name.."_sidefocus", { alp = 1 } );
  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 2, alp,   tme, 2, 1 } );

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "fx_focus_arrow_"..name;
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.3;

  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 1, alp,   tme, 1, 0 } );

end;
--******************************************************************************************
function private.CheckMap()

--  if not ng_var.map_show == true then
--
--    if not private.sound and ( private.show_l or private.show_r ) then
--
--      --common_impl.PlayAudio( "sfx", "audio/aud_left_right" );
--      private.sound = true;
--
--    end;
--
--  end;

end;
--******************************************************************************************
function public.InitSlider( room )

  private.current_room = room;

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local number = 0;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      number = i;
      break;

    end;

  end;
    
  public.Hide();

  if ( number > 0 ) then

    ObjSet( "obj_int_slider", { input = true } );

    public.Show();
    --private.ClickObjEnd( "left", true );    
    --private.ClickObjEnd( "up", true );
    private.WideScreenUpdate();

  end;

end;
--******************************************************************************************
function public.CloseSlider( room )

  private.current_room = room;

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local need = false;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == room then

      local rm = string.sub( room, 4 );

      --ObjSet( "obj_"..rm.."_center", { pos_x = 0, pos_y = 0 } );

      private.WideScreenUpdate();
      break;

    end;
   end;

end;
--******************************************************************************************
function public.Show()

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = string.sub( level, 6 );

  if lvl == "ext" then

    lvl = 4;

  elseif lvl == "scr" then

    lvl = 5;

  end;

  lvl = tonumber(lvl);

  local number = 0;

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[ lvl ][ i ][ 1 ] == GetCurrentRoom() then

      number = i;
      break;

    end;

  end;

  if ( number ~= 0 and
     ( ( not private.show_u and  private.rooms[ lvl ][ number ][ 2 ].up ) or
     ( not private.show_d and  private.rooms[ lvl ][ number ][ 2 ].down ) or
     ( not private.show_l and  private.rooms[ lvl ][ number ][ 2 ].left ) or
     ( not private.show_r and  private.rooms[ lvl ][ number ][ 2 ].right ) ) ) then

    local event_id = "show";
 
    common_impl.PlayAudio( "sfx", "common/audio/aud_display_show_arrow", 0, "", 0 );    
    private.ShowAnim( event_id );

  else
    
    ObjSet( "obj_int_slider_root", { input = true } );

  end;

end;
--******************************************************************************************
function public.Hide()
    
  if private.show_r or private.show_l or private.show_u or private.show_d then
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_display_hide_arrow", 0, "", 0 );


  end;

    private.HideAnim( );

end;
--******************************************************************************************
function public.Unlock( name, params )

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = tonumber(string.sub( level, 6 ) );

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[lvl][i][1] == name then

      for j = 1,#params do
        
        private.rooms[lvl][i][2][ params[j] ] = true;

      end;

      break;

    end;

  end;

end;
--******************************************************************************************
function public.Lock( name )

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl = tonumber(string.sub( level, 6 ) );

  for i = 1, #private.rooms[ lvl ] do

    if private.rooms[lvl][i][1] == name then

      table.remove( private.rooms[lvl], i );

      break;

    end;

  end;

end;
--******************************************************************************************