-- name=ho_chestroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chestroom" );
  game.relations[ "ho_chestroom" ].exitroom = "rm_dungeon";
  --------------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_chestroom = function ()

  local effects_table = 
  {
  --"anm_chestroom_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_chestroom", update_performance_mode_chestroom, "ho_chestroom" );
  
  ObjMultiSet( {
  
  { "spr_chestroom_microchip_2", { event_mdown = function() private.TaskComplete( 'microchip_2' ) end } },
  { "spr_chestroom_aerograph", { event_mdown = function() private.TaskComplete( 'aerograph' ) end } },
  { "spr_chestroom_allenkey", { event_mdown = function() private.TaskComplete( 'allenkey' ) end } },
  { "spr_chestroom_ax", { event_mdown = function() private.TaskComplete( 'ax' ) end } },
  { "spr_chestroom_battery", { event_mdown = function() private.TaskComplete( 'battery' ) end } },
  { "spr_chestroom_item", { event_mdown = function() private.TaskComplete( 'item' ) end } },
  { "spr_chestroom_oiler", { event_mdown = function() private.TaskComplete( 'oiler' ) end } },
  { "spr_chestroom_pliers", { event_mdown = function() private.TaskComplete( 'pliers' ) end } },
  { "spr_chestroom_pruner", { event_mdown = function() private.TaskComplete( 'pruner' ) end } },
  { "spr_chestroom_roulette", { event_mdown = function() private.TaskComplete( 'roulette' ) end } },
  { "spr_chestroom_sinker", { event_mdown = function() private.TaskComplete( 'sinker' ) end } },
  { "spr_chestroom_solderingiron", { event_mdown = function() private.TaskComplete( 'solderingiron' ) end } },
  { "spr_chestroom_part_2", { event_mdown = function() private.GetItem( "spr_chestroom_part" ) ; end, event_dragdrop = private.unmark_solderingiron,
                       event_drag = function() common_impl.SetCursor( CURSOR_NULL );end } },
  { "spr_chestroom_brush_2", { event_mdown = function() private.GetItem( "spr_chestroom_brush" ) ; end, event_dragdrop = private.unmark_aerograph,
                       event_drag = function() common_impl.SetCursor( CURSOR_NULL );end } },
  
  } );
  
  common_impl.hint[ "win_chestroom" ] = {
      type = "win",
      room = "rm_dungeon",
      zz = "ho_chestroom",
      zz_gate = "gho_dungeon_chestroom"
  };
  
  local win_chestroom_func = function ()

    if ( cmn.IsEventDone( "win_chestroom" ) ) then
      interface.InventoryItemAdd( "inv_microchip_2", "spr_chestroom_win" );
      ObjDelete( "spr_chestroom_win_add" );
    end;

  end;
  cmn.AddSubscriber( "win_chestroom", win_chestroom_func );
  ---------------------------------------------------------------------------
  local unmark_solderingiron = function () 
   
    --ObjSet( "spr_chestroom_solderingiron_open_door", { alp = 1, input = false } );
    ObjSet( "spr_chestroom_solderingiron", { input = true, alp = 1 } );
    ObjDelete( "spr_chestroom_part" );
    ObjDelete( "spr_chestroom_part_2" );
    ObjDelete( "spr_chestroom_solderingiron_old" );
    
  end;

  cmn.AddSubscriber( "unmark_solderingiron", unmark_solderingiron, "ho_chestroom" );   
   ---------------------------------------------------------------------------
  local unmark_aerograph = function () 
   
    ObjSet( "spr_chestroom_aerograph", { input = true } );
    ObjDelete( "spr_chestroom_brush" );
    ObjDelete( "spr_chestroom_brush_2" );
    ObjDelete( "spr_chestroom_web" );
    ObjDelete( "anm_chest_web" )
  
  end;

  cmn.AddSubscriber( "unmark_aerograph", unmark_aerograph, "ho_chestroom" ); 
  --------------------------------------------------------------------------------------------------
  local start_chestroom_func = function ()

    if ( cmn.IsEventStart( "win_chestroom" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_chestroom" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        if ho_found[ i ][ "object" ] == "spr_chestroom_microchip_2" then
          ObjDelete( "spr_chestroom_microchip_2_shadow" );
        end;
        
      end;
      
     if not cmn.IsEventDone( "win_chestroom" ) then

      if cmn.IsUnmarkedTask( "chestroom", "aerograph" ) then
          unmark_aerograph();
      end;
  
      if cmn.IsUnmarkedTask( "chestroom", "solderingiron" ) then
          unmark_solderingiron();
      end;
        
     end;
      
    end;

  end;
  cmn.AddSubscriber( "win_chestroom", start_chestroom_func, "ho_chestroom" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_chestroom" ) ) then
  
    cmn.InitHo( "chestroom" );
    cmn.SetEventDone( "opn_chestroom" );
    cmn.SetMarkedTask( "chestroom", "aerograph" );
    cmn.SetMarkedTask( "chestroom", "solderingiron" );
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "microchip_2",          1, 0, { { "spr_chestroom_microchip_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "aerograph",          1, 1, { { "spr_chestroom_web", "spr_chestroom_brush" }, { "spr_chestroom_aerograph" } } );
  interface.TaskPanelTaskAdd( ho_items, "allenkey",          1, 0, { { "spr_chestroom_allenkey" } } );
  interface.TaskPanelTaskAdd( ho_items, "ax",          1, 0, { { "spr_chestroom_ax" } } );
  interface.TaskPanelTaskAdd( ho_items, "battery",          1, 0, { { "spr_chestroom_battery" } } );
  interface.TaskPanelTaskAdd( ho_items, "item",          1, 0, { { "spr_chestroom_item" } } );
  interface.TaskPanelTaskAdd( ho_items, "oiler",          1, 0, { { "spr_chestroom_oiler" } } );
  interface.TaskPanelTaskAdd( ho_items, "pliers",          1, 0, { { "spr_chestroom_pliers" } } );
  interface.TaskPanelTaskAdd( ho_items, "pruner",          1, 0, { { "spr_chestroom_pruner" } } );
  interface.TaskPanelTaskAdd( ho_items, "roulette",          1, 0, { { "spr_chestroom_roulette" } } );
  interface.TaskPanelTaskAdd( ho_items, "sinker",          1, 0, { { "spr_chestroom_sinker" } } );
  interface.TaskPanelTaskAdd( ho_items, "solderingiron",          1, 1, { { "spr_chestroom_part", "spr_chestroom_solderingiron_old" },{ "spr_chestroom_solderingiron" } } );
  
  --interface.ItemPanelItemAdd( ho_items, ""    );

  interface.TaskPanelShow( ho_items );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_chestroom_"..task_name, task_name );
  if task_name == "microchip_2" then
     ObjDelete( "spr_chestroom_microchip_2_shadow" );
  end;
end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  local item_object_name = "obj_"..cmn.GetObjectName( item_name );

  ObjDelete( item_object_name );

  interface.ItemPanelTryToComplete();

end;
--********************************************************************************************************************
function private.GetItem( name )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );

  ObjSet( name, { alp = 0 } );
  ObjSet( name.."_2", { alp = 1, pos_z = 5 } );

end;
--********************************************************************************************************************
function private.unmark_solderingiron() 
 
  if common.ApplyObj( "spr_chestroom_part_2", "spr_chestroom_solderingiron" ) then
      
    local func_after = function()

      common_impl.Lock( false );

      cmn.UnmarkTask( "chestroom", "solderingiron" );
      cmn.CallEventHandler( "unmark_solderingiron" );

    end;
    
      common_impl.Lock( true );
      ObjSet( "spr_chestroom_part_2", { alp = 0 } );

      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_chestroom_aerograph", 0, "", 0 );

      ObjAnimate( "spr_chestroom_solderingiron_old", "alp", 0, 0, func_after, { 0,3,0,  0.3,3,1 } );
      ObjAnimate( "spr_chestroom_solderingiron", "alp", 0, 0, "", { 0,3,0,  0.3,3,1 } );
  else

    ObjSet( "spr_chestroom_part", { alp = 1 } );
    ObjSet( "spr_chestroom_part_2", { pos_z = 0, alp = 0 } );

  end;
  
  common_impl.SetCursor( CURSOR_DEFAULT );
    
end;
--*********************************************************************************************************************
function private.unmark_aerograph() 
 
  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "spr_chestroom_ex", { alp = 1, pos_z = 0 } );

    cmn.UnmarkTask( "chestroom", "aerograph" );
    cmn.CallEventHandler( "unmark_aerograph" );

  end;

    if common.ApplyObj( "spr_chestroom_brush_2", "spr_chestroom_web" ) then
  
      common_impl.Lock( true );
      
      ObjSet( "spr_chestroom_brush_2", { alp = 0 } );

      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_chestroom_brush", 0, "", 0 );
      
      ObjSet( "anm_chest_web", { alp = 1 } );
      ObjSet( "spr_chestroom_web", { alp = 0 } );
      ObjSet( "spr_chestroom_brush_2", { alp = 0 } );      
      AnimPlay( "anm_chest_web", "DoAnim", func_after );
      
    else

      ObjSet( "spr_chestroom_brush", { alp = 1 } );
      common_impl.SetCursor( CURSOR_DEFAULT );
      ObjSet( "spr_chestroom_brush_2", { pos_z = 0, alp = 0 } );
   
    end;
    
    common_impl.SetCursor( CURSOR_DEFAULT );
   
end;