-- name=ho_noteroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "noteroom" );
  game.relations[ "ho_noteroom" ].exitroom = "rm_smallroom";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_noteroom_icon_1",  { event_mdown = function() private.TaskComplete( 'icon_1',  "note_1" ) end } },
  { "spr_noteroom_icon_2",  { event_mdown = function() private.TaskComplete( 'icon_2',  "note_1" ) end } },
  { "spr_noteroom_icon_3",  { event_mdown = function() private.TaskComplete( 'icon_3',  "note_1" ) end } },
  { "spr_noteroom_icon_4",  { event_mdown = function() private.TaskComplete( 'icon_4',  "note_1" ) end } },
  { "spr_noteroom_icon_5",  { event_mdown = function() private.TaskComplete( 'icon_5',  "note_2" ) end } },
  { "spr_noteroom_icon_6",  { event_mdown = function() private.TaskComplete( 'icon_6',  "note_2" ) end } },
  { "spr_noteroom_icon_7",  { event_mdown = function() private.TaskComplete( 'icon_7',  "note_2" ) end } },
  { "spr_noteroom_icon_8",  { event_mdown = function() private.TaskComplete( 'icon_8',  "note_2" ) end } },
  { "spr_noteroom_icon_9",  { event_mdown = function() private.TaskComplete( 'icon_9',  "note_3" ) end } },
  { "spr_noteroom_icon_10", { event_mdown = function() private.TaskComplete( 'icon_10', "note_3" ) end } },
  { "spr_noteroom_icon_11", { event_mdown = function() private.TaskComplete( 'icon_11', "note_3" ) end } },
  { "spr_noteroom_icon_12", { event_mdown = function() private.TaskComplete( 'icon_12', "note_3" ) end } },
 
  { "spr_noteroom_taskpanel_item_note_1", { event_startdrag = function() private.GetNote( 'note_1' ) end ,event_dragdrop = function() private.UseItem( 'note_1' ) end } },
  { "spr_noteroom_taskpanel_item_note_2", { event_startdrag = function() private.GetNote( 'note_2' )  end, event_dragdrop = function() private.UseItem( 'note_2' ) end } },
  { "spr_noteroom_taskpanel_item_note_3", { event_startdrag = function() private.GetNote( 'note_3' )  end, event_dragdrop = function() private.UseItem( 'note_3' ) end } },
  
  } );
  
  --------------------------------------------------------------------------------------------------
  private.taskpanel = 
  {
    note_1 = { "spr_noteroom_icon_1", "spr_noteroom_icon_2",  "spr_noteroom_icon_3",  "spr_noteroom_icon_4" },
    note_2 = { "spr_noteroom_icon_5", "spr_noteroom_icon_6",  "spr_noteroom_icon_7",  "spr_noteroom_icon_8" },
    note_3 = { "spr_noteroom_icon_9", "spr_noteroom_icon_10", "spr_noteroom_icon_11", "spr_noteroom_icon_12"},
  }
--------------------------------------------------------------------------------------------------
  
  common_impl.hint[ "win_noteroom" ] = {
      type = "win",
      room = "rm_smallroom",
      zz = "ho_noteroom",
      zz_gate = "gho_smallroom_noteroom"
  };
  
  local win_noteroom_func = function ()

    if ( cmn.IsEventDone( "win_noteroom" ) ) then
      interface.InventoryItemAdd( "inv_paperwithnotes", "spr_noteroom_win" );
      ObjDelete( "spr_noteroom_win_add" );
    end;

  end;
  local win_noteroom_loc = function ()
    if ( cmn.IsEventDone( "win_noteroom" ) ) then
      ObjDelete( "gho_smallroom_noteroom" );
    end;
  end;
  
  cmn.AddSubscriber( "win_noteroom", win_noteroom_loc, "rm_smallroom" );
  cmn.AddSubscriber( "win_noteroom", win_noteroom_func );
  --------------------------------------------------------------------------------------------------
   --------------------------------------------------------------------------------------------------
  local win_noteroom_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_noteroom" ) ) then

      local ho_progress = ng_global.progress[ "std" ][ "win_noteroom" ];
      for key, value in pairs( private.taskpanel ) do

        local flag_complete = true;
        for i = 1, #private.taskpanel[ key ] do

          if ( not ho_progress.items[ private.taskpanel[ key ][ i ] ] ) then
            flag_complete = false;
            break;
          end;

        end;

        if ( ho_progress.parts[ key ] )then
          
          ObjDelete( "spr_noteroom_taskpanel_item_"..key );
          ObjDelete( "spr_noteroom_"..key.."_issue" );
        
          table.insert( table_multiset, { "spr_noteroom_taskpanel_part_"..key, { input = false } } );
          table.insert( table_multiset, { "spr_noteroom_"..key, { alp = 1 } } );
          
        elseif ( flag_complete ) then

          table.insert( table_multiset, { "spr_noteroom_taskpanel_item_"..key, { input = true, alp = 1 } } );
          table.insert( table_multiset, { "obj_noteroom_use_item_"..key.."_hint", { input = true } } );
          table.insert( table_multiset, { "spr_noteroom_taskpanel_part_"..key, { input = false } } );
         
        end;

      end;

      for j = 1, #ng_global.progress["std"]["win_noteroom"].found do

        local name = tostring( ng_global.progress[ "std" ][ "win_noteroom" ].found[ j ][ "task" ] );
        
        if not string.find( name, "note" ) then
       
          ObjDelete( "spr_noteroom_taskpanel_"..name.."_inv" );
          ObjDelete( "spr_noteroom_"..name );
        
        end;

      end;

    end;
    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  cmn.AddSubscriber( "win_noteroom", win_noteroom_func, "ho_noteroom" );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_noteroom" ) ) then
  
    cmn.InitHo( "noteroom" );
    cmn.SetEventDone( "opn_noteroom" );
  
    ng_global.progress["std"]["win_noteroom"].items = {};
    ng_global.progress["std"]["win_noteroom"].parts = {};
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "icon_1",          1, 0, { { "spr_noteroom_icon_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_2",          1, 0, { { "spr_noteroom_icon_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_3",          1, 0, { { "spr_noteroom_icon_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_4",          1, 0, { { "spr_noteroom_icon_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_5",          1, 0, { { "spr_noteroom_icon_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_6",          1, 0, { { "spr_noteroom_icon_6" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_7",          1, 0, { { "spr_noteroom_icon_7" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_8",          1, 0, { { "spr_noteroom_icon_8" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_9",          1, 0, { { "spr_noteroom_icon_9" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_10",         1, 0, { { "spr_noteroom_icon_10" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_11",         1, 0, { { "spr_noteroom_icon_11" } } );
  interface.TaskPanelTaskAdd( ho_items, "icon_12",         1, 0, { { "spr_noteroom_icon_12" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "note_1",         1, 0, { { "spr_noteroom_taskpanel_item_note_1", "obj_noteroom_use_item_note_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "note_2",         1, 0, { { "spr_noteroom_taskpanel_item_note_2", "obj_noteroom_use_item_note_2_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "note_3",         1, 0, { { "spr_noteroom_taskpanel_item_note_3", "obj_noteroom_use_item_note_3_hint" } } );
 
  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "noteroom" );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "noteroom" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, part )

  cmn.HoTaskFind( "spr_noteroom_"..task_name, task_name );
  
  local func_after = function()
  
    
  end;

  private.check_task( "spr_noteroom_"..task_name, part );   

  ObjAnimate( "spr_noteroom_taskpanel_"..task_name.."_inv", "scale_xy", 0, 0, func_after, { 0,3,0.9,0.9,  0.4,3,0,0 } );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.check_task( obj, part )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_noteroom" ];
  
  ho_progress.items[ obj ] = true;
  local flag_complete = true;
  for i = 1, #private.taskpanel[ part ] do

    if ( not ho_progress.items[ private.taskpanel[ part ][ i ] ] ) then

      flag_complete = false;
      break;

    end;

  end;

  if ( flag_complete ) then    
    
    local func_after = function()
    
      ObjSet( "spr_noteroom_taskpanel_item_"..part, { input = true, alp = 1 } );
      ObjSet( "obj_noteroom_use_item_"..part.."_hint", { input = true } );      

    end;

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_notes_open", 0, "", 0 );

    ObjAnimate( "spr_noteroom_taskpanel_part_"..part, "scale_x", 0, 0, func_after, { 0,0,1, 0.4,0,0, 0.8,0,1 } );
    ObjAnimate( "spr_noteroom_taskpanel_item_"..part, "alp", 0, 0, "", { 0,0,0, 0.4,0,0, 0.41,0,1 } );
    ObjAnimate( "spr_noteroom_taskpanel_item_"..part, "scale_x", 0, 0, "", { 0,0,0.5, 0.4,0,0, 0.8,0,0.5 } );
    
  end;
  
end;

-------------------------------------------------------------------------------------
function private.GetNote( name )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );
  local item = "obj_noteroom_taskpanel_item_"..name;
  
  ObjSet( item, { pos_z = 5 } );

end;
-------------------------------------------------------------------------------------
function private.UseItem( name )

  local item = "spr_noteroom_taskpanel_item_"..name;
  
  if ( ObjIntersect( item, "obj_noteroom_use_note" ) ) then

    ObjDelete( item );

    local func_after = function()

      common_impl.Lock(false);
      cmn.HoTaskFind( "spr_noteroom_"..name.."_hint", name, true );
      ng_global.progress[ ng_global.currentprogress ][ "win_noteroom" ].parts[ name ] = true;
   
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_notes_insert", 0, "", 0 );

     ObjAnimate( "spr_noteroom_"..name, "alp", 0, 0, func_after, 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } );      
  
    ObjAnimate( "spr_noteroom_"..name.."_issue", "alp", 0, 0, "", 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 
  
  else

    ObjSet( "obj_noteroom_taskpanel_item_"..name, { pos_z = 1 } );
   
  end;

end;
--*********************************************************************************************************************
----------------------------------------------------------------------------
