-- name=ho_orchestra
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "orchestra" );
  game.relations[ "ho_orchestra" ].exitroom = "rm_hall";
  --------------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_orchestra = function ()

  local effects_table = 
  {
  --"anm_orchestra_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_orchestra", update_performance_mode_orchestra, "ho_orchestra" );
  --------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_orchestra_bagpipes", { event_mdown = function() private.TaskComplete( 'bagpipes' ) end } },
  { "spr_orchestra_bugle", { event_mdown = function() private.TaskComplete( 'bugle' ) end } },
  { "spr_orchestra_flute", { event_mdown = function() private.TaskComplete( 'flute' ) end } },
  { "spr_orchestra_folding", { event_mdown = function() private.TaskComplete( 'folding' ) end } },
  { "spr_orchestra_guitar", { event_mdown = function() private.TaskComplete( 'guitar' ) end } },
  { "spr_orchestra_gusli", { event_mdown = function() private.TaskComplete( 'gusli' ) end } },
  { "spr_orchestra_harpsichord", { event_mdown = function() private.TaskComplete( 'harpsichord' ) end } },
  { "spr_orchestra_lute", { event_mdown = function() private.TaskComplete( 'lute' ) end } },
  { "spr_orchestra_setar", { event_mdown = function() private.TaskComplete( 'setar' ) end } },
  { "spr_orchestra_violin", { event_mdown = function() private.TaskComplete( 'violin' ) end } },
  { "spr_orchestra_wind", { event_mdown = function() private.TaskComplete( 'wind' ) end } },
  { "spr_orchestra_wind_2", { event_mdown = function() private.TaskComplete( 'wind_2' ) end } },
  { "grm_orchestra_hall", { event_mdown = private.GotoRoom } }
  
  } );
  
  private.ho_close = false;
  
  common_impl.hint[ "win_orchestra" ] = {
      type = "win",
      room = "rm_hall",
      zz = "ho_orchestra",
      zz_gate = "gho_hall_orchestra"
  };
  
  local win_orchestra_func = function ()

    if ( cmn.IsEventDone( "win_orchestra" ) ) then
      interface.InventoryItemAdd( "inv_coin", "spr_orchestra_win" );
      ObjDelete( "spr_orchestra_win_add" );
    end;

  end;
  cmn.AddSubscriber( "win_orchestra", win_orchestra_func );
  --------------------------------------------------------------------------------------------------
  local start_orchestra_func = function ()

    if ( cmn.IsEventStart( "win_orchestra" ) ) then
  
      local ho_found = ng_global.progress[ "std" ][ "win_orchestra" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        ObjDelete( "spr_orchestra_taskpanel_"..ho_found[ i ][ "task" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_orchestra", start_orchestra_func, "ho_orchestra" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_orchestra" ) ) then
  
    cmn.InitHo( "orchestra" );
    cmn.SetEventDone( "opn_orchestra" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bagpipes",          1, 0, { { "spr_orchestra_bagpipes" } } );
  interface.TaskPanelTaskAdd( ho_items, "bugle",          1, 0, { { "spr_orchestra_bugle" } } );
  interface.TaskPanelTaskAdd( ho_items, "flute",          1, 0, { { "spr_orchestra_flute" } } );
  interface.TaskPanelTaskAdd( ho_items, "folding",          1, 0, { { "spr_orchestra_folding" } } );
  interface.TaskPanelTaskAdd( ho_items, "guitar",          1, 0, { { "spr_orchestra_guitar" } } );
  interface.TaskPanelTaskAdd( ho_items, "gusli",          1, 0, { { "spr_orchestra_gusli" } } );
  interface.TaskPanelTaskAdd( ho_items, "harpsichord",          1, 0, { { "spr_orchestra_harpsichord" } } );
  interface.TaskPanelTaskAdd( ho_items, "lute",          1, 0, { { "spr_orchestra_lute" } } );
  interface.TaskPanelTaskAdd( ho_items, "setar",          1, 0, { { "spr_orchestra_setar" } } );
  interface.TaskPanelTaskAdd( ho_items, "violin",          1, 0, { { "spr_orchestra_violin" } } );
  interface.TaskPanelTaskAdd( ho_items, "wind",          1, 0, { { "spr_orchestra_wind" } } );
  interface.TaskPanelTaskAdd( ho_items, "wind_2",          1, 0, { { "spr_orchestra_wind_2" } } );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "orchestra" );
 
  if ng_global.progress[ "std" ][ "see_tutorial" ] and ng_global.progress[ "std" ][ "see_tutorial" ].state.no == 0 and
    ( ng_global[ "gamemode" ] ~= 2 or ( ng_global[ "gamemode" ] == 3 and ng_global[ "gamemode_custom" ][ "tutorial" ] ) ) then
  
    if ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_8" ].shown == 0 then

      common_impl.TutorialShow( "tutorial_page_8" );

    elseif ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_9" ].show == 0 then

      common_impl.TutorialShow( "tutorial_page_9" );

    end;
    
  end;
  
  private.ho_close = false;
  
  --common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "orchestra" );
  
  --common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );
  
  common_impl.PlayAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.TutorialShow( page )
  
  if ng_global.progress[ "std" ][ "see_tutorial" ] and ng_global.progress[ "std" ][ "see_tutorial" ].state.no == 0 and
    ( ng_global[ "gamemode" ] ~= 2 or ( ng_global[ "gamemode" ] == 3 and ng_global[ "gamemode_custom" ][ "tutorial" ] ) ) then

    local func_after = function()

      if not private.ho_close then

        common_impl.TutorialShow( page );

      else

        interface.TutorialHide();
        common_impl.TutorialSetShown( "tutorial_page_9" );
        ObjSet( "tmr_orchestra_tutor", { playing = false } );

      end;

    end;

    ObjSet( "tmr_orchestra_tutor", { playing = true, time = 0.1, endtrig = func_after } );
    
  end;

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;

  cmn.GotoRoom( "rm_hall" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_orchestra_"..task_name, task_name );
  
  ObjAnimate( "spr_orchestra_taskpanel_"..task_name, "scale_xy", 0, 0, function()  private.TextAnim( task_name ); end, { 0,0,0.7,0.7, 0.4,0,0,0 } );
  
  if task_name ~= "harpsichord" then
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_orchestra_"..task_name, 0, "", 0 );
    
  else
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_orchestra_xylo", 0, "", 0 );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TextAnim( task_name )

  ObjClone( "obj_orchestra_name", "_"..task_name, 1, "obj_orchestra_names" );
  ObjClone( "anm_orchestra_name", "_"..task_name, 1, "obj_orchestra_names" );
  
  local pos = GetObjPosByObj( "spr_orchestra_"..task_name );
  
  local ang = math.random( 78, 235 ) / 100;

  ObjSet( "obj_orchestra_name_"..task_name, { ang = ang, pos_x = pos[1], pos_y = pos[2] - 20 } );
  ObjSet( "txt_orchestra_name_"..task_name, { ang = - ang, alp = 1, text = "str_orchestra_"..task_name } );
  ObjSet( "anm_orchestra_name_"..task_name, { pos_x = pos[1] - 615, pos_y = pos[2] - 400, alp = 1, playing = true } );
  
  local delay_tm = 1;
 
  local delay = delay_tm * ( 2 - 1 );

  ObjAnimate( "txt_orchestra_name_"..task_name, "pos_x", 0, 0, "", { 0, 0, 0,   delay/2, 0, 0,    ( delay + delay_tm ), 0, 90 } );
  ObjAnimate( "obj_orchestra_name_"..task_name, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   delay/2, 0, 1, 1,    ( delay + delay_tm/2 ), 3, 1.2, 1.2,   ( delay + delay_tm ), 3, 1, 1, } );
  ObjAnimate( "obj_orchestra_name_"..task_name, "alp", 0, 0, "", { 0, 0, 0,   delay/2, 0, 0,    ( delay + delay_tm/2 ), 0, 1,   ( delay + delay_tm ), 0, 0 } );
 
end;
--*********************************************************************************************************************
