-- name=ho_pictureroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pictureroom" );
  game.relations[ "ho_pictureroom" ].exitroom = "rm_lunchroom";
  private.room_objname = "ho_pictureroom";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_pictureroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
  end;

  local mas_parent_gfx = 
  {
    private.room_objname
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_pictureroom", update_game_mode_pictureroom, private.room_objname );
  
  ObjMultiSet( {
  
    { "spr_pictureroom_button", { event_mdown = function() private.get_button() end } },
 
  
  } );
  
  for i = 1, 18 do
    
    ObjSet( "spr_pictureroom_sign_"..i, { input = true, event_mdown = function() private.TaskComplete( 'sign_'..i ) end } );
    
  end;
  
  common_impl.hint[ "win_pictureroom" ] = {
      type = "win",
      room = "rm_lunchroom",
      zz = "ho_pictureroom",
      zz_gate = "gho_lunchroom_pictureroom"
  };
  
  local win_pictureroom_loc = function ()

    if ( cmn.IsEventDone( "win_pictureroom" ) ) then
      
      --ObjDelete( "anm_lunchroom_stranger_stand" );
      --ObjSet( "anm_lunchroom_stranger_seat", { playing = true, alp = 1 });
      --ObjSet( "obj_lunchroom_bbt_seat", { input = true });
      ObjSet( "spr_lunchroom_picture_open", { alp = 1 });
      
    end;

  end;
  
  cmn.AddSubscriber( "win_pictureroom", win_pictureroom_loc, "rm_lunchroom" );  
  
  local win_pictureroom_func = function ()

    if ( cmn.IsEventDone( "win_pictureroom" ) ) then
      
      ObjSet( "obj_pictureroom_open", { alp = 1, input = true } );
      ObjSet( "gfx_pictureroom_button", { active = true } );
      ObjDelete( "anm_pictureroom_open" );
      
    end;

  end;
  
  cmn.AddSubscriber( "win_pictureroom", win_pictureroom_func );
  --------------------------------------------------------------------------------------------------
  local start_pictureroom_func = function ()

    if ( cmn.IsEventStart( "win_pictureroom" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_pictureroom" ].found;
      
      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_pictureroom", start_pictureroom_func, "ho_pictureroom" );

  --------------------------------------------------------------------------------------------
  -- function get_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button" ] = {
    type = "get",
    get_obj = "spr_pictureroom_button",
    room = "rm_lunchroom",
    zz = "ho_pictureroom",
    zz_gate = "gho_lunchroom_pictureroom"
    
  };
    
  local get_button_inv = function ()
  
    interface.InventoryItemAdd( "inv_button", "spr_pictureroom_button" );
  
  end;
  
  local get_button_closezz = function ()
  
    ObjDelete( "gfx_pictureroom_button" );
    ObjDelete( "spr_pictureroom_button_shadow" );
    ObjDelete( "gho_lunchroom_pictureroom" );
    ObjDelete( "spr_lunchroom_picture_button" );
    
  end;
  
  cmn.AddSubscriber( "get_button", get_button_inv );
  cmn.AddSubscriber( "get_button", get_button_closezz, private.room_objname );
  cmn.AddSubscriber( "get_button", get_button_closezz, "rm_lunchroom" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventDone( "opn_pictureroom" ) ) then
  
    cmn.InitHo( "pictureroom" );
    cmn.SetEventDone( "opn_pictureroom" );
    
    ng_global.progress["std"]["win_pictureroom"].counter = 18;
  
  end;
  
  if not cmn.IsEventDone( "win_pictureroom" ) then

    local ho_items = {};

    interface.TaskPanelTaskAdd( ho_items, "sign_1",          1, 0, { { "spr_pictureroom_sign_1" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_2",          1, 0, { { "spr_pictureroom_sign_2" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_3",          1, 0, { { "spr_pictureroom_sign_3" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_4",          1, 0, { { "spr_pictureroom_sign_4" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_5",          1, 0, { { "spr_pictureroom_sign_5" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_6",          1, 0, { { "spr_pictureroom_sign_6" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_7",          1, 0, { { "spr_pictureroom_sign_7" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_8",          1, 0, { { "spr_pictureroom_sign_8" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_9",          1, 0, { { "spr_pictureroom_sign_9" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_10",          1, 0, { { "spr_pictureroom_sign_10" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_11",          1, 0, { { "spr_pictureroom_sign_11" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_12",          1, 0, { { "spr_pictureroom_sign_12" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_13",          1, 0, { { "spr_pictureroom_sign_13" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_14",          1, 0, { { "spr_pictureroom_sign_14" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_15",          1, 0, { { "spr_pictureroom_sign_15" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_16",          1, 0, { { "spr_pictureroom_sign_16" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_17",          1, 0, { { "spr_pictureroom_sign_17" } } );
    interface.TaskPanelTaskAdd( ho_items, "sign_18",          1, 0, { { "spr_pictureroom_sign_18" } } );
    
    int_taskpanel_impl.HideTextPanel( "pictureroom" );
    
    interface.TaskPanelShow( ho_items );
    
    common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
    
    ObjSet( "txt_pictureroom_taskpanel", { param0 = ng_global.progress["std"]["win_pictureroom"].counter } );
    
  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "pictureroom" );
   
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  cmn.HoTaskFind( "spr_pictureroom_"..task_name, task_name );
  
  ObjAnimate( "spr_pictureroom_"..task_name.."_add", "alp", 0, 0, "", { 0,0,0, 0.1,0,1 } );
  
  ng_global.progress["std"]["win_pictureroom"].counter = ng_global.progress["std"]["win_pictureroom"].counter - 1;

  ObjSet( "txt_pictureroom_taskpanel", { param0 = ng_global.progress["std"]["win_pictureroom"].counter } );

end;
--*********************************************************************************************************************
function public.HoComplete()

  ObjSet("obj_pictureroom_taskpanel",{ alp = 0 });
  common_impl.PassingHoWin();
  common_impl.PlayAudio( "sfx","common/audio/aud_ho_win");
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_button()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );

  cmn.GotoRoom( "rm_lunchroom" );

end;
--*********************************************************************************************************************
-- function *** WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )

  local func_after = function()

    common_impl.Lock( false );

    cmn.SetEventDone( "win_pictureroom" );
    cmn.CallEventHandler( "win_pictureroom" );

  end;
  
    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_pictureroom_win", 0, "", 0 );
    
    ObjSet( "anm_pictureroom_open", { alp = 1 } );
    ObjSet( "obj_pictureroom_open", { alp = 1 } );
    
    AnimPlay( "anm_pictureroom_open", "DoAnim", func_after );
    
end;
--*********************************************************************************************************************
-- function *** HINT *** () end;
--*********************************************************************************************************************
--******************************************************************************************
function public.HoHintShow()

  local hint_table = { hint = {} };

  if not cmn.IsEventDone( "win_pictureroom" ) then

    local objects = ObjGetRelations( "obj_pictureroom_objects" ).childs;

    local objname = objects[ math.random( 1, #objects ) ];
    local pos = GetObjPosByObj( objname );

    table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

  else

    if not cmn.IsEventDone( "get_button" ) then

      local objname = "spr_pictureroom_button" ;
      local pos = GetObjPosByObj( objname );

      table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

    end;

  end;

  if #hint_table.hint ~= 0 then

    MsgSend( Command_Effect_ShowHoHint, hint_table );

  else

    MsgSend( Event_HoHint_NoObjects, {} );

  end;

end;
--*********************************************************************************************************************
