-- name=mg_harproom
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_harproom";
  
  ObjMultiSet({
      { "spr_harproom_mode_btn_play", { event_mdown = function() private.StartAnim() end;
                                        event_menter = function() private.MouseEnterAnim( "spr_harproom_mode_btn_play" ) end, 
                                        event_mleave = function() private.MouseLeaveAnim( "spr_harproom_mode_btn_play" ) end; } },
      { "spr_harproom_mode_btn_hard", { event_mdown = function() private.SetHard() end,
                                        event_menter = function() private.MouseEnterAnim( "spr_harproom_mode_btn_hard" ) end, 
                                        event_mleave = function() private.MouseLeaveAnim( "spr_harproom_mode_btn_hard" ) end; } },
      { "spr_harproom_mode_btn_casual", { event_mdown = function() private.SetNormal() end;
                                        event_menter = function() private.MouseEnterAnim( "spr_harproom_mode_btn_casual" ) end, 
                                        event_mleave = function() private.MouseLeaveAnim( "spr_harproom_mode_btn_casual" ) end; } },
  });
  --{ 3,1,2,5,3,4,2,1,3 }
  
  
  private.coord_mas = 
  {
  { { 312,461 }, { 287,408 }, { 261,353 }, { 234,298 }, { 206,245 } },
  { { 351,437 }, { 325,387 }, { 298,333 }, { 272,279 }, { 244,225 } },
  { { 392,420 }, { 368,371 }, { 339,316 }, { 314,262 }, { 286,211 } },
  { { 432,400 }, { 405,349 }, { 377,295 }, { 351,241 }, { 324,191 } },
  { { 474,383 }, { 447,331 }, { 420,279 }, { 393,223 }, { 367,173 } },
  { { 510,362 }, { 483,311 }, { 458,258 }, { 430,204 }, { 405,153 } },
  { { 551,346 }, { 527,296 }, { 499,241 }, { 472,186 }, { 446,137 } },
  { { 590,325 }, { 567,278 }, { 539,221 }, { 514,169 }, { 486,115 } },
  { { 627,302 }, { 604,253 }, { 575,198 }, { 551,148 }, { 524,93 } }
  };

  for i = 1,9 do
    
    ObjSet( "obj_harproom_ball_"..i, { drag = true, event_startdrag = function() private.StartDrag( i ) end, event_drag = function() private.Drag( i ) end,
    event_dragdrop = function() private.DropDrag( i ) end,
    event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
    event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
    event_mdown = function() private.Click( i ); end } );
    
  end;
  
  common_impl.hint[ "win_harproom" ] = {
    type = "win",
    room = "rm_offstage",
    zz = "mg_harproom",
    zz_gate = "gmg_offstage_harproom"
  };
  --------------------------------------------------------------------------------------------
  -- function win_harproom () end;
  --------------------------------------------------------------------------------------------
  local win_harproom = function ()

  if ( cmn.IsEventDone( "win_harproom" ) ) then 
    ObjSet( "spr_offstage_open_door", { alp = 1});

    else
    
      for i = 1,9 do
        local mas = ng_global.progress[ "std" ][ "win_harproom" ].state[i]
        ObjSet( "spr_harproom_ball_"..i, { pos_x = private.coord_mas[i][mas][1], pos_y = private.coord_mas[i][mas][2] } );
        
      end;
      if ng_global.progress[ "std" ][ "win_harproom" ].hardcore then
        
        ObjMultiSet({
        { "obj_harproom_mode_hard", { alp = 1, input = true } },
        { "spr_harproom_mode_btn_casual", { input = true } },
        { "spr_harproom_mode_btn_hard", { input = false } },
        });
      else
        
        ObjMultiSet({
        { "obj_harproom_mode_hard", { alp = 0, input = false } },
        { "spr_harproom_mode_btn_casual", { input = false } },
        { "spr_harproom_mode_btn_hard", { input = true } },
        });
        
      end;
      
      
    end;

  end;

  cmn.AddSubscriber( "win_harproom", win_harproom, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_harproom" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  iOS_NeedDrag(0);
  if ( not cmn.IsEventStart( "win_harproom" ) ) then
    ng_global.progress[ "std" ][ "win_harproom" ].state = { 3,1,2,5,3,4,2,1,3 };
    ng_global.progress[ "std" ][ "win_harproom" ].hardcore = true;
    ng_global.progress[ "std" ][ "win_harproom" ].win = { 5,3,3,4,1,2,1,5,3 };
  end;
  
  if not cmn.IsEventDone( "win_harproom" ) then
   if ng_global.gamemode == 0 then
      private.SetNormal();
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  iOS_NeedDrag(1);
  if not cmn.IsEventDone( "win_harproom" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Click( number )
  
  local sound = ng_global.progress[ "std" ][ "win_harproom" ].state[number];
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_"..sound, 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.StartDrag( number )

  ObjMultiSet({ 
    { "spr_harproom_ball_"..number.."_green", { alp = 0 } },
    { "spr_harproom_ball_"..number.."_red", { alp = 0 } },
    { "spr_harproom_ball_"..number.."_yellow", { alp = 0 } },  
  });
  
end;
--*********************************************************************************************************************
function private.Drag( number )
  
  local old_last_pos = private.last_pos;
  
  local start_y = ObjGet( "spr_harproom_ball_"..number ).pos_y;

  local cur_pos = GetZoomCursorPos();
  if cur_pos[2] < private.coord_mas[number][5][2] then

    ObjSet( "spr_harproom_ball_"..number, { pos_x = private.coord_mas[number][5][1], pos_y = private.coord_mas[number][5][2] } )
    private.last_pos = 5;
    
  elseif cur_pos[2] > private.coord_mas[number][1][2] then

    ObjSet( "spr_harproom_ball_"..number, { pos_x = private.coord_mas[number][1][1], pos_y = private.coord_mas[number][1][2] } )
    private.last_pos = 1;
    
  else
    
    for i = 2,5 do
      
      if private.coord_mas[number][7-i][2] > cur_pos[2] then
        
        ObjSet( "spr_harproom_ball_"..number, { pos_x = private.coord_mas[number][7-i][1], pos_y = private.coord_mas[number][7-i][2] } )
        private.last_pos = 7-i;
        break;
        
      end;
      
    end;
  
  end;

  if ( private.last_pos ) and old_last_pos ~= private.last_pos then
  
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_"..private.last_pos, 0, "", 0 );
    
  end;
  
end;
function private.DropDrag( number )
  
  ng_global.progress[ "std" ][ "win_harproom" ].state[number] = private.last_pos;
  
end;
function private.StartAnim( skip )
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_play", 0, "", 0 );

  ObjAnimate("spr_harproom_mode_btn_stop", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    2.5, 3, 1,
    2.7, 3, 0
  });
  
  local anim_mas = {};
  local trg_after = "";
  local win_flag = true;
 
  local func_after = function()

    if win_flag then
      
      private.Win();
      
    else
      
      common_impl.Lock( false );
      
    end;
  
  end;
  common_impl.Lock( true )

  local i = 1;
  while (i<10) do
  
    
    if i == 9 then
      
      trg_after = func_after;
 
    end;
    
    if not ObjGet( "tmr_harproom_sound_"..i ) then
   
      ObjClone( "tmr_harproom_sound", "_"..i, 1, "obj_harproom_timers"  );
      
    end;
 
    if i <= #ng_global.progress[ "std" ][ "win_harproom" ].state then
  
      local sound = ng_global.progress[ "std" ][ "win_harproom" ].state[i];
      
      ObjSet( "tmr_harproom_sound_"..i, { time = 0.3*i, playing = true,
      endtrig = function() common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_"..sound ); ObjDelete( "tmr_harproom_sound_"..i ); end  } );
      
    end; 
      
    if ng_global.progress[ "std" ][ "win_harproom" ].state[i] == ng_global.progress[ "std" ][ "win_harproom" ].win[i] or skip then
      
      ObjAnimate( "spr_harproom_ball_"..i.."_green", "alp", 0, 0, trg_after,
      { 
        0, 0, 0,
        0.3*i, 0, 0, 
        0.3*(i+1), 3, 1
      });
      
    elseif math.abs(ng_global.progress[ "std" ][ "win_harproom" ].state[i] - ng_global.progress[ "std" ][ "win_harproom" ].win[i]) == 1 then

      win_flag = false;
      ObjAnimate( "spr_harproom_ball_"..i.."_yellow", "alp", 0, 0, trg_after,
      { 
        0, 0, 0,
        0.3*i, 0, 0, 
        0.3*(i+1), 3, 1
      });
      
    else

      win_flag = false;
      ObjAnimate( "spr_harproom_ball_"..i.."_red", "alp", 0, 0, trg_after,
      { 
        0, 0, 0,
        0.3*i, 0, 0, 
        0.3*(i+1), 3, 1
      });
      
    end;

    if not ( ng_global.progress[ "std" ][ "win_harproom" ].hardcore ) then
      
      i = i + 2;

    else i = i+1;    
  
    end;
    
  end;
  
end;
--*********************************************************************************************************************

--******************************************************************************************
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
--*********************************************************************************************************************
function public.Reset()

  for i = 1,9 do 
    ng_global.progress[ "std" ][ "win_harproom" ].state[i] = math.random( 1,5 )
  end;
    for i = 1,9 do
        local mas = ng_global.progress[ "std" ][ "win_harproom" ].state[i]
        ObjMultiSet({ 
        { "spr_harproom_ball_"..i.."_green", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_red", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_yellow", { alp = 0 } }, 
        {"spr_harproom_ball_"..i, { pos_x = private.coord_mas[i][mas][1], pos_y = private.coord_mas[i][mas][2] } } 
        });        
      end;  
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  common_impl.Lock(true);
  func_after = function() private.StartAnim( true ) end;
  for i = 1, 9 do
    
    local mas = ng_global.progress[ "std" ][ "win_harproom" ].state[i]
    local mas_win = ng_global.progress[ "std" ][ "win_harproom" ].win[i];
    ObjAnimate( "spr_harproom_ball_"..i, "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, private.coord_mas[i][mas][1],private.coord_mas[i][mas][2], 
      0.3, 3, private.coord_mas[i][mas_win][1],private.coord_mas[i][mas_win][2] 
    });
    ObjAnimate( "spr_harproom_ball_"..i.."_green", "pos_xy", 0, 0, "",
    { 
    0.0, 0, ObjGet( "spr_harproom_ball_"..i.."_green" ).alp, 
    0.3, 3, 0
    });
    ObjAnimate( "spr_harproom_ball_"..i.."_red", "pos_xy", 0, 0, "",
    { 
    0.0, 0, ObjGet( "spr_harproom_ball_"..i.."_red" ).alp, 
    0.2, 3, 0 
    }); 
    ObjAnimate( "spr_harproom_ball_"..i.."_yellow", "pos_xy", 0, 0, "",
    { 
    0.0, 0, ObjGet( "spr_harproom_ball_"..i.."_yellow" ).alp, 
    0.2, 3, 0 
    });
    func_after = "";
    
    ng_global.progress[ "std" ][ "win_harproom" ].state[i] = ng_global.progress[ "std" ][ "win_harproom" ].win[i];
    
  end;  
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_harproom" );
  cmn.CallEventHandler( "win_harproom" );

  cmn.GotoRoom( "rm_offstage" );


end;
--*********************************************************************************************************************
function private.Win()
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_win", 0, "", 0 );

  private.WinEnd();

end;
--*********************************************************************************************************************
function private.SetNormal()

  local func_after = function()
  
    ObjMultiSet({
    { "obj_harproom_mode_hard", { alp = 0, input = false } },
    { "spr_harproom_mode_btn_casual", { input = false } },
    { "spr_harproom_mode_btn_hard", { input = true } },
    });
    ng_global.progress[ "std" ][ "win_harproom" ].hardcore = false;
    common_impl.Lock( false );
    for i = 1,9 do
      local mas = ng_global.progress[ "std" ][ "win_harproom" ].state[i]
      ObjMultiSet({ 
        { "spr_harproom_ball_"..i.."_green", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_red", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_yellow", { alp = 0 } }, 
      });        
    end;   
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_change_complexity", 0, "", 0 );
  
  ObjAnimate("spr_harproom_mode_btn_casual", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });

  
end;
--*********************************************************************************************************************
function private.SetHard()

  local func_after = function()
  
    ObjMultiSet({
    { "obj_harproom_mode_hard", { alp = 1, input = true } },
    { "spr_harproom_mode_btn_casual", { input = true } },
    { "spr_harproom_mode_btn_hard", { input = false } },
    });
    ng_global.progress[ "std" ][ "win_harproom" ].hardcore = true;
    common_impl.Lock( false );
    for i = 1,9 do
      local mas = ng_global.progress[ "std" ][ "win_harproom" ].state[i]
      ObjMultiSet({ 
        { "spr_harproom_ball_"..i.."_green", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_red", { alp = 0 } },
        { "spr_harproom_ball_"..i.."_yellow", { alp = 0 } }, 
      });        
    end; 
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_change_complexity", 0, "", 0 );
  
  ObjAnimate("spr_harproom_mode_btn_hard", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });
  for i = 1,9 do 
    ng_global.progress[ "std" ][ "win_harproom" ].win[i] = math.random( 1,5 )
  end;

end;
--*********************************************************************************************************************