-- name=mg_trap
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_trap";
  
  ObjMultiSet({
      { "spr_trap_mode_btn_casual", { event_mdown = function() private.SetNormal() end;
                                      event_menter = function() private.MouseEnterAnim( "spr_trap_mode_btn_casual" ) end, 
                                      event_mleave = function() private.MouseLeaveAnim( "spr_trap_mode_btn_casual" ) end; } },
      { "obj_trap_clk_snail", { event_mdown = private.clk_snail }},
      { "spr_trap_clk_voice", { event_mdown = private.clk_voice } }
                                        
  });
  --{ 3,1,2,5,3,4,2,1,3 }
  private.stage = { { 6 }, { 5, 3 }, { 1 ,4, 2 }  };
  
  private.voc_time = 11.5;
  private.bbt_time = { 0.2, 4.5, 2.9 };
 
  for i = 1,6 do
    
    ObjSet( "obj_trap_stone_"..i.."_clk", {
    event_mdown = function() private.ClkStone( i ) end,
    event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
    event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  
  common_impl.hint[ "win_trap" ] = {
    type = "win",
    room = "rm_offstage",
    zz = "mg_trap",
    zz_gate = "gmg_offstage_trap"
  };
  --------------------------------------------------------------------------------------------
  -- function win_trap () end;
  --------------------------------------------------------------------------------------------
  local win_trap = function ()

  if ( cmn.IsEventDone( "win_trap" ) ) then 
    ObjSet( "spr_offstage_open_door", { alp = 1});

  elseif cmn.IsEventStart( "win_trap" ) then
    
        for j = 2,ng_global.progress[ "std" ][ "win_trap" ].state do
          for i = 1,#private.stage[j] do
        
            name = private.stage[j][i];
            ObjSet( "anm_trap_stone_"..name.."_pushdown", { alp = 0 } );
            ObjSet( "anm_trap_stone_"..name.."_click", { alp = 1 } );
            ObjSet( "anm_trap_stone_"..name.."_pushup", { alp = 0, frame = 0 } );
            ObjSet( "obj_trap_stone_"..name.."_clk", { input = true } );

          end;
        end;

    end;

  end;

  cmn.AddSubscriber( "win_trap", win_trap, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

  private.AnimBeetle();
  private.AnimInsect();
  
end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_trap" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_trap" ) ) then
    ng_global.progress[ "std" ][ "win_trap" ].state = 1;
  end;
  ObjSet( "obj_int_button_map_button", { input = false } );
  ObjSet( "spr_int_button_map_button", { alp = 0 } );
  ObjSet( "anm_trap_wheel", { playing = false } );
  ObjSet( "spr_trap_clk_voice", { input = true } );
  ObjSet( "spr_trap_button", { alp = 1 } );
  
  common_impl.PlayAudio( "env", "common/audio/level1/aud_trap_env", 1, "", 0 );
  
 end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "sfx", "common/audio/level1/aud_dictaphone", 0.5 );
  common_impl.StopAudio( "voc", "common/audio/level1/aud_dictaphone_voc", 0.5 );
  
  ObjSet( "tmr_trap_voice", { playing = false } );
  ObjSet( "tmr_trap_bbt", { playing = false } );
  
  int_blackbartext.MouseDown();
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_trap_env", 0.5 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_trap" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkStone( number )
  
  common_impl.Lock( true );
  
  local func_after = function()
  
    if number == private.stage[ng_global.progress[ "std" ][ "win_trap" ].state][1] then
   

      
      if ng_global.progress[ "std" ][ "win_trap" ].state == 3 then
        private.Win();
      else
        
        local anim_after = function()
          
          local anim_end = function()
            
            common_impl.Lock( false );
            ng_global.progress[ "std" ][ "win_trap" ].state = ng_global.progress[ "std" ][ "win_trap" ].state + 1;
            
          end;
            
          for i = 1,#private.stage[ng_global.progress[ "std" ][ "win_trap" ].state+1] do
              
            local name = private.stage[ng_global.progress[ "std" ][ "win_trap" ].state+1][i];
            ObjSet( "anm_trap_stone_"..name.."_pushup", { alp = 0 } );
            ObjSet( "anm_trap_stone_"..name.."_click", { alp = 1, frame = 0 } );
            ObjSet( "obj_trap_stone_"..name.."_clk", { input = true } );
            
          end;
          
          anim_end();

        end;  
    
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_trap_move", 0, "", 0 );    
        for i = 1,#private.stage[ng_global.progress[ "std" ][ "win_trap" ].state+1] do
          
          local name = private.stage[ng_global.progress[ "std" ][ "win_trap" ].state+1][i];
          AnimPlay( "anm_trap_stone_"..name.."_pushup", "DoAnim", anim_after );          
          anim_after = "";
          
        end;
      
      end;
    
    else
      
      local anim_end = function()
      
        common_impl.Lock( false );
        ng_global.progress[ "std" ][ "win_trap" ].state = 1;
        
      end;   
      local anim_after = function()

        for j = 2,ng_global.progress[ "std" ][ "win_trap" ].state do
          for i = 1,#private.stage[j] do
        
            name = private.stage[j][i];
            ObjSet( "anm_trap_stone_"..name.."_pushdown", { alp = 0 } );
            --ObjSet( "anm_trap_stone_"..name.."_click", { alp = 0 } );
            ObjSet( "anm_trap_stone_"..name.."_pushup", { alp = 1, frame = 0 } );
            ObjSet( "obj_trap_stone_"..name.."_clk", { input = false } );

          end;
        end;
        
        anim_end();
        
      end;
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_trap_move", 0, "", 0 );
      for j = 2,ng_global.progress[ "std" ][ "win_trap" ].state do
        for i = 1,#private.stage[j] do
        
        name = private.stage[j][i];
        
        ObjSet( "anm_trap_stone_"..name.."_pushdown", { alp = 1 } );
        ObjSet( "anm_trap_stone_"..name.."_click", { alp = 0 } );
        --DbgTrace( name )
        AnimPlay( "anm_trap_stone_"..name.."_pushdown", "DoAnim", anim_after );       
        
        anim_after = "";
        end;
      end;
      
    end;
    
  end;

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_trap_click", 0, "", 0 );
  
  AnimPlay( "anm_trap_stone_"..number.."_click", "DoAnim", func_after );
  
end;  
--******************************************************************************************
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
--*********************************************************************************************************************
function public.Reset()

  for j = 2,ng_global.progress[ "std" ][ "win_trap" ].state do
     for i = 1,#private.stage[j] do
        
       name = private.stage[j][i];
       ObjSet( "anm_trap_stone_"..name.."_pushdown", { alp = 0, frame = 0 } );
       ObjSet( "anm_trap_stone_"..name.."_click", { alp = 0 } );
       ObjSet( "anm_trap_stone_"..name.."_pushup", { alp = 1, frame = 0 } );
       ObjSet( "obj_trap_stone_"..name.."_clk", { input = false } );

     end;
   end;
  ng_global.progress[ "std" ][ "win_trap" ].state = 1
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  common_impl.Lock(true);
  private.Win()
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_trap" );
  cmn.CallEventHandler( "win_trap" );

  cmn.GotoRoom( "mg_traproom" );


end;
--*********************************************************************************************************************
function private.Win()
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_trap_win", 0, "", 0 );

  ObjAnimate( "obj_trap_mg", "pos_y", 0, 0, private.WinEnd,
  { 
  0, 0, 0, 
  3, 3, 1000
  });

end;
--*********************************************************************************************************************
function private.clk_snail()
  
  local func_after = function()
  
    ObjSet("anm_trap_snail_2", { alp = 0 });
    
  end;
  
  ObjSet("obj_trap_clk_snail", { input = false });
  ObjSet("anm_trap_snail", { alp = 0 });
  ObjSet("anm_trap_snail_2", { alp = 1 });
  AnimPlay("anm_trap_snail_2","DoAnim", func_after );
  
end;
--*********************************************************************************************************************
function private.clk_voice()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
    common_impl.PlayAudio( "voc", "common/audio/level1/aud_dictaphone_voc", 0, "", 0 );
  
    ObjSet( "anm_trap_wheel", { playing = true } );
    ObjSet( "spr_trap_clk_voice", { input = false } );
    
    ObjSet( "tmr_trap_voice", { time = private.voc_time, playing = true, endtrig = private.after_voice } );
    
    ObjSet( "tmr_trap_bbt", { time = private.bbt_time[1], playing = true, endtrig = function() private.show_bbt( 1 ) end } );
   
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_dictaphone", 0, "", 0 );
  
  ObjAnimate( "spr_trap_button", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  
end;
--*********************************************************************************************************************
function private.after_voice()
  
  ObjSet( "anm_trap_wheel", { playing = false } );
  ObjSet( "spr_trap_clk_voice", { input = true } );
  ObjSet( "spr_trap_button", { alp = 1 } );
  
end;
--*********************************************************************************************************************
function private.show_bbt( number )
  
  common_impl.ShowBbt( 'bbt_trap_dictaphone_'..number );
  
  if number < 3 then
  
    ObjSet( "tmr_trap_bbt", { time = private.bbt_time[ number + 1 ], playing = true, endtrig = function() private.show_bbt( number + 1 ) end } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.AnimBeetle()

  ObjSet( "tmr_trap_beetle", { time = 8, playing = true, endtrig = function() AnimPlay( "anm_trap_beetle", "DoAnim", function() private.AnimBeetle() end ) end } );

end;
function private.AnimInsect()

  ObjSet( "tmr_trap_insect", { time = 10, playing = true, endtrig = function()  AnimPlay( "anm_trap_insect", "DoAnim", function() private.AnimInsect() end ) end  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************