-- name=level1

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd( 26 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.LoupeAdd( 8 );
  interface.PuzzleHelpAdd( 13 );
  interface.BtnApparatAdd( 25 );

  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();

  common.LevelLoad( "level1", "std", "rm_hall", param, private.menu_moduls );
  
  if IsCollectorsEdition() then
    
    common_impl.SetMorphEventDone();
    common_impl.SetCollectEventDone();

  end;

  private.TutorialSetParams();
  interface.KeyUpdate();
  
  common_impl.LoupeSave();
  common_impl.Collectibles2Load();
  
  
  common_impl.UpdateGameMode( ng_global.gamemode );  
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_hall"
  ,"ho_orchestra"
  ,"rm_offstage"
  ,"mg_harproom"
  ,"rm_smallroom"
  ,"ho_noteroom"
  ,"rm_corridor"
  ,"mg_trap"
  ,"mg_traproom"
  ,"rm_lunchroom"
  ,"ho_pictureroom"
  ,"rm_dungeon"
  ,"rm_beforepuzzle"
  ,"ho_chestroom"
  ,"mg_superpuzzle_1"
  ,"rm_demo"
  };

  game.progress_names_room =
  {
   {  "beg_level1" }
  ,{ "see_intro" }
  ,{ "opn_hall",                          "rm_hall",                    { "see_intro" } }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_morph_item_1_1" }
  ,{ "dlg_hall_calling",                  "rm_hall",                    { "opn_hall" } }
  ,{ "get_elf_1",                         "rm_hall",                    { "dlg_hall_calling" } }
  ,{ "get_map",                           "rm_hall",                    { "dlg_hall_calling" } }
  ,{ "get_tweezers",                      "rm_hall",                    { "dlg_hall_calling" } }
  ,{ "get_brokentokenmt",                 "rm_hall",                    { "dlg_hall_calling" } }
  ,{ "get_fragment_1",                    "rm_hall",                    { "dlg_hall_calling" } }
  ,{ "use_tweezers",                      "rm_hall",                    { "get_tweezers" } }
  ,{ "get_tokenfragment_1",               "rm_hall",                    { "use_tweezers" } }  
  ,{ "use_elf_1",                         "rm_hall",                    { "get_elf_1" } }  
  ,{ "get_tokenfragment_2",               "rm_hall",                    { "use_elf_1" } }  
  ,{ "use_tokenfragment_1",        }
  ,{ "use_tokenfragment_2",        }
  ,{ "get_tokenmt",                }
  ,{ "clk_boards",                        "rm_hall",                    { "opn_hall" } } 
  ,{ "clk_boards_1",                      "rm_hall",                    { "clk_boards" } } 
  ,{ "clk_boards_2",                      "rm_hall",                    { "clk_boards_1" } } 
  ,{ "use_tokenmt",                       "rm_hall",                    { "get_tokenmt" }, { "clk_boards_2"} } 
  ,{ "win_stash",                         "rm_hall",                    { "use_tokenmt" } } 
  ,{ "clk_bag",                    }  
  ,{ "get_knife",                         "rm_hall",                    { "win_stash" } }  
  ,{ "get_device",                        "rm_hall",                    { "win_stash" } }  
  ,{ "use_knife",                         "rm_hall",                    { "get_knife" } } 
  ,{ "get_rope",                          "rm_hall",                    { "use_knife" } } 
  ,{ "use_rope",                          "rm_hall",                    { "get_rope" } } 
  ,{ "clk_rope",                          "rm_hall",                    { "use_rope" } } 
  ,{ "opn_orchestra",                     "rm_hall",                    { "clk_rope" } } 
  ,{ "win_orchestra",                     "rm_hall",                    { "clk_rope" } } 
  ,{ "use_coin",                          "rm_hall",                    { "win_orchestra" } } 
  ,{ "get_fireextinguisher",              "rm_hall",                    { "use_coin" } } 
  ,{ "use_fireextinguisher",              "rm_hall",                    { "get_fireextinguisher" } } 
  --
  ,{ "opn_offstage",                      "rm_offstage",                { "use_fireextinguisher" } }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "vid_offstage_vanishing",            "rm_offstage",                { "opn_offstage" } }  
  ,{ "clk_harpelement_old",               "rm_offstage",                { "opn_offstage" } }
  ,{ "get_fragment_2",                    "rm_offstage",                { "clk_harpelement_old" } }  
  ,{ "get_fragment_3",                    "rm_offstage",                { "opn_offstage" } }  
  ,{ "get_battery",                       "rm_offstage",                { "opn_offstage" } }
  ,{ "get_adhesivetape",                  "rm_offstage",                { "opn_offstage" } }
  ,{ "clk_open",                }
  ,{ "use_battery",                }
  ,{ "get_dischargeddevice",       }
  ,{ "use_dischargeddevice",              "rm_offstage",                { "get_dischargeddevice" } }
  ,{ "get_charneddevice",                 "rm_offstage",                { "use_dischargeddevice" } }
  --,{ "vid_offstage_tutorial",             "rm_offstage",                { "use_dischargeddevice" } }  
  ,{ "clk_offstage_point_1",              "rm_offstage",                { "get_charneddevice" } }
  ,{ "clk_offstage_point_2",              "rm_offstage",                { "get_charneddevice" } }
  ,{ "use_charneddevice",                 "rm_offstage",                { "clk_offstage_point_1", "clk_offstage_point_2" } } 
  ,{ "win_offstage",                      "rm_offstage",                { "use_charneddevice" } }
  ,{ "vid_offstage_loupe",                "rm_offstage",                { "win_offstage" } }  
  ,{ "get_defectivedevice" } 
  ,{ "get_fragment_4",                    "rm_offstage",                { "use_device" } } 
  ,{ "use_fragment_1",                    "rm_offstage",                { "get_fragment_1" } } 
  ,{ "use_fragment_2",                    "rm_offstage",                { "get_fragment_2" } } 
  ,{ "use_fragment_3",                    "rm_offstage",                { "get_fragment_3" } } 
  ,{ "use_fragment_4",                    "rm_offstage",                { "get_fragment_4" } } 
  ,{ "use_adhesivetape",                  "rm_offstage",                { "get_adhesivetape" } }
  ,{ "get_code",                          "rm_offstage",                { "use_adhesivetape" } }
  ,{ "use_code",                          "rm_offstage",                { "get_code" } }
  ,{ "win_code",                          "rm_offstage",                { "use_code" } }
  ,{ "get_note",                          "rm_offstage",                { "win_code" } }
  ,{ "use_note",                          "rm_hall",                    { "get_note" } }
  ,{ "get_harpelement",                   "rm_hall",                    { "use_note" } }
  ,{ "use_harpelement",                   "rm_offstage",                { "get_harpelement" } }
  ,{ "win_harproom",                      "rm_offstage",                { "use_harpelement" } }
  ,{ "clk_smallroom_door",                "rm_offstage",                { "win_harproom" } }
  --
  ,{ "opn_smallroom",                     "rm_smallroom",               { "clk_smallroom_door" } }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_wrench",                        "rm_smallroom",               { "opn_smallroom" } }
  ,{ "get_windowhandle",                  "rm_smallroom",               { "opn_smallroom" } }
  ,{ "use_windowhandle",                  "rm_smallroom",               { "get_windowhandle" } }
  ,{ "clk_windowhandle",                  "rm_smallroom",               { "use_windowhandle" } }
  ,{ "use_elf_2",                         "rm_smallroom",               { "clk_windowhandle" } }
  ,{ "get_trebleclef",                    "rm_smallroom",               { "clk_windowhandle", "use_elf_2" } }
  ,{ "use_trebleclef",                    "rm_hall",                    { "get_trebleclef" } }
  ,{ "get_key",                           "rm_hall",                    { "use_trebleclef" } }
  ,{ "use_wrench",                        "rm_hall",                    { "get_wrench" } }
  ,{ "get_picklock",                      "rm_hall",                    { "use_wrench" } }
  ,{ "use_picklock",                      "rm_offstage",                { "get_picklock" } }
  ,{ "get_gear",                          "rm_offstage",                { "use_picklock" } }
  ,{ "use_gear",                          "rm_smallroom",               { "get_gear" } }
  ,{ "clk_handle",                        "rm_smallroom",               { "use_gear" } }
  ,{ "opn_noteroom",                      "rm_smallroom",               { "clk_handle" } } 
  ,{ "win_noteroom",                      "rm_smallroom",               { "clk_handle" } } 
  ,{ "use_paperwithnotes",                "rm_offstage",                { "win_noteroom" } } 
  ,{ "use_key",                           "rm_offstage",                { "get_key" } }
  ,{ "win_piano",                         "rm_offstage",                { "use_key", "use_paperwithnotes" } }
  --
  ,{ "opn_corridor",                      "rm_corridor",                { "win_piano" } }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "vid_corridor_trap",                 "rm_corridor",                { "opn_corridor" } } 
  ,{ "win_trap",                          "rm_corridor",                { "vid_corridor_trap" } }
  ,{ "win_traproom",                      "rm_corridor",                { "win_trap" } }
  ,{ "vid_corridor_saving",               "rm_corridor",                { "win_traproom" } }
  ,{ "clk_manequin",                      "rm_corridor",                { "vid_corridor_saving" } }
  ,{ "get_sign",                          "rm_corridor",                { "opn_corridor", "vid_corridor_saving" } }
  ,{ "use_elf_3",                         "rm_corridor",                { "opn_corridor", "get_elf_1"} } 
  ,{ "get_lever",                         "rm_corridor",                { "use_elf_3" } } 
  ,{ "clk_crow",                          "rm_smallroom",               { "get_lever" } }
  ,{ "use_lever",                         "rm_smallroom",               { "get_lever" } } 
  ,{ "clk_lever_1",                       "rm_smallroom",               { "use_lever" } } 
  ,{ "get_letter_1",                      "rm_smallroom",               { "clk_lever_1" } } 
  ,{ "get_hexagon",                       "rm_smallroom",               { "clk_lever_1" } } 
  ,{ "clk_sign",                 }
  ,{ "use_hexagon",              }
  ,{ "get_letter_2",             }
  ,{ "use_letter_1",                      "rm_offstage",               { "get_letter_1" } } 
  ,{ "use_letter_2",                      "rm_offstage",               { "get_letter_2" } } 
  ,{ "get_signature",                     "rm_offstage",               { "use_letter_1", "use_letter_2" } } 
  ,{ "use_signature",                     "rm_corridor",               { "get_signature" } } 
  ,{ "get_lunchroomkey",                  "rm_corridor",               { "use_signature" } } 
  ,{ "use_lunchroomkey",                  "rm_corridor",               { "get_lunchroomkey" } }
  ,{ "clk_lunchroomkey",                  "rm_corridor",               { "use_lunchroomkey" } }
  ,{ "opn_lunchroom",                     "rm_lunchroom",              { "clk_lunchroomkey" } }
  ,{ "get_collect_item_1_3" }
  ,{ "get_collect_morph_item_1_5" }
  ,{ "get_bottleshard",                   "rm_lunchroom",              { "opn_lunchroom" } } 
  ,{ "get_cane",                          "rm_lunchroom",              { "opn_lunchroom" } } 
  ,{ "use_elf_4",                         "rm_lunchroom",              { "opn_lunchroom" } } 
  ,{ "get_doorhandle",                    "rm_lunchroom",              { "use_elf_4" } } 
  ,{ "get_bag",                           "rm_lunchroom",              { "use_elf_4" } } 
  ,{ "clk_doorhandle",           }
  ,{ "use_doorhandle",           }
  ,{ "use_adhesivetape_1",         }
  ,{ "get_rerolledcane",         }
  ,{ "use_rerolledcane",                  "rm_offstage",               { "get_rerolledcane" } } 
  ,{ "use_bottleshard",          }
  ,{ "get_screwdriver",          }
  ,{ "use_screwdriver",                   "rm_offstage",               { "get_screwdriver" } } 
  ,{ "get_lens",                          "rm_offstage",               { "use_screwdriver" } } 
  ,{ "clk_lens",                 }
  ,{ "use_lens",                 }
  ,{ "get_device_1",             }
  ,{ "clk_corridor_point_1",              "rm_corridor",               { "get_device_1" } }
  ,{ "clk_corridor_point_2",              "rm_corridor",               { "get_device_1" } }
  ,{ "use_device_1",                      "rm_corridor",               { "clk_corridor_point_1", "clk_corridor_point_2" } }
  ,{ "win_corridor",                      "rm_corridor",               { "use_device_1" } } 
  ,{ "vid_corridor_loupe",                "rm_corridor",               { "win_corridor" } } 
  ,{ "get_latchhandle",                   "rm_corridor",               { "vid_corridor_loupe" } } 
  ,{ "use_latchhandle",                   "rm_lunchroom",              { "get_latchhandle" } }
  ,{ "clk_latchhandle",                   "rm_lunchroom",              { "use_latchhandle" } }
  ,{ "get_mineralbottleclose",            "rm_lunchroom",              { "clk_latchhandle" } }
  ,{ "clk_cork",                 }
  ,{ "get_mineralwaterbottle",   }
  ,{ "clk_mineralwaterbottle",   }
  ,{ "get_mineralwater",   }
  ,{ "use_mineralwater",                  "rm_lunchroom",              { "get_mineralwater" } }
  ,{ "dlg_lunchroom_barmen",              "rm_lunchroom",              { "use_mineralwater" } }
  ,{ "use_pictureelement",                "rm_lunchroom",              { "dlg_lunchroom_barmen" } }
  ,{ "opn_pictureroom",                   "rm_lunchroom",              { "use_pictureelement" } } 
  ,{ "win_pictureroom",                   "rm_lunchroom",              { "use_pictureelement" } } 
  ,{ "get_button",                        "rm_lunchroom",              { "win_pictureroom" } }
  ,{ "clk_socket",                        "rm_corridor",               { "vid_corridor_loupe" } } 
  ,{ "use_button",                        "rm_corridor",               { "clk_socket","get_button" } }

  ,{ "opn_dungeon",                       "rm_dungeon",                { "use_button" } }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "anm_dungeon_avenger",               "rm_dungeon",                { "opn_dungeon" } }
  ,{ "get_duster",                        "rm_dungeon",                { "opn_dungeon" } }
  ,{ "clk_controlunit_door",              "rm_dungeon",                { "opn_dungeon", "get_duster" } } 
  ,{ "get_lantern",                       "rm_dungeon",                { "opn_dungeon" } }
  ,{ "use_elf_5",                         "rm_dungeon",                { "opn_dungeon" } }
  ,{ "get_hook",                          "rm_dungeon",                { "use_elf_5" } }
  ,{ "use_hook",                          "rm_dungeon",                { "get_hook" } }
  ,{ "clk_box",                           "rm_dungeon",                { "use_hook" } }
  ,{ "get_safehandle",                    "rm_dungeon",                { "clk_box" } }
  ,{ "use_safehandle",                    "rm_corridor",               { "get_safehandle" } }
  ,{ "win_portrait",                      "rm_corridor",               { "use_safehandle" } }
  ,{ "get_microchip_1",                   "rm_corridor",               { "win_portrait" } }
  ,{ "get_battery_2",                     "rm_corridor",               { "win_portrait" } }
  ,{ "get_tableamulet_1",                 "rm_corridor",               { "win_portrait" } }
  ,{ "use_duster",                        "rm_offstage",               { "get_duster" } }
  ,{ "get_bulb",                          "rm_offstage",               { "use_duster" } } 
  ,{ "clk_lantern",                }
  ,{ "use_bulb",                }
  ,{ "use_battery_2",             }
  ,{ "get_litlantern",          }
  ,{ "use_litlantern",                    "rm_dungeon",                { "get_litlantern" } }
  ,{ "get_tableamulet_2",                 "rm_dungeon",                { "use_litlantern" } }
  ,{ "clk_spread",                        "rm_lunchroom",              { "opn_lunchroom" } }
  ,{ "use_tableamulet_1",                 "rm_lunchroom",              { "get_tableamulet_1" } }
  ,{ "use_tableamulet_2",                 "rm_lunchroom",              { "get_tableamulet_2" } }
  ,{ "get_electroniccard",                "rm_lunchroom",              { "use_tableamulet_1", "use_tableamulet_2" } }
  ,{ "use_electroniccard",                "rm_corridor",               { "get_electroniccard" } }
  ,{ "get_chestkey",                      "rm_corridor",               { "use_electroniccard" } }
  ,{ "use_chestkey",                      "rm_dungeon",                { "get_chestkey" } }
  ,{ "opn_chestroom",                     "rm_dungeon",                { "use_chestkey" } } 
  ,{ "win_chestroom",                     "rm_dungeon",                { "use_chestkey" } } 
  ,{ "clk_controlunit_microchip_1",       "rm_dungeon",                { "clk_controlunit_door" } } 
  ,{ "use_microchip_1",                   "rm_dungeon",                { "get_microchip_1", "clk_controlunit_microchip_1" } } 
  ,{ "use_microchip_2",                   "rm_dungeon",                { "win_chestroom", "clk_controlunit_microchip_1" } }
  ,{ "vid_dungeon_heat",                  "rm_dungeon",                { "use_microchip_1", "use_microchip_2" } }
  
  ,{ "opn_beforepuzzle",                  "rm_dungeon",                { "vid_dungeon_heat" } }
  
  ,{ "win_superpuzzle_1",                 "rm_dungeon",                { "opn_beforepuzzle" } }
  ,{ "vid_beforepuzzle_autro",            "rm_dungeon",                { "win_superpuzzle_1" } }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits",
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;
  
end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 330, posy = 200, arrows = { 
                                                                              { pos_x = 330, pos_y = 450, ang =  3.14 }
                                                                              } },   -- туториал на подбор Эльфа

      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 250, posy = 100, arrows = { 
                                                                              { pos_x = 250, pos_y = 330, ang =  3.14 },
                                                                              } },   -- туториал на открытие зз Кресло
                                                                              
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 500, posy = 500, arrows = { 
                                                                              { pos_x = 450, pos_y = 350, ang =  0 }
                                                                              } },   -- туториал на подбор пинцета

      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 230, posy = 350, arrows = { 
                                                                              { pos_x = 470, pos_y = 360, ang =  -1.58 },
                                                                              { pos_x = 0, pos_y = -150, ang =  3.14, 
                                                                                target = "inv_elf_1", scale_x = 1.5, scale_y = 1.5 },
                                                                              } },   -- туториал на применение Эльфа
                                                                              
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 320, posy = 210, arrows = { 
                                                                              { pos_x = 310, pos_y = 470, ang =  3.14 },
                                                                              { pos_x = 630, pos_y = 150, ang =  -1.58 },
                                                                              } },   -- туториал на подбор и закрытие зз
                                                                              
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 350, posy = 170, arrows = { 
                                                                              { pos_x = 350, pos_y = 410, ang =  3.14 }
                                                                              } },   -- туториал на переход в ХО

      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              --{ pos_x = 600, pos_y = 270, ang =  1.58 },
                                                                              } },   -- туториал на открытие ХО
                                                                              
      [ "tutorial_page_9" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 0, pos_y = -100, ang =  3.14, target = "obj_int_taskpanel_impl" }
                                                                              } },   -- туториал на таски ХО

      [ "tutorial_page_10" ] = { shown = 0, noskip = false, posx = 500, posy = 350, arrows = { 
                                                                              { pos_x = 0, pos_y = -150, ang =  3.14,
                                                                                target = "inv_brokentokenmt", scale_x = 1.5, scale_y = 1.5 },
                                                                              } },   -- туториал на сложный предмет
                                                                              
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 512, posy = 450, arrows = { 
                                                                              { pos_x = 260, pos_y = 0, ang =  1.58, target = "spr_int_button_morph_back" },
                                                                              } },   -- туториал на морфинги
                                                                              
      [ "tutorial_page_12" ] = { shown = 0, noskip = false, posx = 550, posy = 280, arrows = { 
                                                                              { pos_x = 250, pos_y = 0, ang =  1.58, target = "spr_int_button_collectibles_back"  },
                                                                              } },   -- туториал на коллекты
                                                                              
      [ "tutorial_page_13" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang = 1.57, target = "obj_int_button_info_impl" }
                                                                            } },     -- туториал на Инфо в МГ     
      [ "tutorial_page_14" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang = 1.57, target = "obj_int_button_reset_impl" },
                                                                              { pos_x = -50, pos_y = -50, ang = 4, target = "int_button_skip_impl" }
                                                                            } },     -- туториал на скип и ресет в МГ
                                                                              
      [ "tutorial_page_15" ] = { shown = 0, noskip = true, posx = 512, posy = 350, arrows = { 
      {                                                                         pos_x = 0, pos_y = -150, ang = 3.14, target = "obj_int_button_apparat",
                                                                              },
                                                                              } },   -- туториал на лупу

    };

  end;

end;