-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()
  
  private.init_brokentokenmt();
  private.init_device();
  private.init_sign();
  private.init_cane();
  private.init_bag();
  private.init_mineralwaterbottle(); 
  private.init_lantern(); 
  private.init_defectivedevice();
   
  public.deploy_inventory = {
    { "brokentokenmt",      { "use_tokenfragment_1", "use_tokenfragment_2" }, { "get_tokenmt" }            },
    { "device",             { "use_battery" }, { "get_dischargeddevice" }            },
    { "defectivedevice",    { "use_lens" },  { "get_device_1" }            },
    { "sign",               { "use_hexagon" }, { "get_letter_2" }            },
    { "cane",               { "use_adhesivetape_1" }, { "get_rerolledcane" }            },
    { "bag",                { "use_bottleshard" },  { "get_screwdriver" }            },
    { "mineralwaterbottle", { "clk_mineralwaterbottle" },  { "get_mineralwater" }            },
    { "lantern",            { "use_bulb", "use_battery_2" },  { "get_litlantern" }            },
    
  };
  
  public.deploy_sound = { { "defectivedevice", "get_defectivedevice" , "level1/aud_device_env" } }; 
  
  --------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level1_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level1_inv_deploy" }, "level1_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level1_inv_deploy", update_game_mode_level1_inv_deploy, nil );

  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;
end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
function private.ShowBbt( use_name )
  
  if use_name == "tokenfragment" then
    
    if ( cmn.IsEventDone( "use_tokenfragment_1" ) and not cmn.IsEventDone( "use_tokenfragment_2" ) ) or
       ( cmn.IsEventDone( "use_tokenfragment_2" ) and not cmn.IsEventDone( "use_tokenfragment_1" ) ) then
       
       common_impl.ShowBbt( "bbt_brokentokenmt_use_tokenfragment_2", 1 );
       
     else
       
       common_impl.ShowBbt( "bbt_brokentokenmt_use_tokenfragment_1", 1 );
       
     end;
      
  end;
  
end;
--*********************************************************************************************************************
-- function *** brokentokenmt *** () end;
--*********************************************************************************************************************
  function private.init_brokentokenmt()

    ObjSet( "spr_deploy_brokentokenmt", { event_mdown = function() public.get_tokenmt() end } );
    ObjSet( "obj_brokentokenmt_use_tokenfragment", { event_mdown = function() private.ShowBbt( 'tokenfragment' ) end } );

    common_impl.hint[ "use_tokenfragment_1" ] = {
        type = "use",
        inv_obj = "inv_tokenfragment_1",
        use_place = "obj_brokentokenmt_use_tokenfragment",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokentokenmt",
        zz_gate = "inv_brokentokenmt"
    };
    function use_tokenfragment_1_inv ()

      interface.InventoryItemRemove( "inv_tokenfragment_1" );
      if ( not cmn.IsEventDone("get_tokenfragment_2") ) then

        ObjSet( "spr_brokentokenmt_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_brokentokenmt_plus_light", { alp = 1 });

      end;   

    end;
    function use_tokenfragment_1_beg ()

      if ( cmn.IsEventDone("use_tokenfragment_2")) then
        ObjDelete( "obj_brokentokenmt_use_tokenfragment" );      
      end;

    end;
    function use_tokenfragment_1_end ()
      
      ObjSet( "spr_deploy_brokentokenmt_tokenfragment_1", { alp = 1 });
      ObjSet( "spr_brokentokenmt_part_1", { alp = 1 });
      
      if ( cmn.IsEventDone("use_tokenfragment_2") ) then

        ObjMultiSet({
          { "spr_deploy_brokentokenmt",     { input = true }},
          { "gfx_deploy_brokentokenmt",     { active = true }}
        });

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_tokenfragment_1", use_tokenfragment_1_beg, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_1", use_tokenfragment_1_inv );
    cmn.AddSubscriber( "use_tokenfragment_1", use_tokenfragment_1_end );
    cmn.AddSubscriber( "use_tokenfragment_1", use_tokenfragment_1_end, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_1_inv", use_tokenfragment_1_inv );
    cmn.AddSubscriber( "use_tokenfragment_1_beg", use_tokenfragment_1_beg, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_1_end", use_tokenfragment_1_end, "inv_brokentokenmt" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_tokenfragment_2" ] = {
        type = "use",
        inv_obj = "inv_tokenfragment_2",
        use_place = "obj_brokentokenmt_use_tokenfragment",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokentokenmt",
        zz_gate = "inv_brokentokenmt"
    };
    function use_tokenfragment_2_inv ()

      interface.InventoryItemRemove( "inv_tokenfragment_2" );
      if ( not cmn.IsEventDone("get_tokenfragment_1") ) then

        ObjSet( "spr_brokentokenmt_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_brokentokenmt_plus_light", { alp = 1 });

      end;   

    end;
    function use_tokenfragment_2_beg ()

      if ( cmn.IsEventDone("use_tokenfragment_1")) then
        ObjDelete( "obj_brokentokenmt_use_tokenfragment" );      
      end;
      
    end;
    function use_tokenfragment_2_end ()
      
      ObjSet("spr_deploy_brokentokenmt_tokenfragment_2", { alp = 1 });
      ObjSet("spr_brokentokenmt_part_2", { alp = 1 });
      
      if ( cmn.IsEventDone("use_tokenfragment_1") ) then

        ObjMultiSet({
          { "spr_deploy_brokentokenmt",     { input = true }},
          { "gfx_deploy_brokentokenmt",     { active = true }}
        });

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_tokenfragment_2", use_tokenfragment_2_beg, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_2", use_tokenfragment_2_inv );
    cmn.AddSubscriber( "use_tokenfragment_2", use_tokenfragment_2_end );
    cmn.AddSubscriber( "use_tokenfragment_2", use_tokenfragment_2_end, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_2_inv", use_tokenfragment_2_inv );
    cmn.AddSubscriber( "use_tokenfragment_2_beg", use_tokenfragment_2_beg, "inv_brokentokenmt" );
    cmn.AddSubscriber( "use_tokenfragment_2_end", use_tokenfragment_2_end, "inv_brokentokenmt" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_tokenmt" ] = {
      type = "get",
      get_obj = "spr_deploy_brokentokenmt",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokentokenmt",
      zz_gate = "inv_brokentokenmt"
    };
    function get_tokenmt_inv ()

      interface.InventoryItemRemove( "inv_brokentokenmt" );
      interface.InventoryItemAdd( "inv_tokenmt", "spr_deploy_brokentokenmt" );

    end;
    function get_tokenmt_deploy ()

      ObjDelete( "gfx_deploy_brokentokenmt" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_tokenmt", get_tokenmt_inv );
    cmn.AddSubscriber( "get_tokenmt", get_tokenmt_deploy, "inv_brokentokenmt" );
    -------------------------------------------------------------------------------------------
  end;
--*********************************************************************************************************************
  function public.use_tokenfragment_1()

    local item = "inv_tokenfragment_1";
    if private.ObjIntersectCheck( item, "obj_brokentokenmt_use_tokenfragment", "deploy_inv_brokentokenmt" ) then

      cmn.CallEventHandler( "use_tokenfragment_1_beg", "inv_brokentokenmt" );
      cmn.CallEventHandler( "use_tokenfragment_1_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_tokenfragment_1" );
        cmn.CallEventHandler( "use_tokenfragment_1_end", "inv_brokentokenmt" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tokenfragment_mt", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_brokentokenmt_tokenfragment_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      return true;

    end;

  end;
--*********************************************************************************************************************
  function public.use_tokenfragment_2()

    local item = "inv_tokenfragment_2";
    if private.ObjIntersectCheck( item, "obj_brokentokenmt_use_tokenfragment", "deploy_inv_brokentokenmt" ) then

      cmn.CallEventHandler( "use_tokenfragment_2_beg", "inv_brokentokenmt" );
      cmn.CallEventHandler( "use_tokenfragment_2_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_tokenfragment_2" );
        cmn.CallEventHandler( "use_tokenfragment_2_end", "inv_brokentokenmt" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tokenfragment_mt", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_brokentokenmt_tokenfragment_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      return true;

    end;

  end;
  function public.get_tokenmt()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tokenmt" );
    cmn.CallEventHandler( "get_tokenmt", "inv_brokentokenmt" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** device *** () end;
--*********************************************************************************************************************
  function private.init_device()

    ObjSet( "spr_deploy_device", { event_mdown = function() public.get_dischargeddevice() end } );
    ObjSet( "obj_device_clk_open", { event_mdown = function() private.clk_open() end } );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_open" ] = {
        type = "click",
        use_place = "obj_device_clk_open",
        room = "int_deploy_inv",
        zz = "deploy_inv_device",
        zz_gate = "inv_device"
    };
    function clk_open_beg ()

      ObjDelete( "obj_device_clk_open" );

    end;
    function clk_open_end ()

      ObjMultiSet({
        { "obj_device_use_battery",     { input = true }},
        { "spr_deploy_device_cover",     { alp = 0 }},
        { "spr_deploy_device_cover_open",     { alp = 1 }}   
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_open", clk_open_beg, "inv_device" );
    cmn.AddSubscriber( "clk_open", clk_open_end, "inv_device" );
    cmn.AddSubscriber( "clk_open_beg", clk_open_beg, "inv_device" );
    cmn.AddSubscriber( "clk_open_end", clk_open_end, "inv_device" );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_battery" ] = {
        type = "use",
        inv_obj = "inv_battery",
        use_place = "obj_device_use_battery",
        room = "int_deploy_inv",
        zz = "deploy_inv_device",
        zz_gate = "inv_device"
    };
    function use_battery_inv ()

      interface.InventoryItemRemove( "inv_battery" );

    end;
    function use_battery_beg ()

      ObjDelete( "obj_device_use_battery" );

    end;
    function use_battery_end ()

      ObjDelete( "spr_deploy_device_cover_open" );
      ObjDelete( "spr_deploy_device_battery" );
      ObjDelete( "spr_deploy_device_screen_close" );
      ObjDelete( "spr_deploy_device_light_2" ); 
      
      ObjMultiSet({
        { "spr_deploy_device",     { input = true }},
        { "gfx_deploy_device",     { active = true }},
        { "spr_deploy_device_cover",     { alp = 1 }},
        { "spr_deploy_device_screen",     { alp = 1 }},
        { "spr_deploy_device_arrow",     { active = true }},
        { "spr_deploy_device_light_1",     { alp = 1 }},
        { "inv_device", { res = "assets/levels/level1/inv_deploy/inv_device/inv/inv_tokenmt" }},
        { "spr_device_text", { alp = 1 }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_battery", use_battery_beg, "inv_device" );
    cmn.AddSubscriber( "use_battery", use_battery_inv );
    cmn.AddSubscriber( "use_battery", use_battery_end );
    cmn.AddSubscriber( "use_battery", use_battery_end, "inv_device" );
    cmn.AddSubscriber( "use_battery_inv", use_battery_inv );
    cmn.AddSubscriber( "use_battery_beg", use_battery_beg, "inv_device" );
    cmn.AddSubscriber( "use_battery_end", use_battery_end, "inv_device" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_dischargeddevice" ] = {
      type = "get",
      get_obj = "spr_deploy_device",
      room = "int_deploy_inv",
      zz = "deploy_inv_device",
      zz_gate = "inv_device"
    };
    function get_dischargeddevice_inv ()

      interface.InventoryItemRemove( "inv_device" );
      interface.InventoryItemAdd( "inv_dischargeddevice", "spr_deploy_device" );

    end;
    function get_dischargeddevice_deploy ()

      ObjDelete( "gfx_deploy_device" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_dischargeddevice", get_dischargeddevice_inv );
    cmn.AddSubscriber( "get_dischargeddevice", get_dischargeddevice_deploy, "inv_device" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_open()

    cmn.CallEventHandler( "clk_open_beg", "inv_device" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_open" );
      cmn.CallEventHandler( "clk_open_end", "inv_device" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_device_touch_cover", 0, "", 0 );
      
    ObjAnimate( "spr_deploy_device_cover", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    ObjAnimate( "spr_deploy_device_cover_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  end;
  --*********************************************************************************************************************
  function public.use_battery()

    local item = "inv_battery";
    if private.ObjIntersectCheck( item, "obj_device_use_battery", "deploy_inv_device" ) and cmn.IsEventDone("clk_open") then

      cmn.CallEventHandler( "use_battery_beg", "inv_device" );
      cmn.CallEventHandler( "use_battery_inv" );

      local func_after = function ()
      
        local func_anim = function ()
      
          local func_end = function ()
      
            common_impl.Lock( false );
            
            --common_impl.PlayAudio( "env", "common/audio/level1/aud_device_env", 1, "", 0 );

            cmn.SetEventDone( "use_battery" );
            cmn.CallEventHandler( "use_battery_end", "inv_device" );
            
          end;
            
          ObjAnimate( "spr_deploy_device_screen_close", "alp", 0, 0, "",
          { 
            0.0, 0, 1, 
            0.3, 0, 0
          } );
          
          ObjAnimate( "spr_deploy_device_screen", "alp", 0, 0, func_end,
          { 
            0.0, 0, 0, 
            0.3, 0, 1
          } );
          
          ObjAnimate( "spr_deploy_device_light_1", "alp", 0, 0, "",
          { 
            0.0, 0, 0, 
            0.3, 0, 1
          } ); 
          
          ObjAnimate( "spr_deploy_device_light_2", "alp", 0, 0, "",
          { 
            0.0, 0, 1, 
            0.3, 0, 0
          } ); 
          ObjSet( "spr_deploy_device_arrow", { active = true });
          ObjAnimate( "spr_deploy_device_arrow", "ang", 1, 0, "",
          { 
            0.0, 3, 0.2, 
            0.3, 3, -0.2,
            0.6, 3, 0.2
            } );
          
        end;
      
        ObjAnimate( "spr_deploy_device_cover_open", "alp", 0, 0, "",
        { 
          0.0, 0, 1, 
          0.3, 0, 0
        } );
        
        ObjAnimate( "spr_deploy_device_cover", "alp", 0, 0, func_anim,
        { 
          0.0, 0, 0, 
          0.3, 0, 1
        } );
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_device_use_battery", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_device_battery", "pos_xy", 0, 0, func_after,
      { 
      0.0, 0, 365, 476, 
        0.5, 0,  42, 151
      } );

      return true;

    end;

  end;
  function public.get_dischargeddevice()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_dischargeddevice" );
    cmn.CallEventHandler( "get_dischargeddevice", "inv_device" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** defectivedevice *** () end;
--*********************************************************************************************************************
  function private.init_defectivedevice()

    ObjSet( "spr_deploy_device_1", { event_mdown = function() public.get_device_1() end } );
    ObjSet( "obj_defectivedevice_clk_lens", { event_mdown = function() private.clk_lens() end } );

    common_impl.hint[ "clk_lens" ] = {
        type = "click",
        use_place = "obj_defectivedevice_clk_lens",
        room = "int_deploy_inv",
        zz = "deploy_inv_defectivedevice",
        zz_gate = "inv_defectivedevice"
    };
    function clk_lens_beg ()

      ObjDelete( "obj_defectivedevice_clk_lens" );

    end;
    function clk_lens_end ()
      
      ObjDelete( "spr_deploy_defectivedevice_add_glass" );
      ObjMultiSet({
        { "obj_defectivedevice_use_lens",     { input = true }}
      });

    end;
    function clk_lens_inv ()

      ObjSet( "inv_defectivedevice", { res = "assets/levels/level1/inv_deploy/inv_defectivedevice/inv/inv_device" } );
  
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_lens", clk_lens_beg, "inv_defectivedevice" );
    cmn.AddSubscriber( "clk_lens", clk_lens_end, "inv_defectivedevice" );
    cmn.AddSubscriber( "clk_lens_beg", clk_lens_beg, "inv_defectivedevice" );
    cmn.AddSubscriber( "clk_lens_end", clk_lens_end, "inv_defectivedevice" );
    cmn.AddSubscriber( "clk_lens", clk_lens_inv );
    cmn.AddSubscriber( "clk_lens_inv", clk_lens_inv );
    --------------------------------------------------------------------------------------------   
    common_impl.hint[ "use_lens" ] = {
        type = "use",
        inv_obj = "inv_lens",
        use_place = "obj_defectivedevice_use_lens",
        room = "int_deploy_inv",
        zz = "deploy_inv_defectivedevice",
        zz_gate = "inv_defectivedevice"
    };
    function use_lens_inv ()

      interface.InventoryItemRemove( "inv_lens" );

    end;
    function use_lens_beg ()

      ObjDelete( "obj_defectivedevice_use_lens" );

    end;
    function use_lens_end ()

      ObjMultiSet({ 
        { "spr_deploy_defectivedevice_add_glass_1",     { alp = 1 }},
        { "spr_deploy_device_1",     { input = true, active = true }},
        { "gfx_deploy_device_1",     { active = true }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_lens", use_lens_beg, "inv_defectivedevice" );
    cmn.AddSubscriber( "use_lens", use_lens_inv );
    cmn.AddSubscriber( "use_lens", use_lens_end, "inv_defectivedevice" );
    cmn.AddSubscriber( "use_lens_inv", use_lens_inv );
    cmn.AddSubscriber( "use_lens_beg", use_lens_beg, "inv_defectivedevice" );
    cmn.AddSubscriber( "use_lens_end", use_lens_end, "inv_defectivedevice" );
    --------------------------------------------------------------------------------------------
    --common_impl.hint[ "get_device_1" ] = {
    --  type = "get",
    --  get_obj = "spr_deploy_device_1",
    --  room = "int_deploy_inv",
    --  zz = "deploy_inv_device",
    --  zz_gate = "inv_device"
    --};
    common_impl.hint[ "get_device_1" ] = {
      type = "get",
      get_obj = "spr_deploy_device_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_defectivedevice",
      zz_gate = "inv_defectivedevice"
    };
    function get_device_1_inv ()

      interface.InventoryItemRemove( "inv_defectivedevice" );  
      ObjSet( "spr_int_button_apparat_apparat", { alp = 1 } );
      ObjSet( "obj_int_button_apparat", { input = true } );
      --interface.InventoryItemAdd( "inv_workingdevice", "spr_deploy_device_1" );

    end;
    function get_device_1_deploy ()

      ObjDelete( "gfx_deploy_device_1" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_device_1", get_device_1_inv );
    cmn.AddSubscriber( "get_device_1", get_device_1_deploy, "inv_defectivedevice" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_lens()

    cmn.CallEventHandler( "clk_lens_beg", "inv_defectivedevice" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_lens" );
      cmn.CallEventHandler( "clk_lens_end", "inv_defectivedevice" );
      cmn.CallEventHandler( "clk_lens_inv" );
      
    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_device_touch_broken_lens", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_defectivedevice_add_glass", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 16, -35, 
      0.5, 0, 116, 510
    } );

  end;
  --*********************************************************************************************************************
  function public.use_lens()

    local item = "inv_lens";
    if private.ObjIntersectCheck( item, "obj_defectivedevice_use_lens", "deploy_inv_defectivedevice" ) and cmn.IsEventDone("clk_lens") then

      cmn.CallEventHandler( "use_lens_beg", "inv_defectivedevice" );
      cmn.CallEventHandler( "use_lens_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_lens" );
        cmn.CallEventHandler( "use_lens_end", "inv_defectivedevice" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_device_lens", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_defectivedevice_add_glass_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      return true;

    end;

  end;
  function public.get_device_1()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    local get_after = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "get_device_1" );
      cmn.CallEventHandler( "get_device_1", "inv_defectivedevice"  );
      common_impl.HideDeployInv();

    end;

    common_impl.Lock( true );
    cmn.CallEventHandler( "get_device_1_deploy" );
    ObjSet( "spr_deploy_device_1", { input = false } );
    local item_name = "spr_deploy_device_1";
    local start_pos = GetObjPosByObj( item_name );
    ObjAttach( item_name, "ng_interface_transporter" );
    local end_pos = GetObjPosByObj( "spr_int_button_apparat_apparat" );
    ObjAnimate( item_name, "pos_xy", 0, 0, "",
    { 
      0.0, 1, start_pos[1],start_pos[2], 
      0.8, 1, end_pos[1],end_pos[2]
    } );
    ObjAnimate( item_name, "scale_xy", 0, 0, get_after,
    { 
      0.0, 1, 1,1,
      0.6, 1, 0.5,0.5,
      0.8, 1, 0,0
    } );

  end;
--*********************************************************************************************************************
-- function *** sign *** () end;
--*********************************************************************************************************************
  function private.init_sign()

    ObjSet( "spr_deploy_letter_2", { event_mdown = function() public.get_letter_2() end } );
    ObjSet( "obj_sign_clk_sign", { event_mdown = function() private.clk_sign() end } );
    
    common_impl.hint[ "clk_sign" ] = {
        type = "click",
        use_place = "obj_sign_clk_sign",
        room = "int_deploy_inv",
        zz = "deploy_inv_sign",
        zz_gate = "inv_sign"
    };
    function clk_sign_beg ()

      ObjDelete( "obj_sign_clk_sign" );

    end;
    function clk_sign_end ()

      ObjDelete( "spr_deploy_sign_closed" );
      ObjMultiSet({
        { "obj_sign_use_hexagon",     { input = true }},
        { "spr_deploy_sign_back",     { alp = 1 }},
      });

    end;
    
    function clk_sign_inv ()

      ObjSet( "inv_sign", { res = "assets/levels/level1/inv_deploy/inv_sign/inv/inv_sign" } );
  
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_sign", clk_sign_beg, "inv_sign" );
    cmn.AddSubscriber( "clk_sign", clk_sign_end, "inv_sign" );
    cmn.AddSubscriber( "clk_sign_beg", clk_sign_beg, "inv_sign" );
    cmn.AddSubscriber( "clk_sign_end", clk_sign_end, "inv_sign" );
    cmn.AddSubscriber( "clk_sign", clk_sign_inv );
    cmn.AddSubscriber( "clk_sign_inv", clk_sign_inv );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_hexagon" ] = {
        type = "use",
        inv_obj = "inv_hexagon",
        use_place = "obj_sign_use_hexagon",
        room = "int_deploy_inv",
        zz = "deploy_inv_sign",
        zz_gate = "inv_sign"
    };
    function use_hexagon_inv ()

      interface.InventoryItemRemove( "inv_hexagon" );

    end;
    function use_hexagon_beg ()

      ObjDelete( "obj_sign_use_hexagon" );

    end;
    function use_hexagon_end ()

      ObjDelete( "vid_deploy_sign_hex" );
      ObjMultiSet({
      { "spr_deploy_letter_2",     { alp = 1, input = true, pos_y = 220 }},
        { "gfx_deploy_letter_2",     { active = true }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_hexagon", use_hexagon_beg, "inv_sign" );
    cmn.AddSubscriber( "use_hexagon", use_hexagon_inv );
    cmn.AddSubscriber( "use_hexagon", use_hexagon_end );
    cmn.AddSubscriber( "use_hexagon", use_hexagon_end, "inv_sign" );
    cmn.AddSubscriber( "use_hexagon_inv", use_hexagon_inv );
    cmn.AddSubscriber( "use_hexagon_beg", use_hexagon_beg, "inv_sign" );
    cmn.AddSubscriber( "use_hexagon_end", use_hexagon_end, "inv_sign" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_letter_2" ] = {
      type = "get",
      get_obj = "spr_deploy_letter_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_sign",
      zz_gate = "inv_sign"
    };
    function get_letter_2_inv ()

      interface.InventoryItemRemove( "inv_sign" );
      interface.InventoryItemAdd( "inv_letter_2", "spr_deploy_letter_2" );

    end;
    function get_letter_2_deploy ()

      ObjDelete( "gfx_deploy_sign" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_letter_2", get_letter_2_inv );
    cmn.AddSubscriber( "get_letter_2", get_letter_2_deploy, "inv_sign" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_sign()

    cmn.CallEventHandler( "clk_sign_beg", "inv_sign" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_sign" );
      cmn.CallEventHandler( "clk_sign_end", "inv_sign" );
      cmn.CallEventHandler( "clk_sign_inv" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_sign", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_sign_back", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    
    ObjAnimate( "spr_deploy_sign_closed", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );

  end;
  --*********************************************************************************************************************
  function public.use_hexagon()

    local item = "inv_hexagon";
    if private.ObjIntersectCheck( item, "obj_sign_use_hexagon", "deploy_inv_sign" ) and cmn.IsEventDone("clk_sign") then

      cmn.CallEventHandler( "use_hexagon_beg", "inv_sign" );
      cmn.CallEventHandler( "use_hexagon_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
          common_impl.Lock( false );
          
          cmn.SetEventDone( "use_hexagon" );
          cmn.CallEventHandler( "use_hexagon_end", "inv_sign" );
          
          public.get_letter_2();
          
        end;
        
        ObjSet("spr_deploy_letter_2", { alp = 1 });
        ObjAnimate( "spr_deploy_letter_2", "pos_y", 0, 0, func_end,
        { 
          0.0, 0, 90, 
          0.5, 0, 220
        } );
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_hexagon_sign", 0, "", 0 );
      
      VidPlay( "vid_deploy_sign_hex", func_after );   

      return true;

    end;

  end;
  function public.get_letter_2()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_letter_2" );
    cmn.CallEventHandler( "get_letter_2", "inv_sign" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** cane *** () end;
--*********************************************************************************************************************
  function private.init_cane()

    ObjSet( "spr_deploy_rerolledcane", { event_mdown = function() public.get_rerolledcane() end } );
    ObjSet( "obj_cane_clk_doorhandle", { event_mdown = function() private.clk_doorhandle() end } );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "clk_doorhandle" ] = {
        type = "click",
        use_place = "obj_cane_clk_doorhandle",
        room = "int_deploy_inv",
        zz = "deploy_inv_cane",
        zz_gate = "inv_cane"
    };
    function clk_doorhandle_inv ()
      
      ObjSet( "inv_cane", { res ="assets/levels/level1/inv_deploy/inv_cane/inv/inv_cane_1" });
      
    end;  
    
    function clk_doorhandle_beg ()

      ObjDelete( "obj_cane_clk_doorhandle" );

    end;
    
    function clk_doorhandle_end ()

      ObjDelete( "spr_deploy_knob_old" );
      ObjMultiSet({
      { "obj_cane_use_doorhandle",     { input = true }},
      -- { "inv_cane",    { res ="assets\levels\level1\inv_deploy\inv_cane\inv\inv_cane_1"  }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_doorhandle", clk_doorhandle_beg, "inv_cane" );
    cmn.AddSubscriber( "clk_doorhandle", clk_doorhandle_end, "inv_cane" );
    cmn.AddSubscriber( "clk_doorhandle_beg", clk_doorhandle_beg, "inv_cane" );
    cmn.AddSubscriber( "clk_doorhandle_end", clk_doorhandle_end, "inv_cane" );
    cmn.AddSubscriber( "clk_doorhandle", clk_doorhandle_end );
    cmn.AddSubscriber( "clk_doorhandle", clk_doorhandle_inv );
    cmn.AddSubscriber( "clk_doorhandle_inv", clk_doorhandle_inv );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_doorhandle" ] = {
        type = "use",
        inv_obj = "inv_doorhandle",
        use_place = "obj_cane_use_doorhandle",
        room = "int_deploy_inv",
        zz = "deploy_inv_cane",
        zz_gate = "inv_cane"
    };
    function use_doorhandle_inv ()

      interface.InventoryItemRemove( "inv_doorhandle" );
       if ( not cmn.IsEventDone("get_adhesivetape") ) then

         ObjSet( "spr_cane_plus_light", { alp = 0 });

      else 

         ObjSet( "spr_cane_plus_light", { alp = 1 });

      end; 
    end;
    function use_doorhandle_beg ()

      ObjDelete( "obj_cane_use_doorhandle" );

    end;
    function use_doorhandle_end ()

      ObjMultiSet({
      { "spr_deploy_knob_new",     { alp = 1 }},
      { "obj_cane_use_adhesivetape",     { input = true }},
      --{ "anm_deploy_cane_use_adhesivetape", { alp = 1 }}
      { "spr_cane_over", { alp = 1 }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_doorhandle", use_doorhandle_beg, "inv_cane" );
    cmn.AddSubscriber( "use_doorhandle", use_doorhandle_inv );
    cmn.AddSubscriber( "use_doorhandle", use_doorhandle_end );
    cmn.AddSubscriber( "use_doorhandle", use_doorhandle_end, "inv_cane" );
    cmn.AddSubscriber( "use_doorhandle_inv", use_doorhandle_inv );
    cmn.AddSubscriber( "use_doorhandle_beg", use_doorhandle_beg, "inv_cane" );
    cmn.AddSubscriber( "use_doorhandle_end", use_doorhandle_end, "inv_cane" );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_adhesivetape_1" ] = {
        type = "use",
        inv_obj = "inv_adhesivetape",
        use_place = "obj_cane_use_adhesivetape",
        room = "int_deploy_inv",
        zz = "deploy_inv_cane",
        zz_gate = "inv_cane"
    };
    function use_adhesivetape_1_inv ()

      interface.InventoryItemRemove( "inv_adhesivetape" );
       if ( not cmn.IsEventDone("get_doorhandle") ) then

         ObjSet( "spr_cane_plus_light", { alp = 0 });

      else 

         ObjSet( "spr_cane_plus_light", { alp = 1 });

      end;  

    end;
    function use_adhesivetape_1_beg ()

      ObjDelete( "obj_cane_use_adhesivetape" );

    end;
    function use_adhesivetape_1_end ()

      ObjMultiSet({
        { "spr_deploy_knob_scotch",     { alp = 1  }},
        { "spr_deploy_knob_new",        { alp = 0, pos_x = 262, pos_y = -256  }},
        { "spr_deploy_rerolledcane",    { input = true }},
        { "gfx_deploy_rerolledcane",    { active = true }},
        { "inv_cane", { res = "assets/levels/level1/inv_deploy/inv_cane/inv/inv_cane"}},
        { "anm_deploy_cane_use_adhesivetape",    { frame = 210, alp = 1 }} 
      });
     ObjDelete("spr_cane_over");

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_adhesivetape_1", use_adhesivetape_1_beg, "inv_cane" );
    cmn.AddSubscriber( "use_adhesivetape_1", use_adhesivetape_1_inv );
    cmn.AddSubscriber( "use_adhesivetape_1", use_adhesivetape_1_end );
    cmn.AddSubscriber( "use_adhesivetape_1", use_adhesivetape_1_end, "inv_cane" );
    cmn.AddSubscriber( "use_adhesivetape_1_inv", use_adhesivetape_1_inv );
    cmn.AddSubscriber( "use_adhesivetape_1_beg", use_adhesivetape_1_beg, "inv_cane" );
    cmn.AddSubscriber( "use_adhesivetape_1_end", use_adhesivetape_1_end, "inv_cane" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_rerolledcane" ] = {
      type = "get",
      get_obj = "spr_deploy_rerolledcane",
      room = "int_deploy_inv",
      zz = "deploy_inv_cane",
      zz_gate = "inv_cane"
    };
    function get_rerolledcane_inv ()

      interface.InventoryItemRemove( "inv_cane" );
      interface.InventoryItemAdd( "inv_rerolledcane", "spr_deploy_rerolledcane" );

    end;
    function get_rerolledcane_deploy ()

      ObjDelete( "gfx_deploy_rerolledcane" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_rerolledcane", get_rerolledcane_inv );
    cmn.AddSubscriber( "get_rerolledcane", get_rerolledcane_deploy, "inv_cane" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_doorhandle()
    
    cmn.CallEventHandler( "clk_doorhandle_beg", "inv_cane" );
    cmn.CallEventHandler( "clk_doorhandle_inv" );
    
    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_doorhandle" );
      cmn.CallEventHandler( "clk_doorhandle_end", "inv_cane" );

    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_cane_handle", 0, "", 0 );
   
    ObjAnimate( "spr_deploy_knob_old", "ang", 1, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 6
    } );
        
    ObjAnimate( "spr_deploy_knob_old", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, -205, 
      0.5, 0, 470
    } );
    
  end;
  --*********************************************************************************************************************
  function public.use_doorhandle()

    local item = "inv_doorhandle";
    if private.ObjIntersectCheck( item, "obj_cane_use_doorhandle", "deploy_inv_cane" ) and cmn.IsEventDone("clk_doorhandle") then

      cmn.CallEventHandler( "use_doorhandle_beg", "inv_cane" );
      cmn.CallEventHandler( "use_doorhandle_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_doorhandle" );
        cmn.CallEventHandler( "use_doorhandle_end", "inv_cane" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_doorhandle_knob", 0, "", 0 );
              
      ObjAnimate( "spr_deploy_knob_new", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );
      --ObjAnimate( "anm_deploy_cane_use_adhesivetape", "alp", 0, 0, func_after,
      --{ 
      --  0.0, 0, 0,
      --  0.3, 0, 1
      --} );
      return true;

    end;

  end;
    --*********************************************************************************************************************
  function public.use_adhesivetape_1()

    local item = "inv_adhesivetape";
    if private.ObjIntersectCheck( item, "obj_cane_use_adhesivetape", "deploy_inv_cane" ) and cmn.IsEventDone("use_doorhandle") then

      cmn.CallEventHandler( "use_adhesivetape_1_beg", "inv_cane" );
      cmn.CallEventHandler( "use_adhesivetape_1_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
          common_impl.Lock( false );

          cmn.SetEventDone( "use_adhesivetape_1" );
          cmn.CallEventHandler( "use_adhesivetape_1_end", "inv_cane" );
          
        end;
      
      ObjSet( "spr_deploy_knob_new", { alp = 0 });
      ObjSet( "anm_deploy_cane_use_adhesivetape", { alp = 1 });
      AnimPlay("anm_deploy_cane_use_adhesivetape", "DoAnim", func_end );
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_adhesivetape_knob", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_knob_new", "pos_xy", 0, 0, func_after,
      { 
        0.0, 0, 274, -258,
        0.5, 0, 262, -256 
      } );

      return true;

    end;

  end;
  function public.get_rerolledcane()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_rerolledcane" );
    cmn.CallEventHandler( "get_rerolledcane", "inv_cane" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** bag *** () end;
--*********************************************************************************************************************
  function private.init_bag()

    ObjSet( "spr_deploy_screwdriver", { event_mdown = function() public.get_screwdriver() end } );
    ObjSet("obj_bag_use_bottleshard", { event_mdown = private.clk_bag });
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_bottleshard" ] = {
        type = "use",
        inv_obj = "inv_bottleshard",
        use_place = "obj_bag_use_bottleshard",
        room = "int_deploy_inv",
        zz = "deploy_inv_bag",
        zz_gate = "inv_bag"
    };
    function use_bottleshard_inv ()

      interface.InventoryItemRemove( "inv_bottleshard" );

    end;
    function use_bottleshard_beg ()

      ObjDelete( "obj_bag_use_bottleshard" );

    end;
    function use_bottleshard_end ()

     ObjDelete( "spr_deploy_bag_line" ); 
     ObjDelete( "spr_deploy_bag_glass" ); 
     ObjDelete( "anm_deploy_bag_open" );
     ObjDelete( "anm_deploy_bag_clk" );
     ObjMultiSet({
       { "obj_deploy_bag_open",     { input = true, alp = 1 }},
       { "spr_deploy_screwdriver",     { input = true, active = true }},
       { "spr_bag_over", { alp = 1 }}
     });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bottleshard", use_bottleshard_beg, "inv_bag" );
    cmn.AddSubscriber( "use_bottleshard", use_bottleshard_inv );
    cmn.AddSubscriber( "use_bottleshard", use_bottleshard_end );
    cmn.AddSubscriber( "use_bottleshard", use_bottleshard_end, "inv_bag" );
    cmn.AddSubscriber( "use_bottleshard_inv", use_bottleshard_inv );
    cmn.AddSubscriber( "use_bottleshard_beg", use_bottleshard_beg, "inv_bag" );
    cmn.AddSubscriber( "use_bottleshard_end", use_bottleshard_end, "inv_bag" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_screwdriver" ] = {
      type = "get",
      get_obj = "spr_deploy_screwdriver",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
    };
    function get_screwdriver_inv ()

      interface.InventoryItemRemove( "inv_bag" );
      interface.InventoryItemAdd( "inv_screwdriver", "spr_deploy_screwdriver" );

    end;
    function get_screwdriver_deploy ()

      ObjDelete( "gfx_deploy_screwdriver" );
      ObjDelete( "spr_deploy_screwdriver_shadow" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
    cmn.AddSubscriber( "get_screwdriver", get_screwdriver_deploy, "inv_bag" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function public.use_bottleshard()

    local item = "inv_bottleshard";
    if private.ObjIntersectCheck( item, "obj_bag_use_bottleshard", "deploy_inv_bag" ) then

      cmn.CallEventHandler( "use_bottleshard_beg", "inv_bag" );
      cmn.CallEventHandler( "use_bottleshard_inv" );

      local func_after = function ()
      
      --local func_end = function ()
        
          common_impl.Lock( false );

          cmn.SetEventDone( "use_bottleshard" );
          cmn.CallEventHandler( "use_bottleshard_end", "inv_bag" );
          
          --end;
        
        --ObjAnimate( "spr_deploy_bag_line", "alp", 0, 0, "",
        --{ 
        --  0.0, 0, 1, 
        --  0.3, 0, 0
        --} );
        --
        --ObjAnimate( "obj_deploy_bag_open", "alp", 0, 0, func_end,
        --{ 
        --  0.0, 0, 0, 
        --  0.3, 0, 1
        --} );
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_bottleshard", 0, "", 0 );
  
      --ObjAnimate( "spr_deploy_bag_glass", "alp", 0, 0, "",
      --{ 
      --  0.0, 0, 1, 
      --  1.0, 0, 1,
      --  1.3, 0, 0
      --} );
      --  
      --ObjAnimate( "spr_deploy_bag_glass", "pos_xy", 0, 0, func_after,
      --{ 
      --  0.0, 0, -24, -438,
      --  0.5, 0, 120, -67,
      --  1.0, 0, -158, -6
      --} );
      
      ObjSet( "anm_deploy_bag_open", { alp = 1 } );
      ObjSet( "anm_deploy_bag_clk", { alp = 0 });
      
      AnimPlay( "anm_deploy_bag_open", "DoAnim", func_after );
      
      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.get_screwdriver()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_screwdriver" );
    cmn.CallEventHandler( "get_screwdriver", "inv_bag" );
    common_impl.HideDeployInv();

  end;
  --*******************************************************************************************************************
  function private.clk_bag()
    
    local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bag_use_bottleshard' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_bag", 0, "", 0 );
  
  AnimPlay( "anm_deploy_bag_clk", "DoAnim", func_after );
    
    
  end;  
--*********************************************************************************************************************
-- function *** mineralwaterbottle *** () end;
--*********************************************************************************************************************
  function private.init_mineralwaterbottle()

    ObjSet( "spr_deploy_mineralwater", { event_mdown = function() public.get_mineralwater() end } );
    ObjSet( "obj_mineralwaterbottle_clk_cap", { event_mdown = function() private.clk_mineralwaterbottle() end } );
    
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "clk_mineralwaterbottle" ] = {
        type = "click",
        use_place = "obj_mineralwaterbottle_clk_cap",
        room = "int_deploy_inv",
        zz = "deploy_inv_mineralwaterbottle",
        zz_gate = "inv_mineralwaterbottle"
    };
    function clk_mineralwaterbottle_beg ()

      ObjDelete( "obj_mineralwaterbottle_clk_cap" );

    end;
    function clk_mineralwaterbottle_end ()

      ObjDelete( "vid_deploy_mineralwater_cover" );
      ObjMultiSet({
        { "spr_deploy_mineralwater",     { input = true, active = true, alp = 1 }},
        { "gfx_deploy_mineralwater",     { active = true }},
        { "inv_mineralwaterbottle", { res = "assets/levels/level1/inv_deploy/inv_mineralwaterbottle/inv/inv_mineralwaterbottle_1"}}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_mineralwaterbottle", clk_mineralwaterbottle_beg, "inv_mineralwaterbottle" );
    cmn.AddSubscriber( "clk_mineralwaterbottle", clk_mineralwaterbottle_end );
    cmn.AddSubscriber( "clk_mineralwaterbottle", clk_mineralwaterbottle_end, "inv_mineralwaterbottle" );
    cmn.AddSubscriber( "clk_mineralwaterbottle_beg", clk_mineralwaterbottle_beg, "inv_mineralwaterbottle" );
    cmn.AddSubscriber( "clk_mineralwaterbottle_end", clk_mineralwaterbottle_end, "inv_mineralwaterbottle" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_mineralwater" ] = {
      type = "get",
      get_obj = "spr_deploy_mineralwater",
      room = "int_deploy_inv",
      zz = "deploy_inv_mineralwaterbottle",
      zz_gate = "inv_mineralwaterbottle"
    };
    function get_mineralwater_inv ()

      interface.InventoryItemRemove( "inv_mineralwaterbottle" );
      interface.InventoryItemAdd( "inv_mineralwater", "spr_deploy_mineralwater" );

    end;
    function get_mineralwater_deploy ()

      ObjDelete( "gfx_deploy_mineralwater" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_mineralwater", get_mineralwater_inv );
    cmn.AddSubscriber( "get_mineralwater", get_mineralwater_deploy, "inv_mineralwaterbottle" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_mineralwaterbottle()

    cmn.CallEventHandler( "clk_mineralwaterbottle_beg", "inv_mineralwaterbottle" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_mineralwaterbottle" );
      cmn.CallEventHandler( "clk_mineralwaterbottle_end", "inv_mineralwaterbottle" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_mineralwaterbottle", 0, "", 0 );
    
    VidPlay( "vid_deploy_mineralwater_cover", func_after);

  end;
  --*********************************************************************************************************************
  function public.get_mineralwater()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_mineralwater" );
    cmn.CallEventHandler( "get_mineralwater", "inv_mineralwaterbottle" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** lantern *** () end;
--*********************************************************************************************************************
  function private.init_lantern()

    ObjSet( "spr_deploy_litlantern", { event_mdown = function() public.get_litlantern() end } );
    ObjSet( "obj_lantern_clk_lantern", { event_mdown = function() private.clk_lantern() end } );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "clk_lantern" ] = {
        type = "click",
        use_place = "obj_lantern_clk_lantern",
        room = "int_deploy_inv",
        zz = "deploy_inv_lantern",
        zz_gate = "inv_lantern"
    };
    function clk_lantern_beg ()

      ObjDelete( "obj_lantern_clk_lantern" );
      if ( not cmn.IsEventDone( "get_battery_2" ) and not cmn.IsEventDone( "get_bulb" ) ) then
        ObjSet("spr_lantern_plus_light",{ alp = 0 });
      end;
      
    end;
    function clk_lantern_end ()

      ObjMultiSet({
        { "spr_deploy_lantern_glass_1",     { alp = 1 }},
        { "spr_deploy_lantern_glass",     { alp = 0 }},
        { "obj_lantern_use_bulb",     { input = true }},
        { "inv_lantern", { res ="assets/levels/level1/inv_deploy/inv_lantern/inv/inv_lantern_2" }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_lantern", clk_lantern_beg, "inv_lantern" );
    cmn.AddSubscriber( "clk_lantern", clk_lantern_end, "inv_lantern" );
    cmn.AddSubscriber( "clk_lantern_beg", clk_lantern_beg, "inv_lantern" );
    cmn.AddSubscriber( "clk_lantern_end", clk_lantern_end, "inv_lantern" );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_battery_2" ] = {
        type = "use",
        inv_obj = "inv_battery_2",
        use_place = "obj_lantern_use_battery_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_lantern",
        zz_gate = "inv_lantern"
    };
    function use_battery_2_inv ()

      interface.InventoryItemRemove( "inv_battery_2" );
      if ( not cmn.IsEventDone("get_bulb") and cmn.IsEventDone("clk_lantern") ) then

         ObjSet( "spr_lantern_plus_light", { alp = 0 });

      else 

         ObjSet( "spr_lantern_plus_light", { alp = 1 });

      end
    end;
    function use_battery_2_beg ()

      ObjDelete( "obj_lantern_use_battery_2" );

    end;
    function use_battery_2_end ()
      
      ObjSet("spr_deploy_lantern_battery",     { alp = 1 });
      ObjSet( "spr_lantern_battery", { alp = 1 });
      
      if ( cmn.IsEventDone("use_bulb") ) then
        
        ObjMultiSet({
          { "spr_deploy_litlantern",     { input = true }},
          { "gfx_deploy_litlantern",     { active = true }},
         
        });
        
      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_battery_2", use_battery_2_beg, "inv_lantern" );
    cmn.AddSubscriber( "use_battery_2", use_battery_2_inv );
    cmn.AddSubscriber( "use_battery_2", use_battery_2_end );
    cmn.AddSubscriber( "use_battery_2", use_battery_2_end, "inv_lantern" );
    cmn.AddSubscriber( "use_battery_2_inv", use_battery_2_inv );
    cmn.AddSubscriber( "use_battery_2_beg", use_battery_2_beg, "inv_lantern" );
    cmn.AddSubscriber( "use_battery_2_end", use_battery_2_end, "inv_lantern" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_bulb" ] = {
        type = "use",
        inv_obj = "inv_bulb",
        use_place = "obj_lantern_use_bulb",
        room = "int_deploy_inv",
        zz = "deploy_inv_lantern",
        zz_gate = "inv_lantern"
    };
    function use_bulb_inv ()

      interface.InventoryItemRemove( "inv_bulb" );
       if ( not cmn.IsEventDone("get_battery_2") and cmn.IsEventDone("clk_lantern")) then

         ObjSet( "spr_lantern_plus_light", { alp = 0 });

      else 

         ObjSet( "spr_lantern_plus_light", { alp = 1 });

      end;  

    end;
    function use_bulb_beg ()

      ObjDelete( "obj_lantern_use_bulb" );

    end;
    function use_bulb_end ()

      ObjDelete( "spr_deploy_lantern_glass_1" );
      ObjMultiSet({
        { "obj_deploy_lantern_lamp",     { alp = 1, pos_x = -121, pos_y = 68 }},
        { "spr_deploy_lantern_glass",     { alp = 1 }},
        { "spr_lantern_bulb", { alp = 1 } }
      });
      
      if ( cmn.IsEventDone("use_battery_2") ) then
        
        ObjMultiSet({
          { "spr_deploy_litlantern",     { input = true }},
          { "gfx_deploy_litlantern",     { active = true }}
        
        });
          
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bulb", use_bulb_beg, "inv_lantern" );
    cmn.AddSubscriber( "use_bulb", use_bulb_inv );
    cmn.AddSubscriber( "use_bulb", use_bulb_end );
    cmn.AddSubscriber( "use_bulb", use_bulb_end, "inv_lantern" );
    cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv );
    cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, "inv_lantern" );
    cmn.AddSubscriber( "use_bulb_end", use_bulb_end, "inv_lantern" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_litlantern" ] = {
      type = "get",
      get_obj = "spr_deploy_litlantern",
      room = "int_deploy_inv",
      zz = "deploy_inv_lantern",
      zz_gate = "inv_lantern"
    };
    function get_litlantern_inv ()

      interface.InventoryItemRemove( "inv_lantern" );
      interface.InventoryItemAdd( "inv_litlantern", "spr_deploy_litlantern" );

    end;
    function get_litlantern_deploy ()

      ObjDelete( "gfx_deploy_litlantern" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_litlantern", get_litlantern_inv );
    cmn.AddSubscriber( "get_litlantern", get_litlantern_deploy, "inv_lantern" );
    -------------------------------------------------------------------------------------------
  end;
   --*********************************************************************************************************************
  function private.clk_lantern()

    cmn.CallEventHandler( "clk_lantern_beg", "inv_lantern" );

    local func_after = function ()
    
      common_impl.Lock( false );
  
      cmn.SetEventDone( "clk_lantern" );
      cmn.CallEventHandler( "clk_lantern_end", "inv_lantern" );
      
    end;
  
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_lantern_touch_glass", 0, "", 0 ); 
    
    ObjAnimate( "spr_deploy_lantern_glass", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.3, 0, 0
    });

    ObjAnimate( "spr_deploy_lantern_glass_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0,
      0.3, 0, 1
    }); 
      
  end;
  --*********************************************************************************************************************
  function public.use_battery_2()

    local item = "inv_battery_2";
    if private.ObjIntersectCheck( item, "obj_lantern_use_battery_2", "deploy_inv_lantern" ) then

      cmn.CallEventHandler( "use_battery_2_beg", "inv_lantern" );
      cmn.CallEventHandler( "use_battery_2_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_battery_2" );
        cmn.CallEventHandler( "use_battery_2_end", "inv_lantern" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_lantern_battery", 0, "", 0 );

      ObjAnimate( "spr_deploy_lantern_battery", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.use_bulb()

    local item = "inv_bulb";
    if private.ObjIntersectCheck( item, "obj_lantern_use_bulb", "deploy_inv_lantern" ) and cmn.IsEventDone("clk_lantern")  then

      cmn.CallEventHandler( "use_bulb_beg", "inv_lantern" );
      cmn.CallEventHandler( "use_bulb_inv" );

      local func_after = function ()
       
          local func_end = function () 
          
            common_impl.Lock( false );

            cmn.SetEventDone( "use_bulb" );
            cmn.CallEventHandler( "use_bulb_end", "inv_lantern" );
            
          end;
        
          ObjAnimate( "spr_deploy_lantern_glass", "alp", 0, 0, "",
          { 
            0.0, 0, 0,
            0.3, 0, 1
          });

          ObjAnimate( "spr_deploy_lantern_glass_1", "alp", 0, 0, func_end,
          { 
            0.0, 0, 1,
            0.3, 0, 0
          }); 
        
      end;
        
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_lantern_lamp", 0, "", 0 );
       
      ObjAnimate( "obj_deploy_lantern_lamp", "alp", 0, 0, "",
      { 
        0.0, 0, 0,
        0.3, 0, 1
      });
      
      ObjAnimate( "obj_deploy_lantern_lamp", "pos_xy", 0, 0, func_after,
      { 
        0.0, 0, -210, 155,
        0.3, 0, -210, 155,
        0.8, 0, -121, 68
      });

      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.get_litlantern()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_litlantern" );
    cmn.CallEventHandler( "get_litlantern", "inv_lantern" );
    common_impl.HideDeployInv();

  end;

  ObjAnimate( "spr_deploy_device_arrow", "ang", 1, 0, "",
  { 
    0.0, 3, 0.2, 
    0.3, 3, -0.2,
    0.6, 3, 0.2
  } )
  