-- name=rm_beforepuzzle
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_beforepuzzle";
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------              
  ObjMultiSet({ 
    { "spr_armchair_tweezers", { event_mdown = private.get_tweezers }}
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_beforepuzzle = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then   
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_beforepuzzle_superpuzzle_1",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_beforepuzzle", update_game_mode_beforepuzzle, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_beforepuzzle = function ()

  local effects_table = 
  {
    "obj_beforepuzzle_anim"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_beforepuzzle", update_performance_mode_beforepuzzle, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_beforepuzzle () end;
  --------------------------------------------------------------------------------------------
  local opn_beforepuzzle_map = function ()

    common_impl.VisitMapRoom( "dungeon" );
    
  end;
  cmn.AddSubscriber( "opn_beforepuzzle", opn_beforepuzzle_map );

  --------------------------------------------------------------------------------------------
  -- function vid_beforepuzzle_autro () end;
  --------------------------------------------------------------------------------------------
  local vid_beforepuzzle_autro_beg = function ()

  end;
  local vid_beforepuzzle_autro_end = function ()
  
   ObjDelete("anm_beforepuzzle_door");

 end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_beforepuzzle_autro", vid_beforepuzzle_autro_beg, private.room_objname );
  cmn.AddSubscriber( "vid_beforepuzzle_autro", vid_beforepuzzle_autro_end, private.room_objname  );
  cmn.AddSubscriber( "vid_beforepuzzle_autro_beg", vid_beforepuzzle_autro_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_beforepuzzle_autro_end", vid_beforepuzzle_autro_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_beforepuzzle();
  
      
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();  
  
  if ( not cmn.IsEventDone( "vid_beforepuzzle_autro" ) and ( cmn.IsEventDone( "win_superpuzzle_1" ) )  ) then

    ObjSet( "tmr_beforepuzzle_autro", { playing = true, time = 0.00001, endtrig = private.vid_beforepuzzle_autro } );
    
  elseif cmn.IsEventDone( "vid_beforepuzzle_autro" ) and cmn.IsEventDone( "win_superpuzzle_1" ) and iOS_IsBought() == 1 then 
    ObjSet( "tmr_beforepuzzle_autro", { playing = true, time = 1, endtrig = function()
      local prg = ng_global.currentprogress;
      ng_global.progress[ prg ].common.chapter = "level2";
      ng_global.progress[ prg ].common.currentroom = nil;
      local level = ng_global.progress[ prg ].common.chapter;

      common.LevelSwitch( level );
    end});
  end;
  
  common_impl.EnvPlay( { "common/audio/level1/aud_beforepuzzle_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;

function private.opn_beforepuzzle()

  if not ( cmn.IsEventDone( "opn_beforepuzzle" ) ) then
    cmn.SetEventDone( "opn_beforepuzzle" );
  end;

end;
--*********************************************************************************************************************
function private.vid_beforepuzzle_autro()

  local func_video = function ()
    
    cmn.CallEventHandler( "vid_beforepuzzle_autro_beg" );

    local func_after = function ( skip )

      interface.DialogVideoHide();
      cmn.SetEventDone( "vid_beforepuzzle_autro" );
      cmn.CallEventHandler( "vid_beforepuzzle_autro_end" );
    
      if skip then

        common_impl.StopAudio( "sfx", "common/audio/level1/aud_beforepuzzle_autro", 0.2 );
        common_impl.StopAudio( "voc", "common/audio/level1/aud_beforepuzzle_autro_voc", 0.2 );
        
      end;

      --common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );
      if (iOS_IsBought() == 0) then
        
        iOS_LogEvents(1);
        common.LevelSwitch("menu","unlock");
        
      else
        
        local prg = ng_global.currentprogress;
        ng_global.progress[ prg ].common.chapter = "level2";
        ng_global.progress[ prg ].common.currentroom = nil;
        local level = ng_global.progress[ prg ].common.chapter;

        common.LevelSwitch( level );
        
      end;
      --common.GotoRoom( "rm_demo" );
      
      
      
    end;
    
    common_impl.Lock( false );

    common_impl.StopAllMus();

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_beforepuzzle_autro", 0, "", 0 );
    common_impl.PlayAudio( "voc", "common/audio/level1/aud_beforepuzzle_autro_voc", 0, "", 0 );
    interface.DialogVideoShow( "vid_beforepuzzle_autro", 1, function() func_after( 'skip' ); end, 3 );
    VidPlay( "vid_beforepuzzle_autro", function() func_after( nil ); end );
    
  end;
  
  common_impl.Lock( true );
  
  AnimPlay( "anm_beforepuzzle_door", "DoAnim", func_video );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_open_door_dungeon", 0, "", 0 );
  
end;
--*********************************************************************************************************************