-- name=rm_corridor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_lunchroomdoor", "room_hub" );
  ObjAttach( "zz_column", "room_hub" );
  ObjAttach( "zz_portrait", "room_hub" );
  ObjAttach( "zz_understairs", "room_hub" );
  private.Init_Subroom();
  

  -- loupe --
  
  private.loupe_mmg_win_pointer = 0;
  private.loupe_mmg_input_stop_drag = false;
  private.start_drag_auto = false;
  
  private.loupe_mmg_anim();

  for k = 1, 2 do
      
    for j = 1, 4 do
      
      ObjSet( "spr_corridor_loupe_mg_sign_"..k.."_"..j, { event_mdown = function() private.loupe_mmg_clk_sign( k, j ) end,
                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
      
    end;
      
  end;
                                                      
 -- loupe end --
  -- mmg --
  private.mmg_ang_false = {  1.03, -1.72,  1.77,  1.77, -3.75, -3.75 };
  private.mmg_ang_true  = { -0.98,  1.03, -1.72, -2.52,  1.77,  2.53 };
  private.sequence = { true, false, true, true, false, false };
  
 -- mmg end --
  ObjMultiSet({ 
    { "spr_lunchroomdoor_sign", { event_mdown = private.get_sign }},
    { "spr_column_lever", { event_mdown = private.get_lever }},
    { "spr_portrait_lunchroomkey", { event_mdown = private.get_lunchroomkey }},
    { "spr_portrait_microchip_1", { event_mdown = private.get_microchip_1 }},
    { "spr_portrait_battery", { event_mdown = private.get_battery_2 }},
    { "spr_portrait_tableamulet_1", { event_mdown = private.get_tableamulet_1 }},
    { "spr_portrait_chestkey", { event_mdown = private.get_chestkey }},
    { "spr_understairs_latchhandle", { event_mdown = private.get_latchhandle }},
    { "obj_lunchroomdoor_clk_lunchroomkey", { event_mdown = private.clk_lunchroomkey }},
    { "obj_lunchroomdoor_use_lunchroomkey", { event_mdown = private.clk_lunchroom_door }},
    { "obj_understairs_clk_socket", { event_mdown = private.clk_socket }},
    { "obj_portrait_use_safehandle", { event_mdown = private.clk_safe }},
    { "obj_understairs_use_button", { event_mdown = private.clk_door }},
    { "obj_corridor_clk_manequin", { event_mdown = private.clk_manequin }},
    { "spr_portrait_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_portrait_note" ) end }},    
    { "spr_portrait_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_portrait_note" ); common_impl.ShowBbt( 'bbt_portrait_note', 1 ); end } },
    { "spr_portrait_memo",             { event_mdown = function () common_impl.NoteScale( "open", "spr_portrait_memo" ) end }},    
    { "spr_portrait_memo_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_portrait_memo" ); common_impl.ShowBbt( 'bbt_portrait_memo', 1 ); end } },
    { "spr_portrait_arrow_right",      { event_mdown = function () private.Rotate( true ) end, event_menter = function () private.MouseEnterAnim( "right" ) end, event_mleave = function () private.MouseLeaveAnim( "right" ) end }},    
    { "spr_portrait_arrow_left",      { event_mdown = function () private.Rotate( false ) end, event_menter = function () private.MouseEnterAnim( "left" ) end, event_mleave = function () private.MouseLeaveAnim( "left" ) end }},    
    { "spr_corridor_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_portrait_collect_2", { event_mdown = function () private.get_collect_2_1_7(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
    });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_corridor = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then        
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_corridor_lunchroomdoor",
    "gzz_corridor_column",
    "gzz_corridor_portrait",
    "gzz_corridor_understairs"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_lunchroomdoor",
    "zz_column",
    "zz_portrait",
    "zz_understairs"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_corridor", update_game_mode_corridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_corridor = function ()

  local effects_table = 
  {
    "obj_corridor_anim",
    "spr_column_light",
    "spr_corridor_column_light_add",
    "anm_corridor_column_tape",
    "spr_corridor_portrait_add",
    "anm_corridor_manequin",
    "spr_corridor_understairs_light",
    "spr_lunchroomdoor_light",
    "anm_column_tapes",
    "spr_portrait_add_card"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_corridor", update_performance_mode_corridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_corridor () end;
  --------------------------------------------------------------------------------------------
  local opn_corridor_map = function ()

    common_impl.VisitMapRoom( "corridor" );

  end;
  cmn.AddSubscriber( "opn_corridor", opn_corridor_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_sign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sign" ] = {
    type = "get",
    get_obj = "spr_lunchroomdoor_sign",
    room = private.room_objname,
    zz = "zz_lunchroomdoor",
    zz_gate = "gzz_corridor_lunchroomdoor"
  };
    
  local get_sign_inv = function ()
  
    interface.InventoryItemAdd( "inv_sign", "spr_lunchroomdoor_sign" );
    ObjSet( "inv_sign", { drag = false });
     
  end;
  
  local get_sign_closezz = function ()
  
    ObjDelete( "gfx_lunchroomdoor_sign" );
    ObjDelete( "spr_lunchroomdoor_sign_shadow" );
    --ObjDelete( "spr_lunchroomdoor_sign_over" );
    ObjDelete( "spr_corridor_lunchroomdoor_plate" );
    
    
  end;
  
  cmn.AddSubscriber( "get_sign", get_sign_inv );
  cmn.AddSubscriber( "get_sign", get_sign_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever" ] = {
    type = "get",
    get_obj = "spr_column_lever",
    room = private.room_objname,
    zz = "zz_column",
    zz_gate = "gzz_corridor_column"
  };
  
  local get_lever_loc = function()
  
     ObjSet( "obj_window_clk_crow", { input = true });
     ObjSet( "anm_window_crow_1", { playing = true, alp = 1});
     ObjSet("anm_smallroom_crow", { playing = true, alp = 1 }); 
     
  end; 
   
  local get_lever_inv = function ()
  
    interface.InventoryItemAdd( "inv_lever", "spr_column_lever" );
  
  end;
  
  local get_lever_closezz = function ()
  
    ObjDelete( "gfx_column_lever" );
    ObjDelete( "gzz_corridor_column" );
    ObjDelete( "spr_corridor_column_pen" );
  
  end;
  
  cmn.AddSubscriber( "get_lever", get_lever_inv );
  cmn.AddSubscriber( "get_lever", get_lever_closezz, private.room_objname );
  cmn.AddSubscriber( "get_lever", get_lever_loc, "rm_smallroom" );
  --------------------------------------------------------------------------------------------
  -- function get_lunchroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lunchroomkey" ] = {
    type = "get",
    get_obj = "spr_portrait_lunchroomkey",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
    
  local get_lunchroomkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_lunchroomkey", "spr_portrait_lunchroomkey" );
  
  end;
  
  local get_lunchroomkey_closezz = function ()
  
    ObjDelete( "gfx_portrait_lunchroomkey" );
    ObjDelete( "spr_portrait_lunchroomkey_shadow" );
    ObjDelete( "spr_portrait_lunchroomkey_over" );
    ObjDelete( "spr_corridor_portrait_key" );
    ObjSet( "spr_portrait_over_3", { input = false } );
    
  end;
  
  cmn.AddSubscriber( "get_lunchroomkey", get_lunchroomkey_inv );
  cmn.AddSubscriber( "get_lunchroomkey", get_lunchroomkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_microchip_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_microchip_1" ] = {
    type = "get",
    get_obj = "spr_portrait_microchip_1",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
    
  local get_microchip_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_microchip_1", "spr_portrait_microchip_1" );
  
  end;
  
  local get_microchip_1_closezz = function ()
  
    ObjDelete( "gfx_portrait_microchip_1" );
    ObjDelete( "spr_portrait_microchip_1_shadow" );
    ObjSet("spr_portrait_note", { input = true });
        
    if ( cmn.IsEventDone("get_tableamulet_1") and cmn.IsEventDone("get_battery_2") ) then
      ObjDelete( "spr_portrait_over_4" );   
    end;
    
  end;
  
  cmn.AddSubscriber( "get_microchip_1", get_microchip_1_inv );
  cmn.AddSubscriber( "get_microchip_1", get_microchip_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery_2" ] = {
    type = "get",
    get_obj = "spr_portrait_battery",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
    
  local get_battery_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery_2", "spr_portrait_battery" );
    ObjSet("spr_lantern_plus_light",{ alp = 1 });
  
  end;
  
  local get_battery_2_closezz = function ()
  
    ObjDelete( "gfx_portrait_battery" );
    ObjDelete( "spr_portrait_battery_shadow" );
    ObjDelete( "spr_corridor_portrait_battery" );
    
    if ( cmn.IsEventDone("get_microchip_1") and cmn.IsEventDone("get_tableamulet_1") ) then
      ObjDelete( "spr_portrait_over_4" );   
    end;
    
  end;
  
  cmn.AddSubscriber( "get_battery_2", get_battery_2_inv );
  cmn.AddSubscriber( "get_battery_2", get_battery_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tableamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tableamulet_1" ] = {
    type = "get",
    get_obj = "spr_portrait_tableamulet_1",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
    
  local get_tableamulet_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_tableamulet_1", "spr_portrait_tableamulet_1" );
  
  end;
  
  local get_tableamulet_1_closezz = function ()
  
    ObjDelete( "gfx_portrait_tableamulet_1" );
    ObjSet("spr_portrait_note", { input = true });
    ObjDelete( "spr_portrait_tableamulet_1_shadow" );
    
    if ( cmn.IsEventDone("get_microchip_1") and cmn.IsEventDone("get_battery_2") ) then
      ObjDelete( "spr_portrait_over_4" );   
    end;
    
  end;
  
  cmn.AddSubscriber( "get_tableamulet_1", get_tableamulet_1_inv );
  cmn.AddSubscriber( "get_tableamulet_1", get_tableamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chestkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chestkey" ] = {
    type = "get",
    get_obj = "spr_portrait_chestkey",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
    
  local get_chestkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_chestkey", "spr_portrait_chestkey" );
  
  end;
  
  local get_chestkey_closezz = function ()
  
    ObjDelete( "gfx_portrait_chestkey" );
    ObjDelete( "spr_portrait_chestkey_shadow" );
   
  end;
  
  cmn.AddSubscriber( "get_chestkey", get_chestkey_inv );
  cmn.AddSubscriber( "get_chestkey", get_chestkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_latchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_latchhandle" ] = {
    type = "get",
    get_obj = "spr_understairs_latchhandle",
    room = private.room_objname,
    zz = "zz_understairs",
    zz_gate = "gzz_corridor_understairs"
  };
    
  local get_latchhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_latchhandle", "spr_understairs_latchhandle" );
  
  end;
  
  local get_latchhandle_closezz = function ()
  
    ObjDelete( "gfx_understairs_latchhandle" );

    ObjDelete( "spr_understairs_shadow" );
   
  end;
  
  cmn.AddSubscriber( "get_latchhandle", get_latchhandle_inv );
  cmn.AddSubscriber( "get_latchhandle", get_latchhandle_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_4 = function ()
  
    ObjDelete( "obj_corridor_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_4", get_collect_morph_item_1_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_7 = function ()
 
    ObjDelete( "spr_portrait_collect_2" );

    --if cmn.IsEventDone( "get_chestkey" ) then
    --  ObjDelete( "gzz_corridor_portrait" );
    --end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_7", get_collect_2_1_7, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_lunchroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lunchroomkey" ] = {
    type = "use",
    inv_obj = "inv_lunchroomkey",
    use_place = "obj_lunchroomdoor_use_lunchroomkey",
    room = private.room_objname,
    zz = "zz_lunchroomdoor",
    zz_gate = "gzz_corridor_lunchroomdoor"
  };
  local use_lunchroomkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_lunchroomkey" );
  
  end;
  local use_lunchroomkey_beg = function ()
  
    ObjDelete( "obj_lunchroomdoor_use_lunchroomkey" );
  
  end;
  local use_lunchroomkey_end = function ()
  
    ObjSet( "obj_lunchroomdoor_clk_lunchroomkey", { input = true } );
    ObjSet( "spr_lunchroomdoor_key_1", { alp = 1 } );
    ObjSet( "spr_corridor_lunchroomdoor_key", { alp = 1});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lunchroomkey", use_lunchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_lunchroomkey", use_lunchroomkey_inv );
  cmn.AddSubscriber( "use_lunchroomkey", use_lunchroomkey_end, private.room_objname );
  cmn.AddSubscriber( "use_lunchroomkey_inv", use_lunchroomkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_lunchroomkey_beg", use_lunchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_lunchroomkey_end", use_lunchroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_3" ] = {
    type = "use",
    inv_obj = "inv_elf_1",
    use_place = "obj_column_use_elf",
    room = private.room_objname,
    zz = "zz_column",
    zz_gate = "gzz_corridor_column"
  };
  local use_elf_3_beg = function ()
  
    ObjDelete( "obj_column_use_elf" );
  
  end;
  local use_elf_3_end = function ()
  
    ObjDelete( "vid_column_elf" );
    ObjSet( "spr_column_lever", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_3", use_elf_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3", use_elf_3_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_beg", use_elf_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_end", use_elf_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_signature () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_signature" ] = {
    type = "use",
    inv_obj = "inv_signature",
    use_place = "obj_portrait_use_signature",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
  local use_signature_inv = function ()
  
    interface.InventoryItemRemove( "inv_signature" );
  
  end;
  local use_signature_beg = function ()
  
    ObjDelete( "obj_portrait_use_signature" );
  
  end;
  local use_signature_end = function ()
  
    ObjDelete( "spr_portrait_over_2" );
    ObjDelete( "spr_corridor_portrait_signature" );
    ObjSet("spr_corridor_portrait_signature", { alp = 1 });
    ObjDelete( "spr_corridor_portrait" );
    ObjSet( "spr_corridor_portrait_open", { alp = 1 });
    ObjSet( "spr_corridor_portrait_key", { alp = 1 });
    
    ObjMultiSet({ 
      { "spr_portrait_over_3",     { input = true, alp = 1     }},
      { "spr_portrait_lunchroomkey",     { input = true     }},
      { "gfx_portrait_lunchroomkey",     { active = true    }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_signature", use_signature_beg, private.room_objname );
  cmn.AddSubscriber( "use_signature", use_signature_inv );
  cmn.AddSubscriber( "use_signature", use_signature_end, private.room_objname );
  cmn.AddSubscriber( "use_signature_inv", use_signature_inv, private.room_objname );
  cmn.AddSubscriber( "use_signature_beg", use_signature_beg, private.room_objname );
  cmn.AddSubscriber( "use_signature_end", use_signature_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_safehandle" ] = {
    type = "use",
    inv_obj = "inv_safehandle",
    use_place = "obj_portrait_use_safehandle",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
  local use_safehandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_safehandle" );
  
  end;
  local use_safehandle_beg = function ()
  
    ObjDelete( "obj_portrait_use_safehandle" );
  
  end;
  local use_safehandle_end = function ()

    ObjMultiSet({ 
      { "obj_portrait_use_electroniccard",     { input = true  }},
      { "spr_corridor_portrait_detail",     {  alp = 1  }},
      { "spr_portrait_safe_part",     {  alp = 1  }},
      { "obj_portrait_mmg",     {  alp = 1, input = true  }},
    });  
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_safehandle", use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle", use_safehandle_inv );
  cmn.AddSubscriber( "use_safehandle", use_safehandle_end, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_inv", use_safehandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_beg", use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_end", use_safehandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_electroniccard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_electroniccard" ] = {
    type = "use",
    inv_obj = "inv_electroniccard",
    use_place = "obj_portrait_use_electroniccard",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
  local use_electroniccard_inv = function ()
  
    interface.InventoryItemRemove( "inv_electroniccard" );
  
  end;
  local use_electroniccard_beg = function ()

    ObjDelete( "spr_portrait_over_4" );
    ObjDelete( "obj_portrait_use_electroniccard" );
  
  end;
  local use_electroniccard_end = function ()
  
    ObjDelete( "spr_portrait_card" );
    ObjDelete( "spr_portrait_add_card" );
    ObjMultiSet({ 
      { "spr_portrait_chestkey",     { input = true, alp = 1   }},
      { "spr_portrait_memo",     { input = true  }},
      { "gfx_portrait_chestkey",     { active = true    }},
      { "anm_portrait_use_card",     { frame = 177    }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_electroniccard", use_electroniccard_beg, private.room_objname );
  cmn.AddSubscriber( "use_electroniccard", use_electroniccard_inv );
  cmn.AddSubscriber( "use_electroniccard", use_electroniccard_end, private.room_objname );
  cmn.AddSubscriber( "use_electroniccard_inv", use_electroniccard_inv, private.room_objname );
  cmn.AddSubscriber( "use_electroniccard_beg", use_electroniccard_beg, private.room_objname );
  cmn.AddSubscriber( "use_electroniccard_end", use_electroniccard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_device_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_device_1" ] = {
  
    type = "click",
    use_place = "obj_int_button_apparat",  
    room = private.room_objname,
    
  };
  local use_device_1_inv = function ()
  
  end;
  local use_device_1_beg = function ()
  
  
  end;
  local use_device_1_end = function ()
  
  --ObjSet( "gzz_corridor_understairs", { input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_device_1", use_device_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_1", use_device_1_inv );
  cmn.AddSubscriber( "use_device_1", use_device_1_end, private.room_objname );
  cmn.AddSubscriber( "use_device_1_inv", use_device_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_device_1_beg", use_device_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_1_end", use_device_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button" ] = {
    type = "use",
    inv_obj = "inv_button",
    use_place = "obj_understairs_use_button",
    room = private.room_objname,
    zz = "zz_understairs",
    zz_gate = "gzz_corridor_understairs"
  };
  local use_button_inv = function ()
  
    interface.InventoryItemRemove( "inv_button" );
  
  end;
  local use_button_beg = function ()
  
    ObjDelete( "obj_understairs_use_button" );
    ObjDelete( "gzz_corridor_understairs" );
  
  end;
  local use_button_end = function ()
  
   ObjSet( "grm_corridor_dungeon", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_dungeon_focus");
    end;
   ObjSet( "spr_corridor_understairs_open", { alp = 1 } );
   ObjDelete( "spr_understairs_bas" );
  
  end;
 ------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button", use_button_inv );
  cmn.AddSubscriber( "use_button", use_button_end, private.room_objname );
  cmn.AddSubscriber( "use_button_inv", use_button_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_beg", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_end", use_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lunchroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lunchroomkey" ] = {
    type = "click",
    use_place = "obj_lunchroomdoor_clk_lunchroomkey",
    room = private.room_objname,
    zz = "zz_lunchroomdoor",
    zz_gate = "gzz_corridor_lunchroomdoor"
  };
  local clk_lunchroomkey_beg = function ()
  
    ObjDelete( "obj_lunchroomdoor_clk_lunchroomkey" );
    
  end;
  local clk_lunchroomkey_end = function ()
  
    ObjDelete( "gzz_corridor_lunchroomdoor" );
    ObjSet( "grm_corridor_lunchroom", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_lunchroom_focus");
    end;
    --ObjSet( "spr_lunchroomdoor_key_2", { alp = 1 } );
    ObjDelete( "spr_corridor_lunchroomdoor_close" );
    ObjSet("spr_corridor_lunchroomdoor_open", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lunchroomkey", clk_lunchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lunchroomkey", clk_lunchroomkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_lunchroomkey_beg", clk_lunchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lunchroomkey_end", clk_lunchroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_socket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_socket" ] = {
    type = "click",
    use_place = "obj_understairs_clk_socket",
    room = private.room_objname,
    zz = "zz_understairs",
    zz_gate = "gzz_corridor_understairs"
  };
  local clk_socket_beg = function ()
  
    ObjDelete( "obj_understairs_clk_socket" );
    
  end;
  local clk_socket_end = function ()
  
    
    ObjSet( "obj_understairs_use_button", { input = true, active = true } );
    ObjDelete( "spr_understairs_socket" );
    ObjDelete( "spr_corridor_understairs_socket" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_socket", clk_socket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_socket", clk_socket_end, private.room_objname );
  cmn.AddSubscriber( "clk_socket_beg", clk_socket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_socket_end", clk_socket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_manequin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_manequin" ] = {
    type = "click",
    use_place = "obj_corridor_clk_manequin",
    room = private.room_objname
  };
  local clk_manequin_beg = function ()
  
    ObjDelete( "obj_corridor_clk_manequin" );
    
  end;
  local clk_manequin_end = function ()
  
    ObjDelete( "anm_corridor_manequin" );
    ObjDelete( "anm_corridor_manequin_down" );
    ObjSet( "obj_corridor_hole", { input = true } ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_manequin", clk_manequin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_manequin", clk_manequin_end, private.room_objname );
  cmn.AddSubscriber( "clk_manequin_beg", clk_manequin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_manequin_end", clk_manequin_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_corridor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_corridor" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_corridor_loupe_mg",
   
  };

  local win_corridor = function ()
  
    if cmn.IsEventDone( "win_corridor" ) then

      ObjDelete( "obj_corridor_loupe_mg" );
      
    else
      
      for i = 1, 2 do
        
        for j = 1, 4 do
          
          for k = 1, 4 do
            
            if ng_global.progress["std"]["win_corridor"].saves[i][j][k] == 1 then
              
              local pos_star = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "obj_corridor_loupe_mg" );
              
              local pos_star_2 = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..(3-i).."_"..k, "obj_corridor_loupe_mg" );
              
              private.loupe_mmg_make_line( pos_star, pos_star_2, (3-i), k, i, j, true );
              
              private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
              
              ObjSet( "spr_corridor_loupe_mg_sign_"..(3-i).."_"..k.."_light", { alp = 1 } );
              
              ObjSet( "spr_corridor_loupe_mg_sign_"..i.."_"..j, { input = false } );
  
            end;
            
          end;
          
        end;
        
      end;
      
    end;
  
  end;

  cmn.AddSubscriber( "win_corridor", win_corridor, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_portrait () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_portrait" ] = {
    type = "win",
    room = private.room_objname,
    zz = "zz_portrait",
    zz_gate = "gzz_corridor_portrait"
  };
  local win_portrait = function ()

    if cmn.IsEventDone( "win_portrait" ) then
  
      ObjMultiSet({ 
        { "spr_portrait_microchip_1",     { input = true     }},
        { "gfx_portrait_microchip_1",     { active = true    }},
        { "spr_portrait_battery",     { input = true     }},
        { "gfx_portrait_battery",     { active = true    }},
        { "spr_portrait_tableamulet_1",     { input = true     }},
        { "gfx_portrait_tableamulet_1",     { active = true    }},
        { "spr_corridor_portrait_open_safe",     { alp = 1   }},
        { "spr_portrait_open_safe",     { input = true, alp = 1  }},
      });
    
      ObjDelete( "obj_portrait_mmg" )
    
    else

      local state = ng_global.progress["std"]["win_portrait"].state;
      if state > 1 then
        
        ObjSet( "spr_portrait_mmg_part", { ang = private.mmg_ang_true[state-1] } )
        for i = 1, state - 1 do
          
          ObjSet( "spr_portrait_mmg_part_"..i, { drawoff_x = 146 } )
          
        end;
        
      else
        
        ObjSet( "spr_portrait_mmg_part", { ang = 0 } )
        
      end;
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_portrait", win_portrait, private.room_objname );
  --------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------
  -- function vid_corridor_loupe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_corridor_loupe" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_corridor_loupe",
    
  };

  local vid_corridor_loupe = function ()

    ObjSet( "gzz_corridor_understairs", { input = true, active = true } );
  
  end;

  cmn.AddSubscriber( "vid_corridor_loupe", vid_corridor_loupe, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function vid_corridor_saving () end;
  --------------------------------------------------------------------------------------------
  local vid_corridor_saving_end = function ()
  
    ObjSet( "anm_corridor_manequin", { alp = 1, playing = true } );
    ObjSet( "rm_corridor", { color_r = 1, color_g = 1, color_b = 1 });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_corridor_saving", vid_corridor_saving_end, private.room_objname  );
  cmn.AddSubscriber( "vid_corridor_saving_end", vid_corridor_saving_end, private.room_objname  );
  
  common_impl.hint[ "vid_corridor_trap" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_corridor_trap",
    
  };
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_portrait" );
  function zz_portrait.PreOpen()
    
    if not common_impl.corridor then

      common_impl.corridor = {}
      common_impl.corridor.note = "close";

    end;

    if  ObjGet( "spr_portrait_note" ).input == true then

      ObjSet( "spr_portrait_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_portrait_note",     { alp = 1 } );
      
    end;

    if  ObjGet( "spr_portrait_memo" ).input == true then

      ObjSet( "spr_portrait_memo_big", { input = false, alp = 0 } );
      ObjSet( "spr_portrait_memo",     { alp = 1 } );
      
    end;
    if cmn.IsEventDone( "use_safehandle" ) and not cmn.IsEventDone( "win_portrait" ) then
      
      cmn.MiniGameShow( 'portrait' );
      common_impl.PassingMgStart( "portrait" );
      
    end;
    
  end;
  function zz_portrait.Close()
    
    if cmn.IsEventDone( "use_safehandle" ) and not cmn.IsEventDone( "win_portrait" ) then
      
      cmn.MiniGameHide( 'portrait' );
      common_impl.PassingMgStop( "portrait" ); 
      
    end;  

    common_impl.corridor.note = "close"; 
    
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_corridor();
  
  common_impl.LoupeMgCheck();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();  
  
  if not ng_global.progress["std"]["opn_corridor"].viewer then
    
    ng_global.progress["std"]["opn_corridor"].viewer = 1;
    
  end;
  
  if not cmn.IsEventDone( "vid_corridor_trap" ) then

    ObjSet( "tmr_corridor_trap",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_corridor_trap(); end
    } );

  end;
  
  if ( cmn.IsEventDone("win_traproom") and not cmn.IsEventDone("vid_corridor_saving") ) then
    
    private.vid_corridor_saving();
    
  end
  
  common_impl.EnvPlay( { "common/audio/level1/aud_corridor_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "clk_manequin" ) then
      
    common_impl.PlayAudio( "env", "common/audio/level1/aud_commander_doll_env", 1, "", 0 );
      
  end;
  
  if cmn.IsEventDone( "vid_corridor_trap" ) then
    
    if ( ng_global.progress["std"]["opn_corridor"].viewer < 4 ) then
      
      ng_global.progress["std"]["opn_corridor"].viewer = ng_global.progress["std"]["opn_corridor"].viewer + 1;
      
      if ng_global.progress["std"]["opn_corridor"].viewer == 3 then
        
        interface.Lock( true, 3 );
        
        ObjSet( "anm_corridor_human", { alp = 1 } );
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interacitve_corridor_woman", 0, "", 0 );
        
        AnimPlay( "anm_corridor_human", "DoAnim", function() common_impl.ShowBbt( 'bbt_corridor_woman' ); end );
        
      elseif ng_global.progress["std"]["opn_corridor"].viewer == 4 then
          
          interface.Lock( true, 3 );
          
          ObjSet( "anm_corridor_man", { alp = 1 } );
          
          common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interacitve_corridor_man", 0, "", 0 );
          
          AnimPlay( "anm_corridor_man", "DoAnim", function() common_impl.ShowBbt( 'bbt_corridor_man' ); end );
          
      end;
        
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if not cmn.IsEventDone( "clk_manequin" ) then
      
    common_impl.StopAudio( "env", "common/audio/level1/aud_commander_doll_env", 0.5 );
      
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lunchroomkey()

  local item = "inv_lunchroomkey";

  if ( common.ApplyObj( item, "obj_lunchroomdoor_use_lunchroomkey", true ) and cmn.IsEventDone("get_sign") ) then

    cmn.CallEventHandler( "use_lunchroomkey_inv" );
    cmn.CallEventHandler( "use_lunchroomkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lunchroomkey" );
      cmn.CallEventHandler( "use_lunchroomkey_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_key_lunchroomdoor", 0, "", 0 );
    
    ObjAnimate( "spr_lunchroomdoor_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_lunchroomdoor", false ) and cmn.IsEventDone("get_sign") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lunchroomdoor", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_3()

  local item = "inv_elf_1";

  if ( common.ApplyObj( item, "obj_column_use_elf", true ) ) then

    interface.InventoryItemRemove( "inv_elf_1" );
    cmn.CallEventHandler( "use_elf_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_3" );
      cmn.CallEventHandler( "use_elf_3_end" );
      ObjSet( "spr_column_elf", { alp = 1 })
      interface.InventoryItemAdd( "inv_elf_1", "spr_column_elf", nil, "video" );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
      
    end;

    common_impl.Lock( true );

    VidPlay( "vid_column_elf", func_after );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_column_elf", 0, "", 0 );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_column", false ) and not cmn.IsEventDone( "use_elf_3" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_column", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_signature()

  local item = "inv_signature";

  if ( common.ApplyObj( item, "obj_portrait_use_signature", true ) ) then

    cmn.CallEventHandler( "use_signature_inv" );
    cmn.CallEventHandler( "use_signature_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_signature" );
        cmn.CallEventHandler( "use_signature_end" );
        
      end;
      
      ObjAnimate( "spr_portrait_over_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      
      ObjAnimate( "spr_portrait_over_3", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_signature_portrait", 0, "", 0 );
    
    ObjAnimate( "spr_portrait_over_2_part", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_portrait", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_safehandle()

  local item = "inv_safehandle";

  if ( common.ApplyObj( item, "obj_portrait_use_safehandle", true ) ) then

    cmn.CallEventHandler( "use_safehandle_inv" );
    cmn.CallEventHandler( "use_safehandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_safehandle" );
      cmn.CallEventHandler( "use_safehandle_end" );
    --common.CloseSubRoom();;
      ng_global.progress["std"]["win_portrait"].state = 1;
      cmn.MiniGameShow( 'portrait' );
      common_impl.PassingMgStart( "portrait" );
    
  end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_safehandle_portrait", 0, "", 0 );
  
    ObjAnimate( "obj_portrait_mmg", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_portrait_safe_part", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_portrait", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_electroniccard()

  local item = "inv_electroniccard";

  if ( common.ApplyObj( item, "obj_portrait_use_electroniccard", true ) and common_impl.corridor.note == "close") then

    cmn.CallEventHandler( "use_electroniccard_inv" );
    cmn.CallEventHandler( "use_electroniccard_beg" );

    local func_after = function ()   
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_electroniccard" );
        cmn.CallEventHandler( "use_electroniccard_end" );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_electroniccard_portrait", 0, "", 0 );
    
    AnimPlay( "anm_portrait_use_card", "DoAnim", func_after );
    ObjAnimate( "spr_portrait_add_card", "alp", 0, 0, "",
    { 
    0.0, 0, ObjGet( "spr_portrait_add_card" ).alp, 
    0.2, 0, 0.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_portrait", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button()

  local item = "inv_button";

  if ( common.ApplyObj( item, "obj_understairs_use_button", true ) and cmn.IsEventDone("clk_socket")) then

    cmn.CallEventHandler( "use_button_inv" );
    cmn.CallEventHandler( "use_button_beg" );
   
   local func_after = function ()
   
     local func_end = function ()
       
        common_impl.Lock( false );
        cmn.SetEventDone( "use_button" );
        cmn.CallEventHandler( "use_button_end" );
        common.CloseSubRoom();
        
        interface.KeyTaskDone( "open_staircase", true );
         
       end;
      
      ObjSet( "anm_understairs_door", { alp = 1 } );
      ObjSet( "spr_understairs_bas", { alp = 0 } );
      AnimPlay( "anm_understairs_door", "DoAnim", func_end );
      
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_button_understairs", 0, "", 0 );
  ObjAnimate( "spr_understairs_button", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_understairs", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_understairs", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_device_1()

  local item = "inv_device_1";

  cmn.CallEventHandler( "use_device_1_inv" );
  cmn.CallEventHandler( "use_device_1_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_device_1" );
    cmn.CallEventHandler( "use_device_1_end" );
    
    common_impl.LoupeMgStart();
  --common.CloseSubRoom();;
  
  end;

  common_impl.Lock( true );
  func_after();
  --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_device_1", 0, "", 0 );
  
    --ObjAnimate( "spr", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
  
  return true;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_7()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_7");
    cmn.CallEventHandler("get_collect_2_1_7");

    --if cmn.IsEventDone( "get_chestkey" ) then
    --  common.CloseSubRoom();
    --end;    

  end;

  common_impl.PlayEffectHO( "spr_portrait_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_sign()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_sign" );
  cmn.CallEventHandler( "get_sign" );

end;
--------------------------------------------------------------------------------------------
function private.get_lever()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lever" );
  cmn.CallEventHandler( "get_lever" );

  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_lunchroomkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lunchroomkey" );
  cmn.CallEventHandler( "get_lunchroomkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_microchip_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_microchip_1" );
  cmn.CallEventHandler( "get_microchip_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_battery_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_battery_2" );
  cmn.CallEventHandler( "get_battery_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_tableamulet_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tableamulet_1" );
  cmn.CallEventHandler( "get_tableamulet_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_chestkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chestkey" );
  cmn.CallEventHandler( "get_chestkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_latchhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_latchhandle" );
  cmn.CallEventHandler( "get_latchhandle" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_lunchroomkey()
  
  cmn.CallEventHandler( "clk_lunchroomkey_beg" );
      
  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_lunchroomkey" );
    cmn.CallEventHandler( "clk_lunchroomkey_end" );
    common.CloseSubRoom();
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_key_lunchroomdoor", 0, "", 0 );
  
  ObjAnimate( "spr_lunchroomdoor_key_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  
  ObjAnimate( "spr_lunchroomdoor_key_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0,
    0.3, 0, 1.0,  
    0.6, 0, 0.0
  } );
  ObjAnimate( "spr_lunchroomdoor_door_opened", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.6, 3, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_lunchroom_door()
  
      
  local func_after = function ()

    common_impl.Lock( false );
  
  end;
  
  common_impl.ShowBbt( 'bbt_lunchroomdoor_use_lunchroomkey' );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_door_lunchroom", 0, "", 0 );
  
  ObjAnimate( "obj_lunchroomdoor_sign", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 42, 
    0.3, 0, 44,
    0.4, 0, 42
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_manequin()
 
  cmn.CallEventHandler( "clk_manequin_beg" );
  
  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_manequin" );
    cmn.CallEventHandler( "clk_manequin_end" );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_corridor_clk_mannequin', 1 );
  common_impl.StopAudio( "env", "common/audio/level1/aud_commander_doll_env", 0.5 );

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_commander_doll", 0, "", 0 );
  ObjSet( "anm_corridor_manequin", { alp = 0 });
  ObjSet( "anm_corridor_manequin_down", { alp = 1 });
  AnimPlay( "anm_corridor_manequin_down", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_door()
      
  local func_after = function ()

    common_impl.Lock( false );
  
  end;
  
  common_impl.ShowBbt( 'bbt_understairs_use_button' );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_spring_understairs", 0, "", 0 );

  AnimPlay( "anm_understairs_spring", "DoAnim", func_after);
  
end;
--------------------------------------------------------------------------------------------
function private.clk_safe()
    
  local func_after = function ()

    common_impl.Lock( false );
  
  end;
  
  common_impl.ShowBbt( 'bbt_portrait_use_safehandle' );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_safe_portrait", 0, "", 0 );
  
  AnimPlay( "anm_portrait_handle", "DoAnim", func_after)
  
end;
---------------------------------------------------------------------------------------------
function private.clk_socket()
  
  cmn.CallEventHandler( "clk_socket_beg" );
      
  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_socket" );
    cmn.CallEventHandler( "clk_socket_end" );
    --common.CloseSubRoom();
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_button_understairs", 0, "", 0 );
  
  ObjAnimate( "spr_understairs_socket", "ang", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.09,
    0.6, 1, 0.0,
    0.9, 0, -0.1,
  } );
  
  ObjAnimate( "spr_understairs_socket", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, -94, 
    0.9, 0, -94,
    2.0, 3,  300
  } );

end;
--*********************************************************************************************************************
-- function *** MMG PORTRAIT *** () end;
--*********************************************************************************************************************
  function private.Rotate( direction )

    common_impl.Lock( true );
    local pos = ng_global.progress["std"]["win_portrait"].state

    if private.sequence[pos] == direction then
      
      local func_after = function()

        if ng_global.progress["std"]["win_portrait"].state == 6 then
          
          private.WinPortrait();
          
        else
          
          common_impl.Lock( false );
          ng_global.progress["std"]["win_portrait"].state = pos+1;
          
        end;
        
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_rotate", 0, "", 0 );
      local sound_func = function()
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_open", 0, "", 0 );
      end;
      ObjSet( "tmr_portrait_sound", { playing = true, time = 0.8, endtrig = sound_func } );
   
      ObjAnimate("spr_portrait_mmg_part", "ang", 0, 0, "",
      { 
        0, 0, ObjGet( "spr_portrait_mmg_part" ).ang,
        0.8, 3, private.mmg_ang_true[pos]
      });
      ObjAnimate("spr_portrait_mmg_part_"..pos, "drawoff_x", 0, 0, func_after,
      { 
        0, 0, 128,
        0.8, 3, 128,
        1.2, 3, 146,
      });

    else
      
      local func_after = function()
      
        ng_global.progress["std"]["win_portrait"].state = 1;
        common_impl.Lock( false );
        
      end;

      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_rotate", 0, "", 0 );
      ObjAnimate("spr_portrait_mmg_part", "ang", 0, 0, func_after,
      { 
        0, 0, ObjGet( "spr_portrait_mmg_part" ).ang,
        0.8, 3, private.mmg_ang_false[pos],
        1.6, 3, 0
      });
      
      local sound_func = function()
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_rotate", 0, "", 0 );
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_close", 0, "", 0 );
      end;
      ObjSet( "tmr_portrait_sound", { playing = true, time = 0.8, endtrig = sound_func } );
      
      
      if pos ~= 1 then
        
        for i =1,pos-1 do
          
          ObjAnimate("spr_portrait_mmg_part_"..i, "drawoff_x", 0, 0, "",
          { 
            0, 0, 146,
            0.8, 3, 146,
            1.2, 3, 128
          });
          
        end;
        
      end;
      
    end;
  
  end;
  --******************************************************************************************
  function private.MouseEnterAnim( dir )

    common_impl.SetCursor( CURSOR_HAND );

    local obj = "spr_portrait_arrow_"..dir;
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );

  end;
  --******************************************************************************************
  function private.MouseLeaveAnim( dir )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = "spr_portrait_arrow_"..dir;
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
  
  function private.WinPortrait()

    local func_after = function()

      common_impl.Lock( false );    
      cmn.MiniGameHide( "portrait" );
      common_impl.PassingMgWin( "portrait" );    
      cmn.SetEventDone( "win_portrait" )
      cmn.CallEventHandler( "win_portrait" );
      
    end;

    local sound_func = function()
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_portrait_win", 0, "", 0 );
    end;
    ObjSet( "tmr_portrait_sound", { playing = true, time = 0.3, endtrig = sound_func } );
    
    ObjAnimate( "obj_portrait_mmg", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 3, 0
    });
    ObjAnimate( "spr_portrait_open_safe", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0, 
      0.3, 3, 0,
      0.6, 3, 1
    });
    

  end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridor()

  if not ( cmn.IsEventDone( "opn_corridor" ) ) then
    cmn.SetEventDone( "opn_corridor" );
  end;
  
  cmn.CallEventHandler( "opn_corridor" ); 

end;
--*********************************************************************************************************************
function private.vid_corridor_saving()

  cmn.CallEventHandler( "vid_corridor_saving_beg" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_corridor_saving" );
    cmn.CallEventHandler( "vid_corridor_saving_end" );
    common_impl.ShowBbt( 'bbt_vid_corridor_saving', 1 );
    
    interface.KeyTaskAdd( "find_avenger_2", true );
    
     common_impl.AddPageDiary( 3 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_corridor_saving", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level1/aud_corridor_saving_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_corridor_saving", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level1/aud_corridor_saving_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_corridor_saving", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_corridor_saving", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_corridor_trap()

  cmn.CallEventHandler( "vid_corridor_trap_beg" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_corridor_trap" );
    cmn.CallEventHandler( "vid_corridor_trap_end" );
    common_impl.ShowBbt( 'bbt_vid_corridor_trap', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_corridor_trap", 0.2 );
      --common_impl.StopAudio( "voc", "common/audio/level1/aud_corridor_trap_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger2_mus", 0, "", 0 );
    common.GotoRoom( "mg_trap" );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_corridor_trap", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "common/audio/level1/aud_corridor_trap_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_corridor_trap", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_corridor_trap", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function public.vid_corridor_loupe()

  local func_after = function ()

    common_impl.Lock( false );

    int_loupe.Hide();
  
    cmn.SetEventDone( "vid_corridor_loupe" );
    cmn.CallEventHandler( "vid_corridor_loupe" );
    common_impl.ShowBbt( 'bbt_vid_corridor_loupe', 1 );
    
    private.zoom_understairs();
 
  end;

  local func_after_emergence = function ()
  
    local func_after_stand_1 = function ()
    
       local func_after_move = function ()
       
         local func_after_stand_2 = function ()
         
           ObjSet( "anm_corridor_loupe_stand_2", { alp = 0 } );
         
           ObjSet( "anm_corridor_loupe_fade", { alp = 1 } );
  
           AnimPlay( "anm_corridor_loupe_fade", "DoAnim", func_after );
           
           common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_hide", 0, "", 0 );
         
         end;
         
         ObjSet( "anm_corridor_loupe_move", { alp = 0 } );
       
         ObjSet( "anm_corridor_loupe_stand_2", { alp = 1 } );
  
         AnimPlay( "anm_corridor_loupe_stand_2", "DoAnim", "" );
          
         ObjAnimate( "spr_corridor_loupe_text_2", "alp", 0, 0, func_after_stand_2, { 0,0,0, 0.3,0,1 , 2.3,0,1, 2.6,0,0 } );
         
         common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
       
       end;
       
       ObjSet( "anm_corridor_loupe_stand_1", { alp = 0 } );
    
       ObjSet( "anm_corridor_loupe_move", { alp = 1 } );
  
       AnimPlay( "anm_corridor_loupe_move", "DoAnim", func_after_move );
       
       common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_move", 0, "", 0 );
    
    end;
     
    ObjSet( "anm_corridor_loupe_emergence", { alp = 0 } );
 
    ObjSet( "anm_corridor_loupe_stand_1", { alp = 1 } );
  
    AnimPlay( "anm_corridor_loupe_stand_1", "DoAnim", "" );
    
    ObjAnimate( "spr_corridor_loupe_text_1", "alp", 0, 0, func_after_stand_1, { 0,0,0, 0.3,0,1 , 1.3,0,1, 1.6,0,0 } );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
  
  end;

  --common_impl.StopAllMus();
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_show", 0, "", 0 );
 
  ObjSet( "obj_corridor_loupe_anim", { active = true, visible = true } );
  
  AnimPlay( "anm_corridor_loupe_emergence", "DoAnim", func_after_emergence );


end;
--*********************************************************************************************************************
function private.zoom_understairs()
  
  local func_after = function()
  
    local func_after_zoom = function()
    
      common_impl.Lock( false );
      
      interface.KeyTaskDone( "find_avenger_2", true, function() interface.KeyTaskAdd( "open_staircase", true ) end  );
      
      ng_global.task_current = "open_staircase";
    
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
    ObjAnimate( "rm_corridor", "scale_xy", 0, 0, func_after_zoom, { 0,0,1.2,1.2, 0.6,0,1,1 } );  
    ObjAnimate( "rm_corridor", "pos_xy", 0, 0, "", { 0,0,33,-14, 0.6,0,0,0 } );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  
  ObjAnimate( "rm_corridor", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.6,0,1.2,1.2, 1.3,0,1.2,1.2 } );  
  ObjAnimate( "rm_corridor", "pos_xy", 0, 0, "", { 0,0,0,0, 0.6,0,33,-14, 1.3,0,33,-14 } );
  
end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function private.skip_loupe()

  private.win_loupe();
  
end;
--*********************************************************************************************************************
function private.reset_loupe()

  private.win_loupe();
  
end;
--*********************************************************************************************************************
function private.win_loupe()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide( "corridor" );
  common_impl.PassingMgWin( "corridor" );
  cmn.SetEventDone( "win_corridor" );
  cmn.CallEventHandler( "win_corridor" );
  
  public.vid_corridor_loupe();
 
end;
--*********************************************************************************************************************
function public.Skip( event )

  if event == "win_portrait" then

    private.WinPortrait();

  elseif event == "win_corridor" then

    private.skip_loupe();

  end;

end;

function public.Reset( event )
  
  if event == "win_corridor" then
    
    private.loupe_mmg_wrong_anim();

  elseif event == "win_portrait" then

    pos = ng_global.progress["std"]["win_portrait"].state;
    
    if pos ~= 1 then
        
      ng_global.progress["std"]["win_portrait"].state = 1;
      ObjSet( "spr_portrait_mmg_part", { ang = 0 } );
      for i =1,pos-1 do
        
        ObjSet( "spr_portrait_mmg_part_"..i, { drawoff_x = 128 } );
               
      end;

    end;
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** LOUPE *** () end;
--*********************************************************************************************************************
  function private.loupe_mmg_anim()
    
    ObjAnimate( "obj_corridor_loupe_mg_signs", "pos_xy", 1, 0, "", { 0,0,0,0, 2.5,0,-5,-4, 5,0,0,0 } );
  
  end;
--*********************************************************************************************************************
  function private.loupe_mmg_clk_sign( i, j )
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );
    
    local params = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "obj_corridor_loupe_mg" );

    ObjSet( "obj_corridor_loupe_mg_line", { pos_x = params[1], pos_y = params[2],
                                            event_startdrag = function() private.loupe_mmg_start_drag( i, j ) end,
                                            event_drag = function() private.loupe_mmg_drag( i, j ) end,
                                            event_dragdrop = function() private.loupe_mmg_drag_drop( i, j ) end } );
    
    ObjStartDrag( "obj_corridor_loupe_mg_line" );

  end;
--*********************************************************************************************************************
  function public.loupe_mmg_start()
 
    if not ng_global.progress["std"]["win_corridor"].saves then
                                                        
      ng_global.progress["std"]["win_corridor"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_start_drag( i, j )
  
    if not private.start_drag_auto then
    
    private.pos_x_line = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "rm_corridor_loupe" )[1] - 511;
    private.pos_y_line = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "rm_corridor_loupe" )[2] - 383;
    
    if i == 2 then

      private.pos_y_line = private.pos_y_line + 4;
      
    end;
    
    private.pos = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "rm_corridor_loupe" );
   
    private.pos_x_cur = private.pos[1];
    private.pos_y_cur = private.pos[2];
    
    --DbgTrace( private.pos_x_line.." "..private.pos_y_line.."   "..private.pos_x_cur.." "..private.pos_y_cur );
 
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_click", 0, "", 0 );

  end;

  private.loupe_mmg_input_stop_drag = false;
  private.loupe_mmg_stop_drag_flag = false;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_drag( i, j )

  common_impl.SetCursor( CURSOR_GET );

    if ObjIntersect( "obj_corridor_loupe_mg_line", "obj_corridor_loupe_mg" ) then

      local cur_pos = GetZoomCursorPos();
      pos_x1 = cur_pos[ 1 ];
      pos_y1 = cur_pos[ 2 ];

      dx = pos_x1 - private.pos_x_cur;
      dy = pos_y1 - private.pos_y_cur;
      s = math.sqrt(dx^2+dy^2);
      angl = (math.atan2(dx,dy))- 1.57; 
  
      lenght = 2;--коэффициент

      ObjSet( "tmr_corridor_loupe_mmg", 
      { 
        playing = true, 
        time = 0.01,  
        endtrig = function() private.loupe_mmg_drag(i, j) end ;
      } );
      
 

      ObjSet( "spr_corridor_loupe_mg_line", { alp = 1 } );
      ObjSet( "spr_corridor_loupe_mg_line",
        {
         pos_x = private.pos_x_line,
         pos_y = private.pos_y_line,
         ang = angl, 
         scale_x = s / lenght,
         blendmode = 2;
        } );
        
      --ObjSet( "obj_corridor_loupe_mg_line_input",
      --{
      -- pos_x = s/2,
      -- pos_y = 0,
      -- inputrect_w = s - 20, 
      -- inputrect_x = - ( ( s - 20 )/2 ),
      -- inputrect_h = 10,
      -- inputrect_y = -3,
      -- attachtype = 2,
      --} );

    else 
        
        private.loupe_mmg_wrong_anim();

      if private.loupe_mmg_stop_drag_flag == false then

        private.loupe_mmg_input_stop_drag = true;

        ObjStopDrag( "obj_corridor_loupe_mg_line" );

        private.loupe_mmg_stop_drag_flag = true;
        
        --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_wrong", 0, "", 0 );

      end;
        
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_stop_drag()

  ObjSet( "tmr_corridor_loupe_mmg", { playing = 0 } );
  ObjSet( "spr_corridor_loupe_mg_line", { alp = 0 } );

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_drag_drop( i, j )
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "obj_corridor_loupe_mg_line";
  local points = {};
  local old = {};
  old[1] = i;
  old[2] = j;

  --[[поиск куда бросили ]]

  private.start_drag_auto = false;

  if not private.loupe_mmg_input_stop_drag then
   
    for k = 1, 2 do  
      for l = 1, 4 do  
        if ObjIntersect( name, "spr_corridor_loupe_mg_sign_"..k.."_"..l ) and not ( k == i and l == j ) then
          points[1] = k;
          points[2] = l;
        end;
      end;
    end;

    local pos_star = { 
      private.pos_x_line, 
      private.pos_y_line
    };

    if points[1] and points[2] and points[1] ~= old[1] then
      
      local pos_star_2 = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..points[1].."_"..points[2], "obj_corridor_loupe_mg" );
      
      if points[1] == 2 then
        
        pos_star_2[2] = pos_star_2[2] + 4;
        
      end;

      private.loupe_mmg_make_line( pos_star, pos_star_2, points[1],points[2], old[1],old[2], false );

      --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_true", 0, "", 0 );
      
      elseif  private.loupe_mmg_win_pointer ~= 8 then
      
      private.loupe_mmg_wrong_anim();
      
    end;

  end;

  private.loupe_mmg_stop_drag();

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_make_line( elem_1, elem_2, i, j, n, m, save )
  
  local pos_x1 = elem_1[ 1 ];
  local pos_y1 = elem_1[ 2 ];

  local pos_x2 = elem_2[ 1 ]
  local pos_y2 = elem_2[ 2 ];
  
  local dx = pos_x1 - pos_x2;
  local dy = pos_y1 - pos_y2;
  local s = math.sqrt(dx^2+dy^2);
  local angl = (math.atan2(dx,dy)) - 1.57; 
  local lenght = 2;
  
  --DbgTrace( pos_x1.." "..pos_y1.."  "..pos_x2.." "..pos_y2 );

  ObjSet( "spr_corridor_loupe_mg_line", { alp = 0 } );

  if not ObjGet( "spr_corridor_loupe_mg_line_"..i.."_"..j ) and i ~= n then
  
    ObjCreate( "spr_corridor_loupe_mg_line_"..i.."_"..j, "spr" );
    ObjAttach( "spr_corridor_loupe_mg_line_"..i.."_"..j, "obj_corridor_loupe_mg_signs" );
    ObjSet( "spr_corridor_loupe_mg_line_"..i.."_"..j,
      {
       res = "assets/interface/resources/apparatus/line",
       pos_x =  pos_x1,
       pos_y =  pos_y1,
       ang = angl, 
       scale_x = s / lenght,
       scale_y = 1;
       drawoff_x = -1,
       blendmode = 2;
      } );
     
     ObjCreate( "obj_corridor_loupe_mg_line_"..i.."_"..j.."_input", "obj" );
     ObjAttach( "obj_corridor_loupe_mg_line_"..i.."_"..j.."_input", "spr_corridor_loupe_mg_line_"..i.."_"..j ); 
     
     local weight = 0.76 + 0.01* ( s / 50 );
     
     ObjSet( "obj_corridor_loupe_mg_line_"..i.."_"..j.."_input",
      {
      pos_x = -1,
       pos_y = 0,
       input = true,
       inputrect_init = true,
       inputrect_w = 2*weight, 
       inputrect_x = -weight,
       inputrect_h = 10,
       inputrect_y = -5,
      } ); 
      
    local pos_star_2 = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j, "obj_corridor_loupe_mg" );
      
    if not save then

      ObjSet( "obj_corridor_loupe_mg_line", { 
      pos_x = pos_x2,
      pos_y = pos_y2,
      event_startdrag = function () private.loupe_mmg_start_drag(i,j) end,
      event_drag = function () private.loupe_mmg_drag(i,j) end,
      event_dragdrop = function () private.loupe_mmg_drag_drop(i,j) end } );
      
      ObjSet( "spr_corridor_loupe_mg_sign_"..n.."_"..m, { input = false } );
      
      if not private.loupe_mmg_check_intersect() then
      
        --ng_global.progress["std"]["win_corridor"].saves[i][j][m] = 1;
        ng_global.progress["std"]["win_corridor"].saves[n][m][j] = 1;
        
        private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
     
        if private.loupe_mmg_win_pointer ~= 8 then

          private.pos_x_line = ObjGet( "spr_corridor_loupe_mg_sign_"..i.."_"..j ).pos_x;
          private.pos_y_line = ObjGet( "spr_corridor_loupe_mg_sign_"..i.."_"..j ).pos_y;

          private.pos = GetObjPosByObj( "spr_corridor_loupe_mg_sign_"..i.."_"..j );
            
          private.pos_x_cur = private.pos[1];
          private.pos_y_cur = private.pos[2];

          private.start_drag_auto = true; 
          
        else
          
          private.loupe_mmg_win_anim();
            
        end;
        
        private.loupe_mmg_light_anim( i, j );
        
      else
        
        private.loupe_mmg_wrong_anim();
        
      end;
      
    end;

  else

    private.loupe_mmg_wrong_anim();

  end;
 
  end;
------------------------------------------------------------------------------------------
 function private.loupe_mmg_check_intersect()
 
   local intersect_array = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
 
 for i = 1, 14 do

   for j = 1, 2 do
     
     for k = 1, 4 do
 
       if ObjGet( "obj_corridor_loupe_mg_line_"..j.."_"..k.."_input" ) and
         ObjIntersect( "obj_corridor_loupe_mg_intersect_"..i, "obj_corridor_loupe_mg_line_"..j.."_"..k.."_input" ) then
          
          intersect_array[i] = intersect_array[i] + 1;
          
          if intersect_array[i] > 1 then
            
            return true;
            
          end;
          
        end;
       
     end;
     
   end;
   
 end;
  
  return false;
   
 end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_wrong_anim()
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_wrong", 0, "", 0 );

  private.loupe_mmg_stop_drag();
    
  private.loupe_mmg_win_pointer = 0;
  
  local lines = ObjGetRelations( "obj_corridor_loupe_mg_signs" ).childs;

  for j = 1, #lines do
    
    if ObjGet( lines[j] ) and string.find( ObjGet( lines[j] ).name, "line" ) then

      ObjDelete( lines[j] );

    end;

  end;
  
  for i = 1, 2 do
    
    for k = 1, 4 do
      
      ObjSet( "spr_corridor_loupe_mg_sign_"..i.."_"..k.."_light", { alp = 0 } );
      ObjSet( "spr_corridor_loupe_mg_sign_"..i.."_"..k, { input = true } );
   
    end;
    
  end;
    
   ng_global.progress["std"]["win_corridor"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_light_anim( i, j )
  
  local func_after = function()

    common_impl.Lock( false );
    
    if not private.loupe_mmg_stop_drag_flag and private.loupe_mmg_win_pointer ~= 8 then
      
      common_impl.SetCursor( CURSOR_GET );

      ObjStartDrag( "obj_corridor_loupe_mg_line" );
      
    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_true", 0, "", 0 );
  
  ObjAnimate( "spr_corridor_loupe_mg_sign_"..i.."_"..j.."_light", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
  
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_win_anim()
    
    local func_after = function()
    
      private.win_loupe();
      
      common_impl.Lock( false );
    
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_win", 0, "", 0 );
    
    ObjStopDrag( "obj_corridor_loupe_mg_line" );
    
    for i = 1, 2 do
      
      for j = 1, 4 do
        
        ObjAnimate( "spr_corridor_loupe_mg_sign_"..i.."_"..j.."_light_win", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,0, 0.5,0,1, 0.9,0,1, 1.2,0,0 } );
        
        func_after = "";
        
      end;
      
    end;

  end;
--*********************************************************************************************************************
ObjAnimate( "spr_column_light", "alp", 1, 0, "", { 0,0,1, 0.8,0,0.5, 1.6,0,1 } );
ObjAnimate( "spr_corridor_column_light_add", "alp", 1, 0, "", { 0,0,1, 0.8,0,0.5, 1.6,0,1 } );
ObjAnimate( "spr_portrait_add_card", "alp", 1, 0, "", { 0,0,1, 0.4,0,0.0, 0.8,0,1, 1.2,0,1 } );
ObjAnimate( "spr_corridor_light_1_add", "alp", 1, 0, "", { 0,0,1, 0.8,0,0.5, 1.6,0,1 } );
ObjAnimate( "spr_corridor_light_2_add", "alp", 1, 0, "", { 0,0,1, 0.8,0,0.5, 1.6,0,1 } );


  
