-- name=rm_demo
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "rm_demo";
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "btn_demo_buttons", { 
    event_mdown = function () private.ButtonMouseClick(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end 
  });
  
  if IsSurveyEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_survey" } );

  elseif IsDemoEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_end_txt" } );

  end;
  
  common_impl.hint[ "opn_demo" ] = {
    room = private.room_objname
  };

  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_demo = function ()

  local effects_table = 
  {
    "obj_demo_anims"                        ,
    "anm_demo_snow"                     ,
    "anm_demo_steam"                     ,
    "anm_demo_bears"                     ,
    "anm_demo_helicopter_2"                     ,
    "anm_demo_helicopter_1"                     ,
    "anm_demo_light"                     
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_demo", update_performance_mode_demo, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  --[[if not ( cmn.IsEventDone( "opn_demo" ) ) then
    cmn.SetEventDone( "opn_demo" );
  end;]]


  if not ( ( IsSurveyEdition() ) or ( IsDemoEdition() ) ) then

    SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  else

    if ( IsCollectorsEdition() ) then

      ObjSet( "spr_demo_collectors", { visible = 1 } );

    end;

    private.StartAnims();


  end;

  if ( GetPerformanceMode() ~= 1 ) then

    private.AnimHelicopter();

  end;

end;
--*********************************************************************************************************************
function private.AnimHelicopter()

  ObjSet( "anm_demo_helicopter_1", { alp = 1 } );
  ObjSet( "anm_demo_helicopter_2", { alp = 0 } );

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_survey_helicopter_1", 0, "", 0 );
    
  AnimPlay( "anm_demo_helicopter_1", "DoAnim", function() private.AnimHelicopter_2() end );

end;
--*********************************************************************************************************************
function private.AnimHelicopter_2()

  ObjSet( "anm_demo_helicopter_2", { alp = 1 } );
  ObjSet( "anm_demo_helicopter_1", { alp = 0 } );

   common_impl.PlayAudio( "sfx", "common/audio/level1/aud_survey_helicopter_2", 0, "", 0 );

  AnimPlay( "anm_demo_helicopter_2", "DoAnim", function() private.AnimHelicopter() end );

end;
--*********************************************************************************************************************
function public.PreOpen()
--    DbgTrace("enter1")
  if ( (IsSurveyEdition() ) or ( IsDemoEdition()) ) then

    ObjAnimate( "rm_demo", "color_rgb", 0, 0, "", 
    { 
      0.0, 0, 0, 0, 0,
      0.3, 0, 0, 0, 0,
      0.5, 0, 1, 1, 1
    } );

    interface.InterfaceSetInput( 0 ); 
    interface.InterfaceSetVisible( 0, 0 );

    common_impl.PlayAudio( "mus", "common/audio/aud_credits_mus", 1 );

    common_impl.EnvPlay( { "common/audio/level1/aud_hall_env" }, "", 0.5 );

  else
--
--    DbgTrace("enter")
--    ObjSet( "rm_demo", 
--    { 
--      color_r = 0.0,
--      color_g = 0.0,
--      color_b = 0.0
--    } );

    interface.InterfaceSetInput( 0 ); 
    interface.InterfaceSetVisible( 0, 0 );

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  common_impl.StopAudio(  "mus", "common/audio/aud_credits_mus", 1 );

  common_impl.StopAudio( "env", "common/audio/aud_hall_env", 0.5 );

end;
--*********************************************************************************************************************
function private.ButtonMouseEnter()

  local but_name = "spr_demo_ok_focus";

  if ( GetPerformanceMode() == 0 ) then

    but_name = "anm_demo_ok_focus";

  end;
  common_impl.SetCursor( CURSOR_HAND );  

  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - but_alp ) ), 0, 1 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseLeave()

  common_impl.SetCursor( CURSOR_DEFAULT );  

  local but_name = "spr_demo_ok_focus";

  if ( GetPerformanceMode() == 0 ) then

    but_name = "anm_demo_ok_focus";

  end;

  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * but_alp ), 0, 0 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseClick()

  if ( IsSurveyEdition() ) then

    SaveProfiles();
    SaveSettings();

  --  common.SaveInterfaceTimers();
    SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );
  
    --local survey_url = "http://bigfishgames.survey1-mystery-trackers-paxton-creek-avenger.sgizmo.com/s3/";
    --OpenBrowser( survey_url );

    Quit();

  else

    SaveProfiles();
    SaveSettings();

--  common.SaveInterfaceTimers();
    SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );

  end;  

end;
--*********************************************************************************************************************
function private.StartAnims()

  ObjAnimate( "spr_demo_helicopter_light", "alp", 1, 0, "", { 0,0,0.3, 2,0,1, 4,0,0.3 } );
  ObjAnimate( "spr_demo_light_towers", "alp", 1, 0, "", { 0,0,0.3, 3,0,1, 4,0,0.5, 8,0,1, 10,0,0.3  } );
  ObjAnimate( "spr_demo_light_first_plan", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );

end;
--*********************************************************************************************************************