-- name=rm_dungeon
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_dungeon";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_controlunit", "room_hub" );
  ObjAttach( "zz_shore", "room_hub" );
  ObjAttach( "zz_stash", "room_hub" );
  private.Init_Subroom();
  private.clk_lever = false;
  ObjMultiSet({ 
    { "spr_controlunit_duster", { event_mdown = private.get_duster }},
    { "spr_shore_safehandle", { event_mdown = private.get_safehandle }}, 
    { "obj_controlunit_clk_door", { event_mdown = function() private.clk_controlunit_door(); end; }},  
    { "obj_controlunit_clk_microchip_1", { event_mdown = function() private.clk_controlunit_microchip_1(); end; }},  
    --{ "obj_controlunit_clk_microchip_2", { event_mdown = function() private.clk_controlunit_microchip_2(); end; }},  
    { "obj_controlunit_clk_lever", { event_mdown = function() private.clk_lever_zz(); end; }},  
    { "spr_shore_lantern", { event_mdown = private.get_lantern }},
    { "spr_stash_tableamulet_2", { event_mdown = private.get_tableamulet_2 }},
    { "spr_stash_hook", { event_mdown = private.get_hook }},
    { "obj_shore_box_clk", { event_mdown = private.box_clk}},
    { "obj_stash_use_chestkey", { event_mdown = private.clk_stash_castle}},
    { "spr_shore_diary", { event_mdown = function () common_impl.NoteScale( "open", "spr_shore_diary" ) end }},    
    { "spr_shore_diary_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_shore_diary" ); common_impl.ShowBbt( 'bbt_dungeon_book', 1 ); end } },
    { "spr_dungeon_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_shore_collect_2", { event_mdown = function () private.get_collect_2_1_5(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_dungeon = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_dungeon_chestroom",
    "gzz_dungeon_controlunit",
    "gzz_dungeon_stash",
    "gzz_dungeon_shore"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_controlunit",
    "zz_shore",
    "zz_stash"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_dungeon", update_game_mode_dungeon, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_dungeon = function ()

  local effects_table = 
  {
   "obj_dungeon_anim",
   "spr_shore_light_add",
   "anm_dungeon_fog",
   "anm_controlunit_fog_1",
   "anm_controlunit_sparkle",
   "anm_controlunit_sparkle_1",
   "anm_controlunit_fog_2",
   "spr_stash_light",
   "anm_dungeon_fish",
   "vid_shore_water",
   "vid_controlunit_water",
   "vid_dungeon_water",   
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_dungeon", update_performance_mode_dungeon, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_dungeon () end;
  --------------------------------------------------------------------------------------------
  local opn_dungeon_map = function ()

    common_impl.VisitMapRoom( "dungeon" );

  end;
  
  --local opn_dungeon_end = function ()
  --
  --  ObjDelete("anm_dungeon_avenger");
  --  ObjSet("spr_dungeon_gate_door", { alp = 1 });
  --
  --end;
  cmn.AddSubscriber( "opn_dungeon", opn_dungeon_map );
  --cmn.AddSubscriber( "opn_dungeon", opn_dungeon_end );
  
  --------------------------------------------------------------------------------------------
  -- function get_duster () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_duster" ] = {
    type = "get",
    get_obj = "spr_controlunit_duster",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_dungeon_controlunit"
  };
    
  local get_duster_inv = function ()
  
    interface.InventoryItemAdd( "inv_duster", "spr_controlunit_duster" );
  
  end;
  
  local get_duster_closezz = function ()
  
    ObjDelete( "gfx_controlunit_duster" );
    ObjDelete( "spr_controlunit_duster_closed_shadow" );
    ObjSet( "obj_controlunit_clk_door", { input = true } );
    ObjDelete( "spr_dungeon_controlunit_rag_1" );

  end;
  
  cmn.AddSubscriber( "get_duster", get_duster_inv );
  cmn.AddSubscriber( "get_duster", get_duster_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_safehandle" ] = {
    type = "get",
    get_obj = "spr_shore_safehandle",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_dungeon_shore"
  };
    
  local get_safehandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_safehandle", "spr_shore_safehandle" );
  
  end;
  
  local get_safehandle_closezz = function ()
  
    ObjDelete( "gfx_shore_safehandle" );
    ObjDelete( "spr_shore_safehandle_shadow" );
    ObjDelete( "spr_dungeon_shore_safehandle" );
    
    --if cmn.IsEventDone( "get_lantern" ) and common_impl.IsGetCollect( "get_collect_2_1_5" ) then
    --
    --  ObjDelete( "gzz_dungeon_shore" );
    --  
    --end;
  
  end;
  
  cmn.AddSubscriber( "get_safehandle", get_safehandle_inv );
  cmn.AddSubscriber( "get_safehandle", get_safehandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lantern" ] = {
    type = "get",
    get_obj = "spr_shore_lantern",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_dungeon_shore"
  };
    
  local get_lantern_inv = function ()
  
    interface.InventoryItemAdd( "inv_lantern", "spr_shore_lantern" );
    ObjSet("inv_lantern", { drag = false });
    
  end;
  
  local get_lantern_closezz = function ()
  
    ObjDelete( "gfx_shore_lantern" );
    ObjDelete("spr_shore_lantern_shadow");
    ObjDelete("spr_dungeon_shore_lantern");
 
    --if cmn.IsEventDone( "get_safehandle" ) and common_impl.IsGetCollect( "get_collect_2_1_5" ) then
    --
    --  ObjDelete( "gzz_dungeon_shore" );
    --  
    --end;
  
  end;
  
  cmn.AddSubscriber( "get_lantern", get_lantern_inv );
  cmn.AddSubscriber( "get_lantern", get_lantern_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tableamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tableamulet_2" ] = {
    type = "get",
    get_obj = "spr_stash_tableamulet_2",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_dungeon_stash"
  };
    
  local get_tableamulet_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_tableamulet_2", "spr_stash_tableamulet_2" );
  
  end;
  
  local get_tableamulet_2_closezz = function ()
  
    ObjDelete( "gfx_stash_tableamulet_2" );
    ObjDelete( "spr_stash_tableamulet_2_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_tableamulet_2", get_tableamulet_2_inv );
  cmn.AddSubscriber( "get_tableamulet_2", get_tableamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook" ] = {
    type = "get",
    get_obj = "spr_stash_hook",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_dungeon_stash"
  };
    
  local get_hook_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook", "spr_stash_hook" );
  
  end;
  
  local get_hook_closezz = function ()
  
    ObjDelete( "gfx_stash_hook" );
    ObjDelete( "spr_stash_hook_shadow" );
    ObjDelete( "spr_dungeon_stash_hook" );
    ObjSet( "obj_stash_use_litlantern", { input = true });
  
  end;
  
  cmn.AddSubscriber( "get_hook", get_hook_inv );
  cmn.AddSubscriber( "get_hook", get_hook_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_6 = function ()
  
    ObjDelete( "obj_dungeon_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_6", get_collect_morph_item_1_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_microchip_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_microchip_1" ] = {
    type = "use",
    inv_obj = "inv_microchip_1",
    use_place = "obj_controlunit_use_microchip_1",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_dungeon_controlunit"
  };
  local use_microchip_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_microchip_1" );
  
  end;
  local use_microchip_1_beg = function ()
  
    ObjDelete( "obj_controlunit_use_microchip_1" );
  
  end;
  local use_microchip_1_end = function ()

    ObjSet( "spr_controlunit_microchip_1", { alp = 1 } );
    ObjSet( "spr_dungeon_controlunit_chip_1_set", { alp = 1 });
    ObjDelete( "anm_controlunit_sparkle_1" );
    
    if cmn.IsEventDone( "use_microchip_2" ) then

      ObjSet( "obj_controlunit_clk_lever", { input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_microchip_1", use_microchip_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip_1", use_microchip_1_inv );
  cmn.AddSubscriber( "use_microchip_1", use_microchip_1_end, private.room_objname );
  cmn.AddSubscriber( "use_microchip_1_inv", use_microchip_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_microchip_1_beg", use_microchip_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip_1_end", use_microchip_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_microchip_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_microchip_2" ] = {
    type = "use",
    inv_obj = "inv_microchip_2",
    use_place = "obj_controlunit_use_microchip_2",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_dungeon_controlunit"
  };
  local use_microchip_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_microchip_2" );
  
  end;
  local use_microchip_2_beg = function ()
  
    ObjDelete( "obj_controlunit_use_microchip_2" );
  
  end;
  local use_microchip_2_end = function ()

    ObjSet( "spr_controlunit_microchip_2", { alp = 1 } );
    ObjSet( "spr_dungeon_controlunit_chip_2_set", { alp = 1 });
    ObjDelete( "anm_controlunit_sparkle" );
    if cmn.IsEventDone( "use_microchip_1" ) then

      ObjSet( "obj_controlunit_clk_lever", { input = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_microchip_2", use_microchip_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip_2", use_microchip_2_inv );
  cmn.AddSubscriber( "use_microchip_2", use_microchip_2_end, private.room_objname );
  cmn.AddSubscriber( "use_microchip_2_inv", use_microchip_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_microchip_2_beg", use_microchip_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip_2_end", use_microchip_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook" ] = {
    type = "use",
    inv_obj = "inv_hook",
    use_place = "obj_shore_use_hook",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_dungeon_shore"
  };
  local use_hook_inv = function ()
  
    interface.InventoryItemRemove( "inv_hook" );
  
  end;
  local use_hook_beg = function ()
  
    ObjDelete( "obj_shore_use_hook" );
  
  end;
  local use_hook_end = function ()

    ObjMultiSet({ 
      { "obj_shore_box", { alp = 1 }},
      { "obj_shore_box_clk", { input = true, active = true}},
      { "spr_shore_safehandle", { alp = 1 }},
      { "spr_shore_safehandle_shadow", { alp = 1 }},
      { "spr_shore_box_close_cap", {  alp = 1 }},
      { "spr_shore_box_over", {  alp = 1 }},
      { "spr_dungeon_shore_box", { alp = 1 }},
      { "spr_dungeon_shore_box_close", { alp = 1 }},
      
      
    });
    ObjDelete( "anm_shore_use_hook" )
    ObjDelete("spr_shore_box_water");
    --ObjDelete("spr_dungeon_shore_box_water");
    ObjDelete("anm_dungeon_box");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook", use_hook_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook", use_hook_inv );
  cmn.AddSubscriber( "use_hook", use_hook_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_inv", use_hook_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_beg", use_hook_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_end", use_hook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_5" ] = {
    type = "use",
    inv_obj = "inv_elf_1",
    use_place = "obj_stash_use_elf_1",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_dungeon_stash"
  };
  local use_elf_5_beg = function ()
  
    ObjDelete( "obj_stash_use_elf_1" );
  
  end;
  local use_elf_5_end = function ()

    ObjDelete( "vid_stash_static_bat" );
    ObjDelete( "vid_stash_elf" );
    ObjMultiSet({ 
      { "spr_stash_hook",     { input = true     }},
      { "gfx_stash_hook",     { active = true    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_5", use_elf_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_5", use_elf_5_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_5_beg", use_elf_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_5_end", use_elf_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chestkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chestkey" ] = {
    type = "use",
    inv_obj = "inv_chestkey",
    use_place = "obj_stash_use_chestkey",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_dungeon_stash"
  };
  local use_chestkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_chestkey" );
  
  end;
  local use_chestkey_beg = function ()
  
    ObjDelete( "obj_stash_use_chestkey" );
  
  end;
  local use_chestkey_end = function ()
  
    ObjDelete( "gzz_dungeon_stash" );
    ObjDelete( "spr_stash_box_castle_close_light" );
    ObjDelete( "spr_stash_box_close" );
    ObjDelete( "spr_stash_box_close_cover" )
    ObjSet( "gho_dungeon_chestroom", { input = true, active = true, alp = 1 } );
    ObjSet( "anm_dungeon_gho_chestroom", { visible = true } ); 
    ObjSet( "spr_stash_box_castle_open_light", { alp = 1 } );
    ObjSet( "spr_stash_box_open", { alp = 1 } );
    ObjDelete( "spr_dungeon_stash_cache" );
    ObjSet( "spr_dungeon_stash_cache_2", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chestkey", use_chestkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey", use_chestkey_inv );
  cmn.AddSubscriber( "use_chestkey", use_chestkey_end, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_inv", use_chestkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_beg", use_chestkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_end", use_chestkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_litlantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_litlantern" ] = {
    type = "use",
    inv_obj = "inv_litlantern",
    use_place = "obj_stash_use_litlantern",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_dungeon_stash"
  };
  local use_litlantern_inv = function ()
  
    interface.InventoryItemRemove( "inv_litlantern" );
  
  end;
  local use_litlantern_beg = function ()
  
    ObjDelete( "obj_stash_use_litlantern" );
  
  end;
  local use_litlantern_end = function ()
  
    ObjDelete( "spr_stash_box_castle_close" );
    ObjDelete( "spr_stash_shadow_over" );
    ObjDelete( "spr_stash_tableamulet_1" ); 
    ObjMultiSet({ 
      { "spr_stash_tableamulet_2",     { input = true, alp = 1     }},
      { "gfx_stash_tableamulet_2",     { active = true    }},
      { "spr_stash_box_close_over",     { alp = 1    }},
      { "spr_stash_box_castle_close_light",     { alp = 1    }},
      { "obj_stash_lamp",     { alp = 1    }},
      { "obj_stash_use_chestkey",     { input = true    }},
      { "spr_dungeon_stash_cache", { alp = 1}},
      { "spr_dungeon_stash_light", { alp = 1}}
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_litlantern", use_litlantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_litlantern", use_litlantern_inv );
  cmn.AddSubscriber( "use_litlantern", use_litlantern_end, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_inv", use_litlantern_inv, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_beg", use_litlantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_end", use_litlantern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_box () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_box" ] = {
    type = "click",
    use_place = "obj_shore_box_clk",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_dungeon_shore"
  };
  local clk_box_beg = function ()
  
    ObjDelete( "obj_shore_box_clk" );
  
  end;
  local clk_box_end = function ()
  
    ObjSet( "spr_shore_safehandle", { input = true, active = true } );
    ObjSet( "spr_shore_box_open_cap", { alp = 1 });
    ObjDelete( "spr_shore_box_close_cap" );
    ObjDelete("spr_dungeon_shore_box_close");
    ObjSet( "spr_dungeon_shore_box_open", { alp = 1 });
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_box", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box", clk_box_end, private.room_objname );
  cmn.AddSubscriber( "clk_box_beg", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box_end", clk_box_end, private.room_objname );
  ------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_controlunit_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_controlunit_door" ] = {
    type = "click",
    use_place = "obj_controlunit_clk_door",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_dungeon_controlunit"
  };
  local clk_controlunit_door_beg = function ()
  
    ObjDelete( "obj_controlunit_clk_door" );
  
  end;
  local clk_controlunit_door_end = function ()

    ObjMultiSet({ 
      { "spr_controlunit_duster",     { input = true     }},
      { "gfx_controlunit_duster",     { active = true    }},
      { "obj_cotrnrolunit_opened",     { alp = 1, input = true    }},
      { "obj_controlunit_clk_microchip_1",     { input = true }},
      --{ "obj_controlunit_clk_microchip_2",     { input = true }},
      { "spr_dungeon_controlunit_open", { alp = 1 } }
    });
    ObjDelete( "obj_cotrnrolunit_closed" );
    ObjDelete( "spr_dungeon_controlunit_close" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_controlunit_door", clk_controlunit_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_door", clk_controlunit_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_door_beg", clk_controlunit_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_door_end", clk_controlunit_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_controlunit_microchip_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_controlunit_microchip_1" ] = {
    type = "click",
    use_place = "obj_controlunit_clk_microchip_1",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_dungeon_controlunit"
  };
  local clk_controlunit_microchip_1_beg = function ()
  
    ObjDelete( "obj_controlunit_clk_microchip_1" );
  
  end;
  local clk_controlunit_microchip_1_end = function ()

    ObjMultiSet({ 
    { "obj_controlunit_use_microchip_1",     { input = true }},
    { "obj_controlunit_use_microchip_2",     { input = true }}
    });
    ObjDelete( "anm_controlunit_burn_chip" );
    --ObjSet( "spr_dungeon_controlunit_chip_1", { alp = 1 });
    --ObjSet( "spr_dungeon_controlunit_chip_2", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_controlunit_microchip_1", clk_controlunit_microchip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_microchip_1", clk_controlunit_microchip_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_microchip_1_beg", clk_controlunit_microchip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controlunit_microchip_1_end", clk_controlunit_microchip_1_end, private.room_objname );
 
--  --------------------------------------------------------------------------------------------
  -- function anm_dungeon_avenger () end;
  --------------------------------------------------------------------------------------------
  local anm_dungeon_avenger_end = function ()
  
    ObjSet( "spr_dungeon_gate_door", { alp = 1 } );
    ObjSet( "anm_dungeon_boat", { alp = 1 });
    ObjDelete( "anm_dungeon_avenger" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "anm_dungeon_avenger", anm_dungeon_avenger_end, private.room_objname  );
  cmn.AddSubscriber( "anm_dungeon_avenger_end", anm_dungeon_avenger_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_dungeon_heat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_dungeon_heat" ] = {
      type = "click",
      use_place = "obj_controlunit_clk_lever",
      room = private.room_objname,
      zz = "zz_controlunit",
      zz_gate = "gzz_dungeon_controlunit"
  };
  local vid_dungeon_heat_beg = function ()

    ObjDelete( "gzz_dungeon_controlunit" );
    ObjDelete("spr_dungeon_controlunit_lever_up");
    ObjSet( "spr_dungeon_controlunit_lever_down", { alp = 1 });

  end;
  local vid_dungeon_heat_end = function ()

    ObjSet( "grm_dungeon_beforepuzzle", { input = true, active = true } ); 
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_dungeon_beforepuzzle_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_dungeon_heat", vid_dungeon_heat_beg, private.room_objname );
  cmn.AddSubscriber( "vid_dungeon_heat", vid_dungeon_heat_end, private.room_objname  );
  cmn.AddSubscriber( "vid_dungeon_heat_beg", vid_dungeon_heat_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_dungeon_heat_end", vid_dungeon_heat_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_5 = function ()
 
    ObjDelete( "spr_shore_collect_2" );

--    if cmn.IsEventDone( "get_safehandle" ) and cmn.IsEventDone( "get_lantern" ) then
--
--      ObjDelete( "gzz_dungeon_shore" );
--    
--    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_5", get_collect_2_1_5, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_chestroom () end;
  --------------------------------------------------------------------------------------------
  local win_chestroom = function ()
  
    if cmn.IsEventDone( "win_chestroom" ) then

      ObjDelete( "gho_dungeon_chestroom" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_chestroom", win_chestroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gates" ] = {
    type = "win",
    room = private.room_objname,
    zz_gate = "gmg_dungeon_gates",
    zz= "mg_gates"
  };

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************

function private.Init_Subroom()

  subroom.Define( "zz_controlunit" );
 
  function zz_controlunit.Close()

    if private.clk_lever then

      --private.vid_dungeon_heat();
      common_impl.Lock( true )
      ObjSet("spr_dungeon_controlunit_lever_down", { alp = 1 });
      ObjSet("spr_dungeon_controlunit_lever_up", { alp = 0 });
      ObjSet( "anm_dungeon_boat_start", { alp =  1 } );
      ObjSet( "anm_dungeon_boat", { alp =  0 } );
      AnimPlay( "anm_dungeon_boat_start", "DoAnim", private.vid_dungeon_heat )
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_boat_move_dungeon", 0, "", 0 );
      
    end;
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_microchip_env", 0.2 );

  end;
  
  subroom.Define( "zz_stash" );
  subroom.Define( "zz_shore" );
  function zz_shore.PreOpen()
    
       if not common_impl.dungeon then

         common_impl.dungeon = {}
         common_impl.dungeon.note = "close";

        end;
      
      if  ObjGet( "spr_shore_diary" ).input == true then

        ObjSet( "spr_shore_diary_big", { input = false, alp = 0 } );
        ObjSet( "spr_shore_diary",     { alp = 1 } );
        
      end;
      
  end;
    
 function zz_controlunit.PreOpen()  
   
     if cmn.IsEventDone( "clk_controlunit_door" ) and not cmn.IsEventDone( "clk_controlunit_microchip_1" ) then
        
        common_impl.PlayAudio( "env", "common/audio/level1/aud_microchip_env", 1, "", 0 );
        
      end;
      
  end;  
    
  function zz_stash.PreOpen()

    if not cmn.IsEventDone( "use_elf_5" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_bats_env", 1, "", 0 );
      
    end;

  end;
    
  function zz_stash.Close()

    if not cmn.IsEventDone( "use_elf_5" ) then
      
      common_impl.StopAudio( "env", "common/audio/level1/aud_bats_env", 0.5 );
      
    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_dungeon();
  
  if ( not cmn.IsEventDone( "anm_dungeon_avenger" ) ) then
   
    private.anm_dungeon_avenger();
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level1/aud_dungeon_env" }, "", 0.5 );
   
  --if ( not cmn.IsEventDone( "anm_dungeon_avenger" ) ) then
  -- 
  --  private.anm_dungeon_avenger();
  --  
  --end;

end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_microchip_1()

  local item = "inv_microchip_1";

  if ( common.ApplyObj( item, "obj_controlunit_use_microchip_1", true ) and cmn.IsEventDone( "clk_controlunit_microchip_1" )) then

    cmn.CallEventHandler( "use_microchip_1_inv" );
    cmn.CallEventHandler( "use_microchip_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_microchip_1" );
      cmn.CallEventHandler( "use_microchip_1_end" );
--      if cmn.IsEventDone( "use_microchip_2" ) then
--
--        common.CloseSubRoom();
--
--      end;
    
  end;

  common_impl.Lock( true );
  func_after();
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_microchip_controlunit", 0, "", 0 );
  
    ObjAnimate( "spr_controlunit_microchip_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_controlunit", false ) and cmn.IsEventDone( "clk_controlunit_microchip_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_microchip_2()

  local item = "inv_microchip_2";

  if ( common.ApplyObj( item, "obj_controlunit_use_microchip_2", true )  and cmn.IsEventDone( "clk_controlunit_microchip_1" )) then

    cmn.CallEventHandler( "use_microchip_2_inv" );
    cmn.CallEventHandler( "use_microchip_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_microchip_2" );
      cmn.CallEventHandler( "use_microchip_2_end" );
--      if cmn.IsEventDone( "use_microchip_1" ) then
--
--        common.CloseSubRoom();
--
--      end;

  end;

  common_impl.Lock( true );
  func_after();
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_microchip_controlunit", 0, "", 0 );
  
    ObjAnimate( "spr_controlunit_microchip_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_controlunit", false ) and cmn.IsEventDone( "clk_controlunit_microchip_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hook()

  local item = "inv_hook";

  if ( common.ApplyObj( item, "obj_shore_use_hook", true ) ) then

    cmn.CallEventHandler( "use_hook_inv" );
    cmn.CallEventHandler( "use_hook_beg" );

    local func_after = function ()
  
     local func_end = function ()
     
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hook" );
      cmn.CallEventHandler( "use_hook_end" );
      
     end;  
    --common.CloseSubRoom();;
    ObjAnimate( "spr_shore_box_water", "alp", 0, 0, "",
    { 
       0.0, 0, 1,
       0.4, 0, 1,
       0.7, 0, 0
    } );
    ObjAnimate( "anm_shore_use_hook", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    ObjAnimate( "obj_shore_box", "alp", 0, 0, "",
    { 
       0.0, 0, 0,
       1.7, 0, 0,
       1.7, 0, 1
    } );
    ObjAnimate( "spr_shore_box_close_cap", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      1.7, 0, 0,
      1.7, 0, 1
    } );
     ObjAnimate( "spr_shore_box_over", "alp", 0, 0, "",
    { 
       0.0, 0, 0,
       1.7, 0, 0,
       1.7, 0, 1
    } );
    AnimPlay( "anm_shore_use_hook", "DoAnim", func_end )
    
  end;

  common_impl.Lock( true );
  func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_hook_shore", 0, "", 0 );
  
  --ObjAnimate( "spr_shore_box_hook", "pos_xy", 0, 0, func_after,
  --  { 
  --    0.0, 0, -538, 327,
  --    0.6, 0, -143, 86,
  --    1.2, 0, -538, 327
  --  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_shore", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_5()

  local item = "inv_elf_1";

  if ( common.ApplyObj( item, "obj_stash_use_elf_1", true ) ) then

    interface.InventoryItemRemove( "inv_elf_1" ); 
    cmn.CallEventHandler( "use_elf_5_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_5" );
      cmn.CallEventHandler( "use_elf_5_end" );
      ObjSet( "vid_stash_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_1", "spr_stash_elf", nil, "video" );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
      
    end;
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_bats_env", 0.5 );

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_stash_elf", 0, "", 0 );
    ObjSet( "vid_stash_static_bat", { alp = 0, active = false });
    ObjSet( "vid_stash_elf", { alp = 1 });
    VidPlay( "vid_stash_elf", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_stash", false ) and not cmn.IsEventDone( "use_elf_5" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chestkey()

  local item = "inv_chestkey";

  if ( common.ApplyObj( item, "obj_stash_use_chestkey", true ) and cmn.IsEventDone("use_litlantern") and cmn.IsEventDone("get_tableamulet_2") ) then

    cmn.CallEventHandler( "use_chestkey_inv" );
    cmn.CallEventHandler( "use_chestkey_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_chestkey" );
        cmn.CallEventHandler( "use_chestkey_end" );
        common.CloseSubRoom();
        
      end;
      
      ObjAnimate( "spr_stash_box_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_stash_box_close_cover", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_stash_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_chestkey_stash", 0, "", 0 );
    
    ObjAnimate( "spr_stash_box_key", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_stash_box_castle_close_light", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.3, 0, 1.0,  
      0.6, 0, 0.0
    } );
    
    ObjAnimate( "spr_stash_box_castle_open_light", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,  
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_stash", false ) and cmn.IsEventDone("use_litlantern") and cmn.IsEventDone("get_tableamulet_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_litlantern()

  local item = "inv_litlantern";

  if ( common.ApplyObj( item, "obj_stash_use_litlantern", true ) and cmn.IsEventDone("get_hook")) then

    cmn.CallEventHandler( "use_litlantern_inv" );
    cmn.CallEventHandler( "use_litlantern_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_litlantern" );
      cmn.CallEventHandler( "use_litlantern_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_litlantern_stash", 0, "", 0 );
    ObjAnimate( "spr_stash_shadow_over", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    ObjAnimate( "obj_stash_lamp", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_stash_box_close_over", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_stash_box_castle_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    ObjAnimate( "spr_stash_box_castle_close_light", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_stash_tableamulet_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    ObjAnimate( "spr_stash_tableamulet_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_dungeon_stash", false ) and cmn.IsEventDone("get_hook") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_5()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_5");
    cmn.CallEventHandler("get_collect_2_1_5");

    if cmn.IsEventDone( "get_safehandle" ) and cmn.IsEventDone( "get_lantern" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_shore_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_duster()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_duster" );
  cmn.CallEventHandler( "get_duster" );

    if port.isPortable()==1 then
      iOS_RateMe();
    end;
end;
--------------------------------------------------------------------------------------------
function private.get_safehandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_safehandle" );
  cmn.CallEventHandler( "get_safehandle" );
  
  if cmn.IsEventDone( "get_lantern" ) and common_impl.IsGetCollect( "get_collect_2_1_5" ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_lantern()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lantern" );
  cmn.CallEventHandler( "get_lantern" );
  
  if cmn.IsEventDone( "get_safehandle" ) and common_impl.IsGetCollect( "get_collect_2_1_5" ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_tableamulet_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tableamulet_2" );
  cmn.CallEventHandler( "get_tableamulet_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_hook()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hook" );
  cmn.CallEventHandler( "get_hook" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
function private.clk_lever_zz()

  local func_after = "";
  
  if cmn.IsEventDone( "use_microchip_1" ) and
    cmn.IsEventDone( "use_microchip_2" ) then
  
    func_after = function()

      private.clk_lever = true;
      
      --ObjSet("spr_dungeon_controlunit_lever_down", { alp =  1});
      --ObjDelete("spr_dungeon_controlunit_lever_up");
      common.CloseSubRoom();
    
    end;
    
  else
    
    local func_after_2 = function()
    
        common_impl.Lock( false )
    end;

    func_after = function()
    
    common_impl.ShowBbt( 'bbt_controlunit_clk_lever' );
 
    ObjAnimate("obj_controlunit_lever_up", "alp", 0, 0, "",
    { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.6, 3, 1
    }); 
    ObjAnimate("obj_controlunit_lever_down", "alp", 0, 0, func_after_2,
    { 
    0.0, 0, 1, 
    0.3, 0, 1, 
    0.6, 3, 0
    }); 
    
    end;
    
  end; 
  
  if cmn.IsEventDone( "use_microchip_1" ) and
    cmn.IsEventDone( "use_microchip_2" ) then
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_lever_right_controlunit", 0, "", 0 ); 
    
  else
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_lever_controlunit", 0, "", 0 );
    
  end;

  common_impl.Lock( true )
  
  ObjAnimate("obj_controlunit_lever_up", "alp", 0, 0, "",
  { 
  0, 0, 1, 
  0, 3, 0
  }); 
  ObjAnimate("obj_controlunit_lever_down", "alp", 0, 0, func_after,
  { 
  0, 0, 0, 
  0, 3, 1
  }); 


end;
--------------------------------------------------------------------------------------------
function private.clk_controlunit_door()

  local func_after = function()

    cmn.SetEventDone( "clk_controlunit_door" );
    cmn.CallEventHandler( "clk_controlunit_door_end" );
    common_impl.Lock( false );
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_microchip_env", 1, "", 0 );
  
  end;

  common_impl.Lock( true )
  cmn.CallEventHandler( "clk_controlunit_door_beg" );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_door_controlunit", 0, "", 0 );
  
  ObjAnimate( "obj_cotrnrolunit_opened", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 3, 1
  });
  ObjAnimate( "obj_cotrnrolunit_closed", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.3, 3, 0
  }); 

end;
--------------------------------------------------------------------------------------------
function private.clk_controlunit_microchip_1()

  local func_after = function()

    cmn.SetEventDone( "clk_controlunit_microchip_1" );
    cmn.CallEventHandler( "clk_controlunit_microchip_1_end" );
    common_impl.Lock( false )
  
  end;

  common_impl.Lock( true );
  
  cmn.CallEventHandler( "clk_controlunit_microchip_1_beg" );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_microchip_env", 0.5 );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_microchip_controlunit", 0, "", 0 );
 
  AnimPlay("anm_controlunit_burn_chip", "DoAnim", func_after)
  
end;

function private.box_clk()

  local func_after = function()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_box" );
    cmn.CallEventHandler( "clk_box" );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_box_shore", 0, "", 0 );
  
  ObjAnimate( "spr_shore_box_open_cap", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  ObjAnimate( "spr_shore_box_close_cap", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
  
end;
  
function private.clk_stash_castle()

  local func_after = function()

    common_impl.Lock( false );
   
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_stash_use_chestkey' );
  
  local name = "spr_stash_box_castle_close";
  
  if cmn.IsEventDone( "use_litlantern" ) then
    
    name = "spr_stash_box_castle_close_light";
    
  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_castle_stash", 0, "", 0 );
  
  ObjAnimate( name, "ang", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.2, 0, 0.05,
    0.4, 0, 0.0,
  } );
  ObjAnimate( "spr_stash_box_close_cover", "pos_y", 0, 0, "",
  { 
    0.0, 0, -73, 
    0.2, 0, -74,
    0.4, 0, -73,
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_dungeon()

  if not ( cmn.IsEventDone( "opn_dungeon" ) ) then
    
    common_impl.AddPageDiary( 5 );
    
    cmn.SetEventDone( "opn_dungeon" );
    
    
  end;
  cmn.CallEventHandler( "opn_dungeon" );

end;
--*********************************************************************************************************************
function private.anm_dungeon_avenger()

  local func_after = function ( skip )
  
    common_impl.Lock( false );
    cmn.SetEventDone( "anm_dungeon_avenger" );
    cmn.CallEventHandler( "anm_dungeon_avenger_end" );
    
    common_impl.ShowBbt( 'bbt_anm_dungeon_avenger', 1 );
  
    interface.KeyTaskAdd( "hiding_place", true );
    
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_dungeon_avenger", 0, "", 0 );
  ObjSet( "anm_dungeon_avenger", { alp = 1, pos_z = 11 });
  AnimPlay("anm_dungeon_avenger", "DoAnim", func_after );
    
end;
--*********************************************************************************************************************
function private.vid_dungeon_heat()

  cmn.CallEventHandler( "vid_dungeon_heat_beg" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_dungeon_heat" );
    cmn.CallEventHandler( "vid_dungeon_heat_end" );
    common_impl.ShowBbt( 'bbt_vid_dungeon_heat', 1 );
    cmn.GotoRoom( 'rm_beforepuzzle' );
    common_impl.Lock(false);
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_dungeon_heat", 0.2 );
      --common_impl.StopAudio( "voc", "common/audio/level1/aud_dungeon_heat_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

  end;
  
  common_impl.Lock( false );

  common_impl.StopAllMus();
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_dungeon_heat", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "common/audio/level1/aud_dungeon_heat_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_dungeon_heat", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_dungeon_heat", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_shore_light_add", "alp", 1, 0, "",
{
  0.0, 0, 1.0, 
  1.0, 0, 0.5,
  2.0, 0, 1.0
});

ObjAnimate( "spr_shore_box_water", "ang", 1, 0, "",
{
  0.0, 0, -0.04 ,
  3.0, 0, 0.04,
  6.0, 0, -0.04
});