-- name=rm_hall
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_armchair", "room_hub" );
  ObjAttach( "zz_fireservice", "room_hub" );
  ObjAttach( "zz_orchestrapit", "room_hub" );
  private.Init_Subroom();
  --private.draw = {2, 1, 4, 2};
  --private.draw = {2, 1, 4, 1};
  private.draw = {7, 4, 3 };
 
  private.radian = { 0,
                     0.785398163,
                     1.57079633 ,
                     2.35619449 ,
                     3.14159265 ,
                     3.92699082 ,
                     4.71238898 ,
                     5.49778714 ,
                     6.28318531 
                   };  
             
  local table_multiset = {};
  
  for i = 1, 3 do

    table.insert( table_multiset, {"spr_armchair_round_"..i, 
      {
        event_menter = function () private.MouseEnterAnim( i ); end,
        event_mleave = function () private.MouseLeaveAnim( i ); end
      } 
    } );

  end;
  ObjMultiSet( table_multiset );                 
  ObjMultiSet({ 
    { "spr_armchair_tweezers", { event_mdown = private.get_tweezers }},
    { "spr_armchair_tokenfragment_2", { event_mdown = private.get_tokenfragment_2 }},
    { "spr_armchair_knife", { event_mdown = private.get_knife }},
    { "spr_armchair_device", { event_mdown = private.get_device }},
    { "spr_armchair_picklock", { event_mdown = private.get_picklock }},
    { "spr_fireservice_brokentokenmt", { event_mdown = private.get_brokentokenmt }},
    { "spr_fireservice_rope", { event_mdown = private.get_rope }},
    { "spr_fireservice_fireextinguisher", { event_mdown = private.get_fireextinguisher }},
    { "spr_fireservice_harpelement", { event_mdown = private.get_harpelement }},
    { "spr_fireservice_key", { event_mdown = private.get_key }},
    { "spr_orchestrapit_fragment_1", { event_mdown = private.get_fragment_1 }},
    { "spr_orchestrapit_tokenfragment_1", { event_mdown = private.get_tokenfragment_1 }},
    { "vid_hall_elf_1", { event_mdown = private.get_elf_1 }},
    { "obj_armchair_clk_boards", { event_mdown = private.clk_boards }},
    { "obj_armchair_clk_boards_1", { event_mdown = private.clk_boards_1 }},
    { "obj_armchair_clk_boards_2", { event_mdown = private.clk_boards_2 }},
    { "obj_orchestrapit_clk_rope", { event_mdown = private.clk_rope }},
    { "obj_hall_dlg_calling",       { event_mdown = private.dlg_hall_calling }},
    { "obj_fireservice_use_coin", { event_mdown = private.clk_fireextinguisher }},
    { "obj_armchair_use_tokenmt", { event_mdown = private.clk_door_tokenmt }},
    { "obj_armchair_use_wrench", { event_mdown = private.clk_door_wrench}},
    { "obj_orchestrapit_use_tweezers", { event_mdown = private.clk_tokenmt }},
    { "obj_fireservice_use_trebleclef", { event_mdown = private.clk_door_1 }},
    { "obj_fireservice_use_note", { event_mdown = private.clk_door_2 }},
    { "obj_fireservice_use_knife", { event_mdown = private.clk_rope_xx }},
    { "obj_fireservice_clk_brush_1", { event_mdown = private.clk_brush_1 }},
    { "obj_fireservice_clk_brush_2", { event_mdown = private.clk_brush_2 }},
    { "obj_armchair_bag_clk", { event_mdown = private.clk_bag }},
    { "spr_armchair_bag_open_photo", { event_mdown = function () common_impl.NoteScale( "open", "spr_armchair_bag_open_photo" ) end }},    
    { "spr_armchair_bag_open_photo_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_armchair_bag_open_photo" ); common_impl.ShowBbt( 'bbt_armchair_photo', 1 ); end } },
    { "spr_armchair_bag_open_ticket", { event_mdown = function () common_impl.NoteScale( "open", "spr_armchair_bag_open_ticket" ) end }},    
    { "spr_armchair_bag_open_ticket_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_armchair_bag_open_ticket" ); common_impl.ShowBbt( 'bbt_hall_armchair_ticket', 1 ); end } },
    { "spr_orchestrapit_map", { event_mdown = private.get_map }},
    { "spr_armchair_round_1", { event_mdown = function () private.mmg_clk( 1 );    end;  }},
    { "spr_armchair_round_2", { event_mdown = function () private.mmg_clk( 2 );    end;  }},
    { "spr_armchair_round_3", { event_mdown = function () private.mmg_clk( 3 );    end;  }},
    { "spr_hall_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_hall_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_armchair_collect_2", { event_mdown = function () private.get_collect_2_1_8(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  
    --ObjSet("spr_armchair_round_1", { ang = private.radian[2]});
    ----ObjSet("spr_armchair_round_2", { ang = private.radian[4]});
    ----ObjSet("spr_armchair_round_3", { ang = private.radian[2]});
    --ObjSet("spr_armchair_round_2", { ang = private.radian[1]});
    --ObjSet("spr_armchair_round_3", { ang = private.radian[4]});
    
    --ObjSet("spr_armchair_round_3", { ang = private.radian[4]});
    --ObjSet("spr_armchair_round_2", { ang = private.radian[1]});
    --ObjSet("spr_armchair_round_1", { ang = private.radian[2]});
    
    ObjSet("spr_armchair_round_3", { ang = private.radian[3]});
    ObjSet("spr_armchair_round_2", { ang = private.radian[4]});
    ObjSet("spr_armchair_round_1", { ang = private.radian[7]});
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_hall_orchestra",
    "gzz_hall_armchair",
    "gzz_hall_fireservice",
    "gzz_hall_orchestrapit"
  };

  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_armchair",
    "zz_fireservice",
    "zz_orchestrapit"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall", update_game_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall = function ()

  local effects_table = 
  {
    "spr_hall_light",
    "spr_hall_light_2",
    "anm_hall_sparks",
    "spr_orchestrapit_light_add",
    "spr_armchair_light_add"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall", update_performance_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_map = function ()

    common_impl.VisitMapRoom( "hall" );
    
  end;
  cmn.AddSubscriber( "opn_hall", opn_hall_map );
  local beg_level1 = function ()

    ObjSet( "obj_int_button_map_button", { input = false } );
    ObjSet( "spr_int_button_map_button", { alp = 0 } );
    
  end;
  cmn.AddSubscriber( "beg_level1", beg_level1 );  

  --------------------------------------------------------------------------------------------
  -- function see_intro () end;
  --------------------------------------------------------------------------------------------
  local see_intro = function ()

    ObjDelete("anm_hall_avenger");
    ObjMultiSet({ 
      { "rm_hall", { color_r = 1, color_g = 1, color_b = 1 }}  
    });

  end;

  cmn.AddSubscriber( "see_intro", see_intro, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_map () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_map" ] = {
    type = "get",
    get_obj = "spr_orchestrapit_map",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
    
  local get_map_inv = function ()
  
    ObjDelete( "spr_orchestrapit_map" );
    ObjDelete( "spr_hall_orchestrapit_map" );
    ObjSet( "obj_int_button_map_button", { input = true } );
    ObjSet( "spr_int_button_map_button", { alp = 1 } );

  end;
  
  local get_map_closezz = function ()
  
    ObjDelete( "gfx_orchestrapit_map" );
    ObjDelete( "spr_orchestrapit_map_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_map", get_map_inv );
  cmn.AddSubscriber( "get_map_inv", get_map_inv );
  cmn.AddSubscriber( "get_map", get_map_closezz, private.room_objname );
  cmn.AddSubscriber( "get_map_closezz", get_map_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers" ] = {
    type = "get",
    get_obj = "spr_armchair_tweezers",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
    
  local get_tweezers_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers", "spr_armchair_tweezers" );
  
  end;
  
  local get_tweezers_closezz = function ()
  
    ObjDelete( "gfx_armchair_tweezers" );
    ObjDelete("spr_armchair_tweezers_shadow");
  
  end;
  
  cmn.AddSubscriber( "get_tweezers", get_tweezers_inv );
  cmn.AddSubscriber( "get_tweezers", get_tweezers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tokenfragment_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tokenfragment_2" ] = {
    type = "get",
    get_obj = "spr_armchair_tokenfragment_2",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
    
  local get_tokenfragment_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_tokenfragment_2", "spr_armchair_tokenfragment_2" );
    ObjSet("spr_brokentokenmt_plus_light", { alp = 1 });
  end;
  
  local get_tokenfragment_2_closezz = function ()
  
    ObjDelete( "gfx_armchair_tokenfragment_2" );
  
  end;
  
  cmn.AddSubscriber( "get_tokenfragment_2", get_tokenfragment_2_inv );
  cmn.AddSubscriber( "get_tokenfragment_2", get_tokenfragment_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knife" ] = {
    type = "get",
    get_obj = "spr_armchair_knife",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
    
  local get_knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_knife", "spr_armchair_knife" );
  
  end;
  
  local get_knife_closezz = function ()
  
    ObjDelete( "gfx_armchair_knife" );
    ObjDelete( "spr_armchair_knife_shadow" );
    ObjDelete( "spr_hall_knife" );
    if ( cmn.IsEventDone( "get_device" )) then

      ObjSet( "obj_armchair_crop", { input = true } );
      ObjSet( "obj_armchair_use_wrench", { input = true } );
      

    end;
  
  end;
  
  cmn.AddSubscriber( "get_knife", get_knife_inv );
  cmn.AddSubscriber( "get_knife", get_knife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_device () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_device" ] = {
    type = "get",
    get_obj = "spr_armchair_device",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
    
  local get_device_inv = function ()
  
    interface.InventoryItemAdd( "inv_device", "spr_armchair_device" );
    ObjSet("inv_device", { drag = false });
    
  end;
  
  local get_device_closezz = function ()
  
    ObjDelete( "gfx_armchair_device" );
    ObjDelete( "spr_armchair_device_shadow" );
    ObjDelete( "spr_hall_apparat" );
    if ( cmn.IsEventDone( "get_knife" )) then

      ObjSet( "obj_armchair_crop", { input = true } );
      ObjSet( "obj_armchair_use_wrench", { input = true } );
      

    end;
  
  end;
  
  cmn.AddSubscriber( "get_device", get_device_inv );
  cmn.AddSubscriber( "get_device", get_device_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_picklock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_picklock" ] = {
    type = "get",
    get_obj = "spr_armchair_picklock",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
    
  local get_picklock_inv = function ()
  
    interface.InventoryItemAdd( "inv_picklock", "spr_armchair_picklock" );
  
  end;
  
  local get_picklock_closezz = function ()
  
    if common_impl.IsGetCollect( "get_collect_2_1_8" ) then
  
      ObjDelete( "gfx_armchair_picklock" );
      ObjDelete( "gzz_hall_armchair" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_picklock", get_picklock_inv );
  cmn.AddSubscriber( "get_picklock", get_picklock_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_8 = function ()
 
    ObjDelete( "spr_armchair_collect_2" );

    if cmn.IsEventDone( "get_picklock" ) then
      ObjDelete( "gzz_hall_armchair" );
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_8", get_collect_2_1_8, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokentokenmt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokentokenmt" ] = {
    type = "get",
    get_obj = "spr_fireservice_brokentokenmt",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
    
  local get_brokentokenmt_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokentokenmt", "spr_fireservice_brokentokenmt" );
    ObjSet( "inv_brokentokenmt", { drag = false });

  end;
  
  local get_brokentokenmt_closezz = function ()
  
    ObjDelete( "gfx_fireservice_brokentokenmt" );
    ObjDelete( "spr_fireservice_brokentokenmt_shadow" );
    ObjDelete( "spr_fireservice_brokentokenmt_over" );
    if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_harpelement") 
    and cmn.IsEventDone("get_key") and cmn.IsEventDone("get_rope") ) then
      ObjDelete( "gzz_hall_fireservice" );
    end;

  end;
  
  cmn.AddSubscriber( "get_brokentokenmt", get_brokentokenmt_inv );
  cmn.AddSubscriber( "get_brokentokenmt", get_brokentokenmt_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope" ] = {
    type = "get",
    get_obj = "spr_fireservice_rope",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
    
  local get_rope_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope", "spr_fireservice_rope" );
  
  end;
  
  local get_rope_closezz = function ()
  
    ObjDelete( "gfx_fireservice_rope" );
    ObjDelete( "spr_fireservice_rope_shadow" );
    if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_harpelement") 
    and cmn.IsEventDone("get_key") and cmn.IsEventDone("get_brokentokenmt") ) then
      ObjDelete( "gzz_hall_fireservice" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_rope", get_rope_inv );
  cmn.AddSubscriber( "get_rope", get_rope_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fireextinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fireextinguisher" ] = {
    type = "get",
    get_obj = "spr_fireservice_fireextinguisher",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
    
  local get_fireextinguisher_inv = function ()
  
    interface.InventoryItemAdd( "inv_fireextinguisher", "spr_fireservice_fireextinguisher" );
  
  end;
  
  local get_fireextinguisher_closezz = function ()
  
    ObjDelete( "gfx_fireservice_fireextinguisher" );
    ObjDelete( "spr_fireservice_fireextinguisher_shadow" );
    ObjDelete( "spr_fireservice_close" );
    
    ObjSet( "spr_fireservice_fireextinguisher_open", { alp = 1 } );
    ObjSet( "obj_fireservice_use_note", { input = true } );
    ObjSet( "obj_fireservice_use_trebleclef", { input = true } );
  
    ObjDelete( "spr_hall_fireservice_extinguisher" );
    ObjDelete( "spr_hall_fireservice_extinguisher_over" );
    
  end;
  
  cmn.AddSubscriber( "get_fireextinguisher", get_fireextinguisher_inv );
  cmn.AddSubscriber( "get_fireextinguisher", get_fireextinguisher_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_harpelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_harpelement" ] = {
    type = "get",
    get_obj = "spr_fireservice_harpelement",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
    
  local get_harpelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_harpelement", "spr_fireservice_harpelement" );
  
  end;
  
  local get_harpelement_closezz = function ()
  
    ObjDelete( "gfx_fireservice_harpelement" );
    ObjDelete( "spr_hall_fireservice_element" );
    if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_rope") 
    and cmn.IsEventDone("get_key") and cmn.IsEventDone("get_brokentokenmt") ) then
      ObjDelete( "gzz_hall_fireservice" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_harpelement", get_harpelement_inv );
  cmn.AddSubscriber( "get_harpelement", get_harpelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key" ] = {
    type = "get",
    get_obj = "spr_fireservice_key",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
    
  local get_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_key", "spr_fireservice_key" );
  
  end;
  
  local get_key_closezz = function ()
  
    ObjDelete( "gfx_fireservice_key" );
    ObjDelete( "spr_hall_fireservice_key" );
    ObjDelete( "spr_fireservice_key_shadow" );
    ObjDelete( "spr_fireservice_key_over" );
    if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_rope") 
    and cmn.IsEventDone("get_harpelement") and cmn.IsEventDone("get_brokentokenmt") ) then
      ObjDelete( "gzz_hall_fireservice" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_key", get_key_inv );
  cmn.AddSubscriber( "get_key", get_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fragment_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fragment_1" ] = {
    type = "get",
    get_obj = "spr_orchestrapit_fragment_1",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
    
  local get_fragment_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_fragment_1", "spr_orchestrapit_fragment_1" );
  
  end;
  
  local get_fragment_1_closezz = function ()
  
    ObjDelete( "gfx_orchestrapit_fragment_1" );
    ObjDelete( "spr_hall_orchestrapit_fragment_1" );
  
  end;
  
  cmn.AddSubscriber( "get_fragment_1", get_fragment_1_inv );
  cmn.AddSubscriber( "get_fragment_1", get_fragment_1_closezz, private.room_objname );
  ------------------------------------------------------------------------------------------
  --function get_tokenfragment_1 () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tokenfragment_1" ] = {
    type = "get",
    get_obj = "spr_orchestrapit_tokenfragment_1",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
    
  local get_tokenfragment_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_tokenfragment_1", "spr_orchestrapit_tokenfragment_1" );
    ObjSet("spr_brokentokenmt_plus_light", { alp = 1 });
  
  end;
  
  local get_tokenfragment_1_closezz = function ()
  
    ObjDelete( "spr_hall_orchestrapit_tokenfragment_1" );
    ObjDelete( "gfx_orchestrapit_tokenfragment_1" );
  
  end;
  
  cmn.AddSubscriber( "get_tokenfragment_1", get_tokenfragment_1_inv );
  cmn.AddSubscriber( "get_tokenfragment_1", get_tokenfragment_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_elf_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_elf_1" ] = {
    type = "get",
    get_obj = "vid_hall_elf_1",
    room = private.room_objname
  };
    
  local get_elf_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_elf_1", "vid_hall_elf_1", nil, "video" );
  
  end;
  
  local get_elf_1_closezz = function ()
  
    ObjDelete( "vid_hall_elf_1_shadow" );
    ObjDelete( "gfx_hall_elf_1" );
  
  end;
  
  cmn.AddSubscriber( "get_elf_1", get_elf_1_inv );
  cmn.AddSubscriber( "get_elf_1", get_elf_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_1 = function ()
  
    ObjDelete( "obj_hall_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_1", get_collect_item_1_1, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_1 = function ()
  
    ObjDelete( "obj_hall_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_1", get_collect_morph_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_1" ] = {
    type = "use",
    inv_obj = "inv_elf_1",
    use_place = "obj_armchair_use_elf_1",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local use_elf_1_inv = function ()
  end;
  local use_elf_1_beg = function ()
  
    ObjDelete( "obj_armchair_use_elf_1" );
  
  end;
  local use_elf_1_end = function ()
  
    ObjSet( "spr_armchair_tokenfragment_2", { input = true, active = true, alp = 1 } );
    ObjDelete( "spr_armchair_tokenfragment" );
    ObjDelete( "tmr_armchair_tutorial" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_1", use_elf_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_1", use_elf_1_inv );
  cmn.AddSubscriber( "use_elf_1", use_elf_1_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_1_inv", use_elf_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_1_beg", use_elf_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_1_end", use_elf_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tokenmt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tokenmt" ] = {
    type = "use",
    inv_obj = "inv_tokenmt",
    use_place = "obj_armchair_use_tokenmt",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local use_tokenmt_inv = function ()
  
    interface.InventoryItemRemove( "inv_tokenmt" );
  
  end;
  local use_tokenmt_beg = function ()
  
    ObjDelete( "obj_armchair_use_tokenmt" );
   
  
  end;
  local use_tokenmt_end = function ()
  
  --ObjSet("spr_armchair_door_over_2", { alp = 1 });
  --ObjSet( "spr_armchair_door_2", { alp = 1 });
    ObjSet( "obj_armchair_mmg", { input = true, alp = 1});
    ObjDelete("obj_armchair_door");
    ObjSet("spr_armchair_door_over", { alp = 0 });
    ObjSet( "obj_armchair_bag", {pos_z = 0} );
    
    --ObjSet( "spr_armchair_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tokenmt", use_tokenmt_beg, private.room_objname );
  cmn.AddSubscriber( "use_tokenmt", use_tokenmt_inv );
  cmn.AddSubscriber( "use_tokenmt", use_tokenmt_end, private.room_objname );
  cmn.AddSubscriber( "use_tokenmt_inv", use_tokenmt_inv, private.room_objname );
  cmn.AddSubscriber( "use_tokenmt_beg", use_tokenmt_beg, private.room_objname );
  cmn.AddSubscriber( "use_tokenmt_end", use_tokenmt_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench" ] = {
    type = "use",
    inv_obj = "inv_wrench",
    use_place = "obj_armchair_use_wrench",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local use_wrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench" );
  
  end;
  local use_wrench_beg = function ()
  
    ObjDelete( "obj_armchair_use_wrench" );
  
  end;
  local use_wrench_end = function ()
  
    ObjSet( "spr_armchair_picklock", { input = true, active = true } );
    ObjDelete( "spr_armchair_door_over_2" );
    ObjDelete( "spr_armchair_door_1" );
    ObjDelete( "spr_hall_door" );
    ObjSet( "obj_armchair_crop", { input = false });
    ObjDelete( "vid_armchair_use_wrench" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench", use_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench", use_wrench_inv );
  cmn.AddSubscriber( "use_wrench", use_wrench_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_inv", use_wrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_beg", use_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_end", use_wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife" ] = {
    type = "use",
    inv_obj = "inv_knife",
    use_place = "obj_fireservice_use_knife",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
  local use_knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_knife" );
  
  end;
  local use_knife_beg = function ()
  
    ObjDelete( "obj_fireservice_use_knife" );
  
  end;
  local use_knife_end = function ()
  
    ObjDelete( "anm_fireservice_knife" );
    ObjDelete( "anm_fireservice_rope" );
    ObjSet( "spr_fireservice_rope", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife", use_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife", use_knife_inv );
  cmn.AddSubscriber( "use_knife", use_knife_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_inv", use_knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_knife_beg", use_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_end", use_knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin" ] = {
    type = "use",
    inv_obj = "inv_coin",
    use_place = "obj_fireservice_use_coin",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
  local use_coin_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin" );
  
  end;
  local use_coin_beg = function ()
  
    ObjDelete( "obj_fireservice_use_coin" );
  
  end;
  local use_coin_end = function ()
  
    ObjDelete( "anm_fireservice_screw" );
    
    ObjSet( "spr_fireservice_fireextinguisher", { input = true } );
    ObjSet( "gfx_fireservice_fireextinguisher", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin", use_coin_inv );
  cmn.AddSubscriber( "use_coin", use_coin_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_inv", use_coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_beg", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_end", use_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_note () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_note" ] = {
    type = "use",
    inv_obj = "inv_note",
    use_place = "obj_fireservice_use_note",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
  local use_note_inv = function ()
  
    interface.InventoryItemRemove( "inv_note" );
  
  end;
  local use_note_beg = function ()
  
    ObjDelete( "obj_fireservice_use_note" );
  
  end;
  local use_note_end = function ()
  
    ObjDelete( "spr_fireservice_door_2" );
    ObjSet( "spr_fireservice_open_2", { alp = 1 } );
    ObjSet( "spr_fireservice_harpelement", { input = true, active = true } );
    ObjDelete( "spr_hall_fireservice_door_2" );
    ObjSet( "spr_hall_fireservice_door_4", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_note", use_note_beg, private.room_objname );
  cmn.AddSubscriber( "use_note", use_note_inv );
  cmn.AddSubscriber( "use_note", use_note_end, private.room_objname );
  cmn.AddSubscriber( "use_note_inv", use_note_inv, private.room_objname );
  cmn.AddSubscriber( "use_note_beg", use_note_beg, private.room_objname );
  cmn.AddSubscriber( "use_note_end", use_note_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trebleclef () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trebleclef" ] = {
    type = "use",
    inv_obj = "inv_trebleclef",
    use_place = "obj_fireservice_use_trebleclef",
    room = private.room_objname,
    zz = "zz_fireservice",
    zz_gate = "gzz_hall_fireservice"
  };
  local use_trebleclef_inv = function ()
  
    interface.InventoryItemRemove( "inv_trebleclef" );
  
  end;
  local use_trebleclef_beg = function ()
  
    ObjDelete( "obj_fireservice_use_trebleclef" );
  
  end;
  local use_trebleclef_end = function ()
  
    ObjSet( "spr_fireservice_key", { input = true, active = true } );
    ObjSet( "spr_fireservice_open_1", { alp = 1 } );
    ObjDelete( "spr_fireservice_door_1" );
    ObjDelete( "spr_hall_fireservice_door_1" );
    ObjSet( "spr_hall_fireservice_door_3", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_beg, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_inv );
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_end, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_inv", use_trebleclef_inv, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_beg", use_trebleclef_beg, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_end", use_trebleclef_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers" ] = {
    type = "use",
    inv_obj = "inv_tweezers",
    use_place = "obj_orchestrapit_use_tweezers",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
  local use_tweezers_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers" );
  
  end;
  local use_tweezers_beg = function ()
  
    ObjDelete( "obj_orchestrapit_use_tweezers" );
  
  end;
  local use_tweezers_end = function ()
  
    ObjSet( "spr_orchestrapit_tokenfragment_1", { input = true, active = true, alp = 1 } );
    ObjDelete("anm_orchestrapit_use_tweezers");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_inv", use_tweezers_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_beg", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_end", use_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rope" ] = {
    type = "use",
    inv_obj = "inv_rope",
    use_place = "obj_orchestrapit_use_rope",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
  local use_rope_inv = function ()
  
    interface.InventoryItemRemove( "inv_rope" );
  
  end;
  local use_rope_beg = function ()
  
    ObjDelete( "obj_orchestrapit_use_rope" );
  
  end;
  local use_rope_end = function ()
  
    ObjSet("spr_orchestrapit_rope",{ alp = 1 });
    ObjSet("spr_hall_orchestrapit_rope_1",{ alp = 1 });
    ObjSet("obj_orchestrapit_clk_rope", { input = true, active = true});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rope", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope", use_rope_inv );
  cmn.AddSubscriber( "use_rope", use_rope_end, private.room_objname );
  cmn.AddSubscriber( "use_rope_inv", use_rope_inv, private.room_objname );
  cmn.AddSubscriber( "use_rope_beg", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope_end", use_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireextinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fireextinguisher" ] = {
    type = "use",
    inv_obj = "inv_fireextinguisher",
    use_place = "obj_hall_hellfire",
    room = private.room_objname
  };
  local use_fireextinguisher_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireextinguisher" );
  
  end;
  local use_fireextinguisher_beg = function ()
  
    ObjDelete( "obj_hall_hellfire" );
  
  end;
  local use_fireextinguisher_end = function ()
  
    ObjDelete( "vid_hall_fire" );
    ObjDelete( "vid_hall_fireextinguisher" );
    ObjDelete( "gzz_hall_hellfire" );
    ObjSet( "grm_hall_offstage", { input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_hall_offstage_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_inv );
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_end, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_inv", use_fireextinguisher_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_beg", use_fireextinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_end", use_fireextinguisher_end, private.room_objname );
  ------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_boards () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_boards" ] = {
    type = "click",
    use_place = "obj_armchair_clk_boards",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local clk_boards_beg = function ()
  
    ObjDelete( "obj_armchair_clk_boards" );
  
  end;
  local clk_boards_end = function ()
  
    ObjSet( "obj_armchair_clk_boards_1", { input = true, active = true });
    ObjDelete( "anm_armchair_parket_1" );
    ObjDelete( "anm_armchair_parket_6" );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boards", clk_boards_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards", clk_boards_end, private.room_objname );
  cmn.AddSubscriber( "clk_boards_beg", clk_boards_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards_end", clk_boards_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_boards_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_boards_2" ] = {
    type = "click",
    use_place = "obj_armchair_clk_boards_2",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local clk_boards_2_beg = function ()
  
  ObjDelete( "obj_armchair_clk_boards_2" );
  
  end;
  local clk_boards_2_end = function ()
  
    ObjSet( "obj_armchair_use_tokenmt", { input = true, active = true });
    ObjDelete( "obj_armchair_parket" );
    ObjDelete( "spr_hall_door_parket" );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boards_2", clk_boards_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards_2", clk_boards_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_boards_2_beg", clk_boards_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards_2_end", clk_boards_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_boards_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_boards_1" ] = {
    type = "click",
    use_place = "obj_armchair_clk_boards_1",
    room = private.room_objname,
    zz = "zz_armchair",
    zz_gate = "gzz_hall_armchair"
  };
  local clk_boards_1_beg = function ()
  
  ObjDelete( "obj_armchair_clk_boards_1" );
  
  end;
  local clk_boards_1_end = function ()
  
    ObjSet( "obj_armchair_clk_boards_2", { input = true, active = true });
    ObjDelete( "anm_armchair_parket_3" );
    ObjDelete( "anm_armchair_parket_4" );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boards_1", clk_boards_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards_1", clk_boards_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_boards_1_beg", clk_boards_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boards_1_end", clk_boards_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "clk_bag" ] = {
  --  type = "click",
  --  use_place = "obj_armchair_bag_clk",
  --  room = private.room_objname,
  --  zz = "zz_armchair",
  --  zz_gate = "gzz_hall_armchair"
  --};
  local clk_bag_beg = function ()
  
    ObjDelete( "obj_armchair_bag_clk" );
  
  end;
  local clk_bag_end = function ()
  
  --ObjSet( "obj_armchair_clk_photo", { input = true, active = true });
    ObjSet( "spr_armchair_bag_open", { alp = 1 });
    ObjSet( "spr_armchair_bag_open_photo", { alp = 1 });
    ObjSet( "spr_armchair_bag_open_ticket", { alp = 1, input = true  });
    

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bag", clk_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag", clk_bag_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_beg", clk_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_end", clk_bag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_rope" ] = {
    type = "click",
    use_place = "obj_orchestrapit_clk_rope",
    room = private.room_objname,
    zz = "zz_orchestrapit",
    zz_gate = "gzz_hall_orchestrapit"
  };
  local clk_rope_beg = function ()
  
    ObjDelete( "obj_orchestrapit_clk_rope" );
  
  end;
  local clk_rope_end = function ()
  
    ObjSet( "gho_hall_orchestra", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_hall_orchestrapit_rope_2", { alp = 1 } );
    ObjDelete( "spr_hall_orchestrapit_rope_1" );
    if( cmn.IsEventDone("get_map") ) then
      ObjDelete( "gzz_hall_orchestrapit" );
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_rope", clk_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rope", clk_rope_end, private.room_objname );
  cmn.AddSubscriber( "clk_rope_beg", clk_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rope_end", clk_rope_end, private.room_objname );
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --function dlg_hall_calling () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_hall_calling" ] = {

      type = "click",
      use_place = "obj_hall_dlg_calling",
      room = private.room_objname
  };
  local dlg_hall_calling_beg = function ()
  
    ObjDelete( "obj_hall_dlg_calling" );
    
  end;
  local dlg_hall_calling_end = function ()
  
    ObjDelete( "anm_hall_tablet" );
    ObjDelete( "anm_hall_tablet_2" );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_hall_calling", dlg_hall_calling_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_hall_calling", dlg_hall_calling_beg, private.room_objname  );
  cmn.AddSubscriber( "dlg_hall_calling_beg", dlg_hall_calling_beg, private.room_objname  );
  cmn.AddSubscriber( "dlg_hall_calling_end", dlg_hall_calling_end, private.room_objname  );

  --------------------------------------------------------------------------------------------
  -- function win_stash () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_stash" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_armchair_mmg",
    zz_gate = "gzz_hall_armchair",
    zz = "zz_armchair"

  };

  local win_stash = function ()

    if ( cmn.IsEventDone( "win_stash" ) ) then

      ObjSet( "spr_armchair_knife", { active = true, input = true });
      ObjSet( "spr_armchair_device", { active = true, input = true });
      ObjSet("spr_armchair_door_over_2", { alp = 1 });
      ObjSet("vid_armchair_use_wrench", { alp = 1 });
      ObjDelete("spr_armchair_door_2");
      ObjSet("obj_armchair_crop", { input = false });
      ObjDelete( "obj_armchair_mmg" );
      ObjDelete( "spr_hall_door_2" );
      ObjDelete( "anm_armchair_open" );
      ObjSet("spr_armchair_door_over", { alp = 1 });
      ObjSet( "obj_armchair_bag", { pos_z = 5 } );
    elseif   ( cmn.IsEventStart( "win_stash" ) )  then
          
         for i = 1, 4 do
          
           private.draw[i] = ng_global.progress["std"]["win_stash"].array[i];
            
         end;
          
         --ObjSet( "spr_armchair_round_1", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[1] ] });
         --ObjSet( "spr_armchair_round_4", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[2] ] });
         --ObjSet( "spr_armchair_round_2", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[3] ] });
         --ObjSet( "spr_armchair_round_3", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[4] ] });
         ObjSet( "spr_armchair_round_1", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[1] ] });
         ObjSet( "spr_armchair_round_2", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[2] ] });
         ObjSet( "spr_armchair_round_3", { ang = private.radian[ng_global.progress["std"]["win_stash"].array[3] ] });
         
      
       
    end;

  end;

  cmn.AddSubscriber( "win_stash", win_stash, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_orchestra () end;
  --------------------------------------------------------------------------------------------
  local win_orchestra = function ()

    if ( cmn.IsEventDone( "win_orchestra" ) ) then

      ObjDelete( "gho_hall_orchestra" )

    end;

  end;

  cmn.AddSubscriber( "win_orchestra", win_orchestra, private.room_objname );  

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

 subroom.Define( "zz_armchair" );
  
  
 subroom.Define( "zz_orchestrapit" );

  function zz_armchair.PreOpen()
    
    if cmn.IsEventDone( "use_elf_1" ) then

      ObjDelete("vid_armchair_use_elf");
      
    end;  
    if ( cmn.IsEventDone( "use_tokenmt" )) and not cmn.IsEventDone( "win_stash" ) then
    
      cmn.MiniGameShow( 'stash' );
      common_impl.PassingMgStart( "stash" );
      
      if ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_13" ].shown == 0 then
      
        common_impl.TutorialShow( "tutorial_page_13" );
        
      elseif ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_14" ].shown == 0 then
      
        common_impl.TutorialShow( "tutorial_page_14" );
        
      end;
      
    end;
    
    if ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_4" ].shown == 0 then
    
      common_impl.TutorialShow( "tutorial_page_4" );
      common_impl.TutorialSetShown( "tutorial_page_3" );
      
    elseif cmn.IsEventDone( "get_tweezers" ) and not cmn.IsEventDone( "use_elf_1" ) then
      
      interface.InventoryOpen();
      
      common_impl.TutorialShow( "tutorial_page_5" );
      
    elseif cmn.IsEventDone( "use_elf_1" ) and not cmn.IsEventDone( "get_tokenfragment_1" ) then
      
      common_impl.TutorialShow( "tutorial_page_6" );
      
    end;
    -- if cmn.IsEventDone( "clk_bag" ) then 
     
      if not common_impl.hall then

       common_impl.hall = {}
       common_impl.hall.note = "close";

      end;
    if cmn.IsEventDone( "clk_bag" ) then  
      
    if  ObjGet( "spr_armchair_bag_open_photo" ).input == true then

      ObjSet( "spr_armchair_bag_open_photo_big", { input = false, alp = 0 } );
      ObjSet( "spr_armchair_bag_open_photo",     { alp = 1 } );
      
    end;
    
     if  ObjGet( "spr_armchair_bag_open_ticket" ).input == true then

       ObjSet( "spr_armchair_bag_open_ticket_big", { input = false, alp = 0 } );
       ObjSet( "spr_armchair_bag_open_ticket",     { alp = 1 } );
      
    end;
    
   end;
  
  end;

  function zz_armchair.PreClose()

    if ( cmn.IsEventDone( "use_tokenmt" )) and not cmn.IsEventDone( "win_stash" ) then

      cmn.MiniGameHide( 'stash' );
      common_impl.PassingMgStop( "stash" );

    end;

  end;

  function zz_orchestrapit.Close()

    if  cmn.IsEventDone( "clk_rope" ) then

      ObjSet( "tmr_hall_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_orchestra' ) end } );
      
    end;

  end;
  
end;

--*********************************************************************************************************************
function public.Open()

  private.opn_hall();
  
  if cmn.IsEventDone( "dlg_hall_calling" ) then
  
    if ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_1" ].shown == 0 then
      
      common_impl.TutorialShow( "tutorial_page_1" );
    
    elseif ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_2" ].shown == 0 then

      common_impl.TutorialShow( "tutorial_page_2" );
      
    elseif ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_3" ].shown == 0 then
      
      common_impl.TutorialShow( "tutorial_page_3" );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();  

  if ( not cmn.IsEventDone( "see_intro" ) ) then

    ng_global.progress["std"]["opn_hall"].viewer = 0;
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( "rm_hall", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_hall_intro", private.room_objname);
    ObjSet( "tmr_hall_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  else

    common_impl.EnvPlay( { "common/audio/level1/aud_hall_env" }, "", 0.5 );
    
    if not cmn.IsEventDone( "use_fireextinguisher" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 1, "", 0 );
      
    else
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_after_fire_env", 1, "", 0 );
      
    end;

  end;
    
  if cmn.IsEventDone( "see_intro" ) then
    
    if ( ng_global.progress["std"]["opn_hall"].viewer < 4 ) then
      
      ng_global.progress["std"]["opn_hall"].viewer = ng_global.progress["std"]["opn_hall"].viewer + 1;
      
      if ng_global.progress["std"]["opn_hall"].viewer == 2 then
         
        interface.Lock( true, 3 );
        
        AnimPlay( "anm_hall_human", "DoAnim", function() common_impl.ShowBbt( 'bbt_hall_man' ); end );
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interactive_hall_man", 0, "", 0 );
        
      elseif ng_global.progress["std"]["opn_hall"].viewer == 4 then
        
        interface.Lock( true, 3 );
        
        local func_anim = function()
        
          common_impl.ShowBbt( 'bbt_hall_fat_man' );
          ObjSet("anm_hall_fat_man_1", { alp = 1, playing = true });
          ObjSet("anm_hall_fat_man_2", { alp = 0, playing = false });
          
          ObjSet( "obj_hall_clk_fat_man", { input = true } );
          
        end;
      
        ObjSet("anm_hall_fat_man_2", { alp = 1 });
        AnimPlay( "anm_hall_fat_man_2", "DoAnim", func_anim );
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interactive_hall_man_2", 0, "", 0 );
        
      end;
    
    else 
      
      ObjSet("anm_hall_fat_man_1", { alp = 1, playing = true });
      
      ObjSet( "obj_hall_clk_fat_man", { input = true } );
      
    end;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if not cmn.IsEventDone( "use_fireextinguisher" ) then
      
    common_impl.StopAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 0.5 );
    
  else
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_after_fire_env", 0.5 );
      
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_1()

  local item = "inv_elf_1";

  if ( common.ApplyObj( item, "obj_armchair_use_elf_1", true )  and (common_impl.hall.note == "close")) then

    cmn.CallEventHandler( "use_elf_1_inv" );
    cmn.CallEventHandler( "use_elf_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_1" );
      cmn.CallEventHandler( "use_elf_1_end" );
      interface.InventoryItemAdd( "inv_elf_1", "vid_armchair_use_elf", nil, "video" );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
      --common_impl.TutorialShow( "tutorial_page_6" );
   
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_armchair_elf", 0, "", 0 );

  ObjSet( "vid_armchair_use_elf", { pos_z = 4,  playing = true, endtrig = func_after });
  
  ObjSet( "tmr_armchair_tutorial", { time = 6.8, playing = true, endtrig = function() common_impl.TutorialShow( "tutorial_page_6" ); end } );
  
  interface.InventoryItemRemove( "inv_elf_1" ); 
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_armchair", false ) and not cmn.IsEventDone( "use_elf_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armchair", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tokenmt()

  local item = "inv_tokenmt";

  if ( common.ApplyObj( item, "obj_armchair_use_tokenmt", true ) and cmn.IsEventDone("clk_boards_2") and common_impl.hall.note == "close") then

    cmn.CallEventHandler( "use_tokenmt_inv" );
    cmn.CallEventHandler( "use_tokenmt_beg" );

    local func_after = function ()
  
    local func_end = function ()
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tokenmt" );
      cmn.CallEventHandler( "use_tokenmt_end" );
      cmn.MiniGameShow( "stash" );
      common_impl.PassingMgStart( "stash" );
      --ng_global.progress["std"]["win_stash"].array = { 2,1,4,2};
      ng_global.progress["std"]["win_stash"].array = {7, 4, 3 };
      
      common_impl.TutorialShow( "tutorial_page_13" );
      
    end;
    
     ObjSet( "obj_armchair_bag", { pos_z = 0 });
     ObjAnimate( "obj_armchair_mmg", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tokenmt_armchair", 0, "", 0 );
  
    ObjAnimate( "spr_armchair_token", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.9, 0, 1.0
      } );
    --ObjAnimate( "spr_armchair_door_2", "alp", 0, 0, "",
    --  { 
    --    0.0, 0, 0.0,
    --    0.3, 0, 0.0, 
    --    0.6, 0, 1.0
    --  } );
    ObjAttach("obj_armchair_door","obj_armchair_crop");
    ObjAnimate( "spr_armchair_door_flap_1", "pos_xy", 0, 0, func_after,
      { 
        0.0, 0, -97,-4,
        0.9, 0, -97,-4,
        1.6, 0, 29, -21,
        1.9, 0, 29, -21
      } );
     ObjAnimate( "spr_armchair_door_flap_2", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -163, 0,
        0.9, 0, -163, 0,
        1.6, 0, -317, 13,
        1.9, 0, -317, 13
      } );
     ObjAnimate( "spr_armchair_token", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -133, -5,
        0.9, 0, -133, -5,
        1.6, 0, -287, 8,
        1.9, 0, -287, 8
      } );
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_armchair", false ) and cmn.IsEventDone("clk_boards_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armchair", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wrench()

  local item = "inv_wrench";

  if ( common.ApplyObj( item, "obj_armchair_use_wrench", true ) and cmn.IsEventDone("get_knife") and cmn.IsEventDone( "get_device" )  and  (common_impl.hall.note == "close")) then

    cmn.CallEventHandler( "use_wrench_inv" );
    cmn.CallEventHandler( "use_wrench_beg" );
   
   local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_wrench" );
        cmn.CallEventHandler( "use_wrench_end" );
    --common.CloseSubRoom();;
    
      end;
  
    --ObjAnimate( "spr_armchair_door_over_2", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 0.0
    --} );
    --ObjAnimate( "spr_armchair_door_1", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 0.0
    --} );
    --ObjAttach( "spr_armchair_door_1", "obj_armchair_crop");
    ObjSet( "vid_armchair_use_wrench", { alp = 0 });
    ObjAnimate( "spr_armchair_door_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -61, 180,
      0.3, 0, -61, 180,
      0.9, 0, -268, 239
    } );
    
   end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_wrench_armchair", 0, "", 0 );
  --VidPlay( "vid_armchair_use_wrench", func_after );
  --ObjSet("spr_armchair_door_over_2", { pos_z = 5 });
  ObjSet( "vid_armchair_use_wrench", { playing = true, endtrig = func_after });
   --ObjAnimate( "spr_armchair_bolt_1", "alp", 0, 0, "",
   -- { 
   --   0.0, 0, 1.0, 
   --   0.3, 0, 0.0
   -- } );
   -- ObjAnimate( "spr_armchair_bolt_2", "alp", 0, 0, func_after,
   -- { 
   --   0.0, 0, 1.0, 
   --   0.3, 0, 0.0
   -- } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_armchair", false ) and cmn.IsEventDone("get_knife") and cmn.IsEventDone( "get_device" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armchair", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife()

  local item = "inv_knife";

  if ( common.ApplyObj( item, "obj_fireservice_use_knife", true ) ) then

    cmn.CallEventHandler( "use_knife_inv" );
    cmn.CallEventHandler( "use_knife_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_knife" );
      cmn.CallEventHandler( "use_knife_end" );
      private.get_rope();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_knife_fireservice", 0, "", 0 );
    ObjSet( "anm_fireservice_rope", { alp = 0 });
    ObjSet( "anm_fireservice_knife", { alp = 1 });
    AnimPlay("anm_fireservice_knife", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_fireservice", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireservice", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coin()

  local item = "inv_coin";

  if ( common.ApplyObj( item, "obj_fireservice_use_coin", true ) ) then

    cmn.CallEventHandler( "use_coin_inv" );
    cmn.CallEventHandler( "use_coin_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_coin" );
      cmn.CallEventHandler( "use_coin_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_coin_fireservice", 0, "", 0 );

    ObjSet( "anm_fireservice_screw", { alp = 1 });
    AnimPlay( "anm_fireservice_screw", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_fireservice", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireservice", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_note()

  local item = "inv_note";

  if ( common.ApplyObj( item, "obj_fireservice_use_note", true ) and cmn.IsEventDone( "get_fireextinguisher" )) then

    cmn.CallEventHandler( "use_note_inv" );
    cmn.CallEventHandler( "use_note_beg" );

    local func_after = function ()
    
    local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_note" );
        cmn.CallEventHandler( "use_note_end" );
        
      end;
     
       ObjAnimate( "spr_fireservice_door_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_fireservice_open_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_note_fireservice", 0, "", 0 );
    
    ObjAnimate( "spr_fireservice_note_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_fireservice", false ) and cmn.IsEventDone( "get_fireextinguisher" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireservice", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_trebleclef()

  local item = "inv_trebleclef";

  if ( common.ApplyObj( item, "obj_fireservice_use_trebleclef", true ) and cmn.IsEventDone( "get_fireextinguisher" )) then

    cmn.CallEventHandler( "use_trebleclef_inv" );
    cmn.CallEventHandler( "use_trebleclef_beg" );

    local func_after = function ()
    
      local func_end = function ()  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_trebleclef" );
        cmn.CallEventHandler( "use_trebleclef_end" );
      end;
      
      ObjAnimate( "spr_fireservice_open_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "spr_fireservice_door_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_trebleclef_fireservice", 0, "", 0 );
    
    ObjAnimate( "spr_fireservice_trebleclef", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_fireservice", false ) and cmn.IsEventDone( "get_fireextinguisher" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireservice", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers()

  local item = "inv_tweezers";

  if ( common.ApplyObj( item, "obj_orchestrapit_use_tweezers", true ) ) then

    cmn.CallEventHandler( "use_tweezers_inv" );
    cmn.CallEventHandler( "use_tweezers_beg" );

    local func_after = function ()
     
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tweezers" );
      cmn.CallEventHandler( "use_tweezers_end" );
      
      private.get_tokenfragment_1();

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tweezers_orchestrapit", 0, "", 0 );

    AnimPlay("anm_orchestrapit_use_tweezers", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_orchestrapit", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_orchestrapit", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rope()

  local item = "inv_rope";

  if ( common.ApplyObj( item, "obj_orchestrapit_use_rope", true ) and cmn.IsEventDone( "get_tokenfragment_1" ) 
    and cmn.IsEventDone( "get_fragment_1" ) and cmn.IsEventDone( "get_map" )) then

    cmn.CallEventHandler( "use_rope_inv" );
    cmn.CallEventHandler( "use_rope_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_rope" );
      cmn.CallEventHandler( "use_rope_end" );
      --common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_rope_orchestrapit", 0, "", 0 );
  
  ObjAnimate( "spr_orchestrapit_rope", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_orchestrapit", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_orchestrapit", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fireextinguisher()

  local item = "inv_fireextinguisher";

  if ( common.ApplyObj( item, "obj_hall_hellfire", false ) ) then

    cmn.CallEventHandler( "use_fireextinguisher_inv" );
    cmn.CallEventHandler( "use_fireextinguisher_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fireextinguisher" );
      cmn.CallEventHandler( "use_fireextinguisher_end" );
      common.CloseSubRoom();
      
      interface.KeyTaskDone( 'fire_out', true );
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_after_fire_env", 1, "", 0 );
    
    end;

    common_impl.Lock( true );
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 0.5 );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_fireextinguisher_hellfire", 0, "", 0 );
  
    ObjSet("vid_hall_fire", { active = false, alp = 0 });  
    ObjSet("vid_hall_fireextinguisher", { active = true, alp = 1 });
    VidPlay("vid_hall_fireextinguisher", func_after );
    
    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_tweezers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );
  
  interface.InventoryOpen();
  
  common_impl.TutorialShow( "tutorial_page_5" );

end;
--------------------------------------------------------------------------------------------
function private.get_tokenfragment_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tokenfragment_2" );
  cmn.CallEventHandler( "get_tokenfragment_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_knife()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_knife" );
  cmn.CallEventHandler( "get_knife" );

end;
--------------------------------------------------------------------------------------------
function private.get_device()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_device" );
  cmn.CallEventHandler( "get_device" );

end;
--------------------------------------------------------------------------------------------
function private.get_picklock()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_picklock" );
  cmn.CallEventHandler( "get_picklock" );
  
  if common_impl.IsGetCollect( "get_collect_2_1_8" ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_brokentokenmt()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokentokenmt" );
  cmn.CallEventHandler( "get_brokentokenmt" );

  if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_rope") 
  and cmn.IsEventDone("get_harpelement") and cmn.IsEventDone("get_key") ) then
    common.CloseSubRoom();
  end;
  
  common_impl.TutorialShow( "tutorial_page_10" );

end;
--------------------------------------------------------------------------------------------
function private.get_rope()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );

end;
--------------------------------------------------------------------------------------------
function private.get_fireextinguisher()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fireextinguisher" );
  cmn.CallEventHandler( "get_fireextinguisher" );

end;
--------------------------------------------------------------------------------------------
function private.get_harpelement()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  ObjSet("spr_fireservice_close", { alp = 0 }); 
  cmn.SetEventDone( "get_harpelement" );
  cmn.CallEventHandler( "get_harpelement" );

  if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_rope") 
  and cmn.IsEventDone("get_key") and cmn.IsEventDone("get_brokentokenmt") ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_key()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_key" );
  cmn.CallEventHandler( "get_key" );

  if ( cmn.IsEventDone("get_fireextinguisher") and cmn.IsEventDone("get_rope") 
  and cmn.IsEventDone("get_harpelement") and cmn.IsEventDone("get_brokentokenmt") ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_fragment_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fragment_1" );
  cmn.CallEventHandler( "get_fragment_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_tokenfragment_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tokenfragment_1" );
  cmn.CallEventHandler( "get_tokenfragment_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_elf_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_elf_1" );
  cmn.CallEventHandler( "get_elf_1" );
  
  common_impl.TutorialSetShown( "tutorial_page_2" );
  
  common_impl.TutorialShow( "tutorial_page_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_map()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_map", 0, "", 0 );
  local func_after = function()

    common_impl.Lock( false );
    cmn.SetEventDone( "get_map" );
    cmn.CallEventHandler( "get_map_inv" );


  end;

    common_impl.Lock( true );
    cmn.CallEventHandler( "get_map_closezz" );
    ObjSet( "spr_orchestrapit_map", { input = false } );
    local item_name = "spr_orchestrapit_map";
    local start_pos = GetObjPosByObj( item_name );
    ObjAttach( item_name, "ng_interface_transporter" );
    local end_pos = GetObjPosByObj( "spr_int_button_map_button" );
    ObjAnimate( item_name, "pos_xy", 0, 0, "",
    { 
      0.0, 1, start_pos[1],start_pos[2], 
      1.0, 1, end_pos[1],end_pos[2]
    } );
    ObjAnimate( item_name, "scale_xy", 0, 0, func_after,
    { 
      0.0, 1, 1,1,
      0.7, 1, 1,1,
      1.0, 1, 0,0
    } );


end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_8()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_8");
    cmn.CallEventHandler("get_collect_2_1_8");

    if cmn.IsEventDone( "get_picklock" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_armchair_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_rope_xx()
  
  local func_after = function ()
  
      common_impl.Lock( false );
    
  end;
    
  common_impl.ShowBbt( 'bbt_fireservice_use_knife' );
  common_impl.Lock( true );
  AnimPlay("anm_fireservice_rope", "DoAnim", func_after );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_decor_fireservice", 0, "", 0 );
    
end;
--------------------------------------------------------------------------------------------
function private.mmg_clk(num)
  local mem = 0;
  local mem_1 = 0;
  local  num_1 = 0;
  
  if num == 2 then
    
  local func_after = function()

          common_impl.Lock( false );
        
        if ( mem ~= 8 ) then
         
             private.draw[num] = private.draw[num] + 1;          
           
         else  
         
            private.draw[num] = 1;
         
        end;
    
          local count = 0;

          for  i = 1, 3 do  
           
            if   1 == ng_global.progress["std"]["win_stash"].array[i] then

                 count = count + 1;
   
            end;

          end;

             if ( count == 2 ) and ( 1 == private.draw[num] ) then
               
               private.win_stash();

               else

                 ng_global.progress["std"]["win_stash"].array[num] = private.draw[num];
                 

               end;
               
  end;
    
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_armchair_rotate", 0, "", 0.5 );
  
  mem = private.draw[num];

  common_impl.Lock( true );
    
  ObjAnimate("spr_armchair_round_"..num,  "ang", 0,0, func_after,

    { 0.0,0,private.radian[mem],
      0.3,0,private.radian[mem + 1]
    });
    
  else
    
   
  local func_after_2 = function()

        common_impl.Lock( false );
        if mem_1 == 1 then 
        ObjSet("spr_armchair_round_"..num_1, { ang = 5.49778714});
        end;
        if ( mem ~= 8 ) then
         
             private.draw[num] = private.draw[num] + 1;          
           
         else  
         
            private.draw[num] = 1;
         
        end;
          
          if ( mem_1 ~= 1 ) then
         
         
          private.draw[num_1] = private.draw[num_1] - 1 ;          
           
         else  
         
          private.draw[num_1] = 8;
         
        end;  
           
          local count = 0;
          
          for  i = 1, 3 do  
           
            if  1 == ng_global.progress["std"]["win_stash"].array[i] then

                 count = count + 1;
   
            end;

          end;
             
             -- if ( count > 2 ) and ( ng_global.progress["std"]["win_stash"].array[4] == private.draw[num] ) and ( ng_global.progress["std"]["win_stash"].array[4] == private.draw[num_1] ) then
             if count == 1 and private.draw[num] == 1 and private.draw[num_1] == 1 then         
               private.win_stash();

               else

                 ng_global.progress["std"]["win_stash"].array[num] = private.draw[num];
                 ng_global.progress["std"]["win_stash"].array[num_1] = private.draw[num_1];
                 

               end;


  

  end;  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_armchair_rotate", 0, "", 0.5 );
  
  mem = private.draw[num];
  
  if num == 1 then
    
   num_1 = 3;
   
   else
   
   num_1 = 1;
     
  end;  
   
  mem_1 = private.draw[num_1];
  
  common_impl.Lock( true );
    
  ObjAnimate("spr_armchair_round_"..num,  "ang", 0,0, func_after_2,

    {
      0.0,0,private.radian[mem],
      0.3,0,private.radian[mem + 1]
    });  
  if mem_1 ~= 1 then  
  ObjAnimate("spr_armchair_round_"..num_1,  "ang", 0,0, "",

    {
      0.0,0,private.radian[mem_1],
      0.3,0,private.radian[mem_1 - 1]
    }) 
  else
  ObjAnimate("spr_armchair_round_"..num_1,  "ang", 0,0, "",

    {
      0.0,0,0,
      0.3,0, - 0.785398163
    }) 
  end; 
  end; 
 end;
------------------------------------------------------------------------------
function private.clk_boards()

  cmn.CallEventHandler( "clk_boards_beg" );

  local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_boards" );
      cmn.CallEventHandler( "clk_boards_end" );
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_boards_armchair", 0, "", 0 );

  AnimPlay( "anm_armchair_parket_1", "DoAnim", "" );
  AnimPlay( "anm_armchair_parket_6", "DoAnim", func_after );
--  ObjAnimate("spr_armchair_parket_1",  "alp", 0, 0, func_after,
--
--  { 
--    0.0, 0, 1.0,
--    0.3, 0, 0.0
--    
--  }); 
  

end;
--------------------------------------------------------------------------------------------
function private.clk_boards_1()

  cmn.CallEventHandler( "clk_boards_1_beg" );

  local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_boards_1" );
      cmn.CallEventHandler( "clk_boards_1_end" );
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_boards_armchair", 0, "", 0 );

  AnimPlay( "anm_armchair_parket_3", "DoAnim", "" );
  AnimPlay( "anm_armchair_parket_4", "DoAnim", func_after );
--  ObjAnimate("spr_armchair_parket_2",  "alp", 0, 0, func_after,
--
--  { 
--    0.0, 0, 1.0,
--    0.3, 0, 0.0
--    
--  }); 
  

end;
--------------------------------------------------------------------------------------------
function private.clk_boards_2()

  cmn.CallEventHandler( "clk_boards_2_beg" );

  local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_boards_2" );
      cmn.CallEventHandler( "clk_boards_2_end" );
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_boards_armchair", 0, "", 0 );

  AnimPlay( "anm_armchair_parket_5", "DoAnim", "" );
  AnimPlay( "anm_armchair_parket_2", "DoAnim", func_after );
--  ObjAnimate("spr_armchair_parket_3",  "alp", 0, 0, func_after,
--
--  { 
--    0.0, 0, 1.0,
--    0.3, 0, 0.0
--    
--  }); 
  

end;
--------------------------------------------------------------------------------------------
function private.clk_door_tokenmt()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_armchair_use_tokenmt' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_door_armchair", 0, "", 0 );
  
  ObjAnimate( "obj_armchair_door", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 189, 
    0.3, 0, 187,
    0.6, 0, 189
  } );
  
end;  
function private.clk_tokenmt()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_orchestrapit_use_tweezers' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_fragment_orchestrapit", 0, "", 0 );
  
  ObjAnimate( "anm_orchestrapit_use_tweezers", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, -2,
    0.6, 0, 0
  } );
   ObjAnimate( "spr_orchestrapit_fragment_over", "pos_x", 0, 0, "",
  { 
    0.0, 0, 103, 
    0.3, 0, 101,
    0.6, 0, 103
  } );
  
end;  
---------------------------------------------------------------------------------------------
function private.clk_door_wrench()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_armchair_use_wrench' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_touch_latch_armchair", 0, "", 0 );
  
  ObjAnimate( "spr_armchair_door_1", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 180, 
    0.3, 0, 181,
    0.6, 0, 180
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_door_1()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_fireservice_use_trebleclef' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_door_fireservice", 0, "", 0 );
  
  ObjAnimate( "spr_fireservice_door_1", "scale_x", 0, 0,"",
  { 
    0.0, 0, 1, 
    0.3, 0, 0.98,
    0.6, 0, 1
  } );
  ObjAnimate( "spr_fireservice_door_1", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, -9, 
    0.3, 0, -10,
    0.6, 0, -9
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_door_2()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_fireservice_use_note' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_door_fireservice", 0, "", 0 );
  
  ObjAnimate( "spr_fireservice_door_2", "scale_x", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.3, 0, 0.98,
    0.6, 0, 1
  } );
  ObjAnimate( "spr_fireservice_door_2", "pos_x", 0, 0, "",
  { 
    0.0, 0, -11, 
    0.3, 0, -12,
    0.6, 0, -11
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_fireextinguisher()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_fireservice_use_coin' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_fireextinguisher_fireservice", 0, "", 0 );
  
  ObjAnimate( "spr_fireservice_fireextinguisher", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 21, 
    0.3, 0, 18,
    0.6, 0, 21
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_brush_1()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_garter_fireservice", 0, "", 0 );
  
  AnimPlay( "anm_fireservice_brush_1", "DoAnim", func_after )
  
end;
--------------------------------------------------------------------------------------------
function private.clk_brush_2()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_garter_fireservice", 0, "", 0 );
  AnimPlay( "anm_fireservice_brush_2", "DoAnim", func_after )
  
end;
-------------------------------------------------------------------------------------------
function private.clk_rope()

  cmn.CallEventHandler( "clk_rope_beg" );
  local func_end = function()
  
    local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "clk_rope" );
        cmn.CallEventHandler( "clk_rope_end" );
        common.CloseSubRoom();
      
    end;
      
    ObjSet( "tmr_hall_zoom", { playing = true, time = 1, endtrig = function() common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 ); end  } );
    ObjSet("spr_orchestrapit_back_zoom", { alp = 1})
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

    ObjAnimate( "spr_orchestrapit_back_zoom", "scale_xy", 0, 0, func_after, 
    { 
      0.0, 1, 1, 1,
      1.0, 1, 1.4, 1.4
    } ); 
      
  end;    
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_rope_orchestrapit", 0, "", 0 );
  
  ObjAnimate( "spr_orchestrapit_rope", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
    
  ObjAnimate( "spr_orchestrapit_rope_1", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;  
-------------------------------------------------------------------------------
function private.clk_bag()
  
    cmn.CallEventHandler( "clk_bag_beg" );
    local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "clk_bag" );
        cmn.CallEventHandler( "clk_bag_end" );
      
    end;
      
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_bag_armchair", 0, "", 0 );
  
  ObjAnimate( "spr_armchair_bag_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  ObjAnimate( "spr_armchair_bag_open_photo", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  ObjAnimate( "spr_armchair_bag_open_ticket", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  
end;  

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.MouseEnterAnim( number )

  SetCursor( CURSOR_HAND );

  local obj = "spr_armchair_round_"..number.."_add";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.2;
  --local alp2 = ObjGet( obj ).alp;

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_armchair_enter", 0, "", 0.5 );
 
  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
----------------------------------------------------------------------------------
function private.MouseLeaveAnim( number )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_armchair_round_"..number.."_add";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.2;
  

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 0
  } );
 

end;
---------------------------------------------------------------------------------------
function  private.skip_stash()

  local func_after = function() private.win_stash() end;
  common_impl.Lock( true );

  for i = 1,3 do

      ObjAnimate( "spr_armchair_round_"..i, "ang", 0, 0, func_after, 
      {
        0.0,0,ObjGet( "spr_armchair_round_"..i ).ang,
        0.3,0,0.0
      });
      func_after  = "";

    end;

end;

function  private.win_stash()

  local func_after = function ()
  
    local func_end = function ()
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  
    common_impl.Lock( false );
    cmn.MiniGameHide( "stash" );
    common_impl.PassingMgWin( "stash" );
    cmn.SetEventDone( "win_stash" );
    cmn.CallEventHandler( "win_stash" );
    
    end;
    AnimPlay( "anm_armchair_open", "DoAnim", func_end);
    ObjSet("obj_armchair_bag", { pos_z = 5});
    ObjAnimate( "spr_armchair_door_over_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,
      0.5, 0, 1.0,
    } );
    ObjAnimate( "vid_armchair_use_wrench", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,
      0.5, 0, 1.0,
    } );
    ObjAnimate( "spr_armchair_door_over", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,
      0.5, 0, 1.0,
    } );
    
  end;
 
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_armchair_win", 0, "", 0.5 );

  common_impl.Lock( true );
  ObjAnimate( "obj_armchair_mmg", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0,
      0.0, 0, 1.0, 
      1.3, 0, 0.0
    } );
   
  --ObjAnimate( "spr_armchair_door_2", "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 1.0,
  --    1.3, 0, 1.0,
  --    1.6, 0, 0.0
  --  } );
  --ObjAnimate( "spr_armchair_door_2", "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 1.0,
  --    0.3, 0, 0.0
  --  } );
  --ObjAnimate( "spr_armchair_door_2", "pos_xy", 0, 0, func_after,
  --  { 
  --   0.0, 0, -63,182,
  --   1.0, 0, -63,182,
  --   1.6, 0, -300, 204
  --  } );
    
  --ObjAnimate( "spr_armchair_door_over_2", "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 0.0,
  --    0.3, 0, 1.0
  --  } );
  --ObjAnimate( "vid_armchair_use_wrench", "alp", 0, 0, "",
  --  { 
  --    0.0, 0, 0.0,
  --    0.3, 0, 1.0
  --  } );  
  ObjAnimate( "spr_armchair_mmg_start_token", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.3, 0, 0.0
    } );  

end;
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_stash" then
      
      private.skip_stash();

  end;

end;
--*********************************************************************************************************************
function public.Reset( name )

  if name == "win_stash" then
    
    --private.draw = {2,1,4,2};
    private.draw = {7, 4, 3}
    for i = 1, 3 do
    
      ng_global.progress["std"]["win_stash"].array[i] = private.draw[i];
      
    end;

    ObjSet("spr_armchair_round_1", { ang = private.radian[7]});
   
    --ObjSet("spr_armchair_round_2", { ang = private.radian[4] });
    --ObjSet("spr_armchair_round_3", { ang = private.radian[2] });
    ObjSet("spr_armchair_round_2", { ang = private.radian[4] });
    ObjSet("spr_armchair_round_3", { ang = private.radian[3] });


  end;

end;

function private.opn_hall()

  if not ( cmn.IsEventDone( "opn_hall" ) ) then
    cmn.SetEventDone( "beg_level1" );
    cmn.CallEventHandler( "beg_level1" );
    cmn.SetEventDone( "opn_hall" );
  end;
  
  cmn.CallEventHandler( "opn_hall" ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.SeeIntro()

  ObjDelete( "tmr_hall_intro" ); 
  ObjSet( "vid_hall_intro", { alp = 1, active = true, visible = true } );

  local func_after = function ( skip )
  
    local func_end = function()
    
      common_impl.Lock( false );
      common_impl.ShowBbt( "bbt_vid_hall_intro" );
      cmn.SetEventDone( "see_intro" );
      cmn.CallEventHandler( "see_intro" );
      ObjSet( "obj_hall_gates", { input = true } );
      
      interface.KeyTaskAdd( "fire_out", true );

      common_impl.AddPageDiary( 1 );
      
      common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
      
    end;
    
    interface.DialogVideoHide();
    
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_hall_intro", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level1/aud_hall_intro_voc", 0.2 );
      
    end;

    common_impl.EnvPlay( { "common/audio/level1/aud_hall_env" }, "", 0.5 ); 
    common_impl.PlayAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 1, "", 0 );
      
    ObjMultiSet({ 
      { "rm_hall", { color_r = 1, color_g = 1, color_b = 1 }}  
    });
    
    common_impl.Lock( true );
    AnimPlay( "anm_hall_avenger", "DoAnim", func_end );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_phantom_takes_girl", 0, "", 0 );
      
  end;

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_hall_intro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level1/aud_hall_intro_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_hall_intro", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_hall_intro", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.dlg_hall_calling()
  
  local func_after = function()
  
    local func_after_anim = function()
    
      common_impl.Lock( false );
      
      ObjSet( "anm_hall_tablet", { visible = false, active = false } );
    
      ObjAttach( "dlg_hall_calling", private.room_objname );
      cmn.CallEventHandler( "dlg_hall_calling_beg" );

      common_impl.continue_visible = true; 
      common_impl.DialogCharacterStart( "calling", 5, nil, nil, true, "dlg_hall_calling_end" );
      
      ObjAnimate( "rm_hall", "color_rgb", 0, 0, "", { 0,0,0,0,0, 0.3,0,1,1,1 } );
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_tablet_env", 1, "", 0 );
    
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_switch_on", 0, "", 0 );
    
    ObjAnimate( "rm_hall", "color_rgb", 0, 0, func_after_anim, { 0,0,1,1,1, 0.3,0,0,0,0 } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_hall_tablet", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_hall_tablet", "DoAnim", func_after );
 
end;
--------------------------------------------------------------------------------------------
function public.dlg_hall_calling_end()
  
  local func_after = function()
   
    common_impl.Lock( false );
    
    common_impl.StopAudio( "env", "common/audio/level1/aud_tablet_env", 0.5 );
    
    cmn.SetEventDone( "dlg_hall_calling" );
    cmn.CallEventHandler( "dlg_hall_calling_end" ); 
    
    common_impl.ShowBbt( "bbt_dlg_hall_calling" );
    
    common_impl.TutorialShow( "tutorial_page_1" );
    
    common_impl.AddPageDiary( 1 );
    
  end;
  
  common_impl.Lock( true );
  common_impl.StopAudio( "sfx", "common/audio/level1/aud_tablet_windows", 0, "", 0 );
  common_impl.StopAudio( "sfx", "common/audio/level1/aud_tablet_disconnect", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  AnimStop( "anm_hall_calling_interference" );
  
  ObjSet( "anm_hall_tablet_2", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_hall_tablet_2", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "calling" then
    
    if count_txt == 1 then 
      
      local func_after = function()
      
        local func_after_photo_1 = function()
        
          ObjSet( "anm_hall_calling_panel_photo_2", { alp = 1 } );    
          AnimPlay( "anm_hall_calling_panel_photo_2", "DoAnim", "" );
          
          ObjAnimate( "txt_hall_calling_photo_2", "alp", 0, 0, "", { 0,0,0, 1.0,0,0, 1.3,0,1 } );
        
        end;
      
        ObjSet( "anm_hall_calling_interface", { alp = 1, playing = true } );
        ObjSet( "anm_hall_calling_interface_load", { alp = 0 } );
        
        ObjSet( "anm_hall_calling_panel_photo", { alp = 1 } );    
        AnimPlay( "anm_hall_calling_panel_photo", "DoAnim", "" );
        
        ObjAnimate( "txt_hall_calling_photo_1", "alp", 0, 0, func_after_photo_1, { 0,0,0, 1.0,0,0, 1.3,0,1 } );
 
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_windows", 0, "", 0 );
  
      ObjSet( "anm_hall_calling_interface_load", { alp = 1 } );
      
      AnimPlay( "anm_hall_calling_interface_load", "DoAnim", func_after );
      
      ObjAnimate( "txt_hall_calling_tablet", "alp", 0, 0, "", { 0,0,0, 0.3,0,0, 0.6,0,1 } );
      
     elseif count_txt == 2 then 
      
      common_impl.StopAudio( "sfx", "common/audio/level1/aud_tablet_windows", 0, "", 0 );
      
      ObjStopAnimate( "txt_hall_calling_photo_1", "alp" );
      ObjStopAnimate( "txt_hall_calling_photo_2", "alp" );
      
      ObjMultiSet( { { "txt_hall_calling_tablet", { alp = 1 } },
                     { "anm_hall_calling_interface_load", { alp = 0, playing = false } },
                     { "anm_hall_calling_interface", { alp = 1, playing = true } },
                     { "anm_hall_calling_panel_photo", { alp = 1, frame = 100, playing = false } },
                     { "anm_hall_calling_panel_photo_2", { alp = 1, frame = 100, playing = false } },
                     { "txt_hall_calling_photo_1", { alp = 1 } },
                     { "txt_hall_calling_photo_2", { alp = 1 } },
     
      } );
      
     elseif count_txt == 4 then 
      
      local func_after = function()
      
        int_dialog_character.ContinueClick( false );
      
      end;
      
      ObjSet( "anm_hall_calling_interference", { alp = 1 } );
      
      AnimPlay( "anm_hall_calling_interference", "DoAnim", func_after );
  
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_disconnect", 0, "", 0 );
      
    end;

  end;

end;
--*********************************************************************************************************************

ObjAnimate("spr_hall_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});
ObjAnimate("spr_hall_light_2", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_orchestrapit_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_armchair_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.0,
  1.2, 0, 1.0
});
