-- name=rm_lunchroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lunchroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stranger", "room_hub" );
  ObjAttach( "zz_table", "room_hub" );
  ObjAttach( "zz_bar", "room_hub" );
  ObjAttach( "zz_picture", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_stranger_bottleshard", { event_mdown = private.get_bottleshard }},

    { "spr_table_electroniccard", { event_mdown = private.get_electroniccard }},

    { "spr_table_cane", { event_mdown = private.get_cane }},

    { "spr_bar_doorhandle", { event_mdown = private.get_doorhandle }},

    { "spr_bar_bag", { event_mdown = private.get_bag }},

    { "spr_bar_mineralwaterbottle", { event_mdown = private.get_mineralwaterbottle }},
    
    { "obj_bar_clk_latchhandle", { event_mdown = private.clk_latchhandle }},
    
    { "obj_bar_use_elf", { event_mdown = private.clk_bar_door }},
    
    { "obj_table_clk_spread", { event_mdown = private.clk_spread,
                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } },
                                
    { "obj_table_use_tableamulet_1", { event_mdown = function() private.clk_tablebox(1) end } },
    
    { "obj_table_use_tableamulet_2", { event_mdown = function() private.clk_tablebox(2) end } },
   
    { "obj_bar_get_bag", { event_mdown = private.clk_bar_get_all } },
   
    { "obj_bar_use_latchhandle", { event_mdown = private.clk_bar_boxdoors } },
    
    { "obj_bar_clk_grapes", { event_mdown = private.clk_bar_grapes } },
    
    { "obj_bar_clk_icecream", { event_mdown = private.clk_bar_icecream_1 } },
    
    { "obj_bar_clk_icecream_1", { event_mdown = private.clk_bar_icecream_2 } },
    
    { "obj_bar_clk_breadbasket", { event_mdown = private.clk_bar_breadbasket }},
    
    { "obj_bar_clk_bottle", { event_mdown = private.clk_bar_bottle }},
    
    { "spr_table_note", { event_mdown = function () common_impl.NoteScale( "open", "spr_table_note" ) end }},    
    { "spr_table_note_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_table_note" ); common_impl.ShowBbt( 'bbt_armchair_photo', 1 ); end } },
    
    { "spr_lunchroom_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  
    { "spr_lunchroom_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    
    { "spr_table_collect_2", { event_mdown = function () private.get_collect_2_1_1(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
                               
    { "spr_bar_collect_2", { event_mdown = function () private.get_collect_2_1_4(); end,
                             event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                             event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
    
      });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lunchroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_lunchroom_pictureroom",
    "gzz_lunchroom_stranger",
    "gzz_lunchroom_table",
    "gzz_lunchroom_bar",
    "gzz_lunchroom_picture"   
  };
  
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_stranger",
    "zz_table",
    "zz_bar",
    "zz_picture"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_lunchroom", update_game_mode_lunchroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lunchroom = function ()

  local effects_table = 
  {
   "obj_lunchroom_anim",
   "anm_lunchroom_candlelight",
   "spr_stranger_light",
   "obj_table_anim",
   "spr_bar_light_add",
   "spr_picture_light_add"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lunchroom", update_performance_mode_lunchroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lunchroom () end;
  --------------------------------------------------------------------------------------------
  local opn_lunchroom_map = function ()

    common_impl.VisitMapRoom( "lunchroom" );

  end;
  local opn_lunchroom_clk = function ()

  if ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_grapes == true then

      ObjSet( "spr_bar_grapes", { alp = 1 } );
      ObjDelete( "obj_bar_clk_grapes" );

  end;

  if ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_icecream_1 == true then

      ObjSet( "spr_bar_icecream_2", { alp = 1 } );
      ObjSet( "obj_bar_clk_icecream_1", { input = true } );
      ObjDelete( "obj_bar_clk_icecream" );

   end;
    
   if ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_icecream_2 == true then

      ObjSet( "spr_bar_icecream_1", { alp = 1 } );
      ObjDelete( "obj_bar_clk_icecream_1" );

   end; 
  end;
  cmn.AddSubscriber( "opn_lunchroom", opn_lunchroom_map );
  cmn.AddSubscriber( "opn_lunchroom", opn_lunchroom_clk, private.room_objname );
  cmn.AddSubscriber( "opn_lunchroom_clk", opn_lunchroom_clk, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_bottleshard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottleshard" ] = {
    type = "get",
    get_obj = "spr_stranger_bottleshard",
    room = private.room_objname,
    zz = "zz_stranger",
    zz_gate = "gzz_lunchroom_stranger"
  };
    
  local get_bottleshard_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottleshard", "spr_stranger_bottleshard" );
    ObjSet("spr_bag_plus_light",{alp = 1});
  
  end;
  
  local get_bottleshard_closezz = function ()
  
    ObjDelete( "gfx_stranger_bottleshard" );
    ObjDelete( "spr_stranger_bottleshard_shadow" );
    ObjDelete( "spr_lunchroom_stranger_shard" );
  
  end;
  
  cmn.AddSubscriber( "get_bottleshard", get_bottleshard_inv );
  cmn.AddSubscriber( "get_bottleshard", get_bottleshard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_electroniccard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_electroniccard" ] = {
    type = "get",
    get_obj = "spr_table_electroniccard",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_lunchroom_table"
  };
    
  local get_electroniccard_inv = function ()
  
    interface.InventoryItemAdd( "inv_electroniccard", "spr_table_electroniccard" );
  
  end;
  
  local get_electroniccard_closezz = function ()
  
    ObjDelete( "gfx_table_electroniccard" );
    ObjDelete( "spr_table_electroniccard_shadow" );
    ObjDelete( "spr_table_electroniccard_shadow_up" );
    ObjDelete( "spr_lunchroom_table_card" );
    
    --if common_impl.IsGetCollect( "get_collect_2_1_1" ) then
    --  
    --  ObjDelete( "gzz_lunchroom_table" );
    --  
    --end;
  
  end;
  
  cmn.AddSubscriber( "get_electroniccard", get_electroniccard_inv );
  cmn.AddSubscriber( "get_electroniccard", get_electroniccard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cane" ] = {
    type = "get",
    get_obj = "spr_table_cane",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_lunchroom_table"
  };
    
  local get_cane_inv = function ()
  
    interface.InventoryItemAdd( "inv_cane", "spr_table_cane" );
    ObjSet("inv_cane", { drag = false });
    
  end;
  
  local get_cane_closezz = function ()
  
    ObjDelete( "gfx_table_cane" );
    ObjDelete( "obj_table_cane_shadows" );
    ObjDelete( "spr_lunchroom_table_cane" );
  
  end;
  
  cmn.AddSubscriber( "get_cane", get_cane_inv );
  cmn.AddSubscriber( "get_cane", get_cane_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doorhandle" ] = {
    type = "get",
    get_obj = "spr_bar_doorhandle",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
    
  local get_doorhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorhandle", "spr_bar_doorhandle" );
    ObjSet("spr_cane_plus_light", { alp = 1 });
  
  end;
  
  local get_doorhandle_closezz = function ()
  
    ObjDelete( "gfx_bar_doorhandle" );
    ObjDelete( "spr_bar_doorhandle_shadow" );
    ObjDelete( "spr_table_over_cane_2");
    --ObjSet("spr_bar_bag",     { input = true , active = true   });
    --ObjDelete( "gzz_lunchroom_bar" );
  
  end;
  
  cmn.AddSubscriber( "get_doorhandle", get_doorhandle_inv );
  cmn.AddSubscriber( "get_doorhandle", get_doorhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bag" ] = {
    type = "get",
    get_obj = "spr_bar_bag",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
    
  local get_bag_inv = function ()
  
    interface.InventoryItemAdd( "inv_bag", "spr_bar_bag" );
    ObjSet("inv_bag", { drag = false });
    
  end;
  
  local get_bag_closezz = function ()
  
    ObjDelete( "gfx_bar_bag" );
    ObjDelete( "spr_bar_bag_shadow" );
    ObjDelete( "obj_bar_get_bag" );
    --ObjDelete( "gzz_lunchroom_bar" );
  
  end;
  
  cmn.AddSubscriber( "get_bag", get_bag_inv );
  cmn.AddSubscriber( "get_bag", get_bag_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mineralwaterbottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mineralwaterbottle" ] = {
    type = "get",
    get_obj = "spr_bar_mineralwaterbottle",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
    
  local get_mineralwaterbottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_mineralwaterbottle", "spr_bar_mineralwaterbottle" );
    ObjSet("inv_mineralwaterbottle", { drag = false });
    ObjSet("spr_mineralwaterbottle_plus_light",{alp=1});
    
  end;
  
  local get_mineralwaterbottle_closezz = function ()
  
    ObjDelete( "gfx_bar_mineralwaterbottle" );
    ObjDelete( "spr_bar_bottle_shadow" );
    ObjDelete( "spr_lunchroom_bar_bottle" );
    
    if common_impl.IsGetCollect( "get_collect_2_1_4" ) then
    
      ObjDelete( "gzz_lunchroom_bar" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mineralwaterbottle", get_mineralwaterbottle_inv );
  cmn.AddSubscriber( "get_mineralwaterbottle", get_mineralwaterbottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_3 = function ()
  
    ObjDelete( "obj_lunchroom_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_3", get_collect_item_1_3, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_5 = function ()
  
    ObjDelete( "obj_lunchroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_5", get_collect_morph_item_1_5, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_1 = function ()
 
   ObjDelete( "spr_table_collect_2" );

    --if cmn.IsEventDone( "get_electroniccard" ) then
    --  ObjDelete( "gzz_lunchroom_table" );
    --end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_1", get_collect_2_1_1, private.room_objname );
  
  local get_collect_2_1_4 = function ()
 
    ObjDelete( "spr_bar_collect_2" );

    if cmn.IsEventDone( "get_mineralwaterbottle" ) then
      ObjDelete( "gzz_lunchroom_bar" );
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_4", get_collect_2_1_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_mineralwater () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mineralwater" ] = {
    type = "use",
    inv_obj = "inv_mineralwater",
    use_place = "obj_stranger_use_mineralwaterbottle",
    room = private.room_objname,
    zz = "zz_stranger",
    zz_gate = "gzz_lunchroom_stranger"
  };
  local use_mineralwater_inv = function ()
  
    interface.InventoryItemRemove( "inv_mineralwater" );
  
  end;
  local use_mineralwater_beg = function ()
  
    ObjDelete( "obj_stranger_use_mineralwaterbottle" );
    ObjDelete( "gzz_lunchroom_stranger" );
    ObjDelete( "anm_lunchroom_stranger");
    ObjDelete( "spr_lunchroom_stranger_men");
  
  end;
  local use_mineralwater_end = function ()
  
    ObjSet( "anm_lunchroom_stranger_stand", { alp = 1 } );
    ObjDelete( "tmr_stranger_bottle" );
    ObjDelete( "vid_stranger_bottle" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mineralwater", use_mineralwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_mineralwater", use_mineralwater_inv );
  cmn.AddSubscriber( "use_mineralwater", use_mineralwater_end, private.room_objname );
  cmn.AddSubscriber( "use_mineralwater_inv", use_mineralwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_mineralwater_beg", use_mineralwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_mineralwater_end", use_mineralwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tableamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tableamulet_1" ] = {
    type = "use",
    inv_obj = "inv_tableamulet_1",
    use_place = "obj_table_use_tableamulet_1",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_lunchroom_table"
  };
  local use_tableamulet_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_tableamulet_1" );
  
  end;
  local use_tableamulet_1_beg = function ()
  
    ObjDelete( "obj_table_use_tableamulet_1" );
  
  end;
  local use_tableamulet_1_end = function ()
  
  
    ObjSet( "spr_lunchroom_table_mark_1", { alp = 1});
    if cmn.IsEventDone( "use_tableamulet_2" ) then

      ObjMultiSet({ 
        { "spr_table_electroniccard",     { input = true     }},
        { "gfx_table_electroniccard",     { active = true    }},
        { "spr_table_stash",              { alp = 1, input = true } },
        { "spr_lunchroom_table_open", { alp = 1 }}, 
        { "spr_lunchroom_table_card", { alp = 1}}   
      });
      ObjDelete( "anm_table_stash" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tableamulet_1", use_tableamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_1", use_tableamulet_1_inv );
  cmn.AddSubscriber( "use_tableamulet_1", use_tableamulet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_1_inv", use_tableamulet_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_1_beg", use_tableamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_1_end", use_tableamulet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tableamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tableamulet_2" ] = {
    type = "use",
    inv_obj = "inv_tableamulet_2",
    use_place = "obj_table_use_tableamulet_2",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_lunchroom_table"
  };
  local use_tableamulet_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_tableamulet_2" );
  
  end;
  local use_tableamulet_2_beg = function ()
  
    ObjDelete( "obj_table_use_tableamulet_2" );

  end;
  local use_tableamulet_2_end = function ()
  
    ObjSet( "spr_lunchroom_table_mark_2", { alp = 1});
    if cmn.IsEventDone( "use_tableamulet_1" ) then

      ObjMultiSet({ 
        { "spr_table_electroniccard",     { input = true }},
        { "gfx_table_electroniccard",     { active = true    }},
        { "spr_table_stash",              { alp = 1, input = true } },
        { "spr_lunchroom_table_open", { alp = 1 }}, 
        { "spr_lunchroom_table_card", { alp = 1}}   
      });
      ObjDelete( "anm_table_stash" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tableamulet_2", use_tableamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_2", use_tableamulet_2_inv );
  cmn.AddSubscriber( "use_tableamulet_2", use_tableamulet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_2_inv", use_tableamulet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_2_beg", use_tableamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableamulet_2_end", use_tableamulet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4" ] = {
    type = "use",
    inv_obj = "inv_elf_1",
    use_place = "obj_bar_use_elf",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
  local use_elf_4_beg = function ()
  
    ObjDelete( "obj_bar_use_elf" );
  
  end;
  local use_elf_4_end = function ()

  
    ObjMultiSet({ 
    --{ "spr_bar_doorhandle",     { input = true     }},
      { "gfx_bar_doorhandle",     { active = true    }},
      { "gfx_bar_bag",     { active = true    }},
      { "obj_bar_food",     { input = true     }},
      { "obj_bar_get_bag",      {  input = true  }},
      { "spr_bar_lever_down",     { alp = 1     }},
      
    });
    ObjDelete("spr_bar_partition");
    ObjDelete("vid_bar_elf");
    ObjDelete( "spr_lunchroom_bar_arm");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4", use_elf_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4", use_elf_4_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_beg", use_elf_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_end", use_elf_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_latchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_latchhandle" ] = {
    type = "use",
    inv_obj = "inv_latchhandle",
    use_place = "obj_bar_use_latchhandle",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
  local use_latchhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_latchhandle" );
  
  end;
  local use_latchhandle_beg = function ()
  
    ObjDelete( "obj_bar_use_latchhandle" );
  
  end;
  local use_latchhandle_end = function ()
  
    ObjMultiSet({ 
    { "obj_bar_clk_latchhandle",     { input = true, active = true  }},
    { "spr_lunchroom_bar_knob", { alp = 1 } }
    --  { "gfx_bar_mineralwaterbottle",     { active = true    }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_latchhandle", use_latchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_latchhandle", use_latchhandle_inv );
  cmn.AddSubscriber( "use_latchhandle", use_latchhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_latchhandle_inv", use_latchhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_latchhandle_beg", use_latchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_latchhandle_end", use_latchhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_latchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_latchhandle" ] = {
    type = "click",
    use_place = "obj_bar_clk_latchhandle",
    room = private.room_objname,
    zz = "zz_bar",
    zz_gate = "gzz_lunchroom_bar"
  };
  local clk_latchhandle_beg = function ()
  
    ObjDelete( "obj_bar_clk_latchhandle" );
  
  end;
  local clk_latchhandle_end = function ()
 
     ObjMultiSet({ 
      { "spr_bar_mineralwaterbottle", { input = true , alp = 1}},
      { "gfx_bar_mineralwaterbottle",     { active = true    }},
      { "spr_bar_open",                             { alp = 1}},
      { "spr_lunchroom_bar_open", { alp = 1 }}
     });
     ObjDelete( "spr_bar_box_handle" );
     ObjDelete( "spr_lunchroom_bar_knob" );
     ObjDelete( "spr_bar_box_door_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_latchhandle", clk_latchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_latchhandle", clk_latchhandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_latchhandle_beg", clk_latchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_latchhandle_end", clk_latchhandle_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_spread () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_spread" ] = {
    type = "click",
    use_place = "obj_table_clk_spread",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_lunchroom_table"
  };
  local clk_spread_beg = function ()
  
  ObjDelete( "obj_table_clk_spread" );
  
  end;
  local clk_spread_end = function ()
 
     ObjMultiSet({ 
      { "obj_table_use_tableamulet_1", { input = true }},
      { "obj_table_use_tableamulet_2", { input = true }},
      { "spr_lunchroom_table_man", { alp = 1 }}
     });
     ObjDelete( "spr_table_spread" );
     ObjDelete( "anm_table_man");
     ObjSet( "anm_table_man_1", { alp = 1, playing = true });
     ObjSet( "obj_table_clk_man", { input = true });
     --ObjSet("spr_lunchroom_table_over", { alp = 1 });
     ObjSet( "anm_lunchroom_table_man", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_spread", clk_spread_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spread", clk_spread_end, private.room_objname );
  cmn.AddSubscriber( "clk_spread_beg", clk_spread_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spread_end", clk_spread_end, private.room_objname );
  
 ------------------------------------------------------------------------------------------
  -- function use_pictureelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pictureelement" ] = {
    type = "use",
    inv_obj = "inv_pictureelement",
    use_place = "obj_picture_use_pictureelement",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_lunchroom_picture"
  };
  local use_pictureelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_pictureelement" );
  
  end;
  local use_pictureelement_beg = function ()
  
    ObjDelete( "obj_picture_use_pictureelement" );
    
  end;
  local use_pictureelement_end = function ()
  
    ObjSet( "gho_lunchroom_pictureroom", { input = true, active = true, alp = 1 } );
    ObjSet( "anm_hall_gho_pictureroom", { visible = true } ); 
    ObjDelete( "gzz_lunchroom_picture" );
    ObjSet( "spr_picture_head", { alp = 1 });
    ObjDelete( "spr_lunchroom_picture_head" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pictureelement", use_pictureelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_pictureelement", use_pictureelement_inv );
  cmn.AddSubscriber( "use_pictureelement", use_pictureelement_end, private.room_objname );
  cmn.AddSubscriber( "use_pictureelement_inv", use_pictureelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_pictureelement_beg", use_pictureelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_pictureelement_end", use_pictureelement_end, private.room_objname );
 
  --------------------------------------------------------------------------------------------
  -- function win_pictureroom () end;
  --------------------------------------------------------------------------------------------
--  local win_pictureroom = function ()
--
--    ObjSet( "spr_lunchroom_picture_open", { alp = 1 } );
--  
--  end;
--  --------------------------------------------------------------------------------------------
--  cmn.AddSubscriber( "win_pictureroom", win_pictureroom, private.room_objname );
--  --------------------------------------------------------------------------------------------
  -- function dlg_lunchroom_barmen () end;
  --------------------------------------------------------------------------------------------
  local dlg_lunchroom_barmen_beg = function ()

  
  end;
  local dlg_lunchroom_barmen_inv = function ()
  
  interface.InventoryItemAdd( "inv_pictureelement", "spr_lunchroom_barmen_pictureelement" ); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_lunchroom_barmen_beg", dlg_lunchroom_barmen_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_lunchroom_barmen_inv", dlg_lunchroom_barmen_inv );
  cmn.AddSubscriber( "dlg_lunchroom_barmen", dlg_lunchroom_barmen_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_lunchroom_barmen", dlg_lunchroom_barmen_inv );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_table" );
  
   function zz_table.PreOpen()
     
       if not common_impl.lunchroom then

         common_impl.lunchroom = {}
         common_impl.lunchroom.note = "close";
         
       end;
       
      if  ObjGet( "spr_table_note" ).input == true then

      ObjSet( "spr_table_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_table_note",     { alp = 1 } );
      
      end;
    
   end;
  
  subroom.Define( "zz_stranger" );

  function zz_stranger.Close()

    if cmn.IsEventDone( "use_mineralwater" ) then

      private.dlg_lunchroom_barmen();

    end;

    ObjSet( "obj_int_frame_subroom_button", { pos_x = -30 } );
    
    
  end;
  
  function zz_stranger.PreOpen()

    ObjSet( "obj_int_frame_subroom_button", { pos_x = -510 } );
    
  end;
  -----------------------------------------------------------
  subroom.Define( "zz_picture" );

  function zz_picture.Close()
    
    if cmn.IsEventDone( "use_pictureelement" ) then
      
      ObjSet( "tmr_lunchroom_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_pictureroom' ) end } );
      
    end;
  
  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_lunchroom();
  
  private.AnimCandles();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  
  if not ng_global.progress["std"]["opn_lunchroom"].viewer then
    
    ng_global.progress["std"]["opn_lunchroom"].viewer = 1;
    
  end;
  
  if not cmn.IsEventDone( "dlg_lunchroom_barmen" ) and
    cmn.IsEventDone( "use_mineralwater" ) then

    private.dlg_lunchroom_barmen()
  end;  
 
  if  ng_global.progress[ "std" ]["dlg_lunchroom_barmen"].dlg_done then  
    
     ObjDelete( "anm_lunchroom_stranger_stand" );
     ObjSet( "anm_lunchroom_stranger_seat", { playing = true, alp = 1 });
     ObjSet( "obj_lunchroom_bbt_seat", { input = true });
     ObjSet( "obj_lunchroom_loupe_fun_object_2", { visible = true });
     --ObjSet( "anm_lunchroom_stranger_table", { playing = true, alp = 1 });
     --ObjSet( "anm_lunchroom_table_man", { alp = 0 });
     --ObjSet( "anm_table_man_1", { alp = 0});
     --ObjSet( "anm_lunchroom_loupe_fun_object_1", { res ="assets/levels/level1/rm_lunchroom/anims/man/anm_man_seat_red", animfunc = "DoAnim", playing = true });
     --ObjSet( "obj_table_clk_man", { input = false });
     ObjSet( "obj_lunchroom_bbt_seat", { input = true });
     
  if cmn.IsEventDone( "clk_spread" ) then
    
     ObjSet( "anm_lunchroom_stranger_table", { playing = true, alp = 1 });
     ObjSet( "anm_lunchroom_table_man", { alp = 0 });
     ObjSet( "anm_table_man_1", { alp = 0});
     ObjSet( "anm_lunchroom_loupe_fun_object_1", { res ="assets/levels/level1/rm_lunchroom/anims/man/anm_man_seat_red", animfunc = "DoAnim", playing = true });
     ObjSet( "obj_table_clk_man", { input = false });  
  end;
 end;
  if  ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_breadbasket then 
    
    ObjSet( "spr_bar_breadbasket", { alp = 1 }); 
  
  end;
  
  common_impl.EnvPlay( { "common/audio/level1/aud_lunchroom_env" }, "", 0.5 );
  
      if ( ng_global.progress["std"]["opn_lunchroom"].viewer < 4 ) then
      
        ng_global.progress["std"]["opn_lunchroom"].viewer = ng_global.progress["std"]["opn_lunchroom"].viewer + 1;
      
        if ng_global.progress["std"]["opn_lunchroom"].viewer == 4 then
        
        interface.Lock( true, 3 );
        
        ObjSet( "anm_lunchroom_photo", { alp = 1 } );
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interactive_lunchroom_cameraman", 0, "", 0 );
        
        AnimPlay( "anm_lunchroom_photo", "DoAnim", function() common_impl.ShowBbt( 'bbt_lunchroom_photo' ); end );
        
     end;
        
    end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if cmn.IsEventDone( "dlg_lunchroom_barmen" ) then 
    
      ObjDelete( "anm_lunchroom_stranger_stand" );
      ObjSet( "anm_lunchroom_stranger_seat", { playing = true, alp = 1 });
      --ObjSet( "anm_lunchroom_stranger_table", { playing = true, alp = 1 });
      ObjSet( "obj_lunchroom_bbt_seat", { input = true });
      ng_global.progress[ "std" ]["dlg_lunchroom_barmen"].dlg_done = true;
   
  if cmn.IsEventDone( "clk_spread") then   
    
      DbgTrace("zzzz");
      ObjSet( "anm_lunchroom_stranger_table", { playing = true, alp = 1 });
      ObjSet( "anm_lunchroom_table_man", { alp = 0 });
      ObjSet( "anm_table_man_1", { alp = 0});
      ObjSet( "anm_lunchroom_loupe_fun_object_1", { res = "assets/levels/level1/rm_lunchroom/anims/man/anm_man_seat_red", animfunc = "DoAnim", playing = true });
      ObjSet( "obj_table_clk_man", { input = false });
      --ObjSet( "obj_lunchroom_bbt_seat", { input = true });
      
   end; 
   end; 
    
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_mineralwater()

  local item = "inv_mineralwater";

  if ( common.ApplyObj( item, "obj_stranger_use_mineralwaterbottle", true ) ) then

    cmn.CallEventHandler( "use_mineralwater_inv" );
    cmn.CallEventHandler( "use_mineralwater_beg" );

    local func_after = function ()
    
      local func_end = function()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_mineralwater" );
        cmn.CallEventHandler( "use_mineralwater_end" );
        common.CloseSubRoom();
        
      end;
      
      ObjSet( "anm_stranger_andy_1", { alp = 0 } );
      ObjSet( "anm_stranger_andy_2", { alp = 1 } );
      
      AnimPlay( "anm_stranger_andy_2", "DoAnim", func_end );
    
    end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_mineralwater_stranger", 0, "", 0 );
 
  ObjSet( "vid_stranger_bottle", { alp = 1, playing = true } );
  ObjSet( "tmr_stranger_bottle", { time = 2.5, playing = true, endtrig = func_after } );
    
  return true;
  
  elseif common.ApplyObj( item, "gzz_lunchroom_stranger", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stranger", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tableamulet_1()

  local item = "inv_tableamulet_1";

  if ( common.ApplyObj( item, "obj_table_use_tableamulet_1", true ) and cmn.IsEventDone( "clk_spread" ) ) then

    cmn.CallEventHandler( "use_tableamulet_1_inv" );
    cmn.CallEventHandler( "use_tableamulet_1_beg" );

    local func_after = function ()
  
   
      local func_after_open = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_tableamulet_1" );
        cmn.CallEventHandler( "use_tableamulet_1_end" );
      
      end;
      
      if cmn.IsEventDone( "use_tableamulet_2" ) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_open_stash_table", 0, "", 0 );
        
        ObjSet( "anm_table_stash", { alp = 1 } );
        
        AnimPlay( "anm_table_stash", "DoAnim", func_after_open );
        
      else
        
        func_after_open();
  
      end;
      
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tableamulet_table", 0, "", 0 );
  
  ObjAnimate( "spr_table_tableamulet_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_lunchroom_table", false ) and cmn.IsEventDone( "clk_spread" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tableamulet_2()

  local item = "inv_tableamulet_2";

  if ( common.ApplyObj( item, "obj_table_use_tableamulet_2", true ) and cmn.IsEventDone( "clk_spread" ) ) then

    cmn.CallEventHandler( "use_tableamulet_2_inv" );
    cmn.CallEventHandler( "use_tableamulet_2_beg" );

    local func_after = function ()
  
   
      local func_after_open = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_tableamulet_2" );
        cmn.CallEventHandler( "use_tableamulet_2_end" );
      
      end;
      
      if cmn.IsEventDone( "use_tableamulet_1" ) then
  
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_open_stash_table", 0, "", 0 );
        
        ObjSet( "anm_table_stash", { alp = 1 } );
        
        AnimPlay( "anm_table_stash", "DoAnim", func_after_open );
        
      else
        
        func_after_open();
  
      end;
      
    --common.CloseSubRoom();;
    
    end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tableamulet_table", 0, "", 0 );
  
  ObjAnimate( "spr_table_tableamulet_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_lunchroom_table", false ) and cmn.IsEventDone( "clk_spread" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4()

  local item = "inv_elf_1";

  if ( common.ApplyObj( item, "obj_bar_use_elf", true ) ) then

    interface.InventoryItemRemove( "inv_elf_1" ); 
    cmn.CallEventHandler( "use_elf_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_4" );
      cmn.CallEventHandler( "use_elf_4_end" );
      ObjSet( "spr_bar_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_1", "spr_bar_elf", nil, "video" );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_bar_elf", 0, "", 0 );
    VidPlay( "vid_bar_elf", func_after );
    
    ObjAnimate( "spr_bar_partition", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      4.8, 0, 1.0,
      5.1, 0, 0.0
    } );
    
    return true;
    
  elseif common.ApplyObj( item, "gzz_lunchroom_bar", false ) and not cmn.IsEventDone( "use_elf_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bar", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_latchhandle()

  local item = "inv_latchhandle";

  if ( common.ApplyObj( item, "obj_bar_use_latchhandle", true ) and cmn.IsEventDone( "use_elf_4" ) ) then

    cmn.CallEventHandler( "use_latchhandle_inv" );
    cmn.CallEventHandler( "use_latchhandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_latchhandle" );
      cmn.CallEventHandler( "use_latchhandle_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
   common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_handle_bar", 0, "", 0 );
  
    ObjAnimate( "spr_bar_box_handle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_lunchroom_bar", false ) and cmn.IsEventDone( "use_elf_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bar", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pictureelement()

  local item = "inv_pictureelement";

  if ( common.ApplyObj( item, "obj_picture_use_pictureelement", true ) ) then

    cmn.CallEventHandler( "use_pictureelement_inv" );
    cmn.CallEventHandler( "use_pictureelement_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_pictureelement" );
      cmn.CallEventHandler( "use_pictureelement_end" );
      common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_pictureelement_picture", 0, "", 0 );
  
    ObjAnimate( "spr_picture_head", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_lunchroom_picture", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_picture", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_1()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_1");
    cmn.CallEventHandler("get_collect_2_1_1");

    --if cmn.IsEventDone( "get_electroniccard" ) then
    --  common.CloseSubRoom();
    --end;    

  end;

  common_impl.PlayEffectHO( "spr_table_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_4()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_4");
    cmn.CallEventHandler("get_collect_2_1_4");

    if cmn.IsEventDone( "get_mineralwaterbottle" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_bar_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_bottleshard()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottleshard" );
  cmn.CallEventHandler( "get_bottleshard" );

end;
--------------------------------------------------------------------------------------------
function private.get_electroniccard()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_electroniccard" );
  cmn.CallEventHandler( "get_electroniccard" );
  
  --if common_impl.IsGetCollect( "get_collect_2_1_1" ) then
  --  common.CloseSubRoom();
  --end;

end;
--------------------------------------------------------------------------------------------
function private.get_cane()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cane" );
  cmn.CallEventHandler( "get_cane" );

end;
--------------------------------------------------------------------------------------------
function private.get_doorhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_doorhandle" );
  cmn.CallEventHandler( "get_doorhandle" );

end;
--------------------------------------------------------------------------------------------
function private.get_bag()

  if cmn.IsEventDone("get_doorhandle") then
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    cmn.SetEventDone( "get_bag" );
    cmn.CallEventHandler( "get_bag" );
    
  end;
end;
--------------------------------------------------------------------------------------------
function private.get_mineralwaterbottle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_mineralwaterbottle" );
  cmn.CallEventHandler( "get_mineralwaterbottle" );
  
   if common_impl.IsGetCollect( "get_collect_2_1_4" ) then
     
     common.CloseSubRoom();
    
   end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_bar_get_all()
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    cmn.SetEventDone( "get_doorhandle" );
    cmn.CallEventHandler( "get_doorhandle" );
  
    cmn.SetEventDone( "get_bag" );
    cmn.CallEventHandler( "get_bag" );
  
end;
--------------------------------------------------------------------------------------  
function private.clk_bar_door()
 
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_use_elf_1' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_drawer_table", 0, "", 0 );

  ObjAnimate( "spr_bar_partition", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 178, 
    0.3, 0, 179,
    0.6, 0, 178
  } ); 
  
end;
--*********************************************************************************************************************
function private.clk_bar_boxdoors()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_use_latchhandle' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_doors_bar", 0, "", 0 );

  ObjAnimate( "spr_bar_box_door_2", "scale_x", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.3, 0, 0.98,
    0.6, 0, 1
  } ); 
  
  ObjAnimate( "spr_bar_box_door_1", "scale_x", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 1.02,
    0.6, 0, 1
  } );
  
end;
-------------------------------------------------------------------------------------------  
function private.clk_latchhandle()

  cmn.CallEventHandler( "clk_latchhandle_beg" );

  local func_after = function ()
  
   local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_latchhandle" );
      cmn.CallEventHandler( "clk_latchhandle_end" );
      
   end;
    
    ObjAnimate( "spr_bar_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 1.0
    } ); 
   ObjAnimate( "spr_bar_mineralwaterbottle", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
   ObjAnimate( "spr_bar_box_handle", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_bar", 0, "", 0 );
  
  ObjAnimate( "spr_bar_box_handle", "ang", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, -0.1,
      0,6, 0, 0.0
    } );

end;

-------------------------------------------------------------------------------------------  
function private.clk_spread()

  cmn.CallEventHandler( "clk_spread_beg" );

  local func_after = function ()
 
   local func_end = function ()
   
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_spread" );
    cmn.CallEventHandler( "clk_spread_end" );
    
   end; 
   ObjSet("anm_table_man", { alp = 1});
   
   AnimPlay( "anm_table_man", "DoAnim", func_end); 
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_cloth_table", 0, "", 0 );
  
  ObjAnimate( "spr_table_spread", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1, 
      0.3, 0, 0,   
    } );

end;
  
-------------------------------------------------------------------------------------------  
function private.clk_tablebox( num )

  local func_after = function ()
 
  common_impl.Lock( false ); 
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_drawer_table", 0, "", 0 );
 
  common_impl.ShowBbt( 'bbt_table_use_tableamulet_'..num );
  
  ObjAnimate( "spr_table_tablebox", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, -15, 
      0.3, 0, -13,
      0.6, 0, -15   
    } );

end;
------------------------------------------------------------------------------------------
function private.clk_bar_grapes()
  
   local func_after = function()

    common_impl.Lock( false );
    --common_impl.ShowBbt( 'bbt_display_clk_2' );
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_grapes = true;
    cmn.CallEventHandler( "opn_lunchroom_clk" );

    --common_impl.CheckFunAchiev();

   end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_clk_food' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_grapes_bar", 0, "", 0 );
  
  ObjAnimate( "spr_bar_grapes", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
 
end;
----------------------------------------------------------------------------------------
function private.clk_bar_icecream_1()
  
   local func_after = function()

    common_impl.Lock( false );
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_icecream_1 = true;
    cmn.CallEventHandler( "opn_lunchroom_clk" );
   end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_clk_food' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_icecream_bar", 0, "", 0 );
  
  ObjAnimate( "spr_bar_icecream_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
 
end;
--------------------------------------------------------------------------------------------
function private.clk_bar_icecream_2()
  
   local func_after = function()

    common_impl.Lock( false );
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_icecream_2 = true;
    cmn.CallEventHandler( "opn_lunchroom_clk" );

   end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_clk_food' );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_icecream_bar", 0, "", 0 );

  ObjAnimate( "spr_bar_icecream_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
 
end;
-------------------------------------------------------------------------------------------
function private.clk_bar_breadbasket()
  
  local func_after_1 = function()  
  
    common_impl.Lock( false );  
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_breadbasket = false;
  
  end;
  
  local func_after_2 = function()  
  
    common_impl.Lock( false );  
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_breadbasket = true;
    
  end;
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_clk_breadbasket' );
  
  if ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_breadbasket then
  
   ObjAnimate( "spr_bar_breadbasket", "alp", 0, 0, func_after_1,
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_breadbasket_bar_close", 0, "", 0 );
  
 else
  
  ObjAnimate( "spr_bar_breadbasket", "alp", 0, 0, func_after_2,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_breadbasket_bar_open", 0, "", 0 );
  
  end; 
end;  
-----------------------------------------------------------------------------------------
function private.clk_bar_bottle()
  
  local func_after = function()  
  
    common_impl.Lock( false );
   
  end;
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bar_clk_bottle' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_alcohol_bar", 0, "", 0 );
  
  ObjAnimate( "spr_bar_bottle_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1,
    0.3, 0, 0,
    0.6, 0, 0,
    0.9, 0, 1
  } );
 
  ObjAnimate( "spr_bar_bottle_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0,
    0.3, 0, 1,
    0.6, 0, 1,
    0.9, 0, 0
    
  } );
  
end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lunchroom()

  if not ( cmn.IsEventDone( "opn_lunchroom" ) ) then
    
    ng_global.progress[ "std" ]["opn_lunchroom"].bar_clk_breadbasket = false;
    ng_global.progress[ "std" ]["dlg_lunchroom_barmen"].dlg_done = false;
    
    cmn.SetEventDone( "opn_lunchroom" );
    
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
    
  end;
  
  cmn.CallEventHandler( "opn_lunchroom" ); 

end;
--*********************************************************************************************************************
function private.dlg_lunchroom_barmen()

  ObjAttach( "dlg_lunchroom_barmen", private.room_objname );
  ObjSet("anm_lunchroom_barmen_loc", { alp = 0 });
  cmn.CallEventHandler( "dlg_lunchroom_barmen_beg" );
  common_impl.dialog_character_loc = "anm_lunchroom_stranger_stand";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "barmen", 4, nil, nil, true, "dlg_lunchroom_barmen_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_lunchroom_barmen_end()

  if not cmn.IsEventDone( "dlg_lunchroom_barmen" ) then

    cmn.SetEventDone( "dlg_lunchroom_barmen" );
    ObjSet( "spr_lunchroom_barmen_pictureelement", { alp = 1 } );
    cmn.CallEventHandler( "dlg_lunchroom_barmen_inv" );
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
   
    common_impl.ShowBbt( "bbt_dlg_lunchroom_barmen", 1 );
    
    common_impl.AddPageDiary( 4 );

  end;

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "barmen" then
    
    if txt_count == 3 then
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      
      ObjMultiSet( { { "anm_lunchroom_barmen_barmen", { alp = 0 } },
                     { "anm_lunchroom_barmen_barmen_2", { alp = 1 } } } );
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.AnimCandles()
  
  for i = 1, 3 do
    
    local ang = ObjGet( "spr_table_candle_"..i ).ang;
    
    ObjAnimate( "spr_table_candle_"..i, "ang", 1, 0, "", { 0,0,ang, i,0,(-ang), 1.5*i,0,ang } );
    ObjAnimate( "spr_table_candle_"..i.."_light", "alp", 1, 0, "", { 0,0,1, i,0,(0.4), 2*i,0,1 } );
    
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate("spr_bar_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  1.0, 0, 0.5,
  2.0, 0, 1.0
});

ObjAnimate("spr_lunchroom_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});


ObjAnimate("spr_lunchroom_chandelier1", "ang",1,0,"",
{
  0.0, 3, -0.02, 
  1.3, 3, 0.02,
  2.6, 3, -0.02
});

ObjAnimate("spr_lunchroom_chandelier2", "ang",1,0,"",
{
  0.0, 3, 0.02, 
  2.0, 3, -0.02,
  4.0, 3, 0.02
});
ObjAnimate("spr_picture_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});

ObjAnimate("spr_stranger_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});
