-- name=rm_offstage
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_offstage";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_smallroomdoor", "room_hub" );
  ObjAttach( "zz_doublebasscoffer", "room_hub" );
  ObjAttach( "zz_lightningequipment", "room_hub" );
  ObjAttach( "zz_bedsidetable", "room_hub" );
  ObjAttach( "zz_piano", "room_hub" );
  
  private.Init_Subroom();
  
  local table_multiset = {};
  
  for i = 0, 7 do
    table.insert( table_multiset, { "spr_piano_mmg_"..i, { 
    event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
    event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
    event_mdown = function() private.piano_key_clk( i ) end,
    }} );
  end;

  private.piano_current = { 0, 0, 0, 0, 0 };
  private.piano_win = { 3, 4, 2, 5, 1 };
  
  private.piano_sound_mmg = { 4,3,1,2,5,6,7 };
  private.piano_sound_hh = { 1,2,7,5,3,6,4 };

  --ObjMultiSet( table_multiset );
  -- key --
  for i = 1, 7 do
    table.insert( table_multiset, { "spr_piano_key_"..i, { 
    event_mdown = function() private.clk_key( i ) end
   }} );
  end;
  
  -- bass --
  
  
  for i = 1,3 do
    table.insert( table_multiset, { "obj_doublebasscoffer_circle_"..i, { 
    event_menter = function() private.EnterCode( i ) end,
    event_mleave = function() private.LeaveCode( i ) end,
    event_mdown = function() private.code_clk( i ) end,
    }} );
  end;
  
  private.code_start = { 2, 3, 4, 1 };
  private.code_win = {1, 2, 3, 4 };
  private.current = { 0, 0, 0, 0};
  private.pos = { 2, 34 };
  ObjMultiSet( table_multiset );
  
  -- loupe --
  
  private.loupe_mmg_win_pointer = 0;
  private.loupe_mmg_input_stop_drag = false;
  private.start_drag_auto = false;
  
  private.loupe_mmg_anim();

  for k = 1, 2 do
      
    for j = 1, 4 do
      
      ObjSet( "spr_offstage_loupe_mg_sign_"..k.."_"..j, { event_mdown = function() private.loupe_mmg_clk_sign( k, j ) end,
                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
      
    end;
      
  end;
                                                      
 -- loupe end --

  ObjMultiSet({ 
    { "spr_smallroomdoor_fragment_2", { event_mdown = private.get_fragment_2 }},  
    { "spr_doublebasscoffer_note", { event_mdown = private.get_note }},
    { "spr_doublebasscoffer_fragment_3", { event_mdown = private.get_fragment_3 }},
    { "spr_doublebasscoffer_signature", { event_mdown = private.get_signature }},
    { "spr_lightningequipment_battery", { event_mdown = private.get_battery }},
    { "spr_lightningequipment_adhesivetape", { event_mdown = private.get_adhesivetape }},
    { "spr_lightningequipment_gear", { event_mdown = private.get_gear }},
    { "spr_lightningequipment_2_lens", { event_mdown = private.get_lens }},
    { "spr_lightningequipment_2_bulb", { event_mdown = private.get_bulb }},
    { "spr_bedsidetable_device", { event_mdown = private.get_charneddevice }},
    { "spr_bedsidetable_code", { event_mdown = private.get_code }},
    { "spr_piano_fragment_4", { event_mdown = private.get_fragment_4 }},
    --{ "spr_offstage_defectivedevice", { event_mdown = private.get_defectivedevice }},
    { "obj_lightningequipment_use_picklock", { event_mdown = private.clk_box }},
    { "obj_smallroomdoor_clk_harpelement_old", { event_mdown = private.clk_harpelement_old }},
    { "spr_doublebasscoffer_message",             { event_mdown = function () common_impl.NoteScale( "open", "spr_doublebasscoffer_message" ); common_impl.ShowBbt( 'bbt_doublebasscoffer_memo_open') end }},    
    { "spr_doublebasscoffer_message_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_doublebasscoffer_message" ); common_impl.ShowBbt( 'bbt_doublebasscoffer_memo_close') end } },
    { "spr_bedsidetable_newspaper",             { event_mdown = function () common_impl.NoteScale( "open", "spr_bedsidetable_newspaper" );common_impl.ShowBbt( 'bbt_bedsidetable_newspaper', 1 ); end }},    
    { "spr_bedsidetable_newspaper_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_bedsidetable_newspaper" ); end } },
    --{ "spr_lightningequipment_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_lightningequipment_note" ) end }},    
    --{ "spr_lightningequipment_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_lightningequipment_note" ); common_impl.ShowBbt( 'bbt_lightningequipment_note', 1 ); end } },
    { "obj_lightningequipment_clk_note",         { event_mdown = function () private.NoteScale( "open",   "spr_lightningequipment_note" ); common_impl.ShowBbt( 'bbt_map_memo_1' ); end   } },    
    { "spr_lightningequipment_note_big",     { event_mdown = function () private.NoteScale( "change", "obj_lightningequipment_clk_note" )  end                                            } },
    { "spr_doublebasscoffer_left_1",   { event_mdown = function() private.clk_code( 'left',   2 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_center_1", { event_mdown = function() private.clk_code( 'center', 2 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_right_1",  { event_mdown = function() private.clk_code( 'right',  2 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_left_2",   { event_mdown = function() private.clk_code( 'left',   3 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_center_2", { event_mdown = function() private.clk_code( 'center', 3 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_right_2",  { event_mdown = function() private.clk_code( 'right',  1 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },  
    { "spr_doublebasscoffer_left_3",   { event_mdown = function() private.clk_code( 'left',   1 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_doublebasscoffer_center_3", { event_mdown = function() private.clk_code( 'center', 1 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_lightningequipment_use_rerolledcane", { event_mdown = private.clk_stairs }},
    { "obj_bedsidetable_use_fragment", { event_mdown = function() private.ShowBbt( "fragment" ) end } },
    { "spr_lightningequipment_2_spotlight", { event_mdown = function() private.clk_spotlight(nil) end }},
    { "obj_lightningequipment_2_use_screwdriver", { event_mdown = function() private.clk_spotlight("screw") end }},
    { "obj_lightningequipment_2_use_duster", { event_mdown = function() private.clk_spotlight("duster") end }},
    { "spr_offstage_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_lightningequipment_collect_2", { event_mdown = function () private.get_collect_2_1_6(); end,
                                            event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                            event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
    { "spr_doublebasscoffer_collect_2", { event_mdown = function () private.get_collect_2_1_2(); end,
                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
    --{ "obj_offstage_loupe_mg", { event_mdown = private.skip_loupe,
    --                             event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
    --                             event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } }
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_offstage = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then        
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_offstage_harproom",
    "gzz_offstage_doublebasscoffer",
    "gzz_offstage_piano",    
    "gzz_offstage_lightningequipment_2",
    "gzz_offstage_smallroomdoor", 
    "gzz_offstage_lightningequipment", 
    "gzz_offstage_bedsidetable"
  };
  
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_smallroomdoor",
    "zz_doublebasscoffer",
    "zz_lightningequipment",
    "zz_bedsidetable",
    "zz_piano",
    "zz_lightningequipment_2"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_offstage", update_game_mode_offstage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_offstage = function ()

  local effects_table = 
  {
    "obj_offstage_anim",
    "spr_offstage_lightningequioment_light",
    "spr_doublebasscoffer_light",
    "spr_lightningequipment_light",
    "spr_piano_light_add",
    "spr_bedsidetable_light_add",
    "spr_lightningequipment_2_light",
    "anm_lightningequipment_2_light"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_offstage", update_performance_mode_offstage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_offstage () end;
  --------------------------------------------------------------------------------------------
  local opn_offstage_map = function ()

    common_impl.VisitMapRoom( "offstage" );

  end;
  cmn.AddSubscriber( "opn_offstage", opn_offstage_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_fragment_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fragment_2" ] = {
    type = "get",
    get_obj = "spr_smallroomdoor_fragment_2",
    room = private.room_objname,
    zz = "zz_smallroomdoor",
    zz_gate = "gzz_offstage_smallroomdoor"
  };
    
  local get_fragment_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_fragment_2", "spr_smallroomdoor_fragment_2" );
  
  end;
  
  local get_fragment_2_closezz = function ()
  
    ObjDelete( "gfx_smallroomdoor_fragment_2" );
    ObjDelete( "spr_smallroomdoor_fragment_2_shadow" );
    ObjDelete( "spr_smallroomdoor_fragment_2_over" );
  
  end;
  
  cmn.AddSubscriber( "get_fragment_2", get_fragment_2_inv );
  cmn.AddSubscriber( "get_fragment_2", get_fragment_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_note () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_note" ] = {
    type = "get",
    get_obj = "spr_doublebasscoffer_note",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
    
  local get_note_inv = function ()
  
    interface.InventoryItemAdd( "inv_note", "spr_doublebasscoffer_note" );
  
  end;
  
  local get_note_closezz = function ()
  
    ObjDelete( "gfx_doublebasscoffer_note" );
    ObjDelete( "spr_doublebasscoffer_note_shadow" );
    ObjDelete( "spr_offstage_doublebasscoffer_notes");
  
  end;
  
  cmn.AddSubscriber( "get_note", get_note_inv );
  cmn.AddSubscriber( "get_note", get_note_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fragment_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fragment_3" ] = {
    type = "get",
    get_obj = "spr_doublebasscoffer_fragment_3",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
    
  local get_fragment_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_fragment_3", "spr_doublebasscoffer_fragment_3" );
  
  end;
  
  local get_fragment_3_closezz = function ()
  
    ObjDelete( "gfx_doublebasscoffer_fragment_3" );
    ObjDelete( "spr_offstage_doublebasscoffer_fragment" );
    --ObjDelete( "gzz_offstage_doublebasscoffer" );
  
  end;
  
  cmn.AddSubscriber( "get_fragment_3", get_fragment_3_inv );
  cmn.AddSubscriber( "get_fragment_3", get_fragment_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_signature () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_signature" ] = {
    type = "get",
    get_obj = "spr_doublebasscoffer_signature",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
    
  local get_signature_inv = function ()
  
    interface.InventoryItemAdd( "inv_signature", "spr_doublebasscoffer_signature" );
  
  end;
  
  local get_signature_closezz = function ()
  
    ObjDelete( "gfx_doublebasscoffer_signature" );
    ObjDelete( "spr_doublebasscoffer_signature_shadow" );
    ObjDelete( "spr_offstage_doublebasscoffer_signature");
    ObjDelete( "spr_doublebasscoffer_signature_over");
    
    --if common_impl.IsGetCollect( "get_collect_2_1_2" ) then
    --
    --  ObjDelete( "gzz_offstage_doublebasscoffer" );
    --  
    --end;
   
  end;
  
  cmn.AddSubscriber( "get_signature", get_signature_inv );
  cmn.AddSubscriber( "get_signature", get_signature_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery" ] = {
    type = "get",
    get_obj = "spr_lightningequipment_battery",
    room = private.room_objname,
    zz = "zz_lightningequipment",
    zz_gate = "gzz_offstage_lightningequipment"
  };
    
  local get_battery_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery", "spr_lightningequipment_battery" );
    ObjSet("spr_device_plus_light", { alp = 1});
    
  end;
  
  local get_battery_closezz = function ()
  
    ObjDelete( "gfx_lightningequipment_battery" );
    ObjDelete( "spr_lightningequipment_battery_shadow" );
    ObjDelete( "spr_offstage_lightningequioment_battery");
  
  end;
  
  cmn.AddSubscriber( "get_battery", get_battery_inv );
  cmn.AddSubscriber( "get_battery", get_battery_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adhesivetape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_adhesivetape" ] = {
    type = "get",
    get_obj = "spr_lightningequipment_adhesivetape",
    room = private.room_objname,
    zz = "zz_lightningequipment",
    zz_gate = "gzz_offstage_lightningequipment"
  };
    
  local get_adhesivetape_inv = function ()
  
    interface.InventoryItemAdd( "inv_adhesivetape", "spr_lightningequipment_adhesivetape" );
    --ObjSet( "spr_cane_plus_light",{alp = 1});
  
  end;
  
  local get_adhesivetape_closezz = function ()
  
    ObjDelete( "gfx_lightningequipment_adhesivetape" );
    ObjDelete( "spr_lightningequipment_adhesivetape_shadow" );
    ObjDelete( "spr_offstage_lightningequioment_scotch");
    ObjSet( "obj_lightningequipment_use_picklock",{ input = true });
  
  end;
  
  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_inv );
  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear" ] = {
    type = "get",
    get_obj = "spr_lightningequipment_gear",
    room = private.room_objname,
    zz = "zz_lightningequipment",
    zz_gate = "gzz_offstage_lightningequipment"
  };
    
  local get_gear_inv = function ()
  
    interface.InventoryItemAdd( "inv_gear", "spr_lightningequipment_gear" );
  
  end;
  
  local get_gear_closezz = function ()
  
    ObjDelete( "gfx_lightningequipment_gear" );
    ObjDelete( "spr_offstage_lightningequioment_cog");
    ObjDelete( "spr_lightningequipment_gear_over" );
  
  end;
  
  cmn.AddSubscriber( "get_gear", get_gear_inv );
  cmn.AddSubscriber( "get_gear", get_gear_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lens () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lens" ] = {
    type = "get",
    get_obj = "spr_lightningequipment_2_lens",
    room = private.room_objname,
    zz = "zz_lightningequipment_2",
    zz_gate = "gzz_offstage_lightningequipment_2"
  };
    
  local get_lens_inv = function ()
  
    interface.InventoryItemAdd( "inv_lens", "spr_lightningequipment_2_lens" );
    ObjSet("spr_defectivedevice_plus_light",{ alp = 1});
  
  end;
  
  local get_lens_closezz = function ()
  
    ObjSet("obj_lightningequipment_2_use_duster", { input = true });
    ObjSet("anm_lightningequipment_2_bulb", { alp = 1 });
    --ObjDelete( "anm_lightningequipment_2_light" );
    ObjDelete( "gfx_lightningequipment_2_lens" );
    if ( cmn.IsEventDone( "get_bulb" ) ) then
      ObjDelete( "gzz_offstage_lightningequipment_2" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lens", get_lens_inv );
  cmn.AddSubscriber( "get_lens", get_lens_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bulb" ] = {
    type = "get",
    get_obj = "spr_lightningequipment_2_bulb",
    room = private.room_objname,
    zz = "zz_lightningequipment_2",
    zz_gate = "gzz_offstage_lightningequipment_2"
  };
    
  local get_bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulb", "spr_lightningequipment_2_bulb" );
    ObjSet("spr_lantern_plus_light",{ alp = 1 });
  
  end;
  
  local get_bulb_closezz = function ()
  
    ObjDelete( "gfx_lightningequipment_2_bulb" );
    ObjDelete( "spr_offstage_lightningequioment_bulb" );
    ObjDelete( "spr_offstage_lamp_5" )
    if ( cmn.IsEventDone( "get_lens" ) ) then
      ObjDelete( "gzz_offstage_lightningequipment_2" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bulb", get_bulb_inv );
  cmn.AddSubscriber( "get_bulb", get_bulb_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charneddevice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charneddevice" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_device",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
    
  local get_charneddevice_inv = function ()
  
    --interface.InventoryItemAdd( "inv_workingdevice", "spr_bedsidetable_device" );
    ObjSet( "spr_int_button_apparat_apparat", { alp = 1 } );
    ObjSet( "obj_int_button_apparat", { input = true } );
    ObjDelete( "spr_bedsidetable_device" );
    
  end;
  
  local get_charneddevice_closezz = function ()
  
    ObjDelete( "gfx_bedsidetable_device" );
    --ObjDelete( "gzz_offstage_bedsidetable" );
    ObjSet( "spr_bedsidetable_newspaper", { active = true, input = true });
  
  end;
  
  cmn.AddSubscriber( "get_charneddevice", get_charneddevice_inv );
  cmn.AddSubscriber( "get_charneddevice", get_charneddevice_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_code" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_code",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
    
  local get_code_inv = function ()
  
    interface.InventoryItemAdd( "inv_code", "spr_bedsidetable_code" );
  
  end;
  
  local get_code_closezz = function ()
  
    ObjDelete( "gfx_bedsidetable_code" );
    --ObjDelete( "gzz_offstage_bedsidetable" );
  
  end;
  
  cmn.AddSubscriber( "get_code", get_code_inv );
  cmn.AddSubscriber( "get_code", get_code_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fragment_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fragment_4" ] = {
    type = "get",
    get_obj = "spr_piano_fragment_4",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_offstage_piano"
  };
    
  local get_fragment_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_fragment_4", "spr_piano_fragment_4" );
  
  end;
  
  local get_fragment_4_closezz = function ()
  
    ObjDelete( "gfx_piano_fragment_4" );
    ObjDelete("spr_piano_fragment_4_shadow");
    --ObjDelete( "gzz_offstage_piano" );
  
  end;
  
  cmn.AddSubscriber( "get_fragment_4", get_fragment_4_inv );
  cmn.AddSubscriber( "get_fragment_4", get_fragment_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_defectivedevice () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "get_defectivedevice" ] = {
  --  type = "get",
  --  get_obj = "spr_offstage_defectivedevice",
  --  room = "int_investigation_button",
    --zz = "zz_offstage",
    --zz_gate = "gzz_offstage_offstage"
  --};
    
  local get_defectivedevice_inv = function ()
  
    interface.InventoryItemAdd( "inv_defectivedevice", "spr_int_button_apparat_get" );
    ObjDelete( "anm_apparat_get" );
    ObjSet("inv_defectivedevice", { drag = false });
    
  end;
  
  local get_defectivedevice_closezz = function ()
  
    ObjDelete( "gfx_offstage_defectivedevice" );
    --ObjDelete( "gzz_offstage_offstage" );
  
  end;

  local get_defectivedevice_deploy = function ()
  
    ObjDelete( "anm_deploy_defectivedevice_broke" );
    ObjSet( "obj_deploy_defectivedevice", { alp = 1 } );
    ObjSet( "obj_int_button_apparat", { input = false } );
    
  end;
  
  cmn.AddSubscriber( "get_defectivedevice", get_defectivedevice_inv );
  cmn.AddSubscriber( "get_defectivedevice_inv", get_defectivedevice_inv );
  cmn.AddSubscriber( "get_defectivedevice", get_defectivedevice_deploy );
  cmn.AddSubscriber( "get_defectivedevice_deploy", get_defectivedevice_deploy );
  cmn.AddSubscriber( "get_defectivedevice", get_defectivedevice_deploy );
  cmn.AddSubscriber( "get_defectivedevice", get_defectivedevice_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_offstage_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_6 = function ()
 
    ObjDelete( "spr_lightningequipment_collect_2" );
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_6", get_collect_2_1_6, private.room_objname );
  
  local get_collect_2_1_2 = function ()
 
    ObjDelete( "spr_doublebasscoffer_collect_2" );

    --if cmn.IsEventDone( "get_signature" ) then
    --  
    --  --ObjDelete( "gzz_offstage_doublebasscoffer" );
    --  
    --end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_2", get_collect_2_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_harpelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_harpelement" ] = {
    type = "use",
    inv_obj = "inv_harpelement",
    use_place = "obj_smallroomdoor_use_harpelement",
    room = private.room_objname,
    zz = "zz_smallroomdoor",
    zz_gate = "gzz_offstage_smallroomdoor"
  };
  local use_harpelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_harpelement" );
  
  end;
  local use_harpelement_beg = function ()
  
    ObjDelete( "obj_smallroomdoor_use_harpelement" );
  
  end;
  local use_harpelement_end = function ()
  
    ObjDelete( "gzz_offstage_smallroomdoor" );
    ObjSet( "gmg_offstage_harproom", { input = true, visible = true, active = true } );
    ObjSet( "spr_smallroomdoor_harpelement", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_harpelement", use_harpelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_harpelement", use_harpelement_inv );
  cmn.AddSubscriber( "use_harpelement", use_harpelement_end, private.room_objname );
  cmn.AddSubscriber( "use_harpelement_inv", use_harpelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_harpelement_beg", use_harpelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_harpelement_end", use_harpelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_code" ] = {
    type = "use",
    inv_obj = "inv_code",
    use_place = "obj_doublebasscoffer_use_code",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
  local use_code_inv = function ()
  
    interface.InventoryItemRemove( "inv_code" );
  
  end;
  local use_code_beg = function ()
  
    ObjDelete( "obj_doublebasscoffer_use_code" );
  
  end;
  local use_code_end = function ()
  
    ObjSet( "spr_doublebasscoffer_code", { alp = 1 } );
    ObjSet( "obj_doublebasscoffer_coffer", { input = true } );
    ObjSet( "spr_offstage_doublebasscoffer_sheet", { alp = 1 });
    ObjSet( "obj_doublebasscoffer_mmg", { alp = 1 });
   
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code", use_code_inv );
  cmn.AddSubscriber( "use_code", use_code_end, private.room_objname );
  cmn.AddSubscriber( "use_code_inv", use_code_inv, private.room_objname );
  cmn.AddSubscriber( "use_code_beg", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code_end", use_code_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter_1" ] = {
    type = "use",
    inv_obj = "inv_letter_1",
    use_place = "obj_doublebasscoffer_use_letter_1",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
  local use_letter_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter_1" );
  
  end;
  local use_letter_1_beg = function ()
  
    ObjDelete( "obj_doublebasscoffer_use_letter_1" );
  
  end;
  local use_letter_1_end = function ()
  
    ObjSet("spr_doublebasscoffer_letter_1", { alp = 1 });
    if ( cmn.IsEventDone("use_letter_2") ) then
      
      ObjDelete( "spr_doublebasscoffer_letter_1" ); 
      ObjDelete( "spr_doublebasscoffer_letter_2" ); 
      ObjSet( "spr_doublebasscoffer_open", { input = true, alp = 1 } );
      ObjSet( "spr_offstage_doublebasscoffer_open", { alp = 1});
      ObjSet( "spr_offstage_doublebasscoffer_open_compartment", { alp = 1});
      ObjSet( "spr_offstage_doublebasscoffer_signature", { alp = 1});
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter_1", use_letter_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_1", use_letter_1_inv );
  cmn.AddSubscriber( "use_letter_1", use_letter_1_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_1_inv", use_letter_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_1_beg", use_letter_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_1_end", use_letter_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter_2" ] = {
    type = "use",
    inv_obj = "inv_letter_2",
    use_place = "obj_doublebasscoffer_use_letter_2",
    room = private.room_objname,
    zz = "zz_doublebasscoffer",
    zz_gate = "gzz_offstage_doublebasscoffer"
  };
  local use_letter_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter_2" );
  
  end;
  local use_letter_2_beg = function ()
  
    ObjDelete( "obj_doublebasscoffer_use_letter_2" );
  
  end;
  local use_letter_2_end = function ()
  
    ObjSet("spr_doublebasscoffer_letter_2", { alp = 1 });
    if ( cmn.IsEventDone("use_letter_1") ) then
      
      ObjDelete( "spr_doublebasscoffer_letter_1" ); 
      ObjDelete( "spr_doublebasscoffer_letter_2" ); 
      ObjSet( "spr_doublebasscoffer_open", { input = true, alp = 1 } );
      ObjSet( "spr_offstage_doublebasscoffer_open", { alp = 1});
      ObjSet( "spr_offstage_doublebasscoffer_open_compartment", { alp = 1});
      ObjSet( "spr_offstage_doublebasscoffer_signature", { alp = 1});
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter_2", use_letter_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_2", use_letter_2_inv );
  cmn.AddSubscriber( "use_letter_2", use_letter_2_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_2_inv", use_letter_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_2_beg", use_letter_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_2_end", use_letter_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_picklock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_picklock" ] = {
    type = "use",
    inv_obj = "inv_picklock",
    use_place = "obj_lightningequipment_use_picklock",
    room = private.room_objname,
    zz = "zz_lightningequipment",
    zz_gate = "gzz_offstage_lightningequipment"
  };
  local use_picklock_inv = function ()
  
    interface.InventoryItemRemove( "inv_picklock" );
  
  end;
  local use_picklock_beg = function ()
  
    ObjDelete( "obj_lightningequipment_use_picklock" );
  
  end;
  local use_picklock_end = function ()
  
    ObjDelete( "anm_lightningequipment_latchkey" );
    ObjDelete( "spr_lightningequipment_close" );
    ObjDelete( "spr_offstage_lightningequioment_suitcase");
    ObjSet( "spr_offstage_lightningequioment_suitcase_open", { alp = 1 });
    ObjSet( "spr_lightningequipment_gear", { input = true, active = true } );
    ObjSet( "spr_lightningequipment_open", { input = true, alp = 1 } );
    ObjSet( "obj_lightningequipment_clk_note", { input = true });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_picklock", use_picklock_beg, private.room_objname );
  cmn.AddSubscriber( "use_picklock", use_picklock_inv );
  cmn.AddSubscriber( "use_picklock", use_picklock_end, private.room_objname );
  cmn.AddSubscriber( "use_picklock_inv", use_picklock_inv, private.room_objname );
  cmn.AddSubscriber( "use_picklock_beg", use_picklock_beg, private.room_objname );
  cmn.AddSubscriber( "use_picklock_end", use_picklock_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rerolledcane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rerolledcane" ] = {
    type = "use",
    inv_obj = "inv_rerolledcane",
    use_place = "obj_lightningequipment_use_rerolledcane",
    room = private.room_objname,
    zz = "zz_lightningequipment",
    zz_gate = "gzz_offstage_lightningequipment"
  };
  local use_rerolledcane_inv = function ()
  
    interface.InventoryItemRemove( "inv_rerolledcane" );
  
  end;
  local use_rerolledcane_beg = function ()
  
    ObjDelete( "obj_lightningequipment_use_rerolledcane" );
  
  end;
  local use_rerolledcane_end = function ()
    
    ObjDelete( "spr_lightningequipment_stairs_1" );
    ObjSet( "spr_lightningequipment_stairs_2", { input = true, visible = true } );
    ObjSet( "gzz_offstage_lightningequipment_2", { active = true, input = true } );
    ObjDelete( "gzz_offstage_lightningequipment" );
    ObjDelete( "spr_offstage_lightningequioment_stairs_1");
    ObjSet( "spr_offstage_lightningequioment_stairs", { alp = 1});

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rerolledcane", use_rerolledcane_beg, private.room_objname );
  cmn.AddSubscriber( "use_rerolledcane", use_rerolledcane_inv );
  cmn.AddSubscriber( "use_rerolledcane", use_rerolledcane_end, private.room_objname );
  cmn.AddSubscriber( "use_rerolledcane_inv", use_rerolledcane_inv, private.room_objname );
  cmn.AddSubscriber( "use_rerolledcane_beg", use_rerolledcane_beg, private.room_objname );
  cmn.AddSubscriber( "use_rerolledcane_end", use_rerolledcane_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_lightningequipment_2_use_screwdriver",
    room = private.room_objname,
    zz = "zz_lightningequipment_2",
    zz_gate = "gzz_offstage_lightningequipment_2"
  };
  local use_screwdriver_inv = function ()
  
    interface.InventoryItemRemove( "inv_screwdriver" );
  
  end;
  local use_screwdriver_beg = function ()
  
    ObjDelete( "obj_lightningequipment_2_use_screwdriver" );
  
  end;
  local use_screwdriver_end = function ()
  
    ObjSet( "spr_lightningequipment_2_lens", { input = true } );
    ObjSet( "gfx_lightningequipment_2_lens", { active = true } );
    ObjDelete( "vid_lightningequipment_2_screw" );
    ObjDelete( "spr_offstage_lightningequioment_lens");
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_inv );
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_inv", use_screwdriver_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_beg", use_screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_end", use_screwdriver_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_duster () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_duster" ] = {
    type = "use",
    inv_obj = "inv_duster",
    use_place = "obj_lightningequipment_2_use_duster",
    room = private.room_objname,
    zz = "zz_lightningequipment_2",
    zz_gate = "gzz_offstage_lightningequipment_2"
  };
  local use_duster_inv = function ()
  
    interface.InventoryItemRemove( "inv_duster" );
  
  end;
  local use_duster_beg = function ()
  
    ObjDelete( "obj_lightningequipment_2_use_duster" );
  
  end;
  local use_duster_end = function ()
  
    ObjDelete( "anm_lightningequipment_2_bulb" );
    ObjDelete( "anm_lightningequipment_2_light" )
    ObjSet( "gfx_lightningequipment_2_bulb", { active = true } );
    ObjSet( "spr_lightningequipment_2_bulb", { input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_duster", use_duster_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster", use_duster_inv );
  cmn.AddSubscriber( "use_duster", use_duster_end, private.room_objname );
  cmn.AddSubscriber( "use_duster_inv", use_duster_inv, private.room_objname );
  cmn.AddSubscriber( "use_duster_beg", use_duster_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_end", use_duster_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fragment_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fragment_1" ] = {
    type = "use",
    inv_obj = "inv_fragment_1",
    use_place = "obj_bedsidetable_use_fragment",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_fragment_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_fragment_1" );
  
  end;
  local use_fragment_1_beg = function ()
  
  --ObjDelete( "obj_bedsidetable_use_fragment_1" );
  
  end;
  local use_fragment_1_end = function ()
  
    if ( cmn.IsEventDone( "use_fragment_2" ) and cmn.IsEventDone( "use_fragment_3" ) 
    and cmn.IsEventDone( "use_fragment_4" ) ) then

      ObjSet( "obj_bedsidetable_use_adhesivetape", { input = true } );
      ObjDelete( "obj_bedsidetable_use_fragment" );
    end;
    ObjSet("spr_bedsidetable_fragment_1", { alp = 1});
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fragment_1", use_fragment_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_1", use_fragment_1_inv );
  cmn.AddSubscriber( "use_fragment_1", use_fragment_1_end, private.room_objname );
  cmn.AddSubscriber( "use_fragment_1_inv", use_fragment_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fragment_1_beg", use_fragment_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_1_end", use_fragment_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fragment_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fragment_2" ] = {
    type = "use",
    inv_obj = "inv_fragment_2",
    use_place = "obj_bedsidetable_use_fragment",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_fragment_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_fragment_2" );
  
  end;
  local use_fragment_2_beg = function ()
  
  --ObjDelete( "obj_bedsidetable_use_fragment_2" );
  
  end;
  local use_fragment_2_end = function ()
  
    if ( cmn.IsEventDone( "use_fragment_1" ) and cmn.IsEventDone( "use_fragment_3" ) 
    and cmn.IsEventDone( "use_fragment_4" ) ) then

      ObjSet( "obj_bedsidetable_use_adhesivetape", { input = true } );
      ObjDelete( "obj_bedsidetable_use_fragment" );
  
    end;
    ObjSet("spr_bedsidetable_fragment_2", { alp = 1});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fragment_2", use_fragment_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_2", use_fragment_2_inv );
  cmn.AddSubscriber( "use_fragment_2", use_fragment_2_end, private.room_objname );
  cmn.AddSubscriber( "use_fragment_2_inv", use_fragment_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fragment_2_beg", use_fragment_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_2_end", use_fragment_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fragment_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fragment_3" ] = {
    type = "use",
    inv_obj = "inv_fragment_3",
    use_place = "obj_bedsidetable_use_fragment",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_fragment_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_fragment_3" );
  
  end;
  local use_fragment_3_beg = function ()
  
  --ObjDelete( "obj_bedsidetable_use_fragment_3" );
  
  end;
  local use_fragment_3_end = function ()
  
    if ( cmn.IsEventDone( "use_fragment_1" ) and cmn.IsEventDone( "use_fragment_2" ) 
    and cmn.IsEventDone( "use_fragment_4" ) ) then

      ObjSet( "obj_bedsidetable_use_adhesivetape", { input = true } );
      ObjDelete( "obj_bedsidetable_use_fragment" );

    end;
    ObjSet("spr_bedsidetable_fragment_3", { alp = 1});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fragment_3", use_fragment_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_3", use_fragment_3_inv );
  cmn.AddSubscriber( "use_fragment_3", use_fragment_3_end, private.room_objname );
  cmn.AddSubscriber( "use_fragment_3_inv", use_fragment_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_fragment_3_beg", use_fragment_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_3_end", use_fragment_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adhesivetape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_adhesivetape" ] = {
    type = "use",
    inv_obj = "inv_adhesivetape",
    use_place = "obj_bedsidetable_use_adhesivetape",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_adhesivetape_inv = function ()
  
  --interface.InventoryItemRemove( "inv_adhesivetape" );
  
  end;
  local use_adhesivetape_beg = function ()
  
    ObjDelete( "obj_bedsidetable_use_adhesivetape" );
  
  end;
  local use_adhesivetape_end = function ()
  
  ObjSet( "spr_bedsidetable_code", { input = true, alp = 1 } );
  ObjSet( "gfx_bedsidetable_code", { active = true } );
  ObjDelete( "obj_bedsidetable_fragment");
  ObjDelete( "anm_bedsidetable_adhesivetape");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_inv );
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_end, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_inv", use_adhesivetape_inv, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_beg", use_adhesivetape_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_end", use_adhesivetape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dischargeddevice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dischargeddevice" ] = {
    type = "use",
    inv_obj = "inv_dischargeddevice",
    use_place = "obj_bedsidetable_use_dischargeddevice",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_dischargeddevice_inv = function ()
  
    interface.InventoryItemRemove( "inv_dischargeddevice" );
  
  end;
  local use_dischargeddevice_beg = function ()
  
    ObjDelete( "obj_bedsidetable_use_dischargeddevice" );
  
  end;
  local use_dischargeddevice_end = function ()
  
    ObjSet( "spr_bedsidetable_device", { input = true, alp = 1 } );
    ObjSet( "spr_bedsidetable_newspaper", { active = false, input = false});
    ObjSet( "gfx_bedsidetable_device", { active = true } );
    ObjDelete( "anm_bedsidetable_dischargeddevice" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dischargeddevice", use_dischargeddevice_beg, private.room_objname );
  cmn.AddSubscriber( "use_dischargeddevice", use_dischargeddevice_inv );
  cmn.AddSubscriber( "use_dischargeddevice", use_dischargeddevice_end, private.room_objname );
  cmn.AddSubscriber( "use_dischargeddevice_inv", use_dischargeddevice_inv, private.room_objname );
  cmn.AddSubscriber( "use_dischargeddevice_beg", use_dischargeddevice_beg, private.room_objname );
  cmn.AddSubscriber( "use_dischargeddevice_end", use_dischargeddevice_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fragment_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fragment_4" ] = {
    type = "use",
    inv_obj = "inv_fragment_4",
    use_place = "obj_bedsidetable_use_fragment",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_offstage_bedsidetable"
  };
  local use_fragment_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_fragment_4" );
  
  end;
  local use_fragment_4_beg = function ()
  
  --ObjDelete( "obj_bedsidetable_use_fragment_4" );
  
  end;
  local use_fragment_4_end = function ()
  
    if ( cmn.IsEventDone( "use_fragment_1" ) and cmn.IsEventDone( "use_fragment_2" ) 
    and cmn.IsEventDone( "use_fragment_3" ) ) then

      ObjSet( "obj_bedsidetable_use_adhesivetape", { input = true } );
      ObjDelete( "obj_bedsidetable_use_fragment" );

    end;
    ObjSet( "spr_bedsidetable_fragment_4", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fragment_4", use_fragment_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_4", use_fragment_4_inv );
  cmn.AddSubscriber( "use_fragment_4", use_fragment_4_end, private.room_objname );
  cmn.AddSubscriber( "use_fragment_4_inv", use_fragment_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_fragment_4_beg", use_fragment_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_fragment_4_end", use_fragment_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_key" ] = {
    type = "use",
    inv_obj = "inv_key",
    use_place = "obj_piano_use_key",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_offstage_piano"
  };
  local use_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_key" );
  
  end;
  local use_key_beg = function ()
  
    ObjDelete( "obj_piano_use_key" );
  
  end;
  local use_key_end = function ()
  
  
    ObjSet("spr_piano_key",{ alp = 1});
    ObjSet("spr_piano_key_7", { input = true});
    
    if cmn.IsEventDone( "use_paperwithnotes" ) then
      
    ObjSet("obj_piano_mmg", {input = true, active = true });
    ObjDelete( "obj_piano_key");
    --ObjSet( "spr_piano_key", { input = true, visible = true, active = true } );
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_key", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key", use_key_inv );
  cmn.AddSubscriber( "use_key", use_key_end, private.room_objname );
  cmn.AddSubscriber( "use_key_inv", use_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_key_beg", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key_end", use_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_paperwithnotes () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_paperwithnotes" ] = {
    type = "use",
    inv_obj = "inv_paperwithnotes",
    use_place = "obj_piano_use_paperwithnotes",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_offstage_piano"
  };
  local use_paperwithnotes_inv = function ()
  
    interface.InventoryItemRemove( "inv_paperwithnotes" );
  
  end;
  local use_paperwithnotes_beg = function ()
  
    ObjDelete( "obj_piano_use_paperwithnotes" );
  
  end;
  local use_paperwithnotes_end = function ()
  
  ObjSet( "spr_piano_paperwithnotes",{ alp = 1 });
    --ObjSet( "spr_offstage_piano_paper", { alp = 1 });
    --ObjSet( "anm_offstage_open_curtain", { alp = 1 });
    
    ObjDelete( "spr_offstage_piano" );
     if cmn.IsEventDone( "use_key" ) then
    
        ObjSet("obj_piano_mmg", {input = true, active = true });
        ObjDelete( "obj_piano_key");
    --ObjSet( "spr_piano_key", { input = true, visible = true, active = true } );
     end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_paperwithnotes", use_paperwithnotes_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperwithnotes", use_paperwithnotes_inv );
  cmn.AddSubscriber( "use_paperwithnotes", use_paperwithnotes_end, private.room_objname );
  cmn.AddSubscriber( "use_paperwithnotes_inv", use_paperwithnotes_inv, private.room_objname );
  cmn.AddSubscriber( "use_paperwithnotes_beg", use_paperwithnotes_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperwithnotes_end", use_paperwithnotes_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_charneddevice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_charneddevice" ] = {
  
    type = "click",
    use_place = "obj_int_button_apparat",
    room = private.room_objname
    
  };
  local use_charneddevice_inv = function ()
  
    --ObjSet( "spr_int_button_apparat_apparat", { alp = 0 } );
    --ObjSet( "obj_apparat_small", { input = false } );
    --ObjSet( "spr_int_button_apparat_get", { alp = 1, input = true } );
    --ObjSet("spr_int_button_apparat_get", {
    --event_mdown = function()    rm_offstage.get_defectivedevice() end,
    --  event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end,
    --  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
    --  input = true
    --});
    --ObjSet( "obj_int_button_apparat", { input = false } );
  
  end;
  local use_charneddevice_beg = function ()
  
    ObjDelete( "obj_offstage_use_device" );
  
  end;
  local use_charneddevice_end = function ()
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_charneddevice", use_charneddevice_beg, private.room_objname );
  cmn.AddSubscriber( "use_charneddevice", use_charneddevice_inv );
  cmn.AddSubscriber( "use_charneddevice", use_charneddevice_end, private.room_objname );
  cmn.AddSubscriber( "use_charneddevice_inv", use_charneddevice_inv, private.room_objname );
  cmn.AddSubscriber( "use_charneddevice_beg", use_charneddevice_beg, private.room_objname );
  cmn.AddSubscriber( "use_charneddevice_end", use_charneddevice_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_harpelement_old () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_harpelement_old" ] = {
  
    type = "click",
    use_place = "obj_smallroomdoor_clk_harpelement_old",
    room = private.room_objname,
    zz = "zz_smallroomdoor",
    zz_gate = "gzz_offstage_smallroomdoor"
    
  };
  local clk_harpelement_old = function ()

    ObjDelete( "obj_smallroomdoor_clk_harpelement_old" );
    ObjDelete( "obj_smallroomdoor_harpelement_old" );
    ObjSet( "obj_smallroomdoor_use_harpelement", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_harpelement_old", clk_harpelement_old, private.room_objname );
  --------------------------------------------------------------------------------------------  
  local opn_loc_door_end = function ()

    ObjMultiSet( { 
        { "grm_offstage_corridor",     { input = true, active = true, visible = true } },
        { "spr_offstage_piano_open", { alp = 1 }}
    } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_offstage_corridor_focus");
    end;
    ObjDelete( "anm_offstage_open_curtain" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_loc_door", opn_loc_door_end, private.room_objname  );
  cmn.AddSubscriber( "opn_loc_door_end", opn_loc_door_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function win_offstage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_offstage" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_offstage_loupe_mg",
  
  };

  local win_offstage = function ()
  
    if cmn.IsEventDone( "win_offstage" ) then

      ObjDelete( "obj_offstage_loupe_mg" );
      
    else
      
      for i = 1, 2 do
        
        for j = 1, 4 do
          
          for k = 1, 4 do
            
            if ng_global.progress["std"]["win_offstage"].saves[i][j][k] == 1 then
              
              local pos_star = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "obj_offstage_loupe_mg" );
              
              local pos_star_2 = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..(3-i).."_"..k, "obj_offstage_loupe_mg" );
              
              private.loupe_mmg_make_line( pos_star, pos_star_2, (3-i), k, i, j, true );
              
              private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
              
              ObjSet( "spr_offstage_loupe_mg_sign_"..(3-i).."_"..k.."_light", { alp = 1 } );
              
              ObjSet( "spr_offstage_loupe_mg_sign_"..i.."_"..j, { input = false } );
  
            end;
            
          end;
          
        end;
        
      end;
      
    end;
  
  end;

  cmn.AddSubscriber( "win_offstage", win_offstage, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function win_piano () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_piano" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_piano_mmg",
    zz_gate = "gzz_offstage_piano",
    zz = "zz_piano"

  };

  local win_piano = function ()
  
    if ( cmn.IsEventDone( "win_piano" ) ) then

        ObjSet( "grm_offstage_corridor", { active = true, input = true, visible = true });
        --ObjSet( "spr_offstage_piano_open", { alp = 1 });
        if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_offstage_corridor_focus");
        end;
        ObjDelete( "gzz_offstage_piano" );
        ObjDelete( "spr_offstage_piano" );
        
        --ObjDelete( "anm_offstage_open_curtain" );
     
    elseif ( cmn.IsEventStart( "win_piano" ) ) then

        private.piano_current = ng_global.progress[ "std" ][ "win_piano" ].array;
       
        for  i = 1, ng_global.progress[ "std" ][ "win_piano" ].pos - 1 do

          ObjSet("spr_piano_mmg_"..private.piano_win[i], { alp = 1 });
          ObjSet("spr_piano_mmg_"..private.piano_win[i], { input = false });
           
        end;

    end;
    
    --ObjDelete( "gzz_offstage_piano" );

  end;
  --local win_piano_end = function ()
  --
  -- ObjDelete("anm_offstage_piano_open");
  -- ObjSet("spr_offstage_piano_open", { alp = 1 });
  --
  --end;
  cmn.AddSubscriber( "win_piano", win_piano, private.room_objname ); 
  --cmn.AddSubscriber( "win_piano", win_piano_end, private.room_objname );
  --cmn.AddSubscriber( "win_piano_end", win_piano_end, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function win_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_code" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_doublebasscoffer_mmg",
    zz_gate = "gzz_offstage_doublebasscoffer",
    zz = "zz_doublebasscoffer"

  };

  local win_code = function ()

    if ( cmn.IsEventDone( "win_code" ) ) then

      ObjSet( "spr_doublebasscoffer_note", { active = true, input = true });
      ObjSet( "obj_doublebasscoffer_use_letter_1", { input = true });
      ObjSet( "obj_doublebasscoffer_use_letter_2", { input = true });
      ObjSet( "spr_doublebasscoffer_coffer_open", { input = true, alp = 1 });
      ObjDelete( "spr_doublebasscoffer_coffer" );
      ObjDelete( "spr_offstage_doublebasscoffer_close");
      ObjSet( "spr_offstage_doublebasscoffer_open",{ alp = 1});
      ObjSet( "spr_offstage_doublebasscoffer_notes",{ alp = 1});
      
    elseif ( cmn.IsEventStart( "win_code" ) and not cmn.IsEventDone( "win_code" ) ) then 
      
      ObjSet( "obj_doublebasscoffer_mmg", { alp = 1 });
      ObjAttach( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[1],"obj_doublebasscoffer_circle_1_turn");
      ObjAttach( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[2],"obj_doublebasscoffer_circle_1_turn" );
      ObjAttach( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[3],"obj_doublebasscoffer_circle_3_turn" );
      ObjAttach( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[4],"obj_doublebasscoffer_circle_3_turn" );
     
       for i = 1, 3  do
        
        ObjSet( "obj_doublebasscoffer_circle_"..i.."_turn", { ang = private.ang_set(ng_global.progress[ "std" ][ "win_code" ].state[i]) } );
         --ObjSet( "obj_doublebasscoffer_circle_"..i.."_turn", { ang = 0 } );
        ObjSet( "obj_doublebasscoffer_circle_"..i , { pos_z = 0 });
       end;
      if private.ang_set(ng_global.progress[ "std" ][ "win_code" ].state[1]) ~= 0 then 
         ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[1], { pos_x = 2, pos_y = 34 });
         ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[2], { pos_x = 2, pos_y = -34 });
      else
         ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[1], { pos_x = 2, pos_y = -34 });
         ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[2], { pos_x = 2, pos_y = 34 });
      end;
      if private.ang_set(ng_global.progress[ "std" ][ "win_code" ].state[3]) ~= 0 then 
        ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[3], { pos_x = 2, pos_y = 34 });
        ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[4], { pos_x = 2, pos_y = -34 });
      else
        ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[3], { pos_x = 2, pos_y = -34 });
        ObjSet( "spr_doublebasscoffer_element_"..ng_global.progress[ "std" ][ "win_code" ].current[4], { pos_x = 2, pos_y = 34 });
      end;
     
      
    
    end;
      

  end;

  cmn.AddSubscriber( "win_code", win_code, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_harproom () end;
  --------------------------------------------------------------------------------------------
  local win_harproom = function ()

    if ( cmn.IsEventDone( "win_harproom" ) ) then

      ObjDelete( "gmg_offstage_harproom" );

    end;

  end;

  cmn.AddSubscriber( "win_harproom", win_harproom, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function vid_offstage_loupe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_offstage_loupe" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_offstage_loupe",
  };

  local vid_offstage_loupe = function ()

    ObjSet( "gzz_offstage_piano", { input = true, active = true } );
    
    ObjSet( "spr_int_button_apparat_apparat", { alp = 0 } );
    ObjSet( "obj_apparat_small", { input = false } );
    ObjSet( "spr_int_button_apparat_get", { alp = 1, input = true } );
    ObjSet("spr_int_button_apparat_get", {
    event_mdown = function()    rm_offstage.get_defectivedevice() end,
      event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      input = true
    });
    ObjSet( "obj_int_button_apparat", { input = false } );
  
  end;

  cmn.AddSubscriber( "vid_offstage_loupe", vid_offstage_loupe );  

  --------------------------------------------------------------------------------------------
  -- function clk_smallroom_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_smallroom_door" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "spr_offstage_open_door",
    
  };

  local clk_smallroom_door = function ()

    ObjSet( "spr_offstage_open_door", { alp = 1 } );
    ObjSet( "grm_offstage_smallroom", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_offstage_smallroom_focus");
    end; 
  end;
  cmn.AddSubscriber( "clk_smallroom_door", clk_smallroom_door, private.room_objname );  
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_lightningequipment" );
  subroom.Define( "zz_piano" );
  subroom.Define( "zz_doublebasscoffer" );
  subroom.Define( "zz_smallroomdoor" );
  subroom.Define( "zz_bedsidetable" );
  --------------------------------------------------------------------------------------------
  function zz_lightningequipment.Close()

    if ( cmn.IsEventDone( "use_rerolledcane" ) ) then

      local func_after = function() cmn.GotoSubRoom( 'zz_lightningequipment_2', nil, { 512, 384 }, true ) end;

      ObjSet( "tmr_offstage_zzopen", { playing = true, time = 0.3, endtrig = func_after } );

    end;
    ObjSet( "obj_lightningequipment_note", { input = false, active = false, alp = 0 } );
    ObjSet( "spr_lightningequipment_note_big_1", { alp = 0 } );
    ObjSet( "obj_lightningequipment_note", { event_mdown = function() private.NoteScale( "change", "obj_lightningequipment_clk_note" ) end; } );
    ObjSet( "spr_lightningequipment_note_big", { alp = 1 } );
    ObjSet( "spr_lightningequipment_note", { alp = 1 } );
    
    common_impl.offstage.note = "close"; 
   
  end;
  --------------------------------------------------------------------------------------------
  function zz_lightningequipment.PreOpen()
    
    if not common_impl.offstage then

      common_impl.offstage = {}
      common_impl.offstage.note = "close";

    end;
    
  end;  
  --------------------------------------------------------------------------------------------
 function zz_piano.PreOpen()

    if ( cmn.IsEventDone( "use_paperwithnotes" ) and cmn.IsEventDone( "use_key" )) and not cmn.IsEventDone( "win_piano" ) then
    
      cmn.MiniGameShow( 'piano' );
      common_impl.PassingMgStart( "piano" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_piano.PreClose()

    if ( cmn.IsEventDone( "use_paperwithnotes" ) and cmn.IsEventDone( "use_key" )) and not cmn.IsEventDone( "win_piano" ) then

      cmn.MiniGameHide( 'piano' );
      common_impl.PassingMgStop( "piano" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_piano.Close()
    
    if  cmn.IsEventDone( "win_piano" ) then
    
      local func_after = function()

        common_impl.Lock( false );
        --ObjSet( "spr_offstage_piano_open", { alp = 1 });
        cmn.CallEventHandler( "opn_loc_door_end" );
        --ObjDelete( "anm_offstage_piano_open" );
        --ObjDelete( "anm_offstage_open_curtain" );
        
      end;

      common_impl.Lock( true );
      --ObjSet( "spr_offstage_piano", { alp = 0 });
      --ObjSet( "anm_offstage_piano_open", { alp = 1 } );
    
       --AnimPlay( "anm_offstage_piano_open", "DoAnim", func_after);
      AnimPlay( "anm_offstage_open_curtain", "DoAnim", func_after);
    
    end;
  end;  
  --------------------------------------------------------------------------------------------
 function zz_doublebasscoffer.PreOpen()

    if not common_impl.offstage then

      common_impl.offstage = {}
      common_impl.offstage.note = "close";

    end;
    
    if  ObjGet( "spr_doublebasscoffer_message" ).input == true then

      ObjSet( "spr_doublebasscoffer_message_big", { input = false, alp = 0 } );
      ObjSet( "spr_doublebasscoffer_message",     { alp = 1 } );
      
    end;
    
    if ( cmn.IsEventDone( "use_code" ) ) and not cmn.IsEventDone( "win_code" ) then
    
      cmn.MiniGameShow( 'code' );
      common_impl.PassingMgStart( "code" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_doublebasscoffer.PreClose()

    common_impl.offstage.note = "close"; 
    
    if ( cmn.IsEventDone( "use_code" ) ) and not cmn.IsEventDone( "win_code" ) then

      cmn.MiniGameHide( 'code' );
      common_impl.PassingMgStop( "code" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_bedsidetable.PreOpen()

    if not common_impl.offstage then

      common_impl.offstage = {}
      common_impl.offstage.note = "close";

    end;

    if  ObjGet( "spr_bedsidetable_newspaper" ).input == true then

      ObjSet( "spr_bedsidetable_newspaper_big", { input = false, alp = 0 } );
      ObjSet( "spr_bedsidetable_newspaper",     { alp = 1 } );
      
    end;

  end;

  function zz_bedsidetable.Close()

    common_impl.offstage.note = "close"; 

  end;
  --------------------------------------------------------------------------------------------  
  function zz_smallroomdoor.Close()

    if ( cmn.IsEventDone("use_harpelement") ) then
      
      ObjSet( "tmr_offstage_gotomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_harproom' ) end } );
      
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_offstage();
  
  common_impl.LoupeMgCheck();
  
  if cmn.IsEventDone( "get_charneddevice" ) then
    
    common_impl.TutorialShow( "tutorial_page_15" );
    
  end;

  
  if cmn.IsEventDone( "win_harproom" ) and not cmn.IsEventDone( "clk_smallroom_door" ) then
   
    local func_after  = function()
    
    common_impl.Lock( false );
      cmn.SetEventDone( "clk_smallroom_door" );
      cmn.CallEventHandler( "clk_smallroom_door" )
    end;
    
    common_impl.Lock( true );
    
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_win", 0, "", 0 );
    
    ObjAnimate("spr_offstage_open_door", "alp", 0, 0, func_after,
    { 
      0, 0, 0,
      0, 3, 1
    });
    
  end;
  
  if cmn.IsEventDone( "vid_offstage_loupe" ) and not cmn.IsEventDone( "get_defectivedevice" ) then
    
    public.get_defectivedevice();
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if not ng_global.progress["std"]["opn_offstage"].viewer then
    
    ng_global.progress["std"]["opn_offstage"].viewer = 1;
    
  elseif ng_global.progress["std"]["opn_offstage"].viewer < 4 then
    
    ng_global.progress["std"]["opn_offstage"].viewer = ng_global.progress["std"]["opn_offstage"].viewer + 1;
    
  end;
 
  common_impl.MorphItemMorphing(); 
  
  if cmn.IsEventDone( "win_piano") then
    
    ObjSet( "spr_offstage_piano_open", { alp = 1 });
    ObjDelete( "anm_offstage_open_curtain");
    
  end;  
  
  if not cmn.IsEventDone( "vid_offstage_vanishing" ) then

    ObjSet( "rm_offstage", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjSet( "tmr_offstage_vanishing",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_offstage_vanishing(); end
    } );

  end;
  
  if ng_global.progress["std"]["opn_offstage"].viewer == 4 then
    
    interface.Lock( true, 3 );
    ObjSet( "anm_offstage_man_seat", { alp = 0 } );
    ObjSet( "anm_offstage_man_run", { alp = 1 } );
    
    AnimPlay( "anm_offstage_man_run", "DoAnim", function() common_impl.ShowBbt( 'bbt_offstage_run_man' ); end );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_interactive_offstage_man", 0, "", 0 );
    ng_global.progress["std"]["opn_offstage"].viewer = ng_global.progress["std"]["opn_offstage"].viewer + 1;
    
  end;
  
  common_impl.EnvPlay( { "common/audio/level1/aud_offstage_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_harpelement()

  local item = "inv_harpelement";

  if ( common.ApplyObj( item, "obj_smallroomdoor_use_harpelement", true ) and cmn.IsEventDone( "get_fragment_2" ) and cmn.IsEventDone( "clk_harpelement_old" ) ) then

    cmn.CallEventHandler( "use_harpelement_inv" );
    cmn.CallEventHandler( "use_harpelement_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_harpelement" );
      cmn.CallEventHandler( "use_harpelement_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_string_smallroomdoor", 0, "", 0 );
    
    ObjAnimate( "spr_smallroomdoor_harpelement", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_smallroomdoor", false ) and cmn.IsEventDone( "get_fragment_2" )  and cmn.IsEventDone( "clk_harpelement_old" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_smallroomdoor", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_code()

  local item = "inv_code";

  if ( common.ApplyObj( item, "obj_doublebasscoffer_use_code", true ) ) then

    cmn.CallEventHandler( "use_code_inv" );
    cmn.CallEventHandler( "use_code_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_code" );
      cmn.CallEventHandler( "use_code_end" );

      cmn.MiniGameShow( 'code' );
      common_impl.PassingMgStart( "code" );
      ng_global.progress[ "std" ][ "win_code" ].state = { 0, 0, 0};
      ng_global.progress[ "std" ][ "win_code" ].current = { 0, 0, 0, 0};
      ng_global.progress[ "std" ][ "win_code" ].current = private.code_start;
      
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_code_doublebasscoffer", 0, "", 0 );
  
    ObjAnimate( "spr_doublebasscoffer_code", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_doublebasscoffer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doublebasscoffer", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_letter_1()

  local item = "inv_letter_1";

  if ( common.ApplyObj( item, "obj_doublebasscoffer_use_letter_1", true ) and (common_impl.offstage.note == "close") ) then

    cmn.CallEventHandler( "use_letter_1_inv" );
    cmn.CallEventHandler( "use_letter_1_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_letter_1" );
        cmn.CallEventHandler( "use_letter_1_end" );
   
      end;
    
      if ( cmn.IsEventDone("use_letter_2")) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_open_signature_doublebasscoffer", 0, "", 0 );
    
        ObjAnimate( "spr_doublebasscoffer_letter_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_doublebasscoffer_open", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
      else 
        
        func_end();
        
      end;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_letter_doublebasscoffer", 0, "", 0 );
    
    ObjAnimate( "spr_doublebasscoffer_letter_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_doublebasscoffer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doublebasscoffer", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_letter_2()

  local item = "inv_letter_2";

  if ( common.ApplyObj( item, "obj_doublebasscoffer_use_letter_2", true ) and (common_impl.offstage.note == "close") ) then

    cmn.CallEventHandler( "use_letter_2_inv" );
    cmn.CallEventHandler( "use_letter_2_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_letter_2" );
        cmn.CallEventHandler( "use_letter_2_end" );
   
      end;
    
      if ( cmn.IsEventDone("use_letter_1")) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level1/aud_open_signature_doublebasscoffer", 0, "", 0 );
    
        ObjAnimate( "spr_doublebasscoffer_letter_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_doublebasscoffer_open", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
      else 
        
        func_end();
        
      end;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_letter_doublebasscoffer", 0, "", 0 );
    
    ObjAnimate( "spr_doublebasscoffer_letter_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_doublebasscoffer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doublebasscoffer", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_picklock()

  local item = "inv_picklock";

  if ( common.ApplyObj( item, "obj_lightningequipment_use_picklock", true )  and (common_impl.offstage.note == "close")  ) then

    cmn.CallEventHandler( "use_picklock_inv" );
    cmn.CallEventHandler( "use_picklock_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_picklock" );
        cmn.CallEventHandler( "use_picklock_end" );
        
      end;

      ObjAnimate( "anm_lightningequipment_latchkey", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_lightningequipment_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } ); 
      
      ObjAnimate( "spr_lightningequipment_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } ); 
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_picklock_lightningequipment", 0, "", 0 );

    AnimPlay( "anm_lightningequipment_latchkey", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_lightningequipment", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lightningequipment", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rerolledcane()

  local item = "inv_rerolledcane";

  if ( common.ApplyObj( item, "obj_lightningequipment_use_rerolledcane", true ) and cmn.IsEventDone("get_adhesivetape") 
    and cmn.IsEventDone( "get_gear" ) and cmn.IsEventDone( "get_battery" ) and (common_impl.offstage.note == "close")) then

    cmn.CallEventHandler( "use_rerolledcane_inv" );
    cmn.CallEventHandler( "use_rerolledcane_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_rerolledcane" );
      cmn.CallEventHandler( "use_rerolledcane_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_cane_lightingequipment", 0, "", 0 );
    ObjSet( "spr_lightningequipment_stairs_1", { alp = 0 });
    ObjSet( "anm_lightningequipment_cane", { alp = 1 });
    AnimPlay( "anm_lightningequipment_cane", "DoAnim", func_after ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_lightningequipment", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lightningequipment", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver()

  local item = "inv_screwdriver";

  if ( common.ApplyObj( item, "obj_lightningequipment_2_use_screwdriver", true ) and cmn.IsEventDone( "use_rerolledcane" ) ) then

    cmn.CallEventHandler( "use_screwdriver_inv" );
    cmn.CallEventHandler( "use_screwdriver_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_screwdriver" );
      cmn.CallEventHandler( "use_screwdriver_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_screwdriver_lightingequipment", 0, "", 0 );
    VidPlay("vid_lightningequipment_2_screw", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_lightningequipment_2", false ) and cmn.IsEventDone( "use_rerolledcane" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lightningequipment_2", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_duster()

  local item = "inv_duster";

  if ( common.ApplyObj( item, "obj_lightningequipment_2_use_duster", true ) and cmn.IsEventDone("get_lens") and cmn.IsEventDone( "use_rerolledcane" ) ) then

    cmn.CallEventHandler( "use_duster_inv" );
    cmn.CallEventHandler( "use_duster_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_duster" );
      cmn.CallEventHandler( "use_duster_end" );
      private.get_bulb();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_duster_lightningequipment", 0, "", 0 );
    ObjSet("spr_lightningequipment_2_bulb", { alp = 0 });
    ObjSet("spr_lightningequipment_2_bulb_over", { alp = 0 });
    ObjAnimate( "anm_lightningequipment_2_light", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    AnimPlay( "anm_lightningequipment_2_bulb", "DoAnim", func_after );
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_lightningequipment_2", false ) and cmn.IsEventDone("get_lens") and cmn.IsEventDone( "use_rerolledcane" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lightningequipment_2", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fragment_1()

  local item = "inv_fragment_1";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_fragment", true ) ) and (common_impl.offstage.note == "close") then

    cmn.CallEventHandler( "use_fragment_1_inv" );
    cmn.CallEventHandler( "use_fragment_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fragment_1" );
      cmn.CallEventHandler( "use_fragment_1_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_fragment_bedsidetable", 0, "", 0 );
  
  ObjAnimate( "spr_bedsidetable_fragment_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fragment_2()

  local item = "inv_fragment_2";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_fragment", true ) ) and (common_impl.offstage.note == "close") then

    cmn.CallEventHandler( "use_fragment_2_inv" );
    cmn.CallEventHandler( "use_fragment_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fragment_2" );
      cmn.CallEventHandler( "use_fragment_2_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_fragment_bedsidetable", 0, "", 0 );
  
  ObjAnimate( "spr_bedsidetable_fragment_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fragment_3()

  local item = "inv_fragment_3";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_fragment", true ) ) and (common_impl.offstage.note == "close") then

    cmn.CallEventHandler( "use_fragment_3_inv" );
    cmn.CallEventHandler( "use_fragment_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fragment_3" );
      cmn.CallEventHandler( "use_fragment_3_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_fragment_bedsidetable", 0, "", 0 );
  
 ObjAnimate( "spr_bedsidetable_fragment_3", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_adhesivetape()

  local item = "inv_adhesivetape";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_adhesivetape", true ) and cmn.IsEventDone("use_fragment_1") and cmn.IsEventDone("use_fragment_2")
    and cmn.IsEventDone("use_fragment_3") and cmn.IsEventDone("use_fragment_4") and (common_impl.offstage.note == "close") ) then

    cmn.CallEventHandler( "use_adhesivetape_inv" );
    cmn.CallEventHandler( "use_adhesivetape_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_adhesivetape" );
      cmn.CallEventHandler( "use_adhesivetape_end" );
     
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_adhesivetape_bedsidetable", 0, "", 0 );
    
    ObjSet( "anm_bedsidetable_adhesivetape", { active = true, visible = true, alp = 1 } );
     
    AnimPlay( "anm_bedsidetable_adhesivetape", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) and cmn.IsEventDone("use_fragment_1") and cmn.IsEventDone("use_fragment_2")
    and cmn.IsEventDone("use_fragment_3") and cmn.IsEventDone("use_fragment_4") and not cmn.IsEventDone("use_adhesivetape") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dischargeddevice()

  local item = "inv_dischargeddevice";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_dischargeddevice", true ) ) and (common_impl.offstage.note == "close") then

    cmn.CallEventHandler( "use_dischargeddevice_inv" );
    cmn.CallEventHandler( "use_dischargeddevice_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_dischargeddevice" );
        cmn.CallEventHandler( "use_dischargeddevice_end" );
        
      end;
      
      
      ObjSet( "anm_bedsidetable_dischargeddevice", { active = true, visible = true } );
      
      AnimPlay( "anm_bedsidetable_dischargeddevice", "DoAnim", func_end );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_dischargeddevice_bedsidetable", 0, "", 0 );
  
    ObjAnimate( "spr_bedsidetable_device", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fragment_4()

  local item = "inv_fragment_4";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_fragment", true ) ) and (common_impl.offstage.note == "close") then

    cmn.CallEventHandler( "use_fragment_4_inv" );
    cmn.CallEventHandler( "use_fragment_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fragment_4" );
      cmn.CallEventHandler( "use_fragment_4_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_fragment_bedsidetable", 0, "", 0 );
  
  ObjAnimate( "spr_bedsidetable_fragment_4", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_bedsidetable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_key()

  local item = "inv_key";

  if ( common.ApplyObj( item, "obj_piano_use_key", true ) ) then

    cmn.CallEventHandler( "use_key_inv" );
    cmn.CallEventHandler( "use_key_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_key" );
      cmn.CallEventHandler( "use_key_end" );

      if ( cmn.IsEventDone( "use_paperwithnotes" ) ) then
        cmn.MiniGameShow( 'piano' );
        common_impl.PassingMgStart( "piano" );
        ng_global.progress[ "std" ][ "win_piano" ].pos = 1;
        ng_global.progress[ "std" ][ "win_piano" ].array = {0, 0, 0, 0, 0 };
      end;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_key_piano", 0, "", 0 );
  
  ObjAnimate( "spr_piano_key", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_piano", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_piano", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_paperwithnotes()

  local item = "inv_paperwithnotes";

  if ( common.ApplyObj( item, "obj_piano_use_paperwithnotes", true ) ) then

    cmn.CallEventHandler( "use_paperwithnotes_inv" );
    cmn.CallEventHandler( "use_paperwithnotes_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_paperwithnotes" );
      cmn.CallEventHandler( "use_paperwithnotes_end" );

      if ( cmn.IsEventDone( "use_key" ) ) then
        cmn.MiniGameShow( 'piano' );
        common_impl.PassingMgStart( "piano" );
        ng_global.progress[ "std" ][ "win_piano" ].pos = 1;
        ng_global.progress[ "std" ][ "win_piano" ].array = {0, 0, 0, 0, 0 };
      end;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_paperwithnotes_piano", 0, "", 0 );
  
  ObjAnimate( "spr_piano_paperwithnotes", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_offstage_piano", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_piano", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_charneddevice()

  local item = "inv_charneddevice";
  
  ObjMultiSet( { { "obj_workingdevice_loupe_small", { alp = 1 } }, 
              { "obj_workingdevice_loupe_big",   { alp = 0 } }, 

              } );

  cmn.CallEventHandler( "use_charneddevice_inv" );
  cmn.CallEventHandler( "use_charneddevice_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_charneddevice" );
    cmn.CallEventHandler( "use_charneddevice_end" );

    --private.get_defectivedevice();
    
    common_impl.LoupeMgStart();
  --common.CloseSubRoom();;
  
  end;

  common_impl.Lock( true );
  func_after();
    
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_device", 0, "", 0 );
    
      --ObjAnimate( "spr", "alp", 0, 0, func_after,
      --{ 
      --  0.0, 0, 0.0, 
      --  0.3, 0, 1.0
      --} );
    
  return true;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_6()

  local func_after = function ()
    
    common_impl.GetCollectDone( "get_collect_2_1_6" );
    cmn.CallEventHandler( "get_collect_2_1_6" );
--
--    if cmn.IsEventDone( "use_rerolledcane" ) then
--      common.CloseSubRoom();
--    end;    

  end;

  common_impl.PlayEffectHO( "spr_lightningequipment_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_2()

  local func_after = function ()
    
    common_impl.GetCollectDone( "get_collect_2_1_2" );
    cmn.CallEventHandler( "get_collect_2_1_2" );

    --if cmn.IsEventDone( "get_signature" ) then
    --  common.CloseSubRoom();
    --end;    

  end;

  common_impl.PlayEffectHO( "spr_doublebasscoffer_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_fragment_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fragment_2" );
  cmn.CallEventHandler( "get_fragment_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_note()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_note" );
  cmn.CallEventHandler( "get_note" );

end;
--------------------------------------------------------------------------------------------
function private.get_fragment_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fragment_3" );
  cmn.CallEventHandler( "get_fragment_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_signature()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_signature" );
  cmn.CallEventHandler( "get_signature" );
  
  if common_impl.IsGetCollect( "get_collect_2_1_2" ) then
  
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_battery()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_battery" );
  cmn.CallEventHandler( "get_battery" );

end;
--------------------------------------------------------------------------------------------
function private.get_adhesivetape()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_adhesivetape" );
  cmn.CallEventHandler( "get_adhesivetape" );

end;
--------------------------------------------------------------------------------------------
function private.get_gear()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gear" );
  cmn.CallEventHandler( "get_gear" );

end;
--------------------------------------------------------------------------------------------
function private.get_lens()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lens" );
  cmn.CallEventHandler( "get_lens" );

end;
--------------------------------------------------------------------------------------------
function private.get_bulb()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  ObjSet( "spr_lightningequipment_2_bulb", { alp = 1 } );
  
  
  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_charneddevice()

  private.vid_offstage_tutorial();

end;
--------------------------------------------------------------------------------------------
function private.get_code()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_code" );
  cmn.CallEventHandler( "get_code" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_fragment_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fragment_4" );
  cmn.CallEventHandler( "get_fragment_4" );

end;
--------------------------------------------------------------------------------------------
function public.get_defectivedevice()

  local func_after = function()
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    common_impl.ShowBbt( "bbt_offstage_broke" )
    cmn.SetEventDone( "get_defectivedevice" );
    cmn.CallEventHandler( "get_defectivedevice_inv" );
    common_impl.HideDeployInv();
    interface.KeyTaskDone( "find_avenger", true,function() interface.KeyTaskAdd( "open_piano", true, public.get_defectivedevice ) end  );
    ng_global.task_current = "open_piano";
    local tmr_after = function()
    
      cmn.CallEventHandler( "get_defectivedevice_deploy" );
      
    end;
    ObjSet( "tmr_defectivedevice_calling", { playing = true, time = 0.4, endtrig = tmr_after } );
    
  end;

  common_impl.ShowDeployInv("inv_defectivedevice");
  --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_crash_device_offstage", 0, "", 0 );
  AnimPlay( "anm_deploy_defectivedevice_broke", "DoAnim", func_after)
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.code_clk( circle )
  
  local start_ang = ng_global.progress[ "std" ][ "win_code" ].state[circle]
  local end_ang = ng_global.progress[ "std" ][ "win_code" ].state[circle] - 3.14159; 
  
  local func_after = function()
  
  common_impl.Lock( false ); 
   ng_global.progress[ "std" ][ "win_code" ].state[circle] = private.ang_set( end_ang );
    ObjSet( "obj_doublebasscoffer_circle_"..circle , { pos_z = 0 });
   private.Turn( circle );
   if circle == 2 then
     
     ObjAttach("spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2], "obj_doublebasscoffer_circle_1_turn");
     ObjAttach("spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3], "obj_doublebasscoffer_circle_3_turn");
     local temp = math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang + ObjGet("obj_doublebasscoffer_circle_1_turn").ang);
     local temp_1 = math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang + ObjGet("obj_doublebasscoffer_circle_3_turn").ang);
     ObjSet( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2], { ang = temp });
     ObjSet( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3], { ang = temp_1 });

     if private.ang_set(math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang - ObjGet("obj_doublebasscoffer_circle_1_turn").ang)) < 1 then

        name = "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2];
        ObjSet( name, { pos_y = -ObjGet( name ).pos_y });
        
      end;
      if private.ang_set(math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang - ObjGet("obj_doublebasscoffer_circle_3_turn").ang)) < 1 then
        
        name = "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3];
        ObjSet( name, { pos_y = -ObjGet( name ).pos_y });
        
      end;  
     
   end;

    local flag = true;
    for i = 1, 4 do 
      
      if ng_global.progress[ "std" ][ "win_code" ].current[i] ~= i then
      
        flag = false
      
      end;
      
    end;
    
    if flag then
      
        private.anim_win_code();
      
      end;
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_code_click", 0, "", 0 );

  ObjSet( "obj_doublebasscoffer_circle_"..circle , { pos_z = 1 });
  
  if  circle == 2 then
    
    local temp = math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang + ObjGet("obj_doublebasscoffer_circle_1_turn").ang);
    local temp_1 = math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang + ObjGet("obj_doublebasscoffer_circle_3_turn").ang);
    ObjAttach( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2],"obj_doublebasscoffer_circle_"..circle.."_turn");
    ObjAttach( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3],"obj_doublebasscoffer_circle_"..circle.."_turn");
    ObjSet( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2], { ang = temp });
    ObjSet( "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3], { ang = temp_1 });
    

    if private.ang_set(math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang - ObjGet("obj_doublebasscoffer_circle_1_turn").ang)) < 1 then

      name = "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[2];
      ObjSet( name, { pos_y = -ObjGet( name ).pos_y });
      
    end;
    if private.ang_set(math.abs(ObjGet("obj_doublebasscoffer_circle_2_turn").ang - ObjGet("obj_doublebasscoffer_circle_3_turn").ang)) < 1 then
      
      name = "spr_doublebasscoffer_element_".. ng_global.progress[ "std" ][ "win_code" ].current[3];
      ObjSet( name, { pos_y = -ObjGet( name ).pos_y });
      
    end;
    
  end;

  ObjAnimate( "obj_doublebasscoffer_circle_"..circle.."_turn", "ang", 0, 0, func_after,
  {
    0.0, 0, start_ang,
    0.3, 0, end_ang
  } );
  
  
  
end;
----------------------------------------------------------------------------------------------------------------------
function private.ang_set( ang )

  if ang < -6.1 or ang > 6 then

    ang = 0;

  end;

  return ang;

end;
----------------------------------------------------------------------------------------------------------------------
function private.Turn( circle )

  local bufer = 0;
  bufer = ng_global.progress[ "std" ][ "win_code" ].current[circle ];
  ng_global.progress[ "std" ][ "win_code" ].current[circle ] = ng_global.progress[ "std" ][ "win_code" ].current[circle + 1];
  ng_global.progress[ "std" ][ "win_code" ].current[circle + 1] = bufer;
    
 end;
----------------------------------------------------------------------------------------------------------------------  
function private.clk_stairs()
  
  local func_after = function()
  
    common_impl.Lock( false ); 
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_lightningequipment_use_rerolledcane' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_ladder_lightingequipment", 0, "", 0 );
  
  ObjAnimate( "anm_lightningequipment_cane", "pos_y", 0, 0, func_after,
  {
    0.0, 0, -7,
    0.3, 0, -5,
    0.6, 0, -7 
  } );
  
end;
----------------------------------------------------------------------------------------------------------------------  
function private.clk_spotlight( flag )
  
  local func_after = function()
  
    common_impl.Lock( false ); 
    
  end;
  
  if( flag == "screw" )then
    
    common_impl.ShowBbt( 'bbt_lightningequipment_use_screwdriver' );
    
  elseif( flag == "duster" )then

    common_impl.ShowBbt( 'bbt_lightningequipment_use_duster' );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_lightingequipment", 0, "", 0 );
  
  ObjAnimate( "spr_lightningequipment_2_spotlight", "ang", 0, 0, func_after,
  {
    0.0, 0, 0,
    0.3, 0, -0.03,
    0.6, 0, 0
  } );
  
end;
---------------------------------------------------------------------------------------------------------------------- 
function private.clk_harpelement_old()
  
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_harpelement_old" );
    cmn.CallEventHandler( "clk_harpelement_old" ); 
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_harp_broken_string", 0, "", 0 );
  
  ObjAnimate( "obj_smallroomdoor_harpelement_old", "alp", 0, 0, func_after,
  {
    0.0, 0, 1,
    0.3, 0, 0
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.piano_key_clk( i )

  local func_end = function ()

  common_impl.Lock( false );

   if private.piano_current[ng_global.progress[ "std" ][ "win_piano" ].pos] == private.piano_win[ng_global.progress[ "std" ][ "win_piano" ].pos] then
  
     ng_global.progress[ "std" ][ "win_piano" ].pos = ng_global.progress[ "std" ][ "win_piano" ].pos + 1;
     

     if  ng_global.progress[ "std" ][ "win_piano" ].pos == 6 then
       
       private.WinPiano();
       common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_piano_win", 0, "", 0 );

     else

       ng_global.progress[ "std" ][ "win_piano" ].array = private.piano_current;

     end;
          
   else
          
     public.Reset("win_piano");
     common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_piano_wrong", 0, "", 0 );

   end;
  
 end;
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_piano_"..private.piano_sound_mmg[i], 0, "", 0 ); 
  ObjAnimate( "spr_piano_mmg_"..i, "alp", 0, 0, func_end,
  {
    0.0, 0, 0,
    0.3, 0, 1 
  } );
  
  ObjSet("spr_piano_mmg_"..i, {input = false});
  private.piano_current[ng_global.progress[ "std" ][ "win_piano" ].pos] = i;

end;

----------------------------------------------------------
function private.clk_key( i )

  local func_after = function ()

    common_impl.Lock( false );
    ObjSet("spr_piano_key_"..i, { alp = 0 });
    
   end;
  
  common_impl.Lock( true );
   
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_piano_"..private.piano_sound_hh[i], 0, "", 0 ); 
   
  ObjAnimate( "spr_piano_key_"..i, "alp", 0, 0, func_after,
  {
    0.0, 0, 0,
    0.3, 0, 1 
  } );

end;
----------------------------------------------------------
function private.clk_box()

  local func_after = function ()

    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_lightningequipment_use_picklock' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_case_lightingequipment", 0, "", 0 );
  
  ObjAnimate( "spr_lightningequipment_close", "pos_y", 0, 0, func_after,
  {
    0.0, 0, -13,
    0.2, 0, -14,
    0.3, 0, -13
  } ); 
  ObjAnimate( "anm_lightningequipment_latchkey", "pos_y", 0, 0, "",
  {
  0.0, 0, 0,
  0.2, 0, -1,
    0.3, 0, 0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.NoteScale( event, source_name )

  local small_pic = source_name;
  local big_pic   = "obj_lightningequipment_clk_note";
  local pos_array  = {};

  pos_array.start  = {};
  pos_array.finish = {};

  pos_array.finish.pos_x = 0;
  pos_array.finish.pos_y = 0;

  --pos_array.start.pos_x = ObjGet( small_pic ).pos_x;
  --pos_array.start.pos_y = ObjGet( small_pic ).pos_y;
  pos_array.start.pos_x = GetObjPosByObj( small_pic, "zz_lightningequipment" )[1];
  pos_array.start.pos_y = GetObjPosByObj( small_pic, "zz_lightningequipment" )[2];
  pos_array.finish.pos_x = ObjGet( big_pic ).pos_x;
  pos_array.finish.pos_y = ObjGet( big_pic ).pos_y;

  local room = GetCurrentRoom();
  --if ( ObjGet(room).input == false ) then

    local subroom = common.GetCurrentSubRoom();
    local trg_after = function()

      local small_pic = source_name;
      local big_pic   = "obj_lightningequipment_note";

      common_impl.Lock( false );
      local obj = common.GetObjectName( GetCurrentRoom());
      if not common_impl[obj] then 
        common_impl[obj] = {};
        common_impl[obj].note = "close";
      end;
      if event == "open" then
        common_impl[obj].note = "open";
        ObjSet( big_pic, { input = true, event_mdown = function() private.NoteScale( "change", "spr_lightningequipment_note" ) common_impl.ShowBbt( 'bbt_map_memo_2' ); end; } );

      elseif event == "change" then

        ObjSet( "obj_lightningequipment_note", { event_mdown = function() private.NoteScale( "close", "spr_lightningequipment_note" ) end; } );

      else

        common_impl[obj].note = "close"; 
        ObjSet( "obj_lightningequipment_note", { input = false, active = false, alp = 0, pos_x = pos_array.finish.pos_x, pos_y = pos_array.finish.pos_y } );
        ObjSet( "spr_lightningequipment_note_big_1", { alp = 0 } );
        ObjSet( "obj_lightningequipment_note", { event_mdown = function() private.NoteScale( "change", "spr_lightningequipment_note" ) end; } );
        ObjSet( "spr_lightningequipment_note_big", { alp = 1 } );

      end;  

    end;

    if event == "open" then

      common_impl.Lock( true );

      private.note_scale = {};
      private.note_scale.pos_x = pos_array.start.pos_x;
      private.note_scale.pos_y = pos_array.start.pos_y;

      common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

      ObjSet( "obj_lightningequipment_note", { alp = 1, active = true, input = true, inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, inputrect_w = 2000, inputrect_h = 2000  } );
      ObjAnimate( "obj_lightningequipment_note", "pos_xy", 0, 0, "", 
      {
      0.0, 3, pos_array.start.pos_x, pos_array.start.pos_y,
      0.3, 3, pos_array.finish.pos_x - 25 , pos_array.finish.pos_y - 240 
      } );

      ObjAnimate( "obj_lightningequipment_note", "scale_xy", 0, 0, trg_after, 
      {
      0.0, 3, 0, 0,
      0.3, 3, 1, 1
      } );
      
      ObjAnimate( small_pic, "alp", 0, 0, "", 
      {
      0.0, 3, 1,
      0.3, 3, 0
      } );

    elseif event == "change" then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_1", 0, "", 0 );

      ObjAnimate( "spr_lightningequipment_note_big", "alp", 0, 0, "", 
      { 
      0.0, 3, 1,
      0.3, 3, 0 
      } );
      ObjAnimate( "spr_lightningequipment_note_big_1", "alp", 0, 0, trg_after, 
      { 
      0.0, 3, 0,
      0.3, 3, 1 
      } );
      
    else

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_2", 0, "", 0 );

      ObjAnimate( "obj_lightningequipment_note", "pos_xy", 0, 0, "", 
      { 
      0.0, 3, pos_array.finish.pos_x - 25, pos_array.finish.pos_y - 240,
      0.3, 3, pos_array.start.pos_x - 25, pos_array.start.pos_y 
      } );

      ObjAnimate( "obj_lightningequipment_note", "scale_xy", 0, 0, trg_after, 
      {
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
      } );
      
      ObjAnimate( small_pic, "alp", 0, 0, "", 
      {
      0.0, 3, 0,
      0.3, 3, 1
      } );

    end;

end;
--*****************************************  
function private.ShowBbt( use_name )

  if ( use_name == "fragment" ) then
    
    local count = 0;
    
    for i = 1, 4 do
      
      if cmn.IsEventDone( "use_fragment_"..i ) then
        
        count = count + 1; 
        
      end;
      
    end;
    
    if count < 3 then
      
      local rand = math.random( 1, 3 );
      
      common_impl.ShowBbt( 'bbt_bedsidetable_use_fragment_'..rand, 1 );
      
    else
      
      common_impl.ShowBbt( 'bbt_bedsidetable_use_fragment_4', 1 );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.WinPiano()
  
  local func_after = function()
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  
    common_impl.Lock( false );
    cmn.MiniGameHide( "piano" );
    common_impl.PassingMgWin( "piano" );
    cmn.SetEventDone( "win_piano" );
    cmn.CallEventHandler( "win_piano" );
    common.CloseSubRoom();

    interface.KeyTaskDone( 'open_piano', true );
    
  end;
  func_after();
  --ObjAnimate( "spr_piano_win", "alp", 0, 0, func_after,
  --{
  --  0.0, 0, 0,
  --  0.3, 0, 1,
  --  0.6, 0, 1 
  --} );
  --ObjAnimate( "spr_piano_paperwithnotes", "alp", 0, 0, "",
  --{
  --  0.0, 0, 1,
  --  0.3, 0, 0,
  --} );
end;  
function  private.skip_piano()

  --common_impl.Lock( false );
  private.WinPiano();
  --cmn.MiniGameHide( "piano" );
  --common_impl.PassingMgWin( "piano" );
  --cmn.SetEventDone( "win_piano" );
  --cmn.CallEventHandler( "win_piano" );
  --common.CloseSubRoom();

end;


--*********************************************************************************************************************
function private.anim_win_code()
  
   local func_after = function()

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

    common_impl.Lock(false);
    cmn.MiniGameHide( "code" );
    common_impl.PassingMgWin( "code" );
    cmn.SetEventDone( "win_code" );
    cmn.CallEventHandler( "win_code" );

   end;
  common_impl.Lock(true);
   
   common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_code_win", 0, "", 0 );

   ObjAnimate( "spr_doublebasscoffer_coffer_open", "alp", 0, 0, func_after, 
   { 
    0.0, 0, 0, 
    0.3, 0, 1
   } );

   ObjAnimate( "spr_doublebasscoffer_coffer", "alp", 0, 0,"", 
   { 
    0.0, 0, 1, 
    0.3, 0, 0
   } );

end;
--*********************************************************************************************************************
function private.reset_code()

  --ng_global.progress[ "std" ][ "win_code" ].state = { 0, 0, 0};
  ng_global.progress[ "std" ][ "win_code" ].current = { 2, 3, 4, 1 };
      ObjAttach( "spr_doublebasscoffer_element_2","obj_doublebasscoffer_circle_1_turn");
      ObjSet( "spr_doublebasscoffer_element_2", { pos_x = 2, pos_y = -34, ang = 0 });
      ObjAttach( "spr_doublebasscoffer_element_3","obj_doublebasscoffer_circle_1_turn" );
      ObjSet( "spr_doublebasscoffer_element_3", { pos_x = 2, pos_y = 34, ang = 0 });
      ObjAttach( "spr_doublebasscoffer_element_4","obj_doublebasscoffer_circle_3_turn" );
      ObjSet( "spr_doublebasscoffer_element_4", { pos_x = 2, pos_y = -34, ang = 0 });
      ObjAttach( "spr_doublebasscoffer_element_1","obj_doublebasscoffer_circle_3_turn" );
      ObjSet( "spr_doublebasscoffer_element_1", { pos_x = 2, pos_y = 34, ang = 0 });
     
      for i = 1, 3  do
        
        --ObjSet( "obj_doublebasscoffer_circle_"..i, { ang = ng_global.progress[ "std" ][ "win_code" ].state[i],  pos_z = 0 });
          ObjSet( "obj_doublebasscoffer_circle_"..i, { pos_z = 0 });
          ObjSet( "obj_doublebasscoffer_circle_"..i.."_turn", { ang = 0 });
          ng_global.progress[ "std" ][ "win_code" ].state[i] = 0;
        
      end;
      
  
 
end;
function  private.skip_code()
  
  --common_impl.Lock( false );
  --cmn.MiniGameHide( "code" );
  --common_impl.PassingMgWin( "code" );
  --cmn.SetEventDone( "win_code" );
  --cmn.CallEventHandler( "win_code" );
  private.anim_win_code();

end;
--*********************************************************************************************************************
function private.reset_loupe()

  private.loupe_mmg_win_pointer = { 0,0 };
  private.loupe_mmg_input_stop_drag = false;
  private.start_drag_auto = false;
  
  for i = 1, 2 do
      
    for j = 1, 3 do
      
      ObjSet( "spr_offstage_loupe_mg_sign_"..i.."_"..j, { input = true } );
      ObjSet( "spr_offstage_loupe_mg_sign_"..i.."_"..j.."_light", { alp = 0 } );
      
    end;
    
    local lines = ObjGetRelations( "obj_offstage_loupe_mg_signs_"..i ).childs;

    for k = 1, #lines do
      
      if string.find( ObjGet( lines[k] ).name, "line" ) then

        ObjDelete( lines[k] );
  
      end;

    end;
      
  end;
  
  ng_global.progress["std"]["win_offstage"].saves = { { { 0,0,0 },
                                                            { 0,0,0 },
                                                            { 0,0,0 } }, 
                                                            
                                                        { { 0,0,0 },
                                                          { 0,0,0 },
                                                          { 0,0,0 } } }; 

end;
 --*********************************************************************************************************************
function private.skip_loupe()

  private.win_loupe();
  
end;
--*********************************************************************************************************************
function private.win_loupe()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide( "offstage" );
  common_impl.PassingMgWin( "offstage" );
  cmn.SetEventDone( "win_offstage" );
  cmn.CallEventHandler( "win_offstage" );
  
  public.vid_offstage_loupe();
 
end;
--------------------------------------------------------------------------------------------
function private.EnterCode ( i )

  common_impl.SetCursor( CURSOR_HAND );
  ObjSet( "obj_doublebasscoffer_circle_"..i, { pos_z = 1 });
  local obj = "spr_doublebasscoffer_circle_"..i.."_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
   
 
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.LeaveCode ( i )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjSet( "obj_doublebasscoffer_circle_"..i, { pos_z = 0 });
  local obj = "spr_doublebasscoffer_circle_"..i.."_add";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--function private.light_on( num )
-- 
--  common_impl.SetCursor(CURSOR_HAND );
--  local obj = "spr_piano_mmg_"..num.."_add";
--  local alp = ObjGet( obj ).alp;
--  local tme = ( 1 - alp ) * 0.3;
--
--  ObjAnimate( obj, 8, 0, 0, "",
--  {
--    0.0, 2, alp,
--    tme, 2, 1
--  } );
--  
--end;
----*********************************************************************************************************************
--function private.light_off( num )
--
--  common_impl.SetCursor(CURSOR_DEFAULT );
--
--  local obj = "spr_piano_mmg_"..num.."_add";
--  local alp = ObjGet( obj ).alp;
--  local tme = ( 1 - alp ) * 0.3;
--
--  ObjAnimate( obj, 8, 0, 0, "",
--  {
--    0.0, 2, alp,
--    tme, 2, 0
--  } );
--  
--end;
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_piano" then
      
      private.skip_piano();

  elseif name == "win_code" then

      private.skip_code();
      
    elseif name == "win_offstage" then
      
      private.skip_loupe();

  end;

end;
--*********************************************************************************************************************
function public.Reset( name )

  if name == "win_piano" then
    
    local func_after = function ()

         common_impl.Lock( false );
         ng_global.progress[ "std" ][ "win_piano" ].pos = 1;
         ng_global.progress[ "std" ][ "win_piano" ].array = { 0, 0, 0, 0, 0 };
         private.piano_current = { 0, 0, 0, 0 ,0 };

    end;
       
    local func_after_2 = function ()

        common_impl.Lock( false );

    end;
   
    common_impl.Lock( true );
   
    for i = 1, ng_global.progress[ "std" ][ "win_piano" ].pos  do
  
      func_after();
      
    end;

    for j = 1,7   do
      
      if  ObjGet("spr_piano_mmg_"..j).alp == 1 then 

         ObjAnimate( "spr_piano_mmg_"..j, "alp", 0, 0, func_after_2,
         {
          0.0, 0, 1,
          0.3, 0, 0 
         } );
         
         ObjSet("spr_piano_mmg_"..j, { input = true });
         
      end;
       
     end;
     
  elseif name == "win_code" then
     
     private.reset_code();
     
  elseif name == "win_offstage" then
 
     private.loupe_mmg_wrong_anim();
     
  else 

  end;

end;
--*********************************************************************************************************************
function private.opn_offstage()

  if not ( cmn.IsEventDone( "opn_offstage" ) ) then
    cmn.SetEventDone( "opn_offstage" );
  end;
  
  cmn.CallEventHandler( "opn_offstage" ); 

end;
--*********************************************************************************************************************
function private.vid_offstage_tutorial()

  --cmn.CallEventHandler( "vid_offstage_tutorial_beg" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_get_map", 0, "", 0 );
    
  local get_after = function()

    common_impl.Lock( false );
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_charneddevice" );
    cmn.CallEventHandler( "get_charneddevice" );
    common_impl.ShowBbt( 'bbt_vid_offstage_tutorial', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_offstage_tutorial", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level1/aud_offstage_tutorial_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );
    
    common_impl.TutorialShow( "tutorial_page_15" );

  end;

    common_impl.Lock( true );
    cmn.CallEventHandler( "get_charneddevice_closezz" );
    ObjSet( "spr_bedsidetable_device", { input = false } );
    local item_name = "spr_bedsidetable_device";
    local start_pos = GetObjPosByObj( item_name );
    ObjAttach( item_name, "ng_interface_transporter" );
    local end_pos = GetObjPosByObj( "spr_int_button_apparat_apparat" );
    ObjAnimate( item_name, "pos_xy", 0, 0, "",
    { 
      0.0, 1, start_pos[1],start_pos[2], 
      1.0, 1, end_pos[1],end_pos[2]
    } );
    ObjAnimate( item_name, "scale_xy", 0, 0, get_after,
    { 
      0.0, 1, 1,1,
      0.7, 1, 1,1,
      1.0, 1, 0,0
    } );
    
  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_offstage_tutorial", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level1/aud_offstage_tutorial_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_offstage_tutorial", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_offstage_tutorial", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_offstage_vanishing()

  cmn.CallEventHandler( "vid_offstage_vanishing_beg" );

  local func_after = function ( skip )

    ObjSet( "rm_offstage", { color_r = 1, color_g = 1, color_b = 1 } );
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_offstage_vanishing" );
    cmn.CallEventHandler( "vid_offstage_vanishing_end" );
    common_impl.ShowBbt( 'bbt_vid_offstage_vanishing', 1 );
    
    interface.KeyTaskAdd( "find_avenger", true );
    
    common_impl.AddPageDiary( 2 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level1/aud_offstage_vanishing", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level1/aud_offstage_vanishing_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_offstage_vanishing", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level1/aud_offstage_vanishing_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_offstage_vanishing", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_offstage_vanishing", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
-- function *** LOUPE *** () end;
--*********************************************************************************************************************
  function private.loupe_mmg_anim()
    
    ObjAnimate( "obj_offstage_loupe_mg_signs", "pos_xy", 1, 0, "", { 0,0,0,0, 2.5,0,-5,-4, 5,0,0,0 } );
  
  end;
--*********************************************************************************************************************
  function private.loupe_mmg_clk_sign( i, j )
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );
    
    local params = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "obj_offstage_loupe_mg" );

    ObjSet( "obj_offstage_loupe_mg_line", { pos_x = params[1], pos_y = params[2],
                                            event_startdrag = function() private.loupe_mmg_start_drag( i, j ) end,
                                            event_drag = function() private.loupe_mmg_drag( i, j ) end,
                                            event_dragdrop = function() private.loupe_mmg_drag_drop( i, j ) end } );
    
    ObjStartDrag( "obj_offstage_loupe_mg_line" );

  end;
--*********************************************************************************************************************
  function public.loupe_mmg_start()
 
    if not ng_global.progress["std"]["win_offstage"].saves then
                                                        
      ng_global.progress["std"]["win_offstage"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_start_drag( i, j )
  
    if not private.start_drag_auto then
    
    private.pos_x_line = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "rm_offstage_loupe" )[1] - 511;
      --private.pos_y_line = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "rm_offstage_loupe" )[2] - 383;
    private.pos_y_line = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "rm_offstage_loupe" )[2] -383;
    
    if i == 2 then

      private.pos_y_line = private.pos_y_line + 4;
      
    end;
    
    private.pos = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "rm_offstage_loupe" );
   
    private.pos_x_cur = private.pos[1];
    private.pos_y_cur = private.pos[2];
    
    --DbgTrace( private.pos_x_line.." "..private.pos_y_line.."   "..private.pos_x_cur.." "..private.pos_y_cur );
 
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_click", 0, "", 0 );

  end;

  private.loupe_mmg_input_stop_drag = false;
  private.loupe_mmg_stop_drag_flag = false;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_drag( i, j )

  common_impl.SetCursor( CURSOR_GET );

    if ObjIntersect( "obj_offstage_loupe_mg_line", "obj_offstage_loupe_mg" ) then

      local cur_pos = GetZoomCursorPos();
      pos_x1 = cur_pos[ 1 ];
      pos_y1 = cur_pos[ 2 ];

      dx = pos_x1 - private.pos_x_cur;
      dy = pos_y1 - private.pos_y_cur;
      s = math.sqrt(dx^2+dy^2);
      angl = (math.atan2(dx,dy))- 1.57; 
  
      lenght = 2;--коэффициент

      ObjSet( "tmr_offstage_loupe_mmg", 
      { 
        playing = true, 
        time = 0.01,  
        endtrig = function() private.loupe_mmg_drag(i, j) end ;
      } );
      
 

      ObjSet( "spr_offstage_loupe_mg_line", { alp = 1 } );
      ObjSet( "spr_offstage_loupe_mg_line",
        {
         pos_x = private.pos_x_line,
         pos_y = private.pos_y_line,
         ang = angl, 
         scale_x = s / lenght,
         blendmode = 2;
        } );
        
      --ObjSet( "obj_offstage_loupe_mg_line_input",
      --{
      -- pos_x = s/2,
      -- pos_y = 0,
      -- inputrect_w = s - 20, 
      -- inputrect_x = - ( ( s - 20 )/2 ),
      -- inputrect_h = 10,
      -- inputrect_y = -3,
      -- attachtype = 2,
      --} );

    else 
        
        private.loupe_mmg_wrong_anim();

      if private.loupe_mmg_stop_drag_flag == false then

        private.loupe_mmg_input_stop_drag = true;

        ObjStopDrag( "obj_offstage_loupe_mg_line" );

        private.loupe_mmg_stop_drag_flag = true;
        
        --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_wrong", 0, "", 0 );

      end;
        
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_stop_drag()

  ObjSet( "tmr_offstage_loupe_mmg", { playing = 0 } );
  ObjSet( "spr_offstage_loupe_mg_line", { alp = 0 } );

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_drag_drop( i, j )
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "obj_offstage_loupe_mg_line";
  local points = {};
  local old = {};
  old[1] = i;
  old[2] = j;

  --[[поиск куда бросили ]]

  private.start_drag_auto = false;

  if not private.loupe_mmg_input_stop_drag then
   
    for k = 1, 2 do  
      for l = 1, 4 do  
        if ObjIntersect( name, "spr_offstage_loupe_mg_sign_"..k.."_"..l ) and not ( k == i and l == j ) then
          points[1] = k;
          points[2] = l;
        end;
      end;
    end;

    local pos_star = { 
      private.pos_x_line, 
      private.pos_y_line
    };

    if points[1] and points[2] and points[1] ~= old[1] then
      
      local pos_star_2 = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..points[1].."_"..points[2], "obj_offstage_loupe_mg" );
      
      if points[1] == 2 then
        
        pos_star_2[2] = pos_star_2[2] + 4;
        
      end;

      private.loupe_mmg_make_line( pos_star, pos_star_2, points[1],points[2], old[1],old[2], false );

      --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_true", 0, "", 0 );
      
      elseif  private.loupe_mmg_win_pointer ~= 8 then
      
      private.loupe_mmg_wrong_anim();
      
    end;

  end;

  private.loupe_mmg_stop_drag();

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_make_line( elem_1, elem_2, i, j, n, m, save )
  
  local pos_x1 = elem_1[ 1 ];
  local pos_y1 = elem_1[ 2 ];

  local pos_x2 = elem_2[ 1 ]
  local pos_y2 = elem_2[ 2 ];
  
  local dx = pos_x1 - pos_x2;
  local dy = pos_y1 - pos_y2;
  local s = math.sqrt(dx^2+dy^2);
  local angl = (math.atan2(dx,dy)) - 1.57; 
  local lenght = 2;
  
  --DbgTrace( pos_x1.." "..pos_y1.."  "..pos_x2.." "..pos_y2 );

  ObjSet( "spr_offstage_loupe_mg_line", { alp = 0 } );

  if not ObjGet( "spr_offstage_loupe_mg_line_"..i.."_"..j ) and i ~= n then
  
    ObjCreate( "spr_offstage_loupe_mg_line_"..i.."_"..j, "spr" );
    ObjAttach( "spr_offstage_loupe_mg_line_"..i.."_"..j, "obj_offstage_loupe_mg_signs" );
    ObjSet( "spr_offstage_loupe_mg_line_"..i.."_"..j,
      {
       res = "assets/interface/resources/apparatus/line",
       pos_x =  pos_x1,
       pos_y =  pos_y1,
       ang = angl, 
       scale_x = s / lenght,
       scale_y = 1;
       drawoff_x = -1,
       blendmode = 2;
      } );
     
     ObjCreate( "obj_offstage_loupe_mg_line_"..i.."_"..j.."_input", "obj" );
     ObjAttach( "obj_offstage_loupe_mg_line_"..i.."_"..j.."_input", "spr_offstage_loupe_mg_line_"..i.."_"..j ); 
     
     local weight = 0.76 + 0.020* ( s / 50 );
     
     ObjSet( "obj_offstage_loupe_mg_line_"..i.."_"..j.."_input",
      {
       pos_x = -1,
       pos_y = 0,
       input = true,
       inputrect_init = true,
       inputrect_w = 2*weight, 
       inputrect_x = - weight,
       inputrect_h = 10,
       inputrect_y = -5,
      } ); 
      
    local pos_star_2 = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j, "obj_offstage_loupe_mg" );
      
    if not save then

      ObjSet( "obj_offstage_loupe_mg_line", { 
      pos_x = pos_x2,
      pos_y = pos_y2,
      event_startdrag = function () private.loupe_mmg_start_drag(i,j) end,
      event_drag = function () private.loupe_mmg_drag(i,j) end,
      event_dragdrop = function () private.loupe_mmg_drag_drop(i,j) end } );
      
      ObjSet( "spr_offstage_loupe_mg_sign_"..n.."_"..m, { input = false } );
      
      if not private.loupe_mmg_check_intersect() then
      
        --ng_global.progress["std"]["win_offstage"].saves[i][j][m] = 1;
        ng_global.progress["std"]["win_offstage"].saves[n][m][j] = 1;
        
        private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
     
        if private.loupe_mmg_win_pointer ~= 8 then

          private.pos_x_line = ObjGet( "spr_offstage_loupe_mg_sign_"..i.."_"..j ).pos_x;
          private.pos_y_line = ObjGet( "spr_offstage_loupe_mg_sign_"..i.."_"..j ).pos_y;

          private.pos = GetObjPosByObj( "spr_offstage_loupe_mg_sign_"..i.."_"..j );
            
          private.pos_x_cur = private.pos[1];
          private.pos_y_cur = private.pos[2];

          private.start_drag_auto = true; 
          
        else
          
          private.loupe_mmg_win_anim();
            
        end;
        
        private.loupe_mmg_light_anim( i, j );
        
      else
        
        private.loupe_mmg_wrong_anim();
        
      end;
      
    end;

  else

    private.loupe_mmg_wrong_anim();

  end;
 
  end;
------------------------------------------------------------------------------------------
 function private.loupe_mmg_check_intersect()
 
   local intersect_array = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
 
   for i = 1, 18 do
 
   for j = 1, 2 do
     
     for k = 1, 4 do
 
       if ObjGet( "obj_offstage_loupe_mg_line_"..j.."_"..k.."_input" ) and
         ObjIntersect( "obj_offstage_loupe_mg_intersect_"..i, "obj_offstage_loupe_mg_line_"..j.."_"..k.."_input" ) then
          
          intersect_array[i] = intersect_array[i] + 1;
          
          if intersect_array[i] > 1 then
            
            return true;
            
          end;
          
        end;
       
     end;
     
   end;
   
 end;
  
  return false;
   
 end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_wrong_anim()
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_wrong", 0, "", 0 );

  private.loupe_mmg_stop_drag();
    
  private.loupe_mmg_win_pointer = 0;
  
  local lines = ObjGetRelations( "obj_offstage_loupe_mg_signs" ).childs;

  for j = 1, #lines do
    
    if ObjGet( lines[j] ) and string.find( ObjGet( lines[j] ).name, "line" ) then

      ObjDelete( lines[j] );

    end;

  end;
  
  for i = 1, 2 do
    
    for k = 1, 4 do
      
      ObjSet( "spr_offstage_loupe_mg_sign_"..i.."_"..k.."_light", { alp = 0 } );
      ObjSet( "spr_offstage_loupe_mg_sign_"..i.."_"..k, { input = true } );
   
    end;
    
  end;
    
   ng_global.progress["std"]["win_offstage"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_light_anim( i, j )
  
  local func_after = function()

    common_impl.Lock( false );
    
    if not private.loupe_mmg_stop_drag_flag and private.loupe_mmg_win_pointer ~= 8 then
      
      common_impl.SetCursor( CURSOR_GET );

      ObjStartDrag( "obj_offstage_loupe_mg_line" );
      
    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_true", 0, "", 0 );
  
  ObjAnimate( "spr_offstage_loupe_mg_sign_"..i.."_"..j.."_light", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
  
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_win_anim()
    
    local func_after = function()
    
      private.win_loupe();
      
      common_impl.Lock( false );
    
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_win", 0, "", 0 );
    
    ObjStopDrag( "obj_offstage_loupe_mg_line" );
    
    for i = 1, 2 do
      
      for j = 1, 4 do
        
        ObjAnimate( "spr_offstage_loupe_mg_sign_"..i.."_"..j.."_light_win", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,0, 0.5,0,1, 0.9,0,1, 1.2,0,0 } );
        
        func_after = "";
        
      end;
      
    end;

  end;
--*********************************************************************************************************************
function public.vid_offstage_loupe()

  local func_after = function ()

    common_impl.Lock( false );

    int_loupe.Hide();
  
    cmn.SetEventDone( "vid_offstage_loupe" );
    cmn.CallEventHandler( "vid_offstage_loupe" );
    common_impl.ShowBbt( 'bbt_vid_offstage_loupe', 1 );
    
    private.zoom_piano();
    interface.Lock( true, 6 );
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_crash_device_offstage", 0, "", 0 );
    
  end;
  
  local func_after_emergence = function ()
  
    local func_after_stand_1 = function ()
    
       local func_after_move = function ()
       
         local func_after_stand_2 = function ()
         
           ObjSet( "anm_offstage_loupe_stand_2", { alp = 0 } );
         
           ObjSet( "anm_offstage_loupe_fade", { alp = 1 } );
  
           AnimPlay( "anm_offstage_loupe_fade", "DoAnim", func_after );
           
           common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_hide", 0, "", 0 );
         
         end;
         
         ObjSet( "anm_offstage_loupe_move", { alp = 0 } );
       
         ObjSet( "anm_offstage_loupe_stand_2", { alp = 1 } );
  
         AnimPlay( "anm_offstage_loupe_stand_2", "DoAnim", "" );
          
         ObjAnimate( "spr_offstage_loupe_text_2", "alp", 0, 0, func_after_stand_2, { 0,0,0, 0.3,0,1 , 2.3,0,1, 2.6,0,0 } );
         
         common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
       
       end;
       
       ObjSet( "anm_offstage_loupe_stand_1", { alp = 0 } );
    
       ObjSet( "anm_offstage_loupe_move", { alp = 1 } );
  
       AnimPlay( "anm_offstage_loupe_move", "DoAnim", func_after_move );
       
       common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_move", 0, "", 0 );
    
    end;
     
    ObjSet( "anm_offstage_loupe_emergence", { alp = 0 } );
 
    ObjSet( "anm_offstage_loupe_stand_1", { alp = 1 } );
  
    AnimPlay( "anm_offstage_loupe_stand_1", "DoAnim", "" );
    
    ObjAnimate( "spr_offstage_loupe_text_1", "alp", 0, 0, func_after_stand_1, { 0,0,0, 0.3,0,1 , 1.3,0,1, 1.6,0,0 } );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
  
  end;

  --common_impl.StopAllMus();
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_show", 0, "", 0 );
 
  ObjSet( "obj_offstage_loupe_anim", { active = true, visible = true } );
  
  AnimPlay( "anm_offstage_loupe_emergence", "DoAnim", func_after_emergence );

end;
--*********************************************************************************************************************
function private.zoom_piano()
  
  local func_after = function()
  
    local func_after_zoom = function()
    
      common_impl.Lock( false );

      --local func_broke = function()
      
        interface.InventoryOpen();
        rm_offstage.get_defectivedevice();
      
      --end;
       
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
    ObjAnimate( "rm_offstage", "scale_xy", 0, 0, func_after_zoom, { 0,0,1.2,1.2, 0.6,0,1,1 } );  
    ObjAnimate( "rm_offstage", "pos_xy", 0, 0, "", { 0,0,-238,-155, 0.6,0,0,0 } );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  
  ObjAnimate( "rm_offstage", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.6,0,1.2,1.2, 1.3,0,1.2,1.2 } );  
  ObjAnimate( "rm_offstage", "pos_xy", 0, 0, "", { 0,0,0,0, 0.6,0,-238,-155, 1.3,0,-238,-155 } );
  
end;
--*********************************************************************************************************************
ObjAnimate("spr_piano_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_bedsidetable_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});


ObjAnimate("spr_lightningequipment_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  1.5, 0, 0.6,
  3.0, 0, 1.0
});

