-- name=rm_smallroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_smallroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_chest", "room_hub" );
  ObjAttach( "zz_cabinet", "room_hub" );
  ObjAttach( "zz_window", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_chest_wrench", { event_mdown = private.get_wrench }},
    { "spr_chest_letter_1", { event_mdown = private.get_letter_1 }},
    { "spr_chest_hexagon", { event_mdown = private.get_hexagon }},
    { "spr_cabinet_windowhandle", { event_mdown = private.get_windowhandle }},
    { "spr_window_trebleclef", { event_mdown = private.get_trebleclef }},
    { "obj_chest_clk_lever", { event_mdown = private.clk_lever_1 }},
    { "obj_window_use_windowhandle", { event_mdown = private.clk_window }},
    { "obj_window_clk_windowhandle", { event_mdown = private.clk_windowhandle }},
    { "obj_chest_use_lever", { event_mdown = private.clk_lever }},
    { "obj_cabinet_use_gear", { event_mdown = private.clk_cabinet_door }},
    { "obj_cabinet_clk_door", { event_mdown = private.clk_handle }},
    --{ "obj_chest_use_lever", { event_mdown = private.clk_chest }},
    { "obj_window_clk_crow", { event_mdown = private.clk_crow }},
    { "spr_smallroom_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_smallroom_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_window_collect_2", { event_mdown = function () private.get_collect_2_1_3(); end,
                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},

    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_smallroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then        
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_smallroom_noteroom",
    "gzz_smallroom_chest",
    "gzz_smallroom_cabinet",
    "gzz_smallroom_window"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_chest",
    "zz_cabinet",
    "zz_window"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_smallroom", update_game_mode_smallroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_smallroom = function ()

  local effects_table = 
  {
    "obj_smallroom_anim",
    "anm_smallroom_window_window",
    "spr_smallroom_window_light",  
    "anm_smallroom_window_light",
    "spr_cabinet_light_add",
    "anm_window_branch",
    "anm_window_halo"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_smallroom", update_performance_mode_smallroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_smallroom () end;
  --------------------------------------------------------------------------------------------
  local opn_smallroom_map = function ()

    common_impl.VisitMapRoom( "smallroom" );

  end;
  cmn.AddSubscriber( "opn_smallroom", opn_smallroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench" ] = {
    type = "get",
    get_obj = "spr_chest_wrench",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_smallroom_chest"
  };
    
  local get_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench", "spr_chest_wrench" );
  
  end;
  
  local get_wrench_closezz = function ()
  
    ObjDelete( "gfx_chest_wrench" );
    ObjDelete( "spr_chest_wrench_shadow" );
    ObjDelete( "spr_smallroom_chest_wrench" );
  
  end;
  
  cmn.AddSubscriber( "get_wrench", get_wrench_inv );
  cmn.AddSubscriber( "get_wrench", get_wrench_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letter_1" ] = {
    type = "get",
    get_obj = "spr_chest_letter_1",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_smallroom_chest"
  };
    
  local get_letter_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter_1", "spr_chest_letter_1" );
  
  end;
  
  local get_letter_1_closezz = function ()
  
    ObjDelete( "gfx_chest_letter_1" );
    ObjDelete( "spr_chest_letter_1_shadow" );
    ObjDelete( "spr_smallroom_chest_letter" );

    if ( cmn.IsEventDone("get_hexagon") ) then

      ObjDelete( "gzz_smallroom_chest" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_letter_1", get_letter_1_inv );
  cmn.AddSubscriber( "get_letter_1", get_letter_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagon" ] = {
    type = "get",
    get_obj = "spr_chest_hexagon",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_smallroom_chest"
  };
    
  local get_hexagon_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexagon", "spr_chest_hexagon" );
    ObjSet("spr_sign_plus_light",{ alp = 1});
    
  end;
  
  local get_hexagon_closezz = function ()
  
    ObjDelete( "gfx_chest_hexagon" );
    ObjDelete( "spr_chest_hexagon_shadow" );
    ObjDelete( "spr_smallroom_chest_key" );
    
    if ( cmn.IsEventDone("get_letter_1") ) then

      ObjDelete( "gzz_smallroom_chest" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_hexagon", get_hexagon_inv );
  cmn.AddSubscriber( "get_hexagon", get_hexagon_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_windowhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_windowhandle" ] = {
    type = "get",
    get_obj = "spr_cabinet_windowhandle",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_smallroom_cabinet"
  };
    
  local get_windowhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_windowhandle", "spr_cabinet_windowhandle" );
  
  end;
  
  local get_windowhandle_closezz = function ()
  
    ObjDelete( "gfx_cabinet_windowhandle" );
    ObjSet( "obj_cabinet_use_gear", { input = true } );
    ObjDelete("spr_cabinet_windowhandle_shadow");
    ObjDelete("spr_cabinet_windowhandle_over");
    ObjDelete( "spr_smallroom_cabinet_pen" );
  
  end;
  
  cmn.AddSubscriber( "get_windowhandle", get_windowhandle_inv );
  cmn.AddSubscriber( "get_windowhandle", get_windowhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trebleclef () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trebleclef" ] = {
    type = "get",
    get_obj = "spr_window_trebleclef",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_smallroom_window"
  };
    
  local get_trebleclef_inv = function ()
  
    interface.InventoryItemAdd( "inv_trebleclef", "spr_window_trebleclef" );
  
  end;
  
  local get_trebleclef_closezz = function ()
  
    ObjDelete( "gfx_window_trebleclef" );
    ObjDelete( "spr_smallroom_window_note" );
  
    
    if common_impl.IsGetCollect( "get_collect_2_1_3" ) and cmn.IsEventDone( "clk_crow" ) then
    
      ObjDelete( "gzz_smallroom_window" );
    
    end;
   
  end;
  
  cmn.AddSubscriber( "get_trebleclef", get_trebleclef_inv );
  cmn.AddSubscriber( "get_trebleclef", get_trebleclef_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_2 = function ()
  
    ObjDelete( "obj_smallroom_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_2", get_collect_item_1_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
  ObjDelete( "obj_smallroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1_3 = function ()
 
    ObjDelete( "spr_window_collect_2" );

    if cmn.IsEventDone( "get_trebleclef" ) and cmn.IsEventDone( "clk_crow" ) then
      ObjDelete( "gzz_smallroom_window" );
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_1_3", get_collect_2_1_3, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever" ] = {
    type = "use",
    inv_obj = "inv_lever",
    use_place = "obj_chest_use_lever",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_smallroom_chest"
  };
  local use_lever_inv = function ()
  
    interface.InventoryItemRemove( "inv_lever" );
  
  end;
  local use_lever_beg = function ()
  
    ObjDelete( "obj_chest_use_lever" );
  
  end;
  local use_lever_end = function ()
  
    ObjSet( "obj_chest_clk_lever", { input = true, visible = true, active = true } );
    ObjSet( "spr_chest_arm_1", { alp = 1 } );
    ObjSet( "spr_smallroom_chest_pen_2_up", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever", use_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever", use_lever_inv );
  cmn.AddSubscriber( "use_lever", use_lever_end, private.room_objname );
  cmn.AddSubscriber( "use_lever_inv", use_lever_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever_beg", use_lever_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_end", use_lever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear" ] = {
    type = "use",
    inv_obj = "inv_gear",
    use_place = "obj_cabinet_use_gear",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_smallroom_cabinet"
  };
  local use_gear_inv = function ()
  
    interface.InventoryItemRemove( "inv_gear" );
  
  end;
  local use_gear_beg = function ()
  
    ObjDelete( "obj_cabinet_use_gear" );
  
  end;
  local use_gear_end = function ()
  
    --ObjDelete( "gzz_smallroom_cabinet" );
    --ObjSet( "gho_smallroom_noteroom", { input = true, visible = true, active = true } );
    ObjSet( "obj_cabinet_clk_door", { input = true, active = true});
    ObjSet( "anm_cabinet_cogs", { alp = 1});
    ObjSet( "spr_cabinet_cog_shadow", { alp = 1});
    ObjSet( "spr_smallroom_cabinet_cog", { alp = 1 });
    ObjDelete( "spr_cabinet_cog_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear", use_gear_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear", use_gear_inv );
  cmn.AddSubscriber( "use_gear", use_gear_end, private.room_objname );
  cmn.AddSubscriber( "use_gear_inv", use_gear_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear_beg", use_gear_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_end", use_gear_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_2" ] = {
    type = "use",
    inv_obj = "inv_elf_1",
    use_place = "obj_window_use_elf",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_smallroom_window"
  };
  local use_elf_2_inv = function ()
  end;
  local use_elf_2_beg = function ()
  
    ObjDelete( "obj_window_use_elf" );
  
  end;
  local use_elf_2_end = function ()
  
  ObjSet( "spr_window_trebleclef", { input = true, active = true, alp = 1 } );
  ObjSet( "spr_smallroom_window_note", { alp = 1 });
  ObjDelete( "spr_window_trebleclef_2" );
  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_2", use_elf_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2", use_elf_2_inv );
  cmn.AddSubscriber( "use_elf_2", use_elf_2_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_inv", use_elf_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_beg", use_elf_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_end", use_elf_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_windowhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_windowhandle" ] = {
    type = "use",
    inv_obj = "inv_windowhandle",
    use_place = "obj_window_use_windowhandle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_smallroom_window"
  };
  local use_windowhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_windowhandle" );
  
  end;
  local use_windowhandle_beg = function ()
  
    ObjDelete( "obj_window_use_windowhandle" );
  
  end;
  local use_windowhandle_end = function ()
  
    ObjSet( "obj_window_clk_windowhandle", { input = true } );
    ObjSet( "spr_window_windowhandle_1", { alp = 1});
    ObjSet( "spr_smallroom_window_handle", {alp = 1});
    ObjSet( "spr_window_windowhandle_over", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_inv );
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_inv", use_windowhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_beg", use_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_end", use_windowhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lever_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lever_1" ] = {
    type = "click",
    use_place = "obj_chest_clk_lever",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_smallroom_chest"
  };
  local clk_lever_1_beg = function ()
  
    ObjDelete( "obj_chest_clk_lever" );
  
  end;
  local clk_lever_1_end = function ()
  
    ObjDelete( "spr_chest_arm_1" );
    ObjDelete( "spr_chest_arm_2" );
    ObjDelete( "spr_chest_over_1" );
    ObjDelete( "spr_chest_over_2" );
    ObjSet( "spr_chest_arm_1_op", { alp = 1 } );
    ObjSet( "spr_chest_arm_2_op", { alp = 1 } );
    ObjSet( "spr_chest_open", { alp = 1, input = true } );
    ObjSet( "spr_chest_letter_1", { input = true,  active = true } );
    ObjSet( "spr_chest_hexagon", { input = true,  active = true } );
    ObjDelete( "spr_smallroom_chest_pen_1_up" );
    ObjDelete( "spr_smallroom_chest_pen_2_up" );
    ObjSet( "spr_smallroom_chest_pen_1_down",  { alp = 1} );
    ObjSet( "spr_smallroom_chest_pen_2_down",  { alp = 1} );
    ObjSet( "spr_smallroom_chest_open",  { alp = 1} );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lever_1", clk_lever_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_1", clk_lever_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_lever_1_beg", clk_lever_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_1_end", clk_lever_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_windowhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_windowhandle" ] = {
    type = "click",
    use_place = "obj_window_clk_windowhandle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_smallroom_window"
  };
  local clk_windowhandle_beg = function ()
  
    ObjDelete( "obj_window_clk_windowhandle" );
  
  end;
  local clk_windowhandle_end = function ()
  
    ObjSet( "obj_window_use_elf", { input = true, active = true } );
    ObjSet( "spr_window_open", { alp = 1 });
    ObjSet("anm_smallroom_window_window_2", { alp = 1 });   
    ObjDelete("spr_smallroom_window_close")
    ObjDelete( "spr_window_close" );
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_windowhandle", clk_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_windowhandle", clk_windowhandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_windowhandle_beg", clk_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_windowhandle_end", clk_windowhandle_end, private.room_objname );
  ------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle" ] = {
    type = "click",
    use_place = "obj_cabinet_clk_door",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_smallroom_cabinet"
  };
  local clk_handle_beg = function ()
  
    ObjDelete( "obj_cabinet_clk_door" );
  
  end;
  local clk_handle_end = function ()
  
    ObjDelete( "gzz_smallroom_cabinet" );
    ObjDelete( "anm_smallroom_cupboard" );
    ObjSet( "gho_smallroom_noteroom", { input = true, active = true, alp = 1 } );
    ObjSet( "anm_smallrooml_gho_noteroom", { visible = true } ); 
    ObjDelete( "spr_smallroom_cabinet_cog" );
    --ObjDelete("anm_cabinet_cogs");
    ObjSet( "spr_smallroom_cabinet_open_ho", { alp = 1 });
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle", clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle", clk_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_beg", clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_end", clk_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_crow () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "clk_crow" ] = {
  --  type = "click",
  --  use_place = "obj_window_clk_crow",
  --  room = private.room_objname,
  --  zz = "zz_window",
  --  zz_gate = "gzz_smallroom_window"
  --};
  local clk_crow_beg = function ()
  
    ObjDelete( "obj_window_clk_crow" );
  
  end;
  local clk_crow_end = function ()
  
    ObjDelete( "anm_window_crow_1" )
    ObjDelete( "anm_window_crow_2" );
    ObjDelete( "anm_smallroom_crow" );
    
    if ( cmn.IsEventDone( "get_trebleclef" ) and cmn.IsEventDone( "get_collect_2_1_3" ) ) then
      ObjDelete( "gzz_smallroom_window" );
    end;
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_crow", clk_crow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_crow", clk_crow_end, private.room_objname );
  cmn.AddSubscriber( "clk_crow_beg", clk_crow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_crow_end", clk_crow_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
   subroom.Define( "zz_window" );
  
 --------------------------------------------------------------------------------------------
 function zz_window.PreOpen()
    
  if cmn.IsEventDone( "clk_windowhandle" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_open_window_env", 1, "", 0 );
    common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_opened_window_env", 0.5 );
    
  end;
  
  if cmn.IsEventDone( "get_lever" ) and not cmn.IsEventDone( "clk_crow" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_crows_zz_env", 1, "", 0 );
    common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_crows_loc_env", 0.5 );
    
  end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_window.PreClose()

   if cmn.IsEventDone( "clk_windowhandle" ) then
    
     common_impl.StopAudio( "env", "common/audio/level1/aud_open_window_env", 0.5 );
     common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_opened_window_env", 1, "", 0 );
     
   end;
   
   if cmn.IsEventDone( "get_lever" ) and not cmn.IsEventDone( "clk_crow" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_crows_loc_env", 1, "", 0 );
    common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_crows_zz_env", 0.5 );
    
  end;

  end;
  --------------------------------------------------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_smallroom();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.EnvPlay( { "common/audio/level1/aud_smallroom_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "clk_windowhandle" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_closed_window_env", 1, "", 0 );
    
  else
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_opened_window_env", 1, "", 0 );
    
  end;
  
  if cmn.IsEventDone( "get_lever" ) and not cmn.IsEventDone( "clk_crow" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level1/aud_smallroom_crows_loc_env", 1, "", 0 );
  
  end;

  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_closed_window_env", 0 );
  common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_opened_window_env", 0  );
  common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_crows_loc_env", 0.5 );
 
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lever()

  local item = "inv_lever";

  if ( common.ApplyObj( item, "obj_chest_use_lever", true ) ) then

    cmn.CallEventHandler( "use_lever_inv" );
    cmn.CallEventHandler( "use_lever_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lever" );
      cmn.CallEventHandler( "use_lever_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_lever_chest", 0, "", 0 );
    
    ObjAnimate( "spr_chest_arm_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_chest", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gear()

  local item = "inv_gear";

  if ( common.ApplyObj( item, "obj_cabinet_use_gear", true ) and cmn.IsEventDone( "get_windowhandle" ) ) then

    cmn.CallEventHandler( "use_gear_inv" );
    cmn.CallEventHandler( "use_gear_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_gear" );
      cmn.CallEventHandler( "use_gear_end" );
      --common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_gear_cabinet", 0, "", 0 );
  
   ObjAnimate( "anm_cabinet_cogs", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
   ObjAnimate( "spr_cabinet_cog_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0,
      0.6, 0, 0.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_cabinet", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_2()

  local item = "inv_elf_1";

  if ( common.ApplyObj( item, "obj_window_use_elf", true ) and cmn.IsEventDone( "clk_windowhandle" ) 
    and ( ( cmn.IsEventDone( "get_lever" ) and cmn.IsEventDone( "clk_crow" ) ) or ( not cmn.IsEventDone( "get_lever" ) ))) then

    cmn.CallEventHandler( "use_elf_2_inv" );
    cmn.CallEventHandler( "use_elf_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_2" );
      cmn.CallEventHandler( "use_elf_2_end" );
      
      interface.InventoryItemAdd( "inv_elf_1", "vid_window_use_elf", nil, "video" );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    --common.CloseSubRoom();;
    
  end;

   common_impl.Lock( true );
   
   common_impl.PlayAudio( "sfx", "common/audio/level1/aud_window_elf", 0, "", 0 );
 
   ObjSet( "spr_window_trebleclef_2", { alp = 0 });  
   ObjSet( "vid_window_use_elf", { alp = 1, playing = true, endtrig = func_after }); 
   interface.InventoryItemRemove( "inv_elf_1" ); 
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_window", false ) and cmn.IsEventDone( "use_windowhandle" ) and not cmn.IsEventDone( "use_elf_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_windowhandle()

  local item = "inv_windowhandle";

  if ( common.ApplyObj( item, "obj_window_use_windowhandle", true ) ) then

    cmn.CallEventHandler( "use_windowhandle_inv" );
    cmn.CallEventHandler( "use_windowhandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_windowhandle" );
      cmn.CallEventHandler( "use_windowhandle_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_windowhandle_window", 0, "", 0 );
  
  ObjAnimate( "spr_window_windowhandle_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  ObjAnimate( "spr_window_windowhandle_over", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_window", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window", nil, { 512, 384 }, true );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_collect_2_1_3()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_1_3");
    cmn.CallEventHandler("get_collect_2_1_3");

    if cmn.IsEventDone( "get_trebleclef" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_window_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_wrench()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );

end;
--------------------------------------------------------------------------------------------
function private.get_letter_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_letter_1" );
  cmn.CallEventHandler( "get_letter_1" );

  if ( cmn.IsEventDone("get_hexagon") ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hexagon()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hexagon" );
  cmn.CallEventHandler( "get_hexagon" );

  if ( cmn.IsEventDone("get_letter_1") ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_windowhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_windowhandle" );
  cmn.CallEventHandler( "get_windowhandle" );

end;
--------------------------------------------------------------------------------------------
function private.get_trebleclef()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_trebleclef" );
  cmn.CallEventHandler( "get_trebleclef" );
  
  if common_impl.IsGetCollect( "get_collect_2_1_3" ) then

    common.CloseSubRoom();
    
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_lever()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_chest_use_lever' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_chest", 0, "", 0 );
  
  ObjAnimate( "spr_chest_arm_2", "ang", 0, 0, func_after,
  { 
    0.0, 3, 0.0, 
    0.3, 3, -0.04,
    0.6, 3, 0.0
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_chest()
 
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_chest_use_lever' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_chest", 0, "", 0 );
  
  ObjAnimate( "spr_chest_arm_1", "ang", 0, 0, func_after,
  { 
    0.0, 3, 0.0, 
    0.3, 3, -0.04,
    0.6, 3, 0.0
  } );
  
  
  
end;  
--------------------------------------------------------------------------------------------
function private.clk_lever_1()

  cmn.CallEventHandler( "clk_lever_1_beg" );

  local func_after = function ()
  
    local func_end = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_lever_1" );
      cmn.CallEventHandler( "clk_lever_1_end" );
      
    end;
    
    ObjAnimate( "spr_chest_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_chest_over_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_chest_over_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_lever_chest", 0, "", 0 );
  
  ObjAnimate( "spr_chest_arm_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  
  ObjAnimate( "spr_chest_arm_1_op", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  ObjAnimate( "spr_chest_arm_2", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  
  ObjAnimate( "spr_chest_arm_2_op", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
-------------------------------------------------------------------------------------
function private.clk_window()

  
  local func_after = function ()

    common_impl.Lock( false );
   
  end;

  common_impl.Lock( true );
  
  common_impl.ShowBbt( 'bbt_window_use_windowhandle', 1 );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_window", 0, "", 0 );

  ObjAnimate( "spr_window_close", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, -165, 
    0.3, 0, -163,
    0.6, 0, -165
  } );
  

end;
-----------------------------------------------------------------------------------
function private.clk_crow()
  
  cmn.CallEventHandler( "clk_crow_beg" );
  
  local func_after = function ()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_crow" );
    cmn.CallEventHandler( "clk_crow_end" );
    if ( cmn.IsEventDone( "get_trebleclef" ) and cmn.IsEventDone( "get_collect_2_1_3" ) ) then
      common.CloseSubRoom();
    end;
    
  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_smallroom_crows", 0, "", 0 );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_crows_zz_env", 0.5 );

  common_impl.Lock( true );
  ObjSet("anm_window_crow_1", { alp = 0, frame = 0 }); 
  ObjSet("anm_window_crow_2", { alp = 1, frame = 0 }); 
  AnimPlay("anm_window_crow_2", "DoAnim", func_after );
  
end;
-----------------------------------------------------------------------------------
function private.clk_cabinet_door()
  local func_after = function ()

    common_impl.Lock( false );
   
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_cabinet", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_cabinet_use_gear' );
  ObjAnimate( "spr_cabinet_handle_2", "ang", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 0.18,
    0.6, 0, 0
   
  } );
  ObjAnimate( "spr_cabinet_windowhandle_over", "ang", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 0.18,
    0.6, 0, 0
    
  } );
  
end;  
-----------------------------------------------------------------------------------
function private.clk_windowhandle()

  cmn.CallEventHandler( "clk_windowhandle_beg" );
  local func_after = function()
  
    local func_end = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_windowhandle" );
      cmn.CallEventHandler( "clk_windowhandle_end" );

      common_impl.PlayAudio( "env", "common/audio/level1/aud_open_window_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/level1/aud_smallroom_closed_window_env", 0.5 );
      
    end; 
    
    ObjAnimate( "spr_window_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_window_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_window", 0, "", 0 );
  
  ObjAnimate( "spr_window_windowhandle_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
  ObjAnimate( "spr_window_windowhandle_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  


end;
-------------------------------------------------------------------------------------
function private.clk_handle()

  cmn.CallEventHandler( "clk_handle_beg" );
  
  local func_after = function()
  
   local func_end = function()
   
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_handle" );
      cmn.CallEventHandler( "clk_handle_end" );
      common.CloseSubRoom();
      
   end;
   AnimPlay("anm_cabinet_cogs", "DoAnim", func_end );
  end; 
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_touch_handle_cabinet2", 0, "", 0 );
  
  ObjAnimate( "spr_cabinet_handle_2", "ang", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 0.18,
    0.6, 0, 0
   
  } );
  ObjAnimate( "spr_cabinet_windowhandle_over", "ang", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 0.18,
    0.6, 0, 0
    
  } );
  


end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_smallroom()

  if not ( cmn.IsEventDone( "opn_smallroom" ) ) then
    cmn.SetEventDone( "opn_smallroom" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  end;
  
  cmn.CallEventHandler( "opn_smallroom" ); 

end;
--*********************************************************************************************************************
  ObjAnimate( "spr_smallroom_light_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_cabinet_light_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  --ObjAnimate( "spr_window_storm", "alp", 1, 0, "", 
  --{ 
  --  0.0, 0, 0, 
  --  1.5, 0, 0,
  --  1.7, 0, 1,
  --  1.9, 1, 0,
  --  2.1, 1, 1,
  --  2.3, 1, 0,
  --  2.6, 0, 1,
  --  2.9, 0, 0,
  --  10.0, 0, 0
  --  
  --} );
  