-- name=ho_avengersstuff
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "avengersstuff" );
  game.relations[ "ho_avengersstuff" ].exitroom = "rm_base";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_avengersstuff = function ()

  local effects_table = 
  {
    "anm_avengersstuff_anim"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_avengersstuff", update_performance_mode_avengersstuff, "ho_avengersstuff" );
  
  ObjMultiSet( {
  
    { "spr_avengersstuff_bottle", { event_mdown = function() private.TaskComplete( 'bottle' ) end } },
    { "spr_avengersstuff_cassette", { event_mdown = function() private.TaskComplete( 'cassette' ) end } },
    { "spr_avengersstuff_letter", { event_mdown = function() private.TaskComplete( 'letter' ) end } },
    { "spr_avengersstuff_notebook", { event_mdown = function() private.TaskComplete( 'notebook' ) end } },
    { "spr_avengersstuff_pills", { event_mdown = function() private.TaskComplete( 'pills' ) end } },
    { "spr_avengersstuff_mt", { event_mdown = function() private.TaskComplete( 'mt' ) end } },
    { "spr_avengersstuff_skull", { event_mdown = function() private.TaskComplete( 'skull' ) end } },
    { "spr_avengersstuff_theater", { event_mdown = function() private.TaskComplete( 'theater' ) end } },
    { "spr_avengersstuff_town", { event_mdown = function() private.TaskComplete( 'town' ) end } },
    { "spr_avengersstuff_photo_big", { event_mdown = function() private.TaskComplete( 'photo' ) end } },
    { "spr_avengersstuff_paper", { event_mdown = function() private.TaskComplete( 'paper' ) end } },
    { "spr_avengersstuff_tube", { event_mdown = function() private.TaskComplete( 'tube' ) end } },
    { "obj_avengersstuff_clk_dictaphone", { event_mdown = function() private.TaskComplete( 'dictaphone' ) end,
                                            event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                            event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } },
                                            
    { "spr_avengersstuff_photo", { event_mdown = function() ObjSet("spr_avengersstuff_photo",{ input = false }); common_impl.NoteScale( "open", "spr_avengersstuff_photo" ); private.note_open = true; end } }
  
  } );
  
  private.times = { 6, 6, 4, 6, 7, 11, 5, 10, 6, 7, 8, 11 };
  
  private.marked = { "photo", "paper", "tube" };
  
  private.note_open = false;
  
  private.tasks = { "dictaphone", "tube", "letter", "mt", "paper", "skull", "pills", "town", "theater", "photo", "notebook", "bottle", "cassette" };

  for i = 1, #private.marked do
   
    ObjSet( "obj_avengersstuff_clk_open_"..private.marked[i], { event_mdown = function() private.unmark_task( private.marked[i] ) end,
                                                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } ); 
    
  end;
  
  
  common_impl.hint[ "win_avengersstuff" ] = {
      type = "win",
      room = "rm_base",
      zz = "ho_avengersstuff",
      zz_gate = "gho_base_avengersstuff"
  };
  
  local win_avengersstuff_func = function ()

    if ( cmn.IsEventDone( "win_avengersstuff" ) ) then
      
      interface.InventoryItemAdd( "inv_skullsymbol", "spr_avengersstuff_win" );
      
    end;

  end;
  cmn.AddSubscriber( "win_avengersstuff", win_avengersstuff_func );
  ---------------------------------------------------------------------------
  local unmark_photo = function () 
   
    ObjSet( "obj_avengersstuff_open_photo", { alp = 1, input = true } );
    ObjDelete( "obj_avengersstuff_clk_open_photo" );
    ObjDelete( "anm_avengersstuff_open_photo" );

  end;

  cmn.AddSubscriber( "unmark_photo", unmark_photo, "ho_avengersstuff" );   
   ---------------------------------------------------------------------------
  local unmark_paper = function () 
   
    ObjSet( "obj_avengersstuff_open_paper", { alp = 1, input = true } );
    ObjDelete( "obj_avengersstuff_clk_open_paper" );
    ObjDelete( "anm_avengersstuff_open_paper" );

  end;

  cmn.AddSubscriber( "unmark_paper", unmark_paper, "ho_avengersstuff" );   
   ---------------------------------------------------------------------------
  local unmark_tube = function () 
   
    ObjSet( "obj_avengersstuff_open_tube", { alp = 1, input = true } );
    ObjDelete( "obj_avengersstuff_clk_open_tube" );
    ObjDelete( "spr_avengersstuff_letter_over" );

  end;

  cmn.AddSubscriber( "unmark_tube", unmark_tube, "ho_avengersstuff" );   
  --------------------------------------------------------------------------------------------------
  local start_avengersstuff_func = function ()

    if ( cmn.IsEventStart( "win_avengersstuff" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_avengersstuff" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      if ng_global.progress[ "std" ][ "win_avengersstuff" ].clk_dictaphone then
        
        ObjSet( "spr_avengersstuff_dictaphone_light", { alp = 1, active = false } );
        ObjDelete( "obj_avengersstuff_clk_dictaphone" );
        
      end;
      
      if not cmn.IsEventDone( "win_avengersstuff" ) then
        
        private.SetTask();
      
        local name = private.tasks[ ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ];

        ObjSet( "txt_avengersstuff_taskpanel", { text = "str_avengersstuff_"..name } );

        if cmn.IsUnmarkedTask( "avengersstuff", "photo" ) then
          unmark_photo();
        end;
  
        if cmn.IsUnmarkedTask( "avengersstuff", "paper" ) then
          unmark_paper();
        end;
        
        if cmn.IsUnmarkedTask( "avengersstuff", "tube" ) then
          unmark_tube();
        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_avengersstuff", start_avengersstuff_func, "ho_avengersstuff" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_avengersstuff" ) ) then
  
    cmn.InitHo( "avengersstuff" );
    cmn.SetEventDone( "opn_avengersstuff" );
    
    cmn.SetMarkedTask( "avengersstuff", "photo" );
    cmn.SetMarkedTask( "avengersstuff", "paper" );
    cmn.SetMarkedTask( "avengersstuff", "tube" );
    
    ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count = 1;
    ng_global.progress[ "std" ][ "win_avengersstuff" ].clk_dictaphone = false;
    
    private.ShowTask();
  
  end;

  local ho_items = {};

  --interface.TaskPanelTaskAdd( ho_items, "dictaphone",   1, 0, { { "spr_avengersstuff_dictaphone_light" } } );
  interface.TaskPanelTaskAdd( ho_items, "bottle",       1, 0, { { "spr_avengersstuff_bottle" } } );
  interface.TaskPanelTaskAdd( ho_items, "cassette",     1, 0, { { "spr_avengersstuff_cassette" } } );
  interface.TaskPanelTaskAdd( ho_items, "letter",       1, 0, { { "spr_avengersstuff_letter" } } );
  interface.TaskPanelTaskAdd( ho_items, "notebook",     1, 0, { { "spr_avengersstuff_notebook" } } );
  interface.TaskPanelTaskAdd( ho_items, "pills",        1, 0, { { "spr_avengersstuff_pills" } } );
  interface.TaskPanelTaskAdd( ho_items, "mt",           1, 0, { { "spr_avengersstuff_mt" } } );
  interface.TaskPanelTaskAdd( ho_items, "skull",        1, 0, { { "spr_avengersstuff_skull" } } );
  interface.TaskPanelTaskAdd( ho_items, "theater",      1, 0, { { "spr_avengersstuff_theater" } } );
  interface.TaskPanelTaskAdd( ho_items, "town",         1, 0, { { "spr_avengersstuff_town" } } );
  interface.TaskPanelTaskAdd( ho_items, "photo",        1, 1, { { "spr_avengersstuff_photo" } } );
  interface.TaskPanelTaskAdd( ho_items, "paper",        1, 1, { { "spr_avengersstuff_paper" } } );
  interface.TaskPanelTaskAdd( ho_items, "tube",         1, 1, { { "spr_avengersstuff_tube" } } );
  
  --interface.ItemPanelItemAdd( ho_items, ""    );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "avengersstuff" );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
  common_impl.StopAudio( "env", "common/audio/level2/aud_ho_avengersstuff_env", 0 );
  
  ObjSet( "tmr_avengersstuff_dictaphone", { playing = false } );
  ObjSet( "anm_avengersstuff_dictaphone", { playing = false } );

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "avengersstuff" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count = ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count + 1;
  
  if task_name == "dictaphone" then
    
    private.ClkDictaphone();
   
  else
    
    if task_name == "photo" then
      
      private.note_open = false;
    
      cmn.HoTaskFind( "spr_avengersstuff_photo_big", task_name );
      
    else
      
      cmn.HoTaskFind( "spr_avengersstuff_"..task_name, task_name );
      
    end;
    
    if ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ~= 14 then
      
      private.ShowTask();
      
    end;
    
  end;

end;
--************************************************************** *******************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
  common_impl.StopAllVoc();
  
end;
--*********************************************************************************************************************
function private.StartTimer( time )
  
  local func_after = function()
   
    ObjSet( "anm_avengersstuff_dictaphone", { playing = false } );
    
    common_impl.StopAudio( "env", "common/audio/level2/aud_ho_avengersstuff_env", 0 );
   
  end;
  
  common_impl.PlayAudio( "env", "common/audio/level2/aud_ho_avengersstuff_env", 1, "", 0 );
  
  ObjSet( "tmr_avengersstuff_dictaphone", { time = time, playing = true, endtrig = func_after } );
  
  ObjSet( "anm_avengersstuff_dictaphone", { playing = true } );
  
end;
--*********************************************************************************************************************
function private.ShowTask()

  local func_after = function()
  
    common_impl.Lock( false );

    private.SetTask();

    --interface.WidgetSetInput( InterfaceWidget_BtnHint, true );

  end;

  if ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ~= 14 then

    local name = private.tasks[ ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ];
    local time = private.times[ ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count - 1 ];

    common_impl.StopAllVoc();
    
    common_impl.Lock( true );

    common_impl.PlayAudio( "voc", "common/audio/level2/aud_avengersstuff_"..name.."_voc", 0, "", 0 );

    ObjSet( "txt_avengersstuff_taskpanel", { text = "str_avengersstuff_"..name } );
    
    ObjAnimate( "txt_avengersstuff_taskpanel", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
    
    ObjSet( "tmr_avengersstuff_dictaphone", { playing = false } );
    
    if name ~= "dictaphone" then
    
      private.StartTimer( time );
      
    end;

  end;

end;
--*********************************************************************************************************************
function private.SetTask()
  
  if ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ~= 14 then
  
    ObjSet( "spr_avengersstuff_"..private.tasks[ ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count ], { input = true } ); 
    
  end;
 
end;
--*********************************************************************************************************************
function private.ClkDictaphone()
  
  local func_after = function()
  
    common_impl.Lock( false );
  
    ng_global.progress[ "std" ][ "win_avengersstuff" ].clk_dictaphone = true;
    
    ObjSet( "obj_avengersstuff_clk_dictaphone", { input = false } );
    
    private.ShowTask();
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_avengersstuff_play", 0, "", 0 );
  
  ObjAnimate( "spr_avengersstuff_dictaphone_light", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  
end;
--*********************************************************************************************************************
function private.unmark_task( task_name )
  
  local func_after = function()
  
    local func_end = function()

      common_impl.Lock( false );

      cmn.UnmarkTask( "avengersstuff", task_name );
      cmn.CallEventHandler( "unmark_"..task_name );

    end;
 
    ObjAnimate( "obj_avengersstuff_open_"..task_name, "alp", 0, 0, func_end, { 0,3,0,  0.3,3,1 } );
    
    if task_name == "paper" or task_name == "photo" then
 
      ObjAnimate( "anm_avengersstuff_open_"..task_name, "alp", 0, 0, "", { 0,3,1,  0.3,3,0 } );
      
    else
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_avengersstuff_open_pocket", 0, "", 0 );
      
      ObjAnimate( "spr_avengersstuff_letter_over", "alp", 0, 0, "", { 0,3,1,  0.3,3,0 } );
      
    end;
    
  end;
  
  common_impl.Lock( true );
  
  if task_name == "paper" or task_name == "photo" then
    
    AnimPlay( "anm_avengersstuff_open_"..task_name, "DoAnim", func_after );
    
    if task_name == "paper" then
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_avengersstuff_open_right", 0, "", 0 );
        
    else
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_avengersstuff_open_left", 0, "", 0 );
      
    end;
    
  else
    
    func_after();
    
  end;
  
end;
--******************************************************************************************
function public.HoHintShow()
  
  local hint_table = { hint = {} };

  if not cmn.IsEventDone( "win_avengersstuff" ) then

    local task_count = ng_global.progress[ "std" ][ "win_avengersstuff" ].task_count;

    local objname = "spr_avengersstuff_"..private.tasks[ task_count ];
    
    if task_count == 1 then
      
      objname = "obj_avengersstuff_clk_dictaphone";
      
    elseif task_count == 2 and not cmn.IsUnmarkedTask( "avengersstuff", "tube" ) then
      
      objname = "obj_avengersstuff_clk_open_tube";
      
    elseif task_count == 5 and not cmn.IsUnmarkedTask( "avengersstuff", "paper" ) then
      
      objname = "obj_avengersstuff_clk_open_paper";
      
    elseif task_count == 10 and not cmn.IsUnmarkedTask( "avengersstuff", "photo" ) then
 
      objname = "obj_avengersstuff_clk_open_photo";
      
    elseif task_count == 10 and cmn.IsUnmarkedTask( "avengersstuff", "photo" ) and private.note_open then
      
      objname = "spr_avengersstuff_photo_big";
      
    end;
    
    local pos = GetObjPosByObj( objname );

    table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

  end;

  if #hint_table.hint ~= 0 then

    MsgSend( Command_Effect_ShowHoHint, hint_table );

  else

    MsgSend( Event_HoHint_NoObjects, {} );

  end;
  
end;
--*********************************************************************************************************************

ObjAnimate( "spr_avengersstuff_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );

ObjAnimate( "spr_avengersstuff_dictaphone_light", "alp", 1, 0, "", { 0,0,0, 1,0,1, 2,0,0  } );
