-- name=ho_cabinethos
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "cabinethos" );
  game.relations[ "ho_cabinethos" ].exitroom = "rm_garage";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_cabinethos = function ()

  local effects_table = 
  {
    "anm_cabinethos_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_cabinethos", update_performance_mode_cabinethos, "ho_cabinethos" );
  

  ObjMultiSet( {

  { "spr_cabinethos_wrench_1", { event_mdown = function() private.TaskComplete( 'wrench', 1 ) end } },
  { "spr_cabinethos_wrench_2", { event_mdown = function() private.TaskComplete( 'wrench', 2 ) end } },
  { "spr_cabinethos_bulgarian_1", { event_mdown = function() private.TaskComplete( 'bulgarian', 1 ) end } },
  { "spr_cabinethos_bulgarian_2", { event_mdown = function() private.TaskComplete( 'bulgarian', 2 ) end } },
  { "spr_cabinethos_cog_1", { event_mdown = function() private.TaskComplete( 'cog', 1 ) end } },
  { "spr_cabinethos_cog_2", { event_mdown = function() private.TaskComplete( 'cog', 2 ) end } },
  { "spr_cabinethos_die_1", { event_mdown = function() private.TaskComplete( 'die', 1 ) end } },
  { "spr_cabinethos_die_2", { event_mdown = function() private.TaskComplete( 'die', 2 ) end } },
  { "spr_cabinethos_drill_1", { event_mdown = function() private.TaskComplete( 'drill', 1 ) end } },
  { "spr_cabinethos_drill_2", { event_mdown = function() private.TaskComplete( 'drill', 2 ) end } },
  { "spr_cabinethos_tape_1", { event_mdown = function() private.TaskComplete( 'tape', 1 ) end } },
  { "spr_cabinethos_tape_2", { event_mdown = function() private.TaskComplete( 'tape', 2 ) end } },
  
  { "spr_cabinethos_pen", { event_mdown = function() private.TaskComplete( 'pen' ) end } },
  
  } );
  
  private.crop = { 1, 50, 100 };

  common_impl.hint[ "win_cabinethos" ] = {
      type = "win",
      room = "rm_garage",
      zz = "ho_cabinethos",
      zz_gate = "gho_garage_cabinethos"
  };
  
  local win_cabinethos_func = function ()

    if ( cmn.IsEventDone( "win_cabinethos" ) ) then
      interface.InventoryItemAdd( "inv_carhandle", "spr_cabinethos_win" );
      ObjDelete( "gho_garage_cabinethos");
    end;

  end;
  cmn.AddSubscriber( "win_cabinethos", win_cabinethos_func );
  --------------------------------------------------------------------------------------------------
  local start_cabinethos_func = function ()

  if ( cmn.IsEventStart( "win_cabinethos" ) and not cmn.IsEventDone( "win_cabinethos" ) ) then
    
      local ho_found = ng_global.progress[ "std" ][ "win_cabinethos" ].found;

      for i = 1, #ho_found, 1 do
        
        ObjDelete( ho_found[ i ][ "object" ] );
        
        local task_name = common.GetObjectPrefix( ho_found[ i ][ "task" ] );
        
        local counter = ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ task_name ];
        
        if counter ~= 2 then
        
          ObjSet( "spr_cabinethos_taskpanel_"..task_name.."_add", { croprect_w = private.crop[ counter + 1 ] } );
          
        else
          
          ObjSet( "spr_cabinethos_taskpanel_"..task_name, { scale_x = 0, scale_y = 0 } );
          
        end;
 
      end;
      
      if ng_global.progress[ "std" ][ "win_cabinethos" ].task_count == 12 then
            
        ObjSet( "txt_cabinethos_task", { alp = 1 } );
        ObjSet( "spr_cabinethos_pen", { input = true } );
        
      end;

    end;

  end;
  cmn.AddSubscriber( "win_cabinethos", start_cabinethos_func, "ho_cabinethos" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_cabinethos" ) ) then
  
    cmn.InitHo( "cabinethos" );
    cmn.SetEventDone( "opn_cabinethos" );
    
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks = {};
    
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "wrench" ] = 0;
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "bulgarian" ] = 0;
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "cog" ] = 0;
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "die" ] = 0;
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "drill" ] = 0;
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ "tape" ] = 0;
    
    ng_global.progress[ "std" ][ "win_cabinethos" ].task_count = 0;
  

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "wrench_1",             1, 0, { { "spr_cabinethos_wrench_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "wrench_2",             1, 0, { { "spr_cabinethos_wrench_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "bulgarian_1",          1, 0, { { "spr_cabinethos_bulgarian_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "bulgarian_2",          1, 0, { { "spr_cabinethos_bulgarian_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "cog_1",                1, 0, { { "spr_cabinethos_cog_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "cog_2",                1, 0, { { "spr_cabinethos_cog_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "die_1",                1, 0, { { "spr_cabinethos_die_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "die_2",                1, 0, { { "spr_cabinethos_die_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "drill_1",              1, 0, { { "spr_cabinethos_drill_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "drill_2",              1, 0, { { "spr_cabinethos_drill_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "tape_1",               1, 0, { { "spr_cabinethos_tape_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "tape_2",               1, 0, { { "spr_cabinethos_tape_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",                  1, 0, { { "spr_cabinethos_pen" } } );


  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "cabinethos" );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
 function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );
  
  int_taskpanel_impl.ShowTextPanel( "cabinethos" );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
 
end;
--*********************************************************************************************************************
function private.TaskCompleteAnim( task_name, number )
  
  if number then
  
    local old_crop = ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ task_name ] - 1;
    
    local new_crop = ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ task_name ];
   
    local func_after = function()
    
      if new_crop == 2 then
        
        local func_after_2 = function()
        
          ObjAnimate( "spr_cabinethos_taskpanel_"..task_name, "scale_xy", 0, 0, "", { 0,0,0.8,0.8, 0.2,0,0,0 } );
          
          if ng_global.progress[ "std" ][ "win_cabinethos" ].task_count == 12 then
            
            ObjSet( "txt_cabinethos_task", { alp = 1 } );
            ObjSet( "spr_cabinethos_pen", { input = true } );
            
          end;
        
        end;
        
        ObjAnimate( "spr_cabinethos_taskpanel_"..task_name.."_add_2", "alp", 0, 0, func_after_2, { 0,0,0, 0.2,0,1, 0.3,0,1 } );
        
      end;
      
      ObjDelete( "anm_cabinethos_find_"..task_name.."_"..number );
    
    end;
   
    ObjAnimate( "spr_cabinethos_taskpanel_"..task_name.."_add", "croprect_w", 0, 0, func_after, { 0,0, private.crop[old_crop + 1], 0.5,0,private.crop[new_crop + 1] } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, number )
  
  if number then
    
    local func_after = function()
  
      private.TaskCompleteAnim( task_name, number );
      
      ObjClone( "anm_cabinethos_inv", "_"..task_name.."_"..number, 1, "spr_cabinethos_taskpanel_"..task_name );
 
      local name = "anm_cabinethos_inv_"..task_name.."_"..number;
      
      ObjSet( name, { alp = 1, playing = true } );
    
    end;
    
    cmn.HoTaskFind( "spr_cabinethos_"..task_name.."_"..number, task_name.."_"..number );
    
    ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ task_name ] = ng_global.progress[ "std" ][ "win_cabinethos" ].tasks[ task_name ] + 1;
    
    ng_global.progress[ "std" ][ "win_cabinethos" ].task_count = ng_global.progress[ "std" ][ "win_cabinethos" ].task_count + 1;
  
    ObjClone( "anm_cabinethos_find", "_"..task_name.."_"..number, 1, "obj_cabinethos_anim_find" );
    
    local pos = GetObjPosByObj( "spr_cabinethos_"..task_name.."_"..number );
    local pos_2 = GetObjPosByObj( "spr_cabinethos_taskpanel_"..task_name );
 
    local name = "anm_cabinethos_find_"..task_name.."_"..number;
    
    local tme = math.sqrt( ( pos_2[1] - pos[1] )^2 + ( pos_2[2] - pos[2] )^2 )/1000;
    
    ObjAnimate( name, "alp", 0, 0, func_after, { 0,0,1, ( tme + 0.1 ),0,1, ( tme + 0.2 ),0,0 } );
    
    ObjAttach( name, "ng_interface_transporter" );
   
    ObjAnimate( name, "pos_xy", 0, 0, "", { 0,0,pos[1],pos[2], tme,0,pos_2[1], pos_2[2] } );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_cabinethos_effect", 0, "", 0 );
    
  else
    
    cmn.HoTaskFind( "spr_cabinethos_"..task_name, task_name );
    
  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************