-- name=ho_chesthos
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chesthos" );
  game.relations[ "ho_chesthos" ].exitroom = "rm_bar_2";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_chesthos = function ()

  local effects_table = 
  {
    "anm_chesthos_anim",
    "obj_chesthos_anims"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_chesthos", update_performance_mode_chesthos, "ho_chesthos" );
  
  ObjMultiSet( {
  
  { "spr_chesthos_bow", { event_mdown = function() private.TaskComplete( 'bow' ) end } },
  { "spr_chesthos_butterfly_1", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_chesthos_butterfly_1'  ) end } },
  { "spr_chesthos_butterfly_2", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_chesthos_butterfly_2' ) end } },
  { "spr_chesthos_butterfly_3", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_chesthos_butterfly_3' ) end } },
  { "spr_chesthos_button", { event_mdown = function() private.TaskComplete( 'button' ) end } },
  { "spr_chesthos_coffee_1", { event_mdown = function() private.TaskComplete( 'coffee', 'spr_chesthos_coffee_1' ) end } },
  { "spr_chesthos_coffee_2", { event_mdown = function() private.TaskComplete( 'coffee', 'spr_chesthos_coffee_2' ) end } },
  { "spr_chesthos_coffee_3", { event_mdown = function() private.TaskComplete( 'coffee', 'spr_chesthos_coffee_3' ) end } },
  { "spr_chesthos_crest", { event_mdown = function() private.TaskComplete( 'crest' ) end } },
  { "spr_chesthos_cufflink_1", { event_mdown = function() private.TaskComplete( 'cufflink', 'spr_chesthos_cufflink_1' ) end } },
  { "spr_chesthos_cufflink_2", { event_mdown = function() private.TaskComplete( 'cufflink', 'spr_chesthos_cufflink_2' ) end } },
  { "spr_chesthos_feather", { event_mdown = function() private.TaskComplete( 'feather' ) end } },
  { "spr_chesthos_flower", { event_mdown = function() private.TaskComplete( 'flower' ) end } },
  { "spr_chesthos_fork", { event_mdown = function() private.TaskComplete( 'fork' ) end } },
  { "spr_chesthos_phone_drive", { event_mdown = function() private.TaskComplete( 'phone_drive' ) end } },
  { "spr_chesthos_scotch", { event_mdown = function() private.TaskComplete( 'scotch' ) end } },
  { "spr_chesthos_ring", { event_mdown = function() private.TaskComplete( 'ring' ) end } },
  
  } );
  
  common_impl.hint[ "win_chesthos" ] = {
      type = "win",
      room = "rm_bar_2",
      zz = "ho_chesthos",
      zz_gate = "gho_bar_2_chesthos"
  };
  
  local win_chesthos_func = function ()

    if ( cmn.IsEventDone( "win_chesthos" ) ) then
      interface.InventoryItemAdd( "inv_button_2_3", "spr_chesthos_win" );
    end;

  end;
  cmn.AddSubscriber( "win_chesthos", win_chesthos_func );
  --------------------------------------------------------------------------------------------------
  local start_chesthos_func = function ()

    if ( cmn.IsEventStart( "win_chesthos" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_chesthos" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_chesthos", start_chesthos_func, "ho_chesthos" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( "ho_chesthos" ) );
  
  if ( not cmn.IsEventDone( "opn_chesthos" ) ) then
  
    cmn.InitHo( "chesthos" );
    cmn.SetEventDone( "opn_chesthos" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bow",          1, 0, { { "spr_chesthos_bow" } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",    3, 0, { { "spr_chesthos_butterfly_1" }, { "spr_chesthos_butterfly_2" }, { "spr_chesthos_butterfly_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "button",       1, 0, { { "spr_chesthos_button" } } );
  interface.TaskPanelTaskAdd( ho_items, "coffee",       3, 0, { { "spr_chesthos_coffee_1" },{ "spr_chesthos_coffee_2" },{ "spr_chesthos_coffee_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "crest",        1, 0, { { "spr_chesthos_crest" } } );
  interface.TaskPanelTaskAdd( ho_items, "cufflink",     2, 0, { { "spr_chesthos_cufflink_1" }, { "spr_chesthos_cufflink_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "feather",      1, 0, { { "spr_chesthos_feather" } } );
  interface.TaskPanelTaskAdd( ho_items, "flower",       1, 0, { { "spr_chesthos_flower" } } );
  interface.TaskPanelTaskAdd( ho_items, "fork",         1, 0, { { "spr_chesthos_fork" } } );
  interface.TaskPanelTaskAdd( ho_items, "phone_drive",  1, 0, { { "spr_chesthos_phone_drive" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",         1, 0, { { "spr_chesthos_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "scotch",       1, 0, { { "spr_chesthos_scotch" } } );
  
  --interface.ItemPanelItemAdd( ho_items, ""    );

  interface.TaskPanelShow( ho_items );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )
  
  local object = object_name or "spr_chesthos_"..task_name;

  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  local item_object_name = "obj_"..cmn.GetObjectName( item_name );

  ObjDelete( item_object_name );

  interface.ItemPanelTryToComplete();

end;
--*********************************************************************************************************************

ObjAnimate( "spr_chesthos_light", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
