-- name=ho_specialequipment
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "specialequipment" );
  game.relations[ "ho_specialequipment" ].exitroom = "rm_atbar";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_specialequipment = function ()

  local effects_table = 
  {
    "anm_specialequipment_anim"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_specialequipment", update_performance_mode_specialequipment, "ho_specialequipment" );
  
  ObjMultiSet( {
  
  { "spr_specialequipment_camcorder", { event_mdown = function() private.TaskComplete( 'camcorder', 2 ) end } },
  { "spr_specialequipment_dictaphone", { event_mdown = function() private.TaskComplete( 'dictaphone', 7 ) end } },
  { "spr_specialequipment_film", { event_mdown = function() private.TaskComplete( 'film', 12 ) end } },
  { "spr_specialequipment_laser_pointer", { event_mdown = function() private.TaskComplete( 'laser_pointer', 11 ) end } },
  { "spr_specialequipment_lock_picks", { event_mdown = function() private.TaskComplete( 'lock_picks', 5 ) end } },
  { "spr_specialequipment_loupe", { event_mdown = function() private.TaskComplete( 'loupe', 1 ) end } },
  { "spr_specialequipment_mask", { event_mdown = function() private.TaskComplete( 'mask', 6 ) end } },
  { "spr_specialequipment_microphone", { event_mdown = function() private.TaskComplete( 'microphone', 3 ) end } },
  { "spr_specialequipment_respirator", { event_mdown = function() private.TaskComplete( 'respirator', 9 ) end } },
  { "spr_specialequipment_sensor", { event_mdown = function() private.TaskComplete( 'sensor', 4 ) end } },
  { "spr_specialequipment_shoe", { event_mdown = function() private.TaskComplete( 'shoe', 10 ) end } },
  { "spr_specialequipment_wig", { event_mdown = function() private.TaskComplete( 'wig', 8 ) end } },
  { "spr_specialequipment_bomb", { event_mdown = function() private.TaskComplete( 'bomb' ) end } },
  
  } );
  
  for i = 1, 12 do

    ObjSet( "spr_specialequipment_piece_"..i, { event_mdown = function() private.ClkPiece( i ) end } );

  end;
  
  common_impl.hint[ "win_specialequipment" ] = {
      type = "win",
      room = "rm_atbar",
      zz = "ho_specialequipment",
      zz_gate = "gho_atbar_specialequipment"
  };
  
  local win_specialequipment_func = function ()

    if ( cmn.IsEventDone( "win_specialequipment" ) ) then
      interface.InventoryItemAdd( "inv_bomb_plus", "spr_specialequipment_win" );
      ObjSet( "inv_bomb_plus", { drag = false })
    end;

  end;
  cmn.AddSubscriber( "win_specialequipment", win_specialequipment_func );
  --------------------------------------------------------------------------------------------------
  local start_specialequipment_func = function ()

    if ( cmn.IsEventStart( "win_specialequipment" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_specialequipment" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      for i = 1, #ng_global.progress[ "std" ][ "win_specialequipment" ].pieces do
        if ng_global.progress[ "std" ][ "win_specialequipment" ].pieces[i] == 1 then
          ObjSet( "spr_specialequipment_piece_"..i, { input = true } );
        end;   
      end;

      for i = 1, #ng_global.progress[ "std" ][ "win_specialequipment" ].puzzles do
        if ng_global.progress[ "std" ][ "win_specialequipment" ].puzzles[i] == 1 then
          ObjDelete( "spr_specialequipment_piece_"..i );
          ObjSet( "spr_specialequipment_puzzle_"..i, { alp = 1 } );
        end;   
      end;
 
      if ng_global.progress[ "std" ][ "win_specialequipment" ].objects_counter == 0 then

        ObjAttach( "txt_specialequipment_task", "int_taskpanel_impl");
        ObjSet( "obj_int_taskpanel", { alp = 0 } );

        if ng_global.progress[ "std" ][ "win_specialequipment" ].puzzle_counter == 0 then

          ObjSet( "spr_specialequipment_open", { input = true, alp = 1 } );
          ObjSet( "spr_specialequipment_bomb", { input = true } );
          ObjSet( "txt_specialequipment_task", { alp = 1, text = "str_specialequipment_last_task" } ); 

        else 

         ObjSet( "txt_specialequipment_task", { alp = 1, param0 = ng_global.progress["std"]["win_specialequipment"].puzzle_counter } );
             
        end;

      end;

    end;

  end;
 
  cmn.AddSubscriber( "win_specialequipment", start_specialequipment_func, "ho_specialequipment" );  
  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_specialequipment" ) ) then
  
   cmn.InitHo( "specialequipment" );
   cmn.SetEventDone( "opn_specialequipment" );
  
   ng_global.progress[ "std" ][ "win_specialequipment" ].pieces = { 0,0,0,0,0,0,0,0,0,0,0,0 };
   ng_global.progress[ "std" ][ "win_specialequipment" ].puzzles = { 0,0,0,0,0,0,0,0,0,0,0,0 };
   ng_global.progress[ "std" ][ "win_specialequipment" ].objects_counter = 12;
   ng_global.progress[ "std" ][ "win_specialequipment" ].puzzle_counter = 12;
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "camcorder",     1, 0, { { "spr_specialequipment_camcorder" } } );
  interface.TaskPanelTaskAdd( ho_items, "dictaphone",    1, 0, { { "spr_specialequipment_dictaphone" } } );
  interface.TaskPanelTaskAdd( ho_items, "film",          1, 0, { { "spr_specialequipment_film" } } );
  interface.TaskPanelTaskAdd( ho_items, "laser_pointer", 1, 0, { { "spr_specialequipment_laser_pointer" } } );
  interface.TaskPanelTaskAdd( ho_items, "lock_picks",    1, 0, { { "spr_specialequipment_lock_picks" } } );
  interface.TaskPanelTaskAdd( ho_items, "loupe",         1, 0, { { "spr_specialequipment_loupe" } } );
  interface.TaskPanelTaskAdd( ho_items, "mask",          1, 0, { { "spr_specialequipment_mask" } } );
  interface.TaskPanelTaskAdd( ho_items, "microphone",    1, 0, { { "spr_specialequipment_microphone" } } );
  interface.TaskPanelTaskAdd( ho_items, "respirator",    1, 0, { { "spr_specialequipment_respirator" } } );
  interface.TaskPanelTaskAdd( ho_items, "sensor",        1, 0, { { "spr_specialequipment_sensor" } } );
  interface.TaskPanelTaskAdd( ho_items, "shoe",          1, 0, { { "spr_specialequipment_shoe" } } );
  interface.TaskPanelTaskAdd( ho_items, "wig",           1, 0, { { "spr_specialequipment_wig" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "piece_1",       1, 0, { { "spr_specialequipment_piece_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_2",       1, 0, { { "spr_specialequipment_piece_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_3",       1, 0, { { "spr_specialequipment_piece_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_4",       1, 0, { { "spr_specialequipment_piece_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_5",       1, 0, { { "spr_specialequipment_piece_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_6",       1, 0, { { "spr_specialequipment_piece_6" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_7",       1, 0, { { "spr_specialequipment_piece_7" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_8",       1, 0, { { "spr_specialequipment_piece_8" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_9",       1, 0, { { "spr_specialequipment_piece_9" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_10",      1, 0, { { "spr_specialequipment_piece_10" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_11",      1, 0, { { "spr_specialequipment_piece_11" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_12",      1, 0, { { "spr_specialequipment_piece_12" } } );   
  
  interface.TaskPanelTaskAdd( ho_items, "bomb",          1, 0, {  { "spr_specialequipment_bomb" } } );  

  interface.TaskPanelShow( ho_items );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
 --*********************************************************************************************************************
 function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();

  ObjDetach( "txt_specialequipment_task");
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, piece_number )
  
  ng_global.progress[ "std" ][ "win_specialequipment" ].objects_counter = ng_global.progress[ "std" ][ "win_specialequipment" ].objects_counter - 1;
  
  if piece_number then

    cmn.HoTaskFind( "spr_specialequipment_"..task_name, task_name );
    ObjSet( "spr_specialequipment_piece_"..piece_number, { input = true } );
    ng_global.progress[ "std" ][ "win_specialequipment" ].pieces[ piece_number ] = 1;

  else
    
    cmn.HoTaskFind( "spr_specialequipment_bomb", task_name );
    --ObjAnimate( "obj_specialequipment_note", "alp", 0, 0, "", { 0,0,1, 1,0,0 } );

  end;

  if ng_global.progress[ "std" ][ "win_specialequipment" ].objects_counter == 0 then
    
    ObjAttach( "txt_specialequipment_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_specialequipment_task", { alp = 1, param0 = ng_global.progress[ "std" ][ "win_specialequipment" ].puzzle_counter } );
    
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.ClkPiece( number )

  local old_coords = ObjGet( "spr_specialequipment_piece_"..number );
  local new_coords = ObjGet( "spr_specialequipment_puzzle_"..number );

  ObjSet( "spr_specialequipment_piece_"..number, { pos_z = 5, input = false } );
  ObjSet( "spr_specialequipment_piece_"..number.."_shadow", { alp = 0 } );

  local func_after = function()

    ng_global.progress["std"]["win_specialequipment"].puzzle_counter = ng_global.progress["std"]["win_specialequipment"].puzzle_counter - 1;
    ng_global.progress["std"]["win_specialequipment"].puzzles[number] = 1;
    ObjSet( "txt_specialequipment_task", { param0 = ng_global.progress["std"]["win_specialequipment"].puzzle_counter } );

    cmn.HoTaskFind( "spr_specialequipment_puzzle_"..number.."_clone", "piece_"..number );

    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_specialequipment_set", 0, "", 0 );

    if ng_global.progress["std"]["win_specialequipment"].puzzle_counter == 0 then
      ObjSet( "spr_specialequipment_open", { input = true, alp = 1 } );
      ObjSet( "spr_specialequipment_bomb", { input = true } );
      ObjSet( "txt_specialequipment_task", { text = "str_specialequipment_last_task" } ); 
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_specialequipment_open", 0, "", 0 );
      
    end;
    
  end;

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_ho_specialequipment_click", 0, "", 0 );
  
  ObjAnimate( "spr_specialequipment_piece_"..number, "pos_xy", 0, 0, func_after, { 0,0,old_coords.pos_x, old_coords.pos_y,   0.5,0,new_coords.pos_x, new_coords.pos_y } );
  ObjAnimate( "spr_specialequipment_piece_"..number, "ang", 0, 0, "", { 0,0,0,   0.5,0,7.5 } );
  ObjAnimate( "spr_specialequipment_piece_"..number, "alp", 0, 0, "", { 0,0,1, 0.4,0,1, 0.5,0,0 } );
  ObjAnimate( "spr_specialequipment_puzzle_"..number, "alp", 0, 0, "", { 0,0,0, 0.4,0,0, 0.5,0,1 } );  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
