-- name=mg_brickhos
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_brickhos";
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_brickhos = function ()

  local effects_table = 
  {
    "spr_brickhos_light_add",
    "anm_brickhos_background"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_brickhos", update_performance_mode_brickhos, private.room_objname );
  ------------------------------------------------------------------------------------------
  
  private.win_array = { 9, 6, 7, 11, 13, 5 ,10, 14 };
  private.position = 1;
  private.coord = { 0, 0 };
  private.array_sign = { { 1 , 2 , 3 , 4, 5 , 7 , 8 , 9 , 13, 12 },
                         { 11, 10, 16, 6, 20, 18, 19, 15, 17, 14 },
                       };
  
  local table_multiset = {};

  for i = 1, 20 do

      table.insert( table_multiset, { "obj_brickhos_stone_"..i.."_clk", { 
      event_mdown = function()  private.StoneClk( i ) end; 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, 
      } } );

  end;
  ObjMultiSet(table_multiset);  
  ObjMultiSet({
      { "obj_brickhos_stone_first_clk", { event_mdown = function() private.FirstClk() end;
                                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end; } },
      { "obj_brickhos_mode_hard", { event_mdown = function() private.SetHard() end,
                                        event_menter = function() private.MouseEnterAnim( "spr_brickhos_mode_btn_hard" ) end, 
                                        event_mleave = function() private.MouseLeaveAnim( "spr_brickhos_mode_btn_hard" ) end; } },
      { "obj_brickhos_mode_casual", { event_mdown = function() private.SetNormal() end;
                                        event_menter = function() private.MouseEnterAnim( "spr_brickhos_mode_btn_casual" ) end, 
                                        event_mleave = function() private.MouseLeaveAnim( "spr_brickhos_mode_btn_casual" ) end; } },
  });
  
  --------------------------------------------------------------------------------------------
  -- function win_brickhos () end;
  --------------------------------------------------------------------------------------------
  local win_brickhos = function ()

  if ( cmn.IsEventDone( "win_brickhos" ) ) then  

  else
    
    private.position = 1;

     if ng_global.progress[ "std" ][ "win_brickhos" ].first_clk then
        
        ObjSet("obj_brickhos_stone_first_clk", { input = false });
        ObjSet("obj_brickhos_stone_clk", { input = true});
        
      else 
       
        ObjSet("obj_brickhos_stone_first_clk", { input = true });
        ObjSet("obj_brickhos_stone_clk", { input = false});
        
      end;  
      
      if ng_global.progress[ "std" ][ "win_brickhos" ].flag then
        
         private.coord = ng_global.progress[ "std" ][ "win_brickhos" ].push;
         
      end;
    if not ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl then
      
     
        for i = 1, 20  do
          
            ObjSet("spr_brickhos_stone_"..i, { alp = 1 });
            --ObjSet("obj_brickhos_stone_"..i.."_clk", { input = true });
            
        end;
        
        if ng_global.progress[ "std" ][ "win_brickhos" ].hardcore then
          
              ObjMultiSet({
  
               { "obj_brickhos_mode_hard", { input = false } },
               { "obj_brickhos_mode_casual", { input = true } },
              });
          
          for i = 1, 8  do
          
              if ng_global.progress[ "std" ][ "win_brickhos" ].state[i] ~= 0 then
                
                ObjSet("spr_brickhos_stone_"..ng_global.progress[ "std" ][ "win_brickhos" ].state[i], { alp = 0 });
                private.position = private.position + 1;
                
              end;
            
          end
        
      
        else
            
              ObjMultiSet({
  
              { "obj_brickhos_mode_hard", { input = true } },
              { "obj_brickhos_mode_casual", { input = false} },
              });
            
          
         
          for i = 6, 8  do
      
            ObjSet("spr_brickhos_stone_"..private.win_array[i].."_skull", { alp = 0 });
            ObjSet("spr_brickhos_skull_"..private.win_array[i], { alp = 0 });
      
          end; 
          
          for i = 1, 5  do
          
              if ng_global.progress[ "std" ][ "win_brickhos" ].state[i] ~= 0 then
                
                ObjSet("spr_brickhos_stone_"..ng_global.progress[ "std" ][ "win_brickhos" ].state[i], { alp = 0 });
                private.position = private.position + 1;
                
              end;
            
          end;  
        
        
        end
      
    
    else
        
          ObjSet("obj_brickhos_skulls", { alp = 0, input = false });
          ObjSet("obj_brickhos_signs", { alp = 1 });
          for i = 1, 20  do
          
            ObjSet("spr_brickhos_stone_"..i.."_pair", { alp = 1 });
            
            
          end;
          
       if  ng_global.progress[ "std" ][ "win_brickhos" ].hardcore then
          
              ObjMultiSet({
  
               { "obj_brickhos_mode_hard", { input = false } },
               { "obj_brickhos_mode_casual", { input = true } },
              });
          
            for i = 1, 2  do
              
              for j = 1, 10 do  
          
                if ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j] ~= 0 then
                  
                  ObjSet("spr_brickhos_stone_"..ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j].."_pair", { alp = 0 });
                  private.position = private.position + 0.5;
                  
                end;
                
              end;
          end
        
      
        else
            
              ObjMultiSet({
  
              { "obj_brickhos_mode_hard", { input = true } },
              { "obj_brickhos_mode_casual", { input = false} },
              });
            
          
         
          for i = 1, 2  do
              
           -- for j = 5, 10 do  
           for j = 6, 10 do  
      
                ObjSet( "spr_brickhos_stone_"..private.array_sign[i][j].."_signs", { alp = 0 });
                ObjSet( "spr_brickhos_signs_"..private.array_sign[i][j], { alp = 0 });
          
            end;
            
          end; 
          
          
          for i = 1, 2  do
              
            for j = 1, 5 do  
          
                if ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j] ~= 0 then
                  
                  ObjSet("spr_brickhos_stone_"..ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j].."_pair", { alp = 0 });
                  private.position = private.position + 0.5;
                  
                end;
                
              end;
         end;
        
        
        end  
         
       
        
         
    end;  
        
  end;

  end;

  cmn.AddSubscriber( "win_brickhos", win_brickhos, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  local beg_level2 = function ()
  
    interface.InventoryItemAdd( "inv_elf_2_1" );
    
    ObjSet( "spr_int_button_apparat_apparat", { alp = 1 } );
    ObjSet( "obj_int_button_apparat", { input = true } );
    
    ObjSet( "obj_int_button_map_button", { input = false } );
    ObjSet( "spr_int_button_map_button", { alp = 0 } );
    
    ObjSet("spr_int_button_map_button_focus_over", { pos_x = -25, pos_y = 3, res="assets/interface/resources/button_map/map_2"});
    ObjSet("spr_int_button_map_button_focus_1", {  res="assets/interface/resources/button_map/map_2_add"});
    ObjSet("spr_int_button_map_button_focus", { pos_x = 3, pos_y = -22, res="assets/interface/resources/button_map/map_2_add" });
    
  end;
  cmn.AddSubscriber( "beg_level2", beg_level2 );  
  --------------------------------------------------------------------------------------------
  -- function vid_brickhos_intro () end;
  --------------------------------------------------------------------------------------------
  local vid_brickhos_intro_end = function ()
  
    ObjSet( "mg_brickhos", { color_r = 1, color_g = 1, color_b = 1 } );
  
  end;
  
  cmn.AddSubscriber( "vid_brickhos_intro", vid_brickhos_intro_end, private.room_objname );
  cmn.AddSubscriber( "vid_brickhos_intro_end", vid_brickhos_intro_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_brickhos_pulling () end;
  --------------------------------------------------------------------------------------------
  local vid_brickhos_pulling_end = function ()
  
    
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_brickhos_pulling", vid_brickhos_pulling_end, private.room_objname  );
  cmn.AddSubscriber( "vid_brickhos_pulling_end", vid_brickhos_pulling_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_brickhos" ) and cmn.IsEventDone( "vid_brickhos_intro" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
  common_impl.PlayAudio( "env", "common/audio/level2/aud_mg_brickhos_env", 1, "", 0 );
  private.sound = math.random( 1,3 )
  --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_in"..sound, 0, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "vid_brickhos_intro" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( "rm_brickhos", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_brickhos_intro", private.room_objname);
    ObjSet( "tmr_brickhos_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );
      
  end;
  
  if ( not cmn.IsEventDone( "vid_brickhos_pulling" ) and cmn.IsEventDone( "win_brickhos" )) then
    
    private.vid_brickhos_pulling();
    
  end;  

  if ( not cmn.IsEventStart( "win_brickhos" ) ) then
    
    ng_global.progress[ "std" ][ "win_brickhos" ].state = {0, 0, 0, 0, 0, 0, 0, 0};
    ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl = false;
    ng_global.progress[ "std" ][ "win_brickhos" ].hardcore = true;
    ng_global.progress[ "std" ][ "win_brickhos" ].first_clk = false;
    ng_global.progress[ "std" ][ "win_brickhos" ].flag = false;
    ng_global.progress[ "std" ][ "win_brickhos" ].pair = {{0,0,0,0,0,0,0,0,0,0},
                                                          {0,0,0,0,0,0,0,0,0,0},
                                                         };
    ng_global.progress[ "std" ][ "win_brickhos" ].push = { 0, 0};                                                     
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_brickhos" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.FirstClk() 
 
  local func_after = function ()
  
    local func_end = function ()
  
     common_impl.Lock( false );
     ng_global.progress[ "std" ][ "win_brickhos" ].first_clk = true; 
     ObjSet("obj_brickhos_stone_first_clk", { input = false });
     ObjSet("obj_brickhos_stone_clk", { input = true});
     
    end; 
   
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_out3", 0, "", 0 );
   
   for i = 1, 20  do
     
     ObjAnimate( "spr_brickhos_stone_"..i, "alp", 0, 0, func_end,
     { 
     
        0.0, 0, 0,
        0.6, 3, 1
        
     });
     func_end = "";
   end
   

   
  end;
  common_impl.Lock( true );
  --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_in1", 0, "", 0 );
  --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_in2", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_in3", 0, "", 0 );
   ObjAnimate( "spr_brickhos_stone_9", "alp", 0, 0, func_after,
   { 
      0.0, 0, 1,
      0.3, 0, 0
      --0.6, 3, 1
   });
  
  
end;  
-------------------------------------------------------------------------------------------------------------------
function private.StoneClk( i )
  
  local j = 0;
  local k  =0;
  if ng_global.progress[ "std" ][ "win_brickhos" ].hardcore then 
    
    j = 8 
    k = 10;
   else 
    
    j = 5;
    k = 5;
  end;  
  
  if ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl then
    
    private.ClkSigns( i, k );
    
  else
    
    private.ClkSkulls( i, j );
    
  end;
  
end;  
----------------------------------------------------------------------------------------------------------------
function private.ClkSkulls( num, mod )
  
  
    local func_after = function ()
    
      common_impl.Lock( false );
      
      -- for i = 1, mod  do
        
      -- if  num == private.win_array[i] and private.check_elem( num, mod ) then 
      if  private.check_win_array( num, mod ) and not private.check_elem( num, mod ) then
           
           
        --ng_global.progress[ "std" ][ "win_brickhos" ].state[private.position]  = num;
           
           private.position = private.position + 1;
           
       else  
           
           public.Reset();
           
       end; 
       
        -- end;
      
        -- if private.position == mod + 1 then private.Win_First(); end;
        if private.position == mod + 1 then
          
          private.Win_First();
       
        else
        
          ng_global.progress[ "std" ][ "win_brickhos" ].state[private.position - 1] = num;  
      
        end;
    
    end;
  
   common_impl.Lock( true );
   
  
   
   if ObjGet("spr_brickhos_stone_"..num).alp ~=0 then 
     
    private.GetSoundIn();
   
     ObjAnimate( "spr_brickhos_stone_"..num, "alp", 0, 0, func_after,
     { 
        0.0, 0, 1,
        0.3, 0, 0
     });
     
   else  
     
     func_after();
     
   end;
   
end;
 
--------------------------------------------------------------------------------------------------------------------
function private.ClkSigns( num, mod ) 
  
 local func_after = function ()
    
      --local new_j = 0;
      
      common_impl.Lock( false );
      
      if not ng_global.progress[ "std" ][ "win_brickhos" ].flag then
        
        --for i = 1, 2  do
        --  
        --  for j = 1, mod  do
        --    
        --    -- if num == private.array_sign[i][j] and private.check_elem_pair( num, mod ) then 
        --    if num == private.array_sign[i][j]  then 
        if private.check_push_pair( num, mod ) and not private.check_elem_pair( num, mod ) then 
         
               --private.coord[1] = i;
               --private.coord[2] = j;
               
               ng_global.progress[ "std" ][ "win_brickhos" ].flag = true;
               -- ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j] = num;
               ng_global.progress[ "std" ][ "win_brickhos" ].pair[private.coord[1] ][private.coord[2] ] = num;
             
            --else
            --
            --public.Reset();
            --
            --  end
        else
          
           public.Reset();
           
           -- end; 
           
           -- end
          
        end
        
      
      else
         
         if num == private.array_sign[private.get_new_i()][private.coord[2] ] and not private.check_elem_pair( num, mod ) then
         
         ng_global.progress[ "std" ][ "win_brickhos" ].flag = false;
         ng_global.progress[ "std" ][ "win_brickhos" ].pair[private.get_new_i()][private.coord[2] ] = num;
         private.coord = { 0, 0 };
         ng_global.progress[ "std" ][ "win_brickhos" ].push = private.coord;
         private.position = private.position + 1;
         
         
       else  
         
         public.Reset();
        
       end;
       
      end; 
     
     if private.position == mod + 1 then private.Win(); end;
     
   end; 
    
  common_impl.Lock( true );
  
  if ObjGet("spr_brickhos_stone_"..num.."_pair").alp ~= 0 then 
    
    private.GetSoundIn();
    
    ObjAnimate( "spr_brickhos_stone_"..num.."_pair", "alp", 0, 0, func_after,
     { 
        0.0, 0, 1,
        0.3, 0, 0
     });
     
   else
     
     func_after();
     
   end;
end;  
---------------------------------------------------------------------------------------------------------------------
function private.get_new_i()
 
  local new_i = 0;
 
 if private.coord[1] ~= 0 and private.coord[1] == 1
   
   then new_i = 2
   
 else 
  
   new_i = 1;
   
 end;  
 
 return new_i;
 
end; 
---------------------------------------------------------------------------------------------------------------------
function private.check_push_pair( num, mod )
  
   answer = false;
   
   for i = 1, 2  do
          
      for j = 1, mod  do
        
         if num == private.array_sign[i][j]  then 
           
          answer = true; 
          private.coord[1] = i;
          private.coord[2] = j; 
          ng_global.progress[ "std" ][ "win_brickhos" ].push[1] = i;
          ng_global.progress[ "std" ][ "win_brickhos" ].push[2] = j;
          
          
         end;   
  
      end;
          
   end;
    
   return answer;   
end;  
---------------------------------------------------------------------------------------------------------------------
function private.check_elem( num, mod )
  
  answer = false;
  
  for i = 1, mod  do
    
    --if num ~= ng_global.progress[ "std" ][ "win_brickhos" ].state[i] then 
     if num == ng_global.progress[ "std" ][ "win_brickhos" ].state[i] then 
      
      answer = true;
     
      break;
     
    end;
   
  end;
  
 return answer;
  
end; 
---------------------------------------------------------------------------------------------------------------------
function private.check_elem_pair( num, mod )
  
  answer = false;
  
  for i = 1, 2  do
          
    for j = 1, mod  do
    
      if num == ng_global.progress[ "std" ][ "win_brickhos" ].pair[i][j] then 
      
        answer = true;
        
        break;
      
      end;
    
    end;
  
  end;
  
 return answer;
  
end;
---------------------------------------------------------------------------------------------------------------------
function private.check_win_array( num, mod )
  
  answer = false;
  
  for i = 1, mod  do
    
    if num == private.win_array[i] then 
      
     answer = true;
     
    end;
   
  end;
  
 return answer;
  
end;  
---------------------------------------------------------------------------------------------------------------------
function private.SetNormal()

  local func_after = function()
  
    ObjMultiSet({
    --{ "obj_harproom_mode_hard", { alp = 0, input = false } },
    { "obj_brickhos_mode_casual", { input = false } },
    { "obj_brickhos_mode_hard", { input = true } },
    });
    ng_global.progress[ "std" ][ "win_brickhos" ].hardcore = false;
    common_impl.Lock( false );
    for i = 6, 8  do
      
      ObjSet("spr_brickhos_stone_"..private.win_array[i].."_skull", { alp = 0 });
      ObjSet("spr_brickhos_skull_"..private.win_array[i], { alp = 0 });
      
    end;
    for i = 1, 2  do
          
     for j = 6, 10  do
        
       ObjSet( "spr_brickhos_stone_"..private.array_sign[i][j].."_signs", { alp = 0 });
       ObjSet( "spr_brickhos_signs_"..private.array_sign[i][j], { alp = 0 });
      
     end;
    
    end;
    
    if ng_global.progress[ "std" ][ "win_brickhos" ].first_clk then 
      
      public.Reset();
    
    end;
    
  end;
  
  common_impl.Lock( true );
  
  --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_change_complexity", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_change_complexity", 0, "", 0 );
  
  ObjAnimate("spr_brickhos_mode_btn_casual", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });
  
end;
-------------------------------------------------------------
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
----------------------------------------------------------------------------------------------------------------------
function private.GetSoundIn()
  
  local s;
  
  s = math.random(1, 3);

  while (private.sound == s) do
     
     s = math.random(1, 3);
     
   end;
   
  private.sound = s; 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_in"..private.sound, 0, "", 0 );
  

end;  
----------------------------------------------------------------------------------------------------------------------
function private.GetSoundOut()
  
  local s;
  
  s = math.random(1, 3);

  while (private.sound == s) do
     
     s = math.random(1, 3);
     
   end;
   
  private.sound = s; 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_out"..private.sound, 0, "", 0 );
  

end;  
----------------------------------------------------------------------------------------------------------------------
function private.SetHard()

  local func_after = function()
  
    ObjMultiSet({
    --{ "obj_harproom_mode_hard", { alp = 1, input = true } },
    { "obj_brickhos_mode_hard", { input = false } },
    { "obj_brickhos_mode_casual", { input = true } },
    });
    ng_global.progress[ "std" ][ "win_brickhos" ].hardcore = true;
    
    for i = 1, 8  do
      
      ObjSet("spr_brickhos_stone_"..private.win_array[i].."_skull", { alp = 1 });
      ObjSet("spr_brickhos_skull_"..private.win_array[i], { alp = 1 });
      
    end;
    
    for i = 1, 20  do
      
      ObjSet( "spr_brickhos_stone_"..i.."_signs", { alp = 1 });
      ObjSet( "spr_brickhos_signs_"..i, { alp = 1 });
      
    end;
    
    
    
    common_impl.Lock( false );
    
    if ng_global.progress[ "std" ][ "win_brickhos" ].first_clk then 
      
      public.Reset();
    
    end;
    
  end;
  
  common_impl.Lock( true );
  
  --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_harproom_change_complexity", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_change_complexity", 0, "", 0 );
  
  ObjAnimate("spr_brickhos_mode_btn_hard", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 3, 1,
    0.4, 3, 0
  });

end;
--*********************************************************************************************************************
function public.Reset()
 
 
 if not ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl then
    
   local func_after = function()
   
    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_brickhos" ].state = {0, 0, 0, 0, 0, 0, 0, 0};
    private.position = 1;
   
   end;
  
    for i = 1, 20  do
    
     if  ObjGet("spr_brickhos_stone_"..i).alp ~= 1 then 
       
       private.GetSoundOut();
       
       break;
         
      end;
     
    end;
  
   common_impl.Lock( true );
  
   for i = 1, 20  do
     
     --if ng_global.progress[ "std" ][ "win_brickhos" ].state[i] ~= 0 then
       if ObjGet("spr_brickhos_stone_"..i).alp ~= 1 then 
         
         --private.GetSoundOut();
       
        ObjAnimate("spr_brickhos_stone_"..i, "alp", 0, 0, func_after,
         {
        
           0.0, 0, 0, 
           0.4, 0, 1
          
         })
       else 
         
         func_after();
        --func_after="";
        
       end;
   
    end
    
  else 
    
    local func_after_1 = function()
   
    common_impl.Lock( false );
    
    ng_global.progress[ "std" ][ "win_brickhos" ].pair = {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                                                          {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                                                         };
    private.position = 1;
    private.coord = { 0, 0 };
    ng_global.progress[ "std" ][ "win_brickhos" ].push = private.coord;
    ng_global.progress[ "std" ][ "win_brickhos" ].flag = false;
   
   end;
  
   for i = 1, 20  do
    
     if  ObjGet("spr_brickhos_stone_"..i.."_pair").alp ~= 1 then 
       
       private.GetSoundOut();
       
       break;
       
       
      end;
     
    end;
   
  
   common_impl.Lock( true );
   
   for i = 1, 20  do
     
     --if ng_global.progress[ "std" ][ "win_brickhos" ].state[i] ~= 0 then
     if ObjGet("spr_brickhos_stone_"..i.."_pair").alp ~= 1 then 
       
       --private.GetSoundOut();
       
       ObjAnimate("spr_brickhos_stone_"..i.."_pair", "alp", 0, 0, func_after_1,
         {
        
           0.0, 0, 0, 
           0.4, 0, 1
          
         })
       else 
         
         func_after_1();
        --func_after="";
        
       end;
   
    end
    
    
  end;  

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  local func_after = function ()
  
     private.WinEnd();
     
  end;
   
  if not ng_global.progress[ "std" ][ "win_brickhos" ].first_clk then
    
    for  i = 1, 20  do
      
      ObjSet( "spr_brickhos_stone_"..i, { alp = 1 });
      
    end
    
  end; 
  
  if not ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl then
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_win", 0, "", 0 );
    
    for i = 1, 8  do
  
      if ObjGet("spr_brickhos_stone_"..private.win_array[i].."_skull").alp ~= 0 then 
      
         ObjAnimate("spr_brickhos_stone_"..private.win_array[i], "alp", 0, 0, func_after,
        {
        
          0.0, 0, 1, 
          0.4, 3, 0
          
        }); 
        
        func_after ="";
      
      end;
    
   end
    
  else
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_win", 0, "", 0 );
    
    for i = 1, 20  do
      
      if ObjGet("spr_brickhos_stone_"..i.."_signs").alp ~= 0 then 
      
        ObjAnimate("spr_brickhos_stone_"..i.."_pair", "alp", 0, 0, func_after,
        {
        
          0.0, 0, 1, 
          0.4, 3, 0
          
        }); 
        
       func_after ="";
      
      end;
    
   end
   
 end; 

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_brickhos" );
  cmn.CallEventHandler( "win_brickhos" );

  private.vid_brickhos_pulling();

end;
--*********************************************************************************************************************
function private.Win()

  local func_after = function ()
  
     private.WinEnd();
     
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_win", 0, "", 0 );
  
  for i = 1, 20  do
    
    if ObjGet("spr_brickhos_stone_"..i.."_pair").alp ~= 0 then 
      
     
      ObjAnimate("spr_brickhos_stone_"..i.."_pair", "alp", 0, 0, func_after,
        {
        
          0.0, 0, 1, 
          0.4, 3, 0
          
        }); 
        func_after= function() end;
        
      else  

        func_after();
        func_after= function() end;
        
    end;
      
  end; 
   
end;
--*********************************************************************************************************************
function private.Win_First()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    DbgTrace("alalalala");
    ng_global.progress[ "std" ][ "win_brickhos" ].first_lvl = true;
    
    if not ng_global.progress[ "std" ][ "win_brickhos" ].hardcore then
      
      for i = 1, 2  do
          
        for j = 6, 10  do
        
           ObjSet( "spr_brickhos_stone_"..private.array_sign[i][j].."_signs", { alp = 0 });
           ObjSet( "spr_brickhos_signs_"..private.array_sign[i][j], { alp = 0 });
      
        end;
    
    end;
      
      
    end; 
    private.Second_Start();
  
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_win", 0, "", 0 );
  
  for i = 1, 20  do
    
    if ObjGet("spr_brickhos_stone_"..i).alp ~= 0 then 
      
        ObjAnimate("spr_brickhos_stone_"..i, "alp", 0, 0, func_after,
        {
        
          0.0, 0, 1, 
          0.4, 3, 0
          
        }); 
        
    func_after ="";
        
    end;
      
  end
  
end;  
--********************************************************************************************************************  
function private.Second_Start()

   local func_after = function ()
   
    local func_end = function ()
   
      common_impl.Lock( false );
      private.position = 1;
     
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_out3", 0, "", 0 );
    for  i = 1, 20  do
      --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_out3", 0, "", 0 );
      ObjAnimate("spr_brickhos_stone_"..i.."_pair", "alp", 0, 0, func_end,
         {
              
           0.0, 0, 0, 
           0.4, 3, 1
                
         }); 
     
    end;
    
    
   end;
    
   common_impl.Lock( true );
   --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_brickhos_out3", 0, "", 0 );
   ObjAnimate("obj_brickhos_skulls", "alp", 0, 0, func_after,
   {
        
     0.0, 0, 1, 
     0.4, 0, 0
          
   }); 
   
   ObjAnimate("obj_brickhos_signs", "alp", 0, 0, "",
   {
        
    0.0, 0, 0, 
    0.4, 0, 1
          
   }); 
 


end;  
--*********************************************************************************************************************
function private.SeeIntro()

  ObjDelete( "tmr_brickhos_intro" ); 
  ObjSet( "vid_brickhos_intro", { alp = 1, active = true, visible = true } );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "beg_level2" );
    cmn.CallEventHandler( "beg_level2" );
    cmn.SetEventDone( "vid_brickhos_intro" );
    cmn.CallEventHandler( "vid_brickhos_intro_end" );
    
    cmn.MiniGameShow();
    common_impl.PassingMgStart();
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level2/aud_brickhos_intro", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level2/aud_brickhos_intro_voc", 0.2 );
          
    end;

      common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );
    
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Visor
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Visor
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_brickhos_intro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level2/aud_brickhos_intro_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_brickhos_intro", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_brickhos_intro", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_brickhos_pulling()

  local func_after = function ( skip )

    ObjSet( "mg_brickhos", { color_r = 0, color_g = 0, color_b = 0 } );
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_brickhos_pulling" );
    cmn.CallEventHandler( "vid_brickhos_pulling_end" );
    common_impl.ShowBbt( "bbt_vid_garage_pulling" );
    common.GotoRoom( "rm_garage" );
    
    common_impl.AddPageDiary( 6 );
    interface.KeyTaskAdd( "chase_avenger", true );
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level2/aud_brickhos_pulling", 0.2 );
      
    end;

  end;

  common_impl.StopAllMus();
  --cmn.GotoRoom('rm_garage');
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_brickhos_pulling", 0, "", 0 );
  interface.DialogVideoShow( "vid_brickhos_pulling", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_brickhos_pulling", function() func_after( nil ); end );

end;
---------------------------------
ObjAnimate("spr_brickhos_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});