-- name=mg_secretpassage
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_secretpassage";
  
  ObjMultiSet({ 
  
    { "obj_secretpassage_clk_mg", { event_mdown = private.StartMg } },
    { "spr_secretpassage_button", { event_mdown = private.ModeMouseDown,
                                    event_menter = private.ModeMouseEnter,
                                    event_mleave = private.ModeMouseLeave  } },
  });
  
  for i = 1, 15 do
    
    ObjSet( "obj_secretpassage_mg_part_"..i, { event_mdown = function() private.ClkPart( i ); end,
                                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  
  
   private.coords = { { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 } },  
                      { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 } },
                      { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 } },
                      { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 } } };

   private.state = { { 0,  8,  1,  2 },
                     { 9,  3,  4,  5 },
                     { 10, 6,  7,  11 },
                     { 12, 13, 14, 15 } };

   private.win_1_hard =   { {  0, -1,  0,  0 },
                            { -1,  1, -1,  0 },
                            {  0,  0,  1, -1 },
                            {  0,  0, -1,  0 } };
                     
   private.win_2_hard =   { {  0, -1,  0,  0 },
                            { -1,  1,  0,  0 },
                            {  0, -1,  1, -1 },
                            {  0,  0, -1,  0 } };
                       
   private.win_1_casual =   { {  0,  0,  0,  0 },
                              { -1,  1,  0,  0 },
                              {  0, -1,  1, -1 },
                              {  0,  0,  0,  0 } };
                       
   private.win_2_casual =   { {  0,  0,  0,  0 },
                              { -1,  1, -1,  0 },
                              {  0,  0,  1, -1 },
                              {  0,  0,  0,  0 } };
                              
   private.win_3_casual =   { {  0,  0,  0,  0 },
                              { -1,  1, -1,  1 },
                              {  0,  0,  0, -1 },
                              {  0,  0,  0,  0 } };
                              
   private.win_4_casual =   { {  0,  0,  0,  0 },
                              { -1,  0,  0,  0 },
                              {  1, -1,  1, -1 },
                              {  0,  0,  0,  0 } };
                     
   private.rotation = { { 0,  0,  1,  -1 },
                        { 0,  1,  -1,  1 },
                        { 0,  -1,  1,  0 },
                        { 0,  0,  0,  0 } };
                       
   private.main_rotation = { 0,0,0,0 };
   
   private.GetCoords();
   
   private.mode = { "casual", "hard" };
   
  --------------------------------------------------------------------------------------------
  -- function clk_secretpassager () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_secretpassage" ] = {
    type = "click",
    use_place = "obj_secretpassage_clk_mg",
    room = "mg_secretpassage"
  };
 
  local clk_secretpassage_beg = function ()
  
    ObjSet( "obj_secretpassage_clk_mg", { input = false } );
  
  end;
  local clk_secretpassage_end = function ()
  
    ObjDelete( "anm_secretpassage_gears_1" );
    ObjDelete( "anm_secretpassage_gears_2" );
    ObjDelete( "obj_secretpassage_clk_mg" );
    ObjDelete( "anm_secretpassage_button_open" );
    ObjDelete( "anm_secretpassage_gears_1_open" );
    ObjDelete( "anm_secretpassage_gears_2_open" );
    
    ObjSet( "obj_secretpassage_mg", { input = true } );
    ObjSet( "obj_secretpassage_button", { alp = 1 } );
    ObjSet( "anm_secretpassage_gears_open", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_secretpassage", clk_secretpassage_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secretpassage", clk_secretpassage_end, private.room_objname );
  cmn.AddSubscriber( "clk_secretpassage_beg", clk_secretpassage_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secretpassage_end", clk_secretpassage_end, private.room_objname );
  
  common_impl.hint[ "win_secretpassage" ] = {
    type = "win",
    room = "rm_bar_2",
    zz = "mg_secretpassage",
    zz_gate = "gmg_bar_2_secretpassage"
  }; 
  --------------------------------------------------------------------------------------------
  -- function win_secretpassage () end;
  --------------------------------------------------------------------------------------------
  local win_secretpassage = function ()

  if ( cmn.IsEventDone( "win_secretpassage" ) ) then  

  else
    
    for i = 1,4 do
      
      for j = 1,4 do

        private.rotation[i][j] = ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation[i][j];
        private.state[i][j] = ng_global.progress[ "std" ] [ "win_secretpassage" ].state[i][j];
        
        ObjSet( "obj_secretpassage_mg_part_"..private.state[i][j], { pos_x = private.coords[i][j][1],
                                                                     pos_y = private.coords[i][j][2] } );

      end;
      
    end;
                                                                 
    local mode = private.mode[ ng_global.progress[ "std" ] [ "win_secretpassage" ].mode ];
   
    ObjSet( "txt_secretpassage_button_mode", { text = "str_secretpassage_"..mode } );
    
    if mode == "casual" then
      
      ObjMultiSet({
    
        { "obj_secretpassage_mg_part_6_gear", { visible = false, ang = 0 } },
        { "obj_secretpassage_mg_part_7_gear", { visible = false, ang = 0 } },
        { "obj_secretpassage_mg_main_gear_2", { visible = false, ang = 0 } },
        { "obj_secretpassage_mg_main_gear_3", { visible = false, ang = 0 } }
      
      });
      
    end;

  end;

  end;

  cmn.AddSubscriber( "win_secretpassage", win_secretpassage, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_secretpassage" ) and cmn.IsEventDone( "clk_secretpassage" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
  private.StartAnim();
 
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_secretpassage" ) ) then
    
    ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation = { { 0,  0,  1,  -1 },
                                                                     { 0,  1,  -1,  1 },
                                                                     { 0,  -1,  1,  0 },
                                                                     { 0,  0,  0,  0 } };
    
    
    ng_global.progress[ "std" ] [ "win_secretpassage" ].state = { { 0,  8,  1,  2 },
                                                                  { 9,  3,  4,  5 },
                                                                  { 10, 6,  7,  11 },
                                                                  { 12, 13, 14, 15 } };
                                                                  
    ng_global.progress[ "std" ] [ "win_secretpassage" ].mode = 2;
    
  end;
  
  common_impl.PlayAudio( "env", "common/audio/level2/aud_secretpassage_env", 1, "", 0 );
  
  if not cmn.IsEventDone( "win_secretpassage" ) then
   if ng_global.gamemode == 0 then
     private.ChangeMode( private.mode[1] );
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_secretpassage" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
  common_impl.StopAudio( "env", "common/audio/level2/aud_secretpassage_env", 0.5 );
  
  common_impl.StopAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_gear", 0.2 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  local mode = private.mode[ ng_global.progress[ "std" ] [ "win_secretpassage" ].mode ];
  
  private.ChangeMode( mode );

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_secretpassage" );
  cmn.CallEventHandler( "win_secretpassage" );

  cmn.GotoRoom( "rm_bar_2" );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.StartAnim() 
  
  for i = 1, 4 do
    
    for j = 1, 4 do
      
      if private.rotation[i][j] ~= 0 then
 
        if private.rotation[i][j] == 1 then
            
          ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear", { ang = -0.4 } );
          ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear_shadow", { ang = -0.4 } );
          
        else
          
          ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear", { ang = 0 } );
          ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear_shadow", { ang = 0 } );
          
        end;
        
        private.StartRotation( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear", private.rotation[i][j] );
        
      end;
  
      if (( i == 1 and j == 2 ) or ( i == 2 and j == 1 ) or ( i == 3 and j == 4 ) or ( i == 4 and j == 3 )) and 
        ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ) and
        ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ).visible and
        ObjGet( "obj_secretpassage_mg_main_gear_"..j ).visible then 
   
        if private.main_rotation[j] == 0 then
          
          if not private.CheckMainGearsSound() then
                
             common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_gear", 1, "", 0 );
          
          end;
          
          private.main_rotation[j] = 1;
        
          private.StartRotation( "obj_secretpassage_mg_main_gear_"..j, 1 );
          
        end;
      
      end;
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.ClkPart( num )

  local func_after = function()

    common_impl.Lock( false );

    private.SaveState( num );

  end;

  local posx = ObjGet( "obj_secretpassage_mg_part_"..num ).pos_x;
  local posy = ObjGet( "obj_secretpassage_mg_part_"..num ).pos_y;

  local posxNew;
  local posyNew;
  
  local posi;
  local posj;

  for i = 1, 4 do
    for j = 1, 4 do

      if ( private.state[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( private.state[ i ][ j ] == 0 ) then

         posi_null = i;
         posj_null = j;
       
      end;

    end;
  end;
  
  if ( ( math.abs( posi - posi_null ) == 1 ) and ( ( posj - posj_null ) == 0 ) ) or
     ( ( math.abs( posj - posj_null ) == 1 ) and ( ( posi - posi_null ) == 0 ) ) then

    posxNew = private.coords[ posi_null ][ posj_null ][ 1 ];
    posyNew = private.coords[ posi_null ][ posj_null ][ 2 ];

  end

  if ( not ( posxNew and posyNew ) ) then return; end;

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_move", 0, "", 0 );

  common_impl.Lock( true );

  ObjAnimate( "obj_secretpassage_mg_part_"..num, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0,    posx,    posy,
    0.3, 0, posxNew, posyNew,
  } ); 

end;
--------------------------------------------------------------------------------------------------------------
function private.SaveState( num )

  local posi, posj, posi_null, posj_null;
  local tmp_array = {};

  for i = 1, 4 do
    
    tmp_array[ i ] = {};

    for j = 1, 4 do

      tmp_array[ i ][ j ] =  private.state[ i ][ j ];

      if ( tmp_array[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( tmp_array[ i ][ j ] == 0 ) then

        posi_null = i;
        posj_null = j;
  
      end;

    end;
  end;

  tmp_array[ posi ][ posj ] = 0;
  tmp_array[ posi_null ][ posj_null ] = num;

    for i = 1,4 do
     
      for j = 1,4 do

        ng_global.progress[ "std" ] [ "win_secretpassage" ].state[i][j] = private.state[i][j];

      end;
      
    end;

    ng_global.progress[ "std" ] [ "win_secretpassage" ].state[ posi ][ posj ] = 0;
    ng_global.progress[ "std" ] [ "win_secretpassage" ].state[ posi_null ][ posj_null ] = num;

    private.state[ posi ][ posj ] = 0;
    private.state[ posi_null ][ posj_null ] = num;
    
    private.CheckRotation( posi_null, posj_null, posi, posj );

end;
--*********************************************************************************************************************
function private.GetCoords()
  
  local start_x = 383;
  local start_y = 235
  
  for i = 1, 4 do
    
    for j = 1, 4 do 
      
      private.coords[i][j][1] = start_x + 95*( j - 1 );
      private.coords[i][j][2] = start_y + 95*( i - 1 );
      
      --DbgTrace( i.." "..j.."    "..private.coords[i][j][1].."  "..private.coords[i][j][2] );
      
    end;
    
  end;
    
end;
--*********************************************************************************************************************
function private.CheckRotation( i, j, old_i, old_j )
  
  local ang = private.rotation[old_i][old_j];
  
  private.rotation[old_i][old_j] = 0;
  
  -- top, left, right, down
  
  if (( i == 1 and j == 2 ) or ( i == 2 and j == 1 ) or ( i == 3 and j == 4 ) or ( i == 4 and j == 3 )) and 
    
    ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ) and
    ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ).visible and
    ObjGet( "obj_secretpassage_mg_main_gear_"..j ).visible then 
    
    if private.main_rotation[j] == 0 then
      
      if not private.CheckMainGearsSound() then
        
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_gear", 1, "", 0 );
  
      end;
      
      private.main_rotation[j] = 1;
    
      private.StartRotation( "obj_secretpassage_mg_main_gear_"..j, 1 ); 
          
    end;
    
  end;
 
    private.CheckGearsRotation()
  
end;
--*********************************************************************************************************************
function private.StartRotation( name, ang )
 
  ObjAnimate( name, "ang", 1, 0, "", { 0,0,0, 120,0,360*ang } );
  
end;
--*********************************************************************************************************************
function private.StopMainRotation()
 
  if ( private.state[2][1] ~= 0 and private.rotation[2][1] == 0 ) or ( private.state[2][1] == 0 ) then
   
    ObjStopAnimate( "obj_secretpassage_mg_main_gear_1", "ang" );
    
    private.main_rotation[1] = 0;
    
  end;
    
  if ( private.state[1][2] ~= 0 and private.rotation[1][2] == 0 ) or ( private.state[1][2] == 0 ) then
    
    ObjStopAnimate( "obj_secretpassage_mg_main_gear_2", "ang" );
    
    private.main_rotation[2] = 0;
 
  end;
    
  if ( private.state[4][3] ~= 0 and private.rotation[4][3] == 0 ) or ( private.state[4][3] == 0 ) then
    
    ObjStopAnimate( "obj_secretpassage_mg_main_gear_3", "ang" );
    
    private.main_rotation[3] = 0;
  
  end;
    
  if ( private.state[3][4] ~= 0 and private.rotation[3][4] == 0 ) or ( private.state[3][4] == 0 ) then
    
    ObjStopAnimate( "obj_secretpassage_mg_main_gear_4", "ang" );
    
    private.main_rotation[4] = 0;
    
  end;
  
  if not private.CheckMainGearsSound() then
    
    common_impl.StopAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_gear", 0.2 );
    
  end;

  private.CheckWin();
  
end;
--*********************************************************************************************************************
function private.CheckMainGearsSound()

  for i = 1, #private.main_rotation do
    
    if private.main_rotation[i] ~= 0 then
  
      return true;
      
    end;
    
  end;
  
  return false;
 
end;
--*********************************************************************************************************************
function private.CheckGearsRotation()
  
  for i = 1, 4 do
    
    for j = 1, 4 do
   
      if ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ) and
         ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear" ).visible then
        
        local ang = 0;
        
        --DbgTrace( i.." "..j );
        
        if (( i == 1 and j == 2 ) or ( i == 2 and j == 1 ) or ( i == 3 and j == 4 ) or ( i == 4 and j == 3 ))
              and ObjGet( "obj_secretpassage_mg_main_gear_"..j ).visible then
          
          ang = -1;
      
        elseif ( ( j-1 ) > 0 and private.state[i][j-1] ~= 0 and ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j-1].."_gear" ) and
            ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j-1].."_gear" ).visible ) then
          
          if ( private.rotation[i][j-1] ~= 0 ) then
          
            ang = - private.rotation[i][j-1];
            
          else
            
            ang = 1;
            
          end;
          
          --DbgTrace( ang.." enter 1" );
          
        elseif ( ( i-1 ) > 0 and private.state[i-1][j] ~= 0 and ObjGet( "obj_secretpassage_mg_part_"..private.state[i-1][j].."_gear" ) and
            ObjGet( "obj_secretpassage_mg_part_"..private.state[i-1][j].."_gear" ).visible ) then
          
          if ( private.rotation[i-1][j] ~= 0 ) then
          
            ang = - private.rotation[i-1][j];
            
          else
            
            ang = 1;
            
          end;
          
          --DbgTrace( ang.." enter 2" );
          
        elseif ( ( j+1 ) < 5 and private.state[i][j+1] ~= 0 and ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j+1].."_gear" ) and
            ObjGet( "obj_secretpassage_mg_part_"..private.state[i][j+1].."_gear" ).visible ) then
 
          if ( private.rotation[i][j+1] ~= 0 ) then
          
            ang = - private.rotation[i][j+1];
            
          else
            
            ang = 1;
            
          end;
          
          --DbgTrace( ang.." enter 3" );
          
        elseif ( ( i+1 ) < 5 and private.state[i+1][j] ~= 0 and ObjGet( "obj_secretpassage_mg_part_"..private.state[i+1][j].."_gear" ) and
            ObjGet( "obj_secretpassage_mg_part_"..private.state[i+1][j].."_gear" ).visible ) then
     
          if ( private.rotation[i+1][j] ~= 0 ) then
          
            ang = - private.rotation[i+1][j];
            
          else
            
            ang = 1;
            
          end;
          
          --DbgTrace( ang.." enter 4" );                
          
        end;
        
        if ang ~= 0 then
 
          if private.rotation[i][j] ~= ang then
          
            private.rotation[i][j] = ang;
            
            if ang == 1 then
              
              ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear", { ang = -0.4 } );
              ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear_shadow", { ang = -0.4 } );
              
            else
              
              ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear", { ang = 0 } );
              ObjSet( "spr_secretpassage_mg_part_"..private.state[i][j].."_gear_shadow", { ang = 0 } );
              
            end;

            private.StartRotation( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear", ang );
            
          end;
          
        else
          
          private.rotation[i][j] = 0;
          
          ObjStopAnimate( "obj_secretpassage_mg_part_"..private.state[i][j].."_gear", "ang" );
          
        end;
          
      end;
      
    end;
    
  end;
  
  private.StopMainRotation();
  
end;
--*********************************************************************************************************************
function private.CheckWin()

  local count_1 = 0;
  local count_2 = 0;
  local count_3 = 0;
  local count_4 = 0;
  
  local mode = private.mode[ ng_global.progress[ "std" ] [ "win_secretpassage" ].mode ];
  
  for i = 1, 4 do

    for j = 1, 4 do

      if ( mode == "hard" and private.rotation[ i ][ j ] ==  private.win_1_hard[ i ][ j ] ) or
         ( mode == "casual" and private.rotation[ i ][ j ] ==  private.win_1_casual[ i ][ j ] ) then
          
        count_1 = count_1 + 1;

      end;
      
      if ( mode == "hard" and private.rotation[ i ][ j ] ==  private.win_2_hard[ i ][ j ] ) or
        ( mode == "casual" and private.rotation[ i ][ j ] ==  private.win_2_casual[ i ][ j ] ) then
          
        count_2 = count_2 + 1;

      end;
      
      if ( mode == "casual" and private.rotation[ i ][ j ] ==  private.win_3_casual[ i ][ j ] ) then
          
        count_3 = count_3 + 1;

      end;
      
      if ( mode == "casual" and private.rotation[ i ][ j ] ==  private.win_4_casual[ i ][ j ] ) then
          
        count_4 = count_4 + 1;

      end;

    end;

  end;
  
  if ( count_1 == 16 or count_2 == 16 or count_3 == 16 or count_4 == 16 ) then

    private.Win();
   
  else
   
    for i = 1,4 do
      
      for j = 1,4 do

        ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation[i][j] = private.rotation[i][j];

      end;
      
    end;
 
  end;
  
end;
--*********************************************************************************************************************
function private.ModeMouseEnter()
  
  local tme = 0.3;
  
  local obj = "spr_secretpassage_button_light";

  common_impl.SetCursor( CURSOR_HAND );

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,      0, alp, 
    tme*alp , 0, 1
  } ); 
  
end;
--*********************************************************************************************************************
function private.ModeMouseLeave()
  
  local tme = 0.3;
  
  local obj = "spr_secretpassage_button_light";

  common_impl.SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,      0, alp, 
    tme*alp , 0, 0
  } ); 
  
end;
--*********************************************************************************************************************
function private.ModeMouseDown()
  
  ng_global.progress[ "std" ] [ "win_secretpassage" ].mode = 3 - ng_global.progress[ "std" ] [ "win_secretpassage" ].mode;
  
  local new_mode = private.mode[ ng_global.progress[ "std" ] [ "win_secretpassage" ].mode ];
 
  ObjSet( "txt_secretpassage_button_mode", { text = "str_secretpassage_"..new_mode } );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_change_complexity", 0, "", 0 );
  
  private.ChangeMode( new_mode );
  
end;
--*********************************************************************************************************************
function private.ChangeMode( mode )
  
  common_impl.StopAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_gear", 0.2 );
  
  for i = 1, 4 do
    
    ObjStopAnimate( "obj_secretpassage_mg_main_gear_"..i, "ang" );
    
  end;
  
  if mode == "casual" then

    ObjStopAnimate( "obj_secretpassage_mg_part_6_gear", "ang" );
    ObjStopAnimate( "obj_secretpassage_mg_part_7_gear", "ang" );
    
    ObjMultiSet({
    
      { "obj_secretpassage_mg_part_6_gear", { visible = false, ang = 0 } },
      { "obj_secretpassage_mg_part_7_gear", { visible = false, ang = 0 } },
      { "obj_secretpassage_mg_main_gear_2", { visible = false, ang = 0 } },
      { "obj_secretpassage_mg_main_gear_3", { visible = false, ang = 0 } }
    
    });
      
    ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation = { { 0,  0,  1, -1 },
                                                                     { 0,  1, -1,  1 },
                                                                     { 0,  0,  0,  0 },
                                                                     { 0,  0,  0,  0 } };
    
    
    ng_global.progress[ "std" ] [ "win_secretpassage" ].state = { { 0,  8,  1,  2 },
                                                                  { 9,  3,  4,  5 },
                                                                  { 10, 6,  7,  11 },
                                                                  { 12, 13, 14, 15 } };
    
    
  elseif mode == "hard" then
                                                                  
   ObjMultiSet({
    
     { "obj_secretpassage_mg_part_6_gear", { visible = true } },
     { "obj_secretpassage_mg_part_7_gear", { visible = true } },
     { "obj_secretpassage_mg_main_gear_2", { visible = true } },
     { "obj_secretpassage_mg_main_gear_3", { visible = true } }
    
    });
   
    ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation = { { 0,  0,  1,  -1 },
                                                                     { 0,  1,  -1,  1 },
                                                                     { 0,  -1,  1,  0 },
                                                                     { 0,  0,  0,  0 } };
    
    
    ng_global.progress[ "std" ] [ "win_secretpassage" ].state = { { 0,  8,  1,  2 },
                                                                  { 9,  3,  4,  5 },
                                                                  { 10, 6,  7,  11 },
                                                                  { 12, 13, 14, 15 } };
    
    
  end;
                                                                
 for i = 1,4 do
      
    for j = 1,4 do

      private.rotation[i][j] = ng_global.progress[ "std" ] [ "win_secretpassage" ].rotation[i][j];
      private.state[i][j] = ng_global.progress[ "std" ] [ "win_secretpassage" ].state[i][j];
      
      ObjSet( "obj_secretpassage_mg_part_"..private.state[i][j], { pos_x = private.coords[i][j][1],
                                                                   pos_y = private.coords[i][j][2] } );

    end;
    
  end;
                                                               
   private.StartAnim();
  
end;
--*********************************************************************************************************************
function private.StartMg()
  
  local func_after = function()
  
    local func_end = function()
    
      common_impl.Lock( false );
      
      cmn.SetEventDone( "clk_secretpassage" );
      cmn.CallEventHandler( "clk_secretpassage" );
      
      cmn.MiniGameShow();
      common_impl.PassingMgStart();
    
    end;
  
    AnimPlay( "anm_secretpassage_button_open", "DoAnim", func_end );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_secretpassage_open", 0, "", 0 );
  
  ObjSet( "anm_secretpassage_gears_1", { alp = 0, playing = false } );
  ObjSet( "anm_secretpassage_gears_2", { alp = 0, playing = false } );
  
  ObjSet( "anm_secretpassage_gears_1_open", { alp = 1, playing = true, endtrig = func_after } );
  ObjSet( "anm_secretpassage_gears_2_open", { alp = 1, playing = true } );
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_secretpassage_light", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );