-- name=level2

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd( 26 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.LoupeAdd( 8 );
  interface.PuzzleHelpAdd( 13 );
  interface.BtnApparatAdd( 25 );
  interface.BtnMiniHOAdd(8);
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();

  common.LevelLoad( "level2", "std", "mg_brickhos", param, private.menu_moduls );
  
  if IsCollectorsEdition() then
    
    common_impl.SetMorphEventDone();
    common_impl.SetCollectEventDone();

  end;
  
  private.TutorialSetParams();
  interface.KeyUpdate();
  
  common_impl.LoupeSave();
  common_impl.Collectibles2Load();
  common_impl.UpdateGameMode( ng_global.gamemode ); 
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "mg_brickhos"
  ,"rm_garage"
  ,"ho_cabinethos"
  ,"rm_wheelbarrow"
  ,"rm_atbar"
  ,"mg_doorhos"
  ,"rm_bar_2"
  ,"ho_specialequipment"
  ,"mg_secretpassage"
  ,"rm_base"
  ,"ho_avengersstuff"
  ,"rm_groundfloor"
  ,"ho_chesthos"
  ,"mg_superpuzzle_2"
  };

  game.progress_names_room =
  {
   { "beg_level2" }
  --,{ "get_collect_morph_item_1_1" }
  --,{ "get_collect_morph_item_1_2" }
  --,{ "get_collect_morph_item_1_3" }
  --,{ "get_collect_morph_item_1_4" }
  --,{ "get_collect_morph_item_1_5" }
  --,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_item_1_3" }
  ,{ "clk_niwtyaki" }
  ,{ "vid_brickhos_intro"  }
  ,{ "win_brickhos",          }
  ,{ "vid_brickhos_pulling"  }
  ,{ "opn_garage",                                 "rm_garage",                    { "vid_brickhos_pulling" } }
  ,{ "dlg_garage_saved",                           "rm_garage",                    { "opn_garage" } }
  ,{ "get_collect_morph_item_2_1" }
  ,{ "get_collect_item_2_1" }
  ,{ "clk_instruments",                            "rm_garage",                    { "opn_garage" } }
  ,{ "get_navigator",                              "rm_garage",                    { "dlg_garage_saved" } }
  ,{ "get_masterswitch",                           "rm_garage",                    { "dlg_garage_saved" } }
  ,{ "use_elf_2_1",                                "rm_garage",                    { "dlg_garage_saved" } }
  ,{ "get_repairamulet",                           "rm_garage",                    { "use_elf_2_1" } }
  ,{ "use_hairpin",                                "rm_garage",                    { "dlg_garage_saved" } }
  ,{ "use_repairamulet",                           "rm_garage",                    { "dlg_garage_saved", "use_hairpin"} }
  ,{ "get_hacksaw",                                "rm_garage",                    { "use_repairamulet" } }
  ,{ "get_corkscrew",                              "rm_garage",                    { "use_repairamulet" } }
  ,{ "get_fuse_2_1",                               "rm_garage",                    { "use_repairamulet" } }
  ,{ "use_hacksaw",                                "rm_garage",                    { "get_hacksaw" } }
  ,{ "opn_cabinethos",                             "rm_garage",                    { "use_hacksaw" } } 
  ,{ "win_cabinethos",                             "rm_garage",                    { "use_hacksaw" } } 
  ,{ "use_masterswitch",                           "rm_garage",                    { "get_masterswitch" } }
  ,{ "clk_masterswitch",                           "rm_garage",                    { "use_masterswitch" } }
  ,{ "use_carhandle",                              "rm_garage",                    { "win_orchestra" } }
  ,{ "clk_carhandle",                              "rm_garage",                    { "use_carhandle" } }
  ,{ "get_nightsymbolelement_1",                 "rm_garage",                    { "clk_carhandle" } }
  ,{ "get_fuse_2_2",                               "rm_garage",                    { "clk_carhandle" } }
  ,{ "use_fuse_2_1",                               "rm_garage",                    { "get_fuse_2_1" } }
  ,{ "use_fuse_2_2",                               "rm_garage",                    { "get_fuse_2_2" } }
  ,{ "win_disconnection",                          "rm_garage",                    { "use_fuse_2_1", "use_fuse_2_2" } }
  ,{ "dlg_garage_phoned",                          "rm_garage",                    { "win_disconnection" } } 
  ,{ "get_ignitionkey",                            "rm_garage",                    { "dlg_garage_phoned" } } 
  ,{ "use_ignitionkey",                            "rm_garage",                    { "get_ignitionkey" } }
  ,{ "clk_ignitionkey",                            "rm_garage",                    { "use_ignitionkey" } }
  ,{ "opn_wheelbarrow",                            "rm_wheelbarrow",               { "clk_ignitionkey" } }
  ,{ "clk_visor",                                  "rm_wheelbarrow",               { "opn_wheelbarrow" } }
  ,{ "get_button_2",                               "rm_wheelbarrow",               { "clk_visor" } }
  ,{ "use_button_2",                               "rm_wheelbarrow",               { "get_button_2" } }
  ,{ "clk_button_2",                               "rm_wheelbarrow",               { "use_button_2" } }
  ,{ "get_chisel",                                 "rm_wheelbarrow",               { "clk_button_2" } }
  ,{ "get_brokennightsymbol",                      "rm_wheelbarrow",               { "opn_wheelbarrow" } }
  ,{ "clk_handle",                                 "rm_wheelbarrow",               { "get_chisel" } }
  ,{ "use_chisel",                                 "rm_wheelbarrow",               { "clk_handle" } }
  ,{ "clk_chisel",                                 "rm_wheelbarrow",               { "clk_chisel" } }
  ,{ "opn_atbar",                                  "rm_atbar",                     { "use_chisel" } }
  ,{ "vid_atbar_passing",                          "rm_atbar",                     { "opn_atbar" } }
  ,{ "get_collect_morph_item_2_5" }
  ,{ "get_collect_item_2_2" }
  ,{ "get_nightsymbolelement_2",                 "rm_atbar",                     { "vid_atbar_passing" } }
  ,{ "get_nightsymbolelement_3",                 "rm_atbar",                     { "vid_atbar_passing" } }
  ,{ "use_nightsymbolelement_1",     }
  ,{ "use_nightsymbolelement_2",     }
  ,{ "use_nightsymbolelement_3",     }
  ,{ "get_nightsymbol",                }
  ,{ "use_nightsymbol",                            "rm_atbar",                     { "get_nightsymbol" } }
  ,{ "get_handle_2",                               "rm_atbar",                     { "use_nightsymbol" } }
  ,{ "get_englishbadge",                           "rm_atbar",                     { "use_nightsymbol" } }
  ,{ "use_handle_2",                               "rm_wheelbarrow",               { "get_handle_2" } }
  ,{ "clk_handle_2",                               "rm_wheelbarrow",               { "use_handle_2" } }
  ,{ "get_nailpuller",                             "rm_wheelbarrow",               { "clk_handle_2" } }
  ,{ "use_nailpuller",                             "rm_atbar",                     { "get_nailpuller" } }
  ,{ "get_clippers",                               "rm_atbar",                     { "use_nailpuller" } }
  ,{ "get_bag_2",                                "rm_atbar",                     { "use_nailpuller" } }
  ,{ "get_wire_2_1",                               "rm_atbar",                     { "use_nailpuller" } }
  ,{ "use_englishbadge",                           "rm_wheelbarrow",               { "get_englishbadge" } }
  ,{ "use_clippers",                               "rm_wheelbarrow",               { "get_clippers", "use_englishbadge" } }
  ,{ "get_wire_2_2",                               "rm_wheelbarrow",               { "use_clippers" } }
  ,{ "use_wire_2_1",                               "rm_atbar",                     { "get_wire_2_1" } }
  ,{ "use_wire_2_2",                               "rm_atbar",                     { "get_wire_2_2" } }
  ,{ "win_doorhos",                                "rm_atbar",                     { "use_wire_2_1", "use_wire_2_2" } }
  ,{ "clk_button",                                 "rm_atbar",                     { "win_doorhos" } }
  
  ,{ "opn_bar_2",                                  "rm_bar_2",                     { "clk_button" } }
  ,{ "get_collect_morph_item_2_2" }
  ,{ "clk_bar_2_point_1",                          "rm_bar_2",                     { "opn_bar_2" } }
  ,{ "clk_bar_2_point_2",                          "rm_bar_2",                     { "opn_bar_2" } }
  ,{ "use_device_2",                               "rm_bar_2",                     { "clk_bar_2_point_1", "clk_bar_2_point_2" } }
  ,{ "win_bar_2",                                  "rm_bar_2",                     { "use_device_2" } } 
  ,{ "vid_bar_2_loupe",                            "rm_bar_2",                     { "win_bar_2" } } 
  ,{ "clk_airplane",                               "rm_bar_2",                                     }
  ,{ "get_zipperslider",                           "rm_bar_2",                     { "opn_bar_2" } }
  ,{ "get_truckkey",                               "rm_bar_2",                     { "opn_bar_2" } }
  ,{ "use_elf_2_2",                                "rm_bar_2",                     { "opn_bar_2" } }
  ,{ "get_crestfragment",                          "rm_bar_2",                     { "use_elf_2_2" } }
  ,{ "use_crestfragment",                          "rm_bar_2",                     { "get_crestfragment" } }
  ,{ "get_mtmap",                                  "rm_bar_2",                     { "use_crestfragment" } }
  ,{ "get_musictracklist",                         "rm_bar_2",                     { "use_crestfragment" } }
  ,{ "use_truckkey",                               "rm_atbar",                     { "get_truckkey" } }
  ,{ "clk_truckkey",                               "rm_atbar",                     { "use_truckkey" } }
  ,{ "win_pair",                                   "rm_atbar",                     { "clk_truckkey" } }
  ,{ "use_mtmap",                                  "rm_atbar",                     { "win_pair" } }
  ,{ "opn_specialequipment",                       "rm_atbar",                     { "use_mtmap" } } 
  ,{ "win_specialequipment",                       "rm_atbar",                     { "use_mtmap" } }  
  ,{ "use_zipperslider",          }
  ,{ "clk_zipperslider",          }
  ,{ "get_digitalclock",          }
  ,{ "get_toolsymbol",          }
  ,{ "use_toolsymbol",                             "rm_wheelbarrow",               { "get_toolsymbol" } }  
  ,{ "get_screwdriver_2_1",                        "rm_wheelbarrow",               { "use_toolsymbol" } }
  ,{ "get_bottle_2_1",                             "rm_wheelbarrow",               { "use_toolsymbol" } }
  ,{ "use_screwdriver_2_1",                        "rm_atbar",                     { "get_screwdriver_2_1" } }
  ,{ "get_25pence",                                "rm_atbar",                     { "use_screwdriver_2_1" } }
  ,{ "use_digitalclock"          }
  ,{ "get_bomb",                  }
  ,{ "use_bomb",                                   "rm_bar_2",                     { "get_bomb" } }
  ,{ "vid_bar_2_bomb",                             "rm_bar_2",                     { "use_bomb" } }
  ,{ "get_dart",                                   "rm_bar_2",                     { "vid_bar_2_bomb" } }
  ,{ "use_musictracklist",                         "rm_bar_2",                     { "get_musictracklist" } }
  ,{ "use_25pence",                                "rm_bar_2",                     { "get_25pence" } }
  ,{ "clk_jukebox",                                "rm_bar_2",                     { "use_25pence" } }
  ,{ "get_mechanismpart",                          "rm_bar_2",                     { "clk_jukebox" } }
  ,{ "get_rifle",                                  "rm_bar_2",                     { "clk_jukebox" } }
  ,{ "use_dart",                                   "rm_bar_2",                     { "get_dart", "vid_bar_2_loupe" } }
  ,{ "use_mechanismpart",                          "rm_bar_2",                     { "get_mechanismpart", "use_dart" } }
  ,{ "clk_secretpassage",                          "rm_bar_2",                     { "use_dart", "use_mechanismpart" } }
  ,{ "win_secretpassage",                          "rm_bar_2",                     { "clk_secretpassage" } }
  ,{ "clk_bar_2_door",                             "rm_bar_2",                     { "win_secretpassage" } } 
  ,{ "opn_base",                                   "rm_base",                     { "clk_bar_2_door" } }
  ,{ "vid_base_leaving",                           "rm_base",                     { "opn_base" } }
  ,{ "get_collect_morph_item_2_3" }
  ,{ "get_collect_item_2_3" }
  ,{ "opn_avengersstuff",                          "rm_base",                     { "vid_base_leaving" } } 
  ,{ "win_avengersstuff",                          "rm_base",                     { "vid_base_leaving" } }  
  ,{ "use_skullsymbol",                            "rm_atbar",                    { "win_avengersstuff" } }  
  ,{ "get_bottle_2_2",                             "rm_atbar",                    { "use_skullsymbol" } }
  ,{ "use_bottle_2_1",                             "rm_bar_2",                    { "get_bottle_2_1" } }
  ,{ "use_bottle_2_2",                             "rm_bar_2",                    { "get_bottle_2_2" } }
  ,{ "win_bottle",                                 "rm_bar_2",                    { "use_bottle_2_1", "use_bottle_2_2" } } 
  ,{ "get_ruby",                                   "rm_bar_2",                    { "win_bottle" } }
  ,{ "use_ruby",                                   "rm_base",                     { "get_ruby" } }
  ,{ "get_emblem",                                 "rm_base",                     { "use_ruby" } }
  ,{ "use_emblem",                                 "rm_bar_2",                    { "get_emblem" } }
  ,{ "get_button_2_1",                             "rm_bar_2",                    { "use_emblem" } }
  ,{ "get_board",                                  "rm_bar_2",                    { "use_emblem" } }
  ,{ "get_badgeelement_2_1",                       "rm_bar_2",                    { "use_emblem" } }
  ,{ "use_button_2_1",                             "rm_base",                     { "get_button_2_1" } }
  ,{ "get_boardpart",                              "rm_base",                     { "use_button_2_1" } }
  ,{ "use_boardpart",              }
  ,{ "get_elevatorboard",          }
  ,{ "clk_brokencard",                             "rm_base",                     { "opn_base" } }
  ,{ "use_elevatorboard",                          "rm_base",                     { "get_elevatorboard", "clk_brokencard" } }
  ,{ "clk_elevator_button",                        "rm_base",                     { "use_elevatorboard", "clk_brokencard" } }

  ,{ "opn_groundfloor",                            "rm_groundfloor",              { "clk_elevator_button" } }
  ,{ "vid_groundfloor_late",                       "rm_groundfloor",              { "opn_groundfloor" } }  
  ,{ "get_collect_morph_item_2_4" }
  ,{ "use_clippers_1",                             "rm_groundfloor",              { "vid_groundfloor_late" } }
  ,{ "use_elf_2_3",                                "rm_groundfloor",              { "use_clippers_1" } }
  ,{ "get_bartendersbadge",                        "rm_groundfloor",              { "use_clippers_1", "use_elf_2_3" } }
  ,{ "get_button_2_2",                             "rm_groundfloor",              { "use_clippers_1", "use_elf_2_3" } }
  ,{ "use_button_2_2",                             "rm_base",                     { "get_button_2_2" } }
  ,{ "get_badgeelement_2_2",                       "rm_base",                     { "use_button_2_2" } }
  ,{ "use_badgeelement_2_1",        }
  ,{ "use_badgeelement_2_2",        }
  ,{ "get_bartenderbadge",          }
  ,{ "use_bartenderbadge",                         "rm_bar_2",                    { "get_bartenderbadge" } }
  ,{ "opn_chesthos",                               "rm_bar_2",                    { "use_bartenderbadge" } } 
  ,{ "win_chesthos",                               "rm_bar_2",                    { "use_bartenderbadge" } } 
  ,{ "use_button_2_3",                             "rm_base",                     { "win_chesthos" } } 
  ,{ "get_trihedron",                              "rm_base",                     { "use_button_2_3" } }
  ,{ "use_trihedron",                              "rm_groundfloor",              { "get_trihedron" } }
  ,{ "clk_trihedron",                              "rm_groundfloor",              { "use_trihedron" } }
  ,{ "win_superpuzzle_2",                          "rm_groundfloor",              { "clk_trihedron" } }
  ,{ "get_coldsource",                             "rm_groundfloor",              { "win_superpuzzle_2" } }
  ,{ "vid_groundfloor_coldsource",                 "rm_groundfloor",              { "win_superpuzzle_2" } }
  ,{ "use_coldsource",                             "rm_groundfloor",              { "get_coldsource" } }
  ,{ "clk_riffle" } --не обязателен для 2 лвла, может быть и в третьем
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits",
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;