-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()

  private.init_bag_2();
  private.init_bartendersbadge();
  private.init_bomb_plus();
  private.init_rifle();
  private.init_board();
  private.init_brokennightsymbol();
   
  public.deploy_inventory = {
  { "bag_2",      { "use_zipperslider" }, { "get_digitalclock", "get_toolsymbol" }            },
  { "bartendersbadge",      { "use_badgeelement_2_1", "use_badgeelement_2_2" }, { "get_bartenderbadge" }            },
  { "bomb_plus",      { "use_badgeelement_2_1", "use_badgeelement_2_2" }, { "get_bartenderbadge" }            },
  { "brokennightsymbol",      { "use_nightsymbolelement_1", "use_nightsymbolelement_2", "use_nightsymbolelement_3" }, { "get_nightsymbol" }            },
  };

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level2_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level2_inv_deploy" }, "level2_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level2_inv_deploy", update_game_mode_level2_inv_deploy, nil );

  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
function private.ShowBbt( use_name )
  
  if use_name == "badgeelement" then
    
    if ( cmn.IsEventDone( "use_badgeelement_2_1" ) and not cmn.IsEventDone( "use_badgeelement_2_2" ) ) or
      ( cmn.IsEventDone( "use_badgeelement_2_2" ) and not cmn.IsEventDone( "use_badgeelement_2_1" ) ) then
       
       common_impl.ShowBbt( "bbt_bartendersbadge_use_badgeelement_2", 1 );

     else
       
       common_impl.ShowBbt( 'bbt_bartendersbadge_use_badgeelement_1', 1 );
       
     end;
      
  end;
  
end;
--*********************************************************************************************************************
-- function *** bag_2 *** () end;
--*********************************************************************************************************************
  function private.init_bag_2()

    ObjSet( "spr_deploy_bag_2_digitalclock", { event_mdown = function() public.get_digitalclock() end } );
    ObjSet( "spr_deploy_bag_2_toolsymbol", { event_mdown = function() public.get_toolsymbol() end } );
    ObjSet("obj_bag_2_use_zipperslider", { event_mdown = private.clk_bag_2 });
    ObjSet("obj_bag_2_clk_zipperslider", { event_mdown = private.clk_zipperslider });
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_zipperslider" ] = {
        type = "use",
        inv_obj = "inv_zipperslider",
        use_place = "obj_bag_2_use_zipperslider",
        room = "int_deploy_inv",
        zz = "deploy_inv_bag_2",
        zz_gate = "inv_bag_2"
    };
    function use_zipperslider_inv ()

      interface.InventoryItemRemove( "inv_zipperslider" );
      

    end;
    function use_zipperslider_beg ()

      ObjDelete( "obj_bag_2_use_zipperslider" );

    end;
    function use_zipperslider_end ()

     ObjMultiSet({
       { "obj_bag_2_clk_zipperslider",     { input = true }},
       { "anm_deploy_bag_2_use_zipper", { alp = 1 }},
     });
 
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_zipperslider", use_zipperslider_beg, "inv_bag_2" );
    cmn.AddSubscriber( "use_zipperslider", use_zipperslider_inv );
    cmn.AddSubscriber( "use_zipperslider", use_zipperslider_end );
    cmn.AddSubscriber( "use_zipperslider", use_zipperslider_end, "inv_bag_2" );
    cmn.AddSubscriber( "use_zipperslider_inv", use_zipperslider_inv );
    cmn.AddSubscriber( "use_zipperslider_beg", use_zipperslider_beg, "inv_bag_2" );
    cmn.AddSubscriber( "use_zipperslider_end", use_zipperslider_end, "inv_bag_2" );
    --------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------- 
    common_impl.hint[ "clk_zipperslider" ] = {
        type = "click",
        use_place = "obj_bag_2_clk_zipperslider",
        room = "int_deploy_inv",
        zz = "deploy_inv_bag_2",
        zz_gate = "inv_bag_2"
    };   
    function clk_zipperslider_beg ()

      ObjDelete( "obj_bag_2_clk_zipperslider" )

    end;
    function clk_zipperslider_end ()

      ObjMultiSet({
       { "obj_deploy_bag_2_open",     { input = true, alp = 1 }},
       { "spr_bag_2_open", { alp = 1 }},
     });
     ObjDelete( "anm_deploy_bag_2_use_zipper" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_beg, "inv_bag_2" );
    cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_end );
    cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_end, "inv_bag_2" );
    cmn.AddSubscriber( "clk_zipperslider_beg", clk_zipperslider_beg, "inv_bag_2" );
    cmn.AddSubscriber( "clk_zipperslider_end", clk_zipperslider_end, "inv_bag_2" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_digitalclock" ] = {
      type = "get",
      get_obj = "spr_deploy_bag_2_digitalclock",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag_2",
      zz_gate = "inv_bag_2"
    };
    function get_digitalclock_inv ()
      
      if cmn.IsEventDone( "get_toolsymbol" ) then
      
        interface.InventoryItemRemove( "inv_bag_2" );
        
        
      end;
      
      interface.InventoryItemAdd( "inv_digitalclock", "spr_deploy_bag_2_digitalclock" );
      ObjSet("spr_bomb_plus_plus_light", { alp = 1 });

    end;
    function get_digitalclock_deploy ()

      ObjDelete( "gfx_deploy_bag_2_digitalclock" );
      ObjDelete( "spr_deploy_bag_2_digitalclock_shadow" );
      ObjDelete( "spr_bag_2_clock" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_digitalclock", get_digitalclock_inv );
    cmn.AddSubscriber( "get_digitalclock", get_digitalclock_deploy, "inv_bag_2" );
    -------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_toolsymbol" ] = {
      type = "get",
      get_obj = "spr_deploy_bag_2_toolsymbol",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag_2",
      zz_gate = "inv_bag_2"
    };
    function get_toolsymbol_inv ()
      
      if cmn.IsEventDone( "get_digitalclock" ) then
      
        interface.InventoryItemRemove( "inv_bag_2" );
        
      end;
      
      interface.InventoryItemAdd( "inv_toolsymbol", "spr_deploy_bag_2_toolsymbol" );

    end;
    function get_toolsymbol_deploy ()

      ObjDelete( "gfx_deploy_bag_2_toolsymbol" );
      ObjDelete( "spr_deploy_bag_2_toolsymbol_shadow" );
      ObjDelete( "spr_bag_2_item" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_toolsymbol", get_toolsymbol_inv );
    cmn.AddSubscriber( "get_toolsymbol", get_toolsymbol_deploy, "inv_bag_2" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function public.use_zipperslider()

    local item = "inv_zipperslider";
    if private.ObjIntersectCheck( item, "obj_bag_2_use_zipperslider", "deploy_inv_bag_2" ) then

      cmn.CallEventHandler( "use_zipperslider_beg", "inv_bag_2" );
      cmn.CallEventHandler( "use_zipperslider_inv" );

      local func_after = function ()
             
        common_impl.Lock( false );

        cmn.SetEventDone( "use_zipperslider" );
        cmn.CallEventHandler( "use_zipperslider_end", "inv_bag_2" );  
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_backpack_use_zipper", 0, "", 0 );

      ObjAnimate( "anm_deploy_bag_2_use_zipper", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });
           
      return true;

    end;

  end;
  --*********************************************************************************************************************
  function private.clk_zipperslider()

    cmn.CallEventHandler( "clk_zipperslider_beg", "inv_bag_2" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_zipperslider" );
      cmn.CallEventHandler( "clk_zipperslider_end", "inv_bag_2" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_backpack_zipper", 0, "", 0 );
     
    AnimPlay( "anm_deploy_bag_2_use_zipper", "DoAnim", func_after )

  end;
  --*********************************************************************************************************************
  function public.get_digitalclock()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_digitalclock" );
    cmn.CallEventHandler( "get_digitalclock", "inv_bag_2" );

    if cmn.IsEventDone( "get_toolsymbol" ) then
    
      common_impl.HideDeployInv();
      
    end;

  end;
  function public.get_toolsymbol()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_toolsymbol" );
    cmn.CallEventHandler( "get_toolsymbol", "inv_bag_2" );

    if cmn.IsEventDone( "get_digitalclock" ) then
    
      common_impl.HideDeployInv();
      
    end;

  end;
  --*******************************************************************************************************************
  function private.clk_bag_2()

  common_impl.ShowBbt( 'bbt_bag_2_use_zipperslider' );

  end;
--*********************************************************************************************************************
-- function *** bartendersbadge *** () end;
--*********************************************************************************************************************
  function private.init_bartendersbadge()

    ObjSet( "spr_deploy_bartendersbadge", { event_mdown = function() public.get_bartenderbadge() end } );
    ObjSet( "obj_bartendersbadge_use_tokenfragment", { event_mdown = function() private.ShowBbt( 'badgeelement' ) end } );

    common_impl.hint[ "use_badgeelement_2_1" ] = {
        type = "use",
        inv_obj = "inv_badgeelement_2_1",
        use_place = "obj_bartendersbadge_use_tokenfragment",
        room = "int_deploy_inv",
        zz = "deploy_inv_bartendersbadge",
        zz_gate = "inv_bartendersbadge"
    };
    function use_badgeelement_2_1_inv ()

      interface.InventoryItemRemove( "inv_badgeelement_2_1" );
      if ( not cmn.IsEventDone("get_badgeelement_2_2") ) then

        ObjSet( "spr_bartendersbadge_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_bartendersbadge_plus_light", { alp = 1 });

      end;   

    end;
    function use_badgeelement_2_1_beg ()

      if ( cmn.IsEventDone("use_badgeelement_2_2")) then
        ObjDelete( "obj_bartendersbadge_use_tokenfragment" );      
      end;

    end;
    function use_badgeelement_2_1_end ()
      
      ObjSet( "spr_deploy_bartendersbadge_part_1", { alp = 1 });
      ObjSet( "spr_bartendersbadge_element_1", { alp = 1 });
      
      if ( cmn.IsEventDone("use_badgeelement_2_2") ) then

        ObjMultiSet({
          { "spr_deploy_bartendersbadge",     { input = true }},
          { "gfx_deploy_bartendersbadge",     { active = true }}
        });

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_badgeelement_2_1", use_badgeelement_2_1_beg, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_1", use_badgeelement_2_1_inv );
    cmn.AddSubscriber( "use_badgeelement_2_1", use_badgeelement_2_1_end );
    cmn.AddSubscriber( "use_badgeelement_2_1", use_badgeelement_2_1_end, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_1_inv", use_badgeelement_2_1_inv );
    cmn.AddSubscriber( "use_badgeelement_2_1_beg", use_badgeelement_2_1_beg, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_1_end", use_badgeelement_2_1_end, "inv_bartendersbadge" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_badgeelement_2_2" ] = {
        type = "use",
        inv_obj = "inv_badgeelement_2_2",
        use_place = "obj_bartendersbadge_use_tokenfragment",
        room = "int_deploy_inv",
        zz = "deploy_inv_bartendersbadge",
        zz_gate = "inv_bartendersbadge"
    };
    function use_badgeelement_2_2_inv ()

      interface.InventoryItemRemove( "inv_badgeelement_2_2" );
      if ( not cmn.IsEventDone("get_badgeelement_2_1") ) then

        ObjSet( "spr_bartendersbadge_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_bartendersbadge_plus_light", { alp = 1 });

      end;   

    end;
    function use_badgeelement_2_2_beg ()

      if ( cmn.IsEventDone("use_badgeelement_2_1")) then
        ObjDelete( "obj_bartendersbadge_use_tokenfragment" );      
      end;
      
    end;
    function use_badgeelement_2_2_end ()
      
      ObjSet( "spr_bartendersbadge_element_2", { alp = 1 });
      
      if ( cmn.IsEventDone("use_badgeelement_2_1") ) then

        ObjMultiSet({
          { "spr_deploy_bartendersbadge",     { input = true }},
          { "gfx_deploy_bartendersbadge",     { active = true }}
        });

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_badgeelement_2_2", use_badgeelement_2_2_beg, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_2", use_badgeelement_2_2_inv );
    cmn.AddSubscriber( "use_badgeelement_2_2", use_badgeelement_2_2_end );
    cmn.AddSubscriber( "use_badgeelement_2_2", use_badgeelement_2_2_end, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_2_inv", use_badgeelement_2_2_inv );
    cmn.AddSubscriber( "use_badgeelement_2_2_beg", use_badgeelement_2_2_beg, "inv_bartendersbadge" );
    cmn.AddSubscriber( "use_badgeelement_2_2_end", use_badgeelement_2_2_end, "inv_bartendersbadge" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bartenderbadge" ] = {
      type = "get",
      get_obj = "spr_deploy_bartendersbadge",
      room = "int_deploy_inv",
      zz = "deploy_inv_bartendersbadge",
      zz_gate = "inv_bartendersbadge"
    };
    function get_bartenderbadge_inv ()

      interface.InventoryItemRemove( "inv_bartendersbadge" );
      interface.InventoryItemAdd( "inv_bartenderbadge", "spr_deploy_bartendersbadge" );

    end;
    function get_bartenderbadge_deploy ()

      ObjDelete( "gfx_deploy_bartendersbadge" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_bartenderbadge", get_bartenderbadge_inv );
    cmn.AddSubscriber( "get_bartenderbadge", get_bartenderbadge_deploy, "inv_bartendersbadge" );
    -------------------------------------------------------------------------------------------
  end;
--*********************************************************************************************************************
  function public.use_badgeelement_2_1()

    local item = "inv_badgeelement_2_1";
    if private.ObjIntersectCheck( item, "obj_bartendersbadge_use_tokenfragment", "deploy_inv_bartendersbadge" ) then

      cmn.CallEventHandler( "use_badgeelement_2_1_beg", "inv_bartendersbadge" );
      cmn.CallEventHandler( "use_badgeelement_2_1_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_badgeelement_2_1" );
        cmn.CallEventHandler( "use_badgeelement_2_1_end", "inv_bartendersbadge" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tokenfragment_mt", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_bartendersbadge_part_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      return true;

    end;

  end;
--*********************************************************************************************************************
  function public.use_badgeelement_2_2()

    local item = "inv_badgeelement_2_2";
    if private.ObjIntersectCheck( item, "obj_bartendersbadge_use_tokenfragment", "deploy_inv_bartendersbadge" ) then

      cmn.CallEventHandler( "use_badgeelement_2_2_beg", "inv_bartendersbadge" );
      cmn.CallEventHandler( "use_badgeelement_2_2_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_badgeelement_2_2" );
        cmn.CallEventHandler( "use_badgeelement_2_2_end", "inv_bartendersbadge" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level1/aud_use_tokenfragment_mt", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_bartendersbadge_part_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      return true;

    end;

  end;
  function public.get_bartenderbadge()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bartenderbadge" );
    cmn.CallEventHandler( "get_bartenderbadge", "inv_bartendersbadge" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** bomb_plus *** () end;
--*********************************************************************************************************************
  function private.init_bomb_plus()

    ObjSet( "spr_deploy_bomb_plus", { event_mdown = function() public.get_bomb() end } );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_digitalclock" ] = {
        type = "use",
        inv_obj = "inv_digitalclock",
        use_place = "obj_bomb_plus_use_digitalclock",
        room = "int_deploy_inv",
        zz = "deploy_inv_bomb_plus",
        zz_gate = "inv_bomb_plus"
    };
    function use_digitalclock_inv ()

      interface.InventoryItemRemove( "inv_digitalclock" );

    end;
    function use_digitalclock_beg ()

      ObjDelete( "obj_bomb_plus_use_digitalclock" );

    end;
    function use_digitalclock_end ()
      
      ObjSet("spr_deploy_bomb_plus_bomb_part",     { alp = 1 });
      ObjSet( "spr_bomb_plus_battery", { alp = 1 });
      ObjSet( "inv_bomb_plus", { res = "assets/levels/level2/inv_deploy/inv_bomb/inv/inv_bomb"});
      ObjMultiSet({
        { "spr_deploy_bomb_plus",     { input = true }},
        { "gfx_deploy_bomb_plus",     { active = true }},
      });
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_digitalclock", use_digitalclock_beg, "inv_bomb_plus" );
    cmn.AddSubscriber( "use_digitalclock", use_digitalclock_inv );
    cmn.AddSubscriber( "use_digitalclock", use_digitalclock_end );
    cmn.AddSubscriber( "use_digitalclock", use_digitalclock_end, "inv_bomb_plus" );
    cmn.AddSubscriber( "use_digitalclock_inv", use_digitalclock_inv );
    cmn.AddSubscriber( "use_digitalclock_beg", use_digitalclock_beg, "inv_bomb_plus" );
    cmn.AddSubscriber( "use_digitalclock_end", use_digitalclock_end, "inv_bomb_plus" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bomb" ] = {
      type = "get",
      get_obj = "spr_deploy_bomb_plus",
      room = "int_deploy_inv",
      zz = "deploy_inv_bomb_plus",
      zz_gate = "inv_bomb_plus"
    };
    function get_bomb_inv ()

      interface.InventoryItemRemove( "inv_bomb_plus" );
      interface.InventoryItemAdd( "inv_bomb", "spr_deploy_bomb_plus" );

    end;
    function get_bomb_deploy ()

      ObjDelete( "gfx_deploy_bomb" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_bomb", get_bomb_inv );
    cmn.AddSubscriber( "get_bomb", get_bomb_deploy, "inv_bomb_plus" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function public.use_digitalclock()

    local item = "inv_digitalclock";
    if private.ObjIntersectCheck( item, "obj_bomb_plus_use_digitalclock", "deploy_inv_bomb_plus" ) then

      cmn.CallEventHandler( "use_digitalclock_beg", "inv_bomb_plus" );
      cmn.CallEventHandler( "use_digitalclock_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_digitalclock" );
        cmn.CallEventHandler( "use_digitalclock_end", "inv_bomb_plus" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_explosive_clock", 0, "", 0 );

      ObjAnimate( "spr_deploy_bomb_plus_bomb_part", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  ObjAnimate( "spr_deploy_bomb_plus_time", "alp", 1 ,0, "", { 0,0,1, 0.6,0,0.5, 1.2,0,1 } );

  
  --*********************************************************************************************************************
  function public.get_bomb()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bomb" );
    cmn.CallEventHandler( "get_bomb", "inv_bomb_plus" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** rifle *** () end;
--*********************************************************************************************************************
  function private.init_rifle()

    ObjSet( "spr_deploy_shotgun", { event_mdown = function() public.get_shotgun() end } );
    ObjSet( "obj_rifle_clk_rifle", { event_mdown = function() private.clk_rifle_1() end } );
    
    --------------------------------------------------------------------------------------------    
--    function clk_rifle_1_beg ()
--
--      ObjDelete( "obj_rifle_clk_rifle" )
--
--    end;
--    function clk_rifle_1_end ()
--
--      ObjMultiSet({
--        { "obj_rifle_use_bullet",     { input = true }},
--        { "spr_deploy_rifle_close",     { alp = 0 }},
--        { "spr_deploy_rifle_open",     { alp = 1 }},
--        --{ "inv_rifle", { res = "assets/levels/level2/inv_deploy/inv_rifle/inv/inv_rifle_1"}}
--      });
--
--    end;
--    --------------------------------------------------------------------------------------------
--    cmn.AddSubscriber( "clk_rifle_1", clk_rifle_1_beg, "inv_rifle" );
--    cmn.AddSubscriber( "clk_rifle_1", clk_rifle_1_end );
--    cmn.AddSubscriber( "clk_rifle_1", clk_rifle_1_end, "inv_rifle" );
--    cmn.AddSubscriber( "clk_rifle_1_beg", clk_rifle_1_beg, "inv_rifle" );
--    cmn.AddSubscriber( "clk_rifle_1_end", clk_rifle_1_end, "inv_rifle" );
    --------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_rifle_1()

    --cmn.CallEventHandler( "clk_rifle_1_beg", "inv_rifle" );

    local func_after = function ()

      common_impl.Lock( false );

--      cmn.SetEventDone( "clk_rifle_1" );
--      cmn.CallEventHandler( "clk_rifle_1_end", "inv_rifle" );
--
    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_rifle_touch", 0, "", 0 );
    
    common_impl.ShowBbt( 'bbt_bomb_rifle_use_bullet' );
    
    ObjAnimate( "spr_deploy_rifle_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );
    
    ObjAnimate( "spr_deploy_rifle_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** board *** () end;
--*********************************************************************************************************************
  function private.init_board()

    ObjSet( "spr_deploy_elevatorboard", { event_mdown = function() public.get_elevatorboard() end } );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_boardpart" ] = {
        type = "use",
        inv_obj = "inv_boardpart",
        use_place = "obj_board_use_boardpart",
        room = "int_deploy_inv",
        zz = "deploy_inv_board",
        zz_gate = "inv_board"
    };
    function use_boardpart_inv ()

      interface.InventoryItemRemove( "inv_boardpart" );

    end;
    function use_boardpart_beg ()

      ObjDelete( "obj_board_use_boardpart" );

    end;
    function use_boardpart_end ()

      ObjMultiSet({
      { "spr_deploy_elevatorboard",     { input = true }},
      { "spr_deploy_board_part",     { alp = 1 }},
      { "gfx_deploy_elevatorboard",     { active = true }},
      { "inv_board", { res ="assets/levels/level2/inv_deploy/inv_board/inv/inv_elevatorboard"}},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_boardpart", use_boardpart_beg, "inv_board" );
    cmn.AddSubscriber( "use_boardpart", use_boardpart_inv );
    cmn.AddSubscriber( "use_boardpart", use_boardpart_end );
    cmn.AddSubscriber( "use_boardpart", use_boardpart_end, "inv_board" );
    cmn.AddSubscriber( "use_boardpart_inv", use_boardpart_inv );
    cmn.AddSubscriber( "use_boardpart_beg", use_boardpart_beg, "inv_board" );
    cmn.AddSubscriber( "use_boardpart_end", use_boardpart_end, "inv_board" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_elevatorboard" ] = {
      type = "get",
      get_obj = "spr_deploy_elevatorboard",
      room = "int_deploy_inv",
      zz = "deploy_inv_board",
      zz_gate = "inv_board"
    };
    function get_elevatorboard_inv ()

      interface.InventoryItemRemove( "inv_board" );
      interface.InventoryItemAdd( "inv_elevatorboard", "spr_deploy_elevatorboard" );

    end;
    function get_elevatorboard_deploy ()

      ObjDelete( "spr_deploy_board_part" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_elevatorboard", get_elevatorboard_inv );
    cmn.AddSubscriber( "get_elevatorboard", get_elevatorboard_deploy, "inv_board" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function public.use_boardpart()

    local item = "inv_boardpart";
    if private.ObjIntersectCheck( item, "obj_board_use_boardpart", "deploy_inv_board" ) then

      cmn.CallEventHandler( "use_boardpart_beg", "inv_board" );
      cmn.CallEventHandler( "use_boardpart_inv" );

      local func_after = function ()

        common_impl.Lock( false );
          
        cmn.SetEventDone( "use_boardpart" );
        cmn.CallEventHandler( "use_boardpart_end", "inv_board" );
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_plate_insert", 0, "", 0 );
 
      ObjAnimate( "spr_deploy_board_part", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );   

      return true;

    end;

  end;
  function public.get_elevatorboard()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_elevatorboard" );
    cmn.CallEventHandler( "get_elevatorboard", "inv_board" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** brokennightsymbol *** () end;
--*********************************************************************************************************************
  function private.init_brokennightsymbol()

    ObjSet( "spr_deploy_nightsymbol", { event_mdown = function() public.get_nightsymbol() end } );
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_nightsymbolelement_1" ] = {
        type = "use",
        inv_obj = "inv_nightsymbolelement_1",
        use_place = "obj_nightsymbol_use_nightsymbolelement_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokennightsymbol",
        zz_gate = "inv_brokennightsymbol"
    };
    function use_nightsymbolelement_1_inv ()

      interface.InventoryItemRemove( "inv_nightsymbolelement_1" );
      if ( not cmn.IsEventDone("get_nightsymbolelement_2") ) or ( not cmn.IsEventDone("get_nightsymbolelement_3") ) then

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });

      end;   
 
    end;
    function use_nightsymbolelement_1_beg ()

      ObjDelete( "obj_nightsymbol_use_nightsymbolelement_1" );

    end;
    function use_nightsymbolelement_1_end ()
      
      ObjSet("spr_deploy_nightsymbol_symbol_1",     { alp = 1 });
      ObjSet( "spr_brokennightsymbol_element_1", { alp = 1 });
      
      if ( cmn.IsEventDone("use_nightsymbolelement_2") and cmn.IsEventDone("use_nightsymbolelement_3" ) ) then
        
        ObjMultiSet({
          { "spr_deploy_nightsymbol",     { input = true }},
          { "gfx_deploy_nightsymbol",     { active = true }},
         
        });
        
      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_nightsymbolelement_1", use_nightsymbolelement_1_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_1", use_nightsymbolelement_1_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_1", use_nightsymbolelement_1_end );
    cmn.AddSubscriber( "use_nightsymbolelement_1", use_nightsymbolelement_1_end, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_1_inv", use_nightsymbolelement_1_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_1_beg", use_nightsymbolelement_1_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_1_end", use_nightsymbolelement_1_end, "inv_brokennightsymbol" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------    
    common_impl.hint[ "use_nightsymbolelement_2" ] = {
        type = "use",
        inv_obj = "inv_nightsymbolelement_2",
        use_place = "obj_nightsymbol_use_nightsymbolelement_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokennightsymbol",
        zz_gate = "inv_brokennightsymbol"
    };
    function use_nightsymbolelement_2_inv ()

      interface.InventoryItemRemove( "inv_nightsymbolelement_2" );
      if ( not cmn.IsEventDone("get_nightsymbolelement_1") ) or ( not cmn.IsEventDone("get_nightsymbolelement_3") ) then

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });

      end; 

    end;
    function use_nightsymbolelement_2_beg ()

      ObjDelete( "obj_nightsymbol_use_nightsymbolelement_2" );

    end;
    function use_nightsymbolelement_2_end ()

      ObjDelete( "spr_deploy_nightsymbol_glass_1" );
      ObjMultiSet({
      { "spr_deploy_nightsymbol_symbol_2", { alp = 1 } },
      { "spr_brokennightsymbol_element_2", { alp = 1 } },
      });
      
      if ( cmn.IsEventDone("use_nightsymbolelement_1") and cmn.IsEventDone("use_nightsymbolelement_3") ) then
        
        ObjMultiSet({
          { "spr_deploy_nightsymbol",     { input = true }},
          { "gfx_deploy_nightsymbol",     { active = true }}
        
        });
          
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_nightsymbolelement_2", use_nightsymbolelement_2_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_2", use_nightsymbolelement_2_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_2", use_nightsymbolelement_2_end );
    cmn.AddSubscriber( "use_nightsymbolelement_2", use_nightsymbolelement_2_end, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_2_inv", use_nightsymbolelement_2_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_2_beg", use_nightsymbolelement_2_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_2_end", use_nightsymbolelement_2_end, "inv_brokennightsymbol" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_nightsymbolelement_3" ] = {
        type = "use",
        inv_obj = "inv_nightsymbolelement_3",
        use_place = "obj_nightsymbol_use_nightsymbolelement_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokennightsymbol",
        zz_gate = "inv_brokennightsymbol"
    };
    function use_nightsymbolelement_3_inv ()

      interface.InventoryItemRemove( "inv_nightsymbolelement_3" );
      if ( not cmn.IsEventDone("get_nightsymbolelement_2") ) or ( not cmn.IsEventDone("get_nightsymbolelement_1") ) then

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 0 });

      else 

        ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });

      end; 
 
    end;
    function use_nightsymbolelement_3_beg ()

      ObjDelete( "obj_nightsymbol_use_nightsymbolelement_3" );

    end;
    function use_nightsymbolelement_3_end ()
      
      ObjSet("spr_deploy_nightsymbol_symbol_3",     { alp = 1 });
      ObjSet( "spr_brokennightsymbol_element_3", { alp = 1 });
      
      if ( cmn.IsEventDone("use_nightsymbolelement_1") and cmn.IsEventDone( "use_nightsymbolelement_2" ) ) then
        
        ObjMultiSet({
          { "spr_deploy_nightsymbol",     { input = true }},
          { "gfx_deploy_nightsymbol",     { active = true }},
         
        });
        
      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_nightsymbolelement_3", use_nightsymbolelement_3_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_3", use_nightsymbolelement_3_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_3", use_nightsymbolelement_3_end );
    cmn.AddSubscriber( "use_nightsymbolelement_3", use_nightsymbolelement_3_end, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_3_inv", use_nightsymbolelement_3_inv );
    cmn.AddSubscriber( "use_nightsymbolelement_3_beg", use_nightsymbolelement_3_beg, "inv_brokennightsymbol" );
    cmn.AddSubscriber( "use_nightsymbolelement_3_end", use_nightsymbolelement_3_end, "inv_brokennightsymbol" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_nightsymbol" ] = {
      type = "get",
      get_obj = "spr_deploy_nightsymbol",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokennightsymbol",
      zz_gate = "inv_brokennightsymbol"
    };
    function get_nightsymbol_inv ()

      interface.InventoryItemRemove( "inv_brokennightsymbol" );
      interface.InventoryItemAdd( "inv_nightsymbol", "spr_deploy_nightsymbol" );

    end;
    function get_nightsymbol_deploy ()

      ObjDelete( "gfx_deploy_nightsymbol" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_nightsymbol", get_nightsymbol_inv );
    cmn.AddSubscriber( "get_nightsymbol", get_nightsymbol_deploy, "inv_brokennightsymbol" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function public.use_nightsymbolelement_1()

    local item = "inv_nightsymbolelement_1";
    if private.ObjIntersectCheck( item, "obj_nightsymbol_use_nightsymbolelement_1", "deploy_inv_brokennightsymbol" ) then

      cmn.CallEventHandler( "use_nightsymbolelement_1_beg", "inv_brokennightsymbol" );
      cmn.CallEventHandler( "use_nightsymbolelement_1_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_nightsymbolelement_1" );
        cmn.CallEventHandler( "use_nightsymbolelement_1_end", "inv_brokennightsymbol" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_nightsymbol_insert", 0, "", 0 );

      ObjAnimate( "spr_deploy_nightsymbol_symbol_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.use_nightsymbolelement_2()

    local item = "inv_nightsymbolelement_2";
    if private.ObjIntersectCheck( item, "obj_nightsymbol_use_nightsymbolelement_2", "deploy_inv_brokennightsymbol" )  then

      cmn.CallEventHandler( "use_nightsymbolelement_2_beg", "inv_brokennightsymbol" );
      cmn.CallEventHandler( "use_nightsymbolelement_2_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_nightsymbolelement_2" );
        cmn.CallEventHandler( "use_nightsymbolelement_2_end", "inv_brokennightsymbol" );
            
      end;
        
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_nightsymbol_insert", 0, "", 0 );
       
      ObjAnimate( "spr_deploy_nightsymbol_symbol_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0,
        0.3, 0, 1
      });

      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.use_nightsymbolelement_3()

    local item = "inv_nightsymbolelement_3";
    if private.ObjIntersectCheck( item, "obj_nightsymbol_use_nightsymbolelement_3", "deploy_inv_brokennightsymbol" ) then

      cmn.CallEventHandler( "use_nightsymbolelement_3_beg", "inv_brokennightsymbol" );
      cmn.CallEventHandler( "use_nightsymbolelement_3_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_nightsymbolelement_3" );
        cmn.CallEventHandler( "use_nightsymbolelement_3_end", "inv_brokennightsymbol" );
            
      end;
        
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_nightsymbol_insert", 0, "", 0 );
       
      ObjAnimate( "spr_deploy_nightsymbol_symbol_3", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0,
        0.3, 0, 1
      });

      return true;

    end;

  end;
  --*********************************************************************************************************************
  function public.get_nightsymbol()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_nightsymbol" );
    cmn.CallEventHandler( "get_nightsymbol", "inv_brokennightsymbol" );
    common_impl.HideDeployInv();

  end;