-- name=rm_atbar
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_atbar";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_truck", "room_hub" );
  ObjAttach( "zz_telephonebooth", "room_hub" );
  ObjAttach( "zz_motocycle", "room_hub" );
  ObjAttach( "zz_bardoor", "room_hub" );
  private.Init_Subroom();
  
  local  table_multiset = {};
  
  for i = 1, 12  do
    
    table.insert( table_multiset, { "spr_truck_mmg_item_"..i, { event_mdown =  function() private.clk_item( i ) end,
                                                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end }  } );
  end;
                                                              
  ObjMultiSet( table_multiset );
  
  ObjMultiSet({ 
  { "spr_truck_nightsymbolelement_2", { event_mdown = private.get_nightsymbolelement_2 }},
  { "spr_telephonebooth_nightsymbolelement_3", { event_mdown = private.get_nightsymbolelement_3 }},
  { "spr_telephonebooth_clippers", { event_mdown = private.get_clippers }},
  { "spr_telephonebooth_bag_2", { event_mdown = private.get_bag_2 }},
  { "spr_telephonebooth_wire_2_1", { event_mdown = private.get_wire_2_1 }},
  { "spr_telephonebooth_25pence", { event_mdown = private.get_25pence }},
  { "spr_motocycle_handle_2", { event_mdown = private.get_handle_2 }},
  { "spr_motocycle_englishbadge", { event_mdown = private.get_englishbadge }},
  { "spr_motocycle_bottle_2_2", { event_mdown = private.get_bottle_2_2 }},
  { "obj_truck_use_truckkey", { event_mdown = private.clk_door }},
  { "obj_truck_clk_key", { event_mdown = private.clk_truckkey }},
  { "obj_bardoor_use_wire_2_1", { event_mdown = private.clk_bardoor_handle }},
  { "obj_bardoor_use_wire_2_2", { event_mdown = private.clk_bardoor_handle }},
  { "obj_motocycle_use_nightsymbol", { event_mdown = private.clk_motocycle_close }},
  { "obj_motocycle_use_skullsymbol", { event_mdown = private.clk_motocycle_bag }},
  { "obj_telephonebooth_use_nailpuller", { event_mdown = private.clk_telephonebooth_nailpuller }},
  { "obj_truck_use_mtmap", { event_mdown = private.clk_back_door }},
  { "spr_telephonebooth_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_telephonebooth_note" );common_impl.ShowBbt( 'bbt_telephonebooth_note', 1 ); end }},    
  { "spr_telephonebooth_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_telephonebooth_note" ); end } },
  { "spr_motocycle_note", { event_mdown = function () common_impl.NoteScale( "open", "spr_motocycle_note" ) end }},    
  { "spr_motocycle_note_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_motocycle_note" ); common_impl.ShowBbt( 'bbt_motocycle_note', 1 ); end } },
  { "spr_atbar_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_motorcycle_collect_2", { event_mdown = function () private.get_collect_2_2_5(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_telephonebooth_collect_2", { event_mdown = function () private.get_collect_2_2_6(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                                
                                  { "spr_atbar_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  
  private.pair = {};
  private.pair.flag = false;
  private.pair.first = 0;
  private.pair.second = 0; 
  private.pair.comb = { 1, 2, 3, 1, 4, 5, 6, 3, 2, 4, 5, 6 };

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_atbar = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_atbar_specialequipment",
    "gmg_atbar_doorhos",
    "gzz_atbar_truck",
    "gzz_atbar_telephonebooth",
    "gzz_atbar_motocycle",
    "gzz_atbar_bardoor"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_truck",
    "zz_telephonebooth",
    "zz_motocycle",
    "zz_bardoor"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_atbar", update_game_mode_atbar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_atbar = function ()

  local effects_table = 
  {
    "obj_atbar_anim",
    "anm_atbar_smoke",
    "anm_atbar_door_static",
    "spr_truck_light",
    "spr_motocycle_light"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_atbar", update_performance_mode_atbar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_atbar () end;
  --------------------------------------------------------------------------------------------
  local opn_atbar_map = function ()

    common_impl.VisitMapRoom( "atbar" );

  end;
  cmn.AddSubscriber( "opn_atbar", opn_atbar_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_nightsymbolelement_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nightsymbolelement_2" ] = {
    type = "get",
    get_obj = "spr_truck_nightsymbolelement_2",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_atbar_truck"
  };
    
  local get_nightsymbolelement_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_nightsymbolelement_2", "spr_truck_nightsymbolelement_2" );
    ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });
  end;
  
  local get_nightsymbolelement_2_closezz = function ()
  
    ObjDelete( "gfx_truck_nightsymbolelement_2" );
    ObjDelete( "spr_truck_nightsymbolelement_2_add" );
    ObjDelete( "spr_truck_nightsymbolelement_2_shadow" );
    ObjDelete( "spr_truck_nightsymbolelement_2_over" );
    ObjSet( "obj_truck_use_truckkey", { input = true } );
    
  end;
  
  cmn.AddSubscriber( "get_nightsymbolelement_2", get_nightsymbolelement_2_inv );
  cmn.AddSubscriber( "get_nightsymbolelement_2", get_nightsymbolelement_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nightsymbolelement_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nightsymbolelement_3" ] = {
    type = "get",
    get_obj = "spr_telephonebooth_nightsymbolelement_3",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
    
  local get_nightsymbolelement_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_nightsymbolelement_3", "spr_telephonebooth_nightsymbolelement_3" );
    ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });
  end;
  
  local get_nightsymbolelement_3_closezz = function ()
  
    ObjDelete( "gfx_telephonebooth_nightsymbolelement_3" );
    ObjDelete( "spr_telephonebooth_nightsymbolelement_3_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_nightsymbolelement_3", get_nightsymbolelement_3_inv );
  cmn.AddSubscriber( "get_nightsymbolelement_3", get_nightsymbolelement_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clippers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clippers" ] = {
    type = "get",
    get_obj = "spr_telephonebooth_clippers",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
    
  local get_clippers_inv = function ()
  
    interface.InventoryItemAdd( "inv_clippers", "spr_telephonebooth_clippers" );
  
  end;
  
  local get_clippers_closezz = function ()
  
    ObjDelete( "gfx_telephonebooth_clippers" );
    ObjDelete( "spr_telephonebooth_clippers_shadow" );
    ObjDelete( "spr_atbar_telephonebooth_nippers" );
  
  end;
  
  cmn.AddSubscriber( "get_clippers", get_clippers_inv );
  cmn.AddSubscriber( "get_clippers", get_clippers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bag_2" ] = {
    type = "get",
    get_obj = "spr_telephonebooth_bag_2",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
    
  local get_bag_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bag_2", "spr_telephonebooth_bag_2" );
    ObjSet( "inv_bag_2", { drag = false } );
    
  end;
  
  local get_bag_2_closezz = function ()
  
    ObjDelete( "gfx_telephonebooth_bag_2" );
    ObjDelete( "spr_telephonebooth_bag_2_shadow" );
    ObjDelete( "spr_telephonebooth_bag_2_over" );
    ObjDelete( "spr_atbar_telephonebooth_backpack" );
    
  end;
  
  cmn.AddSubscriber( "get_bag_2", get_bag_2_inv );
  cmn.AddSubscriber( "get_bag_2", get_bag_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire_2_1" ] = {
    type = "get",
    get_obj = "spr_telephonebooth_wire_2_1",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
    
  local get_wire_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_wire_2_1", "spr_telephonebooth_wire_2_1" );
  
  end;
  
  local get_wire_2_1_closezz = function ()
  
    ObjDelete( "gfx_telephonebooth_wire_2_1" );
    ObjDelete( "spr_telephonebooth_wire_2_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_wire_2_1", get_wire_2_1_inv );
  cmn.AddSubscriber( "get_wire_2_1", get_wire_2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_25pence () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_25pence" ] = {
    type = "get",
    get_obj = "spr_telephonebooth_25pence",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
    
  local get_25pence_inv = function ()
  
    interface.InventoryItemAdd( "inv_25pence", "spr_telephonebooth_25pence" );
  
  end;
  
  local get_25pence_closezz = function ()
  
    ObjDelete( "gfx_telephonebooth_25pence" );
    ObjDelete( "spr_telephonebooth_25pence_over" );
    ObjDelete( "spr_atbar_telephonebooth_coin" );

    --if( cmn.IsEventDone( "get_wire_2_1" ) and cmn.IsEventDone( "get_bag_2" ) 
    --  and cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "get_nightsymbolelement_3" ) )then
    --  
    --  ObjDelete( "gzz_atbar_telephonebooth" ); 
    --  
    --end;

  end;
  
  cmn.AddSubscriber( "get_25pence", get_25pence_inv );
  cmn.AddSubscriber( "get_25pence", get_25pence_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle_2" ] = {
    type = "get",
    get_obj = "spr_motocycle_handle_2",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_atbar_motocycle"
  };
    
  local get_handle_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_handle_2", "spr_motocycle_handle_2" );
  
  end;
  
  local get_handle_2_closezz = function ()
  
    ObjDelete( "gfx_motocycle_handle_2" );
    ObjDelete( "spr_atbar_mocycle_gear" );
    
  
  end;
  
  cmn.AddSubscriber( "get_handle_2", get_handle_2_inv );
  cmn.AddSubscriber( "get_handle_2", get_handle_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_englishbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_englishbadge" ] = {
    type = "get",
    get_obj = "spr_motocycle_englishbadge",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_atbar_motocycle"
  };
    
  local get_englishbadge_inv = function ()
  
    interface.InventoryItemAdd( "inv_englishbadge", "spr_motocycle_englishbadge" );
  
  end;
  
  local get_englishbadge_closezz = function ()
  
    ObjDelete( "gfx_motocycle_englishbadge" );
    ObjDelete( "spr_atbar_mocycle_token" );
    
  end;
  
  cmn.AddSubscriber( "get_englishbadge", get_englishbadge_inv );
  cmn.AddSubscriber( "get_englishbadge", get_englishbadge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_2_2" ] = {
    type = "get",
    get_obj = "spr_motocycle_bottle_2_2",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_atbar_motocycle"
  };
    
  local get_bottle_2_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_2_2", "spr_motocycle_bottle_2_2" );
  
  end;
  
  local get_bottle_2_2_closezz = function ()
  
    ObjDelete( "gfx_motocycle_bottle_2_2" );
    ObjDelete( "spr_atbar_mocycle_bottle" );
   
  end;
  
  cmn.AddSubscriber( "get_bottle_2_2", get_bottle_2_2_inv );
  cmn.AddSubscriber( "get_bottle_2_2", get_bottle_2_2_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_2 = function ()
  
    ObjDelete( "obj_atbar_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_2", get_collect_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_6 = function ()
 
    ObjDelete( "spr_telephonebooth_collect_2");
    
  end;
  
  cmn.AddSubscriber( "get_collect_2_2_6", get_collect_2_2_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_5 = function ()
 
   ObjDelete( "spr_motorcycle_collect_2" );
   ObjDelete( "spr_motorcycle_collect_2_shadow" );
   
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_5", get_collect_2_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_truckkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_truckkey" ] = {
    type = "use",
    inv_obj = "inv_truckkey",
    use_place = "obj_truck_use_truckkey",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_atbar_truck"
  };
  local use_truckkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_truckkey" );
  
  end;
  local use_truckkey_beg = function ()
  
    ObjDelete( "obj_truck_use_truckkey" );
  
  end;
  local use_truckkey_end = function ()
  
    ObjSet( "spr_truck_key_1", { alp = 1 } );
    ObjSet( "obj_truck_clk_key", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_truckkey", use_truckkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_truckkey", use_truckkey_inv );
  cmn.AddSubscriber( "use_truckkey", use_truckkey_end, private.room_objname );
  cmn.AddSubscriber( "use_truckkey_inv", use_truckkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_truckkey_beg", use_truckkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_truckkey_end", use_truckkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mtmap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mtmap" ] = {
    type = "use",
    inv_obj = "inv_mtmap",
    use_place = "obj_truck_use_mtmap",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_atbar_truck"
  };
  local use_mtmap_inv = function ()
  
    interface.InventoryItemRemove( "inv_mtmap" );
  
  end;
  local use_mtmap_beg = function ()
  
    ObjDelete( "obj_truck_use_mtmap" );
  
  end;
  local use_mtmap_end = function ()
  
    ObjDelete( "gzz_atbar_truck" );
    ObjDelete( "spr_truck_back_red_light_1" );
    ObjDelete( "spr_truck_back_red_light_2" );
    ObjSet( "spr_truck_back_card", { alp = 1, pos_y = -7 } );
    ObjSet( "spr_truck_back_green_light_1", { alp = 1 } );
    ObjSet( "spr_truck_back_green_light_2", { alp = 1 } );
    ObjSet( "spr_atbar_truck_ho", { alp = 1 } );
    ObjSet( "gho_atbar_specialequipment", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mtmap", use_mtmap_beg, private.room_objname );
  cmn.AddSubscriber( "use_mtmap", use_mtmap_inv );
  cmn.AddSubscriber( "use_mtmap", use_mtmap_end, private.room_objname );
  cmn.AddSubscriber( "use_mtmap_inv", use_mtmap_inv, private.room_objname );
  cmn.AddSubscriber( "use_mtmap_beg", use_mtmap_beg, private.room_objname );
  cmn.AddSubscriber( "use_mtmap_end", use_mtmap_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nailpuller () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nailpuller" ] = {
    type = "use",
    inv_obj = "inv_nailpuller",
    use_place = "obj_telephonebooth_use_nailpuller",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
  local use_nailpuller_inv = function ()
  
    interface.InventoryItemRemove( "inv_nailpuller" );
  
  end;
  local use_nailpuller_beg = function ()
  
    ObjDelete( "obj_telephonebooth_use_nailpuller" );
  
  end;
  local use_nailpuller_end = function ()
  
    ObjDelete( "obj_telephonebooth_close" );
    ObjDelete( "spr_atbar_telephonebooth_door" );
    ObjSet( "spr_telephonebooth_door_open", { alp = 1 } );
    ObjSet( "spr_atbar_telephonebooth_door_open", { alp = 1 } );
    ObjSet( "spr_telephonebooth_clippers", { input = true, active = true } );
    ObjSet( "spr_telephonebooth_bag_2", { input = true, active = true } );
    ObjSet( "spr_telephonebooth_wire_2_1", { input = true, active = true } );
    ObjSet( "obj_telephonebooth_use_screwdriver_2_1", { input = true } );
    ObjSet( "spr_telephonebooth_note", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_inv );
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_end, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_inv", use_nailpuller_inv, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_beg", use_nailpuller_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_end", use_nailpuller_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_2_1" ] = {
    type = "use",
    inv_obj = "inv_screwdriver_2_1",
    use_place = "obj_telephonebooth_use_screwdriver_2_1",
    room = private.room_objname,
    zz = "zz_telephonebooth",
    zz_gate = "gzz_atbar_telephonebooth"
  };
  local use_screwdriver_2_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_screwdriver_2_1" );
  
  end;
  local use_screwdriver_2_1_beg = function ()
  
    ObjDelete( "obj_telephonebooth_use_screwdriver_2_1" );
  
  end;
  local use_screwdriver_2_1_end = function ()
  
    ObjDelete( "spr_telephonebooth_cap" );
    ObjDelete( "vid_telephonebooth_screw" );
    ObjSet( "spr_telephonebooth_25pence", { input = true, active = true } );
    ObjSet( "spr_atbar_telephonebooth_coin", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_2_1", use_screwdriver_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_1", use_screwdriver_2_1_inv );
  cmn.AddSubscriber( "use_screwdriver_2_1", use_screwdriver_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_1_inv", use_screwdriver_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_1_beg", use_screwdriver_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_1_end", use_screwdriver_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nightsymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nightsymbol" ] = {
    type = "use",
    inv_obj = "inv_nightsymbol",
    use_place = "obj_motocycle_use_nightsymbol",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_atbar_motocycle"
  };
  local use_nightsymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_nightsymbol" );
  
  end;
  local use_nightsymbol_beg = function ()
  
    ObjDelete( "obj_motocycle_use_nightsymbol" );
  
  end;
  local use_nightsymbol_end = function ()
  
      ObjDelete( "spr_motocycle_pocket_close" );
    ObjDelete( "spr_atbar_mocycle_close" );
      ObjMultiSet({ 
      { "spr_motocycle_handle_2",     { input = true, active = true     }},
      { "spr_motocycle_englishbadge",     { input = true, active = true     }},
      { "obj_motocycle_use_skullsymbol",     { input = true     }},
      { "obj_motocycle_pocket",     { input = true     }},
      { "spr_motocycle_pocket_open",     { alp = 1  }},
      { "spr_atbar_mocycle_open",     { alp = 1  }},
  });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nightsymbol", use_nightsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_nightsymbol", use_nightsymbol_inv );
  cmn.AddSubscriber( "use_nightsymbol", use_nightsymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_nightsymbol_inv", use_nightsymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_nightsymbol_beg", use_nightsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_nightsymbol_end", use_nightsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_skullsymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_skullsymbol" ] = {
    type = "use",
    inv_obj = "inv_skullsymbol",
    use_place = "obj_motocycle_use_skullsymbol",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_atbar_motocycle"
  };
  local use_skullsymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_skullsymbol" );
  
  end;
  local use_skullsymbol_beg = function ()
  
    ObjDelete( "obj_motocycle_use_skullsymbol" );
  
  end;
  local use_skullsymbol_end = function ()
  
    ObjDelete( "spr_motocycle_bag_close" )
    ObjDelete( "spr_atbar_mocycle_bag_close" )
    ObjMultiSet({ 
      { "spr_motocycle_bottle_2_2",     { input = true, active = true     }},
      { "spr_motocycle_bag_open",     { alp = 1    }},
      { "spr_motocycle_bag_item",     { alp = 1    }},
      { "obj_motocycle_bag",     { input = true     }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_skullsymbol", use_skullsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_skullsymbol", use_skullsymbol_inv );
  cmn.AddSubscriber( "use_skullsymbol", use_skullsymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_skullsymbol_inv", use_skullsymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_skullsymbol_beg", use_skullsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_skullsymbol_end", use_skullsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wire_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wire_2_1" ] = {
    type = "use",
    inv_obj = "inv_wire_2_1",
    use_place = "obj_bardoor_use_wire_2_1",
    room = private.room_objname,
    zz = "zz_bardoor",
    zz_gate = "gzz_atbar_bardoor"
  };
  local use_wire_2_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_wire_2_1" );
  
  end;
  local use_wire_2_1_beg = function ()
  
    ObjDelete( "obj_bardoor_use_wire_2_1" );
  
  end;
  local use_wire_2_1_end = function ()
  
    if ( cmn.IsEventDone("use_wire_2_2") ) then
      
      ObjDelete( "gzz_atbar_bardoor" );
      ObjSet( "gmg_atbar_doorhos", { input = true, active = true } );
      
    end;

    ObjSet( "spr_bardoor_wire_1", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wire_2_1", use_wire_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_1", use_wire_2_1_inv );
  cmn.AddSubscriber( "use_wire_2_1", use_wire_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_1_inv", use_wire_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_1_beg", use_wire_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_1_end", use_wire_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wire_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wire_2_2" ] = {
    type = "use",
    inv_obj = "inv_wire_2_2",
    use_place = "obj_bardoor_use_wire_2_2",
    room = private.room_objname,
    zz = "zz_bardoor",
    zz_gate = "gzz_atbar_bardoor"
  };
  local use_wire_2_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_wire_2_2" );
  
  end;
  local use_wire_2_2_beg = function ()
  
    ObjDelete( "obj_bardoor_use_wire_2_2" );
  
  end;
  local use_wire_2_2_end = function ()
  
    if ( cmn.IsEventDone("use_wire_2_1") ) then
      
      ObjDelete( "gzz_atbar_bardoor" );
      ObjSet( "gmg_atbar_doorhos", { input = true, active = true } );

    end;
  
    ObjSet( "spr_bardoor_wire_2", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wire_2_2", use_wire_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_2", use_wire_2_2_inv );
  cmn.AddSubscriber( "use_wire_2_2", use_wire_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_2_inv", use_wire_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_2_beg", use_wire_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_2_2_end", use_wire_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_truckkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_truckkey" ] = {
    type = "click",
    use_place = "obj_truck_clk_key",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_atbar_truck"
  };
  local clk_truckkey_beg = function ()
  
    ObjDelete( "obj_truck_clk_key" );
  
  end;
  local clk_truckkey_end = function ()
      
    ObjDelete( "obj_truck_front_door" );
    ObjSet( "spr_atbar_truck_open",  { alp = 1 } );
    
    ObjSet( "obj_truck_open", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_truckkey", clk_truckkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_truckkey", clk_truckkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_truckkey_beg", clk_truckkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_truckkey_end", clk_truckkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_atbar_passing () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_atbar_passing" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_atbar_passing",
    
  };
  local vid_atbar_passing_end = function ()
  
    ObjDelete( "anm_atbar_avenger" );
    ObjSet( "anm_atbar_smoke", { alp = 1 } );
    ObjSet( "obj_atbar_truck_bardoor", { alp = 1} );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_atbar_passing", vid_atbar_passing_end, private.room_objname  );
  cmn.AddSubscriber( "vid_atbar_passing_end", vid_atbar_passing_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function win_pair () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pair" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_truck_mmg",
    zz_gate = "gzz_atbar_truck",
    zz = "zz_truck"

  };

  local win_pair = function ()
  
    if ( cmn.IsEventDone( "win_pair" ) ) then
      
      ObjDelete( "obj_truck_mmg" );
      ObjSet( "obj_truck_use_mtmap", {  input = true });
      ObjDelete( "spr_atbar_truck_mmg" )
     
    elseif ( cmn.IsEventStart( "win_pair" ) ) then

      private.pair =  ng_global.progress[ "std" ][ "win_pair" ].pair;
      
      ObjSet( "spr_truck_mmg_item_"..private.pair.first.."_light", { alp = 1 } );

      for j = 1, 12 do

        if ( private.pair.comb[j] ~= 0 ) then

          ObjSet( "spr_truck_mmg_item_"..j, { input = true, alp = 1 } );

        else 

          ObjSet( "spr_truck_mmg_item_"..j, { input = false, alp = 0 } );

        end;

      end;
      
    end;
    
  end;

  cmn.AddSubscriber( "win_pair", win_pair, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function win_secretpassage () end;
  --------------------------------------------------------------------------------------------
  local win_secretpassage_atbar = function ()
  
    if cmn.IsEventDone( "win_secretpassage" ) then
      
      ObjSet( "spr_atbar_bardoor_loc", { alp = 1 } );
      
    end;
  
  end;
  cmn.AddSubscriber( "win_secretpassage", win_secretpassage_atbar, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function clk_elevator_button () end;
  --------------------------------------------------------------------------------------------  
  local clk_elevator_button_atbar = function ()
    
    ObjSet( "spr_atbar_bardoor_loc_elevator", { alp = 1 } );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_elevator_button", clk_elevator_button_atbar, private.room_objname  );  
  
  --------------------------------------------------------------------------------------------
  -- function use_mechanismpart () end;
  --------------------------------------------------------------------------------------------  
  local use_mechanismpart_atbar = function ()
    
    ObjDelete( "spr_atbar_bardoor_bar_cog" );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_atbar, private.room_objname  );  
  
  --------------------------------------------------------------------------------------------
  -- function use_dart () end;
  --------------------------------------------------------------------------------------------  
  local use_dart_atbar = function ()
    
    ObjSet( "spr_atbar_bardoor_bar_zz", { alp = 1 } );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dart", use_dart_atbar, private.room_objname  );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_secretpassage () end;
  --------------------------------------------------------------------------------------------  
  local clk_secretpassage_atbar = function ()
    
    ObjSet( "spr_atbar_bardoor_bar_mg", { alp = 1 } );
    ObjDelete( "spr_atbar_bardoor_bar_zz" );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_secretpassage", clk_secretpassage_atbar, private.room_objname  );  
  
  --------------------------------------------------------------------------------------------
  -- function clk_bar_2_door () end;
  --------------------------------------------------------------------------------------------
  local clk_bar_2_door_atbar = function ()

    ObjDelete( "spr_atbar_bardoor_bar_mg" );
 
    ObjSet( "spr_atbar_bardoor_loc", { alp = 1 } );
 
  end;

  cmn.AddSubscriber( "clk_bar_2_door", clk_bar_2_door_atbar, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_doorhos () end;
  --------------------------------------------------------------------------------------------
  local win_doorhos_atbar = function ()
  
  --if cmn.IsEventDone( "win_doorhos" ) and (( ng_global.progress[ "std" ][ "win_doorhos" ].anim == 2 ) or cmn.IsEventDone( "opn_bar_2" ) ) then
  if cmn.IsEventDone( "clk_button" ) and (( ng_global.progress[ "std" ][ "win_doorhos" ].anim == 2 ) or cmn.IsEventDone( "opn_bar_2" ) ) then
      
      ObjSet( "anm_atbar_door_static", { alp = 1, active = true } );
      ObjDelete( "obj_atbar_bardoor_closed" );
      ObjDelete( "gmg_atbar_doorhos" );
      ObjSet( "grm_atbar_bar_2", { input = true, active = true } );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_atbar_bar_2_focus");
      end;      
    end;
  
  end;
  cmn.AddSubscriber( "win_doorhos", win_doorhos_atbar, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_5 = function ()
  
  ObjDelete( "obj_atbar_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_5", get_collect_morph_item_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
  -- function win_specialequipment () end;
  --------------------------------------------------------------------------------------------
  local win_specialequipment_atbar = function ()
  
    if cmn.IsEventDone( "win_specialequipment" ) then
      
      ObjDelete( "gho_atbar_specialequipment" )
      
    end;
  
  end;
  cmn.AddSubscriber( "win_specialequipment", win_specialequipment_atbar, private.room_objname ); 
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
 subroom.Define( "zz_truck" );
 subroom.Define( "zz_telephonebooth" );
 subroom.Define( "zz_bardoor" );
 subroom.Define( "zz_motocycle" );
 
 --------------------------------------------------------------------------------------------
 function zz_truck.PreOpen()

   if ( cmn.IsEventDone( "clk_truckkey" ) ) and not cmn.IsEventDone( "win_pair" ) then
    
      cmn.MiniGameShow( 'pair' );
      common_impl.PassingMgStart( "pair" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_truck.PreClose()

    if ( cmn.IsEventDone( "clk_truckkey" ) ) and not cmn.IsEventDone( "win_pair" ) then

      cmn.MiniGameHide( 'pair' );
      common_impl.PassingMgStop( "pair" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_telephonebooth.PreOpen()

    if not common_impl.atbar then

      common_impl.atbar = {}
      common_impl.atbar.note = "close";

    end;

    if  ObjGet( "spr_telephonebooth_note" ).input == true then

      ObjSet( "spr_telephonebooth_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_telephonebooth_note",     { alp = 1 } );
      
    end;

  end;

  function zz_telephonebooth.Close()

    common_impl.atbar.note = "close"; 

  end;
  --------------------------------------------------------------------------------------------
  function zz_motocycle.PreOpen()

    if not common_impl.atbar then

      common_impl.atbar = {}
      common_impl.atbar.note = "close";

    end;

    if  ObjGet( "spr_motocycle_note" ).input == true then

      ObjSet( "spr_motocycle_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_motocycle_note",     { alp = 1 } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_motocycle.Close()

    common_impl.atbar.note = "close"; 

  end;
  function zz_bardoor.Close()

    if cmn.IsEventDone( "use_wire_2_1" ) and cmn.IsEventDone( "use_wire_2_2" ) and not cmn.IsEventDone( "win_doorhos" ) then
    
      interface.Lock( true, 0.4 );
      cmn.GotoRoom( 'mg_doorhos' )
      
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_atbar();
 

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_atbar_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "vid_atbar_passing" ) then

    
    --ObjSet( "rm_atbar", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjSet( "tmr_atbar_passing",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_atbar_passing(); end
    } );

  end;
  
  if not ng_global.progress[ "std" ][ "win_doorhos" ].anim then
    
  elseif ng_global.progress[ "std" ][ "win_doorhos" ].anim == 1 then
    
    local func_after = function()
    
      ng_global.progress[ "std" ][ "win_doorhos" ].anim = 2;
      cmn.CallEventHandler( "win_doorhos" )
      interface.KeyTaskDone( 'enter_pub', true);
    
    end;
  
    interface.Lock( true, 3 );
    AnimPlay( "anm_atbar_door", "DoAnim", func_after );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_pub_doors", 0, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_truckkey()

  local item = "inv_truckkey";

  if ( common.ApplyObj( item, "obj_truck_use_truckkey", true ) and cmn.IsEventDone("get_nightsymbolelement_2") ) then

    cmn.CallEventHandler( "use_truckkey_inv" );
    cmn.CallEventHandler( "use_truckkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_truckkey" );
      cmn.CallEventHandler( "use_truckkey_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_truckkey_truck", 0, "", 0 );
    
    ObjAnimate( "spr_truck_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_truck", false ) and cmn.IsEventDone("get_nightsymbolelement_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_truck", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mtmap()

  local item = "inv_mtmap";

  if ( common.ApplyObj( item, "obj_truck_use_mtmap", true ) and cmn.IsEventDone("win_pair") and cmn.IsEventDone("get_nightsymbolelement_2") ) then

    cmn.CallEventHandler( "use_mtmap_inv" );
    cmn.CallEventHandler( "use_mtmap_beg" );

    local func_after = function ()
    
      local func_end_1 = function ()
      
        local func_end_2 = function () 
        
          common_impl.Lock( false );
          cmn.SetEventDone( "use_mtmap" );
          cmn.CallEventHandler( "use_mtmap_end" );
          common.CloseSubRoom();
          
        end;
      
        ObjAnimate( "spr_truck_back_door_1", "pos_x", 0, 0, "",
        { 
          0.0, 0, 34, 
          0.4, 0, 134
        } );
      
        ObjAnimate( "spr_truck_back_door_2", "pos_x", 0, 0, func_end_2,
        { 
          0.0, 0, -79, 
          0.4, 0, -179
        } );
        
      end;
      
      ObjAnimate( "spr_truck_back_card", "pos_y", 0, 0, func_end_1,
      { 
        0.0, 0, -58, 
        0.4, 0, -7,
        0.7, 0, -7
      } );
      
      ObjAnimate( "spr_truck_back_red_light_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.4, 0, 1,
        0.7, 0, 0     
      } );
      
      ObjAnimate( "spr_truck_back_green_light_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.4, 0, 0,
        0.7, 0, 1     
      } );
      
      ObjAnimate( "spr_truck_back_red_light_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.4, 0, 1,
        0.7, 0, 0     
      } );
      
      ObjAnimate( "spr_truck_back_green_light_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.4, 0, 0,
        0.7, 0, 1     
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_mtmap_truck", 0, "", 0 );
    
    ObjAnimate( "spr_truck_back_card", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_truck", false ) and cmn.IsEventDone("win_pair") and cmn.IsEventDone("get_nightsymbolelement_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_truck", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nailpuller()

  local item = "inv_nailpuller";

  if ( common.ApplyObj( item, "obj_telephonebooth_use_nailpuller", true ) ) then

    cmn.CallEventHandler( "use_nailpuller_inv" );
    cmn.CallEventHandler( "use_nailpuller_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_nailpuller" );
        cmn.CallEventHandler( "use_nailpuller_end" );
      
      end;
    
      
      ObjAnimate( "spr_telephonebooth_door_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      ObjAnimate( "obj_telephonebooth_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_nailpuller_telephonebooth", 0, "", 0 );
    
    AnimPlay( "anm_telephonebooth_nailpuller", "DoAnim", func_after )
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_telephonebooth", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_telephonebooth", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_2_1()

  local item = "inv_screwdriver_2_1";

  if ( common.ApplyObj( item, "obj_telephonebooth_use_screwdriver_2_1", true ) and cmn.IsEventDone("use_nailpuller") and ( common_impl.atbar.note == "close" ) ) then

    cmn.CallEventHandler( "use_screwdriver_2_1_inv" );
    cmn.CallEventHandler( "use_screwdriver_2_1_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_screwdriver_2_1" );
        cmn.CallEventHandler( "use_screwdriver_2_1_end" );
      
      end;
      
      ObjAnimate( "spr_telephonebooth_cap", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0,  37, -13, 
        0.5, 0, 112, 440
      } );
      
      ObjAnimate( "spr_telephonebooth_cap", "ang", 0, 0, "",
      { 
        0.0, 0,  0, 
        0.5, 0,  1
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_screwdriver_telephonebooth", 0, "", 0 );
    VidPlay( "vid_telephonebooth_screw", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_telephonebooth", false ) and cmn.IsEventDone("use_nailpuller") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_telephonebooth", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nightsymbol()

  local item = "inv_nightsymbol";

  if ( common.ApplyObj( item, "obj_motocycle_use_nightsymbol", true ) ) and ( common_impl.atbar.note == "close" ) then

    cmn.CallEventHandler( "use_nightsymbol_inv" );
    cmn.CallEventHandler( "use_nightsymbol_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_nightsymbol" );
      cmn.CallEventHandler( "use_nightsymbol_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_nightsymbol_motocycle", 0, "", 0 );
  
    ObjAnimate( "spr_motocycle_nightsymbol", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0
    } );  
    ObjAnimate( "spr_motocycle_pocket_open", "alp", 0, 0, "",
    { 
    0.0, 0, 0.0, 
    0.4, 0, 0.0, 
    0.7, 0, 1.0
    } );
    ObjAnimate( "spr_motocycle_pocket_close", "alp", 0, 0, func_after,
    { 
    0.0, 0, 1.0, 
    0.4, 0, 1.0, 
    0.7, 0, 0.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_motocycle", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motocycle", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_skullsymbol()

  local item = "inv_skullsymbol";

  if ( common.ApplyObj( item, "obj_motocycle_use_skullsymbol", true ) and cmn.IsEventDone( "use_nightsymbol" ) and common_impl.atbar.note == "close" ) then

    cmn.CallEventHandler( "use_skullsymbol_inv" );
    cmn.CallEventHandler( "use_skullsymbol_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_skullsymbol" );
      cmn.CallEventHandler( "use_skullsymbol_end" );
      --common.CloseSubRoom();;
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_skullsymbol_motocycle", 0, "", 0 );

    ObjAnimate( "spr_motocycle_bag_item", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0
    } );  
    ObjAnimate( "spr_motocycle_bag_close", "alp", 0, 0, "",
    { 
    0.0, 0, 1.0, 
    0.4, 0, 1.0, 
    0.7, 0, 0.0
    } );
    ObjAnimate( "spr_motocycle_bag_open", "alp", 0, 0, func_after,
    { 
    0.0, 0, 0.0, 
    0.4, 0, 0.0, 
    0.7, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_motocycle", false ) and cmn.IsEventDone( "use_nightsymbol" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motocycle", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wire_2_1()

  local item = "inv_wire_2_1";

  if ( common.ApplyObj( item, "obj_bardoor_use_wire_2_1", true ) ) then

    cmn.CallEventHandler( "use_wire_2_1_inv" );
    cmn.CallEventHandler( "use_wire_2_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wire_2_1" );
      cmn.CallEventHandler( "use_wire_2_1_end" );
      
      if ( cmn.IsEventDone("use_wire_2_2") ) then
      
        common.CloseSubRoom();
        
      end;
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_wire_bardoor", 0, "", 0 );
    
    ObjAnimate( "spr_bardoor_wire_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_bardoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bardoor", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wire_2_2()

  local item = "inv_wire_2_2";

  if ( common.ApplyObj( item, "obj_bardoor_use_wire_2_2", true ) ) then

    cmn.CallEventHandler( "use_wire_2_2_inv" );
    cmn.CallEventHandler( "use_wire_2_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wire_2_2" );
      cmn.CallEventHandler( "use_wire_2_2_end" );
      
      if ( cmn.IsEventDone("use_wire_2_1") ) then
      
        common.CloseSubRoom();
        
      end;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_wire_bardoor", 0, "", 0 );
    
    ObjAnimate( "spr_bardoor_wire_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_atbar_bardoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bardoor", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_nightsymbolelement_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nightsymbolelement_2" );
  cmn.CallEventHandler( "get_nightsymbolelement_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_nightsymbolelement_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nightsymbolelement_3" );
  cmn.CallEventHandler( "get_nightsymbolelement_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_clippers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_clippers" );
  cmn.CallEventHandler( "get_clippers" );

end;
--------------------------------------------------------------------------------------------
function private.get_bag_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bag_2" );
  cmn.CallEventHandler( "get_bag_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_wire_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_wire_2_1" );
  cmn.CallEventHandler( "get_wire_2_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_25pence()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_25pence" );
  cmn.CallEventHandler( "get_25pence" );
  
  --if( cmn.IsEventDone( "get_wire_2_1" ) and cmn.IsEventDone( "get_bag_2" ) 
  --  and cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "get_nightsymbolelement_3" ) )then
  --  
  --  common.CloseSubRoom(); 
  --  
  --end;
  if common_impl.IsGetCollect( "get_collect_2_2_6" ) then 
    
   common.CloseSubRoom(); 
  
  end;  
end;
--------------------------------------------------------------------------------------------
function private.get_handle_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_handle_2" );
  cmn.CallEventHandler( "get_handle_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_englishbadge()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_englishbadge" );
  cmn.CallEventHandler( "get_englishbadge" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_bottle_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottle_2_2" );
  cmn.CallEventHandler( "get_bottle_2_2" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_2_5()

  local func_after = function ()
    
  common_impl.GetCollectDone("get_collect_2_2_5");
  cmn.CallEventHandler("get_collect_2_2_5");

  end;

  common_impl.PlayEffectHO( "spr_motorcycle_collect_2", func_after ); 

end;
----------------------------------------------------------------------------------------------------
function private.get_collect_2_2_6()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_6");
    cmn.CallEventHandler("get_collect_2_2_6");
    
    if cmn.IsEventDone("get_25pence") then 
    
       common.CloseSubRoom(); 
      
   end;  
  
  end;

  common_impl.PlayEffectHO( "spr_telephonebooth_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_item( number )

  if not ( private.pair.flag ) then
      
      private.pair.flag = true;
      private.pair.first = number;
      private.pair.second = 0;
      ObjSet( "spr_truck_mmg_item_"..number.."_light", { alp = 1 } );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_truck_select", 0, "", 0 );
      
  else 

      if ( private.pair.first == number ) then

        ObjSet( "spr_truck_mmg_item_"..number.."_light", { alp = 0 } );
        private.pair.first = 0;
        private.pair.second = 0;
        private.pair.flag = false;
        
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_truck_select", 0, "", 0 );
        
      else 

        if ( private.pair.comb[ number ] == private.pair.comb[ private.pair.first ] ) then

          local func_after = function()

            private.pair.comb[ private.pair.first ] = 0;
            private.pair.comb[ private.pair.second ] = 0;

            ObjSet( "spr_truck_mmg_item_"..private.pair.first, { input = false, alp = 0 });
            ObjSet( "spr_truck_mmg_item_"..private.pair.second, { input = false, alp = 0 });

            private.pair.flag = false;
            private.pair.first = 0;
            private.pair.second = 0;
   
            if private.check_item_win() then

              private.pair_win_anim();

            else

              common_impl.Lock( false );
              ng_global.progress[ "std" ][ "win_pair" ].pair = private.pair;

            end;

          end;

          common_impl.Lock( true );
          
          private.pair.second = number;
          
          common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_truck_hide", 0, "", 0 );
          
          ObjAnimate( "spr_truck_mmg_item_"..private.pair.first,"alp",0,0, "", 
          {
            0.0,0,1,
            0.3,0,0
          });
          
          ObjAnimate( "spr_truck_mmg_item_"..private.pair.second,"alp",0,0, func_after, 
          {
            0.0,0,1,
            0.3,0,0
          });

        else 

          ObjSet( "spr_truck_mmg_item_"..number.."_light", { alp = 1 });
          ObjSet( "spr_truck_mmg_item_"..private.pair.first.."_light", { alp = 0 });
          
          common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_truck_select", 0, "", 0 );
          
          private.pair.first = number;
          private.pair.second = 0;

        end;

      end;

    end;

end;
--------------------------------------------------------------------------------------------
function private.check_item_win()

  local win = true;

  for k = 1,12 do
        
    if private.pair.comb[k] ~= 0 then

      win = false;
      break;

    end; 

  end;

  return win;

end;
--------------------------------------------------------------------------------------------
function private.pair_win_anim()
  
  private.pair_win();
  
end;
--------------------------------------------------------------------------------------------
function private.pair_win()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  
  common_impl.Lock( false );
  cmn.MiniGameHide( "pair" );
  common_impl.PassingMgWin( "pair" );
  cmn.SetEventDone( "win_pair" );
  cmn.CallEventHandler( "win_pair" );
  
end;
--------------------------------------------------------------------------------------------
function private.reset_pair()
 
  private.pair.flag = false;
  private.pair.first = 0;
  private.pair.second = 0; 
  private.pair.comb = { 1, 2, 3, 1, 4, 5, 6, 3, 2, 4, 5, 6 };
  
  ng_global.progress[ "std" ][ "win_pair" ].pair = private.pair;
  
  for j = 1, 12 do

    ObjSet( "spr_truck_mmg_item_"..j, { input = true, alp = 1 } );
    ObjSet( "spr_truck_mmg_item_"..j.."_light", { alp = 0 } );

  end;
   
end;
--------------------------------------------------------------------------------------------
function private.skip_pair()
  
  private.pair_win_anim();
  
end;
--------------------------------------------------------------------------------------------
function private.clk_door()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_truck_use_truckkey' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_door_truck", 0, "", 0 );

  AnimPlay( "anm_truck_door", "DoAnim", func_after )
    
end;
--------------------------------------------------------------------------------------------
function private.clk_back_door()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_truck_use_mtmap' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_back_doors_truck", 0, "", 0 );
  
  ObjAnimate( "spr_truck_back_door_1", "pos_x", 0, 0, "",
  { 
    0.0, 0, 34, 
    0.3, 0, 36,
    0.6, 0, 34   
  } );
  
  ObjAnimate( "spr_truck_back_door_2", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, -79, 
    0.3, 0, -81,
    0.6, 0, -79
  } );
    
end;
--------------------------------------------------------------------------------------------
function private.clk_truckkey()
  
  cmn.CallEventHandler( "clk_truckkey_beg" );
  
  local func_after = function()
  
    local func_end = function()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_truckkey" );
      cmn.CallEventHandler( "clk_truckkey_end" );
      cmn.MiniGameShow( 'pair' );
      common_impl.PassingMgStart( "pair" );
      
    end;
    
    ObjAnimate( "obj_truck_front_door", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );
  
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_truckkey_truck", 0, "", 0 );
  
  ObjAnimate( "spr_truck_key_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );
  
  ObjAnimate( "spr_truck_key_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_bardoor_handle()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_bardoor_use_wire' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_door_bardoor", 0, "", 0 );
  
  AnimPlay( "anm_bardoor_pen", "DoAnim", func_after )
    
end;
--------------------------------------------------------------------------------------------
function private.clk_telephonebooth_nailpuller()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_telephonebooth_use_nailpuller' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_boards_telephonebooth", 0, "", 0 );
  
  ObjAnimate( "anm_telephonebooth_nailpuller", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 0, 2,
    0.4, 0, 0
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_motocycle_close()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_motocycle_use_nightsymbol' );
 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_pocket_motocycle", 0, "", 0 );
  
  ObjAnimate( "spr_motocycle_pocket_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, -38, 
    0.2, 0, -36,
    0.4, 0, -38
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_motocycle_bag()
  
  local func_after = function()
  
    common_impl.Lock( false );
      
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_motocycle_use_skullsymbol' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_pocket_motocycle", 0, "", 0 );
  
  ObjAnimate( "spr_motocycle_bag_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, -57, 
    0.2, 0, -59,
    0.4, 0, -57
  } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_pair" then
      
      private.skip_pair();

  end;

end;
--*********************************************************************************************************************
function public.Reset( name )
  
  if name == "win_pair" then
     
     private.reset_pair();
     
  end;
   
end;
--*********************************************************************************************************************
function private.opn_atbar()

  if not ( cmn.IsEventDone( "opn_atbar" ) ) then
    cmn.SetEventDone( "opn_atbar" );
    common_impl.AddPageDiary( 8 );
  end;
  
  cmn.CallEventHandler( "opn_atbar" ); 

end;
--*********************************************************************************************************************
function private.vid_atbar_passing()

  local func_after = function ()

    local smoke_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "vid_atbar_passing" );
      cmn.CallEventHandler( "vid_atbar_passing_end" );
      common_impl.ShowBbt( 'bbt_vid_atbar_passing', 1 );
      interface.KeyTaskAdd( 'enter_pub', true ); 
      common_impl.StopAudio( "sfx", "common/audio/level2/aud_avengers_runs_pub" );
      common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
      common_impl.SetSoundTimer( 39, "mus", "common/audio/aud_danger1_mus" );
      
      ObjSet( "anm_atbar_smoke", { alp = 1 } );

    end;
    
    smoke_after();

  end;

  common_impl.Lock( true );
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_avengers_runs_pub", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "common/audio/level1/aud_atbar_passing_voc", 0, "", 0 );
  --interface.DialogVideoShow( "vid_atbar_passing", 1, function() func_after( 'skip' ); end, 3 );
  --VidPlay( "vid_atbar_passing", function() func_after( nil ); end );
  AnimPlay( "anm_atbar_avenger", "DoAnim", func_after )
  ObjSet( "anm_atbar_smoke", { alp = 0 } );

end;
--*********************************************************************************************************************
  ObjAnimate( "spr_atbar_light_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_atbar_light_2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_truck_nightsymbolelement_2_add", "alp", 1, 0, "", 
  { 
  0.0, 0, 0, 
  0.2, 0, 1,
  0.4, 0, 0,
  2.0, 0, 0
  } );
  