-- name=rm_base
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_base";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_symbol", "room_hub" );
  ObjAttach( "zz_drawers", "room_hub" );
  ObjAttach( "zz_elevator", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_symbol_emblem", { event_mdown = private.get_emblem }},
  { "spr_drawers_boardpart", { event_mdown = private.get_boardpart }},
  { "spr_drawers_badgeelement_2_2", { event_mdown = private.get_badgeelement_2_2 }},
  { "spr_drawers_trihedron", { event_mdown = private.get_trihedron }},
  { "obj_elevator_clk_card", { event_mdown = private.clk_brokencard }},
  { "obj_elevator_clk_elevator_button", { event_mdown = private.clk_elevator_button }},
  { "spr_symbol_note", { event_mdown = function() common_impl.NoteScale( "open", "spr_symbol_note" ); common_impl.ShowBbt( 'bbt_symbol_note', 1 );end } },
  { "spr_symbol_note_big", { event_mdown = function() common_impl.NoteScale( "close", "spr_symbol_note" ) end } },
  { "obj_symbol_use_ruby", { event_mdown = private.clk_door_symbol } },
  { "spr_base_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_base_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_drawers_collect_2", { event_mdown = function () private.get_collect_2_2_1(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
   { "spr_symbol_collect_2", { event_mdown = function () private.get_collect_2_2_2(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                             
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_base = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_base_avengersstuff",
    "gzz_base_symbol",
    "gzz_base_drawers", 
    "gzz_base_elevator"    
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_symbol",
    "zz_drawers",
    "zz_elevator"   
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_base", update_game_mode_base, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_base = function ()

  local effects_table = 
  {
    "obj_base_anim",
    "obj_symbol_anims",
    "anm_elevator_plate_broken"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_base", update_performance_mode_base, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_base () end;
  --------------------------------------------------------------------------------------------
  local opn_base_map = function ()

    common_impl.VisitMapRoom( "base" );

  end;
  cmn.AddSubscriber( "opn_base", opn_base_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_emblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emblem" ] = {
    type = "get",
    get_obj = "spr_symbol_emblem",
    room = private.room_objname,
    zz = "zz_symbol",
    zz_gate = "gzz_base_symbol"
  };
    
  local get_emblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_emblem", "spr_symbol_emblem" );
  
  end;
  
  local get_emblem_closezz = function ()
  
    ObjDelete( "gfx_symbol_emblem" );
    ObjDelete( "spr_symbol_emblem_shadow" );
    ObjDelete( "spr_base_symbol_lion" );
  
  end;
  
  cmn.AddSubscriber( "get_emblem", get_emblem_inv );
  cmn.AddSubscriber( "get_emblem", get_emblem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boardpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boardpart" ] = {
    type = "get",
    get_obj = "spr_drawers_boardpart",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
    
  local get_boardpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_boardpart", "spr_drawers_boardpart" );
    ObjSet("spr_board_plus_light", { alp = 1 });
  
  end;
  
  local get_boardpart_closezz = function ()
  
    ObjDelete( "gfx_drawers_boardpart" );
    ObjDelete( "spr_drawers_boardpart_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_boardpart", get_boardpart_inv );
  cmn.AddSubscriber( "get_boardpart", get_boardpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_badgeelement_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_badgeelement_2_2" ] = {
    type = "get",
    get_obj = "spr_drawers_badgeelement_2_2",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
    
  local get_badgeelement_2_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_badgeelement_2_2", "spr_drawers_badgeelement_2_2" );
    ObjSet( "spr_bartendersbadge_plus_light", { alp = 1 });
  
  end;
  
  local get_badgeelement_2_2_closezz = function ()
  
    ObjDelete( "gfx_drawers_badgeelement_2_2" );
    --ObjDelete( "gzz_base_drawers" );
  
  end;
  
  cmn.AddSubscriber( "get_badgeelement_2_2", get_badgeelement_2_2_inv );
  cmn.AddSubscriber( "get_badgeelement_2_2", get_badgeelement_2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trihedron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trihedron" ] = {
    type = "get",
    get_obj = "spr_drawers_trihedron",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
    
  local get_trihedron_inv = function ()
  
    interface.InventoryItemAdd( "inv_trihedron", "spr_drawers_trihedron" );
  
  end;
  
  local get_trihedron_closezz = function ()
  
    ObjDelete( "gfx_drawers_trihedron" );
    ObjDelete( "spr_drawers_trihedron_shadow" );
    
    if common_impl.IsGetCollect( "get_collect_2_2_1" ) then
      
      ObjDelete( "gzz_base_drawers" );
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_trihedron", get_trihedron_inv );
  cmn.AddSubscriber( "get_trihedron", get_trihedron_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_3 = function ()
  
    ObjDelete( "obj_base_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_3", get_collect_morph_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_3 = function ()
  
    ObjDelete( "obj_base_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_3", get_collect_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_1 = function ()
 
    ObjDelete( "spr_drawers_collect_2" );
    ObjDelete( "spr_drawers_collect_2_shadow" );

    if cmn.IsEventDone( "get_trihedron" ) then
      
      ObjDelete( "gzz_base_drawers" );
      
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_1", get_collect_2_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
   -- function get_collect_2_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_2 = function ()
 
  ObjDelete( "spr_symbol_collect_2" );
    
    --if cmn.IsEventDone( "get_trihedron" ) then
    --  
    --  ObjDelete( "gzz_base_drawers" );
    --  
    --end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_2", get_collect_2_2_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_ruby () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ruby" ] = {
    type = "use",
    inv_obj = "inv_ruby",
    use_place = "obj_symbol_use_ruby",
    room = private.room_objname,
    zz = "zz_symbol",
    zz_gate = "gzz_base_symbol"
  };
  local use_ruby_inv = function ()
  
    interface.InventoryItemRemove( "inv_ruby" );
  
  end;
  local use_ruby_beg = function ()
  
    ObjDelete( "obj_symbol_use_ruby" );
  
  end;
  local use_ruby_end = function ()
  
    ObjDelete( "anm_symbol_door" );
    ObjDelete( "spr_base_symbol_door_1" );
    ObjSet( "gfx_symbol_emblem", { active = true } );
    ObjSet( "spr_symbol_emblem", { input = true } );
    ObjSet( "spr_symbol_ruby", { alp = 1 } );
    ObjSet( "spr_base_symbol_door_2", { alp = 1 } );
    ObjSet( "spr_base_symbol", { alp = 1 } );
    ObjSet( "spr_symbol_note", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ruby", use_ruby_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruby", use_ruby_inv );
  cmn.AddSubscriber( "use_ruby", use_ruby_end, private.room_objname );
  cmn.AddSubscriber( "use_ruby_inv", use_ruby_inv, private.room_objname );
  cmn.AddSubscriber( "use_ruby_beg", use_ruby_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruby_end", use_ruby_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2_1" ] = {
    type = "use",
    inv_obj = "inv_button_2_1",
    use_place = "obj_drawers_use_button_2_1",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
  local use_button_2_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_2_1" );
  
  end;
  local use_button_2_1_beg = function ()
  
    ObjDelete( "obj_drawers_use_button_2_1" );
  
  end;
  local use_button_2_1_end = function ()
  
    ObjSet( "obj_drawers_box_1", { input = true, alp = 1 } );
    ObjSet( "spr_base_drawers_box_1", { alp = 1 } );
    ObjDelete( "spr_drawers_button_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_2_1", use_button_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_1", use_button_2_1_inv );
  cmn.AddSubscriber( "use_button_2_1", use_button_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_1_inv", use_button_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_1_beg", use_button_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_1_end", use_button_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2_2" ] = {
    type = "use",
    inv_obj = "inv_button_2_2",
    use_place = "obj_drawers_use_button_2_2",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
  local use_button_2_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_2_2" );
  
  end;
  local use_button_2_2_beg = function ()
  
    ObjDelete( "obj_drawers_use_button_2_2" );
  
  end;
  local use_button_2_2_end = function ()
  
    ObjSet( "obj_drawers_box_2", { input = true, alp = 1 } );
    ObjDelete( "spr_drawers_button_2" );
    ObjSet( "spr_base_drawers_box_2", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_2_2", use_button_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_2", use_button_2_2_inv );
  cmn.AddSubscriber( "use_button_2_2", use_button_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_2_inv", use_button_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_2_beg", use_button_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_2_end", use_button_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2_3" ] = {
    type = "use",
    inv_obj = "inv_button_2_3",
    use_place = "obj_drawers_use_button_2_3",
    room = private.room_objname,
    zz = "zz_drawers",
    zz_gate = "gzz_base_drawers"
  };
  local use_button_2_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_2_3" );
  
  end;
  local use_button_2_3_beg = function ()
  
    ObjDelete( "obj_drawers_use_button_2_3" );
  
  end;
  local use_button_2_3_end = function ()

    ObjSet( "obj_drawers_box_3", { input = true, alp = 1 } );
    ObjDelete( "spr_drawers_button_3" );
    ObjSet( "spr_base_drawers_box_3", { alp = 1 } );
    ObjSet( "spr_drawers_box_3_shadow", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_2_3", use_button_2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_3", use_button_2_3_inv );
  cmn.AddSubscriber( "use_button_2_3", use_button_2_3_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_3_inv", use_button_2_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_3_beg", use_button_2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_3_end", use_button_2_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elevatorboard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elevatorboard" ] = {
    type = "use",
    inv_obj = "inv_elevatorboard",
    use_place = "obj_elevator_use_elevatorboard",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_base_elevator"
  };
  local use_elevatorboard_inv = function ()
  
    interface.InventoryItemRemove( "inv_elevatorboard" );
  
  end;
  local use_elevatorboard_beg = function ()
  
    ObjDelete( "obj_elevator_use_elevatorboard" );
  
  end;
  local use_elevatorboard_end = function ()
  
    ObjSet( "obj_elevator_clk_elevator_button", { input = true } );
    ObjSet( "anm_elevator_plate", { frame = 102 } );
    ObjDelete( "spr_elevator_button_add_1" )
    ObjDelete( "spr_base_elevator_shine_1" );
    ObjSet( "spr_elevator_button_add_2", { alp = 1 } );
    ObjSet( "spr_base_elevator_card_2", { alp = 1 });
    ObjSet( "spr_base_elevator_shine_2", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elevatorboard", use_elevatorboard_beg, private.room_objname );
  cmn.AddSubscriber( "use_elevatorboard", use_elevatorboard_inv );
  cmn.AddSubscriber( "use_elevatorboard", use_elevatorboard_end, private.room_objname );
  cmn.AddSubscriber( "use_elevatorboard_inv", use_elevatorboard_inv, private.room_objname );
  cmn.AddSubscriber( "use_elevatorboard_beg", use_elevatorboard_beg, private.room_objname );
  cmn.AddSubscriber( "use_elevatorboard_end", use_elevatorboard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_base_leaving () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_base_leaving" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_base_leaving",
    
  };
  local vid_base_leaving_end = function ()
  
    ObjDelete( "anm_base_leaving" );
    ObjSet( "obj_base_elevator", { alp = 1 } ); 
    ObjSet( "obj_base_stuff", { alp = 1 } ); 
    ObjSet( "gho_base_avengersstuff", { input = true, active = true, alp = 1 } ); 
   
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_base_leaving", vid_base_leaving_end, private.room_objname  );
  cmn.AddSubscriber( "vid_base_leaving_end", vid_base_leaving_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_brokencard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_brokencard" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_elevator_clk_card",
    zz = "zz_elevator",
    zz_gate = "gzz_base_elevator"
    
  };
  local clk_brokencard = function ()
  
    ObjDelete( "anm_elevator_sparkls" )
    ObjDelete( "anm_elevator_plate_broken" )
    ObjDelete( "obj_elevator_clk_card" )
    ObjDelete( "spr_base_elevator_card_1" )
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_brokencard", clk_brokencard, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_elevator_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_elevator_button" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_elevator_clk_elevator_button",
    zz = "zz_elevator",
    zz_gate = "gzz_base_elevator"
    
  };
  local clk_elevator_button = function ()
  
    ObjDelete( "obj_elevator_clk_elevator_button" )
    ObjDelete( "gzz_base_elevator" );
    ObjSet( "grm_base_groundfloor", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_base_groundfloor_focus");
    end;
    ObjDelete( "anm_base_door" );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_elevator_button", clk_elevator_button, private.room_objname  );
    --------------------------------------------------------------------------------------------
  -- function win_avengersstuff () end;
  --------------------------------------------------------------------------------------------
  local win_avengersstuff_loc = function ()
  
    if cmn.IsEventDone( "win_avengersstuff" ) then
      
      ObjDelete( "gho_base_avengersstuff" );
      
    end;
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_avengersstuff", win_avengersstuff_loc, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_symbol" );  
  subroom.Define( "zz_elevator" );
  
  function zz_symbol.PreOpen()
    
    if not common_impl.base then

       common_impl.base = {}
       common_impl.base.note = "close";

      end;
    
  end;
  
  function zz_symbol.Close()
    
    common_impl.base.note = "close";
    
     ObjSet( "spr_symbol_note_big", { input = false, alp = 0 } );
     ObjSet( "spr_symbol_note",     { alp = 1 } );
    
  end;
   
   
   
  ------------------------------------------------------------------------------   
  function zz_elevator.PreOpen()
    
    if not cmn.IsEventDone( "clk_brokencard" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level2/aud_elevator_broken_env", 1, "", 0 );
      
    end;
    
  end;
  ------------------------------------------------------------------------------
  function zz_elevator.Close()
    
    if not cmn.IsEventDone( "clk_brokencard" ) then
      
      common_impl.StopAudio( "env", "common/audio/level2/aud_elevator_broken_env", 0 );
      
    end;
    
    if cmn.IsEventDone( "clk_elevator_button" ) then
    
      interface.Lock( true, 3 )
      AnimPlay( "anm_base_door", "DoAnim", function() cmn.CallEventHandler( "clk_elevator_button" ) end );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_elevator", 0, "", 0 );
      
    end;
    
  end;
  
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_base();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_base_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "vid_base_leaving" ) then

    
    --ObjSet( "rm_base", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjSet( "tmr_base_leaving",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_base_leaving(); end
    } );

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ruby()

  local item = "inv_ruby";

  if ( common.ApplyObj( item, "obj_symbol_use_ruby", true ) ) then

    cmn.CallEventHandler( "use_ruby_inv" );
    cmn.CallEventHandler( "use_ruby_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ruby" );
      cmn.CallEventHandler( "use_ruby_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_ruby_symbol", 0, "", 0 );
  
    ObjAnimate( "spr_symbol_ruby", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    AnimPlay( "anm_symbol_door", "DoAnim", func_after )
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_base_symbol", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_symbol", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_2_1()

  local item = "inv_button_2_1";

  if ( common.ApplyObj( item, "obj_drawers_use_button_2_1", true ) ) then

    cmn.CallEventHandler( "use_button_2_1_inv" );
    cmn.CallEventHandler( "use_button_2_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_2_1" );
      cmn.CallEventHandler( "use_button_2_1_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_button_drawers", 0, "", 0 );
  
    ObjAnimate( "spr_drawers_button_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );  
    ObjAnimate( "obj_drawers_box_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0,
      0.8, 3, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_base_drawers", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawers", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_2_2()

  local item = "inv_button_2_2";

    if ( common.ApplyObj( item, "obj_drawers_use_button_2_2", true ) ) then

      cmn.CallEventHandler( "use_button_2_2_inv" );
      cmn.CallEventHandler( "use_button_2_2_beg" );

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_button_2_2" );
        cmn.CallEventHandler( "use_button_2_2_end" );
      --common.CloseSubRoom();;
      
    end;

    common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_button_drawers", 0, "", 0 );

    ObjAnimate( "spr_drawers_button_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );  
    ObjAnimate( "obj_drawers_box_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0,
      0.8, 3, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_base_drawers", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawers", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_2_3()

  local item = "inv_button_2_3";

  if ( common.ApplyObj( item, "obj_drawers_use_button_2_3", true ) ) then

    cmn.CallEventHandler( "use_button_2_3_inv" );
    cmn.CallEventHandler( "use_button_2_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_2_3" );
      cmn.CallEventHandler( "use_button_2_3_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_button_drawers", 0, "", 0 );

    ObjAnimate( "spr_drawers_button_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );  
    ObjAnimate( "obj_drawers_box_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0,
      0.8, 3, 1.0
    } );
    ObjAnimate( "spr_drawers_box_3_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0,
      0.8, 3, 1.0
    } );
    
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_base_drawers", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawers", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elevatorboard()

  local item = "inv_elevatorboard";

  if ( common.ApplyObj( item, "obj_elevator_use_elevatorboard", true ) and cmn.IsEventDone( "clk_brokencard" ) ) then

    cmn.CallEventHandler( "use_elevatorboard_inv" );
    cmn.CallEventHandler( "use_elevatorboard_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elevatorboard" );
      cmn.CallEventHandler( "use_elevatorboard_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_elevatorboard_elevator", 0, "", 0 );
    
    AnimPlay( "anm_elevator_plate", "DoAnim", "" )
    ObjAnimate( "spr_elevator_button_add_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.6, 0, 1.0,  
      0.9, 0, 0.0
    } ); 
    ObjAnimate( "spr_elevator_button_add_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.6, 0, 0.0,  
      0.9, 0, 1.0
    } );
    
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_base_elevator", false ) and cmn.IsEventDone( "clk_brokencard" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_elevator", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_emblem()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_emblem" );
  cmn.CallEventHandler( "get_emblem" );

end;
--------------------------------------------------------------------------------------------
function private.get_boardpart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_boardpart" );
  cmn.CallEventHandler( "get_boardpart" );

end;
--------------------------------------------------------------------------------------------
function private.get_badgeelement_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_badgeelement_2_2" );
  cmn.CallEventHandler( "get_badgeelement_2_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_trihedron()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_trihedron" );
  cmn.CallEventHandler( "get_trihedron" );
  
  if common_impl.IsGetCollect( "get_collect_2_2_1" ) then
    
   common.CloseSubRoom();
  
  end;
end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_2_1()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_1");
    cmn.CallEventHandler("get_collect_2_2_1");

    if cmn.IsEventDone( "get_trihedron" ) then
      
      common.CloseSubRoom();
      
    end;    

  end;

  common_impl.PlayEffectHO( "spr_drawers_collect_2", func_after ); 

end;
-----------------------------------------------------------------------------------------
function private.get_collect_2_2_2()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_2");
    cmn.CallEventHandler("get_collect_2_2_2");
 
  end;

  common_impl.PlayEffectHO( "spr_symbol_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_elevator_button()

  --common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  local func_after = function()
  
    cmn.SetEventDone( "clk_elevator_button" );
    common_impl.Lock( false );
    common.CloseSubRoom();
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_elevatorboard_elevator", 0, "", 0 );

  ObjAnimate("spr_elevator_button", "pos_x", 0, 0, func_after,
  { 
  0.0, 0, 17,
  0.2, 0, 20, 
  0.4, 3, 17
  });

end;
--------------------------------------------------------------------------------------------
function private.clk_brokencard()

  --common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  local func_after = function()
  
    cmn.SetEventDone( "clk_brokencard" );
    cmn.CallEventHandler( "clk_brokencard" );
    common_impl.Lock( false );
    
  end;
 
      
  common_impl.StopAudio( "env", "common/audio/level2/aud_elevator_broken_env", 0.5 );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_plate_elevator", 0, "", 0 );
  
  common_impl.Lock( true );
  ObjAnimate("anm_elevator_plate_broken", "alp", 0, 0, "",
  { 
  0.0, 0, 1, 
  0.3, 3, 0
  });
  AnimPlay( "anm_elevator_sparkls", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function private.clk_door_symbol()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.ShowBbt( 'bbt_symbol_use_ruby' );
  
  common_impl.Lock( true );
  func_after();
  --ObjAnimate( "spr_symbol_door", "pos_y", 0, 0, , { 0,0,182, 0.2,0,183, 0.4,0,182 } );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_base()

  if not ( cmn.IsEventDone( "opn_base" ) ) then
    cmn.SetEventDone( "opn_base" );
  end;
  
  cmn.CallEventHandler( "opn_base" ); 

end;
--*********************************************************************************************************************
function private.vid_base_leaving()

  local func_after = function ( skip )

    common_impl.Lock( false );
    cmn.SetEventDone( "vid_base_leaving" );
    cmn.CallEventHandler( "vid_base_leaving_end" );
    common_impl.ShowBbt( 'bbt_vid_base_leaving', 1 );
    interface.KeyTaskAdd('seize_avenger', true);
  
    if skip then

      --common_impl.StopAudio( "sfx", "common/audio/level2/aud_avengers_runs_elevator", 0.2 );
      --common_impl.StopAudio( "voc", "common/audio/level1/aud_base_leaving_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger2_mus", 0, "", 0 );
    common_impl.SetSoundTimer( 39, "mus", "common/audio/aud_danger2_mus" );

  end;

  common_impl.Lock( true );
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_avengers_runs_elevator", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "common/audio/level1/aud_base_leaving_voc", 0, "", 0 );
  AnimPlay( "anm_base_leaving", "DoAnim", func_after )
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_symbol_light", "alp", 1 ,0, "", { 0,0,1, 1.5,0,0.5, 3,0,1 } );
