-- name=rm_garage
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_garage";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_muffler", "room_hub" );
  ObjAttach( "zz_cabinet_2", "room_hub" );
  ObjAttach( "zz_ceilingcabinet", "room_hub" );
  ObjAttach( "zz_auto", "room_hub" );
  private.Init_Subroom();
  local table_multiset = {};
  private.dis_win = { 1, 6, 4, 7, 3, 5, 8, 2 };
  private.dis_start = { 4, 7, 1, 6, 3, 5, 8, 2 };
  private.dis_current = 
  {
  { 0, 0, 0, 0, 0, 0, 0, 0 },
  { 4, 7, 1, 6, 3, 5, 8, 2 },
  --{ 2, 8, 4, 7, 5, 3, 6, 1 },
  { 0, 0, 0, 0, 0, 0, 0, 0 }
  };
  private.up = false;
  private.down = false;
  private.left = false;
  private.right = false;
  
  private.coord_mas = 
  {
  { { -171,-52 }, { -119,-52 }, { -69,-52 }, { -18,-52 }, { 33,-52 }, {84, -52}, {134, -52}, {184, -52}},
  { { -171, -9 }, { -119, -9 }, { -69, -9 }, { -18, -9 }, { 33, -9 }, {84, -9 }, {134, -9 }, {184, -9 }},
  { { -171, 34 }, { -119, 34 }, { -69, 34 }, { -18, 34 }, { 33, 34 }, {84, 34 }, {134, 34 }, {184,  34}}
  };
  
  for i = 1, 8 do
    
      table.insert( table_multiset, { "spr_muffler_mmg_button_"..i, { 
      event_mdown = function()  private.FirstClk( i ) end,
      event_menter = function() private.ButtonMouseEnter( i ) end, 
      event_mleave = function() private.ButtonMouseLeave( i ) end;
      } } );

  end;
    
  for i = 1, 3 do
    
    for j = 1, 8 do
      
      table.insert( table_multiset, { "obj_muffler_clk_"..i.."_"..j, { 
      event_mdown = function()  private.SecondClk( i, j ) end; 
      --event_menter = function() private.ButtonMouseEnter( i ) end, 
      --event_mleave = function() private.ButtonMouseLeave( i ) end;
      } } );
      
    end;
    
  end;
  ObjMultiSet( table_multiset );
  ObjMultiSet({ 
  { "spr_muffler_masterswitch", { event_mdown = private.get_masterswitch }},
  { "spr_muffler_navigator", { event_mdown = private.get_navigator }},
  { "spr_muffler_ignitionkey", { event_mdown = private.get_ignitionkey }},
  { "spr_cabinet_2_repairamulet", { event_mdown = private.get_repairamulet }},
  { "spr_ceilingcabinet_fuse_2_1", { event_mdown = private.get_fuse_2_1 }},
  { "spr_ceilingcabinet_hacksaw", { event_mdown = private.get_hacksaw }},
  { "spr_ceilingcabinet_corkscrew", { event_mdown = private.get_corkscrew }},
  { "spr_auto_fuse_2_2", { event_mdown = private.get_fuse_2_2 }},
  { "spr_auto_nightsymbolelement_1", { event_mdown = private.get_nightsymbolelement_1 }},
  { "obj_garage_dlg_saved",       { event_mdown = private.dlg_garage_saved }},
  { "obj_garage_dlg_saved_focus",       { event_mdown = private.dlg_garage_saved }},
  { "obj_auto_use_carhandle", { event_mdown = private.clk_door_auto }},
  { "obj_ceilingcabinet_use_hairpin", { event_mdown = private.clk_ceilingcabinet_door }},
  { "obj_ceilingcabinet_use_repairamulet", { event_mdown = private.clk_ceilingcabinet_box }},
  { "obj_auto_clk_car_door", { event_mdown = private.clk_carhandle }},
  { "obj_garage_clk_instruments", { event_mdown = private.clk_instruments }},
  { "obj_cabinet_2_use_hacksaw", { event_mdown = private.clk_cabinet_door }},
  { "obj_auto_clk_ignitionkey", { event_mdown = private.clk_keyignite}},
  { "obj_garage_clk_masterswitch", { event_mdown = private.clk_masterswitch }},
  { "spr_garage_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_auto_clk_niwtyaki", { event_mdown = private.clk_niwtyaki }},
  { "spr_garage_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_muffler_collect_2", { event_mdown = function () private.get_collect_2_2_8(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_garage = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_garage_",
    "gzz_garage_muffler",
    "gzz_garage_cabinet_2",
    "gzz_garage_ceilingcabinet",
    "gzz_garage_auto",
    "gho_garage_cabinethos"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_muffler",
    "zz_cabinet_2",
    "zz_ceilingcabinet",
    "zz_auto"  
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_garage", update_game_mode_garage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_garage = function ()

  local effects_table = 
  {
    "obj_garage_anim",
    "spr_cabinet_2_light",
    "spr_auto_light_add_2",
    "spr_auto_light_add",
    "spr_garage_light",
    "anm_garage_mouse",
    --"anm_garage_instruments",
    "anm_garage_mouse_run",
    "spr_muffler_light_add",
    "spr_ceilingcabinet_light_add"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_garage", update_performance_mode_garage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_garage () end;
  --------------------------------------------------------------------------------------------
  local opn_garage_map = function ()

    common_impl.VisitMapRoom( "garage" );

  end;
  cmn.AddSubscriber( "opn_garage", opn_garage_map );
  --------------------------------------------------------------------------------------------
  -- function get_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_masterswitch" ] = {
    type = "get",
    get_obj = "spr_muffler_masterswitch",
    room = private.room_objname,
    zz = "zz_muffler",
    zz_gate = "gzz_garage_muffler"
  };
    
  local get_masterswitch_inv = function ()
  
    interface.InventoryItemAdd( "inv_masterswitch", "spr_muffler_masterswitch" );
  
  end;
  
  local get_masterswitch_closezz = function ()
  
    ObjDelete( "gfx_muffler_masterswitch" );
    ObjDelete( "spr_garage_muffler_lever" );
    ObjDelete("spr_muffler_masterswitch_shadow");
    --ObjDelete( "gzz_garage_muffler" );
  
  end;
  
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_inv );
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_navigator () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_navigator" ] = {
    type = "get",
    get_obj = "spr_muffler_navigator",
    room = private.room_objname,
    zz = "zz_muffler",
    zz_gate = "gzz_garage_muffler"
  };
    
  local get_navigator_inv = function ()
  
  --interface.InventoryItemAdd( "inv_navigator", "spr_muffler_navigator" );
    ObjSet( "obj_int_button_map_button", { input = true } );
    ObjSet( "spr_int_button_map_button", { alp = 1 } );
    
  end;
  
  local get_navigator_closezz = function ()
  
    ObjDelete( "gfx_muffler_navigator" );
    ObjDelete("spr_muffler_navigator_shadow");
    ----ObjDelete("spr_garage_muffler_phone");
    ----ObjDelete( "gzz_garage_muffler" );
  
  end;
  
  cmn.AddSubscriber( "get_navigator", get_navigator_inv );
  cmn.AddSubscriber( "get_navigator_inv", get_navigator_inv );
  cmn.AddSubscriber( "get_navigator", get_navigator_closezz, private.room_objname );
  cmn.AddSubscriber( "get_navigator_closezz", get_navigator_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ignitionkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ignitionkey" ] = {
    type = "get",
    get_obj = "spr_muffler_ignitionkey",
    room = private.room_objname,
    zz = "zz_muffler",
    zz_gate = "gzz_garage_muffler"
  };
    
  local get_ignitionkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_ignitionkey", "spr_muffler_ignitionkey" );
  
  end;
  
  local get_ignitionkey_closezz = function ()
  
    ObjDelete( "gfx_muffler_ignitionkey" );
    ObjDelete("spr_muffler_key_shadow");
    ObjDelete("spr_garage_muffler_key");
    --ObjDelete( "gzz_garage_muffler" );
    if common_impl.IsGetCollect( "get_collect_2_2_8" ) then
      
      ObjDelete( "gzz_garage_muffler");
    
    end;
    
  end;
  
  cmn.AddSubscriber( "get_ignitionkey", get_ignitionkey_inv );
  cmn.AddSubscriber( "get_ignitionkey", get_ignitionkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_repairamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_repairamulet" ] = {
    type = "get",
    get_obj = "spr_cabinet_2_repairamulet",
    room = private.room_objname,
    zz = "zz_cabinet_2",
    zz_gate = "gzz_garage_cabinet_2"
  };
    
  local get_repairamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_repairamulet", "spr_cabinet_2_repairamulet" );
  
  end;
  
  local get_repairamulet_closezz = function ()
  
    ObjDelete( "gfx_cabinet_2_repairamulet" );
    ObjDelete( "spr_cabinet_2_repairamulet_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_repairamulet", get_repairamulet_inv );
  cmn.AddSubscriber( "get_repairamulet", get_repairamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuse_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fuse_2_1" ] = {
    type = "get",
    get_obj = "spr_ceilingcabinet_fuse_2_1",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_garage_ceilingcabinet"
  };
    
  local get_fuse_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuse_2_1", "spr_ceilingcabinet_fuse_2_1" );
  
  end;
  
  local get_fuse_2_1_closezz = function ()
  
    ObjDelete( "gfx_ceilingcabinet_fuse_2_1" );
    ObjDelete( "obj_ceilingcabinet_fuse" );
    --ObjDelete( "gzz_garage_ceilingcabinet" );
     if ( cmn.IsEventDone("get_hacksaw") and cmn.IsEventDone("get_corkscrew")) then
    
       ObjDelete( "gzz_garage_ceilingcabinet" );
       
     end;
  
  end;
  
  cmn.AddSubscriber( "get_fuse_2_1", get_fuse_2_1_inv );
  cmn.AddSubscriber( "get_fuse_2_1", get_fuse_2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hacksaw" ] = {
    type = "get",
    get_obj = "spr_ceilingcabinet_hacksaw",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_garage_ceilingcabinet"
  };
    
  local get_hacksaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_hacksaw", "spr_ceilingcabinet_hacksaw" );
  
  end;
  
  local get_hacksaw_closezz = function ()
  
    ObjDelete( "gfx_ceilingcabinet_hacksaw" );
    ObjDelete("obj_ceilingcabinet_hacksaw");
    ObjDelete( "spr_garage_ceilingcabinet_saw" );
    --ObjDelete( "gzz_garage_ceilingcabinet" );
     if ( cmn.IsEventDone("get_corkscrew") and cmn.IsEventDone("get_fuse_2_1")) then
    
       ObjDelete( "gzz_garage_ceilingcabinet" );
       
     end;
  
  
  end;
  
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_inv );
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_corkscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_corkscrew" ] = {
    type = "get",
    get_obj = "spr_ceilingcabinet_corkscrew",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_garage_ceilingcabinet"
  };
    
  local get_corkscrew_inv = function ()
  
    interface.InventoryItemAdd( "inv_corkscrew", "spr_ceilingcabinet_corkscrew" );
  
  end;
  
  local get_corkscrew_closezz = function ()
  
    ObjDelete( "gfx_ceilingcabinet_corkscrew" );
    ObjDelete( "obj_ceilingcabinet_screw" );
    
    --ObjDelete( "gzz_garage_ceilingcabinet" );
     if ( cmn.IsEventDone("get_hacksaw") and cmn.IsEventDone("get_fuse_2_1")) then
    
       ObjDelete( "gzz_garage_ceilingcabinet" );
       
     end;
  end;
  
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_inv );
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuse_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fuse_2_2" ] = {
    type = "get",
    get_obj = "spr_auto_fuse_2_2",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
    
  local get_fuse_2_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuse_2_2", "spr_auto_fuse_2_2" );
  
  end;
  
  local get_fuse_2_2_closezz = function ()
  
    ObjDelete( "gfx_auto_fuse_2_2" );
    --ObjDelete( "gzz_garage_auto" );
    ObjSet( "obj_auto_clk_niwtyaki", {input = true} );
    
  end;
  
  cmn.AddSubscriber( "get_fuse_2_2", get_fuse_2_2_inv );
  cmn.AddSubscriber( "get_fuse_2_2", get_fuse_2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nightsymbolelement_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nightsymbolelement_1" ] = {
    type = "get",
    get_obj = "spr_auto_nightsymbolelement_1",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
    
  local get_nightsymbolelement_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_nightsymbolelement_1", "spr_auto_nightsymbolelement_1" );
    ObjSet( "spr_brokennightsymbol_plus_light", { alp = 1 });
  end;
  
  local get_nightsymbolelement_1_closezz = function ()
  
    ObjDelete( "gfx_auto_nightsymbolelement_1" );
    ObjDelete( "spr_auto_nightsymbol_shadow" );
    --ObjDelete( "gzz_garage_auto" );
  
  end;
  
  cmn.AddSubscriber( "get_nightsymbolelement_1", get_nightsymbolelement_1_inv );
  cmn.AddSubscriber( "get_nightsymbolelement_1", get_nightsymbolelement_1_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_1 = function ()
  
    ObjDelete( "obj_garage_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_1", get_collect_morph_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_1 = function ()
  
    ObjDelete( "obj_garage_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_1", get_collect_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_8 = function ()
 
    ObjDelete( "spr_muffler_collect_2" );

    if cmn.IsEventDone( "get_ignitionkey" ) then
      ObjDelete( "gzz_garage_muffler" );
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_8", get_collect_2_2_8, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_fuse_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuse_2_1" ] = {
    type = "use",
    inv_obj = "inv_fuse_2_1",
    use_place = "obj_muffler_use_fuse_2_1",
    room = private.room_objname,
    zz = "zz_muffler",
    zz_gate = "gzz_garage_muffler"
  };
  local use_fuse_2_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuse_2_1" );
  
  end;
  local use_fuse_2_1_beg = function ()
  
    ObjDelete( "obj_muffler_use_fuse_2_1" );
  
  end;
  local use_fuse_2_1_end = function ()
  
    ObjSet( "spr_muffler_fuse_1", { alp = 1 });
    ObjSet( "spr_muffler_light_green_1", { alp = 1 });
    ObjDelete( "spr_muffler_light_red_1" );
    ObjDelete( "spr_garage_muffler_red_light_2");
    ObjSet( "spr_garage_muffler_green_light_2", { alp = 1 });
    ObjSet("spr_garage_muffler_fuse_1", { alp = 1 });
    
    if cmn.IsEventDone( "use_fuse_2_2" ) then 
      
      ObjSet( "obj_muffler_mmg", { alp = 1, input = true });
      ObjDelete( "spr_muffler_cap_close" );
      ObjSet( "spr_muffler_cap_open_code", { alp = 1});
      
    end;  
    --ObjSet( "spr_muffler_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuse_2_1", use_fuse_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_1", use_fuse_2_1_inv );
  cmn.AddSubscriber( "use_fuse_2_1", use_fuse_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_1_inv", use_fuse_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_1_beg", use_fuse_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_1_end", use_fuse_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fuse_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuse_2_2" ] = {
    type = "use",
    inv_obj = "inv_fuse_2_2",
    use_place = "obj_muffler_use_fuse_2_2",
    room = private.room_objname,
    zz = "zz_muffler",
    zz_gate = "gzz_garage_muffler"
  };
  local use_fuse_2_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuse_2_2" );
  
  end;
  local use_fuse_2_2_beg = function ()
  
    ObjDelete( "obj_muffler_use_fuse_2_2" );
  
  end;
  local use_fuse_2_2_end = function ()
  
    ObjSet( "spr_muffler_fuse_2", { alp = 1 });
    ObjSet( "spr_muffler_light_green_2", { alp = 1 });
    
    ObjDelete( "spr_muffler_light_red_2" );
    ObjDelete( "spr_garage_muffler_red_light_1");
    ObjSet( "spr_garage_muffler_green_light_1", { alp = 1 });
    ObjSet("spr_garage_muffler_fuse_2", { alp = 1 });
    
    if cmn.IsEventDone( "use_fuse_2_1" ) then 
      
      ObjSet( "obj_muffler_mmg", { alp = 1, input = true });
      ObjSet("spr_garage_muffler_fuse", { alp = 1 });
      ObjDelete( "spr_muffler_cap_close" );
      ObjSet( "spr_muffler_cap_open_code",{ alp = 1} );
      
    end;  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuse_2_2", use_fuse_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_2", use_fuse_2_2_inv );
  cmn.AddSubscriber( "use_fuse_2_2", use_fuse_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_2_inv", use_fuse_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_2_beg", use_fuse_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_2_end", use_fuse_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_2_1" ] = {
    type = "use",
    inv_obj = "inv_elf_2_1",
    use_place = "obj_cabinet_2_use_elf_2_1",
    room = private.room_objname,
    zz = "zz_cabinet_2",
    zz_gate = "gzz_garage_cabinet_2"
  };
  local use_elf_2_1_inv = function ()
  
  end;
  local use_elf_2_1_beg = function ()
  
    ObjDelete( "obj_cabinet_2_use_elf_2_1" );
  
  end;
  local use_elf_2_1_end = function ()
    
    ObjSet( "spr_cabinet_2_repairamulet", { input = true, active = true, alp = 1 } );
    ObjDelete( "vid_cabinet_2_use_elf" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_2_1", use_elf_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_1", use_elf_2_1_inv );
  cmn.AddSubscriber( "use_elf_2_1", use_elf_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_1_inv", use_elf_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_1_beg", use_elf_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_1_end", use_elf_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hacksaw" ] = {
    type = "use",
    inv_obj = "inv_hacksaw",
    use_place = "obj_cabinet_2_use_hacksaw",
    room = private.room_objname,
    zz = "zz_cabinet_2",
    zz_gate = "gzz_garage_cabinet_2"
  };
  local use_hacksaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksaw" );
  
  end;
  local use_hacksaw_beg = function ()
  
    ObjDelete( "obj_cabinet_2_use_hacksaw" );
  
  end;
  local use_hacksaw_end = function ()
  
    ObjDelete( "gzz_garage_cabinet_2" );
    ObjSet( "spr_cabinet_2_open", { alp = 1 } );
    ObjSet( "spr_cabinet_2_chain_2", { alp = 1 } );
    ObjSet( "spr_garage_chain_2", { alp = 1 } );
    ObjSet( "gho_garage_cabinethos", { active = true, input = true, alp = 1 } );
    ObjDelete("spr_garage_cabinet_2_circ");
    ObjSet( "spr_garage_cabinet_2_ho", { alp = 1 });
    ObjDelete( "obj_cabinet_2_door_close");
    ObjDelete( "anm_cabinet_2_door");
    ObjDelete( "anm_cabinet_2_use_saw");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_inv );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_inv", use_hacksaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_beg", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_end", use_hacksaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hairpin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hairpin" ] = {
    type = "use",
    inv_obj = "inv_hairpin",
    use_place = "obj_ceilingcabinet_use_hairpin",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_garage_ceilingcabinet"
  };
  local use_hairpin_inv = function ()
  
    interface.InventoryItemRemove( "inv_hairpin" );
  
  end;
  local use_hairpin_beg = function ()
  
    ObjDelete( "obj_ceilingcabinet_use_hairpin" );
  
  end;
  local use_hairpin_end = function ()
  
     ObjDelete( "obj_ceilingcabinet_door_close" );
     ObjSet( "obj_ceilingcabinet_door_open", { alp = 1 });
     ObjSet( "obj_ceilingcabinet_use_repairamulet", { input = true } );
     ObjSet( "spr_garage_ceilingcabinet_box_close", { alp = 1 });
     ObjSet( "spr_garage_ceilingcabinet_open_door_2", { alp = 1});
     ObjSet( "spr_garage_ceilingcabinet_open_door_1", { alp = 1});
     ObjDelete( "anm_ceilingcabinet_use_hairpin");
     ObjSet( "spr_ceilingcabinet_box_over_1", { alp = 1 });
     ObjSet( "spr_ceilingcabinet_box_close", { alp = 1 });
    --ObjSet( "spr_ceilingcabinet_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hairpin", use_hairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin", use_hairpin_inv );
  cmn.AddSubscriber( "use_hairpin", use_hairpin_end, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_inv", use_hairpin_inv, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_beg", use_hairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_end", use_hairpin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_repairamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_repairamulet" ] = {
    type = "use",
    inv_obj = "inv_repairamulet",
    use_place = "obj_ceilingcabinet_use_repairamulet",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_garage_ceilingcabinet"
  };
  local use_repairamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_repairamulet" );
  
  end;
  local use_repairamulet_beg = function ()
  
    ObjDelete( "obj_ceilingcabinet_use_repairamulet" );
  
  end;
  local use_repairamulet_end = function ()
  
    ObjDelete( "spr_ceilingcabinet_box_close" );
    ObjDelete( "spr_garage_ceilingcabinet_box_close" );
    ObjSet( "spr_ceilingcabinet_box_over", { alp = 1 });
    ObjDelete("spr_ceilingcabinet_close_over");
   
    ObjMultiSet({ 
    { "obj_ceilingcabinet_screw", { input = true }},
    { "obj_ceilingcabinet_fuse", { input = true }},
    { "obj_ceilingcabinet_hacksaw", { input = true }},
    { "spr_ceilingcabinet_fuse_2_1", { active = true }},
    { "spr_ceilingcabinet_hacksaw", { active = true }},
    { "spr_ceilingcabinet_corkscrew", { active = true }},
    { "spr_garage_ceilingcabinet_saw", { alp = 1}},
    { "spr_garage_ceilingcabinet_box_open", { alp = 1}}
    
    });
    --ObjSet( "spr_ceilingcabinet_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_repairamulet", use_repairamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_repairamulet", use_repairamulet_inv );
  cmn.AddSubscriber( "use_repairamulet", use_repairamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_repairamulet_inv", use_repairamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_repairamulet_beg", use_repairamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_repairamulet_end", use_repairamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ignitionkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ignitionkey" ] = {
    type = "use",
    inv_obj = "inv_ignitionkey",
    use_place = "obj_auto_use_ignitionkey",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
  local use_ignitionkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_ignitionkey" );
  
  end;
  local use_ignitionkey_beg = function ()
  
    ObjDelete( "obj_auto_use_ignitionkey" );
  
  end;
  local use_ignitionkey_end = function ()
  
  --ObjSet( "spr_auto_key", { alp = 1 } );
   ObjSet( "obj_auto_clk_ignitionkey", { input = true, active = true });
   ObjSet("anm_auto_key_2", { alp = 1 });
   ObjDelete( "anm_auto_key");

  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ignitionkey", use_ignitionkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_ignitionkey", use_ignitionkey_inv );
  cmn.AddSubscriber( "use_ignitionkey", use_ignitionkey_end, private.room_objname );
  cmn.AddSubscriber( "use_ignitionkey_inv", use_ignitionkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_ignitionkey_beg", use_ignitionkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_ignitionkey_end", use_ignitionkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carhandle" ] = {
    type = "use",
    inv_obj = "inv_carhandle",
    use_place = "obj_auto_use_carhandle",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
  local use_carhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_carhandle" );
  
  end;
  local use_carhandle_beg = function ()
  
    ObjDelete( "obj_auto_use_carhandle" );
  
  end;
  local use_carhandle_end = function ()
  
    ObjSet( "spr_garage_auto_handle", { alp = 1 });
    ObjSet( "obj_auto_clk_car_door", { active = true, input = true });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carhandle", use_carhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carhandle", use_carhandle_inv );
  cmn.AddSubscriber( "use_carhandle", use_carhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_carhandle_inv", use_carhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_carhandle_beg", use_carhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carhandle_end", use_carhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_masterswitch" ] = {
    type = "use",
    inv_obj = "inv_masterswitch",
    use_place = "obj_garage_use_masterswitch",
    room = private.room_objname 
  };
  local use_masterswitch_inv = function ()
  
    interface.InventoryItemRemove( "inv_masterswitch" );
  
  end;
  local use_masterswitch_beg = function ()
  
    ObjDelete( "obj_garage_use_masterswitch" );
   
  
  end;
  local use_masterswitch_end = function ()
  
    ObjSet( "obj_garage_clk_masterswitch", { input = true });
    ObjSet( "spr_garage_masterswitch_up", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_inv );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_end, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_inv", use_masterswitch_inv, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_beg", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_end", use_masterswitch_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_carhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carhandle" ] = {
    type = "click",
    use_place = "obj_auto_clk_car_door",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
  local clk_carhandle_beg = function ()
  
    ObjDelete( "obj_auto_clk_car_door" );
  
  end;
  
  local clk_carhandle_end = function ()
  
    ObjSet( "obj_auto_use_ignitionkey", { input = true, active = true });
    ObjSet( "spr_auto_fuse_2_2", { input = true, active = true });
    ObjSet( "spr_auto_nightsymbolelement_1", { input = true, active = true });
    ObjSet( "spr_garage_auto_open", { alp = 1 });
    ObjDelete( "spr_auto_door" );
    ObjDelete( "spr_auto_light_add");
    ObjDelete("spr_garage_auto_handle");
    ObjDelete("spr_garage_auto_close");
    ObjDelete( "anm_auto_grip");
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_carhandle", clk_carhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carhandle", clk_carhandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_carhandle_beg", clk_carhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carhandle_end", clk_carhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_instruments() end;
  --------------------------------------------------------------------------------------------
  local clk_instruments_end = function ()
  
    ObjDelete("anm_garage_instruments");
    ObjDelete( "obj_garage_clk_instruments");
      
  end;
  --------------------------------------------------------------------------------------------
   cmn.AddSubscriber( "clk_instruments", clk_instruments_end, private.room_objname );
   cmn.AddSubscriber( "clk_instruments_end", clk_instruments_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_ignitionkey() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ignitionkey" ] = {
    type = "click",
    use_place = "obj_auto_clk_ignitionkey",
    room = private.room_objname,
    zz = "zz_auto",
    zz_gate = "gzz_garage_auto"
  };
  local clk_ignitionkey_beg = function ()
  
    ObjDelete( "obj_auto_clk_ignitionkey" );
  
  end;
  
  local clk_ignitionkey_end = function ()
  
       ObjDelete("gzz_garage_auto");
       ObjDelete( "spr_garage_auto");
       ObjDelete("spr_garage_auto_car");
       --ObjDelete( "anm_auto_key_2");
   
  end;
     
  local clk_ignitionkey_map = function ()
  
    common_impl.LockMapRoom( "garage", true );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ignitionkey", clk_ignitionkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ignitionkey", clk_ignitionkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_ignitionkey", clk_ignitionkey_map );
  cmn.AddSubscriber( "clk_ignitionkey_beg", clk_ignitionkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ignitionkey_end", clk_ignitionkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_ignitionkey_map", clk_ignitionkey_map );

  --------------------------------------------------------------------------------------------
  -- function clk_niwtyaki() end;
  --------------------------------------------------------------------------------------------
  local clk_niwtyaki_beg = function ()
  
    ObjDelete( "obj_auto_clk_niwtyaki" );
  
  end;
  local clk_niwtyaki_end = function ()
  
    ObjSet( "spr_auto_niwtyaki", { alp = 1 } );
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_niwtyaki", clk_niwtyaki_beg, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki", clk_niwtyaki_end, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki_beg", clk_niwtyaki_beg, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki_end", clk_niwtyaki_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_masterswitch" ] = {
    type = "click",
    use_place = "obj_garage_clk_masterswitch",
    room = private.room_objname 
  };
  local clk_masterswitch_beg = function ()
  
    ObjDelete( "obj_garage_clk_masterswitch" );
  
  end;
  local clk_masterswitch_end = function ()
  
    ObjDelete( "spr_garage_masterswitch_up");
    ObjSet( "spr_garage_masterswitch_down", { alp = 1 });
    ObjSet( "anm_garage_auto", { alp = 1 });
    ObjSet( "spr_garage_auto_car", { alp = 1 });
    ObjDelete( "anm_garage_auto_up");
    ObjSet( "gzz_garage_auto", { input = true, active = true});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_masterswitch", clk_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_masterswitch", clk_masterswitch_end, private.room_objname );
  cmn.AddSubscriber( "clk_masterswitch_beg", clk_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_masterswitch_end", clk_masterswitch_end, private.room_objname );
  ----------------------------------------------------------------------------------------------
  -- function dlg_garage_saved () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_garage_saved" ] = {
    type = "click",
    use_place = "obj_garage_dlg_saved_focus",
    room = private.room_objname
  };
  local dlg_garage_saved_beg = function ()

    ObjDelete( "obj_garage_dlg_saved");
    ObjDelete( "anm_garage_girl_1");
    
  end;

  local dlg_garage_saved_inv = function ()
  
    interface.InventoryItemAdd( "inv_hairpin","spr_garage_saved_hairpin"); 
    ObjSet("anm_garage_girl_2", { alp = 1 });
    ObjSet( "obj_garage_girl_bbt", { input = true });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_garage_saved_beg", dlg_garage_saved_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_garage_saved_inv", dlg_garage_saved_inv );
  cmn.AddSubscriber( "dlg_garage_saved", dlg_garage_saved_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_garage_saved", dlg_garage_saved_inv );
  
  --------------------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------------------
  -- function dlg_garage_phoned () end;
  --------------------------------------------------------------------------------------------
  local dlg_garage_phoned_beg = function ()

  --ObjDelete("obj_garage_dlg_saved");
   
    
  end;

  local dlg_garage_phoned_end = function ()
  
  --interface.InventoryItemAdd( "inv_hairpin" ); 
      ObjSet( "spr_muffler_ignitionkey", { active = true, input = true });
      ObjDelete( "spr_muffler_key_close" );
      ObjDelete("anm_muffler_open");
      ObjDelete( "anm_garage_tablet" );
      ObjDelete( "anm_garage_tablet_2" );
      
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_garage_phoned_beg", dlg_garage_phoned_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_garage_phoned_end", dlg_garage_phoned_end );
  cmn.AddSubscriber( "dlg_garage_phoned", dlg_garage_phoned_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_garage_phoned", dlg_garage_phoned_end );
  
  --------------------------------------------------------------------------------------------
  -- function win_disconnection () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_disconnection" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_muffler_mmg",
    zz_gate = "gzz_garage_muffler",
    zz = "zz_muffler"

  };
  local win_disconnection = function ()

    if ( cmn.IsEventDone( "win_disconnection" ) ) then

      ObjSet("spr_muffler_light_green_3", { alp = 1 });
      ObjSet("spr_garage_muffler_green_light", { alp = 1 });
      --ObjSet( "spr_muffler_ignitionkey", { active = true, input = true });
      --ObjDelete( "spr_muffler_key_close" );
      ObjDelete( "obj_muffler_mmg" );
      ObjDelete( "spr_muffler_light_red_3");
      ObjDelete( "spr_garage_muffler_red_light" );
      ObjSet("spr_muffler_unlock", { alp = 1  });
      ObjSet( "spr_garage_muffler_open_cap", { alp = 1 });
      
      --private.dlg_garage_phoned()
  
      
    elseif ( cmn.IsEventStart( "win_disconnection" ) and not cmn.IsEventDone( "win_disconnection" ) ) then 
      
      for i = 1, 3  do
        
        for j = 1, 8  do
          
          if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j] ~= 0 then 
            
            ObjSet( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j], { pos_x = private.coord_mas[i][j][1], pos_y = private.coord_mas[i][j][2]});
            
          end;
          
        end;
        
      end;
      
      if ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ~= 0 then
        
        ObjSet(  "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1.."_add", { alp = 1 });
        ObjSet(  "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2.."_add", { alp = 1 });
        private.DrawArrow();
        
      --else
      --  
      --  for i = 1, 8  do
      --    
      --    ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[2][i] = private.dis_start[i];
      --    
      --  end
      --  
      
      end;
  
    end;
    private.dis_current = ng_global.progress[ "std" ][ "win_disconnection" ].dis_array;
    private.CheckInput();
    
 
  end;
  cmn.AddSubscriber( "win_disconnection", win_disconnection, private.room_objname ); 
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
 subroom.Define( "zz_muffler" );
 subroom.Define( "zz_auto" );
 subroom.Define( "zz_cabinet_2" );
 subroom.Define( "zz_ceilingcabinet" );
 --------------------------------------------------------------------------------------------
  function zz_muffler.PreOpen()

    if ( cmn.IsEventDone( "use_fuse_2_1" ) and cmn.IsEventDone( "use_fuse_2_2" )) and not cmn.IsEventDone( "win_disconnection" ) then
    
      cmn.MiniGameShow( 'disconnection' );
      common_impl.PassingMgStart( "disconnection" );
      
    end;
    
    if cmn.IsEventDone( "get_navigator" ) then  
      
      ObjDelete("spr_muffler_navigator");
     
    end;

    if cmn.IsEventDone( "dlg_garage_phoned" ) then  
      
     local func_after = function ()
     
        common_impl.Lock( false );
        cmn.CallEventHandler( "dlg_garage_phoned_end" );
     
     end;
     common_impl.Lock( true );
    
     AnimPlay("anm_muffler_open", "DoAnim", func_after);
      
    end; 
   
   --if cmn.IsEventStart( "win_disconnection" ) and not cmn.IsEventDone( "win_disconnection" ) and private.CheckWin() then
   --  
   --  private.win_disconnection();
   --  
   --end;  
 
  end;
  --------------------------------------------------------------------------------------------
  function zz_muffler.PreClose()

    if ( cmn.IsEventDone( "use_fuse_2_1" ) and cmn.IsEventDone( "use_fuse_2_2" )) and not cmn.IsEventDone( "win_disconnection" ) then

      cmn.MiniGameHide( 'disconnection' );
      common_impl.PassingMgStop( "disconnection" );

    end;

  end;
  function zz_muffler.Close()
    
    if ( cmn.IsEventDone( "win_disconnection" ) ) and not cmn.IsEventDone( "dlg_garage_phoned" ) then
      
      private.dlg_garage_phoned();
      
    end;
    
  end;
  
  --------------------------------------------------------------------------------------------
  function zz_muffler.Open()
    
    private.StopMouseAnims();
    
  end;
  
  --------------------------------------------------------------------------------------------
  function zz_auto.Open()
    
    private.StopMouseAnims();
    
  end;
  
  --------------------------------------------------------------------------------------------
  function zz_cabinet_2.Open()
    
    private.StopMouseAnims();
    
  end;
  
  --------------------------------------------------------------------------------------------
  function zz_ceilingcabinet.Open()
    
    private.StopMouseAnims();
    
  end;

  -------------------------------------------------------------------------------------------
  --function zz_auto.Close()
  --  
  --  if ( cmn.IsEventDone( "clk_ignitionkey" ) )  then
  --    
  --     interface.Lock( true, 3 );
  --     local func_after = function()
  --     
  --         cmn.GotoRoom( 'rm_wheelbarrow' );
  --    
  --     end; 
  --      --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_interactive_lunchroom_cameraman", 0, "", 0 );
  --      
  --      AnimPlay( "anm_garage_auto", "DoAnim", func_after );
  --    
  --  end;
  --  
  --end;  

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_garage();
  
  if not ng_global.progress["std"]["opn_garage"].viewer then
    
    ng_global.progress["std"]["opn_garage"].viewer = 1;
    
  end;
  
  if ng_global.progress["std"]["opn_garage"].viewer == 1 then
  
     common_impl.ShowBbt( 'bbt_garage_mouse_1' );
     
     AnimPlay( "anm_garage_mouse_run", "DoAnim", "" );
     
     common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mouse_run", 0, "", 0 );
     
  end;
   
  if ( ng_global.progress["std"]["opn_garage"].viewer < 4 ) then
      
      ng_global.progress["std"]["opn_garage"].viewer = ng_global.progress["std"]["opn_garage"].viewer + 1;
    
      if ng_global.progress["std"]["opn_garage"].viewer == 3 then
      
        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mouse_apple", 0, "", 0 );
      
        common_impl.ShowBbt( 'bbt_garage_mouse' );
        
        AnimPlay( "anm_garage_mouse", "DoAnim", "" );
        
      end;   
        
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
   
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();  
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_garage_env" }, "", 0.5 );

  if not cmn.IsEventDone( "dlg_garage_phoned" ) and
    
    cmn.IsEventDone( "win_disconnection" ) then

    private.dlg_garage_phoned()
    
  end; 
  
  --if not ng_global.progress["std"]["opn_garage"].viewer then
  --  
  --  ng_global.progress["std"]["opn_garage"].viewer = 1;
  --  
  --end;
  --
  --if ng_global.progress["std"]["opn_garage"].viewer == 1 then
  --
  --   common_impl.ShowBbt( 'bbt_garage_mouse_1' );
  --   
  --   AnimPlay( "anm_garage_mouse_run", "DoAnim", "" );
  --   
  --   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mouse_run", 0, "", 0 );
  --   
  --end;
  -- 
  --if ( ng_global.progress["std"]["opn_garage"].viewer < 4 ) then
  --    
  --      ng_global.progress["std"]["opn_garage"].viewer = ng_global.progress["std"]["opn_garage"].viewer + 1;
  --    
  --      if ng_global.progress["std"]["opn_garage"].viewer == 3 then
  --      
  --        common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mouse_apple", 0, "", 0 );
  --      
  --        common_impl.ShowBbt( 'bbt_garage_mouse' );
  --        
  --        AnimPlay( "anm_garage_mouse", "DoAnim", "" );
  --        
  --      end;   
  --      
  --end;
      
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fuse_2_1()

  local item = "inv_fuse_2_1";

  if ( common.ApplyObj( item, "obj_muffler_use_fuse_2_1", true ) ) then

    cmn.CallEventHandler( "use_fuse_2_1_inv" );
    cmn.CallEventHandler( "use_fuse_2_1_beg" );

    local func_after = function ()
  
    local func_end = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fuse_2_1" );
      cmn.CallEventHandler( "use_fuse_2_1_end" );
      if ( cmn.IsEventDone( "use_fuse_2_2" ) ) then
        cmn.MiniGameShow( 'disconnection' );
        common_impl.PassingMgStart( "disconnection" );
        ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 = 0;
        ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 = 0;
        ng_global.progress[ "std" ][ "win_disconnection" ].dis_array = {{0, 0, 0, 0, 0, 0, 0, 0},
                                                                        { 4, 7, 1, 6, 3, 5, 8, 2 },
                                                                        {0, 0, 0, 0, 0, 0, 0, 0}};
        --ng_global.progress[ "std" ][ "win_piano" ].pos = 1;
        --ng_global.progress[ "std" ][ "win_piano" ].array = {0, 0, 0, 0, 0 };
      end;
      
    --common.CloseSubRoom();;
    end;
    ObjAnimate( "spr_muffler_light_red_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_muffler_light_green_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    if ( cmn.IsEventDone( "use_fuse_2_2" ) ) then
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_cap_muffler", 0, "", 0 );
       
      ObjAnimate( "spr_muffler_cap_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_muffler_cap_open_code", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } ); 
      
    end; 
    
  end;

  common_impl.Lock( true );
  -- func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_fuse_muffler", 0, "", 0 );
  
    ObjAnimate( "spr_muffler_fuse_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
   
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_garage_muffler", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_muffler", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fuse_2_2()

  local item = "inv_fuse_2_2";

  if ( common.ApplyObj( item, "obj_muffler_use_fuse_2_2", true ) ) then

    cmn.CallEventHandler( "use_fuse_2_2_inv" );
    cmn.CallEventHandler( "use_fuse_2_2_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_fuse_2_2" );
      cmn.CallEventHandler( "use_fuse_2_2_end" );
      if ( cmn.IsEventDone( "use_fuse_2_1" ) ) then
        cmn.MiniGameShow( 'disconnection' );
        common_impl.PassingMgStart( "disconnection" );
        ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 = 0;
        ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 = 0;
        ng_global.progress[ "std" ][ "win_disconnection" ].dis_array = {{0, 0, 0, 0, 0, 0, 0, 0},
                                                                        { 4, 7, 1, 6, 3, 5, 8, 2 },
                                                                        {0, 0, 0, 0, 0, 0, 0, 0}};
        --ng_global.progress[ "std" ][ "win_piano" ].array = {0, 0, 0, 0, 0 };
      end;

      end;
    ObjAnimate( "spr_muffler_light_red_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_muffler_light_green_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    if ( cmn.IsEventDone( "use_fuse_2_1" ) ) then
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_cap_muffler", 0, "", 0 );
       
      ObjAnimate( "spr_muffler_cap_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_muffler_cap_open_code", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } ); 
    
     end;
     
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_fuse_muffler", 0, "", 0 );
  
    ObjAnimate( "spr_muffler_fuse_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
   
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_garage_muffler", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_muffler", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_2_1()

  local item = "inv_elf_2_1";

  if ( common.ApplyObj( item, "obj_cabinet_2_use_elf_2_1", true ) ) then

    cmn.CallEventHandler( "use_elf_2_1_inv" );
    cmn.CallEventHandler( "use_elf_2_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_2_1" );
      cmn.CallEventHandler( "use_elf_2_1_end" );
      ObjSet( "spr_cabinet_2_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_2_1", "spr_cabinet_2_elf", nil, "video" );
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    end;

    common_impl.Lock( true );
   
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_cabinet_2_use_elf", 0, "", 0 );
    
    ObjSet( "vid_cabinet_2_use_elf", { playing = true, endtrig = func_after });
    
    interface.InventoryItemRemove( "inv_elf_2_1" ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_garage_cabinet_2", false ) and not cmn.IsEventDone( "use_elf_2_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet_2", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hacksaw()

  local item = "inv_hacksaw";

  if ( common.ApplyObj( item, "obj_cabinet_2_use_hacksaw", true ) and cmn.IsEventDone("use_elf_2_1") ) then

    cmn.CallEventHandler( "use_hacksaw_inv" );
    cmn.CallEventHandler( "use_hacksaw_beg" );

    local func_after = function ()
    
        local func_end = function ()
        
          common_impl.Lock( false );
          cmn.SetEventDone( "use_hacksaw" );
          cmn.CallEventHandler( "use_hacksaw_end" );
          common.CloseSubRoom();
          
        end;
        
        ObjAnimate( "anm_cabinet_2_use_saw", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        ObjAnimate( "spr_cabinet_2_chain_2", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        ObjAnimate( "spr_cabinet_2_open", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
    
   end;

    common_impl.Lock( true );
    ObjSet( "anm_cabinet_2_door", { alp = 0 });
    ObjSet( "anm_cabinet_2_use_saw", { alp = 1 });
    AnimPlay( "anm_cabinet_2_use_saw", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_hacksaw_cabinet_2", 0, "", 0 );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_garage_cabinet_2", false ) and cmn.IsEventDone("use_elf_2_1") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet_2", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hairpin()

  local item = "inv_hairpin";

  if ( common.ApplyObj( item, "obj_ceilingcabinet_use_hairpin", true ) ) then

    cmn.CallEventHandler( "use_hairpin_inv" );
    cmn.CallEventHandler( "use_hairpin_beg" );

    local func_after = function ()
   
      local func_end = function ()
   
        common_impl.Lock( false );
        cmn.SetEventDone( "use_hairpin" );
        cmn.CallEventHandler( "use_hairpin_end" );

      end;
    
      ObjSet( "anm_ceilingcabinet_use_hairpin", { alp = 0 });
    
      ObjAnimate( "obj_ceilingcabinet_door_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "obj_ceilingcabinet_door_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_ceilingcabinet_box_over_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_ceilingcabinet_box_close", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "spr_ceilingcabinet_box_over_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;

    common_impl.Lock( true );
    --func_after();
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_hairpin_ceilingcabinet", 0, "", 0 );
     ObjSet( "anm_ceilingcabinet_use_hairpin", { alp = 1});
     AnimPlay( "anm_ceilingcabinet_use_hairpin", "DoAnim", func_after );
    
    return true;
  
  elseif( common.ApplyObj( item, "obj_cabinet_2_use_hacksaw", true ) ) then
    
    common_impl.ShowBbt( 'bbt_cabinet_2_not_use_hairpin' );
    return true;
    
  elseif common.ApplyObj( item, "gzz_garage_ceilingcabinet", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ceilingcabinet", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_repairamulet()

  local item = "inv_repairamulet";

  if ( common.ApplyObj( item, "obj_ceilingcabinet_use_repairamulet", true ) ) and  cmn.IsEventDone("use_hairpin") then

    cmn.CallEventHandler( "use_repairamulet_inv" );
    cmn.CallEventHandler( "use_repairamulet_beg" );

    local func_after = function ()
  
     local func_end = function ()
     
      common_impl.Lock( false );
      cmn.SetEventDone( "use_repairamulet" );
      cmn.CallEventHandler( "use_repairamulet_end" );
    --common.CloseSubRoom();;
     end;
    
      ObjAnimate( "spr_ceilingcabinet_box_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_ceilingcabinet_close_over", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_ceilingcabinet_box_over", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_repairamulet_ceilingcabinet", 0, "", 0 );
  
    ObjAnimate( "spr_ceilingcabinet_box_instruments", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_garage_ceilingcabinet", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ceilingcabinet", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ignitionkey()

  local item = "inv_ignitionkey";


  if ( common.ApplyObj( item, "obj_auto_use_ignitionkey", true ) and cmn.IsEventDone("use_carhandle") ) then

    cmn.CallEventHandler( "use_ignitionkey_inv" );
    cmn.CallEventHandler( "use_ignitionkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      --private.vid_garage_trip();
      cmn.SetEventDone( "use_ignitionkey" );
      cmn.CallEventHandler( "use_ignitionkey_end" );
      --common.CloseSubRoom();
      --cmn.GotoRoom( 'rm_wheelbarrow' );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_ignitionkey_auto", 0, "", 0 );
  
    --ObjAnimate( "spr_auto_key", "pos_xy", 0, 0, func_after,
    --{ 
    --  0.0, 0, -319, 162,
    --  0.9, 0, 49, -95
    --} );
     AnimPlay( "anm_auto_key", "DoAnim", func_after );
    return true;
  
  elseif common.ApplyObj( item, "gzz_garage_auto", false ) and cmn.IsEventDone("use_carhandle") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_auto", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_carhandle()

  local item = "inv_carhandle";

  if ( common.ApplyObj( item, "obj_auto_use_carhandle", true ) and cmn.IsEventDone("use_masterswitch") ) then

    cmn.CallEventHandler( "use_carhandle_inv" );
    cmn.CallEventHandler( "use_carhandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_carhandle" );
      cmn.CallEventHandler( "use_carhandle_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_carhandle_auto", 0, "", 0 );
  
    ObjAnimate( "spr_auto_doorhandle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_garage_auto", false ) and cmn.IsEventDone("use_masterswitch") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_auto", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_masterswitch()

  local item = "inv_masterswitch";

  if ( common.ApplyObj( item, "obj_garage_use_masterswitch", false ) ) then

    cmn.CallEventHandler( "use_masterswitch_inv" );
    cmn.CallEventHandler( "use_masterswitch_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_masterswitch" );
      cmn.CallEventHandler( "use_masterswitch_end" );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_masterswitch_garage", 0, "", 0 );
    
    ObjAnimate( "spr_garage_masterswitch_up", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_masterswitch()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_masterswitch" );
  cmn.CallEventHandler( "get_masterswitch" );

end;
--------------------------------------------------------------------------------------------
function private.get_navigator()

--  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
--  
--  cmn.SetEventDone( "get_navigator" );
--  cmn.CallEventHandler( "get_navigator" );
--
 common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_map", 0, "", 0 );
  local func_after = function()

    common_impl.Lock( false );
    cmn.SetEventDone( "get_navigator" );
    cmn.CallEventHandler( "get_navigator_inv" );


  end;

    common_impl.Lock( true );
    cmn.CallEventHandler( "get_navigator_closezz" );
    ObjSet( "spr_muffler_navigator", { input = false } );
    local item_name = "spr_muffler_navigator";
    local start_pos = GetObjPosByObj( item_name );
    ObjAttach( item_name, "ng_interface_transporter" );
    local end_pos = GetObjPosByObj( "spr_int_button_map_button" );
    ObjAnimate( item_name, "pos_xy", 0, 0, "",
    { 
      0.0, 1, start_pos[1],start_pos[2], 
      1.0, 1, end_pos[1],end_pos[2]
    } );
    ObjAnimate( item_name, "scale_xy", 0, 0, func_after,
    { 
      0.0, 1, 1,1,
      0.7, 1, 1,1,
      1.0, 1, 0,0
    } );
end;
--------------------------------------------------------------------------------------------
function private.get_ignitionkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ignitionkey" );
  cmn.CallEventHandler( "get_ignitionkey" );
  
  if common_impl.IsGetCollect( "get_collect_2_2_8" ) then
    
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_repairamulet()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_repairamulet" );
  cmn.CallEventHandler( "get_repairamulet" );

end;
--------------------------------------------------------------------------------------------
function private.get_fuse_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fuse_2_1" );
  cmn.CallEventHandler( "get_fuse_2_1" );
  
  if ( cmn.IsEventDone("get_hacksaw") and cmn.IsEventDone("get_corkscrew")) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hacksaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hacksaw" );
  cmn.CallEventHandler( "get_hacksaw" );
  
  if ( cmn.IsEventDone("get_corkscrew") and cmn.IsEventDone("get_fuse_2_1")) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_corkscrew()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_corkscrew" );
  cmn.CallEventHandler( "get_corkscrew" );
  
  if ( cmn.IsEventDone("get_hacksaw") and cmn.IsEventDone("get_fuse_2_1")) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_fuse_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fuse_2_2" );
  cmn.CallEventHandler( "get_fuse_2_2" );
  

end;
--------------------------------------------------------------------------------------------
function private.get_nightsymbolelement_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nightsymbolelement_1" );
  cmn.CallEventHandler( "get_nightsymbolelement_1" );

end;
-------------------------------------------------------------------------------------------
function private.get_collect_2_2_8()

  local func_after = function ()
    
  common_impl.GetCollectDone("get_collect_2_2_8");
  cmn.CallEventHandler("get_collect_2_2_8");

  if cmn.IsEventDone( "get_ignitionkey" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_muffler_collect_2", func_after ); 

end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_masterswitch()

 cmn.CallEventHandler( "clk_masterswitch_beg" );

 local func_after = function ()
     
    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_masterswitch" );
      cmn.CallEventHandler( "clk_masterswitch_end" );

    end;
    
    ObjSet("anm_garage_auto_up", { playing = true, endtrig = func_end });

  end;

  common_impl.Lock( true );
  
  ObjAnimate( "spr_garage_masterswitch_down", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  ObjAnimate( "spr_garage_masterswitch_up", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

end;
---------------------------------------------------------------------------------- 
function private.clk_cabinet_door()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_cabinet_2_use_hacksaw' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_door_cabinet_2", 0, "", 0 );
  
  --ObjAnimate( "spr_auto_door", "pos_x", 0, 0, func_after,
  --{ 
  --  0.0, 0, 0, 
  --  0.3, 0, -2,
  --  0.6, 0, 0
  --} );
  AnimPlay( "anm_cabinet_2_door", "DoAnim", func_after);
end;
----------------------------------------------------------------------------------  
function private.clk_door_auto()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_auto_use_carhandle' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_door_auto", 0, "", 0 );
  
  ObjAnimate( "spr_auto_door", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, -2,
    0.6, 0, 0
  } );
  
end;  
-----------------------------------------------------------------------
function private.clk_instruments()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_instruments" );
    cmn.CallEventHandler( "clk_instruments_end" );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_garage_clk_instruments' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_wrench", 0, "", 0 );
  
  AnimPlay( "anm_garage_instruments","DoAnim", func_after );
  
end;  
------------------------------------------------------------------------------------------------------------
function private.FirstClk( num )
  
  local num_1 = 0;
   
  --if ObjGet("spr_muffler_mmg_button_"..num).pos_y == -9  then 
  --  
  --  for  i = 1, 7  do
  --    
  --    if ( private.dis_current[2][i] == num ) and ( private.dis_current[2][i + 1] ~= 0) then
  --      
  --      num_1 = private.dis_current[2][i + 1];
  --      
  --      break;
  --      
  --    end; 
  --    
  --  end;
  --  
  --  if ( private.dis_current[2][8] == num ) and ( private.dis_current[2][7] ~= 0)  then
  --    
  --    num_1 = private.dis_current[2][8];
  --    num = private.dis_current[2][7];
  --    
  --  end;
  --end;
  for k = 1, 3  do
    
    if private.dis_current[k][1] == num and private.dis_current[k][2] == 0 or private.dis_current[k][8] == num and private.dis_current[k][7] == 0 then 
      
      return; 
      
    end;
    
  end;
  
     
    
     for  j = 1, 3  do
      
      for  i = 1, 7  do
        
        
        if private.dis_current[j][i] == num and private.dis_current[j][i + 1] == 0 and private.dis_current[j][i - 1] == 0 then return; end;
      
        if (( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] ~= 0)) then
        
          num_1 = private.dis_current[j][i + 1];
        
          break;
          
        elseif  ( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] == 0) and ( private.dis_current[j][i - 1] ~= 0) then
          
          num_1 = private.dis_current[j][i];
          num = private.dis_current[j][i - 1];
          
        end; 
        
      end;
      
    
      if ( private.dis_current[j][8] == num ) and ( private.dis_current[j][7] ~= 0)  then
      
        num_1 = private.dis_current[j][8];
        num = private.dis_current[j][7];
        
        
      
      end;
    
    end;
    
    
  
  local func_after = function ()
  
    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 = num ;
    ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 = num_1;
    private.DrawArrow();
    private.CheckInput();
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_select", 0, "", 0 );
  
  if ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ~= 0 and ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 ~= 0 then 
    
    ObjSet("spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1.."_add", { alp = 0});
    ObjSet("spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2.."_add", { alp = 0});
    
  end;
  
  ObjAnimate( "spr_muffler_mmg_button_"..num.."_add", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 1
    
  } );
  ObjAnimate( "spr_muffler_mmg_button_"..num_1.."_add", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 1
    
  } );
  
end; 

function private.SecondClk( line, column ) 
  
  local coord_1 = 0;
  local coord_2 = 0;
  --private.DrawArrow();
  --private.CheckInput();
  
  if ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ~= 0 then
    
    for i = 1, 3  do
      
      for j = 1, 8  do
        
        if private.dis_current[i][j] == ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 then
          
          coord_1 = i;
          coord_2 = j;
          
        end;  
        
      end;
      
    end;
    
    if  coord_1 == line and coord_1 ~= 2 then 
      
      
     common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_move", 0, "", 0 ); 
     private.HorizontalMove( coord_2, column, coord_1 ); 
    
      
    elseif ( coord_2 == column ) or ( coord_2 == column - 1 ) then
     
     --common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_move", 0, "", 0 );
     private.VerticalMove( coord_1, line, coord_2 ); 
     
    
    end;
    
    
  --  local func_after = function ()
  --  
  --    common_impl.Lock( false );
  --    
  --  end;
  --  
  --common_impl.Lock( true );
  
  end;
  
end;  
------------------------------------------------------------------------------------------------------------

function private.clk_carhandle()

  cmn.CallEventHandler( "clk_carhandle_beg" );

  local func_after = function ()
  
   local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_carhandle" );
      cmn.CallEventHandler( "clk_carhandle_end" );
     
      
    end;
    
    ObjMultiSet( { 
    
      { "spr_auto_door", { alp = 1 } },
      { "anm_auto_grip", { alp = 0 } }
  
    } );
   
   ObjAnimate("spr_auto_door",  "alp", 0, 0, func_end,
   {
   
     0.0, 0, 1.0,
     0.3, 0, 0.0
        
   }); 
         
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_carhandle_auto", 0, "", 0 );

  ObjMultiSet( { 
    
    { "spr_auto_door", { alp = 0 } },
    { "anm_auto_grip", { alp = 1, playing = true, endtrig = func_after } }
  
  } );

end;-------------------------------------------------------------------------------
function private.clk_keyignite()

  cmn.CallEventHandler( "clk_ignitionkey_beg" );

  local func_after = function ()
  
      common_impl.Lock( false );
      --cmn.SetEventDone( "clk_ignitionkey" );
      --cmn.CallEventHandler( "clk_ignitionkey_end" );
      common.CloseSubRoom();
      private.vid_garage_trip();
     
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_ignitionkey_auto", 0, "", 0 );

 
--   ObjAnimate("spr_auto_door",  "alp", 0, 0, func_after,
--
--   {
--   
--     0.0, 0, 1.0,
--     0.3, 0, 0.0
--        
--   }); 
   AnimPlay( "anm_auto_key_2", "DoAnim", func_after);
  
end; 
 ------------------------------------------------------------------------------- 
function private.clk_ceilingcabinet_door() 
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_ceilingcabinet_use_hairpin' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_door_ceilingcabinet", 0, "", 0 );
  
  ObjAnimate( "spr_ceilingcabinet_door_close_1", "scale_x", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 1.02,
    0.6, 0, 1
  } );
  
   
  ObjAnimate( "spr_ceilingcabinet_door_close_2", "scale_x", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.3, 0, 0.98,
    0.6, 0, 1
  } );
  -- ObjAnimate( "spr_fireservice_door_1", "scale_x", 0, 0,"",
  --{ 
  --  0.0, 0, 1, 
  --  0.3, 0, 0.98,
  --  0.6, 0, 1
  --} );
  
  
end;  
-------------------------------------------------------------------------------------------
function private.clk_ceilingcabinet_box() 
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_ceilingcabinet_use_repairamulet' );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_repair_box_ceilingcabinet", 0, "", 0 );
  
  ObjAnimate( "spr_ceilingcabinet_box_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 29,
    0.3, 0, 31,
    0.6, 0, 29
    
  } );
 
end;  
-------------------------------------------------------------------------------------------
function private.clk_niwtyaki() 
  
  local func_after = function ()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_niwtyaki" );
    cmn.CallEventHandler( "clk_niwtyaki" );
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_bitten_seat_2", 0, "", 0 );
  
  ObjAnimate( "spr_auto_niwtyaki", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
 
end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.ArrowOff()
  
  ObjSet( "spr_muffler_mmg_arrow_up", { alp = 0 });
  ObjSet( "spr_muffler_mmg_arrow_down", { alp = 0 });
  ObjSet( "spr_muffler_mmg_arrow_left", { alp = 0 });
  ObjSet( "spr_muffler_mmg_arrow_right", { alp = 0 });
  
end;  
--------------------------------------------------------------------------------------
function private.DrawArrow()
  
  local pos = {0, 0};
  local line = 0;
  local column = 0;
  
  private.up = false;
  private.down = false;
  private.left = false;
  private.right = false;
 
  private.ArrowOff();
  
  ObjAttach("obj_muffler_arrow", "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1);
  
  pos[1] = ObjGet("spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1).pos_x;
  pos[2] = ObjGet("spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1).pos_y;
  
    for  j = 1, 3  do
      
      for  i = 1, 7  do
        
        if pos[1] == private.coord_mas[j][i][1] and pos[2] == private.coord_mas[j][i][2] then
          
          line = j;
          column = i;
          
        end; 
  
      end;
      
    end;   
--вертикальные стрелки-----    
    if line == 1 then
     
      if  ( ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line + 1][column] == 0 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line + 1][column + 1] == 0) then
      
        ObjSet( "spr_muffler_mmg_arrow_down",{ alp = 1 });
        private.down = true;
     
      end
      
    elseif line == 3 then
      
      if  ( ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line - 1][column] == 0 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line - 1][column + 1] == 0) then
      
        ObjSet( "spr_muffler_mmg_arrow_up",{ alp = 1 });
        private.up = true;
     
      
      end
      
    elseif line == 2 then 
      
      if  ( ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line - 1][column] == 0 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line - 1][column + 1] == 0) then
      
        ObjSet( "spr_muffler_mmg_arrow_up",{ alp = 1});
        private.up = true;
      
      end;
      
      if  ( ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line + 1][column] == 0 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line + 1][column + 1] == 0) then
      
        ObjSet( "spr_muffler_mmg_arrow_down",{ alp = 1});
        private.down = true;
      
      end;
      
      
    end; 
    
--горизонт-----

    
     if line == 2 then 
       
       ng_global.progress[ "std" ][ "win_disconnection" ].check_horizont = false;
       
     else 
    
      if column == 1 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line][column + 2] == 0 then
        
        ObjSet( "spr_muffler_mmg_arrow_right",{ alp = 1 } );
        private.right = true;
      
        
      end; 
      
      if column == 7 and ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line][column - 1] == 0 then
        
        ObjSet( "spr_muffler_mmg_arrow_left",{ alp = 1 } );
        private.left = true;
     
        
      end; 
      
      --end;
    
      if column > 1 and column < 7 then
       
        if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line][column + 2] == 0 then  
        
          ObjSet( "spr_muffler_mmg_arrow_right",{ alp = 1 } );
          private.right = true;
       
          
        end;
        
        if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[line][column - 1] == 0 then  
        
          ObjSet( "spr_muffler_mmg_arrow_left",{ alp = 1} );
          private.left = true;
          
        end;
          
      end;
     
    end; 
     
      
end;  
--------------------------------------------------------------------------------------  
function private.VerticalMove( coord_1, line, coord_2 )
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
    if coord_1 > line then 
      
       private.dis_current[coord_1 - 1][coord_2] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ;
       private.dis_current[coord_1][coord_2] = 0;
       private.dis_current[coord_1 - 1][coord_2 + 1] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 ;
       private.dis_current[coord_1][coord_2 + 1] = 0;
       
    elseif  coord_1 < line then 
       
       private.dis_current[coord_1 + 1][coord_2] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ;
       private.dis_current[coord_1][coord_2] = 0;
       private.dis_current[coord_1 + 1][coord_2 + 1] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 ;
       private.dis_current[coord_1][coord_2 + 1] = 0;
       
    end; 
     
     --ng_global.progress[ "std" ][ "win_disconnection" ].dis_array = private.dis_current;
     
     --private.DrawArrow();
     --private.CheckInput();
     
  if private.CheckWin() then 
       
       private.win_disconnection() 
       
   else 
   
   for i = 1, 3  do
     
     for j = 1, 8  do
       
       ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j] = private.dis_current[i][j]
       
     end;
     
   end;
   
   private.DrawArrow();
   private.CheckInput();
   
   end;
   
  end;
   --common_impl.Lock( true );
  
   --if coord_1 > line then --вверх
  if coord_1 > line and private.up then 
   
    common_impl.Lock( true ); 
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_move", 0, "", 0 );
  
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1, "pos_y", 0, 0, func_after,
    { 
      0.0, 0, private.coord_mas[coord_1][coord_2][2],
      0.3, 0, private.coord_mas[coord_1 - 1][coord_2][2]
      
    } )
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2, "pos_y", 0, 0, "",
    { 
    
      0.0, 0, private.coord_mas[coord_1][coord_2 + 1][2],
      0.3, 0, private.coord_mas[coord_1 - 1][coord_2 + 1][2]
      
    } )
    
  end;
  --elseif coord_1 < line then --вниз
  
  if coord_1 < line and private.down then 
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_move", 0, "", 0 );
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1, "pos_y", 0, 0, func_after,
    { 
      0.0, 0, private.coord_mas[coord_1][coord_2][2],
      0.3, 0, private.coord_mas[coord_1 + 1][coord_2][2]
      
    } );
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2, "pos_y", 0, 0, "",
    { 
    
      0.0, 0, private.coord_mas[coord_1][coord_2 + 1][2],
      0.3, 0, private.coord_mas[coord_1 + 1][coord_2 + 1][2]
      
    } )
  end;

end;  
-----------------------------------------------------------------------------------------
function private.HorizontalMove( coord_2, column, coord_1 )
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
    if coord_2 > column then 
      
     private.dis_current[coord_1][coord_2 - 1] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ;
     -- private.dis_current[coord_1][coord_2] = 0;
     private.dis_current[coord_1][coord_2] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 ;
     private.dis_current[coord_1][coord_2 + 1] = 0;
       
   elseif  coord_2 < column then 
       
     private.dis_current[coord_1][coord_2 + 2] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 ;
     --private.dis_current[coord_1][coord_2] = 0;
     private.dis_current[coord_1][coord_2 + 1] = ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 ;
     private.dis_current[coord_1][coord_2] = 0;
       
    end; 
   
   for i = 1, 3  do
     
     for j = 1, 8  do
       
       ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j] = private.dis_current[i][j]
       
     end;
     
   end;
     
   -- ng_global.progress[ "std" ][ "win_disconnection" ].dis_array = private.dis_current;
    private.DrawArrow();
    private.CheckInput();
    
  end;
 
 if  coord_2 > column and private.left then
   
    common_impl.Lock( true );
    
   -- if coord_2 > column then --левые
      
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1, "pos_x", 0, 0, func_after,
    { 
    
      0.0, 0, private.coord_mas[coord_1][coord_2][1],
      0.3, 0, private.coord_mas[coord_1][coord_2 - 1][1]
        
    } )
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2, "pos_x", 0, 0, "",
    { 
    
      0.0, 0, private.coord_mas[coord_1][coord_2 + 1][1],
      0.3, 0, private.coord_mas[coord_1][coord_2][1]
      
    } )
    
  end; 
 
--elseif  coord_2 < column then --ультраправые
  if  coord_2 < column and private.right then
    
    common_impl.Lock( true );
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_1, "pos_x", 0, 0, func_after,
    { 
      0.0, 0, private.coord_mas[coord_1][coord_2][1],
      0.3, 0, private.coord_mas[coord_1][coord_2 + 1][1]
        
    } )
    
    ObjAnimate( "spr_muffler_mmg_button_"..ng_global.progress[ "std" ][ "win_disconnection" ].pick_2, "pos_x", 0, 0, "",
    { 
    
    0.0, 0, private.coord_mas[coord_1][coord_2 + 1][1],
    0.3, 0, private.coord_mas[coord_1][coord_2 + 2][1]
      
    } )  
    
  end;
  
end; 
-----------------------------------------------------------------------------------------
function private.CheckInput()
  
  if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array then
  
    for i = 1, 3  do
      
      for j = 1, 8  do
        
        if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j] ~= 0 then 
          
          ObjSet("obj_muffler_clk_"..i.."_"..j, { input = false })
          
        else 
        
          ObjSet("obj_muffler_clk_"..i.."_"..j, { input = true });  
        
        end;
      
      end;
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------------
function private.CheckWin()
  
  local win = false;
  local count = 0;
  
  for i = 1, 8  do
    
    --if ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[2][i] == private.dis_win[i] then
    if private.dis_current[2][i] == private.dis_win[i] then
      
      count = count + 1;
      
    end;
    
  end;
  
  if count == 8 then win = true end;
  
  return win;
  
end;
-----------------------------------------------------------------------------------------
function private.ButtonMouseEnter ( num )

  local num_1 = 0;
  common_impl.SetCursor( CURSOR_HAND );
  for k = 1, 3  do
    
    if private.dis_current[k][1] == num and private.dis_current[k][2] == 0 or private.dis_current[k][8] == num and private.dis_current[k][7] == 0 then 
      
      return; 
      
    end;
    
  end;
  
     for  j = 1, 3  do
      
      for  i = 1, 7  do
        
        if private.dis_current[j][i] == num and private.dis_current[j][i + 1] == 0 and private.dis_current[j][i - 1] == 0 then return; end;
      
        if (( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] ~= 0)) then
        
          num_1 = private.dis_current[j][i + 1];
        
          break;
          
        elseif  ( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] == 0) and ( private.dis_current[j][i - 1] ~= 0) then
          
          num_1 = private.dis_current[j][i];
          num = private.dis_current[j][i - 1];
          
        end; 
        
      end;
      
    
      if ( private.dis_current[j][8] == num ) and ( private.dis_current[j][7] ~= 0)  then
      
        num_1 = private.dis_current[j][8];
        num = private.dis_current[j][7];
      
      end;
   end;
      local obj = "spr_muffler_mmg_button_"..num.."_anim";
      local obj_1 = "spr_muffler_mmg_button_"..num_1.."_anim";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
  ObjAnimate( obj_1, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( num )

  common_impl.SetCursor( CURSOR_DEFAULT );
  
  local num_1 = 0;
  
   for k = 1, 3  do
    
    if private.dis_current[k][1] == num and private.dis_current[k][2] == 0 or private.dis_current[k][8] == num and private.dis_current[k][7] == 0 then 
      
      return; 
      
    end;
    
   end;
  
      for  j = 1, 3  do
      
      for  i = 1, 7  do
        
        if private.dis_current[j][i] == num and private.dis_current[j][i + 1] == 0 and private.dis_current[j][i - 1] == 0 then return; end;
      
        if (( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] ~= 0)) then
        
          num_1 = private.dis_current[j][i + 1];
        
          break;
          
        elseif  ( private.dis_current[j][i] == num ) and ( private.dis_current[j][i + 1] == 0) and ( private.dis_current[j][i - 1] ~= 0) then
          
          num_1 = private.dis_current[j][i];
          num = private.dis_current[j][i - 1];
          
        end; 
        
      end;
      
      if ( private.dis_current[j][8] == num ) and ( private.dis_current[j][7] ~= 0)  then
      
        num_1 = private.dis_current[j][8];
        num = private.dis_current[j][7];
      
      end;
      
    end; 
    
      local obj = "spr_muffler_mmg_button_"..num.."_anim";
      local obj_1 = "spr_muffler_mmg_button_"..num_1.."_anim";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  ObjAnimate( obj_1, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end; 
-----------------------------------------------------------------------------------------
function private.opn_garage()

  if not ( cmn.IsEventDone( "opn_garage" ) ) then
    cmn.SetEventDone( "opn_garage" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  end;
  
  cmn.CallEventHandler( "opn_garage" ); 

end;
--*********************************************************************************************************************
function private.vid_garage_trip()

  local func_after = function ( skip )

    ObjSet( "rm_garage", { color_r = 0, color_b = 0, color_g = 0 } );
    interface.DialogVideoHide();
    cmn.SetEventDone( "clk_ignitionkey" );
    cmn.CallEventHandler( "clk_ignitionkey_end" );
    cmn.CallEventHandler( "clk_ignitionkey_map" );
    cmn.GotoRoom( 'rm_wheelbarrow' );
   
    --common_impl.ShowBbt( 'bbt_vid_garage_trip', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level2/aud_garage_trip", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_garage_trip", 0, "", 0 );
  interface.DialogVideoShow( "vid_garage_trip", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_garage_trip", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.dlg_garage_saved()

  ObjAttach( "dlg_garage_saved", private.room_objname );
  ObjSet("anm_garage_saved_loc", { alp = 0 });
  ObjSet("anm_garage_girl_2", { alp = 0 });
  cmn.CallEventHandler( "dlg_garage_saved_beg" );
  
  common_impl.dialog_character_loc = "anm_garage_";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "saved", 4, nil, nil, true, "dlg_garage_saved_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_garage_saved_end()

  if not cmn.IsEventDone( "dlg_garage_saved" ) then

    cmn.SetEventDone( "dlg_garage_saved" );
    ObjSet( "spr_garage_saved_hairpin", { alp = 1 } );
    cmn.CallEventHandler( "dlg_garage_saved_inv" );
    common_impl.ShowBbt( "bbt_dlg_garage_saved", 1 );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_garage_phoned()
  
   local func_after = function()
  
    local func_after_anim = function()
    
      common_impl.Lock( false );
      
      ObjSet( "anm_garage_tablet", { visible = false, active = false } );
      ObjAttach( "dlg_garage_phoned", private.room_objname );
      cmn.CallEventHandler( "dlg_garage_phoned_beg" );

      common_impl.continue_visible = true; 
      common_impl.DialogCharacterStart( "phoned", 5, nil, nil, true, "dlg_garage_phoned_end" );
      
      ObjAnimate( "rm_garage", "color_rgb", 0, 0, "", { 0,0,0,0,0, 0.3,0,1,1,1 } );
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_tablet_env", 1, "", 0 );
    
    end;
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_switch_on", 0, "", 0 );
    
    ObjAnimate( "rm_garage", "color_rgb", 0, 0, func_after_anim, { 0,0,1,1,1, 0.3,0,0,0,0 } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_garage_tablet", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_garage_tablet", "DoAnim", func_after );
 
end;
--------------------------------------------------------------------------------------------
function public.dlg_garage_phoned_end()

--  if not cmn.IsEventDone( "dlg_garage_phoned" ) then
--
--    cmn.SetEventDone( "dlg_garage_phoned" );
--    ObjSet( "spr_garage_phoned_item", { alp = 1 } );
--    --cmn.CallEventHandler( "dlg_garage_phoned_end" );
--   
--    common_impl.ShowBbt( "bbt_dlg_phoned", 1 );
--    cmn.GotoSubRoom( "zz_muffler", nil, { 512, 384 } );
--    
--    common_impl.AddPageDiary( 7 );
-- 
--  end;
    local func_after = function()
   
    common_impl.Lock( false );
    
    common_impl.StopAudio( "env", "common/audio/level2/aud_tablet_env", 0.5 );
    
    cmn.SetEventDone( "dlg_garage_phoned" );
    cmn.CallEventHandler( "dlg_garage_phoned_end" ); 
    
    common_impl.ShowBbt( "bbt_dlg_phoned" );
    cmn.GotoSubRoom( "zz_muffler", nil, { 512, 384 } );
    common_impl.TutorialShow( "tutorial_page_1" );
    
    common_impl.AddPageDiary( 7 );
    
  end;
  
  common_impl.Lock( true );
  common_impl.StopAudio( "sfx", "common/audio/level2/aud_agents_blocked", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_tablet_off", 0, "", 0 );
  common_impl.StopAudio( "env", "common/audio/level1/aud_tablet_env", 0 );
  common_impl.StopAudio( "sfx", "common/audio/level1/aud_tablet_on", 0 );
 
  ObjSet( "anm_garage_tablet_2", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_garage_tablet_2", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "saved" then
    
    if txt_count == 3 then
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      
      ObjMultiSet( { { "anm_garage_saved_saved", { alp = 0 } },
                     { "anm_garage_saved_saved_2", { alp = 1 } } } );
      
    end;
    
  end;
  if dlg_name == "phoned" then
    
    if txt_count == 1 then
      
      local func_after = function() 
      
        ObjSet( "anm_garage_phoned_interface", { alp = 1, playing = true } );
        ObjSet( "anm_garage_phoned_interface_load", { alp = 0 } );
        
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_agents_blocked", 1, "", 0 );
 
      ObjSet( "anm_garage_phoned_interface_load", { alp = 1 } );
      
      AnimPlay( "anm_garage_phoned_interface_load", "DoAnim", func_after );
      
      ObjAnimate( "txt_garage_phoned_tablet", "alp", 0, 0, "", { 0,0,0, 0.3,0,0, 0.6,0,1 } );
    
    elseif count_txt == 2 then
      
     common_impl.StopAudio( "sfx", "common/audio/level1/aud_tablet_on", 0 );
 
     ObjMultiSet( { { "txt_garage_phoned_tablet", { alp = 1 } },
                    { "anm_garage_phoned_interface_load", { alp = 0, playing = false } },
                    { "anm_garage_phoned_interface", { alp = 1, playing = true } },
     
      } );
    
    end; 
    
  end;               
  
end;
--*********************************************************************************************************************
-- MMG
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_disconnection" then
      
    private.skip_disconnection();

  end;

end;
--------------------------------------------------------------------------------------------
function public.Reset( name )

  if name == "win_disconnection" then
    
    private.reset_disconnection();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.reset_disconnection() 
  
  for i = 1, 8  do
    
    ObjSet( "spr_muffler_mmg_button_"..private.dis_start[i], { pos_x = private.coord_mas[2][i][1], pos_y = -9 });
    ObjSet( "spr_muffler_mmg_button_"..i.."_add", { alp = 0 });
  end;
  
  ng_global.progress[ "std" ][ "win_disconnection" ].pick_1 = 0;
  ng_global.progress[ "std" ][ "win_disconnection" ].pick_2 = 0;
  private.dis_current = {
  { 0, 0, 0, 0, 0, 0, 0, 0 },
  { 4, 7, 1, 6, 3, 5, 8, 2 },
  { 0, 0, 0, 0, 0, 0, 0, 0 }
  };
  --ng_global.progress[ "std" ][ "win_disconnection" ].dis_array = private.dis_current;
   for i = 1, 3  do
     
     for j = 1, 8  do
       
       ng_global.progress[ "std" ][ "win_disconnection" ].dis_array[i][j] = private.dis_current[i][j]
       
     end;
     
   end;
  private.CheckInput();
  private.ArrowOff();
  

end;
--------------------------------------------------------------------------------------------
function private.win_disconnection()
  
  local func_after = function()
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
    
    common_impl.Lock( false );
    cmn.MiniGameHide( "disconnection" );
    common_impl.PassingMgWin( "disconnection" );
    cmn.SetEventDone( "win_disconnection" );
    cmn.CallEventHandler( "win_disconnection" );
    common.CloseSubRoom();
    
   
  end;
  
  --func_after();
  private.ArrowOff();
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_mg_muffler_win", 0, "", 0 );
  ObjAnimate("obj_muffler_mmg", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.3, 0, 0
    
  })
  
--  ObjAnimate("spr_muffler_key_close", "pos_xy", 0, 0, func_after,
--  {
--    0.0, 0, -196, 155,
--    0.8, 0, -160, 370
--    
--  })
--
  ObjAnimate("spr_muffler_unlock", "alp", 0, 0, func_after,
  {
    0.0, 0, 0,
    0.8, 0, 1
    
  })
  ObjAnimate("spr_muffler_lock", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.8, 0, 0
  })
  ObjAnimate("spr_muffler_light_red_3", "alp", 0, 0, "",
  {
  
    0.0, 0, 1,
    0.8, 0, 0
    
  })
  ObjAnimate("spr_muffler_light_green_3", "alp", 0, 0, "",
  {
  
    0.0, 0, 0,
    0.8, 0, 1
    
  })
end;
--------------------------------------------------------------------------------------------
function private.skip_disconnection()

  private.win_disconnection();

end;
--------------------------------------------------------------------------------------------
function private.StopMouseAnims()
  
  AnimStop( "anm_garage_mouse_run" );
  AnimStop( "anm_garage_mouse" );
  
  common_impl.StopAudio( "sfx", "common/audio/level2/aud_mouse_run", 0 );
  common_impl.StopAudio( "sfx", "common/audio/level2/aud_mouse_apple", 0 );
  
end;
--********************************************************************************************************************* 
ObjAnimate("spr_garage_lamp", "ang",1,0,"",
{
  0.0, 3, -0.05, 
  1.2, 3, 0.05,
  2.4, 3, -0.05,
}); 
ObjAnimate("spr_garage_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
  
ObjAnimate("spr_auto_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
})
ObjAnimate("spr_auto_light_add_2", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});
ObjAnimate("spr_cabinet_2_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
  
