-- name=rm_groundfloor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_groundfloor";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stair", "room_hub" );
  ObjAttach( "zz_storage", "room_hub" );
  ObjAttach( "zz_slidingdoors", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_stair_button_2_2", { event_mdown = private.get_button_2_2 }},
  { "spr_stair_bartendersbadge", { event_mdown = private.get_bartendersbadge }},
  { "obj_storage_clk_trihedron", { event_mdown = private.clk_trihedron }},
  { "obj_groundfloor_clk_robot", { event_mdown = private.clk_robot } },
  { "obj_stair_use_clippers", { event_mdown = private.clk_grille } },
  { "spr_stair_note", { event_mdown = function() common_impl.NoteScale( "open", "spr_stair_note" );common_impl.ShowBbt( 'bbt_stair_note', 1 ); end } },
  { "spr_stair_note_big", { event_mdown = function() common_impl.NoteScale( "close", "spr_stair_note" ); end } },
  { "spr_groundfloor_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_stairs_collect_2", { event_mdown = function () private.get_collect_2_2_3(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  
  private.clk_trihedron = false;
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_groundfloor = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_groundfloor_superpuzzle_2",
    "gzz_groundfloor_stair",
    "gzz_groundfloor_storage",
    "gzz_groundfloor_slidingdoors"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_stair",
    "zz_storage",
    "zz_slidingdoors"    
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_groundfloor", update_game_mode_groundfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_groundfloor = function ()

  local effects_table = 
  {
    "obj_groundfloor_anim",
    "spr_storage_add_sing"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_groundfloor", update_performance_mode_groundfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_groundfloor () end;
  --------------------------------------------------------------------------------------------
  local opn_groundfloor_map = function ()

    common_impl.VisitMapRoom( "groundfloor" );

  end;
  cmn.AddSubscriber( "opn_groundfloor", opn_groundfloor_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_button_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_2_2" ] = {
    type = "get",
    get_obj = "spr_stair_button_2_2",
    room = private.room_objname,
    zz = "zz_stair",
    zz_gate = "gzz_groundfloor_stair"
  };
    
  local get_button_2_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_2_2", "spr_stair_button_2_2" );
  
  end;
  
  local get_button_2_2_closezz = function ()
  
    ObjDelete( "gfx_stair_button_2_2" );
  
  end;
  
  cmn.AddSubscriber( "get_button_2_2", get_button_2_2_inv );
  cmn.AddSubscriber( "get_button_2_2", get_button_2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bartendersbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bartendersbadge" ] = {
    type = "get",
    get_obj = "spr_stair_bartendersbadge",
    room = private.room_objname,
    zz = "zz_stair",
    zz_gate = "gzz_groundfloor_stair"
  };
    
  local get_bartendersbadge_inv = function ()
  
    interface.InventoryItemAdd( "inv_bartendersbadge", "spr_stair_bartendersbadge" );
    ObjSet( "inv_bartendersbadge", { drag = false } );

  end;
  
  local get_bartendersbadge_closezz = function ()
  
    ObjDelete( "gfx_stair_bartendersbadge" );
    ObjDelete( "spr_stair_bartendersbadge_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_bartendersbadge", get_bartendersbadge_inv );
  cmn.AddSubscriber( "get_bartendersbadge", get_bartendersbadge_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_4 = function ()
  
    ObjDelete( "obj_groundfloor_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_4", get_collect_morph_item_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_3 = function ()
 
    ObjDelete( "spr_stairs_collect_2" );
    ObjDelete( "spr_stairs_collect_2_shadow" );
   
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_3", get_collect_2_2_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_elf_2_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_2_3" ] = {
    type = "use",
    inv_obj = "inv_elf_2_1",
    use_place = "obj_stair_use_elf_2_3",
    room = private.room_objname,
    zz = "zz_stair",
    zz_gate = "gzz_groundfloor_stair"
  };
  local use_elf_2_3_inv = function ()
  
  interface.InventoryItemRemove( "inv_elf_2_1" );
  
  end;
  local use_elf_2_3_beg = function ()
  
    ObjDelete( "obj_stair_use_elf_2_3" );
  
  end;
  local use_elf_2_3_end = function ()
  
    ObjSet( "spr_stair_button_2_2", { input = true, alp = 1 } );
    ObjSet( "obj_stair_bartendersbadge", { input = true, alp = 1 } );
    ObjDelete( "obj_stair_small" );
    ObjDelete( "vid_stair_elf" );
    ObjSet( "gfx_stair_bartendersbadge", { active = true } );
    ObjSet( "gfx_stair_button_2_2", { active = true } );
    ObjSet( "spr_stair_note", { input = true, alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_2_3", use_elf_2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_3", use_elf_2_3_inv );
  cmn.AddSubscriber( "use_elf_2_3", use_elf_2_3_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_3_inv", use_elf_2_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_3_beg", use_elf_2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_3_end", use_elf_2_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers_1" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_stair_use_clippers",
    room = private.room_objname,
    zz = "zz_stair",
    zz_gate = "gzz_groundfloor_stair"
  };
  local use_clippers_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_clippers" );
  
  end;
  local use_clippers_1_beg = function ()
  
    ObjDelete( "obj_stair_use_clippers" );
  
  end;
  local use_clippers_1_end = function ()
  
    ObjSet( "obj_stair_use_elf_2_3", { input = true, active = true } );
   
    ObjDelete( "anm_stair_nippers" );
  
    ObjSet( "spr_groundfloor_open_stair", { alp = 1 } );
    ObjDelete( "spr_groundfloor_close_stair" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_inv );
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_inv", use_clippers_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_beg", use_clippers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_end", use_clippers_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trihedron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trihedron" ] = {
    type = "use",
    inv_obj = "inv_trihedron",
    use_place = "obj_storage_use_trihedron",
    room = private.room_objname,
    zz = "zz_storage",
    zz_gate = "gzz_groundfloor_storage"
  };
  local use_trihedron_inv = function ()
  
    interface.InventoryItemRemove( "inv_trihedron" );
  
  end;
  local use_trihedron_beg = function ()
  
    ObjDelete( "obj_storage_use_trihedron" );
  
  end;
  local use_trihedron_end = function ()
  
    ObjSet( "spr_storage_key_1", { alp = 1 } );
    ObjSet( "obj_storage_clk_trihedron", { input = true } );
    ObjSet( "spr_groundfloor_key", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trihedron", use_trihedron_beg, private.room_objname );
  cmn.AddSubscriber( "use_trihedron", use_trihedron_inv );
  cmn.AddSubscriber( "use_trihedron", use_trihedron_end, private.room_objname );
  cmn.AddSubscriber( "use_trihedron_inv", use_trihedron_inv, private.room_objname );
  cmn.AddSubscriber( "use_trihedron_beg", use_trihedron_beg, private.room_objname );
  cmn.AddSubscriber( "use_trihedron_end", use_trihedron_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coldsource () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coldsource" ] = {
    type = "use",
    inv_obj = "inv_coldsource",
    use_place = "obj_slidingdoors_use_coldsource",
    room = private.room_objname,
    zz = "zz_slidingdoors",
    zz_gate = "gzz_groundfloor_slidingdoors"
  };
  local use_coldsource_inv = function ()
  
    interface.InventoryItemRemove( "inv_coldsource" );
  
  end;
  local use_coldsource_beg = function ()
  
    ObjDelete( "obj_slidingdoors_use_coldsource" );
  
  end;
  local use_coldsource_end = function ()
  
    ObjDelete( "gzz_groundfloor_slidingdoors" );
    ObjSet( "anm_slidingdoors_gold", { frame = 250 } );
    ObjSet( "spr_groundfloor_open_door", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coldsource", use_coldsource_beg, private.room_objname );
  cmn.AddSubscriber( "use_coldsource", use_coldsource_inv );
  cmn.AddSubscriber( "use_coldsource", use_coldsource_end, private.room_objname );
  cmn.AddSubscriber( "use_coldsource_inv", use_coldsource_inv, private.room_objname );
  cmn.AddSubscriber( "use_coldsource_beg", use_coldsource_beg, private.room_objname );
  cmn.AddSubscriber( "use_coldsource_end", use_coldsource_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_trihedron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_trihedron" ] = {
    type = "click",
    use_place = "obj_storage_clk_trihedron",
    room = private.room_objname,
    zz = "zz_storage",
    zz_gate = "gzz_groundfloor_storage"
  };
  local clk_trihedron_beg = function ()
  
    ObjDelete( "obj_storage_clk_trihedron" );
  
  end;
  local clk_trihedron_end = function ()
  
    ObjDelete( "obj_storage_close" );
    ObjDelete( "gzz_groundfloor_storage" );
    ObjSet( "gmg_groundfloor_superpuzzle_2", { input = true, active = true } );
    
    ObjDelete( "obj_groundfloor_storage_glass" );
    ObjDelete( "anm_groundfloor_glass_open" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_trihedron", clk_trihedron_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trihedron", clk_trihedron_end, private.room_objname );
  cmn.AddSubscriber( "clk_trihedron_beg", clk_trihedron_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trihedron_end", clk_trihedron_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  local win_superpuzzle_2_loc = function ()
  
    if cmn.IsEventDone( "win_superpuzzle_2" ) then
      
      ObjDelete( "gmg_groundfloor_superpuzzle_2" );
      ObjDelete( "spr_groundfloor_light_door_red" );
      ObjDelete( "anm_groundfloor_redlight" );
      
    end;
  
  end;
  cmn.AddSubscriber( "win_superpuzzle_2", win_superpuzzle_2_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_groundfloor_late () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_groundfloor_late" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_groundfloor_late",
    
  };
  local vid_groundfloor_late_end = function ()
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_groundfloor_late", vid_groundfloor_late_end, private.room_objname  );
  cmn.AddSubscriber( "vid_groundfloor_late_end", vid_groundfloor_late_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_stair" );
  
  function zz_stair.PreOpen()
    
    if not common_impl.groundfloor then

       common_impl.groundfloor = {}
       common_impl.groundfloor.note = "close";

      end;
    
  end;
   
  function zz_stair.Close()
    
    common_impl.groundfloor.note = "close";
    
    if ( cmn.IsEventDone( "use_elf_2_3" ) ) then
      
      ObjSet( "spr_stair_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_stair_note",     { alp = 1 } );
      
    end;
    
  end;
  
  subroom.Define( "zz_storage" );
  
  function zz_storage.Close()
    
    if private.clk_trihedron then
      
      local func_after = function()
      
        common_impl.Lock( false );
        
        cmn.SetEventDone( "clk_trihedron" );
        cmn.CallEventHandler( "clk_trihedron_end" );
      
      end;
      
      private.clk_trihedron = false;
      
      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_storage_groundfloor", 0, "", 0 );
      
      ObjSet( "obj_groundfloor_storage_glass", { alp = 0 } );
      ObjSet( "anm_groundfloor_glass_open", { alp = 1, playing = true, endtrig = func_after } );
      
    end;
    
  end;
  
  subroom.Define( "zz_slidingdoors" );
  
  function zz_slidingdoors.PreOpen()
    if cmn.IsEventDone("get_coldsource") then
      ObjSet("obj_slidingdoors_use_coldsource",{ event_mdown = function() common_impl.ShowBbt( 'bbt_slidingdoors_use_coldsource_next' ); end; }); 
    end;
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_groundfloor();
  
  private.PlayShineAnim(1);
  private.PlayShineAnim(2);

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_groundfloor_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "vid_groundfloor_late" ) then

    
    ObjSet( "rm_groundfloor", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjSet( "tmr_groundfloor_late",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_groundfloor_late(); end
    } );

  end;
    
end;
--*********************************************************************************************************************
function public.Close()
  
  ObjSet( "tmr_groundfloor_shine_1", { playing = false } );
  ObjSet( "tmr_groundfloor_shine_2", { playing = false } );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_2_3()

  local item = "inv_elf_2_1";

  if ( common.ApplyObj( item, "obj_stair_use_elf_2_3", true ) and cmn.IsEventDone( "use_clippers_1" ) and common_impl.groundfloor.note == "close" ) then

    cmn.CallEventHandler( "use_elf_2_3_inv" );
    cmn.CallEventHandler( "use_elf_2_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_2_3" );
      cmn.CallEventHandler( "use_elf_2_3_end" );
      
      ObjSet( "spr_stair_elf", { alp = 1 });
      
      interface.InventoryItemAdd( "inv_elf_2_1", "spr_stair_elf", nil, "video" );
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
      
    end;

    common_impl.Lock( true );
   
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_stair_use_elf", 0, "", 0 );
    
    VidPlay( "vid_stair_elf", func_after );
    
    interface.InventoryItemRemove( "inv_elf_2_1" ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_groundfloor_stair", false ) and cmn.IsEventDone( "use_clippers" ) and not cmn.IsEventDone( "use_elf_2_3" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stair", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clippers_1()

  local item = "inv_clippers";
 
  if ( common.ApplyObj( item, "obj_stair_use_clippers", true ) ) then

    cmn.CallEventHandler( "use_clippers_1_inv" );
    cmn.CallEventHandler( "use_clippers_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_clippers_1" );
      cmn.CallEventHandler( "use_clippers_1_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_clippers_stair", 0, "", 0 );
  
  AnimPlay( "anm_stair_nippers", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_groundfloor_stair", false ) and not cmn.IsEventDone( "use_clippers_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stair", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_trihedron()

  local item = "inv_trihedron";

  if ( common.ApplyObj( item, "obj_storage_use_trihedron", true ) ) then

    cmn.CallEventHandler( "use_trihedron_inv" );
    cmn.CallEventHandler( "use_trihedron_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_trihedron" );
      cmn.CallEventHandler( "use_trihedron_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_trihedron_storage", 0, "", 0 );
    
    ObjAnimate( "spr_storage_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_groundfloor_storage", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coldsource()

  local item = "inv_coldsource";

  if ( common.ApplyObj( item, "obj_slidingdoors_use_coldsource", true ) ) then

    cmn.CallEventHandler( "use_coldsource_inv" );
    cmn.CallEventHandler( "use_coldsource_beg" );

    local func_after = function ()
        
        common_impl.Lock( false );
        cmn.SetEventDone( "use_coldsource" );
        cmn.CallEventHandler( "use_coldsource_end" );
        ng_global.progress[ ng_global.currentprogress ].common.currentroom = "rm_storageexit";
        common.LevelSwitch( "level3" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_slidingdoors_use_ice", 0, "", 0 );
    
    AnimPlay( "anm_slidingdoors_gold", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_groundfloor_slidingdoors", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_slidingdoors", nil, { 512, 384 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_button_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_2_2" );
  cmn.CallEventHandler( "get_button_2_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_bartendersbadge()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bartendersbadge" );
  cmn.CallEventHandler( "get_bartendersbadge" );

end;
-------------------------------------------------------------------------------------------
function private.get_collect_2_2_3()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_3");
    cmn.CallEventHandler("get_collect_2_2_3");

  end;

  common_impl.PlayEffectHO( "spr_stairs_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_trihedron()

  cmn.CallEventHandler( "clk_trihedron_beg" );

  local func_after = function ()
  
    local func_end = function ()
  
      common_impl.Lock( false );
      --cmn.SetEventDone( "clk_trihedron" );
      --cmn.CallEventHandler( "clk_trihedron_end" );
      
      private.clk_trihedron = true;
      
      common.CloseSubRoom();
    
    end;
    
    ObjAnimate( "obj_storage_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_trihedron_storage", 0, "", 0 );
  
  ObjAnimate( "spr_storage_key_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  
  ObjAnimate( "spr_storage_key_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_robot()
  
   local func_after = function()
   
     common_impl.Lock( false );
  
   end;
  
   common_impl.Lock( true );
   
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_robot_groundfloor", 0, "", 0 );
  
   AnimPlay( "anm_groundfloor_robot", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_grille()
  
   local func_after = function()
   
     common_impl.Lock( false );
  
   end;
  
   common_impl.Lock( true );
   
   common_impl.ShowBbt( "bbt_stair_use_clippers", 1 );
   
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_grille_stair", 0, "", 0 );
  
   ObjAnimate( "anm_stair_nippers", "pos_xy", 0, 0, func_after, { 0,0,-237,-243, 0.3,0,-237,-245, 0.6,0,-237,-243  } );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_groundfloor()

  if not ( cmn.IsEventDone( "opn_groundfloor" ) ) then
    cmn.SetEventDone( "opn_groundfloor" );
  end;
  
  cmn.CallEventHandler( "opn_groundfloor" ); 

end;
--*********************************************************************************************************************
function private.vid_groundfloor_late()

  local func_after = function ( skip )

    ObjSet( "rm_groundfloor", { color_r = 1, color_g = 1, color_b = 1 } );
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_groundfloor_late" );
    cmn.CallEventHandler( "vid_groundfloor_late_end" );
    common_impl.ShowBbt( 'bbt_vid_groundfloor_late', 1 );
    
    common_impl.AddPageDiary( 9 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level2/aud_groundfloor_late", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level2/aud_groundfloor_late_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
    common_impl.SetSoundTimer( 47, "mus", "common/audio/aud_adventure2_mus" );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_groundfloor_late", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level2/aud_groundfloor_late_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_groundfloor_late", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_groundfloor_late", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.PlayShineAnim( num )
  
  local func_after = function()
  
    ObjSet( "tmr_groundfloor_shine_"..num, { time = 2*num, playing = true, endtrig = function() private.PlayShineAnim( num ); end } );
  
  end;
  
  if num ~= 2 or ( num == 2 and not cmn.IsEventDone( "clk_trihedron" ) ) then
  
    AnimPlay( "anm_groundfloor_shine_"..num, "DoAnim", func_after );
    
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_groundfloor_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
ObjAnimate( "spr_groundfloor_light_door", "alp", 1, 0, "", { 0,0,0.5, 0.5,0,1, 1,0,0.5 } );
ObjAnimate( "spr_groundfloor_glass_add", "alp", 1, 0, "", { 0,0,1, 2,0,0.6, 4,0,1 } );

ObjAnimate( "spr_stair_hotspot", "alp", 1, 0, "", { 0,0,1, 0.5,0,0.5, 1,0,1 } );

