-- name=rm_wheelbarrow
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_wheelbarrow";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_glovescompartment", "room_hub" );
  ObjAttach( "zz_seat_2", "room_hub" );
  ObjAttach( "zz_wheel", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_glovescompartment_chisel", { event_mdown = private.get_chisel }},
  { "spr_seat_2_nightsymbol", { event_mdown = private.get_brokennightsymbol }},
  { "spr_seat_2_nailpuller", { event_mdown = private.get_nailpuller }},
  { "spr_seat_2_screwdriver_2_1", { event_mdown = private.get_screwdriver_2_1 }},
  { "spr_seat_2_bottle_2_1", { event_mdown = private.get_bottle_2_1 }},
  { "anm_wheel_wire_2_2", { event_mdown = private.get_wire_2_2 }},
  { "spr_wheelbarrow_button_2", { event_mdown = private.get_button_2 }},
  { "obj_seat_2_use_handle_2", { event_mdown = private.clk_seat }},
  { "spr_seat_2_seet", { event_mdown = private.clk_seat }},
  { "obj_seat_2_use_toolsymbol", { event_mdown = private.clk_boxdoor }},
  { "obj_seat_2_clk_bitten", { event_mdown = private.clk_bitten }},
  { "spr_glovescompartment_button", { event_mdown = private.clk_button_2 } },
  { "obj_wheelbarrow_clk_visor", { event_mdown = private.clk_visor } },
  { "obj_wheelbarrow_clk_handle", { event_mdown = private.clk_handle } },
  { "obj_seat_2_clk_handle", { event_mdown = private.clk_handle_2 } },
  { "obj_wheelbarrow_clk_chisel", { event_mdown = private.clk_chisel } },
  { "obj_wheelbarrow_clk_wheel", { event_mdown = function() private.clk_anim( "wheel" ); end } },
  { "obj_wheelbarrow_clk_mirror", { event_mdown = function() private.clk_anim( "mirror" ); end } },
  { "obj_wheelbarrow_clk_spring_1", { event_mdown = function() private.clk_anim( "spring_1" ); end } },
  { "obj_wheelbarrow_clk_spring_2", { event_mdown = function() private.clk_anim( "spring_2" ); end } },
  { "obj_wheelbarrow_clk_wire", { event_mdown = function() private.clk_anim( "wire" ); end } },
  { "obj_wheel_use_englishbadge", { event_mdown = private.clk_fee } },
  { "obj_wheel_use_clippers", { event_mdown = private.clk_wire } },
  { "obj_glovescompartment_use_button_2", { event_mdown = private.clk_compartment_wire } },
  { "spr_glovescompartment_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_glovescompartment_note" );common_impl.ShowBbt( 'bbt_glovescompartment_note', 1 ); end }},    
  { "spr_glovescompartment_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_glovescompartment_note" ); end } },
  { "spr_glovescompartment_collect_2", { event_mdown = function () private.get_collect_2_2_7(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_wheelbarrow = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gzz_wheelbarrow_seat_2",
    "gzz_wheelbarrow_glovescompartment",
    "gzz_wheelbarrow_wheel"  
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_glovescompartment",
    "zz_seat_2",
    "zz_wheel"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_wheelbarrow", update_game_mode_wheelbarrow, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_wheelbarrow = function ()

  local effects_table = 
  {
    "obj_wheelbarrow_anim",
    "spr_wheel_trinket",
    "spr_wheel_light"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_wheelbarrow", update_performance_mode_wheelbarrow, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_wheelbarrow () end;
  --------------------------------------------------------------------------------------------
  local opn_wheelbarrow_map = function ()

    common_impl.VisitMapRoom( "wheelbarrow" );

  end;

  local opn_wheelbarrow_clk = function ()

    if ng_global.progress[ "std" ]["opn_wheelbarrow"].clk_bitten  and not cmn.IsEventDone("use_handle_2") then
    
      ObjSet( "spr_seat_2_bitten_1", { alp = 1 });
      ObjSet( "spr_seat_2_bitten_2", { alp = 1 });
      ObjDelete( "obj_seat_2_clk_bitten" );
      
    elseif ng_global.progress[ "std" ]["opn_wheelbarrow"].clk_bitten  and cmn.IsEventDone("use_handle_2") then
      
      ObjSet( "spr_seat_2_bitten_2", { alp = 1 });
      ObjDelete( "obj_seat_2_clk_bitten" );
      
    end;

  end;
    
  cmn.AddSubscriber( "opn_wheelbarrow", opn_wheelbarrow_map );
  cmn.AddSubscriber( "opn_wheelbarrow", opn_wheelbarrow_clk, private.room_objname );
  cmn.AddSubscriber( "opn_wheelbarrow_clk", opn_wheelbarrow_clk, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel" ] = {
    type = "get",
    get_obj = "spr_glovescompartment_chisel",
    room = private.room_objname,
    zz = "zz_glovescompartment",
    zz_gate = "gzz_wheelbarrow_glovescompartment"
  };
    
  local get_chisel_inv = function ()
  
    interface.InventoryItemAdd( "inv_chisel", "spr_glovescompartment_chisel" );
  
  end;
  
  local get_chisel_closezz = function ()
  
    ObjDelete( "gfx_glovescompartment_chisel" );
    ObjDelete( "spr_glovescompartment_chisel_shadow" );
    ObjSet( "spr_glovescompartment_note", { input = true } );
    
    ObjDelete( "spr_wheelbarrow_chisel" );
    
  end;
  
  cmn.AddSubscriber( "get_chisel", get_chisel_inv );
  cmn.AddSubscriber( "get_chisel", get_chisel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokennightsymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokennightsymbol" ] = {
    type = "get",
    get_obj = "spr_seat_2_nightsymbol",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
    
  local get_brokennightsymbol_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokennightsymbol", "spr_seat_2_nightsymbol" );
    ObjSet( "inv_brokennightsymbol", { drag = false } );
    
    
  end;
  
  local get_brokennightsymbol_closezz = function ()
  
    ObjDelete( "gfx_seat_2_nightsymbol" );
    ObjDelete( "spr_seat_2_nightsymbol_shadow" );
    
    if( cmn.IsEventDone("get_bottle_2_1") and cmn.IsEventDone("get_nailpuller")
      and cmn.IsEventDone("get_screwdriver_2_1") )then
      
      ObjDelete( "gzz_wheelbarrow_seat_2" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_brokennightsymbol", get_brokennightsymbol_inv );
  cmn.AddSubscriber( "get_brokennightsymbol", get_brokennightsymbol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nailpuller () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nailpuller" ] = {
    type = "get",
    get_obj = "spr_seat_2_nailpuller",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
    
  local get_nailpuller_inv = function ()
  
    interface.InventoryItemAdd( "inv_nailpuller", "spr_seat_2_nailpuller" );
  
  end;
  
  local get_nailpuller_closezz = function ()
  
    ObjDelete( "gfx_seat_2_nailpuller" );
    ObjDelete( "spr_seat_2_nailpuller_shadow" );
    ObjDelete( "spr_wheelbarrow_nailpuller" );
    
    if( cmn.IsEventDone("get_bottle_2_1") and cmn.IsEventDone("get_brokennightsymbol")
      and cmn.IsEventDone("get_screwdriver_2_1") )then
      
      ObjDelete( "gzz_wheelbarrow_seat_2" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_nailpuller", get_nailpuller_inv );
  cmn.AddSubscriber( "get_nailpuller", get_nailpuller_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver_2_1" ] = {
    type = "get",
    get_obj = "spr_seat_2_screwdriver_2_1",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
    
  local get_screwdriver_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver_2_1", "spr_seat_2_screwdriver_2_1" );
  
  end;
  
  local get_screwdriver_2_1_closezz = function ()
  
    ObjDelete( "gfx_seat_2_screwdriver_2_1" );    
    ObjDelete( "spr_wheelbarrow_screwdriver" );
    
    if( cmn.IsEventDone("get_nailpuller") and cmn.IsEventDone("get_brokennightsymbol")
      and cmn.IsEventDone("get_bottle_2_1") )then
      
      ObjDelete( "gzz_wheelbarrow_seat_2" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_screwdriver_2_1", get_screwdriver_2_1_inv );
  cmn.AddSubscriber( "get_screwdriver_2_1", get_screwdriver_2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_2_1" ] = {
    type = "get",
    get_obj = "spr_seat_2_bottle_2_1",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
    
  local get_bottle_2_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_2_1", "spr_seat_2_bottle_2_1" );
  
  end;
  
  local get_bottle_2_1_closezz = function ()
  
    ObjDelete( "gfx_seat_2_bottle_2_1" );
    ObjDelete( "spr_seat_2_bottle_2_1_shadow" );
    
    ObjDelete( "spr_wheelbarrow_bottle" );
    
    if( cmn.IsEventDone("get_nailpuller") and cmn.IsEventDone("get_brokennightsymbol")
      and cmn.IsEventDone("get_screwdriver_2_1") )then
      
      ObjDelete( "gzz_wheelbarrow_seat_2" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bottle_2_1", get_bottle_2_1_inv );
  cmn.AddSubscriber( "get_bottle_2_1", get_bottle_2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire_2_2" ] = {
    type = "get",
    get_obj = "spr_wheel_wire_2_2",
    room = private.room_objname,
    zz = "zz_wheel",
    zz_gate = "gzz_wheelbarrow_wheel"
  };
    
  local get_wire_2_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_wire_2_2", "anm_wheel_wire_2_2" );
  
  end;
  
  local get_wire_2_2_closezz = function ()
  
    ObjDelete( "gfx_wheel_wire_2_2" );
    ObjDelete( "spr_wheel_wire_2_2_shadow" );
    ObjDelete( "gzz_wheelbarrow_wheel" );
    
    ObjDelete( "spr_wheelbarrow_wire" );
  
  end;
  
  cmn.AddSubscriber( "get_wire_2_2", get_wire_2_2_inv );
  cmn.AddSubscriber( "get_wire_2_2", get_wire_2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_2" ] = {
    type = "get",
    get_obj = "spr_wheelbarrow_button_2",
    room = private.room_objname
  };
    
  local get_button_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_2", "spr_wheelbarrow_button_2" );
  
  end;
  
  local get_button_2_closezz = function ()
  
    ObjDelete( "gfx_wheelbarrow_button_2" );
    ObjDelete( "spr_wheelbarrow_button_shadow" );
    --ObjSet( "obj_wheelbarrow_visor", { input = false } );
  
  end;
  
  cmn.AddSubscriber( "get_button_2", get_button_2_inv );
  cmn.AddSubscriber( "get_button_2", get_button_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_7 = function ()
 
    ObjDelete( "spr_glovescompartment_collect_2" );
    ObjDelete( "spr_glovescompartment_collect_2_shadow" );
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_7", get_collect_2_2_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2" ] = {
    type = "use",
    inv_obj = "inv_button_2",
    use_place = "obj_glovescompartment_use_button_2",
    room = private.room_objname,
    zz = "zz_glovescompartment",
    zz_gate = "gzz_wheelbarrow_glovescompartment"
  };
  local use_button_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_2" );
  
  end;
  local use_button_2_beg = function ()
  
    ObjDelete( "obj_glovescompartment_use_button_2" );
  
  end;
  local use_button_2_end = function ()
  
    ObjSet( "spr_glovescompartment_button", { alp = 1, input = true } );
    ObjSet( "spr_wheelbarrow_button_1", { alp = 1 } );
    
    ObjDelete( "obj_glovescompartment_wire" );
    
    ObjDelete( "spr_wheelbarrow_wires" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_2", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2", use_button_2_inv );
  cmn.AddSubscriber( "use_button_2", use_button_2_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_inv", use_button_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_beg", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_end", use_button_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle_2" ] = {
    type = "use",
    inv_obj = "inv_handle_2",
    use_place = "obj_seat_2_use_handle_2",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
  local use_handle_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_handle_2" );
  
  end;
  local use_handle_2_beg = function ()
  
    ObjDelete( "obj_seat_2_use_handle_2" );
  
  end;
  local use_handle_2_end = function ()
  
    --ObjDelete( "spr_seat_2_seet" );
    --ObjSet( "spr_seat_2_nailpuller", { input = true, active = true } );
    --ObjSet( "obj_seat_2_use_toolsymbol", { input = true } );
    --ObjSet( "obj_seat_2_clk_bitten", { pos_x = -182, pos_y = -175 } );
    --ObjDelete( "spr_wheelbarrow_seat" );
    ObjSet( "obj_seat_2_clk_handle", { input = true, active = true });
    ObjSet( "spr_seat_2_lever", { alp = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle_2", use_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_2", use_handle_2_inv );
  cmn.AddSubscriber( "use_handle_2", use_handle_2_end, private.room_objname );
  cmn.AddSubscriber( "use_handle_2_inv", use_handle_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle_2_beg", use_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_2_end", use_handle_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toolsymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toolsymbol" ] = {
    type = "use",
    inv_obj = "inv_toolsymbol",
    use_place = "obj_seat_2_use_toolsymbol",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
  local use_toolsymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_toolsymbol" );
  
  end;
  local use_toolsymbol_beg = function ()
  
    ObjDelete( "obj_seat_2_use_toolsymbol" );
  
  end;
  local use_toolsymbol_end = function ()
  
    ObjDelete( "spr_seat_2_close_door" );
    ObjSet( "spr_seat_2_screwdriver_2_1", { input = true, active = true } );
    ObjSet( "spr_seat_2_bottle_2_1", { input = true, active = true } );
    
    ObjDelete( "spr_wheelbarrow_seat_door" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toolsymbol", use_toolsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolsymbol", use_toolsymbol_inv );
  cmn.AddSubscriber( "use_toolsymbol", use_toolsymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_toolsymbol_inv", use_toolsymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_toolsymbol_beg", use_toolsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolsymbol_end", use_toolsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_wheel_use_clippers",
    room = private.room_objname,
    zz = "zz_wheel",
    zz_gate = "gzz_wheelbarrow_wheel"
  };
  local use_clippers_inv = function ()
  
    --interface.InventoryItemRemove( "inv_clippers" );
  
  end;
  local use_clippers_beg = function ()
  
    ObjDelete( "obj_wheel_use_clippers" );
  
  end;
  local use_clippers_end = function ()
  
    ObjSet( "anm_wheel_wire_2_2", { input = true, frame = 300 } );
    ObjSet( "gfx_wheel_wire_2_2", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers", use_clippers_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers", use_clippers_inv );
  cmn.AddSubscriber( "use_clippers", use_clippers_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_inv", use_clippers_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_beg", use_clippers_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_end", use_clippers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_englishbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_englishbadge" ] = {
    type = "use",
    inv_obj = "inv_englishbadge",
    use_place = "obj_wheel_use_englishbadge",
    room = private.room_objname,
    zz = "zz_wheel",
    zz_gate = "gzz_wheelbarrow_wheel"
  };
  local use_englishbadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_englishbadge" );
  
  end;
  local use_englishbadge_beg = function ()
  
    ObjDelete( "obj_wheel_use_englishbadge" );
  
  end;
  local use_englishbadge_end = function ()
  
    ObjDelete( "obj_wheel_fee" );
    ObjDelete( "vid_wheel_englishbadge" );
    ObjSet( "obj_wheel_use_clippers", { input = true } );
    ObjSet( "spr_wheelbarrow_wire", { alp = 1 } );
    ObjDelete( "spr_wheelbarrow_cover" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_englishbadge", use_englishbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_englishbadge", use_englishbadge_inv );
  cmn.AddSubscriber( "use_englishbadge", use_englishbadge_end, private.room_objname );
  cmn.AddSubscriber( "use_englishbadge_inv", use_englishbadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_englishbadge_beg", use_englishbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_englishbadge_end", use_englishbadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel" ] = {
    type = "use",
    inv_obj = "inv_chisel",
    use_place = "obj_wheelbarrow_use_chisel",
    room = private.room_objname,
    
  };
  local use_chisel_inv = function ()
  
    interface.InventoryItemRemove( "inv_chisel" );
  
  end;
  local use_chisel_beg = function ()
  
    ObjDelete( "obj_wheelbarrow_use_chisel" );
  
  end;
  local use_chisel_end = function ()
  
    ObjSet( "spr_wheelbarrow_door_chisel", { alp = 1 } );
  
    ObjSet( "obj_wheelbarrow_clk_chisel", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel", use_chisel_inv );
  cmn.AddSubscriber( "use_chisel", use_chisel_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_inv", use_chisel_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_beg", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_end", use_chisel_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_2" ] = {
    type = "click",
    use_place = "spr_glovescompartment_button",
    room = private.room_objname,
    zz = "zz_glovescompartment",
    zz_gate = "gzz_wheelbarrow_glovescompartment"
  };
 
  local clk_button_2_beg = function ()
  
  end;
  local clk_button_2_end = function ()
  
    ObjDelete( "spr_glovescompartment_button" );
    ObjSet( "spr_glovescompartment_open", { input = true, alp = 1 } );
    
    ObjDelete( "spr_wheelbarrow_button_1" );
    ObjSet( "spr_wheelbarrow_open", { alp = 1 } );
    ObjSet("spr_glovescompartment_collect_2", { input = true });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_2", clk_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_2", clk_button_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_2_beg", clk_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_2_end", clk_button_2_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_visor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_visor" ] = {
    type = "click",
    use_place = "obj_wheelbarrow_clk_visor",
    room = private.room_objname
  };
 
  local clk_visor_beg = function ()
  
    ObjSet( "obj_wheelbarrow_clk_visor", { input = false } );
  
  end;
  local clk_visor_end = function ()
  
    ObjDelete( "spr_wheelbarrow_visor_1" );
    ObjDelete( "obj_wheelbarrow_clk_visor" );
    ObjSet( "obj_wheelbarrow_visor", { input = true } );
    ObjSet( "spr_wheelbarrow_visor_2", { alp = 1 } );
    ObjSet( "gfx_wheelbarrow_button_2", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_visor", clk_visor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_visor", clk_visor_end, private.room_objname );
  cmn.AddSubscriber( "clk_visor_beg", clk_visor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_visor_end", clk_visor_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle" ] = {
    type = "click",
    use_place = "obj_wheelbarrow_clk_handle",
    room = private.room_objname
  };
 
  local clk_handle_beg = function ()
  
    ObjSet( "obj_wheelbarrow_clk_handle", { input = false } );
  
  end;
  local clk_handle_end = function ()
  
    ObjDelete( "spr_wheelbarrow_pen" );
    ObjDelete( "obj_wheelbarrow_clk_handle" );
    ObjDelete( "anm_wheelbarrow_handle" );
    
    ObjSet( "obj_wheelbarrow_use_chisel", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle", clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle", clk_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_beg", clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_end", clk_handle_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chisel" ] = {
    type = "click",
    use_place = "obj_wheelbarrow_clk_chisel",
    room = private.room_objname
  };
 
  local clk_chisel_beg = function ()
  
    ObjSet( "obj_wheelbarrow_clk_chisel", { input = false } );
  
  end;
  local clk_chisel_end = function ()
  
    ObjDelete( "obj_wheelbarrow_clk_chisel" );
  
    ObjSet( "grm_wheelbarrow_atbar", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_wheelbarrow_atbar_focus");
    end;    
    ObjDelete( "spr_wheelbarrow_door_chisel" );
    ObjDelete( "anm_wheelbarrow_open_door" );
    ObjSet( "obj_wheelbarrow_open_door", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chisel", clk_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chisel", clk_chisel_end, private.room_objname );
  cmn.AddSubscriber( "clk_chisel_beg", clk_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chisel_end", clk_chisel_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_handle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle_2" ] = {
    type = "click",
    use_place = "obj_seat_2_clk_handle",
    room = private.room_objname,
    zz = "zz_seat_2",
    zz_gate = "gzz_wheelbarrow_seat_2"
  };
 
  local clk_handle_2_beg = function ()
  
    ObjDelete( "obj_seat_2_clk_handle");
  
  end;
  local clk_handle_2_end = function ()
  
  --  ObjDelete( "obj_wheelbarrow_clk_chisel" );
  --
  --  ObjSet( "grm_wheelbarrow_atbar", { input = true, active = true } );
  --  
  --  ObjDelete( "spr_wheelbarrow_door_chisel" );
  --  ObjDelete( "anm_wheelbarrow_open_door" );
  --  ObjSet( "obj_wheelbarrow_open_door", { alp = 1 } );
    ObjDelete( "spr_seat_2_seet" );
    ObjSet( "spr_seat_2_nailpuller", { input = true, active = true } );
    ObjSet( "obj_seat_2_use_toolsymbol", { input = true } );
    ObjSet( "obj_seat_2_clk_bitten", { pos_x = -182, pos_y = -175 } );
    ObjDelete( "spr_wheelbarrow_seat" );
  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle_2", clk_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2", clk_handle_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2_beg", clk_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2_end", clk_handle_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_niwtyaki() end;
  --------------------------------------------------------------------------------------------
  local clk_niwtyaki_beg = function ()
  
    ObjDelete( "obj_seat_2_clk_bitten" );
  
  end;
  local clk_niwtyaki_end = function ()
  
    ObjSet( "spr_wheelbarrow_beat", { alp = 1 });
    if not cmn.IsEventDone("use_handle_2") then
    
      ObjSet( "spr_seat_2_bitten_1", { alp = 1 } );
      ObjSet( "spr_wheelbarrow_beat", { pos_x = 296, pos_y = 680})
    
    else

      ObjSet( "spr_seat_2_bitten_2", { alp = 1 } );
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_niwtyaki", clk_niwtyaki_beg, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki", clk_niwtyaki_end, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki_beg", clk_niwtyaki_beg, private.room_objname );
  cmn.AddSubscriber( "clk_niwtyaki_end", clk_niwtyaki_end, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_glovescompartment" );
  --------------------------------------------------------------------------------------------
  function zz_glovescompartment.PreOpen()

    if not common_impl.wheelbarrow then

      common_impl.wheelbarrow = {}
      common_impl.wheelbarrow.note = "close";

    end;

    if  ObjGet( "spr_glovescompartment_note" ).input == true then

      ObjSet( "spr_glovescompartment_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_glovescompartment_note",     { alp = 1 } );
      
    end;

  end;
  
  --------------------------------------------------------------------------------------------
  
  function zz_glovescompartment.Close()

    common_impl.wheelbarrow.note = "close"; 

  end;
  --------------------------------------------------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_wheelbarrow();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  common_impl.ShowBbt( "bbt_vid_wheelbarrow_trip" );
  
  common_impl.EnvPlay( { "common/audio/level2/aud_wheelbarrow_env" }, "", 0.5 );
  
  --common_impl.MorphItemMorphing();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  private.StopAnims();
  
end;
--*********************************************************************************************************************
function public.PreClose()
 
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_button_2()

  local item = "inv_button_2";

  if ( common.ApplyObj( item, "obj_glovescompartment_use_button_2", true ) ) then

    cmn.CallEventHandler( "use_button_2_inv" );
    cmn.CallEventHandler( "use_button_2_beg" );

    local func_after = function ()
   
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_2" );
      cmn.CallEventHandler( "use_button_2_end" );
   
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_button_glovescompartment", 0, "", 0 );
    
    ObjAnimate( "spr_glovescompartment_button", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_wheelbarrow_glovescompartment", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_glovescompartment", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_handle_2()

  local item = "inv_handle_2";

  if ( common.ApplyObj( item, "obj_seat_2_use_handle_2", true ) ) then

    cmn.CallEventHandler( "use_handle_2_inv" );
    cmn.CallEventHandler( "use_handle_2_beg" );

    local func_after = function ()
    
    -- local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_handle_2" );
        cmn.CallEventHandler( "use_handle_2_end" );
        
      end;
      
    --  ObjAnimate( "spr_seat_2_seet", "alp", 0, 0, func_end,
    --  { 
    --    0.0, 0, 1.0, 
    --    0.3, 0, 0.0
    --  } );
    --
    -- end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_handle_seat_2", 0, "", 0 );
    
    ObjAnimate( "spr_seat_2_lever", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_wheelbarrow_seat_2", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_seat_2", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toolsymbol()

  local item = "inv_toolsymbol";

  if ( common.ApplyObj( item, "obj_seat_2_use_toolsymbol", true ) and cmn.IsEventDone("use_handle_2") ) then

    cmn.CallEventHandler( "use_toolsymbol_inv" );
    cmn.CallEventHandler( "use_toolsymbol_beg" );

    local func_after = function ()
    
      local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_toolsymbol" );
        cmn.CallEventHandler( "use_toolsymbol_end" );
        
      end; 
      
      ObjAnimate( "spr_seat_2_close_door", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0, 124, 61, 
        0.5, 0, 402, 153
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_toolsymbol_seat_2", 0, "", 0 );
    
    ObjAnimate( "spr_seat_2_close_door_amulet", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_wheelbarrow_seat_2", false ) and cmn.IsEventDone("use_handle_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_seat_2", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clippers()

  local item = "inv_clippers";

  if ( common.ApplyObj( item, "obj_wheel_use_clippers", true ) and cmn.IsEventDone( "use_englishbadge" )) then

    cmn.CallEventHandler( "use_clippers_inv" );
    cmn.CallEventHandler( "use_clippers_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_clippers" );
      cmn.CallEventHandler( "use_clippers_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_clippers_wheel", 0, "", 0 );
    
    AnimPlay( "anm_wheel_wire_2_2", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_wheelbarrow_wheel", false ) and cmn.IsEventDone("use_englishbadge") and not cmn.IsEventDone( "use_clippers" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheel", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_englishbadge()

  local item = "inv_englishbadge";

  if ( common.ApplyObj( item, "obj_wheel_use_englishbadge", true ) ) then

    cmn.CallEventHandler( "use_englishbadge_inv" );
    cmn.CallEventHandler( "use_englishbadge_beg" );

    local func_after = function ()
    
      local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_englishbadge" );
        cmn.CallEventHandler( "use_englishbadge_end" );
        
      end;
      
      ObjAnimate( "obj_wheel_fee", "ang", 0, 0, "",
      { 
        0.0, 0,  0, 
        0.5, 0,  1
      } );
      
      ObjAnimate( "obj_wheel_fee", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0,  34,  18, 
        0.5, 0, 160, 295
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_wheel_screw", 0, "", 0 );
    VidPlay( "vid_wheel_englishbadge", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_wheelbarrow_wheel", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheel", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel()

  local item = "inv_chisel";
  
  DbgTrace( "use_chisel" );

  if ( common.ApplyObj( item, "obj_wheelbarrow_use_chisel", false ) and cmn.IsEventDone( "clk_handle" ) ) then

    cmn.CallEventHandler( "use_chisel_inv" );
    cmn.CallEventHandler( "use_chisel_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chisel" );
      cmn.CallEventHandler( "use_chisel_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_use_chisel_wheelbarrow", 0, "", 0 );
  
    --ObjAnimate( "spr", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
  
  return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_chisel()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_brokennightsymbol()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokennightsymbol" );
  cmn.CallEventHandler( "get_brokennightsymbol" );
  
  if( cmn.IsEventDone("get_bottle_2_1") and cmn.IsEventDone("get_nailpuller")
    and cmn.IsEventDone("get_screwdriver_2_1") )then
      
    common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_nailpuller()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nailpuller" );
  cmn.CallEventHandler( "get_nailpuller" );
  
  if( cmn.IsEventDone("get_bottle_2_1") and cmn.IsEventDone("get_brokennightsymbol")
    and cmn.IsEventDone("get_screwdriver_2_1") )then
      
    common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_screwdriver_2_1" );
  cmn.CallEventHandler( "get_screwdriver_2_1" );
  
  if( cmn.IsEventDone("get_bottle_2_1") and cmn.IsEventDone("get_brokennightsymbol")
    and cmn.IsEventDone("get_nailpuller") )then
      
    common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bottle_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottle_2_1" );
  cmn.CallEventHandler( "get_bottle_2_1" );
  
  if( cmn.IsEventDone("get_screwdriver_2_1") and cmn.IsEventDone("get_brokennightsymbol")
    and cmn.IsEventDone("get_nailpuller") )then
      
    common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_wire_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_wire_2_2" );
  cmn.CallEventHandler( "get_wire_2_2" );
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_button_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_2" );
  cmn.CallEventHandler( "get_button_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_2_7()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_7");
    cmn.CallEventHandler("get_collect_2_2_7");

  end;

  common_impl.PlayEffectHO( "spr_glovescompartment_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--------------------------------------------------------------------------------------------
function private.clk_button_2()

  cmn.CallEventHandler( "clk_button_2_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_button_2" );
    cmn.CallEventHandler( "clk_button_2_end" );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_button_glovescompartment", 0, "", 0 );
    
  ObjAnimate( "spr_glovescompartment_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.6, 0, 1.0  
  } );
  
  ObjAnimate( "spr_glovescompartment_button", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 1.0,
    0.6, 0, 0.0 
  } );
  
  ObjAnimate( "spr_glovescompartment_button_press", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.clk_visor()

  cmn.CallEventHandler( "clk_visor_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_visor" );
    cmn.CallEventHandler( "clk_visor_end" );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_visor_wheelbarrow", 0, "", 0 );
    
  ObjAnimate( "spr_wheelbarrow_visor_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0,
    
  } );
  
  ObjAnimate( "spr_wheelbarrow_visor_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
  
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_handle()

  cmn.CallEventHandler( "clk_handle_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_handle" );
    cmn.CallEventHandler( "clk_handle_end" );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_handle_wheelbarrow", 0, "", 0 );
    
  ObjSet( "anm_wheelbarrow_handle", { alp = 1, playing = true, endtrig = func_after } );
  ObjSet( "spr_wheelbarrow_pen", { alp = 0 } );
  
end;

--------------------------------------------------------------------------------------------
function private.clk_handle_2()

  cmn.CallEventHandler( "clk_handle_2_beg" );
  
  local func_after = function () 
  
  local func_end = function () 
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_handle_2" );
      cmn.CallEventHandler( "clk_handle_2_end" );
      
    end;
  
     ObjAnimate( "spr_seat_2_seet", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
  end; 
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_handle_wheelbarrow", 0, "", 0 );
    
  --ObjSet( "anm_wheelbarrow_handle", { alp = 1, playing = true, endtrig = func_after } );
  --ObjSet( "spr_wheelbarrow_pen", { alp = 0 } );
  ObjAnimate( "spr_seat_2_lever", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0,
    
  } );
  
  ObjAnimate( "spr_seat_2_lever_turn", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
  
  } );
  
  
end;
--------------------------------------------------------------------------------------------
function private.clk_chisel()

  cmn.CallEventHandler( "clk_chisel_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_chisel" );
    cmn.CallEventHandler( "clk_chisel_end" );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_chisel_wheelbarrow", 0, "", 0 );
  
  ObjSet( "spr_wheelbarrow_door_chisel", { alp = 0 } );
  ObjSet( "anm_wheelbarrow_open_door", { alp = 1 } );
  
  AnimPlay( "anm_wheelbarrow_open_door", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_seat()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_seat_2_use_handle_2' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_seat_seat_2", 0, "", 0 );
  
  ObjAnimate( "spr_seat_2_seet", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 53, 
    0.4, 0, 50,
    0.8, 0, 53
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_fee()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_wheel_use_englishbadge' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_fee_wheel", 0, "", 0 );
  
  ObjAnimate( "spr_wheel_fee", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 2,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_wire()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_wheel_use_clippers' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_wire_wheel", 0, "", 0 );
  
  ObjAnimate( "anm_wheel_wire_2_2", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, -2,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_anim( name )
  
  local loop = false;
  
  if ( name == "spring_1" or name == "spring_2" or name == "wire" ) then
    
    loop = true;
    
  end;
  
  local func_after = function()
  
    ObjSet( "obj_wheelbarrow_clk_"..name, { input = true } );
    
    if loop then
      
      ObjSet( "anm_wheelbarrow_"..name.."_loop", { alp = 1, playing = true } );
      ObjSet( "anm_wheelbarrow_"..name, { alp = 0 } );
      
    end;
    
  end;

  --common_impl.ShowBbt( 'bbt_wheelbarrow_'..name );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_"..name.."_wheelbarrow", 0, "", 0 );
  
  ObjSet( "obj_wheelbarrow_clk_"..name, { input = false } );
  
  if loop then
    
    ObjSet( "anm_wheelbarrow_"..name.."_loop", { alp = 0, playing = false } );
    ObjSet( "anm_wheelbarrow_"..name, { alp = 1 } );
    
  end;
  
  AnimPlay( "anm_wheelbarrow_"..name, "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function private.clk_boxdoor()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_seat_2_use_toolsymbol' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_doors_seat_2", 0, "", 0 );
  
  ObjAnimate( "spr_seat_2_close_door", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, 124, 61,
    0.4, 0, 131, 63,
    0.8, 0, 124, 61
  } ); 
  
end;
--------------------------------------------------------------------------------------------
function private.clk_compartment_wire()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
    ObjSet( "anm_glovescompartment_wire", { alp = 1, playing = true, frame = 0 } );
    ObjSet( "anm_glovescompartment_wire_2", { alp = 0 } );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_glovescompartment_use_button_2' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_wire_glovescompartment", 0, "", 0 );
  
  ObjSet( "anm_glovescompartment_wire", { alp = 0, playing = false } );
  ObjSet( "anm_glovescompartment_wire_2", { alp = 1, playing = true, endtrig = func_after } );
  
end;
-------------------------------------------------------------------------------------------
function private.clk_bitten()
  
  local func_after = function()  
  
    common_impl.Lock( false );  
    --ng_global.progress[ "std" ]["opn_wheelbarrow"].clk_bitten = true;
    cmn.SetEventDone( "clk_niwtyaki" ); 
    cmn.CallEventHandler( "clk_niwtyaki" ); 
    
  end;
  
  common_impl.Lock( true );
  
  ObjSet( "obj_seat_2_clk_bitten", { input = false });
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_bitten_seat_2", 0, "", 0 );
  
  if not cmn.IsEventDone("use_handle_2") then
  
    ObjAnimate( "spr_seat_2_bitten_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
  
  else
    
    ObjAnimate( "spr_seat_2_bitten_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    
  end; 

end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_wheelbarrow()

  if not ( cmn.IsEventDone( "opn_wheelbarrow" ) ) then
    cmn.SetEventDone( "opn_wheelbarrow" );
    interface.KeyTaskDone( 'chase_avenger', true );
    ObjSet( "rm_garage", { color_r = 1, color_b = 1, color_g = 1 } );
  end;
  
  cmn.CallEventHandler( "opn_wheelbarrow" ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.StopAnims()
  
  local list = { "spring_1", "spring_2", "wire", "wheel", "mirror" };
  
  for i = 1, #list do
    
    AnimStop( "anm_wheelbarrow_"..list[i] );
    
    ObjSet( "obj_wheelbarrow_clk_"..list[i], { input = true } );
    
    if ( ObjGet( "anm_wheelbarrow_"..list[i].."_loop" ) ) then
    
      ObjSet( "anm_wheelbarrow_"..list[i].."_loop", { alp = 1, playing = true } );
      ObjSet( "anm_wheelbarrow_"..list[i], { alp = 0 } );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_seat_2_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.4, 0, 0.6,
  0.8, 0, 1.0
} );
ObjAnimate( "spr_wheel_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.4, 0, 0.6,
  0.8, 0, 1.0
} );
ObjAnimate( "spr_wheel_trinket", "ang", 1, 0, "",
{ 
  0.0, 3, -0.03, 
  1.4, 3, 0.03,
  2.8, 3, -0.03
} );
ObjAnimate( "spr_glovescompartment_lamp_add", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.4, 0, 0.6,
  0.8, 0, 1.0
} );

ObjAnimate( "spr_wheelbarrow_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.4, 0, 0.6,
  0.8, 0, 1.0
} );

ObjAnimate( "spr_wheelbarrow_open_door_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  1.4, 0, 0.6,
  1.8, 0, 1.0
} );

