-- name=ho_boatroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "boatroom" );
  game.relations[ "ho_boatroom" ].exitroom = "rm_underbridge";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_boatroom = function ()

  local effects_table = 
  {
  --"anm_boatroom_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_boatroom", update_performance_mode_boatroom, "ho_boatroom" );
  
  private.items = ObjGetRelations( "obj_boatroom_items" ).childs;

  for i = 1, #private.items do

    local item = string.sub( private.items[i], 14 );
  
    ObjSet( "itm_boatroom_"..item, { event_menter     = function() private.PopupShow( item ); end,
                                      event_mleave     = function() interface.PopupHide(); end,
                                      event_startdrag  = function() private.StartDrag(); end,
                                      event_dragdrop   = function() private.DragDrop( item ); end } )

  end;
                                      
  ObjSet( "obj_boatroom_clk_bell", { event_mdown = private.clk_bell } );
  
  common_impl.hint[ "win_boatroom" ] = {
      type = "win",
      room = "rm_underbridge",
      zz = "ho_boatroom",
      zz_gate = "gho_underbridge_boatroom"
  };
  
  local win_boatroom_func = function ()

    if ( cmn.IsEventDone( "win_boatroom" ) ) then
      interface.InventoryItemAdd( "inv_batteries", "spr_boatroom_win" );
      ObjSet( "spr_remotecontrol_plus_light", { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "win_boatroom", win_boatroom_func );
  --------------------------------------------------------------------------------------------------
  local start_boatroom_func = function ()

    if ( cmn.IsEventStart( "win_boatroom" ) ) then
     
      local ho_found = ng_global.progress[ "std" ][ "win_boatroom" ].found;

      for i = 1, #ho_found, 1 do
        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { alp = 1 } );
        ObjSet( "obj_"..name, { input = false } );
        
        if common.GetObjectName( name ) == "key" then
         
          ObjDelete( "obj_boatroom_close" );
          ObjSet( "spr_boatroom_open", { alp = 1 } );
          
        elseif common.GetObjectName( name ) == "fish" then
    
          ObjSet( "anm_boatroom_fish", { alp = 1 } );
          
        elseif common.GetObjectName( name ) == "lace" then
    
          ObjSet( "anm_boatroom_lace", { alp = 1 } );                   
          ObjSet( "spr_boatroom_bell", { alp = 0 } );
          ObjSet( "obj_boatroom_clk_bell", { input = true } );
  
        end; 
        
      end;

    end;

  end;
  cmn.AddSubscriber( "win_boatroom", start_boatroom_func, "ho_boatroom" );  
 
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_boatroom" ) ) then
  
    cmn.InitHo( "boatroom" );
    cmn.SetEventDone( "opn_boatroom" );
  
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "amplifier" );
  interface.ItemPanelItemAdd( ho_items, "key" );
  interface.ItemPanelItemAdd( ho_items, "boot" );
  interface.ItemPanelItemAdd( ho_items, "circuit" );
  interface.ItemPanelItemAdd( ho_items, "cockade" );
  interface.ItemPanelItemAdd( ho_items, "fish" );
  interface.ItemPanelItemAdd( ho_items, "lace" );
  interface.ItemPanelItemAdd( ho_items, "lens" );
  interface.ItemPanelItemAdd( ho_items, "lightbulb" );
  interface.ItemPanelItemAdd( ho_items, "mask" );
  interface.ItemPanelItemAdd( ho_items, "matches");
  interface.ItemPanelItemAdd( ho_items, "flowers");
  
  interface.ItemPanelShow( ho_items );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
    
end;
--*********************************************************************************************************************
function public.PreClose()

   interface.ItemPanelHide();
   
   common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
 --*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  local name = common.GetObjectName( item_name );
  local item_object_name = "obj_"..name;
  local item_spr_name = "spr_"..name;
 
  ObjSet( item_object_name, { input = false } );

  ObjSet( item_spr_name, { alp = 1 } );
  
  local current_name = common.GetObjectName( name );
  
  if current_name == "fish" or current_name == "lace" then
    
    ObjSet( "anm_boatroom_"..current_name, { alp = 1, frame = 0 } );
    
    if current_name == "lace" then
      
      ObjSet( "spr_boatroom_bell", { alp = 0 } );
      ObjSet( "obj_boatroom_clk_bell", { input = true } );
      
    end;
    
  end;

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_ho_"..name, 0, "", 0 );
  
  if common.GetObjectName( name ) == "key" then
    
    local func_after = function()
    
      common_impl.Lock( false );
    
    end;
    
    common_impl.Lock( true );
    
    ObjAnimate( "spr_boatroom_key_1", "alp", 0, 0, "", { 0,0,0, 0.1,0,1, 0.3,0,1, 0.5,0,0 } );    
    ObjAnimate( "spr_boatroom_key_1", "pos_xy", 0, 0, "", { 0,0,-42,16, 0.3,0,-25, 6 } );    
    ObjAnimate( "spr_boatroom_key_2", "alp", 0, 0, "", { 0,0,0, 0.3,0,0, 0.5,0,1 } );    
    ObjAnimate( "spr_boatroom_open", "alp", 0, 0, "", { 0,0,0, 0.6,0,0, 0.9,0,1 } );    
    ObjAnimate( "obj_boatroom_close", "alp", 0, 0, func_after, { 0,0,1, 0.6,0,1, 0.9,0,0 } );
    
  end;

  interface.ItemPanelTryToComplete();

end;
--*********************************************************************************************************************
function private.PopupShow( item_name )

  interface.PopupShow("pop_boatroom_"..item_name);

end;
--*********************************************************************************************************************
function private.StartDrag()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.DragDrop( item_name )

  cmn.HoItemFind( "itm_boatroom_"..item_name );

end;
--*********************************************************************************************************************
function private.clk_bell()
  
  local func_after = function()
    
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_ho_boatroom_touch_bell", 0, "", 0 );
  
  AnimPlay( "anm_boatroom_lace", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
