-- name=ho_chestroom_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chestroom_3" );
  game.relations[ "ho_chestroom_3" ].exitroom = "rm_storageexit";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_chestroom_3 = function ()

  local effects_table = 
  {
    "obj_chestroom_3_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_chestroom_3", update_performance_mode_chestroom_3, "ho_chestroom_3" );
  
  ObjMultiSet( {
  
  { "spr_chestroom_3_deer", { event_mdown = function() private.TaskComplete( 'deer' ) end } },
  { "spr_chestroom_3_dove", { event_mdown = function() private.TaskComplete( 'dove' ) end } },
  { "spr_chestroom_3_honey", { event_mdown = function() private.TaskComplete( 'honey' ) end } },
  { "spr_chestroom_3_makeup", { event_mdown = function() private.TaskComplete( 'makeup' ) end } },
  { "spr_chestroom_3_scabbard", { event_mdown = function() private.TaskComplete( 'scabbard' ) end } },
  { "spr_chestroom_3_scroll", { event_mdown = function() private.TaskComplete( 'scroll' ) end } },
  { "spr_chestroom_3_sun", { event_mdown = function() private.TaskComplete( 'sun' ) end } },
  { "spr_chestroom_3_tear", { event_mdown = function() private.TaskComplete( 'tear' ) end } },
  { "spr_chestroom_3_thermometer", { event_mdown = function() private.TaskComplete( 'thermometer' ) end } },
  { "spr_chestroom_3_thread", { event_mdown = function() private.TaskComplete( 'thread' ) end } },
  { "spr_chestroom_3_valve", { event_mdown = function() private.TaskComplete( 'valve' ) end } },
  { "spr_chestroom_3_scarab", { event_mdown = function() private.TaskComplete( 'scarab' ) end } },
  
  } );
  
  private.tasks = { 

                  [ "spr_chestroom_3_taskpanel_deer"        ] = "spr_chestroom_3_deer",
                  [ "spr_chestroom_3_taskpanel_dove"        ] = "spr_chestroom_3_dove", 
                  [ "spr_chestroom_3_taskpanel_honey"       ] = "spr_chestroom_3_honey",
                  [ "spr_chestroom_3_taskpanel_makeup"      ] = "spr_chestroom_3_makeup", 
                  [ "spr_chestroom_3_taskpanel_scabbard"    ] = "spr_chestroom_3_scabbard",
                  [ "spr_chestroom_3_taskpanel_scroll"      ] = "spr_chestroom_3_scroll", 
                  [ "spr_chestroom_3_taskpanel_sun"         ] = "spr_chestroom_3_sun",
                  [ "spr_chestroom_3_taskpanel_tear"        ] = "spr_chestroom_3_tear", 
                  [ "spr_chestroom_3_taskpanel_thermometer" ] = "spr_chestroom_3_thermometer",
                  [ "spr_chestroom_3_taskpanel_thread"      ] = "spr_chestroom_3_thread", 
                  [ "spr_chestroom_3_taskpanel_valve"       ] = "spr_chestroom_3_valve",
                  [ "spr_chestroom_3_taskpanel_scarab"      ] = "spr_chestroom_3_scarab",

                  }
  
  private.border_coords = { -240, 240 };
  
  common_impl.hint[ "win_chestroom_3" ] = {
      type = "win",
      room = "rm_storageexit",
      zz = "ho_chestroom_3",
      zz_gate = "gho_storageexit_chestroom_3"
  };
  
  local win_chestroom_3_func = function ()

    if ( cmn.IsEventDone( "win_chestroom_3" ) ) then
      
      interface.InventoryItemAdd( "inv_valve", "spr_chestroom_3_win" );
    end;

  end;
  cmn.AddSubscriber( "win_chestroom_3", win_chestroom_3_func );
  --------------------------------------------------------------------------------------------------
  local start_chestroom_3_func = function ()

    if ( cmn.IsEventStart( "win_chestroom_3" ) ) then
     
      local ho_found = ng_global.progress[ "std" ][ "win_chestroom_3" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      private.SetTaskPanel();

    end;

  end;
  cmn.AddSubscriber( "win_chestroom_3", start_chestroom_3_func, "ho_chestroom_3" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_chestroom_3" ) ) then
  
    cmn.InitHo( "chestroom_3" );
    cmn.SetEventDone( "opn_chestroom_3" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "deer",          1, 0, { { "spr_chestroom_3_deer" } } );
  interface.TaskPanelTaskAdd( ho_items, "dove",          1, 0, { { "spr_chestroom_3_dove" } } );
  interface.TaskPanelTaskAdd( ho_items, "honey",         1, 0, { { "spr_chestroom_3_honey" } } );
  interface.TaskPanelTaskAdd( ho_items, "makeup",        1, 0, { { "spr_chestroom_3_makeup" } } );
  interface.TaskPanelTaskAdd( ho_items, "scabbard",      1, 0, { { "spr_chestroom_3_scabbard" } } );
  interface.TaskPanelTaskAdd( ho_items, "scroll",        1, 0, { { "spr_chestroom_3_scroll" } } );
  interface.TaskPanelTaskAdd( ho_items, "sun",           1, 0, { { "spr_chestroom_3_sun" } } );
  interface.TaskPanelTaskAdd( ho_items, "tear",          1, 0, { { "spr_chestroom_3_tear" } } );
  interface.TaskPanelTaskAdd( ho_items, "thermometer",   1, 0, { { "spr_chestroom_3_thermometer" } } );
  interface.TaskPanelTaskAdd( ho_items, "thread",        1, 0, { { "spr_chestroom_3_thread" } } );
  interface.TaskPanelTaskAdd( ho_items, "valve",         1, 0, { { "spr_chestroom_3_valve" } } );
  interface.TaskPanelTaskAdd( ho_items, "scarab",        1, 0, { { "spr_chestroom_3_scarab" } } );
  
  --interface.ItemPanelItemAdd( ho_items, ""    );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "chestroom_3" );
  
  private.SetTasks();
   
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "chestroom_3" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_chestroom_3_"..task_name, task_name );
  
  local func_after = function()

    common_impl.Lock( false );

    private.MoveTasks( "spr_chestroom_3_taskpanel_"..task_name ); 

  end;

  common_impl.Lock( true );

  ObjAnimate( "spr_chestroom_3_taskpanel_"..task_name, "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.4,0,0,0 } )

end;
--*********************************************************************************************************************
function private.MoveTasks( complete_task )  

  local childs = ObjGetRelations( "obj_chestroom_3_taskpanel_crop" ).childs;

  local func_after = function()

    common_impl.Lock( false );

    private.SetTasks();
  
  end;

    for i = 1, #childs do

      local params = ObjGet( childs[i] );

        if params.alp == 1 and params.pos_x > ObjGet( complete_task ).pos_x then

          common_impl.Lock( true );

          ObjAnimate( childs[i], "pos_x", 0, 0, func_after, { 0,0,params.pos_x, 0.6,0,( params.pos_x - 127 ) } );

        end;   

    end;

end;
--*********************************************************************************************************************
function private.IsFound( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "std" ][ "win_chestroom_3" ].found;
  local task_found = false;
        
      for i = 1, #ho_found, 1 do
        
        local task = ho_found[ i ][ "task" ];

        if task == task_name then
           task_found = true;
           break;
        end;

      end;

   return task_found;  

end;
--*********************************************************************************************************************
function private.SetTasks()

  local childs = ObjGetRelations( "obj_chestroom_3_taskpanel_crop" ).childs;

    for i = 1, #childs do
      
      ObjSet( private.tasks[ childs[i] ], { input = false } );

      local params = ObjGet( childs[i] );

        if params.scale_x == 1 and params.pos_x > private.border_coords[1] and params.pos_x < private.border_coords[2] then

          local task = common.GetObjectName( common.GetObjectName( common.GetObjectName( common.GetObjectName( private.tasks[ childs[i] ] ) ) ) );

          if not private.IsFound( task ) then

            ObjSet( private.tasks[ childs[i] ], { input = true } );

          end;

        end;   

    end;

end;
--*********************************************************************************************************************
function private.SetTaskPanel()

  local ho_found = ng_global.progress[ "std" ][ "win_chestroom_3" ].found;
  
  local childs = ObjGetRelations( "obj_chestroom_3_taskpanel_crop" ).childs;

  for i = 1, #ho_found, 1 do

    for task, obj in pairs( private.tasks ) do 

      if ho_found[ i ][ "object" ] == obj then

        ObjSet( task, { scale_x = 0, scale_y = 0 } );

        for j = 1, #childs do

          local params = ObjGet( childs[j] );

          if params.scale_x == 1 and params.pos_x > ObjGet( task ).pos_x then

            ObjSet( childs[j], { pos_x = params.pos_x - 127 } );

          end; 
        
        end;

      end;

    end;

  end;

end;
--*********************************************************************************************************************
ObjAnimate( "spr_chestroom_3_light", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
