-- name=ho_studioroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "studioroom" );
  game.relations[ "ho_studioroom" ].exitroom = "rm_studio";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_studioroom = function ()

  local effects_table = 
  {
    "obj_studioroom_anims",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_studioroom", update_performance_mode_studioroom, "ho_studioroom" );
  
  ObjMultiSet( {
  
  { "spr_studioroom_apple", { event_mdown = function() private.TaskComplete( 'apple' ) end } },
  { "spr_studioroom_bucket", { event_mdown = function() private.TaskComplete( 'bucket' ) end } },
  { "spr_studioroom_camera", { event_mdown = function() private.TaskComplete( 'camera' ) end } },
  { "spr_studioroom_clock", { event_mdown = function() private.TaskComplete( 'clock' ) end } },
  { "spr_studioroom_cup", { event_mdown = function() private.TaskComplete( 'cup' ) end } },
  { "spr_studioroom_knife", { event_mdown = function() private.TaskComplete( 'knife' ) end } },
  { "spr_studioroom_loupe", { event_mdown = function() private.TaskComplete( 'loupe' ) end } },
  { "spr_studioroom_mop", { event_mdown = function() private.TaskComplete( 'mop' ) end } },
  { "spr_studioroom_note_big", { event_mdown = function() private.TaskComplete( 'note_big' ) end } },
  { "spr_studioroom_stairs", { event_mdown = function() private.TaskComplete( 'stairs' ) end } },
  { "spr_studioroom_folder", { event_mdown = function() private.TaskComplete( 'folder' ) end } },
  { "spr_studioroom_amulet", { event_mdown = function() private.TaskComplete( 'amulet' ) end } },
  { "obj_studioroom_clk_screen", { event_mdown = private.ClkScreen } },
  { "spr_studioroom_note", { event_mdown = function() common_impl.NoteScale( 'open','spr_studioroom_note' ) end } },
  { "obj_studioroom_clk_lamp_1", { event_mdown = function() private.clk_anim( "lamp_1" ) end } },
  { "obj_studioroom_clk_lamp_2", { event_mdown = function() private.clk_anim( "lamp_2" ) end } },
  { "obj_studioroom_clk_lamp_3", { event_mdown = function() private.clk_anim( "lamp_3" ) end } }
  
  } );
  
  common_impl.hint[ "win_studioroom" ] = {
      type = "win",
      room = "rm_studio",
      zz = "ho_studioroom",
      zz_gate = "gho_studio_studioroom"
  };
  
  local win_studioroom_func = function ()

    if ( cmn.IsEventDone( "win_studioroom" ) ) then
      interface.InventoryItemAdd( "inv_agemtsymbol", "spr_studioroom_win" );
    end;

  end;
  cmn.AddSubscriber( "win_studioroom", win_studioroom_func );
  --------------------------------------------------------------------------------------------------
  local start_studioroom_func = function ()

    if ( cmn.IsEventStart( "win_studioroom" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_studioroom" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        ObjDelete( "spr_studioroom_taskpanel_"..ho_found[ i ][ "task" ] );
        
        if ho_found[ i ][ "task" ] == "note_big" then
    
          ObjDelete( "spr_studioroom_note" );
    
        end;
        
      end;

    end;

  end;
  cmn.AddSubscriber( "win_studioroom", start_studioroom_func, "ho_studioroom" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_studioroom" ) ) then
  
    cmn.InitHo( "studioroom" );
    cmn.SetEventDone( "opn_studioroom" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "apple",          1, 0, { { "spr_studioroom_apple" } } );
  interface.TaskPanelTaskAdd( ho_items, "bucket",          1, 0, { { "spr_studioroom_bucket" } } );
  interface.TaskPanelTaskAdd( ho_items, "camera",          1, 0, { { "spr_studioroom_camera" } } );
  interface.TaskPanelTaskAdd( ho_items, "clock",          1, 0, { { "spr_studioroom_clock" } } );
  interface.TaskPanelTaskAdd( ho_items, "cup",          1, 0, { { "spr_studioroom_cup" } } );
  interface.TaskPanelTaskAdd( ho_items, "folder",          1, 0, { { "spr_studioroom_folder" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife",          1, 0, { { "spr_studioroom_knife" } } );
  interface.TaskPanelTaskAdd( ho_items, "loupe",          1, 0, { { "spr_studioroom_loupe" } } );
  interface.TaskPanelTaskAdd( ho_items, "mop",          1, 0, { { "spr_studioroom_mop" } } );
  interface.TaskPanelTaskAdd( ho_items, "note_big",          1, 0, { { "spr_studioroom_note", "spr_studioroom_note_big" } } );
  interface.TaskPanelTaskAdd( ho_items, "stairs",          1, 0, { { "spr_studioroom_stairs" } } );
  interface.TaskPanelTaskAdd( ho_items, "amulet",          1, 0, { { "spr_studioroom_amulet" } } );
  
  --interface.ItemPanelItemAdd( ho_items, ""    );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "studioroom" );
   
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  private.StopAnims();
  
  int_taskpanel_impl.ShowTextPanel( "studioroom" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_studioroom_"..task_name, task_name );
  
  ObjAnimate( "spr_studioroom_"..task_name.."_add", "alp", 0, 0, "", { 0,0,0, 0.1,0,1 } );
  
  ObjAnimate( "spr_studioroom_taskpanel_"..task_name, "scale_xy", 0, 0, "", { 0,0,0.8,0.8, 0.4,0,0,0 } );
  
  if task_name == "note_big" then
    
    ObjDelete( "spr_studioroom_note" );
    
  end;

end;
--*********************************************************************************************************************
function private.ClkScreen()
  
  local func_after = function()
  
    common_impl.Lock( false ); 
    
    ObjSet( "obj_studioroom_clk_screen", { input = false } );
  
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "obj_studioroom_screen", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_ho_studioroom_touch_button", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.clk_anim( name )
  
  local func_after = function()
    
    ObjSet( "obj_studioroom_clk_"..name, { input = true } );
    
    if ObjGet( "anm_studioroom_"..name.."_static" ) then
      ObjSet( "anm_studioroom_"..name, {alp = 0})
      ObjSet( "anm_studioroom_"..name.."_static", {alp = 1})
    end;
  
  end;
  
  if ObjGet( "anm_studioroom_"..name.."_static" ) then
    
    ObjSet( "anm_studioroom_"..name, {alp = 1})
    ObjSet( "anm_studioroom_"..name.."_static", {alp = 0})
    
  end;
  
  ObjSet( "obj_studioroom_clk_"..name, { input = false } );
  
  AnimPlay( "anm_studioroom_"..name, "DoAnim", func_after );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_ho_studioroom_touch_"..name, 0, "", 0 );
  
end;
--------------------------------------------------------------------------------------------
function private.StopAnims()
  
  for i = 1, 3 do
    
    ObjSet( "obj_studioroom_clk_lamp_"..i, { input = true } );
    
    ObjSet( "anm_studioroom_lamp_"..i, { playing = false, frame = 0 } );
    
    if ObjGet( "anm_studioroom_lamp_"..i.."_static" ) then
      
      ObjSet( "anm_studioroom_lamp_"..i, {alp = 0})
      ObjSet( "anm_studioroom_lamp_"..i.."_static", {alp = 1})
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
