-- name=ho_underfloor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "underfloor" );
  game.relations[ "ho_underfloor" ].exitroom = "rm_storageexit";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_underfloor = function ()

  local effects_table = 
  {
  --"anm_underfloor_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_underfloor", update_performance_mode_underfloor, "ho_underfloor" );
  
  ObjMultiSet( {
  
  { "obj_underfloor_collect_bracer", { event_mdown = function() private.TaskComplete( 'bracer' ) end } },
  { "obj_underfloor_collect_button", { event_mdown = function() private.TaskComplete( 'button' ) end } },
  { "obj_underfloor_collect_clock", { event_mdown = function() private.TaskComplete( 'clock' ) end } },
  { "obj_underfloor_collect_coins", { event_mdown = function() private.TaskComplete( 'coins' ) end } },
  { "obj_underfloor_collect_comb", { event_mdown = function() private.TaskComplete( 'comb' ) end } },
  { "obj_underfloor_collect_earring", { event_mdown = function() private.TaskComplete( 'earring' ) end } },
  { "obj_underfloor_collect_key", { event_mdown = function() private.TaskComplete( 'key' ) end } },
  { "obj_underfloor_collect_knife", { event_mdown = function() private.TaskComplete( 'knife' ) end } },
  { "obj_underfloor_collect_lighter", { event_mdown = function() private.TaskComplete( 'lighter' ) end } },
  { "obj_underfloor_collect_nailpolish", { event_mdown = function() private.TaskComplete( 'nailpolish' ) end } },
  { "obj_underfloor_collect_ring", { event_mdown = function() private.TaskComplete( 'ring' ) end } },
  { "obj_underfloor_collect_tube", { event_mdown = function() private.TaskComplete( 'tube' ) end } },
  
  } );
  
  private.tasks = { 

  [ "spr_underfloor_taskpanel_bracer"     ] = "obj_underfloor_bracer",
  [ "spr_underfloor_taskpanel_button"     ] = "obj_underfloor_button", 
  [ "spr_underfloor_taskpanel_clock"      ] = "obj_underfloor_clock",
  [ "spr_underfloor_taskpanel_coins"      ] = "obj_underfloor_coins", 
  [ "spr_underfloor_taskpanel_comb"       ] = "obj_underfloor_comb",
  [ "spr_underfloor_taskpanel_earring"    ] = "obj_underfloor_earring", 
  [ "spr_underfloor_taskpanel_key"        ] = "obj_underfloor_key",
  [ "spr_underfloor_taskpanel_knife"      ] = "obj_underfloor_knife", 
  [ "spr_underfloor_taskpanel_lighter"    ] = "obj_underfloor_lighter",
  [ "spr_underfloor_taskpanel_nailpolish" ] = "obj_underfloor_nailpolish", 
  [ "spr_underfloor_taskpanel_ring"       ] = "obj_underfloor_ring",
  [ "spr_underfloor_taskpanel_tube"       ] = "obj_underfloor_tube",

                  }
  
  private.border_coords = { -240, 240 };
  
  private.COLLECT_ANIM_TIME = 0.8;
  private.COLLECT_VISIBLE_TIME = 4.0;
  private.REPLACE_VISIBLE_TIME = 2.0;
  
  common_impl.hint[ "win_underfloor" ] = {
      type = "win",
      room = "rm_storageexit",
      zz = "ho_underfloor",
      zz_gate = "gho_storageexit_underfloor"
  };
  
  local win_underfloor_func = function ()

    if ( cmn.IsEventDone( "win_underfloor" ) ) then

      interface.InventoryItemAdd( "inv_ovalbutton", "spr_underfloor_win" );
      
    end;

  end;
  cmn.AddSubscriber( "win_underfloor", win_underfloor_func );
  --------------------------------------------------------------------------------------------------
  local start_underfloor_func = function ()

    if ( cmn.IsEventStart( "win_underfloor" ) ) then
    
      local ho_found = ng_global.progress[ "std" ][ "win_underfloor" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      private.SetTaskPanel();

    end;

  end;
  cmn.AddSubscriber( "win_underfloor", start_underfloor_func, "ho_underfloor" ); 

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_underfloor" ) ) then
  
    cmn.InitHo( "underfloor" );
    cmn.SetEventDone( "opn_underfloor" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bracer",       1, 0, { { "obj_underfloor_bracer" } } );
  interface.TaskPanelTaskAdd( ho_items, "button",       1, 0, { { "obj_underfloor_button" } } );
  interface.TaskPanelTaskAdd( ho_items, "clock",        1, 0, { { "obj_underfloor_clock" } } );
  interface.TaskPanelTaskAdd( ho_items, "coins",        1, 0, { { "obj_underfloor_coins" } } );
  interface.TaskPanelTaskAdd( ho_items, "comb",         1, 0, { { "obj_underfloor_comb" } } );
  interface.TaskPanelTaskAdd( ho_items, "earring",      1, 0, { { "obj_underfloor_earring" } } );
  interface.TaskPanelTaskAdd( ho_items, "key",          1, 0, { { "obj_underfloor_key" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife",        1, 0, { { "obj_underfloor_knife" } } );
  interface.TaskPanelTaskAdd( ho_items, "lighter",      1, 0, { { "obj_underfloor_lighter" } } );
  interface.TaskPanelTaskAdd( ho_items, "nailpolish",   1, 0, { { "obj_underfloor_nailpolish" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",         1, 0, { { "obj_underfloor_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "tube",         1, 0, { { "obj_underfloor_tube" } } );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "underfloor" );
  
  private.SetTasks();
   
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1 );
  
  for task, obj in pairs( private.tasks ) do 
    
    local rand = math.random( 1, 2 );
    
    if rand == 1 then
    
      private.MorphItemMorphing( common.GetObjectName( common.GetObjectName( obj ) ) );
      
    else
      
      private.MorphItemActive( common.GetObjectName( common.GetObjectName( obj ) ) );
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "underfloor" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "obj_underfloor_"..task_name, task_name );
  
  local collect_item = "obj_underfloor_collect_"..task_name;
  local replace_item = "obj_underfloor_replace_"..task_name; 
  
  ObjStopAnimate( collect_item, "alp" ); 
  ObjStopAnimate( replace_item, "alp" );

  ObjSet( collect_item, { alp = 1, input = false } );
  ObjSet( replace_item, { alp = 0 } );
    
  common_impl.PlayEffectHO( "spr_underfloor_collect_"..task_name, nil, 1 );
  
  ObjSet( "pfx_int_taskpanel_collect_obj_underfloor_"..task_name, { visible = false } );
  
  local func_after = function()

    common_impl.Lock( false );

    private.MoveTasks( "spr_underfloor_taskpanel_"..task_name ); 

  end;

  common_impl.Lock( true );

  ObjAnimate( "spr_underfloor_taskpanel_"..task_name, "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.4,0,0,0 } )

end;
--*********************************************************************************************************************
function private.MoveTasks( complete_task )  

  local childs = ObjGetRelations( "obj_underfloor_taskpanel_crop" ).childs;

  local func_after = function()

    common_impl.Lock( false );

    private.SetTasks();

  end;

    for i = 1, #childs do

      local params = ObjGet( childs[i] );

        if params.alp == 1 and params.pos_x > ObjGet( complete_task ).pos_x then

          common_impl.Lock( true );

          ObjAnimate( childs[i], "pos_x", 0, 0, func_after, { 0,0,params.pos_x, 0.6,0,( params.pos_x - 127 ) } );

        end;   

    end;

end;
--*********************************************************************************************************************
function private.IsFound( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "std" ][ "win_underfloor" ].found;
  local task_found = false;
        
      for i = 1, #ho_found, 1 do
        
        local task = ho_found[ i ][ "task" ];

        if task == task_name then
           task_found = true;
           break;
        end;

      end;

   return task_found;  

end;
--*********************************************************************************************************************
function private.SetTasks()

  local childs = ObjGetRelations( "obj_underfloor_taskpanel_crop" ).childs;

    for i = 1, #childs do
      
      ObjSet( private.tasks[ childs[i] ], { input = false } );

      local params = ObjGet( childs[i] );

      if params.scale_x >= 0.8 and params.pos_x > private.border_coords[1] and params.pos_x < private.border_coords[2] then

        local task = common.GetObjectName( common.GetObjectName( common.GetObjectName( private.tasks[ childs[i] ] ) ) );

        if not private.IsFound( task ) then

          ObjSet( private.tasks[ childs[i] ], { input = true } );

        end;

      end;   

    end;

end;
--*********************************************************************************************************************
function private.SetTaskPanel()

  local ho_found = ng_global.progress[ "std" ][ "win_underfloor" ].found;
  
  local childs = ObjGetRelations( "obj_underfloor_taskpanel_crop" ).childs;

  for i = 1, #ho_found, 1 do

    for task, obj in pairs( private.tasks ) do 

      if ho_found[ i ][ "object" ] == obj then

        ObjSet( task, { scale_x = 0, scale_y = 0 } );

        for j = 1, #childs do

          local params = ObjGet( childs[j] );

          if params.scale_x >= 0.8 and params.pos_x > ObjGet( task ).pos_x then

            ObjSet( childs[j], { pos_x = params.pos_x - 127 } );

          end; 
        
        end;

      end;

    end;

  end;

end;
--------------------------------------------------------
function private.MorphItemMorphing( name )
 
  local collect_item = "obj_underfloor_collect_"..name;
  local replace_item = "obj_underfloor_replace_"..name; 
  local random_time = math.random( 0, 2 );

  ObjSet( collect_item, { input = false } ); 

  ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemActive( name ) end, { 
    0, 0, 1,
    random_time + private.COLLECT_ANIM_TIME, 0, 0,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 0,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 0, 0,
    random_time + private.COLLECT_ANIM_TIME, 0, 1,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 1,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 0 } );
 
end;
--------------------------------------------------------------------------------------------------------------------
function private.MorphItemActive( name )
  
   local collect_item = "obj_underfloor_collect_"..name;
   local replace_item = "obj_underfloor_replace_"..name; 
  
   ObjSet( collect_item, { input = true } ); 

   ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemMorphing( name ) end, { 
    0, 3, 1, 
    private.COLLECT_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 3, 0, 
    private.COLLECT_VISIBLE_TIME, 3, 0 } );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_underfloor_light", "alp", 1 ,0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_underfloor_lamp", "ang", 1 ,0, "", { 0,0,-0.02, 2,0,0.02, 4,0,-0.02 } );

--*********************************************************************************************************************
