-- name=mg_deactivation
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_deactivation";
  
  private.deactivation = {};
  private.deactivation.top = { 6, 4, 2, 1, 5, 3 };
  private.deactivation.bottom = { 1, 5, 2, 6, 4, 3 };
  private.deactivation.get_top = 0; 
  private.deactivation.get_bottom = 0;
  private.deactivation_top_xy = { { -340,-133 }, { -202,-140 }, { -64,-146 }, { 73,-152 }, { 212,-159 }, { 351,-166 } };
  private.deactivation_bottom_xy = { { -327,86 }, { -190,79 }, { -51,73 }, { 87,66 }, { 225,59 }, { 363,52 } };
  private.win_mas = { 1, 2, 3, 4, 5, 6 };
  
  local table_multiset = {};

  for i = 1, 6 do

    table.insert( table_multiset, { "spr_deactivation_puzzle_top_"..i, { 
      event_mdown = function()  private.Deactivation_Take( i, 'top' ) end; 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, 
      } } );

  end; 
    
  for i = 1, 6 do

    table.insert( table_multiset, { "spr_deactivation_puzzle_bottom_"..i, { 
      event_mdown = function()  private.Deactivation_Take( i, 'bottom' ) end; 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, 
      } } );

  end;  
    
  table.insert( table_multiset, { "obj_deactivation_mode_hard", { 
    event_mdown = function() private.SetHard() end,
    event_menter = function() private.MouseEnterAnim( "spr_deactivation_mode_btn_hard" ) end, 
    event_mleave = function() private.MouseLeaveAnim( "spr_deactivation_mode_btn_hard" ) end; 
  } } );
              
  table.insert( table_multiset, { "obj_deactivation_mode_casual", { 
    event_mdown = function() private.SetNormal() end,
    event_menter = function() private.MouseEnterAnim( "spr_deactivation_mode_btn_casual" ) end, 
    event_mleave = function() private.MouseLeaveAnim( "spr_deactivation_mode_btn_casual" ) end; 
  } } );
                                    
  ObjMultiSet( table_multiset );
  
  common_impl.hint[ "win_deactivation" ] = {
    type = "win",
    room = "rm_roof",
    zz = "mg_deactivation",
    zz_gate = "gmg_roof_deactivation"
  };
  --------------------------------------------------------------------------------------------
  -- function win_deactivation_loc () end;
  --------------------------------------------------------------------------------------------
  local win_deactivation_loc = function ()
  
    ObjDelete( "gmg_roof_deactivation" );
    
  end;  
  cmn.AddSubscriber( "win_deactivation", win_deactivation_loc, "rm_roof" );
  --------------------------------------------------------------------------------------------
  -- function win_deactivation () end;
  --------------------------------------------------------------------------------------------
  local win_deactivation = function ()

    if ( cmn.IsEventDone( "win_deactivation" ) ) then 
      
      ObjSet("obj_deactivation_puzzle", { input = false } ); 
      
    else

      private.deactivation = ng_global.progress["std"]["win_deactivation"].deactivation;
      
      for i = 1, 6 do

        local j = private.deactivation.top[i];
        local k = private.deactivation.bottom[i];

        ObjSet( "spr_deactivation_puzzle_top_"..j , { pos_x = private.deactivation_top_xy[i][1], pos_y = private.deactivation_top_xy[i][2] });   
        ObjSet( "spr_deactivation_puzzle_bottom_"..k , { pos_x = private.deactivation_bottom_xy[i][1], pos_y = private.deactivation_bottom_xy[i][2] }); 

      end;

      local deactivation_get_top;
      local deactivation_get_bottom;

      if private.deactivation.get_top ~= 0 then

        deactivation_get_top = private.deactivation.get_top;
        ObjSet( "spr_deactivation_puzzle_top_"..deactivation_get_top.."_light", { alp = 1, pos_z = 5; });

      end;

      if private.deactivation.get_bottom ~= 0 then

        deactivation_get_bottom = private.deactivation.get_bottom;
        ObjSet( "spr_deactivation_puzzle_bottom_"..deactivation_get_bottom.."_light", { alp = 1, pos_z = 5; });

      end;
      
      if ng_global.progress[ "std" ][ "win_deactivation" ].hardcore then
        
        ObjMultiSet({
          { "obj_deactivation_mode_casual", { input = true } },
          { "obj_deactivation_mode_hard", { input = false } },
          { "obj_deactivation_puzzle_top", { input = true } },
          { "obj_deactivation_puzzle_bottom", { input = true }}
        });
        
      else 
        
        ObjMultiSet({
          { "obj_deactivation_mode_casual", { input = false } },
          { "obj_deactivation_mode_hard", { input = true } },
          { "obj_deactivation_puzzle_top", { input = true } },
          { "obj_deactivation_puzzle_bottom", { input = false }}
        });
        
      end;
      
    end;

  end;

  cmn.AddSubscriber( "win_deactivation", win_deactivation, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 
  
  ObjSet("obj_int_button_info_impl", { pos_y = -65 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -75 });
  
  if not cmn.IsEventDone( "win_deactivation" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_deactivation" ) ) then
    
    ng_global.progress[ "std" ][ "win_deactivation" ].hardcore = true;
    ng_global.progress["std"]["win_deactivation"].deactivation = private.deactivation;
    
  end;
  if not cmn.IsEventDone( "win_deactivation" ) then
   if ng_global.gamemode == 0 then
     private.SetNormal();
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
  ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_deactivation" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** Mmg Deactivation ***() end
--*********************************************************************************************************************
  function private.Deactivation_Take( number, current )

    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_deactivation_touch_part", 0, "", 0 );
    
    local flag_top;
    local first_deactivation_top;
    local flag_bottom;
    local first_deactivation_bottom;

    for i = 1,6 do

      if ObjGet("spr_deactivation_puzzle_top_"..i.."_light").alp == 1 then 

          flag_top = true;
          first_deactivation_top = i;
              
      end; 

      if ObjGet("spr_deactivation_puzzle_bottom_"..i.."_light").alp == 1 then 

          flag_bottom = true;
          first_deactivation_bottom = i;
              
      end; 

    end; 

    private.deactivation.reset = true;

    if flag_top or flag_bottom then

      if flag_top and current == "top" then 

        if number == first_deactivation_top then 
            
            local func_after = function()

              common_impl.Lock( false );
              private.deactivation.get_bottom = 0;
              private.deactivation.get_top = 0;

            end;

            common_impl.Lock( true );
          
            ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number.."_light", "alp", 0, 0, "", 
            {          
              0.0, 0,  1, 
              0.3, 0,  0       
            });

            ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number, "pos_z", 0, 0, func_after, 
            {          
                0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_z, 
                0.3, 0,  0     
            });  

        else

            private.Deactivation_Move( first_deactivation_top, number, current );

        end; 

      elseif flag_bottom and current == "bottom" then

        if number == first_deactivation_bottom then 
          
            local func_after = function()

              common_impl.Lock( false );
              private.deactivation.get_bottom = 0;
              private.deactivation.get_top = 0;

            end;

            common_impl.Lock( true );
          
            ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number.."_light", "alp", 0, 0, "", 
            {          
              0.0, 0,  1, 
              0.3, 0,  0       
            });

            ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number , "pos_z", 0, 0, func_after, 
            {          
                0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_z, 
                0.3, 0,  0     
            });  

        else

            private.Deactivation_Move( first_deactivation_bottom, number, current );

        end;

      elseif flag_bottom and current == "top" then 

        private.Deactivation_Not_Scale( first_deactivation_bottom, "bottom" );

      elseif flag_top and current == "bottom" then 

        private.Deactivation_Not_Scale( first_deactivation_top, "top" );

      end;
            
    else 

      common_impl.Lock( true );

      local func_after = function()

        private.Deactivation_Get( number, current );

      end;
      
      ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number.."_light", "alp", 0, 0, "", 
      {          
        0.0, 0,  0, 
        0.3, 0,  1      
      });

      ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number , "pos_z", 0, 0, func_after, 
      {          
        0.0, 0,  ObjGet("spr_deactivation_puzzle_"..current.."_"..number).pos_z, 
        0.3, 0,  50     
      });  

    end; 

  end;
  --*********************************************************************************************************************
  function private.Deactivation_Not_Scale( first_deactivation, current )

    local func_after = function()

      common_impl.Lock( false );
      private.deactivation.get_bottom = 0;
      private.deactivation.get_top = 0;

    end;

    common_impl.Lock( true );

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..first_deactivation.."_light" , "alp", 0, 0, "", 
    {          
      0.0, 0,  1, 
      0.3, 0,  0       
    });

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..first_deactivation , "pos_z", 0, 0, func_after, 
    {          
      0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_z, 
      0.3, 0,  0     
    }); 

  end;
  --*********************************************************************************************************************
  function private.Deactivation_Get( number, current )
    
    if ( current == "top" ) then
      private.deactivation.get_top = number;
    else 
      private.deactivation.get_bottom = number;
    end;

    common_impl.Lock( false );

  end;
  --*********************************************************************************************************************
  function private.Deactivation_Move( first_deactivation, number, current )

    common_impl.Lock( true );

    local func_after =  function()

      private.Deactivation_Move_1( first_deactivation, number, current );

    end;

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number.."_light" , "alp", 0, 0, "", 
    {          
      0.0, 0,  0, 
      0.3, 0,  1     
    });

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number , "pos_z", 0, 0, func_after, 
    {          
      0.0, 0,  ObjGet("spr_deactivation_puzzle_"..current.."_"..number).pos_z, 
      0.3, 0,  51     
    });  

  end;
  --*********************************************************************************************************************
  function private.Deactivation_Move_1( first_deactivation, number, current )

    local first_deactivation_pos_x = ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_x;
    local first_deactivation_pos_y = ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_y;

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..first_deactivation , "pos_xy", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_x, ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_y, 
        0.3, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_x, ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_y      
    }); 

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number , "pos_xy", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_x, ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_y,
        0.3, 0,  first_deactivation_pos_x,  first_deactivation_pos_y
    });
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_deactivation_move_parts", 0, "", 0 );

    if ( current == "top") then

        local place_1, place_2;

        for i = 1, 6 do

          if private.deactivation.top[i] == first_deactivation then 

            place_1 = i; 

          end;

          if private.deactivation.top[i] == number then 

            place_2 = i;

          end;

        end;

        cup = private.deactivation.top[ place_1 ];
        
        private.deactivation.top[ place_1 ]= private.deactivation.top[ place_2 ];

        private.deactivation.top[ place_2 ]= cup;

    else 

        local place_1, place_2;

        for i = 1, 6 do

          if private.deactivation.bottom[i] == first_deactivation then 

            place_1 = i; 

          end;

          if private.deactivation.bottom[i] == number then 

            place_2 = i;

          end;

        end;

        cup = private.deactivation.bottom[ place_1 ];
        
        private.deactivation.bottom[ place_1 ]= private.deactivation.bottom[ place_2 ];

        private.deactivation.bottom[ place_2 ]= cup;

    end;

    local func_after = function()

      private.Deactivation_Move_2( current );

    end;

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..first_deactivation.."_light", "alp", 0, 0, "", 
    {          
      0.0, 0,  1, 
      0.3, 0,  0       
    });

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..first_deactivation , "pos_z", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..first_deactivation ).pos_z, 
        0.3, 0,  0     
    }); 

    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number.."_light" , "alp", 0, 0, "", 
    {          
      0.0, 0,  1, 
      0.3, 0,  0      
    });
    
    ObjAnimate( "spr_deactivation_puzzle_"..current.."_"..number , "pos_z", 0, 0, func_after, 
    {          
        0.0, 0,  ObjGet( "spr_deactivation_puzzle_"..current.."_"..number ).pos_z, 
        0.3, 0,  0     
    });

  end;
  --*********************************************************************************************************************
  function private.Deactivation_Move_2( current )

    if ( private.CheckWin() ) then

      private.Deactivation_WinAnim();

    else 

      common_impl.Lock( false);

      if ( current == "top" ) then

        private.deactivation.get_top = 0;

      else 

        private.deactivation.get_bottom = 0;

      end;

      ng_global.progress["std"]["win_deactivation"].deactivation = private.deactivation;

    end;
   
  end;
  --*********************************************************************************************************************
  function private.CheckWin()

    local win = true;
    for i = 1, 6 do

      if ( private.deactivation.top[i] ~= private.win_mas[i] or private.deactivation.bottom[i] ~= private.win_mas[i] ) then

        win = false;
        break;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.Deactivation_WinAnim()

    local func_after = function()

      common_impl.Lock( false );
      private.WinEnd();
      
    end;

    func_after();
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_deactivation_win", 0, "", 0 );
    
  end;
--*********************************************************************************************************************
function public.Reset()

  if not ng_global.progress[ "std" ][ "win_deactivation" ].hardcore then --normal
    
    local table_multiset = {};

    private.deactivation.top = { 6, 4, 2, 1, 5, 3 };
    private.deactivation.bottom = { 1, 2, 3, 4, 5, 6 };
    private.deactivation.get_top = 0; 
    private.deactivation.get_bottom = 0; 

    ng_global.progress["std"]["win_deactivation"].deactivation = private.deactivation;
    
    table.insert( table_multiset, { "obj_deactivation_puzzle_top", { input = true }});
    table.insert( table_multiset, { "obj_deactivation_puzzle_bottom", { input = false }});
    
    for i = 1, 6 do
                      
      table.insert( table_multiset, { "spr_deactivation_puzzle_top_"..private.deactivation.top[ i ], { pos_x = private.deactivation_top_xy[i][1], pos_y = private.deactivation_top_xy[i][2] } } );
      table.insert( table_multiset, { "spr_deactivation_puzzle_bottom_"..private.deactivation.bottom[ i ], { pos_x = private.deactivation_bottom_xy[i][1], pos_y = private.deactivation_bottom_xy[i][2] } } );

    end;

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;
    
  else 
      
    local table_multiset = {};

    private.deactivation.top = { 6, 4, 2, 1, 5, 3 };
    private.deactivation.bottom = { 1, 5, 2, 6, 4, 3 };
    private.deactivation.get_top = 0; 
    private.deactivation.get_bottom = 0; 
  
    ng_global.progress["std"]["win_deactivation"].deactivation = private.deactivation;
    
    table.insert( table_multiset, { "obj_deactivation_puzzle_top", { input = true }});
    table.insert( table_multiset, { "obj_deactivation_puzzle_bottom", { input = true }});
    
    for i = 1, 6 do
                      
      table.insert( table_multiset, { "spr_deactivation_puzzle_top_"..private.deactivation.top[ i ], { pos_x = private.deactivation_top_xy[i][1], pos_y = private.deactivation_top_xy[i][2] } } );
      table.insert( table_multiset, { "spr_deactivation_puzzle_bottom_"..private.deactivation.bottom[ i ], { pos_x = private.deactivation_bottom_xy[i][1], pos_y = private.deactivation_bottom_xy[i][2] } } );

    end;

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.WinEnd();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_deactivation" );
  cmn.CallEventHandler( "win_deactivation" );
  cmn.CallEventHandler( "win_deactivation_loc" );
  
  common.GotoRoom( "rm_roof" );

end;
---------------------------------------------------------------------------------------------------------------------
function private.SetNormal()

  local func_after = function()
  
    common_impl.Lock( false );
    
    ObjMultiSet({
    { "obj_deactivation_mode_casual", { input = false } },
    { "obj_deactivation_mode_hard", { input = true } },
    });
    
    ng_global.progress[ "std" ][ "win_deactivation" ].hardcore = false;
    
    public.Reset();
    
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate("spr_deactivation_mode_btn_casual", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.2, 3, 0,
    0.4, 3, 1
  });
  
end;
-------------------------------------------------------------
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
----------------------------------------------------------------------------------------------------------------------
function private.SetHard()

  local func_after = function()
  
    common_impl.Lock( false );
    
    ObjMultiSet({
    { "obj_deactivation_mode_hard", { input = false } },
    { "obj_deactivation_mode_casual", { input = true } },
    });
    
    ng_global.progress[ "std" ][ "win_deactivation" ].hardcore = true;
    
    public.Reset();
      
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate("spr_deactivation_mode_btn_hard", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.2, 3, 0,
    0.4, 3, 1
  });

end;