-- name=mg_doorroom
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_doorroom";
  
  for i = 1, 25 do
    
    ObjSet( "obj_doorroom_"..i, { event_mdown = function() private.ClkPart( i ); end,
                                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  ObjMultiSet({ 
  
  { "obj_doorroom_clk", { event_mdown = private.ModeChange}},
  --event_menter = private.ModeMouseEnter,
  -- event_mleave = private.ModeMouseLeave  } },
  });
  private.coordinate = { 
  {{365, 374}, {412, 328}, {460, 279}, {506, 233}, {553, 184}},
  {{411, 422}, {458, 375}, {506, 327}, {553, 279}, {600, 232}},
  {{457, 469}, {506, 421}, {553, 372}, {600, 326}, {647, 279}},
  --{{506, 516}, {549, 467}, {599, 421}, {647, 373}, {695, 327}},
  {{506, 516}, {553, 469}, {600, 422}, {647, 373}, {695, 327}},
  {{554, 563}, {601, 516}, {648, 469}, {694, 421}, {741, 373}},
  };
  private.state = {   { 0,   0,   0,   0,  0 },
                      { 0,   0,   0,   0,  0 },
                      { 0,   0,   0,   0,  0 },
                      { 0,   0,   0,   0,  0 },
                      { 0,   0,   0,   0,  0 },
                   };
  private.casual = {  { 1,   2,   3,   4, 5  },
                      { 6,   7,   8,   9, 10 },
                      { 11, 12,  13,  14, 15 },
                      { 22, 21,  18,  19, 20 },
                      { 17, 16,  23,  24, 25 },
                   };
  --private.hard = {  { 1,   2,   3,   4, 5  },
  --                  { 6,   20,   8, 17, 10 },
  --                  { 11, 18,  13,   7, 19 },
  --                  { 16,  9,  14,  12, 15 },
  --                  { 21, 22,  23,  24, 25 },
  --                 };  
    
  private.hard = {  { 1,   2,   3,   4, 5  },
                    { 6,   20,   12, 17, 10 },
                    { 11, 18,  13,   7, 19 },
                    { 16,  9,  14,  8, 15 },
                    { 21, 22,  23,  24, 25 },
                   };                  
                   
  private.win_array = {{  0,  2, 3,  4,  0},
                       {  6,  0, 8,  0, 10},
                       { 11, 12, 0, 14, 15},
                       { 16,  0, 18, 0, 20},
                       {  0, 22, 23, 24, 0}
                       }; 
                       

                   
  private.pin_up = { 
                    {  0,   0}, {349, 283}, {403, 225}, {444, 188}, {  0, 0  },
                    {347, 464}, {  0,  0 }, {534, 359}, {  0,  0 }, {640, 172},
                    {394, 513}, {527, 423}, {  0, 0  }, {575, 374}, {686, 221},
                    {464, 580}, {  0,   0}, {589, 416}, {  0,   0}, {756, 289},
                    {  0,   0}, {646, 579}, {703, 525}, {740, 485}, {  0,   0},  
                   };                  
   
  private.pin_down = { 
                      {  0,    0}, {319,  251}, {374,  194}, {412,  156}, {  0,   0},
                      {316,  496}, {  0,   0 }, {561,  388}, {  0,    0}, {675, 135},
                      {364,  543}, {550,  399}, {  0,   0 }, {549,  398}, {723, 183},
                      {432,  613}, {  0,    0}, {560,  385}, {  0,    0}, {792, 251},
                      {  0,  0  }, {677, 610 }, {735, 555 }, {772, 517 }, {  0,   0},
                     }                    
                     
  private.exception = 0;  
  --------------------------------------------------------------------------------------------
  -- function win_doorroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_doorroom" ] = {
    type = "win",
    room = "rm_street",
    zz = "mg_doorroom",
    zz_gate = "gmg_street_doorroom"
  };
  
  --------------------------------------------------------------------------------------------  
  local win_doorroom = function ()

    if ( cmn.IsEventDone( "win_doorroom" ) ) then  
      
      ObjDelete("gmg_street_doorroom");
      ObjSet("grm_street_underbridge", { input = true, active = true, alp = 1});
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_street_underbridge_focus");
      end;
      --ObjSet("")

      else
      
        if  ng_global.progress[ "std" ] [ "win_doorroom" ].mode == 2 then 
          
          ObjSet( "obj_doorroom_hard", { alp = 1 });
        
        else  
          
          ObjSet( "obj_doorroom_hard", { alp = 0 });
          ObjSet( "obj_doorroom_casual", { alp = 1 });
          
        end;  
        
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state then
         
         private.GetPin();
         
         private.state = ng_global.progress[ "std" ] [ "win_doorroom" ].state;
         
        end;  
       
    end;

  end;

  cmn.AddSubscriber( "win_doorroom", win_doorroom, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_doorroom" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_doorroom" ) ) then
    
    --ng_global.progress[ "std" ] [ "win_doorroom" ].state =     {  { 1,   2,   3,   4, 5  },
    --                                                              { 6,   20,   8, 17, 10 },
    --                                                              { 11, 18,  13,   7, 19 },
    --                                                              { 16,  9,  14,  12, 15 },
    --                                                              { 21, 22,  23,  24, 25 },
    --                                                           };    
    ng_global.progress[ "std" ] [ "win_doorroom" ].state = private.hard;
    ng_global.progress[ "std" ] [ "win_doorroom" ].mode = 2;
    private.state = ng_global.progress[ "std" ] [ "win_doorroom" ].state;
      
 
  end;
  
  private.GetPin();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_doorroom" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.ClkPart( num )

  private.exception = 0;
  local func_after = function()

    common_impl.Lock( false );

    private.SaveState( num );

  end;

  local posx = ObjGet( "obj_doorroom_"..num ).pos_x;
  local posy = ObjGet( "obj_doorroom_"..num ).pos_y;

  local posxNew;
  local posyNew;
  
  local posi;
  local posj;
  
  local Pin;

  for i = 1, 5 do
    for j = 1, 5 do

      if ( private.state[ i ][ j ] == num ) then

         posi = i;
         posj = j;

       elseif ( private.state[ i ][ j ] == 17 ) then

         posi_null = i;
         posj_null = j;
       
      end;

    end;
  end;
  
  if ( ( math.abs( posi - posi_null ) == 1 ) and ( ( posj - posj_null ) == 0 ) ) or
     ( ( math.abs( posj - posj_null ) == 1 ) and ( ( posi - posi_null ) == 0 ) ) then

     posxNew = private.coordinate[ posi_null ][ posj_null ][ 1 ];
     posyNew = private.coordinate[ posi_null ][ posj_null ][ 2 ];

  end

  if ( not ( posxNew and posyNew ) ) then return; end;

  --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_statue_move", 0, "", 0 );

  common_impl.Lock( true );
  
  if private.CheckDownPin(num) then
    
    if private.exception == 0 then Pin = num else  Pin = private.exception; end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_doorroom_show_pin", 0, "", 0 );
    
    ObjAnimate( "obj_doorroom_pin_"..Pin, "pos_xy", 0, 0, "",
      { 
      0.0, 0, private.pin_up[Pin][1],    private.pin_up[Pin][2],
      0.3, 0, private.pin_down[Pin][1],  private.pin_down[Pin][2]
      } ); 
    
  end; 
   
  if private.CheckUpPin(num) then
    
    if private.exception == 0 then Pin = num else  Pin = private.exception; end;
    
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_doorroom_hide_pin", 0, "", 0 );
    
      ObjAnimate( "obj_doorroom_pin_"..Pin, "pos_xy", 0, 0, "",
      { 
      0.0, 0, private.pin_down[Pin][1],  private.pin_down[Pin][2],
      0.3, 0, private.pin_up[Pin][1],    private.pin_up[Pin][2],
      } ); 
      
    
  end; 
    
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_doorroom_touch_tile", 0, "", 0 );
  
  ObjAnimate( "obj_doorroom_"..num, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0,    posx,    posy,
    0.3, 0, posxNew, posyNew,
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.SaveState( num )

  local posi, posj, posi_null, posj_null;
  local tmp_array = {};

  for i = 1, 5 do
    
    tmp_array[ i ] = {};

    for j = 1, 5 do

      tmp_array[ i ][ j ] =  private.state[ i ][ j ];

      if ( tmp_array[ i ][ j ] == num ) then

         posi = i;
         posj = j;

       elseif ( tmp_array[ i ][ j ] == 17 ) then

        posi_null = i;
        posj_null = j;
  
      end;

    end;
  end;

  tmp_array[ posi ][ posj ] = 17;
  tmp_array[ posi_null ][ posj_null ] = num;

  for i = 1,5 do
     
    for j = 1,5 do

      ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] = private.state[i][j];
      
      --if ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] == private.win_array[i][j] then
      --  
      --  ObjSet( "obj_doorroom_pin_"..ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j], { pos_x = , pos_y = });
      --  
      --else  
      --  
      --end;  

      end;
      
    end;

    ng_global.progress[ "std" ] [ "win_doorroom" ].state[ posi ][ posj ] = 17;
    ng_global.progress[ "std" ] [ "win_doorroom" ].state[ posi_null ][ posj_null ] = num;
    
    if private.CheckWin() then  private.WinEnd() end;

    private.state[ posi ][ posj ] = 17;
    private.state[ posi_null ][ posj_null ] = num;
    
    --private.CheckRotation( posi_null, posj_null, posi, posj );

end;
---------------------------------------------------------------------------------------
function private.CheckDownPin( num ) 
  
  answer = false;
  local posi, posj;
  
  for i = 1,5 do
     
    for j = 1,5 do
     
      if ( ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] == num ) then

        posi = i;
        posj = j;
        
      end;
       
     end;
      
  end;
 
  if private.win_array[posi][posj] == num or private.Exceptions( posi, posj, num) then 
  
      answer = true;
    
    end;
   return answer;
   
end;  
--------------------------------------------------------------------------------- 
function private.CheckUpPin( num ) 
  
  answer = false;
  local posi, posj;
  
  for i = 1,5 do
     
    for j = 1,5 do

      if ( ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j]  == 17 ) then

             posi = i;
             posj = j;
             
      end;
       
      end;
      
    end;
  
       if private.win_array[posi][posj] == num or private.Exceptions( posi, posj, num) then 
  
      answer = true;
    
    end;
   return answer;
   
end;   
---------------------------------------------------------------------------------
function private.Exceptions( i, j, num)
  
  local answer = false;
  private.exception = 0;
  
  if (i == 1 and j == 2) and ( num == 4 or num ==18) then answer = true; private.exception = 2; end;
  
  if (i == 1 and j == 4) and ( num == 2 or num == 18) then answer = true; private.exception = 4; end;
  
  if (i == 4 and j == 3) and ( num == 2 or num == 4) then answer = true; private.exception = 18; end;
  
  if (i == 2 and j == 3) and ( num == 22 or num == 24) then answer = true; private.exception = 8; end;
  
  if (i == 5 and j == 2) and ( num == 8 or num == 24) then answer = true; private.exception = 22; end;
  
  if (i == 5 and j == 4) and ( num == 22 or num == 8) then answer = true; private.exception = 24; end;
  
  return answer;
  
end;  
---------------------------------------------------------------------------------
function private.CheckWin() 
  
  answer = false;
  local count = 0;
  
  for i = 1, 5  do
    
    for j = 1, 5 do
    
      if ng_global.progress[ "std" ][ "win_doorroom" ].state[i][j] == private.win_array[i][j] then
         
        count = count + 1; 
        
      end;
    
    end;
  end;
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[1][2] == 4 or ng_global.progress[ "std" ][ "win_doorroom" ].state[1][2] == 18 then
   
    count = count + 1; 
  
  end; 
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[1][4] == 2 or ng_global.progress[ "std" ][ "win_doorroom" ].state[1][4] == 18 then
   
    count = count + 1; 
  
  end; 
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[4][3] == 4 or ng_global.progress[ "std" ][ "win_doorroom" ].state[4][3] == 2 then
   
    count = count + 1; 
  
  end; 
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[2][3] == 22 or ng_global.progress[ "std" ][ "win_doorroom" ].state[2][3] == 24 then
   
    count = count + 1; 
  
  end; 
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[5][2] == 8 or ng_global.progress[ "std" ][ "win_doorroom" ].state[1][2] == 24 then
   
    count = count + 1; 
  
  end; 
  
  if ng_global.progress[ "std" ][ "win_doorroom" ].state[5][4] == 8 or ng_global.progress[ "std" ][ "win_doorroom" ].state[1][2] == 22 then
   
    count = count + 1; 
  
  end; 
  
   if count == 16 then answer  = true; end;
    
    return answer;
  
end; 
-----------------------------------------------------------------------------------------------------------------------
function private.ModeChange() 
  
  local func_after = function()

    common_impl.Lock( false );
    
    if ng_global.progress[ "std" ] [ "win_doorroom" ].mode == 2 then 
    
      ng_global.progress[ "std" ] [ "win_doorroom" ].mode = 1;
      
      
      ng_global.progress[ "std" ] [ "win_doorroom" ].state = {  { 1,   2,   3,   4, 5  },
                                                                { 6,   7,   8,   9, 10 },
                                                                { 11, 12,  13,  14, 15 },
                                                                { 22, 21,  18,  19, 20 },
                                                                { 17, 16,  23,  24, 25 },
                                                             };     
      private.state = ng_global.progress[ "std" ] [ "win_doorroom" ].state;
      private.GetPin();
      
      
      
    else  
      
      ng_global.progress[ "std" ] [ "win_doorroom" ].mode = 2;
      
      ng_global.progress[ "std" ] [ "win_doorroom" ].state = {  { 1,   2,   3,   4, 5  },
                                                                { 6,   20,   8, 17, 10 },
                                                                { 11, 18,  13,   7, 19 },
                                                                { 16,  9,  14,  12, 15 },
                                                                { 21, 22,  23,  24, 25 },
                                                              };        
      private.state = ng_global.progress[ "std" ] [ "win_doorroom" ].state;
      private.GetPin();
   
    end;   
    --private.SaveState( num );

   end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_doorroom_complexity", 0, "", 0 );
  
  if ng_global.progress[ "std" ] [ "win_doorroom" ].mode == 2 then 
    
    
      ObjAnimate( "obj_doorroom_hard", "alp", 0, 0, "",
      { 
          0.0, 0, 1,
          0.3, 0, 0
      } ); 
      
      ObjAnimate( "obj_doorroom_casual", "alp", 0, 0, func_after,
      { 
          0.0, 0, 0,
          0.3, 0, 1
      } ); 
    
  else  
      
      ObjAnimate( "obj_doorroom_hard", "alp", 0, 0, "",
      { 
          0.0, 0, 0,
          0.3, 0, 1
      } ); 
      
      ObjAnimate( "obj_doorroom_casual", "alp", 0, 0, func_after,
      { 
          0.0, 0, 1,
          0.3, 0, 0
      } ); 
      
   end;
  
end; 
--------------------------------------------------------------------------------------------------------------------
function private.GetPin()
 
 
   for i = 1,5 do
     
    for j = 1,5 do

      ObjSet( "obj_doorroom_"..ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j], { pos_x =  private.coordinate[i][j][1] ,pos_y = private.coordinate[i][j][2] });
      
      if ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] == private.win_array[i][j]  then
        
        ObjSet( "obj_doorroom_pin_"..ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j], { pos_x = private.pin_up[ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] ][1] , pos_y = private.pin_up[ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] ][2] });
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[1][2] == 4 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[1][2] == 18 then ObjSet( "obj_doorroom_pin_2", { pos_x = private.pin_up[2][1], pos_y = private.pin_up[2][2]}) end;
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[1][4] == 2 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[1][4] == 18 then ObjSet( "obj_doorroom_pin_4", { pos_x = private.pin_up[4][1], pos_y = private.pin_up[4][2]}) end;
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[4][3] == 4 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[4][3] == 2 then ObjSet( "obj_doorroom_pin_18", { pos_x = private.pin_up[18][1], pos_y = private.pin_up[18][2]}) end;
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[2][3] == 24 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[2][3] == 22 then ObjSet( "obj_doorroom_pin_8", { pos_x = private.pin_up[8][1], pos_y = private.pin_up[8][2]}) end;
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[5][2] == 8 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[5][2] == 24 then DbgTrace("pppp"); ObjSet( "obj_doorroom_pin_22", { pos_x = private.pin_up[22][1], pos_y = private.pin_up[22][2]}) end;
        
        if ng_global.progress[ "std" ] [ "win_doorroom" ].state[5][4] == 8 or ng_global.progress[ "std" ] [ "win_doorroom" ].state[5][4] == 22 then ObjSet( "obj_doorroom_pin_24", { pos_x = private.pin_up[24][1], pos_y = private.pin_up[24][2]}) end;
      
      else  
       
        ObjSet( "obj_doorroom_pin_"..ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j], { pos_x = private.pin_down[ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] ][1] , pos_y = private.pin_down[ng_global.progress[ "std" ] [ "win_doorroom" ].state[i][j] ][2] }); 
        
      end;  

      end;
      
    end;
 
 
end;  
--*********************************************************************************************************************
function public.Reset()
  
 
      
      --ng_global.progress[ "std" ] [ "win_doorroom" ].state = {  { 1,   2,   3,   4, 5  },
      --                                                                { 6,   20,   8, 17, 10 },
      --                                                                { 11, 18,  13,   7, 19 },
      --                                                                { 16,  9,  14,  12, 15 },
      --                                                                { 21, 22,  23,  24, 25 },
      --                                                              }; 
      ng_global.progress[ "std" ] [ "win_doorroom" ].state = {  { 1,   2,   3,   4, 5  },
                                                                      { 6,   20,   12, 17, 10 },
                                                                      { 11, 18,  13,   7, 19 },
                                                                      { 16,  9,  14,  8, 15 },
                                                                      { 21, 22,  23,  24, 25 },
                                                                    };                                                                 
      private.state = ng_global.progress[ "std" ] [ "win_doorroom" ].state;
      ng_global.progress[ "std" ] [ "win_doorroom" ].mode = 2;
      
      ObjSet( "obj_doorroom_hard", { alp = 1 });
      ObjSet( "obj_doorroom_casual", { alp = 0 });
      private.GetPin();
  

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_doorroom" );
  --cmn.CallEventHandler( "win_doorroom" );
  
  cmn.GotoRoom( "rm_street" );
  cmn.GotoSubRoom( "zz_door_3", nil, { 512, 384 }, false );

end;
--*********************************************************************************************************************
function private.Win()

  ObjSet( "tmr_doorroom_win",
    {
      time = 1.0,
      playing = true,
      endtrig = function() private.WinEnd(); end
    } );
  ng_global.progress[ "std" ] [ "win_doorroom" ].state = {  { 1,   2,   3,   4, 5  },
                                                            { 6,   7,   8, 9, 10 },
                                                            { 11, 12,  13,   14, 15 },
                                                            { 16,  17,  18,  19, 20 },
                                                            { 21, 22,  23,  24, 25 },
                                                          };  
  private.GetPin();
  
end;
--*********************************************************************************************************************