-- name=mg_fight
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_fight";  
 
  private.sequence_1 = {
                        [ "hard" ]  = { 1, 5 },
                        [ "casual" ] = { 2, 4 } 
                       };
                        
  private.sequence_2 = {
                        [ "hard" ]  = { 5, 2, 4, 3, 1 },
                        [ "casual" ] = { 2, 4, 3 } 
                       };
                       
  private.current_number = 1;
                       
  for i = 1, 12 do
    
    for j = 1, 2 do
      
      ObjSet( "obj_fight_symbol_"..i.."_"..j, { event_mdown = function() private.ClkSymbol( i, j ) end } );
      
      private.AnimSymbol( i, j );
      
    end;
    
  end;
  
  ObjSet( "spr_fight_interface_button", { event_mdown = private.ChangeMode } );
  
  private.anim_counter = 0;
 
  --------------------------------------------------------------------------------------------
  -- function win_fight () end;
  --------------------------------------------------------------------------------------------
  local win_fight = function ()

  if ( cmn.IsEventDone( "win_fight" ) ) then
  
    ObjDelete( "obj_fight_symbols" );
    ObjDelete( "obj_fight_interface" );

  else
    
    local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
    local level = ng_global.progress[ "std" ][ "win_fight" ].level;
    local state = ng_global.progress[ "std" ][ "win_fight" ].state;
    local number = ng_global.progress[ "std" ][ "win_fight" ].number;   
    
    ObjSet( "txt_fight_interface_button", { text = "str_secretpassage_"..mode } );
    
    for j = 1, #state[mode][level] do
      
      if level == 2 then
      
        ObjSet( "spr_fight_interface_symbol_"..private.sequence_2[mode][j], { alp = 0 } );
        
      end;
      
      local array_index = private.GetNumber( j, mode, level );
      
      if state[mode][level][j] == 2 then
        
        ObjSet( "obj_fight_symbol_"..array_index.."_1", { scale_x = 0, scale_y = 0 } );
        ObjSet( "obj_fight_symbol_"..array_index.."_2", { scale_x = 0, scale_y = 0 } );
        
        if level == 1 then
       
          ObjSet( "spr_fight_interface_symbol_"..array_index, { alp = 0 } );
        
        elseif level == 2 then
          
          ObjSet( "spr_fight_interface_symbol_"..array_index, { alp = 1 } );
          
          ObjSet( "spr_fight_interface_symbol_"..array_index.."_top", { alp = 1 } );
          ObjSet( "spr_fight_interface_symbol_"..array_index.."_bottom", { alp = 1 } );
         
        end;
        
       elseif state[mode][level][j] == 1 then    
   
        ObjSet( "spr_fight_interface_symbol_"..array_index.."_bottom", { alp = 1 } );  
 
        ObjSet( "obj_fight_symbol_"..array_index.."_"..number[mode][level][j], { scale_x = 0, scale_y = 0 } );
  
      end;
      
    end;
     
    if level == 2 then
    
      for i = 1, #private.sequence_2[mode] do
        
        if state[mode][level][ private.GetIndex( private.sequence_2[mode][i], mode, level ) ] ~= 2 then
          
          private.current_number = i;
          
          break;
          
        end;
        
      end;

    end;
    
    if mode == "hard" then
      
      ObjSet( "obj_fight_interface_symbol_1", { alp = 1 } );
      ObjSet( "obj_fight_interface_symbol_5", { alp = 1 } );
      
    else
      
      ObjSet( "obj_fight_interface_symbol_1", { alp = 0 } );
      ObjSet( "obj_fight_interface_symbol_5", { alp = 0 } );
      
    end;
    
  end;

  end;

  common_impl.hint[ "win_fight" ] = {
    type = "win",
    room = "mg_fight"   
  };
  
  cmn.AddSubscriber( "win_fight", win_fight, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;


  

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_fight" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
 
  if ng_global.progress[ "std" ][ "win_fight" ].level == 2 then
    
    common_impl.Lock( true );
    
    private.ShowSymbol( private.current_number );
    
  end;
  
  private.AnimSound();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_fight" ) ) then
    
    ng_global.progress[ "std" ][ "win_fight" ].mode = "hard";
    
    ng_global.progress[ "std" ][ "win_fight" ].level = 1;
    
    ng_global.progress[ "std" ][ "win_fight" ].state = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                         [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                       };
                                                       
    ng_global.progress[ "std" ][ "win_fight" ].number = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                          [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                       };
    
  end;
                                                     
  ObjAttach( "obj_fight_interface", "obj_int_inventory_impl" );
  
  common_impl.PlayAudio( "env", "common/audio/level3/aud_mg_fight_env", 1, "", 0 );
  
  if not cmn.IsEventDone( "win_fight" ) then
   if ng_global.gamemode == 0 then
     ng_global.progress[ "std" ][ "win_fight" ].mode = "hard";
     private.ChangeMode();
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/level3/aud_mg_fight_env", 0.3 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_fight" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
  ObjAttach( "obj_fight_interface", "mg_fight" );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  ng_global.progress[ "std" ][ "win_fight" ].level = 1;
    
  ng_global.progress[ "std" ][ "win_fight" ].state = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                       [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                     };
                                                     
  ng_global.progress[ "std" ][ "win_fight" ].number = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                        [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                     };
                                                     
  private.current_number = 1;
  
  for i = 1, 12 do
    
    for j = 1, 2 do
      
      ObjSet( "obj_fight_symbol_"..i.."_"..j, { scale_x = 1, scale_y = 1 } );
      
    end;
    
  end;
  
  for k = 1, 5 do
    
    ObjSet( "spr_fight_interface_symbol_"..k, { alp = 1 } );
    ObjSet( "spr_fight_interface_symbol_"..k.."_bottom", { alp = 0 } );
    ObjSet( "spr_fight_interface_symbol_"..k.."_top", { alp = 0 } );
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_fight" );
  cmn.CallEventHandler( "win_fight" );

  cmn.GotoRoom( "rm_roof" );

end;
--*********************************************************************************************************************
function private.Win()
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_win", 0, "", 0 );
  
  private.WinEnd();
 
end;
--*********************************************************************************************************************
function private.GetIndex( number, mode, level )
  
  local sequence = {};
  
  --if level == 1 then
    
    sequence = private.sequence_1[ mode ];
    
    local index = number - sequence[1] + 1;
    
    return index;
 
  --elseif level == 2 then
  --  
  --  sequence = private.sequence_2[ mode ];
  --  
  --  for i = 1, #sequence do
  --  
  --    if sequence[i] == number then
  --      
  --      return i;
  --      
  --    end;
  --  
  --  end;
    
  --end;
  
end;
--*********************************************************************************************************************
function private.GetNumber( index, mode, level )
  
  local sequence = private.sequence_1[ mode ];
    
  local number =  index + sequence[1] - 1;
  
  return number;
  
end;
--*********************************************************************************************************************
function private.ClkSymbol( number, index )
  
  local level = ng_global.progress[ "std" ][ "win_fight" ].level;
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_touch_sign", 0, "", 0 );

  if level == 1 then
    
    private.ClkSymbol_1( number, index );
 
  elseif level == 2 then
    
    private.ClkSymbol_2( number, index );
    
  end;
  
end;
--*********************************************************************************************************************
function private.ClkSymbol_1( number, index )
   
  local level = ng_global.progress[ "std" ][ "win_fight" ].level;
  local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
  
  local range = private.sequence_1[ mode ];
    
  if ( number >= range[1] and number <= range[2] ) then
    
    local func_after = function()
    
      local array_index = private.GetIndex( number, mode, level );
   
      local current_value = ng_global.progress[ "std" ][ "win_fight" ].state[mode][level][array_index];
    
      local func_end = function()
    
        common_impl.Lock( false );
        
        private.CheckLevel();
        
      end;
    
      if current_value ~= 1 then
        
        ObjAnimate( "spr_fight_interface_symbol_"..number.."_bottom", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
        
        ng_global.progress[ "std" ][ "win_fight" ].number[mode][level][array_index] = index;
        
      else
        
        ObjAnimate( "spr_fight_interface_symbol_"..number.."_top", "alp", 0, 0, "", { 0,0,0, 0.3,0,1, 0.6,0,0 } );
        ObjAnimate( "spr_fight_interface_symbol_"..number.."_bottom", "alp", 0, 0, func_end, { 0,0,1, 0.3,0,1, 0.6,0,0 } );
        
        ObjAnimate( "spr_fight_interface_symbol_"..number, "alp", 0, 0, func_end, { 0,0,1, 0.3,0,1, 0.6,0,0 } );
        
      end;
      
      ng_global.progress[ "std" ][ "win_fight" ].state[mode][level][array_index] = current_value + 1;
    
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_right", 0, "", 0 );
  
    ObjAnimate( "obj_fight_symbol_"..number.."_"..index, "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,0,0 } );
    
  else
    
    private.WrongAnim();
    
  end;
  
end;
--*********************************************************************************************************************
function private.ClkSymbol_2( number, index )
  
  local level = ng_global.progress[ "std" ][ "win_fight" ].level;
  local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;

  if number == private.sequence_2[ mode ][private.current_number] then
    
    local func_after = function()
    
      local array_index = private.GetIndex( number, mode, level );
      
      local current_value = ng_global.progress[ "std" ][ "win_fight" ].state[mode][level][array_index];
    
      local func_end = function()
    
        common_impl.Lock( false );
    
        if private.CheckLevel() then
          
          private.Win();
          
        else
     
          ng_global.progress[ "std" ][ "win_fight" ].state[mode][level][array_index] = current_value + 1; 
          ng_global.progress[ "std" ][ "win_fight" ].number[mode][level][array_index] = index;
          
        end;
        
      end;
      
      if current_value ~= 1 then
        
        ObjAnimate( "spr_fight_interface_symbol_"..number.."_bottom", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
  
      else
        
        ObjAnimate( "spr_fight_interface_symbol_"..number.."_top", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
        
        ObjAnimate( "spr_fight_interface_symbol_"..number, "alp", 0, 0, func_end, { 0,0,0, 0.3,0,0, 0.6,0,1 } );
        
        private.current_number = private.current_number + 1;
        
      end;
 
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_right", 0, "", 0 );
  
    ObjAnimate( "obj_fight_symbol_"..number.."_"..index, "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,0,0 } );    
    
  else
    
    private.WrongAnim(); 
    
  end;
  
end;
--*********************************************************************************************************************
function private.WrongAnim()
  
  local func_after = function()
  
    local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
    local level = ng_global.progress[ "std" ][ "win_fight" ].level;
  
    local func_end = function()
      
      common_impl.Lock( false );
      
      for i = 1, #ng_global.progress[ "std" ][ "win_fight" ].state[mode][level] do
        
        ng_global.progress[ "std" ][ "win_fight" ].state[mode][level][i] = 0;
        ng_global.progress[ "std" ][ "win_fight" ].number[mode][level][i] = 0;
        
      end;
      
      if level == 2 then
        
        private.ShowSymbol( 1 );
        
        private.current_number = 1;
        
      end;
      
    end;
    
    for k = 1, 5 do
      
      ObjSet( "spr_fight_interface_symbol_"..k.."_top", { alp = 0 } );
      ObjSet( "spr_fight_interface_symbol_"..k.."_bottom", { alp = 0 } );
      
    end;
    
    local count = 0;
    
    for i = 1, #ng_global.progress[ "std" ][ "win_fight" ].state[mode][level] do
      
      for j = 1, 2 do

        if ObjGet( "obj_fight_symbol_"..i.."_"..j ).scale_x == 0 then
          
          count = count + 1; 
          
          ObjAnimate( "obj_fight_symbol_"..i.."_"..j, "scale_xy", 0, 0, func_end, { 0,0,0,0, 0.3,0,1,1 } );
          
          func_end = "";
          
        end;
        
      end;
      
      if ( ObjGet( "spr_fight_interface_symbol_"..i ).alp == 0 ) and level == 1 then
        
        ObjAnimate( "spr_fight_interface_symbol_"..i, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
        
      elseif ( ObjGet( "spr_fight_interface_symbol_"..i ).alp == 1 ) and level == 2 then
        
        ObjAnimate( "spr_fight_interface_symbol_"..i, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
        
      end;
      
    end;
    
    if count == 0 then
      
      func_end();
      
    end;
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_wrong", 0, "", 0 );
    
  ObjAnimate( "spr_fight_wrong", "alp", 0, 0, "", { 0,0,0, 0.3,0,1, 1.0,0,1, 1.3,0,0 } );
  
  ObjAnimate( "mg_fight", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,1.1,1.1, 1.3,0,1.1,1.1, 1.6,0,1,1 } );

  ObjAnimate( "mg_fight", "pos_xy", 0, 0, "", { 0,0,0,0, 0.3,0,0,0, 0.6,0,-5,-5, 1,0,5,-35, 1.3,0,0,0 } );
  ObjAnimate( "mg_fight", "ang", 0, 0, "", { 0,0,0, 0.3,0,0, 0.6,0,0.03, 1,0,-0.03, 1.3,0,0 } );
  
end;
--*********************************************************************************************************************
function private.CheckLevel()
  
  local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
  local level = ng_global.progress[ "std" ][ "win_fight" ].level;  
  local state = ng_global.progress[ "std" ][ "win_fight" ].state[mode][level];
  
  local count = 0;
  local count_1 = 0;
  
  for i = 1, #state do
    
    if state[i] == 2 then
      
      count = count + 1;
      
    elseif state[i] == 1 then
    
      count_1 = count_1 + 1;
      
    end;
    
  end;
  
  if count == #state and level == 1 then
 
    private.ChangeLevel();
    
    return false;
      
   elseif count == ( #state - 1 ) and count_1 == 1 and level == 2 then       
  
     return true;
      
  end;

end;
--*********************************************************************************************************************
function private.ChangeLevel()
  
  local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
  
  local func_after_1 = function()
  
    local func_after_2 = function() 
    
      common_impl.Lock( false );
    
      ng_global.progress[ "std" ][ "win_fight" ].level = 2;
      
      private.ShowSymbol( 1 );
    
    end;
  
    for i = 1, 12 do
    
      for j = 1, 2 do
        
        ObjSet( "obj_fight_symbol_"..i.."_"..j, { scale_x = 1, scale_y = 1 } );
        
      end;
      
    end;
    
    ObjAnimate( "obj_fight_symbols", "alp", 0, 0, func_after_2, { 0,0,0, 0.3,0,1 } );
  
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "obj_fight_symbols", "alp", 0, 0, func_after_1, { 0,0,1, 0.3,0,0 } );
 
end;
--*********************************************************************************************************************
function private.ShowSymbol( number )
  
  local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
  
  local func_after = function()    
  
    if number ~= #private.sequence_2[mode] then
      
      private.ShowSymbol( number + 1 );
      
    else
      
      common_impl.Lock( false );
      
    end;
  
  end;
  
  if number == 1 then
    
    common_impl.Lock( true );
    
  end;
 
  ObjAnimate( "spr_fight_interface_symbol_"..private.sequence_2[mode][number], "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1, 1.0,0,1, 1.3,0,0 } );
  
end;
--*********************************************************************************************************************
function private.ChangeMode()
  
  if ng_global.progress[ "std" ][ "win_fight" ].mode == "hard" then
    
    ng_global.progress[ "std" ][ "win_fight" ].mode = "casual";
  
    ObjAnimate( "obj_fight_interface_symbol_1", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "obj_fight_interface_symbol_5", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
 
  else
    
    ng_global.progress[ "std" ][ "win_fight" ].mode = "hard";
    
    ObjAnimate( "obj_fight_interface_symbol_1", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    ObjAnimate( "obj_fight_interface_symbol_5", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    
  end;
  
  local func_after = function()
  
    local func_end = function()
    
      common_impl.Lock( false );
    
    end;
  
    local mode = ng_global.progress[ "std" ][ "win_fight" ].mode;
  
    ObjSet( "txt_fight_interface_button", { text = "str_secretpassage_"..mode } );
    
    ObjAnimate( "txt_fight_interface_button", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    ObjAnimate( "spr_fight_interface_button", "alp", 0, 0, func_end, { 0,0,1, 0.3,0,0 } );
    
    ng_global.progress[ "std" ][ "win_fight" ].level = 1;
      
    ng_global.progress[ "std" ][ "win_fight" ].state = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                         [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                       };
                                                       
    ng_global.progress[ "std" ][ "win_fight" ].number = { [ "hard" ] = { { 0,0,0,0,0 },{ 0,0,0,0,0 } }, 
                                                          [ "casual" ] = { { 0,0,0 }, { 0,0,0 } },
                                                       };
                                                       
    private.current_number = 1;
    
    for i = 1, 12 do
      
      for j = 1, 2 do
        
        if ObjGet( "obj_fight_symbol_"..i.."_"..j ).scale_x == 0 then
        
          ObjAnimate( "obj_fight_symbol_"..i.."_"..j, "scale_xy", 0, 0, "", { 0,0,0,0, 0.3,0,1,1 } );
          
        end;
        
      end;
      
    end;
    
    for k = 1, 5 do
      
      local obj = "spr_fight_interface_symbol_"..k;
      local bottom = "spr_fight_interface_symbol_"..k.."_bottom";
      local top = "spr_fight_interface_symbol_"..k.."_top";      
  
      ObjAnimate( obj, "alp", 0, 0, "", { 0,0,ObjGet(obj).alp, 0.3,0,1 } );
      ObjAnimate( bottom, "alp", 0, 0, "", { 0,0,ObjGet(bottom).alp, 0.3,0,0 } );
      ObjAnimate( top, "alp", 0, 0, "", { 0,0,ObjGet(top).alp, 0.3,0,0 } );
      
    end;
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_fight_change_mode", 0, "", 0 );
  
  ObjAnimate( "spr_fight_interface_button", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "txt_fight_interface_button", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  
end;
--*********************************************************************************************************************
function private.AnimSound()
  
  private.anim_counter = private.anim_counter + 1;
  
  AnimPlay( "anm_fight_sound_"..( 2 - private.anim_counter % 2 ), "DoAnim", "" );
  
  ObjSet( "tmr_fight_sound", { time = 1.5, playing = true, endtrig = private.AnimSound } );
  
end;
--*********************************************************************************************************************
function private.AnimSymbol( number, index )
  
  local k = index/2;
  local k2 = number/10;
  local k3;
  
  if number%2 == 0 then
    
    k3 = -1;
    
  else
    
    k3 = 1;
    
  end;
  
  ObjAnimate( "spr_fight_symbol_"..number.."_"..index.."_backlight", "alp", 1, 0, "", {     0, 0,   1,
                                                                                       k*2.45, 0, 0.8,
                                                                                       k*4.58, 0,   1,
                                                                                       k*6.87, 0, 0.7,
                                                                                        k*9.5, 0,   1 } );
                                                                             
  ObjAnimate( "spr_fight_symbol_"..number.."_"..index.."_backlight", "pos_xy", 1, 0, "", {     0, 0,    0,    0,
                                                                                          k*2.45, 0, k2+ 7.4*k3, k2+-3.6*k3,
                                                                                          k*4.58, 0, k2+-8.6*k3, k2+11.2*k3,
                                                                                          k*6.87, 0, k2+10.1*k3, k2+-5.9*k3,
                                                                                           k*9.5, 0,    0,    0 } );
  
  ObjAnimate( "spr_fight_symbol_"..number.."_"..index, "pos_xy", 1, 0, "", {        0, 0, k2+0.4*k3, k2+1.6*k3,
                                                                               k*2.45, 0, k2+10*k3, k2+2.2*k3,
                                                                               k*4.58, 0, k2+-1*k3, k2+13*k3,
                                                                               k*6.87, 0, k2+7*k3, k2+8*k3,
                                                                                k*9.5, 0, k2+0.4*k3, k2+1.6*k3 } );
  
end;