-- name=mg_mechanism
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_mechanism";
  
  --ObjMultiSet({ 
  --});
  private.position = {{ 1,  2,  3,  4,  5,  6,  7, 8 },
                      { 9, 10, 11, 12, 13, 14, 15, 16},
                     };
  
  for i = 1, 16 do
    
    ObjSet( "spr_mechanism_symbol_"..i, { event_mdown = function() private.ClkSymbol( i ); end,
                                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
                                             
   ObjMultiSet({
   { "obj_mechanism_mode_hard", { event_mdown = function() private.ModeChange() end,
       event_menter = function() private.MouseEnterAnim( "spr_mechanism_mode_btn_hard" ) end, 
       event_mleave = function() private.MouseLeaveAnim( "spr_mechanism_mode_btn_hard" ) end; 
                                   } },
      { "obj_mechanism_mode_casual", { event_mdown = function() private.ModeChange() end;
       event_menter = function() private.MouseEnterAnim( "spr_mechanism_mode_btn_casual" ) end, 
       event_mleave = function() private.MouseLeaveAnim( "spr_mechanism_mode_btn_casual" ) end; 
                                     } },
  }); 
  --------------------------------------------------------------------------------------------
  -- function win_mechanism () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mechanism" ] = {
    type = "win",
    use_place = "obj_mechanism_mode",
    room = private.room_objname
  }; 
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mechanism = function ()

  local effects_table = 
  {
    "obj_mechanism_lights"
    
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mechanism", update_performance_mode_mechanism, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_mechanism_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mechanism_loc = function ()
  
    ObjDelete( "gmg_attvatation_mechanism" );
    ObjSet( "anm_victim_use_sidecutter", { alp = 1 });
    ObjSet( "obj_victim_use_sidecutter", { active = true, input = true });
    ObjSet( "gzz_attvatation_victim", { input = true, active = true, alp = 1});
    ObjDelete( "spr_victim_cap_2_close" );
    
  end;
  cmn.AddSubscriber( "win_mechanism", win_mechanism_loc, "rm_attvatation" );
  --------------------------------------------------------------------------------------------
  -- function win_mechanism () end;
  --------------------------------------------------------------------------------------------
  local win_mechanism = function ()

    if ( cmn.IsEventDone( "win_mechanism" ) ) then  
      
      ObjDelete("gmg_attvatation_mechanism");
      ObjSet("gzz_attvatation_victim", { input = true, active = true, alp = 1});

      else
      
      if ng_global.progress[ "std" ][ "win_mechanism" ].mode == 2 then 
        
            ObjMultiSet({
              { "obj_mechanism_mode_hard", { input = false } },
              { "obj_mechanism_mode_casual", { input = true } },
              
            });
        
      
      else 
        
            ObjMultiSet({
            { "obj_mechanism_mode_hard", { input = true } },
            { "obj_mechanism_mode_casual", { input = false } },
              
            });
       
      
      end;
      
      for i = 1, 8  do
        
        if ng_global.progress[ "std" ][ "win_mechanism" ].state[i] == 1 then 
          
         ObjSet("spr_mechanism_symbol_"..i, { input = false, alp = 1}); 
         ObjSet("spr_mechanism_symbol_"..i + 8, { input = false, alp = 1}); 
         
        end;
       
     end;
     
     if ng_global.progress[ "std" ][ "win_mechanism" ].flag ~= 0 then 
       
        ObjSet("spr_mechanism_symbol_"..ng_global.progress[ "std" ][ "win_mechanism" ].flag, { alp = 1}); 
        
     end;  
      

    end;

  end;

  cmn.AddSubscriber( "win_mechanism", win_mechanism, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_mechanism" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  private.RotationAnim();
  common_impl.Lock( true );
  common_impl.PlayAudio( "env", "common/audio/level3/aud_mg_mechanism_env", 1, "", 0 );
  ObjSet( "tmr_mechanism_start",
   {
      time = 1.0,
      playing = true,
      endtrig = function()  common_impl.Lock( false); private.ShowSymbols(); end
   } );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventStart( "win_mechanism" ) ) then
    ng_global.progress[ "std" ][ "win_mechanism" ].state = {0, 0, 0, 0, 0, 0, 0, 0};
    ng_global.progress[ "std" ][ "win_mechanism" ].flag = 0;
    ng_global.progress[ "std" ][ "win_mechanism" ].mode = 2;
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_mechanism" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.ClkSymbol( num )
  
  local func_after = function()

    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_mechanism" ].flag = num;
    
  end;
  
  local func_after_2 = function()

    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_mechanism" ].flag = 0;
    
  end;
  
  if ng_global.progress[ "std" ][ "win_mechanism" ].flag == 0 then 
    
     common_impl.Lock( true );
     common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_touch_sign", 0, "", 0 );
     ObjAnimate( "spr_mechanism_symbol_"..num, "alp", 0, 0, func_after,
      { 
        0.0, 0, 0,
        0.6, 0, 1
      } );  
    
  else 
    
    if  ng_global.progress[ "std" ][ "win_mechanism" ].flag == num then
      
      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_touch_sign", 0, "", 0 );
      
      ObjAnimate( "spr_mechanism_symbol_"..num, "alp", 0, 0, func_after_2,
      { 
        0.0, 0, 1,
        0.6, 0, 0
      } );  
      
    else 
      
       
       private.GetSecondSymbol(num);
       
     
    end;  
  
  end;

end;
------------------------------------------------------------------------------------------------
function private.ShowSymbols()
  
   local func_after = function()

    common_impl.Lock( false );
    
    
  end;
  
  common_impl.Lock( true );
  
  for i = 1, 16  do
    
    if ObjGet( "spr_mechanism_symbol_"..i).alp == 0 then
      
      ObjAnimate( "spr_mechanism_symbol_"..i, "alp", 0, 0, func_after,
      { 
        0.0, 0, 0,
        0.3, 0, 1,
        1.2, 0, 1,
        1.5, 0, 0
      } );  
      
    end;  
    --func_after = "";
    
  end;
  
end;
------------------------------------------------------------------------------------------------
function private.GetSecondSymbol(num)
  
   local index_j = 0;
   local index_i = 0;
   
   for  i = 1, 2  do
     
     for  j = 1, 8  do
       
       if private.position[i][j] == ng_global.progress[ "std" ][ "win_mechanism" ].flag then
         
         index_i = 3 - i;
         index_j = j;
         
       end;
       
     end;
     
   end;

    
    local func_after = function()

      common_impl.Lock( false );
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_right", 0, "", 0 );
      --ng_global.progress[ "std" ][ "win_mechanism" ].flag = num;
      
      if private.position[index_i][index_j] == num then 
        
        ObjSet( "spr_mechanism_symbol_"..num, { input = false});
        ObjSet( "spr_mechanism_symbol_"..ng_global.progress[ "std" ][ "win_mechanism" ].flag, { input = false });
        ng_global.progress[ "std" ][ "win_mechanism" ].state[index_j] = 1;
        ng_global.progress[ "std" ][ "win_mechanism" ].flag = 0;
        
        if private.CheckWin() then private.WinEnd() else private.ShowSymbols(); end
        
      else  
        
       
        private.WrongForsage(num);
        --ObjSet( "spr_mechanism_symbol_"..num, { alp = 0 });
        --ObjSet( "spr_mechanism_symbol_"..ng_global.progress[ "std" ][ "win_mechanism" ].flag, { alp = 0 });
        --ng_global.progress[ "std" ][ "win_mechanism" ].flag = 0;
        --private.ShowSymbols();
      
      end;
      
    end;
  
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_touch_sign", 0, "", 0 );
    ObjAnimate( "spr_mechanism_symbol_"..num, "alp", 0, 0, func_after,
      { 
        0.0, 0, 0,
        0.6, 0, 1
        
      } );  
  
  
end;  
------------------------------------------------------------------------------------------------
function private.RotationAnim()
  
  --ObjAnimate( "obj_mechanism_rotation", "ang", 1, 0, "", { 0,0,0, 120,0, -20 } );
  
  ObjAnimate( "obj_mechanism_rotation", "ang", 1, 0, "", { 0,0, ObjGet("obj_mechanism_rotation").ang, 120,0, ObjGet("obj_mechanism_rotation").ang - 20 } );
  --ObjAnimate( "obj_mechanism_rotation", "ang", 1, 0, "", { 0,0,0, 120,0,360 } );
  for i = 1, 4  do
    
    if i == 1 or i == 4 then 
      
      --ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0,0, 120,0, -30 } );
      ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0, ObjGet("obj_mechanism_gear_"..i).ang, 120,0, ObjGet("obj_mechanism_gear_"..i).ang - 30 } );
      
    else  
      
      --ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0,0, 120,0,  50 } );
      ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0, ObjGet("obj_mechanism_gear_"..i).ang, 120,0, ObjGet("obj_mechanism_gear_"..i).ang + 50 } );
      
    end;
    
  end
  
end;
------------------------------------------------------------------------------------------------
function private.WrongForsage(num)
  
  local func_after = function()
    
   common_impl.Lock( false );
   private.RotationAnim();
    --ObjSet( "spr_mechanism_symbol_"..num, { alp = 0 });
    --ObjSet( "spr_mechanism_symbol_"..ng_global.progress[ "std" ][ "win_mechanism" ].flag, { alp = 0 });
    ng_global.progress[ "std" ][ "win_mechanism" ].flag = 0;
      
      
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_wrong", 0, "", 0 );
  private.ShowSymbols();
  
  ObjStopAnimate("obj_mechanism_rotation", "ang");
  
  for i = 1, 4  do
    
    ObjStopAnimate("obj_mechanism_gear_"..i, "ang");
    
  end;  
  
  --ObjStopAnimate("obj_mechanism_rotation", "ang");
  
  
  ObjAnimate( "spr_mechanism_symbol_"..num, "alp", 0, 0,"",
  { 
      0.0, 0, 1,
      1.5, 0, 0
        
  } ); 
  ObjAnimate( "spr_mechanism_symbol_"..ng_global.progress[ "std" ][ "win_mechanism" ].flag, "alp", 0, 0,"",
  { 
      0.0, 0, 1,
      1.5, 0, 0
        
  } );   
  
  ObjAnimate( "obj_mechanism_rotation", "ang", 1, 0, func_after, { 0,0,ObjGet("obj_mechanism_rotation").ang, 1.5,0, ObjGet("obj_mechanism_rotation").ang - 1.2 } );
  
  
  for i = 1, 4  do
    
    if i == 1 or i == 4 then 
      
      
      ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0, ObjGet("obj_mechanism_gear_"..i).ang, 1.5,0, ObjGet("obj_mechanism_gear_"..i).ang - 1.4 } );
      
    else  
      
    
      ObjAnimate( "obj_mechanism_gear_"..i, "ang", 1, 0, "", { 0,0,ObjGet("obj_mechanism_gear_"..i).ang, 1.5,0, ObjGet("obj_mechanism_gear_"..i).ang + 2.6 } );
      
    end;
  end;
end;  
------------------------------------------------------------------------------------------------
function private.CheckWin()
  
  answer = false;
  local count = 0;
  
  for i = 1, 8 do
    
    if ng_global.progress[ "std" ][ "win_mechanism" ].state[i] == 1 then count = count + 1; end;
    
  end;
  
  if count == 8 then  answer = true; end;
  
  return answer;
  
end;  
---------------------------------------------------------------------------------------------
function private.ModeChange()
  
  
  local func_after = function()

    common_impl.Lock( false );
    
    if ng_global.progress[ "std" ] [ "win_mechanism" ].mode == 2 then 
    
      ng_global.progress[ "std" ] [ "win_mechanism" ].mode = 1;
      ObjMultiSet({
      { "obj_mechanism_mode_hard", { input = true } },
      { "obj_mechanism_mode_casual", { input = false } },
      });
      
      
      ng_global.progress[ "std" ] [ "win_mechanism" ].state = { 0, 1, 0, 1, 0, 0, 1, 1};
      
      for i = 1, 8  do
        
        if ng_global.progress[ "std" ][ "win_mechanism" ].state[i] == 1 then 
          
         ObjSet("spr_mechanism_symbol_"..i, { input = false, alp = 1}); 
         ObjSet("spr_mechanism_symbol_"..i + 8, { input = false, alp = 1}); 
         
        else
         
         ObjSet("spr_mechanism_symbol_"..i, { input = true, alp = 0}); 
         ObjSet("spr_mechanism_symbol_"..i + 8, { input = true, alp = 0});
         
        end;
       
      end
      
      
    else  
     
     ObjMultiSet({
     { "obj_mechanism_mode_hard", { input = false} },
     { "obj_mechanism_mode_casual", { input = true } },
      });
     public.Reset();
   
    end;   
    --private.SaveState( num );

   end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_mg_superpuzzle_1_puzzle_hint", 0, "", 0 );
  
  if ng_global.progress[ "std" ] [ "win_mechanism" ].mode == 2 then 
    
    
      --ObjAnimate( "obj_mechanism_hard", "alp", 0, 0, "",
      --{ 
      --    0.0, 0, 1,
      --    0.3, 0, 0
      --} ); 
      --
      --ObjAnimate( "obj_mechanism_casual", "alp", 0, 0, func_after,
      --{ 
      --    0.0, 0, 0,
      --    0.3, 0, 1
      --} ); 
      ObjAnimate("spr_mechanism_mode_btn_casual", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.2, 3, 1,
        0.4, 3, 0
      });  
    
  else  
      
      ObjAnimate("spr_mechanism_mode_btn_hard", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.2, 3, 1,
        0.4, 3, 0
      });  
      
   end;
  
  
end; 
--------------------------------------------------------------------------------
function private.MouseEnterAnim( name )

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim( name )
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;  
--*********************************************************************************************************************
function public.Reset()
  
  ng_global.progress[ "std" ] [ "win_mechanism" ].state = { 0, 0, 0, 0, 0, 0, 0, 0};
  ng_global.progress[ "std" ] [ "win_mechanism" ].flag = 0;
  ng_global.progress[ "std" ] [ "win_mechanism" ].mode = 2;
  ObjSet( "obj_mechanism_mode_hard", {input = false });
  ObjSet( "obj_mechanism_mode_casual", { input = true});
  
  for i = 1, 8  do
   
    ObjSet("spr_mechanism_symbol_"..i, { input = true, alp = 0}); 
    ObjSet("spr_mechanism_symbol_"..i + 8, { input = true, alp = 0}); 
       
  end;       
  
  

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  local func_after = function()
  
    private.Win();
    
  end; 
  
  common_impl.Lock( true );
  for i = 1, 16  do
        
    if  ObjGet("spr_mechanism_symbol_"..i).alp == 0 then 
          
          ObjAnimate( "spr_mechanism_symbol_"..i, "alp", 0, 0, func_after,
          { 
              0.0, 0, 0,
              0.3, 0, 1
          } ); 
          func_after = "";  
     end;
       
  end;
 

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  common_impl.Lock( false );
  cmn.SetEventDone( "win_mechanism" );
  cmn.CallEventHandler( "win_mechanism" );
  cmn.CallEventHandler( "win_mechanism_loc" );
  
  cmn.GotoRoom( "rm_attvatation" );

end;
--*********************************************************************************************************************
function private.Win()

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_mechanism_win", 0, "", 0 );
    ObjSet( "tmr_mechanism_win",
    {
      time = 1.0,
      playing = true,
      endtrig = function() private.WinEnd(); end
      
    } );

end;
--*********************************************************************************************************************
for  i = 1, 4  do
  
  ObjAnimate( "spr_mechanism_light_"..i, "alp",1,0,"",
  {
    0.0, 3, 0, 
    1.2, 3, 1,
    2.4, 3, 0,
  }); 
  
end;

