-- name=level3

function public.Start ( param )


  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd( 26 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.LoupeAdd( 8 );
  interface.PuzzleHelpAdd( 13 );
  interface.BtnApparatAdd( 25 );
  interface.BtnMiniHOAdd(8);
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();
  
  common.LevelLoad( "level3", "std", "rm_storageexit", param, private.menu_moduls );
  
  if IsCollectorsEdition() then
    
    common_impl.SetMorphEventDone();
    common_impl.SetCollectEventDone();

  end;

  private.TutorialSetParams();
  interface.KeyUpdate();
  
  common_impl.LoupeSave();
  common_impl.Collectibles2Load();
  
  common_impl.UpdateGameMode( ng_global.gamemode ); 
  
end;
    
function private.Init ()
  
  game = {};
  game.room_names =
  {
   "rm_storageexit"
  ,"ho_chestroom_3"
  ,"rm_street"
  ,"mg_doorroom"
  ,"rm_underbridge"
  ,"ho_boatroom"
  ,"rm_attvatation"
  ,"mg_mechanism"
  ,"ho_underfloor"
  ,"rm_studio"
  ,"ho_studioroom"
  ,"rm_roof"
  ,"mg_deactivation"
  ,"mg_fight"
  ,"rm_groundfloor_3"
  ,"rm_atbar_3"
  ,"rm_bar_3"
  ,"rm_base_3"
  ,"rm_wheelbarrow_3"
  };
  
  game.progress_names_room =
  {
   {"beg_level3"}
   ,{"opn_base_3"}
   ,{"opn_bar_3"}
   ,{"opn_groundfloor_3"}
   ,{"opn_atbar_3"}
   ,{"opn_wheelbarrow_3"}
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "get_collect_morph_item_1_5" }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_morph_item_2_1" }
  ,{ "get_collect_morph_item_2_2" }
  ,{ "get_collect_morph_item_2_3" }
  ,{ "get_collect_morph_item_2_4" }
  ,{ "get_collect_morph_item_2_5" }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_item_1_3" }
  ,{ "get_collect_item_2_1" }
  ,{ "get_collect_item_2_2" }
  ,{ "get_collect_item_2_3" }
  ,{ "opn_storageexit",                    "rm_storageexit",                    { "beg_level3" } }
  ,{ "get_collect_morph_item_3_1" }
  ,{ "vid_storageexit_capitulation",       "rm_storageexit",                    { "opn_storageexit" } }
  ,{ "dlg_storageexit_double",             "rm_storageexit",                    { "vid_storageexit_capitulation" } }
  ,{ "get_avengermark1",                   "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "get_scraper",                        "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "get_amuletscales",                   "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "get_amuletcuffs",                    "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "get_protectivemask",                 "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "use_amuletmagnifier",                "rm_storageexit",                    { "dlg_storageexit_double" } }
  ,{ "use_amuletscales",                   "rm_storageexit",                    { "get_amuletscales" } }
  ,{ "use_amuletcuffs",                    "rm_storageexit",                    { "get_amuletcuffs" } }
  ,{ "get_chestkey_3",                     "rm_storageexit",                    { "use_amuletcuffs" } }
  ,{ "use_chestkey_3",                     "rm_storageexit",                    { "get_chestkey_3" } }
  ,{ "clk_chestkey_3",                     "rm_storageexit",                    { "use_chestkey_3" } }
  ,{ "opn_chestroom_3",                    "rm_storageexit",                    { "clk_chestkey_3" } }
  ,{ "win_chestroom_3",                    "rm_storageexit",                    { "opn_chestroom_3" } }
  ,{ "use_valve",                          "rm_storageexit",                    { "win_chestroom_3" } }
  
  ,{ "opn_street",                         "rm_street",                         { "use_valve" } }
  ,{ "get_collect_morph_item_3_2" }
  ,{ "get_collect_item_3_1" }
  ,{ "vid_street_breeding",                "rm_street",                         { "opn_street" } }
  ,{ "dlg_street_breeding",                "rm_street",                         { "vid_street_breeding" } }
  ,{ "get_broom",                          "rm_street",                         { "dlg_street_breeding" } }
  ,{ "get_figurnepart1",                   "rm_street",                         { "dlg_street_breeding" } }
  ,{ "get_branch",                         "rm_street",                         { "dlg_street_breeding" } }
  ,{ "use_elf_3_1",                        "rm_street"  }
  ,{ "use_broom",                          "rm_street",                         { "get_broom" } }
  ,{ "win_flowerbed",                      "rm_street",                         { "use_broom" } }
  ,{ "get_button_3",                         "rm_street",                         { "win_flowerbed" } }
  ,{ "get_star1",                          "rm_street",                         { "win_flowerbed" } }
  ,{ "use_scraper",                        "rm_street",                         { "get_scraper" } }
  ,{ "get_magnet",                         "rm_street",                         { "use_scraper" } }
  ,{ "use_button_3",                         "rm_storageexit",                  { "get_button_3" } }
  ,{ "clk_button_armorybox",                         "rm_storageexit",          { "use_button_3" } }
  ,{ "get_star2",                          "rm_storageexit",                    { "clk_button_armorybox" } }
  ,{ "use_star1",                          "rm_storageexit",                    { "get_star1" } }
  ,{ "use_star2",                          "rm_storageexit",                    { "get_star2" } }
  ,{ "get_agentbadge",                     "rm_storageexit",                    { "use_star1", "use_star2" } }
  ,{ "use_agentbadge",                     "rm_street",                         { "get_agentbadge" } }
  ,{ "get_roundhandle",                    "rm_street",                         { "use_agentbadge" } }
  ,{ "use_roundhandle",                    "rm_storageexit",                    { "get_roundhandle" } }
  ,{ "clk_roundhandle",                    "rm_storageexit",                    { "use_roundhandle" } }
  ,{ "get_cartridge",                      "rm_storageexit",                    { "clk_roundhandle" } }
  ,{ "use_cartridge",          }
  ,{ "clk_rifle_3",          }
  ,{ "get_loadedgun_3",          }
  ,{ "use_loadedgun_3",                      "rm_street",                       { "get_loadedgun_3" } }
  ,{ "get_boxkey",                         "rm_street",                         { "use_loadedgun" } }
  ,{ "use_boxkey",                         "rm_street",                         { "get_boxkey" } }
  ,{ "get_tapepiece",                      "rm_street",                         { "use_boxkey" } }
  ,{ "use_magnet",             }
  ,{ "use_tapepiece",          }
  ,{ "get_magnetbranch",       }
  ,{ "use_magnetbranch",                   "rm_street",                         { "get_magnetbranch" } }
  ,{ "get_mechanismpart_3",                "rm_street",                         { "use_magnetbranch" } }
  ,{ "use_mechanismpart_3",                "rm_street",                         { "get_mechanismpart_3" } }
  ,{ "win_doorroom",                       "rm_street",                         { "use_broom" } } 
  
  ,{ "opn_underbridge",                    "rm_underbridge",                    { "win_doorroom" } }
  ,{ "get_collect_morph_item_3_3" }
  ,{ "get_antirustbottle",                 "rm_underbridge",                    { "opn_underbridge" } }
  ,{ "get_remotecontrol",                  "rm_underbridge",                    { "opn_underbridge" } }
  ,{ "use_corkscrew_3_1",          }
  ,{ "get_antirust",           }
  ,{ "use_antirust_3_1",                   "rm_underbridge",                    { "get_antirust" } }
  ,{ "get_duster_3",                       "rm_underbridge",                    { "use_antirust_3_1" } }
  ,{ "get_pincers_3",                      "rm_underbridge",                    { "use_antirust_3_1" } }
  ,{ "use_duster_3",                       "rm_street",                         { "get_duster_3" } }
  ,{ "use_elf_3_2",                        "rm_street",                         { "use_duster_3" } }
  ,{ "get_ticket",                         "rm_street",                         { "use_elf_3_2" } }
  ,{ "use_ticket",                         "rm_underbridge",                    { "get_ticket" } }
  ,{ "opn_boatroom",                       "rm_underbridge",                    { "use_ticket" } }
  ,{ "win_boatroom",                       "rm_underbridge",                    { "opn_boatroom" } } 
  ,{ "clk_remotecontrol",          }
  ,{ "use_batteries",          }
  ,{ "get_shipremotecontrol",  }
  ,{ "use_elf_3_3",                          "rm_underbridge",                  { "get_shipremotecontrol" } } 
  ,{ "use_shipremotecontrol",              "rm_underbridge",                    { "get_shipremotecontrol" } }
  ,{ "vid_underbridge_bridge",             "rm_underbridge",                    { "use_shipremotecontrol" } }
  ,{ "opn_attvatation",                    "rm_attvatation",                    { "vid_underbridge_bridge" } }
  ,{ "get_collect_morph_item_3_4" }
  ,{ "get_collect_item_3_2" }
  ,{ "vid_attvatation_villain",            "rm_attvatation",                    { "opn_attvatation" } }
  ,{ "get_pole",                           "rm_attvatation",                    { "vid_attvatation_villain" } }
  ,{ "get_hammer",                         "rm_attvatation",                    { "vid_attvatation_villain" } }
  ,{ "use_pincers_3",                      "rm_attvatation",                    { "get_pincers_3" } }
  ,{ "get_penknife",                       "rm_attvatation",                    { "use_pincers_3" } }
  ,{ "use_pole",                           "rm_underbridge",                    { "get_pole" } }
  ,{ "get_moneybox",                       "rm_underbridge",                    { "use_pole" } }
  ,{ "use_hammer_3",            }
  ,{ "get_banknote",          }
  ,{ "use_banknote",                       "rm_street",                         { "get_banknote" } }
  ,{ "clk_button_3",                        "rm_street",                         { "use_banknote" } }
  ,{ "get_nuts",                           "rm_street",                         { "clk_button_3" } }
  ,{ "use_nuts",                           "rm_attvatation",                    { "get_nuts" } }
  ,{ "get_trunkkeys",                      "rm_attvatation",                    { "use_nuts" } }
  ,{ "use_trunkkeys",                      "rm_attvatation",                    { "get_trunkkeys" } }
  ,{ "clk_trunkkeys",                      "rm_attvatation",                    { "get_trunkkeys" } }
  ,{ "get_sidecutter",                     "rm_attvatation",                    { "clk_trunkkeys" } }
  ,{ "get_brokenwelder",                   "rm_attvatation",                    { "clk_trunkkeys" } }
  --,{ "use_penknife_1",                     "rm_attvatation",                    { "get_penknife" } }
  ,{ "use_penknife",                       "rm_attvatation",                    { "get_penknife" } }
  ,{ "win_mechanism",                      "rm_attvatation",                    { "use_penknife_1" } }
  ,{ "use_sidecutter",                     "rm_attvatation",                    { "win_mechanism" } }
  ,{ "dlg_attvatation_save",               "rm_attvatation",                    { "use_sidecutter" } }
  ,{ "clk_carpet",                         "rm_storageexit",                    { "opn_storageexit" } }
  ,{ "use_crosseddaggers",                 "rm_storageexit",                    { "clk_carpet", "dlg_attvatation_save" } }
  ,{ "opn_underfloor",                     "rm_storageexit",                    { "use_crosseddaggers" } }
  ,{ "win_underfloor",                     "rm_storageexit",                    { "opn_underfloor" } }
  ,{ "use_ovalbutton",                     "rm_street",                         { "win_underfloor" } }
  ,{ "clk_ovalbutton",                     "rm_street",                         { "use_ovalbutton" } }
  ,{ "get_battery_3",                      "rm_street",                         { "clk_ovalbutton" } }
  ,{ "clk_welder_1",          }
  ,{ "use_battery_3",          }
  ,{ "get_welder",           }
  ,{ "use_welder",                         "rm_attvatation",                    { "get_welder" } }
  ,{ "use_protectivemask",                 "rm_attvatation",                    { "use_welder" } }
  
  ,{ "opn_studio",                         "rm_studio",                         { "use_protectivemask" } }
  ,{ "get_collect_morph_item_3_5" }
  ,{ "dlg_studio_calling",                 "rm_studio",                         { "opn_studio" } }
  ,{ "clk_studio_point_1",                 "rm_studio",                         { "opn_studio" } }
  ,{ "clk_studio_point_2",                 "rm_studio",                         { "opn_studio" } }
  ,{ "use_device_3",                       "rm_studio",                         { "clk_studio_point_1", "clk_studio_point_2" } }
  ,{ "win_studio",                         "rm_studio",                         { "use_device_3" } } 
  ,{ "vid_studio_loupe",                   "rm_studio",                         { "win_studio" } } 
  ,{ "get_box1",                           "rm_studio",                         { "vid_studio_loupe" } }
  ,{ "get_figurinepart2",                  "rm_studio",                         { "vid_studio_loupe" } }
  ,{ "get_figurinepart3",                  "rm_studio",                         { "opn_studio" } }
  ,{ "get_box2",                           "rm_studio",                         { "opn_studio" } }
  ,{ "use_figurinepart1",                  "rm_studio",                         { "get_figurinepart1" } }
  ,{ "use_figurinepart2",                  "rm_studio",                         { "get_figurinepart2" } }
  ,{ "use_figurinepart3",                  "rm_studio",                         { "get_figurinepart3" } }
  ,{ "win_wall",                           "rm_studio",                         { "use_figurinepart1", "use_figurinepart2", "use_figurinepart3" } } 
  ,{ "get_fastingelement",                 "rm_studio",                         { "win_wall" } }
  ,{ "get_clip_3",                         "rm_studio",                         { "win_wall" } }
  ,{ "use_fastingelement",                 "rm_street",                         { "get_fastingelement" } }
  ,{ "get_box3",                           "rm_street",                         { "use_fastingelement" } }
  ,{ "use_antirust_3_2",                   "rm_attvatation",                    { "get_antirust" } }
  ,{ "use_clip_3",                         "rm_attvatation",                    { "get_clip_3","use_antirust_3_2" } }
  ,{ "clk_clip_3",                         "rm_attvatation",                    { "use_clip_3" } }
  ,{ "get_lever_3",                        "rm_attvatation",                    { "clk_clip_3" } }
  ,{ "use_lever_3",                        "rm_studio",                         { "get_lever_3" } }
  ,{ "win_console",                        "rm_studio",                         { "use_lever_3" } }
  ,{ "opn_studioroom",                     "rm_studio",                         { "win_console" } }
  ,{ "win_studioroom",                     "rm_studio",                         { "win_console" } }
  ,{ "use_agemtsymbol",                    "rm_storageexit",                    { "win_studioroom" } }
  ,{ "get_ax",                             "rm_storageexit",                    { "use_agemtsymbol" } }
  ,{ "get_shocker",                        "rm_storageexit",                    { "use_agemtsymbol" } }
  ,{ "use_ax",                             "rm_underbridge",                    { "get_ax" } }
  ,{ "use_elf_3_4",                        "rm_underbridge",                    { "use_ax" } }
  ,{ "get_box4",                           "rm_underbridge",                    { "use_elf_3_4" } }
  ,{ "use_box",                            "rm_studio",                         { "get_box4" } }
  ,{ "win_ceiling",                        "rm_studio",                         { "use_box" } }
  ,{ "clk_ceiling",                        "rm_studio",                         { "win_ceiling" } }
  ,{ "opn_roof",                           "rm_roof",                           { "clk_ceiling" } } 
  ,{ "get_collect_morph_item_3_6" }
  ,{ "get_collect_item_3_3" }
  ,{ "vid_roof_villainy",                  "rm_roof",                           { "opn_roof" } }
  ,{ "use_shocker",                        "rm_roof",                           { "vid_roof_villainy" } }
  ,{ "clk_roof_birds",                     "rm_roof",                           { "opn_roof" } }
  ,{ "get_bastardsmedallion",              "rm_roof",                           { "vid_roof_villainy" } }
  ,{ "use_penknife_2",                     "rm_roof",                           { "vid_roof_villainy" } }
  ,{ "get_avengermark2",                   "rm_roof",                           { "use_penknife_2" } }
  ,{ "use_bastardsmedallion",              "rm_attvatation",                    { "get_bastardsmedallion" } }
  ,{ "get_plate",                          "rm_attvatation",                    { "use_bastardsmedallion" } }
  ,{ "use_plate",                          "rm_roof",                           { "get_plate" } }
  ,{ "get_avengermark3",                   "rm_roof",                           { "use_plate" } }
  ,{ "use_avengermark1",                   "rm_roof",                           { "get_avengermark1" } }
  ,{ "use_avengermark2",                   "rm_roof",                           { "get_avengermark2" } }
  ,{ "use_avengermark3",                   "rm_roof",                           { "get_avengermark3" } }
  ,{ "win_deactivation",                   "rm_roof",                           { "use_avengermark1", "use_avengermark2", "use_avengermark3" } }
  ,{ "vid_roof_risen",                     "rm_roof",                           { "win_deactivation" } }
  ,{ "win_fight",                        "rm_roof",                             { "vid_roof_risen" } }
  ,{ "vid_roof_final",                     "rm_roof",                           { "win_fight" } }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits",
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;
  
  
end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;