-- name=level3_inv
--*********************************************************************************************************************
function public.Init ()
  
  private.init_branch();
  private.init_antirustbottle();
  private.init_remotecontrol();
  private.init_moneybox();
  private.init_brokenwelder();
  private.init_rifle_3();
  
  public.deploy_inventory = {
  { "branch",      { "use_magnet", "use_tapepiece" }, { "get_magnetbranch" }  },
  { "antirustbottle",      { "use_corkscrew_3_1" }, { "get_antirust" }  },
  { "remotecontrol",      { "clk_remotecontrol", "use_batteries" }, { "get_shipremotecontrol" }  },
  { "moneybox",       { "use_hammer_3" }, { "get_banknote" }  },
  { "brokenwelder",       { "clk_welder_1", "use_battery_3" }, { "get_welder" }  },
  { "rifle_3",       { "use_cartridge", "clk_rifle_3" }, { "get_loadedgun_3" }  }
  };
   
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level3_inv_deploy" }, "level3_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );
  
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;
end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
function private.ShowBbt( use_name )
  
  if use_name == "" then
    
      
  end;
  
end;
--*********************************************************************************************************************
-- function *** branch *** () end;
--*********************************************************************************************************************
  function private.init_branch()

    ObjSet( "spr_deploy_magnetbranch", { event_mdown = function() public.get_magnetbranch() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_magnet" ] = {
        type = "use",
        inv_obj = "inv_magnet_3",
        use_place = "obj_branch_use_magnet",
        room = "int_deploy_inv",
        zz = "deploy_inv_branch",
        zz_gate = "inv_branch"
    };
    function use_magnet_inv ()

      interface.InventoryItemRemove( "inv_magnet_3" );
     
      
    end;
    function use_magnet_beg ()

      ObjDelete( "obj_branch_use_magnet" );

    end;
    function use_magnet_end ()
      
      ObjSet( "spr_branch_magnet", { alp = 1 });
      
      if( cmn.IsEventDone("get_tapepiece") and not cmn.IsEventDone("use_tapepiece") )then
        ObjSet("spr_branch_plus_light", { alp = 1 });
      else
        ObjSet("spr_branch_plus_light", { alp = 0 });
      end;
      
      ObjSet( "spr_deploy_branch_magnet", { alp = 1, pos_x = 78, pos_y = -155 });
      ObjSet( "obj_branch_use_tapepiece", { input = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_magnet", use_magnet_beg, "inv_branch" );
    cmn.AddSubscriber( "use_magnet", use_magnet_inv );
    cmn.AddSubscriber( "use_magnet", use_magnet_end );
    cmn.AddSubscriber( "use_magnet", use_magnet_end, "inv_branch" );
    cmn.AddSubscriber( "use_magnet_inv", use_magnet_inv );
    cmn.AddSubscriber( "use_magnet_beg", use_magnet_beg, "inv_branch" );
    cmn.AddSubscriber( "use_magnet_end", use_magnet_end, "inv_branch" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_tapepiece" ] = {
        type = "use",
        inv_obj = "inv_tapepiece",
        use_place = "obj_branch_use_tapepiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_branch",
        zz_gate = "inv_branch"
    };
    function use_tapepiece_inv ()

      interface.InventoryItemRemove( "inv_tapepiece" );
     
      
    end;
    function use_tapepiece_beg ()

      ObjDelete( "obj_branch_use_tapepiece" );

    end;
    function use_tapepiece_end ()

      ObjSet("spr_branch_plus_light", { alp = 1 });
      ObjSet( "spr_branch_scotch", { alp = 1 });
      ObjSet( "spr_deploy_branch_tapepiece_1", { alp = 1 });
      ObjSet( "spr_deploy_branch_tapepiece_2", { alp = 1 });
      ObjSet( "spr_deploy_magnetbranch", { input = true });
      ObjSet( "gfx_deploy_magnetbranch", { active = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_tapepiece", use_tapepiece_beg, "inv_branch" );
    cmn.AddSubscriber( "use_tapepiece", use_tapepiece_inv );
    cmn.AddSubscriber( "use_tapepiece", use_tapepiece_end );
    cmn.AddSubscriber( "use_tapepiece", use_tapepiece_end, "inv_branch" );
    cmn.AddSubscriber( "use_tapepiece_inv", use_tapepiece_inv );
    cmn.AddSubscriber( "use_tapepiece_beg", use_tapepiece_beg, "inv_branch" );
    cmn.AddSubscriber( "use_tapepiece_end", use_tapepiece_end, "inv_branch" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_magnetbranch" ] = {
      type = "get",
      get_obj = "spr_deploy_magnetbranch",
      room = "int_deploy_inv",
      zz = "deploy_inv_branch",
      zz_gate = "inv_branch"
    };
    function get_magnetbranch_inv ()

      interface.InventoryItemRemove( "inv_branch" );
      interface.InventoryItemAdd( "inv_magnetbranch", "spr_deploy_magnetbranch" );

    end;
    function get_magnetbranch_deploy ()

      ObjDelete( "gfx_deploy_magnetbranch" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_magnetbranch", get_magnetbranch_inv );
    cmn.AddSubscriber( "get_magnetbranch", get_magnetbranch_deploy, "inv_branch" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_magnet()

    local item = "inv_magnet_3";
    if private.ObjIntersectCheck( item, "obj_branch_use_magnet", "deploy_inv_branch" ) then

      cmn.CallEventHandler( "use_magnet_beg", "inv_branch" );
      cmn.CallEventHandler( "use_magnet_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
          common_impl.Lock( false );

          cmn.SetEventDone( "use_magnet" );
          cmn.CallEventHandler( "use_magnet_end", "inv_branch" );
          
        end;
        
        ObjAnimate( "spr_deploy_branch_magnet", "pos_xy", 0, 0, func_end,
        { 
          0.0, 0, -213, -141,
          0.5, 0, 78, -155
        });
      
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_branch_use_magnet", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_branch_magnet", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_tapepiece()

    local item = "inv_tapepiece";
    if private.ObjIntersectCheck( item, "obj_branch_use_tapepiece", "deploy_inv_branch" ) and cmn.IsEventDone("use_magnet") then

      cmn.CallEventHandler( "use_tapepiece_beg", "inv_branch" );
      cmn.CallEventHandler( "use_tapepiece_inv" );

      local func_after = function ()
        
        common_impl.Lock( false );

        cmn.SetEventDone( "use_tapepiece" );
        cmn.CallEventHandler( "use_tapepiece_end", "inv_branch" );
    
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_branch_use_tapepiece", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_branch_tapepiece_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });
      
      ObjAnimate( "spr_deploy_branch_tapepiece_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_magnetbranch()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_magnetbranch" );
    cmn.CallEventHandler( "get_magnetbranch", "inv_branch" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** antirustbottle *** () end;
--*********************************************************************************************************************
  function private.init_antirustbottle()

    ObjSet( "spr_deploy_antirust", { event_mdown = function() public.get_antirust() end } );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_corkscrew_3_1" ] = {
        type = "use",
        inv_obj = "inv_corkscrew_3",
        use_place = "obj_antirustbottle_use_corkscrew_3_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_antirustbottle",
        zz_gate = "inv_antirustbottle"
    };
    function use_corkscrew_3_1_inv ()

      interface.InventoryItemRemove( "inv_corkscrew_3" );
      
    end;
    function use_corkscrew_3_1_beg ()

      ObjDelete( "obj_antirustbottle_use_corkscrew_3_1" );

    end;
    function use_corkscrew_3_1_end ()
      
      ObjDelete( "spr_antirustbottle_cap" );
      ObjDelete( "vid_deploy_antirust_use_corkscrew" );
      ObjSet( "spr_deploy_antirust", { input = true });
      ObjSet( "gfx_deploy_antirust", { active = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_corkscrew_3_1", use_corkscrew_3_1_beg, "inv_antirustbottle" );
    cmn.AddSubscriber( "use_corkscrew_3_1", use_corkscrew_3_1_inv );
    cmn.AddSubscriber( "use_corkscrew_3_1", use_corkscrew_3_1_end );
    cmn.AddSubscriber( "use_corkscrew_3_1", use_corkscrew_3_1_end, "inv_antirustbottle" );
    cmn.AddSubscriber( "use_corkscrew_3_1_inv", use_corkscrew_3_1_inv );
    cmn.AddSubscriber( "use_corkscrew_3_1_beg", use_corkscrew_3_1_beg, "inv_antirustbottle" );
    cmn.AddSubscriber( "use_corkscrew_3_1_end", use_corkscrew_3_1_end, "inv_antirustbottle" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_antirust" ] = {
      type = "get",
      get_obj = "spr_deploy_antirust",
      room = "int_deploy_inv",
      zz = "deploy_inv_antirustbottle",
      zz_gate = "inv_antirustbottle"
    };
    function get_antirust_inv ()

      interface.InventoryItemRemove( "inv_antirustbottle" );
      interface.InventoryItemAdd( "inv_antirust", "spr_deploy_antirust" );

    end;
    function get_antirust_deploy ()

      ObjDelete( "gfx_deploy_antirust" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_antirust", get_antirust_inv );
    cmn.AddSubscriber( "get_antirust", get_antirust_deploy, "inv_antirustbottle" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_corkscrew_3()

    local item = "inv_corkscrew_3";
    if private.ObjIntersectCheck( item, "obj_antirustbottle_use_corkscrew_3_1", "deploy_inv_antirustbottle" ) then

      cmn.CallEventHandler( "use_corkscrew_3_1_beg", "inv_antirustbottle" );
      cmn.CallEventHandler( "use_corkscrew_3_1_inv" );

      local func_after = function ()
        
        common_impl.Lock( false );

        cmn.SetEventDone( "use_corkscrew_3_1" );
        cmn.CallEventHandler( "use_corkscrew_3_1_end", "inv_antirustbottle" );
    
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_antirustbottle_use_corkscrew", 0, "", 0 );
      
      VidPlay( "vid_deploy_antirust_use_corkscrew", func_after );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_antirust()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_antirust" );
    cmn.CallEventHandler( "get_antirust", "inv_antirustbottle" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** remotecontrol *** () end;
--*********************************************************************************************************************
  function private.init_remotecontrol()

    ObjSet( "spr_deploy_shipremotecontrol", { event_mdown = function() public.get_shipremotecontrol() end } );
    ObjSet( "obj_remotecontrol_clk_remotecontrol", { event_mdown = function() private.clk_remotecontrol() end } );
    
    --------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_remotecontrol" ] = {
    type = "click",
    use_place = "obj_remotecontrol_clk_remotecontrol",
    room = "int_deploy_inv",
    zz = "deploy_inv_remotecontrol",
    zz_gate = "inv_remotecontrol"
    };
    
    function clk_remotecontrol_beg ()

      ObjDelete( "obj_remotecontrol_clk_remotecontrol" )

    end;
    function clk_remotecontrol_end ()
      
      if( cmn.IsEventDone("win_boatroom") and not cmn.IsEventDone("use_batteries") )then
        ObjSet( "spr_remotecontrol_plus_light", { alp = 1 });
      else 
        ObjSet( "spr_remotecontrol_plus_light", { alp = 0 });
      end;
      
      ObjMultiSet({
        { "spr_remotecontrol_open",     { alp = 1 }},
        { "spr_deploy_remotecontrol_over",     { pos_y = 280 }},
        { "obj_remotecontrol_use_batteries", { input = true }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_remotecontrol", clk_remotecontrol_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol", clk_remotecontrol_end );
    cmn.AddSubscriber( "clk_remotecontrol", clk_remotecontrol_end, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol_beg", clk_remotecontrol_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol_end", clk_remotecontrol_end, "inv_remotecontrol" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_batteries" ] = {
        type = "use",
        inv_obj = "inv_batteries",
        use_place = "obj_remotecontrol_use_batteries",
        room = "int_deploy_inv",
        zz = "deploy_inv_remotecontrol",
        zz_gate = "inv_remotecontrol"
    };
    function use_batteries_inv ()

      interface.InventoryItemRemove( "inv_batteries" );
      
    end;
    function use_batteries_beg ()

      ObjDelete( "obj_remotecontrol_use_batteries" );

    end;
    function use_batteries_end ()
      
      ObjSet( "spr_remotecontrol_plus_light", { alp = 1 });
      ObjDelete( "spr_remotecontrol_open" );
      ObjDelete( "spr_remotecontrol_battery" );
      ObjSet( "spr_deploy_remotecontrol_battery_1", { alp = 1 });
      ObjSet( "spr_deploy_remotecontrol_battery_2", { alp = 1 });
      ObjSet( "spr_deploy_remotecontrol_over", { pos_y = 136 });
      ObjSet( "spr_deploy_shipremotecontrol", { input = true });
      ObjSet( "gfx_deploy_shipremotecontrol", { active = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_batteries", use_batteries_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "use_batteries", use_batteries_inv );
    cmn.AddSubscriber( "use_batteries", use_batteries_end );
    cmn.AddSubscriber( "use_batteries", use_batteries_end, "inv_remotecontrol" );
    cmn.AddSubscriber( "use_batteries_inv", use_batteries_inv );
    cmn.AddSubscriber( "use_batteries_beg", use_batteries_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "use_batteries_end", use_batteries_end, "inv_remotecontrol" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_shipremotecontrol" ] = {
      type = "get",
      get_obj = "spr_deploy_shipremotecontrol",
      room = "int_deploy_inv",
      zz = "deploy_inv_remotecontrol",
      zz_gate = "inv_remotecontrol"
    };
    function get_shipremotecontrol_inv ()

      interface.InventoryItemRemove( "inv_remotecontrol" );
      interface.InventoryItemAdd( "inv_shipremotecontrol", "spr_deploy_shipremotecontrol" );

    end;
    function get_shipremotecontrol_deploy ()

      ObjDelete( "gfx_deploy_shipremotecontrol" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_shipremotecontrol", get_shipremotecontrol_inv );
    cmn.AddSubscriber( "get_shipremotecontrol", get_shipremotecontrol_deploy, "inv_remotecontrol" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_remotecontrol()

    cmn.CallEventHandler( "clk_remotecontrol_beg", "inv_remotecontrol" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_remotecontrol" );
      cmn.CallEventHandler( "clk_remotecontrol_end", "inv_remotecontrol" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_remotecontrol_touch_cover", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_remotecontrol_over", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, 136, 
      0.5, 0, 280
    } );
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_batteries()

    local item = "inv_batteries";
    if private.ObjIntersectCheck( item, "obj_remotecontrol_use_batteries", "deploy_inv_remotecontrol" ) and cmn.IsEventDone("clk_remotecontrol") then

      cmn.CallEventHandler( "use_batteries_beg", "inv_remotecontrol" );
      cmn.CallEventHandler( "use_batteries_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
          common_impl.Lock( false );
          cmn.SetEventDone( "use_batteries" );
          cmn.CallEventHandler( "use_batteries_end", "inv_remotecontrol" );
          
        end;
        
        ObjAnimate( "spr_deploy_remotecontrol_over", "pos_y", 0, 0, func_end,
        { 
          0.0, 0, 280, 
          0.5, 0, 136
        });
        
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_remotecontrol_use_batteries", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_remotecontrol_battery_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });
      
      ObjAnimate( "spr_deploy_remotecontrol_battery_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 0, 
        0.6, 0, 1
      });

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_shipremotecontrol()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_shipremotecontrol" );
    cmn.CallEventHandler( "get_shipremotecontrol", "inv_remotecontrol" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** moneybox *** () end;
--*********************************************************************************************************************
  function private.init_moneybox()

    ObjSet( "spr_deploy_moneybox_broken_money", { event_mdown = function() public.get_banknote() end } );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_hammer_3" ] = {
        type = "use",
        inv_obj = "inv_hammer_3",
        use_place = "obj_moneybox_use_hammer_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_moneybox",
        zz_gate = "inv_moneybox"
    };
    function use_hammer_3_inv ()

      interface.InventoryItemRemove( "inv_hammer_3" );
     
      
    end;
    function use_hammer_3_beg ()

      ObjDelete( "obj_moneybox_use_hammer_3" );

    end;
    function use_hammer_3_end ()
      
      ObjSet( "inv_moneybox", { res = "assets/levels/level3/inv_deploy/inv_piggy_bank/inv/broken" } );
      ObjSet( "spr_moneybox_broken", { alp = 1 });
      ObjDelete( "vid_deploy_moneybox_use_hammer" );
      ObjSet( "spr_deploy_moneybox_broken", { input = true, alp = 1 });
      ObjSet( "gfx_deploy_antirust", { active = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_hammer_3", use_hammer_3_beg, "inv_moneybox" );
    cmn.AddSubscriber( "use_hammer_3", use_hammer_3_inv );
    cmn.AddSubscriber( "use_hammer_3", use_hammer_3_end );
    cmn.AddSubscriber( "use_hammer_3", use_hammer_3_end, "inv_moneybox" );
    cmn.AddSubscriber( "use_hammer_3_inv", use_hammer_3_inv );
    cmn.AddSubscriber( "use_hammer_3_beg", use_hammer_3_beg, "inv_moneybox" );
    cmn.AddSubscriber( "use_hammer_3_end", use_hammer_3_end, "inv_moneybox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_banknote" ] = {
      type = "get",
      get_obj = "spr_deploy_banknote",
      room = "int_deploy_inv",
      zz = "deploy_inv_moneybox",
      zz_gate = "inv_moneybox"
    };
    function get_banknote_inv ()

      interface.InventoryItemRemove( "inv_moneybox" );
      interface.InventoryItemAdd( "inv_banknote", "spr_deploy_banknote" );

    end;
    function get_banknote_deploy ()

      ObjDelete( "gfx_deploy_moneybox_broken_money" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_banknote", get_banknote_inv );
    cmn.AddSubscriber( "get_banknote", get_banknote_deploy, "inv_moneybox" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_hammer_3()

    local item = "inv_hammer_3";
    if private.ObjIntersectCheck( item, "obj_moneybox_use_hammer_3", "deploy_inv_moneybox" ) then

      cmn.CallEventHandler( "use_hammer_3_beg", "inv_moneybox" );
      cmn.CallEventHandler( "use_hammer_3_inv" );

      local func_after = function ()
        
        common_impl.Lock( false );

        cmn.SetEventDone( "use_hammer_3" );
        cmn.CallEventHandler( "use_hammer_3_end", "inv_moneybox" );
    
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_moneybox_use_hammer", 0, "", 0 );
      
      VidPlay( "vid_deploy_moneybox_use_hammer", func_after );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_banknote()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    ObjSet("spr_deploy_moneybox_broken_money", { alp = 0 });
    ObjSet("spr_deploy_banknote", { alp = 1 });
    
    cmn.SetEventDone( "get_banknote" );
    cmn.CallEventHandler( "get_banknote", "inv_moneybox" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** brokenwelder *** () end;
--*********************************************************************************************************************
  function private.init_brokenwelder()

    ObjSet( "spr_deploy_welder", { event_mdown = function() public.get_welder() end } );
    ObjSet( "obj_brokenwelder_clk_welder_1", { event_mdown = function() private.clk_welder_1() end } );
    
    --------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_welder_1" ] = {
    type = "click",
    use_place = "obj_brokenwelder_clk_welder_1",
    room = "int_deploy_inv",
    zz = "deploy_inv_brokenwelder",
    zz_gate = "inv_brokenwelder"
    };
    
    function clk_welder_1_beg ()

      ObjDelete( "obj_brokenwelder_clk_welder_1" )

    end;
    function clk_welder_1_end ()

      if( cmn.IsEventDone("get_battery_3") and not cmn.IsEventDone("use_battery_3") )then
        ObjSet( "spr_brokenwelder_plus_light", { alp = 1 });
      else 
        ObjSet( "spr_brokenwelder_plus_light", { alp = 0 });
      end;
      
      ObjMultiSet({
        { "spr_brokenwelder_open",     { alp = 1 }},
        { "spr_deploy_welder_cover",     { pos_x = -325, pos_y = 35 }},
        { "obj_brokenwelder_use_battery", { input = true }}
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_welder_1", clk_welder_1_beg, "inv_brokenwelder" );
    cmn.AddSubscriber( "clk_welder_1", clk_welder_1_end );
    cmn.AddSubscriber( "clk_welder_1", clk_welder_1_end, "inv_brokenwelder" );
    cmn.AddSubscriber( "clk_welder_1_beg", clk_welder_1_beg, "inv_brokenwelder" );
    cmn.AddSubscriber( "clk_welder_1_end", clk_welder_1_end, "inv_brokenwelder" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_battery_3" ] = {
        type = "use",
        inv_obj = "inv_battery_3",
        use_place = "obj_brokenwelder_use_battery",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenwelder",
        zz_gate = "inv_brokenwelder"
    };
    function use_battery_3_inv ()

      interface.InventoryItemRemove( "inv_battery_3" );
     
    end;
    function use_battery_3_beg ()

      ObjDelete( "obj_brokenwelder_use_battery" );

    end;
    function use_battery_3_end ()
      
      ObjDelete( "spr_brokenwelder_open" ); 
      ObjDelete( "spr_brokenwelder_battery" );
      ObjSet( "spr_brokenwelder_plus_light", { alp = 1 });
      ObjSet( "spr_deploy_welder_battery", { alp = 1 });
      ObjSet( "spr_deploy_welder_cover", { pos_x = -79, pos_y = 55 });
      ObjSet( "spr_deploy_welder", { input = true });
      ObjSet( "gfx_deploy_welder", { active = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_battery_3", use_battery_3_beg, "inv_brokenwelder" );
    cmn.AddSubscriber( "use_battery_3", use_battery_3_inv );
    cmn.AddSubscriber( "use_battery_3", use_battery_3_end );
    cmn.AddSubscriber( "use_battery_3", use_battery_3_end, "inv_brokenwelder" );
    cmn.AddSubscriber( "use_battery_3_inv", use_battery_3_inv );
    cmn.AddSubscriber( "use_battery_3_beg", use_battery_3_beg, "inv_brokenwelder" );
    cmn.AddSubscriber( "use_battery_3_end", use_battery_3_end, "inv_brokenwelder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_welder" ] = {
      type = "get",
      get_obj = "spr_deploy_welder",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenwelder",
      zz_gate = "inv_brokenwelder"
    };
    function get_welder_inv ()

      interface.InventoryItemRemove( "inv_brokenwelder" );
      interface.InventoryItemAdd( "inv_welder", "spr_deploy_welder" );

    end;
    function get_welder_deploy ()

      ObjDelete( "gfx_deploy_welder" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_welder", get_welder_inv );
    cmn.AddSubscriber( "get_welder", get_welder_deploy, "inv_brokenwelder" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_welder_1()

    cmn.CallEventHandler( "clk_welder_1_beg", "inv_brokenwelder" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_welder_1" );
      cmn.CallEventHandler( "clk_welder_1_end", "inv_brokenwelder" );

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_welding", 0, "", 0 );
    
    ObjAnimate( "spr_deploy_welder_cover", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, -79, 55, 
      0.5, 0, -325, 35
    } );
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_battery_3()

    local item = "inv_battery_3";
    if private.ObjIntersectCheck( item, "obj_brokenwelder_use_battery", "deploy_inv_brokenwelder" ) and cmn.IsEventDone("clk_welder_1") then

      cmn.CallEventHandler( "use_battery_3_beg", "inv_brokenwelder" );
      cmn.CallEventHandler( "use_battery_3_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
          common_impl.Lock( false );
          cmn.SetEventDone( "use_battery_3" );
          cmn.CallEventHandler( "use_battery_3_end", "inv_brokenwelder" );
          
        end;
        
        ObjAnimate( "spr_deploy_welder_cover", "pos_xy", 0, 0, func_end,
        { 
          0.0, 0, -325, 35,
          0.5, 0, -79, 55
        });
        
      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_brokenwelder_use_battery", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_welder_battery", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_welder()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_welder" );
    cmn.CallEventHandler( "get_welder", "inv_brokenwelder" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** rifle_3 *** () end;
--*********************************************************************************************************************
  function private.init_rifle_3()

    ObjSet( "spr_deploy_rifle_3", { event_mdown = function() public.get_loadedgun_3() end } );
    ObjSet( "obj_rifle_3_clk_rifle", { event_mdown = function() private.clk_rifle_3() end } );
    
    --------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_rifle_3" ] = {
    type = "click",
    use_place = "obj_rifle_3_clk_rifle",
    room = "int_deploy_inv",
    zz = "deploy_inv_rifle_3",
    zz_gate = "inv_rifle_3"
    };
    
    function clk_rifle_3_beg ()

      ObjDelete( "obj_rifle_3_clk_rifle" )

    end;
    function clk_rifle_3_end ()

      ObjMultiSet({
        { "spr_deploy_rifle_3_close",     { alp = 1 }},
        { "inv_rifle_3",     { res = "assets/levels/level2/rm_bar_2/zz_jukebox/inv/inv_rifle" }},
        { "spr_deploy_rifle_3", { input = true }},
        { "gfx_deploy_rifle_3", { active = true }}
      });
      
      ObjDelete("spr_deploy_rifle_3_open");
      ObjDelete("spr_rifle_3_bullet");

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_rifle_3", clk_rifle_3_beg, "inv_rifle_3" );
    cmn.AddSubscriber( "clk_rifle_3", clk_rifle_3_end );
    cmn.AddSubscriber( "clk_rifle_3", clk_rifle_3_end, "inv_rifle_3" );
    cmn.AddSubscriber( "clk_rifle_3_beg", clk_rifle_3_beg, "inv_rifle_3" );
    cmn.AddSubscriber( "clk_rifle_3_end", clk_rifle_3_end, "inv_rifle_3" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_cartridge" ] = {
        type = "use",
        inv_obj = "inv_cartridge",
        use_place = "obj_rifle_3_use_cartridge",
        room = "int_deploy_inv",
        zz = "deploy_inv_rifle_3",
        zz_gate = "inv_rifle_3"
    };
    function use_cartridge_inv ()

      interface.InventoryItemRemove( "inv_cartridge" );
     
      
    end;
    function use_cartridge_beg ()

      ObjDelete( "obj_rifle_3_use_cartridge" );
      ObjSet("spr_rifle_3_bullet", { alp = 1 });

    end;
    function use_cartridge_end ()
      
      ObjSet( "spr_deploy_rifle_3_open_cartridge", { alp = 1 });
      ObjSet( "obj_rifle_3_clk_rifle", { input = true });      
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_cartridge", use_cartridge_beg, "inv_rifle_3" );
    cmn.AddSubscriber( "use_cartridge", use_cartridge_inv );
    cmn.AddSubscriber( "use_cartridge", use_cartridge_end );
    cmn.AddSubscriber( "use_cartridge", use_cartridge_end, "inv_rifle_3" );
    cmn.AddSubscriber( "use_cartridge_inv", use_cartridge_inv );
    cmn.AddSubscriber( "use_cartridge_beg", use_cartridge_beg, "inv_rifle_3" );
    cmn.AddSubscriber( "use_cartridge_end", use_cartridge_end, "inv_rifle_3" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_loadedgun_3" ] = {
      type = "get",
      get_obj = "spr_deploy_rifle_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_rifle_3",
      zz_gate = "inv_rifle_3"
    };
    function get_loadedgun_3_inv ()

      interface.InventoryItemRemove( "inv_rifle_3" );
      interface.InventoryItemAdd( "inv_loadedgun_3", "spr_deploy_rifle_3" );

    end;
    function get_loadedgun_3_deploy ()

      ObjDelete( "gfx_deploy_rifle_3" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_loadedgun_3", get_loadedgun_3_inv );
    cmn.AddSubscriber( "get_loadedgun_3", get_loadedgun_3_deploy, "inv_rifle_3" );
    -------------------------------------------------------------------------------------------
  end;
  --*********************************************************************************************************************
  function private.clk_rifle_3()

    if ( cmn.IsEventDone("use_cartridge")) then 
      
      cmn.CallEventHandler( "clk_rifle_3_beg", "inv_rifle_3" );
       
      local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_rifle_3" );
      cmn.CallEventHandler( "clk_rifle_3_end", "inv_rifle_3" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_rifle_touch_cartridge", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_rifle_3_close", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );
      ObjAnimate( "spr_deploy_rifle_3_open", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );
        
    end;
      
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_cartridge()

    local item = "inv_cartridge";
    if private.ObjIntersectCheck( item, "obj_rifle_3_use_cartridge", "deploy_inv_rifle_3" ) then

      cmn.CallEventHandler( "use_cartridge_beg", "inv_rifle_3" );
      cmn.CallEventHandler( "use_cartridge_inv" );

      local func_after = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_cartridge" );
        cmn.CallEventHandler( "use_cartridge_end", "inv_rifle_3" );

      end;

      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_rifle_use_cartridge", 0, "", 0 );

      ObjAnimate( "spr_deploy_rifle_3_open_cartridge", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      });

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_loadedgun_3()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_loadedgun_3" );
    cmn.CallEventHandler( "get_loadedgun_3", "inv_rifle_3" );
    common_impl.HideDeployInv();

  end;
  --*********************************************************************************************************************