-- name=rm_attvatation
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_attvatation";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_ladder", "room_hub" );
  ObjAttach( "zz_trunk", "room_hub" );
  ObjAttach( "zz_tree", "room_hub" );
  ObjAttach( "zz_victim", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({
  { "obj_attvatation_dlg_save", { event_mdown = private.dlg_attvatation_save }},
  { "obj_attvatation_dlg_save_focus", { event_mdown = private.dlg_attvatation_save }},
  { "spr_ladder_pole", { event_mdown = private.get_pole }},
  { "spr_trunk_hammer", { event_mdown = private.get_hammer }},
  { "spr_trunk_sidecutter", { event_mdown = private.get_sidecutter }},
  { "spr_trunk_brokenwelder", { event_mdown = private.get_brokenwelder }},
  { "spr_tree_trunkkeys", { event_mdown = private.get_trunkkeys }},
  { "spr_tree_penknife", { event_mdown = private.get_penknife }},
  { "spr_tree_lever_3", { event_mdown = private.get_lever_3 }},
  { "spr_victim_plate", { event_mdown = private.get_plate }},
  { "spr_attvatation_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_trunk_clk_trunkkeys", { event_mdown = private.clk_trunkkeys }},
  { "obj_tree_clk_clip_3", { event_mdown = private.clk_clip_3 }},
  { "spr_attvatation_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_tree_collect_2", { event_mdown = function () private.get_collect_2_3_4(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_trunk_collect_2", { event_mdown = function () private.get_collect_2_3_2(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                             
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_attvatation = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_attvatation_mechanism",
    "gzz_attvatation_ladder",
    "gzz_attvatation_trunk",
    "gzz_attvatation_tree",
    "gzz_attvatation_victim"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_ladder",
    "zz_trunk", 
    "zz_tree",  
    "zz_victim" 
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_attvatation", update_game_mode_attvatation, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_attvatation = function ()

  local effects_table = 
  {
    "obj_attvatation_anim",
    "anm_tree_fog",
    "anm_tree_squirrel_1",
    "anm_tree_squirrel_3",    
    "anm_victim_female_1",
    "anm_victim_female_2",
    --"anm_attvatation_girl_loc",
    "spr_ladder_light",
    "spr_trunk_light",
    "spr_tree_branch"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_attvatation", update_performance_mode_attvatation, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_attvatation () end;
  --------------------------------------------------------------------------------------------
  local opn_attvatation_map = function ()

    common_impl.VisitMapRoom( "attvatation" );

  end;
  cmn.AddSubscriber( "opn_attvatation", opn_attvatation_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_pole () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pole" ] = {
    type = "get",
    get_obj = "spr_ladder_pole",
    room = private.room_objname,
    zz = "zz_ladder",
    zz_gate = "gzz_attvatation_ladder"
  };
    
  local get_pole_inv = function ()
  
    interface.InventoryItemAdd( "inv_pole", "spr_ladder_pole" );
  
  end;
  
  local get_pole_closezz = function ()
  
    ObjDelete( "gfx_ladder_pole" );
    ObjDelete( "spr_ladder_pole_shadow" );
    ObjDelete( "spr_attvatation_ladder_pole");
  
  end;
  
  cmn.AddSubscriber( "get_pole", get_pole_inv );
  cmn.AddSubscriber( "get_pole", get_pole_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer" ] = {
    type = "get",
    get_obj = "spr_trunk_hammer",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_attvatation_trunk"
  };
    
  local get_hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer_3", "spr_trunk_hammer" );
    ObjSet( "spr_moneybox_plus_light", { alp = 1 });
    
  end;
  
  local get_hammer_closezz = function ()
  
    ObjDelete( "gfx_trunk_hammer" );
    ObjDelete( "spr_trunk_hammer_shadow" );
    ObjDelete( "spr_attvatation_trunk_hammer");
  
  end;
  
  cmn.AddSubscriber( "get_hammer", get_hammer_inv );
  cmn.AddSubscriber( "get_hammer", get_hammer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sidecutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sidecutter" ] = {
    type = "get",
    get_obj = "spr_trunk_sidecutter",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_attvatation_trunk"
  };
    
  local get_sidecutter_inv = function ()
  
    interface.InventoryItemAdd( "inv_sidecutter", "spr_trunk_sidecutter" );
  
  end;
  
  local get_sidecutter_closezz = function ()
  
    ObjDelete( "gfx_trunk_sidecutter" );
    ObjDelete( "spr_trunk_sidecutter_shadow" );
    ObjDelete( "spr_attvatation_trunk_sidecutter");
    
    if( cmn.IsEventDone("get_brokenwelder") and common_impl.IsGetCollect( "get_collect_2_3_2" )) then
      ObjDelete( "gzz_attvatation_trunk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_sidecutter", get_sidecutter_inv );
  cmn.AddSubscriber( "get_sidecutter", get_sidecutter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenwelder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenwelder" ] = {
    type = "get",
    get_obj = "spr_trunk_brokenwelder",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_attvatation_trunk"
  };
    
  local get_brokenwelder_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenwelder", "spr_trunk_brokenwelder" );
    ObjSet("inv_brokenwelder", { drag = false });
    
  end;
  
  local get_brokenwelder_closezz = function ()
  
    ObjDelete( "gfx_trunk_brokenwelder" );
    ObjDelete( "spr_attvatation_trunk_appatat");
    if( cmn.IsEventDone("get_sidecutter") and common_impl.IsGetCollect( "get_collect_2_3_2" ) ) then
      ObjDelete( "gzz_attvatation_trunk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_brokenwelder", get_brokenwelder_inv );
  cmn.AddSubscriber( "get_brokenwelder", get_brokenwelder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trunkkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trunkkeys" ] = {
    type = "get",
    get_obj = "spr_tree_trunkkeys",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
    
  local get_trunkkeys_inv = function ()
  
    interface.InventoryItemAdd( "inv_trunkkeys", "spr_tree_trunkkeys" );
  
  end;
  
  local get_trunkkeys_closezz = function ()
  
    ObjDelete( "gfx_tree_trunkkeys" );
    ObjDelete( "spr_tree_trunkkeys_shadow" );
    ObjDelete( "spr_attvatation_tree_key");
    
    if ( cmn.IsEventDone("get_penknife") and cmn.IsEventDone("get_lever_3") and common_impl.IsGetCollect( "get_collect_2_3_4" ) ) then
      ObjDelete( "gzz_attvatation_tree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_trunkkeys", get_trunkkeys_inv );
  cmn.AddSubscriber( "get_trunkkeys", get_trunkkeys_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_penknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_penknife" ] = {
    type = "get",
    get_obj = "spr_tree_penknife",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
    
  local get_penknife_inv = function ()
  
    interface.InventoryItemAdd( "inv_penknife", "spr_tree_penknife" );
  
  end;
  
  local get_penknife_closezz = function ()
  
    ObjDelete( "gfx_tree_penknife" );
    ObjDelete( "spr_attvatation_tree_knife");
    --ObjDelete( "gzz_attvatation_tree" );
  
  end;
  
  cmn.AddSubscriber( "get_penknife", get_penknife_inv );
  cmn.AddSubscriber( "get_penknife", get_penknife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever_3" ] = {
    type = "get",
    get_obj = "spr_tree_lever_3",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
    
  local get_lever_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_lever_3", "spr_tree_lever_3" );
  
  end;
  
  local get_lever_3_closezz = function ()
  
    ObjDelete( "gfx_tree_lever_3" );
    ObjDelete( "spr_attvatation_tree_lever");
    if ( cmn.IsEventDone("get_penknife") and cmn.IsEventDone("get_trunkkeys") and common_impl.IsGetCollect( "get_collect_2_3_4" )) then
      ObjDelete( "gzz_attvatation_tree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lever_3", get_lever_3_inv );
  cmn.AddSubscriber( "get_lever_3", get_lever_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plate" ] = {
    type = "get",
    get_obj = "spr_victim_plate",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_attvatation_victim"
  };
    
  local get_plate_inv = function ()
  
    interface.InventoryItemAdd( "inv_plate", "spr_victim_plate" );
  
  end;
  
  local get_plate_closezz = function ()
  
    ObjDelete( "gfx_victim_plate" );
    ObjDelete( "gzz_attvatation_victim" );
  
  end;
  
  cmn.AddSubscriber( "get_plate", get_plate_inv );
  cmn.AddSubscriber( "get_plate", get_plate_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_4 = function ()
  
    ObjDelete( "obj_attvatation_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_4", get_collect_morph_item_3_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_2 = function ()
  
    ObjDelete( "obj_attvatation_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_2", get_collect_item_3_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_4 () end;
  --------------------------------------------------------------------------------------------
  
  local get_collect_2_3_4 = function ()
 
    ObjDelete( "spr_tree_collect_2" );
    
    if cmn.IsEventDone( "get_lever_3") and cmn.IsEventDone( "get_penknife") and cmn.IsEventDone( "get_trunkkeys") then
      
      ObjDelete( "gzz_attvatation_tree");
      
    end;  
   
  end;
  cmn.AddSubscriber( "get_collect_2_3_4", get_collect_2_3_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_2 = function ()
 
    ObjDelete( "spr_trunk_collect_2" );
    
    if cmn.IsEventDone( "get_sidecutter") and cmn.IsEventDone( "get_brokenwelder") then
      
      ObjDelete( "gzz_attvatation_trunk");
      
    end;  
   
  end;
  cmn.AddSubscriber( "get_collect_2_3_2", get_collect_2_3_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_protectivemask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_protectivemask" ] = {
    type = "use",
    inv_obj = "inv_protectivemask",
    use_place = "obj_ladder_use_protectivemask",
    room = private.room_objname,
    zz = "zz_ladder",
    zz_gate = "gzz_attvatation_ladder"
  };
  local use_protectivemask_inv = function ()
  
    interface.InventoryItemRemove( "inv_protectivemask" );
  
  end;
  local use_protectivemask_beg = function ()
  
    ObjDelete( "obj_ladder_use_protectivemask" );
  
  end;
  local use_protectivemask_end = function ()
  
    ObjSet( "anm_ladder_weld", { frame = 300, alp = 1 });
    ObjDelete( "obj_ladder_crossbar");
    ObjDelete( "spr_ladder_welder");
    ObjSet( "grm_attvatation_studio", { input = true, active = true });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_attvatation_studio_focus");
    end;
    ObjDelete( "gzz_attvatation_ladder");
    ObjDelete( "spr_attvatation_ladder_1");
    ObjSet( "spr_attvatation_ladder_2", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_protectivemask", use_protectivemask_beg, private.room_objname );
  cmn.AddSubscriber( "use_protectivemask", use_protectivemask_inv );
  cmn.AddSubscriber( "use_protectivemask", use_protectivemask_end, private.room_objname );
  cmn.AddSubscriber( "use_protectivemask_inv", use_protectivemask_inv, private.room_objname );
  cmn.AddSubscriber( "use_protectivemask_beg", use_protectivemask_beg, private.room_objname );
  cmn.AddSubscriber( "use_protectivemask_end", use_protectivemask_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_welder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_welder" ] = {
    type = "use",
    inv_obj = "inv_welder",
    use_place = "obj_ladder_use_welder",
    room = private.room_objname,
    zz = "zz_ladder",
    zz_gate = "gzz_attvatation_ladder"
  };
  local use_welder_inv = function ()
  
    interface.InventoryItemRemove( "inv_welder" );
  
  end;
  local use_welder_beg = function ()
  
    ObjDelete( "obj_ladder_use_welder" );
  
  end;
  local use_welder_end = function ()
  
    ObjSet( "spr_ladder_welder", { alp = 1 } );
    ObjSet( "obj_ladder_use_protectivemask", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_welder", use_welder_beg, private.room_objname );
  cmn.AddSubscriber( "use_welder", use_welder_inv );
  cmn.AddSubscriber( "use_welder", use_welder_end, private.room_objname );
  cmn.AddSubscriber( "use_welder_inv", use_welder_inv, private.room_objname );
  cmn.AddSubscriber( "use_welder_beg", use_welder_beg, private.room_objname );
  cmn.AddSubscriber( "use_welder_end", use_welder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trunkkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trunkkeys" ] = {
    type = "use",
    inv_obj = "inv_trunkkeys",
    use_place = "obj_trunk_use_trunkkeys",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_attvatation_trunk"
  };
  local use_trunkkeys_inv = function ()
  
    interface.InventoryItemRemove( "inv_trunkkeys" );
  
  end;
  local use_trunkkeys_beg = function ()
  
    ObjDelete( "obj_trunk_use_trunkkeys" );
  
  end;
  local use_trunkkeys_end = function ()
  
    ObjSet( "spr_trunk_key_1", { alp = 1 } );
    ObjSet( "obj_trunk_clk_trunkkeys", { input = true } );
    ObjSet( "spr_attvatation_trunk_keys", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trunkkeys", use_trunkkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunkkeys", use_trunkkeys_inv );
  cmn.AddSubscriber( "use_trunkkeys", use_trunkkeys_end, private.room_objname );
  cmn.AddSubscriber( "use_trunkkeys_inv", use_trunkkeys_inv, private.room_objname );
  cmn.AddSubscriber( "use_trunkkeys_beg", use_trunkkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunkkeys_end", use_trunkkeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nuts () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nuts" ] = {
    type = "use",
    inv_obj = "inv_nuts",
    use_place = "obj_tree_use_nuts",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
  local use_nuts_inv = function ()
  
    interface.InventoryItemRemove( "inv_nuts" );
  
  end;
  local use_nuts_beg = function ()
  
    ObjDelete( "obj_tree_use_nuts" );
  
  end;
  local use_nuts_end = function ()
  
    ObjDelete( "anm_tree_squirrel_1" );    
    ObjDelete( "anm_tree_squirrel_2" ); 
    ObjSet( "anm_tree_squirrel_3", { alp = 1, playing = true } );
    ObjSet( "obj_tree_trunkkeys", { active = true, input = true, alp = 1 } );
    ObjDelete( "spr_attvatation_tree_squirrel_1");
    ObjSet( "spr_attvatation_tree_squirrel_2", { alp = 1 });
    ObjSet( "spr_attvatation_tree_key", { alp = 1 });
    ObjDelete( "anm_attvatation_squirrel_1" );
    ObjSet( "anm_attvatation_squirrel_2", { alp = 1, playing = true });
    ObjSet( "spr_attvatation_tree_nuts", { alp = 1 });
    ObjSet( "spr_tree_collect_2", { input = true, pos_z = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nuts", use_nuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts", use_nuts_inv );
  cmn.AddSubscriber( "use_nuts", use_nuts_end, private.room_objname );
  cmn.AddSubscriber( "use_nuts_inv", use_nuts_inv, private.room_objname );
  cmn.AddSubscriber( "use_nuts_beg", use_nuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts_end", use_nuts_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust_3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirust_3_2" ] = {
    type = "use",
    inv_obj = "inv_antirust",
    use_place = "obj_tree_use_antirust",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
  local use_antirust_3_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_antirust" );
  
  end;
  local use_antirust_3_2_beg = function ()
  
    ObjDelete( "obj_tree_use_antirust" );
  
  end;
  local use_antirust_3_2_end = function ()
  
    ObjSet( "obj_tree_use_clip_3", { input = true } );
    ObjDelete( "anm_tree_rust" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust_3_2", use_antirust_3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_2", use_antirust_3_2_inv );
  cmn.AddSubscriber( "use_antirust_3_2", use_antirust_3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_2_inv", use_antirust_3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_2_beg", use_antirust_3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_2_end", use_antirust_3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pincers_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pincers_3" ] = {
    type = "use",
    inv_obj = "inv_pincers_3",
    use_place = "obj_tree_use_pincers_3",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
  local use_pincers_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_pincers_3" );
  
  end;
  local use_pincers_3_beg = function ()
  
    ObjDelete( "obj_tree_use_pincers_3" );
  
  end;
  local use_pincers_3_end = function ()
  
    ObjDelete( "anm_tree_knife" );
    ObjSet( "spr_tree_penknife", { input = true, active = true, alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pincers_3", use_pincers_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers_3", use_pincers_3_inv );
  cmn.AddSubscriber( "use_pincers_3", use_pincers_3_end, private.room_objname );
  cmn.AddSubscriber( "use_pincers_3_inv", use_pincers_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_pincers_3_beg", use_pincers_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers_3_end", use_pincers_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clip_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clip_3" ] = {
    type = "use",
    inv_obj = "inv_clip_3",
    use_place = "obj_tree_use_clip_3",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
  local use_clip_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_clip_3" );
  
  end;
  local use_clip_3_beg = function ()
  
    ObjDelete( "obj_tree_use_clip_3" );
  
  end;
  local use_clip_3_end = function ()
  
    ObjSet( "anm_tree_clip", { frame = 70 } );
    ObjSet( "obj_tree_clk_clip_3", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clip_3", use_clip_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_clip_3", use_clip_3_inv );
  cmn.AddSubscriber( "use_clip_3", use_clip_3_end, private.room_objname );
  cmn.AddSubscriber( "use_clip_3_inv", use_clip_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_clip_3_beg", use_clip_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_clip_3_end", use_clip_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sidecutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sidecutter" ] = {
    type = "use",
    inv_obj = "inv_sidecutter",
    use_place = "obj_victim_use_sidecutter",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_attvatation_victim"
  };
  local use_sidecutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_sidecutter" );
  
  end;
  local use_sidecutter_beg = function ()
  
    ObjDelete( "obj_victim_use_sidecutter" );
  
  end;
  local use_sidecutter_end = function ()
  
    ObjSet( "obj_attvatation_dlg_save", { input = true } );
    ObjSet( "obj_victim_use_bastardsmedallion", { input = true });
    ObjDelete( "anm_attvatation_girl");
    ObjSet( "spr_attvatation_victim", { alp = 1 });
    ObjDelete( "anm_victim_female_2" );
    ObjDelete( "anm_victim_female_open");
    ObjSet( "spr_victim_chair_over_6", {alp=1} );
    ObjDelete( "anm_victim_use_sidecutter");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sidecutter", use_sidecutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_sidecutter", use_sidecutter_inv );
  cmn.AddSubscriber( "use_sidecutter", use_sidecutter_end, private.room_objname );
  cmn.AddSubscriber( "use_sidecutter_inv", use_sidecutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_sidecutter_beg", use_sidecutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_sidecutter_end", use_sidecutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_penknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_penknife" ] = {
    type = "use",
    inv_obj = "inv_penknife",
    use_place = "obj_victim_use_penknife",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_attvatation_victim"
  };
  local use_penknife_inv = function ()
  
  end;
  local use_penknife_beg = function ()
  
    ObjDelete( "obj_victim_use_penknife" );
  
  end;
  local use_penknife_end = function ()
  
    ObjSet( "gmg_attvatation_mechanism", { input = true, active = true, alp = 1});
    ObjSet( "gzz_attvatation_victim", { input = false, active = false, alp = 0});
    ObjDelete( "anm_victim_use_penknife");
    ObjDelete( "anm_victim_female_1");
    ObjSet( "anm_victim_female_2", { playing = true, alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_penknife", use_penknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife", use_penknife_inv );
  cmn.AddSubscriber( "use_penknife", use_penknife_end, private.room_objname );
  cmn.AddSubscriber( "use_penknife_inv", use_penknife_inv, private.room_objname );
  cmn.AddSubscriber( "use_penknife_beg", use_penknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife_end", use_penknife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bastardsmedallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bastardsmedallion" ] = {
    type = "use",
    inv_obj = "inv_bastardsmedallion",
    use_place = "obj_victim_use_bastardsmedallion",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_attvatation_victim"
  };
  local use_bastardsmedallion_inv = function ()
  
    interface.InventoryItemRemove( "inv_bastardsmedallion" );
  
  end;
  local use_bastardsmedallion_beg = function ()
  
    ObjDelete( "obj_victim_use_bastardsmedallion" );
  
  end;
  local use_bastardsmedallion_end = function ()
  
    ObjSet( "spr_victim_open", { input = true, alp = 1 });
    ObjDelete("spr_victim_amulet");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bastardsmedallion", use_bastardsmedallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_bastardsmedallion", use_bastardsmedallion_inv );
  cmn.AddSubscriber( "use_bastardsmedallion", use_bastardsmedallion_end, private.room_objname );
  cmn.AddSubscriber( "use_bastardsmedallion_inv", use_bastardsmedallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_bastardsmedallion_beg", use_bastardsmedallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_bastardsmedallion_end", use_bastardsmedallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_trunkkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_trunkkeys" ] = {
    type = "click",
    use_place = "obj_trunk_clk_trunkkeys",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_attvatation_trunk"
  };
  local clk_trunkkeys_beg = function ()
  
    ObjDelete( "obj_trunk_clk_trunkkeys" );
  
  end;
  local clk_trunkkeys_end = function ()
  
    ObjSet( "spr_trunk_open", { input = true, alp = 1 });
    ObjDelete( "spr_trunk_key_1" );
    ObjDelete( "spr_trunk_key_2" );
    ObjDelete( "spr_attvatation_trunk_keys");
    ObjSet( "spr_attvatation_trunk_open", { alp = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_trunkkeys", clk_trunkkeys_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trunkkeys", clk_trunkkeys_end, private.room_objname );
  cmn.AddSubscriber( "clk_trunkkeys_beg", clk_trunkkeys_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trunkkeys_end", clk_trunkkeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_clip_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_clip_3" ] = {
    type = "click",
    use_place = "obj_tree_clk_clip_3",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_attvatation_tree"
  };
  local clk_clip_3_beg = function ()
  
    ObjDelete( "obj_tree_clk_clip_3" );
  
  end;
  local clk_clip_3_end = function ()
  
    ObjSet( "spr_tree_open", { input = true, alp = 1 } );
    ObjDelete( "anm_tree_clip" );
    ObjDelete( "anm_tree_clip_open" );
    ObjSet( "spr_attvatation_tree_bag_open", { alp = 1 });
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_clip_3", clk_clip_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_3", clk_clip_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_clip_3_beg", clk_clip_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_3_end", clk_clip_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_attvatation_villain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_attvatation_villain" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_attvatation_villain",
    
  };
  local vid_attvatation_villain_end = function ()
  
    ObjDelete( "anm_attvatation_lousy" );
    ObjSet( "anm_attvatation_girl", { alp = 1, playing = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_attvatation_villain", vid_attvatation_villain_end, private.room_objname  );
  cmn.AddSubscriber( "vid_attvatation_villain_end", vid_attvatation_villain_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_attvatation_save () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_attvatation_save" ] = {
    type = "click",
    use_place = "obj_attvatation_dlg_save_focus",
    room = private.room_objname
  };
  local dlg_attvatation_save_beg = function ()

    ObjDelete( "obj_attvatation_dlg_save");
    
  end;

  local dlg_attvatation_save_inv = function ()
  
    interface.InventoryItemAdd( "inv_crosseddaggers","spr_attvatation_save_crosseddaggers");
    
  end;
  
  local dlg_attvatation_save_end = function ()

    ObjDelete( "anm_attvatation_girl");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_attvatation_save_beg", dlg_attvatation_save_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_attvatation_save_inv", dlg_attvatation_save_inv );
  cmn.AddSubscriber( "dlg_attvatation_save", dlg_attvatation_save_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_attvatation_save", dlg_attvatation_save_inv );
  cmn.AddSubscriber( "dlg_attvatation_save_end", dlg_attvatation_save_end, private.room_objname );
  cmn.AddSubscriber( "dlg_attvatation_save", dlg_attvatation_save_end, private.room_objname );
 
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_victim" );
  ------------------------------------------------------------------------------ 
  function zz_victim.PreOpen()
    
    if not cmn.IsEventDone( "use_sidecutter" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level3/aud_woman_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/level3/aud_woman_loc_env", 0 );
      
    end;
    
  end;
  ------------------------------------------------------------------------------ 
  function zz_victim.Open()
    
    if cmn.IsEventDone( "win_mechanism" ) and not cmn.IsEventDone( "use_sidecutter" ) 
      and not ng_global.progress["std"]["opn_attvatation"].opn_zz then  
      
      ng_global.progress["std"]["opn_attvatation"].opn_zz = true;
      
    end;
    
  end;
  ------------------------------------------------------------------------------ 
  function zz_victim.PreClose()
    
    if not cmn.IsEventDone( "use_sidecutter" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level3/aud_woman_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/level3/aud_woman_zz_env", 0 );
      
    end;
    
  end;
  ------------------------------------------------------------------------------ 
  function zz_victim.Close()

    if ( cmn.IsEventDone("use_penknife") and not cmn.IsEventDone("win_mechanism") ) then

      ObjSet( "tmr_attvatation_gomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_mechanism' ) end } );
      
    end;
    
    if cmn.IsEventDone("use_sidecutter") and not cmn.IsEventDone("dlg_attvatation_save") then
     
      private.dlg_attvatation_save();
     
    end;  

  end;
  ------------------------------------------------------------------------------ 
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_attvatation();
  
  if cmn.IsEventDone( "win_mechanism" ) and not cmn.IsEventDone( "use_sidecutter" ) 
    and not ng_global.progress["std"]["opn_attvatation"].opn_zz then
    
    local posxy = { ObjGet("gzz_attvatation_victim").pos_x, ObjGet("gzz_attvatation_victim").pos_y };    
    ObjSet( "tmr_attvatation_gotozz", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoSubRoom( "zz_victim", posxy , { 512, 384 }, true ); end } );
            
  end; 
 
  if ng_global.progress["std"]["opn_attvatation"].girl_hide and
     not ng_global.progress["std"]["opn_attvatation"].show_bbt then
    
     private.zoom_girl();
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  if not cmn.IsEventDone( "vid_attvatation_villain" ) then

    ObjSet( "tmr_attvatation_villain",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_attvatation_villain(); end
    } );

  end;
    
    common_impl.EnvPlay( { "common/audio/level3/aud_attvalation_env" }, "", 0.5 );
    
    if cmn.IsEventDone( "vid_attvatation_villain" ) and not cmn.IsEventDone( "use_sidecutter" ) then
      
      common_impl.PlayAudio( "env", "common/audio/level3/aud_woman_loc_env", 1, "", 0 );
  
    end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if cmn.IsEventDone( "dlg_attvatation_save" ) and not ng_global.progress["std"]["opn_attvatation"].girl_hide then
  
    ObjSet( "anm_attvatation_girl_loc", { alp = 0 } );
    ng_global.progress["std"]["opn_attvatation"].girl_hide = true;
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  common_impl.StopAudio( "env", "common/audio/level3/aud_woman_loc_env", 0.5 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_protectivemask()

  local item = "inv_protectivemask";

  if ( common.ApplyObj( item, "obj_ladder_use_protectivemask", true ) and cmn.IsEventDone( "use_welder" ) ) then

    cmn.CallEventHandler( "use_protectivemask_inv" );
    cmn.CallEventHandler( "use_protectivemask_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_protectivemask" );
      cmn.CallEventHandler( "use_protectivemask_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_protectivemask_ladder", 0, "", 0 );

    ObjSet( "obj_ladder_crossbar", { alp = 0 });
    ObjSet( "spr_ladder_welder", { alp = 0 });
    ObjSet( "anm_ladder_weld", { alp = 1 }); 
    AnimPlay( "anm_ladder_weld", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_ladder", false ) and cmn.IsEventDone( "use_welder" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ladder", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_welder()

  local item = "inv_welder";

  if ( common.ApplyObj( item, "obj_ladder_use_welder", true ) and cmn.IsEventDone( "get_pole" ) ) then

    cmn.CallEventHandler( "use_welder_inv" );
    cmn.CallEventHandler( "use_welder_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_welder" );
      cmn.CallEventHandler( "use_welder_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_welder_ladder", 0, "", 0 );
    
    ObjAnimate( "spr_ladder_welder", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_ladder", false ) and cmn.IsEventDone( "get_pole" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ladder", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_trunkkeys()

  local item = "inv_trunkkeys";

  if ( common.ApplyObj( item, "obj_trunk_use_trunkkeys", true ) and cmn.IsEventDone( "get_hammer" ) ) then

    cmn.CallEventHandler( "use_trunkkeys_inv" );
    cmn.CallEventHandler( "use_trunkkeys_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_trunkkeys" );
      cmn.CallEventHandler( "use_trunkkeys_end" );
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_trunkkeys_trunk", 0, "", 0 );
    
    ObjAnimate( "spr_trunk_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_trunk", false ) and cmn.IsEventDone( "get_hammer" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trunk", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nuts()

  local item = "inv_nuts";

  if ( common.ApplyObj( item, "obj_tree_use_nuts", true ) ) then

    cmn.CallEventHandler( "use_nuts_inv" );
    cmn.CallEventHandler( "use_nuts_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_nuts" );
      cmn.CallEventHandler( "use_nuts_end" );
         
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_nuts_tree", 0, "", 0 );
    
    ObjSet( "anm_tree_squirrel_1", { alp = 0, playing = false } );
    ObjSet( "anm_tree_squirrel_2", { alp = 1 } );
    AnimPlay( "anm_tree_squirrel_2", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_tree", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_antirust_3_2()

  local item = "inv_antirust";

  if ( common.ApplyObj( item, "obj_tree_use_antirust", true ) ) then

    cmn.CallEventHandler( "use_antirust_3_2_inv" );
    cmn.CallEventHandler( "use_antirust_3_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_antirust_3_2" );
      cmn.CallEventHandler( "use_antirust_3_2_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_antirust_tree", 0, "", 0 );
    AnimPlay( "anm_tree_rust", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_tree", false ) and not cmn.IsEventDone( "use_antirust_3_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pincers_3()

  local item = "inv_pincers_3";

  if ( common.ApplyObj( item, "obj_tree_use_pincers_3", true ) ) then

    cmn.CallEventHandler( "use_pincers_3_inv" );
    cmn.CallEventHandler( "use_pincers_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_pincers_3" );
      cmn.CallEventHandler( "use_pincers_3_end" );
      private.get_penknife();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_pincers_tree", 0, "", 0 );
    AnimPlay( "anm_tree_knife", "DoAnim", func_after );
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_tree", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clip_3()

  local item = "inv_clip_3";

  if ( common.ApplyObj( item, "obj_tree_use_clip_3", true ) and cmn.IsEventDone("use_antirust_3_2") ) then

    cmn.CallEventHandler( "use_clip_3_inv" );
    cmn.CallEventHandler( "use_clip_3_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_clip_3" );
      cmn.CallEventHandler( "use_clip_3_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_clip_tree", 0, "", 0 );
    AnimPlay( "anm_tree_clip", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_tree", false ) and cmn.IsEventDone("use_antirust_3_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sidecutter()

  local item = "inv_sidecutter";

  if ( common.ApplyObj( item, "obj_victim_use_sidecutter", true ) ) and ( cmn.IsEventDone( "win_mechanism")) then

    cmn.CallEventHandler( "use_sidecutter_inv" );
    cmn.CallEventHandler( "use_sidecutter_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_sidecutter" );
        cmn.CallEventHandler( "use_sidecutter_end" );
        common.CloseSubRoom();
        
        common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
        
      end;
  
      common_impl.StopAudio( "env", "common/audio/level3/aud_woman_zz_env", 0 );
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_release_victim", 0, "", 0 );
      
      ObjSet( "anm_victim_use_sidecutter", { alp = 0 });
      ObjSet( "anm_victim_female_2", { alp = 0 });  
      ObjSet( "anm_victim_female_open", { alp = 1, playing = true, endtrig = func_end }); 
    
  end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_sidecutter_victim", 0, "", 0 );
    AnimPlay( "anm_victim_use_sidecutter", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_victim", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victim", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_penknife()

  local item = "inv_penknife";

  if ( common.ApplyObj( item, "obj_victim_use_penknife", true ) ) then

    cmn.CallEventHandler( "use_penknife_inv" );
    cmn.CallEventHandler( "use_penknife_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_penknife" );
      cmn.CallEventHandler( "use_penknife_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_penknife_victim", 0, "", 0 );
    ObjSet( "anm_victim_use_penknife", { alp = 1 } );
    ObjSet( "anm_victim_female_1", { alp = 0 } );
    
    AnimPlay( "anm_victim_use_penknife", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_victim", false ) and not cmn.IsEventDone( "use_penknife" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victim", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bastardsmedallion()

  local item = "inv_bastardsmedallion";

  if ( common.ApplyObj( item, "obj_victim_use_bastardsmedallion", true ) ) then

    cmn.CallEventHandler( "use_bastardsmedallion_inv" );
    cmn.CallEventHandler( "use_bastardsmedallion_beg" );

    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_bastardsmedallion" );
        cmn.CallEventHandler( "use_bastardsmedallion_end" );
        
      end;  
       
      ObjAnimate( "spr_victim_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } ); 
      
      ObjAnimate( "spr_victim_amulet", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } ); 
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_bastardsmedallion_victim", 0, "", 0 );
    
    ObjAnimate( "spr_victim_amulet", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_attvatation_victim", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victim", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_pole()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_pole" );
  cmn.CallEventHandler( "get_pole" );

end;
--------------------------------------------------------------------------------------------
function private.get_hammer()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );

end;
--------------------------------------------------------------------------------------------
function private.get_sidecutter()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_sidecutter" );
  cmn.CallEventHandler( "get_sidecutter" );
  
  if( cmn.IsEventDone("get_brokenwelder") and common_impl.IsGetCollect( "get_collect_2_3_2" ) ) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_brokenwelder()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokenwelder" );
  cmn.CallEventHandler( "get_brokenwelder" );
  
  if( cmn.IsEventDone("get_sidecutter") and common_impl.IsGetCollect( "get_collect_2_3_2" ) ) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_trunkkeys()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_trunkkeys" );
  cmn.CallEventHandler( "get_trunkkeys" );

  if ( cmn.IsEventDone("get_penknife") and cmn.IsEventDone("get_lever_3") and common_impl.IsGetCollect( "get_collect_2_3_4" )) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_penknife()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_penknife" );
  cmn.CallEventHandler( "get_penknife" );

end;
--------------------------------------------------------------------------------------------
function private.get_lever_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lever_3" );
  cmn.CallEventHandler( "get_lever_3" );
  
  if ( cmn.IsEventDone("get_penknife") and cmn.IsEventDone("get_trunkkeys") and common_impl.IsGetCollect( "get_collect_2_3_4" )) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_plate()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_plate" );
  cmn.CallEventHandler( "get_plate" );
  common.CloseSubRoom();

end;
-----------------------------------------------------------------------------------------------------------
function private.get_collect_2_3_4()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_4");
    cmn.CallEventHandler("get_collect_2_3_4");
    
    if cmn.IsEventDone( "get_lever_3") and cmn.IsEventDone( "get_penknife") and cmn.IsEventDone( "get_trunkkeys") then
      
      common.CloseSubRoom();
      
    end;  

  end;

  common_impl.PlayEffectHO( "spr_tree_collect_2", func_after ); 

end;   
-----------------------------------------------------------------------------------------------------------
function private.get_collect_2_3_2()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_2");
    cmn.CallEventHandler("get_collect_2_3_2");
    
    if cmn.IsEventDone( "get_sidecutter") and cmn.IsEventDone( "get_brokenwelder")  then
      
      common.CloseSubRoom();
      
    end;  

  end;

  common_impl.PlayEffectHO( "spr_trunk_collect_2", func_after ); 

end;   
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_trunkkeys()

    cmn.CallEventHandler( "clk_trunkkeys_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "clk_trunkkeys" );
        cmn.CallEventHandler( "clk_trunkkeys_end" );
        
      end;
    
      ObjAnimate( "spr_trunk_key_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
    
      ObjAnimate( "spr_trunk_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_trunkkeys_trunk", 0, "", 0 );
    
    ObjAnimate( "spr_trunk_key_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
    ObjAnimate( "spr_trunk_key_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
 end;
------------------------------------------------------------
function private.clk_clip_3()

  cmn.CallEventHandler( "clk_clip_3_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_clip_3" );
    cmn.CallEventHandler( "clk_clip_3_end" );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_clip_tree", 0, "", 0 );
  ObjSet( "anm_tree_clip", { alp = 0 });
  ObjSet( "anm_tree_clip_open", { alp = 1 });
  AnimPlay( "anm_tree_clip_open", "DoAnim", func_after );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.vid_attvatation_villain()

  local func_after = function ()
  
    local func_end = function ()

      common_impl.InterfaceSetVisible(true);
      interface.DialogVideoHide();
      local event_id = "subtitle_hide";
      int_dialog_video_impl.SubtitleHideAnim( event_id );
      cmn.SetEventDone( "vid_attvatation_villain" );
      cmn.CallEventHandler( "vid_attvatation_villain_end" );
      common_impl.ShowBbt( 'bbt_vid_attvatation_villain', 1 );
      
      common_impl.AddPageDiary( 12 );
      common_impl.StopAudio( "sfx", "common/audio/level3/aud_attvatation_villain" );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_attvatation_villain_voc" );
      common_impl.PlayAudio( "env", "common/audio/level3/aud_woman_loc_env", 1, "", 0 );
      common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
      ObjSet( "obj_attvatation_gates", { alp = 1 });
 
    end;
        
    ObjAnimate( "anm_attvatation_lousy", "alp", 0, 0, func_end, { 0,0,1, 0.5,0,0 } );
    ObjAnimate( "anm_attvatation_girl", "alp", 0, 0, "", { 0,0,0, 0.5,0,1 } );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_attvatation_villain", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_attvatation_villain_voc", 0, "", 0 );

  interface.DialogVideoShow( "", 1, function() func_after( 'skip' ); end, 3 );  
  ObjSet( "obj_attvatation_gates", { alp = 0 });
  local show_sub = function()
     
    ObjSet( "txt_int_dialog_video_subtitle", { text = "sub_attvatation_villain_1" } );
    local event_id = "subtitle_show";
    int_dialog_video_impl.SubtitleShowAnim( event_id );  
    
  end;
  common_impl.InterfaceSetVisible(false);
  ObjSet( "tmr_attvatation_sub_show", { playing = true, time = 2, endtrig = show_sub })
  AnimPlay( "anm_attvatation_lousy", "DoAnim", func_after );

end;
--*********************************************************************************************************************
function private.dlg_attvatation_save()

  ObjAttach( "dlg_attvatation_save", private.room_objname );
  ObjSet("anm_attvatation_save_loc", { alp = 0 });
  cmn.CallEventHandler( "dlg_attvatation_save_beg" );
  
  common_impl.dialog_character_loc = "anm_attvatation_girl";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "save", 4, nil, nil, true, "dlg_attvatation_save_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_attvatation_save_end()

  if not cmn.IsEventDone( "dlg_attvatation_save" ) then

    cmn.SetEventDone( "dlg_attvatation_save" );
    ObjSet( "spr_attvatation_save_hairpin", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    cmn.CallEventHandler( "dlg_attvatation_save_inv" );
    cmn.CallEventHandler( "dlg_attvatation_save_end" );
    common_impl.ShowBbt( "bbt_dlg_attvatation_save", 1 );
    
    common_impl.dialog_character_loc = "";

  end;

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "save" then
    
    if txt_count == 1 then
      
      common_impl.dialog_character_loc = "anm_attvatation_girl_loc";
  
    elseif txt_count == 3 then
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      
      ObjMultiSet( { { "anm_attvatation_save_hand_1", { alp = 0 } },
                     { "obj_attvatation_save_hand", { alp = 1 } } } );
      
    end;
    
  end;        
  
end;
--*********************************************************************************************************************
function private.zoom_girl()
 
  local func_after = function()
  
    local func_after_zoom = function()
    
       ng_global.progress["std"]["opn_attvatation"].show_bbt = true;
         
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
    ObjAnimate( "rm_attvatation", "scale_xy", 0, 0, func_after_zoom, { 0,0,1.2,1.2, 0.6,0,1,1 } );  
    ObjAnimate( "rm_attvatation", "pos_xy", 0, 0, "", { 0,0,-235,-1, 0.6,0,0,0 } );
    
  end;


  interface.Lock( true, 1.9 );
  
  common_impl.ShowBbt( "bbt_attvatation_girl_hide", 1 );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  
  ObjAnimate( "rm_attvatation", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.6,0,1.2,1.2, 1.3,0,1.2,1.2 } );  
  ObjAnimate( "rm_attvatation", "pos_xy", 0, 0, "", { 0,0,0,0, 0.6,0,-235,-1, 1.3,0,-235,-1 } );
  
end;
--*********************************************************************************************************************
function private.opn_attvatation()

  if not ( cmn.IsEventDone( "opn_attvatation" ) ) then
    cmn.SetEventDone( "opn_attvatation" );
    ng_global.progress["std"]["opn_attvatation"].girl_hide = false;
    ng_global.progress["std"]["opn_attvatation"].show_bbt = false;
    ng_global.progress["std"]["opn_attvatation"].opn_zz = false;
  end;
  
  cmn.CallEventHandler( "opn_attvatation" ); 

end;
--*********************************************************************************************************************
ObjAnimate("spr_ladder_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_trunk_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.9, 0, 0.5,
  1.8, 0, 1.0
});

ObjAnimate("spr_tree_branch", "ang",1,0,"",
{
  0.0, 3, 0.02, 
  1.6, 3, -0.02,
  3.9, 3, 0.02
});
