-- name=rm_bar_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bar_3";
  --------------------------------------------------------------------------------------------
  
  ObjAttach( "zz_crest_3", "room_hub" );
  
  private.Init_Subroom();
  
  
  ObjMultiSet({ 
  
  { "obj_bar_3_clk_man", { event_mdown = function() private.clk_anim( "man" ) end } },
  { "obj_bar_3_clk_hat", { event_mdown = function() private.clk_anim( "hat" ) end } },
  { "obj_bar_3_clk_jacket", { event_mdown = function() private.clk_anim( "jacket" ) end } },
  { "spr_bar_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_crest_3_collect_2", { event_mdown = function () private.get_collect_2_2_4(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  
  });
  

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_bar_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gzz_bar_3_crest",
    "grm_bar_3_atbar",
    "grm_bar_3_base" 
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_crest_3"    
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_bar_3", update_game_mode_bar_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_bar_3 = function ()

  local effects_table = 
  {
    "obj_bar_3_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
cmn.AddSubscriber( "update_performance_mode_bar_3", update_performance_mode_bar_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_bar_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_bar_3_map = function ()

    common_impl.VisitMapRoom( "bar_2" );

  end;
  cmn.AddSubscriber( "opn_bar_3", opn_bar_3_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_2 = function ()
  
    ObjDelete( "obj_bar_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_2", get_collect_morph_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_4 = function ()
 
    ObjDelete( "spr_crest_3_collect_2" );
    ObjDelete( "spr_crest_3_collect_2_shadow" );
    ObjDelete( "gzz_bar_3_crest" );
 
  end;
  cmn.AddSubscriber( "get_collect_2_2_4", get_collect_2_2_4, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
 
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_bar_3();
  
  private.AnimPlay();
  
  --common_impl.LoupeMgCheck();
 
  --if cmn.IsEventDone( "win_secretpassage" ) and not cmn.IsEventDone( "clk_bar_2_door" ) then
  -- 
  --  local func_after  = function()
  --  
  --    common_impl.Lock( false );
  --    cmn.SetEventDone( "clk_bar_2_door" );
  --    cmn.CallEventHandler( "clk_bar_2_door" )
  --    interface.KeyTaskDone( 'storage', true );
  --    ObjSet( "anm_bar_2_dust", { alp = 1, playing = true } );
  --    
  --  end;
  --  
  --  common_impl.Lock( true );
  --  
  --  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_open_secretpassage", 0, "", 0 );
  --  
  --  AnimPlay( "anm_bar_2_door", "DoAnim", func_after );
  --  
  --end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ng_global.progress["std"]["opn_bar_3"].see_anim then
  
    ObjSet( "anm_bar_3_airplane", { alp = 0, playing = false } );
    
  end;
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_bar_env" }, "", 0.5 );
  
  common_impl.PlayAudio( "env", "common/audio/level2/aud_sleeping_man_env", 1, "", 0 );
  
  --if not common_impl.CheckMusPlaying() then
  --  
  --  private.volume = GetSoundVolume( "soundtrack" );
  --  
  --  SetSoundVolume( "jukebox_loc",  private.volume );
  --  SetSoundVolume( "jukebox_zz",  0 );
  --  
  --  SndPlay( "assets/levels/common/audio/level2/aud_jukebox_loc_mus", "jukebox_loc", 1, 0, 0.2 );
  --  SndPlay( "assets/levels/common/audio/level2/aud_jukebox_zz_mus", "jukebox_zz", 1, 0, 0.2 );
  --  
  --end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  private.StopAnims();
  
  common_impl.StopAudio( "env", "common/audio/level2/aud_sleeping_man_env", 0.2 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  --SndStop( "assets/levels/common/audio/level2/aud_jukebox_loc_mus", "jukebox_loc", 1 );
  --SndStop( "assets/levels/common/audio/level2/aud_jukebox_zz_mus", "jukebox_zz", 1 );
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------------
function private.get_collect_2_2_4()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_4");
    cmn.CallEventHandler("get_collect_2_2_4");
    common.CloseSubRoom();
   
  end;

  common_impl.PlayEffectHO( "spr_crest_3_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
function private.clk_anim( name )
  
  local func_after = function()
  
    common_impl.Lock( false );
  
    ObjSet( "obj_bar_3_clk_"..name, { input = true } );
   
    ObjSet( "anm_bar_3_"..name.."_loop", { alp = 1, playing = true } );
    ObjSet( "anm_bar_3_"..name, { alp = 0 } );
    
    if name == "man" then
      
      common_impl.PlayAudio( "env", "common/audio/level2/aud_sleeping_man_env", 1, "", 0 );
  
    end;
    
  end;

  if name == "man" then 
    
    common_impl.ShowBbt( 'bbt_bar_2_clk_man' );
    
    common_impl.StopAudio( "env", "common/audio/level2/aud_sleeping_man_env", 0 );
  
  end;
  
  if name == "hat" then 
    
    common_impl.ShowBbt( 'bbt_bar_2_clk_hat' );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_"..name.."_bar_2", 0, "", 0 );
  
  ObjSet( "obj_bar_3_clk_"..name, { input = false } );
    
  ObjSet( "anm_bar_3_"..name.."_loop", { alp = 0, playing = false } );
  ObjSet( "anm_bar_3_"..name, { alp = 1 } );

  
  AnimPlay( "anm_bar_3_"..name, "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_bar_3()

  if not ( cmn.IsEventDone( "opn_bar_3" ) ) then
    cmn.SetEventDone( "opn_bar_3" );
    --interface.KeyTaskAdd( 'storage', true );
    ng_global.progress["std"]["opn_bar_3"].see_anim = false;
    --common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0 );
    --common_impl.SetSoundTimer( 54, "mus", "common/audio/aud_adventure1_mus" );
    
  end;
  
  cmn.CallEventHandler( "opn_bar_3" ); 

end;
--*********************************************************************************************************************
function private.AnimPlay()
  
  if not ng_global.progress["std"]["opn_bar_3"].see_anim then
    
    ng_global.progress["std"]["opn_bar_3"].see_anim = true;
    
    common_impl.Lock( true );
    
    ObjSet( "anm_bar_3_airplane", { alp = 1, playing = true, endtrig = function() common_impl.Lock( false ); end } );
    
    common_impl.PlayAudio( "sfx", "common/audio/level2/aud_paper_plane", 0, "", 0 );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.StopAnims()
  
  local list = { "man", "hat", "jacket" };
  
  for i = 1, #list do
    
    AnimStop( "anm_bar_3_"..list[i] );
    
    ObjSet( "obj_bar_3_clk_"..list[i], { input = true } );
    
    if ( ObjGet( "anm_bar_3_"..list[i].."_loop" ) ) then
    
      ObjSet( "anm_bar_3_"..list[i].."_loop", { alp = 1, playing = true } );
      ObjSet( "anm_bar_3_"..list[i], { alp = 0 } );
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_bar_3_lamp_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1, 
  2.4, 0, 0.7,
  4.8, 0, 1
});
ObjAnimate( "spr_bar_3_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1, 
  2.4, 0, 0.7,
  4.8, 0, 1
});
ObjAnimate( "spr_bar_3_lamp", "ang", 1, 0, "",
{ 
  0.0, 0, -0.01, 
  1.2, 3, 0.01,
  2.4, 3, -0.01
});