-- name=rm_base_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_base_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_symbol_3", "room_hub" );
  ObjAttach( "zz_drawers", "room_hub" );
  
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_symbol_3_note", { event_mdown = function() common_impl.NoteScale( "open", "spr_symbol_3_note" ); common_impl.ShowBbt( 'bbt_symbol_note', 1 );end } },
  { "spr_symbol_3_note_big", { event_mdown = function() common_impl.NoteScale( "close", "spr_symbol_3_note" ) end } },
  { "spr_base_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_base_3_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_drawers_3_collect_2", { event_mdown = function () private.get_collect_2_2_1(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_symbol_3_collect_2", { event_mdown = function () private.get_collect_2_2_2(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                             
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_base_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gzz_base_3_symbol",
    "gzz_base_3_drawers"
    
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_symbol_3",
    "zz_drawers_3",
    
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_base_3", update_game_mode_base_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_base_3 = function ()

  local effects_table = 
  {
    "obj_base_3_anim",
    "obj_symbol_3_anims"
   
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
cmn.AddSubscriber( "update_performance_mode_base_3", update_performance_mode_base_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_base_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_base_3_map = function ()

    common_impl.VisitMapRoom( "base" );

  end;
  cmn.AddSubscriber( "opn_base_3", opn_base_3_map );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_3 = function ()
  
    ObjDelete( "obj_base_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_3", get_collect_morph_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_3 = function ()
  
    ObjDelete( "obj_base_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_3", get_collect_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_1 = function ()
 
    ObjDelete( "spr_drawers_3_collect_2" );
    ObjDelete( "spr_drawers_3_collect_2_shadow" );
  ObjDelete( "gzz_base_3_drawers" );
          
  end;
  cmn.AddSubscriber( "get_collect_2_2_1", get_collect_2_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
   -- function get_collect_2_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_2 = function ()
 
  ObjDelete( "spr_symbol_3_collect_2" );
  
        
  end;
  cmn.AddSubscriber( "get_collect_2_2_2", get_collect_2_2_2, private.room_objname );
  
 

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_symbol_3" );  
   
  function zz_symbol_3.PreOpen()
    
    if not common_impl.base then

       common_impl.base_3 = {}
       common_impl.base_3.note = "close";

      end;
    
  end;
  
  function zz_symbol_3.Close()
    
    common_impl.base_3.note = "close";
    
     ObjSet( "spr_symbol_3_note_big", { input = false, alp = 0 } );
     ObjSet( "spr_symbol_3_note",     { alp = 1 } );
    
  end;
 
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_base_3();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_base_env" }, "", 0.5 );
  
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_collect_2_2_1()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_1");
    cmn.CallEventHandler("get_collect_2_2_1");
  common.CloseSubRoom();
 

  end;

  common_impl.PlayEffectHO( "spr_drawers_3_collect_2", func_after ); 

end;
-----------------------------------------------------------------------------------------
function private.get_collect_2_2_2()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_2");
    cmn.CallEventHandler("get_collect_2_2_2");
 
  end;

  common_impl.PlayEffectHO( "spr_symbol_3_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_base_3()

  if not ( cmn.IsEventDone( "opn_base_3" ) ) then
    cmn.SetEventDone( "opn_base_3" );
  end;
  
  cmn.CallEventHandler( "opn_base_3" ); 

end;
--*********************************************************************************************************************
ObjAnimate( "spr_symbol_3_light", "alp", 1 ,0, "", { 0,0,1, 1.5,0,0.5, 3,0,1 } );
