-- name=rm_groundfloor_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_groundfloor_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stair_3", "room_hub" );

  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "obj_groundfloor_3_clk_robot", { event_mdown = private.clk_robot } },
  { "spr_stair_3_note", { event_mdown = function() common_impl.NoteScale( "open", "spr_stair_3_note" );common_impl.ShowBbt( 'bbt_stair_note', 1 ); end } },
  { "spr_stair_3_note_big", { event_mdown = function() common_impl.NoteScale( "close", "spr_stair_3_note" ); end } },
  { "spr_groundfloor_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_stairs_3_collect_2", { event_mdown = function () private.get_collect_2_2_3(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_groundfloor_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "grm_groundfloor_3_base",
    "grm_groundfloor_3_storageexit",
    "gzz_groundfloor_3_stair"
    
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_stair_3"
     
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_groundfloor_3", update_game_mode_groundfloor_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_groundfloor_3 = function ()

  local effects_table = 
  {
    "obj_groundfloor_3_anim"
  
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_groundfloor_3", update_performance_mode_groundfloor_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_groundfloor_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_groundfloor_3_map = function ()

    common_impl.VisitMapRoom( "groundfloor" );

  end;
  cmn.AddSubscriber( "opn_groundfloor_3", opn_groundfloor_3_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_4 = function ()
  
    ObjDelete( "obj_groundfloor_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_4", get_collect_morph_item_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2_3 = function ()
 
    ObjDelete( "spr_stairs_3_collect_2" );
    ObjDelete( "spr_stairs_3_collect_2_shadow" );
     
    
  end;
  cmn.AddSubscriber( "get_collect_2_2_3", get_collect_2_2_3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_stair_3" );
  
  function zz_stair_3.PreOpen()
    
    if not common_impl.groundfloor_3 then

      common_impl.groundfloor_3 = {}
      common_impl.groundfloor_3.note = "close";

      end;
    
  end;
   
  function zz_stair_3.Close()
    
    common_impl.groundfloor_3.note = "close";
    
    ObjSet( "spr_stair_3_note_big", { input = false, alp = 0 } );
    ObjSet( "spr_stair_3_note",     { alp = 1 } );
    
  end;
  
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_groundfloor_3();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level2/aud_groundfloor_env" }, "", 0.5 );
 
end;
--*********************************************************************************************************************
function public.Close()

end;
--*********************************************************************************************************************
function public.PreClose()
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------
function private.get_collect_2_2_3()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_2_3");
    cmn.CallEventHandler("get_collect_2_2_3");

  end;

  common_impl.PlayEffectHO( "spr_stairs_3_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_robot()
  
   local func_after = function()
   
     common_impl.Lock( false );
  
   end;
  
   common_impl.Lock( true );
   
   common_impl.PlayAudio( "sfx", "common/audio/level2/aud_touch_robot_groundfloor", 0, "", 0 );
  
   AnimPlay( "anm_groundfloor_3_robot", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_groundfloor_3()

  if not ( cmn.IsEventDone( "opn_groundfloor_3" ) ) then
    cmn.SetEventDone( "opn_groundfloor_3" );
  end;
  
  cmn.CallEventHandler( "opn_groundfloor_3" ); 

end;

--*********************************************************************************************************************
ObjAnimate( "spr_groundfloor_3_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
ObjAnimate( "spr_groundfloor_3_light_door", "alp", 1, 0, "", { 0,0,0.5, 0.5,0,1, 1,0,0.5 } );
--ObjAnimate( "spr_groundfloor_3_glass_add", "alp", 1, 0, "", { 0,0,1, 2,0,0.6, 4,0,1 } );


