-- name=rm_roof
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_roof";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_vanquished", "room_hub" );
  ObjAttach( "zz_device", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_vanquished_bastardsmedallion", { event_mdown = private.get_bastardsmedallion }},
  { "spr_vanquished_avengermark2", { event_mdown = private.get_avengermark2 }},
  { "spr_vanquished_avengermark3", { event_mdown = private.get_avengermark3 }},
  { "obj_roof_clk_birds_fly", { event_mdown = private.clk_roof_birds }},
  { "spr_roof_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_roof_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_device_collect_2", { event_mdown = function () private.get_collect_2_3_1(); end,
                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_roof = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_roof_deactivation",
    "gmg_roof_fight",
    "gzz_roof_vanquished",
    "gzz_roof_device"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_vanquished",
    "zz_device"   
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_roof", update_game_mode_roof, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_roof = function ()

  local effects_table = 
  {
    "obj_roof_anim" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_roof", update_performance_mode_roof, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_roof () end;
  --------------------------------------------------------------------------------------------
  local opn_roof_map = function ()

    common_impl.VisitMapRoom( "roof" );

  end;
  cmn.AddSubscriber( "opn_roof", opn_roof_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_bastardsmedallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bastardsmedallion" ] = {
    type = "get",
    get_obj = "spr_vanquished_bastardsmedallion",
    room = private.room_objname,
    zz = "zz_vanquished",
    zz_gate = "gzz_roof_vanquished"
  };
    
  local get_bastardsmedallion_inv = function ()
  
    interface.InventoryItemAdd( "inv_bastardsmedallion", "spr_vanquished_bastardsmedallion" );
  
  end;
  
  local get_bastardsmedallion_closezz = function ()
  
    ObjDelete( "gfx_vanquished_bastardsmedallion" );
    ObjDelete( "spr_roof_vanquished_amulet" );
    if( cmn.IsEventDone("get_avengermark3") and cmn.IsEventDone("get_avengermark2") )then
      ObjDelete( "gzz_roof_vanquished" );    
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bastardsmedallion", get_bastardsmedallion_inv );
  cmn.AddSubscriber( "get_bastardsmedallion", get_bastardsmedallion_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_avengermark2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_avengermark2" ] = {
    type = "get",
    get_obj = "spr_vanquished_avengermark2",
    room = private.room_objname,
    zz = "zz_vanquished",
    zz_gate = "gzz_roof_vanquished"
  };
    
  local get_avengermark2_inv = function ()
  
    interface.InventoryItemAdd( "inv_avengermark2", "spr_vanquished_avengermark2" );
  
  end;
  
  local get_avengermark2_closezz = function ()
  
    ObjDelete( "gfx_vanquished_avengermark2" );
    ObjDelete( "spr_roof_vanquished_avengermark2" );
    
    if( cmn.IsEventDone("get_bastardsmedallion") and cmn.IsEventDone("get_avengermark3") )then
      ObjDelete( "gzz_roof_vanquished" );    
    end;
  
  end;
  
  cmn.AddSubscriber( "get_avengermark2", get_avengermark2_inv );
  cmn.AddSubscriber( "get_avengermark2", get_avengermark2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_avengermark3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_avengermark3" ] = {
    type = "get",
    get_obj = "spr_vanquished_avengermark3",
    room = private.room_objname,
    zz = "zz_vanquished",
    zz_gate = "gzz_roof_vanquished"
  };
    
  local get_avengermark3_inv = function ()
  
    interface.InventoryItemAdd( "inv_avengermark3", "spr_vanquished_avengermark3" );
  
  end;
  
  local get_avengermark3_closezz = function ()
  
    ObjDelete( "gfx_vanquished_avengermark3" );
    ObjDelete( "spr_roof_vanquished_avengermark3" );
    
    if( cmn.IsEventDone("get_bastardsmedallion") and cmn.IsEventDone("get_avengermark2") )then
      ObjDelete( "gzz_roof_vanquished" );    
    end;
  
  end;
  
  cmn.AddSubscriber( "get_avengermark3", get_avengermark3_inv );
  cmn.AddSubscriber( "get_avengermark3", get_avengermark3_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_6 = function ()
  
    ObjDelete( "obj_roof_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_6", get_collect_morph_item_3_6, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_3 = function ()
  
  ObjDelete( "obj_roof_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_3", get_collect_item_3_3, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_1 = function ()
  
    ObjDelete( "spr_device_collect_2" );
    
    if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark2") and cmn.IsEventDone("use_avengermark3") ) then
      
      ObjSet( "gmg_roof_deactivation", { active = true, input = true } );
      ObjDelete( "gzz_roof_device" );
      
    end;
  end;
  cmn.AddSubscriber( "get_collect_2_3_1", get_collect_2_3_1 , private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_penknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_penknife_2" ] = {
    type = "use",
    inv_obj = "inv_penknife",
    use_place = "obj_vanquished_use_penknife",
    room = private.room_objname,
    zz = "zz_vanquished",
    zz_gate = "gzz_roof_vanquished"
  };
  local use_penknife_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_penknife" );
  
  end;
  local use_penknife_2_beg = function ()
  
    ObjDelete( "obj_vanquished_use_penknife" );
  
  end;
  local use_penknife_2_end = function ()
  
    ObjDelete( "anm_vanquished_knife" );
    ObjSet( "spr_vanquished_avengermark2", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_vanquished_avengermark2_over", { alp = 1 } );
    ObjSet( "spr_vanquished_avengermark2_over_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_penknife_2", use_penknife_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife_2", use_penknife_2_inv );
  cmn.AddSubscriber( "use_penknife_2", use_penknife_2_end, private.room_objname );
  cmn.AddSubscriber( "use_penknife_2_inv", use_penknife_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_penknife_2_beg", use_penknife_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife_2_end", use_penknife_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plate" ] = {
    type = "use",
    inv_obj = "inv_plate",
    use_place = "obj_vanquished_use_plate",
    room = private.room_objname,
    zz = "zz_vanquished",
    zz_gate = "gzz_roof_vanquished"
  };
  local use_plate_inv = function ()
  
    interface.InventoryItemRemove( "inv_plate" );
  
  end;
  local use_plate_beg = function ()
  
    ObjDelete( "obj_vanquished_use_plate" );
  
  end;
  local use_plate_end = function ()
    
    ObjDelete( "spr_vanquished_plate" );
    ObjSet( "spr_roof_vanquished_open_1", { alp = 1 } );
    ObjSet( "spr_vanquished_open", { input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plate", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate", use_plate_inv );
  cmn.AddSubscriber( "use_plate", use_plate_end, private.room_objname );
  cmn.AddSubscriber( "use_plate_inv", use_plate_inv, private.room_objname );
  cmn.AddSubscriber( "use_plate_beg", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate_end", use_plate_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_avengermark1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_avengermark1" ] = {
    type = "use",
    inv_obj = "inv_avengermark1",
    use_place = "obj_device_use_avengermark",
    room = private.room_objname,
    zz = "zz_device",
    zz_gate = "gzz_roof_device"
  };
  local use_avengermark1_inv = function ()
  
    interface.InventoryItemRemove( "inv_avengermark1" );
  
  end;
  local use_avengermark1_beg = function ()
  
    if ( cmn.IsEventDone("use_avengermark2") and cmn.IsEventDone("use_avengermark3") ) then
      ObjDelete( "obj_device_use_avengermark" );
    end;
  
  end;
  local use_avengermark1_end = function ()
  
    ObjSet( "spr_device_avengermark1", { alp = 1 } );
    if ( cmn.IsEventDone("use_avengermark2") and cmn.IsEventDone("use_avengermark3") ) then
      ObjSet( "gmg_roof_deactivation", { active = true, input = true } );
      
     if common_impl.IsGetCollect( "get_collect_2_3_1" ) then 
      
      ObjDelete( "gzz_roof_device" );
      
     end;
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_avengermark1", use_avengermark1_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark1", use_avengermark1_inv );
  cmn.AddSubscriber( "use_avengermark1", use_avengermark1_end, private.room_objname );
  cmn.AddSubscriber( "use_avengermark1_inv", use_avengermark1_inv, private.room_objname );
  cmn.AddSubscriber( "use_avengermark1_beg", use_avengermark1_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark1_end", use_avengermark1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_avengermark2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_avengermark2" ] = {
    type = "use",
    inv_obj = "inv_avengermark2",
    use_place = "obj_device_use_avengermark",
    room = private.room_objname,
    zz = "zz_device",
    zz_gate = "gzz_roof_device"
  };
  local use_avengermark2_inv = function ()
  
    interface.InventoryItemRemove( "inv_avengermark2" );
  
  end;
  local use_avengermark2_beg = function ()
  
    if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark3") ) then
      ObjDelete( "obj_device_use_avengermark" );
    end;
  
  end;
  local use_avengermark2_end = function ()
  
    ObjSet( "spr_device_avengermark2", { alp = 1 } );
    if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark3") ) then
      ObjSet( "gmg_roof_deactivation", { active = true, input = true } );
      
      if common_impl.IsGetCollect( "get_collect_2_3_1" ) then 
      
        ObjDelete( "gzz_roof_device" );
      
      end;
     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_avengermark2", use_avengermark2_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark2", use_avengermark2_inv );
  cmn.AddSubscriber( "use_avengermark2", use_avengermark2_end, private.room_objname );
  cmn.AddSubscriber( "use_avengermark2_inv", use_avengermark2_inv, private.room_objname );
  cmn.AddSubscriber( "use_avengermark2_beg", use_avengermark2_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark2_end", use_avengermark2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_avengermark3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_avengermark3" ] = {
    type = "use",
    inv_obj = "inv_avengermark3",
    use_place = "obj_device_use_avengermark",
    room = private.room_objname,
    zz = "zz_device",
    zz_gate = "gzz_roof_device"
  };
  local use_avengermark3_inv = function ()
  
    interface.InventoryItemRemove( "inv_avengermark3" );
  
  end;
  local use_avengermark3_beg = function ()
  
    if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark2") ) then
      ObjDelete( "obj_device_use_avengermark" );
    end;
  
  end;
  local use_avengermark3_end = function ()
  
    ObjSet( "spr_device_avengermark3", { alp = 1 } );
    if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark2") ) then
      ObjSet( "gmg_roof_deactivation", { active = true, input = true } );
      
     if common_impl.IsGetCollect( "get_collect_2_3_1" ) then 
      
      ObjDelete( "gzz_roof_device" );
      
     end;
     
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_avengermark3", use_avengermark3_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark3", use_avengermark3_inv );
  cmn.AddSubscriber( "use_avengermark3", use_avengermark3_end, private.room_objname );
  cmn.AddSubscriber( "use_avengermark3_inv", use_avengermark3_inv, private.room_objname );
  cmn.AddSubscriber( "use_avengermark3_beg", use_avengermark3_beg, private.room_objname );
  cmn.AddSubscriber( "use_avengermark3_end", use_avengermark3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shocker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shocker" ] = {
    type = "use",
    inv_obj = "inv_shocker",
    use_place = "obj_roof_use_shocker",
    room = private.room_objname
  };
  local use_shocker_inv = function ()
  
    interface.InventoryItemRemove( "inv_shocker" );
  
  end;
  local use_shocker_beg = function ()
  
    ObjDelete( "obj_roof_use_shocker" );
  
  end;
  local use_shocker_end = function ()
  
    ObjSet( "gzz_roof_vanquished", { input = true, active = true } );
    ObjDelete( "anm_roof_use_shocker" );
    ObjSet( "anm_roof_avenger_sit", { alp = 1 } );
    ObjDelete( "anm_roof_villainy_1");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shocker", use_shocker_beg, private.room_objname );
  cmn.AddSubscriber( "use_shocker", use_shocker_inv );
  cmn.AddSubscriber( "use_shocker", use_shocker_end, private.room_objname );
  cmn.AddSubscriber( "use_shocker_inv", use_shocker_inv, private.room_objname );
  cmn.AddSubscriber( "use_shocker_beg", use_shocker_beg, private.room_objname );
  cmn.AddSubscriber( "use_shocker_end", use_shocker_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_roof_birds() end;
  --------------------------------------------------------------------------------------------
  local clk_roof_birds = function ()
  
    ObjDelete( "anm_roof_birds_fly");
    ObjDelete( "anm_roof_birds");
    ObjDelete( "obj_roof_clk_birds_fly");
      
  end;
  --------------------------------------------------------------------------------------------
   cmn.AddSubscriber( "clk_roof_birds", clk_roof_birds, private.room_objname );
   --cmn.AddSubscriber( "clk_instruments_end", clk_instruments_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function vid_roof_villainy () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_roof_villainy" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_roof_villainy",
    
  };
  local vid_roof_villainy_end = function ()
  
    ObjDelete( "anm_roof_villainy" );
    ObjSet( "obj_roof_use_shocker", { input = true } );
    ObjSet( "anm_roof_radar", { alp = 1, playing = true } );
    ObjSet( "anm_roof_birds", { alp = 1, playing = true } ); 
    ObjSet( "anm_roof_villainy_1", { alp = 1, playing = true });
    ObjSet( "obj_roof_clk_birds_fly", { input = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_roof_villainy", vid_roof_villainy_end, private.room_objname  );
  cmn.AddSubscriber( "vid_roof_villainy_end", vid_roof_villainy_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_roof_risen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_roof_risen" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_roof_risen",
    
  };
  local vid_roof_risen_end = function ()
  
    ObjSet( "gmg_roof_fight", { active = true, input = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_roof_risen", vid_roof_risen_end, private.room_objname  );
  cmn.AddSubscriber( "vid_roof_risen_end", vid_roof_risen_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  -----------------------------------------------------------
  subroom.Define( "zz_device" );
  
  function zz_device.PreOpen()
    
    common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_device_zz_env", 1, "", 0 );
   
  end;

  function zz_device.Close()
    
    common_impl.StopAudio( "env", "common/audio/level3/aud_roof_device_zz_env", 0.2 );
    
    if cmn.IsEventDone( "use_avengermark1" ) and cmn.IsEventDone( "use_avengermark2" ) and cmn.IsEventDone( "use_avengermark3" ) then
      
      ObjSet( "tmr_roof_gotomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_deactivation' ) end } );
      
    end;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_roof();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level3/aud_roof_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "vid_roof_villainy" ) then

    ObjSet( "tmr_roof_villainy",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_roof_villainy(); end
    } );

  end;
    
  if cmn.IsEventDone( "vid_roof_villainy" ) and not cmn.IsEventDone( "use_shocker" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_avenger_env", 1, "", 0 );
    
  end;
  
  if( cmn.IsEventDone( "vid_roof_villainy" ) and not cmn.IsEventDone("vid_roof_risen") ) then
  
    common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_device_env", 1, "", 0 );
  
  end
  
  if( cmn.IsEventDone("win_deactivation") and not cmn.IsEventDone("vid_roof_risen") ) then
    
    private.vid_roof_risen();
    
  end;
  
  if( cmn.IsEventDone("win_fight") and not cmn.IsEventDone("vid_roof_final") ) then
    
    private.vid_roof_final();
    
  end;
  
  if not cmn.IsEventDone( "clk_roof_birds" ) then
    
    common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_pigeons_env", 1, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_penknife_2()

  local item = "inv_penknife";

  if ( common.ApplyObj( item, "obj_vanquished_use_penknife", true ) and cmn.IsEventDone("use_shocker") ) then

    cmn.CallEventHandler( "use_penknife_2_inv" );
    cmn.CallEventHandler( "use_penknife_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_penknife_2" );
      cmn.CallEventHandler( "use_penknife_2_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_penknife_vanquished", 0, "", 0 );
    AnimPlay( "anm_vanquished_knife", "DoAnim", func_after ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_roof_vanquished", false ) and cmn.IsEventDone("use_shocker") and not cmn.IsEventDone( "use_penknife_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vanquished", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_plate()

  local item = "inv_plate";

  if ( common.ApplyObj( item, "obj_vanquished_use_plate", true ) ) then

    cmn.CallEventHandler( "use_plate_inv" );
    cmn.CallEventHandler( "use_plate_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_plate" );
        cmn.CallEventHandler( "use_plate_end" );
        
      end;
      
      ObjAnimate( "spr_vanquished_plate", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_vanquished_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_plate_vanquished", 0, "", 0 );
    
    ObjAnimate( "spr_vanquished_plate", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_roof_vanquished", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vanquished", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_avengermark1()

  local item = "inv_avengermark1";

  if ( common.ApplyObj( item, "obj_device_use_avengermark", true ) ) then

    cmn.CallEventHandler( "use_avengermark1_inv" );
    cmn.CallEventHandler( "use_avengermark1_beg" );

    local func_after = function ()
  
      local func_after_1 = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark1" );
        cmn.CallEventHandler( "use_avengermark1_end" );
        
      end;
    
      local func_after_2 = function ()
        
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark1" );
        cmn.CallEventHandler( "use_avengermark1_end" );
        common.CloseSubRoom();
          
      end;
      
      if ( cmn.IsEventDone("use_avengermark2") and cmn.IsEventDone("use_avengermark3") ) then
        
        AnimPlay( "anm_device_cover", "DoAnim", func_after_2 );
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_open_cover_device", 0, "", 0 );
        
      else 
        
        func_after_1();
        
      end;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_avengermark_device", 0, "", 0 );
    
    ObjAnimate( "spr_device_avengermark1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_roof_device", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_device", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_avengermark2()

  local item = "inv_avengermark2";

  if ( common.ApplyObj( item, "obj_device_use_avengermark", true ) ) then

    cmn.CallEventHandler( "use_avengermark2_inv" );
    cmn.CallEventHandler( "use_avengermark2_beg" );

    local func_after = function ()
    
      local func_after_1 = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark2" );
        cmn.CallEventHandler( "use_avengermark2_end" );
        
      end;
    
      local func_after_2 = function ()
        
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark2" );
        cmn.CallEventHandler( "use_avengermark2_end" );
        common.CloseSubRoom();
          
      end;
      
      if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark3") ) then
        
        AnimPlay( "anm_device_cover", "DoAnim", func_after_2 );
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_open_cover_device", 0, "", 0 );
        
      else 
        
        func_after_1();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_avengermark_device", 0, "", 0 );
    
    ObjAnimate( "spr_device_avengermark2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_roof_device", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_device", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_avengermark3()

  local item = "inv_avengermark3";

  if ( common.ApplyObj( item, "obj_device_use_avengermark", true ) ) then

    cmn.CallEventHandler( "use_avengermark3_inv" );
    cmn.CallEventHandler( "use_avengermark3_beg" );

    local func_after = function ()
  
      local func_after_1 = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark3" );
        cmn.CallEventHandler( "use_avengermark3_end" );
        
      end;
    
      local func_after_2 = function ()
        
        common_impl.Lock( false );
        cmn.SetEventDone( "use_avengermark3" );
        cmn.CallEventHandler( "use_avengermark3_end" );
        common.CloseSubRoom();
          
      end;
      
      if ( cmn.IsEventDone("use_avengermark1") and cmn.IsEventDone("use_avengermark2") ) then
        
        AnimPlay( "anm_device_cover", "DoAnim", func_after_2 );
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_open_cover_device", 0, "", 0 );
        
      else 
        
        func_after_1();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_avengermark_device", 0, "", 0 );
    
    ObjAnimate( "spr_device_avengermark3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_roof_device", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_device", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shocker()

  local item = "inv_shocker";

  if ( common.ApplyObj( item, "obj_roof_use_shocker", false ) ) then

    cmn.CallEventHandler( "use_shocker_inv" );
    cmn.CallEventHandler( "use_shocker_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_shocker" );
      cmn.CallEventHandler( "use_shocker_end" );
      
    end;
    
    common_impl.StopAudio( "env", "common/audio/level3/aud_roof_avenger_env", 0.2 );

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_shocker_roof", 0, "", 0 );
    ObjSet( "anm_roof_villainy_1", { alp = 0 });
    ObjSet( "anm_roof_use_shocker", { alp = 1, playing = true, endtrig = func_after });
    
    return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bastardsmedallion()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bastardsmedallion" );
  cmn.CallEventHandler( "get_bastardsmedallion" );
  
  if( cmn.IsEventDone("get_avengermark3") and cmn.IsEventDone("get_avengermark2") )then
    common.CloseSubRoom();    
  end;
  
      if port.isPortable()==1 then
      iOS_RateMe();
    end;
    
end;
--------------------------------------------------------------------------------------------
function private.get_avengermark2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_avengermark2" );
  cmn.CallEventHandler( "get_avengermark2" );
  
  if( cmn.IsEventDone("get_bastardsmedallion") and cmn.IsEventDone("get_avengermark3") )then
    common.CloseSubRoom();    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_avengermark3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_avengermark3" );
  cmn.CallEventHandler( "get_avengermark3" );

  if( cmn.IsEventDone("get_bastardsmedallion") and cmn.IsEventDone("get_avengermark2") )then
    common.CloseSubRoom();    
  end;
  
end;
-------------------------------------------------------------------------------------------
function private.get_collect_2_3_1()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_1");
    cmn.CallEventHandler("get_collect_2_3_1");

  end;

  common_impl.PlayEffectHO( "spr_device_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_roof_birds()
  
  local func_after = function ()
    
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_roof_birds" );
    cmn.CallEventHandler( "clk_roof_birds" );

  end;
  
  common_impl.StopAudio( "env", "common/audio/level3/aud_roof_pigeons_env", 0.2 );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_pigeons", 0, "", 0 );
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_roof_birds' );
  ObjSet("anm_roof_birds", { alp = 0 });
  ObjSet("anm_roof_birds_fly", { alp = 1 });
  AnimPlay("anm_roof_birds_fly", "DoAnim", func_after);
  
end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.vid_roof_villainy()

  local func_after = function ()
  
    local func_end = function ()

      common_impl.InterfaceSetVisible(true);
      interface.DialogVideoHide();
      local event_id = "subtitle_hide";
      int_dialog_video_impl.SubtitleHideAnim( event_id );
      ObjSet( "obj_roof_gates", { alp = 1 });
      cmn.SetEventDone( "vid_roof_villainy" );
      cmn.CallEventHandler( "vid_roof_villainy_end" );
      common_impl.ShowBbt( 'bbt_vid_roof_villainy', 1 );
      
      common_impl.AddPageDiary( 13 );
      common_impl.StopAudio( "sfx", "common/audio/level3/aud_villainy" );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_villainy_voc" );
      common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_avenger_env", 1, "", 0 );
      common_impl.PlayAudio( "env", "common/audio/level3/aud_roof_device_env", 1, "", 0 );
      
    end;
    
    ObjAnimate( "anm_roof_radar", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 }  );
    ObjAnimate( "anm_roof_birds", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 }  );

    common_impl.PlayAudio( "mus", "common/audio/aud_danger2_mus", 0, "", 0 );

  end;

  local hide_sub = function()
     
    ObjSet( "txt_int_dialog_video_subtitle", { text = "" } );
    local event_id = "subtitle_hide";
    int_dialog_video_impl.SubtitleHideAnim( event_id ); 
    
  end;
  
  common_impl.StopAllMus();

  common_impl.InterfaceSetVisible(false);
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_villainy", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_villainy_voc", 0, "", 0 );
  interface.DialogVideoShow( "", 1, function() func_after( 'skip' ); end, 3 );  
  ObjSet( "txt_int_dialog_video_subtitle", { text = "sub_roof_villainy_1" } );
  
  local event_id = "subtitle_show";
  int_dialog_video_impl.SubtitleShowAnim( event_id );  
  
  ObjSet( "obj_roof_gates", { alp = 0 });
  ObjSet( "anm_roof_radar", { alp = 0 });
  AnimPlay( "anm_roof_villainy", "DoAnim", func_after );
  
  ObjSet( "tmr_roof_sub_hide", { playing = true, time = 5, endtrig = hide_sub })

end;
--*********************************************************************************************************************
function private.vid_roof_risen()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_roof_risen" );
    cmn.CallEventHandler( "vid_roof_risen_end" );
    common_impl.ShowBbt( 'bbt_vid_roof_risen', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level3/aud_roof_risen", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_roof_risen_voc", 0.2 );
      
    end;
    
    common_impl.AddPageDiary( 14 );
    
    cmn.GotoRoom( 'mg_fight' )

    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

  end;
  
  common_impl.StopAudio( "env", "common/audio/level3/aud_roof_device_env", 0.2 );

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_roof_risen", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_roof_risen_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_roof_risen", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_roof_risen", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_roof_final()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_roof_final" );
    cmn.CallEventHandler( "vid_roof_final_end" );
    
    iOS_RegisterGameplay("level_4"); 
    
    common.GotoRoom( "rm_credits" );
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level3/aud_roof_final", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_roof_final_voc", 0.2 );
      
    end;

    --common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_roof_final", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_roof_final_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_roof_final", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_roof_final", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.opn_roof()

  if not ( cmn.IsEventDone( "opn_roof" ) ) then
    cmn.SetEventDone( "opn_roof" );
  end;
  
  cmn.CallEventHandler( "opn_roof" ); 

end;
--*********************************************************************************************************************
ObjAnimate( "spr_roof_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.3, 0, 1.0
} );
ObjAnimate( "spr_device_stone_add", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.3, 0, 1.0
} );
