-- name=rm_storageexit
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_storageexit";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_chest_3", "room_hub" );
  ObjAttach( "zz_armorybox", "room_hub" );
  ObjAttach( "zz_floor", "room_hub" );
  ObjAttach( "zz_statue", "room_hub" );
  ObjAttach( "zz_hatch_3", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_chest_3_avengermark1", { event_mdown = private.get_avengermark1 }},
  { "spr_chest_3_scraper", { event_mdown = private.get_scraper }},
  { "spr_chest_3_amuletscales", { event_mdown = private.get_amuletscales }},
  { "spr_armorybox_amuletcuffs", { event_mdown = private.get_amuletcuffs }},
  { "spr_armorybox_star2", { event_mdown = private.get_star2 }},
  { "spr_armorybox_cartridge", { event_mdown = private.get_cartridge }},
  { "spr_armorybox_ax", { event_mdown = private.get_ax }},
  { "spr_armorybox_shocker", { event_mdown = private.get_shocker }},
  { "spr_floor_protectivemask", { event_mdown = private.get_protectivemask }},
  { "spr_statue_chestkey_3", { event_mdown = private.get_chestkey_3 }},
  { "spr_statue_agentbadge", { event_mdown = private.get_agentbadge }},
  { "obj_storageexit_dlg_double",       { event_mdown = private.dlg_storageexit_double }},
  { "obj_storageexit_dlg_double_focus",       { event_mdown = private.dlg_storageexit_double }},
  { "obj_armorybox_use_button", { event_mdown = private.clk_armorybox_door }},
  { "obj_armorybox_use_agemtsymbol", { event_mdown = private.clk_armorybox_cap }},
  { "obj_floor_clk_carpet", { event_mdown = private.clk_carpet }},
  { "obj_armorybox_clk_button", { event_mdown = private.clk_button_armorybox }},
  { "obj_armorybox_clk_roundhandle", { event_mdown = private.clk_roundhandle }},
  { "spr_storageexit_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_armorybox_note", { event_mdown = function () common_impl.NoteScale( "open", "spr_armorybox_note" ) end }},    
  { "spr_armorybox_note_big",{ event_mdown = function () common_impl.NoteScale( "close", "spr_armorybox_note" ); common_impl.ShowBbt( 'bbt_armorybox_note', 1 ); end } },
  { "obj_armorybox_use_roundhandle", { event_mdown = private.clk_smalldoor }},
  { "spr_chest_3_note", { event_mdown = function() common_impl.NoteScale( "open", "spr_chest_3_note" );common_impl.ShowBbt( 'bbt_chest_3_note', 1 ); end } },
  { "spr_chest_3_note_big", { event_mdown = function() common_impl.NoteScale( "close", "spr_chest_3_note" ); end } },
  { "obj_chest_3_clk_chestkey_3", { event_mdown = private.clk_chestkey_3 }},
  { "spr_statue_collect_2", { event_mdown = function () private.get_collect_2_3_7(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_storageexit_double_mmg_handcuffs_1", { event_mdown = function () private.ClkHandcuffs( 1 ); end,
                                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } },
  { "spr_storageexit_double_mmg_handcuffs_2", { event_mdown = function () private.ClkHandcuffs( 2 ); end,
                                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } },
  { "obj_storageexit_double_mmg_handcuffs", {   event_startdrag = function () private.StartDragHandcuffs(); end,
                                                event_dragdrop = function () private.DropHandcuffs(); end,
                                                } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_storageexit = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_storageexit_chestroom_3",
    "gho_storageexit_underfloor",
    "gzz_storageexit_chest_3",
    "gzz_storageexit_armorybox",
    "gzz_storageexit_floor",
    "gzz_storageexit_statue",
    "gzz_storageexit_hatch_3",
    "grm_storageexit_groundfloor_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_chest_3",
    "zz_armorybox", 
    "zz_floor",
    "zz_statue",
    "zz_hatch_3"   
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_storageexit", update_game_mode_storageexit, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_storageexit = function ()

  local effects_table = 
  {
    "obj_storageexit_anim",
    --"anm_storageexit_double_loc",
    --"anm_storageexit_double_loc_2",
    "anm_armorybox_dust",
    "spr_armorybox_light_add",
    "anm_hatch_3_dust",
    "anm_statue_dust",
    "anm_chest_3_dust"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_storageexit", update_performance_mode_storageexit, private.room_objname );
  
  local beg_level3 = function ()

    ObjSet( "spr_int_button_apparat_apparat", { alp = 1 } );
    ObjSet( "obj_int_button_apparat", { input = true } );  
    
    ObjSet( "obj_int_button_map_button", { input = true } );
    ObjSet( "spr_int_button_map_button", { alp = 1 } );
    
    ObjSet("spr_int_button_map_button_focus_over", { pos_x = -25, pos_y = 3, res="assets/interface/resources/button_map/map_2"});
    ObjSet("spr_int_button_map_button_focus_1", {  res="assets/interface/resources/button_map/map_2_add"});
    ObjSet("spr_int_button_map_button_focus", { pos_x = 3, pos_y = -22, res="assets/interface/resources/button_map/map_2_add" });
    
    interface.InventoryItemAdd( "inv_elf_3_1" );
    interface.InventoryItemAdd( "inv_rifle_3" );
    interface.InventoryItemAdd( "inv_corkscrew_3" );
    ObjSet( "inv_rifle_3", { drag = false });
    
  end;
  cmn.AddSubscriber( "beg_level3", beg_level3 );  
  --------------------------------------------------------------------------------------------
  -- function opn_storageexit () end;
  --------------------------------------------------------------------------------------------
  local opn_storageexit_map = function ()
    
    local rooms = { "atbar", "bar_2", "base", "groundfloor", "wheelbarrow", "storageexit" };
    
    for i = 1, #rooms do
      
      common_impl.VisitMapRoom( rooms[i] );
      
    end;
    
    common_impl.LockMapRoom( "garage", true );
    
    ObjSet( "obj_map_2_screen_1_transition_screen_2", { input = true, visible = true } );
    ObjSet( "obj_map_2_screen_2_transition_screen_1", { input = true, visible = true } );
    if not ng_global.progress[ "std" ][ "get_box1" ].count  then
      ng_global.progress[ "std" ][ "get_box1" ].count = { false,false,false,false };
    end;

  end;
  cmn.AddSubscriber( "opn_storageexit", opn_storageexit_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_avengermark1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_avengermark1" ] = {
    type = "get",
    get_obj = "spr_chest_3_avengermark1",
    room = private.room_objname,
    zz = "zz_chest_3",
    zz_gate = "gzz_storageexit_chest_3"
  };
    
  local get_avengermark1_inv = function ()
  
    interface.InventoryItemAdd( "inv_avengermark1", "spr_chest_3_avengermark1" );
  
  end;
  
  local get_avengermark1_closezz = function ()
  
    ObjDelete( "gfx_chest_3_avengermark1" );
    ObjDelete( "spr_chest_3_avengermark1_shadow" );
    ObjDelete( "spr_storageexit_chest_3_letter" );
  
  end;
  
  cmn.AddSubscriber( "get_avengermark1", get_avengermark1_inv );
  cmn.AddSubscriber( "get_avengermark1", get_avengermark1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scraper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scraper" ] = {
    type = "get",
    get_obj = "spr_chest_3_scraper",
    room = private.room_objname,
    zz = "zz_chest_3",
    zz_gate = "gzz_storageexit_chest_3"
  };
    
  local get_scraper_inv = function ()
  
    interface.InventoryItemAdd( "inv_scraper", "spr_chest_3_scraper" );
  
  end;
  
  local get_scraper_closezz = function ()
  
    ObjDelete( "gfx_chest_3_scraper" );
    ObjDelete( "spr_chest_3_scraper_shadow" );
    ObjDelete( "spr_storageexit_chest_3_opener" );
  
  end;
  
  cmn.AddSubscriber( "get_scraper", get_scraper_inv );
  cmn.AddSubscriber( "get_scraper", get_scraper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletscales () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletscales" ] = {
    type = "get",
    get_obj = "spr_chest_3_amuletscales",
    room = private.room_objname,
    zz = "zz_chest_3",
    zz_gate = "gzz_storageexit_chest_3"
  };
    
  local get_amuletscales_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletscales", "spr_chest_3_amuletscales" );
  
  end;
  
  local get_amuletscales_closezz = function ()
  
    ObjDelete( "gfx_chest_3_amuletscales" );
    ObjDelete( "spr_chest_3_amuletscales_shadow" );
    ObjDelete( "spr_storageexit_chest_3_scales" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletscales", get_amuletscales_inv );
  cmn.AddSubscriber( "get_amuletscales", get_amuletscales_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletcuffs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletcuffs" ] = {
    type = "get",
    get_obj = "spr_armorybox_amuletcuffs",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
    
  local get_amuletcuffs_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletcuffs", "spr_armorybox_amuletcuffs" );
  
  end;
  
  local get_amuletcuffs_closezz = function ()
  
    ObjDelete( "gfx_armorybox_amuletcuffs" );
    ObjDelete("obj_armorybox_handcuffs");
    ObjSet("obj_armorybox_use_button", { input = true});
    ObjDelete( "spr_storageexit_armorybox_amuletcuffs" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletcuffs", get_amuletcuffs_inv );
  cmn.AddSubscriber( "get_amuletcuffs", get_amuletcuffs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_star2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_star2" ] = {
    type = "get",
    get_obj = "spr_armorybox_star2",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
    
  local get_star2_inv = function ()
  
    interface.InventoryItemAdd( "inv_star2", "spr_armorybox_star2" );
  
  end;
  
  local get_star2_closezz = function ()
  
    ObjDelete( "gfx_armorybox_star2" );
    ObjDelete( "spr_storageexit_armorybox_star_1" );
  
  end;
  
  cmn.AddSubscriber( "get_star2", get_star2_inv );
  cmn.AddSubscriber( "get_star2", get_star2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cartridge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cartridge" ] = {
    type = "get",
    get_obj = "spr_armorybox_cartridge",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
    
  local get_cartridge_inv = function ()
  
    interface.InventoryItemAdd( "inv_cartridge", "spr_armorybox_cartridge" );
    ObjSet( "spr_rifle_3_plus_light", { alp = 1 } );
    

  end;
  
  local get_cartridge_closezz = function ()
  
    ObjDelete( "gfx_armorybox_cartridge" );
    ObjDelete( "spr_storageexit_armorybox_cartridge" );
  
  end;
  
  cmn.AddSubscriber( "get_cartridge", get_cartridge_inv );
  cmn.AddSubscriber( "get_cartridge", get_cartridge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ax () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ax" ] = {
    type = "get",
    get_obj = "spr_armorybox_ax",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
    
  local get_ax_inv = function ()
  
    interface.InventoryItemAdd( "inv_ax", "spr_armorybox_ax" );
  
  end;
  
  local get_ax_closezz = function ()
  
    ObjDelete( "gfx_armorybox_ax" );
    ObjDelete( "spr_storageexit_armorybox_ax" );
    
    if ( cmn.IsEventDone("get_shocker") ) then  
     
      ObjDelete( "gzz_storageexit_armorybox");
     
    end;   
  
  end;
  
  cmn.AddSubscriber( "get_ax", get_ax_inv );
  cmn.AddSubscriber( "get_ax", get_ax_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shocker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shocker" ] = {
    type = "get",
    get_obj = "spr_armorybox_shocker",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
    
  local get_shocker_inv = function ()
  
    interface.InventoryItemAdd( "inv_shocker", "spr_armorybox_shocker" );
  
  end;
  
  local get_shocker_closezz = function ()
  
    ObjDelete( "gfx_armorybox_shocker" );
    ObjDelete( "spr_storageexit_armorybox_shocker" );
    if ( cmn.IsEventDone("get_ax") ) then  
     
      ObjDelete( "gzz_storageexit_armorybox");
     
    end;   
  
  end;
  
  cmn.AddSubscriber( "get_shocker", get_shocker_inv );
  cmn.AddSubscriber( "get_shocker", get_shocker_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_protectivemask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_protectivemask" ] = {
    type = "get",
    get_obj = "spr_floor_protectivemask",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_storageexit_floor"
  };
    
  local get_protectivemask_inv = function ()
  
    interface.InventoryItemAdd( "inv_protectivemask", "spr_floor_protectivemask" );
  
  end;
  
  local get_protectivemask_closezz = function ()
  
    ObjDelete( "gfx_floor_protectivemask" );
    ObjDelete( "spr_floor_protectivemask_shadow" );
    ObjDelete( "spr_storageexit_floor_helmet" );
    ObjSet( "obj_floor_clk_carpet", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_protectivemask", get_protectivemask_inv );
  cmn.AddSubscriber( "get_protectivemask", get_protectivemask_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chestkey_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chestkey_3" ] = {
    type = "get",
    get_obj = "spr_statue_chestkey_3",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
    
  local get_chestkey_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_chestkey_3", "spr_statue_chestkey_3" );
  
  end;
  
  local get_chestkey_3_closezz = function ()
  
    ObjDelete( "gfx_statue_chestkey_3" );
    ObjDelete( "spr_statue_chestkey_3_shadow" );
    ObjDelete( "spr_statue_chestkey_3_over" ); 
    
    if ( cmn.IsEventDone("get_agentbadge") and common_impl.IsGetCollect( "get_collect_2_3_7" ) ) then  
      ObjDelete( "gzz_storageexit_statue" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_chestkey_3", get_chestkey_3_inv );
  cmn.AddSubscriber( "get_chestkey_3", get_chestkey_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_agentbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_agentbadge" ] = {
    type = "get",
    get_obj = "spr_statue_agentbadge",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
    
  local get_agentbadge_inv = function ()
  
    interface.InventoryItemAdd( "inv_agentbadge", "spr_statue_agentbadge" );
  
  end;
  
  local get_agentbadge_closezz = function ()
  
    ObjDelete( "gfx_statue_agentbadge" );
    ObjDelete( "spr_statue_agentbadge_shadow" );
    --ObjDelete( "spr_statue_agentbadge_over" );
    
    if ( cmn.IsEventDone("get_chestkey_3") and common_impl.IsGetCollect( "get_collect_2_3_7" )) then  
      ObjDelete( "gzz_storageexit_statue" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_agentbadge", get_agentbadge_inv );
  cmn.AddSubscriber( "get_agentbadge", get_agentbadge_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_1 = function ()
  
    ObjDelete( "obj_storageexit_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_1", get_collect_morph_item_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_7 = function ()
  
    
    ObjDelete( "spr_statue_collect_2" );
    
    if cmn.IsEventDone( "get_agentbadge") and cmn.IsEventDone( "get_chestkey_3")  then  
      
      ObjDelete( "gzz_storageexit_statue");
      
    end;
  end;
  cmn.AddSubscriber( "get_collect_2_3_7", get_collect_2_3_7 , private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_chestkey_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chestkey_3" ] = {
    type = "use",
    inv_obj = "inv_chestkey_3",
    use_place = "obj_chest_3_use_chestkey_3",
    room = private.room_objname,
    zz = "zz_chest_3",
    zz_gate = "gzz_storageexit_chest_3"
  };
  local use_chestkey_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_chestkey_3" );
  
  end;
  local use_chestkey_3_beg = function ()
  
    ObjDelete( "obj_chest_3_use_chestkey_3" );
  
  end;
  local use_chestkey_3_end = function ()
  
    ObjSet( "spr_chest_3_key_1", { alp = 1 } );
    ObjSet( "obj_chest_3_clk_chestkey_3", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chestkey_3", use_chestkey_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_3", use_chestkey_3_inv );
  cmn.AddSubscriber( "use_chestkey_3", use_chestkey_3_end, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_3_inv", use_chestkey_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_3_beg", use_chestkey_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_3_end", use_chestkey_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_3" ] = {
    type = "use",
    inv_obj = "inv_button_3",
    use_place = "obj_armorybox_use_button",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
  local use_button_3_inv = function ()
  
  interface.InventoryItemRemove( "inv_button_3" );
  
  end;
  local use_button_3_beg = function ()
  
    ObjDelete( "obj_armorybox_use_button" );
  
  end;
  local use_button_3_end = function ()
  
    ObjSet("obj_armorybox_clk_button", { input = true, active = true});
    ObjSet("spr_armorybox_button", { alp = 1 });
    ObjSet("spr_storageexit_armorybox_button", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_3", use_button_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_3", use_button_3_inv );
  cmn.AddSubscriber( "use_button_3", use_button_3_end, private.room_objname );
  cmn.AddSubscriber( "use_button_3_inv", use_button_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_3_beg", use_button_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_3_end", use_button_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roundhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roundhandle" ] = {
    type = "use",
    inv_obj = "inv_roundhandle",
    use_place = "obj_armorybox_use_roundhandle",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
  local use_roundhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_roundhandle" );
  
  end;
  local use_roundhandle_beg = function ()
  
    ObjDelete( "obj_armorybox_use_roundhandle" );
  
  end;
  local use_roundhandle_end = function ()
  
    ObjSet("obj_armorybox_clk_roundhandle", { input = true, active = true });
    ObjSet("spr_armorybox_pen", { alp = 1 });
    ObjSet("spr_storageexit_armorybox_handle", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_inv );
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_inv", use_roundhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_beg", use_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_end", use_roundhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_agemtsymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_agemtsymbol" ] = {
    type = "use",
    inv_obj = "inv_agemtsymbol",
    use_place = "obj_armorybox_use_agemtsymbol",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
  local use_agemtsymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_agemtsymbol" );
  
  end;
  local use_agemtsymbol_beg = function ()
  
    ObjDelete( "obj_armorybox_use_agemtsymbol" );
  
  end;
  local use_agemtsymbol_end = function ()
  
    ObjSet( "spr_armorybox_ax", { input = true, active = true } );
    ObjSet( "spr_armorybox_shocker", { input = true, active = true } );
    ObjSet( "spr_armorybox_note", { input = false, active = false, alp = 0 });
    ObjDelete( "spr_armorybox_door_2");
    ObjDelete( "spr_storageexit_armorybox_door_1");
    ObjSet( "spr_armorybox_door_1", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_agemtsymbol", use_agemtsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_agemtsymbol", use_agemtsymbol_inv );
  cmn.AddSubscriber( "use_agemtsymbol", use_agemtsymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_agemtsymbol_inv", use_agemtsymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_agemtsymbol_beg", use_agemtsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_agemtsymbol_end", use_agemtsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crosseddaggers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crosseddaggers" ] = {
    type = "use",
    inv_obj = "inv_crosseddaggers",
    use_place = "obj_floor_use_crosseddaggers",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_storageexit_floor"
  };
  local use_crosseddaggers_inv = function ()
  
    interface.InventoryItemRemove( "inv_crosseddaggers" );
  
  end;
  local use_crosseddaggers_beg = function ()
  
    ObjDelete( "obj_floor_use_crosseddaggers" );
  
  end;
  local use_crosseddaggers_end = function ()
  
    ObjSet( "spr_storageexit_floor_ho", { alp = 1 } );
    ObjSet( "gho_storageexit_underfloor", { input = true, active = true, alp = 1});
    ObjDelete( "gzz_storageexit_floor");
    ObjDelete( "spr_storageexit_floor_carpet_2");
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crosseddaggers", use_crosseddaggers_beg, private.room_objname );
  cmn.AddSubscriber( "use_crosseddaggers", use_crosseddaggers_inv );
  cmn.AddSubscriber( "use_crosseddaggers", use_crosseddaggers_end, private.room_objname );
  cmn.AddSubscriber( "use_crosseddaggers_inv", use_crosseddaggers_inv, private.room_objname );
  cmn.AddSubscriber( "use_crosseddaggers_beg", use_crosseddaggers_beg, private.room_objname );
  cmn.AddSubscriber( "use_crosseddaggers_end", use_crosseddaggers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletmagnifier () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletmagnifier" ] = {
    type = "use",
    inv_obj = "inv_amuletmagnifier",
    use_place = "obj_statue_use_amuletmagnifier",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
  local use_amuletmagnifier_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletmagnifier" );
  
  end;
  local use_amuletmagnifier_beg = function ()
  
    ObjDelete( "obj_statue_use_amuletmagnifier" );
  
  end;
  local use_amuletmagnifier_end = function ()
  
    if ( cmn.IsEventDone("use_amuletscales") and cmn.IsEventDone("use_amuletcuffs") ) then
      
      ObjSet( "spr_statue_open_2", { input = true, alp = 1 } );
      ObjSet( "spr_storageexit_statue_open_2", { alp = 1 } );
      ObjDelete( "spr_statue_over_2" );
      ObjDelete( "spr_statue_amuletmagnifier" );
      ObjDelete( "spr_statue_amuletscales" ); 
      ObjDelete( "spr_statue_amuletcuffs" ); 
      
    else 
      
      ObjSet( "spr_statue_amuletmagnifier", { alp = 1 } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletmagnifier", use_amuletmagnifier_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmagnifier", use_amuletmagnifier_inv );
  cmn.AddSubscriber( "use_amuletmagnifier", use_amuletmagnifier_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletmagnifier_inv", use_amuletmagnifier_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletmagnifier_beg", use_amuletmagnifier_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmagnifier_end", use_amuletmagnifier_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletscales () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletscales" ] = {
    type = "use",
    inv_obj = "inv_amuletscales",
    use_place = "obj_statue_use_amuletscales",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
  local use_amuletscales_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletscales" );
  
  end;
  local use_amuletscales_beg = function ()
  
    ObjDelete( "obj_statue_use_amuletscales" );
  
  end;
  local use_amuletscales_end = function ()
  
    if ( cmn.IsEventDone("use_amuletmagnifier") and cmn.IsEventDone("use_amuletcuffs") ) then
      
      ObjSet( "spr_statue_open_2", { input = true, alp = 1 } );
      ObjSet( "spr_storageexit_statue_open_2", { alp = 1 } );
      ObjDelete( "spr_statue_over_2" );
      ObjDelete( "spr_statue_amuletmagnifier" );
      ObjDelete( "spr_statue_amuletscales" ); 
      ObjDelete( "spr_statue_amuletcuffs" ); 
      
    else 
      
      ObjSet( "spr_statue_amuletscales", { alp = 1 } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletscales", use_amuletscales_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletscales", use_amuletscales_inv );
  cmn.AddSubscriber( "use_amuletscales", use_amuletscales_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletscales_inv", use_amuletscales_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletscales_beg", use_amuletscales_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletscales_end", use_amuletscales_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcuffs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletcuffs" ] = {
    type = "use",
    inv_obj = "inv_amuletcuffs",
    use_place = "obj_statue_use_amuletcuffs",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
  local use_amuletcuffs_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletcuffs" );
  
  end;
  local use_amuletcuffs_beg = function ()
  
    ObjDelete( "obj_statue_use_amuletcuffs" );
  
  end;
  local use_amuletcuffs_end = function ()
  
    if ( cmn.IsEventDone("use_amuletmagnifier") and cmn.IsEventDone("use_amuletscales") ) then
      
      ObjSet( "spr_statue_open_2", { input = true, alp = 1 } );
      ObjSet( "spr_storageexit_statue_open_2", { alp = 1 } );
      ObjDelete( "spr_statue_over_2" );
      ObjDelete( "spr_statue_amuletmagnifier" );
      ObjDelete( "spr_statue_amuletscales" ); 
      ObjDelete( "spr_statue_amuletcuffs" ); 
      
    else 
      
      ObjSet( "spr_statue_amuletcuffs", { alp = 1 } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletcuffs", use_amuletcuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcuffs", use_amuletcuffs_inv );
  cmn.AddSubscriber( "use_amuletcuffs", use_amuletcuffs_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcuffs_inv", use_amuletcuffs_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcuffs_beg", use_amuletcuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcuffs_end", use_amuletcuffs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_star2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_star2" ] = {
    type = "use",
    inv_obj = "inv_star2",
    use_place = "obj_statue_use_star2",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
  local use_star2_inv = function ()
  
    interface.InventoryItemRemove( "inv_star2" );
  
  end;
  local use_star2_beg = function ()
  
    ObjDelete( "obj_statue_use_star2" );
  
  end;
  local use_star2_end = function ()
  
    if ( cmn.IsEventDone("use_star1") ) then
      
      ObjSet( "spr_statue_open_1", { input = true, alp = 1 } );
      ObjSet( "spr_statue_collect_2", { input = true, alp = 1 });
      ObjSet( "spr_storageexit_statue_open_1", { alp = 1 } );
      ObjDelete( "spr_statue_over_1" );
      ObjDelete( "spr_statue_star_1" );
      ObjDelete( "spr_statue_star_2" ); 
      
      
    else 
      
      ObjSet( "spr_statue_star_1", { alp = 1 } );
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_star2", use_star2_beg, private.room_objname );
  cmn.AddSubscriber( "use_star2", use_star2_inv );
  cmn.AddSubscriber( "use_star2", use_star2_end, private.room_objname );
  cmn.AddSubscriber( "use_star2_inv", use_star2_inv, private.room_objname );
  cmn.AddSubscriber( "use_star2_beg", use_star2_beg, private.room_objname );
  cmn.AddSubscriber( "use_star2_end", use_star2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_star1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_star1" ] = {
    type = "use",
    inv_obj = "inv_star1",
    use_place = "obj_statue_use_star1",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_storageexit_statue"
  };
  local use_star1_inv = function ()
  
    interface.InventoryItemRemove( "inv_star1" );
  
  end;
  local use_star1_beg = function ()
  
    ObjDelete( "obj_statue_use_star1" );
  
  end;
  local use_star1_end = function ()
  
    if ( cmn.IsEventDone("use_star2") ) then
      
      ObjSet( "spr_statue_open_1", { input = true, alp = 1 } );
      ObjSet( "spr_statue_collect_2", { input = true, alp = 1 });
      ObjSet( "spr_storageexit_statue_open_1", { alp = 1 } );
      ObjDelete( "spr_statue_over_1" );
      ObjDelete( "spr_statue_star_1" );
      ObjDelete( "spr_statue_star_2" ); 
      
      
    else 
      
      ObjSet( "spr_statue_star_2", { alp = 1 } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_star1", use_star1_beg, private.room_objname );
  cmn.AddSubscriber( "use_star1", use_star1_inv );
  cmn.AddSubscriber( "use_star1", use_star1_end, private.room_objname );
  cmn.AddSubscriber( "use_star1_inv", use_star1_inv, private.room_objname );
  cmn.AddSubscriber( "use_star1_beg", use_star1_beg, private.room_objname );
  cmn.AddSubscriber( "use_star1_end", use_star1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_valve" ] = {
    type = "use",
    inv_obj = "inv_valve",
    use_place = "obj_hatch_3_use_valve",
    room = private.room_objname,
    zz = "zz_hatch_3",
    zz_gate = "gzz_storageexit_hatch_3"
  };
  local use_valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve" );
  
  end;
  local use_valve_beg = function ()
  
    ObjDelete( "obj_hatch_3_use_valve" );
  
  end;
  local use_valve_end = function ()
  
    ObjDelete( "spr_hatch_3_screw");
    ObjSet( "spr_hatch_3_open", { alp = 1 } );  
    ObjSet( "spr_hatch_3_open_over", { alp = 1 } );
    ObjSet( "spr_storageexit_hatch_3_open", { alp = 1 } );    
    ObjDelete( "spr_storageexit_hatch_3_close");
    ObjDelete( "gzz_storageexit_hatch_3");
    ObjSet( "grm_storageexit_street", { input = true, active = true, alp = 1});
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_storageexit_street_focus");
    end;  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve", use_valve_inv );
  cmn.AddSubscriber( "use_valve", use_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_inv", use_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_beg", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_end", use_valve_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_carpet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carpet" ] = {
    type = "click",
    use_place = "obj_floor_clk_carpet",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_storageexit_floor"
  };
 
  local clk_carpet_beg = function ()
 
    ObjDelete( "obj_floor_clk_carpet" );
      
  end;
  local clk_carpet_end = function ()
  
    ObjDelete( "spr_floor_carpet_1" );
    ObjSet( "spr_floor_carpet_2", { alp = 1 } );
    ObjSet( "obj_floor_use_crosseddaggers", { input = true } );  
    ObjSet( "spr_storageexit_floor_carpet_2", { alp = 1 } );
    ObjDelete( "spr_storageexit_floor_carpet_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_carpet", clk_carpet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carpet", clk_carpet_end, private.room_objname );
  cmn.AddSubscriber( "clk_carpet_beg", clk_carpet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carpet_end", clk_carpet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_button_armorybox () end;
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_button_armorybox" ] = {
    type = "click",
    use_place = "obj_armorybox_clk_button",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
 
  local clk_button_armorybox_beg = function ()
 
    ObjDelete( "obj_armorybox_clk_button");
  
  end;

  local clk_button_armorybox_end = function ()
  
     ObjSet( "spr_armorybox_star2", { input = true, active = true, alp = 1 } );
     ObjDelete( "obj_armorybox_close" );
     ObjSet( "obj_armorybox_open", { alp = 1 });
     ObjSet( "spr_armorybox_note", { input = true});
     ObjSet( "obj_armorybox_use_roundhandle", { input = true, active = true });
     ObjSet( "obj_armorybox_use_agemtsymbol", { input = true, active = true });
     ObjSet( "spr_storageexit_armorybox_door_2_open", { alp = 1 });
     ObjDelete( "spr_storageexit_armorybox_door_2_close" );
     ObjDelete( "spr_armorybox_button_push");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_armorybox", clk_button_armorybox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_armorybox", clk_button_armorybox_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_armorybox_beg", clk_button_armorybox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_armorybox_end", clk_button_armorybox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_roundhandle () end;
  --------------------------------------------------------------------------------------------
   common_impl.hint[ "clk_roundhandle" ] = {
    type = "click",
    use_place = "obj_armorybox_clk_roundhandle",
    room = private.room_objname,
    zz = "zz_armorybox",
    zz_gate = "gzz_storageexit_armorybox"
  };
 
  local clk_roundhandle_beg = function ()
 
    ObjDelete( "obj_armorybox_clk_roundhandle");
  
  end;

  local clk_roundhandle_end = function ()
  
    ObjSet( "spr_armorybox_cartridge", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_armorybox_smallopen", { alp = 1 });
    ObjSet( "spr_storageexit_armorybox_open", { alp = 1 });
    ObjDelete( "spr_storageexit_armorybox_handle");
    ObjDelete( "spr_armorybox_small_door");
    ObjDelete("spr_armorybox_pen");
    ObjDelete("spr_armorybox_pen_2");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_roundhandle", clk_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roundhandle", clk_roundhandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_roundhandle_beg", clk_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roundhandle_end", clk_roundhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_chestkey_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chestkey_3" ] = {
    type = "click",
    use_place = "obj_chest_3_clk_chestkey_3",
    room = private.room_objname,
    zz = "zz_chest_3",
    zz_gate = "gzz_storageexit_chest_3"
  };
  local clk_chestkey_3_beg = function ()
  
     ObjDelete( "obj_chest_3_clk_chestkey_3" );
     
  end;
  local clk_chestkey_3_end = function ()
  
    ObjDelete( "spr_chest_3_key_1" );
    ObjDelete( "spr_chest_3_key_2" );
    ObjSet( "spr_chest_3_note", { input = false } );
    ObjSet( "spr_chest_3_open", { input = true, alp = 1 } );
    ObjSet( "gho_storageexit_chestroom_3", { input = true, active = true, alp = 1});
    ObjSet( "spr_storageexit_chest_3_open", { alp = 1 } );
    ObjDelete("gzz_storageexit_chest_3");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chestkey_3", clk_chestkey_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chestkey_3", clk_chestkey_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_chestkey_3_beg", clk_chestkey_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chestkey_3_end", clk_chestkey_3_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_chestroom_3 () end;
  --------------------------------------------------------------------------------------------
  local win_chestroom_3 = function ()

    if ( cmn.IsEventDone( "win_chestroom_3" ) ) then

      ObjDelete( "gho_storageexit_chestroom_3" );

    end;

  end;

  cmn.AddSubscriber( "win_chestroom_3", win_chestroom_3, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function win_underfloor () end;
  --------------------------------------------------------------------------------------------
  local win_underfloor = function ()

    if ( cmn.IsEventDone( "win_underfloor" ) ) then

      ObjDelete( "gho_storageexit_underfloor" );

    end;

  end;

  cmn.AddSubscriber( "win_underfloor", win_underfloor, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function vid_storageexit_capitulation () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_storageexit_capitulation" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_storageexit_capitulation",
    
  };
  local vid_storageexit_capitulation_end = function ()
  
    ObjSet( "anm_storageexit_double_loc", { alp = 1 } );
  
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_storageexit_capitulation", vid_storageexit_capitulation_end, private.room_objname  );
  cmn.AddSubscriber( "vid_storageexit_capitulation_end", vid_storageexit_capitulation_end, private.room_objname  );
  ----------------------------------------------------------------------------------------------
  -- function dlg_storageexit_double () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_storageexit_double" ] = {
    type = "click",
    use_place = "obj_storageexit_dlg_double_focus",
    room = private.room_objname
  };
  local dlg_storageexit_double_beg = function ()

    ObjDelete( "obj_storageexit_dlg_double");
    ObjDelete( "anm_storageexit_girl_1");
    
  end;

  local dlg_storageexit_double_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletmagnifier","spr_storageexit_double_amuletmagnifier"); 
    ObjSet("anm_storageexit_girl_2", { alp = 1 });
    ObjSet( "obj_storageexit_girl_bbt", { input = true });
  
  end;
  
  local dlg_storageexit_double_end = function ()

    ObjDelete( "anm_storageexit_double_loc" );
    ObjSet( "anm_storageexit_double_loc_2", { alp = 1 });
    ObjSet( "obj_storageexit_clk_doubleman", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_storageexit_double_beg", dlg_storageexit_double_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_storageexit_double_inv", dlg_storageexit_double_inv );
  cmn.AddSubscriber( "dlg_storageexit_double", dlg_storageexit_double_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_storageexit_double", dlg_storageexit_double_inv );
  cmn.AddSubscriber( "dlg_storageexit_double", dlg_storageexit_double_end, private.room_objname );
  cmn.AddSubscriber( "dlg_storageexit_double_end", dlg_storageexit_double_end, private.room_objname );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_chest_3" );
  subroom.Define( "zz_armorybox" );
  subroom.Define( "zz_floor" );
  
  function zz_armorybox.PreOpen()
  
    if not common_impl.storageexit then

      common_impl.storageexit = {}
      common_impl.storageexit.note = "close";

    end;
    
    if  ObjGet( "spr_armorybox_note" ).input == true then

      ObjSet( "spr_armorybox_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_armorybox_note",     { alp = 1 } );
      
    end; 
       
  end;  
  -------------------------------------------------------------------------------------------- 
  function zz_armorybox.Close()
    
    common_impl.storageexit.note = "close";
    
  end;
  --------------------------------------------------------------------------------------------     
  function zz_chest_3.PreOpen()
  
    if not common_impl.storageexit then

      common_impl.storageexit = {}
      common_impl.storageexit.note = "close";

    end;
    
    if  ObjGet( "spr_chest_3_note" ).input == true then

      ObjSet( "spr_chest_3_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_chest_3_note",     { alp = 1 } );
      
    end; 
       
  end;  
  -------------------------------------------------------------------------------------------- 
  function zz_chest_3.Close()
    
    common_impl.storageexit.note = "close";
    
    if cmn.IsEventDone( "clk_chestkey_3" ) then
      
      ObjSet( "tmr_storageexit_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_chestroom_3' ) end } );
      
    end;
    
  end;
  -------------------------------------------------------------------------------------------- 
  function zz_floor.Close()
  
    if cmn.IsEventDone( "use_crosseddaggers" ) then
      
      ObjSet( "tmr_storageexit_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_underfloor' ) end } );
      
    end;
    
  end;
  -------------------------------------------------------------------------------------------- 
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_storageexit();

end;
--*********************************************************************************************************************
function public.PreOpen()

 cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
 cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
 
 if not cmn.IsEventDone( "vid_storageexit_capitulation" ) then

    ObjSet( "tmr_storageexit_capitulation",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_storageexit_capitulation(); end
    } );

  end;
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level3/aud_storageexit_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_chestkey_3()

  local item = "inv_chestkey_3";

  if ( common.ApplyObj( item, "obj_chest_3_use_chestkey_3", true ) and cmn.IsEventDone( "get_amuletscales" ) 
    and cmn.IsEventDone( "get_avengermark1" ) and cmn.IsEventDone( "get_scraper" ) and common_impl.storageexit.note == "close" ) then

    cmn.CallEventHandler( "use_chestkey_3_inv" );
    cmn.CallEventHandler( "use_chestkey_3_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_chestkey_3" );
      cmn.CallEventHandler( "use_chestkey_3_end" );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_chestkey_chest_3", 0, "", 0 );
    
    ObjAnimate( "spr_chest_3_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_chest_3", false ) and cmn.IsEventDone( "get_amuletscales" ) 
    and cmn.IsEventDone( "get_avengermark1" ) and cmn.IsEventDone( "get_scraper" ) and common_impl.storageexit.note == "close" then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest_3", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_3()

  local item = "inv_button_3";
  
  DbgTrace("zzz");

  if ( common.ApplyObj( item, "obj_armorybox_use_button", true ) ) then

    cmn.CallEventHandler( "use_button_3_inv" );
    cmn.CallEventHandler( "use_button_3_beg" );

    local func_after = function ()
      
      
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_button_3" );
        cmn.CallEventHandler( "use_button_3_end" );
    --common.CloseSubRoom();;
  
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_button_armorybox", 0, "", 0 );
  
    ObjAnimate( "spr_armorybox_button", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_armorybox", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armorybox", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_roundhandle()

  local item = "inv_roundhandle";

  if ( common.ApplyObj( item, "obj_armorybox_use_roundhandle", true ) ) and common_impl.storageexit.note == "close" then

    cmn.CallEventHandler( "use_roundhandle_inv" );
    cmn.CallEventHandler( "use_roundhandle_beg" );

    local func_after = function ()
    
     
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_roundhandle" );
        cmn.CallEventHandler( "use_roundhandle_end" );
    --common.CloseSubRoom();;
    
  
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_roundhandle_armorybox", 0, "", 0 );
  
   ObjAnimate( "spr_armorybox_pen", "alp", 0, 0, func_after,
   { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
      
   } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_armorybox", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armorybox", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_agemtsymbol()

  local item = "inv_agemtsymbol";

  if ( common.ApplyObj( item, "obj_armorybox_use_agemtsymbol", true ) ) and common_impl.storageexit.note == "close" then

    cmn.CallEventHandler( "use_agemtsymbol_inv" );
    cmn.CallEventHandler( "use_agemtsymbol_beg" );

    local func_after = function ()
  
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_agemtsymbol" );
        cmn.CallEventHandler( "use_agemtsymbol_end" );
    --common.CloseSubRoom();;
    
      end;
  
      ObjAnimate( "spr_armorybox_door_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
        
      } );
      
      ObjAnimate( "spr_armorybox_door_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
        
      } );
      ObjAnimate( "spr_armorybox_note", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
        
      } );
      
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_agemtsymbol_armorybox", 0, "", 0 );
  
    ObjAnimate( "spr_armorybox_amulet", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
      
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_armorybox", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armorybox", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crosseddaggers()

  local item = "inv_crosseddaggers";

  if ( common.ApplyObj( item, "obj_floor_use_crosseddaggers", true ) and cmn.IsEventDone( "clk_carpet" ) ) then

    cmn.CallEventHandler( "use_crosseddaggers_inv" );
    cmn.CallEventHandler( "use_crosseddaggers_beg" );
    
    local func_after = function ()

      local func_end = function ()
      
          common_impl.Lock( false );
          cmn.SetEventDone( "use_crosseddaggers" );
          cmn.CallEventHandler( "use_crosseddaggers_end" );
          common.CloseSubRoom();
          
      end;
      
      
     ObjAnimate( "spr_floor_cap", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_floor_back_ho", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
 
  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_crosseddaggers_floor", 0, "", 0 );
  
  ObjAnimate( "spr_floor_knives", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
 
  return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_floor", false ) and cmn.IsEventDone( "clk_carpet" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floor", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletmagnifier()

  local item = "inv_amuletmagnifier";

  if ( common.ApplyObj( item, "obj_statue_use_amuletmagnifier", true ) ) then

    cmn.CallEventHandler( "use_amuletmagnifier_inv" );
    cmn.CallEventHandler( "use_amuletmagnifier_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_amuletmagnifier" );
        cmn.CallEventHandler( "use_amuletmagnifier_end" );
        
      end;
    
      if ( cmn.IsEventDone("use_amuletscales") and cmn.IsEventDone("use_amuletcuffs")) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_amulet_statue", 0, "", 0 );
        
        ObjAnimate( "spr_statue_amuletscales", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_amuletcuffs", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
  
        ObjAnimate( "spr_statue_amuletmagnifier", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_over_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_open_2", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
      else 
        
        func_end();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_amulet_statue", 0, "", 0 );
    
    ObjAnimate( "spr_statue_amuletmagnifier", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_statue", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletscales()

  local item = "inv_amuletscales";

  if ( common.ApplyObj( item, "obj_statue_use_amuletscales", true ) ) then

    cmn.CallEventHandler( "use_amuletscales_inv" );
    cmn.CallEventHandler( "use_amuletscales_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_amuletscales" );
        cmn.CallEventHandler( "use_amuletscales_end" );
        
      end;
    
      if ( cmn.IsEventDone("use_amuletmagnifier") and cmn.IsEventDone("use_amuletcuffs")) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_amulet_statue", 0, "", 0 );
        
        ObjAnimate( "spr_statue_amuletscales", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_amuletcuffs", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
  
        ObjAnimate( "spr_statue_amuletmagnifier", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_over_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_open_2", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
      else 
        
        func_end();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_amulet_statue", 0, "", 0 );
    
    ObjAnimate( "spr_statue_amuletscales", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_statue", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletcuffs()

  local item = "inv_amuletcuffs";

  if ( common.ApplyObj( item, "obj_statue_use_amuletcuffs", true ) ) then

    cmn.CallEventHandler( "use_amuletcuffs_inv" );
    cmn.CallEventHandler( "use_amuletcuffs_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_amuletcuffs" );
        cmn.CallEventHandler( "use_amuletcuffs_end" );
        
      end;
    
      if ( cmn.IsEventDone("use_amuletmagnifier") and cmn.IsEventDone("use_amuletscales")) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_amulet_statue", 0, "", 0 );
        
        ObjAnimate( "spr_statue_amuletscales", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_amuletcuffs", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
  
        ObjAnimate( "spr_statue_amuletmagnifier", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_over_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_open_2", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
      else 
        
        func_end();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_amulet_statue", 0, "", 0 );
    
    ObjAnimate( "spr_statue_amuletcuffs", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_statue", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_star2()

  local item = "inv_star2";

  if ( common.ApplyObj( item, "obj_statue_use_star2", true ) ) then

    cmn.CallEventHandler( "use_star2_inv" );
    cmn.CallEventHandler( "use_star2_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_star2" );
        cmn.CallEventHandler( "use_star2_end" );
        
      end;
    
      if ( cmn.IsEventDone("use_star1") ) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_amulet_statue", 0, "", 0 );
        
        ObjAnimate( "spr_statue_star_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_star_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
  
        ObjAnimate( "spr_statue_over_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_open_1", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
       
        
      else 
        
        func_end();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_star_statue", 0, "", 0 );
    
    ObjAnimate( "spr_statue_star_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_statue", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_star1()

  local item = "inv_star1";

  if ( common.ApplyObj( item, "obj_statue_use_star1", true ) ) then

    cmn.CallEventHandler( "use_star1_inv" );
    cmn.CallEventHandler( "use_star1_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_star1" );
        cmn.CallEventHandler( "use_star1_end" );
        
      end;
    
      if ( cmn.IsEventDone("use_star2") ) then
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_amulet_statue", 0, "", 0 );
        
        ObjAnimate( "spr_statue_star_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_star_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
  
        ObjAnimate( "spr_statue_over_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        
        ObjAnimate( "spr_statue_open_1", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        
        
      else 
        
        func_end();
        
      end;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_star_statue", 0, "", 0 );
    
    ObjAnimate( "spr_statue_star_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_statue", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_valve()

  local item = "inv_valve";

  if ( common.ApplyObj( item, "obj_hatch_3_use_valve", true ) ) then

    cmn.CallEventHandler( "use_valve_inv" );
    cmn.CallEventHandler( "use_valve_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_valve" );
        cmn.CallEventHandler( "use_valve_end" );
        common.CloseSubRoom();
        
      end;
      
      ObjAnimate( "spr_hatch_3_screw", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_hatch_3_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "spr_hatch_3_open_over", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_valve_hatch_3", 0, "", 0 );
    
    ObjAnimate( "vid_hatch_3_valve", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    VidPlay( "vid_hatch_3_valve", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_storageexit_hatch_3", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hatch_3", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_avengermark1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_avengermark1" );
  cmn.CallEventHandler( "get_avengermark1" );

end;
--------------------------------------------------------------------------------------------
function private.get_scraper()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_scraper" );
  cmn.CallEventHandler( "get_scraper" );

end;
--------------------------------------------------------------------------------------------
function private.get_amuletscales()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_amuletscales" );
  cmn.CallEventHandler( "get_amuletscales" );

end;
--------------------------------------------------------------------------------------------
function private.get_amuletcuffs()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_amuletcuffs" );
  cmn.CallEventHandler( "get_amuletcuffs" );

end;
--------------------------------------------------------------------------------------------
function private.get_star2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_star2" );
  cmn.CallEventHandler( "get_star2" );

end;
--------------------------------------------------------------------------------------------
function private.get_cartridge()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cartridge" );
  cmn.CallEventHandler( "get_cartridge" );

end;
--------------------------------------------------------------------------------------------
function private.get_ax()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ax" );
  cmn.CallEventHandler( "get_ax" );
  
  if ( cmn.IsEventDone("get_shocker") ) then  
       
    common.CloseSubRoom();
       
  end;   

end;
--------------------------------------------------------------------------------------------
function private.get_shocker()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_shocker" );
  cmn.CallEventHandler( "get_shocker" );
  
  if ( cmn.IsEventDone("get_ax") ) then  
     
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_protectivemask()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_protectivemask" );
  cmn.CallEventHandler( "get_protectivemask" );

end;
--------------------------------------------------------------------------------------------
function private.get_chestkey_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chestkey_3" );
  cmn.CallEventHandler( "get_chestkey_3" );
  if ( cmn.IsEventDone("get_agentbadge") and common_impl.IsGetCollect( "get_collect_2_3_7" ) ) then  
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_agentbadge()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_agentbadge" );
  cmn.CallEventHandler( "get_agentbadge" );
  if ( cmn.IsEventDone("get_chestkey_3") and common_impl.IsGetCollect( "get_collect_2_3_7" )) then  
    common.CloseSubRoom();
  end;

end;
---------------------------------------------------------------------------------------------
function private.get_collect_2_3_7()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_7");
    cmn.CallEventHandler("get_collect_2_3_7");
    
    if cmn.IsEventDone( "get_agentbadge") and cmn.IsEventDone( "get_chestkey_3")  then
      
      common.CloseSubRoom();
    
    end;  

  end;

  common_impl.PlayEffectHO( "spr_statue_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_armorybox_door()
  
  local func_after = function ()
  
  common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_armorybox_use_button' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_big_door_armorybox", 0, "", 0 );
   ObjAnimate( "spr_armorybox_door_close", "pos_x", 0, 0, func_after,
   { 
     0.0, 0, 4, 
     0.3, 0, 2,
     0.6, 0, 4
   } );

  
end; 
-----------------------------------------------------------------------------------------------------
function private.clk_smalldoor() 
  
  local func_after = function ()
  
  common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_armorybox_use_roundhandle' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_small_door_armorybox", 0, "", 0 );
  ObjAnimate( "spr_armorybox_small_door", "scale_x", 0, 0, func_after,
   { 
     0.0, 0, 1, 
     0.3, 0, 1.02,
     0.6, 0, 1
   } );
  
end;  
------------------------------------------------------------------------------------------------------
function private.clk_armorybox_cap()
  
  local func_after = function ()
  
  common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_armorybox_use_agemtsymbol' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_right_door_armorybox", 0, "", 0 );
   ObjAnimate( "spr_armorybox_door_2", "pos_x", 0, 0, func_after,
   { 
     0.0, 0, 53, 
     0.3, 0, 55,
     0.6, 0, 53
   } );
   ObjAnimate( "spr_armorybox_note", "pos_x", 0, 0, "",
   { 
     0.0, 0, 56, 
     0.3, 0, 58,
     0.6, 0, 56
   } );

  
end;  
--------------------------------------------------------------------------------------------
function private.clk_carpet()

  cmn.CallEventHandler( "clk_carpet_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_carpet" );
    cmn.CallEventHandler( "clk_carpet_end" );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_carpet_floor", 0, "", 0 );
  
  ObjAnimate( "spr_floor_carpet_1", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_floor_carpet_2", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
 
end;
--------------------------------------------------------------------------------------------
function private.clk_button_armorybox()

  cmn.CallEventHandler( "clk_button_armorybox_beg" );
  
  local func_after = function () 
  
    local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_button_armorybox" );
      cmn.CallEventHandler( "clk_button_armorybox_end" );
      
    end;   
    
     ObjAnimate( "obj_armorybox_close", "alp", 0, 0, func_end,
     { 
         0.0, 0, 1.0, 
         0.3, 0, 0.0
        
     } );
       
     ObjAnimate( "obj_armorybox_open", "alp", 0, 0, "",
     { 
         0.0, 0, 0.0, 
         0.3, 0, 1.0
         
     } );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_button_armorybox", 0, "", 0 );
  
  ObjAnimate( "spr_armorybox_button_push", "alp", 0, 0, func_after, { 0,0,0, 0.3,0, 1 } );
 
end;
--------------------------------------------------------------------------------------------
function private.clk_roundhandle() 
  
  cmn.CallEventHandler( "clk_roundhandle_beg" );
  
  local func_after = function () 
  
    local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_roundhandle" );
      cmn.CallEventHandler( "clk_roundhandle_end" );
      
    end;   
   
     
    ObjSet( "spr_armorybox_cartridge", { active = true });
    
    ObjAnimate( "spr_armorybox_pen", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.2, 0, 0.0
    } );
      
    ObjAnimate( "spr_armorybox_smallopen", "alp", 0, 0, func_end,
    { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
    } );
    ObjAnimate( "spr_armorybox_cartridge", "alp", 0, 0, "",
    { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
        
    } );
    ObjAnimate( "spr_armorybox_small_door", "alp", 0, 0, "",
    { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
        
    } );
      
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_roundhandle_armorybox", 0, "", 0 );
  
  ObjAnimate( "spr_armorybox_pen", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0, 0.6, 0, 1 } );
  ObjAnimate( "spr_armorybox_pen_2", "alp", 0, 0, "", { 0,0,0, 0.3,0,1, 0.6, 0, 0 } );
  
  
end;  
--------------------------------------------------------------------------------------------
function private.clk_chestkey_3()
  
  cmn.CallEventHandler( "clk_chestkey_3_beg" );
  
  local func_after = function () 
  
    local func_end = function () 
    
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_chestkey_3" );
      cmn.CallEventHandler( "clk_chestkey_3_end" );
      common.CloseSubRoom();
      
    end;
    
    ObjAnimate( "spr_chest_3_key_2", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_chest_3_open", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
    
  end;
    
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_chestkey_chest_3", 0, "", 0 );
  
  ObjAnimate( "spr_chest_3_key_1", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_chest_3_key_2", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_storageexit()

  if not ( cmn.IsEventDone( "opn_storageexit" ) ) then
    
    cmn.SetEventDone( "opn_storageexit" );
    cmn.SetEventDone( "beg_level3" );
    cmn.CallEventHandler( "beg_level3" );
    
  end;
  
  cmn.CallEventHandler( "opn_storageexit" ); 

end;
--*********************************************************************************************************************
function private.vid_storageexit_capitulation()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_storageexit_capitulation" );
    cmn.CallEventHandler( "vid_storageexit_capitulation_end" );
    common_impl.ShowBbt( 'bbt_vid_storageexit_capitulation', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level3/aud_storageexit_capitulation", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_storageexit_capitulation_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_storageexit_capitulation", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_storageexit_capitulation_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_storageexit_capitulation", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_storageexit_capitulation", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.dlg_storageexit_double()

  ObjAttach( "dlg_storageexit_double", private.room_objname );
  ObjSet("anm_storageexit_double_loc", { alp = 0 });
  cmn.CallEventHandler( "dlg_storageexit_double_beg" );
  
  common_impl.dialog_character_loc = "anm_storageexit_double_loc";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "double", 5, nil, nil, true, "dlg_storageexit_double_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_storageexit_double_end()

  if not cmn.IsEventDone( "dlg_storageexit_double" ) then

    cmn.SetEventDone( "dlg_storageexit_double" );
    ObjSet( "spr_storageexit_double_hairpin", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    cmn.CallEventHandler( "dlg_storageexit_double_inv" );
    cmn.CallEventHandler( "dlg_storageexit_double_end" );
    common_impl.ShowBbt( "bbt_dlg_storageexit_double", 1 );
    
    ObjMultiSet( { { "obj_int_dialog_character", { visible = true } },
                   { "obj_storageexit_double_mmg", { input = false, alp = 0 } },
                   { "obj_int_dialog_character_input", { event_mdown = int_dialog_character.ContinueClick } } } );
                   
    ObjAttach( "obj_storageexit_double_mmg", "dlg_storageexit_double" );
    
    common_impl.AddPageDiary( 10 );
    
    common_impl.StopAudio( "sfx", "common/audio/level3/aud_cloud_memories_show", 0 ); 
    common_impl.StopAudio( "sfx", "common/audio/level3/aud_cloud_memories_hide", 0 ); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "double" then
    
    if txt_count == 1 then
 
      common_impl.dialog_character_loc = "anm_storageexit_double_loc_2";
    
    elseif txt_count == 2 then
      
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_cloud_memories_show", 0, "", 0 ); 
 
      ObjAnimate( "anm_storageexit_double_flashback_1", "alp", 0, 0, "", { 0,0,0, 1.5,0,0, 2,0,1 } );
      ObjAnimate( "anm_storageexit_double_flashback_1_start", "alp", 0, 0, "", { 0,0,1, 1.5,0,1, 2,0,0 } );
      
      ObjSet( "anm_storageexit_double_flashback_1_start", { alp = 1, playing = true } );
                     
    elseif txt_count == 3 then
      
      local func_after_finish = function()
      
        ObjAnimate( "anm_storageexit_double_flashback_2", "alp", 0, 0, "", { 0,0,0, 1.5,0,0, 2,0,1 } );
        ObjAnimate( "anm_storageexit_double_flashback_2_start", "alp", 0, 0, "", { 0,0,1, 1.5,0,1, 2,0,0 } );
        
        ObjSet( "anm_storageexit_double_flashback_2_start", { alp = 1, playing = true } );
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_cloud_memories_show", 0, "", 0 ); 
      
      end;
      
      common_impl.StopAudio( "sfx", "common/audio/level3/aud_cloud_memories_show", 0, "", 0 ); 
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_cloud_memories_hide", 0, "", 0 ); 
      
      ObjStopAnimate( "anm_storageexit_double_flashback_1", "alp" );
   
      ObjSet( "anm_storageexit_double_flashback_1", { alp = 0 } );
      ObjSet( "anm_storageexit_double_flashback_1_start", { alp = 0, playing = false } );
      ObjSet( "anm_storageexit_double_flashback_1_finish", { alp = 1, playing = true, endtrig = func_after_finish } );
    
     elseif txt_count == 4 then
  
      
      common_impl.StopAudio( "sfx", "common/audio/level3/aud_cloud_memories_hide", 0, "", 0 ); 
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_cloud_memories_hide", 0, "", 0 );
   
      ObjStopAnimate( "anm_storageexit_double_flashback_2", "alp" );
     
      ObjSet( "anm_storageexit_double_flashback_2", { alp = 0 } );
      ObjSet( "anm_storageexit_double_flashback_2_start", { alp = 0, playing = false } );
      ObjSet( "anm_storageexit_double_flashback_1_finish", { alp = 0, playing = false } );
      
      ObjSet( "anm_storageexit_double_flashback_2_finish", { alp = 1, playing = true } );
  
      ObjMultiSet( { { "anm_storageexit_double", { alp = 0 } },
                     { "obj_storageexit_double_2", { alp = 1 } },
                     { "obj_storageexit_double_2_hand", { alp = 1 } },
                     { "anm_storageexit_double_hand_1", { alp = 0 } },
                     { "obj_int_dialog_character_input", { event_mdown = function() private.dlg_double_start_mmg() end } } } );
                       
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
                     
      
    end;
    
  end;        
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_double_start_mmg()

  common_impl.DialogCharacterMmgShow( "double", 0, 0, nil  );
  
  ObjMultiSet( { { "anm_storageexit_double", { alp = 1 } },
                 { "obj_storageexit_double_2", { alp = 0 } },
                 { "obj_storageexit_double_2_hand", { alp = 0 } },
                 { "anm_storageexit_double_hand_1", { alp = 1 } },
             } );
   for i = 1, 4  do
     
     VidStop("vid_storageexit_double_"..i);
     
   end
   

end;  
--------------------------------------------------------------------------------------------
function private.dlg_double_click_handle()
  
   common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_handcuffs_andy", 0, "", 0 );
  
   ObjMultiSet( { { "obj_storageexit_double_2_hand", { alp = 0 } },
                  { "anm_storageexit_double_hand_3", { alp = 1 } },
                  { "anm_storageexit_double_hand_2", { alp = 0 } },
                  { "obj_int_dialog_character", { visible = false } },
                  { "anm_storageexit_double", { alp = 0 } },
                  { "anm_storageexit_double_hand_1", { alp = 0 } },
                  { "obj_storageexit_double_2", { alp = 1 } },
                  { "obj_int_dialog_character_input", { event_mdown = function() int_dialog_character.ContinueClick( false ) end, input = true } } } );
                  
end;
--*********************************************************************************************************************
function private.ClkHandcuffs( number )

  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "spr_storageexit_double_mmg_handcuffs_"..number, { input = false }  );

    if ObjGet( "spr_storageexit_double_mmg_handcuffs_"..( 3 - number ) ).input == false then

      ObjSet( "obj_storageexit_double_mmg_handcuffs", { drag = true, event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                     event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end  } );

      ObjSet( "obj_storageexit_double_mmg_use_handcuffs", { input = true } );
  
    end;

  end;

  local ang = { -1.65, 2.28 };
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_int_double_handcuffs_open", 0, "", 0 );

  ObjAnimate( "spr_storageexit_double_mmg_handcuffs_"..number, "ang", 0, 0, func_after, { 0,0,0, 0.3,0,ang[number] } );

end;
--*********************************************************************************************************************
function private.StartDragHandcuffs()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );
  
  ObjSet( "obj_storageexit_double_mmg_handcuffs", { scale_x = 0.5, scale_y = 0.5 } );

  --ObjAnimate( "obj_storageexit_double_mmg_handcuffs", "scale_xy", 0, 0, "", { 0,0,1,1, 0.2,0,0.5,0.5 } );

end;
--*********************************************************************************************************************
function private.DropHandcuffs()

  if ObjIntersect( "obj_storageexit_double_mmg_handcuffs", "obj_storageexit_double_mmg_use_handcuffs" ) then

    ObjSet( "obj_storageexit_double_mmg_handcuffs", { alp = 0 } );

    private.dlg_double_click_handle();
    
  else
    
    ObjSet( "obj_storageexit_double_mmg_handcuffs", { scale_x = 1, scale_y = 1 } );
 
  end;  

end;
--*********************************************************************************************************************
ObjAnimate("spr_storageexit_lamp", "ang",1,0,"",
{
  0.0, 0, -0.06, 
  1.2, 0, 0.06,
  2.4, 0, -0.06
});
ObjAnimate("spr_storageexit_lamp_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_armorybox_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
