-- name=rm_street
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_street";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_door_3", "room_hub" );
  ObjAttach( "zz_motorscooter", "room_hub" );
  ObjAttach( "zz_cashregister", "room_hub" );
  ObjAttach( "zz_flowerbed", "room_hub" );
  ObjAttach( "zz_vendingmachine", "room_hub" );
  private.Init_Subroom();
  
  local table_multiset = {};
  
  for i = 1, 4 do

    table.insert( table_multiset, {"obj_vendingmachine_button_"..i.."_clk", 
      {
        event_mdown  = function() private.vendingmachine_clk_button( i ) end,
        event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
      } 
    } );

  end;
  ObjMultiSet( table_multiset );   
  
  ObjMultiSet({ 
  { "obj_street_dlg_breeding",       { event_mdown = private.dlg_street_breeding }},
  { "spr_flowerbed_mmg_round_drag",           { event_drag =      function() private.Circle_drag("spr_flowerbed_mmg_round"); end,
                                               event_startdrag = function() private.Circle_startdrag("spr_flowerbed_mmg_round","spr_flowerbed_mmg_round_drag"); end, 
                                               event_dragdrop =  function() private.Circle_dragdrop("spr_flowerbed_mmg_round","spr_flowerbed_mmg_round_drag"); end }},
  { "spr_door_3_broom", { event_mdown = private.get_broom }},
  { "spr_door_3_tapepiece", { event_mdown = private.get_tapepiece }},
  { "spr_motorscooter_figurnepart1", { event_mdown = private.get_figurnepart1 }},
  { "spr_motorscooter_battery", { event_mdown = private.get_battery_3 }},
  { "spr_motorscooter_box3", { event_mdown = private.get_box3 }},
  { "spr_cashregister_mechanismpart", { event_mdown = private.get_mechanismpart_3 }},
  { "spr_cashregister_branch", { event_mdown = private.get_branch }},
  { "spr_cashregister_ticket", { event_mdown = private.get_ticket }},
  { "spr_flowerbed_button", { event_mdown = private.get_button_3 }},
  { "spr_flowerbed_roundhandle", { event_mdown = private.get_roundhandle }},
  { "spr_flowerbed_star1", { event_mdown = private.get_star1 }},
  { "spr_flowerbed_boxkey", { event_mdown = private.get_boxkey }},
  { "spr_vendingmachine_magnet", { event_mdown = private.get_magnet }},
  { "spr_vendingmachine_nuts", { event_mdown = private.get_nuts }},
  { "obj_flowerbed_use_loadedgun", { event_mdown = private.clk_box }},
  { "obj_flowerbed_clk_mmg",          { event_mdown = private.open_mmg           }},
  { "obj_flowerbed_clk_mmg_close",    { event_mdown = private.close_mmg          }},
  { "spr_flowerbed_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_flowerbed_note" ); common_impl.ShowBbt( 'bbt_spr_flowerbed_note')  end }},    
  { "spr_flowerbed_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_flowerbed_note" ); common_impl.ShowBbt( 'bbt_spr_flowerbed_note') end } }, 
  { "spr_door_3_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_door_3_note" ); common_impl.ShowBbt( 'bbt_spr_door_3_note'); ObjSet("obj_door_3_hint", { pos_x = -61, pos_y = -194}); end }},    
  { "spr_door_3_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_door_3_note" ); common_impl.ShowBbt( 'bbt_spr_door_3_note'); ObjSet("obj_door_3_hint", { pos_x = 87, pos_y = -82}); end } },   
  { "obj_vendingmachine_use_scraper", { event_mdown = private.clk_magnet }},
  { "spr_street_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_door_3_use_boxkey",          { event_mdown = private.clk_door_3          }},
  { "obj_door_3_use_mechanismpart",          { event_mdown = private.clk_door_3          }},
  { "obj_motorscooter_use_ovalbutton",          { event_mdown = private.clk_xx_ovalbutton          }},
  { "obj_motorscooter_clk_ovalbutton",          { event_mdown = private.clk_ovalbutton          }},
  { "obj_flowerbed_use_agentbadge",          { event_mdown = private.clk_agentbadge          }},
  { "spr_street_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_flowerbed_collect_2", { event_mdown = function () private.get_collect_2_3_8(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }}, 
  { "spr_cashregister_collect_2", { event_mdown = function () private.get_collect_2_3_6(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                            
  });

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_street = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_street_doorroom",
    "gzz_street_door_3",
    "gzz_street_motorscooter",
    "gzz_street_cashregister",
    "gzz_street_flowerbed",
    "gzz_street_vendingmachine"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_door_3",
    "zz_motorscooter",
    "zz_cashregister",
    "zz_flowerbed",
    "zz_vendingmachine"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_street", update_game_mode_street, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_street = function ()

  local effects_table = 
  {
    "obj_street_anim",
    "anm_door_3_fog",    
    "spr_door_3_light_add",
    "anm_flowerbed_fog",
    "spr_motorscooter_light",  
    "anm_motorscooter_fog"  
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_street", update_performance_mode_street, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_street () end;
  --------------------------------------------------------------------------------------------
  local opn_street_map = function ()

    common_impl.VisitMapRoom( "street" );

  end;
  cmn.AddSubscriber( "opn_street", opn_street_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_broom" ] = {
    type = "get",
    get_obj = "spr_door_3_broom",
    room = private.room_objname,
    zz = "zz_door_3",
    zz_gate = "gzz_street_door_3"
  };
    
  local get_broom_inv = function ()
  
    interface.InventoryItemAdd( "inv_broom", "spr_door_3_broom" );
  
  end;
  
  local get_broom_closezz = function ()
  
    ObjDelete( "gfx_door_3_broom" );
    ObjDelete( "spr_door_3_broom_shadow");
    ObjDelete( "spr_street_door_3_broom");
    --ObjDelete( "gzz_street_door_3" );
  
  end;
  
  cmn.AddSubscriber( "get_broom", get_broom_inv );
  cmn.AddSubscriber( "get_broom", get_broom_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tapepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tapepiece" ] = {
    type = "get",
    get_obj = "obj_door_3_hint",
    room = private.room_objname,
    zz = "zz_door_3",
    zz_gate = "gzz_street_door_3"
  };
    
  local get_tapepiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_tapepiece", "spr_door_3_tapepiece" );
    ObjSet("spr_branch_plus_light", { alp = 1 });
    
  end;
  
  local get_tapepiece_closezz = function ()
  
    ObjDelete( "gfx_door_3_tapepiece" );
    
    --ObjAttach( "spr_door_3_note", "obj_door_3_ground");
    ObjSet( "spr_door_3_note", { alp = 1, pos_x = 77, pos_y = 207, pos_z = 6, ang = -1.6, res="assets/levels/level3/rm_street/zz_door_3/anims/note_3"});
    ObjSet( "spr_door_3_note_big", { pos_z = 7 } );
    ObjDelete("anm_door_3_note");
    ObjSet("spr_street_door_3_note_2", { alp = 1 });
    ObjDelete( "spr_street_door_3_note");
    --ObjDelete( "gzz_street_door_3" );
  
  end;
  
  cmn.AddSubscriber( "get_tapepiece", get_tapepiece_inv );
  cmn.AddSubscriber( "get_tapepiece_inv", get_tapepiece_inv );
  cmn.AddSubscriber( "get_tapepiece_closezz", get_tapepiece_closezz);
  cmn.AddSubscriber( "get_tapepiece", get_tapepiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurnepart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurnepart1" ] = {
    type = "get",
    get_obj = "spr_motorscooter_figurnepart1",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
    
  local get_figurnepart1_inv = function ()
  
  interface.InventoryItemAdd( "inv_figurinepart1", "spr_motorscooter_figurnepart1" );
  
  end;
  
  local get_figurnepart1_closezz = function ()
  
    ObjDelete( "gfx_motorscooter_figurnepart1" );
    ObjDelete( "spr_motorscooter_figurnepart1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_figurnepart1", get_figurnepart1_inv );
  cmn.AddSubscriber( "get_figurnepart1", get_figurnepart1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery_3" ] = {
    type = "get",
    get_obj = "spr_motorscooter_battery",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
    
  local get_battery_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery_3", "spr_motorscooter_battery" );
    ObjSet( "spr_brokenwelder_plus_light", { alp = 1 });
    
  end;
  
  local get_battery_3_closezz = function ()
  
    ObjDelete( "gfx_motorscooter_battery" );
    ObjDelete( "spr_motorscooter_battery_shadow" );
    ObjDelete( "spr_motorscooter_battery_over" );
    
    if( cmn.IsEventDone( "get_box3" ) )then
      
      ObjDelete( "gzz_street_motorscooter" );
      
    end;
    
  end;
  
  cmn.AddSubscriber( "get_battery_3", get_battery_3_inv );
  cmn.AddSubscriber( "get_battery_3", get_battery_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_box3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box3" ] = {
    type = "get",
    get_obj = "spr_motorscooter_box3",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
    
  local get_box3_inv = function ()
 
    ng_global.progress[ "std" ][ "get_box1" ].count[3] = true;
    local count = 0;
    for i = 1,4 do
      if ng_global.progress[ "std" ][ "get_box1" ].count[i] then
        count = count + 1;
      end;
    end;
    interface.InventoryItemRemove( "inv_box_3" );
    local func_end = function()
    
      ObjSet( "spr_box_3_3", { alp = 1 });
      ObjSet( "txt_box_3_number", {text = tostring(count).."/4"});
    
    end;
    interface.InventoryItemAdd( "inv_box_3", "spr_motorscooter_box3", func_end, nil, "assets/levels/level3/rm_street/zz_motorscooter/inv/inv_box_3" );
    ObjSet( "spr_box_3_3", { alp = 1 });
  
  end;
  
  local get_box3_closezz = function ()
  
    ObjDelete( "gfx_motorscooter_box3" );
    ObjDelete( "spr_motorscooter_box3_shadow" );
    ObjDelete( "spr_street_motorscooter_box");
    
    if( cmn.IsEventDone( "get_battery_3" ) )then
      
      ObjDelete( "gzz_street_motorscooter" );
      
    end;

  end;
  
  cmn.AddSubscriber( "get_box3", get_box3_inv );
  cmn.AddSubscriber( "get_box3", get_box3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mechanismpart_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mechanismpart_3" ] = {
    type = "get",
    get_obj = "spr_cashregister_mechanismpart",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
    
  local get_mechanismpart_3_inv = function ()
  
  interface.InventoryItemAdd( "inv_mechanismpart_3", "spr_cashregister_mechanismpart" );
  
  end;
  
  local get_mechanismpart_3_closezz = function ()
  
    ObjDelete( "gfx_cashregister_mechanismpart" );
    ObjSet( "obj_cashregister_use_duster", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_mechanismpart_3", get_mechanismpart_3_inv );
  cmn.AddSubscriber( "get_mechanismpart_3", get_mechanismpart_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_branch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_branch" ] = {
    type = "get",
    get_obj = "spr_cashregister_branch",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
    
  local get_branch_inv = function ()
  
    interface.InventoryItemAdd( "inv_branch", "spr_cashregister_branch" );
    ObjSet( "inv_branch", { drag = false });
    
  end;
  
  local get_branch_closezz = function ()
  
    ObjDelete( "gfx_cashregister_branch" );
    ObjDelete( "spr_cashregister_branch_shadow" );
    ObjDelete( "spr_street_cashregister_rod");
  
  end;
  
  cmn.AddSubscriber( "get_branch", get_branch_inv );
  cmn.AddSubscriber( "get_branch", get_branch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ticket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ticket" ] = {
    type = "get",
    get_obj = "spr_cashregister_ticket",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
    
  local get_ticket_inv = function ()
  
    interface.InventoryItemAdd( "inv_ticket", "spr_cashregister_ticket" );
  
  end;
  
  local get_ticket_closezz = function ()
  
    ObjDelete( "gfx_cashregister_ticket" );
    
    if common_impl.IsGetCollect( "get_collect_2_3_6" ) then
      
      ObjDelete( "gzz_street_cashregister" );
      
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_ticket", get_ticket_inv );
  cmn.AddSubscriber( "get_ticket", get_ticket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_3" ] = {
    type = "get",
    get_obj = "spr_flowerbed_button",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
    
  local get_button_3_inv = function ()
  
  interface.InventoryItemAdd( "inv_button_3", "spr_flowerbed_button" );
  
  end;
  
  local get_button_3_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_button" );
    ObjDelete( "spr_street_flowerbed_button");
    --ObjDelete( "gzz_street_flowerbed" );
  
  end;
  
  cmn.AddSubscriber( "get_button_3", get_button_3_inv );
  cmn.AddSubscriber( "get_button_3", get_button_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_roundhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_roundhandle" ] = {
    type = "get",
    get_obj = "spr_flowerbed_roundhandle",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
    
  local get_roundhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_roundhandle", "spr_flowerbed_roundhandle" );
  
  end;
  
  local get_roundhandle_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_roundhandle" );
    --ObjDelete( "gzz_street_flowerbed" );
  
  end;
  
  cmn.AddSubscriber( "get_roundhandle", get_roundhandle_inv );
  cmn.AddSubscriber( "get_roundhandle", get_roundhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_star1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_star1" ] = {
    type = "get",
    get_obj = "spr_flowerbed_star1",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
    
  local get_star1_inv = function ()
  
    interface.InventoryItemAdd( "inv_star1", "spr_flowerbed_star1" );
  
  end;
  
  local get_star1_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_star1" );
    --ObjDelete( "gzz_street_flowerbed" );
  
  end;
  
  cmn.AddSubscriber( "get_star1", get_star1_inv );
  cmn.AddSubscriber( "get_star1", get_star1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boxkey" ] = {
    type = "get",
    get_obj = "spr_flowerbed_boxkey",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
    
  local get_boxkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxkey", "spr_flowerbed_boxkey" );
  
  end;
  
  local get_boxkey_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_boxkey" );
    ObjDelete( "spr_flowerbed_boxkey_shadow" );
    ObjDelete( "spr_street_flowerbed_key");
  
  end;
  
  cmn.AddSubscriber( "get_boxkey", get_boxkey_inv );
  cmn.AddSubscriber( "get_boxkey", get_boxkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet" ] = {
    type = "get",
    get_obj = "spr_vendingmachine_magnet",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_street_vendingmachine"
  };
    
  local get_magnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet_3", "spr_vendingmachine_magnet" );
    ObjSet("spr_branch_plus_light", { alp = 1 });
  
  end;
  
  local get_magnet_closezz = function ()
  
    ObjDelete( "gfx_vendingmachine_magnet" );
    
    --ObjDelete( "gzz_street_vendingmachine" );
  
  end;
  
  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nuts () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nuts" ] = {
    type = "get",
    get_obj = "spr_vendingmachine_nuts",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_street_vendingmachine"
  };
    
  local get_nuts_inv = function ()
  
    interface.InventoryItemAdd( "inv_nuts", "spr_vendingmachine_nuts" );
  
  end;
  
  local get_nuts_closezz = function ()
  
    ObjDelete( "gfx_vendingmachine_nuts" );
    ObjDelete( "spr_vendingmachine_nuts_shadow");
    ObjDelete( "gzz_street_vendingmachine" );
    ObjDelete( "spr_street_vendingmachine_nuts");
  
  end;
  
  cmn.AddSubscriber( "get_nuts", get_nuts_inv );
  cmn.AddSubscriber( "get_nuts", get_nuts_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_2 = function ()
  
    ObjDelete( "obj_street_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_2", get_collect_morph_item_3_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_1 = function ()
  
    ObjDelete( "obj_street_collect" );
    
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_1", get_collect_item_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_6 = function ()
  
    ObjDelete( "spr_cashregister_collect_2" );
    
    if cmn.IsEventDone( "get_ticket") then
    
      ObjDelete("gzz_street_cashregister")
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_3_6", get_collect_2_3_6 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_8 = function ()
  
    ObjDelete( "spr_flowerbed_collect_2" );
    
  end;
  cmn.AddSubscriber( "get_collect_2_3_8", get_collect_2_3_8 , private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boxkey" ] = {
    type = "use",
    inv_obj = "inv_boxkey",
    use_place = "obj_door_3_use_boxkey",
    room = private.room_objname,
    zz = "zz_door_3",
    zz_gate = "gzz_street_door_3"
  };
  local use_boxkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxkey" );
  
  end;
  local use_boxkey_beg = function ()
  
    ObjDelete( "obj_door_3_use_boxkey" );
  
  end;
  local use_boxkey_end = function ()
  
      ObjDelete( "obj_door_3_bolts" );
      ObjDelete( "spr_door_3_cover");
      ObjDelete( "spr_street_door_3_cover");
      ObjSet( "obj_door_3_use_mechanismpart", { input = true});
      ObjSet( "spr_door_3_tapepiece", { input = true, active = true, alp = 1});
      ObjSet( "spr_door_3_note", { alp = 1, input = true});
      ObjSet( "spr_street_door_3_note", { alp = 1 });
      ObjSet( "spr_street_door_3_cover_2", { alp = 1 });
      ObjSet( "spr_door_3_cover_ground", { alp = 1 });
      ObjSet( "vid_door_3_boxkey", {alp=1, frame = 212});
    
  --ObjSet( "spr_door_3_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxkey", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_inv );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_end, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_inv", use_boxkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_beg", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_end", use_boxkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanismpart_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mechanismpart_3" ] = {
    type = "use",
    inv_obj = "inv_mechanismpart_3",
    use_place = "obj_door_3_use_mechanismpart",
    room = private.room_objname,
    zz = "zz_door_3",
    zz_gate = "gzz_street_door_3"
  };
  local use_mechanismpart_3_inv = function ()
  
  interface.InventoryItemRemove( "inv_mechanismpart_3" );
  
  end;
  local use_mechanismpart_3_beg = function ()
  
    ObjDelete( "obj_door_3_use_mechanismpart" );
  
  end;
  local use_mechanismpart_3_end = function ()
  
     ObjSet("gmg_street_doorroom", { input = true, active = true, alp = 1});
     ObjSet( "gzz_street_door_3", { input = false, active = false, alp = 0 }); 
     ObjDelete( "spr_door_3_slot" );
     ObjSet( "spr_door_3_part", { alp = 1 });
  
    --ObjSet( "spr_door_3_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanismpart_3", use_mechanismpart_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_3", use_mechanismpart_3_inv );
  cmn.AddSubscriber( "use_mechanismpart_3", use_mechanismpart_3_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_3_inv", use_mechanismpart_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_3_beg", use_mechanismpart_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_3_end", use_mechanismpart_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ovalbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ovalbutton" ] = {
    type = "use",
    inv_obj = "inv_ovalbutton",
    use_place = "obj_motorscooter_use_ovalbutton",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
  local use_ovalbutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_ovalbutton" );
  
  end;
  local use_ovalbutton_beg = function ()
  
    ObjDelete( "obj_motorscooter_use_ovalbutton" );
  
  end;
  local use_ovalbutton_end = function ()
  
  ObjSet( "obj_motorscooter_clk_ovalbutton", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ovalbutton", use_ovalbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_ovalbutton", use_ovalbutton_inv );
  cmn.AddSubscriber( "use_ovalbutton", use_ovalbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_ovalbutton_inv", use_ovalbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_ovalbutton_beg", use_ovalbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_ovalbutton_end", use_ovalbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fastingelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fastingelement" ] = {
    type = "use",
    inv_obj = "inv_fastingelement",
    use_place = "obj_motorscooter_use_fastingelement",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
  local use_fastingelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_fastingelement" );
  
  end;
  local use_fastingelement_beg = function ()
  
    ObjDelete( "obj_motorscooter_use_fastingelement" );
  
  end;
  local use_fastingelement_end = function ()
  
    ObjSet( "spr_motorscooter_fastingelement_2", { alp = 1 } );
    ObjSet( "spr_motorscooter_box3", { pos_y = -5, input = true } );
    ObjSet( "gfx_motorscooter_box3", { active = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fastingelement", use_fastingelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_fastingelement", use_fastingelement_inv );
  cmn.AddSubscriber( "use_fastingelement", use_fastingelement_end, private.room_objname );
  cmn.AddSubscriber( "use_fastingelement_inv", use_fastingelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_fastingelement_beg", use_fastingelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_fastingelement_end", use_fastingelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnetbranch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnetbranch" ] = {
    type = "use",
    inv_obj = "inv_magnetbranch",
    use_place = "obj_cashregister_use_magnetbranch",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
  local use_magnetbranch_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnetbranch" );
  
  end;
  local use_magnetbranch_beg = function ()
  
    ObjDelete( "obj_cashregister_use_magnetbranch" );
  
  end;
  local use_magnetbranch_end = function ()
    
    ObjSet( "anm_cashregister_rag", { alp = 1 } );  
    ObjDelete( "anm_cashregister_magnet" ); 
    ObjSet( "spr_cashregister_mechanismpart", { input = true, active = true, alp = 1, pos_x = 115, pos_y = 63 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnetbranch", use_magnetbranch_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetbranch", use_magnetbranch_inv );
  cmn.AddSubscriber( "use_magnetbranch", use_magnetbranch_end, private.room_objname );
  cmn.AddSubscriber( "use_magnetbranch_inv", use_magnetbranch_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnetbranch_beg", use_magnetbranch_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetbranch_end", use_magnetbranch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_duster_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_duster_3" ] = {
    type = "use",
    inv_obj = "inv_duster_3",
    use_place = "obj_cashregister_use_duster",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
  local use_duster_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_duster_3" );
  
  end;
  local use_duster_3_beg = function ()
  
    ObjDelete( "obj_cashregister_use_duster" );
  
  end;
  local use_duster_3_end = function ()
  
    ObjDelete( "anm_cashregister_rag" );
    ObjSet( "spr_cashregister_grass", { alp = 1 } );
    ObjSet( "obj_cashregister_use_elf_3", { input = true } );
    ObjDelete( "spr_street_cashregister_glass" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_duster_3", use_duster_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_3", use_duster_3_inv );
  cmn.AddSubscriber( "use_duster_3", use_duster_3_end, private.room_objname );
  cmn.AddSubscriber( "use_duster_3_inv", use_duster_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_duster_3_beg", use_duster_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_3_end", use_duster_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_3_2" ] = {
    type = "use",
    inv_obj = "inv_elf_3_1",
    use_place = "obj_cashregister_use_elf_3",
    room = private.room_objname,
    zz = "zz_cashregister",
    zz_gate = "gzz_street_cashregister"
  };
  local use_elf_3_2_inv = function ()
  end;
  local use_elf_3_2_beg = function ()
  
    ObjDelete( "obj_cashregister_use_elf_3" );
  
  end;
  local use_elf_3_2_end = function ()
  
    ObjSet( "spr_cashregister_ticket", { input = true, active = true, alp = 1 } );
    ObjDelete( "vid_cashregister_elf" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_3_2", use_elf_3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_2", use_elf_3_2_inv );
  cmn.AddSubscriber( "use_elf_3_2", use_elf_3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_2_inv", use_elf_3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_2_beg", use_elf_3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_2_end", use_elf_3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_agentbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_agentbadge" ] = {
    type = "use",
    inv_obj = "inv_agentbadge",
    use_place = "obj_flowerbed_use_agentbadge",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
  local use_agentbadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_agentbadge" );
  
  end;
  local use_agentbadge_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_agentbadge" );
  
  end;
  local use_agentbadge_end = function ()
  
    ObjDelete( "spr_flowerbed_box_cover" );
    ObjSet( "spr_flowerbed_roundhandle", { active = true, input = true } );
    ObjSet( "spr_flowerbed_box_agentbadge", { alp = 1 } );
    ObjSet( "spr_flowerbed_box_cover_open", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_agentbadge", use_agentbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_agentbadge", use_agentbadge_inv );
  cmn.AddSubscriber( "use_agentbadge", use_agentbadge_end, private.room_objname );
  cmn.AddSubscriber( "use_agentbadge_inv", use_agentbadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_agentbadge_beg", use_agentbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_agentbadge_end", use_agentbadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_broom" ] = {
    type = "use",
    inv_obj = "inv_broom",
    use_place = "obj_flowerbed_use_broom",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
  local use_broom_inv = function ()
  
    interface.InventoryItemRemove( "inv_broom" );
  
  end;
  local use_broom_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_broom" );
  
  end;
  local use_broom_end = function ()
  
    ObjDelete( "anm_flowerbed_broom" ); 
    ObjSet( "obj_flowerbed_clk_mmg", { input = true } );
    ObjDelete("spr_street_flowerbed_ground");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broom", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom", use_broom_inv );
  cmn.AddSubscriber( "use_broom", use_broom_end, private.room_objname );
  cmn.AddSubscriber( "use_broom_inv", use_broom_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom_beg", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_end", use_broom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_3_1" ] = {
    type = "use",
    inv_obj = "inv_elf_3_1",
    use_place = "obj_flowerbed_use_elf_3",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
  local use_elf_3_1_inv = function ()
  end;
  local use_elf_3_1_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_elf_3" );
  
  end;
  local use_elf_3_1_end = function ()
 
    ObjDelete( "spr_flowerbed_soil_2" );
    ObjDelete( "vid_flowerbed_elf" )
    ObjSet( "obj_flowerbed_use_broom", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_3_1", use_elf_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_1", use_elf_3_1_inv );
  cmn.AddSubscriber( "use_elf_3_1", use_elf_3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_1_inv", use_elf_3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_1_beg", use_elf_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_1_end", use_elf_3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_loadedgun_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_loadedgun_3" ] = {
    type = "use",
    inv_obj = "inv_loadedgun_3",
    use_place = "obj_flowerbed_use_loadedgun",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
  local use_loadedgun_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_loadedgun_3" );
  
  end;
  local use_loadedgun_3_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_loadedgun" );
  
  end;
  local use_loadedgun_3_end = function ()
  
    ObjDelete( "spr_flowerbed_close" );  
    ObjSet( "spr_flowerbed_open", { input = true, alp = 1 } );
    ObjDelete("spr_street_flowerbed_lock");
    ObjSet( "spr_street_flowerbed_box_1", { alp = 1 });
    ObjDelete("vid_flowerbed_use_gun");
    ObjDelete("obj_flowerbed_castle");
    ObjSet( "spr_flowerbed_castle_down", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_loadedgun_3", use_loadedgun_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_3", use_loadedgun_3_inv );
  cmn.AddSubscriber( "use_loadedgun_3", use_loadedgun_3_end, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_3_inv", use_loadedgun_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_3_beg", use_loadedgun_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_3_end", use_loadedgun_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scraper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scraper" ] = {
    type = "use",
    inv_obj = "inv_scraper",
    use_place = "obj_vendingmachine_use_scraper",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_street_vendingmachine"
  };
  local use_scraper_inv = function ()
  
    interface.InventoryItemRemove( "inv_scraper" );
  
  end;
  local use_scraper_beg = function ()
  
    ObjDelete( "obj_vendingmachine_use_scraper" );
  
  end;
  local use_scraper_end = function ()
  
    --ObjSet( "spr_vendingmachine_key", { input = true, visible = true, active = true } );
    ObjDelete( "spr_street_vendingmachine_magnet");
    ObjDelete( "anm_vendingmachine_use_scraper");
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scraper", use_scraper_beg, private.room_objname );
  cmn.AddSubscriber( "use_scraper", use_scraper_inv );
  cmn.AddSubscriber( "use_scraper", use_scraper_end, private.room_objname );
  cmn.AddSubscriber( "use_scraper_inv", use_scraper_inv, private.room_objname );
  cmn.AddSubscriber( "use_scraper_beg", use_scraper_beg, private.room_objname );
  cmn.AddSubscriber( "use_scraper_end", use_scraper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_banknote () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_banknote" ] = {
    type = "use",
    inv_obj = "inv_banknote",
    use_place = "obj_vendingmachine_use_banknote",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_street_vendingmachine"
  };
  local use_banknote_inv = function ()
  
    interface.InventoryItemRemove( "inv_banknote" );
  
  end;
  local use_banknote_beg = function ()
  
    ObjDelete( "obj_vendingmachine_use_banknote" );
  
  end;
  local use_banknote_end = function ()
  
    ObjDelete( "obj_vendingmachine_money");
    ObjDelete( "anm_vendingmachine_use_money");
    ObjSet( "spr_vendingmachine_button_1", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_banknote", use_banknote_beg, private.room_objname );
  cmn.AddSubscriber( "use_banknote", use_banknote_inv );
  cmn.AddSubscriber( "use_banknote", use_banknote_end, private.room_objname );
  cmn.AddSubscriber( "use_banknote_inv", use_banknote_inv, private.room_objname );
  cmn.AddSubscriber( "use_banknote_beg", use_banknote_beg, private.room_objname );
  cmn.AddSubscriber( "use_banknote_end", use_banknote_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_ovalbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ovalbutton" ] = {
    type = "click",
    use_place = "obj_motorscooter_clk_ovalbutton",
    room = private.room_objname,
    zz = "zz_motorscooter",
    zz_gate = "gzz_street_motorscooter"
  };
  local clk_ovalbutton_beg = function ()
  
    ObjDelete( "obj_motorscooter_clk_ovalbutton" );
  
  end;
  local clk_ovalbutton_end = function ()

    ObjDelete( "spr_motorscooter_close" );
    ObjSet( "spr_motorscooter_open", { alp = 1 } );
    ObjSet( "obj_motorscooter_battery", { input = true, active = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ovalbutton", clk_ovalbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ovalbutton", clk_ovalbutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_ovalbutton_beg", clk_ovalbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_ovalbutton_end", clk_ovalbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_button_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_3" ] = {
  
    type = "click",
    use_place = "obj_vendingmachine_button_1_clk",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_street_vendingmachine"
    
  };
  local clk_button_3 = function ()

    --ObjDelete( "obj_smallroomdoor_clk_harpelement_old" );
    --ObjDelete( "obj_smallroomdoor_harpelement_old" );
    --ObjSet( "obj_smallroomdoor_use_harpelement", { input = true } );
    ObjSet( "spr_vendingmachine_nuts", { input = true, alp = 1, pos_x = 156, pos_y = 180});
    ObjSet( "spr_vendingmachine_nuts_shadow", {  alp = 1, pos_x = 154, pos_y = 182});
    ObjDelete( "obj_vendingmachine_clk" );
    
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_3", clk_button_3, private.room_objname );
  -------------------------------------------------------------------------------------------- 
  --------------------------------------------------------------------------------------------
  -- function win_flowerbed () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_flowerbed" ] = {
    type = "win",
    use_place = "obj_flowerbed_clk_mmg",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_street_flowerbed"
  };
  local win_flowerbed = function ()
  
    if ( cmn.IsEventDone( "win_flowerbed" ) ) then
      
      ObjDelete( "obj_flowerbed_mmg_big" );
      ObjDelete( "obj_flowerbed_clk_mmg" );
      ObjSet( "spr_flowerbed_box_open", { input = true, alp = 1 } );
      ObjSet( "spr_street_flowerbed_box_2", { alp = 1 });
      
    else

      private.InitFlowerbed();
      private.LoadFlowerbed();
      private.LoadStateFlowerbed();
      
    end;
    
  end;
  cmn.AddSubscriber( "win_flowerbed", win_flowerbed, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_doorroom () end;
  --------------------------------------------------------------------------------------------
  local win_doorroom_loc = function ()

      if cmn.IsEventDone( "win_doorroom" ) then
  
        ObjDelete("gmg_street_doorroom");
        ObjDelete( "gzz_street_door_3");
        ObjSet("grm_street_underbridge", { input = true, active = true, alp = 1});
        if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_street_underbridge_focus");
        end;
        ObjSet("spr_street_door_3_door_opened", { alp = 1});
        ObjDelete( "spr_street_door_3_door");
        
        --ObjDelete( "obj_street_door_3");
      
      end;
    
  end;

    cmn.AddSubscriber( "win_doorroom", win_doorroom_loc, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function vid_street_breeding () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_street_breeding" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_street_breeding",
    
  };
  local vid_street_breeding_end = function ()
  
    ObjSet( "obj_street_dlg_breeding", { input = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_street_breeding", vid_street_breeding_end, private.room_objname  );
  cmn.AddSubscriber( "vid_street_breeding_end", vid_street_breeding_end, private.room_objname  );
  ----------------------------------------------------------------------------------------------
  -- function dlg_street_breeding () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_street_breeding" ] = {
    type = "click",
    use_place = "obj_street_dlg_breeding",
    room = private.room_objname
  };
  local dlg_street_breeding_beg = function ()

    ObjDelete( "obj_street_dlg_breeding");
    
  end;

  local dlg_street_breeding_inv = function ()
   
    ObjSet("gzz_street_flowerbed", { active = true, input = true });
    
    ObjDelete( "anm_street_tablet" );
    ObjDelete( "anm_street_tablet_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_street_breeding_beg", dlg_street_breeding_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_street_breeding_inv", dlg_street_breeding_inv );
  cmn.AddSubscriber( "dlg_street_breeding", dlg_street_breeding_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_street_breeding", dlg_street_breeding_inv );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  --*******************************************************************************************************************
  --*** function zz_flowerbed () end ****
  --*******************************************************************************************************************
  subroom.Define( "zz_flowerbed" ); 
  subroom.Define( "zz_door_3" );   
  -------------------------------------------------   
  function zz_flowerbed.PreOpen()

    if not common_impl.street then

      common_impl.street = {}
      common_impl.street.note = "close";

    end;
     
    if ObjGet( "spr_flowerbed_note" ) and  ObjGet( "spr_flowerbed_note" ).input == true then

      ObjSet( "spr_flowerbed_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_flowerbed_note",     { alp = 1 } );
      
    end; 
    
    if  cmn.IsEventDone( "use_broom" ) and not cmn.IsEventDone( "win_flowerbed" ) then
    
      ObjSet( "obj_flowerbed_clk_mmg", { input = true } );
      ObjSet( "obj_flowerbed_mmg_big", { alp = 0, input = false } );
      
    end;

  end;
  ------------------------------------------------- 
  function zz_flowerbed.PreClose()

    if cmn.IsEventDone( "use_broom" ) and not cmn.IsEventDone( "win_flowerbed" )
      and ObjGet( "obj_flowerbed_mmg_big" ) and  ObjGet( "obj_flowerbed_mmg_big" ).input then

      cmn.MiniGameHide( 'flowerbed' );
      common_impl.PassingMgStop( "flowerbed" )
      iOS_NeedDrag(1);
    end;

  end;
  ------------------------------------------------- 
  function zz_flowerbed.Close()

    common_impl.street.note = "close";
    
    if ( ObjGet( "obj_flowerbed_mmg_big" ) ) and ( ObjGet( "obj_flowerbed_mmg_big" ).input ) then

      ObjSet( "obj_flowerbed_mmg_big", { input = false, alp = 0 } );

    end;

  end;
  -------------------------------------------------   
  function zz_door_3.PreOpen()

     if not common_impl.street then

       common_impl.street = {}
       common_impl.street.note = "close";

     end;
     
     if ObjGet( "spr_door_3_note" ) and  ObjGet( "spr_door_3_note" ).input == true then

      ObjSet( "spr_door_3_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_door_3_note",     { alp = 1 } );
      
    end; 
    
    --if cmn.IsEventDone( "get_tapepiece") then 
    --  
    --  ObjAttach("spr_door_3_note", "obj_door_3_ground");
    -- 
    --end; 
    
    ObjSet("obj_door_3_hint", { pos_x = 87 , pos_y = -82 });
 
  end;
 
 -------------------------------------------------   
  function zz_door_3.Open()
    
    if cmn.IsEventDone( "win_doorroom" ) then  
      
     local func_after = function ()
     
        common_impl.Lock( false );
        cmn.CallEventHandler( "win_doorroom" );
        common.CloseSubRoom();
     
     end;
     common_impl.Lock( true );
     ObjAnimate("obj_door_3_door", "alp", 0, 0, func_after,
     {
       0.0, 0, 1,
       0.3, 0, 0
        
     })
     --ObjAnimate("obj_door_3_door_1", "alp", 0, 0, func_after,
     --{
     --  0.0, 0, 1,
     --  0.3, 0, 0
     --   
     --})
     ObjAnimate("spr_door_3_door_open", "alp", 0, 0, "",
     {
       0.0, 0, 0,
       0.3, 0, 1
        
     })
      
     common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_doorroom_win", 0, "", 0 );      
      
    end; 

  end;

  -------------------------------------------------   
  function zz_door_3.Close()
    
    common_impl.street.note = "close";
        
    if cmn.IsEventDone( "use_mechanismpart_3" ) and not cmn.IsEventDone( "win_doorroom" ) then
         
      ObjSet( "tmr_street_gotomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_doorroom' ) end } );
      
    end;
   
  end;  
  -------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_street();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  if not cmn.IsEventDone( "vid_street_breeding" ) then

    ObjSet( "tmr_street_breeding",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_street_breeding(); end
    } );

  end;
    
  common_impl.EnvPlay( { "common/audio/level3/aud_street_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_boxkey()

  local item = "inv_boxkey";

  if ( common.ApplyObj( item, "obj_door_3_use_boxkey", true ) ) then

    cmn.CallEventHandler( "use_boxkey_inv" );
    cmn.CallEventHandler( "use_boxkey_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_boxkey" );
      cmn.CallEventHandler( "use_boxkey_end" );
    --common.CloseSubRoom();;
      end;
      
    ObjAnimate( "spr_door_3_cover", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_door_3_note", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_door_3_cover_ground", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    
    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_boxkey_door_3", 0, "", 0 );
  
  --ObjAnimate( "obj_door_3_bolts", "alp", 0, 0, func_after,
  --{ 
  --  0.0, 0, 1.0, 
  --  0.3, 0, 0.0
  --} );
  ObjSet( "vid_door_3_boxkey", {alp = 1});
  ObjSet( "obj_door_3_bolts", {alp = 0});
  VidPlay( "vid_door_3_boxkey", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_street_door_3", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door_3", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mechanismpart()

  local item = "inv_mechanismpart_3";

  if ( common.ApplyObj( item, "obj_door_3_use_mechanismpart", true ) ) and common_impl.street.note == "close" then

    cmn.CallEventHandler( "use_mechanismpart_3_inv" );
    cmn.CallEventHandler( "use_mechanismpart_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_mechanismpart_3" );
      cmn.CallEventHandler( "use_mechanismpart_3_end" );
      common.CloseSubRoom();

  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_mechanismpart_door_3", 0, "", 0 );
  
    ObjAnimate( "spr_door_3_part", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_door_3_slot", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0,  94, -77,
      0.3, 0,  94, -77,
      1.0, 0, 180, -60
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_street_door_3", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door_3", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ovalbutton()

  local item = "inv_ovalbutton";

  if ( common.ApplyObj( item, "obj_motorscooter_use_ovalbutton", true ) ) then

    cmn.CallEventHandler( "use_ovalbutton_inv" );
    cmn.CallEventHandler( "use_ovalbutton_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ovalbutton" );
      cmn.CallEventHandler( "use_ovalbutton_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_ovalbutton_motorscooter", 0, "", 0 );
    
    ObjAnimate( "spr_motorscooter_close_button", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_motorscooter", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorscooter", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fastingelement()

  local item = "inv_fastingelement";

  if ( common.ApplyObj( item, "obj_motorscooter_use_fastingelement", true ) ) then

    cmn.CallEventHandler( "use_fastingelement_inv" );
    cmn.CallEventHandler( "use_fastingelement_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_fastingelement" );
        cmn.CallEventHandler( "use_fastingelement_end" );
        
      end;
      
      ObjAnimate( "spr_motorscooter_box3", "pos_y", 0, 0, func_end,
      { 
        0.0, 0, 4, 
        0.5, 0, -5
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_fastingelement_motorscooter", 0, "", 0 );
    
    ObjAnimate( "spr_motorscooter_fastingelement_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_motorscooter", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorscooter", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnetbranch()

  local item = "inv_magnetbranch";

  if ( common.ApplyObj( item, "obj_cashregister_use_magnetbranch", true ) ) then

    cmn.CallEventHandler( "use_magnetbranch_inv" );
    cmn.CallEventHandler( "use_magnetbranch_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_magnetbranch" );
      cmn.CallEventHandler( "use_magnetbranch_end" );
      
      private.get_mechanismpart_3();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_magnetbranch_cashregister", 0, "", 0 );
    ObjSet( "anm_cashregister_rag", { alp = 0 } );
    ObjSet( "spr_cashregister_mechanismpart", { alp = 0 } );
    ObjSet( "anm_cashregister_magnet", { alp = 1 } );  
    AnimPlay( "anm_cashregister_magnet", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_cashregister", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cashregister", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_duster_3()

  local item = "inv_duster_3";

  if ( common.ApplyObj( item, "obj_cashregister_use_duster", true ) and cmn.IsEventDone("get_mechanismpart_3") ) then

    cmn.CallEventHandler( "use_duster_3_inv" );
    cmn.CallEventHandler( "use_duster_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_duster_3" );
      cmn.CallEventHandler( "use_duster_3_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_duster_cashregister", 0, "", 0 );
    AnimPlay( "anm_cashregister_rag", "DoAnim", func_after ); 
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_cashregister", false ) and cmn.IsEventDone("get_mechanismpart_3") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cashregister", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_3_2()

  local item = "inv_elf_3_1";

  if ( common.ApplyObj( item, "obj_cashregister_use_elf_3", true ) and cmn.IsEventDone("use_duster_3") ) then

    cmn.CallEventHandler( "use_elf_3_2_inv" );
    cmn.CallEventHandler( "use_elf_3_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      ObjSet( "spr_cashregister_elf", {alp = 1} );
      interface.InventoryItemAdd( "inv_elf_3_1", "spr_cashregister_elf", nil, "video" );
      cmn.SetEventDone( "use_elf_3_2" );
      cmn.CallEventHandler( "use_elf_3_2_end" );
    
    end;

    common_impl.Lock( true );
   
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_cashregister_elf", 0, "", 0 );

    interface.InventoryItemRemove( "inv_elf_3_1" );
    VidPlay( "vid_cashregister_elf", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_cashregister", false ) and cmn.IsEventDone("use_duster_3") and not cmn.IsEventDone( "use_elf_3_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cashregister", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_agentbadge()

  local item = "inv_agentbadge";

  if ( common.ApplyObj( item, "obj_flowerbed_use_agentbadge", true ) and cmn.IsEventDone("win_flowerbed")
    and cmn.IsEventDone("get_button_3") and cmn.IsEventDone("get_star1") and  common_impl.street.note == "close" ) then

    cmn.CallEventHandler( "use_agentbadge_inv" );
    cmn.CallEventHandler( "use_agentbadge_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_agentbadge" );
        cmn.CallEventHandler( "use_agentbadge_end" );
        
      end;
      
      ObjAnimate( "spr_flowerbed_box_cover", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_flowerbed_box_cover_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
  
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_agentbadge_flowerbed", 0, "", 0 );
    ObjAnimate( "spr_flowerbed_box_agentbadge", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_flowerbed", false ) and cmn.IsEventDone("win_flowerbed")
    and cmn.IsEventDone("get_button_3") and cmn.IsEventDone("get_star1") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_broom()

  local item = "inv_broom";

  if ( common.ApplyObj( item, "obj_flowerbed_use_broom", true ) and cmn.IsEventDone("use_elf_3_1") ) then

    cmn.CallEventHandler( "use_broom_inv" );
    cmn.CallEventHandler( "use_broom_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_broom" );
      cmn.CallEventHandler( "use_broom_end" );
      
      private.InitFlowerbed();
      private.InitFlowerbedVar();
      iOS_NeedDrag(0);
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_broom_flowerbed", 0, "", 0 );
    AnimPlay( "anm_flowerbed_broom", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_flowerbed", false ) and cmn.IsEventDone("use_elf_3_1") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_3_1()

  local item = "inv_elf_3_1";

  if ( common.ApplyObj( item, "obj_flowerbed_use_elf_3", true ) ) then

    cmn.CallEventHandler( "use_elf_3_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_3_1" );
      cmn.CallEventHandler( "use_elf_3_1_end" );
      ObjSet( "spr_flowerbed_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_3_1", "spr_flowerbed_elf", nil, "video" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_flowerbed_elf", 0, "", 0 );
   
    interface.InventoryItemRemove( "inv_elf_3_1" ); 
    VidPlay( "vid_flowerbed_elf", func_after )
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_flowerbed", false ) and not cmn.IsEventDone( "use_elf_3_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_loadedgun_3()

  local item = "inv_loadedgun_3";

  if ( common.ApplyObj( item, "obj_flowerbed_use_loadedgun", true ) and  common_impl.street.note == "close" ) then

    cmn.CallEventHandler( "use_loadedgun_3_inv" );
    cmn.CallEventHandler( "use_loadedgun_3_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_loadedgun_3" );
        cmn.CallEventHandler( "use_loadedgun_3_end" );
        
      end;
      
      ObjAnimate( "spr_flowerbed_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "spr_flowerbed_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_loadedgun_flowerbed", 0, "", 0 );
   
    ObjMultiSet( { 
      { "vid_flowerbed_use_gun", { alp = 1, playing = true, endtrig = func_after } },
      { "obj_flowerbed_castle", { alp = 0 } }
    } );    
 
    return true;
  
  elseif common.ApplyObj( item, "gzz_street_flowerbed", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scraper()

  local item = "inv_scraper";

  if ( common.ApplyObj( item, "obj_vendingmachine_use_scraper", true ) ) then

    cmn.CallEventHandler( "use_scraper_inv" );
    cmn.CallEventHandler( "use_scraper_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_scraper" );
        cmn.CallEventHandler( "use_scraper_end" );
        
      end;
        
      private.get_magnet();
      
      func_end();
      
    --common.CloseSubRoom();;
   
     
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_scraper_vendingmachine", 0, "", 0 );
  
    AnimPlay( "anm_vendingmachine_use_scraper", "DoAnim", func_after);
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_street_vendingmachine", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingmachine", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_banknote()

  local item = "inv_banknote";

  if ( common.ApplyObj( item, "obj_vendingmachine_use_banknote", true ) ) then

    cmn.CallEventHandler( "use_banknote_inv" );
    cmn.CallEventHandler( "use_banknote_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_banknote" );
      cmn.CallEventHandler( "use_banknote_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_banknote_vendingmachine", 0, "", 0 );
  
   --ObjAnimate( "obj_vendingmachine_money", "pos_xy", 0, 0, func_after,
   -- { 
   --   0.0, 0, 108, 351, 
   --   0.3, 0, -15, -4,
   --   1.0, 0, -14,  0
   --   
   -- } );
   -- 
  ObjAnimate( "spr_vendingmachine_button_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    1.3, 0, 0,
    1.6, 0, 1
  } );
  AnimPlay( "anm_vendingmachine_use_money", "DoAnim", "");
   
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_street_vendingmachine", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingmachine", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_broom()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_broom" );
  cmn.CallEventHandler( "get_broom" );

end;
--------------------------------------------------------------------------------------------
function private.get_tapepiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_tapepiece" );
  -- cmn.CallEventHandler( "get_tapepiece" );
  --ObjSet( "spr_door_3_note", { pos_x = 95, pos_y = 174, ang = -0.65});
  --ObjSet("spr_door_3_note", { alp = 0 });
  --ObjAttach( "spr_door_3_note", "obj_door_3_ground");
  common_impl.NoteScale( "close", "spr_door_3_note" );
  cmn.CallEventHandler( "get_tapepiece_inv" );
  ObjSet( "tmr_door_3_note",
  {
        time = 0.3,
        playing = true,
        endtrig = function()  private.anim_note(); end
  } );

  
  

end;
--------------------------------------------------------------------------------------------
function private.get_figurnepart1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_figurnepart1" );
  cmn.CallEventHandler( "get_figurnepart1" );

end;
--------------------------------------------------------------------------------------------
function private.get_battery_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_battery_3" );
  cmn.CallEventHandler( "get_battery_3" );
  
  if( cmn.IsEventDone( "get_box3" ) )then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_box3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_box3" );
  cmn.CallEventHandler( "get_box3" );
  
  if( cmn.IsEventDone( "get_battery_3" ) )then
    
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_mechanismpart_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_mechanismpart_3" );
  cmn.CallEventHandler( "get_mechanismpart_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_branch()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_branch" );
  cmn.CallEventHandler( "get_branch" );

end;
--------------------------------------------------------------------------------------------
function private.get_ticket()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ticket" );
  cmn.CallEventHandler( "get_ticket" );
  if common_impl.IsGetCollect( "get_collect_2_3_6" ) then
      
      common.CloseSubRoom();
      
  end;  
  
  
end;
--------------------------------------------------------------------------------------------
function private.get_button_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_3" );
  cmn.CallEventHandler( "get_button_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_roundhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_roundhandle" );
  cmn.CallEventHandler( "get_roundhandle" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_star1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_star1" );
  cmn.CallEventHandler( "get_star1" );

end;
--------------------------------------------------------------------------------------------
function private.get_boxkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_boxkey" );
  cmn.CallEventHandler( "get_boxkey" );
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_magnet()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );

end;
--------------------------------------------------------------------------------------------
function private.get_nuts()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nuts" );
  cmn.CallEventHandler( "get_nuts" );
  common.CloseSubRoom();
  
  

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_3_6()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_6");
    cmn.CallEventHandler("get_collect_2_3_6");
    if cmn.IsEventDone( "get_ticket") then
    
      common.CloseSubRoom();
    
    end;
    
    
  
  end;

  common_impl.PlayEffectHO( "spr_cashregister_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_3_8()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_8");
    cmn.CallEventHandler("get_collect_2_3_8");
    
  
  end;

  common_impl.PlayEffectHO( "spr_flowerbed_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_agentbadge()
    
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_flowerbed_use_agentbadge' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_chest_flowerbed", 0, "", 0 );
  ObjAnimate( "spr_flowerbed_box_cover", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 7,
    0.3, 0, 8,
    0.6, 0, 7
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_xx_ovalbutton()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_motorscooter_use_ovalbutton' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_cover_motorscooter", 0, "", 0 );
  ObjAnimate( "spr_motorscooter_close", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, -126, -63,
    0.3, 0, -128, -62,
    0.6, 0, -126, -63
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_ovalbutton()
  
  cmn.CallEventHandler( "clk_ovalbutton_beg" );
      
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_ovalbutton" );
    cmn.CallEventHandler( "clk_ovalbutton_end" );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_ovalbutton_motorscooter", 0, "", 0 );
  
  ObjAnimate( "spr_motorscooter_close", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  
  ObjAnimate( "spr_motorscooter_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );

end;
--------------------------------------------------------------------
function private.clk_box()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_flowerbed_use_loadedgun' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_castle_flowerbed", 0, "", 0 );
  ObjAnimate( "spr_flowerbed_castle", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 2,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------
function private.clk_door_3() 
  
 local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  
  if ( cmn.IsEventDone( "use_boxkey" ) ) then 
    
    common_impl.ShowBbt( 'bbt_door_3_use_mechanismpart' );
    
  else 
    
   common_impl.ShowBbt( 'bbt_door_3_use_boxkey' );
  
  end;
  
 common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_door_door_3", 0, "", 0 );
 
  ObjAnimate( "obj_door_3_door", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 2,
    0.6, 0, 0
  } );
  
  ObjAnimate( "spr_door_3_cover", "pos_y", 0, 0, "",
  { 
    0.0, 0, -89, 
    0.3, 0, -87,
    0.6, 0, -89
  } );
  --
  --ObjAnimate( "vid_door_3_boxkey", "pos_y", 0, 0, "",
  --{ 
  --  0.0, 0, 34, 
  --  0.3, 0, 36,
  --  0.6, 0, 34
  --} );
  
  
  if not cmn.IsEventDone( "get_tapepiece" ) then 
    
    ObjAnimate( "spr_door_3_note", "pos_y", 0, 0, "",
    { 
      0.0, 0, -70, 
      0.3, 0, -68,
      0.6, 0, -70
    } );
    
  end; 
 
  if not cmn.IsEventDone( "use_boxkey" ) then  
  
   ObjAnimate( "vid_door_3_boxkey", "pos_y", 0, 0, "",
   { 
      0.0, 0, 34, 
      0.3, 0, 36,
      0.6, 0, 34
   } );
  
  end;  
  --ObjAnimate( "obj_door_3_door_2", "pos_y", 0, 0, func_after,
  --{ 
  --  0.0, 0, 0, 
  --  0.3, 0, 2,
  --  0.6, 0, 0
  --} );


end; 
--------------------------------------------------------------------
function private.clk_magnet()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_vendingmachine_use_scraper' );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_magnet_vendingmachine", 0, "", 0 );
  
  ObjAnimate( "anm_vendingmachine_use_scraper", "pos_y", 0, 0, func_after,

  { 
    0.0, 0, 0, 
    0.3, 0, -2,
    0.6, 0, -0
  } );
 
  
end;  
---------------------------------------------------------------------
function private.vendingmachine_clk_button( num ) 
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;
  
  if num == 1 and cmn.IsEventDone( "use_banknote") then 
    
    local func_after_2 = function()
    
      local func_end = function()
  
          common_impl.Lock( false );
          cmn.SetEventDone( "clk_button_3" );
          cmn.CallEventHandler( "clk_button_3" ); 
          
      end;  
         
      ObjAnimate( "spr_vendingmachine_nuts", "pos_y", 0, 0, "",
      { 
        0.0, 0, 77, 
        0.6, 0, 180
        
      } );
      ObjAnimate( "spr_vendingmachine_nuts_shadow", "pos_y", 0, 0, func_end,
      { 
        0.0, 0, 79, 
        0.6, 0, 182
        
      } );  
        
    end;
  
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_button_open_vendingmachine", 0, "", 0 );
        
    ObjAnimate( "spr_vendingmachine_button_"..num, "alp", 0, 0, func_after_2,
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    
  else   
    
    common_impl.Lock( true );
    common_impl.ShowBbt( 'bbt_vendingmachine_button' );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_button_vendingmachine", 0, "", 0 );
    
    ObjAnimate( "spr_vendingmachine_button_"..num, "alp", 0, 0, func_after,
    { 
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1,
      0.9, 0, 0,
    } );
    
  end;  


end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************

function private.vid_street_breeding()

  local func_video = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_street_breeding" );
    cmn.CallEventHandler( "vid_street_breeding_end" );
    common_impl.ShowBbt( 'bbt_vid_street_breeding', 1 );
    common_impl.AddPageDiary( 11 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger2_mus", 0, "", 0 );
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/level3/aud_street_breeding", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/level3/aud_street_breeding_voc", 0.2 );
      
    end;
  
  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_street_breeding", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/level3/aud_street_breeding_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_street_breeding", 1, function() func_video( 'skip' ); end, 3 );
  VidPlay( "vid_street_breeding", function() func_video( nil ); end );

end;
--*********************************************************************************************************************
function private.dlg_street_breeding()
  
  local func_after = function()
  
    local func_after_anim = function()
    
      common_impl.Lock( false );
      
      ObjSet( "anm_street_tablet", { visible = false, active = false } );
      
      ObjAttach( "dlg_street_breeding", private.room_objname );
      ObjSet("anm_street_breeding_loc", { alp = 0 });
      cmn.CallEventHandler( "dlg_street_breeding_beg" );
      
      --common_impl.dialog_character_loc = "anm_street_";
      common_impl.continue_visible = true;
      common_impl.DialogCharacterStart( "breeding", 4, nil, nil, true, "dlg_street_breeding_end" );
      
      ObjAnimate( "rm_street", "color_rgb", 0, 0, "", { 0,0,0,0,0, 0.3,0,1,1,1 } );
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_tablet_env", 1, "", 0 );
    
    end;
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_switch_on", 0, "", 0 );
    
    ObjAnimate( "rm_street", "color_rgb", 0, 0, func_after_anim, { 0,0,1,1,1, 0.3,0,0,0,0 } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_street_tablet", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_street_tablet", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function public.dlg_street_breeding_end()
  
  local func_after_anim = function()  
  
   if not cmn.IsEventDone( "dlg_street_breeding" ) then

    local func_after = function () 
    
      local func_end = function ()
        
        common_impl.Lock( false );
        cmn.SetEventDone( "dlg_street_breeding" );
        ObjSet( "spr_street_breeding_hairpin", { alp = 1 } );
        cmn.CallEventHandler( "dlg_street_breeding_inv" );
        common_impl.ShowBbt( "bbt_dlg_street_breeding", 1 );
        
      end;
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
      ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_end,
      { 
        0.0, 1, 1.3,1.3, 
        1.0, 1, 1.0,1.0
      } );

      ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
      { 
        0.0, 1, 0,-200, 
        1.0, 1, 0, 0
      } );

    end;
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

    ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_after,
    { 
      0.0, 1, 1.0,1.0, 
      1.0, 1, 1.3,1.3
    } );

    ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
    { 
      0.0, 1,  0, 0, 
      1.0, 1,  0,-200
    } );

  end;
    
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_tablet_env", 0 );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_street_tablet_2", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_street_tablet_2", "DoAnim", func_after_anim );

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "breeding" then
    
    if txt_count == 3 then
      
      ObjMultiSet( { { "anm_street_breeding_breeding", { alp = 0 } },
                     { "anm_street_breeding_breeding_2", { alp = 1 } } } );
      
    end;
    
  end;        
  
end;
--------------------------------------------------------------------------------------------
function private.anim_note() 
  
   local func_after = function()
   
      common_impl.Lock( false );
      cmn.CallEventHandler( "get_tapepiece_closezz" );
      --cmn.SetEventDone( "get_tapepiece" );
   
   end;
  
   common_impl.Lock( true );
   ObjSet("spr_door_3_note", { alp = 0 });
   ObjSet( "anm_door_3_note", { alp = 1 });
   AnimPlay( "anm_door_3_note", "DoAnim", func_after);

end;  
--*********************************************************************************************************************
function private.open_mmg()
  
  local func_end = function ()

    common_impl.Lock( false );
    ObjSet( "obj_flowerbed_mmg_big", { input = true } );
    ObjSet( "obj_flowerbed_clk_mmg", { input = false } );
    ObjSet( "obj_flowerbed_clk_mmg_close", { input = true } );
    
    cmn.MiniGameShow( 'flowerbed' );
    common_impl.PassingMgStart( "flowerbed" );
    iOS_NeedDrag(0);

  end;
  
  common_impl.Lock( true );
  ObjAnimate( "obj_flowerbed_mmg_big", "alp", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.4, 3, 1
  } );

end;
-------------------------------------------------------------------------------------
function private.close_mmg()

  local func_end = function ()

    common_impl.Lock( false );

    ObjSet( "obj_flowerbed_mmg_big", { input = false } );
    ObjSet( "obj_flowerbed_clk_mmg", { input = true } );
    ObjSet( "obj_flowerbed_clk_mmg_close", { input = false } );
    
    cmn.MiniGameHide( 'flowerbed' );
    common_impl.PassingMgStop( "flowerbed" );
    iOS_NeedDrag(1);

  end;

  common_impl.Lock( true );

  ObjAnimate( "obj_flowerbed_mmg_big", "alp", 0, 0, func_end, 
  { 
    0.0, 3, 1,
    0.4, 3, 0
  } );

end;
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_flowerbed" then

    private.WinFlowerbed();
      
  end;

end;
--*********************************************************************************************************************
function public.Reset( name )

  if name == "win_flowerbed" then
    
    private.InitFlowerbed();
    private.InitFlowerbedVar();
    private.LoadFlowerbed();
    private.LoadStateFlowerbed();
    
  end;
  
end;
--*********************************************************************************************************************  
function private.opn_street()

  if not ( cmn.IsEventDone( "opn_street" ) ) then
    cmn.SetEventDone( "opn_street" );
  end;
  
  cmn.CallEventHandler( "opn_street" ); 

end;
--*********************************************************************************************************************
-- function *** MMG flowerbed *** () end;
--*********************************************************************************************************************
  function private.InitFlowerbed ()
    
    private.flowerbed_coords = {};
    private.flowerbed_coords[ 1 ] = { { 0,    -123 },   { 0,     -100 },   { 0,    -77 },   { 0,   -54 },     { 0,   0 } };
    private.flowerbed_coords[ 2 ] = { { 0,     123 },   { 0,      100 },   { 0,     77 },   { 0,    54 },     { 0,   0 } };
    private.flowerbed_coords[ 3 ] = { { -123,     0},   { -100,     0 },   { -77,    0 },   { -54,   0 },     { 0,   0 } };
    private.flowerbed_coords[ 4 ] = { { 123,     0 },   { 100,      0 },   { 77,     0 },   { 54,    0 },     { 0,   0 } };
    
    private.flowerbed_angs = { 3.14, 0, 4.71, 1.57  };
    private.availible_pos = 2;

    local tb = {};

    for i = 1, 9 do

      table.insert( tb, { "spr_flowerbed_mmg_stone_"..i, {  

        event_menter    = function () common_impl.SetCursor( CURSOR_HAND ); end,
        event_mleave    = function () common_impl.SetCursor( CURSOR_DEFAULT ); end,
        event_drag =      function () private.FlowerbedDrag( i );  end,
        event_startdrag = function () private.StartFlowerbedDrag( i ); end,
        event_dragdrop  = function () private.DropFlowerbed( i ); end,
        drag = true,
        realdrag = true;
        
      } } ); 

    end;

    if ( #tb > 0 ) then
      ObjMultiSet( tb );
    end; 

  end;
  --------------------------------------------------------------------------------------------
  function private.InitFlowerbedVar ()

    private.flowerbed_save = {};
    private.flowerbed_save [ 1 ] = { 2, 5 }
    private.flowerbed_save [ 2 ] = { 3, 1 }
    private.flowerbed_save [ 3 ] = { 2, 1 }
    private.flowerbed_save [ 4 ] = { 1, 1 }
    private.flowerbed_save [ 5 ] = { 3, 2 }
    private.flowerbed_save [ 6 ] = { 3, 3 }
    private.flowerbed_save [ 7 ] = { 2, 2 }
    private.flowerbed_save [ 8 ] = { 2, 3 }
    private.flowerbed_save [ 9 ] = { 4, 1 }
    private.flowerbed_ang = 0;
    private.SaveFlowerbed ();

  end;
  --------------------------------------------------------------------------------------------
  function private.FlowerbedDrag( i )
    
    local obj = "spr_flowerbed_mmg_stone_"..i.."_clone";
    local get_obj = ObjGet( obj );
    local cur_coord = GetZoomCursorPos();

    local dif_pos = GetObjPosByObj( obj );

    cur_coord = { cur_coord[ 1 ] - 512 ,cur_coord[ 2 ] - 384 }

    if ( private.flowerbed_save [ i ][ 1 ] == 3 or private.flowerbed_save [ i ][ 1 ] == 4  ) then

      local available_c = private.AvailableCoords( i );

      if ( cur_coord[ 1 ] > available_c[ 1 ] and cur_coord[ 1 ] < available_c[ 2 ] ) then

        ObjSet( obj, { pos_x = cur_coord[ 1 ]  } );

      elseif ( cur_coord[ 1 ] < available_c[ 1 ] ) then

        ObjSet( obj, { pos_x = available_c[ 1 ] } );

      else

        ObjSet( obj, { pos_x = available_c[ 2 ]  } );

      end;


    else

      local available_c = private.AvailableCoords( i );

      if ( cur_coord[ 2 ] > available_c[ 1 ] and cur_coord[ 2 ] < available_c[ 2 ] ) then

        ObjSet( obj, { pos_y = cur_coord[ 2 ]  } );

      elseif ( cur_coord[ 2 ] < available_c[ 1 ] ) then

        ObjSet( obj, { pos_y = available_c[ 1 ]  } );

      else

        ObjSet( obj, { pos_y = available_c[ 2 ]  } );

      end;

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.AvailableCoords( i )
  
    local line = private.flowerbed_save [ i ][ 1 ];
    local pos = private.flowerbed_save [ i ][ 2 ];
    local cur_mas = private.flowerbed_coords[ line ];
    local pos_max = pos;
    local pos_min = pos;
    local pos_availible = 4;

    if ( private.availible_pos == line ) then

      pos_availible = 5;

    end;

    for i = pos + 1, pos_availible do

      if ( private.FindFlowerbed( line, i ) == 0 ) then

        pos_max = i;
      
      else

        break;

      end;

    end;

    for i = pos - 1, 1, -1 do

      if ( private.FindFlowerbed( line, i ) == 0 ) then

        pos_min = i;
      
      else

        break;

      end;

    end;

    local mas_vectors = { 2, 2, 1, 1 };
    local min = cur_mas[ pos_min ][ mas_vectors[ line ] ];
    local max = cur_mas[ pos_max ][ mas_vectors[ line ] ];  

    if ( max < min ) then

      return { max, min };

    else

      return { min, max };

    end;
    
        
  end;
  --------------------------------------------------------------------------------------------
  function private.FindFlowerbed( line, pos )

    for i = 1, #private.flowerbed_save do

      if ( ( private.flowerbed_save [ i ][ 1 ] == line ) and ( private.flowerbed_save [ i ][ 2 ] == pos ) ) then

        return i;

      end;

    end;

    return 0;

  end;
  --------------------------------------------------------------------------------------------
  function private.StartFlowerbedDrag( i )
        
    local obj = "spr_flowerbed_mmg_stone_"..i;
    
    ObjClone( obj, "_clone", true, ObjGetRelations( obj ).parent );
    ObjSet( "spr_flowerbed_mmg_stone_"..i, { alp = 0 } );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_flowerbed_touch_tile", 0, "", 0 );

  end;
  --------------------------------------------------------------------------------------------
  function private.DropFlowerbed( i )

    local obj = "spr_flowerbed_mmg_stone_"..i.."_clone";
    local get_obj = ObjGet( obj );

    ObjSet( "spr_flowerbed_mmg_stone_"..i, { pos_x = get_obj.pos_x, pos_y = get_obj.pos_y,alp = 1 } );

    ObjDelete( obj );

    local cur_line = private.flowerbed_save [ i ][ 1 ];

    private.flowerbed_coords[ 1 ] = { { 0,    -123 },   { 0,    -100 },   { 0,    -77 },   { 0,   -54 },    { 0,   0 } };

    local obj_pos = { get_obj.pos_x, get_obj.pos_y };

    local mas_vectors = { 2, 2, 1, 1 };

    local dif = 52;

    local cur_pos = private.flowerbed_save [ i ][ 2 ];

    for j = 1, #private.flowerbed_coords [ cur_line ] do

      if ( math.abs( private.flowerbed_coords [ cur_line ][ j ][ mas_vectors[ private.flowerbed_save [ i ][ 1 ] ] ] - obj_pos[ mas_vectors[ private.flowerbed_save [ i ][ 1 ] ] ] ) < dif ) then
        
        dif = math.abs( private.flowerbed_coords [ cur_line ][ j ][ mas_vectors[ private.flowerbed_save [ i ][ 1 ] ] ] - obj_pos [ mas_vectors[ private.flowerbed_save [ i ][ 1 ] ] ] );
        
        cur_pos = j;

      end;
    
    end;

    private.flowerbed_save [ i ][ 2 ] = cur_pos;

    if ( private.IsWinFlowerbed() ) then

      private.WinFlowerbed();

    else

      private.SaveFlowerbed();

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_flowerbed_set_tile", 0, "", 0 );

    ObjSet( "spr_flowerbed_mmg_stone_"..i, { pos_x = private.flowerbed_coords [ cur_line ][ cur_pos ][ 1 ], pos_y = private.flowerbed_coords [ cur_line ][ cur_pos ][ 2 ], alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.IsWinFlowerbed()

    if ( ( private.flowerbed_save[ 1 ][ 1 ] ==  2 ) and 
         ( private.flowerbed_save[ 1 ][ 2 ] ==  4 ) and  
         ( private.flowerbed_save[ 2 ][ 1 ] ==  2 ) and 
         ( private.flowerbed_save[ 2 ][ 2 ] ==  3 ) and 
         ( private.flowerbed_save[ 3 ][ 1 ] ==  2 ) and 
         ( private.flowerbed_save[ 3 ][ 2 ] ==  2 ) and 
         ( private.flowerbed_save[ 4 ][ 1 ] ==  2 ) and 
         ( private.flowerbed_save[ 4 ][ 2 ] ==  1 )) then

      return true;

    end;

    return false;
    
  end;
--*********************************************************************************************************************
  function private.SaveFlowerbed () 

    ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_ang = private.flowerbed_ang;
    ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save = { };
    
    for i = 1, #private.flowerbed_save do

      ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save[ i ] = {}
      ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save[ i ][ 1 ] = private.flowerbed_save[ i ][ 1 ];
      ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save[ i ][ 2 ] = private.flowerbed_save[ i ][ 2 ];

    end;

  end;
--*********************************************************************************************************************
  function private.LoadFlowerbed ()

    private.flowerbed_save = {};
    private.flowerbed_ang = ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_ang;

    for i = 1, #ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save do
      
      private.flowerbed_save[ i ] = {};
      private.flowerbed_save[ i ][ 1 ] = ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save[ i ][ 1 ];
      private.flowerbed_save[ i ][ 2 ] = ng_global.progress[ "std" ][ "win_flowerbed" ].flowerbed_save[ i ][ 2 ];

    end;

  end;
--*********************************************************************************************************************
  function private.LoadStateFlowerbed ()

    local table_mts = {};

    for i = 1, #private.flowerbed_save do

      local line = private.flowerbed_save[ i ][ 1 ];
      local pos = private.flowerbed_save[ i ][ 2 ];


      local pos_x = private.flowerbed_coords[ line ][ pos ][ 1 ];
      local pos_y = private.flowerbed_coords[ line ][ pos ][ 2 ];
      local ang = private.flowerbed_angs[ line ];

      table.insert( table_mts, { "spr_flowerbed_mmg_stone_"..i, { pos_x = pos_x, pos_y = pos_y, ang = ang } } );

    end;

    table.insert( table_mts,{ "spr_flowerbed_mmg_round",{ ang = private.flowerbed_ang } } );

    ObjMultiSet( table_mts );

  end;
  --------------------------------------------------------------------------------------------
  function private.WinFlowerbed ()

    common_impl.Lock( true );

    local enfunc = function ()
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
      common_impl.Lock( false );
      cmn.MiniGameHide( "flowerbed" );
      common_impl.PassingMgWin( "flowerbed" ); 
      cmn.SetEventDone( "win_flowerbed" );
      cmn.CallEventHandler( "win_flowerbed" ); 

      iOS_NeedDrag(1);
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_flowerbed_win", 0, "", 0 );
    
    ObjAnimate( "obj_flowerbed_mmg_big", "alp", 0, 0, enfunc, {
      0.0, 0, 1,
      0.3, 0, 0
    } );
    
    ObjAnimate( "spr_flowerbed_box_open", "alp", 0, 0, "", {
      0.0, 0, 0,
      0.3, 0, 1
    } ); 
    
  end; 
  --------------------------------------------------------------------------------------------
  function private.Circle_startdrag( circle_obj_name,drag_obj_name)

    private.Stack_flowerbed = 0;

    for i = 1, #private.flowerbed_save do

      if ( private.flowerbed_save [ i ][ 2 ] == 5 ) then

        ObjAttach( "spr_flowerbed_mmg_stone_"..i, "spr_flowerbed_mmg_round"  );
        ObjSet( "spr_flowerbed_mmg_stone_"..i, { ang = 0, pos_x = -1, pos_y = -2 } );

        private.Stack_flowerbed = i;

        break;

      end; 

    end;

    private.coords_begin = GetZoomCursorPos();
    private.get_dragobj = ObjGet( drag_obj_name );
    private.coords_begin = { private.coords_begin[ 1 ] - GetObjPosByObj( circle_obj_name )[ 1 ], private.coords_begin[ 2 ] - GetObjPosByObj( circle_obj_name )[ 2 ] };

    private.dragobj_coords = { ObjGet( drag_obj_name).pos_x, ObjGet( drag_obj_name).pos_y};

    ObjSet( drag_obj_name, { pos_x = private.coords_begin[1], pos_y = private.coords_begin[2] } );
    
    private.ang_circle = ObjGet( circle_obj_name ).ang;
    private.ang_old = math.atan2( private.coords_begin[1] - private.dragobj_coords[1] ,private.coords_begin[2] - private.dragobj_coords[2] );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_flowerbed_touch_center", 0, "", 0 );

  end;
  --------------------------------------------------------------------------------------------
  function private.Circle_drag(circle_obj_name)
    
    SetCursor(CURSOR_HAND);

    local cur_pos = GetZoomCursorPos();

    cur_pos[1] = cur_pos[1] - GetObjPosByObj( circle_obj_name )[ 1 ];
    cur_pos[2] = cur_pos[2] - GetObjPosByObj( circle_obj_name )[ 2 ];

    if ( private.coords_begin[ 1 ] ~= cur_pos[ 1 ] ) or ( private.coords_begin[ 2 ] ~= cur_pos[ 2 ] ) then

      local diff = math.atan2( cur_pos[1] - private.dragobj_coords[1],cur_pos[2] - private.dragobj_coords[2] ) - private.ang_old;

      ObjSet( circle_obj_name, { ang = diff + private.ang_circle  } );
 
    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.Circle_dragdrop(circle_obj_name,drag_obj_name)
    
    SetCursor(CURSOR_DEFAULT);

    ObjSet( drag_obj_name, { pos_x = private.get_dragobj.pos_x, pos_y = private.get_dragobj.pos_y } );
    private.NormalizeAngle( circle_obj_name );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_flowerbed_set_center", 0, "", 0 );

  end;
--------------------------------------------------------------------------------------------
  function private.NormalizeAngle ( circle_obj_name )

    local obj = circle_obj_name;

    local ang = ObjGet( obj ).ang;

    if ( ang > math.pi*2 ) then

      ang = ang - math.pi*2

    elseif ( ang < 0 ) then

      ang = ang + math.pi*2

    end;

    local sektor = math.floor( ang / 1.57 )

    local dif_ang = math.fmod( ang, 1.57 );

    if ( dif_ang > 0.785  ) then

      sektor = sektor + 1;

    end;

    ObjSet( obj, { ang = sektor*1.57 } );

    private.flowerbed_ang = sektor*1.57;

    if ( sektor < 1 ) then

      sektor = 4;

    end;

    local mas_save = { 4, 1, 3, 2 };
    
    if ( private.Stack_flowerbed ~= 0 ) then
      
      ObjAttach( "spr_flowerbed_mmg_stone_"..private.Stack_flowerbed, "obj_flowerbed_stones"  );
      ObjSet( "spr_flowerbed_mmg_stone_"..private.Stack_flowerbed, { ang = private.flowerbed_angs[ mas_save[ sektor ] ], pos_x = private.flowerbed_coords[ mas_save [ sektor ] ][ 5 ][ 1 ], pos_y = private.flowerbed_coords[ mas_save[ sektor ] ][ 5 ][ 2 ] } )
      private.flowerbed_save[ private.Stack_flowerbed ] = { mas_save[ sektor ], 5 };
      
    end;

    private.availible_pos = mas_save[ sektor ];
    private.SaveFlowerbed ();

  end;
--------------------------------------------------------------------------------------------  
ObjAnimate("spr_door_3_light_add", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.6,
  1.2, 0, 1.0
});
ObjAnimate("spr_vendingmachine_arrow", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.5, 0, 0.2,
  1.0, 0, 1.0
});

ObjAnimate("spr_motorscooter_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_street_breeding_light_add", "alp",1,0,"",
{
  0.0, 0, 0,
  0.8, 0, 1,
  1.0, 0, 0, 
  1.2, 0, 1, 
  1.4, 0, 0, 
  1.8, 0, 1,
  2.1, 0, 0
});

  