-- name=rm_studio
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_studio";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_directordashboard", "room_hub" );
  ObjAttach( "zz_ceiling", "room_hub" );
  ObjAttach( "zz_wall", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "obj_studio_clk_bear",         { event_mdown = private.clk_bear }},
  { "obj_studio_clk_lamp_1",       { event_mdown = private.clk_lamp_1 }},
  { "obj_studio_clk_lamp_2",       { event_mdown = private.clk_lamp_2 }},
  { "obj_studio_clk_lamp_3",       { event_mdown = private.clk_lamp_3 }},
  { "obj_studio_clk_lamp_4",       { event_mdown = private.clk_lamp_4 }},
  { "obj_studio_dlg_calling",       { event_mdown = private.dlg_studio_calling }},
  { "spr_directordashboard_box1", { event_mdown = private.get_box1 }},
  { "spr_directordashboard_figurinepart2", { event_mdown = private.get_figurinepart2 }},
  { "spr_ceiling_figurinepart3", { event_mdown = private.get_figurinepart3 }},
  { "spr_wall_fastingelement", { event_mdown = private.get_fastingelement }},
  { "spr_wall_clip_3", { event_mdown = private.get_clip_3 }},
  { "spr_wall_box2", { event_mdown = private.get_box2 }},
  { "obj_directordashboard_clk_button", { event_mdown = private.clk_play_sound,
                                          event_menter = private.menter_play_sound,
                                          event_mleave = private.mleave_play_sound } },
  { "spr_studio_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_ceiling_open", { event_mdown = private.clk_ceiling } },
  { "spr_directordashboard_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_directordashboard_note" );common_impl.ShowBbt( 'bbt_directordashboard_note', 1 ); end }},    
  { "spr_directordashboard_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_directordashboard_note" ); end } },
  { "spr_wall_collect_2", { event_mdown = function () private.get_collect_2_3_3(); end,
                                  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  });
  
  for i = 1, 4 do
    
    ObjSet( "spr_ceiling_mmg_box_"..i, { event_mdown = function() private.mmg_ceiling_clk_box( i ); end,
                                         event_menter = function() private.mmg_ceiling_enter_box( i ); end,
                                         event_mleave = function() private.mmg_ceiling_leave_box( i ); end } );
    
  end;
  
  for i = 1, 25 do
    
    ObjSet( "obj_wall_mmg_puzzle_"..i, { event_mdown = function() private.ClkPart( i ); end,
                                         event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                         event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  for i = 1, 4 do
    
    ObjSet( "obj_wall_use_figurinepart"..i, { event_mdown = function() private.ClkWallCap( i ); end,
                                              event_menter = function() common_impl.SetCursor( CURSOR_USE ) end,
                                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end; 
                                              
  private.contact = { { 1, 2, 3 },{ 4, 6, 5 } };    

  private.playing_sound = false  
                                             
  private.mmg_ceiling_state = { 1,2,3,4 };
  private.mmg_ceiling_zoom_scale = { 1.3, 1.6, 1.8, 2.3 };
  private.mmg_ceiling_zoom_coords = { { -110,110 }, { -200,270 }, { -300,360 }, { -450,700 } };
  
  private.coords = { { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 }, { 0,0} },  
                    { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 }, { 0,0} },
                    { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 }, { 0,0} },
                    { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 }, { 0,0} },
                    { { 0,0 }, { 0,0 }, { 0,0 }, { 0,0 }, { 0,0} } };
                    
                    
  private.win_wall =  { {   1,  2,  3,  4,  5 },
                        {   6,  7,  8,  9, 10 },
                        {  11, 12, 13, 14, 15 },
                        {  16, 17, 18, 19, 20 },
                        {  21, 22, 23, 24, 25 },
                      };
  --private.state_wall = { {  1,  2, 4,  5, 3 },
  --                  {  6,  7,  8,  10, 9 },
  --                  { 23, 12,  13,  14, 15 },
  --                  { 16, 11, 18, 19, 20 },
  --                  --{ 21, 22, 17, 24, 25 } }; 
  --                 { 21, 17, 22, 24, 25 } }; 
                   
  private.state_wall = { {  1,  2, 3,  4, 5 },
                         {  6,  7,  13,  8, 10 },
                         { 11, 12,  18,  9, 15 },
                         { 16, 17, 23, 14, 20 },
                         { 21, 22, 24, 19, 25 } };                
                    
  -- loupe --
  
  private.loupe_mmg_win_pointer = 0;
  private.loupe_mmg_input_stop_drag = false;
  private.start_drag_auto = false;
  
  private.loupe_mmg_anim();

  for k = 1, 2 do
      
    for j = 1, 4 do
      
      ObjSet( "spr_studio_loupe_mg_sign_"..k.."_"..j, { event_mdown = function() private.loupe_mmg_clk_sign( k, j ) end,
                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
      
    end;
      
  end;
                                                      
 -- loupe end --
                    
  private.GetCoords();
  --------------------------------------------------------------------------------------------
  -- function mmg_wire () end;
  --------------------------------------------------------------------------------------------
  private.wires = {{}, {}, {}}; 
  private.wire_pos =  { { -155, -155, -155,  158, 158,  158,  0 },
                        { -174,  -67,   45, -174, -67,   45,  168 } };

  private.letters = { "q", "w", "e", "r", "t", "y", "u", "i", "o", "p",
                        "a", "s", "d", "f", "g", "h", "j", "k", "l",
                            "z", "x", "c", "v", "b", "n", "m" };

  private.WIRE_P = 20;--   //количество частей проводков в одном проводе
  private.TEN = 2;--      // К растяжения провода под собственным весом
  private.REL = 0.5;--   // K ускорения (затухание скорости движения)
  private.GRAV = 0.5;-- // сила гравитации (px/frame)

  local color = { "green", "violet", "blue" };
  
  for i = 1,2,1 do

    for j = 1,3,1 do

      --********************* раскоментировать как будет готов лабиринт

      ObjCreate( "spr_directordashboard_contact_"..i..j, "spr" );    
      ObjAttach( "spr_directordashboard_contact_"..i..j, "obj_directordashboard_mmg_wire" );

      ObjSet( "spr_directordashboard_contact_"..i..j, 
        { 
          pos_z = 1, alp = 1, input = true, active = true, visible = true, drag = true, res = "assets/levels/level3/rm_studio/zz_directordashboard/layers/"..color[ j ].."_contact",
          event_mdown = function () 

            private.ClkWire( i, j );
 
          end; 
          event_drag = function () 

            private.UpdateWire( i, j ,1 );

          end;
          event_dragdrop = function () 
  
            private.DropWire( i ,j );
        
          end;
          event_startdrag = function () 

            private.StartDragWire( i, j );

          end; 
          event_menter = function ()

            common_impl.SetCursor( CURSOR_HAND );

          end,
          event_mleave = function ()

            common_impl.SetCursor( CURSOR_DEFAULT );

          end
        } );

    end;

  end;
    
  --генерация проводков
  for i = 1, 3, 1 do
    
    for j = 1, private.WIRE_P, 1 do

      --********************* раскоментировать как будет готов лабиритнт
      ObjCreate( "spr_directordashboard_wire_"..i.."_"..j, "spr" );
      ObjAttach( "spr_directordashboard_wire_"..i.."_"..j, "obj_directordashboard_mmg_wire" );
      ObjSet( "spr_directordashboard_wire_"..i.."_"..j, { alp = 1, input = false, res = "assets/levels/level3/rm_studio/zz_directordashboard/layers/"..color[ i ].."_wire" } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_studio = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_studio_studioroom",
    "gzz_studio_directordashboard",
    "gzz_studio_ceiling",
    "gzz_studio_wall"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_directordashboard",
    "zz_ceiling",
    "zz_wall"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_studio", update_game_mode_studio, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_studio = function ()

  local effects_table = 
  {
    "obj_studio_anim",
    "spr_directordashboard_light",
    "anm_directordashboard_dust", 
    "anm_wall_dust",
    "anm_ceiling_dust"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_studio", update_performance_mode_studio, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_studio () end;
  --------------------------------------------------------------------------------------------
  local opn_studio_map = function ()

    common_impl.VisitMapRoom( "studio" );

  end;
  cmn.AddSubscriber( "opn_studio", opn_studio_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_box1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box1" ] = {
    type = "get",
    get_obj = "spr_directordashboard_box1",
    room = private.room_objname,
    zz = "zz_directordashboard",
    zz_gate = "gzz_studio_directordashboard"
  };
    
  local get_box1_inv = function ()
  
    ng_global.progress[ "std" ][ "get_box1" ].count[1] = true;
    local count = 0;
    for i = 1,4 do
      if ng_global.progress[ "std" ][ "get_box1" ].count[i] then
        count = count + 1;
      end;
    end;
    interface.InventoryItemRemove( "inv_box_3" );
        interface.InventoryItemRemove( "inv_box_3" );
    local func_end = function()
    
      ObjSet( "txt_box_3_number", {text = tostring(count).."/4"});
      ObjSet( "spr_box_3_1", { alp = 1 });
    
    end;
    interface.InventoryItemAdd( "inv_box_3", "spr_directordashboard_box1", func_end, nil, "assets/levels/level3/rm_studio/zz_directordashboard/inv/inv_box1" );

  end;
  
  local get_box1_closezz = function ()
  
    ObjDelete( "gfx_directordashboard_box1" );
    ObjDelete( "spr_directordashboard_box1_shadow" );
    ObjDelete( "spr_studio_directordashboard_box_1" );
    if cmn.IsEventDone( "get_box1" ) and cmn.IsEventDone( "win_console" ) then
      ObjDelete( "gzz_studio_directordashboard" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_box1", get_box1_inv );
  cmn.AddSubscriber( "get_box1", get_box1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurinepart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurinepart2" ] = {
    type = "get",
    get_obj = "spr_directordashboard_figurinepart2",
    room = private.room_objname,
    zz = "zz_directordashboard",
    zz_gate = "gzz_studio_directordashboard"
  };
    
  local get_figurinepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurinepart2", "spr_directordashboard_figurinepart2" );
  
  end;
  
  local get_figurinepart2_closezz = function ()
  
    ObjDelete( "gfx_directordashboard_figurinepart2" );
    ObjDelete( "spr_directordashboard_figurinepart2_shadow" );
    ObjDelete( "spr_directordashboard_figurinepart2_over" );
    ObjDelete( "spr_studio_directordashboard_figurinepart2" );
    
  end;
  
  cmn.AddSubscriber( "get_figurinepart2", get_figurinepart2_inv );
  cmn.AddSubscriber( "get_figurinepart2", get_figurinepart2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurinepart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurinepart3" ] = {
    type = "get",
    get_obj = "spr_ceiling_figurinepart3",
    room = private.room_objname,
    zz = "zz_ceiling",
    zz_gate = "gzz_studio_ceiling"
  };
    
  local get_figurinepart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurinepart3", "spr_ceiling_figurinepart3" );
  
  end;
  
  local get_figurinepart3_closezz = function ()
  
    ObjDelete( "gfx_ceiling_figurinepart3" );
    ObjDelete( "spr_ceiling_figurinepart3_shadow" );
    ObjDelete( "spr_ceiling_figurinepart3_over" );
    ObjDelete( "spr_studio_ceiling_figurinepart3" );
  
  end;
  
  cmn.AddSubscriber( "get_figurinepart3", get_figurinepart3_inv );
  cmn.AddSubscriber( "get_figurinepart3", get_figurinepart3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fastingelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fastingelement" ] = {
    type = "get",
    get_obj = "spr_wall_fastingelement",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
    
  local get_fastingelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_fastingelement", "spr_wall_fastingelement" );
  
  end;
  
  local get_fastingelement_closezz = function ()
  
    ObjDelete( "gfx_wall_fastingelement" );
    ObjDelete( "spr_wall_fastingelement_shadow");
    ObjDelete( "spr_studio_wall_button" );

    if cmn.IsEventDone("get_clip_3") then 
     
       ObjDelete("obj_wall_mmg");
       
       if cmn.IsEventDone("get_box2") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
         
         ObjDelete("gzz_studio_wall");
         
       end;  
     
     end;  
  
  end;
  
  cmn.AddSubscriber( "get_fastingelement", get_fastingelement_inv );
  cmn.AddSubscriber( "get_fastingelement", get_fastingelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clip_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clip_3" ] = {
    type = "get",
    get_obj = "spr_wall_clip_3",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
    
  local get_clip_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_clip_3", "spr_wall_clip_3" );
  
  end;
  
  local get_clip_3_closezz = function ()
  
   ObjDelete( "gfx_wall_clip_3" );
   ObjDelete( "spr_studio_wall_clip" );

   if cmn.IsEventDone("get_fastingelement") then 
     
     ObjDelete("obj_wall_mmg");
     
     if cmn.IsEventDone("get_box2") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
       
       ObjDelete("gzz_studio_wall");
       
     end;  
     
   end;  
  
  end;
  
  cmn.AddSubscriber( "get_clip_3", get_clip_3_inv );
  cmn.AddSubscriber( "get_clip_3", get_clip_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_box2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box2" ] = {
    type = "get",
    get_obj = "spr_wall_box2",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
    
  local get_box2_inv = function ()
     
    ng_global.progress[ "std" ][ "get_box1" ].count[2] = true;
    local count = 0;
    for i = 1,4 do
      if ng_global.progress[ "std" ][ "get_box1" ].count[i] then
        count = count + 1;
      end;
    end;
    interface.InventoryItemRemove( "inv_box_3" );
    local func_end = function()
    
      ObjSet( "txt_box_3_number", {text = tostring(count).."/4"});
      ObjSet( "spr_box_3_2", { alp = 1 });
    
    end;
    interface.InventoryItemAdd( "inv_box_3", "spr_wall_box2", func_end, nil, "assets/levels/level3/rm_studio/zz_wall/inv/inv_box2" );

  end;
  
  local get_box2_closezz = function ()
  
    ObjDelete( "gfx_wall_box2" );
    ObjDelete( "spr_wall_box2_shadow");
    ObjDelete( "spr_studio_wall_box_2" );
    
    if cmn.IsEventDone( "get_clip_3") and cmn.IsEventDone( "get_fastingelement") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
      
      ObjDelete( "gzz_studio_wall");
      
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_box2", get_box2_inv );
  cmn.AddSubscriber( "get_box2", get_box2_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_5 = function ()
  
    ObjDelete( "obj_studio_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_5", get_collect_morph_item_3_5, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collectibles_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_3 = function ()
 
    ObjDelete( "spr_wall_collect_2" );

    if cmn.IsEventDone( "get_box2" ) and cmn.IsEventDone( "get_fastingelement") and cmn.IsEventDone( "get_clip_3") then
      ObjDelete( "gzz_studio_wall" );
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_3_3", get_collect_2_3_3, private.room_objname );

  
  --------------------------------------------------------------------------------------------
  -- function use_lever_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever_3" ] = {
    type = "use",
    inv_obj = "inv_lever_3",
    use_place = "obj_directordashboard_use_lever_3",
    room = private.room_objname,
    zz = "zz_directordashboard",
    zz_gate = "gzz_studio_directordashboard"
  };
  local use_lever_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_lever_3" );
  
  end;
  local use_lever_3_beg = function ()
  
    ObjDelete( "obj_directordashboard_use_lever_3" );
  
  end;
  local use_lever_3_end = function ()
  
    ObjSet( "spr_directordashboard_note", { input = false } );
    ObjSet( "spr_directordashboard_mini_mg", { alp = 1 } );
    ObjSet( "spr_directordashboard_lever", { alp = 1 } );
    if not cmn.IsEventDone( "win_console" ) then
      ObjSet( "obj_directordashboard_mmg", { input = true, alp = 1 } );
    end;
    ObjSet( "spr_studio_directordashboard_lever", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever_3", use_lever_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_3", use_lever_3_inv );
  cmn.AddSubscriber( "use_lever_3", use_lever_3_end, private.room_objname );
  cmn.AddSubscriber( "use_lever_3_inv", use_lever_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever_3_beg", use_lever_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_3_end", use_lever_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_box () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_box" ] = {
    type = "use",
    inv_obj = "inv_box_3",
    use_place = "obj_ceiling_use_box",
    room = private.room_objname,
    zz = "zz_ceiling",
    zz_gate = "gzz_studio_ceiling"
  };
  local use_box_inv = function ()
  
  interface.InventoryItemRemove( "inv_box_3" );
  
  end;
  local use_box_beg = function ()
  
    ObjDelete( "obj_ceiling_use_box" );
  
  end;
  local use_box_end = function ()
  
    ObjSet( "obj_ceiling_mmg", { input = true, alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_box", use_box_beg, private.room_objname );
  cmn.AddSubscriber( "use_box", use_box_inv );
  cmn.AddSubscriber( "use_box", use_box_end, private.room_objname );
  cmn.AddSubscriber( "use_box_inv", use_box_inv, private.room_objname );
  cmn.AddSubscriber( "use_box_beg", use_box_beg, private.room_objname );
  cmn.AddSubscriber( "use_box_end", use_box_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurinepart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurinepart1" ] = {
    type = "use",
    inv_obj = "inv_figurinepart1",
    use_place = "obj_wall_use_figurinepart1",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
  local use_figurinepart1_inv = function ()
  
  interface.InventoryItemRemove( "inv_figurinepart1" );
  
  end;
  local use_figurinepart1_beg = function ()
  
  ObjDelete( "obj_wall_use_figurinepart1" );
  
  end;
  local use_figurinepart1_end = function ()
  
    ObjSet("spr_wall_figurinepart_1", { alp = 1 });
    ObjSet( "spr_studio_wall_mmg_part_1", { alp = 1 } );
    
    if cmn.IsEventDone( "use_figurinepart2") and cmn.IsEventDone( "use_figurinepart3") then
      
      ObjSet("obj_wall_mmg", { alp = 1, input = true});
      ObjSet("spr_wall_box2", { input = false});
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurinepart1", use_figurinepart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart1", use_figurinepart1_inv );
  cmn.AddSubscriber( "use_figurinepart1", use_figurinepart1_end, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart1_inv", use_figurinepart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart1_beg", use_figurinepart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart1_end", use_figurinepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurinepart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurinepart2" ] = {
    type = "use",
    inv_obj = "inv_figurinepart2",
    use_place = "obj_wall_use_figurinepart2",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
  local use_figurinepart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurinepart2" );
  
  end;
  local use_figurinepart2_beg = function ()
  
    ObjDelete( "obj_wall_use_figurinepart2" );
  
  end;
  local use_figurinepart2_end = function ()
  
    ObjSet("spr_wall_figurinepart_2", { alp = 1 });
    ObjSet( "spr_studio_wall_mmg_part_2", { alp = 1 } );
    
    if cmn.IsEventDone( "use_figurinepart1") and cmn.IsEventDone( "use_figurinepart3") then
      
      ObjSet("obj_wall_mmg", { alp = 1, input = true});
      ObjSet("spr_wall_box2", { input = false});
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurinepart2", use_figurinepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart2", use_figurinepart2_inv );
  cmn.AddSubscriber( "use_figurinepart2", use_figurinepart2_end, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart2_inv", use_figurinepart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart2_beg", use_figurinepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart2_end", use_figurinepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurinepart3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurinepart3" ] = {
    type = "use",
    inv_obj = "inv_figurinepart3",
    use_place = "obj_wall_use_figurinepart3",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_studio_wall"
  };
  local use_figurinepart3_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurinepart3" );
  
  end;
  local use_figurinepart3_beg = function ()
  
    ObjDelete( "obj_wall_use_figurinepart3" );
  
  end;
  local use_figurinepart3_end = function ()
  
    ObjSet("spr_wall_figurinepart_3", { alp = 1 });
    --ObjSet( "spr_wall_key", { input = true, visible = true, active = true } );
     if cmn.IsEventDone( "use_figurinepart2") and cmn.IsEventDone( "use_figurinepart1") then
      
      ObjSet("obj_wall_mmg", { alp = 1, input = true});
      ObjSet("spr_wall_box2", { input = false});
    
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurinepart3", use_figurinepart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart3", use_figurinepart3_inv );
  cmn.AddSubscriber( "use_figurinepart3", use_figurinepart3_end, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart3_inv", use_figurinepart3_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart3_beg", use_figurinepart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart3_end", use_figurinepart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_device_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_device_3" ] = {
    type = "click",
    use_place = "obj_int_button_apparat",  
    room = private.room_objname,
  };
  local use_device_3_inv = function ()
  
  end;
  local use_device_3_beg = function ()
  
  end;
  local use_device_3_end = function ()
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_device_3", use_device_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_3", use_device_3_inv );
  cmn.AddSubscriber( "use_device_3", use_device_3_end, private.room_objname );
  cmn.AddSubscriber( "use_device_3_inv", use_device_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_device_3_beg", use_device_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_device_3_end", use_device_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_console () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_console" ] = {
    type = "win",    
    room = private.room_objname,
    use_place = "obj_directordashboard_mmg",
    zz_gate = "gzz_studio_directordashboard",
    zz = "zz_directordashboard"
  };

  local win_console = function ()

    if ( cmn.IsEventDone( "win_console" ) ) then
      
      if cmn.IsEventDone( "get_box1" ) then
        ObjDelete( "gzz_studio_directordashboard" );
      end;
      ObjSet( "obj_directordashboard_mmg_wire", { input = false } );
      ObjSet( "gho_studio_studioroom", { input = true, active = true } );
      ObjSet( "obj_directordashboard_mmg", { input = false, alp = 0 } );
      
    elseif ( cmn.IsEventStart( "win_console" ) and not cmn.IsEventDone( "win_console" ) ) then 

        for i = 1, #private.contact , 1 do

          for j = 1, #private.contact[ i ], 1 do 

            private.contact[ i ][ j ] = ng_global.progress[ "std" ][ "win_console" ].mmg.contact[ i ][ j ];         

          end; 

        end;

        for kk = 1, 3, 1 do

          private.CreateWire( kk );

          for gg = 1, 10, 1 do

            private.UpdateWire( "1",kk );

          end;

        end;
        
    end;
      
  end;
  
  cmn.AddSubscriber( "win_console", win_console, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function win_ceiling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_ceiling" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_ceiling_mmg",
    zz_gate = "gzz_studio_ceiling",
    zz = "zz_ceiling"

  };

  local win_ceiling = function ()
  
    if ( cmn.IsEventDone( "win_ceiling" ) ) then
      
      ObjSet( "spr_ceiling_open", { input = true } );
      
      ObjDelete( "obj_ceiling_mmg" );
      
      for i = 1, 4 do
    
        ObjSet( "spr_ceiling_box_"..i, { alp = 1 } );
        ObjSet( "spr_studio_ceiling_box_"..i, { alp = 1 } );
        
      end;
  
      local scale = private.mmg_ceiling_zoom_scale[4];
      local pos = private.mmg_ceiling_zoom_coords[4];
      
      ObjSet( "spr_ceiling_back", { scale_x = scale, scale_y = scale, pos_x = pos[1], pos_y = pos[2] } );
  
    elseif ( cmn.IsEventStart( "win_ceiling" ) ) then
      
      local state = ng_global.progress["std"]["win_ceiling"].state;
      
      for i = 1, state do
        
        ObjSet( "spr_ceiling_mmg_box_"..i, { alp = 0, input = false } );
        ObjSet( "spr_studio_ceiling_box_"..i, { alp = 1 } );
        ObjSet( "spr_ceiling_box_"..i, { alp = 1 } );
        ObjSet( "spr_ceiling_back", { scale_x = private.mmg_ceiling_zoom_scale[ state ],
                                      scale_y = private.mmg_ceiling_zoom_scale[ state ],
                                      pos_x = private.mmg_ceiling_zoom_coords[ state ][1],
                                      pos_y = private.mmg_ceiling_zoom_coords[ state ][2] });  
        
      end;

    end;
  

  end;
 
  cmn.AddSubscriber( "win_ceiling", win_ceiling, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_wall () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_wall" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_wall_mmg",
    zz_gate = "gzz_studio_wall",
    zz = "zz_wall"

  };

  local win_wall = function ()
  
    if ( cmn.IsEventDone( "win_wall" ) ) then
      
      ObjSet("obj_wall_mmg_open", { alp = 1, input = true, acrive = true});
      ObjSet("obj_wall_mmg_main", { input = false });
      ObjDelete( "spr_wall_puzzle_cap");
      ObjDelete( "spr_studio_wall_mmg" );
      ObjDelete( "anm_wall_mmg_open" );
      
      if not cmn.IsEventDone("get_box2") then
        
        ObjSet("spr_wall_box2", { active = true, input = true });
        
      end;  
      
    else 
    
    
     for i = 1,5 do
      
       for j = 1,5 do

         private.state_wall[i][j] = ng_global.progress[ "std" ] [ "win_wall" ].state[i][j];
        
         ObjSet( "obj_wall_mmg_puzzle_"..private.state_wall[i][j], { pos_x = private.coords[i][j][1],
                                                                     pos_y = private.coords[i][j][2] } );

      end;
      
    end;
    --  
    --  local state = ng_global.progress["std"]["win_ceiling"].state;
    --  
    --  for i = 1, state do
    --    
    --    ObjSet( "spr_ceiling_mmg_box_"..i, { alp = 0, input = false } );
    --    ObjSet( "spr_ceiling_box_"..i, { alp = 1 } );
    --    ObjSet( "spr_ceiling_back", { scale_x = private.mmg_ceiling_zoom_scale[ state ],
    --                                  scale_y = private.mmg_ceiling_zoom_scale[ state ],
    --                                  pos_x = private.mmg_ceiling_zoom_coords[ state ][1],
    --                                  pos_y = private.mmg_ceiling_zoom_coords[ state ][2] });  
        
      

    end;
  

  end;
 
  cmn.AddSubscriber( "win_wall", win_wall, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function clk_ceiling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_ceiling" ] = {
    type = "click",
    use_place = "spr_ceiling_open",
    room = private.room_objname,
    zz_gate = "gzz_studio_ceiling",
    zz = "zz_ceiling"
  };

  local clk_ceiling_end = function ()
  
    ObjDelete( "gzz_studio_ceiling" );
    ObjSet( "grm_studio_roof", { active = true, input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_studio_roof_focus");
    end;
    ObjSet( "spr_studio_ceiling_door_open", { alp = 1 } );
    ObjDelete( "spr_studio_ceiling_door_close" );
    ObjSet( "anm_studio_open_hath", { alp = 1, playing = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_ceiling", clk_ceiling_end, private.room_objname );
  cmn.AddSubscriber( "clk_ceiling_end", clk_ceiling_end, private.room_objname );
  
  ----------------------------------------------------------------------------------------------
  -- function dlg_studio_calling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_studio_calling" ] = {
    type = "click",
    use_place = "obj_studio_dlg_calling",
    room = private.room_objname
  };
  local dlg_studio_calling_beg = function ()

    ObjDelete( "obj_studio_dlg_calling");
    
  end;

  local dlg_studio_calling_inv = function ()
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_studio_calling_beg", dlg_studio_calling_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_studio_calling_inv", dlg_studio_calling_inv );
  cmn.AddSubscriber( "dlg_studio_calling", dlg_studio_calling_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_studio_calling", dlg_studio_calling_inv );
  
  --------------------------------------------------------------------------------------------
  -- function win_studioroom () end;
  --------------------------------------------------------------------------------------------
  local win_studioroom = function ()

    if ( cmn.IsEventDone( "win_studioroom" ) ) then

      ObjDelete( "gho_studio_studioroom" );

    end;

  end;

  cmn.AddSubscriber( "win_studioroom", win_studioroom, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_studio () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_studio" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_studio_loupe_mg",
   
  };

  local win_studio = function ()
  
    if cmn.IsEventDone( "win_studio" ) then

      ObjDelete( "obj_studio_loupe_mg" );
      
    else
      
      for i = 1, 2 do
        
        for j = 1, 4 do
          
          for k = 1, 4 do
            
            if ng_global.progress["std"]["win_studio"].saves[i][j][k] == 1 then
              
              local pos_star = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "obj_studio_loupe_mg" );
              
              local pos_star_2 = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..(3-i).."_"..k, "obj_studio_loupe_mg" );
              
              private.loupe_mmg_make_line( pos_star, pos_star_2, (3-i), k, i, j, true );
              
              private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
              
              ObjSet( "spr_studio_loupe_mg_sign_"..(3-i).."_"..k.."_light", { alp = 1 } );
              
              ObjSet( "spr_studio_loupe_mg_sign_"..i.."_"..j, { input = false } );
  
            end;
            
          end;
          
        end;
        
      end;
      
    end;
  
  end;

  cmn.AddSubscriber( "win_studio", win_studio, private.room_objname );  
 
  --------------------------------------------------------------------------------------------
  -- function vid_studio_loupe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_studio_loupe" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_studio_loupe",
    
  };

  local vid_studio_loupe = function ()

    ObjSet( "gzz_studio_ceiling", { input = true, active = true } );
  
  end;

  cmn.AddSubscriber( "vid_studio_loupe", vid_studio_loupe, private.room_objname ); 
 
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_ceiling" );
  subroom.Define( "zz_directordashboard" );
  subroom.Define( "zz_wall" );
  
  function zz_ceiling.Open()
    
    if cmn.IsEventDone( "use_box" ) and not cmn.IsEventDone( "win_ceiling" ) then
      
      cmn.MiniGameShow( "ceiling" );
      
    end;
     
  end;
   
  function zz_ceiling.Close()
    
    if cmn.IsEventDone( "use_box" ) and not cmn.IsEventDone( "win_ceiling" ) then
      
      cmn.MiniGameHide( "ceiling" );
      
    end;
     
  end;
  ---------------------------------------------------------------------------------------------
  function zz_wall.Open()
    
    if cmn.IsEventDone( "use_figurinepart1" ) and cmn.IsEventDone( "use_figurinepart2" ) and cmn.IsEventDone( "use_figurinepart3" ) and not cmn.IsEventDone( "win_wall" ) then
      
       cmn.MiniGameShow( "wall" );
      
    end;
     
   end;
   
  function zz_wall.Close()
    
    if cmn.IsEventDone( "use_figurinepart1" ) and cmn.IsEventDone( "use_figurinepart2" ) and cmn.IsEventDone( "use_figurinepart3" ) and not cmn.IsEventDone( "win_wall" ) then
      
      cmn.MiniGameHide( "wall" );
      
    end;
     
  end;
  --------------------------------------------------------------------------------------------
  function zz_directordashboard.PreOpen()
    
    if not common_impl.studio then

      common_impl.studio = {}
      common_impl.studio.note = "close";

    end;
    
    if  ObjGet( "spr_directordashboard_note" ).input == true then

      ObjSet( "spr_directordashboard_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_directordashboard_note",     { alp = 1 } );
      
    end;
    
      private.LoadState();
      private.Update();
  
    if cmn.IsEventDone( "use_lever_3" ) and not cmn.IsEventDone( "win_console" ) then
    
      cmn.MiniGameShow( 'console' );
      common_impl.PassingMgStart( "console" );
      
    end;
 
  end;
  --------------------------------------------------------------------------------------------
  function zz_directordashboard.PreClose()

    if cmn.IsEventDone( "use_lever_3" ) and not cmn.IsEventDone( "win_console" ) then

      cmn.MiniGameHide( 'console' );
      common_impl.PassingMgStop( "console" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_directordashboard.Close()

    common_impl.studio.note = "close"; 
    
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_studio();
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.LoupeMgCheck();

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level3/aud_studio_env" }, "", 0.5 );
  
  if private.playing_sound then
    
    common_impl.StopAllMus();   
    common_impl.PlayAudio( "mus", "common/audio/level3/aud_studio_mus", 1, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  common_impl.StopAudio( "mus", "common/audio/level3/aud_studio_mus", 0.5 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lever_3()

  local item = "inv_lever_3";

  if ( common.ApplyObj( item, "obj_directordashboard_use_lever_3", true ) and common_impl.studio.note == "close" ) then

    cmn.CallEventHandler( "use_lever_3_inv" );
    cmn.CallEventHandler( "use_lever_3_beg" );

    local func_after = function ()
    
      local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_lever_3" );
        cmn.CallEventHandler( "use_lever_3_end" );
        
        cmn.MiniGameShow( 'console' );
        common_impl.PassingMgStart( "console" );
        
      end;
      
      ObjAnimate( "obj_directordashboard_mmg", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_lever_directordashboard", 0, "", 0 );

    ObjAnimate( "spr_directordashboard_lever", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_directordashboard_mini_mg", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,  
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_studio_directordashboard", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_directordashboard", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_box()

  local item = "inv_box_3";

  if ( common.ApplyObj( item, "obj_ceiling_use_box", true ) ) and ( cmn.IsEventDone( "get_box1" ) and cmn.IsEventDone( "get_box2") and cmn.IsEventDone( "get_box3") and cmn.IsEventDone( "get_box4" )) then
    cmn.CallEventHandler( "use_box_inv" );
    cmn.CallEventHandler( "use_box_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_box" );
      cmn.CallEventHandler( "use_box_end" );
   
      cmn.MiniGameShow( "ceiling" );
      
      ng_global.progress["std"]["win_ceiling"].state = 0;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_box_ceiling", 0, "", 0 );
  
    ObjAnimate( "obj_ceiling_mmg", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_studio_ceiling", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ceiling", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_figurinepart1()

  local item = "inv_figurinepart1";

  if ( common.ApplyObj( item, "obj_wall_use_figurinepart1", true ) ) then

    cmn.CallEventHandler( "use_figurinepart1_inv" );
    cmn.CallEventHandler( "use_figurinepart1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_figurinepart1" );
      cmn.CallEventHandler( "use_figurinepart1_end" );
       if ( cmn.IsEventDone( "use_figurinepart2" ) and cmn.IsEventDone( "use_figurinepart3" ) ) then
         cmn.MiniGameShow( 'wall' );
        common_impl.PassingMgStart( "wall" );
        --ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 4,  5, 3 },
        --                                                    {  6,  7,  8,  10, 9 },
        --                                                    { 23, 12,  13,  14, 15 },
        --                                                    { 16, 11, 18, 19, 20 },
        --                                                    --{ 21, 22, 17, 24, 25 } };  
        --                                                     { 21, 17, 22, 24, 25 } }; 
        ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 3,  4, 5 },
                                                      {  6,  7,  13,  8, 10 },
                                                      { 11, 12,  18,  9, 15 },
                                                      { 16, 17, 23, 14, 20 },
                                                      { 21, 22, 24, 19, 25 } };                                                     
                                                             
      end;
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_figurnepart_wall", 0, "", 0 );
  
  ObjAnimate( "spr_wall_figurinepart_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_studio_wall", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_figurinepart2()

  local item = "inv_figurinepart2";

  if ( common.ApplyObj( item, "obj_wall_use_figurinepart2", true ) ) then

    cmn.CallEventHandler( "use_figurinepart2_inv" );
    cmn.CallEventHandler( "use_figurinepart2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_figurinepart2" );
      cmn.CallEventHandler( "use_figurinepart2_end" );
      if ( cmn.IsEventDone( "use_figurinepart1" ) and cmn.IsEventDone( "use_figurinepart3" ) ) then
         cmn.MiniGameShow( 'wall' );
        common_impl.PassingMgStart( "wall" );
        --ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 4,  5, 3 },
        --                                                    {  6,  7,  8,  10, 9 },
        --                                                    { 23, 12,  13,  14, 15 },
        --                                                    { 16, 11, 18, 19, 20 },
        --                                                    --{ 21, 22, 17, 24, 25 } }; 
        --                                                    { 21, 17, 22, 24, 25 } }; 
        ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 3,  4, 5 },
                                                      {  6,  7,  13,  8, 10 },
                                                      { 11, 12,  18,  9, 15 },
                                                      { 16, 17, 23, 14, 20 },
                                                      { 21, 22, 24, 19, 25 } };  
                                                            
      end;
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_figurnepart_wall", 0, "", 0 );
  
  ObjAnimate( "spr_wall_figurinepart_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_studio_wall", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_figurinepart3()

  local item = "inv_figurinepart3";

  if ( common.ApplyObj( item, "obj_wall_use_figurinepart3", true ) ) then

    cmn.CallEventHandler( "use_figurinepart3_inv" );
    cmn.CallEventHandler( "use_figurinepart3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_figurinepart3" );
      cmn.CallEventHandler( "use_figurinepart3_end" );
      if ( cmn.IsEventDone( "use_figurinepart2" ) and cmn.IsEventDone( "use_figurinepart1" ) ) then
         cmn.MiniGameShow( 'wall' );
        common_impl.PassingMgStart( "wall" );
        --ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 4,  5, 3 },
        --                                                    {  6,  7,  8,  10, 9 },
        --                                                    { 23, 12,  13,  14, 15 },
        --                                                    { 16, 11, 18, 19, 20 },
        --                                                    --{ 21, 22, 17, 24, 25 } };  
        --                                                    { 21, 17, 22, 24, 25 } }; 
        ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 3,  4, 5 },
                                                      {  6,  7,  13,  8, 10 },
                                                      { 11, 12,  18,  9, 15 },
                                                      { 16, 17, 23, 14, 20 },
                                                      { 21, 22, 24, 19, 25 } }; 
      end;
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_figurnepart_wall", 0, "", 0 );
  
    ObjAnimate( "spr_wall_figurinepart_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_studio_wall", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_device_3()

  --cmn.CallEventHandler( "use_device_3_inv" );
  --cmn.CallEventHandler( "use_device_3_beg" );

  local func_after = function ()
   
    cmn.SetEventDone( "use_device_3" );
    cmn.CallEventHandler( "use_device_3_end" );
    
    common_impl.LoupeMgStart();
 
  end;
  
  func_after();

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_box1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_box1" );
  cmn.CallEventHandler( "get_box1" );

end;
--------------------------------------------------------------------------------------------
function private.get_figurinepart2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_figurinepart2" );
  cmn.CallEventHandler( "get_figurinepart2" );

end;
--------------------------------------------------------------------------------------------
function private.get_figurinepart3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_figurinepart3" );
  cmn.CallEventHandler( "get_figurinepart3" );

end;
--------------------------------------------------------------------------------------------
function private.get_fastingelement()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fastingelement" );
  cmn.CallEventHandler( "get_fastingelement" );
  if cmn.IsEventDone("get_clip_3") then 
     
    if cmn.IsEventDone("get_box2") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
       
       common.CloseSubRoom();
       
     end;  
     
   end;  

end;
--------------------------------------------------------------------------------------------
function private.get_clip_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_clip_3" );
  cmn.CallEventHandler( "get_clip_3" );
  
   if cmn.IsEventDone("get_fastingelement") then 
     
     if cmn.IsEventDone("get_box2") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
       
       common.CloseSubRoom();
       
     end;  
     
   end;  

end;
--------------------------------------------------------------------------------------------
function private.get_box2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_box2" );
  cmn.CallEventHandler( "get_box2" );
  
  if cmn.IsEventDone( "get_clip_3") and cmn.IsEventDone( "get_fastingelement") and common_impl.IsGetCollect( "get_collect_2_3_3" ) then 
      
     common.CloseSubRoom();
      
   end;  
 
end;
 --*********************************************************************************************************************
function private.get_collect_2_3_3()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_3_3");
    cmn.CallEventHandler("get_collect_2_3_3");

    if cmn.IsEventDone( "get_box2" ) and cmn.IsEventDone( "get_fastingelement") and cmn.IsEventDone( "get_clip_3") then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_wall_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_lamp_1()
  
  local func_after = function () 
  
    common_impl.Lock( false );
      
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_studio_lamp' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_lamp_1_studio", 0, "", 0 );
  AnimPlay( "anm_studio_lamp_1", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_lamp_2()
  
  local func_after = function () 
  
    common_impl.Lock( false );
      
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_studio_lamp' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_lamp_2_studio", 0, "", 0 );
  AnimPlay( "anm_studio_lamp_2", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_lamp_3()
  
  local func_after = function () 
  
    common_impl.Lock( false );
      
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_studio_lamp' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_lamp_3_studio", 0, "", 0 );
  AnimPlay( "anm_studio_lamp_3", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_lamp_4()
  
  local func_after = function () 
  
    common_impl.Lock( false );
      
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_studio_lamp' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_lamp_4_studio", 0, "", 0 );
  AnimPlay( "anm_studio_lamp_4", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_bear()
  
  local func_after = function () 
  
    common_impl.Lock( false );
      
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_studio_bear' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_bear_studio", 0, "", 0 );
  AnimPlay( "anm_studio_bear", "DoAnim", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_ceiling()
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_ceiling" );
    cmn.CallEventHandler( "clk_ceiling_end" );
    
    common.CloseSubRoom();
      
  end;
    
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_door_ceiling", 0, "", 0 );

  ObjAnimate( "spr_ceiling_open", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
 
end;
--------------------------------------------------------------------------------------
function private.ClkWallCap( i )
  
  local func_after = function () 
  
     common_impl.Lock( false );
  
  end;
   
  common_impl.Lock( true ); 
  
  common_impl.ShowBbt( 'bbt_wall_use_figurinepart'..i );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_cap_wall", 0, "", 0 );
  
  ObjAnimate( "spr_wall_puzzle_cap", "pos_x", 0, 0, func_after, { 0,0,45, 0.3,0,47, 0.6, 0, 45 } );

end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--пятнашки
function private.ClkPart( num )

  local func_after = function()

    common_impl.Lock( false );

    private.SaveState( num );

  end;

  local posx = ObjGet( "obj_wall_mmg_puzzle_"..num ).pos_x;
  local posy = ObjGet( "obj_wall_mmg_puzzle_"..num ).pos_y;

  local posxNew;
  local posyNew;
  
  local posi;
  local posj;

  for i = 1, 5 do
    for j = 1, 5 do

      if ( private.state_wall[ i ][ j ] == num ) then

         posi = i;
         posj = j;

       elseif ( private.state_wall[ i ][ j ] == 23 ) then

         posi_null = i;
         posj_null = j;
       
      end;

    end;
  end;
  
  if ( ( math.abs( posi - posi_null ) == 1 ) and ( ( posj - posj_null ) == 0 ) ) or
     ( ( math.abs( posj - posj_null ) == 1 ) and ( ( posi - posi_null ) == 0 ) ) then

    posxNew = private.coords[ posi_null ][ posj_null ][ 1 ];
    posyNew = private.coords[ posi_null ][ posj_null ][ 2 ];

  end

  if ( not ( posxNew and posyNew ) ) then return; end;

  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_wall_touch_square", 0, "", 0 );

  common_impl.Lock( true );

  ObjAnimate( "obj_wall_mmg_puzzle_"..num, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0,    posx,    posy,
    0.3, 0, posxNew, posyNew,
  } ); 

end;
------------------------------------------------------------------------------------
function private.SaveState( num )

  local posi, posj, posi_null, posj_null;
  local tmp_array = {};

  for i = 1, 5 do
    
    tmp_array[ i ] = {};

    for j = 1, 5 do

      tmp_array[ i ][ j ] =  private.state_wall[ i ][ j ];

      if ( tmp_array[ i ][ j ] == num ) then

         posi = i;
         posj = j;

       elseif ( tmp_array[ i ][ j ] == 23 ) then

        posi_null = i;
        posj_null = j;
  
      end;

    end;
  end;

  tmp_array[ posi ][ posj ] = 23;
  tmp_array[ posi_null ][ posj_null ] = num;

  for i = 1,5 do
     
    for j = 1,5 do

      ng_global.progress[ "std" ] [ "win_wall" ].state[i][j] = private.state_wall[i][j];

      end;
      
    end;

    ng_global.progress[ "std" ] [ "win_wall" ].state[ posi ][ posj ] = 23;
    ng_global.progress[ "std" ] [ "win_wall" ].state[ posi_null ][ posj_null ] = num;
    
    if private.CheckWin() then  private.WinWall() end;

    private.state_wall[ posi ][ posj ] = 23;
    private.state_wall[ posi_null ][ posj_null ] = num;
    
    --private.CheckRotation( posi_null, posj_null, posi, posj );

end;
------------------------------------------------------------------------------------
function private.GetCoords() 
  
  local start_x = -157;
  local start_y = -171
  
  for i = 1, 5 do
    
    for j = 1, 5 do 
      
      private.coords[i][j][1] = start_x + 80*( j - 1 );
      private.coords[i][j][2] = start_y + 80*( i - 1 );
      
      --DbgTrace( i.." "..j.."    "..private.coords[i][j][1].."  "..private.coords[i][j][2] );
      
    end;
    
  end;
    
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  answer = false;
  local count = 0;
  
  for i = 1, 5  do
    
    for j = 1, 5 do
    
      if ng_global.progress[ "std" ][ "win_wall" ].state[i][j] == private.win_wall[i][j] then
         
        count = count + 1; 
        
      end;
    
    end;
  end;
  
  if count == 25 then answer  = true; end;
    
  return answer;
  
end;  
-----------------------------------------------------------------------------------
function private.DefaultState()
  
  private.contact = { { 1, 2, 3 },{ 4, 6, 5 } };
  private.state = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  ng_global.progress[ "std" ][ "win_console" ].mmg = {};
  ng_global.progress[ "std" ][ "win_console" ].mmg.contact = { { 1, 2, 3 },{ 4, 6, 5 } };
  
end;
----------------------------------------------------------------------------------------------------
function private.LoadState()
  
  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_console" ];
  
  if not progress.contact then
    
    private.DefaultState();
    
  end;

  for kk = 1,3,1 do

    private.CreateWire( kk );

    for gg = 1,25,1 do

      private.UpdateWire( "1",kk );

    end;

  end;

end;
----------------------------------------------------------------------------------------------------
function private.CreateWire ( num )

  private.wires[ num ] = {};
  
  local x1 = private.wire_pos[ 1 ][ ( private.contact[ 1 ][ num ] ) ];
  local y1 = private.wire_pos[ 2 ][ ( private.contact[ 1 ][ num ] ) ];
  local x2 = private.wire_pos[ 1 ][ ( private.contact[ 2 ][ num ] ) ];
  local y2 = private.wire_pos[ 2 ][ ( private.contact[ 2 ][ num ] ) ];

  local i;
  
  for i = 1, private.WIRE_P, 1 do

    local wireinfo = {};
    wireinfo.x = x1 + ( x2 - x1 ) / private.WIRE_P * ( i - 1 );
    wireinfo.y = y1 + ( y2 - y1 ) / private.WIRE_P * ( i - 1 );
    wireinfo.vx = 0;
    wireinfo.vy = 0;
    table.insert( private.wires[ num ], wireinfo );
    ObjSet( "spr_directordashboard_wire_"..num.."_"..i, { pos_x = wireinfo.x, pos_y = wireinfo.y } );

  end;

end;
----------------------------------------------------------------------------------------------------
function private.ClkWire ( dir1, dir2 )

  ObjSet( "spr_directordashboard_contact_1"..dir2, { pos_z = 3 } );
  ObjSet( "spr_directordashboard_contact_2"..dir2, { pos_z = 3 } );

  for i = 1, private.WIRE_P, 1 do

    ObjSet( "spr_directordashboard_wire_"..dir2.."_"..i, { pos_z = 2 } );

  end;

end;
----------------------------------------------------------------------------------------------------
function private.Update ()
  
  for i = 1,2,1 do

    for j = 1,3,1 do 

      private.state[ ( private.contact[ i ][ j ] ) ] = j;
      ObjSet( "spr_directordashboard_contact_"..i..j, 
        { 
          pos_x = private.wire_pos[ 1 ][ ( private.contact[ i ][ j ] ) ], 
          pos_y = private.wire_pos[ 2 ][ ( private.contact[ i ][ j ] ) ] 
        } );

    end;

  end;    
  
end;
----------------------------------------------------------------------------------------------------
function private.StartDragWire ( dir1 , dir2 )
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_console_touch_wire", 0, "", 0 );

end;
-----------------------------------------------------------------------------------------------------
function private.UpdateWire ( dir1, dir2, num )


  local x1 = private.wire_pos[ 1 ][( private.contact[ 1 ][ dir2 ])];
  local y1 = private.wire_pos[ 2 ][( private.contact[ 1 ][ dir2 ])];
  local x2 = private.wire_pos[ 1 ][( private.contact[ 2 ][ dir2 ])];
  local y2 = private.wire_pos[ 2 ][( private.contact[ 2 ][ dir2 ])];

  if num == 1 then

    if dir1 == 1 then 

      x1 = GetZoomCursorPos()[ 1 ] - 512;
      y1 = GetZoomCursorPos()[ 2 ] - 384;
      x2 = private.wire_pos[ 1 ][ ( private.contact[ 2 ][ dir2 ] ) ];
      y2 = private.wire_pos[ 2 ][ ( private.contact[ 2 ][ dir2 ] ) ];

    else

      x1 = private.wire_pos[ 1 ][ ( private.contact[ 1 ][ dir2 ] ) ];
      y1 = private.wire_pos[ 2 ][ ( private.contact[ 1 ][ dir2 ] ) ];
      x2 = GetZoomCursorPos()[ 1 ]- 512;
      y2 = GetZoomCursorPos()[ 2 ]- 384;

    end;

  end;

  local wire = private.wires[ dir2 ];

  for i = private.WIRE_P,1,-1 do
    local node = wire[ i ];
    if  i == 1 then
      node.x = x1;
      node.y = y1;
    end;

    local vx = node.vx;
    local vy = node.vy;
    local a_x = node.x;
    local a_y = node.y;

    local nextnode = wire[ i + 1 ];
    local n_x = i < private.WIRE_P and nextnode.x or x2;
    local n_y = i < private.WIRE_P and nextnode.y or y2;

    if i > 1 then

      local prevnode = wire[ i - 1 ];
      local p_x = prevnode.x;
      local p_y = prevnode.y;

      vx = vx + ( p_x - a_x ) / private.TEN;
      vy = vy + ( p_y - a_y ) / private.TEN;
      vx = vx + ( n_x - a_x ) / private.TEN;
      vy = vy + ( n_y - a_y ) / private.TEN;
      vy = vy + private.GRAV;
      vx = vx * private.REL;
      vy = vy * private.REL;

      node.x = a_x + vx;
      node.y = a_y + vy;
      node.vx = vx;
      node.vy = vy;

    end;

    local dx = node.x - n_x;
    local dy = node.y - n_y;

    ObjSet( "spr_directordashboard_wire_"..dir2.."_"..i, { } );
    ObjSet( "spr_directordashboard_wire_"..dir2.."_"..i, { pos_x = node.x, pos_y = node.y
                                                     ,scale_x = math.sqrt( dx^2 + dy^2 )/25
                                                     ,ang = math.atan2( dy, dx)*-1  } );
                                                   
  end;

end;
-----------------------------------------------------------------------------------------------------
function private.DropWire ( dir1, dir2 )
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_console_set_wire", 0, "", 0 );

  local xx = GetZoomCursorPos()[ 1 ] - 512;
  local yy = GetZoomCursorPos()[ 2 ] - 384;
    if  tostring(GetPlatform()) == "android" then
      yy = yy - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        yy = yy - 75;
      else
        yy = yy - 50;
      end;
    end;
    
  local obj = "spr_directordashboard_contact_"..dir1..dir2;
  local con = private.contact[ dir1 ][ dir2 ];
  local true_drop = false;

  ObjSet( "spr_directordashboard_contact_1"..dir2, { pos_z = 1 } );
  ObjSet( "spr_directordashboard_contact_2"..dir2, { pos_z = 1 } );
  
  for i = 1, private.WIRE_P, 1 do

    ObjSet( "spr_directordashboard_wire_"..dir2.."_"..i, { pos_z = 0 } );

  end;

  for i = 1, 7, 1 do
    
    if xx >= private.wire_pos[ 1 ][ i ] - 15 and
       xx <= private.wire_pos[ 1 ][ i ] + 15 and
       yy >= private.wire_pos[ 2 ][ i ] - 15 and
       yy <= private.wire_pos[ 2 ][ i ] + 15 and 
       private.state[ i ] == 0 then
      
      private.state[ i ] = dir2;
      private.state[ con ] = 0;
      private.contact[ dir1 ][ dir2 ] = i;
      ObjSet( obj, { pos_x = private.wire_pos[ 1 ][ i ], pos_y = private.wire_pos[ 2 ][ i ] } );

      true_drop = true;

      break;        

    end;

  end;

  for j = 1,50,1 do

    private.UpdateWire( dir1, dir2 );

  end;

  private.Update();
  
  if ( private.CheckWinWire() ) then

    private.WinWireEnd();

  else

    for i = 1, #private.contact , 1 do

      for j = 1, #private.contact[ i ], 1 do 

        ng_global.progress[ "std" ][ "win_console" ].mmg.contact[ i ][ j ] = private.contact[ i ][ j ];         

      end; 

    end;

  end;

end;
-----------------------------------------------------------------------------------------------------
function private.CheckWinWire ()

  local count = 0;
  local bool = false;

  local wire_sum = { 19, 10, 11, 7, 14, 13, 0 };  
  
  for i = 1, #private.contact[ 1 ],1  do
    
    if( ( wire_sum [ private.contact[ 1 ][ i ] ] + wire_sum [ private.contact[ 2 ][ i ] ] == 17 ) or ( wire_sum [ private.contact[ 1 ][ i ] ] + wire_sum [ private.contact[ 2 ][ i ] ] == 24 )
      or ( wire_sum [ private.contact[ 1 ][ i ] ] + wire_sum [ private.contact[ 2 ][ i ] ] == 33 ) ) then 
      
      count = count + 1;
      
    end; 
  
  end;

  if ( count == 3 ) then 

    bool = true;

  end;
  
  return bool;

end;
-----------------------------------------------------------------------------------------------------
function private.WinWireEnd ()

  common_impl.Lock( false );
  
  for i = 1, #private.contact , 1 do

    for j = 1, #private.contact[ i ], 1 do 

      ng_global.progress[ "std" ][ "win_console" ].mmg.contact[ i ][ j ] = private.contact[ i ][ j ];         

    end; 

  end;  
 
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_console_win", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide( "console" );
  common_impl.PassingMgWin( "console" );
  cmn.SetEventDone( "win_console" );
  cmn.CallEventHandler( "win_console" );
  common.CloseSubRoom();

end;
----------------------------------------------------------------------------------------------
function private.WinWall ()

  local func_after = function()

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
    common_impl.Lock( false );
    cmn.MiniGameHide( "wall" );
    common_impl.PassingMgWin( "wall" );
    cmn.SetEventDone( "win_wall" );
    cmn.CallEventHandler( "win_wall" );
    

  end;
 
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_wall_win", 0, "", 0 );
  
  ObjSet( "obj_wall_mmg_open", { alp = 1 } );
 
  AnimPlay( "anm_wall_mmg_open", "DoAnim", func_after ); 

end;
-----------------------------------------------------------------------------------------------------
function private.WinState()
  
  local progress = ng_global.progress[ ng_global.currentprogress ][ "win_console" ];
  progress.contact = { { 1, 2, 3 },{ 5, 4, 6 } };
  
end;
-----------------------------------------------------------------------------------------------------
function private.SkipWire()
  
  private.WinState();
  private.Update();
  private.WinWireEnd();
  
end;
----------------------------------------------------------------------------------------------------
function private.SkipWall()
  
  for i = 1, 5 do
    
    for j = 1, 5 do
      
      ObjSet("obj_wall_mmg_puzzle_"..private.win_wall[i][j], { pos_x = private.coords[i][j][1], pos_y = private.coords[i][j][2]});
      
    end;
    
  end;
  
   ObjSet( "tmr_wall_win",
    {
      time = 1.0,
      playing = true,
      endtrig = function() private.WinWall(); end
    } );
  
  
end;
-----------------------------------------------------------------------------------------------------
function private.ResetWire()
  
  private.DefaultState(); 

  for kk = 1,3,1 do

    private.CreateWire( kk );

    for gg = 1,25,1 do

      private.UpdateWire( "1",kk );

    end;

  end;

  private.Update();
  
end;
----------------------------------------------------------------------------------------------
function private.ResetWall()
  
  --ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 4,  5, 3 },
  --                                                          {  6,  7,  8,  10, 9 },
  --                                                          { 23, 12,  13,  14, 15 },
  --                                                          { 16, 11, 18, 19, 20 },
  --                                                          { 21, 17, 22, 24, 25 } };
  ng_global.progress[ "std" ][ "win_wall" ].state = { {  1,  2, 3,  4, 5 },
                                                      {  6,  7,  13,  8, 10 },
                                                      { 11, 12,  18,  9, 15 },
                                                      { 16, 17, 23, 14, 20 },
                                                      { 21, 22, 24, 19, 25 } };  
  for i = 1, 5 do
    
    for j = 1, 5 do
      
      ObjSet("obj_wall_mmg_puzzle_"..ng_global.progress[ "std" ][ "win_wall" ].state[i][j], { pos_x = private.coords[i][j][1], pos_y = private.coords[i][j][2]});
      
    end;
    
  end; 
  
  private.state_wall =  ng_global.progress[ "std" ][ "win_wall" ].state;
  
end;
-----------------------------------------------------------------------------------------------------
function private.opn_studio()

  if not ( cmn.IsEventDone( "opn_studio" ) ) then
    
    cmn.SetEventDone( "opn_studio" );
    
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
    
  end;
  
  cmn.CallEventHandler( "opn_studio" ); 

end;
-----------------------------------------------------------------------------------------------------
function private.menter_play_sound()
  
  local tme = 0.3;
  
  local obj = "spr_directordashboard_button_glow";

  common_impl.SetCursor( CURSOR_HAND );

  local alp = ObjGet( obj ).alp;

  local alp_end = 1;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, alp_end
  } );
  
end;
-----------------------------------------------------------------------------------------------------
function private.mleave_play_sound()
  
  local tme = 0.3;
  
  local obj = "spr_directordashboard_button_glow";

  common_impl.SetCursor( CURSOR_HAND );

  local alp = ObjGet( obj ).alp;

  local alp_end = 0;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, alp_end
  } );
  
end;
-----------------------------------------------------------------------------------------------------
function private.clk_play_sound()
 
  if not private.playing_sound then
 
    common_impl.StopAllMus();   
    common_impl.PlayAudio( "mus", "common/audio/level3/aud_studio_mus", 1, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_button_on_directordashboard", 0, "", 0 );
    
    private.playing_sound = true;
    
    ObjSet( "spr_directordashboard_button_press", { alp = 1 } );
    ObjSet( "spr_directordashboard_indicator_green", { alp = 1 } );
    ObjSet( "spr_directordashboard_indicator_red", { alp = 0 } );
    
  else
    
    common_impl.StopAudio( "mus", "common/audio/level3/aud_studio_mus", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_button_off_directordashboard", 0, "", 0 );
    
    private.playing_sound = false;
    
    ObjSet( "spr_directordashboard_button_press", { alp = 0 } );
    ObjSet( "spr_directordashboard_indicator_green", { alp = 0 } );
    ObjSet( "spr_directordashboard_indicator_red", { alp = 1 } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.dlg_studio_calling()
  
  local func_after = function()
  
    local func_after_anim = function()
    
      common_impl.Lock( false );
      
      ObjSet( "anm_studio_tablet", { visible = false, active = false } );
      
      ObjAttach( "dlg_studio_calling", private.room_objname );
      ObjSet("anm_studio_calling_loc", { alp = 0 });
      cmn.CallEventHandler( "dlg_studio_calling_beg" );
      
      common_impl.dialog_character_loc = "";
      common_impl.continue_visible = true;
      common_impl.DialogCharacterStart( "calling", 3, nil, nil, true, "dlg_studio_calling_end" );
       
      ObjAnimate( "rm_studio", "color_rgb", 0, 0, "", { 0,0,0,0,0, 0.3,0,1,1,1 } );
      
      common_impl.PlayAudio( "env", "common/audio/level1/aud_tablet_env", 1, "", 0 );
    
    end;
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_switch_on", 0, "", 0 );
    
    ObjAnimate( "rm_studio", "color_rgb", 0, 0, func_after_anim, { 0,0,1,1,1, 0.3,0,0,0,0 } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_studio_tablet", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_studio_tablet", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function public.dlg_studio_calling_end()
  
  local func_after_anim = function() 
  
    common_impl.Lock( false );

    if not cmn.IsEventDone( "dlg_studio_calling" ) then

      cmn.SetEventDone( "dlg_studio_calling" );
      ObjSet( "spr_studio_calling_hairpin", { alp = 1 } );
      cmn.CallEventHandler( "dlg_studio_calling_inv" );
      common_impl.ShowBbt( "bbt_dlg_studio_calling", 1 );

    end;
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_tablet_env", 0 );
 
  common_impl.PlayAudio( "sfx", "common/audio/level1/aud_tablet_on", 0, "", 0 );
  
  ObjSet( "anm_studio_tablet_2", { visible = true, active = true, alp = 1 } );
  
  AnimPlay( "anm_studio_tablet_2", "DoAnim", func_after_anim );

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "calling" then
    
    if txt_count == 3 then
      
     
      
    end;
    
  end;        
  
end;
--*********************************************************************************************************************
function public.Skip( name )

  if name == "win_ceiling" then

    private.mmg_ceiling_skip();
    
  end;

  if name == "win_console" then
    
    private.SkipWire();
    
  end;
  
  if name == "win_wall" then
    
    private.SkipWall();
    
  end;
  
  if name == "win_studio" then

    private.skip_loupe();
    
  end;
  
end;
--*********************************************************************************************************************
function public.Reset( name )

  if name == "win_ceiling" then
    
    private.mmg_ceiling_wrong_anim();
  
  end;
  
  if name == "win_console" then
    
    private.ResetWire();
    
  end;
  
  if name == "win_wall" then
    
    private.ResetWall();
    
  end;
  
  if event == "win_studio" then
    
    private.loupe_mmg_wrong_anim();
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
function private.mmg_ceiling_clk_box( number )
  
  local state = ng_global.progress["std"]["win_ceiling"].state;

  if number == private.mmg_ceiling_state[state+1] then
    
    local func_after = function()
    
      local func_end = function()
 
        ng_global.progress["std"]["win_ceiling"].state = number;

        if number == 4 then
          
          local func_win = function()
          
            common_impl.Lock( false );
            
            private.mmg_ceiling_win();
            
          end;
          
         ObjAnimate( "obj_ceiling_mmg", "alp", 0, 0, func_win, { 0,0,1, 0.3,0,0 } ); 
          
        else
          
           common_impl.Lock( false );
            
        end;
      
      end;
      
      local old_scale = 1;
      local new_scale = private.mmg_ceiling_zoom_scale[number];
      
      if private.mmg_ceiling_zoom_scale[number-1] then
        
         old_scale = private.mmg_ceiling_zoom_scale[number-1];
        
      end;
       
      local old_pos = ObjGet( "spr_ceiling_back" );
      local new_pos = private.mmg_ceiling_zoom_coords[number];
    
      ObjAnimate( "spr_ceiling_back", "scale_xy", 0, 0, func_end, { 0,0,old_scale,old_scale, 0.5,0,new_scale,new_scale } );
      ObjAnimate( "spr_ceiling_back", "pos_xy", 0, 0, "", { 0,0,old_pos.pos_x,old_pos.pos_y, 0.5,0,new_pos[1],new_pos[2] } );
       
      ObjSet( "spr_ceiling_mmg_box_"..number, { input = false } );
      ObjSet( "spr_studio_ceiling_box_"..number, { alp = 1 } );
      
    end;
  
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_ceiling_right", 0, "", 0 );    

    ObjAnimate( "spr_ceiling_box_"..number, "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
    ObjAnimate( "spr_ceiling_mmg_box_"..number, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    
  else
    
    private.mmg_ceiling_wrong_anim();

    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_mg_ceiling_wrong", 0, "", 0 );    
    
  end;
  
end;
--*********************************************************************************************************************
function private.mmg_ceiling_wrong_anim()
  
  local state = ng_global.progress["std"]["win_ceiling"].state;
  
  if state ~= 0 then
  
    local func_after = function()
    
      common_impl.Lock( false );
      
      for i = 1, state do
        
        ObjSet( "spr_ceiling_mmg_box_"..i, { input = true } );
        ObjSet( "spr_studio_ceiling_box_"..i, { alp = 0 } );
        
      end;
      
      ng_global.progress["std"]["win_ceiling"].state = 0;
    
    end;
    
    
    common_impl.Lock( true );
    
    for i = 1, state do
      
      ObjAnimate( "spr_ceiling_box_"..i, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_ceiling_mmg_box_"..i, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
   
    end;
    
    local current = ObjGet( "spr_ceiling_back" );
    
    ObjAnimate( "spr_ceiling_back", "scale_xy", 0, 0, func_after, { 0,0,current.scale_x,current.scale_y, 0.3,0,1,1 } );
    ObjAnimate( "spr_ceiling_back", "pos_xy", 0, 0, "", { 0,0,current.pos_x,current.pos_y, 0.3,0,0,0 } );
    
  end;
  
end;
--*********************************************************************************************************************
function private.mmg_ceiling_enter_box( number )
  
  local tme = 0.3;
  
  local obj = "spr_ceiling_mmg_box_"..number.."_light";

  common_impl.SetCursor( CURSOR_HAND );

  local alp = ObjGet( obj ).alp;

  local alp_end = 1;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, alp_end
  } );
  
end;
--*********************************************************************************************************************
function private.mmg_ceiling_leave_box( number )
  
  local tme = 0.3;
  
  local obj = "spr_ceiling_mmg_box_"..number.."_light";

  common_impl.SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;

  local alp_end = 0;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, alp_end
  } );
  
end;
--*********************************************************************************************************************
function private.mmg_ceiling_skip()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
    private.mmg_ceiling_win();
  
  end;
  
  common_impl.Lock( true );
  
  for i = 1, 4 do
    
    local alp = ObjGet( "spr_ceiling_box_"..i ).alp;
    local alp_mmg = ObjGet( "spr_ceiling_box_"..i ).alp;
    
    ObjAnimate( "spr_ceiling_box_"..i, "alp", 0, 0, "", { 0,0,alp, 0.3,0,1 } );
    ObjAnimate( "spr_ceiling_mmg_box_"..i, "alp", 0, 0, "", { 0,0,alp, 0.3,0,0 } );
    
  end;
  
  local current = ObjGet( "spr_ceiling_back" );
  
  local scale = private.mmg_ceiling_zoom_scale[4];
  local pos = private.mmg_ceiling_zoom_coords[4];
    
  ObjAnimate( "spr_ceiling_back", "scale_xy", 0, 0, func_after, { 0,0,current.scale_x,current.scale_y, 0.7,0,scale,scale } );
  ObjAnimate( "spr_ceiling_back", "pos_xy", 0, 0, "", { 0,0,current.pos_x,current.pos_y, 0.7,0,pos[1],pos[2] } );
  
end;
--*********************************************************************************************************************
function private.mmg_ceiling_win()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide( "ceiling" );
  common_impl.PassingMgWin( "ceiling" );         
  cmn.SetEventDone( "win_ceiling" );
  cmn.CallEventHandler( "win_ceiling" ); 
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** LOUPE *** () end;
--*********************************************************************************************************************
function public.vid_studio_loupe()

  local func_after = function ()

    int_loupe.Hide();
  
    cmn.SetEventDone( "vid_studio_loupe" );
    cmn.CallEventHandler( "vid_studio_loupe" );
    common_impl.ShowBbt( 'bbt_vid_studio_loupe', 1 );
    
    private.zoom_ceiling();
 
  end;

  common_impl.Lock( true );
  
  local func_after_man_1 = function ()
  
    local func_after_stand_1 = function ()
        
      local func_after_man_2 = function ()
       
         local func_after_stand_2 = function ()
         
         ObjSet( "anm_studio_loupe_man_2", { alp = 0 } );
    
           ObjSet( "anm_studio_loupe_man_3", { alp = 1, playing = true, endtrig = func_after } );
           
           common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_hide", 0, "", 0 );
         
         end;
  
         ObjAnimate( "spr_studio_loupe_text_2", "alp", 0, 0, func_after_stand_2, { 0,0,0, 0.3,0,1 , 2.3,0,1, 2.6,0,0 } );
         
         common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
       
       end;
       
       ObjSet( "anm_studio_loupe_man_1", { alp = 0 } );
    
       ObjSet( "anm_studio_loupe_man_2", { alp = 1, playing = true, endtrig = func_after_man_2 } );
       
       common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_move", 0, "", 0 );
    
    end;
    
     ObjAnimate( "spr_studio_loupe_text_1", "alp", 0, 0, func_after_stand_1, { 0,0,0, 0.3,0,1 , 1.3,0,1, 1.6,0,0 } );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_txt", 0, "", 0 );
  
  end;

  --common_impl.StopAllMus();
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_device_silhouette_show", 0, "", 0 );
 
  ObjSet( "obj_studio_loupe_anim", { active = true, visible = true } );
  ObjSet( "anm_studio_loupe_man_1", { alp = 1, playing = true, endtrig = func_after_man_1 } );

end;
--*********************************************************************************************************************
function private.zoom_ceiling()
  
  local func_after = function()
  
    local func_after_zoom = function()
    
      common_impl.Lock( false );
      
      --interface.KeyTaskDone( "find_avenger_2", true, function() interface.KeyTaskAdd( "open_staircase", true ) end  );
      --
      --ng_global.task_current = "open_staircase";
    
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    
    ObjAnimate( "rm_studio", "scale_xy", 0, 0, func_after_zoom, { 0,0,1.2,1.2, 0.6,0,1,1 } );  
    ObjAnimate( "rm_studio", "pos_xy", 0, 0, "", { 0,0,-235,-1, 0.6,0,0,0 } );
    
  end;

  --common_impl.Lock( true );
  interface.Lock( true, 1.9 );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  
  ObjAnimate( "rm_studio", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.6,0,1.2,1.2, 1.3,0,1.2,1.2 } );  
  ObjAnimate( "rm_studio", "pos_xy", 0, 0, "", { 0,0,0,0, 0.6,0,-235,-1, 1.3,0,-235,-1 } );
  
end;
--*********************************************************************************************************************
function private.skip_loupe()

  private.win_loupe();
  
end;
--*********************************************************************************************************************
function private.reset_loupe()

  private.loupe_mmg_wrong_anim();
  
end;
--*********************************************************************************************************************
function private.win_loupe()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

  common_impl.Lock( false );
  cmn.MiniGameHide( "studio" );
  common_impl.PassingMgWin( "studio" );
  cmn.SetEventDone( "win_studio" );
  cmn.CallEventHandler( "win_studio" );
  
  public.vid_studio_loupe();
 
end;
--*********************************************************************************************************************
  function private.loupe_mmg_anim()
    
    ObjAnimate( "obj_studio_loupe_mg_signs", "pos_xy", 1, 0, "", { 0,0,0,0, 2.5,0,-5,-4, 5,0,0,0 } );
  
  end;
--*********************************************************************************************************************
  function private.loupe_mmg_clk_sign( i, j )
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );
    
    local params = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "obj_studio_loupe_mg" );

    ObjSet( "obj_studio_loupe_mg_line", { pos_x = params[1], pos_y = params[2],
                                            event_startdrag = function() private.loupe_mmg_start_drag( i, j ) end,
                                            event_drag = function() private.loupe_mmg_drag( i, j ) end,
                                            event_dragdrop = function() private.loupe_mmg_drag_drop( i, j ) end } );
    
    ObjStartDrag( "obj_studio_loupe_mg_line" );

  end;
--*********************************************************************************************************************
  function public.loupe_mmg_start()
 
    if not ng_global.progress["std"]["win_studio"].saves then
                                                        
      ng_global.progress["std"]["win_studio"].saves = { { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } }, 
                                                            
                                                          { { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 },
                                                            { 0,0,0,0 } } }; 
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_start_drag( i, j )
  
    if not private.start_drag_auto then
    
    private.pos_x_line = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "rm_studio_loupe" )[1] - 511;
    private.pos_y_line = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "rm_studio_loupe" )[2] - 383;
    
    if i == 2 then

      private.pos_y_line = private.pos_y_line + 4;
      
    end;
    
    private.pos = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "rm_studio_loupe" );
   
    private.pos_x_cur = private.pos[1];
    private.pos_y_cur = private.pos[2];
    
    --DbgTrace( private.pos_x_line.." "..private.pos_y_line.."   "..private.pos_x_cur.." "..private.pos_y_cur );
 
    --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_click", 0, "", 0 );

  end;

  private.loupe_mmg_input_stop_drag = false;
  private.loupe_mmg_stop_drag_flag = false;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_drag( i, j )

  common_impl.SetCursor( CURSOR_GET );

    if ObjIntersect( "obj_studio_loupe_mg_line", "obj_studio_loupe_mg" ) then

      local cur_pos = GetZoomCursorPos();
      pos_x1 = cur_pos[ 1 ];
      pos_y1 = cur_pos[ 2 ];

      dx = pos_x1 - private.pos_x_cur;
      dy = pos_y1 - private.pos_y_cur;
      s = math.sqrt(dx^2+dy^2);
      angl = (math.atan2(dx,dy))- 1.57; 
  
      lenght = 2;--коэффициент

      ObjSet( "tmr_studio_loupe_mmg", 
      { 
        playing = true, 
        time = 0.01,  
        endtrig = function() private.loupe_mmg_drag(i, j) end ;
      } );
      
 

      ObjSet( "spr_studio_loupe_mg_line", { alp = 1 } );
      ObjSet( "spr_studio_loupe_mg_line",
        {
         pos_x = private.pos_x_line,
         pos_y = private.pos_y_line,
         ang = angl, 
         scale_x = s / lenght,
         blendmode = 2;
        } );
        
      --ObjSet( "obj_studio_loupe_mg_line_input",
      --{
      -- pos_x = s/2,
      -- pos_y = 0,
      -- inputrect_w = s - 20, 
      -- inputrect_x = - ( ( s - 20 )/2 ),
      -- inputrect_h = 10,
      -- inputrect_y = -3,
      -- attachtype = 2,
      --} );

    else 
        
        private.loupe_mmg_wrong_anim();

      if private.loupe_mmg_stop_drag_flag == false then

        private.loupe_mmg_input_stop_drag = true;

        ObjStopDrag( "obj_studio_loupe_mg_line" );

        private.loupe_mmg_stop_drag_flag = true;
        
        --common_impl.PlayAudio( "sfx", "common/audio/level1/aud_int_tablet_wrong", 0, "", 0 );

      end;
        
    end;

  end;
--*********************************************************************************************************************
  function private.loupe_mmg_stop_drag()

  ObjSet( "tmr_studio_loupe_mmg", { playing = 0 } );
  ObjSet( "spr_studio_loupe_mg_line", { alp = 0 } );

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_drag_drop( i, j )
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_click", 0, "", 0 );

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "obj_studio_loupe_mg_line";
  local points = {};
  local old = {};
  old[1] = i;
  old[2] = j;

  --[[поиск куда бросили ]]

  private.start_drag_auto = false;

  if not private.loupe_mmg_input_stop_drag then
   
    for k = 1, 2 do  
      for l = 1, 4 do  
        if ObjIntersect( name, "spr_studio_loupe_mg_sign_"..k.."_"..l ) and not ( k == i and l == j ) then
          points[1] = k;
          points[2] = l;
        end;
      end;
    end;

    local pos_star = { 
      private.pos_x_line, 
      private.pos_y_line
    };

    if points[1] and points[2] and points[1] ~= old[1] then
      
      local pos_star_2 = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..points[1].."_"..points[2], "obj_studio_loupe_mg" );
      
      if points[1] == 2 then
        
        pos_star_2[2] = pos_star_2[2] + 4;
        
      end;

      private.loupe_mmg_make_line( pos_star, pos_star_2, points[1],points[2], old[1],old[2], false );

      --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_true", 0, "", 0 );
      
      elseif  private.loupe_mmg_win_pointer ~= 8 then
      
      private.loupe_mmg_wrong_anim();
      
    end;

  end;

  private.loupe_mmg_stop_drag();

  end;
---------------------------------------------------------------------------------
  function private.loupe_mmg_make_line( elem_1, elem_2, i, j, n, m, save )
  
  local pos_x1 = elem_1[ 1 ];
  local pos_y1 = elem_1[ 2 ];

  local pos_x2 = elem_2[ 1 ]
  local pos_y2 = elem_2[ 2 ];
  
  local dx = pos_x1 - pos_x2;
  local dy = pos_y1 - pos_y2;
  local s = math.sqrt(dx^2+dy^2);
  local angl = (math.atan2(dx,dy)) - 1.57; 
  local lenght = 2;
  
  --DbgTrace( pos_x1.." "..pos_y1.."  "..pos_x2.." "..pos_y2 );

  ObjSet( "spr_studio_loupe_mg_line", { alp = 0 } );

  if not ObjGet( "spr_studio_loupe_mg_line_"..i.."_"..j ) and i ~= n then
  
    ObjCreate( "spr_studio_loupe_mg_line_"..i.."_"..j, "spr" );
    ObjAttach( "spr_studio_loupe_mg_line_"..i.."_"..j, "obj_studio_loupe_mg_signs" );
    ObjSet( "spr_studio_loupe_mg_line_"..i.."_"..j,
      {
       res = "assets/interface/resources/apparatus/line",
       pos_x =  pos_x1,
       pos_y =  pos_y1,
       ang = angl, 
       scale_x = s / lenght,
       scale_y = 1;
       drawoff_x = -1,
       blendmode = 2;
      } );
     
     ObjCreate( "obj_studio_loupe_mg_line_"..i.."_"..j.."_input", "obj" );
     ObjAttach( "obj_studio_loupe_mg_line_"..i.."_"..j.."_input", "spr_studio_loupe_mg_line_"..i.."_"..j ); 
     
     local weight = 0.76 + 0.01* ( s / 50 );
     
     ObjSet( "obj_studio_loupe_mg_line_"..i.."_"..j.."_input",
      {
      pos_x = -1,
       pos_y = 0,
       input = true,
       inputrect_init = true,
       inputrect_w = 2*weight, 
       inputrect_x = -weight,
       inputrect_h = 10,
       inputrect_y = -5,
      } ); 
      
    local pos_star_2 = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j, "obj_studio_loupe_mg" );
      
    if not save then

      ObjSet( "obj_studio_loupe_mg_line", { 
      pos_x = pos_x2,
      pos_y = pos_y2,
      event_startdrag = function () private.loupe_mmg_start_drag(i,j) end,
      event_drag = function () private.loupe_mmg_drag(i,j) end,
      event_dragdrop = function () private.loupe_mmg_drag_drop(i,j) end } );
      
      ObjSet( "spr_studio_loupe_mg_sign_"..n.."_"..m, { input = false } );
      
      if not private.loupe_mmg_check_intersect() then
      
        --ng_global.progress["std"]["win_studio"].saves[i][j][m] = 1;
        ng_global.progress["std"]["win_studio"].saves[n][m][j] = 1;
        
        private.loupe_mmg_win_pointer = private.loupe_mmg_win_pointer + 1;
     
        if private.loupe_mmg_win_pointer ~= 8 then

          private.pos_x_line = ObjGet( "spr_studio_loupe_mg_sign_"..i.."_"..j ).pos_x;
          private.pos_y_line = ObjGet( "spr_studio_loupe_mg_sign_"..i.."_"..j ).pos_y;

          private.pos = GetObjPosByObj( "spr_studio_loupe_mg_sign_"..i.."_"..j );
            
          private.pos_x_cur = private.pos[1];
          private.pos_y_cur = private.pos[2];

          private.start_drag_auto = true; 
          
        else
          
          private.loupe_mmg_win_anim();
            
        end;
        
        private.loupe_mmg_light_anim( i, j );
        
      else
        
        private.loupe_mmg_wrong_anim();
        
      end;
      
    end;

  else

    private.loupe_mmg_wrong_anim();

  end;
 
  end;
------------------------------------------------------------------------------------------
 function private.loupe_mmg_check_intersect()
 
   local intersect_array = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
 
   for i = 1, 15 do

   for j = 1, 2 do
     
     for k = 1, 4 do
 
       if ObjGet( "obj_studio_loupe_mg_line_"..j.."_"..k.."_input" ) and
         ObjIntersect( "obj_studio_loupe_mg_intersect_"..i, "obj_studio_loupe_mg_line_"..j.."_"..k.."_input" ) then
          
          intersect_array[i] = intersect_array[i] + 1;
          
          if intersect_array[i] > 1 then
            
            return true;
            
          end;
          
        end;
       
     end;
     
   end;
   
 end;
  
  return false;
   
 end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_wrong_anim()
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_wrong", 0, "", 0 );

  private.loupe_mmg_stop_drag();
    
  private.loupe_mmg_win_pointer = 0;
  
  local lines = ObjGetRelations( "obj_studio_loupe_mg_signs" ).childs;

  for j = 1, #lines do
    
    if ObjGet( lines[j] ) and string.find( ObjGet( lines[j] ).name, "line" ) then

      ObjDelete( lines[j] );

    end;

  end;
  
  for i = 1, 2 do
    
    for k = 1, 4 do
      
      ObjSet( "spr_studio_loupe_mg_sign_"..i.."_"..k.."_light", { alp = 0 } );
      ObjSet( "spr_studio_loupe_mg_sign_"..i.."_"..k, { input = true } );
   
    end;
    
  end;
    
   ng_global.progress["std"]["win_studio"].saves = { { { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 } }, 
                                                      
                                                    { { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 },
                                                      { 0,0,0,0 } } }; 
    
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_light_anim( i, j )
  
  local func_after = function()

    common_impl.Lock( false );
    
    if not private.loupe_mmg_stop_drag_flag and private.loupe_mmg_win_pointer ~= 8 then
      
      common_impl.SetCursor( CURSOR_GET );

      ObjStartDrag( "obj_studio_loupe_mg_line" );
      
    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_true", 0, "", 0 );
  
  ObjAnimate( "spr_studio_loupe_mg_sign_"..i.."_"..j.."_light", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
  
  end;
------------------------------------------------------------------------------------------
  function private.loupe_mmg_win_anim()
    
    local func_after = function()
    
      private.win_loupe();
      
      common_impl.Lock( false );
    
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_device_win", 0, "", 0 );
    
    ObjStopDrag( "obj_studio_loupe_mg_line" );
    
    for i = 1, 2 do
      
      for j = 1, 4 do
        
        ObjAnimate( "spr_studio_loupe_mg_sign_"..i.."_"..j.."_light_win", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,0, 0.5,0,1, 0.9,0,1, 1.2,0,0 } );
        
        func_after = "";
        
      end;
      
    end;

  end;
--*********************************************************************************************************************
ObjAnimate( "spr_directordashboard_light", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_ceiling_light_2", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_studio_calling_light_add", "alp",1,0,"",
{
  0.0, 0, 0,
  0.8, 0, 1,
  1.0, 0, 0, 
  1.2, 0, 1, 
  1.4, 0, 0, 
  1.8, 0, 1,
  2.1, 0, 0
});