-- name=rm_underbridge
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_underbridge";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_water", "room_hub" );
  ObjAttach( "zz_wicketgate", "room_hub" );
  ObjAttach( "zz_shed", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_water_antirustbottle", { event_mdown = private.get_antirustbottle }},
  { "spr_wicketgate_remotecontrol", { event_mdown = private.get_remotecontrol }},
  { "spr_shed_duster", { event_mdown = private.get_duster_3 }},
  { "spr_shed_pincers_3", { event_mdown = private.get_pincers_3 }},
  { "spr_shed_moneybox", { event_mdown = private.get_moneybox }},
  { "spr_shed_box4", { event_mdown = private.get_box4 }},
  { "obj_wicketgate_use_ticket", { event_mdown = private.clk_ticket }},
  { "obj_shed_zz", { event_mdown = function() common_impl.NoteScale( "open", "obj_shed_zz" ); private.opn_hint_zz(); end }},    
  --{ "spr_shed_zz_big",{ event_mdown = function() common_impl.NoteScale( "close", "obj_shed_zz" ); private.close_hint_zz() end }},
  { "spr_underbridge_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_shed_use_antirust", { event_mdown = private.clk_xx_door }},
  { "obj_shed_use_ax", { event_mdown = private.clk_xx_door_2 }},
 { "spr_water_collect_2", { event_mdown = function () private.get_collect_2_3_5(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "obj_shed_zz", { event_mdown = function() private.opn_shed(); private.opn_hint_zz(); end }},    
  { "obj_shed_zz_big",{ event_mdown = function() private.close_shed(); private.close_hint_zz() end }},
  { "spr_shed_zz_big_cross",{ event_mdown = function() private.close_shed(); private.close_hint_zz() end,
                              event_menter = function() private.MouseEnterAnim () end,
                              event_mleave = function() private.MouseLeaveAnim () end }},
  
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_underbridge = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_underbridge_boatroom",
    "gzz_underbridge_water",
    "gzz_underbridge_wicketgate",
    "gzz_underbridge_shed"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_water",
    "zz_wicketgate",
    "zz_shed"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_underbridge", update_game_mode_underbridge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_underbridge = function ()

  local effects_table = 
  {
    "obj_underbridge_anim",
    "anm_shed_fog",
    "spr_water_light",
    "anm_water_fog",
    "anm_wicketgate_fog",
    "spr_wicketgate_light",
    "spr_underbridge_water_ship_1",
    "spr_underbridge_water_ship_2"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_underbridge", update_performance_mode_underbridge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_underbridge () end;
  --------------------------------------------------------------------------------------------
  local opn_underbridge_map = function ()

    common_impl.VisitMapRoom( "underbridge" );

  end;
  cmn.AddSubscriber( "opn_underbridge", opn_underbridge_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_antirustbottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_antirustbottle" ] = {
    type = "get",
    get_obj = "spr_water_antirustbottle",
    room = private.room_objname,
    zz = "zz_water",
    zz_gate = "gzz_underbridge_water"
  };
    
  local get_antirustbottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_antirustbottle", "spr_water_antirustbottle" );
    ObjSet("inv_antirustbottle",{ drag = false });
    
  end;
  
  local get_antirustbottle_closezz = function ()
  
    ObjDelete( "gfx_water_antirustbottle" );
    ObjDelete( "spr_water_antirustbottle_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_antirustbottle", get_antirustbottle_inv );
  cmn.AddSubscriber( "get_antirustbottle", get_antirustbottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_remotecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_remotecontrol" ] = {
    type = "get",
    get_obj = "spr_wicketgate_remotecontrol",
    room = private.room_objname,
    zz = "zz_wicketgate",
    zz_gate = "gzz_underbridge_wicketgate"
  };
    
  local get_remotecontrol_inv = function ()
  
    interface.InventoryItemAdd( "inv_remotecontrol", "spr_wicketgate_remotecontrol" );
    ObjSet("inv_remotecontrol", { drag = false });
    
  end;
  
  local get_remotecontrol_closezz = function ()
  
    ObjDelete( "gfx_wicketgate_remotecontrol" );
    ObjDelete( "spr_wicketgate_remotecontrol_shadow" );
    ObjSet("obj_wicketgate_use_ticket", { input = true });
    ObjDelete( "spr_underbridge_wicketgate_console" );
  
  end;
  
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_inv );
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_duster_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_duster_3" ] = {
    type = "get",
    get_obj = "spr_shed_duster",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
    
  local get_duster_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_duster_3", "spr_shed_duster" );
  
  end;
  
  local get_duster_3_closezz = function ()
  
    ObjDelete( "gfx_shed_duster" );
    ObjDelete( "spr_underbridge_shed_rag" );
    ObjDelete( "spr_shed_duster_shadow" );
    
  end;
  
  cmn.AddSubscriber( "get_duster_3", get_duster_3_inv );
  cmn.AddSubscriber( "get_duster_3", get_duster_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pincers_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pincers_3" ] = {
    type = "get",
    get_obj = "spr_shed_pincers_3",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
    
  local get_pincers_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_pincers_3", "spr_shed_pincers_3" );
  
  end;
  
  local get_pincers_3_closezz = function ()
  
    ObjDelete( "gfx_shed_pincers_3" );
    ObjDelete( "spr_underbridge_shed_pincers" );
    
  end;
  
  cmn.AddSubscriber( "get_pincers_3", get_pincers_3_inv );
  cmn.AddSubscriber( "get_pincers_3", get_pincers_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_moneybox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_moneybox" ] = {
    type = "get",
    get_obj = "spr_shed_moneybox",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
    
  local get_moneybox_inv = function ()
  
    interface.InventoryItemAdd( "inv_moneybox", "spr_shed_moneybox" );
    ObjSet("inv_moneybox", { drag = false });
    
  end;
  
  local get_moneybox_closezz = function ()
  
    ObjDelete( "gfx_shed_moneybox" );
    ObjDelete( "spr_underbridge_shed_moneybox" );
  
  end;
  
  cmn.AddSubscriber( "get_moneybox", get_moneybox_inv );
  cmn.AddSubscriber( "get_moneybox", get_moneybox_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_box4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_box4" ] = {
    type = "get",
    get_obj = "spr_shed_box4",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
    
  local get_box4_inv = function ()
  
    ng_global.progress[ "std" ][ "get_box1" ].count[4] = true;
    local count = 0;
    for i = 1,4 do
      if ng_global.progress[ "std" ][ "get_box1" ].count[i] then
        count = count + 1;
      end;
    end;
    interface.InventoryItemRemove( "inv_box_3" );
    local func_end = function()
    
      ObjSet( "txt_box_3_number", {text = tostring(count).."/4"});
      ObjSet( "spr_box_3_4", { alp = 1 });
    
    end;
    interface.InventoryItemAdd( "inv_box_3", "spr_shed_box4", func_end, nil, "assets/levels/level3/rm_street/zz_motorscooter/inv/inv_box_3" );
  
  end;
  
  local get_box4_closezz = function ()
  
    ObjDelete( "gfx_shed_box4" );
    ObjDelete( "spr_shed_box" );
    
    if( cmn.IsEventDone("get_moneybox") and cmn.IsEventDone("get_pincers_3") and cmn.IsEventDone("get_duster_3") )then
      
      ObjDelete( "gzz_underbridge_shed" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_box4", get_box4_inv );
  cmn.AddSubscriber( "get_box4", get_box4_closezz, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_3 = function ()
  
    ObjDelete( "obj_underbridge_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_3", get_collect_morph_item_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3_5 = function ()
  
    ObjDelete( "spr_water_collect_2" );
    
    if cmn.IsEventDone( "use_shipremotecontrol") then  
      
      ObjDelete( "gzz_underbridge_water");
      
    end;
  end;
  cmn.AddSubscriber( "get_collect_2_3_5", get_collect_2_3_5 , private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_elf_3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_3_3" ] = {
    type = "use",
    inv_obj = "inv_elf_3_1",
    use_place = "obj_water_use_elf_3",
    room = private.room_objname,
    zz = "zz_water",
    zz_gate = "gzz_underbridge_water"
  };
  local use_elf_3_3_inv = function ()
  
  interface.InventoryItemRemove( "inv_elf_3_1" );
  
  end;
  local use_elf_3_3_beg = function ()
  
    ObjDelete( "obj_water_use_elf_3" );
    ObjDelete( "anm_water_ship_1" );
  
  end;
  local use_elf_3_3_end = function ()
  
    ObjSet( "obj_water_use_shipremotecontrol", { input = true } );
    ObjDelete( "vid_water_elf_jump" );  
    ObjSet( "vid_water_elf_loop", { alp = 1, playing = true, looped = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_3_3", use_elf_3_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_3", use_elf_3_3_inv );
  cmn.AddSubscriber( "use_elf_3_3", use_elf_3_3_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_3_inv", use_elf_3_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_3_beg", use_elf_3_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_3_end", use_elf_3_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shipremotecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shipremotecontrol" ] = {
    type = "use",
    inv_obj = "inv_shipremotecontrol",
    use_place = "obj_water_use_shipremotecontrol",
    room = private.room_objname,
    zz = "zz_water",
    zz_gate = "gzz_underbridge_water"
  };
  local use_shipremotecontrol_inv = function ()
  
    interface.InventoryItemRemove( "inv_shipremotecontrol" );
  
  end;
  local use_shipremotecontrol_inv_add = function ()
  
    interface.InventoryItemAdd( "inv_elf_3_1", "spr_water_elf", nil, "video" );
  
  end;
  local use_shipremotecontrol_beg = function ()
  
    ObjDelete( "obj_water_use_shipremotecontrol" );
    ObjDelete( "vid_water_elf_loop" );
  
  end;
  local use_shipremotecontrol_end = function ()
  
    ObjDelete( "spr_underbridge_water_roof1" );
    ObjSet( "anm_underbridge_bridge_2", { alp = 1 } );
    ObjSet( "spr_underbridge_water_ship_2", { alp = 1 } );
    ObjDelete( "spr_underbridge_water_ship_1" );
    ObjDelete( "vid_water_elf_sweem" );
    
    ObjDelete( "spr_water_controller" );
    ObjSet( "anm_water_ship_2", { alp = 1, playing = true } );
    
    if common_impl.IsGetCollect( "get_collect_2_3_5" ) then
      
      ObjDelete( "gzz_underbridge_water" );
      
    end;  
  
  end;
  local use_shipremotecontrol_loc = function ()
  
    ObjSet( "grm_street_attvatation", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_street_attvatation_focus");
    end;
    ObjDelete( "spr_street_bridge" );
    ObjDelete( "obj_street_clk_bridge" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shipremotecontrol", use_shipremotecontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol", use_shipremotecontrol_inv );
  cmn.AddSubscriber( "use_shipremotecontrol", use_shipremotecontrol_inv_add );
  cmn.AddSubscriber( "use_shipremotecontrol", use_shipremotecontrol_end, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol", use_shipremotecontrol_loc, "rm_street" );
  cmn.AddSubscriber( "use_shipremotecontrol_inv", use_shipremotecontrol_inv, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol_beg", use_shipremotecontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol_end", use_shipremotecontrol_end, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol_end", use_shipremotecontrol_inv_add, private.room_objname );
  cmn.AddSubscriber( "use_shipremotecontrol_loc", use_shipremotecontrol_loc, "rm_street" );
  --------------------------------------------------------------------------------------------
  -- function use_ticket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ticket" ] = {
    type = "use",
    inv_obj = "inv_ticket",
    use_place = "obj_wicketgate_use_ticket",
    room = private.room_objname,
    zz = "zz_wicketgate",
    zz_gate = "gzz_underbridge_wicketgate"
  };
  local use_ticket_inv = function ()
  
    interface.InventoryItemRemove( "inv_ticket" );
  
  end;
  local use_ticket_beg = function ()
  
    ObjDelete( "obj_wicketgate_use_ticket" );
  
  end;
  local use_ticket_end = function ()
  
    ObjDelete( "spr_wicketgate_door" );
    ObjDelete( "gzz_underbridge_wicketgate" );
    ObjSet( "spr_wicketgate_ticket", { alp = 1, pos_x = 249, pos_y = -49 } );
    ObjSet( "gho_underbridge_boatroom", { active = true, input = true } );
    ObjSet( "spr_wicketgate_arrow_open", { alp = 1  } );
    ObjSet( "spr_underbridge_wicketgate_card", { alp = 1  } );
    ObjDelete( "spr_underbridge_wicketgate_arrow" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ticket", use_ticket_beg, private.room_objname );
  cmn.AddSubscriber( "use_ticket", use_ticket_inv );
  cmn.AddSubscriber( "use_ticket", use_ticket_end, private.room_objname );
  cmn.AddSubscriber( "use_ticket_inv", use_ticket_inv, private.room_objname );
  cmn.AddSubscriber( "use_ticket_beg", use_ticket_beg, private.room_objname );
  cmn.AddSubscriber( "use_ticket_end", use_ticket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ax () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ax" ] = {
    type = "click",
    use_place = "obj_shed_zz",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
  local use_ax_inv = function ()
  
    interface.InventoryItemRemove( "inv_ax" );
  
  end;
  local use_ax_beg = function ()
  
    ObjDelete( "obj_shed_use_ax" );
  
  end;
  local use_ax_end = function ()
  
    ObjSet( "spr_underbridge_shed_open_1", { alp = 1 } );
    ObjSet( "obj_shed_use_elf_3_4", { input = true } );
    ObjSet( "spr_shed_zz_open_light", { alp = 1 } );
    ObjSet( "spr_shed_open_doors_2", { alp = 1 } );
    ObjDelete( "spr_shed_zz_close_light" );
    ObjSet( "anm_shed_open", { frame = 300, alp = 1 } );
    ObjDelete( "anm_shed_close" );
    ObjDelete( "anm_shed_ax" ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ax", use_ax_beg, private.room_objname );
  cmn.AddSubscriber( "use_ax", use_ax_inv );
  cmn.AddSubscriber( "use_ax", use_ax_end, private.room_objname );
  cmn.AddSubscriber( "use_ax_inv", use_ax_inv, private.room_objname );
  cmn.AddSubscriber( "use_ax_beg", use_ax_beg, private.room_objname );
  cmn.AddSubscriber( "use_ax_end", use_ax_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_3_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_3_4" ] = {
    type = "click",
    use_place = "obj_shed_zz",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
  local use_elf_3_4_inv = function ()
  
  end;
  local use_elf_3_4_beg = function ()
  
    ObjDelete( "obj_shed_use_elf_3_4" );
  
  end;
  local use_elf_3_4_end = function ()
  
    ObjDelete( "vid_shed_elf" );
    ObjSet( "spr_shed_box4", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_3_4", use_elf_3_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_4", use_elf_3_4_inv );
  cmn.AddSubscriber( "use_elf_3_4", use_elf_3_4_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_4_inv", use_elf_3_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_4_beg", use_elf_3_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_3_4_end", use_elf_3_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust_3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirust_3_1" ] = {
    type = "use",
    inv_obj = "inv_antirust",
    use_place = "obj_shed_use_antirust",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
  local use_antirust_3_1_inv = function ()
  
  end;
  local use_antirust_3_1_beg = function ()
  
    ObjDelete( "obj_shed_use_antirust" );
  
  end;
  local use_antirust_3_1_end = function ()
  
    ObjDelete( "anm_shed_clk_door" );  
    ObjDelete( "anm_shed_solvent" );
    ObjSet( "spr_shed_open_door", { input = true, alp = 1 } );
    ObjSet( "spr_underbridge_shed_open", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust_3_1", use_antirust_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_1", use_antirust_3_1_inv );
  cmn.AddSubscriber( "use_antirust_3_1", use_antirust_3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_1_inv", use_antirust_3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_1_beg", use_antirust_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_3_1_end", use_antirust_3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pole () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pole" ] = {
    type = "use",
    inv_obj = "inv_pole",
    use_place = "obj_shed_use_pole",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
  local use_pole_inv = function ()
  
    interface.InventoryItemRemove( "inv_pole" );
  
  end;
  local use_pole_beg = function ()
  
    ObjDelete( "obj_shed_use_pole" );
  
  end;
  local use_pole_end = function ()
  
    ObjDelete( "anm_shed_stick" );
    ObjSet( "spr_shed_moneybox", { input = true, alp = 1  } );
    ObjSet( "gfx_shed_moneybox", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pole", use_pole_beg, private.room_objname );
  cmn.AddSubscriber( "use_pole", use_pole_inv );
  cmn.AddSubscriber( "use_pole", use_pole_end, private.room_objname );
  cmn.AddSubscriber( "use_pole_inv", use_pole_inv, private.room_objname );
  cmn.AddSubscriber( "use_pole_beg", use_pole_beg, private.room_objname );
  cmn.AddSubscriber( "use_pole_end", use_pole_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_boatroom () end;
  --------------------------------------------------------------------------------------------
  local win_boatroom = function ()

    if ( cmn.IsEventDone( "win_boatroom" ) ) then

      ObjDelete( "gho_underbridge_boatroom" );

    end;

  end;

  cmn.AddSubscriber( "win_boatroom", win_boatroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_underbridge_bridge () end;
  --------------------------------------------------------------------------------------------
  local vid_underbridge_bridge = function ()
  
    ObjDelete( "anm_underbridge_bridge_2" );
    ObjSet( "spr_underbridge_water_roof2", { alp = 1 } );
    
  end;

  cmn.AddSubscriber( "vid_underbridge_bridge", vid_underbridge_bridge, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
 subroom.Define( "zz_shed" );
 subroom.Define( "zz_wicketgate" );
 subroom.Define( "zz_water" );
 --------------------------------------------------------------------------------------------
 function zz_water.PreOpen()
   
   if cmn.IsEventDone( "use_elf_3_3" ) and not cmn.IsEventDone( "use_shipremotecontrol" ) then
     
     common_impl.PlayAudio( "sfx", "common/audio/level3/aud_water_loop_elf", 1, "", 0 );
     
   end;
   
   common_impl.PlayAudio( "env", "common/audio/level3/aud_underbridge_zz_env", 1, "", 0 );
 
 end;
 --------------------------------------------------------------------------------------------
 function zz_water.PreClose()
   
   common_impl.StopAudio( "sfx", "common/audio/level3/aud_water_loop_elf", 0 );
  
   common_impl.StopAudio( "env", "common/audio/level3/aud_underbridge_zz_env", 0 );

 end;
 --------------------------------------------------------------------------------------------
 function zz_water.Close()

   if ( cmn.IsEventDone( "use_shipremotecontrol" ) and not cmn.IsEventDone( "vid_underbridge_bridge" ) ) then
     
     local func_after = function()
   
        common_impl.Lock( false );
        cmn.SetEventDone( "vid_underbridge_bridge" );
        cmn.CallEventHandler( "vid_underbridge_bridge" );

     end;
     
     common_impl.Lock( true );
     AnimPlay( "anm_underbridge_bridge_2", "DoAnim", func_after );  
     common_impl.PlayAudio( "sfx", "common/audio/level3/aud_bridge_anim", 0, "", 0 );
   
   end;

 end;
 --------------------------------------------------------------------------------------------
 function zz_shed.PreOpen()
   
    if not common_impl.underbridge then

      common_impl.underbridge = {}
      common_impl.underbridge.note = "close";

    end;
    
    if  ObjGet( "obj_shed_zz" ).input == true then

      --ObjSet( "spr_shed_zz_big", { input = false, alp = 0 } );
      --ObjSet( "obj_shed_zz",     { alp = 1 } );
      
    end;
    
 end;
 --------------------------------------------------------------------------------------------
 function zz_shed.PreClose()

    common_impl.underbridge.note = "close"; 
    
 end;
 --------------------------------------------------------------------------------------------
 function zz_shed.Close()
   
   private.close_hint_zz();
   ObjSet( "obj_shed_zz_big", { alp = 0, input = false });
   
 end;
 -------------------------------------------------------------------------------------------- 
 function zz_wicketgate.Close()
    
   if cmn.IsEventDone( "use_ticket" ) then
      
     ObjSet( "tmr_underbridge_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_boatroom' ) end } );
      
    end;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_underbridge();
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( cmn.IsEventDone( "use_shipremotecontrol" ) and not cmn.IsEventDone( "vid_underbridge_bridge" ) ) then
   
     local func_after = function()
   
        common_impl.Lock( false );
        cmn.SetEventDone( "vid_underbridge_bridge" );
        cmn.CallEventHandler( "vid_underbridge_bridge" );

     end;
     
     common_impl.Lock( true );
     ObjSet( "spr_underbridge_water_roof2", { alp = 0 });
     ObjSet( "anm_underbridge_bridge_2", { alp = 1 });
     AnimPlay( "anm_underbridge_bridge_2", "DoAnim", func_after );  
 
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/level3/aud_underbridge_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_3_3()

  local item = "inv_elf_3_1";

  if ( common.ApplyObj( item, "obj_water_use_elf_3", true ) ) then

    if ( cmn.IsEventDone( "use_elf_3_2" ) ) then
    
      cmn.CallEventHandler( "use_elf_3_3_inv" );
      cmn.CallEventHandler( "use_elf_3_3_beg" );

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_elf_3_3" );
        cmn.CallEventHandler( "use_elf_3_3_end" );
        
        common_impl.PlayAudio( "sfx", "common/audio/level3/aud_water_loop_elf", 1, "", 0 );
        
      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/level3/aud_water_jump_elf", 0, "", 0 );

      ObjSet( "vid_water_elf_jump", { alp = 1 } );
      VidPlay( "vid_water_elf_jump", func_after );
      
    else 
    
      common_impl.ShowBbt( 'bbt_water_not_use_elf_3' );
    
    end;
  
    return true;
    
  elseif common.ApplyObj( item, "gzz_underbridge_water", false ) and cmn.IsEventDone( "use_elf_3_2" ) and not cmn.IsEventDone( "use_elf_3_3" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_water", nil, { 512, 384 } );

    return true;
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shipremotecontrol()

  local item = "inv_shipremotecontrol";

  if ( common.ApplyObj( item, "obj_water_use_shipremotecontrol", true ) and cmn.IsEventDone("use_elf_3_3") ) then

    cmn.CallEventHandler( "use_shipremotecontrol_inv" );
    cmn.CallEventHandler( "use_shipremotecontrol_beg" );
    
    local func_after = function () 
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_shipremotecontrol" );
      cmn.CallEventHandler( "use_shipremotecontrol_end" );
      cmn.CallEventHandler( "use_shipremotecontrol_loc" );
      ObjSet( "spr_water_elf", { alp = 1 } )
      common.CloseSubRoom();
        
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_shipremotecontrol_water", 0, "", 0 );
    common_impl.StopAudio( "sfx", "common/audio/level3/aud_water_loop_elf", 0 );
 
    ObjSet( "vid_water_elf_sweem", { alp = 1 } );
    VidPlay( "vid_water_elf_sweem", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_underbridge_water", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_water", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ticket()

  local item = "inv_ticket";

  if ( common.ApplyObj( item, "obj_wicketgate_use_ticket", true ) and cmn.IsEventDone("get_remotecontrol")) then

    cmn.CallEventHandler( "use_ticket_inv" );
    cmn.CallEventHandler( "use_ticket_beg" );

    local func_after = function ()
    
      local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_ticket" );
        cmn.CallEventHandler( "use_ticket_end" );
        common.CloseSubRoom();
        
      end;
      
      
      ObjAnimate( "spr_wicketgate_arrow_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );
      
      ObjAnimate( "spr_wicketgate_door", "pos_x", 0, 0, func_end,
      { 
        0.0, 0, -19,
        0.3, 0, -19,  
        0.8, 0, 287
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_ticket_wicketgate", 0, "", 0 );
    
    ObjAnimate( "spr_wicketgate_ticket", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    ObjAnimate( "spr_wicketgate_ticket", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 270, -117,
      0.3, 0, 270, -117,  
      0.8, 0, 249, -49
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_underbridge_wicketgate", false ) and cmn.IsEventDone("get_remotecontrol") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wicketgate", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ax()

  local item = "inv_ax";

  if ( common.ApplyObj( item, "obj_shed_use_ax", true ) and cmn.IsEventDone("use_antirust_3_1") and ( ObjGet( "obj_shed_zz_big" ).alp == 1 )) then

    cmn.CallEventHandler( "use_ax_inv" );
    cmn.CallEventHandler( "use_ax_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ax" );
      cmn.CallEventHandler( "use_ax_end" );
        
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_ax_shed", 0, "", 0 );
    ObjSet( "anm_shed_close", { alp = 0 } );
    ObjSet( "anm_shed_ax", { alp = 1 } );
    AnimPlay( "anm_shed_ax", "DoAnim", func_after );
    
    return true;
  
    
  elseif common.ApplyObj( item, "spr_shed_open_door", true ) and cmn.IsEventDone("use_antirust_3_1") and ( ObjGet( "obj_shed_zz_big" ).alp == 0 ) then
    
   --interface.ObjDoNotDrop( item );
    private.opn_shed();
    return true;
    
  elseif common.ApplyObj( item, "gzz_underbridge_shed", false ) and cmn.IsEventDone("use_antirust_3_1") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shed", nil, { 512, 384 }, true );

    return true;

    
  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_3_4()

  local item = "inv_elf_3_1";

  if ( common.ApplyObj( item, "obj_shed_use_elf_3_4", true ) and cmn.IsEventDone("use_ax") and ( ObjGet( "obj_shed_zz_big" ).alp == 1 ) ) then

    cmn.CallEventHandler( "use_elf_3_4_inv" );
    cmn.CallEventHandler( "use_elf_3_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_3_4" );
      cmn.CallEventHandler( "use_elf_3_4_end" );
      
      ObjSet( "spr_shed_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_3_1", "spr_shed_elf", nil, "video" );
    
    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_shed_elf", 0, "", 0 );
    
    interface.InventoryItemRemove( "inv_elf_3_1" );
    VidPlay( "vid_shed_elf", func_after );
    
    return true;
    
  elseif ( common.ApplyObj( item, "spr_shed_open_door", true ) and cmn.IsEventDone("use_ax") and not cmn.IsEventDone( "use_elf_3_4" ) and ( ObjGet( "obj_shed_zz_big" ).alp == 0 ) ) then
  
   --interface.ObjDoNotDrop( item );
    private.opn_shed();
    
  elseif common.ApplyObj( item, "gzz_underbridge_shed", false ) and cmn.IsEventDone("use_ax") and not cmn.IsEventDone( "use_elf_3_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_antirust_3_1()

  local item = "inv_antirust";

  if ( common.ApplyObj( item, "obj_shed_use_antirust", true ) and ( common_impl.underbridge.note == "close" ) and not cmn.IsEventDone("use_antirust_3_1") ) then

    cmn.CallEventHandler( "use_antirust_3_1_inv" );
    cmn.CallEventHandler( "use_antirust_3_1_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_antirust_3_1" );
        cmn.CallEventHandler( "use_antirust_3_1_end" );
      
      end;
      
      ObjAnimate( "anm_shed_solvent", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_shed_open_door", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_antirust_shed", 0, "", 0 );
    ObjSet( "anm_shed_clk_door", { alp = 0 });
    ObjSet( "anm_shed_solvent", { alp = 1 });
    AnimPlay( "anm_shed_solvent", "DoAnim", func_after )
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_underbridge_shed", false ) and not cmn.IsEventDone("use_antirust_3_1") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pole()

  local item = "inv_pole";

  if ( common.ApplyObj( item, "obj_shed_use_pole", true ) and ( common_impl.underbridge.note == "close" ) ) then

    cmn.CallEventHandler( "use_pole_inv" );
    cmn.CallEventHandler( "use_pole_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_pole" );
      cmn.CallEventHandler( "use_pole_end" );
      private.get_moneybox();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/level3/aud_use_pole_shed", 0, "", 0 );
    AnimPlay( "anm_shed_stick", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_underbridge_shed", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shed", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_antirustbottle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_antirustbottle" );
  cmn.CallEventHandler( "get_antirustbottle" );

end;
--------------------------------------------------------------------------------------------
function private.get_remotecontrol()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_remotecontrol" );
  cmn.CallEventHandler( "get_remotecontrol" );

end;
--------------------------------------------------------------------------------------------
function private.get_duster_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_duster_3" );
  cmn.CallEventHandler( "get_duster_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_pincers_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_pincers_3" );
  cmn.CallEventHandler( "get_pincers_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_moneybox()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_moneybox" );
  cmn.CallEventHandler( "get_moneybox" );

end;
--------------------------------------------------------------------------------------------
function private.get_box4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_box4" );
  cmn.CallEventHandler( "get_box4" );
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_3_5()

  local func_after = function ()
    
  common_impl.GetCollectDone("get_collect_2_3_5");
  cmn.CallEventHandler("get_collect_2_3_5");
    
    if cmn.IsEventDone( "use_shipremotecontrol") then
      
      common.CloseSubRoom();
    
    end;  

  end;

  common_impl.PlayEffectHO( "spr_water_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_ticket()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_wicketgate_use_ticket' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_doors_wicketgate", 0, "", 0 );
  
  ObjAnimate( "spr_wicketgate_door", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, -19, 
    0.3, 0, -17,
    0.6, 0, -19
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_xx_door()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_shed_use_antirust' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_doors_shed", 0, "", 0 );
  AnimPlay( "anm_shed_clk_door", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
function private.clk_xx_door_2()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;
    
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_shed_use_ax' );
  common_impl.PlayAudio( "sfx", "common/audio/level3/aud_touch_inside_doors_shed", 0, "", 0 );
  ObjAnimate( "anm_shed_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.2, 0, 2,
    0.4, 0, 0
  } );

end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hint_zz()
  
  common_impl.hint[ "use_elf_3_4" ] = {
    type = "use",
    inv_obj = "inv_elf_3_1",
    use_place = "obj_shed_use_elf_3_4",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  }; 
  
  common_impl.hint[ "use_ax" ] = {
    type = "use",
    inv_obj = "inv_ax",
    use_place = "obj_shed_use_ax",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
    
  
end;
--------------------------------------------------------------------------------------------
function private.close_hint_zz()
 
  common_impl.hint[ "use_elf_3_4" ] = {
    type = "click",
    use_place = "obj_shed_zz",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  }; 
  
  common_impl.hint[ "use_ax" ] = {
    type = "click",
    use_place = "obj_shed_zz",
    room = private.room_objname,
    zz = "zz_shed",
    zz_gate = "gzz_underbridge_shed"
  };
  
end;
--------------------------------------------------------------------------------------------
function private.opn_underbridge()

  if not ( cmn.IsEventDone( "opn_underbridge" ) ) then
    cmn.SetEventDone( "opn_underbridge" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
  end;
  
  cmn.CallEventHandler( "opn_underbridge" ); 

end;
function private.opn_shed()

  local tme = 0.5;  
  local alpha_anm_table = {0,0,0, 0.2,1,0.9, tme,1,1};
  local pos_xy_anm_table = {0,0,-50,-50, tme,1,0,0};
  local scale_xy_anm_table = {0,0,0,0, 4*tme/5,3,1.1,1.1, tme,3,1,1 };
  
  local func_after = function()
  
  
    common_impl.Lock( false );
    ObjSet( "obj_shed_zz_big", { input = true } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_close_zz", 0, "", 0 );
  
  ObjAnimate( "obj_shed_zz_big", "alp", 0, 0, "", alpha_anm_table );
  ObjAnimate( "obj_shed_zz_big", "pos_xy", 0, 0, func_after, pos_xy_anm_table );
  ObjAnimate( "obj_shed_zz_big", "scale_xy", 0, 0, "", scale_xy_anm_table );

end;
function private.close_shed()
  
  local tme = 0.5;  
  local alpha_anm_table = {0,0,1, 0.4,1,0.9, tme,0,0};
  local pos_xy_anm_table = {0,0,0,0, tme,0,-50,-50};
  local scale_xy_anm_table = {0,0,1,1, tme/5,3,1.1,1.1, tme,3,0,0 };
  
  local func_after = function()
  
    common_impl.Lock( false );
    ObjSet( "obj_shed_zz_big", { input = false } );
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_open_zz", 0, "", 0 );
  
  ObjAnimate( "obj_shed_zz_big", "alp", 0, 0, "", alpha_anm_table );
  ObjAnimate( "obj_shed_zz_big", "pos_xy", 0, 0, func_after, pos_xy_anm_table );
  ObjAnimate( "obj_shed_zz_big", "scale_xy", 0, 0, "", scale_xy_anm_table );

end;

--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_shed_zz_big_cross";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.3;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ( name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_shed_zz_big_cross";
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.3;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************

--*********************************************************************************************************************
ObjAnimate("spr_water_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_wicketgate_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  1.1, 0, 0.5,
  2.3, 0, 1.0
});
ObjAnimate("spr_underbridge_water_ship_1", "ang",1,0,"",
{
  0.0, 0, -0.03, 
  1.6, 0, 0.03,
  3.2, 0, -0.03
});
ObjAnimate("spr_underbridge_water_ship_2", "ang",1,0,"",
{
  0.0, 0, -0.03, 
  1.6, 0, 0.03,
  3.2, 0, -0.03
});
