-- name=ho_balconyroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "balconyroom" );
  game.relations[ "ho_balconyroom" ].exitroom = "rm_balcony";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_balconyroom = function ()

  local effects_table = 
  {
    "obj_balconyroom_anims",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_balconyroom", update_performance_mode_balconyroom, "ho_balconyroom" );
  
  ObjMultiSet( {
  
    { "spr_balconyroom_bag", { event_mdown = function() private.TaskComplete( 'bag' ) end } },
    { "spr_balconyroom_bird", { event_mdown = function() private.TaskComplete( 'bird' ) end } },
    { "spr_balconyroom_bow", { event_mdown = function() private.TaskComplete( 'bow' ) end } },
    { "spr_balconyroom_candlestick", { event_mdown = function() private.TaskComplete( 'candlestick' ) end } },
    { "spr_balconyroom_doll", { event_mdown = function() private.TaskComplete( 'doll' ) end } },
    { "spr_balconyroom_hairpin", { event_mdown = function() private.TaskComplete( 'hairpin' ) end } },
    { "spr_balconyroom_holder", { event_mdown = function() private.TaskComplete( 'holder' ) end } },
    { "spr_balconyroom_letter", { event_mdown = function() private.TaskComplete( 'letter' ) end } },
    { "spr_balconyroom_medallion", { event_mdown = function() private.TaskComplete( 'medallion' ) end } },
    { "spr_balconyroom_note", { event_mdown = function() private.TaskComplete( 'note' ) end } },
    { "spr_balconyroom_pearls", { event_mdown = function() private.TaskComplete( 'pearls' ) end } },
    { "spr_balconyroom_star", { event_mdown = function() private.TaskComplete( 'star' ) end } },
    { "spr_balconyroom_candle", { event_startdrag = function() private.GetItem( 'candle' ) end, event_dragdrop = function() private.unmark_candlestick() end } },
    { "spr_balconyroom_pearl", { event_startdrag = function() private.GetItem( 'pearl' ) end, event_dragdrop = function() private.unmark_pearls() end } },

  } );
  
  common_impl.hint[ "win_balconyroom" ] = {
      type = "win",
      room = "rm_balcony",
      zz = "ho_balconyroom",
      zz_gate = "gho_balcony_balconyroom"
  };
  
  local win_balconyroom_func = function ()

    if ( cmn.IsEventDone( "win_balconyroom" ) ) then
      interface.InventoryItemAdd( "inv_toolbox", "spr_balconyroom_win" );
      ObjSet( "inv_toolbox", { drag = false });
      if ( cmn.IsEventDone( "get_coin_4" ) ) then
        ObjSet( "spr_toolbox_plus_light", { alp = 1 });
      end;
      
    end;

  end;
  cmn.AddSubscriber( "win_balconyroom", win_balconyroom_func );
  
  --------------------------------------------------------------------------------------------------
  local unmark_candlestick = function () 
   
    ObjSet( "spr_balconyroom_candlestick_candle", { alp = 1 } );
    ObjSet( "spr_balconyroom_candlestick", { input = true } ); 
    ObjDelete( "spr_balconyroom_candle" );  
    ObjDelete( "obj_balconyroom_use_candle" );    

  end;

  cmn.AddSubscriber( "unmark_candlestick", unmark_candlestick, "ho_balconyroom" );  
  
  --------------------------------------------------------------------------------------------------
  local unmark_pearls = function () 
   
    ObjSet( "spr_balconyroom_pearls_pearl", { alp = 1 } );
    ObjSet( "spr_balconyroom_pearls", { input = true } ); 
    ObjDelete( "spr_balconyroom_pearl" );  
    ObjDelete( "obj_balconyroom_use_pearl" );    

  end;

  cmn.AddSubscriber( "unmark_pearls", unmark_pearls, "ho_balconyroom" ); 
  
  --------------------------------------------------------------------------------------------------
  local start_balconyroom_func = function ()

    if ( cmn.IsEventStart( "win_balconyroom" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_balconyroom" ].found;

      for i = 1, #ho_found, 1 do
        
        local taskname = ho_found[ i ][ "task" ];
        
        ObjDelete( ho_found[ i ][ "object" ] );
        ObjDelete( "spr_balconyroom_taskpanel_"..taskname );
        
      end;
    
      if not cmn.IsEventDone( "win_balconyroom" ) then

        if cmn.IsUnmarkedTask( "balconyroom", "candlestick" ) then
            unmark_candlestick();
        end;

          if cmn.IsUnmarkedTask( "balconyroom", "pearls" ) then
            unmark_pearls();
        end;

      end;
        
    end;

  end;
    
  cmn.AddSubscriber( "win_balconyroom", start_balconyroom_func, "ho_balconyroom" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_balconyroom" ) ) then
  
    cmn.InitHo( "balconyroom" );
    cmn.SetEventDone( "opn_balconyroom" );
    
    cmn.SetMarkedTask( "balconyroom", "candlestick" );
    cmn.SetMarkedTask( "balconyroom", "pearls" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bag",          1, 0, { { "spr_balconyroom_bag" } } );
  interface.TaskPanelTaskAdd( ho_items, "bird",         1, 0, { { "spr_balconyroom_bird" } } );
  interface.TaskPanelTaskAdd( ho_items, "bow",          1, 0, { { "spr_balconyroom_bow" } } );
  interface.TaskPanelTaskAdd( ho_items, "candlestick",  1, 1, { { "spr_balconyroom_candle", "obj_balconyroom_use_candle" }, { "spr_balconyroom_candlestick" } } );
  interface.TaskPanelTaskAdd( ho_items, "doll",         1, 0, { { "spr_balconyroom_doll" } } );
  interface.TaskPanelTaskAdd( ho_items, "hairpin",      1, 0, { { "spr_balconyroom_hairpin" } } );
  interface.TaskPanelTaskAdd( ho_items, "holder",       1, 0, { { "spr_balconyroom_holder" } } );
  interface.TaskPanelTaskAdd( ho_items, "letter",       1, 0, { { "spr_balconyroom_letter" } } );
  interface.TaskPanelTaskAdd( ho_items, "medallion",    1, 0, { { "spr_balconyroom_medallion" } } );
  interface.TaskPanelTaskAdd( ho_items, "note",         1, 0, { { "spr_balconyroom_note" } } );
  interface.TaskPanelTaskAdd( ho_items, "pearls",       1, 1, { { "spr_balconyroom_pearl", "obj_balconyroom_use_pearl" }, { "spr_balconyroom_pearls" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",         1, 0, { { "spr_balconyroom_star" } } );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "balconyroom" );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
 --*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "balconyroom" );
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_balconyroom_"..task_name, task_name );
  
  ObjAnimate( "spr_balconyroom_taskpanel_"..task_name, "scale_xy", 0, 0, "", { 0,0,0.6,0.6, 0.4,0,0,0 } );

end;
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.SetCursor( CURSOR_NULL );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );

  ObjSet( "spr_balconyroom_"..name, { pos_z = 20 } );

end;
--*********************************************************************************************************************
function private.unmark_candlestick() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_balconyroom_candle", "obj_balconyroom_use_candle" ) ) then
    
    ObjSet( "spr_balconyroom_candle", { alp = 0 } );

    local func_after = function()

      common_impl.Lock( false );
  
      cmn.UnmarkTask( "balconyroom", "candlestick" );
      cmn.CallEventHandler( "unmark_candlestick" );

    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_balconyroom_use_candle", 0, "", 0 );

    ObjAnimate( "spr_balconyroom_candlestick_candle", "alp", 0, 0, func_after, { 0,3,0, 0.3,3,1 } );
   
  else

    ObjSet( "spr_balconyroom_candle", { pos_z = 0 } );
  
  end;

end;
--*********************************************************************************************************************
function private.unmark_pearls() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_balconyroom_pearl", "obj_balconyroom_use_pearl" ) ) then
    
    ObjSet( "spr_balconyroom_pearl", { alp = 0 } );

    local func_after = function()

      common_impl.Lock( false );
  
      cmn.UnmarkTask( "balconyroom", "pearls" );
      cmn.CallEventHandler( "unmark_pearls" );

    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_balconyroom_use_pearl", 0, "", 0 );

    ObjAnimate( "spr_balconyroom_pearls_pearl", "alp", 0, 0, func_after, { 0,3,0, 0.3,3,1 } );
   
  else

    ObjSet( "spr_balconyroom_pearl", { pos_z = 0 } );
  
  end;

end;
--*********************************************************************************************************************
ObjAnimate( "spr_balconyroom_light", "alp", 1, 0, "", { 0,0,1, 2,0,0.4, 4,0,1 } );
