-- name=ho_mockuproom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "mockuproom" );
  game.relations[ "ho_mockuproom" ].exitroom = "rm_secondfloor";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mockuproom = function ()

  local effects_table = 
  {
    "obj_mockuproom_anims",
    "anm_mockuproom_cat"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mockuproom", update_performance_mode_mockuproom, "ho_mockuproom" );
  
  ObjMultiSet( {
  
    { "spr_mockuproom_binoculars", { event_mdown = function() private.TaskComplete( 'binoculars' ) end } },
    { "spr_mockuproom_bird", { event_mdown = function() private.TaskComplete( 'bird' ) end } },
    { "spr_mockuproom_butterfly", { event_mdown = function() private.TaskComplete( 'butterfly' ) end } },
    { "spr_mockuproom_clown", { event_mdown = function() private.TaskComplete( 'clown' ) end } },
    { "spr_mockuproom_comb", { event_mdown = function() private.TaskComplete( 'comb' ) end } },
    { "spr_mockuproom_crane", { event_mdown = function() private.TaskComplete( 'crane' ) end } },
    { "spr_mockuproom_dool", { event_mdown = function() private.TaskComplete( 'dool' ) end } },
    { "spr_mockuproom_log", { event_mdown = function() private.TaskComplete( 'log' ) end } },
    { "spr_mockuproom_mask", { event_mdown = function() private.TaskComplete( 'mask' ) end } },
    { "spr_mockuproom_shoe", { event_mdown = function() private.TaskComplete( 'shoe' ) end } },
    { "spr_mockuproom_stocking", { event_mdown = function() private.TaskComplete( 'stocking' ) end } },
    { "spr_mockuproom_sword", { event_mdown = function() private.TaskComplete( 'sword' ) end } },
    { "spr_mockuproom_splinter", { event_mdown = function() private.TaskComplete( 'splinter' ) end } },
    
    { "obj_mockuproom_clk_cat", { event_mdown = function() private.clk_cat() end } },
    { "obj_mockuproom_clk_clothes", { event_mdown = function() private.clk_clothes() end } }
    
  } );
  
  private.splinter = { [ "binoculars" ] = 1,
                       [ "bird" ]       = 2,
                       [ "butterfly" ]  = 3,
                       [ "clown" ]      = 4,
                       [ "comb" ]       = 5,
                       [ "crane" ]      = 6,
                       [ "dool" ]       = 7,
                       [ "log" ]        = 8,
                       [ "mask" ]       = 9,
                       [ "shoe" ]       = 10,
                       [ "stocking" ]   = 11,
                       [ "sword" ]      = 12 }
  
  common_impl.hint[ "win_mockuproom" ] = {
      type = "win",
      room = "rm_secondfloor",
      zz = "ho_mockuproom",
      zz_gate = "gho_secondfloor_mockuproom"
  };
  
  local win_mockuproom_func = function ()

    if ( cmn.IsEventDone( "win_mockuproom" ) ) then
      interface.InventoryItemAdd( "inv_spinning", "spr_mockuproom_win" );
    end;

  end;
  cmn.AddSubscriber( "win_mockuproom", win_mockuproom_func );
  --------------------------------------------------------------------------------------------------
  local start_mockuproom_func = function ()

    if ( cmn.IsEventStart( "win_mockuproom" ) and not cmn.IsEventDone( "win_mockuproom" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_mockuproom" ].found;
   
      for i = 1, #ho_found, 1 do
        
        local taskname = ho_found[ i ][ "task" ];
        
        ObjDelete( ho_found[ i ][ "object" ] );
        ObjDelete( "spr_mockuproom_taskpanel_"..taskname );
        ObjDelete( "spr_mockuproom_splinter_"..private.splinter[taskname] );
        
      end;
      
      if ( #ho_found == 12 ) then
      
        ObjSet( "spr_mockuproom_splinter", { input = true } );
        ObjSet( "txt_mockuproom_taskpanel", { alp = 1 } );
      
      end;

    end;

  end;
  cmn.AddSubscriber( "win_mockuproom", start_mockuproom_func, "ho_mockuproom" );  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_mockuproom" ) ) then
  
    cmn.InitHo( "mockuproom" );
    cmn.SetEventDone( "opn_mockuproom" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "binoculars",    1, 0, { { "spr_mockuproom_binoculars" } } );
  interface.TaskPanelTaskAdd( ho_items, "bird",          1, 0, { { "spr_mockuproom_bird" } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",     1, 0, { { "spr_mockuproom_butterfly" } } );
  interface.TaskPanelTaskAdd( ho_items, "clown",         1, 0, { { "spr_mockuproom_clown" } } );
  interface.TaskPanelTaskAdd( ho_items, "comb",          1, 0, { { "spr_mockuproom_comb" } } );
  interface.TaskPanelTaskAdd( ho_items, "crane",         1, 0, { { "spr_mockuproom_crane" } } );
  interface.TaskPanelTaskAdd( ho_items, "dool",          1, 0, { { "spr_mockuproom_dool" } } );
  interface.TaskPanelTaskAdd( ho_items, "log",           1, 0, { { "spr_mockuproom_log" } } );
  interface.TaskPanelTaskAdd( ho_items, "mask",          1, 0, { { "spr_mockuproom_mask" } } );
  interface.TaskPanelTaskAdd( ho_items, "shoe",          1, 0, { { "spr_mockuproom_shoe" } } );
  interface.TaskPanelTaskAdd( ho_items, "stocking",      1, 0, { { "spr_mockuproom_stocking" } } );
  interface.TaskPanelTaskAdd( ho_items, "sword",         1, 0, { { "spr_mockuproom_sword" } } );
  interface.TaskPanelTaskAdd( ho_items, "splinter",      1, 0, { { "spr_mockuproom_splinter" } } );
 
  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "mockuproom" );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  int_taskpanel_impl.ShowTextPanel( "mockuproom" );
   
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_mockuproom_"..task_name, task_name );
  
  if task_name == "splinter" then
    
    ObjAnimate( "spr_mockuproom_splinter_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "spr_mockuproom_taskpanel_"..task_name, "scale_xy", 0, 0, function() private.TaskCompleteAnim( task_name ) end, { 0,0,0.7,0.7, 0.2,0,0,0 } );
 
end;
--*********************************************************************************************************************
function private.TaskCompleteAnim( task_name )
  
  local number = private.splinter[task_name];
  
  local func_after = function()
 
    local ho_found = ng_global.progress[ "ext" ][ "win_mockuproom" ].found;
    
    if ( #ho_found == 12 ) then
      
      local func_end = function()
  
        common_impl.Lock( false );
        
        ObjSet( "spr_mockuproom_splinter", { input = true } );
        
      end;
 
      ObjAnimate( "txt_mockuproom_taskpanel", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
      
    else
      
      common_impl.Lock( false );
      
    end;
  
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_mockuproom_find_anim", 0, "", 0 );
  
  ObjAnimate( "spr_mockuproom_splinter_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  
end;
--*********************************************************************************************************************
function private.clk_cat()
  
  local func_after = function()
  
    common_impl.Lock( false );
    ObjSet( "anm_mockuproom_cat", { alp = 1 });
    ObjSet( "anm_mockuproom_cat_2", { alp = 0 });  
    
  end;

  common_impl.Lock( true );
  ObjSet( "anm_mockuproom_cat", { alp = 0 });
  ObjSet( "anm_mockuproom_cat_2", { alp = 1 });  
  AnimPlay( "anm_mockuproom_cat_2", "DoAnim", func_after );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_mockuproom_cat", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.clk_clothes()
  
  local func_after = function()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true ); 
  AnimPlay( "anm_mockuproom_clothes", "DoAnim", func_after );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_mockuproom_cloth", 0, "", 0 );
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_mockuproom_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.3, 2,0,1 } );
