-- name=ho_pharmacy
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pharmacy" );
  game.relations[ "ho_pharmacy" ].exitroom = "rm_behindstage";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_pharmacy = function ()

  local effects_table = 
  {
  --"anm_pharmacy_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_pharmacy", update_performance_mode_pharmacy, "ho_pharmacy" );
  
  ObjMultiSet( {
  
  { "spr_pharmacy_ascorbic", { event_mdown = function() private.TaskComplete( 'ascorbic' ) end } },
  { "spr_pharmacy_enema", { event_mdown = function() private.TaskComplete( 'enema' ) end } },
  { "spr_pharmacy_patch", { event_mdown = function() private.TaskComplete( 'patch' ) end } },
  { "spr_pharmacy_scalpel", { event_mdown = function() private.TaskComplete( 'scalpel' ) end } },
  { "spr_pharmacy_scissors", { event_mdown = function() private.TaskComplete( 'scissors' ) end } },
  { "spr_pharmacy_sedative", { event_mdown = function() private.TaskComplete( 'sedative' ) end } },
  { "spr_pharmacy_stall", { event_mdown = function() private.TaskComplete( 'stall' ) end } },
  { "spr_pharmacy_syringe_2", { event_mdown = function() private.TaskComplete( 'syringe_2' ) end } },
  { "spr_pharmacy_tube", { event_mdown = function() private.TaskComplete( 'tube' ) end } },
  { "spr_pharmacy_tonometer", { event_mdown = function() private.TaskComplete( 'tonometer' ) end } },
  { "spr_pharmacy_tourniquet", { event_mdown = function() private.TaskComplete( 'tourniquet' ) end } },
  { "spr_pharmacy_wadding_2", { event_mdown = function() private.TaskComplete( 'wadding_2' ) end } },
  { "spr_pharmacy_syringe", { event_startdrag = function() private.GetItem( 'syringe' ) end, event_dragdrop = function() private.unmark_syringe() end } },
  { "spr_pharmacy_wadding", { event_startdrag = function() private.GetItem( 'wadding' ) end, event_dragdrop = function() private.unmark_wadding() end } },

  
  } );
  
  common_impl.hint[ "win_pharmacy" ] = {
      type = "win",
      room = "rm_behindstage",
      zz = "ho_pharmacy",
      zz_gate = "gho_behindstage_pharmacy"
  };
  
  local win_pharmacy_func = function ()

    if ( cmn.IsEventDone( "win_pharmacy" ) ) then
      interface.InventoryItemAdd( "inv_sedative", "spr_pharmacy_win" );
      ObjSet( "spr_cup_plus_light", { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "win_pharmacy", win_pharmacy_func );
  --------------------------------------------------------------------------------------------
  -- function win_pharmacy_loc () end;
  --------------------------------------------------------------------------------------------
  local win_pharmacy_loc = function ()
  
   if ( cmn.IsEventDone( "win_pharmacy" ) ) then
     
      ObjDelete( "gho_behindstage_pharmacy" );
      ObjSet( "gzz_behindstage_foldingtable", { input = true, active = true, alp = 1});
   
   end;
    
  end;
  cmn.AddSubscriber( "win_pharmacy", win_pharmacy_loc, "rm_behindstage" );
  
  --------------------------------------------------------------------------------------------------
  local unmark_syringe = function () 
   
    ObjSet( "spr_pharmacy_syringe_2", { alp = 1, input = true } );
    ObjDelete( "spr_pharmacy_syringe_shadow" );  
    ObjDelete( "spr_pharmacy_syringe" ); 
    ObjDelete( "obj_pharmacy_use_syringe" );   
    ObjDelete( "anm_pharmacy_use_syringe" ); 

  end;

  cmn.AddSubscriber( "unmark_syringe", unmark_syringe, "ho_pharmacy" );  
  
  --------------------------------------------------------------------------------------------------
  local unmark_wadding = function () 
   
    ObjSet( "spr_pharmacy_wadding_2", { alp = 1, input = true } );
    ObjDelete( "spr_pharmacy_wadding" ); 
    ObjDelete( "obj_pharmacy_use_wadding" );    
    ObjDelete( "anm_pharmacy_use_wadding" );
    
  end;

  cmn.AddSubscriber( "unmark_wadding", unmark_wadding, "ho_pharmacy" );  
  --------------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------------
  local start_pharmacy_func = function ()

    if ( cmn.IsEventStart( "win_pharmacy" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_pharmacy" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        
        if ho_found[ i ][ "task" ] == "wadding_2" then
    
          ObjSet( "spr_pharmacy_wadding_shadow", { alp = 0 } );
          
        end;
        
      end;
      
      if not cmn.IsEventDone( "win_pharmacy" ) then

        if cmn.IsUnmarkedTask( "pharmacy", "syringe_2" ) then
            unmark_syringe();
        end;

          if cmn.IsUnmarkedTask( "pharmacy", "wadding_2" ) then
            unmark_wadding();
        end;

      end;

    end;

  end;
  cmn.AddSubscriber( "win_pharmacy", start_pharmacy_func, "ho_pharmacy" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_pharmacy" ) ) then
  
    cmn.InitHo( "pharmacy" );
    cmn.SetEventDone( "opn_pharmacy" );
    
    cmn.SetMarkedTask( "pharmacy", "syringe_2" );
    cmn.SetMarkedTask( "pharmacy", "wadding_2" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "ascorbic",       1, 0, { { "spr_pharmacy_ascorbic" } } );
  interface.TaskPanelTaskAdd( ho_items, "enema",          1, 0, { { "spr_pharmacy_enema" } } );
  interface.TaskPanelTaskAdd( ho_items, "patch",          1, 0, { { "spr_pharmacy_patch" } } );
  interface.TaskPanelTaskAdd( ho_items, "scalpel",        1, 0, { { "spr_pharmacy_scalpel" } } );
  interface.TaskPanelTaskAdd( ho_items, "scissors",       1, 0, { { "spr_pharmacy_scissors" } } );
  interface.TaskPanelTaskAdd( ho_items, "stall",          1, 0, { { "spr_pharmacy_stall" } } );
  interface.TaskPanelTaskAdd( ho_items, "sedative",       1, 0, { { "spr_pharmacy_sedative" } } );
  interface.TaskPanelTaskAdd( ho_items, "syringe_2",      1, 1, { { "spr_pharmacy_syringe", "obj_pharmacy_use_syringe" }, { "spr_pharmacy_syringe_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "tube",           1, 0, { { "spr_pharmacy_tube" } } );
  interface.TaskPanelTaskAdd( ho_items, "tonometer",      1, 0, { { "spr_pharmacy_tonometer" } } );
  interface.TaskPanelTaskAdd( ho_items, "tourniquet",     1, 0, { { "spr_pharmacy_tourniquet" } } );
  interface.TaskPanelTaskAdd( ho_items, "wadding_2",      1, 1, { { "spr_pharmacy_wadding", "obj_pharmacy_use_wadding" }, { "spr_pharmacy_wadding_2" } } );
  
  interface.TaskPanelShow( ho_items );
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )

  cmn.HoTaskFind( "spr_pharmacy_"..task_name, task_name );
  
  if task_name == "wadding_2" then
    
    ObjSet( "spr_pharmacy_wadding_shadow", { alp = 0 } );
    
  end;

end;
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.SetCursor( CURSOR_NULL );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );

  ObjSet( "spr_pharmacy_"..name, { pos_z = 20 } );
  ObjSet( "spr_pharmacy_"..name.."_shadow", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.unmark_syringe() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_pharmacy_syringe", "obj_pharmacy_use_syringe" ) ) then
    
    ObjSet( "spr_pharmacy_syringe", { alp = 0 } );

    local func_after = function()

      common_impl.Lock( false );
  
      cmn.UnmarkTask( "pharmacy", "syringe_2" );
      cmn.CallEventHandler( "unmark_syringe" );

    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_pharmacy_use_syringe", 0, "", 0 );

    ObjSet( "anm_pharmacy_use_syringe", { alp = 1, playing = true, endtrig = func_after } );
   
  else

    ObjSet( "spr_pharmacy_syringe", { pos_z = 0 } );
    ObjSet( "spr_pharmacy_syringe_shadow", { alp = 1 } );
  
  end;

end;
--*********************************************************************************************************************
function private.unmark_wadding() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_pharmacy_wadding", "obj_pharmacy_use_wadding" ) ) then
    
    ObjSet( "spr_pharmacy_wadding", { alp = 0 } );

    local func_after = function()

      common_impl.Lock( false );
  
      cmn.UnmarkTask( "pharmacy", "wadding_2" );
      cmn.CallEventHandler( "unmark_wadding" );
      ObjSet( "obj_pharmacy_bottle", { alp = 1 } );
      ObjSet( "spr_pharmacy_wadding_shadow", { alp = 1 } );
       
    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_pharmacy_use_cotton", 0, "", 0 );

    ObjSet( "obj_pharmacy_bottle", { alp = 0 } );
    ObjSet( "anm_pharmacy_use_wadding", { alp = 1, playing = true, endtrig = func_after } );
   
  else

    ObjSet( "spr_pharmacy_wadding", { pos_z = 0 } );
    ObjSet( "spr_pharmacy_wadding_shadow", { alp = 1 } );
  
  end;

end;
--*********************************************************************************************************************
ObjAnimate( "spr_pharmacy_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
