-- name=ho_warehouse
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "warehouse" );
  game.relations[ "ho_warehouse" ].exitroom = "rm_behindstage";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_warehouse = function ()

  local effects_table = 
  {
  --"anm_warehouse_anim",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_warehouse", update_performance_mode_warehouse, "ho_warehouse" );
  
  private.tasks = { "", "" };
  private.anim_time = { 8, 5 };
  private.anim_name = { "right", "left" };
  
  ObjMultiSet( {
  
  { "spr_warehouse_cloud_1", { event_mdown = function() private.ClkTask( 'cloud', 'cloud_1' ) end } },
  { "spr_warehouse_cloud_2", { event_mdown = function() private.ClkTask( 'cloud', 'cloud_2' ) end } },
  { "spr_warehouse_fan_1", { event_mdown = function() private.ClkTask( 'fan', 'fan_1' ) end } },
  { "spr_warehouse_fan_2", { event_mdown = function() private.ClkTask( 'fan', 'fan_2' ) end } },
  { "spr_warehouse_knife_1", { event_mdown = function() private.ClkTask( 'knife', 'knife_1' ) end } },
  { "spr_warehouse_knife_2", { event_mdown = function() private.ClkTask( 'knife', 'knife_2' ) end } },
  { "spr_warehouse_lamp_1", { event_mdown = function() private.ClkTask( 'lamp', 'lamp_1' ) end } },
  { "spr_warehouse_lamp_2", { event_mdown = function() private.ClkTask( 'lamp', 'lamp_2' ) end } },
  { "spr_warehouse_revolver_1", { event_mdown = function() private.ClkTask( 'revolver', 'revolver_1' ) end } },
  { "spr_warehouse_revolver_2", { event_mdown = function() private.ClkTask( 'revolver', 'revolver_2' ) end } },
  { "spr_warehouse_rope_1", { event_mdown = function() private.ClkTask( 'rope', 'rope_1' ) end } },
  { "spr_warehouse_rope_2", { event_mdown = function() private.ClkTask( 'rope', 'rope_2' ) end } },
  { "spr_warehouse_scarecrow_1", { event_mdown = function() private.ClkTask( 'scarecrow', 'scarecrow_1' ) end } },
  { "spr_warehouse_scarecrow_2", { event_mdown = function() private.ClkTask( 'scarecrow', 'scarecrow_2' ) end } },
  { "spr_warehouse_stairs_1", { event_mdown = function() private.ClkTask( 'stairs', 'stairs_1' ) end } },
  { "spr_warehouse_stairs_2", { event_mdown = function() private.ClkTask( 'stairs', 'stairs_2' ) end } },
  { "spr_warehouse_wig_1", { event_mdown = function() private.ClkTask( 'wig', 'wig_1' ) end } },
  { "spr_warehouse_wig_2", { event_mdown = function() private.ClkTask( 'wig', 'wig_2' ) end } },
  
  } );
  
  common_impl.hint[ "win_warehouse" ] = {
      type = "win",
      room = "rm_behindstage",
      zz = "ho_warehouse",
      zz_gate = "gho_behindstage_warehouse"
  };
  
  local win_warehouse_func = function ()

    if ( cmn.IsEventDone( "win_warehouse" ) ) then
      interface.InventoryItemAdd( "inv_valise", "spr_warehouse_win" );
      ObjSet("inv_valise", { drag = false });
    end;

  end;
  cmn.AddSubscriber( "win_warehouse", win_warehouse_func );
  --------------------------------------------------------------------------------------------------
  local start_warehouse_func = function ()

    if ( cmn.IsEventStart( "win_warehouse" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_warehouse" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      ObjSet( "txt_warehouse_tasklist", { param0 = ng_global.progress[ "ext" ][ "win_warehouse" ].counter } );

    end;

  end;
  cmn.AddSubscriber( "win_warehouse", start_warehouse_func, "ho_warehouse" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.PassingHoStart();
  
  AnimPlay( "anm_warehouse_beetle_1", "DoAnim", function() private.AnimStart( 1 ); end );
  AnimPlay( "anm_warehouse_beetle_2", "DoAnim", function() private.AnimStart( 2 ); end );
    
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_bug_right", 0, "", 0 ); 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_bug_left", 0, "", 0 ); 

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_warehouse" ) ) then
  
    cmn.InitHo( "warehouse" );
    cmn.SetEventDone( "opn_warehouse" );
  
    ng_global.progress[ "ext" ][ "win_warehouse" ].counter = 9;
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "cloud",       1, 0, { { "spr_warehouse_cloud_1", "spr_warehouse_cloud_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "cloud_2",       1, 0, { { "spr_warehouse_cloud_2", "spr_warehouse_cloud_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "fan",       1, 0, { { "spr_warehouse_fan_1", "spr_warehouse_fan_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "fan_2",       1, 0, { { "spr_warehouse_fan_2", "spr_warehouse_fan_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife",       1, 0, { { "spr_warehouse_knife_1", "spr_warehouse_knife_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "knife_2",       1, 0, { { "spr_warehouse_knife_2", "spr_warehouse_knife_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "lamp",       1, 0, { { "spr_warehouse_lamp_1", "spr_warehouse_lamp_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "lamp_2",       1, 0, { { "spr_warehouse_lamp_2", "spr_warehouse_lamp_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "revolver",       1, 0, { { "spr_warehouse_revolver_1", "spr_warehouse_revolver_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "revolver_2",       1, 0, { { "spr_warehouse_revolver_2", "spr_warehouse_revolver_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope",       1, 0, { { "spr_warehouse_rope_1", "spr_warehouse_rope_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope_2",       1, 0, { { "spr_warehouse_rope_2", "spr_warehouse_rope_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "scarecrow",       1, 0, { { "spr_warehouse_scarecrow_1", "spr_warehouse_scarecrow_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "scarecrow_2",       1, 0, { { "spr_warehouse_scarecrow_2", "spr_warehouse_scarecrow_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "stairs",       1, 0, { { "spr_warehouse_stairs_1", "spr_warehouse_stairs_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "stairs_2",       1, 0, { { "spr_warehouse_stairs_2", "spr_warehouse_stairs_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "wig",       1, 0, { { "spr_warehouse_wig_1", "spr_warehouse_wig_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "wig_2",       1, 0, { { "spr_warehouse_wig_2", "spr_warehouse_wig_1" } } );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "warehouse" );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
 
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  
  common_impl.StopAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_bug_right", 0 );
  common_impl.StopAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_bug_left", 0 );

  int_taskpanel_impl.ShowTextPanel( "warehouse" )

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
  int_taskpanel_impl.sound_play = true;
  
end;
--*********************************************************************************************************************
function private.ClkTask( task_name, object_name )

  local object =  "spr_warehouse_"..object_name.."_light";

  if private.tasks[1] ~= "" then

    if task_name == private.tasks[1] and private.tasks[2] ~= object_name  then

      int_taskpanel_impl.sound_play = true;
      private.TaskComplete( task_name, "spr_warehouse_"..task_name.."_1" );

      int_taskpanel_impl.sound_play = false;
      private.TaskComplete( task_name.."_2" );

      ng_global.progress[ "ext" ][ "win_warehouse" ].counter = ng_global.progress[ "ext" ][ "win_warehouse" ].counter - 1;

      ObjSet( "txt_warehouse_tasklist", { param0 = ng_global.progress[ "ext" ][ "win_warehouse" ].counter } );

    elseif task_name == private.tasks[1] and private.tasks[2] == object_name  then

      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_touch_item", 0, "", 0 ); 

      ObjSet( object, { alp = 0 } ); 

    else
     
      ObjSet( "spr_warehouse_"..private.tasks[1].."_1_light", { alp = 0 } ); 
      ObjSet( "spr_warehouse_"..private.tasks[1].."_2_light", { alp = 0 } );

      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_wrong", 0, "", 0 ); 
         
    end;

     private.tasks[1] = "";
     private.tasks[2] = "";

     ObjSet( "spr_warehouse_"..private.tasks[1].."_1_light", { alp = 0 } ); 
     ObjSet( "spr_warehouse_"..private.tasks[1].."_2_light", { alp = 0 } );
    

  else

    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_touch_item", 0, "", 0 ); 

    private.tasks[1] = task_name;
    private.tasks[2] = object_name;

    ObjSet( object, { alp = 1 } );  
    
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_warehouse_"..task_name;

  end;
  
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );
  
end;
--*********************************************************************************************************************
function private.AnimStart( number )
  
  local func_after = function()
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ho_warehouse_bug_"..private.anim_name[number], 0, "", 0 ); 
  
    AnimPlay( "anm_warehouse_beetle_"..number, "DoAnim", function() private.AnimStart( number ); end );
    
  end;
    
  ObjSet( "tmr_warehouse_anim_"..number, { time = private.anim_time[number], playing = true, endtrig = func_after } );
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_warehouse_light", "alp", 1, 0, "", { 0,0,1, 3,0,0.5, 6,0,1 } );
