-- name=mg_apparatusroom_4_1
--*********************************************************************************************************************
function public.Init()
  
  private.InitAnimation();

  private.room_objname = "mg_apparatusroom_4_1";
  private.mg = "apparatusroom_4_1";
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_apparatusroom_4_1 = function ()

  local effects_table = 
  {
    "anm_apparatusroom_4_1"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_apparatusroom_4_1", update_performance_mode_apparatusroom_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_apparatusroom_4_1" ] = {
    type = "win",
    room = "rm_hall_4",
    zz = "mg_apparatusroom_4_1",
    zz_gate = "gmg_hall_4_apparatusroom_4_1"
  };
  --------------------------------------------------------------------------------------------
  -- function win_apparatusroom_4_1_loc () end;
  --------------------------------------------------------------------------------------------
  local win_apparatusroom_4_1_loc = function ()
    
    if ( cmn.IsEventDone( "win_apparatusroom_4_1" ) ) then  
      
      ObjDelete( "gmg_hall_4_apparatusroom_4_1" );
      ObjSet( "grm_hall_4_behindstage", { active = true, input = true });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_hall_4_behindstage_focus");
      end;
      ObjDelete( "anm_hall_4_anomaly" );
      
      if ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].anim then
        
        ObjDelete( "anm_hall_4_apparatus_2" );
        
      end;
      
    end;

  end;

  cmn.AddSubscriber( "win_apparatusroom_4_1", win_apparatusroom_4_1_loc, "rm_hall_4" );
  --------------------------------------------------------------------------------------------
  -- function win_apparatusroom_4_1 () end;
  --------------------------------------------------------------------------------------------
  local win_apparatusroom_4_1 = function ()

  if ( cmn.IsEventDone( "win_apparatusroom_4_1" ) ) then  

  else

    private.InitMG();
    private.MGLoad();
    private.MGLoadStateMode();
    private.MGLoadState();

  end;

  end;

  cmn.AddSubscriber( "win_apparatusroom_4_1", win_apparatusroom_4_1, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_apparatusroom_4_1" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventStart( "win_apparatusroom_4_1" ) ) then

    ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode = "hard"
    ObjSet( "rm_hall_4", { scale_x = 1, scale_y = 1, pos_x = 0, pos_y = 0 } );
    private.InitMG();
    private.InitMGVar();
    private.MGLoadState();

  end;
  
  common_impl.PlayAudio( "env", "common/audio/levelext/aud_mg_apparatusroom_env", 1, "", 0 );
  
  if not cmn.IsEventDone( "win_apparatusroom_4_1" ) then
   if ng_global.gamemode == 0 then
     private.ChangeMode( "casual" );
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_apparatusroom_4_1" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

 private.InitMGVar();
 private.MGLoadState();

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.InitMG()

  local table_mts = {};
  
  for j = 1, 10 do

    table.insert( table_mts, { "spr_apparatusroom_4_1_sign_"..j, 
    {  

      alp = 0,

    } } );

    table.insert( table_mts, { "obj_apparatusroom_4_1_sign_"..j.."_clk", 
    {  

      event_mdown = function ()  private.SignClk( j ) end,
      event_menter = function () private.ButtonMenter( j ) end,
      event_mleave = function () private.ButtonMleave( j ) end,
      input = false,

    } } );

    table.insert( table_mts, { "obj_apparatusroom_4_1_over_"..j.."_clk", 
    {  

      event_mdown = function ()  private.OverClk( j ) end,
      event_menter = function () private.ButtonMenter( j ) end,
      event_mleave = function () private.ButtonMleave( j ) end,

    } } );

  end;

  table.insert( table_mts, { "obj_apparatusroom_4_1_mode_hard", 
  {  

    event_mdown = function ()  private.ChangeMode( "hard" ) end,
    event_menter = function () private.ButtonMenter( j ) end,
    event_mleave = function () private.ButtonMleave( j ) end,

  } } );

  table.insert( table_mts, { "obj_apparatusroom_4_1_mode_casual", 
  {  

    event_mdown = function ()  private.ChangeMode( "casual" ) end,
    event_menter = function () private.ButtonMenter( j ) end,
    event_mleave = function () private.ButtonMleave( j ) end,

  } } );

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.InitMGVar()

  private.save = { { false, false, false, false, false, false, false, false, false, false }, 
                   { true, true, true, true, true, true, true, true, true, true  } };

  private.MGSave();

end;
--*********************************************************************************************************************
function private.MGSave()

  ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save = {};

  for i = 1, #private.save do

    ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save[ i ] = {};

    for j = 1, #private.save[ i ] do

      ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save[ i ][ j ] = private.save[ i ][ j ];

    end;

  end;

end;
--*********************************************************************************************************************
function private.MGLoad()

  private.save = {};

  for i = 1, #ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save do

    private.save[ i ] = {};

    for j = 1, #ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save[ i ] do

      private.save[ i ][ j ] = ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].save[ i ][ j ];

    end;

  end;

end;
--*********************************************************************************************************************
function private.ChangeMode( mode ) 

  ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode = mode;

  private.MGLoadStateMode();
  public.Reset();
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_apparatusroom_change_mode", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.MGLoadStateMode()

  local table_mts = {};

  local mode = ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode;

  if ( mode == "casual" ) then

    table.insert( table_mts, { "obj_apparatusroom_4_1_mode_hard", { input = true } } );
    table.insert( table_mts, { "obj_apparatusroom_4_1_mode_casual", { input = false } } );

    table.insert( table_mts, { "spr_apparatusroom_4_1_mode_btn_hard_focus", { visible = false } } );
    table.insert( table_mts, { "spr_apparatusroom_4_1_mode_btn_casual_focus", { visible = true } } );

  else

    table.insert( table_mts, { "obj_apparatusroom_4_1_mode_hard", { input = false } } );
    table.insert( table_mts, { "obj_apparatusroom_4_1_mode_casual", { input = true } } );

    table.insert( table_mts, { "spr_apparatusroom_4_1_mode_btn_hard_focus", { visible = true } } );
    table.insert( table_mts, { "spr_apparatusroom_4_1_mode_btn_casual_focus", { visible = false } } );
  end;

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.MGLoadState()

  local table_mts = {};

  for j = 1, #private.save[ 2 ] do

    if ( private.save[ 2 ][ j ] ) then

      table.insert( table_mts, { "anm_apparatusroom_4_1_clot_"..j, { alp = 0 } } );
      table.insert( table_mts, { "obj_apparatusroom_4_1_over_"..j.."_clk", { input = false } } );
      table.insert( table_mts, { "obj_apparatusroom_4_1_sign_"..j.."_clk", { input = true } } );
      table.insert( table_mts, { "spr_apparatusroom_4_1_sign_"..j, { alp = 1 } } );

    else

      table.insert( table_mts, { "anm_apparatusroom_4_1_clot_"..j, { alp = 1 } } );
      table.insert( table_mts, { "obj_apparatusroom_4_1_over_"..j.."_clk", { input = true } } );
      table.insert( table_mts, { "obj_apparatusroom_4_1_sign_"..j.."_clk", { input = false } } );
      table.insert( table_mts, { "spr_apparatusroom_4_1_sign_"..j, { alp = 0 } } );

    end;

    if ( private.save[ 1 ][ j ] ) then

      table.insert( table_mts, { "anm_apparatusroom_4_1_sign_"..j.."_add", { alp = 1, visible = true } } );
      table.insert( table_mts, { "spr_apparatusroom_4_1_sign_"..j.."_add", { visible = true } } );
      
    else

      table.insert( table_mts, { "anm_apparatusroom_4_1_sign_"..j.."_add", { alp = 0, visible = false } } );
      table.insert( table_mts, { "spr_apparatusroom_4_1_sign_"..j.."_add", { visible = false } } );

    end;

  end;

  local mode = ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode;

  if ( mode == "casual" ) then

    table.insert( table_mts, { "spr_apparatusroom_4_1_symbol_hard", { visible = false } } );
    table.insert( table_mts, { "spr_apparatusroom_4_1_symbol_casual", { visible = true } } );

  else

    table.insert( table_mts, { "spr_apparatusroom_4_1_symbol_hard", { visible = true } } );
    table.insert( table_mts, { "spr_apparatusroom_4_1_symbol_casual", { visible = false } } );

  end;

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.CheckWin()

  local mode = ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode;

  local win_state = {};

  win_state[ "casual" ] = { false, true, false, false, false, false, false, true, false, false  };
  win_state [ "hard" ] =  { true , true, false, false, false, true, false, true, false, false  };
  
  for i = 1, #private.save[ 1 ] do

    if ( private.save[ 1 ][ i ] ~= win_state[ mode ][ i ] ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.SignClk( num )

  if ( private.save[ 1 ][ num ] ) then

    local anm = "anm_apparatusroom_4_1_sign_"..num.."_add";

    local endfunc = function ()

    common_impl.Lock( false );

      ObjMultiSet({ 
    
        { "spr_apparatusroom_4_1_sign_"..num.."_add", { visible = false } },
        { anm, { visible = false } },

      });

    end;

    local alp_anm = ObjGet( "anm_apparatusroom_4_1_sign_"..num.."_add" ).alp;

    common_impl.Lock( true );

    DbgTrace( "1" )

    ObjAnimate( anm, "alp", 0, 0, endfunc, 
    { 
      0.00, 3, alp_anm, 
      0.25, 3, 0,

    });

  else

    local anm = "anm_apparatusroom_4_1_sign_"..num.."_add";

    local endfunc = function ()

      common_impl.Lock( false );

    end; 

    local alp_anm = ObjGet( "anm_apparatusroom_4_1_sign_"..num.."_add" ).alp;

    ObjMultiSet({ 
  
      { "spr_apparatusroom_4_1_sign_"..num.."_add", { visible = true } },
      { anm, { visible = true } },

    });

    common_impl.Lock( true );
    DbgTrace( "2" )
    ObjAnimate( anm, "alp", 0, 0, endfunc, 
    { 
      0.00, 3, alp_anm, 
      0.25, 3, 1,

    });

  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_apparatusroom_touch_sign", 0, "", 0 );

  private.save[ 1 ][ num ] = not private.save[ 1 ][ num ];

  if ( private.CheckWin()) then

    private.Win();

  else

    private.MGSave();

  end;

end;
--*********************************************************************************************************************
function private.OverClk( num )

  local endfunc = function ()
    
    common_impl.Lock( false );

    private.save[ 2 ][ num ] = true;
    
    ObjMultiSet({ 
  
      { "obj_apparatusroom_4_1_over_"..num.."_clk", { input = false } },
      { "obj_apparatusroom_4_1_sign_"..num.."_clk", { input = true }},

    });

    private.MGSave();

  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_apparatusroom_touch_cover", 0, "", 0 );

  local over = "anm_apparatusroom_4_1_clot_"..num;

  ObjAttach( over, ObjGetRelations( over ).parent );

  ObjAnimate( over, "alp", 0, 0, "", 
  { 
    0.0, 1, 1, 
    1.5, 1, 0,

  });

  ObjAnimate( over, "pos_y", 0, 1, endfunc, 
  { 
    0.0, 1, 0, 
    1.5, 1, 300,

  });

  local turn = { -1, -1, 1, -1, 1, 1, 1, -1, -1, 1 };

  ObjAnimate( over, "ang", 0, 1, "",
  { 
    0.0, 1, 0, 
    1.5, 1, 1.2*turn[ num ],

  });

  ObjAnimate( "spr_apparatusroom_4_1_sign_"..num, "alp", 0, 0, "", 
  { 
    0.0, 1, 0, 
    0.5, 1, 1,

  });

end;
 --*********************************************************************************************************************   
function private.ButtonMenter()

  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ButtonMleave()

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_apparatusroom_4_1" );
  cmn.CallEventHandler( "win_apparatusroom_4_1" );
  cmn.CallEventHandler( "win_apparatusroom_4_1_loc" );
  common.GotoRoom( "rm_hall_4" );
  
end;
--*********************************************************************************************************************
function private.Win()

  local endfunc = function ()

    common_impl.Lock( false );

    private.WinEnd();

  end;

  common_impl.Lock( true );

  local mode = ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].mode;
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_apparatusroom_win", 0, "", 0 );

  ObjAnimate( "spr_apparatusroom_4_1_symbol_"..mode.."_add", "alp", 0, 0, endfunc, 
  { 
    0.0, 3, 0, 
    0.5, 3, 0,
    0.5, 3, 1,
    0.6, 3, 0,
    0.9, 3, 1,
    1.2, 3, 0,
    1.5, 3, 1,
    
  });

end;
--*********************************************************************************************************************
function private.InitAnimation ()

  for i = 1, 10 do

    private.AnimSymbol( i );

  end;

  ObjAnimate( "obj_apparatusroom_4_1_comlete_sign", "pos_xy", 1, 1, "", 
  { 
    00.0, 3, 0, 0,
    07.5, 3, -10, 10,
    15.5, 3, 0, 0,
    23.6, 3, 10, -10,
    31.2, 3, 0, 0,

  } );
  private.AnimAdd();
end;
--*********************************************************************************************************************
function private.AnimSymbol( number )
  
  local k = 1;
  local k2 = number/10;
  local k3;
  
  if number%2 == 0 then
    
    k3 = -1;
    
  else
    
    k3 = 1;
    
  end;

  ObjAnimate( "spr_apparatusroom_4_1_sign_"..number, "pos_xy", 1, 1, "", 
  {  
     0, 0, k2+0.4*k3, k2+1.6*k3,
     k*2.45, 0, k2+10*k3, k2+2.2*k3,
     k*4.58, 0, k2+-1*k3, k2+13*k3,
     k*6.87, 0, k2+7*k3, k2+8*k3,
     k*9.5, 0, k2+0.4*k3, k2+1.6*k3 

  } );

--  ObjAnimate( "spr_apparatusroom_4_1_sign_"..number.."_add", "pos_xy", 1, 1, "", 
--  { 
--    0, 0, k2+0.4*k3, k2+1.6*k3,
--    k*2.45, 0, k2+10*k3, k2+2.2*k3,
--    k*4.58, 0, k2+-1*k3, k2+13*k3,
--    k*6.87, 0, k2+7*k3, k2+8*k3,
--    k*9.5, 0, k2+0.4*k3, k2+1.6*k3 
--
--  } );
  
end;
--*********************************************************************************************************************
function private.AnimAdd(  )

  for i = 1, 10 do

    local tme = 1.5 + math.random( 1, 5 )/ 10;

    ObjAnimate( "spr_apparatusroom_4_1_sign_"..i.."_add", "alp", 1, 0, endfunc, 
    { 
          0.0, 3, 0, 
          tme, 3, 1,
      2 * tme, 3, 0,
      
    });

  end;


end;