-- name=mg_computerroom
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_computerroom";
  private.win_1_pos = {};
  private.win_2_pos = {};
  private.scale = { 0.76, 0.84, 0.91, 1.0, 1.1, 1.2 };
  private.posx_pos = { -60, -40, -20, 0, 30, 60 };
  private.posy_pos = { -150, -100, -50, 0, 50, 100 };
  private.pi = 3.14;
  win_state = {{5,5,3},{1,3,5}};
  
  local table_multiset = {};

  table.insert( table_multiset, { "spr_computerroom_button_1", { event_mdown = function() private.Move_pos_x() end,
  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
  table.insert( table_multiset, { "spr_computerroom_button_2", { event_mdown = function() private.Move_pos_y() end,
  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
  table.insert( table_multiset, { "spr_computerroom_button_3", { event_mdown = function() private.Scale() end,
  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
  table.insert( table_multiset, { "spr_computerroom_hard_set", { event_mdown = function() private.SetHard();
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_change_mode", 0, "", 0 ); end,
  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
    table.insert( table_multiset, { "spr_computerroom_casual_set", { event_mdown = function() private.SetCasual();
     common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_change_mode", 0, "", 0 ); end,
  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
  event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
 
  ObjMultiSet(table_multiset);
  
  common_impl.hint[ "win_computerroom" ] = {
    type = "win",
    room = "rm_corridor_4",
    zz = "mg_computerroom",
    zz_gate = "gmg_corridor_4_computerroom"
  };
  --------------------------------------------------------------------------------------------
  -- function win_computerroom_loc () end;
  --------------------------------------------------------------------------------------------
  local win_computerroom_loc = function ()

    if ( cmn.IsEventDone( "win_computerroom" ) ) then  
      
      ObjDelete( "gmg_corridor_4_computerroom" );
      ObjSet( "gzz_corridor_4_computer", { active = true, input = true });
      ObjSet( "obj_computer_keycard_4", { alp = 1, input = true });
      
      ObjSet( "spr_corridor_4_computer_card", { alp = 1 } );
      
    end;

  end;

  cmn.AddSubscriber( "win_computerroom", win_computerroom_loc, "rm_corridor_4" );
  --------------------------------------------------------------------------------------------
  -- function win_computerroom () end;
  --------------------------------------------------------------------------------------------
  local win_computerroom = function ()

  if ( cmn.IsEventDone( "win_computerroom" ) ) then  

  elseif cmn.IsEventStart( "win_computerroom" ) then
    
    local mg_num = ng_global.progress[ "ext" ][ "win_computerroom" ].state[1];
    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2];
  
    ObjSet( "spr_computerroom_button_1_arrow", { ang = private.pi/3 * ( state[1] - 1 )} )
    ObjSet( "spr_computerroom_button_2_arrow", { ang = private.pi/3 * ( state[2] - 1 ) } )
    ObjSet( "spr_computerroom_button_3_arrow", { ang = private.pi/3 * ( state[3] - 1 ) } )
    ObjSet( "spr_computerroom_wave_1", { pos_x = private.posx_pos[win_state[mg_num][1]], pos_y = private.posy_pos[win_state[mg_num][2]],scale_x = private.scale[win_state[mg_num][3]] } )
    ObjSet( "spr_computerroom_wave_2", { pos_x = private.posx_pos[state[1]], pos_y = private.posy_pos[state[2]],scale_x = private.scale[state[3]] } )
    if mg_num > 1 then
      ObjSet( "spr_computerroom_flame_1_2", { alp = 1 });
      ObjSet( "spr_computerroom_flame_1_1", { alp = 0 });
    end;
    if ng_global.progress[ "ext" ][ "win_computerroom" ].hard then
      ObjMultiSet({
      { "spr_computerroom_hard_set", { alp = 1, input = false } },
      { "spr_computerroom_casual_set", { input = true, alp = 0 } },
      { "spr_computerroom_button_3", { alp = 1, input = true } },
      { "spr_computerroom_wave_2", { pos_x = 0, scale_x = 1, pos_y = 0 } },
      });
    else
      ObjMultiSet({
      { "spr_computerroom_hard_set", { alp = 0, input = true } },
      { "spr_computerroom_casual_set", { input = false, alp = 1 } },
      { "spr_computerroom_button_3", { alp = 0, input = false } },
      { "spr_computerroom_wave_2", { pos_x = 0, scale_x = private.scale[win_state[mg_num][3]], pos_y = 0 } },
      });
      
    end;
    
  end;

  end;

  cmn.AddSubscriber( "win_computerroom", win_computerroom, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_computerroom" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_computerroom" ) ) then
    ng_global.progress[ "ext" ][ "win_computerroom" ].state = { 1, {4,4,4}};
    ng_global.progress[ "ext" ][ "win_computerroom" ].hard = true;
    local mg_num = ng_global.progress[ "ext" ][ "win_computerroom" ].state[1];
    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2];
    ObjSet( "spr_computerroom_button_1_arrow", { ang = private.pi/3 * ( state[1] - 1 )} )
    ObjSet( "spr_computerroom_button_2_arrow", { ang = private.pi/3 * ( state[2] - 1 ) } )
    ObjSet( "spr_computerroom_button_3_arrow", { ang = private.pi/3 * ( state[3] - 1 ) } )
    ObjSet( "spr_computerroom_wave_1", { pos_x = private.posx_pos[win_state[mg_num][1]], pos_y = private.posy_pos[win_state[mg_num][2]],scale_x = private.scale[win_state[mg_num][3]] } )
    ObjSet( "spr_computerroom_wave_2", { pos_x = private.posx_pos[state[1]], pos_y = private.posy_pos[state[2]],scale_x = private.scale[state[3]] } )

  end;
  
  if not cmn.IsEventDone( "win_computerroom" ) then
   if ng_global.gamemode == 0 then
     private.SetCasual();
    end;  
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_computerroom" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MG_FUNC  *** () end;
--*********************************************************************************************************************
  function private.Move_pos_y()

    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][2];
    local start_ang = private.pi/3 * ( state - 1);
    local end_ang = private.pi/3 * state;
    local new_state = state + 1;
    if (#private.posy_pos == state ) then 
      new_state = 1;
    end;
    
    local func_after = function ()
   
      common_impl.Lock( false );
      ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][2] = new_state;
      private.CheckWin( );
   
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_touch_circle", 0, "", 0 );
    
    ObjAnimate( "spr_computerroom_button_2_arrow", "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, end_ang
    } );
    ObjAnimate( "spr_computerroom_wave_2", "pos_y", 0, 0, "",
    { 
    0.0, 0, private.posy_pos[state],
    0.3, 0, private.posy_pos[new_state]
    } );
    
  end;
  function private.Move_pos_x()

    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][1];
    local start_ang = private.pi/3 * ( state - 1);
    local end_ang = private.pi/3 * state;
    local new_state = state + 1;
    if (#private.posx_pos == state ) then 
      new_state = 1;
    end;
    
    local func_after = function ()
   
      common_impl.Lock( false );
      ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][1] = new_state;
      private.CheckWin( );
   
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_touch_circle", 0, "", 0 );

    
    ObjAnimate( "spr_computerroom_button_1_arrow", "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, end_ang
    } );
    ObjAnimate( "spr_computerroom_wave_2", "pos_x", 0, 0, "",
    { 
    0.0, 0, private.posx_pos[state],
    0.3, 0, private.posx_pos[new_state]
    } );
    
  end;
  function private.Scale()

    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][3];
    local start_ang = private.pi/3 * ( state - 1);
    local end_ang = private.pi/3 * state;
    local new_state = state + 1;
    if (#private.scale == state ) then 
      new_state = 1;
    end;
    
    local func_after = function ()
   
      
      common_impl.Lock( false );
      ng_global.progress[ "ext" ][ "win_computerroom" ].state[2][3] = new_state;
      private.CheckWin( );
   
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_touch_circle", 0, "", 0 );

    
    ObjAnimate( "spr_computerroom_button_3_arrow", "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, end_ang
    } );
    ObjAnimate( "spr_computerroom_wave_2", "scale_x", 0, 0, "",
    { 
    0.0, 0, private.scale[state],
    0.3, 0, private.scale[new_state]
    } );
    
  end;
  function private.CheckWin()
  
    local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2];
    local mg_num = ng_global.progress[ "ext" ][ "win_computerroom" ].state[1];
    local win_flag = true;
    for i = 1,3 do
      if state[i] ~= win_state[mg_num][i] then
  
        if not (i==3 and not ng_global.progress[ "ext" ][ "win_computerroom" ].hard ) then 
          win_flag = false;
          break;
        end;
        
      end;
    end;
    if win_flag then
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_right", 0, "", 0 );

      if mg_num == 1 then
        private.SetState();
      else
        
        state[1]=state[1]-1;
        local func_after = function()
          
          private.Win();
          common_impl.Lock( false );
          
        end;
        common_impl.Lock( true );
        ObjAnimate( "spr_computerroom_wave_2_win", "alp", 0, 0, func_after,
        { 
          0.0, 0, 0,
          0.3, 0, 1
        } );
        ObjAnimate( "spr_computerroom_flame_2_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
      
      ObjAnimate( "spr_computerroom_flame_2_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
        
      end;
      
    end;
      
  end;
  function private.SetState()
    
    local func_after = function()
    
      local new_scale = 1;
      if not ng_global.progress[ "ext" ][ "win_computerroom" ].hard then
        new_scale = private.scale[win_state[2][3]];
      end;
      ObjSet( "spr_computerroom_wave_1", { pos_x = private.posx_pos[win_state[2][1]], pos_y = private.posy_pos[win_state[2][2]],scale_x = private.scale[win_state[2][3]] } )
      ObjSet( "spr_computerroom_wave_2", { pos_x = 0, scale_x = new_scale, pos_y = 0 } )
      ObjSet( "spr_computerroom_button_1_arrow", { ang = 0 } )
      ObjSet( "spr_computerroom_button_2_arrow", { ang = 0 } )
      ObjSet( "spr_computerroom_button_3_arrow", { ang = 0 } )
    
      local set_end = function()
      
        common_impl.Lock( false );
        ng_global.progress[ "ext" ][ "win_computerroom" ].state[1] = 2;
        ng_global.progress[ "ext" ][ "win_computerroom" ].state[2] = {4,4,4};
        
      end;
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_computerroom_win", 0, "", 0 );

      ObjSet( "spr_computerroom_wave_1_win", {alp = 0});
      ObjAnimate( "obj_computerroom_waves", "alp", 0, 0, set_end,
      { 
      0.0, 0, 0,
      0.3, 0, 1
      } );
      
    end;
    
    common_impl.Lock( true );
    
    ObjAnimate( "spr_computerroom_wave_1_win", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    ObjAnimate( "spr_computerroom_flame_1_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );
    
    ObjAnimate( "spr_computerroom_flame_1_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    ObjAnimate( "obj_computerroom_waves", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1,
      0.3, 0, 1,
      0.6, 3, 0
    } );
    
  end;
--*********************************************************************************************************************
function public.Reset()

  if ng_global.progress[ "ext" ][ "win_computerroom" ].hard then
    
    private.SetHard()
    
  else
    
    private.SetCasual()
    
  end;
  
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.SetHard()
  
  local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2];
  local mg_num = ng_global.progress[ "ext" ][ "win_computerroom" ].state[1];
  ObjMultiSet({
  { "spr_computerroom_hard_set", { alp = 1, input = false } },
  { "spr_computerroom_casual_set", { input = true, alp = 0 } },
  { "spr_computerroom_button_3", { alp = 1, input = true } },
  { "spr_computerroom_wave_2", { pos_x = 0, scale_x = 1, pos_y = 0 } },
  });
  ObjSet( "spr_computerroom_button_1_arrow", { ang = 0 } )
  ObjSet( "spr_computerroom_button_2_arrow", { ang = 0 } )
  ObjSet( "spr_computerroom_button_3_arrow", { ang = 0 } )
  ng_global.progress[ "ext" ][ "win_computerroom" ].hard = true;
  ng_global.progress[ "ext" ][ "win_computerroom" ].state[2] = {4,4,4}
  ObjSet( "spr_computerroom_wave_1", { pos_x = private.posx_pos[win_state[mg_num][1]], pos_y = private.posy_pos[win_state[mg_num][2]],scale_x = private.scale[win_state[mg_num][3]] } )

end;
--*********************************************************************************************************************
function private.SetCasual()
  
  local state = ng_global.progress[ "ext" ][ "win_computerroom" ].state[2];
  local mg_num = ng_global.progress[ "ext" ][ "win_computerroom" ].state[1];
  ng_global.progress[ "ext" ][ "win_computerroom" ].state[2] = {4,4,4}
  ObjMultiSet({
  { "spr_computerroom_casual_set", { alp = 1, input = false } },
  { "spr_computerroom_hard_set", { input = true, alp = 0 } },
  { "spr_computerroom_button_3", { input = true, alp = 0 } },
  { "spr_computerroom_wave_2", { pos_x = 0, scale_x = private.scale[win_state[mg_num][3]], pos_y = 0 } },
  });
  ObjSet( "spr_computerroom_button_1_arrow", { ang = 0 } )
  ObjSet( "spr_computerroom_button_2_arrow", { ang = 0 } )
  ObjSet( "spr_computerroom_button_3_arrow", { ang = 0 } )
  ng_global.progress[ "ext" ][ "win_computerroom" ].hard = false;
  ObjSet( "spr_computerroom_wave_1", { pos_x = private.posx_pos[win_state[mg_num][1]], pos_y = private.posy_pos[win_state[mg_num][2]],scale_x = private.scale[win_state[mg_num][3]] } )

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_computerroom" );
  cmn.CallEventHandler( "win_computerroom" );
  cmn.CallEventHandler( "win_computerroom_loc" );

  common.GotoRoom( "rm_corridor_4" );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************