-- name=mg_door_4
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_door_4";
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_door_4 = function ()

  local effects_table = 
  {
    "spr_door_4_light_add",
    "obj_door_4_gear"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_door_4", update_performance_mode_door_4, private.room_objname );
  --------------------------------------------------------------------------------------------  
  private.button_push = { 0, 0, 0, 0, 0, 0 };
  
  private.win_array = { { 1, 1, 0, 0, 0, 0 },
                        { 0, 0, 0, 1, 0, 1 },
                        { 0, 0, 1, 0, 0, 1 },
                        { 0, 1, 0, 0, 1, 0 },
                        { 0, 1, 1, 0, 0, 0 },
                        { 1, 0, 0, 1, 0, 0 }
                      };
  
  for i = 1, 6 do
    
    ObjSet( "obj_door_4_button_"..i.."_clk", { event_mdown = function() private.PushButton( i ); end,
                                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  ObjMultiSet({ 
  { "obj_door_4_mode_clk", { event_mdown = function() private.ModeChange() end,
                             event_menter = function() private.MouseEnterAnim() end,
                             event_mleave = function() private.MouseLeaveAnim() end;
                           }},
  });
  
  
  
  --ObjMultiSet({ 
  --});
  common_impl.hint[ "win_door_4" ] = {
    type = "win",
    room = "rm_secondfloor",
    zz = "mg_door_4",
    zz_gate = "gmg_secondfloor_door_4"
  };
  --------------------------------------------------------------------------------------------
  -- function win_door_4_loc () end;
  --------------------------------------------------------------------------------------------
  local win_door_4_loc = function ()

    if ( cmn.IsEventDone( "win_door_4" ) ) then  
      
      ObjDelete( "gmg_secondfloor_door_4" );
      ObjSet( "grm_secondfloor_study", { active = true, input = true });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloor_study_focus");
      end;
      ObjDelete( "obj_secondfloor_studydoor" );
      ObjSet( "obj_secondfloor_studydoor_open", { alp =1 });
      
    end;

  end;

  cmn.AddSubscriber( "win_door_4", win_door_4_loc, "rm_secondfloor" );
  --------------------------------------------------------------------------------------------
  -- function win_door_4 () end;
  --------------------------------------------------------------------------------------------
  local win_door_4 = function ()

    if ( cmn.IsEventDone( "win_door_4" ) ) then  
      
      

    else
    
      if ng_global.progress[ "ext" ][ "win_door_4" ].mode == 2 then
        
        ObjSet("obj_door_4_hard", { alp = 0 });
        ObjSet( "obj_door_4_mode_casual", { alp = 1 });
        ObjSet( "obj_door_4_mode_hard", { alp = 0 });
        
      end; 
     
      for i = 1, ng_global.progress[ "ext" ][ "win_door_4" ].prog  do
        
        ObjSet("obj_door_4_task_"..i, { alp = 1 });
        
      end;
      
      if ng_global.progress[ "ext" ][ "win_door_4" ].prog > 1 then
        
        for i = 1, ng_global.progress[ "ext" ][ "win_door_4" ].prog - 1  do
          
          ObjSet("spr_door_4_task_"..i.."_add", { alp = 1 });
          
        end;
        
      end;  
      
      for i = 1, 6  do
        
        if ng_global.progress[ "ext" ][ "win_door_4" ].push_button[i] ~= 0 then
          
          ObjSet( "spr_door_4_button_"..i.."_add", { alp = 1});
          ObjSet( "spr_door_4_center_"..i.."_sign", { alp = 1 });
          
        end;
        
      end;
      
      

    end;

  end;

  cmn.AddSubscriber( "win_door_4", win_door_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 
  
  ObjSet("obj_int_button_info_impl", { pos_y = -20 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -34 });
  if not cmn.IsEventDone( "win_door_4" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventStart( "win_door_4" ) ) then
    --ng_global.progress[ "std" ][ "win_door_4" ].state = {};
    ng_global.progress[ "ext" ][ "win_door_4" ].prog = 1;
    ng_global.progress[ "ext" ][ "win_door_4" ].push_button = { 0, 0, 0, 0, 0, 0 };
    ng_global.progress[ "ext" ][ "win_door_4" ].mode = 1;
    
  end;
  private.GearsAnim();
  common_impl.PlayAudio( "env", "common/audio/levelext/aud_mg_doorroom_env", 1, "", 0 );
  
  if not cmn.IsEventDone( "win_door_4" ) then
   if ng_global.gamemode == 0 then
     ng_global.progress[ "ext" ] [ "win_door_4" ].mode = 1;
     private.ModeChange();
    end;  
  end;
 
end;
--*********************************************************************************************************************
function public.Close()
  
  ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
  common_impl.StopAudio( "env", "common/audio/levelext/aud_mg_doorroom_env", 0.3 );
  --ObjSet( "tmr_door_4", { playing = true, time = 0.3, endtrig = function()  ObjSet("obj_int_button_info_impl", { pos_y = -91 }); ObjSet("obj_int_button_reset_impl", { pos_y = -105 }); end } );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_door_4" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  --ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  --ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.PushButton( num )
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_doorroom_touch_sign", 0, "", 0 );
  
  if ng_global.progress[ "ext" ][ "win_door_4" ].push_button[num] == 0 then 
    
    private.ShowSymbol(num);
    
  else 
    
    private.HideSymbol(num);
   
  end; 
   
  
end;

--------------------------------------------------------------------------------

function private.ModeChange()
  
  local func_after = function()

    common_impl.Lock( false );
    
    if ng_global.progress[ "ext" ] [ "win_door_4" ].mode == 1 then 
      
      ObjSet( "obj_door_4_hard", { alp = 0 });
      ng_global.progress[ "ext" ] [ "win_door_4" ].mode = 2;
      public.Reset();
      
    else 
      
     ObjSet( "obj_door_4_hard", { alp = 1 });
     ng_global.progress[ "ext" ] [ "win_door_4" ].mode = 1;
     public.Reset();
      
    end;
   
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_doorroom_change_mode", 0, "", 0 );
  
  if ng_global.progress[ "ext" ] [ "win_door_4" ].mode == 1 then 
    
    
      ObjAnimate( "obj_door_4_mode_casual", "alp", 0, 0, "",
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } ); 
      
      ObjAnimate( "obj_door_4_mode_hard", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } ); 
    
  else  
      
      ObjAnimate( "obj_door_4_mode_hard", "alp", 0, 0, "",
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } ); 
      
      ObjAnimate( "obj_door_4_mode_casual", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } ); 
      
   end;
  
end;  
--*********************************************************************************************************************
-- function *** PROGRESS OTHER *** () end;
--*********************************************************************************************************************
function private.ShowSymbol(num)
  
  local func_after = function()
  
    common_impl.Lock( false );
    ng_global.progress[ "ext" ][ "win_door_4" ].push_button[num] = 1;
    private.CheckTask( num );
  
  end;

  common_impl.Lock( true );
  
  ObjAnimate( "spr_door_4_center_"..num.."_sign", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } ); 
  
  ObjAnimate( "spr_door_4_button_"..num.."_add", "alp", 0, 0, "",
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } ); 

  
end;
  
--------------------------------------------------------------------------------

function private.HideSymbol(num)
  
  local func_after = function()
  
    common_impl.Lock( false );
    ng_global.progress[ "ext" ][ "win_door_4" ].push_button[num] = 0;
    private.CheckTask( num );
  
  end;

  common_impl.Lock( true );
  
  ObjAnimate( "spr_door_4_center_"..num.."_sign", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } ); 
  
  ObjAnimate( "spr_door_4_button_"..num.."_add", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } ); 
  
end;  

--------------------------------------------------------------------------------

function private.CheckTask(num)

  local temp = { 0, 0, 0, 0, 0, 0 };
  
  local bool = true;
  
  for i = 1, 6  do
    
    temp[i] = private.win_array[ng_global.progress[ "ext" ][ "win_door_4" ].prog][i];
    
    if temp[i] ~= ng_global.progress[ "ext" ][ "win_door_4" ].push_button[i] then
      
      bool = false;
      
    end;
    
  end;
  
  --if ng_global.progress[ "ext" ][ "win_door_4" ].push_button == temp then 
    
   if  bool then
    
    if ng_global.progress[ "ext" ][ "win_door_4" ].mode == 1 then 
    
      ng_global.progress[ "ext" ][ "win_door_4" ].prog = ng_global.progress[ "ext" ][ "win_door_4" ].prog + 1
      
    else
      
      if ng_global.progress[ "ext" ][ "win_door_4" ].prog == 3 then
        
        ng_global.progress[ "ext" ][ "win_door_4" ].prog = ng_global.progress[ "ext" ][ "win_door_4" ].prog + 1
        
      else  
        
        ng_global.progress[ "ext" ][ "win_door_4" ].prog = ng_global.progress[ "ext" ][ "win_door_4" ].prog + 2;
        
      end;
      
    end; 
    
    private.ChangeLvl();
      
    
  end;  
  
end;

--------------------------------------------------------------------------------

function private.ChangeLvl()
  
   local func_after = function()
   
    common_impl.Lock( false );
    
   end;
  
    if ng_global.progress[ "ext" ][ "win_door_4" ].prog > 6 then
      
      local func_last = function()
      
        common_impl.Lock( false ); 
        private.Win();
        --return;
        
      end;  
      
      common_impl.Lock( true ); 
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_doorroom_right", 0, "", 0 );
      
       ObjAnimate( "spr_door_4_task_6_add", "alp", 0, 0, func_last,
       { 
           0.0, 0, 0,
           0.3, 0, 1
           
       } );
       
       return;
      
    end;  
 
   common_impl.Lock( true ); 
   
   private.ResetButton();
   
   common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_doorroom_right", 0, "", 0 );
   
   local temp = ng_global.progress[ "ext" ][ "win_door_4" ].prog - 1;
   
   if (ng_global.progress[ "ext" ][ "win_door_4" ].prog == 3  or ng_global.progress[ "ext" ][ "win_door_4" ].prog == 6) and ng_global.progress[ "ext" ][ "win_door_4" ].mode == 2 then
     
     temp = ng_global.progress[ "ext" ][ "win_door_4" ].prog - 2;
     
   end;  
   
   ObjAnimate( "spr_door_4_task_"..temp.."_add", "alp", 0, 0, "",
   { 
       0.0, 0, 0,
       0.3, 0, 1
       
   } ); 
  
   ObjAnimate( "obj_door_4_task_"..ng_global.progress[ "ext" ][ "win_door_4" ].prog, "alp", 0, 0, func_after,
   { 
       0.0, 0, 0,
       0.3, 0, 1
       
   } ); 
  

end;
 
--------------------------------------------------------------------------------

function private.ResetButton()
  
  ng_global.progress[ "ext" ][ "win_door_4" ].push_button = { 0, 0, 0, 0, 0, 0 };

  for i = 1, 6  do
    
    if ObjGet("spr_door_4_center_"..i.."_sign").alp == 1 then
      
     ObjSet( "spr_door_4_center_"..i.."_sign", { alp = 0 }); 
     
    end; 
    
    if ObjGet("spr_door_4_button_"..i.."_add").alp == 1 then
      
      ObjSet( "spr_door_4_button_"..i.."_add", { alp = 0 }); 
     
    end; 
   
    
  end;
  
 
end; 
--*********************************************************************************************************************
function public.Reset()
  
  private.ResetButton();
  
  ng_global.progress[ "ext" ][ "win_door_4" ].prog = 1;
  
  for i = 2, 6  do
    
    ObjSet( "obj_door_4_task_"..i, { alp = 0});
    ObjSet( "spr_door_4_task_"..i.."_add", { alp = 0});
    
  end;
  
  ObjSet("spr_door_4_task_1_add", { alp = 0 });
   

end;
--*********************************************************************************************************************
function public.Skip()
    port.skip_mg = true;
  local func_after = function()
  
     common_impl.Lock( false );

    private.Win();
    
  end;  
  
  private.ResetButton();
  
  common_impl.Lock( true ); 
  
  for i = 1, 6  do
    
    --if ObjGet("obj_door_4_task_"..i).alp == 0 then
    --  
    -- ObjAnimate( "obj_door_4_task_"..i, "alp", 0, 0, "",
    -- { 
    --     0.0, 0, 0,
    --     0.3, 0, 1
    -- } ); 
   
     if ObjGet("spr_door_4_task_"..i.."_add").alp == 0 then
       
       ObjAnimate( "spr_door_4_task_"..i.."_add", "alp", 0, 0, func_after,
       { 
           0.0, 0, 0,
           0.3, 0, 1
       } );
       func_after = "";
      
     if ObjGet("obj_door_4_task_"..i).alp == 0 then
      
     ObjAnimate( "obj_door_4_task_"..i, "alp", 0, 0, "",
     { 
         0.0, 0, 0,
         0.3, 0, 1
     } );   
       
     end;
     
    end;  
    
 end;
 
end;
--------------------------------------------------------------------------------
function private.GearsAnim()
  
  for i = 1, 6  do
    
    if i%2 == 0 then 
      
      ObjAnimate( "spr_door_4_gear_"..i, "ang", 1, 0, "", { 0,0,0, 120,0,-120 } );
      ObjAnimate( "spr_door_4_gear_"..i.."_shadow", "ang", 1, 0, "", { 0,0,0, 120,0,-120 } );
      
   else  
      
      ObjAnimate( "spr_door_4_gear_"..i, "ang", 1, 0, "", { 0,0,0, 120,0,120 } );
      ObjAnimate( "spr_door_4_gear_"..i.."_shadow", "ang", 1, 0, "", { 0,0,0, 120,0,120 } );
      
    end;  
      
  end;
  
  
  
  
end;  
--*********************************************************************************************************************
function private.MouseEnterAnim()

  if ( cmn.IsPC() ) then
  
    common_impl.SetCursor( CURSOR_HAND );

    local obj = "spr_door_4_mode_light_add";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
    
  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim()
  
    common_impl.SetCursor( CURSOR_DEFAULT );

    local obj = "spr_door_4_mode_light_add";
    local alp = ObjGet( obj ).alp;
    local tme = alp * 0.3;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_door_4" );
  cmn.CallEventHandler( "win_door_4" );
  cmn.CallEventHandler( "win_door_4_loc" );
  common.GotoRoom( "rm_secondfloor" );

end;
--*********************************************************************************************************************
function private.Win()

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_doorroom_wrong", 0, "", 0 );
  ObjSet( "tmr_door_4", { playing = true, time = 0.3, endtrig = function() private.WinEnd()   end } );
  --private.WinEnd(); 

end;
--*********************************************************************************************************************
ObjAnimate( "spr_door_4_light_add", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
