-- name=mg_final
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_final";
  
  private.mmg_start = {{ 3,false,2,false,4 }, 
                       {  1, 5,false ,3 ,4 }, 
                       {  4, 2, 1, 5, 3 }};
  --private.mmg_start = {{ false,3,2,4,false }, 
  --                     {  1, 5,false ,3 ,4 }, 
  --                     {  4, 2, 1, 5, 3 }};
  private.mmg_1_start = { 1,3,2,4,5 };
  
  private.circles = {
    { nil },
    { 1,3 },
    { 2,4,5 },
    { 1,3,4,5 },
    { 1,2,3,4,5 }
  }
  private.slots = {
    --{ nil },
    --    { 2,4 },
    { 1,3,5 },
    { 1,2,4,5 },
    { 1,2,3,4,5}
  }

  
  table_multiset = {};
  for i = 1,5 do 

      table.insert( table_multiset, { "spr_round_symbol_"..i, {
      event_menter = function() common_impl.SetCursor( CURSOR_GET ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      drag = true,
      event_startdrag = function()  private.CircleStartDrag() end,
      event_dragdrop = function() private.CircleDropDrag( i ) end
      } } );

  end;

  ObjMultiSet( table_multiset );
  
  common_impl.hint[ "win_final" ] = {
    type = "win",
    room = "rm_secondroom",
    zz = "mg_final",
    zz_gate = "gmg_secondroom_final"
  };
  --------------------------------------------------------------------------------------------
  -- function win_final_loc () end;
  --------------------------------------------------------------------------------------------
  local win_final_loc = function ()

    if ( cmn.IsEventDone( "win_final" ) ) then  

      ObjDelete( "gmg_secondroom_final" );

    end;

  end;

  cmn.AddSubscriber( "win_final", win_final_loc, "rm_secondroom" );
  --------------------------------------------------------------------------------------------
  -- function win_final () end;
  --------------------------------------------------------------------------------------------
  local win_final = function ()

    if ( cmn.IsEventDone( "win_final" ) ) then

    elseif cmn.IsEventStart( "win_final" ) then

      private.Reset();      

    end;

  end;

  cmn.AddSubscriber( "win_final", win_final, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_final" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_mg_final_env" }, "", 0.5 );
  private.ShowSlots();
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_final" ) ) then

    ng_global.progress[ "ext" ][ "win_final" ].state = { 1,3 };
    ng_global.progress[ "ext" ][ "win_final" ].progress = {};
    private.Reset();

  else
    private.CheckWin();
  end;  
  

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_final" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.CircleStartDrag()
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_final_touch_sign", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.CircleDropDrag( number )

  drag_obj = "spr_round_symbol_"..number;
  apply_obj = drag_obj.."_slot";
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_final_set_sign", 0, "", 0 );
  
  if common.ApplyObj( drag_obj, apply_obj, false ) then
    
    local func_after = function()
      
      common_impl.Lock( false );
      private.CheckWin();
      
    end;
    
    common_impl.Lock( true );
    ObjSet( drag_obj, { alp = 0, input = false } );
    ObjAnimate( apply_obj, "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
      
  else
   
    for i = 1,5 do
  
      if common.ApplyObj( drag_obj, "spr_round_symbol_"..i.."_slot", false ) then
        
        common_impl.Lock(true);
        ObjMultiSet({ 
          { "anm_final_ghost_3", { alp = 1 }},
          { "anm_final_ghost_1", { alp = 0}}   
        });
        AnimPlay( "anm_final_ghost_3", "DoAnim", public.Reset);
        common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_final_wrong", 0, "", 0 );

        break;
        
        
      end;
      
    end;
    
  end;
  
end;
function private.CheckWin()
    
  local state = ng_global.progress[ "ext" ][ "win_final" ].state[1];
  
  for i = 1, 5 do
    
    if private.mmg_start[state][i] then
      
      if ObjGet( "spr_round_symbol_"..private.mmg_start[state][i].."_slot" ).alp == 0 then
        return;
      end;
    
    end;
    
  end;
  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_final_right", 0, "", 0 );

  ObjMultiSet({ 
    { "anm_final_ghost_1", { alp = 0 }},
    { "anm_final_ghost_2", { alp = 1}}   
  });
  if ng_global.progress[ "ext" ][ "win_final" ].state[1] == 3 then

    AnimPlay( "anm_final_ghost_2", "DoAnim", private.Win );
  else
    AnimPlay( "anm_final_ghost_2", "DoAnim", private.IncLevel );
  end;
  
end;
--*********************************************************************************************************************
function private.ShowSlots()

  local func_after = function()
  
    common_impl.Lock( false );
  
  end;
  
  
  local time = 0;
  step = 0.6
  
  common_impl.Lock( true );
  for i = 1,5 do

    if ObjGetRelations( "spr_round_symbol_"..i.."_slot" ).parent ~= "obj_final_hub" then
 
    ObjAnimate( "spr_round_symbol_"..i.."_slot", "alp", 0, 0, func_after,
    { 
      0.0     , 0, 0.0, 
      time    , 0, 0.0,
      time+0.3, 0, 1.0,
      3, 0, 1.0,
      3.3, 0, 0.0 
    } );
     
    local func_sound = function()
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_final_show_sign", 0, "", 0 );
    end;
      
    ObjSet( "tmr_final_sound_"..i, { playing = true, time = time, endtrig = func_sound} )
      
    time = time + 0.6;
    func_after="";
    
    end;

  end;
  
end;
function private.IncLevel()
  
  local anim_hit_after = function()
  
    local func_after = function()
    
      common_impl.Lock( false );
      
    end;
    
    ng_global.progress[ "ext" ][ "win_final" ].state[1] = ng_global.progress[ "ext" ][ "win_final" ].state[1] + 1;
    ng_global.progress[ "ext" ][ "win_final" ].state[2] = ng_global.progress[ "ext" ][ "win_final" ].state[2] + 1;
    
    private.Reset();
    
    ObjAnimate( "obj_final_panel", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_final_round_small", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    
  end;
  
  common_impl.Lock( true );
  ObjSet( "obj_final_panel", { alp = 0 });
  ObjAnimate( "obj_final_round_small", "alp", 0, 0, anim_hit_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  
  
end;
function private.Reset()
  
  local state = ng_global.progress[ "ext" ][ "win_final" ].state[1];
  local number = #private.slots[state]
  local j = 1;
  for i = 1,5 do
    
      ObjAttach( "spr_round_symbol_"..i, "obj_final_hub"  )
      ObjAttach( "spr_round_symbol_"..i.."_slot", "obj_final_hub"  )
      
  end;
  for i = 1, 5 do
    
    if private.mmg_start[state][i] then
      
      ObjAttach( "spr_round_symbol_"..private.mmg_start[state][i], "obj_round_symbol_"..i  )
      ObjAttach( "spr_round_symbol_"..private.mmg_start[state][i].."_slot", "obj_final_round_small_"..private.circles[number][j]  )
      ObjSet( "spr_round_symbol_"..private.mmg_start[state][i], { alp = 1, input = true });
      ObjSet( "spr_round_symbol_"..private.mmg_start[state][i].."_slot", { alp = 0, input = false });
      j = j+1;

    end;
    
  end;
  private.ShowSlots();
  
end;
function public.Reset()

  ng_global.progress[ "ext" ][ "win_final" ].state = { 1,3 };
  private.Reset();
  ObjMultiSet({ 
    { "anm_final_ghost_3", { alp = 0 }},
    { "anm_final_ghost_2", { alp = 0 }},
    { "anm_final_ghost_1", { alp = 1}}   
  });

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  common_impl.Lock( false );
  cmn.MiniGameHide();
  common_impl.PassingMgWin();
  cmn.SetEventDone( "win_final" );
  cmn.CallEventHandler( "win_final" );
  cmn.CallEventHandler( "win_final_loc" );
  
  common.GotoRoom( "rm_secondroom" );

end;
--*********************************************************************************************************************
function private.Win()

  
  ObjMultiSet({ 
    { "anm_final_ghost_2", { alp = 0 }},
    { "anm_final_ghost_1", { alp = 1}}   
  });
  private.WinEnd();

end;
--*********************************************************************************************************************
for i = 1,5 do
  
  ObjAnimate( "obj_round_round_"..i, "ang", 1, 0, "",
  { 
    0.0, 0, 0.0, 
    4.0, 0, 6.28
  } );
  ObjAnimate( "spr_round_symbol_"..i.."_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.6, 0, 0.7,
    1.2, 0, 1.0
  } );
  
end;

ObjAnimate( "spr_round_round_big", "ang", 1, 0, "",
{ 
  0.0, 0, 0.0, 
  12.0, 0, 6.28
} );