-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd( 26 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  --interface.LoupeAdd( 8 );
  interface.PuzzleHelpAdd( 13 );
  --interface.BtnApparatAdd( 25 );
  interface.BtnMiniHOAdd(8);
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();

  common.LevelLoad( "levelext", "ext", "rm_hall_4", param, private.menu_moduls );
  
  if IsCollectorsEdition() then
    
    common_impl.SetMorphEventDone();
    common_impl.SetCollectEventDone();

  end;

  private.TutorialSetParams();
  interface.KeyUpdate();
  
  --common_impl.LoupeSave();
  common_impl.Collectibles2Load();
  common_impl.UpdateGameMode( ng_global.gamemode ); 
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_hall_4"
  ,"mg_apparatusroom_4_1"
  ,"rm_behindstage"
  ,"rm_smallroom_4"
  ,"ho_pharmacy"
  ,"rm_corridor_4"
  ,"mg_computerroom"
  ,"rm_lunchroom_4"
  ,"mg_apparatusroom_4_2"
  ,"ho_warehouse"
  ,"rm_secondfloor"
  ,"mg_apparatusroom_4_3"
  ,"rm_balcony"
  ,"ho_balconyroom"
  ,"mg_door_4"
  ,"rm_study"
  ,"ho_mockuproom"
  ,"rm_secondroom"
  ,"mg_final"
  };

  game.progress_names_room =
  {
   { "beg_levelext" }
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "get_collect_morph_item_1_5" }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_morph_item_2_1" }
  ,{ "get_collect_morph_item_2_2" }
  ,{ "get_collect_morph_item_2_3" }
  ,{ "get_collect_morph_item_2_4" }
  ,{ "get_collect_morph_item_2_5" }
  ,{ "get_collect_morph_item_3_1" }
  ,{ "get_collect_morph_item_3_2" }
  ,{ "get_collect_morph_item_3_3" }
  ,{ "get_collect_morph_item_3_4" }
  ,{ "get_collect_morph_item_3_5" }
  ,{ "get_collect_morph_item_3_6" }
  ,{ "opn_hall_4",                              "rm_hall_4",                    { "beg_levelext" } }
  ,{ "get_collect_morph_item_4_1" }
  ,{ "vid_hall_4_incident",                     "rm_hall_4",                    { "opn_hall_4" } }
  ,{ "get_bagbutton",                           "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "get_thermos_4",                           "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "get_amuletelement_4_1",                   "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "get_caseelement_4_1",                     "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "get_micholder",                           "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "get_caseelement_4_2",                     "rm_hall_4",                    { "vid_hall_4_incident" } }
  ,{ "use_bagbutton",                           "rm_hall_4",                    { "get_bagbutton" } }
  ,{ "clk_bag_4",                               "rm_hall_4",                    { "use_bagbutton" } }
  ,{ "get_cutters_4",                           "rm_hall_4",                    { "clk_bag_4" } }
  ,{ "get_diode_4_1",                           "rm_hall_4",                    { "clk_bag_4" } }
  ,{ "use_cutters_4",                           "rm_hall_4",                    { "get_cutters_4" } }
  ,{ "get_caseelement_4_3",                     "rm_hall_4",                    { "use_cutters_4" } }
  ,{ "use_caseelement_4_1",                     "rm_hall_4",                    { "get_caseelement_4_1" } }
  ,{ "use_caseelement_4_2",                     "rm_hall_4",                    { "get_caseelement_4_2" } }
  ,{ "use_caseelement_4_3",                     "rm_hall_4",                    { "get_caseelement_4_3" } }
  ,{ "vid_hall_4_superdevice",                  "rm_hall_4",                    { "use_caseelement_4_1", "use_caseelement_4_2", "use_caseelement_4_3" } } 
  ,{ "get_brokenapparatus_4",                   "rm_hall_4",                    { "vid_hall_4_superdevice" } }
  ,{ "get_chisel_4",                            "rm_hall_4",                    { "vid_hall_4_superdevice" } }
  ,{ "get_screwdriver_4",                       "rm_hall_4",                    { "vid_hall_4_superdevice" } }
  ,{ "use_screwdriver_4_1",                     "rm_hall_4",                    { "get_screwdriver_4" } }
  ,{ "get_batteries_4",                         "rm_hall_4",                    { "use_screwdriver_4_1" } }
  ,{ "clk_apparatus_4_1",        }
  ,{ "use_batteries_4",          }
  ,{ "clk_apparatus_4_2",        }
  ,{ "get_apparatus_4",          }
  ,{ "use_apparatus_4_1",                       "rm_hall_4",                    { "get_apparatus_4" } }
  ,{ "win_apparatusroom_4_1",                   "rm_hall_4",                    { "use_apparatus_4_1" } } 
  
  ,{ "opn_behindstage",                         "rm_behindstage",               { "win_apparatusroom_4_1" } } 
  ,{ "get_collect_morph_item_4_2" }
  ,{ "get_collect_item_4_1" }
  ,{ "vid_behindstage_door",                    "rm_behindstage",               { "opn_behindstage" } } 
  ,{ "get_bucket_4",                            "rm_behindstage",               { "vid_behindstage_door" } }
  ,{ "get_glue_4",                              "rm_behindstage",               { "vid_behindstage_door" } }
  ,{ "get_cofferelement_4_1",                   "rm_behindstage",               { "vid_behindstage_door" } }
  ,{ "get_cofferelement_4_2",                   "rm_behindstage",               { "vid_behindstage_door" } }
  ,{ "use_glue_4",              }
  ,{ "clk_micholder",              }
  ,{ "use_bucket_4",            }
  ,{ "get_holderwithbucket"     }
  ,{ "use_holderwithbucket",                    "rm_hall_4",                    { "get_holderwithbucket" } }
  ,{ "use_elf_4_1",                             "rm_hall_4",                    { "use_holderwithbucket" } }
  ,{ "get_cup",                                 "rm_hall_4",                    { "use_elf_4_1" } }
  ,{ "use_cofferelement_4_1",                   "rm_hall_4",                    { "get_cofferelement_4_1" } }
  ,{ "use_cofferelement_4_2",                   "rm_hall_4",                    { "get_cofferelement_4_2" } }
  ,{ "win_trunk_4",                             "rm_hall_4",                    { "use_cofferelement_4_1", "use_cofferelement_4_2" } }
  ,{ "get_ax_4",                                "rm_hall_4",                    { "win_trunk_4" } }
  ,{ "get_anglegrinder",                        "rm_hall_4",                    { "win_trunk_4" } }
  ,{ "use_ax_4",                                "rm_behindstage",               { "get_ax_4" } }
  
  ,{ "opn_smallroom_4",                         "rm_smallroom_4",               { "use_ax_4" } } 
  ,{ "get_collect_morph_item_4_3" }
  ,{ "get_plank_4_1",                           "rm_smallroom_4",               { "opn_smallroom_4" } }
  ,{ "use_elf_4_2",                             "rm_smallroom_4",               { "opn_smallroom_4" } }
  ,{ "get_handkerchief",                        "rm_smallroom_4",               { "use_elf_4_2" } }
  ,{ "get_doorelement_4_1",                     "rm_smallroom_4",               { "opn_smallroom_4" } }
  ,{ "use_handkerchief",                        "rm_smallroom_4",               { "get_handkerchief" } }
  ,{ "get_shard",                               "rm_smallroom_4",               { "use_handkerchief" } }
  ,{ "use_shard",                               "rm_behindstage",               { "get_shard" } }

  ,{ "opn_pharmacy",                            "rm_behindstage",               { "use_shard" } }
  ,{ "win_pharmacy",                            "rm_behindstage",               { "use_shard" } }
  ,{ "use_sedative",           }
  ,{ "use_thermos_4",          }
  ,{ "clk_thermos_4",          }
  ,{ "get_sedativecup",        }
  ,{ "use_sedativecup",                         "rm_hall_4",                    { "get_sedativecup" } }
  ,{ "dlg_hall_4_workman",                      "rm_hall_4",                    { "use_sedativecup" } } 
  ,{ "use_corridorkey_4",                       "rm_behindstage",               { "dlg_hall_4_workman" } } 
  ,{ "clk_corridorkey",                         "rm_behindstage",               { "use_corridorkey_4" } } 

  ,{ "opn_corridor_4",                          "rm_corridor_4",                { "clk_corridorkey" } }
  ,{ "get_collect_morph_item_4_4" }
  ,{ "vid_corridor_4_running",                  "rm_corridor_4",                { "opn_corridor_4" } }  
  ,{ "get_hammer_4",                            "rm_corridor_4",                { "vid_corridor_4_running" } }
  ,{ "get_amuletelement_4_2",                   "rm_corridor_4",                { "vid_corridor_4_running" } }
  ,{ "get_brokenboxamulet_4",                   "rm_corridor_4",                { "vid_corridor_4_running" } }
  ,{ "use_elf_4_3",                             "rm_corridor_4",                { "vid_corridor_4_running" } }
  ,{ "get_hexagon_4",                           "rm_corridor_4",                { "use_elf_4_3" } }
  ,{ "use_hexagon_4",                           "rm_hall_4",                    { "get_hexagon_4" } }
  ,{ "get_diode_4_2",                           "rm_hall_4",                    { "use_hexagon_4" } }
  ,{ "use_chisel_4",                            "rm_smallroom_4",               { "get_chisel_4" } }
  ,{ "use_hammer_4_1",                          "rm_smallroom_4",               { "get_hammer_4" } }
  ,{ "get_amuletelement_4_3",                   "rm_smallroom_4",               { "use_hammer_4_1" } }
  ,{ "use_amuletelement_4_1",   }
  ,{ "use_amuletelement_4_2",   }
  ,{ "use_amuletelement_4_3",   }
  ,{ "get_boxamulet_4",         }
  ,{ "use_boxamulet_4",                         "rm_behindstage",               { "get_boxamulet_4" } }
  ,{ "get_hairpin_4",                           "rm_behindstage",               { "use_boxamulet_4" } }
  ,{ "use_hairpin_4",                           "rm_smallroom_4",               { "get_hairpin_4" } }
  ,{ "get_radio",                               "rm_smallroom_4",               { "use_hairpin_4" } }
  ,{ "get_tongs_4",                             "rm_smallroom_4",               { "use_hairpin_4" } }
  ,{ "use_screwdriver_4_2",     }
  ,{ "get_diode_4_3",           }
  ,{ "use_diode_4_1",                           "rm_corridor_4",                { "get_diode_4_1" } }
  ,{ "use_diode_4_2",                           "rm_corridor_4",                { "get_diode_4_2" } }
  ,{ "use_diode_4_3",                           "rm_corridor_4",                { "get_diode_4_3" } }
  ,{ "win_computerroom",                        "rm_corridor_4",                { "use_diode_4_1", "use_diode_4_2", "use_diode_4_3"  } }  
  ,{ "vid_corridor_4_message",                  "rm_corridor_4",                { "win_computerroom" } }  
  ,{ "get_keycard_4",                           "rm_corridor_4",                { "vid_corridor_4_message" } }  
  ,{ "use_tongs_4",                             "rm_corridor_4",                { "vid_corridor_4_message" } }  
  ,{ "get_solderingironemblem",                 "rm_corridor_4",                { "use_tongs_4" } }  
  ,{ "use_solderingironemblem",                 "rm_hall_4",                    { "get_solderingironemblem" } }  
  ,{ "get_solderingiron",                       "rm_hall_4",                    { "use_solderingironemblem" } }
  ,{ "clk_lounchroom_4_cover",                  "rm_corridor_4",                { "vid_corridor_4_running" } }
  ,{ "use_solderingiron",                       "rm_corridor_4",                { "clk_lounchroom_4_cover", "get_solderingiron" } }
  ,{ "use_keycard_4",                           "rm_corridor_4",                { "vid_corridor_4_message" } }
  ,{ "clk_handle_4",                            "rm_corridor_4",                { "use_keycard_4" } }
  ,{ "opn_lunchroom_4",                         "rm_lunchroom_4",               { "use_keycard_4" } } 
  ,{ "get_collect_morph_item_4_5" }
  ,{ "get_collect_item_4_2" }
  ,{ "use_apparatus_4_2",                       "rm_lunchroom_4",               { "opn_lunchroom_4" } } 
  ,{ "win_apparatusroom_4_2",                   "rm_lunchroom_4",               { "use_apparatus_4_2" } } 
  ,{ "dlg_lunchroom_4_leading",                 "rm_lunchroom_4",               { "win_apparatusroom_4_2" } } 
  ,{ "use_tweezers_4",                          "rm_behindstage",               { "dlg_lunchroom_4_leading" } } 
  ,{ "get_statuefragment_4",                    "rm_behindstage",               { "use_tweezers_4" } } 
  ,{ "use_statuefragment_4",                    "rm_smallroom_4",               { "get_statuefragment_4" } } 
  ,{ "get_threewaymirrortoken",                 "rm_smallroom_4",               { "use_statuefragment_4" } } 
  ,{ "use_threewaymirrortoken",                 "rm_smallroom_4",               { "get_threewaymirrortoken" } }
  ,{ "get_ring_4",                              "rm_smallroom_4",               { "use_threewaymirrortoken" } }
  ,{ "use_ring_4",                              "rm_behindstage",               { "get_ring_4" } } 
  ,{ "clk_floor_4_door",                        "rm_behindstage",               { "use_ring_4" } }
  ,{ "opn_warehouse",                           "rm_behindstage",               { "clk_floor_4_door" } }
  ,{ "win_warehouse",                           "rm_behindstage",               { "clk_floor_4_door" } }
  ,{ "win_valise",             }
  ,{ "get_acid",               }
  ,{ "use_acid",                                "rm_corridor_4",                { "get_acid" } }
  ,{ "opn_secondfloor",                         "rm_secondfloor",               { "use_acid" } }
  ,{ "get_collect_morph_item_4_6" }
  ,{ "vid_secondfloor_spirit",                  "rm_secondfloor",               { "opn_secondfloor" } } 
  ,{ "get_plank_4_2",                           "rm_secondfloor",               { "vid_secondfloor_spirit" } }
  ,{ "use_apparatus_4_3",                       "rm_secondfloor",               { "vid_secondfloor_spirit" } }
  ,{ "win_apparatusroom_4_3",                   "rm_secondfloor",               { "use_apparatus_4_3" } }

  ,{ "opn_balcony",                             "rm_balcony",                   { "win_apparatusroom_4_3" } }
  ,{ "get_collect_morph_item_4_7" }  
  ,{ "use_screwdriver_4_3",                     "rm_balcony",                   { "opn_balcony" } } 
  ,{ "get_secretsign",                          "rm_balcony",                   { "use_screwdriver_4_3" } } 
  ,{ "use_elf_4_4",                             "rm_balcony",                   { "opn_balcony" } } 
  ,{ "get_coin_4",                              "rm_balcony",                   { "use_elf_4_4" } } 
  ,{ "use_elf_4_5",                             "rm_balcony",                   { "opn_balcony" } }
  ,{ "use_plank_4_1",                           "rm_balcony",                   { "use_elf_4_5" } }
  ,{ "use_plank_4_2",                           "rm_balcony",                   { "use_elf_4_5" } }
  ,{ "opn_balconyroom",                         "rm_balcony",                   { "use_plank_4_1", "use_plank_4_2" } }
  ,{ "win_balconyroom",                         "rm_balcony",                   { "use_plank_4_1", "use_plank_4_2" } }
  ,{ "use_coin_4",            }
  ,{ "get_wrench_4",          }
  ,{ "use_wrench_4",                            "rm_corridor_4",                { "get_wrench_4" } }
  ,{ "get_tinsnips",                            "rm_corridor_4",                { "use_wrench_4" } }
  ,{ "get_knife_4",                             "rm_corridor_4",                { "use_wrench_4" } }
  ,{ "use_tinsnips",                            "rm_secondfloor",               { "get_tinsnips" } }
  ,{ "dlg_secondfloor_scientist",               "rm_secondfloor",               { "use_tinsnips" } }  
  ,{ "use_searcher_4_1",                        "rm_secondfloor",               { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_1",                       "rm_secondfloor",               { "use_searcher_4_1" } } 
  ,{ "use_searcher_4_2",                        "rm_corridor_4",                { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_2",                       "rm_corridor_4",                { "use_searcher_4_2" } }
  ,{ "use_searcher_4_3",                        "rm_lunchroom_4",               { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_3",                       "rm_lunchroom_4",               { "use_searcher_4_3" } } 
  ,{ "use_searcher_4_4",                        "rm_behindstage",               { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_4",                       "rm_behindstage",               { "use_searcher_4_4" } } 
  ,{ "use_searcher_4_5",                        "rm_smallroom_4",               { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_5",                       "rm_smallroom_4",               { "use_searcher_4_5" } } 
  ,{ "use_searcher_4_6",                        "rm_hall_4",                    { "dlg_secondfloor_scientist" } } 
  ,{ "get_ectoplasm_4_6",                       "rm_hall_4",                    { "use_searcher_4_6" } }
  ,{ "use_ectoplasm",                           "rm_secondfloor",               { "get_ectoplasm_4_1", "get_ectoplasm_4_2", "get_ectoplasm_4_3", "get_ectoplasm_4_4", "get_ectoplasm_4_5", "get_ectoplasm_4_6" } }
  ,{ "dlg_secondfloor_meeting",                 "rm_secondfloor",               { "use_ectoplasm" } }   
  ,{ "use_hammer_4_2",                          "rm_corridor_4",                { "get_hammer_4" } }
  ,{ "use_secretsign",                          "rm_corridor_4",                { "use_hammer_4_2", "get_secretsign" } }
  ,{ "get_potdetail",                           "rm_corridor_4",                { "use_secretsign" } }
  ,{ "use_potdetail",                           "rm_balcony",                   { "get_potdetail" } }
  ,{ "get_doorelement_4_3",                     "rm_balcony",                   { "use_potdetail" } }
  ,{ "use_knife_4",                             "rm_secondfloor",               { "get_knife_4" } }
  ,{ "get_patternelement",                      "rm_secondfloor",               { "use_knife_4" } }
  ,{ "use_patternelement",                      "rm_balcony",                   { "get_patternelement" } }
  ,{ "get_doorelement_4_4",                     "rm_balcony",                   { "use_patternelement" } }
  ,{ "use_doorelement_4_1",                     "rm_secondfloor",               { "get_doorelement_4_1" } }
  ,{ "use_doorelement_4_2",                     "rm_secondfloor",               { "get_doorelement_4_2" } }
  ,{ "use_doorelement_4_3",                     "rm_secondfloor",               { "get_doorelement_4_3" } }
  ,{ "use_doorelement_4_4",                     "rm_secondfloor",               { "get_doorelement_4_4" } }
  ,{ "win_door_4",                              "rm_secondfloor",               { "use_doorelement_4_3","use_doorelement_4_4" } }

  ,{ "opn_study",                               "rm_study",                     { "win_door_4" } } 
  ,{ "get_collect_morph_item_4_8" }  
  ,{ "get_collect_item_4_3" }
  ,{ "vid_study_keyhole",                       "rm_study",                     { "opn_study" } }   
  ,{ "get_anglegrinderdisk",                    "rm_study",                     { "opn_study" } }
  ,{ "get_book_4_1",                            "rm_study",                     { "opn_study" } }
  ,{ "get_lanternelement_4_1",                  "rm_study",                     { "opn_study" } }
  ,{ "get_lanternelement_4_2",                  "rm_study",                     { "opn_study" } }
  ,{ "use_anglegrinderdisk",      }
  ,{ "get_workanglegrinder",          }
  ,{ "use_workanglegrinder",                    "rm_secondfloor",               { "get_workanglegrinder" } }
  ,{ "opn_mockuproom",                          "rm_secondfloor",               { "use_workanglegrinder" } }
  ,{ "win_mockuproom",                          "rm_secondfloor",               { "use_workanglegrinder" } }
  ,{ "use_lanternelement_4_1",                  "rm_balcony",                   { "get_lanternelement_4_1" } }
  ,{ "use_lanternelement_4_2",                  "rm_balcony",                   { "get_lanternelement_4_2" } }
  ,{ "get_book_4_2",                            "rm_balcony",                   { "use_lanternelement_4_1", "use_lanternelement_4_2" } }
  ,{ "use_spinning",                            "rm_study",                     { "win_mockuproom" } }
  ,{ "get_boxhandle_4",                         "rm_study",                     { "use_spinning" } }
  ,{ "use_boxhandle_4",                         "rm_study",                     { "get_boxhandle_4" } }
  ,{ "clk_boxhandle_4",                         "rm_study",                     { "use_boxhandle_4" } }
  ,{ "get_book_4_3",                            "rm_study",                     { "clk_boxhandle_4" } }
  ,{ "use_book_4_1",                            "rm_study",                     { "get_book_4_1" } }
  ,{ "use_book_4_2",                            "rm_study",                     { "get_book_4_2" } }
  ,{ "use_book_4_3",                            "rm_study",                     { "get_book_4_3" } }
  ,{ "win_bookcase",                            "rm_study",                     { "use_book_4_1", "use_book_4_2", "use_book_4_3"} } 
  ,{ "get_reliefelement",                       "rm_study",                     { "win_bookcase" } }
  ,{ "use_reliefelement",                       "rm_balcony",                   { "get_reliefelement" } }
  ,{ "get_button_4",                            "rm_balcony",                   { "use_reliefelement" } }
  ,{ "use_button_4",                            "rm_study",                     { "get_button_4" } }
  ,{ "get_doorkey_4",                           "rm_study",                     { "use_button_4" } }
  ,{ "use_doorkey_4",                           "rm_study",                     { "get_doorkey_4" } }
  ,{ "clk_doorkey_4",                           "rm_study",                     { "use_doorkey_4" } }
  ,{ "opn_secondroom",                          "rm_secondroom",                { "clk_doorkey_4" } }
  ,{ "get_collect_morph_item_4_9" } 
  ,{ "use_enhancedapparatus",                   "rm_secondroom",                { "opn_secondroom" } }
  ,{ "vid_secondroom_attack",                   "rm_secondroom",                { "use_enhancedapparatus" } }
  ,{ "win_final",                             "rm_secondroom",                  { "vid_secondroom_attack" } }
  ,{ "vid_secondroom_autro",                    "rm_secondroom",                { "win_final" } }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits",
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;