-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()


  
  private.init_micholder();
  private.init_cup();
  private.init_radio();  
  private.init_valise(); 
  private.InitSearcher();
  private.init_anglegrinder(); 
  private.init_brokenboxamulet_4();
  private.init_toolbox();
  private.init_brokenapparatus_4();
  
  public.deploy_inventory = {
  { "micholder",      { "use_glue_4", "use_bucket_4" }, { "get_holderwithbucket" }  },
  { "cup",      { "use_sedative", "use_thermos_4", "clk_thermos_4" }, { "get_sedativecup" }  },
  { "radio",      { "use_screwdriver_4_2" }, { "get_diode_4_3" }  },
  { "valise",      { "win_valise" }, { "get_acid" }  },
  { "anglegrinder",      { "use_anglegrinderdisk" }, { "get_workanglegrinder" }  },
  { "brokenboxamulet_4",      { "use_amuletelement_4_1", "use_amuletelement_4_2", "use_amuletelement_4_3" }, { "get_boxamulet_4" }  },
  { "toolbox",      { "use_coin_4" }, { "get_wrench_4" }  },
  { "brokenapparatus_4",      { "clk_apparatus_4_1", "use_batteries_4", "clk_apparatus_4_2"}, { "get_apparatus_4" }  },

  };
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level3_inv_deploy" }, "level3_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
function private.ShowBbt( use_name )
  
  if use_name == "amuletelement" then
   
    common_impl.ShowBbt( "bbt_brokenboxamulet_4_use_amuletelement_1", 1 );
    --common_impl.ShowBbt( 'bbt_brokenboxamulet_4_use_amuletelement_2', 1 );
      
  end;
  
end;
--*********************************************************************************************************************
-- function *** micholder *** () end;
--*********************************************************************************************************************
  function private.init_micholder()
    
    ObjSet( "obj_micholder_clk_micholder", { event_mdown = function() public.clk_micholder() end } );
    ObjSet( "spr_deploy_holderwithbucket", { event_mdown = function() public.get_holderwithbucket() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_glue_4" ] = {
        type = "use",
        inv_obj = "inv_glue_4",
        use_place = "obj_micholder_use_glue_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_micholder",
        zz_gate = "inv_micholder"
    };
    function use_glue_4_inv ()

      interface.InventoryItemRemove( "inv_glue_4" );
      
    end;
    function use_glue_4_beg ()

      ObjDelete( "obj_micholder_use_glue_4" );

    end;
    function use_glue_4_end ()
      
      ObjSet( "obj_micholder_clk_micholder", { input = true });
      --ObjDelete( "amn_deploy_micholder_use_glue" );
      --ObjSet( "spr_deploy_holderwithbucket", { alp = 1 } );
      ObjSet( "amn_deploy_micholder_use_glue", { frame = 256 } );
      
      ObjSet( "inv_micholder", { res = "assets/levels/levelext/inv_deploy/inv_micholder/inv/inv_microphoner2" });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_glue_4", use_glue_4_beg, "inv_micholder" );
    cmn.AddSubscriber( "use_glue_4", use_glue_4_inv );
    cmn.AddSubscriber( "use_glue_4", use_glue_4_end );
    cmn.AddSubscriber( "use_glue_4", use_glue_4_end, "inv_micholder" );
    cmn.AddSubscriber( "use_glue_4_inv", use_glue_4_inv );
    cmn.AddSubscriber( "use_glue_4_beg", use_glue_4_beg, "inv_micholder" );
    cmn.AddSubscriber( "use_glue_4_end", use_glue_4_end, "inv_micholder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_bucket_4" ] = {
        type = "use",
        inv_obj = "inv_bucket_4",
        use_place = "obj_micholder_use_bucket_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_micholder",
        zz_gate = "inv_micholder"
    };
    function use_bucket_4_inv ()

      interface.InventoryItemRemove( "inv_bucket_4" ); 
      
    end;
    function use_bucket_4_beg ()

      ObjDelete( "obj_micholder_use_bucket_4" );

    end;
    function use_bucket_4_end ()

      ObjSet("spr_micholder_plus_light", { alp = 1 });
      ObjSet( "spr_deploy_micholder_bucket", { alp = 1 });
      ObjSet( "spr_deploy_holderwithbucket", { input = true });
      ObjSet( "spr_deploy_holderwithbucket", { active = true });
      
      ObjSet( "spr_micholder_bucket", { alp = 1 });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bucket_4", use_bucket_4_beg, "inv_micholder" );
    cmn.AddSubscriber( "use_bucket_4", use_bucket_4_inv );
    cmn.AddSubscriber( "use_bucket_4", use_bucket_4_end );
    cmn.AddSubscriber( "use_bucket_4", use_bucket_4_end, "inv_micholder" );
    cmn.AddSubscriber( "use_bucket_4_inv", use_bucket_4_inv );
    cmn.AddSubscriber( "use_bucket_4_beg", use_bucket_4_beg, "inv_micholder" );
    cmn.AddSubscriber( "use_bucket_4_end", use_bucket_4_end, "inv_micholder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_holderwithbucket" ] = {
      type = "get",
      get_obj = "spr_deploy_holderwithbucket",
      room = "int_deploy_inv",
      zz = "deploy_inv_micholder",
      zz_gate = "inv_micholder"
    };
    function get_holderwithbucket_inv ()

      interface.InventoryItemRemove( "inv_micholder" );
      --interface.InventoryItemAdd( "inv_holderwithbucket", "obj_deploy_holderwithbucket" );
      interface.InventoryItemAdd( "inv_holderwithbucket", "obj_deploy_micholder" );
      

    end;
    function get_holderwithbucket_deploy ()

      ObjDelete( "gfx_deploy_holderwithbucket" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_holderwithbucket", get_holderwithbucket_inv );
    cmn.AddSubscriber( "get_holderwithbucket", get_holderwithbucket_deploy, "inv_micholder" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_micholder" ] = {
      type = "click",
      use_place = "spr_deploy_micholder_part",
      room = "int_deploy_inv",
      zz = "deploy_inv_micholder",
      zz_gate = "inv_micholder"
    };
    function clk_micholder ()
      
      if( cmn.IsEventDone("get_bucket_4") and not cmn.IsEventDone("use_bucket_4") )then
        ObjSet("spr_micholder_plus_light", { alp = 1 });
      else
        ObjSet("spr_micholder_plus_light", { alp = 0 });
      end;
      ObjSet( "obj_micholder_use_bucket_4", {input = true } );
      ObjSet( "spr_deploy_micholder_over", {alp = 1} );
      ObjSet( "spr_deploy_micholder_part", { pos_x = -267, pos_y = -68 } );
      ObjDelete( "obj_micholder_clk_micholder" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_micholder", clk_micholder, "inv_micholder" );
    -------------------------------------------------------------------------------------------
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_glue_4()

    local item = "inv_glue_4";
    if private.ObjIntersectCheck( item, "obj_micholder_use_glue_4", "deploy_inv_micholder" ) then

      cmn.CallEventHandler( "use_glue_4_beg", "inv_micholder" );
      cmn.CallEventHandler( "use_glue_4_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1034"); common_impl.Lock( false );

        cmn.SetEventDone( "use_glue_4" );
        cmn.CallEventHandler( "use_glue_4_end", "inv_micholder" );
    
      end;

       DbgTrace("common_impl.Lock( 1035"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_micholder_use_glue", 0, "", 0 );
      
      AnimPlay( "amn_deploy_micholder_use_glue", "DoAnim", func_after );


      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_bucket_4()

    local item = "inv_bucket_4";
    if private.ObjIntersectCheck( item, "obj_micholder_use_bucket_4", "deploy_inv_micholder" ) and cmn.IsEventDone("use_glue_4") then

      cmn.CallEventHandler( "use_bucket_4_beg", "inv_micholder" );
      cmn.CallEventHandler( "use_bucket_4_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1036"); common_impl.Lock( false );

        cmn.SetEventDone( "use_bucket_4" );
        cmn.CallEventHandler( "use_bucket_4_end", "inv_micholder" );
    
      end;

       DbgTrace("common_impl.Lock( 1037"); common_impl.Lock( true ); 
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_micholder_use_bucket", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_micholder_bucket", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );  

      return true;

    end;

  end;
  ----------------------------------------------------------------------------
  function public.clk_micholder()
    
    local func_after = function ()
      
       DbgTrace("common_impl.Lock( 1038"); common_impl.Lock( false );
      cmn.SetEventDone( "clk_micholder" );
      cmn.CallEventHandler( "clk_micholder", "inv_micholder" );
      
    end;
    
     DbgTrace("common_impl.Lock( 1039"); common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_micholder_touch_glue", 0, "", 0 );

    ObjAnimate( "spr_deploy_micholder_part", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, -314, -157,
      1.0, 0, -267, -68
    } );  
 
    
  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_holderwithbucket()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_holderwithbucket" );
    cmn.CallEventHandler( "get_holderwithbucket", "inv_micholder" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** cup *** () end;
--*********************************************************************************************************************
  function private.init_cup()

    ObjSet( "spr_deploy_sedativecup", { event_mdown = function() public.get_sedativecup() end } );
    ObjSet( "obj_cup_clk_thermos_4", { event_mdown = function() private.clk_thermos_4() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_sedative" ] = {
        type = "use",
        inv_obj = "inv_sedative",
        use_place = "obj_cup_use_sedative",
        room = "int_deploy_inv",
        zz = "deploy_inv_cup",
        zz_gate = "inv_cup"
    };
    function use_sedative_inv ()

      interface.InventoryItemRemove( "inv_sedative" );
      
    end;
    function use_sedative_beg ()

      ObjDelete( "obj_cup_use_sedative" );

    end;
    function use_sedative_end ()
      
      if( cmn.IsEventDone("use_thermos_4") and not cmn.IsEventDone("use_thermos_4") )then
        ObjSet("spr_cup_plus_light", { alp = 1 });
      else
        ObjSet("spr_cup_plus_light", { alp = 0 });
      end;
      ObjSet("obj_cup_use_thermos_4", { input = true });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_sedative", use_sedative_beg, "inv_cup" );
    cmn.AddSubscriber( "use_sedative", use_sedative_inv );
    cmn.AddSubscriber( "use_sedative", use_sedative_end );
    cmn.AddSubscriber( "use_sedative", use_sedative_end, "inv_cup" );
    cmn.AddSubscriber( "use_sedative_inv", use_sedative_inv );
    cmn.AddSubscriber( "use_sedative_beg", use_sedative_beg, "inv_cup" );
    cmn.AddSubscriber( "use_sedative_end", use_sedative_end, "inv_cup" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_thermos_4" ] = {
        type = "use",
        inv_obj = "inv_thermos_4",
        use_place = "obj_cup_use_thermos_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_cup",
        zz_gate = "inv_cup"
    };
    function use_thermos_4_inv ()

      interface.InventoryItemRemove( "inv_thermos_4" ); 
      
    end;
    function use_thermos_4_beg ()

      ObjDelete( "obj_cup_use_thermos_4" );

    end;
    function use_thermos_4_end ()

      ObjSet("spr_cup_plus_light", { alp = 1 });
      ObjSet("obj_cup_clk_thermos_4", { input = true });
      ObjSet("anm_deploy_cup_water", { alp = 1 });
      ObjDelete( "anm_deploy_cup_medicine" );
      
      ObjSet("inv_cup", { res = "assets/levels/levelext/inv_deploy/inv_cup/inv/inv_thermos2" });
            
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_thermos_4", use_thermos_4_beg, "inv_cup" );
    cmn.AddSubscriber( "use_thermos_4", use_thermos_4_inv );
    cmn.AddSubscriber( "use_thermos_4", use_thermos_4_end );
    cmn.AddSubscriber( "use_thermos_4", use_thermos_4_end, "inv_cup" );
    cmn.AddSubscriber( "use_thermos_4_inv", use_thermos_4_inv );
    cmn.AddSubscriber( "use_thermos_4_beg", use_thermos_4_beg, "inv_cup" );
    cmn.AddSubscriber( "use_thermos_4_end", use_thermos_4_end, "inv_cup" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_thermos_4" ] = {
        type = "click",
        use_place = "obj_cup_clk_thermos_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_cup",
        zz_gate = "inv_cup"
    };
    function clk_thermos_4_beg ()

      ObjDelete( "obj_cup_clk_thermos_4" );

    end;
    function clk_thermos_4_end ()
      
      ObjDelete( "spr_deploy_cup_thermos_cover" );
      ObjDelete( "anm_deploy_cup_water" );     
      ObjSet( "spr_cup_plus_light", { alp = 1 });
      ObjSet( "obj_deploy_cup_sedative", { alp = 1 });
      ObjSet( "spr_deploy_sedativecup", { input = true });
      ObjSet( "gfx_deploy_sedativecup", { active = true });
      ObjSet( "spr_deploy_cup_sedative_water_1", { alp = 1 });
      
      ObjSet("inv_cup", { res = "assets/levels/levelext/inv_deploy/inv_cup/inv/inv_water_1" });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_thermos_4", clk_thermos_4_beg, "inv_cup" );
    cmn.AddSubscriber( "clk_thermos_4", clk_thermos_4_end );
    cmn.AddSubscriber( "clk_thermos_4", clk_thermos_4_end, "inv_cup" );
    cmn.AddSubscriber( "clk_thermos_4_beg", clk_thermos_4_beg, "inv_cup" );
    cmn.AddSubscriber( "clk_thermos_4_end", clk_thermos_4_end, "inv_cup" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_sedativecup" ] = {
      type = "get",
      get_obj = "spr_deploy_sedativecup",
      room = "int_deploy_inv",
      zz = "deploy_inv_cup",
      zz_gate = "inv_cup"
    };
    function get_sedativecup_inv ()

      interface.InventoryItemRemove( "inv_cup" );
      interface.InventoryItemAdd( "inv_sedativecup", "spr_deploy_sedativecup" );

    end;
    function get_sedativecup_deploy ()

      ObjDelete( "gfx_deploy_sedativecup" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_sedativecup", get_sedativecup_inv );
    cmn.AddSubscriber( "get_sedativecup", get_sedativecup_deploy, "inv_cup" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_sedative()

    local item = "inv_sedative";
    if private.ObjIntersectCheck( item, "obj_cup_use_sedative", "deploy_inv_cup" ) then

      cmn.CallEventHandler( "use_sedative_beg", "inv_cup" );
      cmn.CallEventHandler( "use_sedative_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1040"); common_impl.Lock( false );

        cmn.SetEventDone( "use_sedative" );
        cmn.CallEventHandler( "use_sedative_end", "inv_cup" );
    
      end;

       DbgTrace("common_impl.Lock( 1041"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_cup_use_sedative", 0, "", 0 );
      
      AnimPlay( "anm_deploy_cup_medicine", "DoAnim", func_after );

      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_thermos_4()

    local item = "inv_thermos_4";
    if private.ObjIntersectCheck( item, "obj_cup_use_thermos_4", "deploy_inv_cup" ) and cmn.IsEventDone("use_sedative") then

      cmn.CallEventHandler( "use_thermos_4_beg", "inv_cup" );
      cmn.CallEventHandler( "use_thermos_4_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1042"); common_impl.Lock( false );

        cmn.SetEventDone( "use_thermos_4" );
        cmn.CallEventHandler( "use_thermos_4_end", "inv_cup" );
    
      end;

       DbgTrace("common_impl.Lock( 1043"); common_impl.Lock( true );   
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_cup_use_thermos", 0, "", 0 );
      
      ObjAnimate( "anm_deploy_cup_medicine", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

      ObjAnimate( "anm_deploy_cup_water", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function private.clk_thermos_4()

    cmn.CallEventHandler( "clk_thermos_4_beg", "inv_cup" );

    local func_after = function ()
    
      local func_end = function ()
      
         DbgTrace("common_impl.Lock( 1044"); common_impl.Lock( false );

        cmn.SetEventDone( "clk_thermos_4" );
        cmn.CallEventHandler( "clk_thermos_4_end", "inv_cup" );
        
      end;
      
      AnimPlay( "anm_deploy_cup_water", "DoAnim", func_end );
    
    end;

     DbgTrace("common_impl.Lock( 1045"); common_impl.Lock( true );   
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_cup_touch_thermos", 0, "", 0 );
    ObjAnimate( "spr_deploy_cup_thermos_cover", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    
  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_sedativecup()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_sedativecup" );
    cmn.CallEventHandler( "get_sedativecup", "inv_cup" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** radio *** () end;
--*********************************************************************************************************************
  function private.init_radio()

    ObjSet( "spr_deploy_diode_4_3", { event_mdown = function() public.get_diode_4_3() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_screwdriver_4_2" ] = {
        type = "use",
        inv_obj = "inv_screwdriver_4",
        use_place = "obj_radio_use_screwdriver_4_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_radio",
        zz_gate = "inv_radio"
    };
    function use_screwdriver_4_2_inv ()
      
    end;
    function use_screwdriver_4_2_beg ()

      ObjDelete( "obj_radio_use_screwdriver_4_2" );

    end;
    function use_screwdriver_4_2_end ()

      ObjDelete( "spr_deploy_radio_cover" );
      ObjSet("spr_radio_plus_light", { alp = 1 });
      ObjSet( "spr_deploy_radio_retro", { input = true });
      ObjSet( "spr_deploy_diode_4_3", { input = true });
      ObjSet( "spr_radio_plus_light", { active = true });  
     
      ObjDelete( "spr_radio_cover" ); 
      ObjDelete( "vid_deploy_radio_use_screwdriver");
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_screwdriver_4_2", use_screwdriver_4_2_beg, "inv_radio" );
    cmn.AddSubscriber( "use_screwdriver_4_2", use_screwdriver_4_2_inv );
    cmn.AddSubscriber( "use_screwdriver_4_2", use_screwdriver_4_2_end );
    cmn.AddSubscriber( "use_screwdriver_4_2", use_screwdriver_4_2_end, "inv_radio" );
    cmn.AddSubscriber( "use_screwdriver_4_2_inv", use_screwdriver_4_2_inv );
    cmn.AddSubscriber( "use_screwdriver_4_2_beg", use_screwdriver_4_2_beg, "inv_radio" );
    cmn.AddSubscriber( "use_screwdriver_4_2_end", use_screwdriver_4_2_end, "inv_radio" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_diode_4_3" ] = {
      type = "get",
      get_obj = "spr_deploy_diode_4_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_radio",
      zz_gate = "inv_radio"
    };
    function get_diode_4_3_inv ()

      interface.InventoryItemRemove( "inv_radio" );
      interface.InventoryItemAdd( "inv_diode_4_3", "spr_deploy_diode_4_3" );

    end;
    function get_diode_4_3_deploy ()

      ObjDelete( "gfx_deploy_diode_4_3" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_diode_4_3", get_diode_4_3_inv );
    cmn.AddSubscriber( "get_diode_4_3", get_diode_4_3_deploy, "inv_radio" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_screwdriver_4_2()

    local item = "inv_screwdriver_4";
    if private.ObjIntersectCheck( item, "obj_radio_use_screwdriver_4_2", "deploy_inv_radio" ) then

      interface.InventoryItemRemove( "inv_screwdriver_4" );
      cmn.CallEventHandler( "use_screwdriver_4_2_beg", "inv_radio" );
      cmn.CallEventHandler( "use_screwdriver_4_2_inv" );

      local func_after = function ()
        
        ObjSet( "spr_deploy_radio_screw", {alp=1} );
        interface.InventoryItemAdd( "inv_screwdriver_4", "spr_deploy_radio_screw" );
        local func_end = function ()
        
           DbgTrace("common_impl.Lock( 1046"); common_impl.Lock( false );

          cmn.SetEventDone( "use_screwdriver_4_2" );
          cmn.CallEventHandler( "use_screwdriver_4_2_end", "inv_radio" );
          
        end;
        
        ObjAnimate( "spr_deploy_radio_cover", "pos_xy", 0, 0, func_end,
        { 
          0.0, 0, -29, 18,
          0.6, 0, 216, 544,
        } );
        
      end;

       DbgTrace("common_impl.Lock( 1047"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_radio_use_screwdriver", 0, "", 0 );
      
      VidPlay( "vid_deploy_radio_use_screwdriver", func_after)

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_diode_4_3()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_diode_4_3" );
    cmn.CallEventHandler( "get_diode_4_3", "inv_radio" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** valise *** () end;
--*********************************************************************************************************************
  function private.init_valise()

    private.numbers = { 1, 5, 9, 11, 13, 18, 20 };
    
    ObjSet( "spr_deploy_valise_acid_1", { event_mdown = function() public.get_acid() end } );
    ObjSet( "inv_valise", { event_mdown = function() private.show_valise() end });
    
    for i = 1, 7  do
      ObjSet( "spr_deploy_valise_part_"..i, { event_mdown = function() levelext_inv.clk_valise_part( i ) end,  event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end });     
    end;
    
    common_impl.hint[ "win_valise" ] = {
        type = "win",
        use_place = "spr_deploy_valise",
        room = "int_deploy_inv",
        zz = "deploy_inv_valise",
        zz_gate = "inv_valise"
    };
    
    local win_valise = function ()  

        if cmn.IsEventDone( "win_valise" ) then
          
          local win_val = { 2, 5, 7, 12, 14, 17, 19 };
          
          for i = 1, 7 do
            ObjSet( "spr_deploy_valise_part_"..i, { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..win_val[i] } );
          end;
          
          ObjSet( "obj_deploy_valise_bag_open", { input = true, alp = 1 });
          ObjSet( "spr_deploy_valise_bag_cryptogram", { input = false });
          
          ObjSet( "inv_valise", { res = "assets/levels/levelext/inv_deploy/inv_valise/inv/inv_bag2" });
          
        else 
          
          for i = 1, 7 do

            private.numbers[i] = ng_global.progress["ext"]["win_valise"].numbers[i];

            ObjSet( "spr_deploy_valise_part_"..i, { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..ng_global.progress["ext"]["win_valise"].numbers[i] } );

            if ng_global.progress["ext"]["win_valise"].numbers[i] == 1 or ng_global.progress["ext"]["win_valise"].numbers[i] == 4
              or ng_global.progress["ext"]["win_valise"].numbers[i] == 7 or ng_global.progress["ext"]["win_valise"].numbers[i] == 10  
              or ng_global.progress["ext"]["win_valise"].numbers[i] == 13 or ng_global.progress["ext"]["win_valise"].numbers[i] == 16
              or ng_global.progress["ext"]["win_valise"].numbers[i] == 19 then

              ObjSet( "spr_deploy_valise_part_"..i.."_up", { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..( ng_global.progress["ext"]["win_valise"].numbers[i] + 3 ) } );

            else

              ObjSet( "spr_deploy_valise_part_"..i.."_up", { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..( ng_global.progress["ext"]["win_valise"].numbers[i] - 1 ) } );

            end;

          end;

        end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "win_valise", win_valise, "inv_valise" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_acid" ] = {
      type = "get",
      get_obj = "spr_deploy_valise_acid",
      room = "int_deploy_inv",
      zz = "deploy_inv_valise",
      zz_gate = "inv_valise"
    };
    function get_acid_inv ()

      interface.InventoryItemRemove( "inv_valise" );
      interface.InventoryItemAdd( "inv_acid", "spr_deploy_valise_acid" );

    end;
    function get_acid_deploy ()

      ObjDelete( "gfx_deploy_valise_acid" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_acid", get_acid_inv );
    cmn.AddSubscriber( "get_acid", get_acid_deploy, "inv_valise" );
    -------------------------------------------------------------------------------------------
    
  end;
  --------------------------------------------------------------------------------------------
  function private.show_valise()

    if ( not cmn.IsEventStart( "win_valise" ) ) then
      
      ng_global.progress["ext"]["win_valise"].numbers = {};
      for i = 1, 7 do
        ng_global.progress["ext"]["win_valise"].numbers[i] = private.numbers[i];
      end;
      
    end;
    
    if ( not cmn.IsEventDone( "win_valise" ) ) then
      
      cmn.MiniGameShow( 'valise' );
      common_impl.PassingMgStart( 'valise' );
      
    end;
    
    common_impl.ShowDeployInv('inv_valise');

  end;
  ----------------------------------------------------------------------------------------------
  function public.clk_valise_part( number )

    local clk_valise_part_end = function ()

      if private.numbers[number] ~= 1 and private.numbers[number] ~= 4 and private.numbers[number] ~= 7 and private.numbers[number] ~= 10
        and private.numbers[number] ~= 13 and private.numbers[number] ~= 16 and private.numbers[number] ~= 19 then
        
          ObjSet( "spr_deploy_valise_part_"..number.."_up", { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..( private.numbers[number] - 1 ) } );
               
      else  

          ObjSet( "spr_deploy_valise_part_"..number.."_up", { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..( private.numbers[number] + 2 ) } );

      end;

      public.check_win_valise();

    end;

    local func_after = function ()

        DbgTrace("common_impl.Lock( 1048"); common_impl.Lock(false);
      
       if private.numbers[number] ~= 1 and private.numbers[number] ~= 4 and private.numbers[number] ~= 7 and private.numbers[number] ~= 10
        and private.numbers[number] ~= 13 and private.numbers[number] ~= 16 and private.numbers[number] ~= 19 then
      
         private.numbers[number] = private.numbers[number] - 1;
             
       else  

         private.numbers[number] = private.numbers[number] + 2;

       end;

       ObjSet( "spr_deploy_valise_part_"..number, { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..private.numbers[number], pos_y = 0 } );
      
       for i = 1, 7 do

        ng_global.progress["ext"]["win_valise"].numbers[i] = private.numbers[i];

       end;

       clk_valise_part_end();
                 
    end;
   
     DbgTrace("common_impl.Lock( 1049"); common_impl.Lock(true);

    local coord_y = ObjGet( "spr_deploy_valise_part_"..number ).pos_y;
      
     ObjAnimate( "spr_deploy_valise_part_"..number, "pos_y", 0, 0, func_after, 
    { 
      0.0, 0, coord_y, 
      0.5, 0, ( coord_y + 47 )
    } );

    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_valice_touch_sign", 0, "", 0 );

  end;
  --------------------------------------------------------------------------------------------
  function public.check_win_valise()
    
    private.win_valise = { 2, 5, 7, 12, 14, 17, 19 };

    local win_count = 0;

    for i = 1, 7 do

      if ng_global.progress["ext"]["win_valise"].numbers[i] == private.win_valise[i] then

        win_count = win_count + 1;

      end;

    end;

    if win_count == 7 then

      public.anim_win_valise();

    end;

  end;
  --------------------------------------------------------------------------------------------
  function public.anim_win_valise()
    
    local func_after = function()

      DbgTrace("common_impl.Lock( 1050"); common_impl.Lock(false);
     common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
     cmn.MiniGameHide( "valise" );
     common_impl.PassingMgWin( "valise" );
     cmn.SetEventDone( "win_valise" );
     cmn.CallEventHandler( "win_valise", "inv_valise" );

    end;

     DbgTrace("common_impl.Lock( 1051"); common_impl.Lock(true);

    ObjAnimate( "obj_deploy_valise_bag_open", "alp", 0, 0,func_after, 
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_valice_win", 0, "", 0 );

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_acid()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    ObjSet("spr_deploy_valise_acid_1", { alp = 0 });
    ObjSet("spr_deploy_valise_acid", { alp = 1 });
    cmn.SetEventDone( "get_acid" );
    cmn.CallEventHandler( "get_acid", "inv_valise" );
    common_impl.HideDeployInv();

  end;
  --******************************************************************************************************
  function public.Skip( event )

    if ( event == "win_valise" ) then
      public.anim_win_valise();
    end;

  end;
  --******************************************************************************************************
  function public.Reset( event )

    if ( event == "win_valise" ) then
      
      private.numbers = { 1, 5, 9, 11, 13, 18, 20 };
      local numbers_up = { 3, 4, 8, 10, 15, 17, 19 };    
      for i = 1, 7 do

        ObjSet( "spr_deploy_valise_part_"..i, { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..private.numbers[i], pos_y = 0 } );
        ObjSet( "spr_deploy_valise_part_"..i.."_up", { res = "assets/levels/levelext/inv_deploy/inv_valise/layers/symbol_"..numbers_up[i] } );
        ng_global.progress[ "ext" ][ "win_valise" ].numbers[ i ] = private.numbers[ i ];

      end;

    end;
    

  end;
--*********************************************************************************************************************
-- function *** anglegrinder *** () end;
--*********************************************************************************************************************
  function private.init_anglegrinder()

    ObjSet( "spr_deploy_workanglegrinder", { event_mdown = function() public.get_workanglegrinder() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_anglegrinderdisk" ] = {
        type = "use",
        inv_obj = "inv_anglegrinderdisk",
        use_place = "obj_anglegrinder_use_anglegrinderdisk",
        room = "int_deploy_inv",
        zz = "deploy_inv_anglegrinder",
        zz_gate = "inv_anglegrinder"
    };
    function use_anglegrinderdisk_inv ()
      
      interface.InventoryItemRemove( "inv_anglegrinderdisk" );
      
    end;
    function use_anglegrinderdisk_beg ()

      ObjDelete( "obj_anglegrinder_use_anglegrinderdisk" );

    end;
    function use_anglegrinderdisk_end ()
      
      ObjSet( "spr_deploy_anglegrinder_disk", { alp = 1 });
      ObjSet( "spr_deploy_anglegrinder_shadow", { alp = 1 });
      ObjSet( "spr_anglegrinder_plus_light", { alp = 1 });
      ObjSet( "spr_deploy_workanglegrinder", { input = true });
      ObjSet( "gfx_deploy_workanglegrinder", { active = true });   
      
      ObjSet( "inv_anglegrinder", { res = "assets/levels/levelext/inv_deploy/inv_anglegrinder/inv/inv_foot_grinder2" });
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_anglegrinderdisk", use_anglegrinderdisk_beg, "inv_anglegrinder" );
    cmn.AddSubscriber( "use_anglegrinderdisk", use_anglegrinderdisk_inv );
    cmn.AddSubscriber( "use_anglegrinderdisk", use_anglegrinderdisk_end );
    cmn.AddSubscriber( "use_anglegrinderdisk", use_anglegrinderdisk_end, "inv_anglegrinder" );
    cmn.AddSubscriber( "use_anglegrinderdisk_inv", use_anglegrinderdisk_inv );
    cmn.AddSubscriber( "use_anglegrinderdisk_beg", use_anglegrinderdisk_beg, "inv_anglegrinder" );
    cmn.AddSubscriber( "use_anglegrinderdisk_end", use_anglegrinderdisk_end, "inv_anglegrinder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_workanglegrinder" ] = {
      type = "get",
      get_obj = "spr_deploy_workanglegrinder",
      room = "int_deploy_inv",
      zz = "deploy_inv_anglegrinder",
      zz_gate = "inv_anglegrinder"
    };
    function get_workanglegrinder_inv ()

      interface.InventoryItemRemove( "inv_anglegrinder" );
      interface.InventoryItemAdd( "inv_workanglegrinder", "spr_deploy_workanglegrinder" );

    end;
    function get_workanglegrinder_deploy ()

      ObjDelete( "gfx_deploy_workanglegrinder" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_workanglegrinder", get_workanglegrinder_inv );
    cmn.AddSubscriber( "get_workanglegrinder", get_workanglegrinder_deploy, "inv_anglegrinder" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_anglegrinderdisk()

    local item = "inv_anglegrinderdisk";
    if private.ObjIntersectCheck( item, "obj_anglegrinder_use_anglegrinderdisk", "deploy_inv_anglegrinder" ) then

      cmn.CallEventHandler( "use_anglegrinderdisk_beg", "inv_anglegrinder" );
      cmn.CallEventHandler( "use_anglegrinderdisk_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1052"); common_impl.Lock( false );

        cmn.SetEventDone( "use_anglegrinderdisk" );
        cmn.CallEventHandler( "use_anglegrinderdisk_end", "inv_anglegrinder" );
    
      end;

       DbgTrace("common_impl.Lock( 1053"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_anglegrinder_use_disk", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_anglegrinder_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "spr_deploy_anglegrinder_disk", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_workanglegrinder()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_workanglegrinder" );
    cmn.CallEventHandler( "get_workanglegrinder", "inv_anglegrinder" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** brokenboxamulet_4 *** () end;
--*********************************************************************************************************************
  function private.init_brokenboxamulet_4()

    ObjSet( "spr_deploy_boxamulet_4", { event_mdown = function() public.get_boxamulet_4() end } );
    ObjSet( "obj_brokenboxamulet_4_use_amuletelement", { event_mdown = function() private.ShowBbt( 'amuletelement' ) end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletelement_4_1" ] = {
        type = "use",
        inv_obj = "inv_amuletelement_4_1",
        use_place = "obj_brokenboxamulet_4_use_amuletelement",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenboxamulet_4",
        zz_gate = "inv_brokenboxamulet_4"
    };
    function use_amuletelement_4_1_inv ()
      
      interface.InventoryItemRemove( "inv_amuletelement_4_1" );
      if ( ( cmn.IsEventDone("get_amuletelement_4_2") and not cmn.IsEventDone("use_amuletelement_4_2")) or ( cmn.IsEventDone("get_amuletelement_4_3") and not cmn.IsEventDone("use_amuletelement_4_3")) ) then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 }); 
      elseif cmn.IsEventDone("use_amuletelement_4_2") and cmn.IsEventDone("use_amuletelement_4_3") then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });       
      else 
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 0 });     
      end;
      
    end;
    function use_amuletelement_4_1_beg ()
      
      if ( cmn.IsEventDone( "use_amuletelement_4_2" ) and cmn.IsEventDone( "use_amuletelement_4_3" ) ) then
        
         ObjDelete( "obj_brokenboxamulet_4_use_amuletelement" );
         
      end;

    end;
    function use_amuletelement_4_1_end ()
      
      ObjSet( "obj_deploy_brokenboxamulet_4_detail_1", { alp = 1 });
      ObjSet( "spr_brokenboxamulet_4_detail_1", { alp = 1 });
      if( cmn.IsEventDone("use_amuletelement_4_2") and cmn.IsEventDone("use_amuletelement_4_3") ) then
        
        ObjSet( "spr_deploy_boxamulet_4", { input = true });
        ObjSet( "gfx_deploy_boxamulet_4", { active = true }); 
        
      end; 
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletelement_4_1", use_amuletelement_4_1_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_1", use_amuletelement_4_1_inv );
    cmn.AddSubscriber( "use_amuletelement_4_1", use_amuletelement_4_1_end );
    cmn.AddSubscriber( "use_amuletelement_4_1", use_amuletelement_4_1_end, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_1_inv", use_amuletelement_4_1_inv );
    cmn.AddSubscriber( "use_amuletelement_4_1_beg", use_amuletelement_4_1_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_1_end", use_amuletelement_4_1_end, "inv_brokenboxamulet_4" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletelement_4_2" ] = {
        type = "use",
        inv_obj = "inv_amuletelement_4_2",
        use_place = "obj_brokenboxamulet_4_use_amuletelement",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenboxamulet_4",
        zz_gate = "inv_brokenboxamulet_4"
    };
    function use_amuletelement_4_2_inv ()
      
      interface.InventoryItemRemove( "inv_amuletelement_4_2" );
      if ( ( cmn.IsEventDone("get_amuletelement_4_1") and not cmn.IsEventDone("use_amuletelement_4_1")) or ( cmn.IsEventDone("get_amuletelement_4_3") and not cmn.IsEventDone("use_amuletelement_4_3")) ) then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 }); 
      elseif cmn.IsEventDone("use_amuletelement_4_1") and cmn.IsEventDone("use_amuletelement_4_3") then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });       
      else 
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 0 });     
      end;
      
    end;
    function use_amuletelement_4_2_beg ()

      if ( cmn.IsEventDone( "use_amuletelement_4_1" ) and cmn.IsEventDone( "use_amuletelement_4_3" ) ) then
        
         ObjDelete( "obj_brokenboxamulet_4_use_amuletelement" );
         
      end;

    end;
    function use_amuletelement_4_2_end ()
      
      ObjSet( "spr_brokenboxamulet_plus_light", { alp = 1 });
      ObjSet( "obj_deploy_brokenboxamulet_4_detail_2", { alp = 1 });
      ObjSet( "spr_brokenboxamulet_4_detail_2", { alp = 1 });
      
      if( cmn.IsEventDone("use_amuletelement_4_1") and cmn.IsEventDone("use_amuletelement_4_3") ) then
        
        ObjSet( "spr_deploy_boxamulet_4", { input = true });
        ObjSet( "gfx_deploy_boxamulet_4", { active = true }); 
        
      end;  
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletelement_4_2", use_amuletelement_4_2_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_2", use_amuletelement_4_2_inv );
    cmn.AddSubscriber( "use_amuletelement_4_2", use_amuletelement_4_2_end );
    cmn.AddSubscriber( "use_amuletelement_4_2", use_amuletelement_4_2_end, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_2_inv", use_amuletelement_4_2_inv );
    cmn.AddSubscriber( "use_amuletelement_4_2_beg", use_amuletelement_4_2_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_2_end", use_amuletelement_4_2_end, "inv_brokenboxamulet_4" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletelement_4_3" ] = {
        type = "use",
        inv_obj = "inv_amuletelement_4_3",
        use_place = "obj_brokenboxamulet_4_use_amuletelement",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenboxamulet_4",
        zz_gate = "inv_brokenboxamulet_4"
    };
    function use_amuletelement_4_3_inv ()
      
      interface.InventoryItemRemove( "inv_amuletelement_4_3" );
      if ( ( cmn.IsEventDone("get_amuletelement_4_1") and not cmn.IsEventDone("use_amuletelement_4_1")) or ( cmn.IsEventDone("get_amuletelement_4_2") and not cmn.IsEventDone("use_amuletelement_4_2")) ) then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 }); 
      elseif cmn.IsEventDone("use_amuletelement_4_1") and cmn.IsEventDone("use_amuletelement_4_2") then
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });       
      else 
        ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 0 });     
      end;
      
    end;
    function use_amuletelement_4_3_beg ()

      if ( cmn.IsEventDone( "use_amuletelement_4_1" ) and cmn.IsEventDone( "use_amuletelement_4_2" ) ) then
        
         ObjDelete( "obj_brokenboxamulet_4_use_amuletelement" );
         
      end;

    end;
    function use_amuletelement_4_3_end ()
      
      ObjSet( "spr_brokenboxamulet_plus_light", { alp = 1 });
      ObjSet( "obj_deploy_brokenboxamulet_4_detail_3", { alp = 1 });
      ObjSet( "spr_brokenboxamulet_4_detail_3", { alp = 1 });
      
      if( cmn.IsEventDone("use_amuletelement_4_2") and cmn.IsEventDone("use_amuletelement_4_1") ) then
        
        ObjSet( "spr_deploy_boxamulet_4", { input = true });
        ObjSet( "gfx_deploy_boxamulet_4", { active = true }); 
        
      end;  
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletelement_4_3", use_amuletelement_4_3_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_3", use_amuletelement_4_3_inv );
    cmn.AddSubscriber( "use_amuletelement_4_3", use_amuletelement_4_3_end );
    cmn.AddSubscriber( "use_amuletelement_4_3", use_amuletelement_4_3_end, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_3_inv", use_amuletelement_4_3_inv );
    cmn.AddSubscriber( "use_amuletelement_4_3_beg", use_amuletelement_4_3_beg, "inv_brokenboxamulet_4" );
    cmn.AddSubscriber( "use_amuletelement_4_3_end", use_amuletelement_4_3_end, "inv_brokenboxamulet_4" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_boxamulet_4" ] = {
      type = "get",
      get_obj = "spr_deploy_boxamulet_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenboxamulet_4",
      zz_gate = "inv_brokenboxamulet_4"
    };
    function get_boxamulet_4_inv ()

      interface.InventoryItemRemove( "inv_brokenboxamulet_4" );
      interface.InventoryItemAdd( "inv_boxamulet_4", "spr_deploy_boxamulet_4" );

    end;
    function get_boxamulet_4_deploy ()

      ObjDelete( "gfx_deploy_boxamulet_4" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_boxamulet_4", get_boxamulet_4_inv );
    cmn.AddSubscriber( "get_boxamulet_4", get_boxamulet_4_deploy, "inv_brokenboxamulet_4" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_amuletelement_4_1()

    local item = "inv_amuletelement_4_1";
    if private.ObjIntersectCheck( item, "obj_brokenboxamulet_4_use_amuletelement", "deploy_inv_brokenboxamulet_4" ) then

      cmn.CallEventHandler( "use_amuletelement_4_1_beg", "inv_brokenboxamulet_4" );
      cmn.CallEventHandler( "use_amuletelement_4_1_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1054"); common_impl.Lock( false );

        cmn.SetEventDone( "use_amuletelement_4_1" );
        cmn.CallEventHandler( "use_amuletelement_4_1_end", "inv_brokenboxamulet_4" );
    
      end;

       DbgTrace("common_impl.Lock( 1055"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenboxamulet_4_use_detail", 0, "", 0 );
      
      ObjAnimate( "obj_deploy_brokenboxamulet_4_detail_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_amuletelement_4_2()

    local item = "inv_amuletelement_4_2";
    if private.ObjIntersectCheck( item, "obj_brokenboxamulet_4_use_amuletelement", "deploy_inv_brokenboxamulet_4" ) then

      cmn.CallEventHandler( "use_amuletelement_4_2_beg", "inv_brokenboxamulet_4" );
      cmn.CallEventHandler( "use_amuletelement_4_2_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1056"); common_impl.Lock( false );

        cmn.SetEventDone( "use_amuletelement_4_2" );
        cmn.CallEventHandler( "use_amuletelement_4_2_end", "inv_brokenboxamulet_4" );
    
      end;

       DbgTrace("common_impl.Lock( 1057"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenboxamulet_4_use_detail", 0, "", 0 );
      
      ObjAnimate( "obj_deploy_brokenboxamulet_4_detail_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      return true;

    end;

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_amuletelement_4_3()

    local item = "inv_amuletelement_4_3";
    if private.ObjIntersectCheck( item, "obj_brokenboxamulet_4_use_amuletelement", "deploy_inv_brokenboxamulet_4" ) then

      cmn.CallEventHandler( "use_amuletelement_4_3_beg", "inv_brokenboxamulet_4" );
      cmn.CallEventHandler( "use_amuletelement_4_3_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1058"); common_impl.Lock( false );

        cmn.SetEventDone( "use_amuletelement_4_3" );
        cmn.CallEventHandler( "use_amuletelement_4_3_end", "inv_brokenboxamulet_4" );
    
      end;

       DbgTrace("common_impl.Lock( 1059"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenboxamulet_4_use_detail", 0, "", 0 );
      
      ObjAnimate( "obj_deploy_brokenboxamulet_4_detail_3", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_boxamulet_4()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_boxamulet_4" );
    cmn.CallEventHandler( "get_boxamulet_4", "inv_brokenboxamulet_4" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** toolbox *** () end;
--*********************************************************************************************************************
  function private.init_toolbox()

    ObjSet( "spr_deploy_toolbox_wrench_4", { event_mdown = function() public.get_wrench_4() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_coin_4" ] = {
        type = "use",
        inv_obj = "inv_coin_4",
        use_place = "obj_toolbox_use_coin",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };
    function use_coin_4_inv ()
      
      interface.InventoryItemRemove( "inv_coin_4" );
      
    end;
    function use_coin_4_beg ()

      ObjDelete( "obj_toolbox_use_coin" );

    end;
    function use_coin_4_end ()

      ObjDelete( "spr_deploy_toolbox_box_close" );
      ObjSet( "spr_deploy_toolbox_box_open", { input = true, alp = 1 });
      ObjSet( "spr_deploy_toolbox_wrench_4", { input = true });
      ObjSet( "gfx_deploy_toolbox_wrench_4", { active = true });
      ObjSet( "spr_toolbox_plus_light", { alp = 1 });   
      
      ObjSet( "inv_toolbox", { res = "assets/levels/levelext/inv_deploy/inv_toolbox/inv/inv_drawer_is_open" }); 
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_coin_4", use_coin_4_beg, "inv_toolbox" );
    cmn.AddSubscriber( "use_coin_4", use_coin_4_inv );
    cmn.AddSubscriber( "use_coin_4", use_coin_4_end );
    cmn.AddSubscriber( "use_coin_4", use_coin_4_end, "inv_toolbox" );
    cmn.AddSubscriber( "use_coin_4_inv", use_coin_4_inv );
    cmn.AddSubscriber( "use_coin_4_beg", use_coin_4_beg, "inv_toolbox" );
    cmn.AddSubscriber( "use_coin_4_end", use_coin_4_end, "inv_toolbox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_wrench_4" ] = {
      type = "get",
      get_obj = "spr_deploy_toolbox_wrench_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_toolbox",
      zz_gate = "inv_toolbox"
    };
    function get_wrench_4_inv ()

      interface.InventoryItemRemove( "inv_toolbox" );
      interface.InventoryItemAdd( "inv_wrench_4", "spr_deploy_toolbox_wrench_4" );

    end;
    function get_wrench_4_deploy ()

      ObjDelete( "gfx_deploy_toolbox_wrench_4" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_wrench_4", get_wrench_4_inv );
    cmn.AddSubscriber( "get_wrench_4", get_wrench_4_deploy, "inv_toolbox" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_coin_4()

    local item = "inv_coin_4";
    if private.ObjIntersectCheck( item, "obj_toolbox_use_coin", "deploy_inv_toolbox" ) then

      cmn.CallEventHandler( "use_coin_4_beg", "inv_toolbox" );
      cmn.CallEventHandler( "use_coin_4_inv" );

      local func_after = function ()
        
        local func_end = function ()
        
           DbgTrace("common_impl.Lock( 1060"); common_impl.Lock( false );

          cmn.SetEventDone( "use_coin_4" );
          cmn.CallEventHandler( "use_coin_4_end", "inv_toolbox" );
          
        end;
        
        ObjAnimate( "spr_deploy_toolbox_box_bolt", "pos_y", 0, 0, "",
        { 
          0.0, 0, -68,
          0.5, 0, -37,
        } );
        
        ObjAnimate( "spr_deploy_toolbox_box_close", "alp", 0, 0, "",
        { 
          0.0, 0, 1,
          0.5, 0, 1,
          0.8, 0, 0,
        } );
        
        ObjAnimate( "spr_deploy_toolbox_box_open", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1,
        } );
        
      end;

       DbgTrace("common_impl.Lock( 1061"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_toolbox_use_coin", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_toolbox_box_coin_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.6, 0, 1.0,
        0.9, 0, 0.0
      } );
      
      ObjAnimate( "spr_deploy_toolbox_box_over_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.6, 0, 0.0,
        0.9, 0, 1.0
      } );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_wrench_4()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_wrench_4" );
    cmn.CallEventHandler( "get_wrench_4", "inv_toolbox" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** brokenapparatus_4 *** () end;
--*********************************************************************************************************************
  function private.init_brokenapparatus_4()

    ObjSet( "spr_deploy_brokenapparatus_4_apparatus_4", { event_mdown = function() public.get_apparatus_4() end } );
    ObjSet( "obj_brokenapparatus_4_clk_apparatus_4_1", { event_mdown = function() private.clk_apparatus_4_1() end } );
    ObjSet( "obj_brokenapparatus_4_clk_apparatus_4_2", { event_mdown = function() private.clk_apparatus_4_2() end } );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_apparatus_4_1" ] = {
        type = "click",
        use_place = "obj_brokenapparatus_4_clk_apparatus_4_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenapparatus_4",
        zz_gate = "inv_brokenapparatus_4"
    };
    function clk_apparatus_4_1_beg ()

      ObjDelete( "obj_brokenapparatus_4_clk_apparatus_4_1" );

    end;
    function clk_apparatus_4_1_end ()
      
      ObjSet( "obj_brokenapparatus_4_use_batteries_4", { input = true });
      ObjSet( "spr_deploy_brokenapparatus_4_cover", { pos_x = 246, pos_y = 231 }); 
      
      ObjSet( "spr_brokenapparatus_4_cover", { alp = 0 });
      
      if ( cmn.IsEventDone("get_batteries_4") and not cmn.IsEventDone("use_batteries_4")) then
        ObjSet( "spr_brokenapparatus_4_plus_light", { alp = 1 });
      else 
        ObjSet( "spr_brokenapparatus_4_plus_light", { alp = 0 });        
      end;
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_apparatus_4_1", clk_apparatus_4_1_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_1", clk_apparatus_4_1_end );
    cmn.AddSubscriber( "clk_apparatus_4_1", clk_apparatus_4_1_end, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_1_beg", clk_apparatus_4_1_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_1_end", clk_apparatus_4_1_end, "inv_brokenapparatus_4" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_apparatus_4_2" ] = {
        type = "click",
        use_place = "obj_brokenapparatus_4_clk_apparatus_4_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenapparatus_4",
        zz_gate = "inv_brokenapparatus_4"
    };
    function clk_apparatus_4_2_beg ()

      ObjDelete( "obj_brokenapparatus_4_clk_apparatus_4_2" );

    end;
    function clk_apparatus_4_2_end ()
      
      ObjSet( "spr_deploy_brokenapparatus_4_cover", { pos_x = 114, pos_y = 173 });   
      ObjSet( "spr_deploy_brokenapparatus_4_apparatus_4", { input = true }); 
      ObjSet( "gfx_deploy_brokenapparatus_4_apparatus_4", { active = true }); 
      ObjSet( "spr_deploy_brokenapparatus_4_light", { alp = 1 });
      
      ObjSet( "spr_brokenapparatus_4_cover", { alp = 1 }); 
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_apparatus_4_2", clk_apparatus_4_2_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_2", clk_apparatus_4_2_end );
    cmn.AddSubscriber( "clk_apparatus_4_2", clk_apparatus_4_2_end, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_2_beg", clk_apparatus_4_2_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "clk_apparatus_4_2_end", clk_apparatus_4_2_end, "inv_brokenapparatus_4" );
    ------------------------------------------------------------------------------------------
    common_impl.hint[ "use_batteries_4" ] = {
        type = "use",
        inv_obj = "inv_batteries_4",
        use_place = "obj_brokenapparatus_4_use_batteries_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenapparatus_4",
        zz_gate = "inv_brokenapparatus_4"
    };
    function use_batteries_4_inv ()
      
      interface.InventoryItemRemove( "inv_batteries_4" );
      
    end;
    function use_batteries_4_beg ()

      ObjDelete( "obj_brokenapparatus_4_use_batteries_4" );

    end;
    function use_batteries_4_end ()
      
      ObjSet( "spr_deploy_brokenapparatus_4_battery", { alp = 1 }); 
      ObjSet( "obj_brokenapparatus_4_clk_apparatus_4_2", { input = true }); 
     
      ObjSet( "spr_brokenapparatus_4_battery", { alp = 1 });  
      ObjSet( "spr_brokenapparatus_4_light_2", { alp = 1 }); 
      ObjDelete( "spr_brokenapparatus_4_light_1" );
      ObjSet( "spr_brokenapparatus_4_plus_light", { alp = 1 });  
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_batteries_4", use_batteries_4_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "use_batteries_4", use_batteries_4_inv );
    cmn.AddSubscriber( "use_batteries_4", use_batteries_4_end );
    cmn.AddSubscriber( "use_batteries_4", use_batteries_4_end, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "use_batteries_4_inv", use_batteries_4_inv );
    cmn.AddSubscriber( "use_batteries_4_beg", use_batteries_4_beg, "inv_brokenapparatus_4" );
    cmn.AddSubscriber( "use_batteries_4_end", use_batteries_4_end, "inv_brokenapparatus_4" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_apparatus_4" ] = {
      type = "get",
      get_obj = "spr_deploy_brokenapparatus_4_apparatus_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenapparatus_4",
      zz_gate = "inv_brokenapparatus_4"
    };
    function get_apparatus_4_inv ()

      interface.InventoryItemRemove( "inv_brokenapparatus_4" );
      --interface.InventoryItemAdd( "inv_apparatus_4", "spr_deploy_brokenapparatus_4_apparatus_4" );
      interface.InventoryItemAdd( "inv_apparatus_4", "obj_deploy_brokenapparatus_4" ); 
    end;
    function get_apparatus_4_deploy ()

      ObjDelete( "gfx_deploy_toolbox_wrench_4" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_apparatus_4", get_apparatus_4_inv );
    cmn.AddSubscriber( "get_apparatus_4", get_apparatus_4_deploy, "inv_brokenapparatus_4" );
    -------------------------------------------------------------------------------------------
    
  end;
  -------------------------------------------------------------------------------------------------------------
  function private.clk_apparatus_4_1()

      cmn.CallEventHandler( "clk_apparatus_4_1_beg", "inv_brokenapparatus_4" );
      cmn.CallEventHandler( "clk_apparatus_4_1_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1062"); common_impl.Lock( false );

        cmn.SetEventDone( "clk_apparatus_4_1" );
        cmn.CallEventHandler( "clk_apparatus_4_1_end", "inv_brokenapparatus_4" );
    
      end;

       DbgTrace("common_impl.Lock( 1063"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenapparatus_touch_cover_open", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_brokenapparatus_4_cover", "pos_xy", 0, 0, func_after,
      { 
        0.0, 0, 114, 173, 
        0.5, 0, 246, 231
      } );

  end;
  -------------------------------------------------------------------------------------------------------------
  function private.clk_apparatus_4_2()

      cmn.CallEventHandler( "clk_apparatus_4_2_beg", "inv_brokenapparatus_4" );
      cmn.CallEventHandler( "clk_apparatus_4_2_inv" );

      local func_after = function ()
      
        local func_end = function ()
        
           DbgTrace("common_impl.Lock( 1064"); common_impl.Lock( false );

          cmn.SetEventDone( "clk_apparatus_4_2" );
          cmn.CallEventHandler( "clk_apparatus_4_2_end", "inv_brokenapparatus_4" );
    
        end;
      
       ObjAnimate( "spr_deploy_brokenapparatus_4_light", "alp", 0, 0, func_end,
       { 
         0.0, 0, 0, 
         0.3, 0, 1
       } );
       
      end;  
     
       DbgTrace("common_impl.Lock( 1065"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenapparatus_touch_cover_close", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_brokenapparatus_4_cover", "pos_xy", 0, 0, func_after,
      { 
        0.0, 0, 246, 231, 
        0.5, 0, 114, 173
      } );

  end;
  -------------------------------------------------------------------------------------------------------------
  function public.use_batteries_4()

    local item = "inv_batteries_4";
    if private.ObjIntersectCheck( item, "obj_brokenapparatus_4_use_batteries_4", "deploy_inv_brokenapparatus_4" ) and cmn.IsEventDone("clk_apparatus_4_1") then

      cmn.CallEventHandler( "use_batteries_4_beg", "inv_brokenapparatus_4" );
      cmn.CallEventHandler( "use_batteries_4_inv" );

      local func_after = function ()
        
         DbgTrace("common_impl.Lock( 1066"); common_impl.Lock( false );

        cmn.SetEventDone( "use_batteries_4" );
        cmn.CallEventHandler( "use_batteries_4_end", "inv_brokenapparatus_4" );
          
      end;

       DbgTrace("common_impl.Lock( 1067"); common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_brokenapparatus_use_batteries", 0, "", 0 );
      
      ObjAnimate( "spr_deploy_brokenapparatus_4_battery", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      return true;

    end;

  end;
  ------------------------------------------------------------------------------------------------------------------
  function public.get_apparatus_4()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_apparatus_4" );
    cmn.CallEventHandler( "get_apparatus_4", "inv_brokenapparatus_4" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** Searcher *** () end;
--*********************************************************************************************************************
function private.InitSearcher()

  private.SearcherData = { [ "rm_secondfloor" ] = { "", "obj_secondfloor_use_searcher", "use_searcher_4_1" },
                           [ "rm_corridor_4" ] =  { "", "obj_corridor_4_use_searcher",  "use_searcher_4_2" },
                           [ "rm_lunchroom_4" ] = { "", "obj_lunchroom_4_use_searcher", "use_searcher_4_3" },
                           [ "rm_behindstage" ] = { "", "obj_behindstage_use_searcher", "use_searcher_4_4" },
                           [ "rm_smallroom_4" ] = { "", "obj_smallroom_4_use_searcher", "use_searcher_4_5" },
                           [ "rm_hall_4" ] =      { "", "obj_hall_4_use_searcher",      "use_searcher_4_6" }, };

  private.SearcherRooms = { "rm_secondfloor",
                            "rm_corridor_4",
                            "rm_lunchroom_4",
                            "rm_behindstage",
                            "rm_smallroom_4",
                            "rm_hall_4",
                          };    
 
  ObjSet( "inv_searcher",
  {
    event_startdrag = private.SercherStartDrag,
    event_dragdrop = private.SearcherDragDrop,
    event_drag = private.SearcherDrag,

  } );

end;
--*********************************************************************************************************************
function private.SercherStartDrag()
  common.BlockGotoRoom(false);
  private.find_anim_start = false; 
  
  private.find_anim_searcher = false;
  ObjSet("obj_searcher_dummy_apply_small",{ pos_y = -120 });
  
  local tme = 0.2

  ObjAnimate( "inv_searcher_small", "alp", 0, 0, "", 
  { 
    0.0, 3, 1, 
    tme, 3, 0,

  });

  ObjAnimate( "obj_searcher_big", "alp", 0, 0, "", 
  { 
    0.0, 3, 0, 
    tme, 3, 1,

  });
  
  local room_current = GetCurrentRoom();
  if ( common_impl.ExistInArr( private.SearcherRooms, room_current ) and not cmn.IsEventDone( private.SearcherData[ room_current ][ 3 ] ) ) then

    local event = private.SearcherData[ room_current ][ 3 ];

    local obj = private.SearcherData[ room_current ][ 2 ];

    local item = "obj_searcher_dummy_apply_big";

    if ( not cmn.IsEventDone( event ) and common.ApplyObj( item, obj, false )  ) then
      
      private.StartSearch();
      private.SearcherIsEnter = false;

    else

      common_impl.ShowBbt( 'bbt_searcher_no_item' );

    end;

  else

    common_impl.ShowBbt( 'bbt_searcher_no_item' );

  end;
  SetCursor( CURSOR_DEFAULT );
end;
--*********************************************************************************************************************
function private.SearcherDragDrop()

  --if ( private.SearcherNotDrop ) then

   --interface.ObjDoNotDrop( "inv_searcher" );

    --return;

  --end;
  -- common_impl.Lock( true )

  local tme_big = 0.2;
  local tme_small = 0.2;

  local get = ObjGet( "obj_searcher_big" );

  local big_name = "obj_searcher_big";
    
  if ( ObjGet( "inv_searcher_clone" ) ) then

    big_name = big_name.."_clone";
    tme_small = 0.4;

  end;  

  local endfunc = function ()

  ObjDelete( "inv_searcher_clone" );

  --DbgTrace( "ObjDelete( inv_searcher_clone )" );

  --ObjSet( "itm_int_inventory_searcher", { input = true } );
--
  if private.find_anim_searcher == false then
     common_impl.Lock( false );
  end;

    local flag = true;

      for i = 1, 6 do

        if ( not cmn.IsEventDone( "use_searcher_4_"..i ) ) then

          flag = false;

        end;
  
      end;

    if ( flag ) then

      interface.InventoryItemRemove( "inv_searcher" );
      common.BlockGotoRoom(true);
      
    end;

  end;

  ObjAnimate( big_name, "alp", 0, 0, endfunc, 
  { 
    0.0, 3, 1, 
    tme_big, 3, 0,

  });

  if ( ObjGet( "inv_searcher_clone" ) ) then

    ObjAnimate( "inv_searcher_small", "alp", 0, 0, "", 
    { 
      0.0, 3, 0, 
      0.5, 3, 0,
      0.8, 3, 1,

    });

  else

    ObjAnimate( "inv_searcher_small", "alp", 0, 0, "", 
    { 
      0.0,     3, 0, 
      tme_small, 3, 1,

    });

  end;

  common_impl.StopAudio( "env", "common/audio/levelext/aud_searcher_env", 0.2 );

  private.SearcherIsEnter = false;
  private.Searching( false, false );
  ObjSet( "tmr_searcher_menter_time", { playing = false } );

  ObjSet("obj_searcher_dummy_apply_small",{ pos_y = 32 });
  
  ObjSet( "tmr_searcher_drop_time", { playing = true, time = 3.0, 
  endtrig = function()
    if private.find_anim_searcher == false and private.SearcherIsEnter == false and private.find_anim_start == false then
      common.BlockGotoRoom(true);
    end;
    private.find_anim_searcher = false;
    common_impl.Lock( false );
  end;
  } );
  
end;
private.find_anim_searcher = false;
private.find_anim_start = false;
--*********************************************************************************************************************
function private.SearcherDrag()

  local searcher = 4;

  local room_current = GetCurrentRoom();

  if ( common_impl.ExistInArr( private.SearcherRooms, room_current ) and not cmn.IsEventDone( private.SearcherData[ room_current ][ 3 ] ) ) then

    local item = "obj_searcher_dummy_apply_big";

    local obj = private.SearcherData[ room_current ][ 2 ];

    if ( common.ApplyObj( item, obj, false ) ) then

      local pos = GetObjPosByObj( "obj_searcher_dummy_apply_small", obj );

      private.SearchingDistance = math.sqrt ( pos[ 1 ]^2 + pos[ 2 ]^2 );

      local tmr_time = ObjGet( "tmr_searcher_sound" ).time;

      local time = private.SearchingDistance * 0.002;

      if ( time < 0.2 ) then

        searcher = 1;

      elseif ( time < 1 ) then

        searcher = 2;

      elseif ( time < 1.5 ) then

        searcher = 3;

      end;

      if ( time < 0.1 ) then 

        time = 0.1;

      end;

      if ( tmr_time > time ) then

        private.Searching( true, false );

      end;

      if ( common.ApplyObj( "obj_searcher_dummy_apply_small", obj, false ) ) then

        if ( not private.SearcherIsEnter ) then
          
          private.SearcherIsEnter = true;
          private.find_anim_searcher = true;
          private.find_anim_start = true;
          
          local endfunc = function ()
            
            event = private.SearcherData[ room_current ][ 3 ];
            private.Searching( true, true, true );
            --private.SearcherNotDrop = true;

            --private.SearcherGetObj = ObjGet( "inv_searcher" );

            if not ( ObjGet( "inv_searcher_clone" ) ) then

              ObjClone( "inv_searcher", "_clone", 1, "ng_interface_internal" );
            
            end;

            local pos_clone = GetObjPosByObj( "inv_searcher", "ng_interface_internal" );

            ObjMultiSet({ 
        
              { "inv_searcher_clone", { pos_x = pos_clone[ 1 ], pos_y = pos_clone[ 2 ], pos_z = 1000 }},
              { "inv_searcher", { alp = 0 } },

            });

            _G[ room_current ][event]( 

              function ()

                private.SearcherNotDrop = false; 
                private.Searching( false, false, false );
                ObjMultiSet({ 
            
                  { "obj_searcher_big", { alp = 0 } },
                  { "inv_searcher", { alp = 1 } },

                });

                --ObjSet( "itm_int_inventory_searcher", { input = false } );

                ObjStopDrag( "inv_searcher" );
                
                ObjSet( "tmr_searcher_menter_time", { playing = true, time = 2, endtrig = function()
                  private.find_anim_searcher = false;
                  common_impl.Lock( false );
                  
                  end;
                } );
                
                --DbgTrace( " DbgTrace("common_impl.Lock( 1072"); common_impl.Lock( false ) - private.SearcherDrag() => endfunc" );
                --DbgTrace( "stopdrag" );

              end );

          end;

          ObjSet( "tmr_searcher_menter_time", { playing = true, time = 2, endtrig = endfunc } );

        end;
        
      else

        ObjSet( "tmr_searcher_menter_time", { playing = false } );
        private.find_anim_searcher = false;
        private.SearcherIsEnter = false;

      end;
    end;
  end;

  if ( private.current_sercher ~= searcher ) then

    private.current_sercher = searcher;

    ObjMultiSet({ 
  
      { "anm_searcher_1", { visible = false }},
      { "anm_searcher_2", { visible = false }},
      { "anm_searcher_3", { visible = false }},
      { "anm_searcher_4", { visible = false }},

      { "anm_searcher_"..searcher, { visible = true }},

    });

  end;

end;
--*********************************************************************************************************************
function private.StartSearch(  )

  private.SearcherDrag();
  private.Searching( true, true );

end;
--*********************************************************************************************************************
function private.Searching( playing, sound, forcibly )

  local time = 0;

  if ( playing ) then

    time = private.SearchingDistance * 0.002;

  end;

  if ( forcibly ) then

    time = 0;

  end;

  if ( time < 0.1 ) then 

    time = 0.1;

  end;

  if ( sound ) then

    common_impl.PlayAudio( "sfx", "common/audio/aud_call_cancel", 0, "", 0 );

  end;
  
  common_impl.PlayAudio( "env", "common/audio/levelext/aud_searcher_env", 1, "", 0 );

  ObjSet( "tmr_searcher_sound", { time = time, playing = playing, endtrig = function () private.Searching( true, true ) end } );

end;
--*********************************************************************************************************************
function public.IsUseAllSearchers( num )

  for i = 1, 6 do

    if ( not cmn.IsEventDone( "use_searcher_4_"..i ) ) then

      if ( i ~= num ) then

        return false;

      end;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function public.EctoplasmCount( )

  local num = 0;

  for i = 1, 6 do

    if ( cmn.IsEventDone( "get_ectoplasm_4_"..i ) ) then

      num = num + 1;

    end;

  end;

  return num;

end;
---------------------------------------------------------------------------------
ObjAnimate( "spr_depoly_brokenapparatus_4_light_add", "alp", 1, 0, "", { 0,0,1, 2,0,0.0, 4,0,1 } );
ObjAnimate( "spr_depoly_brokenapparatus_4_light_add_2", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.0, 3,0,1 } );
