-- name=rm_balcony
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_balcony";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_lantern", "room_hub" );
  ObjAttach( "zz_pot", "room_hub" );
  ObjAttach( "zz_banister", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_lantern_secretsign", { event_mdown = private.get_secretsign }},
  { "spr_lantern_doorelement_4_4", { event_mdown = private.get_doorelement_4_4 }},
  { "spr_lantern_book_4_2", { event_mdown = private.get_book_4_2 }},
  { "spr_pot_coin_4", { event_mdown = private.get_coin_4 }},
  { "spr_pot_button_4", { event_mdown = private.get_button_4 }},
  { "spr_pot_doorelement_4_3", { event_mdown = private.get_doorelement_4_3 }},
  { "obj_lantern_use_lanternelement_4_1", { event_mdown = private.clk_stash_2_door }},
  { "obj_lantern_use_lanternelement_4_2", { event_mdown = private.clk_stash_2_door }},
  { "spr_pot_collect_2", { event_mdown = function () private.get_collect_2_4_7(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }}, 
  { "spr_lantern_collect_2", { event_mdown = function () private.get_collect_2_4_5(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                             
  { "spr_balcony_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_7" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_balcony = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_balcony_balconyroom",
    "gzz_balcony_lantern",
    "gzz_balcony_pot",
    "gzz_balcony_banister"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_lantern",
    "zz_pot",
    "zz_banister"  
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_balcony", update_game_mode_balcony, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_balcony = function ()

  local effects_table = 
  {
    "spr_banister_light_add",
    "anm_banister_birds",
    --"anm_banister_snow",
    "anm_lantern_sky", 
    "spr_lantern_light_2_add",
    --"anm_lantern_snow",
    "anm_pot_flover",
    "anm_balcony_clouds",
    "spr_balcony_over_2",
    "anm_balcony_branch",
    "spr_balcony_lamp_1",
    "spr_balcony_lamp_2",
    "spr_balcony_lamp_3",
    "spr_balcony_glass",
    "spr_balcony_over",
    --"anm_pot_snow"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_balcony", update_performance_mode_balcony, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_balcony () end;
  --------------------------------------------------------------------------------------------
  local opn_balcony_map = function ()

    common_impl.VisitMapRoom( "balcony" );

  end;
  cmn.AddSubscriber( "opn_balcony", opn_balcony_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_secretsign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_secretsign" ] = {
    type = "get",
    get_obj = "spr_lantern_secretsign",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
    
  local get_secretsign_inv = function ()
  
    interface.InventoryItemAdd( "inv_secretsign", "spr_lantern_secretsign" );
  
  end;
  
  local get_secretsign_closezz = function ()
  
    ObjDelete( "gfx_lantern_secretsign" );
    ObjDelete( "spr_lantern_secretsign_over" );
    ObjDelete( "spr_balcony_lantern_mask" );
  
  end;
  
  cmn.AddSubscriber( "get_secretsign", get_secretsign_inv );
  cmn.AddSubscriber( "get_secretsign", get_secretsign_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorelement_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doorelement_4_4" ] = {
    type = "get",
    get_obj = "spr_lantern_doorelement_4_4",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
    
  local get_doorelement_4_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorelement_4_4", "spr_lantern_doorelement_4_4" );
  
  end;
  
  local get_doorelement_4_4_closezz = function ()
  
    ObjDelete( "gfx_lantern_doorelement_4_4" );
    ObjDelete( "spr_lantern_doorelement_over" );
    ObjDelete( "spr_balcony_lantern_note_3" );
      
  end;
  
  cmn.AddSubscriber( "get_doorelement_4_4", get_doorelement_4_4_inv );
  cmn.AddSubscriber( "get_doorelement_4_4", get_doorelement_4_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_book_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_book_4_2" ] = {
    type = "get",
    get_obj = "spr_lantern_book_4_2",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
    
  local get_book_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_book_4_2", "spr_lantern_book_4_2" );
  
  end;
  
  local get_book_4_2_closezz = function ()
  
    ObjDelete( "gfx_lantern_book_4_2" );
    
    if common_impl.IsGetCollect( "get_collect_2_4_5" ) then
    
      ObjDelete( "gzz_balcony_lantern" );
    
    end;
    ObjDelete( "spr_lantern_book_4_2_shadow" );
    ObjDelete( "spr_balcony_lantern_book" );
  
  end;
  
  cmn.AddSubscriber( "get_book_4_2", get_book_4_2_inv );
  cmn.AddSubscriber( "get_book_4_2", get_book_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin_4" ] = {
    type = "get",
    get_obj = "spr_pot_coin_4",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
    
  local get_coin_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin_4", "spr_pot_coin_4" );
    ObjSet( "spr_toolbox_plus_light", { alp = 1 });
  
  end;
  
  local get_coin_4_closezz = function ()
  
    ObjDelete( "gfx_pot_coin_4" );
    ObjDelete( "spr_balcony_pot_coin" );
    
    if( cmn.IsEventDone( "get_doorelement_4_3" ) and cmn.IsEventDone( "get_button_4" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ))then
      
      ObjDelete( "gzz_balcony_pot" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_coin_4", get_coin_4_inv );
  cmn.AddSubscriber( "get_coin_4", get_coin_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorelement_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doorelement_4_3" ] = {
    type = "get",
    get_obj = "spr_pot_doorelement_4_3",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
    
  local get_doorelement_4_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorelement_4_3", "spr_pot_doorelement_4_3" );
  
  end;
  
  local get_doorelement_4_3_closezz = function ()
  
    ObjDelete( "gfx_pot_doorelement_4_3" );
    ObjDelete( "spr_pot_doorelement_4_3_over" );
    ObjDelete( "spr_balcony_pot_note" );
    
    if( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_button_4" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ))then
      
      ObjDelete( "gzz_balcony_pot" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_doorelement_4_3", get_doorelement_4_3_inv );
  cmn.AddSubscriber( "get_doorelement_4_3", get_doorelement_4_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_4" ] = {
    type = "get",
    get_obj = "spr_pot_button_4",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
    
  local get_button_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_4", "spr_pot_button_4" );
  
  end;
  
  local get_button_4_closezz = function ()
  
    ObjDelete( "gfx_pot_button_4" );
    ObjDelete( "spr_pot_button_4_shadow" );
    ObjDelete( "spr_pot_button_4_over" ); 
    ObjDelete( "spr_balcony_pot_detail" );    
    
    if( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_doorelement_4_3" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ))then
      
      ObjDelete( "gzz_balcony_pot" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_button_4", get_button_4_inv );
  cmn.AddSubscriber( "get_button_4", get_button_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_7 = function ()
  
    ObjDelete( "obj_balcony_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_7", get_collect_morph_item_4_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_7 = function ()
  
    ObjDelete( "spr_pot_collect_2" );
    
    if ( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_doorelement_4_3" ) and cmn.IsEventDone( "get_button_4" )) then
    
      ObjDelete("gzz_balcony_pot");
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_7", get_collect_2_4_7 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_5 = function ()
  
    ObjDelete( "spr_lantern_collect_2" );
    
    if cmn.IsEventDone( "get_book_4_2" ) then
    
      ObjDelete( "gzz_balcony_lantern" );
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_5", get_collect_2_4_5 , private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_4_3" ] = {
    type = "use",
    inv_obj = "inv_screwdriver_4",
    use_place = "obj_lantern_use_screwdriver_4",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
  local use_screwdriver_4_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_screwdriver_4" );
  
  end;
  local use_screwdriver_4_3_beg = function ()
  
    ObjDelete( "obj_lantern_use_screwdriver_4" );
  
  end;
  local use_screwdriver_4_3_end = function ()
  
    ObjSet( "spr_lantern_secretsign", { input = true, active = true } );
    ObjDelete( "spr_lantern_glass" );
    ObjSet( "obj_lanter_stash_3", { input = true, alp = 1 } );
    ObjSet( "spr_balcony_lantern_open_3", { alp = 1 } );
    ObjDelete( "vid_lantern_use_screwdriver_4");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_4_3", use_screwdriver_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_3", use_screwdriver_4_3_inv );
  cmn.AddSubscriber( "use_screwdriver_4_3", use_screwdriver_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_3_inv", use_screwdriver_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_3_beg", use_screwdriver_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_3_end", use_screwdriver_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_patternelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_patternelement" ] = {
    type = "use",
    inv_obj = "inv_patternelement",
    use_place = "obj_lantern_use_patternelement",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
  local use_patternelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_patternelement" );
  
  end;
  local use_patternelement_beg = function ()
  
    ObjDelete( "obj_lantern_use_patternelement" );
  
  end;
  local use_patternelement_end = function ()
  
    ObjSet( "spr_lantern_doorelement_4_4", { input = true, active = true } );
    ObjSet( "obj_lanter_stash_1", { alp = 1, input = true } );
    ObjSet( "spr_lantern_part", { alp = 1 });
    ObjSet( "spr_balcony_lantern_element", { alp = 1 });
    ObjSet( "spr_balcony_lantern_open_1", { alp = 1 });
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_patternelement", use_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternelement", use_patternelement_inv );
  cmn.AddSubscriber( "use_patternelement", use_patternelement_end, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_inv", use_patternelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_beg", use_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_end", use_patternelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lanternelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lanternelement_4_1" ] = {
    type = "use",
    inv_obj = "inv_lanternelement_4_1",
    use_place = "obj_lantern_use_lanternelement_4_1",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
  local use_lanternelement_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_lanternelement_4_1" );
  
  end;
  local use_lanternelement_4_1_beg = function ()
  
    ObjDelete( "obj_lantern_use_lanternelement_4_1" );
  
  end;
  local use_lanternelement_4_1_end = function ()
  
    if ( cmn.IsEventDone("use_lanternelement_4_2") ) then
            
      ObjSet( "obj_lanter_stash_2", { input = 1 } );
      ObjSet( "spr_lantern_open_2", {alp = 1 })
      ObjDelete( "spr_lantern_doors_closed" );
      ObjSet( "spr_lantern_book_4_2", { input = true, active = true } );
      ObjDelete( "spr_balcony_lantern_note_1" );
      ObjDelete( "spr_balcony_lantern_note_2" );
      ObjSet( "spr_balcony_lantern_open_2", { alp = 1 } );
      
    else
      
      ObjSet( "spr_lantern_note_1", { alp = 1 } );
      ObjSet( "spr_balcony_lantern_note_1", { alp = 1 } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lanternelement_4_1", use_lanternelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_1", use_lanternelement_4_1_inv );
  cmn.AddSubscriber( "use_lanternelement_4_1", use_lanternelement_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_1_inv", use_lanternelement_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_1_beg", use_lanternelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_1_end", use_lanternelement_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lanternelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lanternelement_4_2" ] = {
    type = "use",
    inv_obj = "inv_lanternelement_4_2",
    use_place = "obj_lantern_use_lanternelement_4_2",
    room = private.room_objname,
    zz = "zz_lantern",
    zz_gate = "gzz_balcony_lantern"
  };
  local use_lanternelement_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lanternelement_4_2" );
  
  end;
  local use_lanternelement_4_2_beg = function ()
  
    ObjDelete( "obj_lantern_use_lanternelement_4_2" );
  
  end;
  local use_lanternelement_4_2_end = function ()
  
    if ( cmn.IsEventDone("use_lanternelement_4_1") ) then
      
      ObjSet( "obj_lanter_stash_2", { alp = 1, input = true } );
      ObjSet( "spr_lantern_book_4_2", { input = true, active = true } );
      ObjDelete( "spr_balcony_lantern_note_1" );
      ObjDelete( "spr_balcony_lantern_note_2" );
      ObjSet( "spr_balcony_lantern_open_2", { alp = 1 } );
      
    else
      
      ObjSet( "spr_lantern_note_2", { alp = 1 } );
      ObjSet( "spr_balcony_lantern_note_2", { alp = 1 } );
            
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lanternelement_4_2", use_lanternelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_2", use_lanternelement_4_2_inv );
  cmn.AddSubscriber( "use_lanternelement_4_2", use_lanternelement_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_2_inv", use_lanternelement_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_2_beg", use_lanternelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lanternelement_4_2_end", use_lanternelement_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4_4" ] = {
    type = "use",
    inv_obj = "inv_elf_4",
    use_place = "obj_pot_use_elf_4",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
  local use_elf_4_4_inv = function ()
  
  end;
  local use_elf_4_4_beg = function ()
  
    ObjDelete( "obj_pot_use_elf_4" );
  
  end;
  local use_elf_4_4_end = function ()
  
    ObjDelete( "vid_pot_use_elf" );
    ObjSet( "spr_pot_coin_4", { input = true,  active = true, alp = 1 } );
    ObjSet( "spr_balcony_pot_coin", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4_4", use_elf_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_4", use_elf_4_4_inv );
  cmn.AddSubscriber( "use_elf_4_4", use_elf_4_4_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_4_inv", use_elf_4_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_4_beg", use_elf_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_4_end", use_elf_4_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_potdetail () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_potdetail" ] = {
    type = "use",
    inv_obj = "inv_potdetail",
    use_place = "obj_pot_use_potdetail",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
  local use_potdetail_inv = function ()
  
    interface.InventoryItemRemove( "inv_potdetail" );
  
  end;
  local use_potdetail_beg = function ()
  
    ObjDelete( "obj_pot_use_potdetail" );
  
  end;
  local use_potdetail_end = function ()
  
    ObjSet( "spr_pot_potdetail", { alp = 1 } );
    ObjSet( "spr_pot_open", { alp = 1, input = true } );
    ObjSet( "spr_pot_doorelement_4_3", { input = true, active = true } );
    ObjSet( "spr_balcony_pot_potdetail", { alp = 1 } );
    ObjSet( "spr_balcony_pot_open", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_potdetail", use_potdetail_beg, private.room_objname );
  cmn.AddSubscriber( "use_potdetail", use_potdetail_inv );
  cmn.AddSubscriber( "use_potdetail", use_potdetail_end, private.room_objname );
  cmn.AddSubscriber( "use_potdetail_inv", use_potdetail_inv, private.room_objname );
  cmn.AddSubscriber( "use_potdetail_beg", use_potdetail_beg, private.room_objname );
  cmn.AddSubscriber( "use_potdetail_end", use_potdetail_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_reliefelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_reliefelement" ] = {
    type = "use",
    inv_obj = "inv_reliefelement",
    use_place = "obj_pot_use_reliefelement",
    room = private.room_objname,
    zz = "zz_pot",
    zz_gate = "gzz_balcony_pot"
  };
  local use_reliefelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_reliefelement" );
  
  end;
  local use_reliefelement_beg = function ()
  
    ObjDelete( "obj_pot_use_reliefelement" );
  
  end;
  local use_reliefelement_end = function ()
  
    ObjDelete( "spr_pot_cover" );
    ObjSet( "spr_pot_button_4", { input = true,  active = true } );
    ObjDelete( "spr_balcony_pot_over" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_reliefelement", use_reliefelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_reliefelement", use_reliefelement_inv );
  cmn.AddSubscriber( "use_reliefelement", use_reliefelement_end, private.room_objname );
  cmn.AddSubscriber( "use_reliefelement_inv", use_reliefelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_reliefelement_beg", use_reliefelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_reliefelement_end", use_reliefelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4_5" ] = {
    type = "use",
    inv_obj = "inv_elf_4",
    use_place = "obj_banister_use_elf_4",
    room = private.room_objname,
    zz = "zz_banister",
    zz_gate = "gzz_balcony_banister"
  };
  local use_elf_4_5_inv = function ()
  
  end;
  local use_elf_4_5_beg = function ()
  
    ObjDelete( "obj_banister_use_elf_4" );
  
  end;
  local use_elf_4_5_end = function ()
  
    ObjSet( "obj_banister_use_plank_4_1", { input = true } );
    ObjSet( "obj_banister_use_plank_4_2", { input = true } );
    ObjDelete( "anm_banister_birds");
    ObjDelete( "spr_balcony_banister_crow");
    ObjDelete( "vid_banister_elf");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4_5", use_elf_4_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_5", use_elf_4_5_inv );
  cmn.AddSubscriber( "use_elf_4_5", use_elf_4_5_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_5_inv", use_elf_4_5_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_5_beg", use_elf_4_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_5_end", use_elf_4_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plank_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plank_4_1" ] = {
    type = "use",
    inv_obj = "inv_plank_4_1",
    use_place = "obj_banister_use_plank_4_1",
    room = private.room_objname,
    zz = "zz_banister",
    zz_gate = "gzz_balcony_banister"
  };
  local use_plank_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_plank_4_1" );
  
  end;
  local use_plank_4_1_beg = function ()
  
    ObjDelete( "obj_banister_use_plank_4_1" );
  
  end;
  local use_plank_4_1_end = function ()
  
    ObjSet( "spr_banister_plank_1", { alp = 1 });
    ObjSet( "spr_balcony_banister_boards_1", { alp = 1 });
  
    if ( cmn.IsEventDone( "use_plank_4_2" ) ) then
      
      ObjSet( "gho_balcony_balconyroom", { input = true, active = true } ); 
      ObjDelete( "gzz_balcony_banister" );
      ObjSet( "spr_balcony_banister_boards", { alp = 1 });
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plank_4_1", use_plank_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_1", use_plank_4_1_inv );
  cmn.AddSubscriber( "use_plank_4_1", use_plank_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_1_inv", use_plank_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_1_beg", use_plank_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_1_end", use_plank_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plank_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plank_4_2" ] = {
    type = "use",
    inv_obj = "inv_plank_4_2",
    use_place = "obj_banister_use_plank_4_2",
    room = private.room_objname,
    zz = "zz_banister",
    zz_gate = "gzz_balcony_banister"
  };
  local use_plank_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_plank_4_2" );
  
  end;
  local use_plank_4_2_beg = function ()
  
    ObjDelete( "obj_banister_use_plank_4_2" );
  
  end;
  local use_plank_4_2_end = function ()
  
    ObjSet( "spr_banister_plank_2", { alp = 1 });
    ObjSet( "spr_balcony_banister_boards_2", { alp = 1 });
    
    if ( cmn.IsEventDone( "use_plank_4_1" ) ) then
      
      ObjSet( "gho_balcony_balconyroom", { input = true, active = true } ); 
      ObjDelete( "gzz_balcony_banister" );
      ObjSet( "spr_balcony_banister_boards", { alp = 1 });
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plank_4_2", use_plank_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_2", use_plank_4_2_inv );
  cmn.AddSubscriber( "use_plank_4_2", use_plank_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_2_inv", use_plank_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_2_beg", use_plank_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_plank_4_2_end", use_plank_4_2_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_balconyroom () end;
  --------------------------------------------------------------------------------------------
  local win_balconyroom = function ()

    if ( cmn.IsEventDone( "win_balconyroom" ) ) then

      ObjDelete( "gho_balcony_balconyroom" );

    end;

  end;

  cmn.AddSubscriber( "win_balconyroom", win_balconyroom, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_banister" );
  ---------------------------------------------------------------------------------------------
  function zz_banister.PreOpen()
    
    if not cmn.IsEventDone( "use_elf_4_5" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_balcony_crows_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_balcony_crows_loc_env", 0 );
    
    end;
     
  end; 
  ---------------------------------------------------------------------------------------------
  function zz_banister.PreClose()
    
    if not cmn.IsEventDone( "use_elf_4_5" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_balcony_crows_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_balcony_crows_zz_env", 0 );
    
    end;
     
  end;
  ---------------------------------------------------------------------------------------------
  function zz_banister.Close()
    
    if ( cmn.IsEventDone( "use_plank_4_1" ) and cmn.IsEventDone( "use_plank_4_2" ) ) then
      
      
      ObjSet( "tmr_balcony_gotoho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( "ho_balconyroom" ) end } );
      
    end;
     
  end; 
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_balcony();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_balcony_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "use_elf_4_5" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_balcony_crows_loc_env", 1, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_screwdriver_4_3()

  local item = "inv_screwdriver_4";

  if ( common.ApplyObj( item, "obj_lantern_use_screwdriver_4", true ) ) then

    cmn.CallEventHandler( "use_screwdriver_4_3_inv" );
    cmn.CallEventHandler( "use_screwdriver_4_3_beg" );

    local func_after = function ()
  
      local func_end = function ()
        
      common_impl.Lock( false );
      cmn.SetEventDone( "use_screwdriver_4_3" );
      cmn.CallEventHandler( "use_screwdriver_4_3_end" );
      
      end;
    --common.CloseSubRoom();;
        ObjAnimate( "spr_lantern_glass", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );
        ObjAnimate( "obj_lanter_stash_3", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_screwdriver_lantern", 0, "", 0 );
  

    VidPlay( "vid_lantern_use_screwdriver_4", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_lantern", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lantern", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_patternelement()

  local item = "inv_patternelement";

  if ( common.ApplyObj( item, "obj_lantern_use_patternelement", true ) ) then

    cmn.CallEventHandler( "use_patternelement_inv" );
    cmn.CallEventHandler( "use_patternelement_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_patternelement" );
      cmn.CallEventHandler( "use_patternelement_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_patternelement_lantern", 0, "", 0 );
  
    ObjAnimate( "spr_lantern_part", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_lanter_stash_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_lantern", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lantern", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lanternelement_4_1()

  local item = "inv_lanternelement_4_1";

  if ( common.ApplyObj( item, "obj_lantern_use_lanternelement_4_1", true ) ) then

    cmn.CallEventHandler( "use_lanternelement_4_1_inv" );
    cmn.CallEventHandler( "use_lanternelement_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lanternelement_4_1" );
      cmn.CallEventHandler( "use_lanternelement_4_1_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_lanternelement_lantern", 0, "", 0 );
    
    if cmn.IsEventDone( "use_lanternelement_4_1" ) then
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_lanternelement_lantern", 0, "", 0 );

      ObjAnimate( "spr_lantern_doors_closed", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1.0,
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );
      func_after = ""; --или проигрывание звука открывания

      ObjAnimate( "spr_lantern_open_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0,
        0.3, 0, 0.0,
        0.6, 0, 1.0
      } );
      
    end;
    
    ObjAnimate( "spr_lantern_note_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_lantern", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lantern", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lanternelement_4_2()

  local item = "inv_lanternelement_4_2";

  if ( common.ApplyObj( item, "obj_lantern_use_lanternelement_4_2", true ) ) then

    cmn.CallEventHandler( "use_lanternelement_4_2_inv" );
    cmn.CallEventHandler( "use_lanternelement_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lanternelement_4_2" );
      cmn.CallEventHandler( "use_lanternelement_4_2_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_lanternelement_lantern", 0, "", 0 );
  
    if cmn.IsEventDone( "use_lanternelement_4_1" ) then
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_lanternelement_lantern", 0, "", 0 );

      ObjAnimate( "spr_lantern_doors_closed", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1.0,
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );
      
      ObjAnimate( "spr_lantern_open_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0,
        0.3, 0, 0.0,
        0.6, 0, 1.0
      } );
      
      func_after = ""; --или проигрывание звука открывания

    end;
  
  
    ObjAnimate( "spr_lantern_note_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_lantern", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lantern", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4_4()

  local item = "inv_elf_4";

  if ( common.ApplyObj( item, "obj_pot_use_elf_4", true ) ) then

    cmn.CallEventHandler( "use_elf_4_4_inv" );
    cmn.CallEventHandler( "use_elf_4_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      ObjSet( "spr_pot_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_4", "spr_pot_elf", nil, "video" );
      cmn.SetEventDone( "use_elf_4_4" );
      cmn.CallEventHandler( "use_elf_4_4_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_pot_elf", 0, "", 0 );
    
    interface.InventoryItemRemove( "inv_elf_4" );
    VidPlay( "vid_pot_use_elf", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_pot", false ) and not cmn.IsEventDone( "use_elf_4_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pot", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_potdetail()

  local item = "inv_potdetail";

  if ( common.ApplyObj( item, "obj_pot_use_potdetail", true ) ) then

    cmn.CallEventHandler( "use_potdetail_inv" );
    cmn.CallEventHandler( "use_potdetail_beg" );

    local func_after = function ()
    
      local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_potdetail" );
        cmn.CallEventHandler( "use_potdetail_end" );
        
      end;
      
      ObjAnimate( "spr_pot_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
  
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_potdetail_pot", 0, "", 0 );
    
    ObjAnimate( "spr_pot_potdetail", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_pot", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pot", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_reliefelement()

  local item = "inv_reliefelement";

  if ( common.ApplyObj( item, "obj_pot_use_reliefelement", true ) ) then

    cmn.CallEventHandler( "use_reliefelement_inv" );
    cmn.CallEventHandler( "use_reliefelement_beg" );

    local func_after = function ()
    
      local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_reliefelement" );
        cmn.CallEventHandler( "use_reliefelement_end" );
        
      end;
      
      ObjAnimate( "spr_pot_cover", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0, -67, 158, 
        0.5, 0, -77, 345
      } );
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_reliefelement_lantern", 0, "", 0 );
  
  ObjAnimate( "spr_pot_reliefelement", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
    0.6, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_pot", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pot", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4_5()

  local item = "inv_elf_4";

  if ( common.ApplyObj( item, "obj_banister_use_elf_4", true ) ) then

    cmn.CallEventHandler( "use_elf_4_5_inv" );
    cmn.CallEventHandler( "use_elf_4_5_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_4_5" );
      cmn.CallEventHandler( "use_elf_4_5_end" );
      ObjSet( "spr_banister_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_4", "spr_banister_elf", nil, "video" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_banister_elf", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/levelext/aud_balcony_crows_zz_env", 0 );
    
    interface.InventoryItemRemove( "inv_elf_4" );
    ObjSet( "anm_banister_birds", { alp = 0 });
    ObjSet( "vid_banister_elf", { alp = 1 });
    VidPlay( "vid_banister_elf", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_banister", false ) and not cmn.IsEventDone( "use_elf_4_5" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_banister", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_plank_4_1()

  local item = "inv_plank_4_1";

  if ( common.ApplyObj( item, "obj_banister_use_plank_4_1", true ) and cmn.IsEventDone( "use_elf_4_5" ) ) then

    cmn.CallEventHandler( "use_plank_4_1_inv" );
    cmn.CallEventHandler( "use_plank_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_plank_4_1" );
      cmn.CallEventHandler( "use_plank_4_1_end" );
      
      if ( cmn.IsEventDone( "use_plank_4_2" ) ) then
      
        common.CloseSubRoom(); 
        
      end;

  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_plank_banister", 0, "", 0 );
  
    ObjAnimate( "spr_banister_plank_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_banister", false ) and cmn.IsEventDone( "use_elf_4_5" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_banister", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_plank_4_2()

  local item = "inv_plank_4_2";

  if ( common.ApplyObj( item, "obj_banister_use_plank_4_2", true ) and cmn.IsEventDone( "use_elf_4_5" ) ) then

    cmn.CallEventHandler( "use_plank_4_2_inv" );
    cmn.CallEventHandler( "use_plank_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_plank_4_2" );
      cmn.CallEventHandler( "use_plank_4_2_end" );
      
      if ( cmn.IsEventDone( "use_plank_4_1" ) ) then
      
        common.CloseSubRoom(); 
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_plank_banister", 0, "", 0 );
  
    ObjAnimate( "spr_banister_plank_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_balcony_banister", false ) and cmn.IsEventDone( "use_elf_4_5" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_banister", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_secretsign()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_secretsign" );
  cmn.CallEventHandler( "get_secretsign" );

end;
--------------------------------------------------------------------------------------------
function private.get_doorelement_4_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_doorelement_4_4" );
  cmn.CallEventHandler( "get_doorelement_4_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_book_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_book_4_2" );
  cmn.CallEventHandler( "get_book_4_2" );
  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_coin_4" );
  cmn.CallEventHandler( "get_coin_4" );
  
  if( cmn.IsEventDone( "get_doorelement_4_3" ) and cmn.IsEventDone( "get_button_4" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ) )then
      
    common.CloseSubRoom(); 
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_doorelement_4_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_doorelement_4_3" );
  cmn.CallEventHandler( "get_doorelement_4_3" );
  
  if( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_button_4" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ))then
      
    common.CloseSubRoom(); 
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_button_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_4" );
  cmn.CallEventHandler( "get_button_4" );

  if( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_doorelement_4_3" ) and common_impl.IsGetCollect( "get_collect_2_4_7" ) )then
      
    common.CloseSubRoom(); 
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_4_7()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_7");
    cmn.CallEventHandler("get_collect_2_4_7");
    
    if ( cmn.IsEventDone( "get_coin_4" ) and cmn.IsEventDone( "get_doorelement_4_3" ) and cmn.IsEventDone( "get_button_4" )) then
    
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.PlayEffectHO( "spr_pot_collect_2", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_4_5()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_5");
    cmn.CallEventHandler("get_collect_2_4_5");
    
    if  cmn.IsEventDone( "get_book_4_2" ) then
    
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.PlayEffectHO( "spr_lantern_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_balcony()

  if not ( cmn.IsEventDone( "opn_balcony" ) ) then
    cmn.SetEventDone( "opn_balcony" );
  end;
  
  cmn.CallEventHandler( "opn_balcony" ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_stash_2_door()
  
  local func_after = function ()
  
    common_impl.Lock( false );
    
  end;

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_lantern_use_lanternelement_4_1' );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/clk_doors_closed", 0, "", 0 );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_doors_lantern", 0, "", 0 );
  
  ObjAnimate( "spr_lantern_doors_closed", "scale_xy", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 1.0,
      0.3, 0, 1.01, 1.01,
      0.4, 0, 1.0, 1.0
    } );
  
end;
--*********************************************************************************************************************

ObjAnimate( "spr_balcony_lamp_1", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_balcony_lamp_2", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.5, 3,0,1 } );
ObjAnimate( "spr_balcony_lamp_3", "alp", 1, 0, "", { 0,0,1, 2.5,0,0.5, 5,0,1 } );
ObjAnimate( "spr_banister_light_add", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.0, 3,0,1 } );
ObjAnimate( "spr_lantern_light_1_add", "alp", 1, 0, "", { 0,0,1, 3.5,0,0.5, 7,0,1 } );
ObjAnimate( "spr_lantern_light_2_add", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.7, 3,0,1 } );
