-- name=rm_behindstage
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_behindstage";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_boardeddoor", "room_hub" );
  ObjAttach( "zz_floor_4", "room_hub" );
  ObjAttach( "zz_foldingtable", "room_hub" );
  ObjAttach( "zz_corridordoor", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_boardeddoor_bucket_4", { event_mdown = private.get_bucket_4 }},
  { "spr_floor_4_glue_4", { event_mdown = private.get_glue_4 }},
  { "spr_foldingtable_cofferelement_4_1", { event_mdown = private.get_cofferelement_4_1 }},
  { "spr_foldingtable_hairpin_4", { event_mdown = private.get_hairpin_4 }},
  { "spr_foldingtable_statuefragment_4", { event_mdown = private.get_statuefragment_4 }},
  { "spr_corridordoor_cofferelement_4_2", { event_mdown = private.get_cofferelement_4_2 }},
  { "obj_corridordoor_clk_corridorkey", { event_mdown = private.clk_corridorkey }},
  { "obj_foldingtable_use_boxamulet_4", { event_mdown = private.clk_smallbox }},
  { "obj_floor_4_clk_door", { event_mdown = private.clk_floor_4_door }},
  { "obj_floor_4_use_ring_4", { event_mdown = private.clk_floor_4_door }},
  { "obj_boardeddoor_use_ax_4", { event_mdown = private.clk_boardeddoor }},
  { "spr_foldingtable_collect_2", { event_mdown = function () private.get_collect_2_4_1(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_boardeddoor_note",             { event_mdown = function () common_impl.NoteScale( "open", "spr_boardeddoor_note" );common_impl.ShowBbt( 'bbt_boardeddoor_note', 1 ); end }},    
  { "spr_boardeddoor_note_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_boardeddoor_note" ); end } },
  { "spr_behindstage_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_behindstage_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_behindstage = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_behindstage_pharmacy",
    "gho_behindstage_warehouse",
    "gzz_behindstage_boardeddoor",
    "gzz_behindstage_floor_4",
    "gzz_behindstage_foldingtable",
    "gzz_behindstage_corridordoor"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_boardeddoor",
    "zz_floor_4",
    "zz_foldingtable",
    "zz_corridordoor"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_behindstage", update_game_mode_behindstage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_behindstage = function ()

  local effects_table = 
  {
    "obj_behindstage_anim",
    "spr_boardeddoor_light_add",
    "anm_foldingtable_strap"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_behindstage", update_performance_mode_behindstage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_behindstage () end;
  --------------------------------------------------------------------------------------------
  local opn_behindstage_map = function ()

    common_impl.VisitMapRoom( "behindstage" );

  end;
  cmn.AddSubscriber( "opn_behindstage", opn_behindstage_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_bucket_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bucket_4" ] = {
    type = "get",
    get_obj = "spr_boardeddoor_bucket_4",
    room = private.room_objname,
    zz = "zz_boardeddoor",
    zz_gate = "gzz_behindstage_boardeddoor"
  };
    
  local get_bucket_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_bucket_4", "spr_boardeddoor_bucket_4" );
  
  end;
  
  local get_bucket_4_closezz = function ()
  
    ObjDelete( "gfx_boardeddoor_bucket_4" );
    ObjDelete( "spr_boardeddoor_bucket_shadow");
    ObjDelete( "spr_behindstage_boardeddoor_bucket" );
    ObjSet( "obj_boardeddoor_use_ax_4", {input = true});
    
  end;
  
  cmn.AddSubscriber( "get_bucket_4", get_bucket_4_inv );
  cmn.AddSubscriber( "get_bucket_4", get_bucket_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glue_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glue_4" ] = {
    type = "get",
    get_obj = "spr_floor_4_glue_4",
    room = private.room_objname,
    zz = "zz_floor_4",
    zz_gate = "gzz_behindstage_floor_4"
  };
    
  local get_glue_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_glue_4", "spr_floor_4_glue_4" );
    ObjSet( "spr_micholder_plus_light", { alp = 1 } );
    
  end;
  
  local get_glue_4_closezz = function ()
  
    ObjDelete( "gfx_floor_4_glue_4" );
    ObjDelete( "spr_floor_4_glue_shadow" );
    ObjSet( "obj_floor_4_use_ring_4", { input = true } );
    ObjDelete( "spr_behindstage_floor_4_glue" );
  
  end;
  
  cmn.AddSubscriber( "get_glue_4", get_glue_4_inv );
  cmn.AddSubscriber( "get_glue_4", get_glue_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cofferelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cofferelement_4_1" ] = {
    type = "get",
    get_obj = "spr_foldingtable_cofferelement_4_1",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
    
  local get_cofferelement_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_cofferelement_4_1", "spr_foldingtable_cofferelement_4_1" );
  
  end;
  
  local get_cofferelement_4_1_closezz = function ()
  
    ObjDelete( "gfx_foldingtable_cofferelement_4_1" );
    ObjDelete( "spr_foldingtable_cofferelement_4_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_cofferelement_4_1", get_cofferelement_4_1_inv );
  cmn.AddSubscriber( "get_cofferelement_4_1", get_cofferelement_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hairpin_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hairpin_4" ] = {
    type = "get",
    get_obj = "spr_foldingtable_hairpin_4",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
    
  local get_hairpin_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_hairpin_4", "spr_foldingtable_hairpin_4" );
  
  end;
  
  local get_hairpin_4_closezz = function ()
  
    ObjDelete( "gfx_foldingtable_hairpin_4" );
    --ObjDelete( "gzz_behindstage_foldingtable" );
  
  end;
  
  cmn.AddSubscriber( "get_hairpin_4", get_hairpin_4_inv );
  cmn.AddSubscriber( "get_hairpin_4", get_hairpin_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuefragment_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statuefragment_4" ] = {
    type = "get",
    get_obj = "spr_foldingtable_statuefragment_4",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
    
  local get_statuefragment_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_statuefragment_4", "spr_foldingtable_statuefragment_4" );
  
  end;
  
  local get_statuefragment_4_closezz = function ()
  
    ObjDelete( "gfx_foldingtable_statuefragment_4" );
    
    if common_impl.IsGetCollect( "get_collect_2_4_1" ) then
      
      ObjDelete( "gzz_behindstage_foldingtable" );
      
    end;   
  
  end;
  
  cmn.AddSubscriber( "get_statuefragment_4", get_statuefragment_4_inv );
  cmn.AddSubscriber( "get_statuefragment_4", get_statuefragment_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cofferelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cofferelement_4_2" ] = {
    type = "get",
    get_obj = "spr_corridordoor_cofferelement_4_2",
    room = private.room_objname,
    zz = "zz_corridordoor",
    zz_gate = "gzz_behindstage_corridordoor"
  };
    
  local get_cofferelement_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_cofferelement_4_2", "spr_corridordoor_cofferelement_4_2" );
  
  end;
  
  local get_cofferelement_4_2_closezz = function ()
  
    ObjDelete( "gfx_corridordoor_cofferelement_4_2" );
    ObjDelete( "spr_corridordoor_cofferelement_4_2_shadow" );
    ObjSet( "obj_corridordoor_use_corridorkey_4", { input = true } );
    ObjDelete( "spr_behindstage_corridordoor_element" );
  
  end;
  
  cmn.AddSubscriber( "get_cofferelement_4_2", get_cofferelement_4_2_inv );
  cmn.AddSubscriber( "get_cofferelement_4_2", get_cofferelement_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_4" ] = {
    type = "get",
    get_obj = "anm_behindstage_ectoplasm_4_4",
    room = private.room_objname,
    zz = "zz_behindstage",
    zz_gate = "gzz_behindstage_behindstage"
  };
    
  local get_ectoplasm_4_4_inv = function ()

    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_behindstage_ectoplasm_4_4", function() 
      common.BlockGotoRoom(true); 
      common_impl.Lock( false );
    end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_4_closezz = function ()
  
    ObjDelete( "gfx_behindstage_ectoplasm" );
    --ObjDelete( "gzz_behindstage_behindstage" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_4", get_ectoplasm_4_4_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_4", get_ectoplasm_4_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_2 = function ()
  
    ObjDelete( "obj_behindstage_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_2", get_collect_morph_item_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_1 = function ()
  
    ObjDelete( "obj_behindstage_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_1", get_collect_item_4_1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_1 = function ()
  
    ObjDelete( "spr_foldingtable_collect_2" );
    
    if cmn.IsEventDone( "get_statuefragment_4") then
    
      ObjDelete("gzz_behindstage_foldingtable");
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_1", get_collect_2_4_1 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ax_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ax_4" ] = {
    type = "use",
    inv_obj = "inv_ax_4",
    use_place = "obj_boardeddoor_use_ax_4",
    room = private.room_objname,
    zz = "zz_boardeddoor",
    zz_gate = "gzz_behindstage_boardeddoor"
  };
  local use_ax_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_ax_4" );
  
  end;
  local use_ax_4_beg = function ()
  
    ObjDelete( "obj_boardeddoor_use_ax_4" );
    ObjDelete( "anm_boardeddoor_boards" );
  
  end;
  local use_ax_4_end = function ()
  
    ObjDelete( "gzz_behindstage_boardeddoor" );
    ObjSet( "grm_behindstage_smallroom_4", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_behindstage_smallroom_4_focus");
    end;
    ObjDelete( "obj_boardeddoor_boards");
    ObjDelete( "spr_behindstage_boardeddoor_boards" );
    ObjSet( "spr_behindstage_boardeddoor_door_open", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ax_4", use_ax_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ax_4", use_ax_4_inv );
  cmn.AddSubscriber( "use_ax_4", use_ax_4_end, private.room_objname );
  cmn.AddSubscriber( "use_ax_4_inv", use_ax_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ax_4_beg", use_ax_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ax_4_end", use_ax_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring_4" ] = {
    type = "use",
    inv_obj = "inv_ring_4",
    use_place = "obj_floor_4_use_ring_4",
    room = private.room_objname,
    zz = "zz_floor_4",
    zz_gate = "gzz_behindstage_floor_4"
  };
  local use_ring_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring_4" );
  
  end;
  local use_ring_4_beg = function ()
  
    ObjDelete( "obj_floor_4_use_ring_4" );
  
  end;
  local use_ring_4_end = function ()
  
    ObjSet( "obj_floor_4_ring", { alp = 1 } );
    ObjSet( "obj_floor_4_clk_door", {input = true });
    ObjSet( "spr_behindstage_floor_4_knob", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring_4", use_ring_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_4", use_ring_4_inv );
  cmn.AddSubscriber( "use_ring_4", use_ring_4_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_inv", use_ring_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_beg", use_ring_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_end", use_ring_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shard" ] = {
    type = "use",
    inv_obj = "inv_shard",
    use_place = "obj_foldingtable_use_shard",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
  local use_shard_inv = function ()
  
    interface.InventoryItemRemove( "inv_shard" );
  
  end;
  local use_shard_beg = function ()
  
    ObjDelete( "obj_foldingtable_use_shard" );
  
  end;
  local use_shard_end = function ()
  
    ObjSet( "gho_behindstage_pharmacy", { input = true, active = true, alp = 1 } );
    ObjSet( "gzz_behindstage_foldingtable", { input = false, active = false, alp = 0});
    ObjDelete( "obj_foldingtable_bag_close");
    ObjSet( "spr_foldingtable_bag_open", {alp = 1} );
    ObjDelete("anm_foldingtable_use_shard");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shard", use_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard", use_shard_inv );
  cmn.AddSubscriber( "use_shard", use_shard_end, private.room_objname );
  cmn.AddSubscriber( "use_shard_inv", use_shard_inv, private.room_objname );
  cmn.AddSubscriber( "use_shard_beg", use_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard_end", use_shard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boxamulet_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boxamulet_4" ] = {
    type = "use",
    inv_obj = "inv_boxamulet_4",
    use_place = "obj_foldingtable_use_boxamulet_4",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
  local use_boxamulet_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxamulet_4" );
  
  end;
  local use_boxamulet_4_beg = function ()
  
    ObjDelete( "obj_foldingtable_use_boxamulet_4" );
  
  end;
  local use_boxamulet_4_end = function ()
  
    ObjSet( "spr_foldingtable_hairpin_4", { input = true, active = true } );
    ObjSet( "spr_foldingtable_open", { alp = 1 });
    ObjDelete( "spr_foldingtable_close");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxamulet_4", use_boxamulet_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxamulet_4", use_boxamulet_4_inv );
  cmn.AddSubscriber( "use_boxamulet_4", use_boxamulet_4_end, private.room_objname );
  cmn.AddSubscriber( "use_boxamulet_4_inv", use_boxamulet_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxamulet_4_beg", use_boxamulet_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxamulet_4_end", use_boxamulet_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers_4" ] = {
    type = "use",
    inv_obj = "inv_tweezers_4",
    use_place = "obj_foldingtable_use_tweezers_4",
    room = private.room_objname,
    zz = "zz_foldingtable",
    zz_gate = "gzz_behindstage_foldingtable"
  };
  local use_tweezers_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers_4" );
  
  end;
  local use_tweezers_4_beg = function ()
  
    ObjDelete( "obj_foldingtable_use_tweezers_4" );
  
  end;
  local use_tweezers_4_end = function ()
  
    ObjSet( "spr_foldingtable_statuefragment_4", { input = true, active = true, alp = 1 } );
    ObjDelete( "anm_foldingtable_use_tweesers");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_inv );
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_inv", use_tweezers_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_beg", use_tweezers_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_end", use_tweezers_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corridorkey_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corridorkey_4" ] = {
    type = "use",
    inv_obj = "inv_corridorkey_4",
    use_place = "obj_corridordoor_use_corridorkey_4",
    room = private.room_objname,
    zz = "zz_corridordoor",
    zz_gate = "gzz_behindstage_corridordoor"
  };
  local use_corridorkey_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_corridorkey_4" );
  
  end;
  local use_corridorkey_4_beg = function ()
  
    ObjDelete( "obj_corridordoor_use_corridorkey_4" );
  
  end;
  local use_corridorkey_4_end = function ()
  
    ObjSet( "obj_corridordoor_clk_corridorkey", { input = true } );
    ObjSet( "spr_corridordoor_key_1", { alp = 1 } );
    ObjSet( "spr_behindstage_corridordoor_key", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corridorkey_4", use_corridorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_corridorkey_4", use_corridorkey_4_inv );
  cmn.AddSubscriber( "use_corridorkey_4", use_corridorkey_4_end, private.room_objname );
  cmn.AddSubscriber( "use_corridorkey_4_inv", use_corridorkey_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_corridorkey_4_beg", use_corridorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_corridorkey_4_end", use_corridorkey_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_4" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname
  };
  local use_searcher_4_4_inv = function ()

    if ( levelext_inv.IsUseAllSearchers( 4 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;

  end;
  local use_searcher_4_4_beg = function ()
  
    
  
  end;
  local use_searcher_4_4_end = function ()
 
    ObjDelete( "obj_behindstage_use_searcher" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_4", use_searcher_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_4", use_searcher_4_4_inv );
  cmn.AddSubscriber( "use_searcher_4_4", use_searcher_4_4_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_4_inv", use_searcher_4_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_4_beg", use_searcher_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_4_end", use_searcher_4_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_behindstage_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_behindstage_door" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_behindstage_door",
    
  };
  local vid_behindstage_door_end = function ()
  
    ObjDelete( "anm_behindstage_door" ); 
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_behindstage_door", vid_behindstage_door_end, private.room_objname  );
  cmn.AddSubscriber( "vid_behindstage_door_end", vid_behindstage_door_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_corridorkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_corridorkey" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_corridordoor_clk_corridorkey",
    zz = "zz_corridordoor",
    zz_gate = "gzz_behindstage_corridordoor"
  };
  local clk_corridorkey = function ()
  
    ObjSet( "grm_behindstage_corridor_4", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_behindstage_corridor_4_focus");
    end;
    ObjDelete( "obj_corridordoor_clk_corridorkey" );
    ObjDelete( "gzz_behindstage_corridordoor" );
    ObjDelete( "spr_behindstage_corridordoor_key" );
    ObjSet( "spr_behindstage_corridordoor_door_op", { alp = 1 } );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_corridorkey", clk_corridorkey, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_floor_4_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_floor_4_door" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_floor_4_clk_door",
    zz = "zz_floor_4",
    zz_gate = "gzz_behindstage_floor_4"
  };
  local clk_floor_4_door = function ()
  
    ObjDelete( "gzz_behindstage_floor_4" );
    ObjSet( "gho_behindstage_warehouse", { input = true, active = true, alp = 1 } );
    ObjDelete( "obj_floor_4_clk_door" );
    ObjDelete( "spr_behindstage_floor_4_door" );
    ObjSet( "spr_behindstage_floor_4_door_op", { alp = 1 } );
    ObjDelete( "spr_behindstage_floor_4_knob" );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floor_4_door", clk_floor_4_door, private.room_objname  );
  
  --------------------------------------------------------------------------------------------
  -- function win_pharmacy () end;
  --------------------------------------------------------------------------------------------
  local win_pharmacy = function ()

    if ( cmn.IsEventDone( "win_pharmacy" ) ) then

      ObjDelete( "gho_behindstage_pharmacy" );
      ObjDelete( "spr_foldingtable_bag_open");
      ObjSet("spr_foldingtable_bag_open_2", { alp = 1 });

    end;

  end;

  cmn.AddSubscriber( "win_pharmacy", win_pharmacy, private.room_objname ); 
  
  --------------------------------------------------------------------------------------------
  -- function win_warehouse () end;
  --------------------------------------------------------------------------------------------
  local win_warehouse = function ()

    if ( cmn.IsEventDone( "win_warehouse" ) ) then

      ObjDelete( "gho_behindstage_warehouse" );

    end;

  end;

  cmn.AddSubscriber( "win_warehouse", win_warehouse, private.room_objname );
    
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_foldingtable" );
  ------------------------------------------------------------------------------
  function zz_foldingtable.Close()
    
    if ( cmn.IsEventDone("use_shard") and not cmn.IsEventDone("win_pharmacy") ) then

      ObjSet( "tmr_behindstage_goho", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'ho_pharmacy' ) end } );
      
    end;
    
  end;
  ------------------------------------------------------------------------------
  function zz_foldingtable.Open()
    
    if cmn.IsEventDone( "win_pharmacy" ) and not ng_global.progress["ext"]["opn_behindstage"].opn_zz then  
      
      ng_global.progress["ext"]["opn_behindstage"].opn_zz = true;
      
    end;
    
  end;

   subroom.Define( "zz_boardeddoor" );
  --------------------------------------------------------------------------------------------
  function zz_boardeddoor.PreOpen()

    if not common_impl.boardeddoor then

      common_impl.boardeddoor = {}
      common_impl.boardeddoor.note = "close";

    end;

    if  ObjGet( "spr_boardeddoor_note" ).input == true then

      ObjSet( "spr_boardeddoor_note_big", { input = false, alp = 0 } );
      ObjSet( "spr_boardeddoor_note",     { alp = 1 } );
      
    end;

  end;
  
  --------------------------------------------------------------------------------------------
  
  function zz_boardeddoor.Close()

    common_impl.boardeddoor.note = "close"; 

  end; 
    
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_behindstage();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
 
  if ( not cmn.IsEventDone( "vid_behindstage_door" ) ) then

    ObjSet( "tmr_behindstage_door",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_behindstage_door(); end
    } );
      
  end;
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  if cmn.IsEventDone("win_pharmacy") and not ng_global.progress["ext"]["opn_behindstage"].opn_zz then
    
    local posxy = { ObjGet("gzz_behindstage_foldingtable").pos_x, ObjGet("gzz_behindstage_foldingtable").pos_y }; 
    cmn.GotoSubRoom( "zz_foldingtable", posxy , { 512, 384 }, true );
    
  end;  
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_behindstage_env" }, "", 0.5 );
    
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ax_4()

  local item = "inv_ax_4";

  if ( common.ApplyObj( item, "obj_boardeddoor_use_ax_4", true )) and cmn.IsEventDone( "get_bucket_4" ) and common_impl.boardeddoor.note == "close" then

    cmn.CallEventHandler( "use_ax_4_inv" );
    cmn.CallEventHandler( "use_ax_4_beg" );
    
   local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_ax_4" );
      cmn.CallEventHandler( "use_ax_4_end" );
      common.CloseSubRoom();
      
    end; 
  
  common_impl.Lock( true );

  ObjSet( "anm_boardeddoor_axe", {alp=1} );
  ObjSet( "spr_boardeddoor_note", {alp=0} );

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_ax_boardeddoor", 0, "", 0 );
  AnimPlay( "anm_boardeddoor_axe", "DoAnim", func_after );
 
  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_boardeddoor", false ) and cmn.IsEventDone( "get_bucket_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boardeddoor", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ring_4()

  local item = "inv_ring_4";

  if ( common.ApplyObj( item, "obj_floor_4_use_ring_4", true ) and cmn.IsEventDone( "get_glue_4" ) ) then

    cmn.CallEventHandler( "use_ring_4_inv" );
    cmn.CallEventHandler( "use_ring_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ring_4" );
      cmn.CallEventHandler( "use_ring_4_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_ring_floor_4", 0, "", 0 );
  
    ObjAnimate( "obj_floor_4_ring", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_floor_4", false ) and cmn.IsEventDone( "get_glue_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floor_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shard()

  local item = "inv_shard";

  if ( common.ApplyObj( item, "obj_foldingtable_use_shard", true ) ) then

    cmn.CallEventHandler( "use_shard_inv" );
    cmn.CallEventHandler( "use_shard_beg" );

    local func_after = function ()
    
    -- local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_shard" );
        cmn.CallEventHandler( "use_shard_end" );
        common.CloseSubRoom();
        
      end;
  
      

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_shard_foldingtable", 0, "", 0 );
  AnimPlay("anm_foldingtable_use_shard", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_foldingtable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foldingtable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_boxamulet_4()

  local item = "inv_boxamulet_4";

  if ( common.ApplyObj( item, "obj_foldingtable_use_boxamulet_4", true ) ) then

    cmn.CallEventHandler( "use_boxamulet_4_inv" );
    cmn.CallEventHandler( "use_boxamulet_4_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_boxamulet_4" );
        cmn.CallEventHandler( "use_boxamulet_4_end" );
      
    --common.CloseSubRoom();;
      end;
    
      ObjAnimate( "spr_foldingtable_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_foldingtable_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
       
  
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_boxamulet_foldingtable", 0, "", 0 );
  
    ObjAnimate( "spr_foldingtable_amulet", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_foldingtable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foldingtable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers_4()

  local item = "inv_tweezers_4";

  if ( common.ApplyObj( item, "obj_foldingtable_use_tweezers_4", true ) ) then

    cmn.CallEventHandler( "use_tweezers_4_inv" );
    cmn.CallEventHandler( "use_tweezers_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tweezers_4" );
      cmn.CallEventHandler( "use_tweezers_4_end" );
    --common.CloseSubRoom();;
      
    
  end;

  common_impl.Lock( true );
  --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_tweezers_foldingtable", 0, "", 0 );
  

    AnimPlay( "anm_foldingtable_use_tweesers", "DoAnim", func_after );

  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_foldingtable", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foldingtable", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_corridorkey_4()

  local item = "inv_corridorkey_4";

  if ( common.ApplyObj( item, "obj_corridordoor_use_corridorkey_4", true ) and cmn.IsEventDone( "get_cofferelement_4_2" ) ) then

    cmn.CallEventHandler( "use_corridorkey_4_inv" );
    cmn.CallEventHandler( "use_corridorkey_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_corridorkey_4" );
      cmn.CallEventHandler( "use_corridorkey_4_end" );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_corridorkey_corridordoor", 0, "", 0 );
  
    ObjAnimate( "spr_corridordoor_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_behindstage_corridordoor", false ) and cmn.IsEventDone( "get_cofferelement_4_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_corridordoor", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_4( func )

  cmn.CallEventHandler( "use_searcher_4_4_beg" );

  local func_after = function ()

    --common_impl.Lock( false );
    cmn.SetEventDone( "use_searcher_4_4" );
    cmn.CallEventHandler( "use_searcher_4_4_end" );
    private.get_ectoplasm_4_4();
    
    local delayfunc = function ()

      --common_impl.Lock( false );
      func();
      --cmn.CallEventHandler( "use_searcher_4_4_inv" );

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );
  
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );
    
  ObjSet( "anm_behindstage_ectoplasm_4_4", { visible = true, active = true, playing = true, endtrig = func_after } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bucket_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bucket_4" );
  cmn.CallEventHandler( "get_bucket_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_glue_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_glue_4" );
  cmn.CallEventHandler( "get_glue_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_cofferelement_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cofferelement_4_1" );
  cmn.CallEventHandler( "get_cofferelement_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_hairpin_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hairpin_4" );
  cmn.CallEventHandler( "get_hairpin_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_statuefragment_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_statuefragment_4" );
  cmn.CallEventHandler( "get_statuefragment_4" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_cofferelement_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cofferelement_4_2" );
  cmn.CallEventHandler( "get_cofferelement_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_4" );
  cmn.CallEventHandler( "get_ectoplasm_4_4" );

end;
-------------------------------------------------------------------------------------------
function private.get_collect_2_4_1()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_1");
    cmn.CallEventHandler("get_collect_2_4_1");
    
    if cmn.IsEventDone( "get_statuefragment_4") then
    
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.PlayEffectHO( "spr_foldingtable_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_corridorkey()
    
    local func_after = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_corridorkey" );
      cmn.CallEventHandler( "clk_corridorkey" );
      common.CloseSubRoom();

    end;
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_corridorkey_corridordoor", 0, "", 0 );
    
    ObjAnimate( "spr_corridordoor_key_1", "alp", 0, 0, "",
    { 
    0.0, 0, 1.0,
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_corridordoor_key_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
      0.8, 0, 1.0,
      1.0, 0, 0.0
    } );
    ObjAnimate( "spr_corridordoor_doorhandle", "ang", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,
      0.6, 0, -0.25 
    } );
    ObjAnimate( "spr_corridordoor_opendoor", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.8, 0, 0.0,
      1.1, 0, 1.0
    } );
    
end;
--------------------------------------------------------------------------------
function private.clk_smallbox()
  
  local func_after = function()

      common_impl.Lock( false );
    
  end;
    
  common_impl.Lock( true ); 
  common_impl.ShowBbt( 'bbt_foldingtable_use_boxamulet_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_smallbox_foldingtable", 0, "", 0 );
  
  ObjAnimate( "spr_foldingtable_close", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, -107,
    0.3, 0, -106,
    0.6, 0, -107
  } );
  

end;  
--------------------------------------------------------------------------------
function private.clk_boardeddoor()
  
  local func_after = function()

      common_impl.Lock( false );
    
  end;
    
  common_impl.Lock( true ); 
  common_impl.ShowBbt( 'bbt_boardeddoor_use_ax_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_doors_boardeddoor", 0, "", 0 );
  
  AnimPlay( "anm_boardeddoor_boards", "DoAnim", func_after );

  ObjAnimate( "spr_boardeddoor_note", "pos_y", 0, 0, "",
  { 
    0.0, 0, -114,
    0.2333, 0, -112,
    0.4667, 0, -114
  } );
  
end;  
--------------------------------------------------------------------------------
function private.clk_floor_4_door()
  
  if not cmn.IsEventDone( "use_ring_4" ) then
  
    local step = 2;
    local func_after = function()

        common_impl.Lock( false );
      
    end;
      
    common_impl.Lock( true ); 
    common_impl.ShowBbt( 'bbt_floor_4_use_ring_4' );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_floor_4", 0, "", 0 );
    
    ObjAnimate( "obj_floor_4_over", "pos_y", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, -2,
      0.6, 0, 0
    } );
    ObjAnimate( "spr_floor_4_door", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, 0,
      0.3, 0, -2,
      0.6, 0, 0
    } );
    ObjAnimate( "spr_floor_4_glue_4", "pos_y", 0, 0, "",
    { 
      0.0, 0, -4,
      0.3, 0, -6,
      0.6, 0, -4
    } );
   
    
    
  else
    
    local func_after = function()
    
      cmn.SetEventDone( "clk_floor_4_door" );
      cmn.CallEventHandler( "clk_floor_4_door" );
      common_impl.Lock( false );
      common.CloseSubRoom();
      
    end;
    common_impl.Lock( true );     
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_ring_floor_4", 0, "", 0 );
  
    ObjAnimate( "spr_floor_4_door", "alp", 0, 0, "",
    { 
    0.0, 0, 1,
    0.3, 0, 0
    } );
    ObjAnimate( "obj_floor_4_over", "alp", 0, 0, "",
    { 
    0.0, 0, 1,
    0.3, 0, 0
    } );
    ObjAnimate( "spr_floor_4_door_opened", "alp", 0, 0, func_after,
    { 
    0.0, 0, 0,
    0.3, 0, 1
    } );
    
  end;

end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_behindstage()

  if not ( cmn.IsEventDone( "opn_behindstage" ) ) then
    
    cmn.SetEventDone( "opn_behindstage" );
    ng_global.progress["ext"]["opn_behindstage"].opn_zz = false;
    
  end;
  
  cmn.CallEventHandler( "opn_behindstage" ); 

end;
--*********************************************************************************************************************
function private.vid_behindstage_door()

  local func_after = function ()
  
    common_impl.Lock( false ); 
    cmn.SetEventDone( "vid_behindstage_door" );
    cmn.CallEventHandler( "vid_behindstage_door_end" );
    common_impl.ShowBbt( 'bbt_vid_behindstage_door', 1 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();
  common_impl.Lock( true ); 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_anm_door_ghost", 0, "", 0 );
  ObjSet( "anm_behindstage_door", { pos_z = 12 });
  AnimPlay( "anm_behindstage_door", "DoAnim", func_after );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_corridordoor_light", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0,
  1.0, 0, 0.6,
  2.0, 0, 1.0
} );
 ObjAnimate( "spr_boardeddoor_light_add", "alp", 1, 0, "",
{ 
  0.0, 0, 1.0,
  1.0, 0, 0.6,
  2.0, 0, 1.0
} );
ObjAnimate("spr_behindstage_lamp_1", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate("spr_behindstage_lamp_2", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.9, 0, 0.5,
  1.8, 0, 1.0
});
ObjAnimate("spr_behindstage_lamp_3", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.5, 0, 0.5,
  1.0, 0, 1.0
});
    