-- name=rm_corridor_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_box_4", "room_hub" );
  ObjAttach( "zz_computer", "room_hub" );
  ObjAttach( "zz_grid_4", "room_hub" );
  ObjAttach( "zz_sofa", "room_hub" );
  ObjAttach( "zz_lunchroomdoor_4", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_box_4_solderingironemblem", { event_mdown = private.get_solderingironemblem }},
  { "spr_box_4_hammer_4", { event_mdown = private.get_hammer_4 }},
  { "spr_box_4_tinsnips", { event_mdown = private.get_tinsnips }},
  { "spr_box_4_knife_4", { event_mdown = private.get_knife_4 }},
  { "spr_computer_amuletelement_4_2", { event_mdown = private.get_amuletelement_4_2 }},
  { "spr_computer_keycard_4", { event_mdown = private.get_keycard_4 }},
  { "spr_grid_4_boxamulet_4", { event_mdown = private.get_brokenboxamulet_4 }},
  { "spr_sofa_hexagon_4", { event_mdown = private.get_hexagon_4 }},
  { "spr_sofa_potdetail", { event_mdown = private.get_potdetail }},
  { "obj_lunchroomdoor_4_clk_over", { event_mdown = private.clk_lounchroom_4_cover }},
  { "obj_box_4_use_tongs_4", { event_mdown = private.clk_box_4_door }},
  { "obj_sofa_use_secretsign", { event_mdown = private.clk_sofa_door }},
  { "obj_sofa_use_hammer_4", { event_mdown = private.clk_sofa_cover }},
  { "obj_lunchroomdoor_4_clk_handle", { event_mdown = private.clk_handle_4 }},
  { "spr_sofa_collect_2", { event_mdown = function () private.get_collect_2_4_8(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }}, 
  { "spr_corridor_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_corridor_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_corridor_4_computerroom",
    "gzz_corridor_4_box_4",
    "gzz_corridor_4_computer",
    "gzz_corridor_4_grid_4",
    "gzz_corridor_4_sofa",
    "gzz_corridor_4_lunchroomdoor"   
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_box_4",
    "zz_computer",
    "zz_grid_4",
    "zz_sofa",
    "zz_lunchroomdoor_4"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_corridor_4", update_game_mode_corridor_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_corridor_4 = function ()

  local effects_table = 
  {
    "obj_corridor_4_anim" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_corridor_4", update_performance_mode_corridor_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_corridor_4 () end;
  --------------------------------------------------------------------------------------------
  local opn_corridor_4_map = function ()

    common_impl.VisitMapRoom( "corridor_4" );

  end;
  cmn.AddSubscriber( "opn_corridor_4", opn_corridor_4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_solderingironemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_solderingironemblem" ] = {
    type = "get",
    get_obj = "spr_box_4_solderingironemblem",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
    
  local get_solderingironemblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_solderingironemblem", "spr_box_4_solderingironemblem" );
  
  end;
  
  local get_solderingironemblem_closezz = function ()
  
    ObjDelete( "gfx_box_4_solderingironemblem" );
    ObjDelete( "spr_box_4_solderingironemblem_shadow" );
    
    ObjDelete( "spr_corridor_4_box_4_emblem" );
  
  end;
  
  cmn.AddSubscriber( "get_solderingironemblem", get_solderingironemblem_inv );
  cmn.AddSubscriber( "get_solderingironemblem", get_solderingironemblem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammer_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer_4" ] = {
    type = "get",
    get_obj = "spr_box_4_hammer_4",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
    
  local get_hammer_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer_4", "spr_box_4_hammer_4" );
  
  end;
  
  local get_hammer_4_closezz = function ()
  
    ObjDelete( "gfx_box_4_hammer_4" );
    ObjDelete( "spr_box_4_hammer_4_shadow");
    ObjDelete( "spr_corridor_4_box_4_hammer" );
  
  end;
  
  cmn.AddSubscriber( "get_hammer_4", get_hammer_4_inv );
  cmn.AddSubscriber( "get_hammer_4", get_hammer_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tinsnips () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tinsnips" ] = {
    type = "get",
    get_obj = "spr_box_4_tinsnips",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
    
  local get_tinsnips_inv = function ()
  
    interface.InventoryItemAdd( "inv_tinsnips", "spr_box_4_tinsnips" );
  
  end;
  
  local get_tinsnips_closezz = function ()
  
    ObjDelete( "gfx_box_4_tinsnips" );
    ObjDelete( "spr_corridor_4_box_4_scissors" );
    
    if cmn.IsEventDone("get_knife_4") then
    
       ObjDelete("gzz_corridor_4_box_4");
    
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_tinsnips", get_tinsnips_inv );
  cmn.AddSubscriber( "get_tinsnips", get_tinsnips_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knife_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knife_4" ] = {
    type = "get",
    get_obj = "spr_box_4_knife_4",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
    
  local get_knife_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_knife_4", "spr_box_4_knife_4" );
  
  end;
  
  local get_knife_4_closezz = function ()
  
    ObjDelete( "gfx_box_4_knife_4" );
    ObjDelete( "spr_corridor_4_box_4_knife" );
    
     if cmn.IsEventDone("get_tinsnips") then
    
       ObjDelete("gzz_corridor_4_box_4");
    
     end;  
  
  end;
  
  cmn.AddSubscriber( "get_knife_4", get_knife_4_inv );
  cmn.AddSubscriber( "get_knife_4", get_knife_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletelement_4_2" ] = {
    type = "get",
    get_obj = "spr_computer_amuletelement_4_2",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_corridor_4_computer"
  };
    
  local get_amuletelement_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletelement_4_2", "spr_computer_amuletelement_4_2" );
    ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });
    
  end;
  
  local get_amuletelement_4_2_closezz = function ()
  
    ObjDelete( "gfx_computer_amuletelement_4_2" );
    ObjDelete( "spr_computer_amuletelement_4_2_shadow" );
    
    ObjDelete( "spr_corridor_4_computer_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletelement_4_2", get_amuletelement_4_2_inv );
  cmn.AddSubscriber( "get_amuletelement_4_2", get_amuletelement_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keycard_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keycard_4" ] = {
    type = "get",
    get_obj = "spr_computer_keycard_4",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_corridor_4_computer"
  };
    
  local get_keycard_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_keycard_4", "spr_computer_keycard_4" );
  
  end;
  
  local get_keycard_4_closezz = function ()
  
    ObjDelete( "gfx_computer_keycard_4" );
    ObjDelete( "spr_computer_keycard_4_shadow" );
    ObjDelete( "spr_computer_keycard_4_over" );
    ObjDelete( "gzz_corridor_4_computer" );
    
    ObjDelete( "spr_corridor_4_computer_card" );
    
  end;
  
  cmn.AddSubscriber( "get_keycard_4", get_keycard_4_inv );
  cmn.AddSubscriber( "get_keycard_4", get_keycard_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenboxamulet_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenboxamulet_4" ] = {
    type = "get",
    get_obj = "spr_grid_4_boxamulet_4",
    room = private.room_objname,
    zz = "zz_grid_4",
    zz_gate = "gzz_corridor_4_grid_4"
  };
    
  local get_brokenboxamulet_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenboxamulet_4", "spr_grid_4_boxamulet_4" );
    ObjSet( "inv_brokenboxamulet_4", { drag = false });
    
  end;
  
  local get_brokenboxamulet_4_closezz = function ()
  
    ObjDelete( "gfx_grid_4_boxamulet_4" );
    ObjDelete( "spr_corridor_4_grid_4_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenboxamulet_4", get_brokenboxamulet_4_inv );
  cmn.AddSubscriber( "get_brokenboxamulet_4", get_brokenboxamulet_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagon_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagon_4" ] = {
    type = "get",
    get_obj = "spr_sofa_hexagon_4",
    room = private.room_objname,
    zz = "zz_sofa",
    zz_gate = "gzz_corridor_4_sofa"
  };
    
  local get_hexagon_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexagon_4", "spr_sofa_hexagon_4" );
  
  end;
  
  local get_hexagon_4_closezz = function ()
  
    ObjDelete( "gfx_sofa_hexagon_4" );
    ObjDelete( "spr_corridor_4_sofa_key" );
    
    if ( cmn.IsEventDone( "get_potdetail" ) and common_impl.IsGetCollect( "get_collect_2_4_8" )) then
      ObjDelete( "gzz_corridor_4_sofa" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_hexagon_4", get_hexagon_4_inv );
  cmn.AddSubscriber( "get_hexagon_4", get_hexagon_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_potdetail () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_potdetail" ] = {
    type = "get",
    get_obj = "spr_sofa_potdetail",
    room = private.room_objname,
    zz = "zz_sofa",
    zz_gate = "gzz_corridor_4_sofa"
  };
    
  local get_potdetail_inv = function ()
  
    interface.InventoryItemAdd( "inv_potdetail", "spr_sofa_potdetail" );
  
  end;
  
  local get_potdetail_closezz = function ()
  
    ObjDelete( "gfx_sofa_potdetail" );
    ObjDelete( "spr_sofa_potdetail_shadow" );
    if ( cmn.IsEventDone( "get_hexagon_4" ) and common_impl.IsGetCollect( "get_collect_2_4_8" )) then
      ObjDelete( "gzz_corridor_4_sofa" );
    end;
    
    ObjDelete( "spr_corridor_4_sofa_part" );
  
  end;
  
  cmn.AddSubscriber( "get_potdetail", get_potdetail_inv );
  cmn.AddSubscriber( "get_potdetail", get_potdetail_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_2" ] = {
    type = "get",
    get_obj = "anm_corridor_4_ectoplasm_4_2",
    room = private.room_objname,
    zz = "zz_corridor_4",
    zz_gate = "gzz_corridor_4_corridor_4"
  };
    
  local get_ectoplasm_4_2_inv = function ()

    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_corridor_4_ectoplasm_4_2", function() common.BlockGotoRoom(true); common_impl.Lock( false ); end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_2_closezz = function ()
  
    ObjDelete( "gfx_corridor_4_ectoplasm" );
    --ObjDelete( "gzz_corridor_4_corridor_4" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_2", get_ectoplasm_4_2_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_2", get_ectoplasm_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_4 = function ()
  
    ObjDelete( "obj_corridor_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_4", get_collect_morph_item_4_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_8 = function ()
  
    ObjDelete( "spr_sofa_collect_2" );
    
    if cmn.IsEventDone( "get_potdetail" ) and cmn.IsEventDone( "get_hexagon_4" ) then
      
      ObjDelete("gzz_corridor_4_sofa");
      
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_8", get_collect_2_4_8 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs_4" ] = {
    type = "use",
    inv_obj = "inv_tongs_4",
    use_place = "obj_box_4_use_tongs_4",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
  local use_tongs_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_tongs_4" );
  
  end;
  local use_tongs_4_beg = function ()
  
    ObjDelete( "obj_box_4_use_tongs_4" );
  
  end;
  local use_tongs_4_end = function ()
  
    ObjSet( "spr_box_4_solderingironemblem", { input = true, active = true } );
    ObjSet( "obj_box_4_use_wrench_4", { input = true } );
    ObjSet( "spr_box_4_bigbox_open", { alp = 1 } );
    ObjDelete( "anm_box_4_use_tongs_4");
    --ObjDelete( "obj_box_4_pins");
    
    ObjSet( "spr_corridor_4_box_4_open", { alp = 1 } );
    ObjSet( "spr_corridor_4_box_4_emblem", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs_4", use_tongs_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_4", use_tongs_4_inv );
  cmn.AddSubscriber( "use_tongs_4", use_tongs_4_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_4_inv", use_tongs_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_4_beg", use_tongs_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_4_end", use_tongs_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench_4" ] = {
    type = "use",
    inv_obj = "inv_wrench_4",
    use_place = "obj_box_4_use_wrench_4",
    room = private.room_objname,
    zz = "zz_box_4",
    zz_gate = "gzz_corridor_4_box_4"
  };
  local use_wrench_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench_4" );
  
  end;
  local use_wrench_4_beg = function ()
  
    ObjDelete( "obj_box_4_use_wrench_4" );
  
  end;
  local use_wrench_4_end = function ()
  
  ObjSet( "spr_box_4_knife_4", { alp = 1, input = true, active = true } );
  ObjSet( "spr_box_4_tinsnips", { alp = 1, input = true, active = true } );
  ObjSet("obj_box_4_crop", { input =  true });
  --ObjDelete( "vid_box_4_use_wrench_4");
  ObjSet( "vid_box_4_use_wrench_4", { frame = 293 });
  ObjSet("spr_box_4_smallbox_open", { alp = 1 });
  
  ObjSet( "spr_corridor_4_box_4_open_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_inv );
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_inv", use_wrench_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_beg", use_wrench_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_end", use_wrench_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diode_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diode_4_2" ] = {
    type = "use",
    inv_obj = "inv_diode_4_2",
    use_place = "obj_computer_use_diode",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_corridor_4_computer"
  };
  local use_diode_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_diode_4_2" );
  
  end;
  local use_diode_4_2_beg = function ()
  
    if ( cmn.IsEventDone( "use_diode_4_1" ) and cmn.IsEventDone( "use_diode_4_3" ) )then
      
      ObjDelete( "obj_computer_use_diode" );
      
    end;
    
  end;
  local use_diode_4_2_end = function ()
  
    ObjSet( "spr_computer_lamp_2", { alp = 1 } );  
    
    if( cmn.IsEventDone( "use_diode_4_1" ) and cmn.IsEventDone( "use_diode_4_3" ) )then
      
      ObjSet( "gmg_corridor_4_computerroom", { input = true, active = true } );   
      ObjSet( "gzz_corridor_4_computer", { input = false, active = false } );
      ObjSet( "spr_computer_lamp_add", { alp = 1 } );
      
      ObjSet( "spr_corridor_4_computer_lamps_add", { alp = 1 } ); 
      
    end;
    
    ObjSet( "spr_corridor_4_computer_lamp_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diode_4_2", use_diode_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_2", use_diode_4_2_inv );
  cmn.AddSubscriber( "use_diode_4_2", use_diode_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_2_inv", use_diode_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_2_beg", use_diode_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_2_end", use_diode_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diode_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diode_4_1" ] = {
    type = "use",
    inv_obj = "inv_diode_4_1",
    use_place = "obj_computer_use_diode",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_corridor_4_computer"
  };
  local use_diode_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_diode_4_1" );
  
  end;
  local use_diode_4_1_beg = function ()
  
    if ( cmn.IsEventDone( "use_diode_4_2" ) and cmn.IsEventDone( "use_diode_4_3" ) )then
      
      ObjDelete( "obj_computer_use_diode" );
      
    end;
  
  end;
  local use_diode_4_1_end = function ()
  
    ObjSet( "spr_computer_lamp_1", { alp = 1 } );  
    
    if( cmn.IsEventDone( "use_diode_4_2" ) and cmn.IsEventDone( "use_diode_4_3" ) )then
      
      ObjSet( "gmg_corridor_4_computerroom", { input = true, active = true } );   
      ObjSet( "gzz_corridor_4_computer", { input = false, active = false } ); 
      ObjSet( "spr_computer_lamp_add", { alp = 1 } ); 
      
      ObjSet( "spr_corridor_4_computer_lamps_add", { alp = 1 } ); 
      
    end;
    
    ObjSet( "spr_corridor_4_computer_lamp_1", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diode_4_1", use_diode_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_1", use_diode_4_1_inv );
  cmn.AddSubscriber( "use_diode_4_1", use_diode_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_1_inv", use_diode_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_1_beg", use_diode_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_1_end", use_diode_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diode_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diode_4_3" ] = {
    type = "use",
    inv_obj = "inv_diode_4_3",
    use_place = "obj_computer_use_diode",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_corridor_4_computer"
  };
  local use_diode_4_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_diode_4_3" );
  
  end;
  local use_diode_4_3_beg = function ()
  
    if ( cmn.IsEventDone( "use_diode_4_1" ) and cmn.IsEventDone( "use_diode_4_2" ) )then
      
      ObjDelete( "obj_computer_use_diode" );
      
    end;
  
  end;
  local use_diode_4_3_end = function ()
  
    ObjSet( "spr_computer_lamp_3", { alp = 1 } );   
    
    if( cmn.IsEventDone( "use_diode_4_1" ) and cmn.IsEventDone( "use_diode_4_2" ) )then
      
      ObjSet( "gmg_corridor_4_computerroom", { input = true, active = true } );   
      ObjSet( "gzz_corridor_4_computer", { input = false, active = false } ); 
      ObjSet( "spr_computer_lamp_add", { alp = 1 } ); 
      
      ObjSet( "spr_corridor_4_computer_lamps_add", { alp = 1 } ); 
      
    end;
    
    ObjSet( "spr_corridor_4_computer_lamp_3", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diode_4_3", use_diode_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_3", use_diode_4_3_inv );
  cmn.AddSubscriber( "use_diode_4_3", use_diode_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_3_inv", use_diode_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_3_beg", use_diode_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_diode_4_3_end", use_diode_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acid () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_acid" ] = {
    type = "use",
    inv_obj = "inv_acid",
    use_place = "obj_grid_4_use_acid",
    room = private.room_objname,
    zz = "zz_grid_4",
    zz_gate = "gzz_corridor_4_grid_4"
  };
  local use_acid_inv = function ()
  
    interface.InventoryItemRemove( "inv_acid" );
  
  end;
  local use_acid_beg = function ()
  
    ObjDelete( "obj_grid_4_use_acid" );
  
  end;
  local use_acid_end = function ()
  
    ObjDelete( "spr_grid_4_lattice_shadow_1" );
    ObjDelete( "spr_grid_4_acid" );
    ObjDelete( "spr_grid_4_lattice" );
    ObjSet( "obj_grid_4_part_acid", { alp = 1 } );
    ObjSet( "spr_grid_4_lattice_shadow_2", { alp = 1 } );
    ObjSet( "grm_corridor_4_secondfloor", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_4_secondfloor_focus");
    end;
    ObjDelete( "gzz_corridor_4_grid_4" );
    --ObjDelete( "anm_grid_4_acid" );
    
    ObjSet( "spr_corridor_4_grid_4_open", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_acid", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid", use_acid_inv );
  cmn.AddSubscriber( "use_acid", use_acid_end, private.room_objname );
  cmn.AddSubscriber( "use_acid_inv", use_acid_inv, private.room_objname );
  cmn.AddSubscriber( "use_acid_beg", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid_end", use_acid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4_3" ] = {
    type = "use",
    inv_obj = "inv_elf_4",
    use_place = "obj_sofa_use_elf_4",
    room = private.room_objname,
    zz = "zz_sofa",
    zz_gate = "gzz_corridor_4_sofa"
  };
  local use_elf_4_3_inv = function ()
  
  end;
  local use_elf_4_3_beg = function ()
  
    ObjDelete( "obj_sofa_use_elf_4" );
  
  end;
  local use_elf_4_3_end = function ()
    
    ObjDelete( "vid_sofa_use_elf" );
    ObjSet( "spr_sofa_hexagon_4", { input = true, alp = 1, active = true } );
    
    ObjSet( "spr_corridor_4_sofa_key", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4_3", use_elf_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_3", use_elf_4_3_inv );
  cmn.AddSubscriber( "use_elf_4_3", use_elf_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_3_inv", use_elf_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_3_beg", use_elf_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_3_end", use_elf_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_4_2" ] = {
    type = "use",
    inv_obj = "inv_hammer_4",
    use_place = "obj_sofa_use_hammer_4",
    room = private.room_objname,
    zz = "zz_sofa",
    zz_gate = "gzz_corridor_4_sofa"
  };
  local use_hammer_4_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_hammer_4_1" ) ) then
      
      interface.InventoryItemRemove( "inv_hammer_4" );
      
    end;
  
  end;
  local use_hammer_4_2_beg = function ()
  
    ObjDelete( "obj_sofa_use_hammer_4" );
  
  end;
  local use_hammer_4_2_end = function ()
  
    ObjDelete( "spr_sofa_over_1" );
    ObjDelete( "anm_sofa_use_hammer" );
    ObjSet( "obj_sofa_use_secretsign", { input = true } );
    
    ObjDelete( "spr_corridor_4_sofa_cover_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_4_2", use_hammer_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_2", use_hammer_4_2_inv );
  cmn.AddSubscriber( "use_hammer_4_2", use_hammer_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_2_inv", use_hammer_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_2_beg", use_hammer_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_2_end", use_hammer_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_secretsign () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_secretsign" ] = {
    type = "use",
    inv_obj = "inv_secretsign",
    use_place = "obj_sofa_use_secretsign",
    room = private.room_objname,
    zz = "zz_sofa",
    zz_gate = "gzz_corridor_4_sofa"
  };
  local use_secretsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_secretsign" );
  
  end;
  local use_secretsign_beg = function ()
  
    ObjDelete( "obj_sofa_use_secretsign" );
  
  end;
  local use_secretsign_end = function ()
  
    ObjSet( "spr_sofa_potdetail", { input = true, active = true } );
    ObjDelete( "spr_sofa_door" );
    
    ObjDelete( "spr_corridor_4_sofa_cover" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_secretsign", use_secretsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_secretsign", use_secretsign_inv );
  cmn.AddSubscriber( "use_secretsign", use_secretsign_end, private.room_objname );
  cmn.AddSubscriber( "use_secretsign_inv", use_secretsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_secretsign_beg", use_secretsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_secretsign_end", use_secretsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_solderingiron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_solderingiron" ] = {
    type = "use",
    inv_obj = "inv_solderingiron",
    use_place = "obj_lunchroomdoor_4_use_solderingiron",
    room = private.room_objname,
    zz = "zz_lunchroomdoor_4",
    zz_gate = "gzz_corridor_4_lunchroomdoor"
  };
  local use_solderingiron_inv = function ()
  
    interface.InventoryItemRemove( "inv_solderingiron" );
  
  end;
  local use_solderingiron_beg = function ()
  
    ObjDelete( "obj_lunchroomdoor_4_use_solderingiron" );
  
  end;
  local use_solderingiron_end = function ()
  
    ObjSet( "obj_lunchroomdoor_4_use_keycard_4", { input = true } );
    --ObjSet( "spr_lunchroomdoor_4_wire_2", { alp = 1 } );
    --ObjDelete( "spr_lunchroomdoor_4_wire_1" );
    ObjSet( "anm_lunchroomdoor_4_use_solder", {frame = 219} );
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_solderingiron", use_solderingiron_beg, private.room_objname );
  cmn.AddSubscriber( "use_solderingiron", use_solderingiron_inv );
  cmn.AddSubscriber( "use_solderingiron", use_solderingiron_end, private.room_objname );
  cmn.AddSubscriber( "use_solderingiron_inv", use_solderingiron_inv, private.room_objname );
  cmn.AddSubscriber( "use_solderingiron_beg", use_solderingiron_beg, private.room_objname );
  cmn.AddSubscriber( "use_solderingiron_end", use_solderingiron_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_keycard_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_keycard_4" ] = {
    type = "use",
    inv_obj = "inv_keycard_4",
    use_place = "obj_lunchroomdoor_4_use_keycard_4",
    room = private.room_objname,
    zz = "zz_lunchroomdoor_4",
    zz_gate = "gzz_corridor_4_lunchroomdoor"
  };
  local use_keycard_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_keycard_4" );
  
  end;
  local use_keycard_4_beg = function ()
  
    ObjDelete( "obj_lunchroomdoor_4_use_keycard_4" );
  
  end;
  local use_keycard_4_end = function ()
     
    ObjSet( "spr_corridor_4_lunchroomdoor_4_card", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_keycard_4", use_keycard_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_keycard_4", use_keycard_4_inv );
  cmn.AddSubscriber( "use_keycard_4", use_keycard_4_end, private.room_objname );
  cmn.AddSubscriber( "use_keycard_4_inv", use_keycard_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_keycard_4_beg", use_keycard_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_keycard_4_end", use_keycard_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_2" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname,
  };
  local use_searcher_4_2_inv = function ()
  
    if ( levelext_inv.IsUseAllSearchers( 2 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;
  
  end;
  local use_searcher_4_2_beg = function ()
  
    
  
  end;
  local use_searcher_4_2_end = function ()
    ObjDelete( "obj_corridor_4_use_searcher" );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_2", use_searcher_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_2", use_searcher_4_2_inv );
  cmn.AddSubscriber( "use_searcher_4_2", use_searcher_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_2_inv", use_searcher_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_2_beg", use_searcher_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_2_end", use_searcher_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_corridor_4_running () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_corridor_4_running" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_corridor_4_running",
    
  };
  local vid_corridor_4_running_end = function ()
  
    ObjDelete( "anm_corridor_4_ghost" );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_corridor_4_running", vid_corridor_4_running_end, private.room_objname  );
  cmn.AddSubscriber( "vid_corridor_4_running_end", vid_corridor_4_running_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_handle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle_4" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "obj_lunchroomdoor_4_clk_handle",
    zz = "zz_lunchroomdoor_4",
    zz_gate = "gzz_behindstage_lunchroomdoor_4"
  };
  local clk_handle_4 = function ()
  
    ObjDelete( "gzz_corridor_4_lunchroomdoor" );
    ObjSet( "grm_corridor_4_lunchroom_4", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_4_lunchroom_4_focus");
    end;
    --ObjDelete("anm_lunchroomdoor_4_clk_door");
    
    ObjSet( "spr_corridor_4_lunchroomdoor_4_open", { alp = 1 } );
    ObjDelete( "spr_corridor_4_lunchroomdoor_4_open_lock" );
    ObjDelete( "spr_corridor_4_lunchroomdoor_4_card" );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle_4", clk_handle_4, private.room_objname  );
  -- function clk_lounchroom_4_cover () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lounchroom_4_cover" ] = {
    type = "click",
    use_place = "obj_lunchroomdoor_4_clk_over",
    room = private.room_objname,
    zz = "zz_lunchroomdoor_4",
    zz_gate = "gzz_corridor_4_lunchroomdoor"
  };
  local clk_lounchroom_4_cover = function ()

    ObjDelete( "obj_lunchroomdoor_4_clk_over" );
    ObjSet( "spr_lunchroomdoor_4_open_lock", { alp = 1 });
    ObjSet( "obj_lunchroomdoor_4_use_solderingiron", { input = true });
    ObjSet( "anm_lunchroomdoor_4_use_solder", { alp = 1 });
    ObjSet( "spr_corridor_4_lunchroomdoor_4_open_lock", { alp = 1 } );

  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lounchroom_4_cover", clk_lounchroom_4_cover, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_corridor_4_message () end;
  --------------------------------------------------------------------------------------------
  local vid_corridor_4_message_end = function ()
  
    ObjSet( "spr_computer_keycard_4", { input = true, active = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_corridor_4_message", vid_corridor_4_message_end, private.room_objname  );
  cmn.AddSubscriber( "vid_corridor_4_message_end", vid_corridor_4_message_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_computer" );
  --------------------------------------------------------------------------------------------- 
  function zz_computer.Close()
    
    if cmn.IsEventDone( "use_diode_4_1" ) and cmn.IsEventDone( "use_diode_4_2" ) and cmn.IsEventDone( "use_diode_4_3" )
     and not cmn.IsEventDone( "win_computerroom" ) then
      
     ObjSet( "tmr_corridor_4_gomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_computerroom' ) end } );
      
    end;
     
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_corridor_4();
  
--  if ( cmn.IsEventDone("win_computerroom") and not cmn.IsEventDone( "vid_corridor_4_message" ) ) then
--
--    private.vid_corridor_4_message();
--      
--  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  
  if ( not cmn.IsEventDone( "vid_corridor_4_running" ) ) then

    ObjSet( "tmr_corridor_4_running",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_corridor_4_running(); end
    } );
      
  end;
  
  if ( cmn.IsEventDone("win_computerroom") and not cmn.IsEventDone( "vid_corridor_4_message" ) ) then

    private.vid_corridor_4_message();
      
  end;
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_corridor_4_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_tongs_4()

  local item = "inv_tongs_4";

  if ( common.ApplyObj( item, "obj_box_4_use_tongs_4", true ) ) then

    cmn.CallEventHandler( "use_tongs_4_inv" );
    cmn.CallEventHandler( "use_tongs_4_beg" );

  local func_after = function ()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "use_tongs_4" );
    cmn.CallEventHandler( "use_tongs_4_end" );
  --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_tongs_box_4", 0, "", 0 );
  AnimPlay( "anm_box_4_use_tongs_4", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_box_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wrench_4()

  local item = "inv_wrench_4";

  if ( common.ApplyObj( item, "obj_box_4_use_wrench_4", true ) and cmn.IsEventDone( "use_tongs_4" )) then

    cmn.CallEventHandler( "use_wrench_4_inv" );
    cmn.CallEventHandler( "use_wrench_4_beg" );

    local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wrench_4" );
      cmn.CallEventHandler( "use_wrench_4_end" );
    --common.CloseSubRoom();;
    end;
  
  local func_after = function ()
  
    ObjAnimate( "spr_box_4_smallbox_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_box_4_tinsnips", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_box_4_knife_4", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_wrench_box_4", 0, "", 0 );
  
    VidPlay( "vid_box_4_use_wrench_4", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_box_4", false ) and cmn.IsEventDone( "use_tongs_4" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_diode_4_2()

  local item = "inv_diode_4_2";

  if ( common.ApplyObj( item, "obj_computer_use_diode", true ) ) then

    cmn.CallEventHandler( "use_diode_4_2_inv" );
    cmn.CallEventHandler( "use_diode_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_diode_4_2" );
      cmn.CallEventHandler( "use_diode_4_2_end" );
      
      if ( cmn.IsEventDone("use_diode_4_1") and cmn.IsEventDone("use_diode_4_3") ) then
        
        common.CloseSubRoom();
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_diode_computer", 0, "", 0 );
  
  ObjAnimate( "spr_computer_lamp_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_computer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_computer", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_diode_4_1()

  local item = "inv_diode_4_1";

  if ( common.ApplyObj( item, "obj_computer_use_diode", true ) ) then

    cmn.CallEventHandler( "use_diode_4_1_inv" );
    cmn.CallEventHandler( "use_diode_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_diode_4_1" );
      cmn.CallEventHandler( "use_diode_4_1_end" );
      
      if ( cmn.IsEventDone("use_diode_4_2") and cmn.IsEventDone("use_diode_4_3") ) then
        
        common.CloseSubRoom();
        
      end;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_diode_computer", 0, "", 0 );
  
  ObjAnimate( "spr_computer_lamp_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_computer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_computer", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_diode_4_3()

  local item = "inv_diode_4_3";

  if ( common.ApplyObj( item, "obj_computer_use_diode", true ) ) then

    cmn.CallEventHandler( "use_diode_4_3_inv" );
    cmn.CallEventHandler( "use_diode_4_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_diode_4_3" );
      cmn.CallEventHandler( "use_diode_4_3_end" );
      
      if ( cmn.IsEventDone("use_diode_4_1") and cmn.IsEventDone("use_diode_4_2") ) then
        
        common.CloseSubRoom();
        
      end;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_diode_computer", 0, "", 0 );
  
  ObjAnimate( "spr_computer_lamp_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_computer", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_computer", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_acid()

  local item = "inv_acid";

  if ( common.ApplyObj( item, "obj_grid_4_use_acid", true ) and cmn.IsEventDone("get_brokenboxamulet_4") ) then

    cmn.CallEventHandler( "use_acid_inv" );
    cmn.CallEventHandler( "use_acid_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_acid" );
      cmn.CallEventHandler( "use_acid_end" );
      common.CloseSubRoom();
        
    end;
        
      


    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_acid_grid_4", 0, "", 0 );
    
    AnimPlay( "anm_grid_4_acid", "DoAnim", func_after)
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_grid_4", false ) and cmn.IsEventDone("get_brokenboxamulet_4") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid_4", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4_3()

  local item = "inv_elf_4";

  if ( common.ApplyObj( item, "obj_sofa_use_elf_4", true ) ) then

    cmn.CallEventHandler( "use_elf_4_3_inv" );
    cmn.CallEventHandler( "use_elf_4_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      ObjSet( "spr_sofa_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_4", "spr_sofa_elf", nil, "video" );
      cmn.SetEventDone( "use_elf_4_3" );
      cmn.CallEventHandler( "use_elf_4_3_end" );
 
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_sofa_elf", 0, "", 0 );
    
    interface.InventoryItemRemove( "inv_elf_4" );
    VidPlay( "vid_sofa_use_elf", func_after );
    ObjSet( "spr_sofa_hexagon_add", { active = false, alp = 0 } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_sofa", false ) and not cmn.IsEventDone( "use_elf_4_3" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sofa", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hammer_4_2()

  local item = "inv_hammer_4";

  if ( common.ApplyObj( item, "obj_sofa_use_hammer_4", true ) ) then

    cmn.CallEventHandler( "use_hammer_4_2_inv" );
    cmn.CallEventHandler( "use_hammer_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hammer_4_2" );
      cmn.CallEventHandler( "use_hammer_4_2_end" );
      
    end;

    common_impl.Lock( true );
  
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_hammer_sofa", 0, "", 0 );
    ObjSet( "anm_sofa_use_hammer", { alp = 1, playing = true, endtrig = func_after } );
    ObjSet( "spr_sofa_over_1", { alp = 0 } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_sofa", false ) and not cmn.IsEventDone( "use_hammer_4_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sofa", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_secretsign()

  local item = "inv_secretsign";

  if ( common.ApplyObj( item, "obj_sofa_use_secretsign", true ) and cmn.IsEventDone( "use_hammer_4_2" ) ) then

    cmn.CallEventHandler( "use_secretsign_inv" );
    cmn.CallEventHandler( "use_secretsign_beg" );

    local func_after = function ()
    
      local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_secretsign" );
        cmn.CallEventHandler( "use_secretsign_end" );
        
      end;
  
      ObjAnimate( "spr_sofa_door", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0, 120, 183, 
        1,   0, -109, 192 
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_secretsign_sofa", 0, "", 0 );
    ObjAnimate( "spr_sofa_mask", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_sofa", false ) and cmn.IsEventDone( "use_hammer_4_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sofa", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_solderingiron()

  local item = "inv_solderingiron";

  if ( common.ApplyObj( item, "obj_lunchroomdoor_4_use_solderingiron", true ) and cmn.IsEventDone("clk_lounchroom_4_cover")) then

    cmn.CallEventHandler( "use_solderingiron_inv" );
    cmn.CallEventHandler( "use_solderingiron_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_solderingiron" );
      cmn.CallEventHandler( "use_solderingiron_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_solderingiron_lunchroomdoor", 0, "", 0 );
  
    --ObjAnimate( "spr_lunchroomdoor_4_wire_2", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
    --ObjAnimate( "spr_lunchroomdoor_4_wire_1", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 0.0
    --} );
  AnimPlay( "anm_lunchroomdoor_4_use_solder", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_lunchroomdoor", false ) and cmn.IsEventDone("clk_lounchroom_4_cover") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lunchroomdoor_4", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_keycard_4()

  local item = "inv_keycard_4";

  if ( common.ApplyObj( item, "obj_lunchroomdoor_4_use_keycard_4", true ) and cmn.IsEventDone( "use_solderingiron" ) ) then

    cmn.CallEventHandler( "use_keycard_4_inv" );
    cmn.CallEventHandler( "use_keycard_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_keycard_4" );
      cmn.CallEventHandler( "use_keycard_4_end" );
      --common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_keycard_lunchroomdoor", 0, "", 0 );
  
    ObjAnimate( "obj_lunchroomdoor_card", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_lunchroomdoor_card", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, -5, -40,
      0.3, 0, -5, -40,
      1.0, 0, 0, 0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_corridor_4_lunchroomdoor", false ) and cmn.IsEventDone( "use_solderingiron" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lunchroomdoor_4", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_2( func )

  cmn.CallEventHandler( "use_searcher_4_2_beg" );

  local func_after = function ()

    --common_impl.Lock( false );
    cmn.SetEventDone( "use_searcher_4_2" );
    cmn.CallEventHandler( "use_searcher_4_2_end" );
    private.get_ectoplasm_4_2();
    
    local delayfunc = function ()

      --common_impl.Lock( false );
      func();
      --cmn.CallEventHandler( "use_searcher_4_2_inv" );

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );
  
  ObjSet( "anm_corridor_4_ectoplasm_4_2", { visible = true, playing = true, active = true, endtrig = func_after } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_solderingironemblem()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_solderingironemblem" );
  cmn.CallEventHandler( "get_solderingironemblem" );

end;
--------------------------------------------------------------------------------------------
function private.get_hammer_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hammer_4" );
  cmn.CallEventHandler( "get_hammer_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_tinsnips()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tinsnips" );
  cmn.CallEventHandler( "get_tinsnips" );
  
   if cmn.IsEventDone("get_knife_4") then
    
    common.CloseSubRoom();
    
   end;  

end;
--------------------------------------------------------------------------------------------
function private.get_knife_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_knife_4" );
  cmn.CallEventHandler( "get_knife_4" );
  
  if cmn.IsEventDone("get_tinsnips") then
    
    common.CloseSubRoom();
    
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_amuletelement_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_amuletelement_4_2" );
  cmn.CallEventHandler( "get_amuletelement_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_keycard_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_keycard_4" );
  cmn.CallEventHandler( "get_keycard_4" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_brokenboxamulet_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokenboxamulet_4" );
  cmn.CallEventHandler( "get_brokenboxamulet_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexagon_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hexagon_4" );
  cmn.CallEventHandler( "get_hexagon_4" );
  
  if ( cmn.IsEventDone( "get_potdetail" ) and common_impl.IsGetCollect( "get_collect_2_4_8" ) ) then
    
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_potdetail()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_potdetail" );
  cmn.CallEventHandler( "get_potdetail" );
  
  if ( cmn.IsEventDone( "get_hexagon_4" ) and common_impl.IsGetCollect( "get_collect_2_4_8" ) ) then
    
    common.CloseSubRoom();
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_2" );
  cmn.CallEventHandler( "get_ectoplasm_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_4_8()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_8");
    cmn.CallEventHandler("get_collect_2_4_8");
    
    if cmn.IsEventDone( "get_potdetail" ) and cmn.IsEventDone( "get_hexagon_4" ) then
      
      common.CloseSubRoom();
      
    end;  
  
  end;

  common_impl.PlayEffectHO( "spr_sofa_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_sofa_door() 
 
  local func_after = function()
 
    common_impl.Lock( false );
 
  end;
 
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_sofa_use_secretsign' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_sofa", 0, "", 0 );
  
  ObjAnimate( "spr_sofa_door", "pos_xy", 0, 0, func_after,
  {
    0.0, 0, 120, 183,
    0.3, 0, 122, 185,
    0.6, 0, 120, 183
  } );
  
end;
--*********************************************************************************************************************
function private.clk_sofa_cover() 
 
  local func_after = function()
 
    common_impl.Lock( false );
 
  end;
 
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_sofa_use_hammer_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_cover_sofa", 0, "", 0 );
  
  ObjAnimate( "spr_sofa_over_1", "pos_xy", 0, 0, func_after,
  {
    0.0, 0, 71, 170,
    0.3, 0, 70, 173,
    0.6, 0, 71, 170
  } );
  
end;
--------------------------------------------------------------------------------
function private.clk_lounchroom_4_cover()

  local func_after = function()

    common_impl.Lock( false ); 
    cmn.SetEventDone( "clk_lounchroom_4_cover" );
    cmn.CallEventHandler( "clk_lounchroom_4_cover" );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_lock_lunchroomdoor", 0, "", 0 );
  
  ObjAnimate( "anm_lunchroomdoor_4_use_solder", "alp", 0, 0, func_after,
  {
    0.0, 0, 0.0,
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------
function private.clk_box_4_door() 
 
  local func_after = function()
 
    common_impl.Lock( false );
 
  end;
 
  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_box_4_use_tongs_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_box_4", 0, "", 0 );
  
  ObjAnimate( "anm_box_4_use_tongs_4", "pos_x", 0, 0, func_after,
  {
  
    0.0, 0, -422,
    0.3, 0, -421,
    0.6, 0, -422
    
  } );
  
end; 
--------------------------------------------------------------------------------
function private.clk_handle_4()
  
  if not cmn.IsEventDone( "use_keycard_4" ) then
  
    local func_after = function()

        common_impl.Lock( false );
      
    end;
      
    common_impl.Lock( true ); 
    
    if  cmn.IsEventDone( "use_solderingiron" ) then
      
      common_impl.ShowBbt( 'bbt_lunchroomdoor_4_use_keycard_4' );
      
    else 
     
      common_impl.ShowBbt( 'bbt_lunchroomdoor_4_use_solderingiron' );
      
    end;  
    
   common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_doorhandle_lunchroomdoor", 0, "", 0 );
   
   AnimPlay( "anm_lunchroomdoor_4_clk_door", "DoAnim", func_after );
    
  else
    
    local func_after = function()
    
      cmn.SetEventDone( "clk_handle_4" );
      cmn.CallEventHandler( "clk_handle_4" );
      common_impl.Lock( false );
      common.CloseSubRoom();
      
    end;
    common_impl.Lock( true ); 
  
    --ObjAnimate( "spr_lunchroomdoor_4_doorhandle", "ang", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0,
    --  0.3, 0, -0.22,
    --  0.6, 0, 0
    --} );   
    AnimPlay( "anm_lunchroomdoor_4_clk_door", "DoAnim", func_after );
    
  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_open_lunchroomdoor", 0, "", 0 );

end;   
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridor_4()

  if not ( cmn.IsEventDone( "opn_corridor_4" ) ) then
    cmn.SetEventDone( "opn_corridor_4" );
  end;
  
  cmn.CallEventHandler( "opn_corridor_4" ); 

end;
--*********************************************************************************************************************
function private.vid_corridor_4_running()

  local func_after = function ( skip )
  
    common_impl.Lock( false ); 
    cmn.SetEventDone( "vid_corridor_4_running" );
    cmn.CallEventHandler( "vid_corridor_4_running_end" );
    common_impl.ShowBbt( 'bbt_vid_corridor_4_running', 1 );
 
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();
  common_impl.Lock( true ); 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_anm_ghost", 0, "", 0 );
  AnimPlay("anm_corridor_4_ghost", "DoAnim", func_after );

end;
--*********************************************************************************************************************
function private.vid_corridor_4_message()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_corridor_4_message" );
    cmn.CallEventHandler( "vid_corridor_4_message_end" );
    common_impl.ShowBbt( 'bbt_vid_corridor_4_message', 1 );
    
    local posxy = { ObjGet("gzz_corridor_4_computer").pos_x, ObjGet("gzz_corridor_4_computer").pos_y };    
    ObjSet( "tmr_corridor_4_gotozz", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoSubRoom( "zz_computer", posxy , { 512, 384 }, true ); end } );
      
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_corridor_4_message", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_corridor_4_message_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_corridor_4_message", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_corridor_4_message_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_corridor_4_message", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_corridor_4_message", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_sofa_hexagon_add", "alp", 1, 0, "", { 0,0,0, 2.5,0,1, 5,0,0 } );