-- name=rm_hall_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_scared", "room_hub" );
  ObjAttach( "zz_videocamera", "room_hub" );
  ObjAttach( "zz_orchestra_4", "room_hub" );
  ObjAttach( "zz_equipment_4", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 

    { "spr_scared_bagbutton", { event_mdown = private.get_bagbutton }},
    { "obj_scrared_thermos_obj_click", { event_mdown = private.get_thermos_4 }},
    { "spr_scared_amuletelement_4_1", { event_mdown = private.get_amuletelement_4_1 }},
    { "spr_scared_caseelement_4_3", { event_mdown = private.get_caseelement_4_3 }},
    { "spr_videocamera_caseelement_4_1", { event_mdown = private.get_caseelement_4_1 }},
    { "spr_videocamera_micholder", { event_mdown = private.get_micholder }},
    { "spr_videocamera_batteries_4", { event_mdown = private.get_batteries_4 }},
    { "spr_videocamera_diode_4_2", { event_mdown = private.get_diode_4_2 }},
    { "spr_orchestra_4_caseelement_4_2", { event_mdown = private.get_caseelement_4_2 }},
    { "spr_orchestra_4_cup", { event_mdown = private.get_cup }},
    { "spr_equipment_4_cutters_4", { event_mdown = private.get_cutters_4 }},
    { "spr_equipment_4_screwdriver_4", { event_mdown = private.get_screwdriver_4 }},
    { "spr_equipment_4_diode_4_1", { event_mdown = private.get_diode_4_1 }},
    { "spr_equipment_4_brokenapparatus_4", { event_mdown = private.get_brokenapparatus_4 }},
    { "spr_equipment_4_chisel_4", { event_mdown = private.get_chisel_4 }},
    { "spr_equipment_4_ax_4", { event_mdown = private.get_ax_4 }},
    { "spr_equipment_4_anglegrinder", { event_mdown = private.get_anglegrinder }},
    { "spr_equipment_4_solderingiron", { event_mdown = private.get_solderingiron }},
    { "obj_equipment_4_clk_bag", { event_mdown = private.clk_bag_4 }},
    { "obj_videocamera_use_hexagon_4", { event_mdown = private.clk_cover }},
    { "obj_videocamera_use_screwdriver_4", { event_mdown = private.clk_cap }},
    { "spr_equipment_4_collect_2", { event_mdown = function () private.get_collect_2_4_6(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
    { "spr_hall_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
    
  for i = 1, 8 do
    
    ObjSet( "obj_equipment_4_mmg_symbol_"..i, { event_mdown = function() private.ClkSymbol( i ); end,
                                                event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end  } );
    
  end;
    
    
  private.equipment_mmg_angles = { 0.49, -0.47, -1.24, -1.92, -2.69, 2.69, 1.92, 1.28 };
  private.equipment_mmg_sequence = { { 2, 7, 8 }, { 6, 5, 4 } };
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_hall_4_apparatusroom_4_1",
    "gzz_hall_4_scared",
    "gzz_hall_4_videocamera",
    "gzz_hall_4_orchestra_4",
    "gzz_hall_4_equipment_4"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_scared",
    "zz_videocamera",
    "zz_orchestra_4",
    "zz_equipment_4"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall_4", update_game_mode_hall_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall_4 = function ()

  local effects_table = 
  {
    "obj_hall_4_anim",
    "spr_orchestra_4_light_add",
    "anm_scared_sit",
    "anm_hall_4_anomaly"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall_4", update_performance_mode_hall_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall_4 () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_4_map = function ()

    common_impl.VisitMapRoom( "hall_4" );

  end;
  cmn.AddSubscriber( "opn_hall_4", opn_hall_4_map );
  --------------------------------------------------------------------------------------------
  local beg_levelext = function ()

    ObjSet( "spr_int_button_apparat_apparat", { alp = 1 } );
    ObjSet( "obj_int_button_apparat", { input = true } );  
    
    ObjSet( "obj_int_button_map_button", { input = true } );
    ObjSet( "spr_int_button_map_button", { alp = 1 } );
  
    interface.InventoryItemAdd( "inv_elf_4" );
    
  end;
  cmn.AddSubscriber( "beg_levelext", beg_levelext ); 
  --------------------------------------------------------------------------------------------
  -- function get_bagbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagbutton" ] = {
    type = "get",
    get_obj = "spr_scared_bagbutton",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
    
  local get_bagbutton_inv = function ()
  
    interface.InventoryItemAdd( "inv_bagbutton", "spr_scared_bagbutton" );
  
  end;
  
  local get_bagbutton_closezz = function ()
  
    ObjDelete( "gfx_scared_bagbutton" );
    ObjDelete( "spr_scared_bagbutton_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_bagbutton", get_bagbutton_inv );
  cmn.AddSubscriber( "get_bagbutton", get_bagbutton_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thermos_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_thermos_4" ] = {
    type = "get",
    get_obj = "spr_scared_thermos_4",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
    
  local get_thermos_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_thermos_4", "spr_scared_thermos_4" );
  
  end;
  
  local get_thermos_4_closezz = function ()
  
    ObjDelete( "gfx_scared_thermos_4" );
    ObjDelete( "spr_scared_thermos_4_1_shadow" );
    ObjDelete( "spr_scared_thermos_4_2_shadow" );
    ObjDelete( "obj_scrared_thermos_obj_click" );
    
  end;
  
  cmn.AddSubscriber( "get_thermos_4", get_thermos_4_inv );
  cmn.AddSubscriber( "get_thermos_4", get_thermos_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletelement_4_1" ] = {
    type = "get",
    get_obj = "spr_scared_amuletelement_4_1",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
    
  local get_amuletelement_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletelement_4_1", "spr_scared_amuletelement_4_1" );
    ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });
        
  end;
  
  local get_amuletelement_4_1_closezz = function ()
  
    ObjDelete( "gfx_scared_amuletelement_4_1" );
    ObjDelete( "spr_scared_amuletelement_4_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletelement_4_1", get_amuletelement_4_1_inv );
  cmn.AddSubscriber( "get_amuletelement_4_1", get_amuletelement_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caseelement_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caseelement_4_3" ] = {
    type = "get",
    get_obj = "spr_scared_caseelement_4_3",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
    
  local get_caseelement_4_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_caseelement_4_3", "spr_scared_caseelement_4_3" );
  
  end;
  
  local get_caseelement_4_3_closezz = function ()
  
    ObjDelete( "gfx_scared_caseelement_4_3" );
    ObjDelete( "anm_scared_nippers" );
  
  end;
  
  cmn.AddSubscriber( "get_caseelement_4_3", get_caseelement_4_3_inv );
  cmn.AddSubscriber( "get_caseelement_4_3", get_caseelement_4_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caseelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caseelement_4_1" ] = {
    type = "get",
    get_obj = "spr_videocamera_caseelement_4_1",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
    
  local get_caseelement_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_caseelement_4_1", "spr_videocamera_caseelement_4_1" );
  
  end;
  
  local get_caseelement_4_1_closezz = function ()
  
    ObjDelete( "gfx_videocamera_caseelement_4_1" );
    ObjDelete("spr_videocamera_caseelement_shadow");
    ObjDelete( "spr_hall_4_videocamera_element" );
  
  end;
  
  cmn.AddSubscriber( "get_caseelement_4_1", get_caseelement_4_1_inv );
  cmn.AddSubscriber( "get_caseelement_4_1", get_caseelement_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_micholder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_micholder" ] = {
    type = "get",
    get_obj = "spr_videocamera_micholder",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
    
  local get_micholder_inv = function ()
  
    interface.InventoryItemAdd( "inv_micholder", "spr_videocamera_micholder" );
    ObjSet( "inv_micholder", { drag = false });
    
  end;
  
  local get_micholder_closezz = function ()
  
    ObjDelete( "gfx_videocamera_micholder" );
    ObjDelete( "spr_videocamera_micholder_shadow" );
    ObjDelete( "spr_hall_4_videocamera_holder" );
  
  end;
  
  cmn.AddSubscriber( "get_micholder", get_micholder_inv );
  cmn.AddSubscriber( "get_micholder", get_micholder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_batteries_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_batteries_4" ] = {
    type = "get",
    get_obj = "spr_videocamera_batteries_4",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
    
  local get_batteries_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_batteries_4", "spr_videocamera_batteries_4" );
    ObjSet( "spr_brokenapparatus_4_plus_light", { alp = 1 });
  
  end;
  
  local get_batteries_4_closezz = function ()
  
    ObjDelete( "gfx_videocamera_batteries_4" );
    ObjDelete( "spr_videocamera_light_lanter");
    
    if cmn.IsEventDone("get_diode_4_2") then
      
      ObjDelete( "gzz_hall_4_videocamera" );
    
    end
    
  
  end;
  
  cmn.AddSubscriber( "get_batteries_4", get_batteries_4_inv );
  cmn.AddSubscriber( "get_batteries_4", get_batteries_4_inv, private.room_objnam  );
  cmn.AddSubscriber( "get_batteries_4", get_batteries_4_closezz, private.room_objname );
  cmn.AddSubscriber( "get_batteries_4_inv", get_batteries_4_inv, private.room_objname );
  cmn.AddSubscriber( "get_batteries_4_closezz", get_batteries_4_closezz, private.room_objname );

  ---
  --------------------------------------------------------------------------------------------
  -- function get_diode_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_diode_4_2" ] = {
    type = "get",
    get_obj = "spr_videocamera_diode_4_2",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
    
  local get_diode_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_diode_4_2", "spr_videocamera_diode_4_2" );
  
  end;
  
  local get_diode_4_2_closezz = function ()
  
    ObjDelete( "gfx_videocamera_diode_4_2" );
    ObjDelete( "spr_videocamera_diode_4_2_light" );
    
    if cmn.IsEventDone("get_batteries_4") then
      
      ObjDelete( "gzz_hall_4_videocamera" );
    
    end
    
  
  end;
  
  cmn.AddSubscriber( "get_diode_4_2", get_diode_4_2_inv );
  cmn.AddSubscriber( "get_diode_4_2", get_diode_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caseelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caseelement_4_2" ] = {
    type = "get",
    get_obj = "spr_orchestra_4_caseelement_4_2",
    room = private.room_objname,
    zz = "zz_orchestra_4",
    zz_gate = "gzz_hall_4_orchestra_4"
  };
    
  local get_caseelement_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_caseelement_4_2", "spr_orchestra_4_caseelement_4_2" );
  
  end;
  
  local get_caseelement_4_2_closezz = function ()
  
    ObjDelete( "gfx_orchestra_4_caseelement_4_2" );
    ObjDelete( "spr_orchestra_4_caseelement_4_2_shadow" );
    ObjDelete( "spr_hall_4_orchestra_4_part" );
  
  end;
  
  cmn.AddSubscriber( "get_caseelement_4_2", get_caseelement_4_2_inv );
  cmn.AddSubscriber( "get_caseelement_4_2", get_caseelement_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cup () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cup" ] = {
    type = "get",
    get_obj = "spr_orchestra_4_cup",
    room = private.room_objname,
    zz = "zz_orchestra_4",
    zz_gate = "gzz_hall_4_orchestra_4"
  };
    
  local get_cup_inv = function ()
  
    interface.InventoryItemAdd( "inv_cup", "spr_orchestra_4_cup" );
    ObjSet( "inv_cup", { drag = false } );
    
    if ( cmn.IsEventDone( "get_sedative") ) then
      ObjSet( "spr_cup_plus_light", { alp = 1 } );
    end;
    
  end;
  
  local get_cup_closezz = function ()
  
    ObjDelete( "gfx_orchestra_4_cup" );
    ObjDelete( "spr_orchestra_4_cup_shadow" );
    ObjDelete( "spr_hall_4_orchestra_4_cup" );
    ObjDelete( "gzz_hall_4_orchestra_4" );
  
  end;
  
  cmn.AddSubscriber( "get_cup", get_cup_inv );
  cmn.AddSubscriber( "get_cup", get_cup_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cutters_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cutters_4" ] = {
    type = "get",
    get_obj = "spr_equipment_4_cutters_4",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_cutters_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_cutters_4", "spr_equipment_4_cutters_4" );
  
  end;
  
  local get_cutters_4_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_cutters_4" );
    --ObjDelete( "spr_equipment_4_cutters_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_cutters_4", get_cutters_4_inv );
  cmn.AddSubscriber( "get_cutters_4", get_cutters_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver_4" ] = {
    type = "get",
    get_obj = "spr_equipment_4_screwdriver_4",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_screwdriver_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver_4", "spr_equipment_4_screwdriver_4" );
  
  end;
  
  local get_screwdriver_4_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_screwdriver_4" );
    --ObjDelete( "spr_equipment_4_screwdriver_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_screwdriver_4", get_screwdriver_4_inv );
  cmn.AddSubscriber( "get_screwdriver_4", get_screwdriver_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_diode_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_diode_4_1" ] = {
    type = "get",
    get_obj = "spr_equipment_4_diode_4_1",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_diode_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_diode_4_1", "spr_equipment_4_diode_4_1" );
  
  end;
  
  local get_diode_4_1_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_diode_4_1" );
    ObjDelete( "spr_equipment_4_diode_4_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_diode_4_1", get_diode_4_1_inv );
  cmn.AddSubscriber( "get_diode_4_1", get_diode_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenapparatus_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenapparatus_4" ] = {
    type = "get",
    get_obj = "spr_equipment_4_brokenapparatus_4",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_brokenapparatus_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenapparatus_4", "spr_equipment_4_brokenapparatus_4" );
    ObjSet( "inv_brokenapparatus_4", { drag = false });
    
  end;
  
  local get_brokenapparatus_4_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_brokenapparatus_4" );
    ObjDelete( "spr_hall_4_equipment_4_apparatus" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenapparatus_4", get_brokenapparatus_4_inv );
  cmn.AddSubscriber( "get_brokenapparatus_4", get_brokenapparatus_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel_4" ] = {
    type = "get",
    get_obj = "spr_equipment_4_chisel_4",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_chisel_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_chisel_4", "spr_equipment_4_chisel_4" );
  
  end;
  
  local get_chisel_4_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_chisel_4" );
  
  end;
  
  cmn.AddSubscriber( "get_chisel_4", get_chisel_4_inv );
  cmn.AddSubscriber( "get_chisel_4", get_chisel_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ax_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ax_4" ] = {
    type = "get",
    get_obj = "spr_equipment_4_ax_4",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_ax_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_ax_4", "spr_equipment_4_ax_4" );
  
  end;
  
  local get_ax_4_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_ax_4" );
    --ObjDelete( "spr_equipment_4_ax_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_ax_4", get_ax_4_inv );
  cmn.AddSubscriber( "get_ax_4", get_ax_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_anglegrinder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_anglegrinder" ] = {
    type = "get",
    get_obj = "spr_equipment_4_anglegrinder",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_anglegrinder_inv = function ()
  
    interface.InventoryItemAdd( "inv_anglegrinder", "spr_equipment_4_anglegrinder" );
    ObjSet("inv_anglegrinder", { drag = false });
    
  end;
  
  local get_anglegrinder_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_anglegrinder" );
    ObjDelete( "spr_hall_4_equipment_4_grinder" );
  
  end;
  
  cmn.AddSubscriber( "get_anglegrinder", get_anglegrinder_inv );
  cmn.AddSubscriber( "get_anglegrinder", get_anglegrinder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_solderingiron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_solderingiron" ] = {
    type = "get",
    get_obj = "spr_equipment_4_solderingiron",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
    
  local get_solderingiron_inv = function ()
  
    interface.InventoryItemAdd( "inv_solderingiron", "spr_equipment_4_solderingiron" );
  
  end;
  
  local get_solderingiron_closezz = function ()
  
    ObjDelete( "gfx_equipment_4_solderingiron" );
    ObjDelete( "spr_equipment_4_solderingiron_shadow" );
    ObjDelete( "spr_hall_4_equipment_4_copper" );
    
    if common_impl.IsGetCollect( "get_collect_2_4_6" ) then
      
      ObjDelete( "gzz_hall_4_equipment_4" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_solderingiron", get_solderingiron_inv );
  cmn.AddSubscriber( "get_solderingiron", get_solderingiron_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_6" ] = {
    type = "get",
    get_obj = "anm_hall_4_ectoplasm_4_6",
    room = private.room_objname,
    zz = "zz_hall_4",
    zz_gate = "gzz_hall_4_hall_4"
  };
    
  local get_ectoplasm_4_6_inv = function ()

    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_hall_4_ectoplasm_4_6", function() common.BlockGotoRoom(true); common_impl.Lock( false ); end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_6_closezz = function ()
  
    ObjDelete( "gfx_hall_4_ectoplasm" );
    --ObjDelete( "gzz_hall_4_hall_4" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_6", get_ectoplasm_4_6_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_6", get_ectoplasm_4_6_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_1 = function ()
  
    ObjDelete( "obj_hall_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_1", get_collect_morph_item_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_6 = function ()
  
    ObjDelete( "spr_equipment_4_collect_2" );
    
    if cmn.IsEventDone( "get_solderingiron") then
    
      ObjDelete("gzz_hall_4_equipment_4");
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_6", get_collect_2_4_6 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutters_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cutters_4" ] = {
    type = "use",
    inv_obj = "inv_cutters_4",
    use_place = "obj_scared_use_cutters_4",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
  local use_cutters_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_cutters_4" );
  
  end;
  local use_cutters_4_beg = function ()
  
    ObjDelete( "obj_scared_use_cutters_4" );
  
  end;
  local use_cutters_4_end = function ()
  
    ObjDelete( "spr_scared_man_cup" );
    ObjSet( "spr_scared_caseelement_4_3", { input = true, active = true } );
    ObjSet( "obj_scared_use_sedativecup", { input = true } );
    ObjSet( "anm_scared_chain", { frame = 125 });
    ObjSet( "anm_scared_nippers", { frame = 183 });
    ObjDelete( "spr_scared_nippers");
    --ObjDelete( "anm_scared_nippers");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cutters_4", use_cutters_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters_4", use_cutters_4_inv );
  cmn.AddSubscriber( "use_cutters_4", use_cutters_4_end, private.room_objname );
  cmn.AddSubscriber( "use_cutters_4_inv", use_cutters_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutters_4_beg", use_cutters_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters_4_end", use_cutters_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sedativecup () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sedativecup" ] = {
    type = "use",
    inv_obj = "inv_sedativecup",
    use_place = "obj_scared_use_sedativecup",
    room = private.room_objname,
    zz = "zz_scared",
    zz_gate = "gzz_hall_4_scared"
  };
  local use_sedativecup_inv = function ()
  
    interface.InventoryItemRemove( "inv_sedativecup" );
  
  end;
  local use_sedativecup_beg = function ()
  
    ObjDelete( "obj_scared_use_sedativecup" );
  
  end;
  local use_sedativecup_end = function ()
  
    ObjDelete( "gzz_hall_4_scared" );
    ObjDelete( "anm_scared_cup");
    ObjDelete( "anm_scared_chain");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sedativecup", use_sedativecup_beg, private.room_objname );
  cmn.AddSubscriber( "use_sedativecup", use_sedativecup_inv );
  cmn.AddSubscriber( "use_sedativecup", use_sedativecup_end, private.room_objname );
  cmn.AddSubscriber( "use_sedativecup_inv", use_sedativecup_inv, private.room_objname );
  cmn.AddSubscriber( "use_sedativecup_beg", use_sedativecup_beg, private.room_objname );
  cmn.AddSubscriber( "use_sedativecup_end", use_sedativecup_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_4_1" ] = {
    type = "use",
    inv_obj = "inv_screwdriver_4",
    use_place = "obj_videocamera_use_screwdriver_4",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
  local use_screwdriver_4_1_inv = function ()
  
  end;
  local use_screwdriver_4_1_beg = function ()
  
    ObjDelete( "obj_videocamera_use_screwdriver_4" );
  
  end;
  local use_screwdriver_4_1_end = function ()
  
    ObjSet( "spr_videocamera_batteries_4", { input = true, active = true } );
    ObjDelete( "spr_videocamera_cover_battery");
    ObjDelete( "vid_videocamera_use_screwdriver_4");
    ObjDelete( "spr_videocamera_screwdriver");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_4_1", use_screwdriver_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_1", use_screwdriver_4_1_inv );
  cmn.AddSubscriber( "use_screwdriver_4_1", use_screwdriver_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_1_inv", use_screwdriver_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_1_beg", use_screwdriver_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_4_1_end", use_screwdriver_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hexagon_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexagon_4" ] = {
    type = "use",
    inv_obj = "inv_hexagon_4",
    use_place = "obj_videocamera_use_hexagon_4",
    room = private.room_objname,
    zz = "zz_videocamera",
    zz_gate = "gzz_hall_4_videocamera"
  };
  local use_hexagon_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_hexagon_4" );
  
  end;
  local use_hexagon_4_beg = function ()
  
    ObjDelete( "obj_videocamera_use_hexagon_4" );
  
  end;
  local use_hexagon_4_end = function ()
  
    ObjSet( "spr_videocamera_diode_4_2", { input = true, active = true } );
    ObjDelete( "spr_videocamera_hexagon");
    ObjDelete( "spr_videocamera_cover_diod");
    ObjSet( "spr_videocamera_diode_4_2_light", { active = true, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexagon_4", use_hexagon_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_4", use_hexagon_4_inv );
  cmn.AddSubscriber( "use_hexagon_4", use_hexagon_4_end, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_4_inv", use_hexagon_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_4_beg", use_hexagon_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagon_4_end", use_hexagon_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_holderwithbucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_holderwithbucket" ] = {
    type = "use",
    inv_obj = "inv_holderwithbucket",
    use_place = "obj_orchestra_4_use_holderwithbucket",
    room = private.room_objname,
    zz = "zz_orchestra_4",
    zz_gate = "gzz_hall_4_orchestra_4"
  };
  local use_holderwithbucket_inv = function ()
  
    interface.InventoryItemRemove( "inv_holderwithbucket" );
  
  end;
  local use_holderwithbucket_beg = function ()
  
    ObjDelete( "obj_orchestra_4_use_holderwithbucket" );
  
  end;
  local use_holderwithbucket_end = function ()
  
    ObjSet( "obj_orchestra_4_use_elf_4", { input = true } );
    ObjSet( "obj_orchestra_4_bucket", { alp = 1 } );
    ObjSet( "obj_hall_4_orchestra_4_bucket", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holderwithbucket", use_holderwithbucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_holderwithbucket", use_holderwithbucket_inv );
  cmn.AddSubscriber( "use_holderwithbucket", use_holderwithbucket_end, private.room_objname );
  cmn.AddSubscriber( "use_holderwithbucket_inv", use_holderwithbucket_inv, private.room_objname );
  cmn.AddSubscriber( "use_holderwithbucket_beg", use_holderwithbucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_holderwithbucket_end", use_holderwithbucket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4_1" ] = {
    type = "use",
    inv_obj = "inv_elf_4",
    use_place = "obj_orchestra_4_use_elf_4",
    room = private.room_objname,
    zz = "zz_orchestra_4",
    zz_gate = "gzz_hall_4_orchestra_4"
  };
  local use_elf_4_1_inv = function ()
  
  end;
  local use_elf_4_1_beg = function ()
  
    ObjDelete( "obj_orchestra_4_use_elf_4" );
  
  end;
  local use_elf_4_1_end = function ()
    
    ObjSet( "obj_orchestra_4_bucket", { alp = 1 });
    --ObjSet( "obj_orchestra_4_cup", { alp = 1 });
    ObjSet( "spr_hall_4_orchestra_4_cup", { alp = 1 });
    ObjSet( "spr_orchestra_4_cup", { input = true, active = true } );
    ObjDelete( "vid_orchestra_4_elf" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4_1", use_elf_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_1", use_elf_4_1_inv );
  cmn.AddSubscriber( "use_elf_4_1", use_elf_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_1_inv", use_elf_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_1_beg", use_elf_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_1_end", use_elf_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bagbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bagbutton" ] = {
    type = "use",
    inv_obj = "inv_bagbutton",
    use_place = "obj_equipment_4_use_bagbutton",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_bagbutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_bagbutton" );
  
  end;
  local use_bagbutton_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_bagbutton" );
  
  end;
  local use_bagbutton_end = function ()
    
    ObjSet( "spr_equipment_4_bagbutton", { alp = 1 } );
    ObjSet( "obj_equipment_4_clk_bag", { input = true } );
    ObjSet( "spr_hall_4_equipment_4_button", { alp = 1 } ); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bagbutton", use_bagbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagbutton", use_bagbutton_inv );
  cmn.AddSubscriber( "use_bagbutton", use_bagbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_bagbutton_inv", use_bagbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_bagbutton_beg", use_bagbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagbutton_end", use_bagbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caseelement_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caseelement_4_3" ] = {
    type = "use",
    inv_obj = "inv_caseelement_4_3",
    use_place = "obj_equipment_4_use_caseelement_4_3",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_caseelement_4_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_caseelement_4_3" );
  
  end;
  local use_caseelement_4_3_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_caseelement_4_3" );
  
  end;
  local use_caseelement_4_3_end = function ()
  
    ObjSet( "spr_equipment_4_caseelement_4_3", { alp = 1 } );
    ObjSet( "spr_hall_4_equipment_4_part_3", { alp = 1 } );
    
    if cmn.IsEventDone( "use_caseelement_4_1" ) and cmn.IsEventDone( "use_caseelement_4_2" ) then
      
      ObjMultiSet( { { "obj_equipment_4_case_open", { alp = 1, input = true } },
                     { "gfx_equipment_4_screwdriver_4", { active = true } },
                     { "gfx_equipment_4_chisel_4", { active = true } },
                     { "gfx_equipment_4_apparatus_4", { active = true } },
                   } );
                   
      ObjDelete( "spr_equipment_4_over_zz_case_1" );
      ObjDelete( "spr_equipment_4_over_zz_case_2" );
      ObjDelete( "obj_hall_4_equipment_4_part" );
      ObjSet( "spr_hall_4_equipment_4_open_1", { alp = 1 });
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_caseelement_4_3", use_caseelement_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_3", use_caseelement_4_3_inv );
  cmn.AddSubscriber( "use_caseelement_4_3", use_caseelement_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_3_inv", use_caseelement_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_3_beg", use_caseelement_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_3_end", use_caseelement_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caseelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caseelement_4_1" ] = {
    type = "use",
    inv_obj = "inv_caseelement_4_1",
    use_place = "obj_equipment_4_use_caseelement_4_1",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_caseelement_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_caseelement_4_1" );
  
  end;
  local use_caseelement_4_1_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_caseelement_4_1" );
  
  end;
  local use_caseelement_4_1_end = function ()
  
    ObjSet( "spr_equipment_4_caseelement_4_1", { alp = 1 } );
    ObjSet( "spr_hall_4_equipment_4_part_1", { alp = 1 } );
    
    if cmn.IsEventDone( "use_caseelement_4_3" ) and cmn.IsEventDone( "use_caseelement_4_2" ) then
      
      ObjMultiSet( { { "obj_equipment_4_case_open", { alp = 1, input = true } },
                     { "gfx_equipment_4_screwdriver_4", { active = true } },
                     { "gfx_equipment_4_chisel_4", { active = true } },
                     { "gfx_equipment_4_apparatus_4", { active = true } },
                   } );
                   
                   
      ObjDelete( "spr_equipment_4_over_zz_case_1" );
      ObjDelete( "spr_equipment_4_over_zz_case_2" );
      ObjDelete( "obj_hall_4_equipment_4_part" );
      ObjSet( "spr_hall_4_equipment_4_open_1", { alp = 1 }); 
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_caseelement_4_1", use_caseelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_1", use_caseelement_4_1_inv );
  cmn.AddSubscriber( "use_caseelement_4_1", use_caseelement_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_1_inv", use_caseelement_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_1_beg", use_caseelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_1_end", use_caseelement_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caseelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caseelement_4_2" ] = {
    type = "use",
    inv_obj = "inv_caseelement_4_2",
    use_place = "obj_equipment_4_use_caseelement_4_2",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_caseelement_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_caseelement_4_2" );
  
  end;
  local use_caseelement_4_2_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_caseelement_4_2" );
  
  end;
  local use_caseelement_4_2_end = function ()
  
    ObjSet( "spr_equipment_4_caseelement_4_2", { alp = 1 } );
    ObjSet( "spr_hall_4_equipment_4_part_2", { alp = 1 } );
    
    if cmn.IsEventDone( "use_caseelement_4_1" ) and cmn.IsEventDone( "use_caseelement_4_3" ) then
      
      ObjMultiSet( { { "obj_equipment_4_case_open", { alp = 1, input = true } },
                     { "gfx_equipment_4_screwdriver_4", { active = true } },
                     { "gfx_equipment_4_chisel_4", { active = true } },
                     { "gfx_equipment_4_apparatus_4", { active = true } },
                   } );
                   
      ObjDelete( "spr_equipment_4_over_zz_case_1" );
      ObjDelete( "spr_equipment_4_over_zz_case_2" );
      ObjDelete( "obj_hall_4_equipment_4_part" );
      ObjSet( "spr_hall_4_equipment_4_open_1", { alp = 1 });
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_caseelement_4_2", use_caseelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_2", use_caseelement_4_2_inv );
  cmn.AddSubscriber( "use_caseelement_4_2", use_caseelement_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_2_inv", use_caseelement_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_2_beg", use_caseelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_caseelement_4_2_end", use_caseelement_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cofferelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cofferelement_4_1" ] = {
    type = "use",
    inv_obj = "inv_cofferelement_4_1",
    use_place = "obj_equipment_4_use_cofferelement_4_1",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_cofferelement_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_cofferelement_4_1" );
  
  end;
  local use_cofferelement_4_1_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_cofferelement_4_1" );
  
  end;
  local use_cofferelement_4_1_end = function ()
  
    ObjSet( "spr_equipment_4_cofferelement_4_1", { alp = 1 } );
    
    if cmn.IsEventDone( "use_cofferelement_4_2" ) then
      
      ObjDelete( "spr_equipment_4_coffer_cover" );
      ObjDelete( "spr_hall_4_equipment_4_cover" );
      ObjSet( "obj_equipment_4_mmg", { alp = 1, input = true } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cofferelement_4_1", use_cofferelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_1", use_cofferelement_4_1_inv );
  cmn.AddSubscriber( "use_cofferelement_4_1", use_cofferelement_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_1_inv", use_cofferelement_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_1_beg", use_cofferelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_1_end", use_cofferelement_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cofferelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cofferelement_4_2" ] = {
    type = "use",
    inv_obj = "inv_cofferelement_4_2",
    use_place = "obj_equipment_4_use_cofferelement_4_2",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_cofferelement_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_cofferelement_4_2" );
  
  end;
  local use_cofferelement_4_2_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_cofferelement_4_2" );
  
  end;
  local use_cofferelement_4_2_end = function ()
  
    ObjSet( "spr_equipment_4_cofferelement_4_2", { alp = 1 } );
    
    if cmn.IsEventDone( "use_cofferelement_4_1" ) then
      
      ObjDelete( "spr_equipment_4_coffer_cover" );
      ObjDelete( "spr_hall_4_equipment_4_cover" );
      ObjSet( "obj_equipment_4_mmg", { alp = 1, input = true } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cofferelement_4_2", use_cofferelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_2", use_cofferelement_4_2_inv );
  cmn.AddSubscriber( "use_cofferelement_4_2", use_cofferelement_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_2_inv", use_cofferelement_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_2_beg", use_cofferelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cofferelement_4_2_end", use_cofferelement_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_solderingironemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_solderingironemblem" ] = {
    type = "use",
    inv_obj = "inv_solderingironemblem",
    use_place = "obj_equipment_4_use_solderingironemblem",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
  local use_solderingironemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_solderingironemblem" );
  
  end;
  local use_solderingironemblem_beg = function ()
  
    ObjDelete( "obj_equipment_4_use_solderingironemblem" );
  
  end;
  local use_solderingironemblem_end = function ()
  
    ObjSet( "obj_equipment_4_case_emblem_open", { input = true, alp = 1 } );
    ObjSet( "spr_hall_4_equipment_4_open_2", { alp = 1 } );
    ObjSet( "gfx_equipment_4_solderingiron", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_solderingironemblem", use_solderingironemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_solderingironemblem", use_solderingironemblem_inv );
  cmn.AddSubscriber( "use_solderingironemblem", use_solderingironemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_solderingironemblem_inv", use_solderingironemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_solderingironemblem_beg", use_solderingironemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_solderingironemblem_end", use_solderingironemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apparatus_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_apparatus_4_1" ] = {
    type = "use",
    inv_obj = "inv_apparatus_4",
    use_place = "obj_hall_4_use_apparatus_4",
    room = private.room_objname
  };
  local use_apparatus_4_1_inv = function ()
  
  end;
  local use_apparatus_4_1_beg = function ()
  
    ObjDelete( "obj_hall_4_use_apparatus_4" );
  
  end;
  local use_apparatus_4_1_end = function ()
  
    ObjSet( "gmg_hall_4_apparatusroom_4_1", { input = true, active = true } );
    ObjDelete( "anm_hall_4_apparatus" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apparatus_4_1", use_apparatus_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_1", use_apparatus_4_1_inv );
  cmn.AddSubscriber( "use_apparatus_4_1", use_apparatus_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_1_inv", use_apparatus_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_1_beg", use_apparatus_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_1_end", use_apparatus_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_6" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname
  };

  local use_searcher_4_6_inv = function ()
  
    if ( levelext_inv.IsUseAllSearchers( 6 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;
  
  end;
  local use_searcher_4_6_beg = function ()
  
    ObjDelete( "obj_hall_4_use_searcher" );
  
  end;
  local use_searcher_4_6_end = function ()
 
  ObjDelete( "obj_hall_4_use_searcher" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_6", use_searcher_4_6_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_6", use_searcher_4_6_inv );
  cmn.AddSubscriber( "use_searcher_4_6", use_searcher_4_6_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_6_inv", use_searcher_4_6_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_6_beg", use_searcher_4_6_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_6_end", use_searcher_4_6_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bag_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag_4" ] = {
    type = "click",
    use_place = "obj_equipment_4_clk_bag",
    room = private.room_objname,
    zz = "zz_equipment_4",
    zz_gate = "gzz_hall_4_equipment_4"
  };
 
  local clk_bag_4_beg = function ()
  
    ObjSet( "obj_equipment_4_clk_bag", { input = false } );
  
  end;
  local clk_bag_4_end = function ()
  
    ObjSet( "obj_equipment_4_bag_open", { alp = 1, input = true } );
    ObjSet( "gfx_equipment_4_diode_4_1", { active = true } );
    ObjSet( "gfx_equipment_4_cutters_4", { active = true } );
    
    ObjDelete( "spr_equipment_4_bag_over" );
    ObjDelete( "spr_equipment_4_bagbutton" );
    ObjDelete( "spr_hall_4_equipment_4_button" );
    ObjSet( "spr_hall_4_equipment_4_open_4", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bag_4", clk_bag_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_4", clk_bag_4_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_4_beg", clk_bag_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_4_end", clk_bag_4_end, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function vid_hall_4_incident () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_hall_4_incident" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_hall_4_incident",
    
  };
  local vid_hall_4_incident_end = function ()
  
    ObjSet( "rm_hall_4", { color_r = 1, color_g = 1, color_b = 1 } );
    ObjDelete( "anm_hall_4_ghost" );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_hall_4_incident", vid_hall_4_incident_end, private.room_objname  );
  cmn.AddSubscriber( "vid_hall_4_incident_end", vid_hall_4_incident_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_hall_4_superdevice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_hall_4_superdevice" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_hall_4_superdevice",
    
  };
  local vid_hall_4_superdevice_end = function ()
  
    ObjSet( "spr_equipment_4_brokenapparatus_4", { active = true, input = true } ); 
    ObjSet( "spr_equipment_4_chisel_4", { active = true, input = true } );
    ObjSet( "spr_equipment_4_screwdriver_4", { active = true, input = true } );
     
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_hall_4_superdevice", vid_hall_4_superdevice_end, private.room_objname  );
  cmn.AddSubscriber( "vid_hall_4_superdevice_end", vid_hall_4_superdevice_end, private.room_objname  );
  ----------------------------------------------------------------------------------------------
  -- function dlg_hall_4_workman () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_hall_4_workman" ] = {
    type = "click",
    use_place = "obj_hall_4_workman",
    room = private.room_objname
  };
  local dlg_hall_4_workman_beg = function ()

    ObjDelete( "obj_hall_4_workman");
    
  end;

  local dlg_hall_4_workman_inv = function ()
  
    interface.InventoryItemAdd( "inv_corridorkey_4","spr_hall_4_workman_key");
    ObjSet( "anm_hall_4_man", { alp = 1 });
    ObjSet( "obj_hall_4_workman_bbt", { input = true });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_hall_4_workman_beg", dlg_hall_4_workman_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_hall_4_workman_inv", dlg_hall_4_workman_inv );
  cmn.AddSubscriber( "dlg_hall_4_workman", dlg_hall_4_workman_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_hall_4_workman", dlg_hall_4_workman_inv );
  --------------------------------------------------------------------------------------------
  -- function win_trunk_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_trunk_4" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_equipment_4_mmg",
    zz_gate = "gzz_hall_4_equipment_4",
    zz = "zz_equipment_4"

  };

  local win_trunk_4 = function ()
  
    if ( cmn.IsEventDone( "win_trunk_4" ) ) then
      
      ObjSet( "obj_equipment_4_coffer_open", { alp = 1, input = true } );
      ObjSet( "spr_hall_4_equipment_4_open_3", { alp = 1 });  
      ObjSet( "gfx_equipment_4_ax_4", { active = true });
      ObjSet( "gfx_equipment_4_anglegrinder", { active = true });   
      
      ObjDelete( "obj_equipment_4_mmg" );
      
    else 
      
      local current = ng_global.progress["ext"]["win_trunk_4"].state;  
      
      for i = 1, current do
        
        ObjSet( "spr_equipment_4_mmg_symbol_"..private.equipment_mmg_sequence[1][i].."_right", { alp = 1 } );          
        ObjSet( "spr_equipment_4_mmg_symbol_"..private.equipment_mmg_sequence[2][i].."_right", { alp = 1 } );
                
      end;  
      
      ObjSet( "spr_equipment_4_mmg_symbol_"..private.equipment_mmg_sequence[1][current + 1].."_current", { alp = 1 } ); 

      ObjSet( "spr_equipment_4_mmg_arrow", { ang = private.equipment_mmg_angles[ private.equipment_mmg_sequence[1][current + 1] ] } );    
    
      if ( current ~= 0 ) then
      
         ObjSet( "spr_equipment_4_mmg_symbol_2_current", { alp = 0 } );
      
      end;  
    
    end;
  
  end;
 
  cmn.AddSubscriber( "win_trunk_4", win_trunk_4, private.room_objname );   
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_equipment_4" );
  subroom.Define( "zz_scared" );
  ---------------------------------------------------------------------------------------------
  function zz_scared.Open()   
      
    if not cmn.IsEventDone( "use_sedativecup" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_warnington_scary_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_warnington_scary_loc_env", 0 );
    
    end;
     
  end; 
  ---------------------------------------------------------------------------------------------
  function zz_scared.Close()
    
    if cmn.IsEventDone( "use_sedativecup" ) and  not cmn.IsEventDone( "dlg_hall_4_workman" ) then
      
      interface.KeyTaskDone( 'give_sedative', true, function() private.dlg_hall_4_workman(); end ); 
      
    end;
      
    if not cmn.IsEventDone( "use_sedativecup" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_warnington_scary_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_warnington_scary_zz_env", 0 );
    
    end;
     
  end;    
  ---------------------------------------------------------------------------------------------
  function zz_equipment_4.Open()
    
    if cmn.IsEventDone( "use_cofferelement_4_1" ) and cmn.IsEventDone( "use_cofferelement_4_2" ) and not cmn.IsEventDone( "win_trunk_4" ) then
      
       cmn.MiniGameShow( "trunk_4" );
      
    end;
     
  end;
  --------------------------------------------------------------------------------------------- 
  function zz_equipment_4.Close()
    
    if cmn.IsEventDone( "use_cofferelement_4_1" ) and cmn.IsEventDone( "use_cofferelement_4_2" ) and not cmn.IsEventDone( "win_trunk_4" ) then
      
      cmn.MiniGameHide( "trunk_4" );
      
    end;
     
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_hall_4();

end;
--*********************************************************************************************************************
function public.PreOpen()

    cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
    cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
    if ( not cmn.IsEventDone( "vid_hall_4_incident" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( "rm_hall_4", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_hall_4_incident", private.room_objname);
    ObjSet( "tmr_hall_4_incident",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_hall_4_incident(); end
    } );
      
  end;
  
  if not cmn.IsEventDone( "dlg_hall_4_workman" ) and
    cmn.IsEventDone( "use_sedativecup" ) then

    private.dlg_hall_4_workman();
    
  end; 
  
  common_impl.MorphItemMorphing();
 
  common_impl.EnvPlay( { "common/audio/levelext/aud_hall_4_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "win_apparatusroom_4_1" ) and cmn.IsEventDone( "vid_hall_4_incident" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_phenomenon_hall_env", 1, "", 0 );
    
  end;
  
  if not cmn.IsEventDone( "use_sedativecup" ) and cmn.IsEventDone( "vid_hall_4_incident" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_warnington_scary_loc_env", 1, "", 0 );
    
  end;
  
  if not ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].anim and cmn.IsEventDone( "win_apparatusroom_4_1") then
    
    local func_after = function()
      
      common_impl.Lock(false);
      ng_global.progress[ "ext" ][ "win_apparatusroom_4_1" ].anim = true;
      cmn.CallEventHandler( "win_apparatusroom_4_1" );
      
    end;
    common_impl.Lock(true);
    ObjSet( "anm_hall_4_apparatus_2", {alp=1});
    AnimPlay( "anm_hall_4_apparatus_2", "DoAnim", func_after );
    common_impl.StopAudio( "env", "common/audio/levelext/aud_phenomenon_hall_env", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_remove_anomaly", 0, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/levelext/aud_phenomenon_hall_env", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cutters_4()

  local item = "inv_cutters_4";

  if ( common.ApplyObj( item, "obj_scared_use_cutters_4", true ) ) then

    cmn.CallEventHandler( "use_cutters_4_inv" );
    cmn.CallEventHandler( "use_cutters_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cutters_4" );
      cmn.CallEventHandler( "use_cutters_4_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_cutters_scared", 0, "", 0 );
    AnimPlay( "anm_scared_nippers", "DoAnim", func_after );
    AnimPlay( "anm_scared_chain", "DoAnim", "" );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_scared", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_scared", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sedativecup()

  local item = "inv_sedativecup";

  if ( common.ApplyObj( item, "obj_scared_use_sedativecup", true ) and cmn.IsEventDone("use_cutters_4") and cmn.IsEventDone("get_caseelement_4_3") and cmn.IsEventDone("get_amuletelement_4_1")
    and cmn.IsEventDone("get_thermos_4") and cmn.IsEventDone("get_bagbutton") ) then

    cmn.CallEventHandler( "use_sedativecup_inv" );
    cmn.CallEventHandler( "use_sedativecup_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_sedativecup" );
      cmn.CallEventHandler( "use_sedativecup_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
  
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_sedativecup_scared", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/levelext/aud_warnington_scary_zz_env", 0 );
    
      ObjSet( "anm_scared_sit", { alp = 0 });
      ObjSet( "anm_scared_cup", { alp = 1, playing = true, endtrig = func_after });
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_scared", false ) and cmn.IsEventDone("use_cutters_4") and cmn.IsEventDone("get_caseelement_4_3") and cmn.IsEventDone("get_amuletelement_4_1")
    and cmn.IsEventDone("get_thermos_4") and cmn.IsEventDone("get_bagbutton") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_scared", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_4_1()

  local item = "inv_screwdriver_4";

  if ( common.ApplyObj( item, "obj_videocamera_use_screwdriver_4", true ) ) then

    interface.InventoryItemRemove( "inv_screwdriver_4" );
    cmn.CallEventHandler( "use_screwdriver_4_1_inv" );
    cmn.CallEventHandler( "use_screwdriver_4_1_beg" );
    
    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_screwdriver_4_1" );
        cmn.CallEventHandler( "use_screwdriver_4_1_end" );
          
      end;  
  
      interface.InventoryItemAdd( "inv_screwdriver_4", "spr_videocamera_srew" );
      
      ObjAnimate( "spr_videocamera_cover_battery", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1,
        0.3, 0, 0
       
      } );
    
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_screwdriver_videocamera", 0, "", 0 );
  
  VidPlay( "vid_videocamera_use_screwdriver_4", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_videocamera", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videocamera", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hexagon_4()

  local item = "inv_hexagon_4";

  if ( common.ApplyObj( item, "obj_videocamera_use_hexagon_4", true ) and cmn.IsEventDone( "get_micholder") ) then

    cmn.CallEventHandler( "use_hexagon_4_inv" );
    cmn.CallEventHandler( "use_hexagon_4_beg" );

    local func_after = function ()
  
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_hexagon_4" );
        cmn.CallEventHandler( "use_hexagon_4_end" );
        
      end; 
      
      ObjAnimate( "spr_videocamera_cover_diod", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      --ObjAnimate( "spr_videocamera_hexagon", "alp", 0, 0, "",
      --{ 
      --  0.0, 0, 1.0, 
      --  0.3, 0, 0.0
      --} );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_hexagon_videocamera", 0, "", 0 );
  
  VidPlay( "vid_videocamera_use_hexagon_4", func_after ); 
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_videocamera", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videocamera", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_holderwithbucket()

  local item = "inv_holderwithbucket";

  if ( common.ApplyObj( item, "obj_orchestra_4_use_holderwithbucket", true ) ) then

    cmn.CallEventHandler( "use_holderwithbucket_inv" );
    cmn.CallEventHandler( "use_holderwithbucket_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_holderwithbucket" );
      cmn.CallEventHandler( "use_holderwithbucket_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_holderwithbucket_orchestra_4", 0, "", 0 );
    
    ObjAnimate( "obj_orchestra_4_bucket", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_orchestra_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_orchestra_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4_1()

  local item = "inv_elf_4";

  if ( common.ApplyObj( item, "obj_orchestra_4_use_elf_4", true ) and cmn.IsEventDone("use_holderwithbucket") ) then

    cmn.CallEventHandler( "use_elf_4_1_inv" );
    cmn.CallEventHandler( "use_elf_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_4_1" );
      cmn.CallEventHandler( "use_elf_4_1_end" );
      ObjSet( "obj_orchestra_4_bucket", { alp = 1 });
      ObjSet( "spr_orchestra_4_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_4", "spr_orchestra_4_elf", nil, "video" );
      private.get_cup();
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_orchestra_4_elf", 0, "", 0 );
    interface.InventoryItemRemove( "inv_elf_4" );
    ObjSet( "obj_orchestra_4_bucket", { alp = 0 });
    ObjSet( "obj_orchestra_4_cup", { alp = 0, pos_x = - 197,pos_y = 141 });
    ObjSet( "vid_orchestra_4_elf", { alp = 1 });
    VidPlay( "vid_orchestra_4_elf", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_orchestra_4", false ) and cmn.IsEventDone("use_holderwithbucket") and not cmn.IsEventDone( "use_elf_4_1" )  then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_orchestra_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bagbutton()

  local item = "inv_bagbutton";

  if ( common.ApplyObj( item, "obj_equipment_4_use_bagbutton", true ) ) then

    cmn.CallEventHandler( "use_bagbutton_inv" );
    cmn.CallEventHandler( "use_bagbutton_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bagbutton" );
      cmn.CallEventHandler( "use_bagbutton_end" );        

    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_bagbutton_equipment_4", 0, "", 0 );
  
    ObjAnimate( "spr_equipment_4_bagbutton", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );      
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_caseelement_4_3()

  local item = "inv_caseelement_4_3";

  if ( common.ApplyObj( item, "obj_equipment_4_use_caseelement_4_3", true ) ) then

    cmn.CallEventHandler( "use_caseelement_4_3_inv" );
    cmn.CallEventHandler( "use_caseelement_4_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_caseelement_4_3" );
      cmn.CallEventHandler( "use_caseelement_4_3_end" );
      
      if( cmn.IsEventDone("use_caseelement_4_2") and cmn.IsEventDone("use_caseelement_4_1") )then
        
        common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_caseelement_equipment_4", 0, "", 0 );
        
        private.vid_hall_4_superdevice();
        
      end;
    
    end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_caseelement_equipment_4", 0, "", 0 );
  
  ObjAnimate( "spr_equipment_4_caseelement_4_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_caseelement_4_1()

  local item = "inv_caseelement_4_1";

  if ( common.ApplyObj( item, "obj_equipment_4_use_caseelement_4_1", true ) ) then

    cmn.CallEventHandler( "use_caseelement_4_1_inv" );
    cmn.CallEventHandler( "use_caseelement_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_caseelement_4_1" );
      cmn.CallEventHandler( "use_caseelement_4_1_end" );
      
      if( cmn.IsEventDone("use_caseelement_4_2") and cmn.IsEventDone("use_caseelement_4_3") )then
        
        common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_caseelement_equipment_4", 0, "", 0 );
        
        private.vid_hall_4_superdevice();
        
      end;
      
    end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_caseelement_equipment_4", 0, "", 0 );
  
  ObjAnimate( "spr_equipment_4_caseelement_4_1", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_caseelement_4_2()

  local item = "inv_caseelement_4_2";

  if ( common.ApplyObj( item, "obj_equipment_4_use_caseelement_4_2", true ) ) then

    cmn.CallEventHandler( "use_caseelement_4_2_inv" );
    cmn.CallEventHandler( "use_caseelement_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_caseelement_4_2" );
      cmn.CallEventHandler( "use_caseelement_4_2_end" );
      
      if( cmn.IsEventDone("use_caseelement_4_1") and cmn.IsEventDone("use_caseelement_4_3") )then
        
        common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_caseelement_equipment_4", 0, "", 0 );
        
        private.vid_hall_4_superdevice();
        
      end;
    
    end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_caseelement_equipment_4", 0, "", 0 );
  
  ObjAnimate( "spr_equipment_4_caseelement_4_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cofferelement_4_1()

  local item = "inv_cofferelement_4_1";

  if ( common.ApplyObj( item, "obj_equipment_4_use_cofferelement_4_1", true ) ) then

    cmn.CallEventHandler( "use_cofferelement_4_1_inv" );
    cmn.CallEventHandler( "use_cofferelement_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cofferelement_4_1" );
      cmn.CallEventHandler( "use_cofferelement_4_1_end" );
      
      if ( cmn.IsEventDone( "use_cofferelement_4_2" ) ) then
        
        ng_global.progress["ext"]["win_trunk_4"].state = 0;
        
        cmn.MiniGameShow( 'trunk_4' );
        common_impl.PassingMgStart( "trunk_4" );
        
      end;
      
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_cofferelement_equipment_4", 0, "", 0 );
  
    ObjAnimate( "spr_equipment_4_cofferelement_4_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cofferelement_4_2()

  local item = "inv_cofferelement_4_2";

  if ( common.ApplyObj( item, "obj_equipment_4_use_cofferelement_4_2", true ) ) then

    cmn.CallEventHandler( "use_cofferelement_4_2_inv" );
    cmn.CallEventHandler( "use_cofferelement_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cofferelement_4_2" );
      cmn.CallEventHandler( "use_cofferelement_4_2_end" );
      
      if ( cmn.IsEventDone( "use_cofferelement_4_1" ) ) then
        
        ng_global.progress["ext"]["win_trunk_4"].state = 0;
        
        cmn.MiniGameShow( 'trunk_4' );
        common_impl.PassingMgStart( "trunk_4" );
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_cofferelement_equipment_4", 0, "", 0 );
  
    ObjAnimate( "spr_equipment_4_cofferelement_4_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_solderingironemblem()

  local item = "inv_solderingironemblem";

  if ( common.ApplyObj( item, "obj_equipment_4_use_solderingironemblem", true ) ) then

    cmn.CallEventHandler( "use_solderingironemblem_inv" );
    cmn.CallEventHandler( "use_solderingironemblem_beg" );

    local func_after = function ()
      
      local func_end = function ()
  
        common_impl.Lock( false );
        cmn.SetEventDone( "use_solderingironemblem" );
        cmn.CallEventHandler( "use_solderingironemblem_end" );
        
      end;
          
      ObjAnimate( "obj_equipment_4_case_emblem_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_solderingironemblem_equipment_4", 0, "", 0 );
  
    ObjAnimate( "spr_equipment_4_case_emblem", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_hall_4_equipment_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_equipment_4", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_apparatus_4_1()

  local item = "inv_apparatus_4";

  if ( common.ApplyObj( item, "obj_hall_4_use_apparatus_4", false ) ) then

    cmn.CallEventHandler( "use_apparatus_4_1_inv" );
    cmn.CallEventHandler( "use_apparatus_4_1_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_apparatus_4_1" );
        cmn.CallEventHandler( "use_apparatus_4_1_end" );
        cmn.GotoRoom( "mg_apparatusroom_4_1" );
        
      end;
    
      ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_end,
      { 
        0.0, 1, 1.0,1.0, 
        1.0, 1, 1.2,1.2
      } );

      ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
      { 
        0.0, 1,  0, 0, 
        1.0, 1,  -200, 0
      } );   
    
    end;
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_apparatus", 0, "", 0 );
    ObjSet( "anm_hall_4_apparatus", {alp = 1 });
    AnimPlay( "anm_hall_4_apparatus", "DoAnim", "" );
    ObjSet( "tmr_hall_4_apparatus", { playing = true, time = 2, endtrig = func_after });
    
    return true;
  
  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_6( func )

  cmn.CallEventHandler( "use_searcher_4_6_beg" );

  local func_after = function ()

    --common_impl.Lock( false );
    cmn.SetEventDone( "use_searcher_4_6" );
    cmn.CallEventHandler( "use_searcher_4_6_end" );
    private.get_ectoplasm_4_6();
     
    local delayfunc = function ()

      --common_impl.Lock( false );
      func();

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );
   
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );
  
  ObjSet( "anm_hall_4_ectoplasm_4_6", { visible = true, active = true, playing = true, endtrig = func_after } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bagbutton()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bagbutton" );
  cmn.CallEventHandler( "get_bagbutton" );

end;
--------------------------------------------------------------------------------------------
function private.get_thermos_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_thermos_4" );
  cmn.CallEventHandler( "get_thermos_4" );
  
  

end;
--------------------------------------------------------------------------------------------
function private.get_amuletelement_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_amuletelement_4_1" );
  cmn.CallEventHandler( "get_amuletelement_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_caseelement_4_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_caseelement_4_3" );
  cmn.CallEventHandler( "get_caseelement_4_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_caseelement_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_caseelement_4_1" );
  cmn.CallEventHandler( "get_caseelement_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_micholder()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_micholder" );
  cmn.CallEventHandler( "get_micholder" );

end;
--------------------------------------------------------------------------------------------
function private.get_batteries_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.CallEventHandler( "get_batteries_4_inv" );
  
  local func_after = function ()
  
    common_impl.Lock( false );
    cmn.SetEventDone( "get_batteries_4" );
    cmn.CallEventHandler( "get_batteries_4_closezz" );
    
    if cmn.IsEventDone("get_diode_4_2") then
      
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.Lock( true );
  
  ObjAnimate( "spr_videocamera_light_lanter", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0,

  } );

end;
--------------------------------------------------------------------------------------------
function private.get_diode_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_diode_4_2" );
  cmn.CallEventHandler( "get_diode_4_2" );
  if cmn.IsEventDone("get_batteries_4") then
      
      common.CloseSubRoom();
    
  end

end;
--------------------------------------------------------------------------------------------
function private.get_caseelement_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_caseelement_4_2" );
  cmn.CallEventHandler( "get_caseelement_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_cup()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cup" );
  cmn.CallEventHandler( "get_cup" );
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function private.get_cutters_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cutters_4" );
  cmn.CallEventHandler( "get_cutters_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_screwdriver_4" );
  cmn.CallEventHandler( "get_screwdriver_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_diode_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_diode_4_1" );
  cmn.CallEventHandler( "get_diode_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_brokenapparatus_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokenapparatus_4" );
  cmn.CallEventHandler( "get_brokenapparatus_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_chisel_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chisel_4" );
  cmn.CallEventHandler( "get_chisel_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_ax_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ax_4" );
  cmn.CallEventHandler( "get_ax_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_anglegrinder()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_anglegrinder" );
  cmn.CallEventHandler( "get_anglegrinder" );

end;
--------------------------------------------------------------------------------------------
function private.get_solderingiron()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_solderingiron" );
  cmn.CallEventHandler( "get_solderingiron" );
  if common_impl.IsGetCollect( "get_collect_2_4_6" ) then
      
      common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_6()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_6" );
  cmn.CallEventHandler( "get_ectoplasm_4_6" );

end;
---------------------------------------------------------------------------------------------
function private.get_collect_2_4_6()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_6");
    cmn.CallEventHandler("get_collect_2_4_6");
    if cmn.IsEventDone( "get_solderingiron") then
    
      common.CloseSubRoom();
    
    end;
    
    
  
  end;

  common_impl.PlayEffectHO( "spr_equipment_4_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_cover()
  
  local func_after = function ()
  
    common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.ShowBbt( 'bbt_videocamera_use_hexagon_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_cover_diode_videocamera", 0, "", 0 );
  
  ObjAnimate( "spr_videocamera_cover_diod", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, 95, 
    0.3, 0, 96,
    0.6, 0, 95

  } );
  
end;  
---------------------------------------------------------------------------------
function private.clk_cap()
  
  local func_after = function ()
  
    common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.ShowBbt( 'bbt_videocamera_use_screwdriver_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_cover_battery_videocamera", 0, "", 0 );
  
  ObjAnimate( "spr_videocamera_cover_battery", "pos_x", 0, 0, func_after,
  { 
    0.0, 0, -27, 
    0.3, 0, -26,
    0.6, 0, -26

  } );
  
end;  
--------------------------------------------------------------------------------------------
function private.clk_bag_4()

  cmn.CallEventHandler( "clk_bag_4_beg" );
  
  local func_after = function () 
  
    common_impl.Lock( false );
    cmn.SetEventDone( "clk_bag_4" );
    cmn.CallEventHandler( "clk_bag_4_end" );
      
  end;
    
  common_impl.Lock( true );  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_bagbutton_equipment_4", 0, "", 0 );
  
  ObjAnimate( "obj_equipment_4_bag_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );
  
  ObjAnimate( "spr_equipment_4_bag_over", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.win_trunk_4()
  
  common_impl.Lock( false );
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
  cmn.MiniGameHide( "trunk_4" );
  common_impl.PassingMgWin( "trunk_4" );
  cmn.SetEventDone( "win_trunk_4" );
  cmn.CallEventHandler( "win_trunk_4" );
    
end;
--*********************************************************************************************************************
function private.skip_trunk_4()
  
  private.WinAnimEquipment();
  
end;
--********************************************************************************************************************* 
function public.Skip( name )
  
  if name == "win_trunk_4" then
    
    private.skip_trunk_4();
    
  end;
  
end;
--*********************************************************************************************************************
function public.Reset( name )
  
  if name == "win_trunk_4" then
    
    private.ResetEquipment();
    
  end;
  
end;
--*********************************************************************************************************************
function private.opn_hall_4()

  if not ( cmn.IsEventDone( "opn_hall_4" ) ) then
    cmn.SetEventDone( "opn_hall_4" );
  end;
  
  cmn.CallEventHandler( "opn_hall_4" ); 

end;
--*********************************************************************************************************************
function private.vid_hall_4_incident()

  local func_after = function ( skip )

    local func_end = function ()
    
      common_impl.Lock( false );
      common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
      cmn.SetEventDone( "vid_hall_4_incident" );
      cmn.CallEventHandler( "vid_hall_4_incident_end" );
      cmn.SetEventDone( "beg_levelext" );
      cmn.CallEventHandler( "beg_levelext" );
      common_impl.ShowBbt( 'bbt_vid_hall_4_incident', 1 );
    
      interface.KeyTaskAdd( "give_sedative", true );
      
      common_impl.AddPageDiary( 15 );
      
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_phenomenon_hall_env", 1, "", 0 );
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_warnington_scary_loc_env", 1, "", 0 );
      
    end;
    
    interface.DialogVideoHide();
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Visor
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Visor
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;
      
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_hall_4_incident", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_hall_4_incident_voc", 0.2 );
      
    end;
    
    ObjMultiSet({ 
      { "rm_hall_4", { color_r = 1, color_g = 1, color_b = 1 }}  
    });
    
    common_impl.Lock( true );
    AnimPlay( "anm_hall_4_ghost", "DoAnim", func_end );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_ghost_leave_hall", 0, "", 0 );
    
  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_hall_4_incident", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_hall_4_incident_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_hall_4_incident", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_hall_4_incident", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_hall_4_superdevice()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_hall_4_superdevice" );
    cmn.CallEventHandler( "vid_hall_4_superdevice_end" );
    common_impl.ShowBbt( 'bbt_vid_hall_4_superdevice', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_hall_4_superdevice", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_hall_4_superdevice_voc", 0.2 );
      
    end;
   
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_hall_4_superdevice", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_hall_4_superdevice_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_hall_4_superdevice", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_hall_4_superdevice", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.dlg_hall_4_workman()

  ObjAttach( "dlg_hall_4_workman", private.room_objname );
  ObjSet( "anm_hall_4_man", { alp = 0 });
  cmn.CallEventHandler( "dlg_hall_4_workman_beg" );
  common_impl.dialog_character_loc = "spr_hall_4_scared_men";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "workman", 4, nil, nil, true, "dlg_hall_4_workman_end" );

end;
--*********************************************************************************************************************
function public.dlg_hall_4_workman_end()

  if not cmn.IsEventDone( "dlg_hall_4_workman" ) then

    cmn.SetEventDone( "dlg_hall_4_workman" );
    ObjSet( "spr_hall_4_workman_key", { alp = 1 } );
    cmn.CallEventHandler( "dlg_hall_4_workman_inv" );
    common_impl.ShowBbt( "bbt_dlg_hall_4_workman", 1 );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    interface.KeyTaskAdd( "find_filming", true );
    
    common_impl.AddPageDiary( 16 );

  end;

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "workman" then
    
    if txt_count == 3 then
      
      ObjMultiSet( { 
        { "anm_hall_4_workman_workman_1", { alp = 0 } },
        { "anm_hall_4_workman_workman_2", { alp = 1 } }
      } );
      
    end;
    
  end;     
  
end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
function private.ArrowAnim( number, func )
  
  local func_after = function()
    
    common_impl.Lock( false );
    
    if func then
    
      func();
      
    end;
    
  end;
  
  common_impl.Lock( true );
  
  local ang_old = ObjGet( "spr_equipment_4_mmg_arrow" ).ang;
  local ang_new = private.equipment_mmg_angles[number];
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_equipment_4_rotate_arrow", 0, "", 0 );
      
  ObjAnimate( "spr_equipment_4_mmg_arrow", "ang", 0, 0, func_after, { 0,0,ang_old, 0.3,0,ang_new } );
  
end;
--*********************************************************************************************************************
function private.ClkSymbol( number )
  
  local current = ng_global.progress["ext"]["win_trunk_4"].state;
  
  local func_after = function()
 
    if ( number == private.equipment_mmg_sequence[2][current + 1] ) then
      
      local func_end = function()
    
        common_impl.Lock( false );
   
        if ( current < 2 ) then          
        
          ng_global.progress["ext"]["win_trunk_4"].state = ng_global.progress["ext"]["win_trunk_4"].state + 1;
          
          local new_current = ng_global.progress["ext"]["win_trunk_4"].state;
          
          local next_state = private.equipment_mmg_sequence[1][new_current + 1];
          
          local func_next = function()
            
            ObjSet( "spr_equipment_4_mmg_symbol_"..next_state.."_current", { alp = 1 } );
            
          end;
        
          private.ArrowAnim( next_state, func_next );  
          
        else
          
          private.WinAnimEquipment();
          
        end;
        
      end;
      
      common_impl.Lock( true );
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_equipment_4_right", 0, "", 0 );
      
      ObjAnimate( "spr_equipment_4_mmg_symbol_"..number.."_right", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
 
      ObjAnimate( "spr_equipment_4_mmg_symbol_"..private.equipment_mmg_sequence[1][current + 1].."_right", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_equipment_4_mmg_symbol_"..private.equipment_mmg_sequence[1][current + 1].."_current", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      
    else
      
      --local func_reset = function()
        
        private.ResetEquipment();
        
      --end;
      
      common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_equipment_4_wrong", 0, "", 0 );
      
      --private.ArrowAnim( 2, func_reset );      
      
    end;
    
  end;
  
  if ( number ~= private.equipment_mmg_sequence[1][current + 1] ) then
  
    private.ArrowAnim( number, func_after );
    
  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_equipment_4_touch_sign", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function private.ResetEquipment()
  
  ng_global.progress["ext"]["win_trunk_4"].state = 0;
  
  for i = 1, 8 do
    
    ObjSet( "spr_equipment_4_mmg_symbol_"..i.."_right", { alp = 0 } );
    ObjSet( "spr_equipment_4_mmg_symbol_"..i.."_current", { alp = 0 } );
    
  end;
  
    ObjSet( "spr_equipment_4_mmg_symbol_2_current", { alp = 1 } );
    
    private.ArrowAnim( 2 );   
  
end;
--*********************************************************************************************************************
function private.WinAnimEquipment()
  
  private.win_trunk_4();
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_equipment_4_win", 0, "", 0 );
  
end;
--********************************************************************************************************************* 
ObjAnimate("spr_hall_4_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});
ObjAnimate("spr_hall_4_light_2", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.6, 0, 0.5,
  1.2, 0, 1.0
});
ObjAnimate( "spr_orchestra_4_light_add", "alp", 1, 0, "",
{ 
  0.0, 0, 1, 
  1.3, 0, 0.6,
  2.6, 0, 1
} ); 
ObjAnimate( "spr_videocamera_diode_4_2_light", "alp", 1, 0, "",
{ 
  0, 0, 0.5, 
  2, 0, 1,
  4, 0, 0.5
} ); 
