-- name=rm_lunchroom_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lunchroom_4";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 

  { "obj_lunchroom_4_dlg_leading", { event_mdown = private.dlg_lunchroom_4_leading }},
  { "obj_lunchroom_4_dlg_leading_focus", { event_mdown = private.dlg_lunchroom_4_leading }},
  { "spr_lunchroom_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lunchroom_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_lunchroom_4_apparatusroom_4_2"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_lunchroom_4", update_game_mode_lunchroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lunchroom_4 = function ()

  local effects_table = 
  {
    "obj_lunchroom_4_anim" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lunchroom_4", update_performance_mode_lunchroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lunchroom_4 () end;
  --------------------------------------------------------------------------------------------
  local opn_lunchroom_4_map = function ()

    common_impl.VisitMapRoom( "lunchroom_4" );

  end;
  cmn.AddSubscriber( "opn_lunchroom_4", opn_lunchroom_4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_3" ] = {
    type = "get",
    get_obj = "anm_lunchroom_4_ectoplasm_4_3",
    room = private.room_objname,
    zz = "zz_lunchroom_4",
    zz_gate = "gzz_lunchroom_4_lunchroom_4"
  };
    
  local get_ectoplasm_4_3_inv = function ()

    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_lunchroom_4_ectoplasm_4_3", function() common.BlockGotoRoom(true); common_impl.Lock( false ); end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_3_closezz = function ()
  
    ObjDelete( "gfx_lunchroom_4_ectoplasm" );
    --ObjDelete( "gzz_lunchroom_4_lunchroom_4" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_3", get_ectoplasm_4_3_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_3", get_ectoplasm_4_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_5 = function ()
  
    ObjDelete( "obj_lunchroom_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_5", get_collect_morph_item_4_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apparatus_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_apparatus_4_2" ] = {
    type = "use",
    inv_obj = "inv_apparatus_4",
    use_place = "obj_lunchroom_4_use_apparatus_4",
    room = private.room_objname
  };
  local use_apparatus_4_2_inv = function ()
  
  end;
  local use_apparatus_4_2_beg = function ()
  
    ObjDelete( "obj_lunchroom_4_use_apparatus_4" );
  
  end;
  local use_apparatus_4_2_end = function ()
  
    ObjSet( "gmg_lunchroom_4_apparatusroom_4_2", { input = true, active = true } );    
    ObjDelete( "anm_lunchroom_4_apparatus" );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apparatus_4_2", use_apparatus_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_2", use_apparatus_4_2_inv );
  cmn.AddSubscriber( "use_apparatus_4_2", use_apparatus_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_2_inv", use_apparatus_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_2_beg", use_apparatus_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_2_end", use_apparatus_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_3" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname,

  };
  local use_searcher_4_3_inv = function ()
  
    if ( levelext_inv.IsUseAllSearchers( 3 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;
  
  end;
  local use_searcher_4_3_beg = function ()
  
    
  
  end;
  local use_searcher_4_3_end = function ()
  
    ObjDelete( "obj_lunchroom_4_use_searcher" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_3", use_searcher_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_3", use_searcher_4_3_inv );
  cmn.AddSubscriber( "use_searcher_4_3", use_searcher_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_3_inv", use_searcher_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_3_beg", use_searcher_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_3_end", use_searcher_4_3_end, private.room_objname );
  ----------------------------------------------------------------------------------------------
  -- function dlg_lunchroom_4_leading () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_lunchroom_4_leading" ] = {
    type = "click",
    use_place = "obj_lunchroom_4_dlg_leading_focus",
    room = private.room_objname
  };
  local dlg_lunchroom_4_leading_loc = function ()

    ObjSet( "anm_lunchroom_4_leading", { alp = 1 } );
    ObjDelete( "obj_lunchroom_4_dlg_leading" );
    ObjDelete("anm_lunchroom_4_leading_2");
    ObjSet("obj_lunchroom_4_leading_bbt", { input = true });
    
  end;

  local dlg_lunchroom_4_leading_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers_4","spr_lunchroom_4_leading_tweezers"); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_lunchroom_4_leading_loc", dlg_lunchroom_4_leading_loc, private.room_objname );
  cmn.AddSubscriber( "dlg_lunchroom_4_leading_inv", dlg_lunchroom_4_leading_inv );
  cmn.AddSubscriber( "dlg_lunchroom_4_leading", dlg_lunchroom_4_leading_loc, private.room_objname );
  cmn.AddSubscriber( "dlg_lunchroom_4_leading", dlg_lunchroom_4_leading_inv );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_lunchroom_4();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
 
  common_impl.MorphItemMorphing();
 
  common_impl.EnvPlay( { "common/audio/levelext/aud_lunchroom_4_env" }, "", 0.5 );
  
  if not ng_global.progress[ "ext" ][ "win_apparatusroom_4_2" ].anim and cmn.IsEventDone( "win_apparatusroom_4_2") then
    
    local func_after = function()
      
      common_impl.Lock(false);
      ng_global.progress[ "ext" ][ "win_apparatusroom_4_2" ].anim = true;
      cmn.CallEventHandler( "win_apparatusroom_4_2" );
      
    end;
    common_impl.Lock(true);
    ObjSet( "anm_lunchroom_4_use_appatatus_2", {alp=1});
    AnimPlay( "anm_lunchroom_4_use_appatatus_2", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_remove_anomaly", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 0 );
    
  end;
  
  if not cmn.IsEventDone( "win_apparatusroom_4_2" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 1, "", 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_apparatus_4_2()

  local item = "inv_apparatus_4";

  if ( common.ApplyObj( item, "obj_lunchroom_4_use_apparatus_4", false ) ) then

    cmn.CallEventHandler( "use_apparatus_4_2_inv" );
    cmn.CallEventHandler( "use_apparatus_4_2_beg" );

    local func_after = function ()
      
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_apparatus_4_2" );
        cmn.CallEventHandler( "use_apparatus_4_2_end" );
        cmn.GotoRoom( "mg_apparatusroom_4_2" );
        
      end;
    
      ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_end,
      { 
        0.0, 1, 1.0,1.0, 
        1.0, 1, 1.3,1.3
      } );

      ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
      { 
        0.0, 1,  0, 0, 
        1.0, 1,  60, 0
      } ); 
    
    end;
  
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_apparatus", 0, "", 0 );
    
    AnimPlay( "anm_lunchroom_4_apparatus", "DoAnim", "" );
    ObjSet( "tmr_lunchroom_4_apparatus", { playing = true, time = 2, endtrig = func_after });
    return true;
  


  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_3( func )

  cmn.CallEventHandler( "use_searcher_4_3_beg" );

  local func_after = function ()

    --common_impl.Lock( false );
    cmn.SetEventDone( "use_searcher_4_3" );
    cmn.CallEventHandler( "use_searcher_4_3_end" );
    private.get_ectoplasm_4_3();
    
    local delayfunc = function ()

      --common_impl.Lock( false );
      func();
      --cmn.CallEventHandler( "use_searcher_4_3_inv" );

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );

  ObjSet( "anm_lunchroom_4_ectoplasm_4_3", { visible = true, active = true, playing = true, endtrig = func_after } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_3" );
  cmn.CallEventHandler( "get_ectoplasm_4_3" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lunchroom_4()

  if not ( cmn.IsEventDone( "opn_lunchroom_4" ) ) then
    cmn.SetEventDone( "opn_lunchroom_4" );
    interface.KeyTaskDone( 'find_filming', true );
  end;
  
  cmn.CallEventHandler( "opn_lunchroom_4" ); 

end;
--*********************************************************************************************************************
function private.dlg_lunchroom_4_leading()

  ObjAttach( "dlg_lunchroom_4_leading", private.room_objname );
  -- ObjSet("anm_lunchroom_4_leading_loc", { alp = 0 });
  ObjSet("anm_lunchroom_4_leading", { alp = 0 });
  ObjSet("anm_lunchroom_4_leading_2", { alp = 0 });
  
  common_impl.dialog_character_loc = "";

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "leading", 4, nil, nil, true, "dlg_lunchroom_4_leading_end" );

end;
--*********************************************************************************************************************
function public.dlg_lunchroom_4_leading_end()

  if not cmn.IsEventDone( "dlg_lunchroom_4_leading" ) then

    cmn.SetEventDone( "dlg_lunchroom_4_leading" );
    ObjSet( "spr_lunchroom_4_leading_tweezers", { alp = 1 } );
    cmn.CallEventHandler( "dlg_lunchroom_4_leading_inv" );
    cmn.CallEventHandler( "dlg_lunchroom_4_leading_loc" );
    common_impl.ShowBbt( "bbt_dlg_lunchroom_4_leading", 1 );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    interface.KeyTaskAdd( "second_floor", true );
    
    common_impl.AddPageDiary( 17 );

  end;

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "leading" then
    
    if txt_count == 3 then
      
      common_impl.dialog_character_loc = "anm_lunchroom_4_leading";
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      
      ObjMultiSet( { 
        { "anm_lunchroom_4_leading_leading_1", { alp = 0 } },
        { "anm_lunchroom_4_leading_leading_2", { alp = 1 } }
     
      } );
      
    end;
    
  end;     
  
end;
--*********************************************************************************************************************
ObjAnimate("spr_lunchroom_4_chandelier1", "ang",1,0,"",
{
  0.0, 3, -0.02, 
  1.3, 3, 0.02,
  2.6, 3, -0.02
});

ObjAnimate("spr_lunchroom_4_chandelier2", "ang",1,0,"",
{
  0.0, 3, 0.02, 
  2.0, 3, -0.02,
  4.0, 3, 0.02
});

ObjAnimate("spr_lunchroom_4_light", "alp",1,0,"",
{
  0.0, 0, 1.0, 
  0.8, 0, 0.5,
  1.6, 0, 1.0
});