-- name=rm_secondfloor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondfloor";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_drape", "room_hub" );
  ObjAttach( "zz_captive", "room_hub" );
  ObjAttach( "zz_studydoor", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
  { "spr_drape_plank_4_2", { event_mdown = private.get_plank_4_2 }},
  { "spr_drape_patternelement", { event_mdown = private.get_patternelement }},
  { "spr_secondfloor_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_secondfloor_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_secondfloor_meeting_mmg_apparatus", { event_dragdrop = private.dlg_dragdrop, event_startdrag = function() common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 ); end } }
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondfloor = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gho_secondfloor_mockuproom",
    "gmg_secondfloor_apparatusroom_4_3",
    "gmg_secondfloor_door_4",
    "gzz_secondfloor_drape",
    "gzz_secondfloor_captive",
    "gzz_secondfloor_studydoor"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_drape",
    "zz_captive",
    "zz_studydoor"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_secondfloor", update_game_mode_secondfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secondfloor = function ()

  local effects_table = 
  {
    "obj_secondfloor_anim",
    "spr_studydoor_light_add",
    "anm_secondfloor_snow",
    "anm_secondfloor_scintist",
    "anm_secondfloor_scintist_2",
    "anm_captive_doctor" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secondfloor", update_performance_mode_secondfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloor () end;
  --------------------------------------------------------------------------------------------
  local opn_secondfloor_map = function ()

    common_impl.VisitMapRoom( "secondfloor" );
    ObjSet( "spr_map_1_screen_2_transition_secondfloor", { active = true, input = true, visible = true } );

  end;
  cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_plank_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plank_4_2" ] = {
    type = "get",
    get_obj = "spr_drape_plank_4_2",
    room = private.room_objname,
    zz = "zz_drape",
    zz_gate = "gzz_secondfloor_drape"
  };
    
  local get_plank_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_plank_4_2", "spr_drape_plank_4_2" );
  
  end;
  
  local get_plank_4_2_closezz = function ()
  
    ObjDelete( "gfx_drape_plank_4_2" );
    ObjDelete( "spr_drape_plank_4_2_shadow" );
    ObjDelete( "spr_secondfloor_drape_board" );

  end;
  
  cmn.AddSubscriber( "get_plank_4_2", get_plank_4_2_inv );
  cmn.AddSubscriber( "get_plank_4_2", get_plank_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_patternelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_patternelement" ] = {
    type = "get",
    get_obj = "spr_drape_patternelement",
    room = private.room_objname,
    zz = "zz_drape",
    zz_gate = "gzz_secondfloor_drape"
  };
    
  local get_patternelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_patternelement", "spr_drape_patternelement" );
  
  end;
  
  local get_patternelement_closezz = function ()
  
    ObjDelete( "gfx_drape_patternelement" );
    ObjDelete( "spr_drape_patternelement_over" );
    ObjDelete( "spr_drape_patternelement_shadow" );
    ObjSet( "obj_drape_use_workanglegrinder", { input = true });
    ObjDelete( "spr_secondfloor_drape_part" );
    
  end;
  
  cmn.AddSubscriber( "get_patternelement", get_patternelement_inv );
  cmn.AddSubscriber( "get_patternelement", get_patternelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_1" ] = {
    type = "get",
    get_obj = "anm_secondfloor_ectoplasm_4_1",
    room = private.room_objname,
    zz = "zz_secondfloor",
    zz_gate = "gzz_secondfloor_secondfloor"
  };
    
  local get_ectoplasm_4_1_inv = function ()
  
    --interface.InventoryItemAdd( "inv_ectoplasm", "anm_secondfloor_ectoplasm_4_1" );
    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_secondfloor_ectoplasm_4_1", function() common.BlockGotoRoom(true); common_impl.Lock( false ); end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_1_closezz = function ()
  
    ObjDelete( "gfx_secondfloor_ectoplasm" );
    --ObjDelete( "gzz_secondfloor_secondfloor" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_1", get_ectoplasm_4_1_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_1", get_ectoplasm_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_6 = function ()
  
    ObjDelete( "obj_secondfloor_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_6", get_collect_morph_item_4_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_2 = function ()
  
    ObjDelete( "obj_secondfloor_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_2", get_collect_item_4_2, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_knife_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_4" ] = {
    type = "use",
    inv_obj = "inv_knife_4",
    use_place = "obj_drape_use_knife_4",
    room = private.room_objname,
    zz = "zz_drape",
    zz_gate = "gzz_secondfloor_drape"
  };
  local use_knife_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_knife_4" );
  
  end;
  local use_knife_4_beg = function ()
  
    ObjDelete( "obj_drape_use_knife_4" );
  
  end;
  local use_knife_4_end = function ()
  
    ObjSet( "spr_drape_patternelement", { input = true, active = true } );
    ObjSet( "obj_drape_lines", { alp = 1 });
    ObjDelete( "anm_drape_use_knife");
    ObjDelete( "spr_secondfloor_drape" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_4", use_knife_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_4", use_knife_4_inv );
  cmn.AddSubscriber( "use_knife_4", use_knife_4_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_inv", use_knife_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_beg", use_knife_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_end", use_knife_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workanglegrinder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workanglegrinder" ] = {
    type = "use",
    inv_obj = "inv_workanglegrinder",
    use_place = "obj_drape_use_workanglegrinder",
    room = private.room_objname,
    zz = "zz_drape",
    zz_gate = "gzz_secondfloor_drape"
  };
  local use_workanglegrinder_inv = function ()
  
    interface.InventoryItemRemove( "inv_workanglegrinder" );
  
  end;
  local use_workanglegrinder_beg = function ()
  
    ObjDelete( "obj_drape_use_workanglegrinder" );
  
  end;
  local use_workanglegrinder_end = function ()
  
    ObjDelete( "vid_drape_workanglegrinder" );
    ObjDelete( "gzz_secondfloor_drape" );
    ObjSet( "spr_drape_open_door", { alp = 1 } );
    ObjSet( "spr_secondfloor_drape_open", {alp = 1} );
    ObjSet( "gho_secondfloor_mockuproom", { input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workanglegrinder", use_workanglegrinder_beg, private.room_objname );
  cmn.AddSubscriber( "use_workanglegrinder", use_workanglegrinder_inv );
  cmn.AddSubscriber( "use_workanglegrinder", use_workanglegrinder_end, private.room_objname );
  cmn.AddSubscriber( "use_workanglegrinder_inv", use_workanglegrinder_inv, private.room_objname );
  cmn.AddSubscriber( "use_workanglegrinder_beg", use_workanglegrinder_beg, private.room_objname );
  cmn.AddSubscriber( "use_workanglegrinder_end", use_workanglegrinder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tinsnips () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tinsnips" ] = {
    type = "use",
    inv_obj = "inv_tinsnips",
    use_place = "obj_captive_use_tinsnips",
    room = private.room_objname,
    zz = "zz_captive",
    zz_gate = "gzz_secondfloor_captive"
  };
  local use_tinsnips_inv = function ()
  
    interface.InventoryItemRemove( "inv_tinsnips" );
  
  end;
  local use_tinsnips_beg = function ()
  
    ObjDelete( "obj_captive_use_tinsnips" );
  
  end;
  local use_tinsnips_end = function ()
  
    ObjDelete( "gzz_secondfloor_captive" );
    ObjDelete( "anm_captive_use_scissors");
    ObjDelete( "anm_secondfloor_scintist" );
    ObjSet( "anm_secondfloor_scintist_2", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tinsnips", use_tinsnips_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinsnips", use_tinsnips_inv );
  cmn.AddSubscriber( "use_tinsnips", use_tinsnips_end, private.room_objname );
  cmn.AddSubscriber( "use_tinsnips_inv", use_tinsnips_inv, private.room_objname );
  cmn.AddSubscriber( "use_tinsnips_beg", use_tinsnips_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinsnips_end", use_tinsnips_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doorelement_4_1" ] = {
    type = "use",
    inv_obj = "inv_doorelement_4_1",
    use_place = "obj_studydoor_use_doorelement_4_1",
    room = private.room_objname,
    zz = "zz_studydoor",
    zz_gate = "gzz_secondfloor_studydoor"
  };
  local use_doorelement_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorelement_4_1" );
  
  end;
  local use_doorelement_4_1_beg = function ()
  
    ObjDelete( "obj_studydoor_use_doorelement_4_1" );
  
  end;
  local use_doorelement_4_1_end = function ()
  
    ObjSet( "spr_studydoor_element_1", { alp = 1 });
  
    if ( cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
      
      ObjDelete( "gzz_secondfloor_studydoor" );
      ObjSet( "gmg_secondfloor_door_4", { input = true, active = true });
      ObjSet( "spr_studydoor_cap_open", { alp = 1 });
      ObjDelete( "spr_studydoor_cap");
      ObjDelete( "anm_secondfloor_mg");
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorelement_4_1", use_doorelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_1", use_doorelement_4_1_inv );
  cmn.AddSubscriber( "use_doorelement_4_1", use_doorelement_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_1_inv", use_doorelement_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_1_beg", use_doorelement_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_1_end", use_doorelement_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorelement_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doorelement_4_4" ] = {
    type = "use",
    inv_obj = "inv_doorelement_4_4",
    use_place = "obj_studydoor_use_doorelement_4_4",
    room = private.room_objname,
    zz = "zz_studydoor",
    zz_gate = "gzz_secondfloor_studydoor"
  };
  local use_doorelement_4_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorelement_4_4" );
  
  end;
  local use_doorelement_4_4_beg = function ()
  
    ObjDelete( "obj_studydoor_use_doorelement_4_4" );
  
  end;
  local use_doorelement_4_4_end = function ()
  
    ObjSet( "spr_studydoor_element_4", { alp = 1 });
  
    if ( cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_3" ) ) then
      
      ObjDelete( "gzz_secondfloor_studydoor" );
      ObjSet( "gmg_secondfloor_door_4", { input = true, active = true });
      ObjSet( "spr_studydoor_cap_open", { alp = 1 });
      ObjDelete( "spr_studydoor_cap");
      ObjDelete( "anm_secondfloor_mg")
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorelement_4_4", use_doorelement_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_4", use_doorelement_4_4_inv );
  cmn.AddSubscriber( "use_doorelement_4_4", use_doorelement_4_4_end, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_4_inv", use_doorelement_4_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_4_beg", use_doorelement_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_4_end", use_doorelement_4_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorelement_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doorelement_4_3" ] = {
    type = "use",
    inv_obj = "inv_doorelement_4_3",
    use_place = "obj_studydoor_use_doorelement_4_3",
    room = private.room_objname,
    zz = "zz_studydoor",
    zz_gate = "gzz_secondfloor_studydoor"
  };
  local use_doorelement_4_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorelement_4_3" );
  
  end;
  local use_doorelement_4_3_beg = function ()
  
    ObjDelete( "obj_studydoor_use_doorelement_4_3" );
  
  end;
  local use_doorelement_4_3_end = function ()
  
    ObjSet( "spr_studydoor_element_3", { alp = 1 });
  
    if ( cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
      
      ObjDelete( "gzz_secondfloor_studydoor" );
      ObjSet( "gmg_secondfloor_door_4", { input = true, active = true });
      ObjSet( "spr_studydoor_cap_open", { alp = 1 });
      ObjDelete( "spr_studydoor_cap");
      ObjDelete( "anm_secondfloor_mg")
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorelement_4_3", use_doorelement_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_3", use_doorelement_4_3_inv );
  cmn.AddSubscriber( "use_doorelement_4_3", use_doorelement_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_3_inv", use_doorelement_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_3_beg", use_doorelement_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_3_end", use_doorelement_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doorelement_4_2" ] = {
    type = "use",
    inv_obj = "inv_doorelement_4_2",
    use_place = "obj_studydoor_use_doorelement_4_2",
    room = private.room_objname,
    zz = "zz_studydoor",
    zz_gate = "gzz_secondfloor_studydoor"
  };
  local use_doorelement_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorelement_4_2" );
  
  end;
  local use_doorelement_4_2_beg = function ()
  
    ObjDelete( "obj_studydoor_use_doorelement_4_2" );
  
  end;
  local use_doorelement_4_2_end = function ()
  
    ObjSet( "spr_studydoor_element_2", { alp = 1 });
  
    if ( cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
      
      ObjDelete( "gzz_secondfloor_studydoor" );
      ObjSet( "gmg_secondfloor_door_4", { input = true, active = true });
      ObjSet( "spr_studydoor_cap_open", { alp = 1 });
      ObjDelete( "spr_studydoor_cap");
      ObjDelete( "anm_secondfloor_mg")
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorelement_4_2", use_doorelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_2", use_doorelement_4_2_inv );
  cmn.AddSubscriber( "use_doorelement_4_2", use_doorelement_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_2_inv", use_doorelement_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_2_beg", use_doorelement_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorelement_4_2_end", use_doorelement_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apparatus_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_apparatus_4_3" ] = {
    type = "use",
    inv_obj = "inv_apparatus_4",
    use_place = "obj_secondfloor_use_apparatus_4",
    room = private.room_objname
  };
  local use_apparatus_4_3_inv = function ()
  
  end;
  local use_apparatus_4_3_beg = function ()
  
    ObjDelete( "obj_secondfloor_use_apparatus_4" );
  
  end;
  local use_apparatus_4_3_end = function ()
  
    ObjSet( "gmg_secondfloor_apparatusroom_4_3", { input = true, visible = true, active = true } );
    ObjDelete( "anm_secondfloor_apparatus" );
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apparatus_4_3", use_apparatus_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_3", use_apparatus_4_3_inv );
  cmn.AddSubscriber( "use_apparatus_4_3", use_apparatus_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_3_inv", use_apparatus_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_3_beg", use_apparatus_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_apparatus_4_3_end", use_apparatus_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_1" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname
  };
  local use_searcher_4_1_inv = function ()
  
    if ( levelext_inv.IsUseAllSearchers( 1 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;
  
  end;
  local use_searcher_4_1_beg = function ()
  
    
  
  end;
  local use_searcher_4_1_end = function ()

    ObjDelete( "obj_secondfloor_use_searcher" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_1", use_searcher_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_1", use_searcher_4_1_inv );
  cmn.AddSubscriber( "use_searcher_4_1", use_searcher_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_1_inv", use_searcher_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_1_beg", use_searcher_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_1_end", use_searcher_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_secondfloor_spirit () end;
  --------------------------------------------------------------------------------------------
  local vid_secondfloor_spirit_end = function ()
  
    ObjDelete( "anm_secondfloor_spirit" );
    ObjSet( "obj_secondfloor_studydoor", { alp = 1 } );
    ObjSet( "anm_secondfloor_scintist", { alp = 1 } );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_secondfloor_spirit", vid_secondfloor_spirit_end, private.room_objname  );
  cmn.AddSubscriber( "vid_secondfloor_spirit_end", vid_secondfloor_spirit_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function use_ectoplasm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ectoplasm" ] = {
    type = "use",
    inv_obj = "inv_ectoplasm",
    use_place = "obj_secondfloor_use_ectoplasm",
    room = private.room_objname,
  };
  local use_ectoplasm_inv = function ()
  
    interface.InventoryItemRemove( "inv_ectoplasm" );
  
  end;
  local use_ectoplasm_beg = function ()
  
    ObjDelete( "obj_secondfloor_use_ectoplasm" );
  
  end;
  local use_ectoplasm_end = function ()
  
    --ObjSet( "spr_secondfloor_key", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ectoplasm", use_ectoplasm_beg, private.room_objname );
  cmn.AddSubscriber( "use_ectoplasm", use_ectoplasm_inv );
  cmn.AddSubscriber( "use_ectoplasm", use_ectoplasm_end, private.room_objname );
  cmn.AddSubscriber( "use_ectoplasm_inv", use_ectoplasm_inv, private.room_objname );
  cmn.AddSubscriber( "use_ectoplasm_beg", use_ectoplasm_beg, private.room_objname );
  cmn.AddSubscriber( "use_ectoplasm_end", use_ectoplasm_end, private.room_objname );
  ----------------------------------------------------------------------------------------------
  -- function dlg_secondfloor_scientist () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_secondfloor_scientist" ] = {
    type = "click",
    use_place = "obj_secondfloor_scientist",
    room = private.room_objname
  };
  local dlg_secondfloor_scientist_beg = function ()

    ObjDelete( "obj_secondfloor_scientist");
    
  end;

  local dlg_secondfloor_scientist_inv = function ()
  
    interface.InventoryItemAdd( "inv_searcher","spr_secondfloor_scientist_ectoplasm_detector"); 
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_secondfloor_scientist_beg", dlg_secondfloor_scientist_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_secondfloor_scientist_inv", dlg_secondfloor_scientist_inv );
  cmn.AddSubscriber( "dlg_secondfloor_scientist", dlg_secondfloor_scientist_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_secondfloor_scientist", dlg_secondfloor_scientist_inv );
  ----------------------------------------------------------------------------------------------
  -- function dlg_secondfloor_meeting () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_secondfloor_meeting" ] = {
    type = "click",
    use_place = "obj_secondfloor_meeting",
    room = private.room_objname
  };
  local dlg_secondfloor_meeting_beg = function ()

    ObjDelete( "obj_secondfloor_meeting");
    
  end;

  local dlg_secondfloor_meeting_inv = function ()
  
    interface.InventoryItemRemove( "inv_apparatus_4" );
    interface.InventoryItemAdd( "inv_doorelement_4_2","spr_secondfloor_meeting_element"); 
    interface.InventoryItemAdd( "inv_enhancedapparatus","spr_secondfloor_meeting_apparatus");
    ObjSet( "obj_secondfloor_scientist_sit", { alp = 1 }); 
    ObjDelete( "anm_secondfloor_scintist_2");
    --ObjSet( "anm_secondfloor_scintist_2", { alp = 0 }); 
    ObjSet( "obj_secondfloor_scientist_bbt", { input = true });
    
    
  --------------------------------------------------------------------------------------------
  -- function win_mockuproom () end;
  --------------------------------------------------------------------------------------------
  local win_mockuproom = function ()

    if ( cmn.IsEventDone( "win_mockuproom" ) ) then

      ObjDelete( "gho_secondfloor_mockuproom" );

    end;

  end;

  cmn.AddSubscriber( "win_mockuproom", win_mockuproom, private.room_objname ); 
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_secondfloor_meeting_beg", dlg_secondfloor_meeting_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_secondfloor_meeting_inv", dlg_secondfloor_meeting_inv );
  cmn.AddSubscriber( "dlg_secondfloor_meeting", dlg_secondfloor_meeting_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_secondfloor_meeting", dlg_secondfloor_meeting_inv );
    
  
  local win_mockuproom_loc = function ()

    if ( cmn.IsEventDone( "win_mockuproom" ) ) then
      ObjDelete( "gho_secondfloor_mockuproom" );
    end;

  end;
  cmn.AddSubscriber( "win_mockuproom", win_mockuproom_loc );
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_captive" );
  subroom.Define( "zz_studydoor" );
  ---------------------------------------------------------------------------------------------
  function zz_captive.PreOpen()
    
    if not cmn.IsEventDone( "use_tinsnips" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_scientist_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_scientist_loc_env", 0 );
    
    end;
     
  end;  
  ---------------------------------------------------------------------------------------------
  function zz_captive.PreClose()
    
    if not cmn.IsEventDone( "use_tinsnips" ) then
    
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_scientist_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/levelext/aud_scientist_zz_env", 0 );
    
    end;
     
  end;  
  ---------------------------------------------------------------------------------------------
  function zz_captive.Close()
    
    if cmn.IsEventDone( "use_tinsnips" ) and  not cmn.IsEventDone( "dlg_secondfloor_scientist" ) then
      
      interface.KeyTaskDone( "save_professor", true,function() private.dlg_secondfloor_scientist(); end  ); 
      
    end;
     
  end;   
  ---------------------------------------------------------------------------------------------
  function zz_studydoor.Close()
    
    if ( cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_4" ) 
      and not cmn.IsEventDone( "win_door_4" ) ) then
      
      ObjSet( "tmr_secondfloor_gotomg", { playing = true, time = 0.0000001, endtrig = function()  cmn.GotoRoom( 'mg_door_4' ) end } );
      
    end;
     
  end; 
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_secondfloor();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  if ( not cmn.IsEventDone( "vid_secondfloor_spirit" ) ) then

    ObjSet( "tmr_secondfloor_spirit",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_secondfloor_spirit(); end
    } );
      
  end;
  
  if cmn.IsEventDone( "use_tinsnips" ) and  not cmn.IsEventDone( "dlg_secondfloor_scientist" ) then
      
      private.dlg_secondfloor_scientist();
      
  end;
  
  if cmn.IsEventDone( "use_ectoplasm" ) and  not cmn.IsEventDone( "dlg_secondfloor_meeting" ) then
      
      private.dlg_secondfloor_meeting();
      
  end;
    
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_secondfloor_env" }, "", 0.5 );
  
  if not cmn.IsEventDone( "win_apparatusroom_4_3" ) and cmn.IsEventDone( "vid_secondfloor_spirit" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 1, "", 0 );
    
  end;
  
  if not cmn.IsEventDone( "use_tinsnips" ) and cmn.IsEventDone( "vid_secondfloor_spirit" ) then
    
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_scientist_loc_env", 1, "", 0 );
    
  end;

  if not ng_global.progress[ "ext" ][ "win_apparatusroom_4_3" ].anim and cmn.IsEventDone( "win_apparatusroom_4_3") then
    
    local func_after = function()
      
      common_impl.Lock(false);
      ng_global.progress[ "ext" ][ "win_apparatusroom_4_3" ].anim = true;
      cmn.CallEventHandler( "win_apparatusroom_4_3" );
      
    end;
    common_impl.Lock(true);
    ObjSet( "anm_secondfloor_apparatus_2", {alp=1});
    AnimPlay( "anm_secondfloor_apparatus_2", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_remove_anomaly", 0, "", 0 );
    
  end;  
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 0 );
  common_impl.StopAudio( "env", "common/audio/levelext/aud_scientist_loc_env", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_knife_4()

  local item = "inv_knife_4";

  if ( common.ApplyObj( item, "obj_drape_use_knife_4", true ) and cmn.IsEventDone("get_plank_4_2") ) then

    cmn.CallEventHandler( "use_knife_4_inv" );
    cmn.CallEventHandler( "use_knife_4_beg" );
 
    
      local func_end = function () 
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_knife_4" );
        cmn.CallEventHandler( "use_knife_4_end" );
        
      end;
      

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_knife_drape", 0, "", 0 );
    
    ObjAnimate( "obj_drape_lines", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      2.8, 0, 0.0,
      3.0, 0, 1.0
      
    } );
    AnimPlay( "anm_drape_use_knife", "DoAnim", func_end);
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_drape", false ) and cmn.IsEventDone("get_plank_4_2") then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drape", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workanglegrinder()

  local item = "inv_workanglegrinder";

  if ( common.ApplyObj( item, "obj_drape_use_workanglegrinder", true ) and cmn.IsEventDone( "get_patternelement" ) ) then

    cmn.CallEventHandler( "use_workanglegrinder_inv" );
    cmn.CallEventHandler( "use_workanglegrinder_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_workanglegrinder" );
        cmn.CallEventHandler( "use_workanglegrinder_end" );
        common.CloseSubRoom();
        
      end;
      
      ObjAnimate( "spr_drape_open_door", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_workanglegrinder_drape", 0, "", 0 );
    ObjSet( "vid_drape_workanglegrinder", { alp = 1 });
    VidPlay( "vid_drape_workanglegrinder", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_drape", false ) and cmn.IsEventDone( "get_patternelement" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drape", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tinsnips()

  local item = "inv_tinsnips";

  if ( common.ApplyObj( item, "obj_captive_use_tinsnips", true ) ) then

    cmn.CallEventHandler( "use_tinsnips_inv" );
    cmn.CallEventHandler( "use_tinsnips_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tinsnips" );
      cmn.CallEventHandler( "use_tinsnips_end" );
      common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_tinsnips_captive", 0, "", 0 );
  common_impl.StopAudio( "env", "common/audio/levelext/aud_scientist_zz_env", 0 );
   
  ObjSet( "anm_captive_doctor", { alp = 0});
  ObjSet( "anm_captive_use_scissors", { alp = 1, playing = true, endtrig = func_after });
    
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_captive", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_captive", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorelement_4_1()

  local item = "inv_doorelement_4_1";

  if ( common.ApplyObj( item, "obj_studydoor_use_doorelement_4_1", true ) ) then

    cmn.CallEventHandler( "use_doorelement_4_1_inv" );
    cmn.CallEventHandler( "use_doorelement_4_1_beg" );
    
    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_doorelement_4_1" );
        cmn.CallEventHandler( "use_doorelement_4_1_end" );
        
      end;  
      
    if ( cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
        
        local func_close = function ()
        
          AnimPlay( "anm_secondfloor_mg", "DoAnim", func_end);
          
          common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_open_mg_doorroom", 0, "", 0 );
        
        end;
        
        common.CloseSubRoom();
        interface.Lock( true, 2 );
        func_close();
        --ObjAnimate( "spr_studydoor_cap_open", "alp", 0, 0, func_close,
        --{ 
        --  0.0, 0, 0.0, 
        --  0.3, 0, 1.0,
        --  0.6, 0, 1.0
        --} );
        --
        --ObjAnimate( "spr_studydoor_cap", "alp", 0, 0, "",
        --{ 
        --  0.0, 0, 1.0, 
        --  0.3, 0, 0.0,
        --  0.6, 0, 0.0
        --} );
        
     else 
      
        func_end();
        
     end;
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_doorelement_studydoor", 0, "", 0 );
  
    ObjAnimate( "spr_studydoor_element_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_studydoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_studydoor", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorelement_4_4()

  local item = "inv_doorelement_4_4";

  if ( common.ApplyObj( item, "obj_studydoor_use_doorelement_4_4", true ) ) then

    cmn.CallEventHandler( "use_doorelement_4_4_inv" );
    cmn.CallEventHandler( "use_doorelement_4_4_beg" );

    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_doorelement_4_4" );
        cmn.CallEventHandler( "use_doorelement_4_4_end" );
        
      end;  
      
      if ( cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_1" ) ) then

        local func_close = function ()
        
          AnimPlay( "anm_secondfloor_mg", "DoAnim", func_end);
          
          common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_open_mg_doorroom", 0, "", 0 );
        
        end;
        
        common.CloseSubRoom();
        interface.Lock( true, 2 );
        func_close();
       
      else
        
        func_end();
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_doorelement_studydoor", 0, "", 0 );
  
    ObjAnimate( "spr_studydoor_element_4", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_studydoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_studydoor", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorelement_4_3()

  local item = "inv_doorelement_4_3";

  if ( common.ApplyObj( item, "obj_studydoor_use_doorelement_4_3", true ) ) then

    cmn.CallEventHandler( "use_doorelement_4_3_inv" );
    cmn.CallEventHandler( "use_doorelement_4_3_beg" );

    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_doorelement_4_3" );
        cmn.CallEventHandler( "use_doorelement_4_3_end" );
        
      end;  
      
      if ( cmn.IsEventDone( "use_doorelement_4_2" ) and cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
        
        local func_close = function ()
        
          AnimPlay( "anm_secondfloor_mg", "DoAnim", func_end);
          
          common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_open_mg_doorroom", 0, "", 0 );
        
        end;
        
        common.CloseSubRoom();
        interface.Lock( true, 2 );
        func_close();
        
       else 
        
          func_end();
          
       end;
    
    end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_doorelement_studydoor", 0, "", 0 );
  
    ObjAnimate( "spr_studydoor_element_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_studydoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_studydoor", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorelement_4_2()

  local item = "inv_doorelement_4_2";

  if ( common.ApplyObj( item, "obj_studydoor_use_doorelement_4_2", true ) ) then

    cmn.CallEventHandler( "use_doorelement_4_2_inv" );
    cmn.CallEventHandler( "use_doorelement_4_2_beg" );

    local func_after = function ()
    
      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_doorelement_4_2" );
        cmn.CallEventHandler( "use_doorelement_4_2_end" );
        
      end;  
      
      if ( cmn.IsEventDone( "use_doorelement_4_1" ) and cmn.IsEventDone( "use_doorelement_4_3" ) and cmn.IsEventDone( "use_doorelement_4_4" ) ) then
          
          local func_close = function ()
          
            AnimPlay( "anm_secondfloor_mg", "DoAnim", func_end);
            
            common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_open_mg_doorroom", 0, "", 0 );
          
          end;
          
          common.CloseSubRoom();
          interface.Lock( true, 2 );
          func_close();
          
       else 
        
          func_end();
          
       end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_doorelement_studydoor", 0, "", 0 );
  
    ObjAnimate( "spr_studydoor_element_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secondfloor_studydoor", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_studydoor", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_apparatus_4_3()

  local item = "inv_apparatus_4";

  if ( common.ApplyObj( item, "obj_secondfloor_use_apparatus_4", false ) ) then

    cmn.CallEventHandler( "use_apparatus_4_3_inv" );
    cmn.CallEventHandler( "use_apparatus_4_3_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_apparatus_4_3" );
        cmn.CallEventHandler( "use_apparatus_4_3_end" );
        cmn.GotoRoom( "mg_apparatusroom_4_3" );
      
      end;
    
      ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_end,
      { 
        0.0, 1, 1.0,1.0, 
        1.0, 1, 1.3,1.3
      } );

      ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
      { 
        0.0, 1,  0, 0, 
        1.0, 1,  60, 0
      } ); 
      
    end;
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_apparatus", 0, "", 0 );
    ObjSet( "anm_secondfloor_apparatus", {alp=1});
    AnimPlay( "anm_secondfloor_apparatus", "DoAnim", "" );
    ObjSet( "tmr_secondfloor_apparatus", { playing = true, time = 2, endtrig = func_after });
    
    return true;
  
  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_1( func )

  cmn.CallEventHandler( "use_searcher_4_1_beg" );

  local func_after = function ()

    cmn.SetEventDone( "use_searcher_4_1" );
    cmn.CallEventHandler( "use_searcher_4_1_end" );
    private.get_ectoplasm_4_1();
    
    local delayfunc = function ()
      --DbgTrace( "common_impl.Lock( false ) - public.use_searcher_4_1 => delayfunc" );
      --common_impl.Lock( false );
      func();
      --cmn.CallEventHandler( "use_searcher_4_1_inv" );

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );

  ObjMultiSet({ 
  
    { "anm_secondfloor_ectoplasm_4_1", { visible = true, playing = true, active = true, endtrig = func_after  }},

  });

end;
--------------------------------------------------------------------------------------------
function public.use_ectoplasm()

  local item = "inv_ectoplasm";

  local all_get = false;

  if ( levelext_inv.EctoplasmCount() == 6 ) then
  
    all_get = true;

  end;

  if ( common.ApplyObj( item, "obj_secondfloor_use_ectoplasm", false ) and all_get ) then

    cmn.CallEventHandler( "use_ectoplasm_inv" );
    cmn.CallEventHandler( "use_ectoplasm_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ectoplasm" );
      cmn.CallEventHandler( "use_ectoplasm_end" );
      
      interface.KeyTaskDone( "bring_ectoplasm", true,function() private.dlg_secondfloor_meeting(); end  );
      
  end;

  common_impl.Lock( true );
  func_after();
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_ectoplasm_secondfloor", 0, "", 0 );
  
    --ObjAnimate( "spr", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
  
  return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_plank_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_plank_4_2" );
  cmn.CallEventHandler( "get_plank_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_patternelement()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_patternelement" );
  cmn.CallEventHandler( "get_patternelement" );

end;
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_1" );
  cmn.CallEventHandler( "get_ectoplasm_4_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_secondfloor()

  if not ( cmn.IsEventDone( "opn_secondfloor" ) ) then
    cmn.SetEventDone( "opn_secondfloor" );
  end;
  
  cmn.CallEventHandler( "opn_secondfloor" ); 

end;
--*********************************************************************************************************************
function private.vid_secondfloor_spirit()

  local func_after = function ()
    
    common_impl.InterfaceSetVisible(true);
    interface.DialogVideoHide();
    local event_id = "subtitle_hide";
    int_dialog_video_impl.SubtitleHideAnim( event_id );
    --common_impl.Lock( false ); 
    ObjSet( "tmr_secondfloor_sub_hide", { playing = false });
    cmn.SetEventDone( "vid_secondfloor_spirit" );
    cmn.CallEventHandler( "vid_secondfloor_spirit_end" );
    common_impl.ShowBbt( 'bbt_vid_secondfloor_spirit', 1 );

    common_impl.StopAudio( "sfx", "common/audio/levelext/aud_secondfloor_scientist", 0.2 );
    common_impl.StopAudio( "voc", "common/audio/levelext/aud_secondfloor_scientist_voc", 0.2 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger2_mus", 0, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_phenomenon_lunchroom_4_env", 1, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_scientist_loc_env", 1, "", 0 );
    
    interface.KeyTaskDone( "second_floor", true,function() interface.KeyTaskAdd( "save_professor", true ) end  );
    ng_global.task_current = "save_professor";

  end;

  common_impl.StopAllMus();
  --common_impl.Lock( true ); 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_secondfloor_scientist", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_secondfloor_scientist_voc", 0, "", 0 );
  common_impl.InterfaceSetVisible(false);
  
  ObjSet( "txt_int_dialog_video_subtitle", { text = "sub_secondfloor_scientist_1" } );
  AnimPlay( "anm_secondfloor_spirit", "DoAnim", func_after );
  local event_id = "subtitle_show";
  ObjSet( "tmr_secondfloor_sub_hide", { playing = true, time = 4, endtrig = function() int_dialog_video_impl.SubtitleHideAnim( event_id ); end;});
   int_dialog_video_impl.SubtitleShowAnim( event_id );
  --VidPlay( "anm_secondfloor_spirit", func_after  );
  interface.DialogVideoShow( "", 1, function() func_after( 'skip' ); end, 3 );


end;
--*********************************************************************************************************************
function private.dlg_secondfloor_scientist()

  ObjAttach( "dlg_secondfloor_scientist", private.room_objname );
  ObjSet("anm_secondfloor_scientist_loc", { alp = 0 });
  ObjSet("anm_secondfloor_scientist_2", { alp = 0 });
  cmn.CallEventHandler( "dlg_secondfloor_scientist_beg" );
  
  common_impl.dialog_character_loc = "anm_secondfloor_scintist_2";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "scientist", 4, nil, nil, true, "dlg_secondfloor_scientist_end" );

end;
--*********************************************************************************************************************
function public.dlg_secondfloor_scientist_end()

  if not cmn.IsEventDone( "dlg_secondfloor_scientist" ) then

    cmn.SetEventDone( "dlg_secondfloor_scientist" );
    ObjSet( "spr_secondfloor_scientist_ectoplasm_detector", { alp = 1 } );
    cmn.CallEventHandler( "dlg_secondfloor_scientist_inv" );
    common_impl.ShowBbt( "bbt_dlg_secondfloor_scientist", 1 );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    interface.KeyTaskAdd( "bring_ectoplasm", true );
    
    common_impl.AddPageDiary( 18 );

  end;

end;
--*********************************************************************************************************************
function private.dlg_secondfloor_meeting()

  ObjAttach( "dlg_secondfloor_meeting", private.room_objname );
  ObjSet("anm_secondfloor_meeting_loc", { alp = 0 });
  ObjSet("anm_secondfloor_meeting_2", { alp = 0 });
  cmn.CallEventHandler( "dlg_secondfloor_meeting_beg" );
  
  common_impl.dialog_character_loc = "anm_secondfloor_scintist_2";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "meeting", 4, nil, nil, true, "dlg_secondfloor_meeting_end" );

end;
--*********************************************************************************************************************
function public.dlg_secondfloor_meeting_end()

  if not cmn.IsEventDone( "dlg_secondfloor_meeting" ) then

    cmn.SetEventDone( "dlg_secondfloor_meeting" );
    ObjSet( "spr_secondfloor_meeting_apparatus", { alp = 1 } );
    ObjSet( "spr_secondfloor_meeting_element", { alp = 1 } );
    ObjSet( "obj_secondfloor_scientist_sit", { alp = 1 });
    
    cmn.CallEventHandler( "dlg_secondfloor_meeting_inv" );
    common_impl.ShowBbt( "bbt_dlg_secondfloor_meeting", 1 );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    interface.KeyTaskAdd( "stop_avenger", true );
    
    common_impl.AddPageDiary( 19 );
    
    ObjMultiSet( { { "obj_int_dialog_character", { visible = true } },
                   { "obj_secondfloor_meeting_mmg", { input = false, alp = 0 } },
                   { "obj_int_dialog_character_input", { event_mdown = int_dialog_character.ContinueClick } } } );
                   
    ObjAttach( "obj_secondfloor_meeting_mmg", "dlg_secondfloor_meeting" );

  end;

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, txt_count )
  
  if dlg_name == "scientist" then
    
    if txt_count == 3 then
      
      local func_after = function()
        
        ObjMultiSet( { 
          { "anm_secondfloor_scientist_scientist_2", { alp = 0 } },
          { "anm_secondfloor_scientist_scientist_3", { alp = 1, playing = true } }
        } );   
        
      end;
      
      ObjMultiSet( { 
        { "anm_secondfloor_scientist_scientist_1", { alp = 0 } },
        { "anm_secondfloor_scientist_scientist_2", { alp = 1, playing = true, endtrig = func_after } }
      } );
      
    end;
    
  end;     
  
  if dlg_name == "meeting" then
    
    if txt_count == 1 then
      
      ObjSet( "obj_int_dialog_character_input", { event_mdown = private.dlg_start_mmg } );
      
    elseif txt_count == 3 then
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      
      ObjMultiSet( { 
        { "anm_secondfloor_meeting_scientist_2", { alp = 0 } },
        { "anm_secondfloor_meeting_scientist_3", { alp = 1 } },
        { "obj_int_dialog_character_input", { event_mdown = function() private.dlg_get_item( "apparat" ); end } }
      } );
      
    end;
    
  end; 
  
end;
--*********************************************************************************************************************
function private.dlg_start_mmg()
  
  ObjSet( "obj_int_dialog_character_input", { input = false } );
  ObjSet( "vid_secondfloor_meeting_1", { alp = 0 });
      
  common_impl.DialogCharacterMmgShow( "meeting", 250, 360, nil  );
  
end;
--*********************************************************************************************************************
function private.dlg_dragdrop()
  
  common_impl.SetCursor( CURSOR_DEFAULT );
  
  if ObjIntersect( "spr_secondfloor_meeting_mmg_apparatus", "obj_secondfloor_meeting_mmg_use_apparat" ) then
  
    local func_after = function()
        
      ObjMultiSet( { 
        { "anm_secondfloor_meeting_scientist_apparatus", { alp = 0 } },
        { "anm_secondfloor_meeting_scientist_2", { alp = 1, playing = true } },
        { "obj_int_dialog_character_input", { input = true, event_mdown = function() int_dialog_character.ContinueClick( false ); end } }
         
      } );
      
        int_dialog_character.ContinueClick( false );
      
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_int_meeting_use_apparat", 0, "", 0 );
    
    ObjMultiSet( { 
      { "anm_secondfloor_meeting_scientist_1", { alp = 0 } },
      { "anm_secondfloor_meeting_scientist_apparatus", { alp = 1, playing = true, endtrig = func_after } },
      { "spr_secondfloor_meeting_mmg_apparatus", { alp = 0, input = false } },
 
    } );
    
    common_impl.DialogCharacterMmgHide( "meeting"  );
    
  end;
  
end;
--*********************************************************************************************************************
function private.dlg_get_item( name )
  
  if name == "apparat" then
    
    ObjMultiSet( { 
       { "anm_secondfloor_meeting_scientist_2", { alp = 0 } },
       { "anm_secondfloor_meeting_scientist_3", { alp = 1 } },
       { "obj_int_dialog_character_input", { event_mdown = function() int_dialog_character.ContinueClick( false ); end } }
      } );
    
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_secondfloor_candles_left", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
ObjAnimate( "spr_secondfloor_candles_right", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );

ObjAnimate( "spr_secondfloor_chandelier_1", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_secondfloor_chandelier_2", "alp", 1, 0, "", { 0,0,1, 2.5,0,0.5, 5,0,1 } );
ObjAnimate( "spr_secondfloor_chandelier_3", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.5, 3,0,1 } );

ObjAnimate( "spr_secondfloor_light_1", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_secondfloor_light_2", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_secondfloor_light_3", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_studydoor_light_add", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } )