-- name=rm_secondroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 
   { "spr_secondroom_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_9" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
     { "obj_secondroom_clk_man", { event_mdown = private.clk_man } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gmg_secondroom_final"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_secondroom", update_game_mode_secondroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secondroom = function ()

  local effects_table = 
  {
    "obj_secondroom_anim" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secondroom", update_performance_mode_secondroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secondroom () end;
  --------------------------------------------------------------------------------------------
  local opn_secondroom_map = function ()

    common_impl.VisitMapRoom( "secondroom" );

  end;
  cmn.AddSubscriber( "opn_secondroom", opn_secondroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_9 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_9 = function ()
  
    ObjDelete( "obj_secondroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_9", get_collect_morph_item_4_9, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_enhancedapparatus () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_enhancedapparatus" ] = {
    type = "use",
    inv_obj = "inv_enhancedapparatus",
    use_place = "obj_secondroom_use_enhancedapparatus",
    room = private.room_objname
  };
  local use_enhancedapparatus_inv = function ()
  
    interface.InventoryItemRemove( "inv_enhancedapparatus" );
  
  end;
  local use_enhancedapparatus_beg = function ()
  
    ObjDelete( "obj_secondroom_use_enhancedapparatus" );
  
  end;
  local use_enhancedapparatus_end = function ()
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_enhancedapparatus", use_enhancedapparatus_beg, private.room_objname );
  cmn.AddSubscriber( "use_enhancedapparatus", use_enhancedapparatus_inv );
  cmn.AddSubscriber( "use_enhancedapparatus", use_enhancedapparatus_end, private.room_objname );
  cmn.AddSubscriber( "use_enhancedapparatus_inv", use_enhancedapparatus_inv, private.room_objname );
  cmn.AddSubscriber( "use_enhancedapparatus_beg", use_enhancedapparatus_beg, private.room_objname );
  cmn.AddSubscriber( "use_enhancedapparatus_end", use_enhancedapparatus_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_secondroom_attack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_secondroom_attack" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_secondroom_attack",
    
  };
  local vid_secondroom_attack_end = function ()
  
    ObjSet( "gmg_secondroom_final", { active = true, input = true });
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_secondroom_attack", vid_secondroom_attack_end, private.room_objname  );
  cmn.AddSubscriber( "vid_secondroom_attack_end", vid_secondroom_attack_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_secondroom_autro () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_secondroom_autro" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_secondroom_autro",
    
  };
  local vid_secondroom_autro_end = function ()
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_secondroom_autro", vid_secondroom_autro_end, private.room_objname  );
  cmn.AddSubscriber( "vid_secondroom_autro_end", vid_secondroom_autro_end, private.room_objname  );
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_secondroom();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_secondroom_env" }, "", 0.5 );
  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
 
  if( cmn.IsEventDone("use_enhancedapparatus") and not cmn.IsEventDone("vid_secondroom_attack") ) then
    
    private.vid_secondroom_attack();
    
  elseif( cmn.IsEventDone( "win_final" ) and not cmn.IsEventDone("vid_secondroom_autro") ) then
    
    private.vid_secondroom_autro();
    
  else
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_secondroom_ghost_env", 1, "", 0 );
      common_impl.PlayAudio( "env", "common/audio/levelext/aud_secondroom_man_scared_env", 1, "", 0 );
  end;
  
  common_impl.MorphItemMorphing();
  
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_enhancedapparatus()

  local item = "inv_enhancedapparatus";

  if ( common.ApplyObj( item, "obj_secondroom_use_enhancedapparatus", false ) ) then

    cmn.CallEventHandler( "use_enhancedapparatus_inv" );
    cmn.CallEventHandler( "use_enhancedapparatus_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_enhancedapparatus" );
      cmn.CallEventHandler( "use_enhancedapparatus_end" );
      
      private.vid_secondroom_attack();
    
    end;

  common_impl.Lock( true );
  func_after();
 
  return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_man()

  local func_after = function()
    
    common_impl.Lock(false);
    ObjSet( "anm_secondroom_man_2", { alp = 0});
    ObjSet( "anm_secondroom_man", { alp = 1});
    common_impl.ShowBbt( "bbt_secondroom_man")
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_secondroom_man_scared_env", 1, "", 0 );
    
  end;
  
  common_impl.Lock(true);
  ObjSet( "anm_secondroom_man", { alp = 0});
  ObjSet( "anm_secondroom_man_2", { alp = 1});
  AnimPlay( "anm_secondroom_man_2", "DoAnim", func_after)
  
  common_impl.StopAudio( "env", "common/audio/levelext/aud_secondroom_man_scared_env", 0 );  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_secondroom_man", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_secondroom()

  if not ( cmn.IsEventDone( "opn_secondroom" ) ) then
    cmn.SetEventDone( "opn_secondroom" );
  end;
  
  cmn.CallEventHandler( "opn_secondroom" ); 

end;
--*********************************************************************************************************************
function private.vid_secondroom_attack()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_secondroom_attack" );
    cmn.CallEventHandler( "vid_secondroom_attack_end" );
    common_impl.ShowBbt( 'bbt_vid_secondroom_attack', 1 );
    cmn.GotoRoom('mg_final');
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_secondroom_attack", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_secondroom_attack_voc", 0.2 );
      
    end;
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_secondroom_ghost_env", 1, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/levelext/aud_secondroom_man_scared_env", 1, "", 0 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_secondroom_attack", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_secondroom_attack_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_secondroom_attack", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_secondroom_attack", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_secondroom_autro()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_secondroom_autro" );
    cmn.CallEventHandler( "vid_secondroom_autro_end" );
    
    common.GotoRoom( "rm_credits" );
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_secondroom_autro", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_secondroom_autro_voc", 0.2 );
      
    end;

    --common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_secondroom_autro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_secondroom_autro_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_secondroom_autro", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_secondroom_autro", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_secondroom_lamp_right", "alp", 1, 0, "", { 0,0,1, 2,0,0.5, 4,0,1 } );
ObjAnimate( "spr_secondroom_lamp", "alp", 1, 0, "", { 0,0,1, 2.5,0,0.5, 5,0,1 } );
ObjAnimate( "spr_secondroom_lamp_left", "alp", 1, 0, "", { 0,0,1, 1.5,0,0.5, 3,0,1 } );