-- name=rm_smallroom_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_smallroom_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_closetwithshelves", "room_hub" );
  ObjAttach( "zz_threewaymirror", "room_hub" );
  ObjAttach( "zz_statue_4", "room_hub" );
  private.Init_Subroom();
  
  for i = 1, 3 do
    
    ObjSet( "obj_closetwithshelves_clk_"..i, { event_mdown = function() private.ClkBook( i ); end,
                                               event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                               event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end, } );
    
  end;
  
  ObjMultiSet({ 
    { "spr_closetwithshelves_plank_4_1", { event_mdown = private.get_plank_4_1 }},
    { "spr_closetwithshelves_handkerchief", { event_mdown = private.get_handkerchief }},
    { "spr_closetwithshelves_radio", { event_mdown = private.get_radio }},
    { "spr_closetwithshelves_tongs_4", { event_mdown = private.get_tongs_4 }},
    { "spr_threewaymirror_ring_4", { event_mdown = private.get_ring_4 }},
    { "spr_threewaymirror_shard", { event_mdown = private.get_shard }},
    { "spr_threewaymirror_doorelement_4_1", { event_mdown = private.get_doorelement_4_1 }},
    { "spr_statue_4_threewaymirrortoken", { event_mdown = private.get_threewaymirrortoken }},
    { "spr_statue_4_amuletelement_4_3", { event_mdown = private.get_amuletelement_4_3 }},
    { "obj_closetwithshelves_use_hairpin_4", { event_mdown = private.clk_door_closet }},
    { "spr_statue_4_collect_2", { event_mdown = function () private.get_collect_2_4_2(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }}, 
    { "obj_threewaymirror_use_threewaymirrortoken", { event_mdown = private.clk_door_threewaymirror }},
    { "spr_smallroom_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_smallroom_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gzz_smallroom_4_closetwithshelves",
    "gzz_smallroom_4_threewaymirror",
    "gzz_smallroom_4_statue_4"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_closetwithshelves",
    "zz_threewaymirror", 
    "zz_statue_4"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_smallroom_4", update_game_mode_smallroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_smallroom_4 = function ()

  local effects_table = 
  {
    "obj_smallroom_4_anim" 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_smallroom_4", update_performance_mode_smallroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_smallroom_4 () end;
  --------------------------------------------------------------------------------------------
  local opn_smallroom_4_map = function ()

    common_impl.VisitMapRoom( "smallroom_4" );

  end;
  cmn.AddSubscriber( "opn_smallroom_4", opn_smallroom_4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_plank_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plank_4_1" ] = {
    type = "get",
    get_obj = "spr_closetwithshelves_plank_4_1",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
    
  local get_plank_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_plank_4_1", "spr_closetwithshelves_plank_4_1" );
  end;
  
  local get_plank_4_1_closezz = function ()
  
    ObjDelete( "gfx_closetwithshelves_plank_4_1" );
    ObjDelete( "spr_smallroom_4_closetwithshelves_plank" );
    ObjSet( "obj_closetwithshelves_clk_2", { input = true });
  
  end;
  
  cmn.AddSubscriber( "get_plank_4_1", get_plank_4_1_inv );
  cmn.AddSubscriber( "get_plank_4_1", get_plank_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handkerchief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handkerchief" ] = {
    type = "get",
    get_obj = "spr_closetwithshelves_handkerchief",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
    
  local get_handkerchief_inv = function ()
  
    interface.InventoryItemAdd( "inv_handkerchief", "spr_closetwithshelves_handkerchief" );
  
  end;
  
  local get_handkerchief_closezz = function ()
  
    ObjDelete( "gfx_closetwithshelves_handkerchief" );
    ObjDelete( "spr_smallroom_4_closetwithshelves_shawel" );
    if cmn.IsEventDone("get_radio") and cmn.IsEventDone("get_tongs_4") then
      
      ObjDelete( "gzz_smallroom_4_closetwithshelves" );
    
    end;
  
  end;
  
  cmn.AddSubscriber( "get_handkerchief", get_handkerchief_inv );
  cmn.AddSubscriber( "get_handkerchief", get_handkerchief_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_radio () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_radio" ] = {
    type = "get",
    get_obj = "spr_closetwithshelves_radio",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
    
  local get_radio_inv = function ()
  
    interface.InventoryItemAdd( "inv_radio", "spr_closetwithshelves_radio" );
    ObjSet( "inv_radio", { drag = false });
    if ( cmn.IsEventDone( "get_screwdriver_4" ) ) then
      ObjSet( "spr_radio_plus_light", { alp = 1 });     
    end;
    
  end;
  
  local get_radio_closezz = function ()
  
    ObjDelete( "gfx_closetwithshelves_radio" );
    ObjDelete( "spr_smallroom_4_closetwithshelves_radio" );
    
    if cmn.IsEventDone("get_handkerchief") and cmn.IsEventDone("get_tongs_4") then 
      
      ObjDelete( "gzz_smallroom_4_closetwithshelves" );
    
    end;
    
  
  end;
  
  cmn.AddSubscriber( "get_radio", get_radio_inv );
  cmn.AddSubscriber( "get_radio", get_radio_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs_4" ] = {
    type = "get",
    get_obj = "spr_closetwithshelves_tongs_4",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
    
  local get_tongs_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs_4", "spr_closetwithshelves_tongs_4" );
  
  end;
  
  local get_tongs_4_closezz = function ()
  
    ObjDelete( "gfx_closetwithshelves_tongs_4" );
    ObjDelete( "spr_closetwithshelves_tongs_shadow");
    ObjDelete( "spr_smallroom_4_closetwithshelves_nippers" );
    
    if cmn.IsEventDone("get_handkerchief") and cmn.IsEventDone("get_radio") then 
      
      ObjDelete( "gzz_smallroom_4_closetwithshelves" );
    
    end;
  end;
  
  cmn.AddSubscriber( "get_tongs_4", get_tongs_4_inv );
  cmn.AddSubscriber( "get_tongs_4", get_tongs_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring_4" ] = {
    type = "get",
    get_obj = "spr_threewaymirror_ring_4",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_smallroom_4_threewaymirror"
  };
    
  local get_ring_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_ring_4", "spr_threewaymirror_ring_4" );
  
  end;
  
  local get_ring_4_closezz = function ()
  
    ObjDelete( "gfx_threewaymirror_ring_4" );
    ObjDelete( "spr_smallroom_4_threewaymirror_ring" );
    ObjDelete( "gzz_smallroom_4_threewaymirror" );
  
  end;
  
  cmn.AddSubscriber( "get_ring_4", get_ring_4_inv );
  cmn.AddSubscriber( "get_ring_4", get_ring_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shard" ] = {
    type = "get",
    get_obj = "spr_threewaymirror_shard",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_smallroom_4_threewaymirror"
  };
    
  local get_shard_inv = function ()
  
    interface.InventoryItemAdd( "inv_shard", "spr_threewaymirror_shard" );
  
  end;
  
  local get_shard_closezz = function ()
  
    ObjDelete( "gfx_threewaymirror_shard" );
    ObjDelete( "spr_smallroom_4_threewaymirror_splinter_2" );
  
  end;
  
  cmn.AddSubscriber( "get_shard", get_shard_inv );
  cmn.AddSubscriber( "get_shard", get_shard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doorelement_4_1" ] = {
    type = "get",
    get_obj = "spr_threewaymirror_doorelement_4_1",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_smallroom_4_threewaymirror"
  };
    
  local get_doorelement_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorelement_4_1", "spr_threewaymirror_doorelement_4_1" );
  
  end;
  
  local get_doorelement_4_1_closezz = function ()
  
    ObjDelete( "gfx_threewaymirror_doorelement_4_1" );
    ObjDelete( "spr_smallroom_4_threewaymirror_doorsimbl" );
  
  end;
  
  cmn.AddSubscriber( "get_doorelement_4_1", get_doorelement_4_1_inv );
  cmn.AddSubscriber( "get_doorelement_4_1", get_doorelement_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_threewaymirrortoken () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_threewaymirrortoken" ] = {
    type = "get",
    get_obj = "spr_statue_4_threewaymirrortoken",
    room = private.room_objname,
    zz = "zz_statue_4",
    zz_gate = "gzz_smallroom_4_statue_4"
  };
    
  local get_threewaymirrortoken_inv = function ()
  
    interface.InventoryItemAdd( "inv_threewaymirrortoken", "spr_statue_4_threewaymirrortoken" );
  
  end;
  
  local get_threewaymirrortoken_closezz = function ()
  
    ObjDelete( "gfx_statue_4_threewaymirrortoken" );
    ObjDelete( "spr_smallroom_4_statue_4_amulet_1" );
    ObjDelete( "anm_statue_4_hand");
    
    if ( cmn.IsEventDone("get_amuletelement_4_3") and common_impl.IsGetCollect( "get_collect_2_4_2" ) ) then
      ObjDelete( "gzz_smallroom_4_statue_4" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_threewaymirrortoken", get_threewaymirrortoken_inv );
  cmn.AddSubscriber( "get_threewaymirrortoken", get_threewaymirrortoken_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletelement_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletelement_4_3" ] = {
    type = "get",
    get_obj = "spr_statue_4_amuletelement_4_3",
    room = private.room_objname,
    zz = "zz_statue_4",
    zz_gate = "gzz_smallroom_4_statue_4"
  };
    
  local get_amuletelement_4_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletelement_4_3", "spr_statue_4_amuletelement_4_3" );
    ObjSet( "spr_brokenboxamulet_4_plus_light", { alp = 1 });
    
  end;
  
  local get_amuletelement_4_3_closezz = function ()
  
    ObjDelete( "gfx_statue_4_amuletelement_4_3" );
    ObjDelete( "spr_smallroom_4_statue_4_amulet_2" );
    
    if ( cmn.IsEventDone("get_threewaymirrortoken") and common_impl.IsGetCollect( "get_collect_2_4_2" ) ) then
      
      ObjDelete( "gzz_smallroom_4_statue_4" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_amuletelement_4_3", get_amuletelement_4_3_inv );
  cmn.AddSubscriber( "get_amuletelement_4_3", get_amuletelement_4_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ectoplasm_4_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ectoplasm_4_5" ] = {
    type = "get",
    get_obj = "anm_smallroom_4_ectoplasm_4_5",
    room = private.room_objname,
    zz = "zz_smallroom_4",
    zz_gate = "gzz_smallroom_4_smallroom_4"
  };

  local get_ectoplasm_4_5_inv = function ()

    interface.InventoryItemRemove( "inv_ectoplasm" );
    interface.InventoryItemAdd( "inv_ectoplasm", "anm_smallroom_4_ectoplasm_4_5", function() common.BlockGotoRoom(true); common_impl.Lock( false ); end, nil, "assets/levels/levelext/rm_secondfloor/inv/inv_ectoplasm" );

    ObjSet( "txt_ectoplasm_number", { text = levelext_inv.EctoplasmCount( ).."/6" } );

  end;
  
  local get_ectoplasm_4_5_closezz = function ()
  
    ObjDelete( "gfx_smallroom_4_ectoplasm" );
    --ObjDelete( "gzz_smallroom_4_smallroom_4" );
  
  end;
  
  cmn.AddSubscriber( "get_ectoplasm_4_5", get_ectoplasm_4_5_inv );
  cmn.AddSubscriber( "get_ectoplasm_4_5", get_ectoplasm_4_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_3 = function ()
  
  ObjDelete( "obj_smallroom_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_3", get_collect_morph_item_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_2 = function ()
  
    ObjDelete( "spr_statue_4_collect_2" );
    
   if cmn.IsEventDone( "get_threewaymirrortoken") and cmn.IsEventDone( "get_amuletelement_4_3") then
    
      ObjDelete("gzz_smallroom_4_statue_4")
    
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_2", get_collect_2_4_2 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4_2" ] = {
    type = "use",
    inv_obj = "inv_elf_4",
    use_place = "obj_closetwithshelves_use_elf_4",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
  local use_elf_4_2_inv = function ()
  
  end;
  local use_elf_4_2_beg = function ()
  
    ObjDelete( "obj_closetwithshelves_use_elf_4" );
  
  end;
  local use_elf_4_2_end = function ()
  
    ObjDelete( "vid_closetwithshelves_elf" );
    ObjSet( "spr_closetwithshelves_handkerchief", { input = true,  active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4_2", use_elf_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_2", use_elf_4_2_inv );
  cmn.AddSubscriber( "use_elf_4_2", use_elf_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_2_inv", use_elf_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_2_beg", use_elf_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_2_end", use_elf_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hairpin_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hairpin_4" ] = {
    type = "use",
    inv_obj = "inv_hairpin_4",
    use_place = "obj_closetwithshelves_use_hairpin_4",
    room = private.room_objname,
    zz = "zz_closetwithshelves",
    zz_gate = "gzz_smallroom_4_closetwithshelves"
  };
  local use_hairpin_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_hairpin_4" );
  
  end;
  local use_hairpin_4_beg = function ()
  
    ObjDelete( "obj_closetwithshelves_use_hairpin_4" );
  
  end;
  local use_hairpin_4_end = function ()
  
    ObjSet( "spr_closetwithshelves_radio", { input = true, active = true } );
    ObjSet( "spr_closetwithshelves_tongs_4", { input = true, active = true } );
    ObjSet( "spr_smallroom_4_closetwithshelves_open", { alp = 1 } );
    ObjSet( "spr_closetwithshelves_open", { alp = 1});
    ObjDelete("spr_closetwithshelves_close");
    ObjDelete("anm_closetwithshelves_use_hairpin");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hairpin_4", use_hairpin_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_4", use_hairpin_4_inv );
  cmn.AddSubscriber( "use_hairpin_4", use_hairpin_4_end, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_4_inv", use_hairpin_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_4_beg", use_hairpin_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_4_end", use_hairpin_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handkerchief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handkerchief" ] = {
    type = "use",
    inv_obj = "inv_handkerchief",
    use_place = "obj_threewaymirror_use_handkerchief",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_smallroom_4_threewaymirror"
  };
  local use_handkerchief_inv = function ()
  
    interface.InventoryItemRemove( "inv_handkerchief" );
  
  end;
  local use_handkerchief_beg = function ()
  
    ObjDelete( "obj_threewaymirror_use_handkerchief" );
  
  end;
  local use_handkerchief_end = function ()
  
    ObjSet( "spr_threewaymirror_shard", { input = true, active = true } );
    ObjDelete( "spr_smallroom_4_threewaymirror_splinter_1" );
    ObjSet( "spr_smallroom_4_threewaymirror_splinter_2", { alp = 1 } );
    ObjDelete( "anm_threewaymirror_use_handerchief" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_beg, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_inv );
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_end, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_inv", use_handkerchief_inv, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_beg", use_handkerchief_beg, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_end", use_handkerchief_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_threewaymirrortoken () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_threewaymirrortoken" ] = {
    type = "use",
    inv_obj = "inv_threewaymirrortoken",
    use_place = "obj_threewaymirror_use_threewaymirrortoken",
    room = private.room_objname,
    zz = "zz_threewaymirror",
    zz_gate = "gzz_smallroom_4_threewaymirror"
  };
  local use_threewaymirrortoken_inv = function ()
  
    interface.InventoryItemRemove( "inv_threewaymirrortoken" );
  
  end;
  local use_threewaymirrortoken_beg = function ()
  
    ObjDelete( "obj_threewaymirror_use_threewaymirrortoken" );
  
  end;
  local use_threewaymirrortoken_end = function ()
  
    ObjSet( "spr_threewaymirror_ring_4", { input = true, active = true } );
    ObjDelete("spr_threewaymirror_close");
    ObjSet("spr_threewaymirror_open", { alp = 1 });
    ObjSet("spr_smallroom_4_threewaymirror_open", { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_threewaymirrortoken", use_threewaymirrortoken_beg, private.room_objname );
  cmn.AddSubscriber( "use_threewaymirrortoken", use_threewaymirrortoken_inv );
  cmn.AddSubscriber( "use_threewaymirrortoken", use_threewaymirrortoken_end, private.room_objname );
  cmn.AddSubscriber( "use_threewaymirrortoken_inv", use_threewaymirrortoken_inv, private.room_objname );
  cmn.AddSubscriber( "use_threewaymirrortoken_beg", use_threewaymirrortoken_beg, private.room_objname );
  cmn.AddSubscriber( "use_threewaymirrortoken_end", use_threewaymirrortoken_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_4" ] = {
    type = "use",
    inv_obj = "inv_chisel_4",
    use_place = "obj_statue_4_use_chisel_4",
    room = private.room_objname,
    zz = "zz_statue_4",
    zz_gate = "gzz_smallroom_4_statue_4"
  };
  local use_chisel_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_chisel_4" );
  
  end;
  local use_chisel_4_beg = function ()
  
    ObjDelete( "obj_statue_4_use_chisel_4" );
  
  end;
  local use_chisel_4_end = function ()
    
    ObjMultiSet({ 
      { "obj_statue_4_use_hammer_4", { input = true, visible = true }},
      { "anm_statue_4_use_hammer", { alp = 1 }},
      { "spr_smallroom_4_statue_4_chisel", { alp = 1 }}
    });
    ObjDelete( "obj_statue_4_not_crack" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_4", use_chisel_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_4", use_chisel_4_inv );
  cmn.AddSubscriber( "use_chisel_4", use_chisel_4_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_4_inv", use_chisel_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_4_beg", use_chisel_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_4_end", use_chisel_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuefragment_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_statuefragment_4" ] = {
    type = "use",
    inv_obj = "inv_statuefragment_4",
    use_place = "obj_statue_4_use_statuefragment_4",
    room = private.room_objname,
    zz = "zz_statue_4",
    zz_gate = "gzz_smallroom_4_statue_4"
  };
  local use_statuefragment_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_statuefragment_4" );
  
  end;
  local use_statuefragment_4_beg = function ()
  
    ObjDelete( "obj_statue_4_use_statuefragment_4" );
  
  end;
  local use_statuefragment_4_end = function ()
  
    ObjSet( "spr_statue_4_threewaymirrortoken", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_statue_4_hand", { alp = 1 } );
    --ObjSet( "spr_statue_4_hand_over", { alp = 1 });
    ObjDelete( "spr_statue_4_ring" );
    --ObjDelete("anm_statue_4_hand");
    ObjSet("anm_statue_4_hand", { frame = 100 });
    ObjSet( "spr_smallroom_4_statue_4_hand_2", { alp = 1 } );
    ObjSet( "spr_smallroom_4_statue_4_amulet_1", { alp = 1 } );
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuefragment_4", use_statuefragment_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuefragment_4", use_statuefragment_4_inv );
  cmn.AddSubscriber( "use_statuefragment_4", use_statuefragment_4_end, private.room_objname );
  cmn.AddSubscriber( "use_statuefragment_4_inv", use_statuefragment_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuefragment_4_beg", use_statuefragment_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuefragment_4_end", use_statuefragment_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_4_1" ] = {
    type = "use",
    inv_obj = "inv_hammer_4",
    use_place = "obj_statue_4_use_hammer_4",
    room = private.room_objname,
    zz = "zz_statue_4",
    zz_gate = "gzz_smallroom_4_statue_4"
  };
  local use_hammer_4_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_hammer_4_2" ) ) then
      
      interface.InventoryItemRemove( "inv_hammer_4" );
      
    end;
    
  end;
  local use_hammer_4_1_beg = function ()
  
    ObjDelete( "obj_statue_4_use_hammer_4" );
  
  end;
  local use_hammer_4_1_end = function ()
    
    ObjDelete( "spr_smallroom_4_statue_4_chisel" );
    ObjDelete("anm_statue_4_use_hammer");
    ObjMultiSet({ 
        { "obj_statue_4_amuletelement_4_3", { input = true, alp = 1 }},
        { "spr_statue_4_amuletelement_4_3", { input = true, alp = 1 } },
        { "spr_smallroom_4_statue_4_crack", { alp = 1 } }
      });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_4_1", use_hammer_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_1", use_hammer_4_1_inv );
  cmn.AddSubscriber( "use_hammer_4_1", use_hammer_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_1_inv", use_hammer_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_1_beg", use_hammer_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_1_end", use_hammer_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_searcher_4_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_searcher_4_5" ] = {
    type = "use",
    inv_obj = "inv_searcher",
    use_place = "inv_searcher",
    room = private.room_objname
  };
  local use_searcher_4_5_inv = function ()
  
    if ( levelext_inv.IsUseAllSearchers( 5 ) ) then

      interface.InventoryItemRemove( "inv_searcher" );

    end;
  
  end;
  local use_searcher_4_5_beg = function ()
  
    
  
  end;
  local use_searcher_4_5_end = function ()
  
    ObjDelete( "obj_smallroom_4_use_searcher" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_searcher_4_5", use_searcher_4_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_5", use_searcher_4_5_inv );
  cmn.AddSubscriber( "use_searcher_4_5", use_searcher_4_5_end, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_5_inv", use_searcher_4_5_inv, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_5_beg", use_searcher_4_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_searcher_4_5_end", use_searcher_4_5_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

subroom.Define( "zz_closetwithshelves" );
---------------------------------------------------------------------------------------------
  function zz_closetwithshelves.PreOpen()
    
    for i = 1, 3  do
      
      if ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book[i] == 1 then
       
        ObjSet("spr_closetwithshelves_book_"..i, { alp = 1 });
        
      end;  
      
    end
    
     
  end;
---------------------------------------------------------------------------------------------  
subroom.Define("zz_statue_4")

  function zz_statue_4.Close()
    ObjSet( "grd_int_frame_subroom", {scale_x = 1});
  end;
  
  function zz_statue_4.PreOpen()
    ObjSet( "grd_int_frame_subroom", {scale_x = -1});
  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_smallroom_4();

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  common_impl.MorphItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_smallroom_4_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_4_2()

  local item = "inv_elf_4";

  if ( common.ApplyObj( item, "obj_closetwithshelves_use_elf_4", true ) ) then

    cmn.CallEventHandler( "use_elf_4_2_inv" );
    cmn.CallEventHandler( "use_elf_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      ObjSet( "spr_closetwithshelves_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_4", "spr_closetwithshelves_elf", nil, "video" )
      cmn.SetEventDone( "use_elf_4_2" );
      cmn.CallEventHandler( "use_elf_4_2_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_closetwithshelves_elf", 0, "", 0 );
    interface.InventoryItemRemove( "inv_elf_4" );
    VidPlay( "vid_closetwithshelves_elf", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_closetwithshelves", false ) and not cmn.IsEventDone( "use_elf_4_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closetwithshelves", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hairpin_4()

  local item = "inv_hairpin_4";

  if ( common.ApplyObj( item, "obj_closetwithshelves_use_hairpin_4", true ) ) then

    cmn.CallEventHandler( "use_hairpin_4_inv" );
    cmn.CallEventHandler( "use_hairpin_4_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_hairpin_4" );
        cmn.CallEventHandler( "use_hairpin_4_end" );
     
      end;
      
    ObjAnimate( "spr_closetwithshelves_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_closetwithshelves_open", "alp", 0, 0,"",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
      
    } );
    ObjAnimate( "anm_closetwithshelves_use_hairpin", "alp", 0, 0,"",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
      
    } );
    
    
   end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_hairpin_closetwithshelves", 0, "", 0 );
  
  AnimPlay( "anm_closetwithshelves_use_hairpin", "DoAnim", func_after );
    
  return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_closetwithshelves", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closetwithshelves", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_handkerchief()

  local item = "inv_handkerchief";

  if ( common.ApplyObj( item, "obj_threewaymirror_use_handkerchief", true ) ) then

    cmn.CallEventHandler( "use_handkerchief_inv" );
    cmn.CallEventHandler( "use_handkerchief_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_handkerchief" );
      cmn.CallEventHandler( "use_handkerchief_end" );
    --common.CloseSubRoom();;
      private.get_shard();
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_handkerchief_threewaymirror", 0, "", 0 );
  
    AnimPlay( "anm_threewaymirror_use_handerchief", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_threewaymirror", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_threewaymirror", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_threewaymirrortoken()

  local item = "inv_threewaymirrortoken";

  if ( common.ApplyObj( item, "obj_threewaymirror_use_threewaymirrortoken", true ) ) then

    cmn.CallEventHandler( "use_threewaymirrortoken_inv" );
    cmn.CallEventHandler( "use_threewaymirrortoken_beg" );

    local func_after = function ()
    
      local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_threewaymirrortoken" );
      cmn.CallEventHandler( "use_threewaymirrortoken_end" );
    --common.CloseSubRoom();;
      end;
      
    ObjAnimate( "spr_threewaymirror_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_threewaymirror_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_threewaymirrortoken_threewaymirro", 0, "", 0 );
  
    ObjAnimate( "spr_threewaymirror_badge", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_threewaymirror", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_threewaymirror", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel_4()

  local item = "inv_chisel_4";

  if ( common.ApplyObj( item, "obj_statue_4_use_chisel_4", true ) ) then

    cmn.CallEventHandler( "use_chisel_4_inv" );
    cmn.CallEventHandler( "use_chisel_4_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chisel_4" );
      cmn.CallEventHandler( "use_chisel_4_end" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_chisel_statue_4", 0, "", 0 );
   
    
    ObjAnimate( "anm_statue_4_use_hammer", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_statue_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue_4", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_statuefragment_4()

  local item = "inv_statuefragment_4";

  if ( common.ApplyObj( item, "obj_statue_4_use_statuefragment_4", true ) ) then

    cmn.CallEventHandler( "use_statuefragment_4_inv" );
    cmn.CallEventHandler( "use_statuefragment_4_beg" );

    local func_after = function ()
    
      local func_end = function ()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_statuefragment_4" );
        cmn.CallEventHandler( "use_statuefragment_4_end" );
        
      end;
   
      AnimPlay( "anm_statue_4_hand","DoAnim", func_end );
      
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_statuefragment_statue_4", 0, "", 0 );
   
    ObjAnimate( "anm_statue_4_hand", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_smallroom_4_statue_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue_4", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hammer_4_1()

  local item = "inv_hammer_4";

  if ( common.ApplyObj( item, "obj_statue_4_use_hammer_4", true ) and cmn.IsEventDone( "use_chisel_4" ) ) then

    cmn.CallEventHandler( "use_hammer_4_1_inv" );
    cmn.CallEventHandler( "use_hammer_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hammer_4_1" );
      cmn.CallEventHandler( "use_hammer_4_1_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_hammer_statue_4", 0, "", 0 );
    
    AnimPlay( "anm_statue_4_use_hammer", "DoAnim", func_after );
    
    return true;
    
  elseif common.ApplyObj( item, "gzz_smallroom_4_statue_4", false ) and cmn.IsEventDone( "use_chisel_4" ) and not cmn.IsEventDone( "use_hammer_4_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue_4", nil, { 512, 384 }, true );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_searcher_4_5( func )

  cmn.CallEventHandler( "use_searcher_4_5_beg" );

  local func_after = function ()

    --common_impl.Lock( false );
    cmn.SetEventDone( "use_searcher_4_5" );
    cmn.CallEventHandler( "use_searcher_4_5_end" );
    private.get_ectoplasm_4_5();
    
    local delayfunc = function ()

      --common_impl.Lock( false );
      func();
      --cmn.CallEventHandler( "use_searcher_4_5_inv" );

    end;

    cmn.DelayFunc( 1.5, delayfunc, private.room_objname );
    
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_searcher", 0, "", 0 );
  
  ObjSet( "anm_smallroom_4_ectoplasm_4_5", { visible = true, active = true, playing = true, endtrig = func_after } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_plank_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_plank_4_1" );
  cmn.CallEventHandler( "get_plank_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_handkerchief()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_handkerchief" );
  cmn.CallEventHandler( "get_handkerchief" );
  if cmn.IsEventDone("get_radio") and cmn.IsEventDone("get_tongs_4") then 
      
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_radio()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_radio" );
  cmn.CallEventHandler( "get_radio" );
  if cmn.IsEventDone("get_handkerchief") and cmn.IsEventDone("get_tongs_4") then 
      
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_tongs_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tongs_4" );
  cmn.CallEventHandler( "get_tongs_4" );
  if cmn.IsEventDone("get_handkerchief") and cmn.IsEventDone("get_radio") then 
      
    common.CloseSubRoom();
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_ring_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ring_4" );
  cmn.CallEventHandler( "get_ring_4" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_shard()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_shard" );
  cmn.CallEventHandler( "get_shard" );

end;
--------------------------------------------------------------------------------------------
function private.get_doorelement_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_doorelement_4_1" );
  cmn.CallEventHandler( "get_doorelement_4_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_threewaymirrortoken()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_threewaymirrortoken" );
  cmn.CallEventHandler( "get_threewaymirrortoken" );
  
  if ( cmn.IsEventDone("get_amuletelement_4_3") and common_impl.IsGetCollect( "get_collect_2_4_2" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_amuletelement_4_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_amuletelement_4_3" );
  cmn.CallEventHandler( "get_amuletelement_4_3" );
  
  if ( cmn.IsEventDone("get_threewaymirrortoken") and common_impl.IsGetCollect( "get_collect_2_4_2" )) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_ectoplasm_4_5()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ectoplasm_4_5" );
  cmn.CallEventHandler( "get_ectoplasm_4_5" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_4_2()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_2");
    cmn.CallEventHandler("get_collect_2_4_2");
    
    if cmn.IsEventDone( "get_threewaymirrortoken") and cmn.IsEventDone( "get_amuletelement_4_3") then
    
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.PlayEffectHO( "spr_statue_4_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_door_closet()
  
  local func_after = function ()
  
    common_impl.Lock( false );
  
  end;

  common_impl.Lock( true );
  
  common_impl.ShowBbt( 'bbt_closetwithshelves_use_hairpin_4' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_closetwithshelves", 0, "", 0 );
  
  ObjAnimate( "spr_closetwithshelves_close", "pos_x", 0, 0, func_after,
  { 
  
    0.0, 0, 155,
    0.3, 0, 156,
    0.6, 0, 155

  } );
  ObjAnimate( "anm_closetwithshelves_use_hairpin", "pos_x", 0, 0, "",
  { 
  
    0.0, 0, 156,
    0.3, 0, 157,
    0.6, 0, 156

  } );
  
  ObjAnimate( "anm_closetwithshelves_use_hairpin", "scale_x", 0, 0, "",
  { 
  
    0.0, 0, 1,
    0.3, 0, 1.01,
    0.6, 0, 1

  } );
  
  ObjAnimate( "spr_closetwithshelves_close", "scale_x", 0, 0, "",
  { 
  
    0.0, 0, 1,
    0.3, 0, 1.01,
    0.6, 0, 1

  } );
  
end; 
--------------------------------------------------------------------------------
function private.ClkBook(i) 
 
 local func_after = function ()
  
    common_impl.Lock( false );
    if ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book[i] == 1 then
      
      ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book[i] = 0;
      
    else
      
      ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book[i] = 1;
    
    end;  
  
  end;
  
  common_impl.Lock( true ); 
  
  common_impl.ShowBbt( 'bbt_closetwithshelves_book' );
  
  if ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book[i] == 1 then
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_closetwithshelves_book_in", 0, "", 0 );
  
    ObjAnimate( "spr_closetwithshelves_book_"..i, "alp", 0, 0, func_after,
    { 
    
      0.0, 0, 1,
      0.3, 0, 0

    } );
    
  else   
    
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_closetwithshelves_book_out", 0, "", 0 );
   
    ObjAnimate( "spr_closetwithshelves_book_"..i, "alp", 0, 0, func_after,
    { 
    
      0.0, 0, 0,
      0.3, 0, 1

    } ); 
  
  end;
  
end;  
--------------------------------------------------------------------------------
function private.clk_door_threewaymirror()
  
  local func_after = function ()
  
    common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  
  common_impl.ShowBbt( 'bbt_threewaymirror_use_threewaymirrortoken' );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_door_threewaymirror", 0, "", 0 );
  
  ObjAnimate( "spr_threewaymirror_close", "pos_x", 0, 0, func_after,
  { 
  
    0.0, 0, 110,
    0.3, 0, 109,
    0.6, 0, 110

  } );
  
  ObjAnimate( "spr_threewaymirror_close", "scale_x", 0, 0, "",
  { 
  
    0.0, 0, 1,
    0.3, 0, 0.99,
    0.6, 0, 1

  } );
  
end;  
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_smallroom_4()

  if not ( cmn.IsEventDone( "opn_smallroom_4" ) ) then
    cmn.SetEventDone( "opn_smallroom_4" );
    ng_global.progress[ "ext" ][ "opn_smallroom_4" ].book = {0, 0, 0};
    
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 1, "", 0 );
    
  end;
  
  cmn.CallEventHandler( "opn_smallroom_4" ); 

end;
--*********************************************************************************************************************
  ObjAnimate( "spr_smallroom_4_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1,
    0.5, 0, 0.6,
    1.0, 0, 1
  } );
