-- name=rm_study
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_study";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_writingdesk", "room_hub" );
  ObjAttach( "zz_aquarium", "room_hub" );
  ObjAttach( "zz_bookcase", "room_hub" );
  ObjAttach( "zz_keyhole_4", "room_hub" );
  private.Init_Subroom();
  
  local table_multiset = {};
  
  for i = 1, 10 do  
    
    table.insert( table_multiset, { "spr_bookcase_mmg_book_"..i, { 
    event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
    event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
    event_mdown = function() private.clk_book( i ) end,
    }} );
    
  end;
  
  ObjMultiSet( table_multiset );
  
  ObjMultiSet({ 
  { "spr_writingdesk_anglegrinderdisk", { event_mdown = private.get_anglegrinderdisk }},
  { "spr_writingdesk_book_4_3", { event_mdown = private.get_book_4_3 }},
  { "spr_writingdesk_doorkey_4", { event_mdown = private.get_doorkey_4 }},
  { "spr_aquarium_lanternelement_4_1", { event_mdown = private.get_lanternelement_4_1 }},
  { "spr_aquarium_boxhandle_4", { event_mdown = private.get_boxhandle_4 }},
  { "spr_aquarium_book_4_1", { event_mdown = private.get_book_4_1 }},
  { "spr_bookcase_lanternelement_4_2", { event_mdown = private.get_lanternelement_4_2 }},
  { "spr_bookcase_reliefelement", { event_mdown = private.get_reliefelement }},
  { "spr_keyhole_4_pen", { event_mdown = private.clk_doorkey_4 }},
  { "obj_writingdesk_clk_boxhandle", { event_mdown = private.clk_boxhandle_4 }},
  { "spr_bookcase_collect_2", { event_mdown = function () private.get_collect_2_4_4(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},
  { "spr_writingdesk_collect_2", { event_mdown = function () private.get_collect_2_4_3(); end,
                              event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                              event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,  }},                            
  { "spr_study_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_8" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_study_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  private.book_coord = { {-101, -135},
                         {- 50, -133},
                         {  -3, -133},
                         {  44, -135},
                         {  92, -134},
                         {-100,  110},
                         { -50,  112},
                         {  -5,  112},
                         {  45,  112},
                         {  91,  112} };
                         
  private.start = { 2, 4, 3, 6, 8, 10, 7, 5, 9, 1 };                       
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_study = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) or ng_global.gamemode == 1 or ng_global.gamemode == 2  then       
    visible_sparkle_ho = false;
    end;
  local gates = 
  {
    "gzz_study_writingdesk",
    "gzz_study_aquarium",
    "gzz_study_bookcase",
    "gzz_study_keyhole_4"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then    
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    
    end;

  end;

  local mas_parent_gfx = 
  {
    private.room_objname,
    "zz_writingdesk",
    "zz_aquarium",
    "zz_bookcase",
    "zz_keyhole_4"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_study", update_game_mode_study, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_study = function ()

  local effects_table = 
  {
    "obj_study_anim",
    "anm_aquarium_aquarium",
    "spr_aquarium_light"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

    ObjSet( effects_table[ i ], { visible = visible } )

    end;
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_study", update_performance_mode_study, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_study () end;
  --------------------------------------------------------------------------------------------
  local opn_study_map = function ()

    common_impl.VisitMapRoom( "study" );

  end;
  cmn.AddSubscriber( "opn_study", opn_study_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_anglegrinderdisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_anglegrinderdisk" ] = {
    type = "get",
    get_obj = "spr_writingdesk_anglegrinderdisk",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
    
  local get_anglegrinderdisk_inv = function ()
  
    interface.InventoryItemAdd( "inv_anglegrinderdisk", "spr_writingdesk_anglegrinderdisk" );
    ObjSet( "spr_anglegrinder_plus_light", { alp = 1 } );
  
  end;
  
  local get_anglegrinderdisk_closezz = function ()
  
    ObjDelete( "gfx_writingdesk_anglegrinderdisk" );
    ObjDelete( "spr_writingdesk_disk_shadow" );
    ObjDelete( "spr_study_writingdesk_disk" );
  
  end;
  
  cmn.AddSubscriber( "get_anglegrinderdisk", get_anglegrinderdisk_inv );
  cmn.AddSubscriber( "get_anglegrinderdisk", get_anglegrinderdisk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_book_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_book_4_3" ] = {
    type = "get",
    get_obj = "spr_writingdesk_book_4_3",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
    
  local get_book_4_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_book_4_3", "spr_writingdesk_book_4_3" );
  
  end;
  
  local get_book_4_3_closezz = function ()
  
    ObjDelete( "gfx_writingdesk_book_4_3" );
    ObjDelete( "spr_study_writingdesk_book" );
  
  end;
  
  cmn.AddSubscriber( "get_book_4_3", get_book_4_3_inv );
  cmn.AddSubscriber( "get_book_4_3", get_book_4_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorkey_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doorkey_4" ] = {
    type = "get",
    get_obj = "spr_writingdesk_doorkey_4",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
    
  local get_doorkey_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorkey_4", "spr_writingdesk_doorkey_4" );
  
  end;
  
  local get_doorkey_4_closezz = function ()
  
    ObjDelete( "gfx_writingdesk_doorkey_4" );
    ObjDelete( "gzz_study_writingdesk" );
    ObjDelete( "spr_study_writingdesk_key" );
  
  end;
  
  cmn.AddSubscriber( "get_doorkey_4", get_doorkey_4_inv );
  cmn.AddSubscriber( "get_doorkey_4", get_doorkey_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lanternelement_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lanternelement_4_1" ] = {
    type = "get",
    get_obj = "spr_aquarium_lanternelement_4_1",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_study_aquarium"
  };
    
  local get_lanternelement_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_lanternelement_4_1", "spr_aquarium_lanternelement_4_1" );
  
  end;
  
  local get_lanternelement_4_1_closezz = function ()
  
    ObjDelete( "gfx_aquarium_lanternelement_4_1" );
    ObjDelete( "spr_study_aquarium_note" );
    ObjDelete( "spr_aquarium_lanternelement_4_1_shadow" );
    
    if cmn.IsEventDone( "get_book_4_1" ) and cmn.IsEventDone( "get_boxhandle_4" ) then
    
      ObjDelete( "gzz_study_aquarium" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lanternelement_4_1", get_lanternelement_4_1_inv );
  cmn.AddSubscriber( "get_lanternelement_4_1", get_lanternelement_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxhandle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boxhandle_4" ] = {
    type = "get",
    get_obj = "spr_aquarium_boxhandle_4",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_study_aquarium"
  };
    
  local get_boxhandle_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxhandle_4", "spr_aquarium_boxhandle_4" );
  
  end;
  
  local get_boxhandle_4_closezz = function ()
  
    ObjDelete( "gfx_aquarium_boxhandle_4" );
    ObjDelete( "spr_aquarium_knob_over" );
    if cmn.IsEventDone( "get_book_4_1" ) and cmn.IsEventDone( "get_lanternelement_4_1" ) then
    
      ObjDelete( "gzz_study_aquarium" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_boxhandle_4", get_boxhandle_4_inv );
  cmn.AddSubscriber( "get_boxhandle_4", get_boxhandle_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_book_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_book_4_1" ] = {
    type = "get",
    get_obj = "spr_aquarium_book_4_1",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_study_aquarium"
  };
    
  local get_book_4_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_book_4_1", "spr_aquarium_book_4_1" );
  
  end;
  
  local get_book_4_1_closezz = function ()
  
    ObjDelete( "gfx_aquarium_book_4_1" );
    ObjDelete( "spr_study_aquarium_book" );
    ObjDelete( "spr_aquarium_book_4_1_shadow" );
    if cmn.IsEventDone( "get_boxhandle_4" ) and cmn.IsEventDone( "get_lanternelement_4_1" ) then
    
      ObjDelete( "gzz_study_aquarium" );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "get_book_4_1", get_book_4_1_inv );
  cmn.AddSubscriber( "get_book_4_1", get_book_4_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lanternelement_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lanternelement_4_2" ] = {
    type = "get",
    get_obj = "spr_bookcase_lanternelement_4_2",
    room = private.room_objname,
    zz = "zz_bookcase",
    zz_gate = "gzz_study_bookcase"
  };
    
  local get_lanternelement_4_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lanternelement_4_2", "spr_bookcase_lanternelement_4_2" );
  
  end;
  
  local get_lanternelement_4_2_closezz = function ()
  
    ObjDelete( "gfx_bookcase_lanternelement_4_2" );
    ObjDelete( "spr_bookcase_lanternelement_4_2_shadow" );
    ObjDelete( "spr_study_bookcase_note" );
  
  end;
  
  cmn.AddSubscriber( "get_lanternelement_4_2", get_lanternelement_4_2_inv );
  cmn.AddSubscriber( "get_lanternelement_4_2", get_lanternelement_4_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_reliefelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_reliefelement" ] = {
    type = "get",
    get_obj = "spr_bookcase_reliefelement",
    room = private.room_objname,
    zz = "zz_bookcase",
    zz_gate = "gzz_study_bookcase"
  };
    
  local get_reliefelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_reliefelement", "spr_bookcase_reliefelement" );
  
  end;
  
  local get_reliefelement_closezz = function ()
  
    ObjDelete( "gfx_bookcase_reliefelement" );
    ObjDelete( "spr_bookcase_reliefelement_shadow");
    if common_impl.IsGetCollect( "get_collect_2_4_4" ) then
      
      ObjDelete( "gzz_study_bookcase" );
      
    end;  
    ObjDelete( "spr_study_bookcase_stone" );
  
  end;
  
  cmn.AddSubscriber( "get_reliefelement", get_reliefelement_inv );
  cmn.AddSubscriber( "get_reliefelement", get_reliefelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_8 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_8 = function ()
  
    ObjDelete( "obj_study_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_8", get_collect_morph_item_4_8, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_3 = function ()
  
    ObjDelete( "obj_study_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_3", get_collect_item_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_4 = function ()
  
    ObjDelete( "spr_bookcase_collect_2" );
    if cmn.IsEventDone( "get_reliefelement" ) then
      
      ObjDelete( "gzz_study_bookcase" );
      
    end;
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_4", get_collect_2_4_4 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_4_3 = function ()
  
    ObjDelete( "spr_writingdesk_collect_2" );
    
  end;
  cmn.AddSubscriber( "get_collect_2_4_3", get_collect_2_4_3 , private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_4" ] = {
    type = "use",
    inv_obj = "inv_button_4",
    use_place = "obj_writingdesk_use_button_4",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
  local use_button_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_4" );
  
  end;
  local use_button_4_beg = function ()
  
    ObjDelete( "obj_writingdesk_use_button_4" );
  
  end;
  local use_button_4_end = function ()
  
    ObjSet( "spr_writingdesk_doorkey_4", { input = true, active = true } );
    ObjSet("obj_writingdesk_open", { alp = 1});
    ObjSet("spr_study_writingdesk_open", { alp = 1});
    ObjDelete("spr_writingdesk_flower");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_4", use_button_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_4", use_button_4_inv );
  cmn.AddSubscriber( "use_button_4", use_button_4_end, private.room_objname );
  cmn.AddSubscriber( "use_button_4_inv", use_button_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_4_beg", use_button_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_4_end", use_button_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boxhandle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boxhandle_4" ] = {
    type = "use",
    inv_obj = "inv_boxhandle_4",
    use_place = "obj_writingdesk_use_boxhandle_4",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
  local use_boxhandle_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxhandle_4" );
  
  end;
  local use_boxhandle_4_beg = function ()
  
    ObjDelete( "obj_writingdesk_use_boxhandle_4" );
  
  end;
  local use_boxhandle_4_end = function ()
  
  --ObjSet( "spr_writingdesk_book_4_3", { input = true,  active = true } );
    ObjSet( "spr_writingdesk_knob", { alp = 1});
    ObjSet( "obj_writingdesk_clk_boxhandle", { input = true, active = true });
    ObjSet( "spr_study_writingdesk_pen", { alp = 1});
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxhandle_4", use_boxhandle_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxhandle_4", use_boxhandle_4_inv );
  cmn.AddSubscriber( "use_boxhandle_4", use_boxhandle_4_end, private.room_objname );
  cmn.AddSubscriber( "use_boxhandle_4_inv", use_boxhandle_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxhandle_4_beg", use_boxhandle_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxhandle_4_end", use_boxhandle_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spinning () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spinning" ] = {
    type = "use",
    inv_obj = "inv_spinning",
    use_place = "obj_aquarium_use_spinning",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_study_aquarium"
  };
  local use_spinning_inv = function ()
  
    interface.InventoryItemRemove( "inv_spinning" );
  
  end;
  local use_spinning_beg = function ()
  
    ObjDelete( "obj_aquarium_use_spinning" );
  
  end;
  local use_spinning_end = function ()
  
    ObjSet( "spr_aquarium_boxhandle_4", { alp = 1 } );
    ObjDelete( "anm_aquarium_use_spinning" );
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spinning", use_spinning_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinning", use_spinning_inv );
  cmn.AddSubscriber( "use_spinning", use_spinning_end, private.room_objname );
  cmn.AddSubscriber( "use_spinning_inv", use_spinning_inv, private.room_objname );
  cmn.AddSubscriber( "use_spinning_beg", use_spinning_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinning_end", use_spinning_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_book_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_book_4_2" ] = {
    type = "use",
    inv_obj = "inv_book_4_2",
    use_place = "obj_bookcase_use_book",
    room = private.room_objname,
    zz = "zz_bookcase",
    zz_gate = "gzz_study_bookcase"
  };
  local use_book_4_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_book_4_2" );
  
  end;
  local use_book_4_2_beg = function ()
  
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_3" ) then 
    
      ObjDelete( "obj_bookcase_use_book" );
      
    end; 
  
  end;
  local use_book_4_2_end = function ()
  
    --ObjSet( "spr_bookcase_key", { input = true, visible = true, active = true } );
   
    ObjSet("spr_bookcase_mmg_book_7", { alp = 1 });
    ObjDelete( "spr_study_bookcase_book_2" );
    
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_3" ) then
      
      ObjSet( "obj_bookcase_mmg_books", { input = true });
        
    end;
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_book_4_2", use_book_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_2", use_book_4_2_inv );
  cmn.AddSubscriber( "use_book_4_2", use_book_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_book_4_2_inv", use_book_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_book_4_2_beg", use_book_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_2_end", use_book_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_book_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_book_4_3" ] = {
    type = "use",
    inv_obj = "inv_book_4_3",
    use_place = "obj_bookcase_use_book",
    room = private.room_objname,
    zz = "zz_bookcase",
    zz_gate = "gzz_study_bookcase"
  };
  local use_book_4_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_book_4_3" );
  
  end;
  local use_book_4_3_beg = function ()
  
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_2" ) then 
    
      ObjDelete( "obj_bookcase_use_book" );
      
    end; 
  
  end;
  local use_book_4_3_end = function ()
  
    --ObjSet( "spr_bookcase_key", { input = true, visible = true, active = true } );
    ObjSet("spr_bookcase_mmg_book_9", { alp = 1 });
    ObjDelete( "spr_study_bookcase_book_3" );
    
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_2" ) then
      
      ObjSet( "obj_bookcase_mmg_books", { input = true });
      
        
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_book_4_3", use_book_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_3", use_book_4_3_inv );
  cmn.AddSubscriber( "use_book_4_3", use_book_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_book_4_3_inv", use_book_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_book_4_3_beg", use_book_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_3_end", use_book_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_book_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_book_4_1" ] = {
    type = "use",
    inv_obj = "inv_book_4_1",
    use_place = "obj_bookcase_use_book",
    room = private.room_objname,
    zz = "zz_bookcase",
    zz_gate = "gzz_study_bookcase"
  };
  local use_book_4_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_book_4_1" );
  
  end;
  local use_book_4_1_beg = function ()
  
  if cmn.IsEventDone( "use_book_4_3" ) and cmn.IsEventDone( "use_book_4_2" ) then 
    
      ObjDelete( "obj_bookcase_use_book" );
      
    end; 
  
  end;
  local use_book_4_1_end = function ()
  
    --ObjSet( "spr_bookcase_key", { input = true, visible = true, active = true } );
    ObjSet("spr_bookcase_mmg_book_3", { alp = 1 });
    ObjDelete( "spr_study_bookcase_book_1" );
    
    if cmn.IsEventDone( "use_book_4_2" ) and cmn.IsEventDone( "use_book_4_3" ) then
      
      ObjSet( "obj_bookcase_mmg_books", { input = true });
        
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_book_4_1", use_book_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_1", use_book_4_1_inv );
  cmn.AddSubscriber( "use_book_4_1", use_book_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_book_4_1_inv", use_book_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_book_4_1_beg", use_book_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_4_1_end", use_book_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorkey_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doorkey_4" ] = {
    type = "use",
    inv_obj = "inv_doorkey_4",
    use_place = "obj_keyhole_4_use_doorkey_4",
    room = private.room_objname,
    zz = "zz_keyhole_4",
    zz_gate = "gzz_study_keyhole_4"
  };
  local use_doorkey_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorkey_4" );
  
  end;
  local use_doorkey_4_beg = function ()
  
    ObjDelete( "obj_keyhole_4_use_doorkey_4" );
  
  end;
  local use_doorkey_4_end = function ()
  
    ObjSet( "obj_keyhole_4_clk_doorkey_4", { input = true } );
    ObjDelete( "spr_keyhole_4_key_1" );
    ObjSet( "spr_keyhole_4_key_2", { alp = 1 } );
    ObjSet( "spr_study_keyhole_4_key", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorkey_4", use_doorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorkey_4", use_doorkey_4_inv );
  cmn.AddSubscriber( "use_doorkey_4", use_doorkey_4_end, private.room_objname );
  cmn.AddSubscriber( "use_doorkey_4_inv", use_doorkey_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorkey_4_beg", use_doorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorkey_4_end", use_doorkey_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_doorkey_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_doorkey_4" ] = {
    type = "click",
    use_place = "obj_keyhole_4_clk_doorkey_4",
    room = private.room_objname,
    zz = "zz_keyhole_4",
    zz_gate = "gzz_study_keyhole_4"
  };
  local clk_doorkey_4_beg = function ()
  
    ObjDelete( "obj_keyhole_4_clk_doorkey_4" );
  
  end;
  local clk_doorkey_4_end = function ()
  
    ObjDelete( "gzz_study_keyhole_4" );
    ObjDelete( "spr_keyhole_4_key_2" );
    ObjDelete( "obj_keyhole_4_pen" );
    ObjDelete( "spr_study_keyhole_4_key" );
    ObjSet( "spr_keyhole_4_open", { alp = 1 } );
    ObjSet( "grm_study_secondroom", { input = true,  active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_study_secondroom_focus");
    end;
    ObjSet( "spr_study_keyhole_door_op", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_doorkey_4", clk_doorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorkey_4", clk_doorkey_4_end, private.room_objname );
  cmn.AddSubscriber( "clk_doorkey_4_beg", clk_doorkey_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorkey_4_end", clk_doorkey_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_boxhandle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_boxhandle_4" ] = {
    type = "click",
    use_place = "obj_writingdesk_clk_boxhandle",
    room = private.room_objname,
    zz = "zz_writingdesk",
    zz_gate = "gzz_study_writingdesk"
  };
  
  local clk_boxhandle_4_beg = function ()
  
    ObjDelete( "obj_writingdesk_clk_boxhandle" );
  
  end;
  
  local clk_boxhandle_4_end = function ()
  
    ObjSet( "obj_writingdesk_box_open", { alp = 1 } );
    ObjSet( "spr_writingdesk_book_4_3", { input = true,  active = true } );
    ObjSet( "spr_study_writingdesk_open_2", { alp = 1});
    ObjDelete( "spr_study_writingdesk_pen" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boxhandle_4", clk_boxhandle_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxhandle_4", clk_boxhandle_4_end, private.room_objname );
  cmn.AddSubscriber( "clk_boxhandle_4_beg", clk_boxhandle_4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxhandle_4_end", clk_boxhandle_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_study_keyhole () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_study_keyhole" ] = {

    type = "click",    
    room = private.room_objname,
    use_place = "vid_study_keyhole",
    
  };
  local vid_study_keyhole_end = function ()
  
    ObjSet( "rm_hall_4", { color_r = 1, color_g = 1, color_b = 1 } );
    
  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_study_keyhole", vid_study_keyhole_end, private.room_objname  );
  cmn.AddSubscriber( "vid_study_keyhole_end", vid_study_keyhole_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function win_bookcase () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bookcase" ] = {

    type = "win",    
    room = private.room_objname,
    use_place = "obj_bookcase_mmg",
    zz_gate = "gzz_study_bookcase",
    zz = "zz_bookcase"

  };

  local win_bookcase = function ()
  
    if ( cmn.IsEventDone( "win_bookcase" ) ) then
      
      ObjSet( "spr_bookcase_reliefelement", { active = true, input = true }); 
      ObjDelete("obj_bookcase_mmg");
      ObjDelete( "spr_study_bookcase_books" );
      
    else 
      
      for i = 1, 10  do
        
        ObjSet( "spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].position[i], { pos_x = private.book_coord[i][1] , pos_y = private.book_coord[i][2]});
        
      end;
      
      if ng_global.progress[ "ext" ][ "win_bookcase" ].flag ~= 0 then 
        
        ObjSet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag.."_add", { alp = 1 });
        
      end;

    end;
  
  end;
 
  cmn.AddSubscriber( "win_bookcase", win_bookcase, private.room_objname );   
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_bookcase" );
  ---------------------------------------------------------------------------------------------
  function zz_bookcase.Open()
    
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_2" ) and cmn.IsEventDone( "use_book_4_3" ) and not cmn.IsEventDone( "win_bookcase" ) then
      
       cmn.MiniGameShow( "bookcase" );
      
    end;
     
  end;
  --------------------------------------------------------------------------------------------- 
  function zz_bookcase.Close()
    
    if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_2" ) and cmn.IsEventDone( "use_book_4_3" ) and not cmn.IsEventDone( "win_bookcase" ) then
      
       cmn.MiniGameHide( "bookcase" );
      
    end;
     
  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_study();
  if not cmn.IsEventStart("win_bookcase") then
    
    private.GetBookPosition();
    
  end;  

end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
 
  if ( not cmn.IsEventDone( "vid_study_keyhole" ) ) then

    ObjSet( "tmr_study_keyhole",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_study_keyhole(); end
    } );
      
  end;
  
  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();
  
  common_impl.EnvPlay( { "common/audio/levelext/aud_study_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_button_4()

  local item = "inv_button_4";

  if ( common.ApplyObj( item, "obj_writingdesk_use_button_4", true ) ) then

    cmn.CallEventHandler( "use_button_4_inv" );
    cmn.CallEventHandler( "use_button_4_beg" );

    local func_after = function ()
    
      local func_after_1 = function ()
    
        local func_end = function ()
  
          common_impl.Lock( false );
          cmn.SetEventDone( "use_button_4" );
          cmn.CallEventHandler( "use_button_4_end" );
      
        end;  
    --common.CloseSubRoom();;
    
       ObjAnimate( "obj_writingdesk_open", "alp", 0, 0, func_end,
       { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
          
       } );
       
     end; 
       
     AnimPlay("anm_writingdesk_statuette", "DoAnim", func_after_1);
     
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_button_writingdesk", 0, "", 0 );
  
    ObjAnimate( "spr_writingdesk_flower", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_writingdesk", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_boxhandle_4()

  local item = "inv_boxhandle_4";

  if ( common.ApplyObj( item, "obj_writingdesk_use_boxhandle_4", true ) ) then

    cmn.CallEventHandler( "use_boxhandle_4_inv" );
    cmn.CallEventHandler( "use_boxhandle_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_boxhandle_4" );
      cmn.CallEventHandler( "use_boxhandle_4_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_boxhandle_writingdesk", 0, "", 0 );
  
    ObjAnimate( "spr_writingdesk_knob", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_writingdesk", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spinning()

  local item = "inv_spinning";

  if ( common.ApplyObj( item, "obj_aquarium_use_spinning", true ) ) then

    cmn.CallEventHandler( "use_spinning_inv" );
    cmn.CallEventHandler( "use_spinning_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_spinning" );
      cmn.CallEventHandler( "use_spinning_end" );
  
      private.get_boxhandle_4();
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_spinning_aquarium", 0, "", 0 );
  
  AnimPlay( "anm_aquarium_use_spinning", "DoAnim", func_after );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_aquarium", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_aquarium", nil, { 512, 384 }, true );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_book_4_2()

  local item = "inv_book_4_2";

  if ( common.ApplyObj( item, "obj_bookcase_use_book", true ) ) then

    cmn.CallEventHandler( "use_book_4_2_inv" );
    cmn.CallEventHandler( "use_book_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_book_4_2" );
      cmn.CallEventHandler( "use_book_4_2_end" );

      if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_3" ) then
        
        cmn.MiniGameShow( 'bookcase' );
        common_impl.PassingMgStart( "bookcase" );
        ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
        ng_global.progress[ "ext" ][ "win_bookcase" ].position = { 2, 4, 3, 6, 8, 10, 7, 5 ,9, 1 };
        
        
      end;
    
  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_book_bookcase", 0, "", 0 );
  
    ObjAnimate( "spr_bookcase_mmg_book_7", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_bookcase", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bookcase", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_book_4_3()

  local item = "inv_book_4_3";

  if ( common.ApplyObj( item, "obj_bookcase_use_book", true ) ) then

    cmn.CallEventHandler( "use_book_4_3_inv" );
    cmn.CallEventHandler( "use_book_4_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_book_4_3" );
      cmn.CallEventHandler( "use_book_4_3_end" );

      if cmn.IsEventDone( "use_book_4_1" ) and cmn.IsEventDone( "use_book_4_2" ) then
        
        cmn.MiniGameShow( 'bookcase' );
        common_impl.PassingMgStart( "bookcase" );
        ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
        ng_global.progress[ "ext" ][ "win_bookcase" ].position = { 2, 4, 3, 6, 8, 10, 7, 5 ,9, 1 };
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_book_bookcase", 0, "", 0 );
  
   ObjAnimate( "spr_bookcase_mmg_book_9", "alp", 0, 0, func_after,
   { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
   } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_bookcase", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bookcase", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_book_4_1()

  local item = "inv_book_4_1";

  if ( common.ApplyObj( item, "obj_bookcase_use_book", true ) ) then

    cmn.CallEventHandler( "use_book_4_1_inv" );
    cmn.CallEventHandler( "use_book_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_book_4_1" );
      cmn.CallEventHandler( "use_book_4_1_end" );

      if cmn.IsEventDone( "use_book_4_2" ) and cmn.IsEventDone( "use_book_4_3" ) then
        
        cmn.MiniGameShow( 'bookcase' );
        common_impl.PassingMgStart( "bookcase" );
        ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
        ng_global.progress[ "ext" ][ "win_bookcase" ].position = { 2, 4, 3, 6, 8, 10, 7, 5 ,9, 1 };
        
      end;
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_book_bookcase", 0, "", 0 );
  
    ObjAnimate( "spr_bookcase_mmg_book_3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_study_bookcase", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bookcase", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorkey_4()

  local item = "inv_doorkey_4";

  if ( common.ApplyObj( item, "obj_keyhole_4_use_doorkey_4", true ) ) then

    cmn.CallEventHandler( "use_doorkey_4_inv" );
    cmn.CallEventHandler( "use_doorkey_4_beg" );

    local func_after = function ()
    
      local func_end = function ()  
      
        common_impl.Lock( false );
        cmn.SetEventDone( "use_doorkey_4" );
        cmn.CallEventHandler( "use_doorkey_4_end" );
        
      end;
    
      ObjAnimate( "spr_keyhole_4_key_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_keyhole_4_key_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.6, 0, 1.0
      } );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_use_doorkey_keyhole", 0, "", 0 );
    
    ObjAnimate( "spr_keyhole_4_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_study_keyhole_4", false ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_keyhole_4", nil, { 512, 384 }, true );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_anglegrinderdisk()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_anglegrinderdisk" );
  cmn.CallEventHandler( "get_anglegrinderdisk" );
 

end;
--------------------------------------------------------------------------------------------
function private.get_book_4_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_book_4_3" );
  cmn.CallEventHandler( "get_book_4_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_doorkey_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_doorkey_4" );
  cmn.CallEventHandler( "get_doorkey_4" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_lanternelement_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lanternelement_4_1" );
  cmn.CallEventHandler( "get_lanternelement_4_1" );
      
  if cmn.IsEventDone( "get_book_4_1" ) and cmn.IsEventDone( "get_boxhandle_4" ) then
    
      common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_boxhandle_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_boxhandle_4" );
  cmn.CallEventHandler( "get_boxhandle_4" );
  if cmn.IsEventDone( "get_book_4_1" ) and cmn.IsEventDone( "get_lanternelement_4_1" ) then
    
      common.CloseSubRoom();
      
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_book_4_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_book_4_1" );
  cmn.CallEventHandler( "get_book_4_1" );
  if cmn.IsEventDone( "get_lanternelement_4_1" ) and cmn.IsEventDone( "get_boxhandle_4" ) then
    
      common.CloseSubRoom();
      
  end;
end;
--------------------------------------------------------------------------------------------
function private.get_lanternelement_4_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lanternelement_4_2" );
  cmn.CallEventHandler( "get_lanternelement_4_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_reliefelement()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_reliefelement" );
  cmn.CallEventHandler( "get_reliefelement" );
  if common_impl.IsGetCollect( "get_collect_2_4_4" ) then
    
    common.CloseSubRoom();
    
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_collect_2_4_4()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_4");
    cmn.CallEventHandler("get_collect_2_4_4");
  
    if cmn.IsEventDone( "get_reliefelement") then
    
      common.CloseSubRoom();
    
    end;
    
  end;

  common_impl.PlayEffectHO( "spr_bookcase_collect_2", func_after ); 

end;
---------------------------------------------------------------------------------------------
function private.get_collect_2_4_3()

  local func_after = function ()
    
    common_impl.GetCollectDone("get_collect_2_4_3");
    cmn.CallEventHandler("get_collect_2_4_3");
  
  end;

  common_impl.PlayEffectHO( "spr_writingdesk_collect_2", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_boxhandle_4()
  
  cmn.CallEventHandler( "clk_boxhandle_4_beg" );
 
  local func_after = function ()
  
     common_impl.Lock( false );
     cmn.SetEventDone( "clk_boxhandle_4" );
     cmn.CallEventHandler( "clk_boxhandle_4_end" );
     
  end;
   
  common_impl.Lock( true ); 
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_boxhandle_writingdesk", 0, "", 0 );

  ObjAnimate( "obj_writingdesk_box_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  
  } );

end;  
--------------------------------------------------------------------------------------------
function private.clk_doorkey_4()
    
  local func_after = function ()
 
    if ( cmn.IsEventDone("use_doorkey_4") ) then
      
      local func_end = function()
      
        common_impl.Lock( false );
        cmn.SetEventDone( "clk_doorkey_4" );
        cmn.CallEventHandler( "clk_doorkey_4_end" );
        common.CloseSubRoom();
        
      end;
      
      ObjAnimate( "spr_keyhole_4_key_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "obj_keyhole_4_pen", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      
      ObjAnimate( "spr_keyhole_4_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
   
    else
      
      common_impl.Lock( false );
      
    end;
    
  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_touch_handle_keyhole", 0, "", 0 );
  
  ObjAnimate( "obj_keyhole_4_pen", "ang", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, -0.1,
    0.6, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_book( num )
  
  DbgTrace("clk");
 
  if ng_global.progress[ "ext" ][ "win_bookcase" ].flag == 0 then 
    
    --private.position = ObjGet( "spr_wineshelf_2_bottle_"..num).pos_z;
    private.Choice( num );
   
    
  else
    
    if  num == ng_global.progress[ "ext" ][ "win_bookcase" ].flag then
      
      ObjSet( "spr_bookcase_mmg_book_"..num.."_add", { alp = 0});
      --ObjSet( "spr_wineshelf_2_bottle_"..num, { pos_y = ObjGet("spr_wineshelf_2_bottle_"..num).pos_y + 70});
      
      ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
      
    else  
    
      private.Swap( num );
    
    end;
  
  end;
  
end; 
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.win_bookcase()
  
  local func_after = function ()
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   
    common_impl.Lock( false );
    cmn.MiniGameHide( "bookcase" );
    common_impl.PassingMgWin( "bookcase" );
    cmn.SetEventDone( "win_bookcase" );
    cmn.CallEventHandler( "win_bookcase" );
    
  end; 
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_bookcase_win", 0, "", 0 );
  ObjAnimate( "obj_bookcase_mmg", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
      
  } );
  ObjAnimate( "obj_bookcase_open", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
      
  } );
    
end;
--------------------------------------------------------------------------------
function private.Choice( num )
  
   local func_after = function ()
   
      common_impl.Lock( false );
      ng_global.progress[ "ext" ][ "win_bookcase" ].flag = num;
   
   end;
  
   common_impl.Lock( true );
  
   common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_bookcase_click", 0, "", 0 );
   
    ObjAnimate( "spr_bookcase_mmg_book_"..num.."_add", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
      
    } );
   

end;
--------------------------------------------------------------------------------
function private.Swap( num )
  
  local position_1 = 0;
  local position_2 = 0;
  local buffer = 0;
  local win = true;
  
   for i = 1, 10  do
     
     if ng_global.progress[ "ext" ][ "win_bookcase" ].flag  == ng_global.progress[ "ext" ][ "win_bookcase" ].position[i] then
       
         position_1 = i;
         
     end; 
     
     if num == ng_global.progress[ "ext" ][ "win_bookcase" ].position[i] then
       
        position_2 = i;
       
     end;   
     
   end;
  
  local func_after = function()
  
    common_impl.Lock( false );
    local temp = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
      
    for i = 1, 10  do
        
      temp[i] = ng_global.progress[ "ext" ][ "win_bookcase" ].position[i];
        
    end;
    
    buffer = ng_global.progress[ "ext" ][ "win_bookcase" ].flag;
    temp[position_1] = num;
    temp[position_2] = buffer;
    ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
    
    for i = 1, 10  do
      
      if temp[i] ~= i then 
        
        win = false;
        
      end;
      
    end;
    
  if win then 
    
    private.win_bookcase(); 

  else 
  
    for i = 1, 10  do
    
      ng_global.progress[ "ext" ][ "win_bookcase" ].position[i] = temp[i]
    
    end;  
  
  end;
  
  end;
 
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_bookcase_move", 0, "", 0 );
  
  ObjSet( "spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag.."_add", { alp = 0 });
  
  
  ObjAnimate( "spr_bookcase_mmg_book_"..num, "pos_xy", 0, 0, func_after,
  { 
  
    0.0, 0, ObjGet("spr_bookcase_mmg_book_"..num).pos_x, ObjGet("spr_bookcase_mmg_book_"..num).pos_y,
    0.3, 0, ObjGet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag).pos_x, ObjGet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag).pos_y,

      
  } );
  
  ObjAnimate( "spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag, "pos_xy", 0, 0, "",
  { 
  
    0.0, 0, ObjGet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag).pos_x, ObjGet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag).pos_y,
    0.3, 0, ObjGet("spr_bookcase_mmg_book_"..num).pos_x, ObjGet("spr_bookcase_mmg_book_"..num).pos_y

  } );
 
end;  
--------------------------------------------------------------------------------
function private.GetBookPosition()
  
  for i = 1, 10  do
    
    ObjSet( "spr_bookcase_mmg_book_"..private.start[i], { pos_x = private.book_coord[i][1] , pos_y = private.book_coord[i][2]});
    
  end;
  
  
end;  
--*********************************************************************************************************************
function private.skip_bookcase()
  
  private.win_bookcase();
  
end;
--********************************************************************************************************************* 
function public.Skip( name )
  
  if name == "win_bookcase" then
    
    private.skip_bookcase();
    
  end;
  
end;
--*********************************************************************************************************************
function private.reset_bookcase()
  
  private.GetBookPosition();
  ObjSet("spr_bookcase_mmg_book_"..ng_global.progress[ "ext" ][ "win_bookcase" ].flag.."_add", { alp = 0 });
  
  ng_global.progress[ "ext" ][ "win_bookcase" ].flag = 0;
  
  for  i = 1, 10  do
    
    ng_global.progress[ "ext" ][ "win_bookcase" ].position[i] = private.start[i];
    
  end;
  
end;  
--*********************************************************************************************************************
function public.Reset( name )
  
  if name == "win_bookcase" then
    
    private.reset_bookcase();
    
  end;
  
end;
--*********************************************************************************************************************
function private.opn_study()

  if not ( cmn.IsEventDone( "opn_study" ) ) then
    cmn.SetEventDone( "opn_study" );
  end;
  
  cmn.CallEventHandler( "opn_study" ); 

end;
--*********************************************************************************************************************
function private.vid_study_keyhole()

  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_study_keyhole" );
    cmn.CallEventHandler( "vid_study_keyhole_end" );
    common_impl.ShowBbt( 'bbt_vid_study_keyhole', 1 );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/levelext/aud_study_keyhole", 0.2 );
      common_impl.StopAudio( "voc", "common/audio/levelext/aud_study_keyhole_voc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

  end;

  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_study_keyhole", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/levelext/aud_study_keyhole_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_study_keyhole", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_study_keyhole", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_study_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );
ObjAnimate( "spr_aquarium_light", "alp", 1, 0, "", { 0,0,1, 1,0,0.5, 2,0,1 } );