-- name=ho_aquarium_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "aquarium_scr" );
  game.relations[ "ho_aquarium_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_aquarium_scr";
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_aquarium_scr_map", { event_mdown = function() private.TaskComplete( 'map' ) end } } );  
  table.insert( table_multiset, { "spr_aquarium_scr_barometer", { event_mdown = function() private.TaskComplete( 'barometer' ) end } } ); 
  table.insert( table_multiset, { "spr_aquarium_scr_fishhook", { event_mdown = function() private.TaskComplete( 'fishhook' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_seal_ring", { event_mdown = function() private.TaskComplete( 'seal_ring' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_umbrella", { event_mdown = function() private.TaskComplete( 'umbrella' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_boot", { event_mdown = function() private.TaskComplete( 'boot' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_seahorse_1", { event_mdown = function() private.TaskComplete( 'seahorse', 'spr_aquarium_scr_seahorse_1' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_seahorse_2", { event_mdown = function() private.TaskComplete( 'seahorse', 'spr_aquarium_scr_seahorse_2' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_seahorse_3", { event_mdown = function() private.TaskComplete( 'seahorse', 'spr_aquarium_scr_seahorse_3' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_turtle_1", { event_mdown = function() private.TaskComplete( 'turtle', 'spr_aquarium_scr_turtle_1' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_turtle_2", { event_mdown = function() private.TaskComplete( 'turtle', 'spr_aquarium_scr_turtle_2' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_turtle_3", { event_mdown = function() private.TaskComplete( 'turtle', 'spr_aquarium_scr_turtle_3' ); end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_jolly_roger", { event_mdown = function() private.TaskComplete( 'jolly_roger' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_forceps", { event_mdown = function() private.TaskComplete( 'forceps' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_rod", { event_mdown = function() private.TaskComplete( 'rod' ) end } } );
  table.insert( table_multiset, { "spr_aquarium_scr_net", { event_mdown = function() private.TaskComplete( 'net' ) end } } );
   
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_aquarium_scr = function ()

  local effects_table = 
  {
  --"anm_aquarium_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_aquarium_scr", update_performance_mode_owlscenescr, room_objname );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  -----------------------------------------------------------------------------
  local win_aquarium_scr = function ()

    if ( not cmn.IsEventDone( "win_aquarium_scr" ) ) then
      
       for j = 1, #ng_global.progress["scr"]["win_aquarium_scr"].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_aquarium_scr" ].found[ j ][ "object" ] );

        ObjSet( name, { visible = false, input = false, active = false } );
        ObjSet( name.."_shadow", { visible = false, input = false, active = false } );
      
      end;
      
    end;   
    
  end;
  
  cmn.AddSubscriber( "win_aquarium_scr", win_aquarium_scr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_1_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_1_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_1_big_check_ho_1", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_1" );

  end;

  cmn.AddSubscriber( "win_ho_1_scr", win_ho_1_scr_loc, "rm_mysteryroom" );
  -----------------------------------------------------------------------------------
  local win_aquarium_scr_inv = function ()

  if ( cmn.IsEventDone( "win_aquarium_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_aquarium_scr", win_aquarium_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_aquarium_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_aquarium_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_aquarium_scr" ) ) then
  
    cmn.InitHo( "aquarium_scr" );
    cmn.SetEventDone( "opn_aquarium_scr" );
    
    ng_global.progress[ "scr" ][ "win_aquarium_scr" ].parents = {};
  
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "map",                    1, 0, { { "spr_aquarium_scr_map" } } );
  interface.TaskPanelTaskAdd( ho_items, "barometer",              1, 0, { { "spr_aquarium_scr_barometer" } } );
  interface.TaskPanelTaskAdd( ho_items, "fishhook",               1, 0, { { "spr_aquarium_scr_fishhook" } } );
  interface.TaskPanelTaskAdd( ho_items, "seal_ring",              1, 0, { { "spr_aquarium_scr_seal_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella",               1, 0, { { "spr_aquarium_scr_umbrella" } } );
  interface.TaskPanelTaskAdd( ho_items, "boot",                   1, 0, { { "spr_aquarium_scr_boot" } } );
  interface.TaskPanelTaskAdd( ho_items, "seahorse",               3, 0, { { "spr_aquarium_scr_seahorse_1" }, { "spr_aquarium_scr_seahorse_2" }, { "spr_aquarium_scr_seahorse_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "turtle",                 3, 0, { { "spr_aquarium_scr_turtle_1" }, { "spr_aquarium_scr_turtle_2" }, { "spr_aquarium_scr_turtle_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "jolly_roger",            1, 0, { { "spr_aquarium_scr_jolly_roger" } } );
  interface.TaskPanelTaskAdd( ho_items, "forceps",                1, 0, { { "spr_aquarium_scr_forceps" } } );
  interface.TaskPanelTaskAdd( ho_items, "rod",                    1, 0, { { "spr_aquarium_scr_rod" } } );
  interface.TaskPanelTaskAdd( ho_items, "net",                    1, 0, { { "spr_aquarium_scr_net" } } );

  interface.TaskPanelShow( ho_items );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";
  
  if object_name then

    object = tostring( object_name );

  else

    object = "spr_aquarium_scr_"..task_name;

  end;
  
  table.insert( ng_global.progress[ "scr" ][ "win_aquarium_scr" ].parents, ObjGetRelations( object ).parent );
  
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )

  cmn.SetEventDone( "win_ho_1_scr" );
  --cmn.CallEventHandler( "win_ho_1_scr" );
  rm_mysteryroom.HoComplete( ho_name );

end;
--*********************************************************************************************************************