-- name=ho_hothouse_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "hothouse_scr" );
  game.relations[ "ho_hothouse_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_hothouse_scr";
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_hothouse_scr_bailer", { event_mdown = function() private.TaskComplete( 'bailer' ) end } } );  
  table.insert( table_multiset, { "spr_hothouse_scr_syringe", { event_mdown = function() private.TaskComplete( 'syringe' ) end } } ); 
  table.insert( table_multiset, { "spr_hothouse_scr_eyepieces", { event_mdown = function() private.TaskComplete( 'eyepieces' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_formula", { event_mdown = function() private.TaskComplete( 'formula' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_ladybird_1", { event_mdown = function() private.TaskComplete( 'ladybird', 'spr_hothouse_scr_ladybird_1' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_ladybird_2", { event_mdown = function() private.TaskComplete( 'ladybird', 'spr_hothouse_scr_ladybird_2' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_ladybird_3", { event_mdown = function() private.TaskComplete( 'ladybird', 'spr_hothouse_scr_ladybird_3' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_microscope", { event_mdown = function() private.TaskComplete( 'microscope' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_photo", { event_mdown = function() private.TaskComplete( 'photo' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_picture", { event_mdown = function() private.TaskComplete( 'picture' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_respirator", { event_mdown = function() private.TaskComplete( 'respirator' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_frog", { event_mdown = function() private.TaskComplete( 'frog' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_oldhandset", { event_mdown = function() private.TaskComplete( 'oldhandset' ) end } } );
  table.insert( table_multiset, { "spr_hothouse_scr_elephant", { event_mdown = function() private.FindElephant() end } } );
  
  for i = 1,8 do
    table.insert( table_multiset, { "obj_hothouse_scr_button"..i, 
    { 
    event_mdown = function() private.ClkButton( i ) end, 
    event_menter = function() SetCursor( CURSOR_HAND ) end, 
    event_mleave = function() SetCursor( CURSOR_DEFAULT ) end
    }});
  end;
  
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hothouse_scr = function ()

  local effects_table = 
  {
  --"anm_hothouse_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hothouse_scr", update_performance_mode_hothousescr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_5_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_5_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_5_big_check_ho_5", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_5" );

  end;

  cmn.AddSubscriber( "win_ho_5_scr", win_ho_5_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  ------------------------------------------------
  function unmark_syringe() 

    ObjSet( "spr_hothouse_scr_door", { alp = 0 } );
    ObjSet("obj_hothouse_scr_button", { input = false, alp = 0 });
    ObjSet( "spr_hothouse_scr_syringe", { input = true } );
    ObjSet( "obj_hothouse_scr_buttons", { input = false } );
    ObjSet( "obj_hothouse_scr_button1", { input = false } );

  end;

  cmn.AddSubscriber( "unmark_syringe", unmark_syringe, room_objname );
  ------------------------------------------------
  local win_hothouse_scr = function ()

    if ( cmn.IsEventDone( "win_hothouse_scr" ) ) then
    
    else 
      
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hothouse_scr" ].found;
  
      for i = 1, #ho_found, 1 do
    
        ObjSet( ho_found[ i ][ "object" ], { visible = false, input = false, active = false } );
        --ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = false, input = false, active = false } );
      
      end;
      
      if ( cmn.IsUnmarkedTask( "hothouse_scr", "syringe" ) ) then
  
        for i = 1,8 do
      
          ObjSet( "obj_hothouse_scr_button"..i, { alp = 1 } );
       
        end;
    
      else
    
        for i = 1,8 do
      
          if ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[i] ~= 0 then
      
            ObjSet( "obj_hothouse_scr_button"..ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[i], { input = false, alp = 1 } );
       
          end;
      
        end;
      
      end;
      
    end;

  end;

  cmn.AddSubscriber( "win_hothouse_scr", win_hothouse_scr, "ho_hothouse_scr" );
  -----------------------------------------------------------------------------------
  local win_hothouse_scr_inv = function ()

    if ( cmn.IsEventDone( "win_hothouse_scr" ) ) then

    end;

  end;
  cmn.AddSubscriber( "win_hothouse_scr", win_hothouse_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_hothouse_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_hothouse_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;

  for i = 1,8 do
    ObjSet("obj_hothouse_scr_button"..i, { alp = 0, input = true });
  end;
  
  ObjSet( "spr_hothouse_scr_door", { alp = 1, pos_y = 286 } );
  ObjSet("obj_hothouse_scr_button", { input = true, alp = 1 });
  ObjSet( "spr_hothouse_scr_syringe", { input = false } );
  ObjSet( "obj_hothouse_scr_buttons", { input = true } );
  ObjSet( "obj_hothouse_scr_button1", { input = true } );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_hothouse_scr" ) ) then
  
    cmn.InitHo( "hothouse_scr" );
    
    ng_global.progress[ "scr" ][ "win_hothouse_scr" ].found = {};
    ng_global.progress[ "scr" ][ "win_hothouse_scr" ].unmark = {};
    ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed = { 0,0,0,0,0,0,0,0 };
    
    cmn.SetEventDone( "opn_hothouse_scr" );
    cmn.SetMarkedTask( "hothouse_scr", "syringe" );
    
    ng_global.progress[ "scr" ][ "win_hothouse_scr" ].parents = {};
  
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bailer",                 1, 0, { { "spr_hothouse_scr_bailer" } } );
  interface.TaskPanelTaskAdd( ho_items, "elephant",               1, 0, { { "spr_hothouse_scr_elephant_shadow" } } );
  interface.TaskPanelTaskAdd( ho_items, "eyepieces",              1, 0, { { "spr_hothouse_scr_eyepieces" } } );
  interface.TaskPanelTaskAdd( ho_items, "formula",                1, 0, { { "spr_hothouse_scr_formula" } } );
  interface.TaskPanelTaskAdd( ho_items, "ladybird",               3, 0, { { "spr_hothouse_scr_ladybird_1" }, { "spr_hothouse_scr_ladybird_2" }, { "spr_hothouse_scr_ladybird_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "microscope",             1, 0, { { "spr_hothouse_scr_microscope" } } );
  interface.TaskPanelTaskAdd( ho_items, "oldhandset",             1, 0, { { "spr_hothouse_scr_oldhandset" } } );
  interface.TaskPanelTaskAdd( ho_items, "photo",                  1, 0, { { "spr_hothouse_scr_photo" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture",                1, 0, { { "spr_hothouse_scr_picture" } } );
  interface.TaskPanelTaskAdd( ho_items, "respirator",             1, 0, { { "spr_hothouse_scr_respirator" } } );
  interface.TaskPanelTaskAdd( ho_items, "frog",                   1, 0, { { "spr_hothouse_scr_frog" } } );
  interface.TaskPanelTaskAdd( ho_items, "syringe",                1, 1, { { "obj_hothouse_scr_button" }, { "spr_hothouse_scr_syringe" } } );

  interface.TaskPanelShow( ho_items );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "hothouse_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";
  
  if object_name then

    object = tostring( object_name );

  else

    object = "spr_hothouse_scr_"..task_name;

  end;
  
  table.insert( ng_global.progress[ "scr" ][ "win_hothouse_scr" ].parents, ObjGetRelations( object ).parent );
  
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_5_scr" );
  --cmn.CallEventHandler( "win_ho_5_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.FindElephant()

  local func_after = function()
  
    common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate("spr_hothouse_scr_elephant_shadow","alp",0,0, func_after,
  {
    0.0,0,1,
    0.2,0,0
  });
  
  private.TaskComplete( 'elephant' );
  
end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( false );
  cmn.UnmarkTask( "hothouse_scr", "syringe" );
  cmn.CallEventHandler( "unmark_syringe" );

end;
--*********************************************************************************************************************
function private.Skip()

  local func_after = function()
  
    private.Win();
  
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_open", 0, "", 0);
  ObjAnimate( "spr_hothouse_scr_door", "pos_y", 0,0, func_after,
  { 
    0.0,0,286,
    0.3,0,223 
  });

end;
--*********************************************************************************************************************
function private.Reset()

  ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed = {0,0,0,0,0,0,0,0};
  for i = 1,8 do
    ObjSet("obj_hothouse_scr_button"..i, { alp = 0, input = true });
  end;

  common_impl.PlayAudio("assets/levels/common/audio/sfx_use/aud_wrongapply"..math.random(3).."_sfx", 0, "", 0);

end;
--*********************************************************************************************************************
function private.ClkButton( num )

  local func_after = function()
  
    local all_pressed = false;
   
    common_impl.Lock( false );
    
    for i = 1,8 do
    
      if ( i == 8 ) then
        
        all_pressed = true;
         
      elseif ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[i] == 0 then
          
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[i] = num;
        ObjSet("obj_hothouse_scr_button"..num, { input = false, alp = 1 });
        break;
          
      end;
    
    end;
    
    if all_pressed then

      if ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[1] == 6 and 
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[2] == 1 and
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[3] == 2 and
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[4] == 3 and
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[5] == 5 and
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[6] == 7 and
        ng_global.progress[ "scr" ][ "win_hothouse_scr" ].pressed[7] == 8 and
       num == 4 then
       
        private.Skip();
      
      else
      
        private.Reset();
        
      end;
    
    end;
    
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_click", 0, "", 0);
  ObjSet( "obj_hothouse_scr_button"..num, { input = false } );
  ObjAnimate( "obj_hothouse_scr_button"..num, "alp", 0,0, func_after,
  { 
    0.0,0,0,
    0.3,0,1 
  });

  --common_impl.PlayAudio( "assets/levels/levelscr/ho_hothouse_scr/aud_ho_hothouse_scr_click", 0, "", 0 );

end;
--*********************************************************************************************************************
-- Animations ---------------------------------------------------------------------------------
ObjAnimate( "spr_hothouse_scr_frog_eye1", "alp", 1, 0, "", 
{ 
  0,0,0, 
  1.0,0,0, 
  1.0,0,1, 
  1.1,0,1, 
  1.1,0,0, 
  1.3,0,0, 
  1.3,0,1, 
  1.4,0,1, 
  1.4,0,0, 
  3,0,0 
});
ObjAnimate( "spr_hothouse_scr_frog_eye2", "alp", 1, 0, "", 
{ 
  0,0,0, 
  1.1,0,0, 
  1.1,0,1, 
  1.3,0,1, 
  1.3,0,0, 
  3,0,0 
});
ObjAnimate( "spr_hothouse_scr_kap1", "alp", 1, 0, function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_frog", 0, "", 0); end, 
{ 
  0.0,0,0, 
  0.0,0,1, 
  0.1,0,1, 
  0.1,0,0, 
  0.3,0,0, 
  0.3,0,1, 
  0.4,0,1, 
  0.4,0,0, 
  15,0,0 
});
ObjAnimate( "spr_hothouse_scr_kap2", "alp", 1, 0, "", 
{ 
  0.0,0,0, 
  0.1,0,0, 
  0.1,0,1, 
  0.3,0,1, 
  0.3,0,0, 
  15,0,0 
});
ObjAnimate( "spr_hothouse_scr_telly1", "alp", 1, 0, "", 
{ 
  0,0,0, 
  5,0,0, 
  5,0,1, 
  10.0,0,1, 
  10.0,0,0,
  15.0,0,0  
});
ObjAnimate( "spr_hothouse_scr_telly2", "alp", 1, 0, "", 
{ 
  0,0,0, 
  10.0,0,0, 
  10.0,0,1, 
  15.0,0,1, 
  15.0,0,0
});
ObjAnimate( "spr_hothouse_scr_ladybird_1", "ang", 1, 0, function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_ladybug_left", 0, "", 0); end, 
{ 
  0.0,0,0, 
  0.3,0,0, 
  0.4,0,-0.07,
  0.6,0,0.07,
  0.8,0,-0.07,
  1.0,0,0.07,
  1.1,0,0,
  4,0,0
});
ObjAnimate( "spr_hothouse_scr_ladybird_2", "ang", 1, 0, function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_ladybug_right", 0, "", 0); end, 
{ 
  0.0,0,0, 
  0.1,0,-0.07,
  0.3,0,0.07,
  0.5,0,-0.07,
  0.7,0,0.07,
  0.8,0,0,
  3,0,0
});
ObjAnimate( "spr_hothouse_scr_ladybird_3", "pos_xy", 1, 0,  function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_hothouse_ladybug_down", 0, "", 0); end, 
{ 
  0.0,0,443,587,
  1.5,0,481,569, 
  1.9,0,481,569, 
  2.9,0,498,581,
  3.2,0,498,581,
  6.2,0,443,587,  
  7.2,0,443,587,  
  7.7,0,443,587
});
ObjAnimate( "spr_hothouse_scr_ladybird_3", "ang", 1, 0, "", 
{ 
  0.0,0,0, 
  1.5,0,0, 
  1.9,0,-1.21,
  2.9,0,-1.21,
  3.2,0,-3.66,
  6.2,0,-3.66,
  7.2,0,-3.66,
  7.7,0,-6.28
});
--*********************************************************************************************************************