-- name=ho_inlaptop_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "inlaptop_scr" );
  game.relations[ "ho_inlaptop_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_inlaptop_scr_racoon",   { event_mdown = function() private.TaskComplete( 'racoon' )   end } },
  { "spr_inlaptop_scr_stop",     { event_mdown = function() private.TaskComplete( 'stop' )     end } },
  { "spr_inlaptop_scr_gears",    { event_mdown = function() private.TaskComplete( 'gears' )    end } },
  { "spr_inlaptop_scr_tv",       { event_mdown = function() private.TaskComplete( 'tv' )       end } },
  { "spr_inlaptop_scr_ball",     { event_mdown = function() private.TaskComplete( 'ball' )     end } },
  { "spr_inlaptop_scr_castle",   { event_mdown = function() private.TaskComplete( 'castle' )   end } },
  { "spr_inlaptop_scr_equalizer",    { event_mdown = function() private.TaskComplete( 'equalizer' )    end } },
  { "spr_inlaptop_scr_mail",     { event_mdown = function() private.TaskComplete( 'mail' )     end } },
  { "spr_inlaptop_scr_fish",     { event_mdown = function() private.TaskComplete( 'fish' )     end } },
  { "spr_inlaptop_scr_orca",     { event_mdown = function() private.TaskComplete( 'orca' )     end } },
  { "spr_inlaptop_scr_boat",     { event_mdown = function() private.TaskComplete( 'boat' )     end } },
  { "spr_inlaptop_scr_diskette", { event_mdown = function() private.TaskComplete( 'diskette' ) end } },
  { "obj_inlaptop_scr_window_code_clk_win", { event_mdown = function() private.ClickActiveCrane() end } },

  { "spr_inlaptop_scr_folder", { event_mdown = function() private.OpenWindow( "folder" ) end } },
  { "spr_inlaptop_scr_photo",  { event_mdown = function() private.OpenWindow( "photo" ) end } },
  { "obj_inlaptop_scr_clk_folder_1", { event_mdown = function() private.OpenWindow( "empty_1" ) end } },
  { "obj_inlaptop_scr_clk_folder_2", { event_mdown = function() private.OpenWindow( "empty_2" ) end } },
  { "obj_inlaptop_scr_clk_folder_3", { event_mdown = function() private.OpenWindow( "empty_3" ) end } },
  { "obj_inlaptop_scr_clk_photo_1", { event_mdown = function() private.OpenWindow( "photo_mt6" ) end } },
  { "obj_inlaptop_scr_clk_photo_2", { event_mdown = function() private.OpenWindow( "photo_mt8" ) end } },
  { "obj_inlaptop_scr_clk_photo_3", { event_mdown = function() private.OpenWindow( "photo_groupe" ) end } },
  { "obj_inlaptop_scr_clk_video",   { event_mdown = function() private.OpenWindow( "video" ) end } },
  { "spr_inlaptop_scr_window_folder_folder_2", { event_mdown = private.ClickFolder } },

  { "spr_inlaptop_scr_music_open_volume", { event_mdown = private.VolumeBtnMouseDown } },
  { "obj_inlaptop_scr_music_open_volume_drag", { event_startdrag = private.VolumeBtnStartDrag,
                                             event_drag = private.VolumeBtnDrag,
                                             event_dragdrop = private.VolumeBtnDragDrop } },
  { "spr_inlaptop_scr_music_play_add", { event_mdown = private.PlayMouseDown,
                                     event_menter = private.PlayMouseEnter,
                                     event_mleave = private.PlayMouseLeave } },

  { "obj_inlaptop_scr_music_switch_music", { event_mdown = function() private.SwitchMusic(2); end  } },
  { "obj_inlaptop_scr_music_next", { event_mdown = function() private.ChangeMusic( "next" ); end  } },
  { "obj_inlaptop_scr_music_prev", { event_mdown = function() private.ChangeMusic( "prev" ); end  } },
  { "obj_inlaptop_scr_window_video_play", { event_mdown = private.VideoPlay } }
  
  } );

  private.windows = { [ "empty_1"      ] = { object = "obj_inlaptop_scr_clk_folder_1", pos_end_x = 703, pos_end_y = 206, open = false },
                      [ "empty_2"      ] = { object = "obj_inlaptop_scr_clk_folder_2", pos_end_x = 683, pos_end_y = 186, open = false },
                      [ "empty_3"      ] = { object = "obj_inlaptop_scr_clk_folder_3", pos_end_x = 723, pos_end_y = 226, open = false },
                      [ "folder"       ] = { object = "spr_inlaptop_scr_folder",       pos_end_x = 587, pos_end_y = 123, open = false },
                      [ "photo"        ] = { object = "spr_inlaptop_scr_photo",        pos_end_x = 747, pos_end_y = 124, open = false },
                      [ "error_1"      ] = { object = "",                          pos_end_x = 0,   pos_end_y = 0,   open = true  },
                      [ "error_2"      ] = { object = "",                          pos_end_x = 0,   pos_end_y = 0,   open = true  },
                      [ "code"         ] = { object = "",                          pos_end_x = 0,   pos_end_y = 0,   open = true  },
                      [ "photo_mt6"    ] = { object = "obj_inlaptop_scr_clk_photo_1",  pos_end_x = 415, pos_end_y = 196, open = false },
                      [ "photo_mt8"    ] = { object = "obj_inlaptop_scr_clk_photo_2",  pos_end_x = 606, pos_end_y = 237, open = false },
                      [ "photo_groupe" ] = { object = "obj_inlaptop_scr_clk_photo_3",  pos_end_x = 606, pos_end_y = 237, open = false },
                      [ "video"        ] = { object = "obj_inlaptop_scr_clk_video",    pos_end_x = 685, pos_end_y = 273, open = false },

  }

  for window, value in pairs( private.windows ) do    

    local obj = "obj_inlaptop_scr_window_"..window.."_drag";
    local obj_close = "spr_inlaptop_scr_window_"..window.."_close_focus";

    ObjSet( obj_close, { event_menter = function() private.CloseBtnEnter( obj_close ); end,
                         event_mleave = function() private.CloseBtnLeave( obj_close ); end,
                         event_mdown  = function() private.CloseWindow( window ); end } );

   
    ObjSet( obj, { event_startdrag = function() private.StartDragWindow( window ); end,
                   event_drag = function() private.DragWindow( window ); end,
                   event_dragdrop = function() private.DragDropWindow( window ); end,  } );

  end;

    ObjSet( "spr_inlaptop_scr_window_error_crane_close_focus", { event_menter = function() private.CloseBtnEnter( "spr_inlaptop_scr_window_error_crane_close_focus" ); end,
                                                             event_mleave = function() private.CloseBtnLeave( "spr_inlaptop_scr_window_error_crane_close_focus" ); end,
                                                             event_mdown  = function() private.CloseWindow( "error_crane" ); end } );

  for i = 1, 12 do

    ObjSet( "spr_inlaptop_scr_window_code_letter_"..i, { event_mdown  = function() private.ClickLetter( i ); end,
                                                     event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                     event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } );

  end;

  private.folder_open = false;
  private.music_open = false;
  private.coords = { 0,0 };
  private.intersect = false;
  private.intersect_objects = {};

  private.video_play = false;

  private.letter = 0;

  private.win = { { 1, 3, 5, 10, 4, 9, 12, 2, 6, 11, 8, 7 }, 
                  { 1, 3, 5, 10, 9, 4, 12, 2, 6, 11, 8, 7 },
                  { 1, 12, 5, 10, 4, 9, 3, 2, 6, 11, 8, 7 },
                  { 1, 12, 5, 10, 9, 4, 3, 2, 6, 11, 8, 7 } };

  private.start_coords = { 0, 0 };
  private.start_button_coords = { 0, 0 };

  private.current_track = 1;
  private.track_timer = { { 7, 54.5 }, { 8, 36 }, { 4.5, 43.5 }, { 7, 28 } }; 

  private.player_coords = { { 1, 6, 13, 19, 26, 26, 19, 13, 6, 1 },
                            { -27, -9, -8, 11, 3, 5, -8, -23, -33, -5  },
                            { 10, 1, 13, 29, 50, 41, 3, 18, 31, 30 },
                            { 0, 0, 0, 0, 0, 0,0, 0, 0, 0 } };
  
  local win_inlaptop_scr_func = function ()
    

  end;
  cmn.AddSubscriber( "win_inlaptop_scr", win_inlaptop_scr_func );
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  local start_inlaptop_scr_func = function ()

    if ( cmn.IsEventStart( "win_inlaptop_scr" ) ) then

      local ho_found = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found;

      for i = 1, #ho_found, 1 do

        ObjSet( ho_found[ i ][ "object" ], { active = false, visible = false, input = false } );
        ObjSet( "spr_inlaptop_scr_window_code_letter_"..i, { alp = 1 } );
      end;

      private.CheckMmgStart( #ho_found );

    end;

  end;
  cmn.AddSubscriber( "win_inlaptop_scr", start_inlaptop_scr_func, "ho_inlaptop_scr" ); 
 
  --------------------------------------------------------------------------------------------
  -- function win_ho_9_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_9_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_9_big_check_ho_9", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_9" );

  end;

  cmn.AddSubscriber( "win_ho_9_scr", win_ho_9_scr_loc, "rm_mysteryroom" ); 

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found;

  for i = 1, #ho_found, 1 do

    if ho_found[ i ][ "task" ]~= "diskette" and ho_found[ i ][ "task" ]~= "equalizer" then

      ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1, 
                                           pos_x = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_x,
                                           pos_y = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_y } );

    else

      ObjSet( ho_found[ i ][ "object" ], { visible = true, active = true,  
                                           pos_x = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_x,
                                           pos_y = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_y } );      

    end;

    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] );
  
  end;

  ObjSet( "spr_inlaptop_scr_window_code_activate_add", { alp = 0 } );
  ObjSet( "obj_inlaptop_scr_window_code_clk_win", { input = false } );
  ObjSet( "txt_inlaptop_scr_window_code", { visible = false } );                   

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open ()
  
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_inlaptop_scr" ) ) then
  
    cmn.InitHo( "inlaptop_scr" );
    cmn.SetEventDone( "opn_inlaptop_scr" );

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords = { 

                                                                 [ "racoon" ]    = { pos_x = 0, pos_y = 0 },
                                                                 [ "stop" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "gears" ]     = { pos_x = 0, pos_y = 0 },
                                                                 [ "tv" ]        = { pos_x = 0, pos_y = 0 },
                                                                 [ "mail" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "ball" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "castle" ]    = { pos_x = 0, pos_y = 0 },
                                                                 [ "equalizer" ] = { pos_x = 0, pos_y = 0 },
                                                                 [ "fish" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "diskette" ]  = { pos_x = 0, pos_y = 0 },
                                                                 [ "orca" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "boat" ]      = { pos_x = 0, pos_y = 0 },
                                                                 [ "mmg" ]       = { pos_x = 731, pos_y = 80 },
                                                           
                                                               };

    local tasks = { "racoon", "stop", "gears", "tv", "mail", "ball", "castle", "equalizer", "fish", "diskette", "orca", "boat" };

    for i = 1, #tasks do

      cmn.SetMarkedTask( "inlaptop_scr", tasks[i] );

      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[tasks[i]].pos_x = ObjGet( "spr_inlaptop_scr_"..tasks[i] ).pos_x;
      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[tasks[i]].pos_y = ObjGet( "spr_inlaptop_scr_"..tasks[i] ).pos_y;

    end;
    
    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].folder_open = false;
    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].music_open = false;

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords = {  [ "empty_1"     ] = { pos_x = 703, pos_y = 206, pos_z = 0, open = false },
                                                                          [ "empty_2"     ] = { pos_x = 683, pos_y = 186, pos_z = 0, open = false },
                                                                          [ "empty_3"     ] = { pos_x = 723, pos_y = 226, pos_z = 0, open = false },
                                                                          [ "folder"      ] = { pos_x = 587, pos_y = 123, pos_z = 0, open = false },
                                                                          [ "photo"       ] = { pos_x = 747, pos_y = 124, pos_z = 0, open = false },
                                                                          [ "error_1"     ] = { pos_x = 728, pos_y = 317, pos_z = 0, open = true },
                                                                          [ "error_2"     ] = { pos_x = 809, pos_y = 212, pos_z = 0, open = true  },
                                                                          [ "code"        ] = { pos_x = 731, pos_y = 80,  pos_z = 0, open = true  },
                                                                          [ "photo_mt6"   ] = { pos_x = 415, pos_y = 196, pos_z = 0, open = false },
                                                                          [ "photo_mt8"   ] = { pos_x = 606, pos_y = 237, pos_z = 0, open = false },
                                                                          [ "photo_groupe"] = { pos_x = 606, pos_y = 237, pos_z = 0, open = false },
                                                                          [ "video"       ] = { pos_x = 685, pos_y = 273, pos_z = 0, open = false },
      
                                                                       };

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].parents = {};

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "racoon",          1, 1, { { "spr_inlaptop_scr_racoon" }, {  } } );
  interface.TaskPanelTaskAdd( ho_items, "stop",            1, 1, { { "spr_inlaptop_scr_stop" } } );
  interface.TaskPanelTaskAdd( ho_items, "gears",           1, 1, { { "spr_inlaptop_scr_gears" } } );
  interface.TaskPanelTaskAdd( ho_items, "tv",              1, 1, { { "spr_inlaptop_scr_tv" } } );
  interface.TaskPanelTaskAdd( ho_items, "ball",            1, 1, { { "spr_inlaptop_scr_ball" } } );
  interface.TaskPanelTaskAdd( ho_items, "castle",          1, 1, { { "spr_inlaptop_scr_castle" } } );
  interface.TaskPanelTaskAdd( ho_items, "equalizer",       1, 1, { { "spr_inlaptop_scr_equalizer" } } );
  interface.TaskPanelTaskAdd( ho_items, "mail",            1, 1, { { "spr_inlaptop_scr_mail" } } );
  interface.TaskPanelTaskAdd( ho_items, "fish",            1, 1, { { "spr_inlaptop_scr_fish" } } );
  interface.TaskPanelTaskAdd( ho_items, "diskette",        1, 1, { { "spr_inlaptop_scr_diskette" } } );
  interface.TaskPanelTaskAdd( ho_items, "orca",            1, 1, { { "spr_inlaptop_scr_orca" } } );
  interface.TaskPanelTaskAdd( ho_items, "boat",            1, 1, { { "spr_inlaptop_scr_boat" } } );


  interface.TaskPanelTaskAdd( ho_items, "mmg",             1, 0, { { "" } } );

  interface.TaskPanelShow( ho_items );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  local volume = 56 - GetSoundVolume( "soundtrack" )*100;

  ObjSet( "spr_inlaptop_scr_music_open_volume", { pos_y = volume } );

  for window, value in pairs( ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords ) do 

    if value.open == true then

      ObjSet( "spr_inlaptop_scr_window_"..window, { pos_x = value.pos_x, pos_y = value.pos_y, pos_z = value.pos_z, scale_x = 1, scale_y = 1, input = true } );

      ObjSet( private.windows[ window ].object, { input = false } );

      ObjSet( "obj_inlaptop_scr_window_"..window.."_hint", { input = true } );

    end;

    private.windows[ window ].open = value.open;

  end;   

  private.folder_open = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].folder_open;
  private.music_open = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].music_open;

  if private.folder_open == true then
  
    ObjSet( "spr_inlaptop_scr_diskette", { alp = 1 } );
    ObjSet( "obj_inlaptop_scr_window_folder_screen_1", { input = false, alp = 0 } );

  end;

  if private.music_open == true then

    ObjMultiSet( { { "spr_inlaptop_scr_music_open", { alp = 1, pos_y = -115, input = true } },
                   { "spr_inlaptop_scr_equalizer", { alp = 1, pos_y = -235, input = true } },
                   { "spr_inlaptop_scr_music", { input = true } },
                   { "spr_inlaptop_scr_music_stop", { alp = 1 } }
               } );

    ObjSet( "obj_inlaptop_scr_music_next", { input = true } );
    ObjSet( "obj_inlaptop_scr_music_prev", { input = true } );

    common_impl.StopAllMus();
    private.SetSoundVolume();

    private.PlayTimers();

    SndStop( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..private.current_track.."_mus", 0.2 );
    SndPlay( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..private.current_track.."_mus", "group", 1, 0, 0.5 );

  end;

  private.SetTasks();

  private.SetLetters();

  --private.CheckMmgStart( #ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close ()

  int_taskpanel_impl.ShowTextPanel( "inlaptop_scr" );

  SndStop( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..private.current_track.."_mus", 1 );

  ObjSet( "obj_inlaptop_scr_window_video_play", { input = true } );
  ObjSet( "vid_inlaptop_scr_window_video", { frame = 0, playing = false } ); 
  common_impl.StopAudio( "sfx", "common/audio/levelscr/aud_bear_uprt", 0, "", 0.5 ); 

  private.video_play = false;  

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

  ObjMultiSet( { { "tmr_inlaptop_scr_music", { playing = false } },
                 { "anm_inlaptop_scr_music_equalizer", { active = false, frame = 0, playing = false } }
               } );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PlayAudio( "sfx","common/audio/aud_ho_win");
  
end;
--*********************************************************************************************************************
function private.ClickActiveCrane()

  if private.CheckMmgWin() == 12 then
  
    private.TaskComplete( "mmg" );

  else

    local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_inlaptop_scr_window_error_crane", { input = true } );
      ObjSet( "obj_inlaptop_scr_window_code_clk_win", { input = false } );

    end;

    common_impl.Lock( true );

    ObjSet( "spr_inlaptop_scr_window_error_crane", { alp = 1 } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_error", 0, "", 0 );

    local coords = GetObjPosByObj( "obj_inlaptop_scr_window_code_clk_win" );

    ObjAnimate( "spr_inlaptop_scr_window_error_crane", "scale_xy", 0, 0, "", { 0,0,0,0, 0.3,0,1,1 } );
    ObjAnimate( "spr_inlaptop_scr_window_error_crane", "pos_xy", 0, 0, "", { 0,0,coords[1],coords[2], 0.3,0,512,150 } );
    ObjAnimate( "spr_inlaptop_scr_window_code_no_activate_add", "alp", 0, 0, func_after, { 0,0,0, 0.1,0,1, 0.2,0,0, 0.3,0,1, 0.4,0,0 } );

  end;

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  if task_name == "mmg" then

    DbgTrace( "mmg "..ObjGetRelations( "spr_inlaptop_scr_window_code" ).parent );

    table.insert( ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].parents, ObjGetRelations( "spr_inlaptop_scr_window_code" ).parent );

    cmn.HoTaskFind( "spr_inlaptop_scr_window_code", task_name );
   
  else

    DbgTrace( "not mmg. task_name = "..task_name.."  "..ObjGetRelations( "spr_inlaptop_scr_"..task_name ).parent );

    table.insert( ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].parents, ObjGetRelations( "spr_inlaptop_scr_"..task_name ).parent );

    cmn.HoTaskFind( "spr_inlaptop_scr_"..task_name, task_name );

  end;

  local ho_found = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found;

  ObjSet( "spr_inlaptop_scr_window_code_letter_"..#ho_found, { alp = 1 } );

  private.CheckMmgStart( #ho_found );
 
end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.CheckMmgStart( count )

  if count == 12 then 

    int_taskpanel_impl.HideTextPanel( "inlaptop_scr" );

    ObjMultiSet( { {  "obj_inlaptop_scr_window_code_mmg", { input = true } },
                   {  "txt_inlaptop_scr_window_code", { visible = true } }, 
                   {  "obj_inlaptop_scr_window_code_clk_win", { input = true } },
                   {  "spr_inlaptop_scr_window_code", { pos_z = 20 } }
       
               } );

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords["code"].pos_z = 20;

   
    private.CheckMmgWin();

    for window, value in pairs( private.windows ) do    

      if value.object ~= "" then

         ObjSet( value.object, { input = false } );
         ObjSet( "obj_inlaptop_scr_window_"..window.."_drag", { input = false } );

      end;

    end;
 
  end;

end;
--*********************************************************************************************************************
function private.CheckMmgWin( current_number )

  local count = 0;

  for i = 1, #ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg do

    local num = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg[i];

    for j = 1, #private.win do

      ObjSet( "spr_inlaptop_scr_window_code_letter_"..num.."_right", { alp = 0 } );

      if num == private.win[j][i] then

        local num = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg[i];
       
        ObjSet( "spr_inlaptop_scr_window_code_letter_"..num.."_right", { alp = 1 } );
        ObjSet( "spr_inlaptop_scr_window_code_letter_"..num, { input = false } );

        if current_number and not common_impl.CheckSoundPlaying( "sfx", "common/audio/levelscr/aud_ho_inlaptop_mmg_right" ) then

          common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_mmg_right", 0, "", 0 );
  
          common_impl.SetSoundTimer( 0.2, "sfx", "common/audio/levelscr/aud_ho_inlaptop_mmg_right" )

        end;

        count = count + 1;

        break;

      end;

    end;

  end;

  if count == 12 then

    ObjSet( "spr_inlaptop_scr_window_code_activate_add", { alp = 1 } );

    if current_number then

      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_mmg_win", 0, "", 0 );

    end;

  end;

  return count;

end;
--*********************************************************************************************************************
function private.SetLetters()

  for i = 1, #ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg do

    ObjSet( "spr_inlaptop_scr_window_code_letter_"..ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg[i], { pos_x = -204 + ( i - 1 )*37  } );  

  end;

  private.CheckMmgWin();

end;
--*********************************************************************************************************************
function private.ClickLetter( number )

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_mmg_click", 0, "", 0 );

  if private.letter == 0 then

    private.letter = number;

    ObjSet( "spr_inlaptop_scr_window_code_letter_"..number.."_add", { alp = 1 } );

  else

    if private.letter ~= number then
  
      local func_after = function()

        local pos_x_1 = ObjGet( "spr_inlaptop_scr_window_code_letter_"..number ).pos_x; 
        local pos_x_2 = ObjGet( "spr_inlaptop_scr_window_code_letter_"..private.letter ).pos_x; 

        local func_after_2 = function()

          common_impl.Lock( false );

          ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg[ math.floor(( pos_x_1 + 204 )/37) + 1 ] = private.letter;
          ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].mmg[ math.floor(( pos_x_2 + 204 )/37) + 1 ] = number;

          private.letter = 0;

          private.CheckMmgWin( number );

        end;

        ObjSet( "spr_inlaptop_scr_window_code_letter_"..number,         { pos_x = pos_x_2 } );
        ObjSet( "spr_inlaptop_scr_window_code_letter_"..private.letter, { pos_x = pos_x_1 } );

        ObjAnimate( "spr_inlaptop_scr_window_code_letter_"..number, "alp", 0, 0, func_after_2, { 0,0,0, 0.3,0,1 } );
        ObjAnimate( "spr_inlaptop_scr_window_code_letter_"..private.letter, "alp", 0, 0, "",   { 0,0,0, 0.3,0,1 } );

      end;

      common_impl.Lock( true );

      ObjSet( "spr_inlaptop_scr_window_code_letter_"..private.letter.."_add", { alp = 0 } );

      ObjAnimate( "spr_inlaptop_scr_window_code_letter_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_inlaptop_scr_window_code_letter_"..private.letter, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

    else

      private.letter = 0;

      ObjSet( "spr_inlaptop_scr_window_code_letter_"..number.."_add", { alp = 0 } );

    end;

  end;

end;
--*********************************************************************************************************************
-- function *** WINDOWS *** () end;
--*********************************************************************************************************************
function private.SetWindows()

  local childs = ObjGetRelations( "obj_inlaptop_scr_windows" ).childs;

  for i = 1, #childs do

     ObjSet( childs[i], { pos_z = 0 } );

  end;

end;
--*********************************************************************************************************************
function private.GetWindowsParam( obj )

  local childs = ObjGetRelations( "obj_inlaptop_scr_windows" ).childs;

  local max_z = 0;

  for i = 1, #childs do

    if ( childs[i] ~= obj or not obj ) and ObjGet( childs[i] ).pos_z > max_z then

      max_z = ObjGet( childs[i] ).pos_z;

    end;

  end;

  return max_z;

end;
--*********************************************************************************************************************
function private.GetMaxIntersectWindow()

  local childs = private.intersect_objects;

  local max_z = 0;

  for i = 1, #childs do

    if ( childs[i] ~= obj or not obj ) and ObjGet( childs[i] ).pos_z > max_z then

      max_z = ObjGet( childs[i] ).pos_z;

    end;

  end;

  return max_z;

end;
--*********************************************************************************************************************
function private.OpenWindow( window )

  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "spr_inlaptop_scr_window_"..window, { input = true, pos_z =  private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1 } );
    ObjSet( "obj_inlaptop_scr_window_"..window.."_hint", { input = true } );
    ObjSet( private.windows[ window ].object, { input = false }  );

    private.windows[ window ].open = true;

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].open = true;
    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].pos_z = private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1;

    private.SetTasks();

  end;

  common_impl.Lock( true );

  local obj = private.windows[ window ].object;

  local obj_params = ObjGet( obj );

  local pos_x = private.windows[ window ].pos_end_x;
  local pos_y = private.windows[ window ].pos_end_y;

  if obj_params then

    ObjSet( "spr_inlaptop_scr_window_"..window, { alp = 1, pos_z = ( private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1 ) } );

    ObjAnimate( "spr_inlaptop_scr_window_"..window, "scale_xy", 0, 0, func_after, { 0,0,0,0, 0.3,0,1,1 } );
    ObjAnimate( "spr_inlaptop_scr_window_"..window, "pos_xy", 0, 0, "", { 0,0,obj_params.pos_x, obj_params.pos_y,
                                                                    0.3,0,pos_x,pos_y } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_window_open", 0, "", 0 );

  elseif window == "error_1" or "error_2" then

    ObjAnimate( "spr_inlaptop_scr_window_"..window, "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );

  end;

end;
--*********************************************************************************************************************
function private.CloseBtnEnter( obj )
  
  local tme = 0.3;
  SetCursor( CURSOR_HAND );
  local alp = ObjGet( obj ).alp;
  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.CloseBtnLeave( obj )

  local tme = 0.3;

  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 0, alp, 
    tme *alp , 0,    0
  } ); 

end;
--*********************************************************************************************************************
function private.CloseWindow( window )

  local func_after = function()

    common_impl.Lock( false );

    if window ~= "error_crane" then

      if #ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found ~= 12 then

        ObjSet( private.windows[ window ].object, { input = true }  );

      end;
      ObjSet( "spr_inlaptop_scr_window_"..window, { input = false, scale_x = 0, scale_y = 0, pos_z = 0 } );
      ObjSet( "obj_inlaptop_scr_window_"..window.."_hint", { input = false } );


      --DbgTrace( "objset     spr_inlaptop_scr_window_"..window );

      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].pos_z = 0;

      private.windows[ window ].open = false;

      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].open = false;

      if window == "folder" then

         private.folder_open = false;
         ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].folder_open = false;

         ObjSet( "spr_inlaptop_scr_diskette", { alp = 0, input = false } );
         ObjSet( "obj_inlaptop_scr_window_folder_screen_1", { input = true, alp = 1 } );

      end;

      if window == "video" then

        ObjSet( "obj_inlaptop_scr_window_video_play", { input = true } );
        ObjSet( "vid_inlaptop_scr_window_video", { frame = 0, playing = false } ); 
        common_impl.StopAudio( "sfx", "common/audio/levelscr/aud_bear_uprt", 0, "", 0.5 ); 

        private.video_play = false;  

      end;

      private.SetTasks();

    else

      ObjSet( "spr_inlaptop_scr_window_"..window, { input = false } );
      ObjSet( "obj_inlaptop_scr_window_code_clk_win", { input = true } );

    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_window_close", 0, "", 0 );

  ObjAnimate( "spr_inlaptop_scr_window_"..window, "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );

end;
--*********************************************************************************************************************
function private.StartDragWindow( window )

  private.intersect = false;

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_touch_window", 0, "", 0 );

  ObjSet( "spr_inlaptop_scr_window_"..window, { pos_z = ( private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1 ) } );

end;
--*********************************************************************************************************************
function private.DragWindow( window )

  common_impl.SetCursor( CURSOR_HAND ); 

  local coords = GetZoomCursorPos();

  ObjSet( "spr_inlaptop_scr_window_"..window, { pos_x = coords[1], pos_y = coords[2] } );

  if coords[1] > 956 then

    ObjSet( "spr_inlaptop_scr_window_"..window, { pos_x = 956 } );
    common_impl.SetCursor( CURSOR_DEFAULT );

  elseif coords[1] < 55 then

    ObjSet( "spr_inlaptop_scr_window_"..window, { pos_x = 55 } );
    common_impl.SetCursor( CURSOR_DEFAULT );

  end;

  if coords[2] > 562 then

    ObjSet( "spr_inlaptop_scr_window_"..window, { pos_y = 562 } );
    common_impl.SetCursor( CURSOR_DEFAULT );

  elseif coords[2] < 76 then

    ObjSet( "spr_inlaptop_scr_window_"..window, { pos_y = 76 } );
    common_impl.SetCursor( CURSOR_DEFAULT );

  end;

end;
--*********************************************************************************************************************
function private.DragDropWindow( window )

  if private.intersect == false then

    common_impl.SetCursor( CURSOR_DEFAULT );
  
    local coords = GetZoomCursorPos();

    if     coords[1] > 956 then coords[1] = 956;
    elseif coords[1] < 55  then coords[1] = 55;
    end;

    if     coords[2] > 562 then coords[2] = 562;
    elseif coords[2] < 76  then coords[2] = 76;
    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_drop_window", 0, "", 0 );

    ObjSet( "spr_inlaptop_scr_window_"..window, { pos_x = coords[1], pos_y = coords[2], pos_z = private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1; } );

    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].pos_x = coords[1];
    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].pos_y = coords[2];
    ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].windows_coords[ window ].pos_z = private.GetWindowsParam( "spr_inlaptop_scr_window_"..window ) + 1;
 
    private.SetTasks();

    private.intersect = true;

  end;

end;
--*********************************************************************************************************************
-- function *** FOLDERS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClickFolder()

  if not private.IsFound( "diskette" ) then

    local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_inlaptop_scr_diskette", { input = true } );
      ObjSet( "obj_inlaptop_scr_window_folder_screen_1", { input = false } );

      private.folder_open = true;

      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].folder_open = true;

      private.UnmarkTask( "diskette" );    

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_window_open", 0, "", 0 );

    ObjAnimate( "obj_inlaptop_scr_window_folder_screen_1", "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
    ObjAnimate( "spr_inlaptop_scr_diskette", "alp", 0, 0, "", { 0,0,0, 0.2,0,1 } )

  else

    local func_after = function()

      common_impl.Lock( false );
      ObjSet( "obj_inlaptop_scr_window_folder_screen_1", { input = false } );

      private.folder_open = true;
      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].folder_open = true;

    end;

    common_impl.Lock( true );

    ObjAnimate( "obj_inlaptop_scr_window_folder_screen_1", "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );

  end;

end;
--*********************************************************************************************************************
-- function *** MUSIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.PlayTimers()

  if not private.IsFound( "equalizer" ) then

    local func_after_mus = function()

      local func_after_anim_stop = function()

        ObjMultiSet( { { "tmr_inlaptop_scr_music", { playing = true, time = private.track_timer[private.current_track][1], endtrig = private.PlayTimers } },
                       { "anm_inlaptop_scr_music_equalizer", { active = false, playing = false, alp = 0 } },
                       { "anm_inlaptop_scr_music_equalizer_stop", { alp = 0, frame = 0 } }, 

                   } );

      end;

       ObjSet( "anm_inlaptop_scr_music_equalizer_stop", { alp = 1 } );
       ObjSet( "anm_inlaptop_scr_music_equalizer", { alp = 0 } );
       AnimPlay( "anm_inlaptop_scr_music_equalizer_stop", "DoAnim", func_after_anim_stop );      

    end;

    local func_after_anim_start = function()
 
      ObjMultiSet( { { "tmr_inlaptop_scr_music", { playing = true, time = private.track_timer[private.current_track][2], endtrig = func_after_mus } },
                     { "anm_inlaptop_scr_music_equalizer", { active = true, frame = 0, playing = true, alp = 1 } },
                     { "anm_inlaptop_scr_music_equalizer_start", { alp = 0, frame = 0 } },
                 } );

    end;

    ObjSet( "anm_inlaptop_scr_music_equalizer_start", { alp = 1 } );
    AnimPlay( "anm_inlaptop_scr_music_equalizer_start", "DoAnim", func_after_anim_start );

  end;

end;
--*********************************************************************************************************************
function private.PlayMouseEnter()

  local tme = 0.3;
  local obj = "spr_inlaptop_scr_music_play_add";
  SetCursor( CURSOR_HAND );
  local alp = ObjGet( obj ).alp;
  --common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    tme *( 1 - alp ), 0, 1
  } );

end;
--*********************************************************************************************************************
function private.PlayMouseLeave()

  local tme = 0.3;
  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_inlaptop_scr_music_play_add";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 0, alp, 
    tme *alp , 0,    0
  } ); 

end;
--*********************************************************************************************************************
function private.PlayMouseDown( replay )

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_inlaptop_touch_play", 0, "", 0 );

  if ( not private.music_open and not private.video_play ) or ( private.music_open and replay == true ) then

    local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_inlaptop_scr_music_open", { input = true } );

      if not private.IsFound( "equalizer" ) then

        ObjSet( "spr_inlaptop_scr_equalizer", { input = true } );

      end;
       
      private.music_open = true;
      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].music_open = true;

      private.SetTasks();

      ObjSet( "obj_inlaptop_scr_music_next", { input = true } );
      ObjSet( "obj_inlaptop_scr_music_prev", { input = true } );

    end;

    --common_impl.Lock( true );

    common_impl.StopAllMus();
    private.SetSoundVolume();

    for i = 1, 4 do

      SndStop( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..i.."_mus", 0 );

    end;

    SndPlay( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..private.current_track.."_mus", "group", 1, 0, 0.5 );

    private.PlayTimers();

    ObjMultiSet( { { "spr_inlaptop_scr_music_open", { alp = 1 } },
                   { "spr_inlaptop_scr_music_stop", { alp = 1 } },
               } );

    if replay ~= true then

      common_impl.Lock( true );

      ObjSet( "obj_inlaptop_scr_window_video_play", { input = true } );
      ObjSet( "vid_inlaptop_scr_window_video", { frame = 0, playing = false } ); 
      common_impl.StopAudio( "sfx", "common/audio/levelscr/aud_bear_uprt", 0, "", 0.5 );   
    
      if not private.IsFound( "equalizer" ) then
       
        ObjSet( "spr_inlaptop_scr_equalizer", { alp = 1 } );

        ObjAnimate( "spr_inlaptop_scr_music_open", "pos_y", 0, 0, "", { 0,0,35, 0.3,0,-115 } );
        ObjAnimate( "spr_inlaptop_scr_equalizer", "pos_y", 0, 0, func_after, { 0,0,-129, 0.3,0,-129, 0.6,0,-235 } );

      else

        ObjAnimate( "spr_inlaptop_scr_music_open", "pos_y", 0, 0, func_after, { 0,0,35, 0.3,0,-115 } );

      end;

    else

      func_after();

    end;

  elseif private.music_open then

    local func_after = function()

      common_impl.Lock( false );

      ObjMultiSet( { { "spr_inlaptop_scr_music_open", { input = false, alp = 0 } },
                     { "spr_inlaptop_scr_equalizer", { input = false, alp = 0 } },
                 } );
   
      private.music_open = false;
    
      ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].music_open = false;

      private.SetTasks();

      ObjSet( "obj_inlaptop_scr_music_next", { input = false } );
      ObjSet( "obj_inlaptop_scr_music_prev", { input = false } );

--      if replay == true then
--
--        private.PlayMouseDown( false );
--
--      end;
--
    end;

    common_impl.Lock( true );

    for i = 1, 4 do

      SndStop( "assets/levels/common/audio/levelscr/aud_ho_inlaptop_"..i.."_mus", 0 );

    end;

    ObjMultiSet( { { "tmr_inlaptop_scr_music", { playing = false } },
                 { "anm_inlaptop_scr_music_equalizer", { active = false, frame = 0, playing = false } },
                 { "spr_inlaptop_scr_music_stop", { alp = 0 } }
               } );

    if not private.IsFound( "equalizer" ) then

      ObjAnimate( "spr_inlaptop_scr_music_open", "pos_y", 0, 0, func_after, { 0,0,-115, 0.3,0,-115, 0.6,0,35 } );
      ObjAnimate( "spr_inlaptop_scr_equalizer", "pos_y", 0, 0, "", { 0,0,-235, 0.3,0,-129 } );

    else

      ObjAnimate( "spr_inlaptop_scr_music_open", "pos_y", 0, 0, func_after, { 0.0,0,-115, 0.3,0,35 } );

    end;

  end;

  if private.video_play then

    private.video_play = false;

  end;

end;
--*********************************************************************************************************************
function private.SetSoundVolume()

  local coord = GetObjPosByObj( "spr_inlaptop_scr_music_open_volume", "spr_inlaptop_scr_music_open" )[2];

  local volume = 0.56 - coord/100;

  SetSoundVolume( "group",  volume );

end;
--*********************************************************************************************************************
function private.VolumeBtnMouseDown()

  ObjStartDrag( "obj_inlaptop_scr_music_open_volume_drag" );

end;
--*********************************************************************************************************************
function private.VolumeBtnStartDrag()

  private.start_coords = GetZoomCursorPos();
  private.start_button_coords = GetObjPosByObj( "spr_inlaptop_scr_music_open_volume", "spr_inlaptop_scr_music_open" );

end;
--*********************************************************************************************************************
function private.VolumeBtnDrag()
  
  local dif_coords = GetZoomCursorPos()[2] - private.start_coords[2];

  local coord = private.start_button_coords[2] + dif_coords;
 
  if coord < -44 then coord = -44;
  elseif coord > 56 then coord = 56;
  end;

  ObjSet( "spr_inlaptop_scr_music_open_volume", { pos_y = coord } );

  private.SetSoundVolume();

end;
--*********************************************************************************************************************
function private.VolumeBtnDragDrop()

  local dif_coords = GetZoomCursorPos()[2] - private.start_coords[2];

  local coord = private.start_button_coords[2] + dif_coords;
 
  if coord < -44 then coord = -44;
  elseif coord > 56 then coord = 56;
  end;

  ObjSet( "spr_inlaptop_scr_music_open_volume", { pos_y = coord } );

  private.SetSoundVolume();

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.SwitchMusic( number )
 
  if number >=5 then

    number = 1;
  
  end;

  for i = 1, 10 do

    ObjSet( "spr_inlaptop_scr_music_open_button_"..i, { pos_y = private.player_coords[number][i] } );

  end;

  ObjSet( "obj_inlaptop_scr_music_switch_music", { event_mdown = function() private.SwitchMusic( number + 1 ); end  } );
   

end;
--*********************************************************************************************************************
function private.ChangeMusic( type )

  local new_track = private.current_track;
 
  if type == "next" then

    new_track = new_track + 1;

  elseif type == "prev" then

    new_track = new_track - 1;

  end;

  if new_track == 5 then

    new_track = 1;

  elseif new_track == 0 then

    new_track = 4;

  end;

  private.current_track = new_track;

  for i = 1, 10 do

    ObjSet( "spr_inlaptop_scr_music_open_button_"..i, { pos_y = private.player_coords[new_track][i] } );

  end;

  private.PlayMouseDown( true );

end;
--*********************************************************************************************************************
-- function *** VIDEO *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.VideoPlay()

  local func_after = function()
  
    ObjSet( "obj_inlaptop_scr_window_video_play", { input = true } );
    ObjSet( "vid_inlaptop_scr_window_video", { frame = 0 } );

    private.video_play = false;

  end;

  common_impl.StopAllMus();
--
--  ObjSet( "tmr_inlaptop_scr_music", { playing = false } );
--  AnimStop( "anm_inlaptop_scr_music_equalizer" );
--  AnimStop( "anm_inlaptop_scr_music_equalizer_start" );
--  AnimStop( "anm_inlaptop_scr_music_equalizer_stop" );

  VidPlay( "vid_inlaptop_scr_window_video", func_after );

  ObjSet( "obj_inlaptop_scr_window_video_play", { input = false } );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_bear_uprt", 0, "", 0 );

  private.video_play = true;

  private.PlayMouseDown( false );

end;
--*********************************************************************************************************************
-- function *** LOGIC *** () end;
--*********************************************************************************************************************
function private.IsFound( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found;
  local task_found = false;
        
      for i = 1, #ho_found, 1 do
        
        local task = ho_found[ i ][ "task" ];

        if task == task_name then
           task_found = true;
           break;
        end;

      end;

   return task_found;  

end;
-----------------------------------------------
function private.IntersectCheck( obj, type )

  if ObjGet( obj ) then
 
    for window, value in pairs( private.windows ) do  

      local intersect = "obj_inlaptop_scr_window_"..window.."_intersect";

      local pos_z = ObjGet( obj ).pos_z;

      local parent_flag = false;

      if type == "task" and ObjGetRelations( obj ).parent ~= "obj_inlaptop_scr_desktop" then

        pos_z = ObjGet( ObjGetRelations( obj ).parent ).pos_z;

        if ObjGetRelations( obj ).parent == "spr_inlaptop_scr_window_"..window then
      
          parent_flag = true;
      
        end;

      end;

      local dif = ObjGet( ObjGetRelations( intersect ).parent ).pos_z - pos_z;

      local scale = ObjGet( ObjGetRelations( intersect ).parent ).scale_x;

      --DbgTrace( "intersect = "..intersect.." parent = "..ObjGetRelations( obj ).parent.." dif = "..dif );

      if dif >= 0 and ObjIntersect( intersect, obj ) and parent_flag == false and scale ~= 0 then

        --DbgTrace( "intersect    obj = "..obj.."  intersect = "..intersect.."    "..tostring( ObjIntersect( intersect, obj ) ) );

        return true;

      end;

    end;  

  end;

  return false;

end;
-----------------------------------------------
function private.GetIntersectObjects( obj, type )

  if ObjGet( obj ) then

    local intersect = "";
    local pos_z = 0;
    local parent_flag = false;
 
    for window, value in pairs( private.windows ) do  

      intersect = "obj_inlaptop_scr_window_"..window.."_intersect";

      pos_z = ObjGet( obj ).pos_z;

      parent_flag = false;

      if type == "task" and ObjGetRelations( obj ).parent ~= "obj_inlaptop_scr_desktop" then

        pos_z = ObjGet( ObjGetRelations( obj ).parent ).pos_z;

        --DbgTrace( obj.." "..ObjGetRelations( obj ).parent.." spr_inlaptop_scr_window_"..window );

        local parent = string.sub( ObjGetRelations( obj ).parent, 21 );

        if parent == window then
      
          parent_flag = true;

        end;
  
        if private.windows[ parent ] and not private.windows[ parent ].open then

          obj = private.windows[ parent ].object;

        end;

      end;

      local dif = ObjGet( ObjGetRelations( intersect ).parent ).pos_z - pos_z;

      local scale = ObjGet( ObjGetRelations( intersect ).parent ).scale_x;

      if dif >= 0 and ObjIntersect( intersect, obj ) and parent_flag == false and scale ~= 0 then

        if obj == "spr_inlaptop_scr_orca" or obj == "spr_inlaptop_scr_boat" then

          --DbgTrace(ObjIntersect( intersect, obj ) );

        end;

        --DbgTrace( ObjGetRelations( intersect ).parent.." "..dif.." "..tostring(parent_flag).." "..intersect.." "..obj.." "..tostring(ObjIntersect( intersect, obj )) );

        table.insert( private.intersect_objects, ObjGetRelations( intersect ).parent );

      end;

    end;  

  end;

end;
-----------------------------------------------
function private.SetMarkedTask( task_name )

  if private.IsFound( task_name ) ~= true then

    cmn.SetMarkedTask( "inlaptop_scr", task_name );
    interface.TaskPanelTaskMark( "inlaptop_scr", task_name );

    ObjSet( "spr_inlaptop_scr_"..task_name, { input = false } );

  end;

end;
-----------------------------------------------
function private.UnmarkTask( task_name )

  if private.IsFound( task_name ) ~= true then

    cmn.UnmarkTask( "inlaptop_scr", task_name );

    ObjSet( "spr_inlaptop_scr_"..task_name, { input = true } );

  end;  

end;
-----------------------------------------------
function private.SetTasks()

  -- photo

  if private.windows[ "photo" ].open == true and private.IntersectCheck( "spr_inlaptop_scr_boat", "task" ) == false then

     private.UnmarkTask( "boat" );

  else

     private.SetMarkedTask( "boat" );

  end;

  if private.windows[ "photo" ].open == true and private.IntersectCheck( "spr_inlaptop_scr_orca", "task" ) == false then
  
     private.UnmarkTask( "orca" );

  else
   
     private.SetMarkedTask( "orca" );
    
  end;

  -- tasks in windows
  
  if private.windows[ "empty_1" ].open == true and private.IntersectCheck( "spr_inlaptop_scr_fish", "task" ) == false then
  
     private.UnmarkTask( "fish" );

  else
   
     private.SetMarkedTask( "fish" );
    
  end;

  if private.windows[ "empty_2" ].open == true and private.IntersectCheck( "spr_inlaptop_scr_tv", "task" ) == false then
  
     private.UnmarkTask( "tv" );

  else

    private.SetMarkedTask( "tv" );
    
  end;

  -- other

  local tasks = { "racoon", "stop", "gears", "mail", "ball", "castle", "equalizer", "diskette" };

  for i = 1, #tasks do

    if private.IntersectCheck( "spr_inlaptop_scr_"..tasks[i], "task" ) == false then
     
      if ( tasks[i] == "diskette" and private.folder_open == true and private.windows[ "folder" ].open == true ) then

        private.UnmarkTask( tasks[i] );

      elseif ( tasks[i] == "diskette" and ( private.windows[ "folder" ].open ~= true or private.folder_open ~= true )  ) then

        private.SetMarkedTask( tasks[i] );

      elseif ( tasks[i] == "equalizer" and private.music_open == true  ) then

        private.UnmarkTask( tasks[i] );

      elseif ( tasks[i] == "equalizer" and private.music_open == false ) then

        private.SetMarkedTask( tasks[i] );
      
      else

        private.UnmarkTask( tasks[i] );
     
      end;

    else

      private.SetMarkedTask( tasks[i] );

    end;  

  end;

  if #ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found ~= 12 then

    for window, value in pairs( private.windows ) do  

      if private.IntersectCheck( value.object ) == false and value.open == false then

        ObjSet( value.object, { input = true } );

      elseif private.IntersectCheck( value.object ) == true then

        --DbgTrace( "input false "..value.object );

        ObjSet( value.object, { input = false } );      

      end;

    end;

  end;

end;
--*********************************************************************************************************************
-- function *** HINT *** () end;
--*********************************************************************************************************************
--******************************************************************************************
function public.HoHintShow()

  local tasks = { "racoon", "stop", "gears", "tv", "mail", "ball", "castle", "equalizer", "fish", "diskette", "orca", "boat" };

  local hint_table = { hint = {} };

  for i = 1, #tasks do  -- если на рабочем столе, открыто
 
    --i = math.random( 1, #tasks );

    if private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] ) and ObjGet( "spr_inlaptop_scr_"..tasks[i] ).input == true then

       local pos = GetObjPosByObj( "spr_inlaptop_scr_"..tasks[i] );

       table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = "spr_inlaptop_scr_"..tasks[i] } );

       break;

    end;

  end;

  if #hint_table.hint ==0 then -- если закрыто

      for i = 1, #tasks do

        if private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] ) and ObjGet( "spr_inlaptop_scr_"..tasks[i] ).input == false then
      
           private.GetIntersectObjects( "spr_inlaptop_scr_"..tasks[i], "task" );

            --DbgTrace( tasks[i] );

             if #private.intersect_objects ~= 0 then

                for j = 1, #private.intersect_objects do

                  --DbgTrace( private.intersect_objects[j] );
  
                  if ( private.GetMaxIntersectWindow() == ObjGet( private.intersect_objects[j] ).pos_z ) or 

                     ( ( private.intersect_objects[j] == "spr_inlaptop_scr_window_error_1" or private.intersect_objects[j] == "spr_inlaptop_scr_window_error_2" ) and

                         private.GetWindowsParam() == 1 and
                     not ObjIntersect( private.intersect_objects[j], "spr_inlaptop_scr_window_code" ) ) then

                     local objname = "obj_"..common.GetObjectName( private.intersect_objects[j] ).."_hint";
                     local pos = GetObjPosByObj( objname );
  
                     --DbgTrace( "intersect "..objname.." "..private.GetWindowsParam().." "..ObjGet( private.intersect_objects[j] ).pos_z );

                     local new_obj = "spr_"..common.GetObjectName( private.intersect_objects[j] ).."_close_focus";

                     if private.intersect_objects[j] == "spr_inlaptop_scr_window_code" then

                       new_obj = "spr_inlaptop_scr_window_code";

                     end;

                     private.GetIntersectObjects( new_obj );

                     --DbgTrace( private.intersect_objects[j] );

                     if #private.intersect_objects == 0 then

                        table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

                        --DbgTrace( "1 "..objname );

                        break;

                     else

                         for k = 1, #private.intersect_objects do
    
                            if ( private.GetMaxIntersectWindow() == ObjGet( private.intersect_objects[k] ).pos_z ) or 

                               ( ( private.intersect_objects[k] == "spr_inlaptop_scr_window_error_1" or private.intersect_objects[k] == "spr_inlaptop_scr_window_error_2" ) and

                                   private.GetWindowsParam() == 1 and 
                              not ObjIntersect( private.intersect_objects[k], "spr_inlaptop_scr_window_code" ) ) then

                              local objname = "obj_"..common.GetObjectName( private.intersect_objects[k] ).."_hint";
                              local pos = GetObjPosByObj( objname );
                            
                              table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

                              --DbgTrace( "2 "..objname );

                              break;

                            end;

                         end;
    
                      end;

                      break;

                  end;

                end;

             end;

        end;

     if #hint_table.hint ~= 0 then

      break;

     end;
     
     end;

  end;

  if #hint_table.hint == 0 then

    for i = 1, #tasks do

        if private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] ) then

            local parent = ObjGetRelations( "spr_inlaptop_scr_"..tasks[i] ).parent;

            if parent ~= "obj_inlaptop_scr_desktop" then

                for j = 1, 3 do

                  parent = common.GetObjectName( parent );

                end;

                if parent == "folder" and private.windows["folder"].open == true and private.folder_open == false then

                   local pos = GetObjPosByObj( "spr_inlaptop_scr_window_folder_folder_2" );
                   table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = "spr_inlaptop_scr_window_folder_folder_2" } );

                   break;

                elseif tasks[i] == "equalizer" and private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] )
                       and ObjGet( "spr_inlaptop_scr_"..tasks[i] ).input == false  then

                   local pos = GetObjPosByObj( "spr_inlaptop_scr_music" );
                   table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = "spr_inlaptop_scr_music" } );

                   break;

                else


                    if private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] ) and ObjGet( "spr_inlaptop_scr_"..tasks[i] ).input == false 
                       and ObjGet( private.windows[ parent ].object ).input == true then

                        local pos = GetObjPosByObj( private.windows[ parent ].object );
                        table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = private.windows[ parent ].object } );

                        break;

                    elseif private.IsFound( tasks[i] ) == false and ObjGet( "spr_inlaptop_scr_"..tasks[i] ) and ObjGet( "spr_inlaptop_scr_"..tasks[i] ).input == false 
                       and ObjGet( private.windows[ parent ].object ).input == false then

                         private.GetIntersectObjects( private.windows[ parent ].object );

                         if #private.intersect_objects ~= 0 then

                            for j = 1, #private.intersect_objects do

                              if private.GetMaxIntersectWindow() == ObjGet( private.intersect_objects[j] ).pos_z then

                                local objname = "obj_"..common.GetObjectName( private.intersect_objects[j] ).."_hint";
                                local pos = GetObjPosByObj( objname );

                                --DbgTrace( "intersect2 "..objname.." "..private.GetWindowsParam().." "..ObjGet( private.intersect_objects[j] ).pos_z );

                                table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

                                break;

                              end;

                            end;

                         end;

                    end;

                end;

            end;
        end;

    if #hint_table.hint ~= 0 then

      break;

    end

    end;

  end;

  if #hint_table.hint == 0 then

    local objname = "obj_inlaptop_scr_window_code_hint_mg";

    if private.CheckMmgWin() == 12 then

      objname = "obj_inlaptop_scr_window_code_hint_win";

    end;

    --DbgTrace( objname );

    local pos = GetObjPosByObj( objname );

    table.insert( hint_table.hint, { pos_x = pos[ 1 ], pos_y = pos[ 2 ], obj_name = objname } );

  end;

  for i = 1, #private.intersect_objects do

    table.remove( private.intersect_objects );

  end;


  if #hint_table.hint ~= 0 then

    MsgSend( Command_Effect_ShowHoHint, hint_table );

  else

    MsgSend( Event_HoHint_NoObjects, {} );

  end;

end;
--*********************************************************************************************************************
-- function *** WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PlayHoVideo( ho_name )

   local func_after = function()

      private.folder_open = false;
      private.music_open = false;
      private.coords = { 0,0 };
      private.intersect = false;
      private.intersect_objects = {};

      private.video_play = false;

      private.letter = 0;

      private.start_coords = { 0, 0 };
      private.start_button_coords = { 0, 0 };

      private.current_track = 1;

      common_impl.Lock( false );
      cmn.SetEventDone( "win_ho_9_scr" );
      --cmn.CallEventHandler( "win_ho_9_scr" );
      rm_mysteryroom.HoComplete( ho_name );

   end;

   local ho_found = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].found;

   for i = 1, #ho_found, 1 do

    --ObjSet( ho_found[ i ][ "object" ], { pos_x = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_x,
    --                                     pos_y = ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].coords[ho_found[ i ]["task"]].pos_y } );
      
     ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_inlaptop_scr" ].parents[i] );
   
     ObjSet( "spr_inlaptop_scr_window_code_letter_"..i, { alp = 0, input = true } );
     ObjSet( "spr_inlaptop_scr_window_code_letter_"..i.."_right", { alp = 0 } );
     ObjSet( "obj_inlaptop_scr_window_code_mmg", { input = false } );
    
   end;

   for window, value in pairs( private.windows ) do

     if value.open and window ~= "code" 
                   and window ~= "error_1"
                   and window ~= "error_2" then

       private.CloseWindow( window );

     elseif ( window == "error_1" or window == "error_2" ) then

       private.OpenWindow( window );

     end; 

   end;

   if private.music_open then

     private.PlayMouseDown();

   end;

   ObjSet( "spr_inlaptop_scr_window_code", { pos_z = 0 } );

   common_impl.Lock( true );

   ObjAnimate( "spr_inlaptop_scr_equalizer", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,0 } );

end;
--*********************************************************************************************************************
ObjAnimate( "spr_inlaptop_scr_screen_add", "alp", 1, 0, "", { 0,0,0.5, 1,0,1, 2,0,0.5 } );
--*********************************************************************************************************************
