-- name=ho_orchestra_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "orchestra_scr" );
  game.relations[ "ho_orchestra_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_orchestra_scr = function ()

  local effects_table = 
  {
  --"anm_orchestra_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_orchestra_scr", update_performance_mode_orchestra_scr, "ho_orchestra_scr" );
  --------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_orchestra_scr_bagpipes", { event_mdown = function() private.TaskComplete( 'bagpipes' ) end } },
  { "spr_orchestra_scr_bugle", { event_mdown = function() private.TaskComplete( 'bugle' ) end } },
  { "spr_orchestra_scr_flute", { event_mdown = function() private.TaskComplete( 'flute' ) end } },
  { "spr_orchestra_scr_folding", { event_mdown = function() private.TaskComplete( 'folding' ) end } },
  { "spr_orchestra_scr_guitar", { event_mdown = function() private.TaskComplete( 'guitar' ) end } },
  { "spr_orchestra_scr_gusli", { event_mdown = function() private.TaskComplete( 'gusli' ) end } },
  { "spr_orchestra_scr_harpsichord", { event_mdown = function() private.TaskComplete( 'harpsichord' ) end } },
  { "spr_orchestra_scr_lute", { event_mdown = function() private.TaskComplete( 'lute' ) end } },
  { "spr_orchestra_scr_setar", { event_mdown = function() private.TaskComplete( 'setar' ) end } },
  { "spr_orchestra_scr_violin", { event_mdown = function() private.TaskComplete( 'violin' ) end } },
  { "spr_orchestra_scr_wind", { event_mdown = function() private.TaskComplete( 'wind' ) end } },
  { "spr_orchestra_scr_wind_2", { event_mdown = function() private.TaskComplete( 'wind_2' ) end } },
  { "grm_orchestra_scr_mysteryroom", { event_mdown = private.GotoRoom } }
  
  } );
  
  private.ho_close = false;
  
  local win_orchestra_scr_func = function ()

    if ( cmn.IsEventDone( "win_orchestra_scr" ) ) then

    end;

  end;
  cmn.AddSubscriber( "win_orchestra_scr", win_orchestra_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_orchestra_scr_func = function ()

    if ( cmn.IsEventStart( "win_orchestra_scr" ) ) then
  
      local ho_found = ng_global.progress[ "scr" ][ "win_orchestra_scr" ].found;

      for i = 1, #ho_found, 1 do
        ObjSet( ho_found[ i ][ "object" ], { visible = false, input = false, active = false } );
        ObjSet( "spr_orchestra_scr_taskpanel_"..ho_found[ i ][ "task" ], { visible = false, input = false, active = false  } );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_orchestra_scr", start_orchestra_scr_func, "ho_orchestra_scr" );  
  --------------------------------------------------------------------------------------------
  -- function win_ho_10_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_10_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_10_big_check_ho_10", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_10" );

  end;

  cmn.AddSubscriber( "win_ho_10_scr", win_ho_10_scr_loc, "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_orchestra_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_orchestra_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjDelete( "obj_orchestra_scr_name_"..ho_found[ i ][ "task" ] );
    ObjDelete( "anm_orchestra_scr_name_"..ho_found[ i ][ "task" ] );
    
    ObjSet( "spr_orchestra_scr_taskpanel_"..ho_found[ i ][ "task" ], { visible = true, active = true, scale_x = 0.7, scale_y = 0.7 } );
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_orchestra_scr" ) ) then
  
    cmn.InitHo( "orchestra_scr" );
    cmn.SetEventDone( "opn_orchestra_scr" );
    
    ng_global.progress[ "scr" ][ "win_orchestra_scr" ].parents = {};
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bagpipes",          1, 0, { { "spr_orchestra_scr_bagpipes" } } );
  interface.TaskPanelTaskAdd( ho_items, "bugle",          1, 0, { { "spr_orchestra_scr_bugle" } } );
  interface.TaskPanelTaskAdd( ho_items, "flute",          1, 0, { { "spr_orchestra_scr_flute" } } );
  interface.TaskPanelTaskAdd( ho_items, "folding",          1, 0, { { "spr_orchestra_scr_folding" } } );
  interface.TaskPanelTaskAdd( ho_items, "guitar",          1, 0, { { "spr_orchestra_scr_guitar" } } );
  interface.TaskPanelTaskAdd( ho_items, "gusli",          1, 0, { { "spr_orchestra_scr_gusli" } } );
  interface.TaskPanelTaskAdd( ho_items, "harpsichord",          1, 0, { { "spr_orchestra_scr_harpsichord" } } );
  interface.TaskPanelTaskAdd( ho_items, "lute",          1, 0, { { "spr_orchestra_scr_lute" } } );
  interface.TaskPanelTaskAdd( ho_items, "setar",          1, 0, { { "spr_orchestra_scr_setar" } } );
  interface.TaskPanelTaskAdd( ho_items, "violin",          1, 0, { { "spr_orchestra_scr_violin" } } );
  interface.TaskPanelTaskAdd( ho_items, "wind",          1, 0, { { "spr_orchestra_scr_wind" } } );
  interface.TaskPanelTaskAdd( ho_items, "wind_2",          1, 0, { { "spr_orchestra_scr_wind_2" } } );

  interface.TaskPanelShow( ho_items );
  
  int_taskpanel_impl.HideTextPanel( "orchestra_scr" );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
  common_impl.StopAudio( "env", "common/audio/level1/aud_hall_fire_loc_env", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "orchestra_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;

  cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  table.insert( ng_global.progress[ "scr" ][ "win_orchestra_scr" ].parents, ObjGetRelations( "spr_orchestra_scr_"..task_name ).parent );

  cmn.HoTaskFind( "spr_orchestra_scr_"..task_name, task_name );
  
  ObjAnimate( "spr_orchestra_scr_taskpanel_"..task_name, "scale_xy", 0, 0, function()  private.TextAnim( task_name ); end, { 0,0,0.7,0.7, 0.4,0,0,0 } );
  
  if task_name ~= "harpsichord" then
 
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_orchestra_"..task_name, 0, "", 0 );
    
  else
    
    common_impl.PlayAudio( "sfx", "common/audio/level1/aud_ho_orchestra_xylo", 0, "", 0 );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_10_scr" );
  --cmn.CallEventHandler( "win_ho_10_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.TextAnim( task_name )

  ObjClone( "obj_orchestra_scr_name", "_"..task_name, 1, "obj_orchestra_scr_names" );
  ObjClone( "anm_orchestra_scr_name", "_"..task_name, 1, "obj_orchestra_scr_names" );
  
  local pos = GetObjPosByObj( "spr_orchestra_scr_"..task_name );
  
  local ang = math.random( 78, 235 ) / 100;

  ObjSet( "obj_orchestra_scr_name_"..task_name, { ang = ang, pos_x = pos[1], pos_y = pos[2] - 20 } );
  ObjSet( "txt_orchestra_scr_name_"..task_name, { ang = - ang, alp = 1, text = "str_orchestra_"..task_name } );
  ObjSet( "anm_orchestra_scr_name_"..task_name, { pos_x = pos[1] - 615, pos_y = pos[2] - 400, alp = 1, playing = true } );
  
  local delay_tm = 1;
 
  local delay = delay_tm * ( 2 - 1 );

  ObjAnimate( "txt_orchestra_scr_name_"..task_name, "pos_x", 0, 0, "", { 0, 0, 0,   delay/2, 0, 0,    ( delay + delay_tm ), 0, 90 } );
  ObjAnimate( "obj_orchestra_scr_name_"..task_name, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   delay/2, 0, 1, 1,    ( delay + delay_tm/2 ), 3, 1.2, 1.2,   ( delay + delay_tm ), 3, 1, 1, } );
  ObjAnimate( "obj_orchestra_scr_name_"..task_name, "alp", 0, 0, "", { 0, 0, 0,   delay/2, 0, 0,    ( delay + delay_tm/2 ), 0, 1,   ( delay + delay_tm ), 0, 0 } );
 
end;
--*********************************************************************************************************************
