-- name=ho_owlscene_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "owlscene_scr" );
  game.relations[ "ho_owlscene_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_owlscene_scr";
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_owlscene_scr_ball", { event_mdown = function() private.TaskComplete( 'ball' ) end } } );  
  table.insert( table_multiset, { "spr_owlscene_scr_bookmark", { event_mdown = function() private.TaskComplete( 'bookmark' ) end } } ); 
  table.insert( table_multiset, { "spr_owlscene_scr_chessman", { event_mdown = function() private.TaskComplete( 'chessman' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_pen", { event_mdown = function() private.TaskComplete( 'pen' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_pince", { event_mdown = function() private.TaskComplete( 'pince' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_pipe", { event_mdown = function() private.TaskComplete( 'pipe' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_pocket_watch", { event_mdown = function() private.TaskComplete( 'pocket_watch' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_rose", { event_mdown = function() private.TaskComplete( 'rose' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_rowan", { event_mdown = function() private.TaskComplete( 'rowan' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_shoes", { event_mdown = function() private.TaskComplete( 'shoes' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_cufflinks", { event_mdown = function() private.TaskComplete( 'cufflinks' ) end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_ball_badminton", { event_mdown = function() private.TaskComplete( 'ball_badminton' ) end } } );
  
  table.insert( table_multiset, { "obj_owlscene_scr_clk_head", { event_mdown = function() private.ClkHead() end, event_menter = function()  SetCursor( CURSOR_HAND ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_shoes_pick", { event_mdown = function() private.ItemClk('shoes') end, event_menter = function()  SetCursor( CURSOR_GET ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end,
    event_dragdrop = function() private.unmark_shoes() end } } );
  table.insert( table_multiset, { "spr_owlscene_scr_cufflinks_pick", { event_mdown = function() private.ItemClk('cufflinks') end, event_menter = function()  SetCursor( CURSOR_GET ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end,
    event_dragdrop = function() private.unmark_cufflinks() end } } );
  table.insert( table_multiset, { "obj_owlscene_scr_clk_moth", { event_mdown = function() private.ClkMoth() end, event_menter = function()  SetCursor( CURSOR_HAND ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end } } ); 
  
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_owlscene_scr = function ()

  local effects_table = 
  {
  --"anm_owlscene_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_owlscene_scr", update_performance_mode_owlscenescr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_7_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_7_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_7_big_check_ho_7", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_7" );

  end;

  cmn.AddSubscriber( "win_ho_7_scr", win_ho_7_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  ------------------------------------------------
  local unmark_shoes = function () 
   
    ObjSet( "spr_owlscene_scr_shoes", { input = true } );  
    ObjSet( "spr_owlscene_scr_shoes_1", { alp = 1 } );
    ObjSet( "spr_owlscene_scr_shoes_pick", { alp = 0 } );
    ObjSet( "obj_owlscene_scr_shoes", { input = false } );

  end;
  cmn.AddSubscriber( "owlscene_scr_unmark_shoes", unmark_shoes, room_objname );
  ------------------------------------------------
  local unmark_cufflinks = function () 
 
    ObjSet( "spr_owlscene_scr_cufflinks", { input = true } );  
    ObjSet( "spr_owlscene_scr_cufflinks_1", { alp = 1 } );
    ObjSet( "spr_owlscene_scr_cufflinks_pick", { alp = 0, input = false } );
    ObjSet( "obj_owlscene_scr_cufflinks", { input = false } );

  end;
  cmn.AddSubscriber( "owlscene_scr_unmark_cufflinks", unmark_cufflinks, room_objname );
  -----------------------------------------------------------------------------
  local win_owlscene_scr = function ()
    
    if not ( cmn.IsEventDone( "win_owlscene_scr" ) ) then
      
    for j = 1, #ng_global.progress["scr"]["win_owlscene_scr"].found do

      local name = tostring( ng_global.progress[ "scr" ][ "win_owlscene_scr" ].found[ j ][ "object" ] );
  
      ObjSet( name, { visible = false, input = false, active = false } );
      ObjSet( name.."_shadow", { visible = false, input = false, active = false } );

    end;
    

      if ( cmn.IsUnmarkedTask( ho_name, "shoes" ) ) then
        unmark_shoes();
      end;

      if ( cmn.IsUnmarkedTask( ho_name, "cufflinks" ) ) then
       unmark_cufflinks();
      end;
     
     
   end;
   
  end;
  cmn.AddSubscriber( "win_owlscene_scr", win_owlscene_scr, room_objname );
  -----------------------------------------------------------------------------------
  local win_owlscene_scr_inv = function ()

  if ( cmn.IsEventDone( "win_owlscene_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_owlscene_scr", win_owlscene_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_owlscene_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_owlscene_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 

    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
    
    ObjSet( "spr_owlscene_scr_shoes", { input = false } );  
    ObjSet( "spr_owlscene_scr_shoes_1", { alp = 0 } );
    ObjSet( "spr_owlscene_scr_shoes_pick", { alp = 1 } );
    ObjSet( "obj_owlscene_scr_shoes", { input = true } );
    
    ObjSet( "spr_owlscene_scr_cufflinks", { input = false } );  
    ObjSet( "spr_owlscene_scr_cufflinks_1", { alp = 0 } );
    ObjSet( "spr_owlscene_scr_cufflinks_pick", { alp = 1, input = true } );
    ObjSet( "obj_owlscene_scr_cufflinks", { input = true } );
 
  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_owlscene_scr" ) ) then
  
    cmn.InitHo( "owlscene_scr" );
    cmn.SetEventDone( "opn_owlscene_scr" );
    cmn.SetMarkedTask( "owlscene_scr", "shoes" );
    cmn.SetMarkedTask( "owlscene_scr", "cufflinks" );
    
    ng_global.progress[ "scr" ][ "win_owlscene_scr" ].parents = {};
  
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "chessman",          1, 0, { { "spr_owlscene_scr_chessman" } } );
  interface.TaskPanelTaskAdd( ho_items, "ball",              1, 0, { { "spr_owlscene_scr_ball" } } );
  interface.TaskPanelTaskAdd( ho_items, "bookmark",          1, 0, { { "spr_owlscene_scr_bookmark" } } );
  interface.TaskPanelTaskAdd( ho_items, "ball_badminton",    1, 0, { { "spr_owlscene_scr_ball_badminton" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",               1, 0, { { "spr_owlscene_scr_pen" } } );
  interface.TaskPanelTaskAdd( ho_items, "pince",             1, 0, { { "spr_owlscene_scr_pince" } } );
  interface.TaskPanelTaskAdd( ho_items, "rose",              1, 0, { { "spr_owlscene_scr_rose" } } );
  interface.TaskPanelTaskAdd( ho_items, "pipe",              1, 0, { { "spr_owlscene_scr_pipe" } } );
  interface.TaskPanelTaskAdd( ho_items, "rowan",             1, 0, { { "spr_owlscene_scr_rowan" } } );
  interface.TaskPanelTaskAdd( ho_items, "pocket_watch",      1, 0, { { "spr_owlscene_scr_pocket_watch" } } );

  interface.TaskPanelTaskAdd( ho_items, "cufflinks",         1, 1, { { "spr_owlscene_scr_cufflinks_pick", "obj_owlscene_scr_cufflinks" }, { "spr_owlscene_scr_cufflinks" } } );
  interface.TaskPanelTaskAdd( ho_items, "shoes",             1, 1, { { "spr_owlscene_scr_shoes_pick", "obj_owlscene_scr_shoes" }, { "spr_owlscene_scr_shoes" } } );

  interface.TaskPanelShow( ho_items );

  common_impl.StopAllEnv( "common/audio/levelscr/aud_ho_owlscene_env" );
  common_impl.PlayAudio( "env", "common/audio/levelscr/aud_ho_owlscene_env", 1 );
  
  private.ho_close = false;
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "owlscene_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  table.insert( ng_global.progress[ "scr" ][ "win_owlscene_scr" ].parents, ObjGetRelations( "spr_owlscene_scr_"..task_name ).parent );

  cmn.HoTaskFind( "spr_owlscene_scr_"..task_name, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )

  cmn.SetEventDone( "win_ho_7_scr" );
  --cmn.CallEventHandler( "win_ho_7_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.ItemClk( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_get_inv_sfx", 0);

  if name == "shoes" then

    ObjSet( "spr_owlscene_scr_shoes_pick", { pos_z = 20} );

  elseif name == "cufflinks" then

    ObjSet( "spr_owlscene_scr_cufflinks_pick", { pos_z = 20} );

  end;

end;
--*********************************************************************************************************************
function private.unmark_shoes() 
 
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.UnmarkTask( "owlscene_scr", "shoes" );
    cmn.CallEventHandler( "owlscene_scr_unmark_shoes" );
  
  end;
  
  SetCursor( CURSOR_DEFAULT );

  if common.ApplyObj( "spr_owlscene_scr_shoes_pick", "obj_owlscene_scr_shoes" ) then

    common_impl.Lock( true );
    ObjSet( "spr_owlscene_scr_shoes_pick", { alp = 0 } );
    ObjAnimate( "spr_owlscene_scr_shoes_1", "alp", 0, 0, func_after, 
    {
      0.0,0,0,  
      0.3,0,1
    });

    common_impl.PlayAudio("sfx","common/audio/levelscr/aud_ho_owlscene_shoe");
 
  else

    ObjSet( "spr_owlscene_scr_shoes_pick", { pos_z = 0 } );
   
  end;

end;
--*********************************************************************************************************************
function private.unmark_cufflinks() 
 
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.UnmarkTask( "owlscene_scr", "cufflinks" );
    cmn.CallEventHandler( "owlscene_scr_unmark_cufflinks" );
  
  end;
  
  SetCursor( CURSOR_DEFAULT );

  if common.ApplyObj( "spr_owlscene_scr_cufflinks_pick", "obj_owlscene_scr_cufflinks" ) then

    common_impl.Lock( true );
    ObjSet( "spr_owlscene_scr_cufflinks_pick", { alp = 0 } );  

    ObjAnimate( "spr_owlscene_scr_cufflinks_1", "alp", 0, 0, func_after, 
    {
      0.0,0,0,  
      0.3,0,1
    });

    common_impl.PlayAudio( "sfx","common/audio/levelscr/aud_ho_owlscene_cufflink" );

  else

    ObjSet( "spr_owlscene_scr_cufflinks_pick", { pos_z = 0 } );
   
  end;

end;
--*********************************************************************************************************************
function private.ClkMoth()

  local func_after = function()
  
  common_impl.Lock( false );
  
  end;
  
  common_impl.Lock( true );
  ObjSet( "obj_owlscene_scr_clk_moth", { input = false });
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_touch_butterfly", 0 );
  ObjAnimate( "can_owlscene_scr_moth2", "pos_xy", 0, 0, func_after, 
  {
    0.0, 0, -196, 75,
    1.5, 0, 54, -139,
  });

end;
--*********************************************************************************************************************
function private.ClkHead()
  
  local func_after = function()
  
  common_impl.Lock( false );
  ObjSet( "obj_owlscene_scr_clk_head", { input = true });
  
  end;
  
  common_impl.Lock( true );
  ObjSet( "obj_owlscene_scr_clk_head", { input = false });
  ObjAnimate( "spr_owlscene_scr_lowered_head_2", "alp", 0, 0, func_after, 
  {
  0.0, 0, 0,
  0.3, 0, 1,
  0.9, 0, 1,
  1.2, 0, 0
  });

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_owlscene_owl" );

end;
--*********************************************************************************************************************
ObjAnimate("spr_owlscene_scr_light_add_1", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    0.8, 0, 0.5,
    1.9, 0, 1
  });

ObjAnimate("spr_owlscene_scr_light_add_2", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.2, 0, 1
  });

ObjAnimate("spr_owlscene_scr_light_add_3", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    0.9, 0, 0.5,
    2.1, 0, 1
  });
--*********************************************************************************************************************