-- name=ho_smuggling_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "smuggling_scr" );
  game.relations[ "ho_smuggling_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  private.smuggling_pos_xy = { { -29,-21 }, { 10,-34 }, { -20,8 }, { 19,-5 }, { -11,37 }, { 28,24 } };
  private.smuggling_click = 0;
  private.smuggling_tmp_pieces = { 0,0,0,0,0,0 };

  local room_objname = "ho_smuggling_scr";
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_smuggling_scr_fork", { event_mdown = function() private.TaskComplete( 'fork' ) end } } );  
  table.insert( table_multiset, { "spr_smuggling_scr_glasses", { event_mdown = function() private.TaskComplete( 'glasses' ) end } } ); 
  table.insert( table_multiset, { "spr_smuggling_scr_candle", { event_mdown = function() private.TaskComplete( 'candle' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_letter_a", { event_mdown = function() private.TaskComplete( 'letter_a' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_parsley", { event_mdown = function() private.TaskComplete( 'parsley' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_pin", { event_mdown = function() private.TaskComplete( 'pin' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_pocket_watch", { event_mdown = function() private.TaskComplete( 'pocket_watch' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_purse", { event_mdown = function() private.TaskComplete( 'purse' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_puzzle", { event_mdown = function() private.TaskComplete( 'puzzle' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_dragon", { event_mdown = function() private.TaskComplete( 'dragon' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_bow_tie", { event_mdown = function() private.TaskComplete( 'bow_tie' ) end } } );
  table.insert( table_multiset, { "spr_smuggling_scr_blue_elephant", { event_mdown = function() private.TaskComplete( 'blue_elephant' ) end } } );
 
  table.insert( table_multiset, { "spr_smuggling_scr_puppet", { event_mdown = function() private.PuppetClk() end, event_menter = function()  SetCursor( CURSOR_HAND ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end } } );  
   
  for i = 1, 6  do
    table.insert( table_multiset, { "spr_smuggling_scr_piece_"..i, { event_mdown = function() private.ClickPiece(i) end, event_menter = function()  SetCursor( CURSOR_HAND ); end, event_mleave = function()  SetCursor( CURSOR_DEFAULT ); end } } );  
  end
  

  ObjMultiSet(table_multiset);  
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_smuggling_scr = function ()

  local effects_table = 
  {
  --"anm_smuggling_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_smuggling_scr", update_performance_mode_smugglingscr, room_objname );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  --------------------------------------------------------------------------------------------
  -- function win_ho_6_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_6_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_6_big_check_ho_6", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_6" );

  end;

  cmn.AddSubscriber( "win_ho_6_scr", win_ho_6_scr_loc, "rm_mysteryroom" );
  ------------------------------------------------
  function smuggling_scr_unmark_puzzle() 

    ObjSet( "spr_smuggling_scr_puzzle", { alp = 1, input = true } );
    ObjSet( "obj_smuggling_scr_puzzle", { alp = 0, input = false } );

  end;

  cmn.AddSubscriber( "smuggling_scr_unmark_puzzle", smuggling_scr_unmark_puzzle, room_objname );
  ------------------------------------------------
  local win_smuggling_scr = function ()
    
  if not ( cmn.IsEventDone( "win_smuggling_scr" ) ) then

    if ( cmn.IsUnmarkedTask( ho_name, "puzzle" ) ) then
    
      smuggling_scr_unmark_puzzle();
      
    else

      for i = 1,6 do
      
        ObjSet( "spr_smuggling_scr_piece_"..i, { pos_x = private.smuggling_pos_xy[ ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ i ] ][ 1 ], 
                             pos_y = private.smuggling_pos_xy[ ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ i ] ][ 2 ] } );
      
      end;

    end;
    
   for j = 1, #ng_global.progress["scr"]["win_smuggling_scr"].found do

      local name = tostring( ng_global.progress[ "scr" ][ "win_smuggling_scr" ].found[ j ][ "object" ] );
     
      ObjSet( name, { visible = false, input = false, active = false } );
      ObjSet( name.."_shadow", { visible = false, input = false, active = false } );

    end;
    
  end;

  end;

  cmn.AddSubscriber( room_objname, "win_smuggling_scr", win_smuggling_scr );
  -----------------------------------------------------------------------------------
  local win_smuggling_scr_inv = function ()

  if ( cmn.IsEventDone( "win_smuggling_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_smuggling_scr", win_smuggling_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_smuggling_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_smuggling_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;
  
  private.smuggling_pos_xy = { { -29,-21 }, { 10,-34 }, { -20,8 }, { 19,-5 }, { -11,37 }, { 28,24 } };
  private.smuggling_click = 0;
  private.smuggling_tmp_pieces = { 0,0,0,0,0,0 };
  
  local pieces = { 5,3,1,6,4,2 };
  
      for i = 1,6 do
      
        ObjSet( "spr_smuggling_scr_piece_"..i, { pos_x = private.smuggling_pos_xy[ pieces[ i ] ][ 1 ], 
                                                 pos_y = private.smuggling_pos_xy[ pieces[ i ] ][ 2 ] } );
      
      end;
  
  ObjSet( "spr_smuggling_scr_puzzle", { alp = 0, input = false } );
  ObjSet( "obj_smuggling_scr_puzzle", { alp = 1, input = true } );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_smuggling_scr" ) ) then
  
    cmn.InitHo( "smuggling_scr" );
    cmn.SetEventDone( "opn_smuggling_scr" );
    cmn.SetMarkedTask( "smuggling_scr", "puzzle" );
    ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces = { 5,3,1,6,4,2 };
    ng_global.progress[ "scr" ][ "win_smuggling_scr" ].parents = {};
  
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "letter_a",          1, 0, { { "spr_smuggling_letter_a" } } );
  interface.TaskPanelTaskAdd( ho_items, "pin",               1, 0, { { "spr_smuggling_pin" } } );
  interface.TaskPanelTaskAdd( ho_items, "candle",            1, 0, { { "spr_smuggling_candle" } } );
  interface.TaskPanelTaskAdd( ho_items, "puzzle",            1, 1, { { "obj_smuggling_puzzle" }, { "spr_smuggling_puzzle" } } );
  interface.TaskPanelTaskAdd( ho_items, "dragon",            1, 0, { { "spr_smuggling_dragon" } } );
  interface.TaskPanelTaskAdd( ho_items, "glasses",           1, 0, { { "spr_smuggling_glasses" } } );
  interface.TaskPanelTaskAdd( ho_items, "bow_tie",           1, 0, { { "spr_smuggling_bow_tie" } } );
  interface.TaskPanelTaskAdd( ho_items, "parsley",           1, 0, { { "spr_smuggling_parsley" } } );
  interface.TaskPanelTaskAdd( ho_items, "purse",             1, 0, { { "spr_smuggling_purse" } } );
  interface.TaskPanelTaskAdd( ho_items, "blue_elephant",     1, 0, { { "spr_smuggling_blue_elephant" } } );
  interface.TaskPanelTaskAdd( ho_items, "fork",              1, 0, { { "spr_smuggling_fork" } } );
  interface.TaskPanelTaskAdd( ho_items, "pocket_watch",      1, 0, { { "obj_smuggling_pocket_watch" } } );

  interface.TaskPanelShow( ho_items );

  common_impl.StopAllEnv( "common/audio/aud_ho_smuggling_env" );
  common_impl.PlayAudio( "env", "common/audio/aud_ho_smuggling_env", 1 );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "smuggling_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name )
  
  table.insert( ng_global.progress[ "scr" ][ "win_smuggling_scr" ].parents, ObjGetRelations( "spr_smuggling_scr_"..task_name ).parent );

  cmn.HoTaskFind( "spr_smuggling_scr_"..task_name, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_6_scr" );
  --cmn.CallEventHandler( "win_ho_6_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.ClickPiece( piece )
  
  if ng_global.progress[ "scr" ][ "win_smuggling_scr" ].start == 0 then
    ng_global.progress[ "scr" ][ "win_smuggling_scr" ].start = 1;
  end;

  if private.smuggling_click == 0 then

    ObjSet( "spr_smuggling_scr_piece_light_"..piece, { alp = 1 } );
    private.smuggling_click = piece;

  else

    if private.smuggling_click == piece then

      ObjSet( "spr_smuggling_scr_piece_light_"..piece, { alp = 0 } );
      private.smuggling_click = 0;

    else

      ObjSet( "spr_smuggling_scr_piece_light_"..piece, { alp = 1 } );

      common_impl.Lock( true );

      local piece1 = piece;
      local piece2 = private.smuggling_click;

      ObjAnimate( "spr_smuggling_scr_piece_"..private.smuggling_click, "alp",0,0, function() private.ClickPieceEnd0( piece1, piece2 ) end,
    { 0.0,0,1,
    0.2,0,1,
    0.4,0,0,
    0.6,0,1 } );

      local pos_1 = ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ piece ];
      local pos_2 = ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ private.smuggling_click ];
      ObjAnimate( "obj_smuggling_scr_objects", "alp", 0, 0, "", { 0,0,1, 0.2,0,1 });
      ObjAnimate( "spr_smuggling_scr_piece_"..piece, "pos_xy",0,0, "",
                  { 0.0,0,private.smuggling_pos_xy[ pos_1 ][ 1 ],private.smuggling_pos_xy[ pos_1 ][ 2 ],
                    0.4,0,private.smuggling_pos_xy[ pos_1 ][ 1 ],private.smuggling_pos_xy[ pos_1 ][ 2 ],
                    0.4,0,private.smuggling_pos_xy[ pos_2 ][ 1 ],private.smuggling_pos_xy[ pos_2 ][ 2 ] } );

      ObjAnimate( "spr_smuggling_scr_piece_"..private.smuggling_click, "pos_xy",0,0, "",
                  { 0.0,0,private.smuggling_pos_xy[ pos_2 ][ 1 ],private.smuggling_pos_xy[ pos_2 ][ 2 ],
                    0.4,0,private.smuggling_pos_xy[ pos_2 ][ 1 ],private.smuggling_pos_xy[ pos_2 ][ 2 ],
                    0.4,0,private.smuggling_pos_xy[ pos_1 ][ 1 ],private.smuggling_pos_xy[ pos_1 ][ 2 ] } );

      local win = 1;

      for i = 1,6 do
        private.smuggling_tmp_pieces[ i ] = ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ i ];
      end;

      private.smuggling_tmp_pieces[ piece ] = pos_2;
      private.smuggling_tmp_pieces[ private.smuggling_click ] = pos_1;

      for i = 1,6 do
        if private.smuggling_tmp_pieces[ i ] ~= i then
          win = 0;
          break;
        end;
      end;

      if win == 1 then

        ObjAnimate( "spr_smuggling_scr_piece_"..piece, "alp",0,0,  function() private.Win() end,
    { 0.0,0,1,
      0.2,0,1,
      0.4,0,0,
      0.6,0,1 } );

      else

        ObjAnimate( "spr_smuggling_scr_piece_"..piece, "alp",0,0, function() private.ClickPieceEnd() end,
    { 0.0,0,1,
      0.2,0,1,
      0.4,0,0,
      0.6,0,1 } );
       
      end;

      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_smuggling_puzzle_move", 0 );

    end;

  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_smuggling_puzzle_click", 0 );

end;
--*********************************************************************************************************************
function private.ClickPieceEnd()

  common_impl.Lock( false );

  private.smuggling_click = 0;

  for i = 1,6 do
    ng_global.progress[ "scr" ][ "win_smuggling_scr" ].pieces[ i ] = private.smuggling_tmp_pieces[ i ];
  end;

end;
--*********************************************************************************************************************
function private.ClickPieceEnd0( piece1, piece2 )

  ObjSet( "spr_smuggling_scr_piece_light_"..piece1, { alp = 0 } );
  ObjSet( "spr_smuggling_scr_piece_light_"..piece2, { alp = 0 } );

end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( false );

  cmn.UnmarkTask( "smuggling_scr", "puzzle" );
  cmn.CallEventHandler( "smuggling_scr_unmark_puzzle" );

end;
--*********************************************************************************************************************
function private.PuppetClk()

  ObjSet( "spr_smuggling_scr_puppet", { input = 0 } );
  
  ObjAnimate( "obj_smuggling_scr_puppet", "ang",0,0, "*ObjSet( &apos;spr_smuggling_scr_puppet&apos;, { input = 1 } );",
  { 0.0,3,0,
  0.6,3,-0.1,
  2.0,3,0.08,
  3.4,3,-0.06,
  4.8,3,0.04,
  5.8,3,0 } );
 common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_ho_smuggling_touch_doll", 0 );

end;
--*********************************************************************************************************************
-- Animations ---------------------------------------------------------------------------------
ObjAnimate( "spr_smuggling_scr_scr_light", "alp",1,0, "",
{ 0.0,0,0.3,
  3.0,0,1,
  6.0,0,0.3 } );
  
ObjAnimate( "spr_smuggling_scr_scr_pocket_watch", "ang",1,0, "",
{ 0.0,3,0,
  2.0,3,0.07,
  4.0,3,0 } );
  
ObjAnimate( "obj_smuggling_scr_scr_brush_1", "ang",1,0, "",
{ 0.0,0,0,
  1.5,2,-0.05,
  4.5,3,0.05,
  6.0,1,0 } );

ObjAnimate( "obj_smuggling_scr_scr_brush_2", "ang",1,0, "",
{ 0.0,0,0,
  1.1,2,0.03,
  3.3,3,-0.03,
  4.4,1,0 } );
--*********************************************************************************************************************