-- name=ho_theatre_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "theatre_scr" );
  game.relations[ "ho_theatre_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_theatre_scr";
  local table_multiset = {};
  
  -- миниминиигра веер
  private.mmg_fan_win_angle = {-1.39,-0.899999,-0.415,0.065,0.555,1.03};
  -- выигрышные углы секторов
  private.mmg_fan_start_angle = {-0.415,1.03,-1.39,0.555,-0.899999,0.065};
  -- стартовые углы секторов
  private.mmg_fan_current_angle = {-0.415,1.03,-1.39,0.555,-0.899999,0.065}; 
  -- стартовые углы секторов
  private.mmg_fan_first_sector_number = 0;
  private.mmg_fan_second_sector_number = 0;
  
  for i = 1,6 do
    ObjSet( "spr_theatre_scr_fan_part_0"..i, { ang = private.mmg_fan_start_angle[i] } );
  end;
    
  table.insert( table_multiset, { "spr_theatre_scr_nippers", { event_mdown = function() private.TaskComplete( 'nippers' ) end } } );  
  table.insert( table_multiset, { "spr_theatre_scr_binoculars", { event_mdown = function() private.TaskComplete( 'binoculars' ) end } } ); 
  table.insert( table_multiset, { "spr_theatre_scr_bracelet", { event_mdown = function() private.TaskComplete( 'bracelet' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_butterfly_1", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_theatre_scr_butterfly_1' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_butterfly_2", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_theatre_scr_butterfly_2' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_butterfly_3", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_theatre_scr_butterfly_3' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_butterfly_4", { event_mdown = function() private.TaskComplete( 'butterfly', 'spr_theatre_scr_butterfly_4' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_diadem", { event_mdown = function() private.TaskComplete( 'diadem' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_flute", { event_mdown = function() private.TaskComplete( 'flute' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_gloves", { event_mdown = function() private.TaskComplete( 'gloves' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_note", { event_mdown = function() private.TaskComplete( 'note' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_pointes_1", { event_mdown = function() private.TaskComplete( 'pointes', 'spr_theatre_scr_pointes_1' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_pointes_2", { event_mdown = function() private.TaskComplete( 'pointes', 'spr_theatre_scr_pointes_2' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_pointes_3", { event_mdown = function() private.TaskComplete( 'pointes', 'spr_theatre_scr_pointes_3' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_frock", { event_mdown = function() private.TaskComplete( 'frock' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_mask_painted", { event_mdown = function() private.TaskComplete( 'mask_painted' ) end } } );
  table.insert( table_multiset, { "spr_theatre_scr_fan", { event_mdown = function() private.TaskComplete( 'fan' ) end } } );
 
  for i = 1, 6  do
    table.insert( table_multiset, { "spr_theatre_scr_fan_part_0"..i, { event_mdown = function() private.mmg_fan_click( i ) end } } ); 
  end;
  
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_theatre_scr = function ()

  local effects_table = 
  {
  --"anm_theatre_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_theatre_scr", update_performance_mode_owlscenescr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_3_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_3_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_3_big_check_ho_3", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_3" );

  end;

  cmn.AddSubscriber( "win_ho_3_scr", win_ho_3_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  
  function unmark_fan() 

    for i = 1,6 do
      
      ObjSet( "spr_theatre_scr_fan_part_0"..i, { alp = 0, input = false } );
      
    end;
    
    ObjSet( "spr_theatre_scr_fan", { input = true, alp = 1 } );

  end;

  cmn.AddSubscriber( "unmark_fan", unmark_fan, room_objname );
  -----------------------------------------------------------------------------
  local win_theatre_scr = function ()
    
    if ( not cmn.IsEventDone( "win_theatre_scr" ) ) then

     if ( cmn.IsUnmarkedTask( "theatre_scr", "fan" ) ) then
    
       unmark_fan();
          
     end;
     
     for j = 1, #ng_global.progress["scr"]["win_theatre_scr"].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_theatre_scr" ].found[ j ][ "object" ] );

        ObjSet( name, { visible = false, input = false, active = false } );
        ObjSet( name.."_shadow", { visible = false, input = false, active = false } );

      end;
 
   end;

  end;
  cmn.AddSubscriber( "win_theatre_scr", win_theatre_scr, room_objname );
  -----------------------------------------------------------------------------------
  local win_theatre_scr_inv = function ()

  if ( cmn.IsEventDone( "win_theatre_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_theatre_scr", win_theatre_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_theatre_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_theatre_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;
  
  -- миниминиигра веер
  private.mmg_fan_win_angle = {-1.39,-0.899999,-0.415,0.065,0.555,1.03};
  -- выигрышные углы секторов
  private.mmg_fan_start_angle = {-0.415,1.03,-1.39,0.555,-0.899999,0.065};
  -- стартовые углы секторов
  private.mmg_fan_current_angle = {-0.415,1.03,-1.39,0.555,-0.899999,0.065}; 
  -- стартовые углы секторов
  private.mmg_fan_first_sector_number = 0;
  private.mmg_fan_second_sector_number = 0;
  
  for i = 1,6 do
      
    ObjSet( "spr_theatre_scr_fan_part_0"..i, { alp = 1, input = true, ang = private.mmg_fan_start_angle[i] } );
    
  end;
  
  ObjSet( "spr_theatre_scr_fan", { input = false, alp = 0 } );

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_theatre_scr" ) ) then
  
    cmn.InitHo( "theatre_scr" );
    cmn.SetEventDone( "opn_theatre_scr" );
    cmn.SetMarkedTask( "theatre_scr", "fan" );
    
    ng_global.progress[ "scr" ][ "win_theatre_scr" ].parents = {};
    
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "nippers",                  1, 0, { { "spr_theatre_scr_nippers" } } );
  interface.TaskPanelTaskAdd( ho_items, "binoculars",               1, 0, { { "spr_theatre_scr_binoculars" } } );
  interface.TaskPanelTaskAdd( ho_items, "bracelet",                 1, 0, { { "spr_theatre_scr_bracelet" } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",                4, 0, { { "spr_theatre_scr_butterfly_1" }, { "spr_theatre_scr_butterfly_2" }, { "spr_theatre_scr_butterfly_3" }, { "spr_theatre_scr_butterfly_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "diadem",                   1, 0, { { "spr_theatre_scr_diadem" } } );
  interface.TaskPanelTaskAdd( ho_items, "flute",                    1, 0, { { "spr_theatre_scr_flute" } } );
  interface.TaskPanelTaskAdd( ho_items, "gloves",                   1, 0, { { "spr_theatre_scr_gloves" } } );
  interface.TaskPanelTaskAdd( ho_items, "note",                     1, 0, { { "spr_theatre_scr_note" } } );
  interface.TaskPanelTaskAdd( ho_items, "pointes",                  3, 0, { { "spr_theatre_scr_pointes_1" }, { "spr_theatre_scr_pointes_2" }, { "spr_theatre_scr_pointes_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "frock",                    1, 0, { { "spr_theatre_scr_frock" } } );
  interface.TaskPanelTaskAdd( ho_items, "mask_painted",             1, 0, { { "spr_theatre_scr_mask_painted" } } );
  interface.TaskPanelTaskAdd( ho_items, "fan",                      1, 1, { { "spr_theatre_scr_fan" } } );
  
  interface.TaskPanelShow( ho_items );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "theatre_scr" ); 
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";
  
  if object_name then

    object = tostring( object_name );

  else

    object = "spr_theatre_scr_"..task_name;

  end;
  
  table.insert( ng_global.progress[ "scr" ][ "win_theatre_scr" ].parents, ObjGetRelations( object ).parent );
  
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_3_scr" );
  --cmn.CallEventHandler( "win_ho_3_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.mmg_fan_click( num ) 
  
  local sector_number = tonumber( num );
  
  if private.mmg_fan_first_sector_number == 0 then
    
    private.mmg_fan_first_sector_number = sector_number;
    
    ObjAttach( "spr_theatre_scr_fan_part_light", "spr_theatre_scr_fan_part_0"..sector_number );
    ObjSet( "spr_theatre_scr_fan_part_light", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/ho_theatre_hath_partfanselect", 0, "" );
    
  elseif private.mmg_fan_first_sector_number == sector_number then
    
    private.mmg_fan_first_sector_number = 0;
    ObjSet( "spr_theatre_scr_fan_part_light", { alp = 0 } );
    
  else
    
    private.mmg_fan_second_sector_number = sector_number;
    ObjSet( "spr_theatre_scr_fan_part_light", { alp = 0 } );
    private.mmg_fan_change_angle();
    
  end;
  
end;
--*********************************************************************************************************************
function private.mmg_fan_change_angle()
  
  local func_after = function()
    
    local sum_win = 0;
    for i = 1,6 do  
      
      if private.mmg_fan_current_angle[i] == private.mmg_fan_win_angle[i] then
        
        sum_win = sum_win + 1;
        
      else
        
        break;
        
      end;
      
    end;

    if sum_win == 6 then
      
      private.mmg_fan_win();
      
    else
      
      common_impl.Lock( false );
      
    end;
  
  end;

  common_impl.Lock( true );
  
  local first_angle = private.mmg_fan_current_angle[ private.mmg_fan_first_sector_number ];
  local second_angle = private.mmg_fan_current_angle[ private.mmg_fan_second_sector_number ];
  
  ObjAnimate( "spr_theatre_scr_fan_part_0"..private.mmg_fan_first_sector_number, 7, 0, 0, "", {
    0.0, 0, first_angle, 
    0.5, 0, second_angle 
  } );
  
  ObjAnimate( "spr_theatre_scr_fan_part_0"..private.mmg_fan_second_sector_number, 7, 0, 0, func_after, {
    0.0, 0, second_angle, 
    0.5, 0, first_angle 
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/ho_theatre_hath_partfanmove", 0, "" );
  
  private.mmg_fan_current_angle[ private.mmg_fan_first_sector_number ] = second_angle;
  private.mmg_fan_current_angle[ private.mmg_fan_second_sector_number ] = first_angle;
  private.mmg_fan_first_sector_number = 0;
  private.mmg_fan_second_sector_number = 0;
  
end;
--*********************************************************************************************************************
function private.mmg_fan_win()
  
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.UnmarkTask( "theatre_scr", "fan" );
    cmn.CallEventHandler( "unmark_fan" );
    
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "spr_theatre_scr_fan", 8, 0, 0, func_after, 
  { 
    0.0, 0, 0,
    0.2, 0, 1 
  } );
  
end;
--*********************************************************************************************************************
function private.bbt_show()
  
  local x = math.random(2);
  common_impl.ShowBbt( "bbt_spr_theatre_scr_no_feather_fan_"..x );
  
end;
--*********************************************************************************************************************