-- name=ho_underseat_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "underseat_scr" );
  game.relations[ "ho_underseat_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_underseat_scr";
  local table_multiset = {};
  
  private.ho_underseat_scr_puzzle_start = 0;  
  
  table.insert( table_multiset, { "spr_underseat_scr_airplane", { event_mdown = function() private.TaskComplete( 'airplane' ) end } } );  
  table.insert( table_multiset, { "spr_underseat_scr_beetle", { event_mdown = function() private.TaskComplete( 'beetle' ) end } } ); 
  table.insert( table_multiset, { "spr_underseat_scr_clothespin", { event_mdown = function() private.TaskComplete( 'clothespin' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_dog_1", { event_mdown = function() private.TaskComplete( 'dog', 'spr_underseat_scr_dog_1' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_dog_2", { event_mdown = function() private.TaskComplete( 'dog', 'spr_underseat_scr_dog_2' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_megaphone", { event_mdown = function() private.TaskComplete( 'megaphone' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_pen", { event_mdown = function() private.TaskComplete( 'pen' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_revolver_loaded", { event_mdown = function() private.TaskComplete( 'revolver_loaded' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_servicebell", { event_mdown = function() private.TaskComplete( 'servicebell' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_lemon_1", { event_mdown = function() private.TaskComplete( 'lemon', 'spr_underseat_scr_lemon_1' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_lemon_2", { event_mdown = function() private.TaskComplete( 'lemon', 'spr_underseat_scr_lemon_2' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_slingshot", { event_mdown = function() private.TaskComplete( 'slingshot' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_whistle", { event_mdown = function() private.TaskComplete( 'whistle' ) end } } );
  table.insert( table_multiset, { "spr_underseat_scr_ball", { event_mdown = function() private.TaskComplete( 'ball' ) end } } );
  
  table.insert( table_multiset, { "spr_underseat_scr_revolver_loaded_bullet", { event_mdown = function() private.loaded_bullet_click( 'revolver_loaded_bullet' ) end,
    event_menter = function() SetCursor(CURSOR_GET); end, event_mleave = function() SetCursor(CURSOR_DEFAULT); end, event_dragdrop = function() private.loaded_bullet_drop( 'revolver_loaded_bullet' ) end } } );
  
  table.insert( table_multiset, { "spr_underseat_scr_ball_1", { event_mdown = function() private.ball_1_click() end } } );

  for i = 1, 6  do
    table.insert( table_multiset, { "spr_underseat_scr_ball_puzzle_"..i, { event_mdown = function() private.puzzle_click() end, event_menter = function() SetCursor(CURSOR_GET); end, event_mleave = function() SetCursor(CURSOR_DEFAULT); end,
    event_drag = function() private.puzzle_drag( i ) end, event_dragdrop = function() private.puzzle_drop( i ) end } } );
  end;
  
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_underseat_scr = function ()

  local effects_table = 
  {
  --"anm_underseat_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_underseat_scr", update_performance_mode_owlscenescr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_4_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_4_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_4_big_check_ho_4", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_4" );

  end;

  cmn.AddSubscriber( "win_ho_4_scr", win_ho_4_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  --------------------------------------------------------------------------------------------
  function unmark_ball()
    
    ObjSet( "spr_underseat_scr_ball", { alp = 1, input = true } );
    ObjSet( "spr_underseat_scr_ball_1", { alp = 0, input = false } );
    ObjSet( "spr_underseat_scr_ball_obj", { alp = 0 } );
    ObjSet( "obj_underseat_scr_ball_puzzle_use", { input = false } );
    
    for i = 1,6 do
      
      ObjSet( "spr_underseat_scr_ball_puzzle_"..i, { alp = 0, input = false } ); 
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "unmark_ball", unmark_ball, room_objname );
  --------------------------------------------------------------------------------------------  
  function unmark_revolver_loaded()
  
    ObjSet( "spr_underseat_scr_revolver_loaded_revolver_open", { alp = 0 } );
    ObjSet( "spr_underseat_scr_layer_bullet", { alp = 0 } );
    ObjSet( "spr_underseat_scr_revolver_loaded_bullet", { alp = 0, input = false } );
    ObjSet( "spr_underseat_scr_revolver_loaded", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "unmark_revolver_loaded", unmark_revolver_loaded, room_objname );
  -----------------------------------------------------------------------------
  local win_underseat_scr = function ()
    
    if ( not cmn.IsEventDone( "win_underseat_scr" ) ) then

       if ( cmn.IsUnmarkedTask( "underseat_scr", "revolver_loaded" ) ) then
      
         unmark_revolver_loaded();
            
       end;
       
       if ( cmn.IsUnmarkedTask( "underseat_scr", "ball" ) ) then
      
         unmark_ball();
         
       else 
         
         local puzzle_pos = 
          {
            { 634, 600 },
            { 654, 564 },
            { 626, 569 },
            { 624, 535 },
            { 650, 532 },
            { 670, 526 }
          };
          
          for i = 1, 6 do
          
            if ng_global.progress["scr"]["win_underseat_scr"].puzzle.state[i] == 1 then
              
              ObjSet("spr_underseat_scr_ball_puzzle_"..i, { input = true, pos_x = puzzle_pos[i][1], pos_y = puzzle_pos[i][2], pos_z = 6 });
                
            end;
            
          end;
          
       end;
        
      for j = 1, #ng_global.progress["scr"]["win_underseat_scr"].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_underseat_scr" ].found[ j ][ "object" ] );
  
        ObjSet( name, { visible = false, input = false, active = false } );
        ObjSet( name.."_shadow", { visible = false, input = false, active = false } );

      end;  
        
    end;
  
  end;
  cmn.AddSubscriber( "win_underseat_scr", win_underseat_scr, room_objname );
  -----------------------------------------------------------------------------------
  local win_underseat_scr_inv = function ()

  if ( cmn.IsEventDone( "win_underseat_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_underseat_scr", win_underseat_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_underseat_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_underseat_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;
  
  ObjSet( "spr_underseat_scr_revolver_loaded_revolver_open", { alp = 1, input = true } );
  ObjSet( "spr_underseat_scr_layer_bullet", { alp = 0 } );
  ObjSet( "spr_underseat_scr_revolver_loaded_bullet", { alp = 1, input = true } );
  ObjSet( "spr_underseat_scr_revolver_loaded", { input = false } );
  
  ObjSet( "spr_underseat_scr_ball", { alp = 0, input = false } );
  ObjSet( "spr_underseat_scr_ball_1", { alp = 1, input = true } );
  ObjSet( "spr_underseat_scr_ball_obj", { alp = 1 } );
  ObjSet( "obj_underseat_scr_ball_puzzle_use", { input = true } );
  
  local puzzle_pos = {
                      { 634, 600 },
                      { 220, 304 },
                      { 704, 106 },
                      { 358, 145 },
                      { 705, 455 },
                      { 297, 474 }
                    };
  
  for i = 1,6 do
    
    ObjSet( "spr_underseat_scr_ball_puzzle_"..i, { alp = 1, input = true, 
                                                   pos_x = puzzle_pos[i][1], pos_y = puzzle_pos[i][2], pos_z = 6 } ); 
    
  end;
 

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_underseat_scr" ) ) then
  
    cmn.InitHo( "underseat_scr" );
    cmn.SetEventDone( "opn_underseat_scr" );
    ng_global.progress["scr"]["win_underseat_scr"].puzzle = {};
    ng_global.progress["scr"]["win_underseat_scr"].box = false;
    ng_global.progress["scr"]["win_underseat_scr"].bandage = false;
    ng_global.progress["scr"]["win_underseat_scr"].puzzle.state = {1,0,0,0,0,0};
    cmn.SetMarkedTask( "underseat_scr", "ball" );
    cmn.SetMarkedTask( "underseat_scr", "revolver_loaded" );
    
    ng_global.progress[ "scr" ][ "win_underseat_scr" ].parents = {};
    
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "airplane",                   1, 0, { { "spr_underseat_scr_airplane" } } );
  interface.TaskPanelTaskAdd( ho_items, "beetle",                     1, 0, { { "spr_underseat_scr_beetle" } } );
  interface.TaskPanelTaskAdd( ho_items, "clothespin",                 1, 0, { { "spr_underseat_scr_clothespin" } } );
  interface.TaskPanelTaskAdd( ho_items, "dog",                        2, 0, { { "spr_underseat_scr_dog_1" }, { "spr_underseat_scr_dog_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "megaphone",                  1, 0, { { "spr_underseat_scr_megaphone" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",                        1, 0, { { "spr_underseat_scr_pen" } } );
  interface.TaskPanelTaskAdd( ho_items, "servicebell",                1, 0, { { "spr_underseat_scr_servicebell" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon",                      2, 0, { { "spr_underseat_scr_lemon_1" }, { "spr_underseat_scr_lemon_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "slingshot",                  1, 0, { { "spr_underseat_scr_slingshot" } } );
  interface.TaskPanelTaskAdd( ho_items, "whistle",                    1, 0, { { "spr_underseat_scr_whistle" } } );
  interface.TaskPanelTaskAdd( ho_items, "ball",                       1, 1, { { "spr_underseat_scr_ball" } } );
  interface.TaskPanelTaskAdd( ho_items, "revolver_loaded",            1, 1, { { "spr_underseat_scr_revolver_loaded" } } );
  
  interface.TaskPanelShow( ho_items );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "underseat_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );

end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";
  
  if object_name then

    object = tostring( object_name );

  else

    object = "spr_underseat_scr_"..task_name;

  end;
  
  table.insert( ng_global.progress[ "scr" ][ "win_underseat_scr" ].parents, ObjGetRelations( object ).parent );
  
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_4_scr" );
  --cmn.CallEventHandler( "win_ho_4_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************
function private.loaded_bullet_click( name )
  
  local obj = "spr_underseat_scr_"..name;
  ObjSet( obj , { pos_z = 9 } );
  SetCursor(CURSOR_DEFAULT);
  
end;
--*********************************************************************************************************************
function private.loaded_bullet_drop( name ) 

  local obj = "spr_underseat_scr_"..name;
  
  local func_after = function()
  
    common_impl.Lock( false );
    cmn.UnmarkTask( "underseat_scr", "revolver_loaded" );
    cmn.CallEventHandler( "unmark_revolver_loaded" );
    
  end;

  if common.ApplyObj( obj, "spr_underseat_scr_revolver_loaded_revolver_open" ) then

    common_impl.Lock( true );
    
    ObjSet( "spr_underseat_scr_revolver_loaded_bullet", { alp = 0 } );
    ObjSet( "spr_underseat_scr_revolver_loaded_revolver_open", { input = false } );

    ObjAnimate( "spr_underseat_scr_layer_bullet", 8, 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );
    
    ObjAnimate( "spr_underseat_scr_revolver_loaded_revolver_open", 8, 0, 0, func_after, 
    { 
      0.0, 0, 1,
      0.6, 0, 1,
      0.9, 0, 0 
    } );
    
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_use_bullet_sfx", 0, "" );
    
  else

    ObjSet( obj, { pos_z = 0 } );
    SetCursor(CURSOR_DEFAULT);
    
  end;
  
end;
--*********************************************************************************************************************
function private.ball_1_click()
  
  common_impl.ShowBbt( "bbt_spr_underseat_scr_ball_1_click_"..math.random(2) );
  
end;
--*********************************************************************************************************************
function private.puzzle_click()
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_ball_get_sfx", 0, "" ); 
  
end;
--*********************************************************************************************************************
function private.puzzle_drag( num )
  
  local obj = "spr_underseat_scr_ball_puzzle_"..num;
  local puzzle = tonumber( string.match( obj, "%d+"));

  ObjSet( obj, { pos_z = 10 });

  if private.ho_underseat_scr_puzzle_start == 0 then
    
    private.ho_underseat_scr_puzzle_start = 1;
    
  end;
  
end;
--*********************************************************************************************************************
function private.puzzle_drop( num )
  
  local obj = "spr_underseat_scr_ball_puzzle_"..num;

  local puzzle_pos = 
    {
    { 634, 600 },
    { 654, 564 },
    { 626, 569 },
    { 624, 535 },
    { 650, 532 },
    { 670, 526 }
    };

  private.ho_underseat_scr_puzzle_start = 0;
    
  if common.ApplyObj( obj, "obj_underseat_scr_ball_puzzle_use" )  then
    
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_ball_use_sfx", 0, "" );
    
    ObjSet( obj, { input = false, pos_x = puzzle_pos[ num ][1], pos_y = puzzle_pos[ num ][2], pos_z = 6 });
    ng_global.progress["scr"]["win_underseat_scr"].puzzle.state[ num ] = 1;

    if private.check_puzzle_win() then
    
      private.puzzle_win();

    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.check_puzzle_win()
  
  local puzzle_win = true;
    
  for i = 1,6 do
      
    if ng_global.progress["scr"]["win_underseat_scr"].puzzle.state[i] ~= 1 then
      
      puzzle_win = false;
      break;
      
    end;
      
  end;
 
  return puzzle_win;
  
end;
--*********************************************************************************************************************
function private.puzzle_win()
  
 local func_after = function()
 
    common_impl.Lock( false );
    cmn.UnmarkTask( "underseat_scr", "ball" );
    cmn.CallEventHandler( "unmark_ball" );
    
 end;

 common_impl.Lock( true );
  
 for i = 1,6 do
    
  ObjAnimate( "spr_underseat_scr_ball_puzzle_"..i, 8, 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0 
  });
    
 end;
  
 ObjAnimate( "spr_underseat_scr_ball", 8, 0, 0, func_after, 
 { 
   0.0, 0, 0,
   0.3, 0, 1 
 });
  
end;
--*********************************************************************************************************************