-- name=ho_workbench_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "workbench_scr" );
  game.relations[ "ho_workbench_scr" ].exitroom = "rm_mysteryroom";
  --------------------------------------------------------------------------------------------------
  local room_objname = "ho_workbench_scr";
  local table_multiset = {};
  
  table.insert( table_multiset, { "spr_workbench_scr_dynamite", { event_mdown = function() private.TaskComplete( 'dynamite' ) end } } );  
  table.insert( table_multiset, { "spr_workbench_scr_camera", { event_mdown = function() private.TaskComplete( 'camera' ) end } } ); 
  table.insert( table_multiset, { "spr_workbench_scr_compass", { event_mdown = function() private.TaskComplete( 'compass' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_detonator", { event_mdown = function() private.TaskComplete( 'detonator' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_egg", { event_mdown = function() private.TaskComplete( 'egg' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_fan", { event_mdown = function() private.TaskComplete( 'fan' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_flower_1", { event_mdown = function() private.TaskComplete( 'flower', 'spr_workbench_scr_flower_1' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_flower_2", { event_mdown = function() private.TaskComplete( 'flower', 'spr_workbench_scr_flower_2' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_flower_3", { event_mdown = function() private.TaskComplete( 'flower', 'spr_workbench_scr_flower_3' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_seashell_1", { event_mdown = function() private.TaskComplete( 'seashell', 'spr_workbench_scr_seashell_1' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_seashell_2", { event_mdown = function() private.TaskComplete( 'seashell', 'spr_workbench_scr_seashell_2' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_seashell_3", { event_mdown = function() private.TaskComplete( 'seashell', 'spr_workbench_scr_seashell_3' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_ship", { event_mdown = function() private.TaskComplete( 'ship' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_sword_1", { event_mdown = function() private.TaskComplete( 'sword', 'spr_workbench_scr_sword_1' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_sword_2", { event_mdown = function() private.TaskComplete( 'sword', 'spr_workbench_scr_sword_2' ); end } } );
  table.insert( table_multiset, { "spr_workbench_scr_thread", { event_mdown = function() private.TaskComplete( 'thread' ) end } } );
  table.insert( table_multiset, { "spr_workbench_scr_wire", { event_mdown = function() private.TaskComplete( 'wire' ) end } } );
  
  ObjMultiSet(table_multiset);    
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_workbench_scr = function ()

  local effects_table = 
  {
  --"anm_workbench_scr_name",
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "fog" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_workbench_scr", update_performance_mode_owlscenescr, room_objname );
  --------------------------------------------------------------------------------------------
  private.ho_close = false;
  -----------------------------------------------------------------------------
  local win_workbench_scr = function ()
    
    if ( not cmn.IsEventDone( "win_workbench_scr" ) ) then
      
       for j = 1, #ng_global.progress["scr"]["win_workbench_scr"].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_workbench_scr" ].found[ j ][ "object" ] );
  
        ObjSet( name, { visible = false, input = false, active = false } );
        ObjSet( name.."_shadow", { visible = false, input = false, active = false } );

      end;
    
    end;

  end;
  cmn.AddSubscriber( "win_workbench_scr", win_workbench_scr, room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ho_2_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_ho_2_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_2_big_check_ho_2", { alp = 1 });
    ObjDelete( "anm_mysteryroom_mt_check_mark_ho_2" );

  end;

  cmn.AddSubscriber( "win_ho_2_scr", win_ho_2_scr_loc, "rm_mysteryroom" );
  -----------------------------------------------------------------------------------
  local win_workbench_scr_inv = function ()

  if ( cmn.IsEventDone( "win_workbench_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_workbench_scr", win_workbench_scr_inv );
  --------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Reset()

  local ho_found = ng_global.progress[ "scr" ][ "win_workbench_scr" ].found;

  for i = 1, #ho_found, 1 do

    ObjSet( ho_found[ i ][ "object" ], { visible = true, input = true, active = true, alp = 1 } );
    ObjAttach( ho_found[ i ][ "object" ], ng_global.progress[ "scr" ][ "win_workbench_scr" ].parents[i] );
    ObjDelete( "pfx_int_taskpanel_collect_"..ho_found[ i ][ "object" ] ); 
    ObjSet( ho_found[ i ][ "object" ].."_shadow", { visible = true, active = true, alp = 1 } );
 
  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ( not cmn.IsEventDone( "opn_workbench_scr" ) ) then
  
    cmn.InitHo( "workbench_scr" );
    cmn.SetEventDone( "opn_workbench_scr" );
    
    ng_global.progress[ "scr" ][ "win_workbench_scr" ].parents = {};
  
  end;
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "dynamite",             1, 0, { { "spr_workbench_scr_dynamite" } } );
  interface.TaskPanelTaskAdd( ho_items, "camera",               1, 0, { { "spr_workbench_scr_camera" } } );
  interface.TaskPanelTaskAdd( ho_items, "compass",              1, 0, { { "spr_workbench_scr_compass" } } );
  interface.TaskPanelTaskAdd( ho_items, "detonator",            1, 0, { { "spr_workbench_scr_detonator" } } );
  interface.TaskPanelTaskAdd( ho_items, "egg",                  1, 0, { { "spr_workbench_scr_egg" } } );
  interface.TaskPanelTaskAdd( ho_items, "fan",                  1, 0, { { "spr_workbench_scr_fan" } } );
  interface.TaskPanelTaskAdd( ho_items, "flower",               3, 0, { { "spr_workbench_scr_flower_1" }, { "spr_workbench_scr_flower_2" }, { "spr_workbench_scr_flower_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "seashell",             3, 0, { { "spr_workbench_scr_seashell_1" }, { "spr_workbench_scr_seashell_2" }, { "spr_workbench_scr_seashell_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "ship",                 1, 0, { { "spr_workbench_scr_ship" } } );
  interface.TaskPanelTaskAdd( ho_items, "sword",                2, 0, { { "spr_workbench_scr_sword_1" }, { "spr_workbench_scr_sword_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "thread",               1, 0, { { "spr_workbench_scr_thread" } } );
  interface.TaskPanelTaskAdd( ho_items, "wire",                 1, 0, { { "spr_workbench_scr_wire" } } );

  interface.TaskPanelShow( ho_items );
  
  private.ho_close = false;
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  int_taskpanel_impl.ShowTextPanel( "workbench_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0.5 );  
  
end;
--*********************************************************************************************************************
function private.GotoRoom()

  private.ho_close = true;
  --cmn.GotoRoom( "rm_mysteryroom" );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";
  
  if object_name then

    object = tostring( object_name );

  else

    object = "spr_workbench_scr_"..task_name;

  end;
  
  
table.insert( ng_global.progress[ "scr" ][ "win_workbench_scr" ].parents, ObjGetRelations( object ).parent );
  
  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function public.HoComplete()
end;
--*********************************************************************************************************************
function public.HoCompleteFunction( ho_name )
  
  cmn.SetEventDone( "win_ho_2_scr" );
  --cmn.CallEventHandler( "win_ho_2_scr" );
  rm_mysteryroom.HoComplete( ho_name );
  
end;
--*********************************************************************************************************************