-- name=mg_basementlock_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_basementlock_scr";
  private.lever = 0;
  private.ball_pos = 1;
  private.angl1 = 1;
  private.angl2 = 1;
  private.pos_ball = {{ 474, 212 },{ 759, 254 },{ 720, 499 },{ 530, 547 }};

  local table_multiset = {};
  
  for i = 1, 7 do 
  
    table.insert( table_multiset, {"obj_basementlock_scr_lever_"..i, 
      {
      event_mdown = function() private.LeverClick( i ); end ,
      event_menter = function () SetCursor( CURSOR_HAND ); end,
      event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
      } 
    } );
    
  end;
  
  ObjMultiSet( table_multiset );
  
  local win_basementlock_scr_start = function ()

    if ( not cmn.IsEventDone( "win_basementlock_scr" ) ) then

     private.lever = ng_global.progress[ "scr" ][ "win_basementlock_scr" ].lever;
     private.ball_pos = ng_global.progress[ "scr" ][ "win_basementlock_scr" ].ball_pos;
     private.angl1 = ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl1;
     private.angl2 = ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl2;
    
     if (private.ball_pos == 1) then
      ObjSet( "obj_basementlock_scr_ball", { pos_x = 474, pos_y = 212 } );
     elseif (private.ball_pos == 2) then
      ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_clamp_3");
      ObjSet( "obj_basementlock_scr_ball", { pos_x = 53, pos_y = 1 } );
     elseif (private.ball_pos == 3) then
      ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_clamp_4");
      ObjSet( "obj_basementlock_scr_ball", { pos_x = 54, pos_y = 5 } );
     elseif (private.ball_pos == 4) then
      ObjSet( "obj_basementlock_scr_ball", { pos_x = 530, pos_y = 547 } );
     end;

     if ( private.lever == 1 ) then
      ObjSet( "spr_basementlock_scr_part_1", { pos_x = -53, pos_y = 165 } );
     else
      ObjSet( "spr_basementlock_scr_part_1", { pos_x = -53, pos_y = -175 } );
     end;

     if (private.angl1 == 1) then
      ObjSet( "obj_basementlock_scr_clamp_3", { ang = 5.29, pos_x = 728 } );
     else
      ObjSet( "obj_basementlock_scr_clamp_3", { ang = 3.15, pos_x = 714 } );
     end;
     
     if (private.angl2 == 1) then
      ObjSet( "obj_basementlock_scr_clamp_4", { ang = 3.37, pos_x = 773, pos_y = 484 } );
     else
      ObjSet( "obj_basementlock_scr_clamp_4", { ang = 1.26, pos_x = 778, pos_y = 463 } );
     end;
     
    end;

  end;
  -----------------------------------------------------------------------------------
  local win_basementlock_scr_done = function ()

    if ( cmn.IsEventDone( "win_basementlock_scr" ) ) then
    
    ObjSet( "obj_basementlock_scr_ball", { pos_x = 425, pos_y = 354 } );
    ObjSet( "spr_basementlock_scr_lock", { pos_x = 882 } );
    ObjSet( "spr_basementlock_scr_weel_3", { ang = 0.6 } );
    ObjSet( "obj_basementlock_scr_weel_4", { ang = 0.6 } );
    ObjSet( "spr_basementlock_scr_weel_6", { ang = -0.6 } );
    ObjSet( "spr_basementlock_scr_weel_7", { ang = -0.6 } );
    ObjSet( "spr_basementlock_scr_part_1", { pos_x = -53, pos_y = -175 } );
    ObjSet( "obj_basementlock_scr_lever", { input = 0 } );

    end;

  end;

  cmn.AddSubscriber( "mg_basementlock_scr", "win_basementlock_scr", win_basementlock_scr_start );
  cmn.AddSubscriber( "mg_basementlock_scr", "win_basementlock_scr", win_basementlock_scr_done );
  cmn.AddSubscriber( "mg_basementlock_scr", "win_basementlock_scr_done", win_basementlock_scr_done );
  --------------------------------------------------------------------------------------------
  -- function win_mg_7_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_7_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_7_big_check_mg_7", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_7" );

  end;

  cmn.AddSubscriber( "win_mg_7_scr", win_mg_7_scr_loc, "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function public.Open() 

  ObjSet("obj_int_button_info_impl", { pos_y = 70 });
  ObjSet("obj_int_button_reset_impl", { pos_y = 70 });
  
  if not cmn.IsEventDone( "win_basementlock_scr" ) then

    cmn.MiniGameShow();
   
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_basementlock_scr" ) ) then
  
    ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl1 = 1;
    ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl2 = 1;
    ng_global.progress[ "scr" ][ "win_basementlock_scr" ].lever = 0;
    ng_global.progress[ "scr" ][ "win_basementlock_scr" ].ball_pos = 1;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_basementlock_scr" ) then

    cmn.MiniGameHide();

  end;
  
end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_basementlock_scr" );  
  cmn.CallEventHandler( "win_basementlock_scr_done" );
  cmn.SetEventDone( "win_mg_7_scr" );
  --cmn.CallEventHandler( "win_mg_7_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );
  
end;
--*********************************************************************************************************************
function private.WinAnim()

  local func_after = function()
  
    private.Win();
  
  end;
  
  common_impl.Lock( true ); 
  
  ObjAnimate( "spr_basementlock_scr_weel_7", "ang",0,0, "",
  { 
    0.0,0,0,
    0.3,0,-0.3,
    0.6,0,-0.6
  } );

  ObjAnimate( "spr_basementlock_scr_weel_6", "ang",0,0, "",
  { 
    0.0,0,0,
    0.3,0,-0.3,
    0.6,0,-0.6
  } );

  ObjAnimate( "obj_basementlock_scr_weel_4", "ang",0,0, "",
  { 
    0.0,0,0,
    0.3,0,0.3,
    0.6,0,0.6
  } );

  ObjAnimate( "spr_basementlock_scr_weel_3", "ang",0,0, "",
  { 
    0.0,0,0,
    0.3,0,0.3,
    0.6,0,0.6
  } );

  ObjAnimate( "spr_basementlock_scr_lock", "pos_x",0,0, func_after,
  { 
    0.0,0,1043,
    0.9,0,882
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_win", 0, "", 0 );

end;
--*********************************************************************************************************************
function public.Skip()

  common_impl.Lock( true );
  ObjAnimate( "obj_basementlock_scr_ball", "alp",0,0, "",
  { 
    0.0,0,1,
    0.3,0,0,
    0.6,0,0,
    0.9,0,1
  } );

  ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, "",
  { 
    0.0,0,ObjGet("obj_basementlock_scr_ball").pos_x,ObjGet("obj_basementlock_scr_ball").pos_y,
    0.3,0,ObjGet("obj_basementlock_scr_ball").pos_x,ObjGet("obj_basementlock_scr_ball").pos_y,
    0.6,0,425,354
  } );

  ObjSet( "tmr_basementlock_scr_win", { playing = true, time = 0.9, endtrig = function() private.WinAnim(); end } );

end;
--*********************************************************************************************************************
function public.Reset()

  ng_global.progress[ "scr" ][ "win_basementlock_scr" ].lever = 0;
  ng_global.progress[ "scr" ][ "win_basementlock_scr" ].ball_pos = 1;
  ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl1 = 1;
  ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl2 = 1;
  private.lever = 0;
  private.ball_pos = 1;
  private.angl1 = 1;
  private.angl2 = 1;
  ObjSet( "obj_basementlock_scr_clamp_3", { ang = 5.29 } );
  ObjSet( "obj_basementlock_scr_clamp_4", { ang = 3.37, pos_x = 773, pos_y = 484 } );
  ObjSet( "obj_basementlock_scr_ball", { pos_x = 474, pos_y = 212 } );
  ObjSet( "spr_basementlock_scr_part_1", { pos_x = -53, pos_y = -175 } );
  ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_ball_home"); 
  
  for i = 1,7  do

    ObjSet( "spr_basementlock_scr_weel_"..i, { ang = 0 } );

  end

end;
--*********************************************************************************************************************
function private.LeverClick( num )

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_click", 0, "", 0 );
  number = tonumber( num );
  common_impl.Lock( true );
  
  local func_after = function()
  
    private.LeverClickEnd( number );
  
  end;
  
  if ( number == 4 ) or ( number == 5 ) then
  
    local x1 = ObjGet( "obj_basementlock_scr_lever_"..number ).pos_x - 20;
    ObjAnimate( "obj_basementlock_scr_lever_"..number, "pos_x",0,0, "",
    { 
      0.0,0,ObjGet( "obj_basementlock_scr_lever_"..number ).pos_x,
      0.3,0,x1,
      0.6,0,x1+20
    } );
  
  else
  
    local x1 = ObjGet( "obj_basementlock_scr_lever_"..number ).pos_x + 20;
    ObjAnimate( "obj_basementlock_scr_lever_"..number, "pos_x",0,0, "",
    { 
      0.0,0,ObjGet( "obj_basementlock_scr_lever_"..number ).pos_x,
      0.3,0,x1,
      0.6,0,x1-20
    } );
  
  end;

  if ( number == 1 ) then 
  
    if ( private.lever == 0 ) then
  
      ObjAnimate( "spr_basementlock_scr_part_"..number, "pos_y",0,0, func_after,
      { 
        0.0,0,-175,
        0.6,0,165
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_1", 0, "", 0 );
    else
  
      ObjAnimate( "spr_basementlock_scr_part_"..number, "pos_y",0,0, func_after,
      { 
        0.0,0,165,
        0.6,0,-175
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_1", 0, "", 0 );
    end;
  
  elseif ( number == 2 ) then 
  
    if ( private.angl1 == 1 ) then
    
      ObjAnimate( "obj_basementlock_scr_clamp_3", "ang",0,0, func_after,
      { 
        0.0,0,5.29,
        0.3,0,3.15
      } );  
      
      ObjAnimate( "obj_basementlock_scr_clamp_3", "pos_x",0,0, "",
      { 
        0.0,0,728,
        0.3,0,714
      } );  
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
    else 
    
      ObjAnimate( "obj_basementlock_scr_clamp_3", "ang",0,0, func_after,
      { 
        0.0,0,3.15,
        0.3,0,5.29
      } );
    
      ObjAnimate( "obj_basementlock_scr_clamp_3", "pos_x",0,0, "",
      { 
        0.0,0,714,
        0.3,0,728
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );    
    end;
  
  elseif ( number == 3 ) then 
  
    if ( private.ball_pos == 1 ) then
  
      local func_after_2 = function()
      
        ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_clamp_3" );
        ObjSet( "obj_basementlock_scr_ball", { pos_x = 53, pos_y = 1 } );
        private.LeverClickEnd( number );
      
      end;
    
      if ( private.lever == 1 ) and ( private.angl1 == 0 )then
    
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after_2,
        { 
          0.0,0,474,212,
          0.9,0,650,212,
          1.2,0,663,214
        } );             
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move", 0, "", 0 ); 
        private.ball_pos = 2;
    
      else
    
        private.DeleteLock();
    
      end;
    
    else
  
      private.DeleteLock();
    
    end;
  
  elseif ( number == 4 ) then
  
    ObjAnimate( "obj_basementlock_scr_weel_1", "ang",0,0, "",
    { 
      0.0,0,ObjGet("obj_basementlock_scr_weel_1").ang,
      0.6,0,ObjGet("obj_basementlock_scr_weel_1").ang - 0.3
    } );
    
    ObjAnimate( "spr_basementlock_scr_weel_2", "ang",0,0, "",
    { 
      0.0,0,ObjGet("spr_basementlock_scr_weel_2").ang,
      0.6,0,ObjGet("spr_basementlock_scr_weel_2").ang + 0.3
    } );
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_3", 0, "", 0 );
    if ( private.ball_pos == 2 ) then
  
      if ( private.angl1 == 1 ) and ( private.angl2 == 0 ) then
    
        local func_after_3 = function()
        
          ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_clamp_4" );
          ObjSet( "obj_basementlock_scr_ball", { pos_x = 54, pos_y = 5 } );
          private.LeverClickEnd( number );
          
        end;
    
        ObjAnimate( "obj_basementlock_scr_clamp_3", "pos_xy",0,0, "",
        { 
          0.0,0,728,210,
          0.3,0,735,216,
          0.6,0,728,210
        } );  
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
        ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_ball_home" );
        ObjSet( "obj_basementlock_scr_ball", { pos_x = 759, pos_y = 254 } );
     
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after_3,
        { 
          0.0,0,765,263,
          0.3,0,787,320,
          0.6,0,797,365,
          0.9,0,796,414
        } );        
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move", 0, "", 0 );
        private.ball_pos = 3;
    
      elseif ( private.angl1 == 0 ) then
    
        ObjAnimate( "obj_basementlock_scr_clamp_3", "pos_xy",0,0, "",
        { 
          0.0,0,714,210,
          0.3,0,704,210,
          0.6,0,715,210
        } );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
        ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_ball_home");
    
        ObjSet( "obj_basementlock_scr_ball", { pos_x = 663, pos_y = 214 } );
    
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after,
        { 
          0.0,0,663,214,
          0.9,0,474,212
        } );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move", 0, "", 0 );
        private.ball_pos = 1;
    
      else
    
        private.DeleteLock();
    
      end;
    
    else
  
      private.DeleteLock();
    
    end;
  
  elseif ( number == 5 ) then 
  
    if ( private.angl2 == 1 ) then
    
      ObjAnimate( "obj_basementlock_scr_clamp_4", "ang",0,0, func_after,
      { 
        0.0,0,3.37,
        0.3,0,1.26
      } ); 
    
      ObjAnimate( "obj_basementlock_scr_clamp_4", "pos_xy",0,0, "",
      { 
        0.0,0,773,484,
        0.3,0,778,463
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );  
      
    else 
    
      ObjAnimate( "obj_basementlock_scr_clamp_4", "ang",0,0, func_after,
      { 
        0.0,0,1.26,
        0.3,0,3.37
      } );
    
      ObjAnimate( "obj_basementlock_scr_clamp_4", "pos_xy",0,0, "",
      { 
        0.0,0,778,463,
        0.3,0,773,484
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
      
    end;
  
  elseif ( number == 6 ) then 
  
    ObjAnimate( "obj_basementlock_scr_weel_5", "ang",0,0, "",
    { 
      0.0,0,ObjGet("obj_basementlock_scr_weel_5").ang,
      0.6,0,ObjGet("obj_basementlock_scr_weel_5").ang - 0.3,
    } );
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_4", 0, "", 0 );
    if ( private.ball_pos == 3 ) then
  
      if ( private.angl2 == 1 ) and ( private.lever == 0 ) then
    
        ObjAnimate( "obj_basementlock_scr_clamp_4", "pos_xy",0,0, "",
        { 
          0.0,0,773,484,
          0.3,0,764,487,
          0.6,0,773,484
        } );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
        ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_ball_home");
        ObjSet( "obj_basementlock_scr_ball", { pos_x = 720, pos_y = 499 } );
    
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after,
        { 
          0.0,0,720,499,
          0.3,0,605,527,
          0.6,0,530,547
        } );  
    
        private.ball_pos = 4;
    
      elseif ( private.angl2 == 0 ) and ( private.angl1 == 1 ) then
    
        local func_after_4 = function()
          
          ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_clamp_3" );
          ObjSet( "obj_basementlock_scr_ball", { pos_x = 53, pos_y = 1 } );
          private.LeverClickEnd( number );
          
        end;
    
        ObjAnimate( "obj_basementlock_scr_clamp_4", "pos_xy",0,0, "",
        { 
          0.0,0,778,463,
          0.3,0,780,454,
          0.6,0,778,463
        } );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move_holder", 0, "", 0 );
        ObjAttach( "obj_basementlock_scr_ball", "obj_basementlock_scr_ball_home" );
        ObjSet( "obj_basementlock_scr_ball", { pos_x = 796, pos_y = 414 } );
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after_4,
        { 
          0.0,0,796,414,
          0.9,0,765,263
        } );        
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move", 0, "", 0 );
        private.ball_pos = 2;
    
      else
    
        private.DeleteLock();
    
      end;
    
    else
  
      private.DeleteLock();
    
    end;
  
  elseif (number == 7) then
  
    if ( private.lever == 0 ) then 
  
      ObjAnimate( "spr_basementlock_scr_part_"..number, "pos_xy",0,0, "",
      { 
        0.0,0,30,199,
        0.2,0, 0,135,
        0.4,0,30,199
      } );
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_5", 0, "", 0 );
      if ( private.ball_pos == 4 ) then
    
        ObjAnimate( "obj_basementlock_scr_ball", "pos_xy",0,0, func_after,
        {
          0.0,0,530,547,
          0.2,0,493,477,
          0.4,0,425,354
        } );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_basementlock_move", 0, "", 0 );
      else
    
        private.DeleteLock();
    
      end;
    
    else
  
      private.DeleteLock();
    
    end;
  
  end;
  
end;
--*********************************************************************************************************************
function private.LeverClickEnd( num )
  
   if ( private.ball_pos == 4 and tonumber(num) == 7 ) then 

      private.WinAnim();

   else

       common_impl.Lock( false );

       if ( tonumber(num) == 1 ) then

          if ( private.lever == 0 ) then

            private.lever = 1;

          else 

            private.lever = 0;
        
          end;

      elseif ( tonumber(num) == 2 ) then

          if ( private.angl1 == 0 ) then

            private.angl1 = 1;

          else 

            private.angl1 = 0;
        
          end;
          
      elseif ( tonumber(num) == 5 ) then

          if ( private.angl2 == 0 ) then

            private.angl2 = 1;

          else 

            private.angl2 = 0;
        
          end;
          
       end;
       
       ng_global.progress[ "scr" ][ "win_basementlock_scr" ].lever = private.lever;
       ng_global.progress[ "scr" ][ "win_basementlock_scr" ].ball_pos = private.ball_pos;
       ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl1 = private.angl1;
       ng_global.progress[ "scr" ][ "win_basementlock_scr" ].angl2 = private.angl2;

  end;

end;
--*********************************************************************************************************************
function private.DeleteLock()
 
  ObjSet( "tmr_basementlock_scr_unlock", { playing = true, time = 0.6, endtrig = function() common_impl.Lock( false ); end });

end;