-- name=mg_bomb_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_bomb_scr";
  --------------------------------------------------------------------------------------------
  -- function win_mg_4_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_4_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_4_big_check_mg_4", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_4" );

  end;

  cmn.AddSubscriber( "win_mg_4_scr", win_mg_4_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_bomb_scr () end;
  --------------------------------------------------------------------------------------------
  local win_bomb_scr = function ()

  if ( cmn.IsEventDone( "win_bomb_scr" ) ) then  

  else

    private.MGLoad();
    private.MGLoadState();

  end;

  end;

  cmn.AddSubscriber( "win_bomb_scr", win_bomb_scr, private.room_objname );

  --------------------------------------------------------------------------------------------
  private.InitMG();

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_bomb_scr" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_bomb_scr" ) ) then

    private.InitMGVar();
    private.MGLoadState();

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_bomb_scr" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  if ( private.cur_smile ) then

    ObjSet( "anm_bomb_scr_smile_"..private.cur_i, { alp = 1 } );
    private.cur_smile = nil;

  end;

  private.InitMGVar();
  private.InitMG();
  private.MGLoadState();

end;
--*********************************************************************************************************************
function public.Skip()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.Lock( false );

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_bomb_scr" );
  cmn.CallEventHandler( "win_bomb_scr" );
  cmn.SetEventDone( "win_mg_4_scr" );
  --cmn.CallEventHandler( "win_mg_4_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  private.save = 6;
  private.MGLoadState();
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_mg_bomb_win_sfx", 0, "", 0 );
  ObjAnimate( "anm_bomb_scr_face_"..private.save, "alp", 0, 0, private.WinEnd, 
  { 
    0.0, 3, 0, 
    0.5, 3, 1,
    1.5, 3, 1,
    
  });

end;
--*********************************************************************************************************************
function private.InitMG() 

  local start_pos = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
  
  local cur_pos = {};

  for i = 1, #start_pos do

    local num = math.random( 1, #start_pos );
    table.insert( cur_pos, start_pos[ num ] );
    table.remove( start_pos, num );

  end;

  local table_mts = {};
  
  for i = 0, 15 do

    table.insert( table_mts, { "obj_bomb_scr_smile_"..i, 
    {  
      event_mdown = function () private.SmileClk( i ,cur_pos[ i + 1 ] ) end,
      event_menter = function () private.SmileMenter( i ) end,
      event_mleave = function () private.SmileMleave( i ) end,
      frame = cur_pos[ i + 1 ],

    } } );

    table.insert( table_mts, { "anm_bomb_scr_smile_"..i, 
    {  

      frame = cur_pos[ i + 1 ],

    } } );

  end; 

  ObjMultiSet( table_mts );

  private.clicks_sm = {{  0,  1 },
                       {  2,  3 },
                       {  4,  5 },
                       {  6,  7 },
                       {  8,  9 },
                       { 10, 11 }};

end;
--*********************************************************************************************************************
function private.InitMGVar()

  private.save = 0;

  private.MGSave();

end;
--*********************************************************************************************************************
function private.MGSave()

  ng_global.progress[ "scr" ][ "win_bomb_scr" ].save = private.save;

end;
--*********************************************************************************************************************
function private.MGLoad()

  private.save = ng_global.progress[ "scr" ][ "win_bomb_scr" ].save;

end;
--*********************************************************************************************************************
function private.MGLoadState()

  local table_mts = {};

  for i = 0, 6 do
    
    table.insert( table_mts, { "anm_bomb_scr_face_"..i, { visible = false } } );

    local lamp_color = 1;

    if ( private.save > i ) then

      lamp_color = 2;

    end;

    table.insert( table_mts, { "anm_bomb_scr_lamp_"..i, { frame = lamp_color } } );
    
  end;

  table.insert( table_mts, { "anm_bomb_scr_face_"..private.save, { visible = true } } );

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.SmileClk( i, num )

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_mg_bomb_clk_sfx", 0, "", 0 );

  if ( not private.cur_smile ) then

    private.cur_smile = num;
    private.cur_i = i;

    common_impl.Lock( true );

    ObjAnimate( "anm_bomb_scr_smile_"..i, "alp", 0, 0, function () common_impl.Lock( false ); end, 
    { 
      0.0, 3, 1, 
      0.3, 3, 0.5,
    });

  elseif ( private.cur_smile == num ) then


    private.cur_smile = nil;

    common_impl.Lock( true );

    ObjAnimate( "anm_bomb_scr_smile_"..i, "alp", 0, 0, function () common_impl.Lock( false ); end, 
    { 
      0.0, 3, 0.5, 
      0.3, 3, 1,
    });

  else

    local func_after = function ()

      local cur_mas_sm = private.clicks_sm[ private.save + 1 ];

      if ( ( private.FindIndex( cur_mas_sm, private.cur_smile ) ~= 0 ) and ( private.FindIndex( cur_mas_sm, num ) ~= 0 ) ) then

        
        if ( private.save > 4 ) then

          private.Win();

        else

          private.RoundWinAnm();
          private.cur_smile = nil;

        end;

      else

        common_impl.Lock( true );
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_mg_bomb_wrong_sfx", 0, "", 0 );
        ObjAnimate( "anm_bomb_scr_smile_"..i, "alp", 0, 0, function () common_impl.Lock( false ); end, 
        { 
          0.0, 3, 0.5, 
          0.3, 3, 1,
        });

        ObjAnimate( "anm_bomb_scr_smile_"..private.cur_i, "alp", 0, 0, "", 
        { 
          0.0, 3, 0.5, 
          0.3, 3, 1,
        });
        
        private.cur_smile = nil;
        private.MGSave();      

      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_mg_bomb_true_sfx", 0, "", 0 );

    ObjAnimate( "anm_bomb_scr_smile_"..i, "alp", 0, 0, func_after, 
    { 
      0.0, 3, 1,
      0.3, 3, 0.5,
    });

  end;

end;
--*********************************************************************************************************************   
function private.RoundWinAnm()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/ad_mg_bomb_cells_sfx", 0, "", 0 );

  local animfunc = function ( num ) 

    ObjAnimate( "anm_bomb_scr_smile_"..num, "alp", 1, 0, "", 
    { 
      0.00, 3, 1,
      0.15, 3, 0,
      0.30, 3, 1, 
      
    });

  end;

  local tmr_func = function ( num ) end;

  tmr_func = function ( num )

    if ( num < 0 ) then

      ObjSet( "tmr_bomb_scr", { playing = true, time = 0.60, endtrig = private.RoundStopAnm } )
      return;

    end;

    animfunc( num );

    ObjSet( "tmr_bomb_scr", { playing = true, time = 0.075, endtrig = function () tmr_func( num - 1 ) end } )

  end;

  tmr_func( 15 );

end;
--*********************************************************************************************************************   
function private.RoundStopAnm()

  private.save = private.save + 1;

  private.MGSave();
  private.InitMG();
  private.MGLoadState();

  local endfunc = function ()

    common_impl.Lock( false );
    
  end;

  for i = 0, 15 do

    local objname = "anm_bomb_scr_smile_"..i;

    local alp = ObjGet( objname ).alp;

    ObjAnimate( objname, "alp", 0, 0, endfunc, 
    { 
      0.0, 3, alp, 
      0.15, 3, 1,
      
    });

    endfunc = "";

  end;

end;
--*********************************************************************************************************************   
function private.SmileMenter( num )

  ObjAttach( "spr_bomb_scr_light_add", "obj_bomb_scr_smile_"..num )
  ObjSet( "spr_bomb_scr_light_add", { visible = true } );
  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.SmileMleave( num )

  ObjSet( "spr_bomb_scr_light_add", { visible = false } );
  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице SS
  
  for i = 1, #arr  do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************