-- name=mg_fridgesafe_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_fridgesafe_scr";
  -----------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------- 
  local table_multiset = {};
  table.insert( table_multiset, { "obj_fridgesafe_scr_button_left", { event_mdown = function() private.ButtonClk( 'left' ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_fridgesafe_scr_button_right", { event_mdown = function() private.ButtonClk( 'right' ); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "spr_fridgesafe_scr_button_up", { event_mdown = function() private.PushSlider(); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end } } );
  table.insert( table_multiset, { "obj_fridgesafe_scr_stethoscope", { event_mdown = function() private.StetClk(); end , event_menter = function () SetCursor( CURSOR_HAND ); end, event_mleave = function () SetCursor( CURSOR_DEFAULT ); end,
  event_dragdrop = function() private.StetDrop() end, event_drag = function() private.StetDrag() end  } } );
      
  ObjMultiSet( table_multiset );
  
  private.fridgesafe_scr_angs = { 6.28,4.71,3.14,1.57,0,-1.57,-3.14,-4.71,-6.28 };
  private.slider_direction = { 1,2,3,4,1,2,3,4,1 };
  -----------------------------------------------------------------------------------
  private.fridgesafe_scr_link =
  {
    {  2,  0,  0,  0 }, --[ [  1 ] ]  
    {  0,  3,  1,  0 }, --[ [  2 ] ]
    {  4,  0,  0,  2 }, --[ [  3 ] ]  
    {  0,  8,  3,  5 }, --[ [  4 ] ]
    {  6,  4,  0,  0 }, --[ [  5 ] ]  
    {  0,  7,  5,  0 }, --[ [  6 ] ] 
    {  0, 14,  8,  6 }, --[ [  7 ] ]  
    {  7,  0,  9,  4 }, --[ [  8 ] ]
    {  8,  0,  0, 10 }, --[ [  9 ] ]  
    {  0,  9, 11,  0 }, --[ [ 10 ] ]
    { 10,  0,  0, 12 }, --[ [ 11 ] ]  
    {  0, 11, 13,  0 }, --[ [ 12 ] ]
    { 12,  0,  0,  0 }, --[ [ 13 ] ]  
    {  0, 16, 15,  7 }, --[ [ 14 ] ]
    { 14,  0,  0,  0 }, --[ [ 15 ] ]  
    {  0,  0, 17, 14 }, --[ [ 16 ] ]
    { 16,  0,  0, 18 }, --[ [ 17 ] ]  
    {  0, 17, 19,  0 }, --[ [ 18 ] ]
    { 18,  0, 24, 20 }, --[ [ 19 ] ]  
    {  0, 19, 21,  0 }, --[ [ 20 ] ]
    { 20,  0,  0, 22 }, --[ [ 21 ] ]  
    {  0, 21, 23,  0 }, --[ [ 22 ] ]
    { 22,  0,  0,  0 }, --[ [ 23 ] ]  
    { 19, 25,  0,  0 }, --[ [ 24 ] ]
    {  0,  0, 26, 24 }, --[ [ 25 ] ]  
    { 25,  0,  0,  0 }  --[ [ 26 ] ]
  };
  -----------------------------------------------------------------------------------------
  private.fridgesafe_scr_point_xy =
  {
    { 180, 110 }, --[[  1 ]]  
    { 390, 110 }, --[[  2 ]]
    { 390, 243 }, --[[  3 ]]  
    { 514, 243 }, --[[  4 ]]
    { 514, 112 }, --[[  5 ]]  
    { 715, 112 }, --[[  6 ]]
    { 715, 413 }, --[[  7 ]]  
    { 514, 413 }, --[[  8 ]]
    { 405, 413 }, --[[  9 ]]  
    { 405, 326 }, --[[ 10 ]]
    { 288, 326 }, --[[ 11 ]]  
    { 288, 214 }, --[[ 12 ]]
    {  95, 214 }, --[[ 13 ]]  
    { 715, 489 }, --[[ 14 ]]
    { 594, 489 }, --[[ 15 ]]  
    { 715, 637 }, --[[ 16 ]]
    { 546, 637 }, --[[ 17 ]]  
    { 546, 548 }, --[[ 18 ]]
    { 372, 548 }, --[[ 19 ]]  
    { 372, 470 }, --[[ 20 ]]
    { 278, 470 }, --[[ 21 ]]  
    { 278, 409 }, --[[ 22 ]]
    {  95, 409 }, --[[ 23 ]]  
    { 238, 548 }, --[[ 24 ]]
    { 238, 608 }, --[[ 25 ]]  
    {  95, 608 }  --[[ 26 ]]
  };
  -----------------------------------------------------------------------------------
  local win_fridgesafe_scr = function ()

    if ( not cmn.IsEventDone( "win_fridgesafe_scr" ) ) then

      ObjSet( "spr_fridgesafe_scr_slider", { pos_x = private.fridgesafe_scr_point_xy[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point ][ 1 ],
                         pos_y = private.fridgesafe_scr_point_xy[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point ][ 2 ],
                         ang = private.fridgesafe_scr_angs[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang ] } );
      ObjSet( "spr_fridgesafe_scr_safe_lock", { ang = private.fridgesafe_scr_angs[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang ] } );

      ObjSet( "obj_fridgesafe_scr_stethoscope", { pos_x = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 1 ],
                          pos_y = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 2 ] } );

      ObjSet( "obj_fridgesafe_scr_stethoscope_dummy", { pos_x = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 1 ],
                              pos_y = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 2 ] } );

      for i = 1, 3 do

        if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ i ] == 1 then

        ObjSet( "spr_fridgesafe_scr_lock_open_"..i, { alp = 1 } );
        ObjSet( "spr_fridgesafe_scr_lock_open_in_"..i, { alp = 1 } );
        ObjSet( "spr_fridgesafe_scr_lock_closed_"..i, { alp = 0 } );
        ObjSet( "spr_fridgesafe_scr_lock_closed_in_"..i, { alp = 0 } );

        end;
      
       end;
  
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fridgesafe_scr", win_fridgesafe_scr, "mg_fridgesafe_scr" );
  --------------------------------------------------------------------------------------------
  -- function win_mg_6_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_6_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_6_big_check_mg_6", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_6" );

  end;

  cmn.AddSubscriber( "win_mg_6_scr", win_mg_6_scr_loc, "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function public.Open() 
  
  ObjSet("obj_int_button_info_impl", { pos_y = -8 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -22 });
  
  if not cmn.IsEventDone( "win_fridgesafe_scr" ) then

    cmn.MiniGameShow();
   
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_fridgesafe_scr" ) ) then
  
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang = 5;
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy = { 540,360 };
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point = 1;
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock = { 0,0,0 };
  
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  ObjSet("obj_int_button_info_impl", { pos_y = -91 });
  ObjSet("obj_int_button_reset_impl", { pos_y = -105 });
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_fridgesafe_scr" ) then

    cmn.MiniGameHide();

  end;
  
end;
--*********************************************************************************************************************
function private.ButtonClk( direction )

  local func_after = function()
  
    private.ButtonClkEnd( direction );
  
  end;
  
  common_impl.Lock( true );
  
  ObjAnimate( "spr_fridgesafe_scr_button_"..direction.."_light", "alp",0,0, func_after,
  { 
    0.0,0,0,
    0.1,0,1,
    0.4,0,1,
    0.5,0,0 
  } );

  local start_ang,end_ang;

  start_ang = private.fridgesafe_scr_angs[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang ];

  if direction == "right" then
  
    end_ang = private.fridgesafe_scr_angs[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang + 1 ];
  
  else
  
    end_ang = private.fridgesafe_scr_angs[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang - 1 ];
  
  end;

  ObjAnimate( "spr_fridgesafe_scr_slider", "ang",0,0, "",
  { 
    0.0,0,start_ang,
    0.1,0,start_ang,
    0.4,0,end_ang 
  } );

  ObjAnimate( "spr_fridgesafe_scr_safe_lock", "ang",0,0, "",
  { 
    0.0,0,start_ang,
    0.1,0,start_ang,
    0.4,0,end_ang 
  } );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_rotate", 0, "", 0 );
    
end;
--*********************************************************************************************************************
function private.ButtonClkEnd( direction )

  common_impl.Lock( false );

  if direction == "right" then
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang + 1;
  else
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang - 1;
  end;

  if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang == 1 or
     ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang == 9 then

    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang = 5;
    ObjSet( "spr_fridgesafe_scr_slider", { ang = 0 } );

  end;

end;
--*********************************************************************************************************************
function private.PushSlider() 
 
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_click_on", 0, "", 0 );
  
  ObjAnimate( "spr_fridgesafe_scr_button_up", "alp",0,0, "",
              { 0.0,0,1,
                0.2,0,0 } );
  ObjAnimate( "spr_fridgesafe_scr_button_down", "alp",0,0, "",
              { 0.0,0,0,
                0.2,0,1 } );

  local direction = private.slider_direction[ ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang ];
  local point_1 = ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point;
  local point_2 = private.fridgesafe_scr_link[ point_1 ][ direction ];

  local time_def = 0.01;
  local time = 0;
  local distance = 0;

  local func_after = function()
  
    private.PushSliderEnd( point_2 );
  
  end;
  
  if point_2 ~= 0 then

    common_impl.Lock( true );

    if direction == 1 or direction == 3 then

      distance = math.abs( private.fridgesafe_scr_point_xy[ point_1 ][ 1 ] - private.fridgesafe_scr_point_xy[ point_2 ][ 1 ] );
      time = distance * time_def;

      if point_2 == 13 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 1 ] == 0 then

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_move", 0, "", 0 );  
        
        ObjAnimate( "spr_fridgesafe_scr_slider", "pos_x",0,0, "",
                    { 0.0, 0,private.fridgesafe_scr_point_xy[ point_1 ][ 1 ],
                      time,0,private.fridgesafe_scr_point_xy[ point_2 ][ 1 ] } );

        ObjAnimate( "spr_fridgesafe_scr_lock_closed_1", "alp",0,0, func_after,
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_1", "alp",0,0, "",
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_1", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_in_1", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );

        ObjSet( "tmr_fridgesafe_scr_opn_lock", { playing = true, time = time, endtrig = function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_open", 0, "", 0 ); end; } );

      elseif point_2 == 23 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 2 ] == 0 then

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_move", 0, "", 0 ); 
        
        ObjAnimate( "spr_fridgesafe_scr_slider", "pos_x",0,0, "",
                    { 0.0, 0,private.fridgesafe_scr_point_xy[ point_1 ][ 1 ],
                      time,0,private.fridgesafe_scr_point_xy[ point_2 ][ 1 ] } );

        ObjAnimate( "spr_fridgesafe_scr_lock_closed_2", "alp",0,0, func_after,
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_2", "alp",0,0, "",
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_2", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_in_2", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );

        ObjSet( "tmr_fridgesafe_scr_opn_lock", { playing = true, time = time, endtrig = function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_open", 0, "", 0 ); end; } );

      elseif point_2 == 26 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 3 ] == 0 then
        
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_move", 0, "", 0 );
        
        ObjAnimate( "spr_fridgesafe_scr_slider", "pos_x",0,0, "",
                    { 0.0, 0,private.fridgesafe_scr_point_xy[ point_1 ][ 1 ],
                      time,0,private.fridgesafe_scr_point_xy[ point_2 ][ 1 ] } );

        ObjAnimate( "spr_fridgesafe_scr_lock_closed_3", "alp",0,0, func_after,
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_3", "alp",0,0, "",
                    { 0.0,     0,1,
                      time,    0,1,
                      time+0.3,0,0 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_3", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );
        ObjAnimate( "spr_fridgesafe_scr_lock_open_in_3", "alp",0,0, "",
                    { 0.0,     0,0,
                      time,    0,0,
                      time+0.3,0,1 } );

        ObjSet( "tmr_fridgesafe_scr_opn_lock", { playing = true, time = time, endtrig = function() common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_open", 0, "", 0 ); end; } );

      else

        ObjAnimate( "spr_fridgesafe_scr_slider", "pos_x",0,0, func_after,
                    { 0.0, 0,private.fridgesafe_scr_point_xy[ point_1 ][ 1 ],
                      time,0,private.fridgesafe_scr_point_xy[ point_2 ][ 1 ] } );

      end;

    else
                    
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_move", 0, "", 0 );
      
      distance = math.abs( private.fridgesafe_scr_point_xy[ point_1 ][ 2 ] - private.fridgesafe_scr_point_xy[ point_2 ][ 2 ] );
      time = distance * time_def;

      ObjAnimate( "spr_fridgesafe_scr_slider", "pos_y",0,0, func_after,
                  { 0.0, 0,private.fridgesafe_scr_point_xy[ point_1 ][ 2 ],
                    time,0,private.fridgesafe_scr_point_xy[ point_2 ][ 2 ] } );

    end;

  else
                  
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_click_off", 0, "", 0 );
    
    ObjAnimate( "spr_fridgesafe_scr_button_up", "alp",0,0, "",
                { 0.0,0,0,
                  0.2,0,1 } );
    ObjAnimate( "spr_fridgesafe_scr_button_down", "alp",0,0, "",
                { 0.0,0,1,
                  0.2,0,0 } );

  end;

end;
--*********************************************************************************************************************
function private.PushSliderEnd( new_point )

  common_impl.Lock( false );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_click_off", 0, "", 0 );
  common_impl.StopAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_move", 0, "", 0 );
  
  ObjAnimate( "spr_fridgesafe_scr_button_up", "alp",0,0, "",
              { 0.0,0,0,
                0.2,0,1 } );
  ObjAnimate( "spr_fridgesafe_scr_button_down", "alp",0,0, "",
              { 0.0,0,1,
                0.2,0,0 } );

  local point = tonumber( new_point );
  
  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point = point;

  if point == 13 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 1 ] == 0 then
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 1 ] = 1;
  elseif point == 23 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 2 ] == 0 then
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 2 ] = 1;
  elseif point == 26 and ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 3 ] == 0 then
    ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 3 ] = 1;
  end;

  if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 1 ] == 1 and
     ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 2 ] == 1 and
     ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 3 ] == 1 then

    private.Win();

  end;

end;
--*********************************************************************************************************************
function private.StetClk()
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_start", 0, "", 0 ); 
  ObjSet( "spr_fridgesafe_scr_stethoscope_1", { alp = 0.4 } );
  ObjSet( "obj_fridgesafe_scr_field", { alp = 1, croprect_init = 1 } );
  SetCursor( CURSOR_NULL );

end;
--*********************************************************************************************************************
function private.StetDrag()

  local delta_x = 105;
  local delta_y = 110;

  local pos = GetObjPosByObj( "obj_fridgesafe_scr_stethoscope", "obj_fridgesafe_scr_field" );  

  local x = pos[1] - delta_x;
  local y = pos[2] - delta_y;

  local x1 = pos[1];
  local y1 = pos[2];

  local width = 220;
  local height = 225;


  if y >= 440 then
    y = 440;
    y1 = 550;
  end;

  ObjSet( "obj_fridgesafe_scr_field", { alp = 1, croprect_x = x, croprect_y = y, croprect_w = width, croprect_h = height } );
  ObjSet( "obj_fridgesafe_scr_stethoscope_dummy", { pos_x = x1, pos_y = y1 } );

  SetCursor( CURSOR_NULL );

end;
--*********************************************************************************************************************
function private.StetDrop()

  local x = ObjGet( "obj_fridgesafe_scr_stethoscope_dummy" ).pos_x;
  local y = ObjGet( "obj_fridgesafe_scr_stethoscope_dummy" ).pos_y;

  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 1 ] = x;
  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy[ 2 ] = y;

  ObjSet( "obj_fridgesafe_scr_field", { alp = 0, croprect_init = 0 } );
  ObjSet( "spr_fridgesafe_scr_stethoscope_1", { alp = 1 } );
  ObjSet( "obj_fridgesafe_scr_stethoscope", { pos_x = x, pos_y = y } );
  SetCursor( CURSOR_DEFAULT );
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_start", 0, "", 0 ); 

end;
--*********************************************************************************************************************
function public.Skip()

  local func_after = function()
  
    private.Win();
    
  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_open", 0, "", 0 ); 
 
  ObjAnimate( "mg_fridgesafe_scr",   "alp",0,0, func_after, { 0.0,0,1, 0.3,0,1 } );
  
  if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 1 ] == 0 then
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_1", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_1", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_1",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_in_1",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
  end;
  
  if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 2 ] == 0 then
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_2", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_2", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_2",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_in_2",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
  end;
  
  if ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock[ 3 ] == 0 then
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_in_3", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_closed_3", "alp",0,0, "", { 0.0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_3",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
    ObjAnimate( "spr_fridgesafe_scr_lock_open_in_3",   "alp",0,0, "", { 0.0,0,0, 0.3,0,1 } );
  end;

end;
--*********************************************************************************************************************
function public.Reset()

  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_ang = 5;
  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].slider_point = 1;
  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].lock = { 0,0,0 };
  ng_global.progress[ "scr" ][ "win_fridgesafe_scr" ].pos_xy = { 540,360 };

  ObjSet( "obj_fridgesafe_scr_stethoscope", { pos_x = 540, pos_y = 360 } );
  ObjSet( "obj_fridgesafe_scr_stethoscope_dummy", { pos_x = 540, pos_y = 360 } );
  ObjSet( "spr_fridgesafe_scr_slider", { pos_x = 180, pos_y = 110, ang = 0 } );

  for i = 1,3 do

    ObjSet( "spr_fridgesafe_scr_lock_closed_"..i, { alp = 1 } );
    ObjSet( "spr_fridgesafe_scr_lock_closed_in_"..i, { alp = 1 } );
    ObjSet( "spr_fridgesafe_scr_lock_open_"..i, { alp = 0 } );
    ObjSet( "spr_fridgesafe_scr_lock_open_in_"..i, { alp = 0 } );

  end;

end;
--*********************************************************************************************************************
function private.Win()

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_fridgesafe_win", 0, "", 0 );   
  common_impl.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_fridgesafe_scr" );
  cmn.CallEventHandler( "win_fridgesafe_scr" );
  cmn.SetEventDone( "win_mg_6_scr" );
  --cmn.CallEventHandler( "win_mg_6_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_fridgesafe_scr_light", "alp",1,0, "",
{ 
  0.0, 0,1,
  2.5, 0,0.4,
  5.0, 0,1 
} );