-- name=mg_gestures_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_gestures_scr";

  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_gestures_scr = function ()

  local effects_table = 
  {
    "anm_gestures_scr_glow",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_gestures_scr", update_performance_mode_gestures_scr, private.room_objname );
  --------------------------------------------------------------------------------------------

  private.signs_name = { { "wire"  , "red"   , "yellow"}, 
                         { "lever" , "blue"  , "white" },
                         { "button", "green" , "brown" }
                       }

  private.signs_state = 0;

  private.book = { { "brown" , "wire", "purpul", "black" , "blue"  , "pedal"  },
                   { "white" , "key" , "sound" , "button", "danger", "lever"  },
                   { "answer", "red" , "green" , "error" , "true"  , "yellow" }  
                 };

  private.book_page = 1;

  private.book_win_counter = 1;

  private.wire = "";

  private.lever = 0;

  private.button = 0;

  local table_multiset = {};

  table.insert( table_multiset, { "obj_gestures_scr_clk_start", { event_mdown = private.StartMg } } );
  table.insert( table_multiset, { "spr_gestures_scr_book_arrow_left", { event_mdown = function() private.ClickBookArrow( "left" ); end } } );
  table.insert( table_multiset, { "spr_gestures_scr_book_arrow_right", { event_mdown = function() private.ClickBookArrow( "right" ); end } } );

  for j = 1, 3 do

    for i = 1, 6 do
      
       table.insert( table_multiset, { "obj_gestures_scr_book_clk_sign_"..j.."_"..i, { event_mdown = function() private.ClickSign( i ); end } } );

    end;

    table.insert( table_multiset, { "spr_gestures_scr_lever_part_"..j,  { event_mdown  = function() private.ClickLever( j ); end,
                                                                      event_menter = function() private.MEventLever( j, CURSOR_HAND ); end,
                                                                      event_mleave = function() private.MEventLever( j, CURSOR_DEFAULT ); end } } );

    table.insert( table_multiset, { "spr_gestures_scr_button_pressed_"..j,  { event_mdown  = function() private.ClickButton( j ); end,
                                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } } );

    table.insert( table_multiset, { "spr_gestures_scr_book_"..j.."_arrow_left",  { event_mdown  = function() private.ClickBookArrow( "left" ); end,
                                                                          event_menter = function() private.BookArrowMEvents( "left", "enter" ); end,
                                                                          event_mleave = function() private.BookArrowMEvents( "left", "leave" ); end } } );

    table.insert( table_multiset, { "spr_gestures_scr_book_"..j.."_arrow_right",  { event_mdown  = function() private.ClickBookArrow( "right" ); end,
                                                                          event_menter = function() private.BookArrowMEvents( "right", "enter" ); end,
                                                                          event_mleave = function() private.BookArrowMEvents( "right", "leave" ); end } } );

  end;

  for i = 1, 5 do
      
     table.insert( table_multiset, { "obj_gestures_scr_wire_"..i.."_input", { event_mdown  = function() private.ClickWire( i ); end,
                                                                          event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                                          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } } );

  end;

  table.insert( table_multiset, { "obj_gestures_scr_wire_red_input", { event_mdown  = function() private.ClickWire( "red" ); end,
                                                                   event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                                   event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } } );

  table.insert( table_multiset, { "obj_gestures_scr_wire_yellow_input", { event_mdown  = function() private.ClickWire( "yellow" ); end,
                                                                      event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
                                                                      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } } );
  
  ObjMultiSet( table_multiset );

  --------------------------------------------------------------------------------------------
  -- function win_gestures_scr () end;
  --------------------------------------------------------------------------------------------
  local win_gestures_scr = function ()

    if ( cmn.IsEventDone( "win_gestures_scr" ) ) then  

      ObjDelete( "gmg_stationhall_gestures_scr" );

    else

      local phase = ng_global.progress[ "scr" ][ "win_gestures_scr" ].phase;
      local table_multiset = {};
      local center_pos = 340;

      private.signs_state = ng_global.progress[ "scr" ][ "win_gestures_scr" ].signs_state;

      table.insert( table_multiset, { "obj_gestures_scr_clk_start", { input = false } } );

      private.SaveSignsAndBook();

      if phase == "shade" then

          center_pos = -340;   

          private.SaveShade();

      end;

      ObjSet( "obj_gestures_scr_center", { pos_x = center_pos }  );    
      
      if  phase ~= "shade" then
  
          --table.insert( table_multiset, { "obj_gestures_scr_"..phase, { input = true } } );

          private.SetBook( false );

          if phase == "wires" then

            private.SaveWires();

          elseif phase == "levers" then

            private.SaveLevers();

          elseif phase == "buttons" then

            private.SaveButtons();

          end;

      end;

      if ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "levers" ] == true then

        table.insert( table_multiset, { "spr_gestures_scr_error", { active = false, visible = false } } );
        table.insert( table_multiset, { "spr_gestures_scr_progress", { alp = 1 } } );
        table.insert( table_multiset, { "obj_gestures_scr_progress_part_1", { alp = 1 } } );
        table.insert( table_multiset, { "obj_gestures_scr_progress_part_2", { alp = 1 } } );  
        table.insert( table_multiset, { "spr_gestures_scr_page_wall_2", { alp = 1 } } );

        table.insert( table_multiset, { "spr_gestures_scr_lever_part_1", { scale_y = 0.7 } } );
        table.insert( table_multiset, { "spr_gestures_scr_lever_part_2", { scale_y = 0.7 } } );
        table.insert( table_multiset, { "spr_gestures_scr_lever_1", { pos_y = 471 } } );  
        table.insert( table_multiset, { "spr_gestures_scr_lever_2", { pos_y = 471 } } );      

      end;

      if ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "wires" ] == true then

        table.insert( table_multiset, { "spr_gestures_scr_wire_red", { alp = 0 } } );
        table.insert( table_multiset, { "spr_gestures_scr_wire_yellow", { alp = 0 } } );
        table.insert( table_multiset, { "spr_gestures_scr_wire_red_yellow", { alp = 1 } } );
        table.insert( table_multiset, { "spr_gestures_scr_page_wall_1", { alp = 1 } } );     

      end;

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_gestures_scr", win_gestures_scr, "mg_gestures_scr" );
  cmn.AddSubscriber( "win_gestures_scr", win_gestures_scr, "rm_stationhall" );
  
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_mg_9_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_9_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_9_big_check_mg_9", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_9" );

  end;

  cmn.AddSubscriber( "win_mg_9_scr", win_mg_9_scr_loc, "rm_mysteryroom" );
  
end;

function private.SaveSignsAndBook()

 
  local table_multiset = {};

  --private.signs_state = ng_global.progress[ "scr" ][ "win_gestures_scr" ].signs_state;

  if private.signs_state == 0 then

      table.insert( table_multiset, { "obj_gestures_scr_clk_start", { input = true } } );

  else

      private.SetBook( true );

      private.book_page = ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_page;

      for i = 1, 3 do

          table.insert( table_multiset, { "obj_gestures_scr_shade_"..i.."_signs", { visible = false } } );
          table.insert( table_multiset, { "spr_gestures_scr_book_page_"..i, { input = false, alp = 0 } } );

          if ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[i][1] ~= "" then

              private.book_win_counter = private.book_win_counter + 1;

              table.insert( table_multiset, { "spr_gestures_scr_shade_"..private.signs_state.."_sign_"..ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[i][1], { alp = 0.3, active = false } } );
            
              local page_number = ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[i][2];
              local obj_number  = ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[i][3];

              table.insert( table_multiset, { "spr_gestures_scr_book_page_"..page_number.."_select_"..obj_number, { alp = 1 } } );
              table.insert( table_multiset, { "obj_gestures_scr_book_clk_sign_"..page_number.."_"..obj_number,    { input = false } } );

              if private.book_win_counter == 4 and ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_anims_done[private.signs_state] == false then

                private.book_win_counter = 1;

                local mmg_name = "wires";
            
                if private.signs_state == 2 then

                  mmg_name = "levers";

                elseif private.signs_state == 3 then

                  mmg_name = "buttons";

                end;

                private.NewPageAnim( mmg_name );

              end;
          
          end;

          table.insert( table_multiset, { "spr_gestures_scr_book_page_"..i, { alp = 0 } } );

      end;

--      for j = 1, #ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs do
--
--        local wrong_page_number = ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs[j][1];
--        local wrong_obj_number  = ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs[j][2];
--
--        table.insert( table_multiset, { "spr_gestures_scr_book_page_"..wrong_page_number.."_wrong_"..wrong_obj_number, { alp = 1 } } );
--        table.insert( table_multiset, { "obj_gestures_scr_book_clk_sign_"..wrong_page_number.."_"..wrong_obj_number,   { input = false } } );
--
--      end;
--
      if ng_global.progress[ "scr" ][ "win_gestures_scr" ].anims_done[private.signs_state] == true then

        table.insert( table_multiset, { "obj_gestures_scr_shade_"..private.signs_state.."_signs", { visible = true } } );

      end;

      --ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[ private.book_win_counter ][1] = result;

      table.insert( table_multiset, { "spr_gestures_scr_book_page_"..private.book_page, { alp = 1, input = true } } );

      ObjMultiSet( table_multiset );

      private.SignsAnim();

  end;       


end;
-----------------------------------------------------------------------------------------------
function private.SaveShade()

   if ng_global.progress[ "scr" ][ "win_gestures_scr" ].anims_done[private.signs_state] == false then

     private.PlayAnims( private.signs_state, 1 );

   else

   end;

end;
-----------------------------------------------------------------------------------------------
function private.SaveWires()

  ObjSet( "spr_gestures_scr_page_wall_1", { alp = 1 } );

   if ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "wires" ] == true then

     ObjSet( "obj_gestures_scr_wires", { input = false } );

     private.Scroll( "right", "shade" );

   else

     ObjSet( "obj_gestures_scr_wires", { input = true } ); 

   end;

end;
-----------------------------------------------------------------------------------------------
function private.SaveLevers()

  ObjSet( "spr_gestures_scr_page_wall_2", { alp = 1 } );

  private.lever = ng_global.progress[ "scr" ][ "win_gestures_scr" ].lever;

  local table_multiset = {};

  if ( private.lever ~= 0 ) then

     table.insert( table_multiset, { "spr_gestures_scr_lever_part_"..private.lever, { scale_y = 0.7  } } );
     table.insert( table_multiset, { "spr_gestures_scr_lever_"..private.lever, { pos_y = 471  } } );

        if private.lever == 1 or private.lever == 2 then

          table.insert( table_multiset, { "spr_gestures_scr_error", { active = false, visible = false } } );
          table.insert( table_multiset, { "spr_gestures_scr_progress", { alp = 1 } } );
          table.insert( table_multiset, { "obj_gestures_scr_progress_part_1", { alp = 1 } } );
    
        end;

  end;

  if #table_multiset ~= 0 then
    ObjMultiSet( table_multiset );
  end;

  if ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "levers" ] == true then

     ObjSet( "obj_gestures_scr_levers", { input = false } );

     private.Scroll( "right", "shade" );

  else

    ObjSet( "obj_gestures_scr_levers", { input = true } );

  end;

end;
-----------------------------------------------------------------------------------------------
function private.SaveButtons()

  ObjSet( "spr_gestures_scr_page_wall_3", { alp = 1 } );

  ObjSet( "obj_gestures_scr_buttons", { input = true } );

end;

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_gestures_scr" ) then

    cmn.MiniGameShow();
   
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_performance_mode_gestures_scr" );
  if ( not cmn.IsEventStart( "win_gestures_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].phase        = "shade";
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].signs_state  = 1;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_page    = 1;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs   = { { "",0,0 }, { "", 0,0 }, { "", 0,0 } };
    --ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs   = { };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].lever        = 0;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].button       = 0;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].anims_done   = { false, false, false };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_anims_done   = { false, false, false };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg = { [ "wires" ] = false, [ "levers" ] = false }

  end;
 
  common_impl.PlayAudio( "env", "common/audio/levelscr/aud_stationhall_env", 1 );  

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_gestures_scr" ) then

    cmn.MiniGameHide();

  end;

  common_impl.StopAudio( "env", "common/audio/levelscr/aud_mg_gesture_env", 0.5 )  
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].phase        = "shade";
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].signs_state  = 1;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_page    = 1;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs   = { { "",0,0 }, { "", 0,0 }, { "", 0,0 } };
    --ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs   = { };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].lever        = 0;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].button       = 0;
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].anims_done   = { false, false, false };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_anims_done   = { false, false, false };
    ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg = { [ "wires" ] = false, [ "levers" ] = false }

  private.signs_state = 0;
  private.book_page = 1;
  private.book_win_counter = 1;
  private.wire = "";
  private.lever = 0;
  private.button = 0;

  local table_multiset = {};

  table.insert( table_multiset, { "obj_gestures_scr_center", { pos_x = -340 } } );

  table.insert( table_multiset, { "spr_gestures_scr_lever_part_1", { scale_y = 1  } } );
  table.insert( table_multiset, { "spr_gestures_scr_lever_1", { pos_y = 442  } } );

  table.insert( table_multiset, { "spr_gestures_scr_lever_part_2", { scale_y = 1  } } );
  table.insert( table_multiset, { "spr_gestures_scr_lever_2", { pos_y = 442  } } );

  table.insert( table_multiset, { "spr_gestures_scr_error", { active = true, visible = true } } );
  table.insert( table_multiset, { "spr_gestures_scr_progress", { alp = 0  } } );

  table.insert( table_multiset, { "obj_gestures_scr_progress_part_1", { alp = 0  } } );
  table.insert( table_multiset, { "obj_gestures_scr_progress_part_2", { alp = 0  } } );

  table.insert( table_multiset, { "spr_gestures_scr_wire_red", { alp = 1 } } );
  table.insert( table_multiset, { "spr_gestures_scr_wire_yellow", { alp = 1 } } );
  table.insert( table_multiset, { "spr_gestures_scr_wire_red_yellow", { alp = 0 } } );

  table.insert( table_multiset, { "spr_gestures_scr_button_right_2", { alp = 0 } } );
  table.insert( table_multiset, { "spr_gestures_scr_button_right_3", { alp = 0 } } );

  table.insert( table_multiset, { "obj_gestures_scr_wires", { input = false } } );
  table.insert( table_multiset, { "obj_gestures_scr_levers", { input = false } } );
  table.insert( table_multiset, { "obj_gestures_scr_buttons", { input = false } } );

  table.insert( table_multiset, { "spr_gestures_scr_book_page_1", { alp = 1, input = true } } );
  table.insert( table_multiset, { "spr_gestures_scr_book_page_2", { alp = 0, input = false } } );
  table.insert( table_multiset, { "spr_gestures_scr_book_page_3", { alp = 0, input = false } } );

  for i = 1, 3 do

    table.insert( table_multiset, { "spr_gestures_scr_page_wall_"..i, { alp = 0 } } );
    table.insert( table_multiset, { "obj_gestures_scr_shade_"..i.."_signs", { visible = false } } );
    table.insert( table_multiset, { "spr_gestures_scr_page_wall_"..i, { alp = 0 } } );

    for j = 1, 3 do

      table.insert( table_multiset, { "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j], { active = false, alp = 0 } } );
      table.insert( table_multiset, { "anm_gestures_scr_shade_anim_"..private.signs_name[i][j], { alp = 0, playing = false } } );

    end;

  end;

  table.insert( table_multiset, { "obj_gestures_scr_shade_1_signs", { visible = true } } );
  table.insert( table_multiset, { "obj_gestures_scr_clk_start", { input = true } } );
  table.insert( table_multiset, { "anm_gestures_scr_shade_state", { alp = 1 } } );

  private.SetBook( false );

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.Skip()

  local table_multiset = {};

  table.insert( table_multiset, { "spr_gestures_scr_page_wall_1", { alp = 1 } } );
  table.insert( table_multiset, { "spr_gestures_scr_page_wall_2", { alp = 1 } } );
  table.insert( table_multiset, { "spr_gestures_scr_page_wall_3", { alp = 1 } } );

  ObjMultiSet( table_multiset );

  local old_coord = ObjGet( "obj_gestures_scr_center" ).pos_x;

  --common_impl.Lock( true );

  if ObjGet( "obj_gestures_scr_center" ).pos_x ~= 340 then

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_display_move", 0, "", 0 );

    ObjAnimate( "obj_gestures_scr_center", "pos_x", 0, 0, private.WinAnim, { 0,0,ObjGet( "obj_gestures_scr_center" ).pos_x, 0.5,0,340 } );

  else

    private.WinAnim();

  end;

end;
--*********************************************************************************************************************
-- function *** WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.WinAnim()

   local func_after_levers = function()

      local func_after = function()

         ObjSet( "spr_gestures_scr_button_right_2", { alp = 1 } );
         ObjSet( "spr_gestures_scr_button_right_3", { alp = 1 } );

         common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_button_right", 0, "", 0 );
      
         common_impl.Lock( false );
  
         private.Win();

      end;

        common_impl.Lock( true );

        local table_multiset = {};

        table.insert( table_multiset, { "spr_gestures_scr_error", { active = false, visible = false } } );
        table.insert( table_multiset, { "spr_gestures_scr_progress", { alp = 1  } } );

        table.insert( table_multiset, { "obj_gestures_scr_progress_part_1", { alp = 1  } } );
        table.insert( table_multiset, { "obj_gestures_scr_progress_part_2", { alp = 1  } } );

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_right", 0, "", 0 );

        ObjMultiSet( table_multiset );

        ObjAnimate( "spr_gestures_scr_button_pressed_2", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1, 0.5,0,0 } );
        ObjAnimate( "spr_gestures_scr_button_pressed_3", "alp", 0, 0, "", { 0,0,0, 0.3,0,1, 0.5,0,0 } );

   end;

   local func_after_wires = function()

     common_impl.Lock( true );

     common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_down", 0, "", 0 );

     ObjAnimate( "spr_gestures_scr_lever_part_1", "scale_y", 0, 0, func_after_levers, { 0,0,ObjGet( "spr_gestures_scr_lever_part_1" ).scale_y, 0.3,0,0.7 } );
     ObjAnimate( "spr_gestures_scr_lever_part_2", "scale_y", 0, 0, "", { 0,0,ObjGet( "spr_gestures_scr_lever_part_1" ).scale_y, 0.3,0,0.7 } );

     ObjAnimate( "spr_gestures_scr_lever_1", "pos_y", 0, 0, "", { 0,0,ObjGet( "spr_gestures_scr_lever_1" ).pos_y, 0.3,0,471 } );
     ObjAnimate( "spr_gestures_scr_lever_2", "pos_y", 0, 0, "", { 0,0,ObjGet( "spr_gestures_scr_lever_2" ).pos_y, 0.3,0,471 } );

   end;

   if ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "wires" ] ~= true then

     common_impl.Lock( true );

     common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_wire_right", 0, "", 0 );

     ObjAnimate( "spr_gestures_scr_wire_red", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
     ObjAnimate( "spr_gestures_scr_wire_yellow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
     ObjAnimate( "spr_gestures_scr_wire_red_yellow", "alp", 0, 0, func_after_wires, { 0,0,0, 0.3,0,1 } );

   elseif ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "levers" ] ~= true then

     func_after_wires();

   else

     func_after_levers();

   end;

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_gestures_scr" );
  cmn.CallEventHandler( "win_gestures_scr" );
  cmn.SetEventDone( "win_mg_9_scr" );
  --cmn.CallEventHandler( "win_mg_9_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( false );

  private.WinEnd();

  --TimerStart( "tmr_gestures_scr_win", private.WinEnd, 1.0 );

end;
--*********************************************************************************************************************
function private.StartMg()

  private.PlayAnims( 1, 1 );  

  ObjSet( "obj_gestures_scr_clk_start", { input = false } );

end;
--*********************************************************************************************************************
-- function *** SHADE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.PlayAnims( groupe, i )

  local func_after = function()

    ObjSet( "anm_gestures_scr_shade_anim_"..private.signs_name[groupe][i], { alp = 0 } );

    if i ~= 3 then

      private.PlayAnims( groupe, i + 1 );    

    else

      common_impl.Lock( false );

      ObjSet( "anm_gestures_scr_shade_state", { alp = 1 } );

      ObjSet( "obj_gestures_scr_shade_"..private.signs_state.."_signs", { visible = true } );

      local index = private.signs_state;

      if private.signs_state == 0 then
    
        index = 1;

      end;
      
      ng_global.progress[ "scr" ][ "win_gestures_scr" ].anims_done[index] = true;   

      for j = 1, 3 do

        ObjSet( "spr_gestures_scr_shade_"..groupe.."_sign_"..private.signs_name[groupe][j], { active = true } );

      end;   

      private.ShowSigns( groupe );

      private.SetBook( true );

    end;
    

  end;

  common_impl.Lock( true );

  ObjSet( "anm_gestures_scr_shade_anim_"..private.signs_name[groupe][i], { alp = 1 } );
  ObjSet( "anm_gestures_scr_shade_state", { alp = 0 } );

  AnimPlay( "anm_gestures_scr_shade_anim_"..private.signs_name[groupe][i], "DoAnim", func_after );  


end;
--*********************************************************************************************************************
-- function *** SIGNS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ShowSigns( groupe )


   local func_after = function()
   

     common_impl.Lock( false );

     private.SignsAnim();

     private.SetBook( true );

     private.signs_state = groupe;

   end;
 
   common_impl.Lock( true );

   common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_show_signs", 0, "", 0 );
   
   for i = 1, 3 do

      ObjAnimate( "spr_gestures_scr_shade_"..groupe.."_sign_"..private.signs_name[groupe][i], "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

   end;

   ObjSet( "tmr_gestures_scr_show_sings", { playing = true, time = 0.3, endtrig = func_after } );

  -- ObjAnimate( "spr_gestures_scr_shade_"..groupe.."_sign_"..private.signs_name[groupe][3], "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
  --
end;
--*********************************************************************************************************************
function private.SignsAnim()

  for i = 1, 3 do

    for j = 1, 3 do

      local params = ObjGet( "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j] );

      local random = math.random( 1, 5 );

      local tme = 0.005*random;

      local ang = -0.012;

      if j == 2 then

        ang = 0.012;

      end;

      if i == 2 and private.signs_name[i][j] == "blue" then

        ObjAnimate( "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j], "ang", 0, 0, "",    { 0,0,params.ang, ( 1.5 + tme ),0,( params.ang + ang*random ), ( 3.0 + tme ),0,params.ang } );
      
      else

        ObjAnimate( "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j], "ang", 0, 0, "",    { 0,0,params.ang, ( 1.5 + tme ),0,( ang*random ), ( 3.0 + tme ),0,params.ang } );
      
      end;
      
      ObjAnimate( "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j], "alp", 0, 0, "",    { 0,0,params.alp, ( 0.7 + tme),0,( 0.3 ), ( 1.4 + tme ),0,1, ( 2.1 + tme ),0,0.7, ( 3.0 + tme ),0,params.alp } );
      ObjAnimate( "spr_gestures_scr_shade_"..i.."_sign_"..private.signs_name[i][j], "pos_xy", 0, 0, private.SignsAnim, { 0,0,params.pos_x, params.pos_y,
                                                                                                                   ( 1.0 + tme ),0, params.pos_x , ( params.pos_y - 2*random),
                                                                                                                   ( 2.0 + tme ),0, params.pos_x , ( params.pos_y + 2*random),
                                                                                                                   ( 3.0 + tme ),0, params.pos_x ,   params.pos_y } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.CheckSign( number )

   local check = "";

   for i = 1, 3 do

      if number and private.book[ private.book_page ][ number ] == private.signs_name[ private.signs_state ][i] then

        check = private.signs_name[ private.signs_state ][i];
        break;

      end; 

   end;
  
   return check;

end;
--*********************************************************************************************************************
-- function *** BOOK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.BookArrowMEvents( type, event )

  if event == "enter" then

    common_impl.SetCursor( CURSOR_HAND );

    ObjSet( "spr_gestures_scr_book_"..private.book_page.."_arrow_"..type.."_focus", { alp = 1 } );


  elseif event == "leave" then

    common_impl.SetCursor( CURSOR_DEFAULT );

    ObjSet( "spr_gestures_scr_book_"..private.book_page.."_arrow_"..type.."_focus", { alp = 0 } );

  end;


end;
--*********************************************************************************************************************
function private.ClickBookArrow( type )

  local difference = 1;

  if type == "left" then

    difference = -1;

  end;

  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "spr_gestures_scr_book_"..private.book_page.."_arrow_"..type.."_press", { alp = 0 } );

    ObjSet( "spr_gestures_scr_book_page_"..( private.book_page )             , { input = false } );
    ObjSet( "spr_gestures_scr_book_page_"..( private.book_page + difference ), { input = true  } );

    private.book_page = private.book_page + difference;

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_page = private.book_page;

  end;

  common_impl.Lock( true );

  ObjSet( "spr_gestures_scr_book_"..private.book_page.."_arrow_"..type.."_press", { alp = 1 } );

  ObjAnimate( "spr_gestures_scr_book_page_"..private.book_page, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_gestures_scr_book_page_"..( private.book_page + difference ), "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  local rand = math.random( 1, 3 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_"..rand, 0, "", 0 );

end;
--*********************************************************************************************************************
function private.ClickSign( number )

  local result = private.CheckSign( number );

  local func_after = function( mode )

     common_impl.Lock( false );       

     if mode ~= "wrong" then

       ObjSet( "spr_gestures_scr_shade_"..private.signs_state.."_sign_"..result, { active = false, alp = 0.3 } );

       ObjSet( "obj_gestures_scr_book_clk_sign_"..private.book_page.."_"..number, { input = false } );

       ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[ private.book_win_counter ][1] = result;
       ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[ private.book_win_counter ][2] = private.book_page; 
       ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs[ private.book_win_counter ][3] = number;
    
       private.book_win_counter = private.book_win_counter + 1; 

         if private.book_win_counter == 4 then

            private.book_win_counter = 1;

            --ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs   = { { "",0,0 }, { "", 0,0 }, { "", 0,0 } };

            private.SetBook( false );

            local mmg_name = "wires";
        
            if private.signs_state == 2 then

              mmg_name = "levers";

            elseif private.signs_state == 3 then

              mmg_name = "buttons";

            end;

            private.NewPageAnim( mmg_name );

       else
                   
       end;

     else

       --table.insert( ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs, { private.book_page, number }  );

     end;

  end;

  common_impl.Lock( true );

  if result ~= "" then

     common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_click_right", 0, "", 0 );
        
     ObjAnimate( "spr_gestures_scr_book_page_"..private.book_page.."_select_"..number, "alp", 0, 0, function() func_after( "right" ); end, { 0,0,0, 0.3,0,1 } );

  else

     common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_click_wrong", 0, "", 0 );

     ObjAnimate( "spr_gestures_scr_book_page_"..private.book_page.."_wrong_"..number, "alp", 0, 0, function() func_after( "wrong" ); end, { 0,0,0, 0.1,0,1, 0.2,0,0, 0.3,0,1, 0.4,0,0 } );

  end;  

end;
--*********************************************************************************************************************
function private.NewPageAnim( mmg_name )

  local func_after = function()

    common_impl.Lock( false );

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_anims_done[private.signs_state] = true;

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_signs   = { { "",0,0 }, { "", 0,0 }, { "", 0,0 } };

--    for i = 1, #ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs do
--
--      table.remove( ng_global.progress[ "scr" ][ "win_gestures_scr" ].book_wrong_signs );
--
--    end;

    local rand = math.random( 1, 3 );

    common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_"..rand, 0, "", 0 );

    ObjAnimate( "spr_gestures_scr_book_page_"..private.book_page, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

    private.Scroll( "left", mmg_name );

    private.SetBook( false );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_new_page", 0, "", 0 );

  local rand = math.random( 1, 3 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_"..rand, 0, "", 0 );

  ObjAnimate( "spr_gestures_scr_book_page_"..private.book_page, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

  ObjAnimate( "spr_gestures_scr_book_new_page_"..private.signs_state.."_"..private.signs_name[private.signs_state][1], "alp", 0, 0, "", { 0,0,0, 0.3,0,0, 0.6,0,1 } );
  ObjAnimate( "spr_gestures_scr_book_new_page_"..private.signs_state.."_"..private.signs_name[private.signs_state][2], "alp", 0, 0, "", { 0,0,0, 1.0,0,0, 1.3,0,1 } );
  ObjAnimate( "spr_gestures_scr_book_new_page_"..private.signs_state.."_"..private.signs_name[private.signs_state][3], "alp", 0, 0, "", { 0,0,0, 1.7,0,0, 2.1,0,1 } );

  ObjAnimate( "obj_gestures_scr_book_new_page_"..private.signs_state, "alp", 0, 0, "", { 0,0,1, 2.3,0,1, 2.6,0,0 } );
  ObjAnimate( "spr_gestures_scr_page_wall_"..private.signs_state, "alp", 0, 0, func_after, { 0,0,0, 2.3,0,0, 2.6,0,1 } );

end;
--*********************************************************************************************************************
function private.SetBook( input )

  for i = 1, 3 do

    for j = 1, 6 do

      ObjSet( "obj_gestures_scr_book_clk_sign_"..i.."_"..j, { input = true } );
      ObjSet( "spr_gestures_scr_book_page_"..i.."_select_"..j, { alp = 0 } );
      ObjSet( "spr_gestures_scr_book_page_"..i.."_wrong_"..j, { alp = 0 } );

    end;

  end;

  ObjSet( "obj_gestures_scr_book", { input = input } );

end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Scroll( type, mmg_name )

  local func_after = function()

    common_impl.Lock( false );

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].phase = mmg_name;

    if mmg_name ~= "shade" then

      ObjSet( "obj_gestures_scr_"..mmg_name, { input = true } );

    else

      ObjSet( "obj_gestures_scr_shade_"..private.signs_state.."_signs", { visible = false } );

      private.signs_state = private.signs_state + 1;

      ng_global.progress[ "scr" ][ "win_gestures_scr" ].signs_state = private.signs_state;
  
      for i = 1, 3 do

        for j = 1, 3 do

          ObjSet( "spr_gestures_scr_book_page_"..i.."_select_"..j, { alp = 0 } );

        end;

      end;
    
      private.PlayAnims( private.signs_state, 1 );

    end;

  end;

    common_impl.Lock( true );

    local old_coord = ObjGet( "obj_gestures_scr_center" ).pos_x;

    local new_coord = 340;

    if type == "right" then

      new_coord = -340;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_display_move", 0, "", 0 );

    ObjAnimate( "obj_gestures_scr_center", "pos_x", 0, 0, func_after, { 0,0,old_coord, 1.5,0,new_coord } );
  
    if mmg_name == "shade" then

      ObjSet( "obj_gestures_scr_shade_"..private.signs_state.."_signs", { visible = false } );

    end;
    
end;
--*********************************************************************************************************************
function private.ClickWire( name )
 
  local alpha = ObjGet( "spr_gestures_scr_wire_"..name.."_focus" ).alp;

  ObjSet( "spr_gestures_scr_wire_"..name.."_focus", { alp = 1 - alpha } );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_click_wire", 0, "", 0 );

     if private.wire == "" then

       private.wire = name;
      
     else

       ObjSet( "spr_gestures_scr_wire_"..private.wire.."_focus", { alp = 0 } );
       ObjSet( "spr_gestures_scr_wire_"..name.."_focus", { alp = 0 } );

       if ( private.wire == "red" and name == "yellow" ) or 
          ( private.wire == "yellow" and name == "red" ) then


            local func_after = function()

               common_impl.Lock( false );  

               ObjSet( "obj_gestures_scr_wires", { input = false } ); 

               ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "wires" ] = true;

               private.Scroll( "right", "shade" );         

            end;

            common_impl.Lock( true );

            common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_wire_right", 0, "", 0 );

            ObjAnimate( "spr_gestures_scr_wire_red", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
            ObjAnimate( "spr_gestures_scr_wire_yellow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
            ObjAnimate( "spr_gestures_scr_wire_red_yellow", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );


       else
      
          if name ~=  private.wire then

            common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_wire_wrong", 0, "", 0 );

            ObjSet( "anm_gestures_scr_wrong_wire_"..name, { active = true, visible = true } );
            ObjSet( "anm_gestures_scr_wrong_wire_"..private.wire, { active = true, visible = true } );
      
            AnimPlay( "anm_gestures_scr_wrong_wire_"..name, "DoAnim", "" );
            AnimPlay( "anm_gestures_scr_wrong_wire_"..private.wire, "DoAnim", "" );

          end;

          private.wire = "";

       end; 
         

     end;
   
end;
--*********************************************************************************************************************
function private.MEventLever( number, cursor )

  local alpha = ObjGet( "spr_gestures_scr_lever_"..number.."_focus" ).alp;

  ObjSet( "spr_gestures_scr_lever_"..number.."_focus", { alp = 1 - alpha } );

  common_impl.SetCursor( cursor );

end;
--*********************************************************************************************************************
function private.ClickLever( number )

   if private.lever == 0 then

      private.lever = number;

      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_down", 0, "", 0 );

      ObjSet( "spr_gestures_scr_lever_part_"..number, { scale_y = 0.7 } );
      ObjSet( "spr_gestures_scr_lever_"..number, { pos_y = 471 } );

      if number == 1 or number == 2 then

        ObjSet( "spr_gestures_scr_error", { active = false, visible = false } );
        ObjSet( "spr_gestures_scr_progress", { alp = 1 } );
        ObjSet( "obj_gestures_scr_progress_part_1", { alp = 1 } );

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_right", 0, "", 0 )
  
      end;
    
   else

      if private.lever == 3 - number then
        
        ObjSet( "spr_gestures_scr_lever_part_"..number, { scale_y = 0.7 } );
        ObjSet( "spr_gestures_scr_lever_"..number, { pos_y = 471 } );

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_down", 0, "", 0 )

        ObjSet( "obj_gestures_scr_levers", { input = false } ); 

        ObjSet( "obj_gestures_scr_progress_part_2", { alp = 1 } );
  
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_right", 0, "", 0 )

        ng_global.progress[ "scr" ][ "win_gestures_scr" ].win_mmg[ "levers" ] = true;

        private.Scroll( "right", "shade" );    

      else

        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_lever_up", 0, "", 0 )

        ObjSet( "spr_gestures_scr_lever_part_"..number, { scale_y = 1 } );
        ObjSet( "spr_gestures_scr_lever_"..number, { pos_y = 442 } );

        ObjSet( "spr_gestures_scr_lever_part_"..private.lever, { scale_y = 1 } );
        ObjSet( "spr_gestures_scr_lever_"..private.lever, { pos_y = 442 } );

        ObjSet( "spr_gestures_scr_error", { active = true, visible = true } );
        ObjSet( "spr_gestures_scr_progress", { alp = 0 } );
        ObjSet( "obj_gestures_scr_progress_part_1", { alp = 0 } );
        ObjSet( "obj_gestures_scr_progress_part_2", { alp = 0 } );

        private.lever = 0;

      end;
  
   end;

    ng_global.progress[ "scr" ][ "win_gestures_scr" ].lever = private.lever;

end;
--*********************************************************************************************************************
function private.ClickButton( number )

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_click_button", 0, "", 0 );

  if private.button == 0 then
 
     local func_after_1 = function()

         common_impl.Lock( false );
  
         if number == 2 or number == 3 then

           common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_button_right", 0, "", 0 );

         end;
       
         ObjSet( "spr_gestures_scr_button_right_"..number, { alp = 1 } );

         if number == 1 then

           private.button = 0;

         else

           private.button = number;

         end;

     end;

     common_impl.Lock( true );

     ObjAnimate( "spr_gestures_scr_button_pressed_"..number, "alp", 0, 0, func_after_1, { 0,0,0, 0.1,0,1, 0.2,0,0 } );
    
   else

     if private.button == 5 - number then

       local func_after_2 = function()

         common_impl.Lock( false );

         common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_button_right", 0, "", 0 );

         ObjSet( "spr_gestures_scr_button_right_"..number, { alp = 1 } );
         ObjSet( "obj_gestures_scr_buttons", { input = false } ); 
         private.Win();

       end;

       common_impl.Lock( true );

       ObjAnimate( "spr_gestures_scr_button_pressed_"..number, "alp", 0, 0, func_after_2, { 0,0,0, 0.1,0,1, 0.2,0,0 } );

     else

        local func_after_3 = function()

          common_impl.Lock( false );

          common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_gesture_button_wrong", 0, "", 0 );

          ObjSet( "spr_gestures_scr_button_pressed_"..number, { alp = 0 } );
          ObjSet( "spr_gestures_scr_button_right_"..number, { alp = 0 } );

          ObjSet( "spr_gestures_scr_button_pressed_".. private.button, { alp = 0 } );
          ObjSet( "spr_gestures_scr_button_right_".. private.button, { alp = 0 } );
        
          private.button = 0;

        end;

        common_impl.Lock( true );

        ObjAnimate( "spr_gestures_scr_button_pressed_"..number, "alp", 0, 0, func_after_3, { 0,0,0, 0.1,0,1, 0.2,0,0 } );

     end;
  
   end;

   ng_global.progress[ "scr" ][ "win_gestures_scr" ].button = private.button;

end;
----------------------------------------------------------------------------------------------
ObjAnimate( "spr_gestures_scr_error", "alp", 1, 0, "", { 0,0,1, 0.5,0,1, 1,0,0, 1.5,0,1 } );