-- name=mg_mask_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_mask_scr";
  --------------------------------------------------------------------------------------------
  -- function win_mg_1_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_2_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_2_big_check_mg_2", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_2" );

  end;

  cmn.AddSubscriber( "win_mg_2_scr", win_mg_2_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_mask_scr () end;
  --------------------------------------------------------------------------------------------
  local win_mask_scr = function ()

  if ( cmn.IsEventDone( "win_mask_scr" ) ) then  

  else

    private.MGLoad();
    private.MGLoadState();

  end;

  end;

  cmn.AddSubscriber( "win_mask_scr", win_mask_scr, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  private.InitMG();

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_mask_scr" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_mask_scr" ) ) then

    private.InitMGVar();
    private.MGLoadState();

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_mask_scr" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  private.InitMGVar();
  private.MGLoadState();

end;
--*********************************************************************************************************************
function public.Skip()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_roulete_s_win", 0, "", 0 );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mask_scr" );
  cmn.CallEventHandler( "win_mask_scr" );
  cmn.SetEventDone( "win_mg_2_scr" );
  --cmn.CallEventHandler( "win_mg_2_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************
function private.InitMG()

  local table_mts = {};
    
  local radius = 135;
  
  for j = 1, 8 do
    
    local ang = 6.28/8*j;

    table.insert( table_mts, { "spr_mask_scr_pic"..j, 
    {  

      event_mdown = function ()  private.ButtonClk( j ) end,
      event_menter = function () private.ButtonMenter( j ) end,
      event_mleave = function () private.ButtonMleave( j ) end,
      pos_x = radius*math.cos( ang ),
      pos_y = radius*math.sin( ang ),
      ang =  - ang + 1.57,

    } } );

  end;

  for j = 1, 2 do

    table.insert( table_mts, { "spr_mask_scr_rot_"..j, 
    {  

      event_mdown =  function () private.ButtonRtClk( j ) end,
      event_menter = function () private.ButtonRtMenter( j ) end,
      event_mleave = function () private.ButtonRtMleave( j ) end,

    } } );

  end;  

  for j = 1, 3 do

    table.insert( table_mts, { "spr_mask_scr_button_"..j, 
    {  

      event_mdown =  function () private.ButtonClk( j ) end,
      event_menter = function () private.ButtonMenter( j ) end,
      event_mleave = function () private.ButtonMleave( j ) end,

    } } );

  end;

  ObjMultiSet( table_mts );

  private.pics = { 2, 3, 4, 5, 6, 7, 8, 1 };

end;
--*********************************************************************************************************************
function private.InitMGVar()

  private.save = { false, false, false, 0 };

  private.MGSave();

end;
--*********************************************************************************************************************
function private.MGSave()

  ng_global.progress[ "scr" ][ "win_mask_scr" ].save = {};

  for i = 1, #private.save do
  
    ng_global.progress[ "scr" ][ "win_mask_scr" ].save[ i ] = private.save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoad()

  private.save = {};

  for i = 1, #ng_global.progress[ "scr" ][ "win_mask_scr" ].save do
  
    private.save[ i ] = ng_global.progress[ "scr" ][ "win_mask_scr" ].save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoadState()

  local mas_mask = { 1, 4, 7 };

  local table_mts = {};

  for j = 1, 8 do

    table.insert( table_mts, { "spr_mask_scr_pic"..j, 
    {  
      scale_x = 0.9,
      scale_y = 0.9,
    } } );

  end;

  for i = 1, #private.save - 1 do
    
    local state = not private.save[ i ];

    table.insert( table_mts, { "spr_mask_std_pic"..mas_mask[ i ], { visible = state } } );
    table.insert( table_mts, { "spr_mask_scr_button_"..i, { input = state } } );    

  end;

  table.insert( table_mts, { "obj_mask_scr_pics", { ang = private.save[ 4 ]*6.28/8 } } );

  local cur_mask = private.pics[ private.save[ 4 ] + 1 ];

  ObjAttach( "spr_mask_scr_pic"..cur_mask, ObjGetRelations( "spr_mask_scr_pic"..cur_mask ).parent );

  table.insert( table_mts, { "spr_mask_scr_pic"..cur_mask, { scale_x = 1.2, scale_y = 1.2 } } );

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.CheckWin()

  for i = 1, #private.save - 1 do

    if ( private.save[ i ] ~= true ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClk( num )

  local mas_mask = { 1, 4, 7 };

  local sektor = private.save[ 4 ];

  local cur_mask = private.pics[ sektor + 1 ];

  if ( cur_mask == mas_mask[ num ] ) then

    local endfunc = function ()

      common_impl.Lock( false );
      
      private.save[ num ] = true;

      ObjMultiSet({ 
  
        { "spr_mask_std_pic"..cur_mask, { visible = false }},
        { "spr_mask_scr_button_"..num, { input = false } },

      });
  
      if ( private.CheckWin() ) then

        private.Win();
        

      else

        private.MGSave();

      end; 

    end;
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_roulete_s_move", 0, "", 0 );

    ObjAnimate( "spr_mask_std_pic"..cur_mask, "pos_y", 0, 1, endfunc, 
    { 

      0.0, 3, 0,
      0.7, 3, -125,

    });

  else

    --snd;

  end;

  ObjAnimate( "spr_mask_scr_light_button_"..num, "alp", 0, 0, "", 
  { 
    0.00, 3, 1, 
    0.15, 3, 0,
    0.30, 3, 1,
  });

end;
--*********************************************************************************************************************
function private.ButtonRtClk( turn )

  local sektor = private.save[ 4 ];

  local func_after_scale = function ()

    local start_sektor = sektor;

    if ( turn == 2 ) then

      sektor = sektor - 4;
      common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_roulete_s_rotateshort", 0, "", 0 );

    else

      common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_roulete_s_rotatelong", 0, "", 0 );
      sektor = sektor + 5;

    end;

    local start_ang = start_sektor*6.28/8;
    local ang = sektor*6.28/8;

    local time = 0.2*math.abs( ang - start_ang );

    if ( sektor > 7 ) then

      sektor = sektor - 8;

    end;

    if ( sektor < 0 ) then

      sektor = sektor + 8;

    end;

    private.save[ 4 ] = sektor;

    local endfunc = function ()

      private.MGSave();

      ObjAttach(
       "spr_mask_scr_pic"..private.pics[ sektor + 1 ], 
       ObjGetRelations( "spr_mask_scr_pic"..private.pics[ sektor + 1 ] ).parent );

      ObjAnimate( "spr_mask_scr_pic"..private.pics[ sektor + 1 ], "scale_xy", 0, 0, function () common_impl.Lock( false ); end, 
      { 
        0.0, 3, 0.9, 0.9,
        0.3, 3, 1.2, 1.2,
      });

    end;

    ObjAnimate( "obj_mask_scr_pics", "ang", 0, 0, endfunc, 
    { 

      0.0, 3, start_ang, 
      time, 3, ang,
      
    });

  end;

  ObjAnimate( "spr_mask_scr_pic"..private.pics[ sektor + 1 ], "scale_xy", 0, 0, func_after_scale, 
  { 
    0.0, 3, 1.2, 1.2,
    0.3, 3, 0.9, 0.9,
  });

  common_impl.Lock( true );

  ObjAnimate( "spr_mask_scr_rot_"..turn, "alp", 0, 0, endfunc, 
  { 
    0.00, 3, 1, 
    0.15, 3, 0,
    0.30, 3, 1,
  });

end;
 --*********************************************************************************************************************   
function private.ButtonMenter()

  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ButtonMleave()

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
 --*********************************************************************************************************************   
function private.ButtonRtMenter()

  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ButtonRtMleave()

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************