-- name=mg_route_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_route_scr";
  --------------------------------------------------------------------------------------------
  -- function win_mg_1_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_1_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_1_big_check_mg_1", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_1" );

  end;

  cmn.AddSubscriber( "win_mg_1_scr", win_mg_1_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_route_scr () end;
  --------------------------------------------------------------------------------------------
  local win_route_scr = function ()

  if ( cmn.IsEventDone( "win_route_scr" ) ) then  
    
  else

    private.MGLoad();
    private.MGLoadState();

  end;

  end;

  cmn.AddSubscriber( "win_route_scr", win_route_scr, private.room_objname );
  ----------------------------------------------------------------------------------------------
  private.InitMG();

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_route_scr" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_route_scr" ) ) then
    
    ng_global.progress[ "scr" ][ "win_mg_1_scr" ].start = true;
    private.InitMGVar();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_route_scr" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  private.ResetTrain();
  private.InitMGVar();
  private.MGLoadState();

end;
--*********************************************************************************************************************
function private.ResetTrain()

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/3routeresetbutton", 0, "", 0 );

  ObjMultiSet({ 

    { "spr_route_scr_reset_over", { alp = 0, input = false } },
    { "obj_route_scr_buttons", { input = true } },
    { "obj_route_scr_try", { input = true } },
    { "obj_route_scr_train", { pos_x = 230, pos_y = 477 } },
    { "spr_route_scr_train", { alp = 1 } },
    { "spr_route_scr_train2", { alp = 0 } },
    { "spr_route_scr_try_off", { alp = 1 } },
    { "spr_route_scr_try_on", { alp = 0 } },

  });

end;
--*********************************************************************************************************************
function public.Skip()

  private.save = { 10, 5, 15, 5, 20, 0 };
  private.MGLoadState();
  private.TryClk();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_route_scr" );
  cmn.CallEventHandler( "win_route_scr" );
  cmn.SetEventDone( "win_mg_1_scr" );
  --cmn.CallEventHandler( "win_mg_1_scr" );
  
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************
function private.InitMG()

  local table_mts = {};
    
  for i = 1, 5 do

    for j = 1, 2 do

      table.insert( table_mts, { "spr_route_scr_button_"..i.."_"..j, 
      {  

        event_mdown = function ()  private.ButtonClk( i, j ) end,
        event_menter = function () private.ButtonMenter( i, j ) end,
        event_mleave = function () private.ButtonMleave( i, j ) end,

      } } );

    end;  

  end;
  
  table.insert( table_mts, { "spr_route_scr_try_off", 
  {
    
    event_mdown = private.TryClk,
    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end,
  } } );

  table.insert( table_mts, { "spr_route_scr_reset_over", 
  {
    
    event_mdown = private.ResetTrain,
    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end,

  } } );

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.InitMGVar()

  private.save = { 5, 5, 5, 5, 5, 30 };

  private.MGSave();

end;
--*********************************************************************************************************************
function private.MGSave()

  ng_global.progress[ "scr" ][ "win_route_scr" ].save = {};

  for i = 1, #private.save do
  
    ng_global.progress[ "scr" ][ "win_route_scr" ].save[ i ] = private.save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoad()

  private.save = {};

  for i = 1, #ng_global.progress[ "scr" ][ "win_route_scr" ].save do
  
    private.save[ i ] = ng_global.progress[ "scr" ][ "win_route_scr" ].save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoadState()

  table_mts = {};

  for i = 1, #private.save do
    
    local num_i_1 = math.floor ( private.save[ i ]/ 10 );
    local num_i_2 = math.fmod  ( private.save[ i ], 10 );

    local res_i_1 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_i_1;
    local res_i_2 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_i_2;

    table.insert( table_mts, { "spr_route_scr_digit_"..i.."_1", { res = res_i_1 } } );
    table.insert( table_mts, { "spr_route_scr_digit_"..i.."_2", { res = res_i_2 } } );

  end;

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.ButtonClk( i, j )

  if ( j == 1 ) then

    if ( private.save[ i ] > 5 ) then

      private.save[ 6 ] =  private.save[ 6 ] + 5;
      private.save[ i ] =  private.save[ i ] - 5;

    else
    
      return;

    end;

  else

   if ( private.save[ 6 ]~= 0 ) then

     private.save[ 6 ] =  private.save[ 6 ] - 5;
     private.save[ i ] =  private.save[ i ] + 5;
    
   else

    return;

   end;

  end; 
  
  local num_i_1 = math.floor ( private.save[ i ]/ 10 );
  local num_i_2 = math.fmod  ( private.save[ i ], 10 );
  local num_6_1 = math.floor ( private.save[ 6 ]/ 10 );
  local num_6_2 = math.fmod  ( private.save[ 6 ], 10 );

  local res_i_1 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_i_1;
  local res_i_2 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_i_2;
  local res_6_1 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_6_1;
  local res_6_2 = "assets/levels/levelscr/mg_route_scr/layers/digit_"..num_6_2;

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/3routebutton", 0, "", 0 );

  ObjMultiSet({ 

    { "spr_route_scr_digit_"..i.."_1", {  res = res_i_1 }},
    { "spr_route_scr_digit_"..i.."_2", { res = res_i_2 }},
    { "spr_route_scr_digit_6_1", { res = res_6_1 }},
    { "spr_route_scr_digit_6_2", { res = res_6_2 }},

  });

  private.MGSave();

end;
 --*********************************************************************************************************************   
function private.ButtonMenter( i, j )

  ObjSet( "spr_route_scr_button_"..i.."_"..j, { alp = 1 } );
  
  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ButtonMleave( i, j )

  ObjSet( "spr_route_scr_button_"..i.."_"..j, { alp = 0 } );

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.TryClk()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/3routecoach", 1, "", 0 );

  if ( not private.trainState or private.trainState > 1 ) then

    private.trainState = 1;
  
  end;

  local dots = { { 230, 477 },
                 { 349, 477 },
                 { 461, 533 },
                 { 572, 476 },
                 { 685, 534 },
                 { 779, 431 },}; 

  local win_mas = { 10, 5, 15, 5, 20 };
  
  local trainfunc = "";

  trainfunc = function ()

    if ( private.trainState ~= 6 ) then

      if ( private.save[ private.trainState ] > win_mas[ private.trainState ] - 1 ) then


        ObjAnimate( "obj_route_scr_train", "pos_xy", 0, 0, trainfunc, 
        { 

          0.0, 3, dots[ private.trainState ][ 1 ],     dots[ private.trainState ][ 2 ], 
          1.0, 3, dots[ private.trainState + 1 ][ 1 ], dots[ private.trainState + 1 ][ 2 ],

        });

        private.trainState = private.trainState + 1;

      else

        local exitfunc = function ( )

          common_impl.Lock( false );

          ObjMultiSet({ 
  
            { "obj_route_scr_buttons", { input = false } },
            { "obj_route_scr_try", { input = false } },
            { "spr_route_scr_reset_over", { alp = 1, input = true } },

          });

        end;

        private.LowEnergyAnim( exitfunc );
        common_impl.StopAudio( "sfx", "common/audio/levelscr/3routecoach", 0.5 );
      end;

    else

      common_impl.Lock( false );
      private.Win();
      common_impl.StopAudio( "sfx", "common/audio/levelscr/3routecoach", 0.5 );
    end;
    
  end;

  ObjAnimate( "spr_route_scr_try_on", "alp", 0, 0, "", 
  { 
    0.0, 3, 0, 
    0.2, 3, 1,
    
  });
  ObjAnimate( "spr_route_scr_try_off", "alp", 0, 0, trainfunc, 
  { 
    0.0, 3, 1, 
    0.2, 3, 0,
    
  });

end;
--*********************************************************************************************************************
function private.LowEnergyAnim( func_after )

  ObjAnimate( "spr_route_scr_train2", "alp", 0, 0, func_after, 
  { 
    0.0, 3, 0.0, 
    0.4, 3, 1.0,
    0.8, 3, 0.5, 
    1.2, 3, 1.0,
    1.6, 3, 0.5, 
    2.0, 3, 1.0,
    2.4, 3, 0.0,

  });

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************