-- name=mg_sail_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_sail_scr";
  --------------------------------------------------------------------------------------------
  -- function win_mg_3_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_3_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_3_big_check_mg_3", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_3" );

  end;

  cmn.AddSubscriber( "win_mg_3_scr", win_mg_3_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_sail_scr () end;
  --------------------------------------------------------------------------------------------
  local win_sail_scr = function ()

  if ( cmn.IsEventDone( "win_sail_scr" ) ) then  

  else

    private.MGLoad();
    private.MGLoadState();

  end;

  end;

  cmn.AddSubscriber( "win_sail_scr", win_sail_scr, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  private.InitMG();

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_sail_scr" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_sail_scr" ) ) then

    private.InitMGVar();

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_sail_scr" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_embroider", 0, "", 0 );

  private.InitMGVar();

  local table_mts = {};

  for i = 1, #private.save do

    local rope = "spr_sail_scr_rope_"..private.save[ i ];
    local hole = "obj_sail_scr_hole_"..i;
      
    table.insert( table_mts, { "spr_sail_scr_rope_"..i, { visible = false } } );
    table.insert( table_mts, { "obj_sail_scr_hole_"..i, { input = true } } );
    table.insert( table_mts, { "obj_sail_scr_needle_"..i, { input = true, visible = true } } );    

  end;

  if ( #table_mts > 1 ) then

    ObjMultiSet( table_mts );   

  end;


end;
--*********************************************************************************************************************
function public.Skip()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.Lock( false );

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_sail_scr" );
  cmn.CallEventHandler( "win_sail_scr" );
  cmn.SetEventDone( "win_mg_3_scr" );
  --cmn.CallEventHandler( "win_mg_3_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_win", 0, "", 0 );

  ObjAnimate( "spr_sail_scr_layer_1", "alp", 0, 0, private.WinEnd, 
  { 
    0.0, 3, 0, 
    0.5, 3, 1,
    1.5, 3, 1,

  });

end;
--*********************************************************************************************************************
function private.InitMG()

  local table_mts = {};
  
  for j = 1, 9 do

    table.insert( table_mts, { "obj_sail_scr_hole_"..j, 
    {  

      event_menter_drag = function () private.HoleMenter( j ) end,
      event_mleave_drag = function () private.HoleMleave( j ) end,

    } } );

    table.insert( table_mts, { "obj_sail_scr_hole_"..j.."_clk", 
    {  
      event_mdown  = function () private.RopeClk( j )  end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end,

    } } );

  end;

  for j = 1, 9 do

    table.insert( table_mts, { "obj_sail_scr_needle_"..j, 
    {  

      event_dragdrop =  function () private.NeedleDrop( j ) end,

    } } );

    table.insert( table_mts, { "spr_sail_scr_needle_big_"..j, 
    {  

      event_mdown =  function () private.NeedleClk( j ) end,
      event_menter = function () private.NeedleMenter( j ) end,
      event_mleave = function () private.NeedleMleave( j ) end,

    } } );

  end;  

  ObjMultiSet( table_mts );

end;
--*********************************************************************************************************************
function private.InitMGVar()

  private.save = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

  private.MGSave();

end;
--*********************************************************************************************************************
function private.MGSave()

  ng_global.progress[ "scr" ][ "win_sail_scr" ].save = {};

  for i = 1, #private.save do
  
    ng_global.progress[ "scr" ][ "win_sail_scr" ].save[ i ] = private.save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoad()

  private.save = {};

  for i = 1, #ng_global.progress[ "scr" ][ "win_sail_scr" ].save do
  
    private.save[ i ] = ng_global.progress[ "scr" ][ "win_sail_scr" ].save[ i ];

  end;

end;
--*********************************************************************************************************************
function private.MGLoadState()

  local table_mts = {};

  for i = 1, #private.save do

    if ( private.save[ i ] ~= 0 ) then

      local rope = "spr_sail_scr_rope_"..private.save[ i ];
      local hole = "obj_sail_scr_hole_"..i;

      ObjAttach( rope, hole );
      
      table.insert( table_mts, { "spr_sail_scr_rope_"..private.save[ i ], { visible = true } } );
      table.insert( table_mts, { "obj_sail_scr_hole_"..i, { input = false } } );
      table.insert( table_mts, { "obj_sail_scr_needle_"..private.save[ i ], { input = false, visible = false } } );    

    else

      table.insert( table_mts, { "obj_sail_scr_hole_"..i, { input = true } } );

    end;

  end;

  if ( #table_mts > 1 ) then

    ObjMultiSet( table_mts );   

  end;

end;
--*********************************************************************************************************************
function private.CheckWin()

  local holes_count = { 9,  4, 4, 9, 4, 9, 4, 9, 10 };
  local rope_count =  { 9, 10, 4, 8, 4, 6, 9, 7, 5 };

  local mas_count = { 1, 2, 7, 8 };

  for i = 1, #private.save do

    if ( private.save[ i ] ~= 0 )  then

      if ( ( rope_count[ private.save[ i ] ] ~= holes_count[ i ] ) ) then

        if ( private.FindIndex( mas_count, private.save[ i ] ) ) then

        else

          return false;

        end;

      end;

    else

      return false;

    end;
    
  end;

  if ( ( ( rope_count[ private.save[ 1 ] ] + rope_count[ private.save[ 2 ] ] ) == 13 ) and ( ( rope_count[ private.save[ 7 ] ] + rope_count[ private.save[ 8 ] ] ) == 13 ) ) then

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.RopeClk( num_hole )

  local rope = private.save[ num_hole ]

  ObjMultiSet({ 

    { "spr_sail_scr_rope_"..rope, { visible = false } },
    { "obj_sail_scr_hole_"..num_hole, { input = true } }, 
    { "obj_sail_scr_needle_"..rope, { input = true, visible = true } },
    { "spr_sail_scr_hole_add_"..num_hole, { visible = true } },

  });

  --common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_sew", 0, "", 0 );

  private.save[ num_hole ] = 0;

  ObjMultiSet({ 

    { "spr_sail_scr_needle_small_"..rope, { visible = true } },
    { "spr_sail_scr_needle_big_"..rope, { visible = false } },

  });

  private.MGSave();
  private.NeedleClk( rope );

end;
--*********************************************************************************************************************
function private.NeedleClk( num )

  private.needleIsDrag = true;
  
  ObjStartDrag( "obj_sail_scr_needle_"..num );

  ObjAttach( "obj_sail_scr_needle_"..num , "obj_sail_scr_needles_over" );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_take", 0, "", 0 );

  ObjMultiSet({ 

    { "spr_sail_scr_needle_small_"..num, { visible = true } },
    { "spr_sail_scr_needle_big_"..num, { visible = false } },

  });

  common_impl.SetCursor( CURSOR_NONE );

end;
--*********************************************************************************************************************
function private.NeedleDrop( num )

  private.needleIsDrag = false;

  if ( private.numHole )then

    ObjAttach( "spr_sail_scr_rope_"..num, "obj_sail_scr_hole_"..private.numHole );

    ObjMultiSet({ 
  
      { "spr_sail_scr_rope_"..num, { visible = true } },
      { "obj_sail_scr_hole_"..private.numHole, { input = false } }, 
      { "obj_sail_scr_needle_"..num, { input = false, visible = false } },
      { "spr_sail_scr_hole_add_"..private.numHole, { visible = false } },

    });

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_sew", 0, "", 0 );

    private.save[ private.numHole ] = num;

    private.numHole = nil;

    if ( private.CheckWin() ) then

      private.Win();    

    else

      private.MGSave();

    end;

  end;

  ObjAttach( "obj_sail_scr_needle_"..num , "obj_sail_scr_needles" );

  ObjMultiSet({ 

    { "spr_sail_scr_needle_small_"..num, { visible = false } },
    { "spr_sail_scr_needle_big_"..num, { visible = true } },

  });

  common_impl.SetCursor( CURSOR_DEFAULT ); 

end;
 --*********************************************************************************************************************   
function private.HoleMenter( num )

  if ( private.needleIsDrag ) then

    ObjSet( "spr_sail_scr_hole_add_"..num, { visible = true } );
    private.numHole = num;

  end;

end;
--*********************************************************************************************************************
function private.HoleMleave( num )

  if ( private.needleIsDrag ) then

    ObjSet( "spr_sail_scr_hole_add_"..num, { visible = false } );
    private.numHole = nil;

  end;

end;
 --*********************************************************************************************************************   
function private.NeedleMenter( num )

  common_impl.SetCursor( CURSOR_HAND );

  common_impl.PlayAudio( "sfx", "common/audio/levelscr/mg_sail_s_select"..num, 0, "", 0 );

end;
--*********************************************************************************************************************
function private.NeedleMleave()

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.FindIndex( arr, elem ) -- поиск по таблице SS
  
  for i = 1, #arr  do
    
    if arr[i] == elem then

      return i;

    end;
    
  end;
  
  return 0;  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--********************************************************************************************************************