-- name=mg_superpuzzle_2_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle_2_scr";
  --------------------------------------------------------------------------------------------
  -- function win_mg_8_scr_loc () end;
  --------------------------------------------------------------------------------------------
  local win_mg_8_scr_loc = function ()
      
    ObjSet( "spr_mysteryroom_mt_8_big_check_mg_8", { alp = 1 } );
    ObjDelete( "anm_mysteryroom_mt_check_mark_mg_8" );

  end;

  cmn.AddSubscriber( "win_mg_8_scr", win_mg_8_scr_loc, "rm_mysteryroom" );
  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle_2_scr () end;
  --------------------------------------------------------------------------------------------
  local win_superpuzzle_2_scr = function ()

    local table_multiset = {};

    private.lever       = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].lever;
    private.gears       = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].gears;
    private.circles     = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].circles;
    private.quadrates   = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates;
    private.buttons     = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].buttons;
    private.tube        = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].tube;
    private.plates      = ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].plates;

    if ( cmn.IsEventDone( "win_superpuzzle_2_scr" ) ) then  
    
      --

    else

      --

    end;

    -----------------------------

    if ( private.lever.win ) then

      private.LeverWinSet();
      
    end;

    local pos_y = private.LeverGetPosCover( private.lever.current_step );
    local ang   = private.LeverGetAngLever( private.lever.current_step );

    table.insert( table_multiset, { "spr_superpuzzle_2_scr_cover", { pos_y = pos_y } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_lever", { ang = ang } } );
  
    if ( private.lever.current_step > 1 ) then

      ObjSet( "spr_superpuzzle_2_scr_lever_sh2", { alp = 0 } );

    end;

    -----------------------------

    if ( private.gears.win ) then

      private.GearsWinSet();
      
    end;

    for i = 1, #private.gears.current_list do
      
      local pos_x = private.gears_pos_x[ i ]; 
      local pos_y = private.gears_pos_y[ i ];                   
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_gear"..private.gears.current_list[ i ], { pos_x = pos_x, pos_y = pos_y } } );

    end;

    -----------------------------

    if ( private.circles.win ) then

      private.CirclesWinSet();
      
    end;

    for i = 1, #private.circles.current_list do
      
      local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_circle"..i, { ang = ang } } );

    end;

    -----------------------------

    if ( private.quadrates.win ) then

      private.QuadratesWinSet();
      
    end;

    for i = 1, #private.quadrates.current_list do
      
      for j = 1, #private.quadrates.current_list[ 1 ] do
        
        local number = private.quadrates.current_list[ j ][ i ];

        if ( number >= 1 and number <= 4 ) then

          local pos_x = private.quadrates_pos_x[ i ];
          local pos_y = private.quadrates_pos_y[ j ]; 
                          
          table.insert( table_multiset, { "spr_superpuzzle_2_scr_quadrate"..number, { pos_x = pos_x, pos_y = pos_y } } );

        end;

      end;

    end;

    local ang = private.quadrates_chopping_ang[ private.quadrates.chopping_state ];

    table.insert( table_multiset, { "spr_superpuzzle_2_scr_chopping", { ang = ang } } );

    if ( private.quadrates.current_list[ 2 ][ 3 ] >= 1 and private.quadrates.current_list[ 2 ][ 3 ] <= 4 ) then

      private.quadrates_chopping_number = private.quadrates.current_list[ 2 ][ 3 ];

    elseif ( private.quadrates.current_list[ 3 ][ 2 ] >= 1 and private.quadrates.current_list[ 3 ][ 2 ] <= 4 ) then

      private.quadrates_chopping_number = private.quadrates.current_list[ 3 ][ 2 ];

    end;

    -----------------------------

    if ( private.buttons.win ) then

      private.ButtonsWinSet();
      
    end;

    for i = 1, #private.buttons.current_list do

      local pos_y = private.buttons_pos_y[ private.buttons.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_button"..i, { pos_y = pos_y } } );

    end;

    -----------------------------

    if ( private.tube.win ) then

      private.TubeWinSet();
      
    end;

    local croprect_y = private.TubeGetLevel( private.tube.current_state );

    table.insert( table_multiset, { "anm_superpuzzle_2_scr_water", { croprect_y = croprect_y } } );

    -----------------------------

    for i = 1, #private.plates.current_list do
        
      if ( private.plates.current_list[ i ] ) then

        table.insert( table_multiset, { "spr_superpuzzle_2_scr_plate"..i, { input = false } } );
        table.insert( table_multiset, { "spr_superpuzzle_2_scr_plate"..i.."_1", { alp = 0 } } );

      end;

    end;

    -----------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle_2_scr", win_superpuzzle_2_scr, private.room_objname );
  ------------------------------------------------------------------------------------------------

  local table_multiset = {};

  --------------------------------------

  private.lever = {};
  private.lever.current_step = 0;

  private.lever_win_step  = 5;
  private.lever_pos_y_beg = 378;
  private.lever_pos_y_end = 68;

  --------------------------------------

  private.gears = {};
  --                             x  x               x           x
  private.gears.current_list = { 1, 2, 9, 10, 3, 8, 7, 6, 5, 4, 11 };

  private.gears_win_list  = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };
  private.gears_pos_x     = { 455, 510, 472, 436, 456, 490, 545, 601, 636, 654, 672 };
  private.gears_pos_y     = { 491, 454, 399, 347, 292, 292, 294, 274, 311, 384, 455 };
  private.gears_prev_name = "";

  for i = 1, #private.gears.current_list do
    
    local pos_x = private.gears_pos_x[ i ]; 
    local pos_y = private.gears_pos_y[ i ];                   
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_gear"..private.gears.current_list[ i ], { pos_x = pos_x, pos_y = pos_y } } );

  end;

  --------------------------------------

  private.circles = {};
  private.circles.current_list = { 1, 3, 2 };

  private.circles_ang = { 0, - 1.57, - 3.14, - 4.71, - 6.28 };

  for i = 1, #private.circles.current_list do
    
    local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_circle"..i, { ang = ang } } );

  end;

  --------------------------------------

  private.quadrates = {};
  private.quadrates.current_list = { 
    { 1, 2, 3, 4 },
    { 0, 9, 0, 9 },
    { 0, 9, 9, 9 },
    { 0, 9, 9, 9 }
  };
  private.quadrates.chopping_state = 1;

  private.quadrates_win_list = { 3, 2, 4, 1 };
  private.quadrates_pos_x = { 189, 234, 278, 318 };
  private.quadrates_pos_y = { 264, 308, 352, 392 };

  private.quadrates_chopping_ang = { 0, 1.57 };

  local pos_y = private.quadrates_pos_y[ private.quadrates.current_list[ 1 ][ 1 ] ]; 
            
  for i = 1, #private.quadrates.current_list do
    
    local pos_x = private.quadrates_pos_x[ private.quadrates.current_list[ 1 ][ i ] ]; 
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_quadrate"..i, { pos_x = pos_x, pos_y = pos_y } } );

  end;

  --------------------------------------

  private.buttons = {};
  private.buttons.current_list = { 1, 1, 1, 1 };

  private.buttons_win_list = { 2, 1, 4, 3 };
  private.buttons_pos_y    = { 202, 235, 262, 290 };

  for i = 1, #private.buttons.current_list do
    
    local pos_y = private.buttons_pos_y[ private.buttons.current_list[ i ] ]; 
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_button"..i, { pos_y = pos_y } } );

  end;

  --------------------------------------

  private.tube = {};
  private.tube.current_state = 0;

  private.tube_croprect_y_beg = 460;
  private.tube_croprect_y_end = 0;
  private.tube_win_state = 6;

  table.insert( table_multiset, { "anm_superpuzzle_2_scr_water", { croprect_y = tube_croprect_y_beg } } );

  --------------------------------------

  private.plates = {};
  private.plates.current_list = { false, false, false, false, false, false, false, false, false, false, false, false };

  private.plates_prev_number = "";
  private.plates_list = { 1, 2, 3, 4, 4, 5, 6, 1, 2, 3, 5, 6 };

  --------------------------------------

  table.insert( table_multiset, { "spr_superpuzzle_2_scr_lever", { event_mdown = private.LeverClick } } );

  for g = 1, 11 do
    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_gear"..g, { event_mdown = function () private.GearsClick( g ) end } } );

  end;

  for c = 1, 11 do
    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_circle"..c, { event_mdown = function () private.CirclesClick( c ) end } } );

  end;

  for q = 1, 4 do
    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_quadrate"..q, { 
      event_mdown  = function () private.QuadratesClk( q ) end
    } } );

  end;

  for a = 1, 4 do
    
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_arrow"..a, { 
      event_mdown = function () private.QuadratesArrowClk( a ) end
    } } );

  end;

  table.insert( table_multiset, { "spr_superpuzzle_2_scr_chopping", { 
    event_mdown = function () private.QuadratesChoppingClk() end
  } } );


  for b = 1, 4 do
    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_button"..b, { 
      event_mdown = function () private.ButtonsClk( b ) end
    } } );

  end;

  for p = 1, 12 do
    
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_plate"..p, { 
      event_mdown = function () private.PlatesClk( p ) end
    } } );

  end; 

  table.insert( table_multiset, { "spr_superpuzzle_2_scr_puzzle_hint", { 
    event_mdown  = private.PuszzleHintClk,
    event_menter = private.PuszzleHintEnter,
    event_mleave = private.PuszzleHintLeave
  } } );

  --------------------------------------
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_superpuzzle_2_scr" ) then

    cmn.MiniGameShow();
  
  end;

  private.volume_env = GetSoundVolume( "env" );
  SetSoundVolume( "env", 0.7*private.volume_env );

  common_impl.PlayAudio( "mus", "common/audio/levelscr/aud_enigma_mus", 0, "", 0 );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_superpuzzle_2_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].lever      = private.lever;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].gears      = private.gears;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].circles    = private.circles;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates  = private.quadrates;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].buttons    = private.buttons;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].tube       = private.tube;
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].plates     = private.plates;

  end;

end;
--*********************************************************************************************************************
function public.Close()

  if not cmn.IsEventDone( "win_superpuzzle_2_scr" ) then


  end;

  SetSoundVolume( "env", private.volume_env );
  
  common_impl.StopAudio( "mus", "common/audio/levelscr/aud_enigma_mus", 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_superpuzzle_2_scr" ) then

    cmn.MiniGameHide();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  private.LeverResetSet();
  private.GearsResetSet();
  private.CirclesResetSet();
  private.QuadratesResetSet();
  private.ButtonsResetSet();
  private.TubeResetSet();
  private.PlatesResetSet();

end;
--*********************************************************************************************************************
function public.Skip()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_superpuzzle_2_scr" );
  cmn.CallEventHandler( "win_superpuzzle_2_scr" );
  cmn.SetEventDone( "win_mg_8_scr" );
  --cmn.CallEventHandler( "win_mg_8_scr" );
  rm_mysteryroom.WinEnd( private.room_objname );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd()

end;
--*********************************************************************************************************************
-- function *** Mmg Lever ***() end
--*********************************************************************************************************************
  function private.LeverClick ()

    common_impl.Lock( true );

    local current_step = private.lever.current_step + 1;

    local func_end = function ()

      common_impl.Lock( false );

      private.LeverClickEnd( number );

    end;

    local old_ang = ObjGet( "spr_superpuzzle_2_scr_lever" ).ang;
    local new_ang = private.LeverGetAngLever( current_step );

    local old_pos_y = ObjGet( "spr_superpuzzle_2_scr_cover" ).pos_y;
    local new_pos_y = private.LeverGetPosCover( current_step );

    ObjAnimate( "spr_superpuzzle_2_scr_lever", "ang", 0, 0, func_end, 
    { 
      0,   3, old_ang,  
      0.2, 3, new_ang
    } );

    if ( current_step == 1 ) then

      ObjAnimate( "spr_superpuzzle_2_scr_lever_sh2", "alp", 0, 0, "", 
      { 
        0,   3, 1,  
        0.3, 3, 0
      } );

    end;

    ObjAnimate( "spr_superpuzzle_2_scr_cover", "pos_y", 0, 0, "", 
    { 
      0,   3, old_pos_y,  
      0.2, 3, new_pos_y 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_lever", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LeverClickEnd ()

    private.lever.current_step = private.lever.current_step + 1;

    if ( private.lever.current_step == private.lever_win_step ) then

      private.LeverWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].lever = private.lever;

    end;

  end;
  --*********************************************************************************************************************
  function private.LeverGetPosCover ( current_step )

    return private.lever_pos_y_end + ( private.lever_pos_y_beg - private.lever_pos_y_end ) / 5 * ( 5 - current_step );

  end;
  --*********************************************************************************************************************
  function private.LeverGetAngLever ( current_step )

    return current_step * ( - 0.24 );

  end;
  --*********************************************************************************************************************
  function private.LeverWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.lever.win = true;

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].lever = private.lever;

      private.LeverWinSet();

      private.TubeLevelUp();

    end;

    ObjAnimate( "spr_superpuzzle_2_scr_cover_sh", "alp", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, 1 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_mechanism_on", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LeverWinSet ()

    ObjSet( "spr_superpuzzle_2_scr_cover",    { pos_y = private.lever_pos_y_end } );
    ObjSet( "spr_superpuzzle_2_scr_cover_sh", { alp = 1 } );  
    ObjSet( "obj_superpuzzle_2_scr_gears",    { input = true } );  
    ObjSet( "spr_superpuzzle_2_scr_lever",    { input = false } );  

  end;
  --*********************************************************************************************************************
  function private.LeverResetSet ()

    private.lever.current_step = 0;
    private.lever.win = false;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].lever = private.lever;

    ObjSet( "spr_superpuzzle_2_scr_cover",    { pos_y = private.lever_pos_y_beg } );
    ObjSet( "spr_superpuzzle_2_scr_cover_sh", { alp = 0 } );  
    ObjSet( "obj_superpuzzle_2_scr_gears",    { input = false } );  
    ObjSet( "spr_superpuzzle_2_scr_lever",    { input = true } );  

  end;
--*********************************************************************************************************************
-- function *** Mmg Gears ***() end
--*********************************************************************************************************************
  function private.GearsClick ( name )

    local obj_name = "spr_superpuzzle_2_scr_gear"..name;
   
    if ( private.gears_prev_name == name ) then

      ObjSet( "spr_superpuzzle_2_scr_gear"..name.."_light", { alp = 0 } );
      private.gears_prev_name = "";

    elseif ( private.gears_prev_name ~= "" ) then

      local obj_name_prev = "spr_superpuzzle_2_scr_gear"..private.gears_prev_name;

      local number_current = private.GearsGetNumber( name );
      local number_prev    = private.GearsGetNumber( private.gears_prev_name );

      local func_end = function ()

        private.GearsClickEnd( number_current, number_prev );

      end;

      common_impl.Lock( true );

      ObjAnimate( obj_name, "pos_xy", 0, 0, "", 
      { 
        0,   3, private.gears_pos_x[ number_current ], private.gears_pos_y[ number_current ], 
        0.4, 3, private.gears_pos_x[ number_prev ],    private.gears_pos_y[ number_prev ]
      } );

      ObjAnimate( obj_name_prev, "pos_xy", 0, 0, func_end, 
      { 
        0,   3, private.gears_pos_x[ number_prev ],    private.gears_pos_y[ number_prev ],
        0.4, 3, private.gears_pos_x[ number_current ], private.gears_pos_y[ number_current ]
      } );

      ObjSet( "spr_superpuzzle_2_scr_gear"..private.gears_prev_name.."_light", { alp = 0 } );

      private.gears_prev_name = "";

      common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_gear_move", 0, "", 0 );

    else

      ObjSet( "spr_superpuzzle_2_scr_gear"..name.."_light", { alp = 1 } );
      private.gears_prev_name = name;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_gear_click", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.GearsClickEnd ( name_current, name_prev )

    common_impl.Lock( false );

    private.gears.current_list[ name_current ], private.gears.current_list[ name_prev ] =
    private.gears.current_list[ name_prev ], private.gears.current_list[ name_current ];

    local flag_win = true;
    
    for i = 1, #private.gears.current_list do
      
      if ( private.gears.current_list[ i ] ~= private.gears_win_list[ i ]) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.GearsWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].gears = private.gears;

    end;

  end;
  --*********************************************************************************************************************
  function private.GearsGetNumber ( number )

    for i = 1, #private.gears.current_list do
      
      if ( private.gears.current_list[ i ] == number ) then

        return i;

      end;

    end;

    return 0;

  end;
  --*********************************************************************************************************************
  function private.GearsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.gears.win = true;
      private.gears.current_list = private.gears_win_list;

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].gears = private.gears;

      private.GearsWinSet();

      private.TubeLevelUp();

    end;

    local tme = 4.0;

    for g = 1,#private.gears.current_list do
    
      local ang = math.pow ( -1, g ) * 6.28;

      ObjAnimate( "spr_superpuzzle_2_scr_gear"..g, "ang", 0, 0, "", { 0,3,0,  tme,3,ang } );

    end;
    ObjAnimate( "spr_superpuzzle_2_scr_wire3_light",      "alp", 0, 0, "",       { 0.0,3,0,        tme,3,0,  tme + 0.2,3,1,  tme + 0.4,3,0,  tme + 0.6,3,1 } );
    ObjAnimate( "spr_superpuzzle_2_scr_wire4_light",      "alp", 0, 0, "",       { 0.0,3,0,  tme + 0.6,3,0,  tme + 0.8,3,1,  tme + 1.0,3,0,  tme + 1.2,3,1 } );
    ObjAnimate( "obj_superpuzzle_2_scr_quadrates_lights", "alp", 0, 0, func_end, { 0.0,3,0,  tme + 0.6,3,0,  tme + 0.8,3,1,  tme + 1.0,3,0,  tme + 1.2,3,1 } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_gear_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.GearsWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_gears",            { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates",        { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_circles",          { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_chopping",         { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire3_light",      { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire4_light",      { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates_lights", { alp = 1 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.GearsResetSet ()

    local table_multiset = {};

    private.gears.current_list = { 1, 2, 9, 10, 3, 8, 7, 6, 5, 4, 11 };
    private.gears.win = false;

    private.gears_prev_name = "";
    
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].gears = private.gears;

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates",        { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_circles",          { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_chopping",         { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire3_light",      { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire4_light",      { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates_lights", { alp = 0 } } );

    for i = 1, #private.gears.current_list do
      
      local pos_x = private.gears_pos_x[ i ]; 
      local pos_y = private.gears_pos_y[ i ];   
                      
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_gear"..private.gears.current_list[ i ], { pos_x = pos_x, pos_y = pos_y } } );
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_gear"..private.gears.current_list[ i ].."_light", { alp = 0 } } );

    end;

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Circles ***() end
--*********************************************************************************************************************
  function private.CirclesClick ( number_circle )

    local obj_name = "spr_superpuzzle_2_scr_circle"..number_circle;
   
    local current_number = private.circles.current_list[ number_circle ] + 1;

    local anm_ang = private.circles_ang[ current_number ];

    if ( current_number > 4 ) then

      current_number = 1;

    end;

    local old_ang = ObjGet( obj_name ).ang;
    local new_ang = private.circles_ang[ current_number ];

    local func_end = function ()

      common_impl.Lock( false );

      private.CirclesClickEnd( number_circle, current_number );

    end;

    common_impl.Lock( true );

    ObjAnimate( obj_name, "ang", 0, 0, func_end, 
    { 
      0,   3, old_ang, 
      0.3, 3, anm_ang,
      0.3, 3, new_ang,
    } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_wheel_click", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesClickEnd ( number_circle, current_number )

    private.circles.current_list[ number_circle ] = current_number;

    if ( private.circles.current_list[ 1 ] == private.circles.current_list[ 2 ] ) and 
       ( private.circles.current_list[ 2 ] == private.circles.current_list[ 3 ] ) then

      private.CirclesWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].circles = private.circles;

    end;

  end;
  --*********************************************************************************************************************
  function private.CirclesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.circles.win = true;

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].circles = private.circles;

      private.CirclesWinSet();

      private.TubeLevelUp();

    end;

    local tme = 0.0;

    ObjAnimate( "spr_superpuzzle_2_scr_wire2_light", "alp", 0, 0, "",       { 0.0,3,0,  tme,3,0,  tme + 0.2,3,1,  tme + 0.4,3,0,  tme + 0.6,3,1 } );
    ObjAnimate( "spr_superpuzzle_2_scr_sfmt",        "alp", 0, 0, "",       { 0.0,3,0,  tme,3,0,  tme + 0.2,3,1,  tme + 0.4,3,0,  tme + 0.6,3,1 } );
    ObjAnimate( "spr_superpuzzle_2_scr_wire1_light", "alp", 0, 0, func_end, { 0.0,3,0,  tme,3,0,  tme + 0.2,3,1,  tme + 0.4,3,0,  tme + 0.6,3,1 } );

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_wheel_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_circles",          { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_buttons",          { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire1_light",      { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire2_light",      { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_sfmt",             { alp = 1 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.CirclesResetSet ()

    local table_multiset = {};

    private.circles.current_list = { 1, 3, 2 };
    private.circles.win = false;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].circles = private.circles;

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_buttons",          { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire1_light",      { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire2_light",      { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_sfmt",             { alp = 0 } } );

    for i = 1, #private.circles.current_list do
      
      local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_circle"..i, { ang = ang } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Quadrates ***() end
--*********************************************************************************************************************
  function private.QuadratesClk ( number )

    number = number or private.quadrate_number;

    local quadrate_name = "spr_superpuzzle_2_scr_quadrate"..number;
    local arrows_name   = "obj_superpuzzle_2_scr_arrows";

    local index = private.QuadratesGetIndex( number );
    local index_empty = private.QuadratesGetEmpty( index );

    private.quadrates_index = index;
    private.quadrate_number = number;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_square_select", 0, "", 0 );

    for a = 1, 4 do
    
      ObjSet( "obj_superpuzzle_2_scr_arrow"..a, { input = false, visible = false, active = false } );

    end;

    for i = 1, #index_empty do
    
      ObjSet( "obj_superpuzzle_2_scr_arrow"..index_empty[ i ], { input = true, visible = true, active = true } );

    end;

    local param = ObjGet( quadrate_name );
    ObjSet( "obj_superpuzzle_2_scr_arrows", { input = true, visible = true, active = true, pos_x = param.pos_x, pos_y = param.pos_y } );

  end;
  --*********************************************************************************************************************
  function private.QuadratesArrowClk ( direction )

    common_impl.Lock( true );

    ObjSet( "obj_superpuzzle_2_scr_arrows", { input = false, visible = false, active = false } );

    local offset = { { 0, -1 }, { -1, 0 }, { 0, 1 }, { 1, 0 } };
   
    local i_old = private.quadrates_index[ 1 ];
    local j_old = private.quadrates_index[ 2 ];
   
    local i_new = i_old + offset[ direction ][ 1 ];
    local j_new = j_old + offset[ direction ][ 2 ];

    local quadrate_name = "spr_superpuzzle_2_scr_quadrate"..private.quadrate_number;
    local param = ObjGet( quadrate_name );

    local new_x = private.quadrates_pos_x[ j_new ];
    local new_y = private.quadrates_pos_y[ i_new ];

    local func_end = function ()

      common_impl.Lock( false );

      private.QuadratesArrowClkEnd( direction );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_square_move", 0, "", 0 );

    ObjAnimate( quadrate_name, "pos_xy", 0, 0, func_end, { 
      0,    3,  param.pos_x,  param.pos_y ,  
      0.2,  3,  new_x,        new_y 
    } );

  end;
  --*********************************************************************************************************************
  function private.QuadratesArrowClkEnd ( direction )

    local offset = { { 0, -1 }, { -1, 0 }, { 0, 1 }, { 1, 0 } };
   
    local i_old = private.quadrates_index[ 1 ];
    local j_old = private.quadrates_index[ 2 ];
   
    local i_new = i_old + offset[ direction ][ 1 ];
    local j_new = j_old + offset[ direction ][ 2 ];

    private.quadrates.current_list[ i_old ][ j_old ], 
    private.quadrates.current_list[ i_new ][ j_new ] = 
    private.quadrates.current_list[ i_new ][ j_new ],
    private.quadrates.current_list[ i_old ][ j_old ];

    private.QuadratesClk();

    private.quadrates_chopping_number = nil;

    if ( private.quadrates.current_list[ 2 ][ 3 ] >= 1 and private.quadrates.current_list[ 2 ][ 3 ] <= 4 ) then

      private.quadrates_chopping_number = private.quadrates.current_list[ 2 ][ 3 ];

    elseif ( private.quadrates.current_list[ 3 ][ 2 ] >= 1 and private.quadrates.current_list[ 3 ][ 2 ] <= 4 ) then

      private.quadrates_chopping_number = private.quadrates.current_list[ 3 ][ 2 ];

    end;

    local flag_win = true;
    
    for i = 1, #private.quadrates.current_list[ 1 ] do
      
      if ( private.quadrates.current_list[ 1 ][ i ] ~= private.quadrates_win_list[ i  ]) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.QuadratesWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates = private.quadrates;

    end;

  end;
  --*********************************************************************************************************************
  function private.QuadratesChoppingClk ()

    common_impl.Lock( true );

    ObjSet( "obj_superpuzzle_2_scr_arrows", { input = false, visible = false, active = false } );

    local old_state = private.quadrates.chopping_state;

    local new_state;
    local new_pos_x;
    local new_pos_y;

    local new_x = private.quadrates_pos_x[ j_new ];
    local new_y = private.quadrates_pos_y[ i_new ];

    if ( old_state == 1 ) then

      new_state = 2;
      new_pos_x = private.quadrates_pos_x[ 2 ];
      new_pos_y = private.quadrates_pos_y[ 3 ];

    else

      new_state = 1;
      new_pos_x = private.quadrates_pos_x[ 3 ];
      new_pos_y = private.quadrates_pos_y[ 2 ];

    end;

    local old_ang = private.quadrates_chopping_ang[ old_state ];
    local new_ang = private.quadrates_chopping_ang[ new_state ];

    local func_end = function ()

      common_impl.Lock( false );

      private.QuadratesChoppingClkEnd( direction );

      if ( private.quadrates_chopping_number ) then

        local name = "spr_superpuzzle_2_scr_quadrate"..private.quadrates_chopping_number;

        ObjSet( name, { pos_x = new_pos_x, pos_y = new_pos_y, ang = 0 } );
      
        ObjAttach( name, "obj_superpuzzle_2_scr_quadrates" );

      end;

      if ( private.quadrate_number ) then

        private.QuadratesClk();

      end;

    end;

    if ( private.quadrates_chopping_number ) then

      local name = "spr_superpuzzle_2_scr_quadrate"..private.quadrates_chopping_number;

      ObjSet( name, { pos_x = 0, pos_y = 0 } );
    
      ObjAttach( name, "obj_superpuzzle_2_scr_chopping_place" );

      ObjAnimate( name, "ang", 0, 0, "", { 
        0,    3,  - old_ang,  
        0.3,  3,  - new_ang 
      } );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_square_rotate", 0, "", 0 );

    ObjAnimate( "obj_superpuzzle_2_scr_chopping", "ang", 0, 0, func_end, { 
      0,    3,  old_ang,  
      0.3,  3,  new_ang 
    } );

  end;
  --*********************************************************************************************************************
  function private.QuadratesChoppingClkEnd ()

    local new_state = 1;

    if ( private.quadrates.chopping_state == 1 ) then

      new_state = 2;

    end;

    private.quadrates.chopping_state = new_state;

    private.quadrates.current_list[ 2 ][ 3 ], 
    private.quadrates.current_list[ 3 ][ 2 ]= 
    private.quadrates.current_list[ 3 ][ 2 ],
    private.quadrates.current_list[ 2 ][ 3 ];

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates = private.quadrates;

  end;
  --*********************************************************************************************************************
  function private.QuadratesGetIndex ( number )

    local i_max = #private.quadrates.current_list;
    local j_max = #( private.quadrates.current_list[ 1 ] );

    for i = 1, i_max do
    
      for j = 1, j_max do
          
        if ( private.quadrates.current_list[ i ][ j ] == number ) then

          return { i, j };

        end;

      end;
    
    end;

  end;
  --*********************************************************************************************************************
  function private.QuadratesGetEmpty ( index )

    local offset = { { 0, -1 }, { -1, 0 }, { 0, 1 }, { 1, 0 } };

    local i_max = #private.quadrates.current_list;
    local j_max = #( private.quadrates.current_list[ 1 ] );
    local direction = {}

    for i = 1, #offset do
      
      local i_cur = index[ 1 ] + offset[ i ][ 1 ];
      local j_cur = index[ 2 ] + offset[ i ][ 2 ];

      if ( i_cur > 0 ) and ( i_cur <= i_max ) and 
         ( j_cur > 0 ) and ( j_cur <= j_max ) and
         ( private.quadrates.current_list[ i_cur ][ j_cur ] == 0 ) then

        table.insert( direction, i );

      end;

    end;

    return direction;

  end;
  --*********************************************************************************************************************
  function private.QuadratesWinAnim ()

    private.quadrates.win = true;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates = private.quadrates;

    private.QuadratesWinSet();

    private.TubeLevelUp();

  end;
  --*********************************************************************************************************************
  function private.QuadratesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates",          { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_chopping",           { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_2_scr_arrows",             { input = false, visible = false, active = false } } );

    if ( private.buttons.win ) then

      table.insert( table_multiset, { "obj_superpuzzle_2_scr_plates", { input = true } } );
  
    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.QuadratesResetSet ()

    local table_multiset = {};

    private.quadrates.win = false;
    private.quadrates.current_list = { 
      { 1, 2, 3, 4 },
      { 0, 9, 0, 9 },
      { 0, 9, 9, 9 },
      { 0, 9, 9, 9 }
    };
    private.quadrates.chopping_state = 1;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].quadrates = private.quadrates;

    --table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates",        { input = false } } );
    --table.insert( table_multiset, { "obj_superpuzzle_2_scr_circles",          { input = false } } );
    --table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire3_light",      { alp = 0 } } );
    --table.insert( table_multiset, { "spr_superpuzzle_2_scr_wire4_light",      { alp = 0 } } );
    --table.insert( table_multiset, { "obj_superpuzzle_2_scr_quadrates_lights", { alp = 0 } } );

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_arrows", { input = false, visible = false, active = false } } );

    for i = 1, #private.quadrates.current_list do
      
      for j = 1, #private.quadrates.current_list[ 1 ] do
        
        local number = private.quadrates.current_list[ j ][ i ];

        if ( number >= 1 and number <= 4 ) then

          local pos_x = private.quadrates_pos_x[ i ];
          local pos_y = private.quadrates_pos_y[ j ]; 
                          
          table.insert( table_multiset, { "spr_superpuzzle_2_scr_quadrate"..number, { pos_x = pos_x, pos_y = pos_y } } );

        end;

      end;

    end;

    local ang = private.quadrates_chopping_ang[ private.quadrates.chopping_state ];

    table.insert( table_multiset, { "spr_superpuzzle_2_scr_chopping", { ang = ang } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Buttons ***() end
--*********************************************************************************************************************
  function private.ButtonsClk ( number )

    common_impl.Lock( true );

    local name = "spr_superpuzzle_2_scr_button"..number;
    local param = ObjGet( name );

    local state = private.buttons.current_list[ number ] + 1;

    if ( state > 4) then

      state = 1;
  
    end;

    local new_y = private.buttons_pos_y[ state ];

    local func_end = function ()

      common_impl.Lock( false );

      private.ButtonsClkEnd( number, state );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_square_move", 0, "", 0 );

    ObjAnimate( name, "pos_y", 0, 0, func_end, { 
      0,    3,   param.pos_y ,  
      0.2,  3,   new_y 
    } );

  end;
  --*********************************************************************************************************************
  function private.ButtonsClkEnd ( number, state )

    private.buttons.current_list[ number ] = state;

    local flag_win = true;
    
    for i = 1, #private.buttons.current_list do
      
      if ( private.buttons.current_list[ i ] ~= private.buttons_win_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.ButtonsWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].buttons = private.buttons;

    end;

  end;
   --*********************************************************************************************************************
  function private.ButtonsWinAnim ()

    private.buttons.win = true;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].buttons = private.buttons;

    private.ButtonsWinSet();

    private.TubeLevelUp();

  end;
  --*********************************************************************************************************************
  function private.ButtonsWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_buttons", { input = false } } );

    if ( private.quadrates.win ) then

      table.insert( table_multiset, { "obj_superpuzzle_2_scr_plates", { input = true } } );
  
    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.ButtonsResetSet ()

    local table_multiset = {};
  
    private.buttons.win = false;
    private.buttons.current_list = { 1, 1, 1, 1 };

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].buttons = private.buttons;

    for i = 1, #private.buttons.current_list do

      local pos_y = private.buttons_pos_y[ private.buttons.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_button"..i, { pos_y = pos_y } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Tube ***() end
--*********************************************************************************************************************
  function private.TubeLevelUp ( func_end )

    common_impl.Lock( true );

    local name = "anm_superpuzzle_2_scr_water";
    local croprect_y = ObjGet( name ).croprect_y;

    local state = private.tube.current_state + 1;

    local new_croprect_y = private.TubeGetLevel( state );

    private.tube.current_state = state;

    local func_anim_end = function ()

      common_impl.Lock( false );

      ObjStopAnimate( "spr_superpuzzle_2_scr_pump2", "pos_xy" );

      if ( state == private.tube_win_state ) then

        private.tube.win = true;

        private.TubeWinSet();

      end;

      if ( func_end ) then

        func_end();

      end

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_water", 0, "", 0 );

    ObjAnimate( name, "croprect_y", 0, 0, func_anim_end, { 
      0,    3,       croprect_y,  
      0.6,  3,       croprect_y,
      1.2,  3,   new_croprect_y 
    } );

    ObjAnimate( "spr_superpuzzle_2_scr_pump", "scale_y", 0, 0, "", { 
      0,    3,   1.0,  
      0.6,  3,   0.8,
      1.2,  3,   1.0,  
    } );

    local params = ObjGet( "spr_superpuzzle_2_scr_pump2" );

    ObjAnimate( "spr_superpuzzle_2_scr_pump2", "pos_xy", 1, 0, "", { 
      0.0,   3,   params.pos_x,       params.pos_y, 
      0.05,  3,   params.pos_x + 2,   params.pos_y, 
      0.1,   3,   params.pos_x + 2,   params.pos_y + 2, 
      0.15,  3,   params.pos_x,       params.pos_y + 2, 
      0.2,   3,   params.pos_x,       params.pos_y, 
    } );

    ObjAnimate( "spr_superpuzzle_2_scr_wire5_light", "alp", 0, 0, "", { 
      0,    3,   0.0,  
      0.2,  3,   1.0,
      1.0,  3,   1.0,
      1.2,  3,   0.0,  
    } );

  end;
  --*********************************************************************************************************************
  function private.TubeGetLevel ( state )

    local div = math.abs( private.tube_croprect_y_end - private.tube_croprect_y_beg );

    return private.tube_croprect_y_beg - ( div / private.tube_win_state * state );

  end;
  --*********************************************************************************************************************
  function private.TubeWinSet ()

    local table_multiset = {};

    private.tube.current_state = private.tube_win_state;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].tube = private.tube;

    table.insert( table_multiset, { "spr_superpuzzle_2_scr_lever_sh2",  { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.TubeResetSet ()

    local table_multiset = {};
  
    private.tube.win = false;
    private.tube.current_state = 0;

    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].tube = private.tube;

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_plates",     { input = false } } );
    table.insert( table_multiset, { "anm_superpuzzle_2_scr_water",      { croprect_y = private.tube_croprect_y_beg } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_lever_sh2",  { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_2_scr_lever",      { ang = 0 } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Plates ***() end
--*********************************************************************************************************************
  function private.PlatesClk ( number )

    common_impl.Lock( true );

    local func_unlock = function ()

      common_impl.Lock( false );

    end;

    local obj_name = "spr_superpuzzle_2_scr_plate"..number;
   
    local prev_number = private.plates_prev_number;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_cards_rotate", 0, "", 0 );

    if ( private.plates_prev_number == number ) then

      ObjAnimate( obj_name,       "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( obj_name.."_1", "alp", 0, 0, "", { 0,3,0,  0.2,3,0,  0.2,3,1 } );

      private.plates_prev_number = "";

    elseif ( private.plates_prev_number ~= "" ) then

      local obj_name_prev = "spr_superpuzzle_2_scr_plate"..private.plates_prev_number;

      if ( private.plates_list[ number ] == private.plates_list[ private.plates_prev_number ] ) then

        ObjSet( obj_name,      { input = false } );
        ObjSet( obj_name_prev, { input = false } );

        local func_anim_end = function ()

          common_impl.Lock( false );

          private.PlatesCheck( number, prev_number );

        end;

        ObjAnimate( obj_name,       "scale_x", 0, 0, func_anim_end, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
        ObjAnimate( obj_name.."_1", "alp",     0, 0, "",            { 0,3,1,  0.2,3,1,  0.2,3,0 } );

      else

        ObjAnimate( obj_name,       "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( obj_name.."_1", "alp",     0, 0, "",          { 0,3,1,  0.2,3,1,  0.2,3,0,  1.2,3,0,  1.2,3,1 } );

        ObjAnimate( obj_name_prev,       "scale_x", 0, 0, "", { 0,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( obj_name_prev.."_1", "alp",     0, 0, "", { 0,3,0,  1.2,3,0,  1.2,3,1 } );

      end;

      private.plates_prev_number = "";

      --common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_windmill_move", 0, "", 0 );

    else

      ObjAnimate( obj_name,       "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( obj_name.."_1", "alp", 0, 0, "", { 0,3,1,  0.2,3,1,  0.2,3,0 } );

      private.plates_prev_number = number;

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_windmill_click", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PlatesCheck ( number, prev_number )

    private.plates.current_list[ number ]      = true;
    private.plates.current_list[ prev_number ] = true;

    local flag_win = true;
    
    for i = 1, #private.plates.current_list do
      
      if ( not private.plates.current_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.plates.current_list[ number ]      = false;
      private.plates.current_list[ prev_number ] = false;

      private.PlatesWinAnim();

    else

      ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].plates = private.plates;

    end;

  end;
  --*********************************************************************************************************************
  function private.PlatesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.TubeLevelUp( private.Win );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_mg_superpuzzle_2_cards_win", 0, "", 0 );

    ObjAnimate( "obj_superpuzzle_2_scr_plates", "pos_y", 0, 0, func_end, { 0,3,33,  0.4,3,0 } );

  end;
  --*********************************************************************************************************************
  function private.PlatesResetSet ()

    local table_multiset = {};

    private.plates.current_list = { false, false, false, false, false, false, false, false, false, false, false, false };
    private.plates.win = false;

    private.plates_prev_number = "";
    
    ng_global.progress[ "scr" ][ "win_superpuzzle_2_scr" ].plates = private.plates;

    table.insert( table_multiset, { "obj_superpuzzle_2_scr_plates", { pos_y = 33 } } );

    for i = 1, #private.plates.current_list do
        
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_plate"..i, { input = true } } );
      table.insert( table_multiset, { "spr_superpuzzle_2_scr_plate"..i.."_1", { alp = 1 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

    end;

    local postfix = private.GetHintPostfix();

    interface.DialogShow( "ifo_superpuzzle_2_scr_hint_"..postfix );

    ObjAnimate( "spr_superpuzzle_2_scr_puzzle_hint_press", "alp", 0, 0, func_end, { 0,3,0,  0.05,3,1, 0.15,3,1, 0.02,3,0 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle_2_scr_puzzle_hint_light", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle_2_scr_puzzle_hint_light", { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.GetHintPostfix ()

    local postfix;

    if     ( not private.lever.win )                    then postfix = "1";
    elseif ( not private.gears.win )                    then postfix = "2";
    elseif ( not private.quadrates.win )                then postfix = "3";
    elseif ( not private.circles.win )                  then postfix = "4";
    elseif ( not private.buttons.win )                  then postfix = "5";
    elseif ( not private.plates.win )                   then postfix = "6";
    end;

    return postfix;

  end;
--*********************************************************************************************************************