-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  

  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetSetVisible( InterfaceWidget_BtnSkip, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnSkip, false );  
  
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  interface.WidgetAdd( InterfaceWidget_Inventory, 9 ); 
  interface.WidgetSetVisible( InterfaceWidget_Inventory, 0 );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   

  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_Tutorial );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.PanelNotificationAdd();
  interface.PuzzleHelpAdd( 13 );
  
  --if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  --end;

  private.Init();
  ModLoad( "assets/levels/levelscr/mod_levelscr_inv" );
  levelscr_inv.Init();

  common.LevelLoad( "levelscr", "scr", "rm_mysteryroom", param );
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
    "rm_mysteryroom"
   ,"ho_aquarium_scr"
   ,"ho_workbench_scr"
   ,"ho_theatre_scr"
   ,"ho_underseat_scr"
   ,"ho_hothouse_scr"
   ,"ho_smuggling_scr"
   ,"ho_owlscene_scr"
   ,"ho_search_scr"
   ,"ho_inlaptop_scr"
   ,"ho_orchestra_scr"
   ,"mg_route_scr"
   ,"mg_mask_scr"
   ,"mg_sail_scr"
   ,"mg_bomb_scr"
   ,"mg_bridge_scr"
   ,"mg_fridgesafe_scr"
   ,"mg_basementlock_scr"
   ,"mg_superpuzzle_2_scr"
   ,"mg_gestures_scr"
   ,"mg_superpuzzle_1_scr"
  };

  game.progress_names_room =
  {
   { "beg_levelscr" }
  ,{ "opn_mysteryroom" }

  ,{ "win_route_scr" }
  ,{ "win_mg_1_scr" }
  ,{ "win_mt_1_scr" }
  ,{ "win_mask_scr" }
  ,{ "win_mg_2_scr" }
  ,{ "win_mt_2_scr" }
  ,{ "win_sail_scr" } 
  ,{ "win_mg_3_scr" } 
  ,{ "win_mt_3_scr" }
  ,{ "win_bomb_scr" }
  ,{ "win_mg_4_scr" }
  ,{ "win_mt_4_scr" }
  ,{ "win_bridge_scr" }
  ,{ "win_mg_5_scr" }
  ,{ "win_mt_5_scr" }
  ,{ "win_fridgesafe_scr" }
  ,{ "win_mg_6_scr" }
  ,{ "win_mt_6_scr" }
  ,{ "win_basementlock_scr" }
  ,{ "win_mg_7_scr" }
  ,{ "win_mt_7_scr" }
  ,{ "win_superpuzzle_2_scr" }
  ,{ "win_mg_8_scr" }
  ,{ "win_mt_8_scr" }
  ,{ "win_gestures_scr" }
  ,{ "win_mg_9_scr" }
  ,{ "win_mt_9_scr" }
  ,{ "win_superpuzzle_1_scr" }
  ,{ "win_mg_10_scr" }
  ,{ "win_mt_10_scr" }
  
  ,{ "opn_underseat_scr" }
  ,{ "win_underseat_scr" }  
  ,{ "opn_aquarium_scr" }
  ,{ "win_aquarium_scr" } 
  ,{ "opn_workbench_scr" }
  ,{ "win_workbench_scr" }  
  ,{ "opn_theatre_scr" }
  ,{ "win_theatre_scr" }  
  ,{ "opn_hothouse_scr" }
  ,{ "win_hothouse_scr" }  
  ,{ "opn_smuggling_scr" }
  ,{ "win_smuggling_scr" }  
  ,{ "opn_owlscene_scr" }
  ,{ "win_owlscene_scr" }  
  ,{ "opn_search_scr" }
  ,{ "win_search_scr" }  
  ,{ "opn_inlaptop_scr" }
  ,{ "win_inlaptop_scr" }
  ,{ "opn_orchestra_scr" }
  ,{ "win_orchestra_scr" }
  ,{ "win_ho_1_scr" } 
  ,{ "win_ho_2_scr" } 
  ,{ "win_ho_3_scr" } 
  ,{ "win_ho_4_scr" } 
  ,{ "win_ho_5_scr" } 
  ,{ "win_ho_6_scr" } 
  ,{ "win_ho_7_scr" } 
  ,{ "win_ho_8_scr" } 
  ,{ "win_ho_9_scr" } 
  ,{ "win_ho_10_scr" }
  ,{ "win_archive" }  
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;
--************************************************************************************************************************

function private.TutorialSetParams()

  if not ng_global.progress[ "scr" ][ "see_tutorial_scr" ] then

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ] = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.no  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.currentpage = "tutorial_page_1_scr";
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );
      
    end;

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages = {


    };

  end;

end;
--************************************************************************************************************************
function public.InventoryDisable()

  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );    
  ObjStopAnimate( "int_inventory", "alp" );
  ObjSet( "int_inventory", { alp = 0 } );  

end;