-- name=rm_mysteryroom
--*********************************************************************************************************************
-- function *** INIT *** () end;
--*********************************************************************************************************************
  function public.Init()
    --------------------------------------------------------------------------------------------
    private.room_objname = "rm_mysteryroom";   

    private.current = { [ "mg" ] = 1, [ "ho" ] = 1 };
    private.type = "mg";
    private.open_mt = 0;
    public.reset_name = "";
    private.stamp = { { -470, -255 },
                      { -248, -248 },
                      {  -34, -244 },
                      {  170, -230 },
                      {  380, -240 },
                      { -450,  143 },
                      { -230,  140 },
                      {  -17,  133 },
                      {  188,  124 },
                      {  395,  122 }                    
                    };
    private.names = { [ "mg" ] = {  

                                    "mg_route_scr"
                                   ,"mg_mask_scr"
                                   ,"mg_sail_scr"
                                   ,"mg_bomb_scr"
                                   ,"mg_bridge_scr"                  
                                   ,"mg_fridgesafe_scr"
                                   ,"mg_basementlock_scr"
                                   ,"mg_superpuzzle_2_scr"
                                   ,"mg_gestures_scr"
                                   ,"mg_superpuzzle_1_scr"
                                   },

  
                      [ "ho" ] = {  "ho_aquarium_scr" 
                                   ,"ho_workbench_scr"
                                   ,"ho_theatre_scr"                 
                                   ,"ho_underseat_scr"
                                   ,"ho_hothouse_scr"
                                   ,"ho_smuggling_scr"
                                   ,"ho_owlscene_scr"
                                   ,"ho_search_scr" 
                                   ,"ho_inlaptop_scr"
                                   ,"ho_orchestra_scr" }

                    }
    
    --------------------------------------------------------------------------------------------
    local table_multiset = {};
    for i = 1, 10 do

      table.insert( table_multiset, {"spr_mysteryroom_mt_"..i, 
         {
           event_mdown =  function() private.NoteScale( "open", i ); end ,
           event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end ,
           event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
         }
      } );

      table.insert( table_multiset, { "obj_mysteryroom_mt_"..i.."_close", 
        { 
          event_mdown =  function() private.NoteScale( "close", i ); end ,
          event_menter = function() common_impl.SetCursor( CURSOR_DOWN ) end, 
          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end 
        } 
      } );
      
      table.insert( table_multiset, { "obj_mysteryroom_mt_"..i.."_big_mg_"..i, 
        { 
          event_mdown =  function() private.ButtonDown( "mg", i ); end ,
          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end 
        } 
      } );

      table.insert( table_multiset, { "obj_mysteryroom_mt_"..i.."_big_ho_"..i, 
        { 
          event_mdown =  function() private.ButtonDown( "ho", i ); end ,
          event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
          event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end 
        } 
      } );
      
      table.insert( table_multiset, {"spr_mysteryroom_mt_"..i.."_photo_1_"..i, 
         {
           event_mdown =  function() common_impl.NoteScale( "open", "spr_mysteryroom_mt_"..i.."_photo_1_"..i );  end ,
           event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end ,
           event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
         }
      } );
      
      table.insert( table_multiset, {"spr_mysteryroom_mt_"..i.."_photo_1_"..i.."_big", 
         {
           event_mdown =  function() common_impl.NoteScale( "close", "spr_mysteryroom_mt_"..i.."_photo_1_"..i );  end ,
         }
      } );
      
      table.insert( table_multiset, {"spr_mysteryroom_mt_"..i.."_photo_2_"..i, 
         {
           event_mdown =  function() common_impl.NoteScale( "open", "spr_mysteryroom_mt_"..i.."_photo_2_"..i );  end ,
           event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end ,
           event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
         }
      } );
      
      table.insert( table_multiset, {"spr_mysteryroom_mt_"..i.."_photo_2_"..i.."_big", 
         {
          event_mdown =  function() common_impl.NoteScale( "close", "spr_mysteryroom_mt_"..i.."_photo_2_"..i );  end ,
         }
      } );
      
    end;
    
    ObjMultiSet( table_multiset );
    --------------------------------------------------------------------------------------------
    private.Init_Subroom();
    --------------------------------------------------------------------------------------------
    -- function UpdateGameMode () end;
    --------------------------------------------------------------------------------------------
    local update_game_mode_mysteryroom = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      --"gzz_",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    end;
    cmn.AddSubscriber( "update_game_mode_mysteryroom", update_game_mode_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function UpdatePerfMode () end;
    --------------------------------------------------------------------------------------------
    local update_performance_mode_mysteryroom = function ()

    local effects_table = 
    {
      "obj_mysteryroom_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

    end;
    cmn.AddSubscriber( "update_performance_mode_mysteryroom", update_performance_mode_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function opn_mysteryroom () end;
    --------------------------------------------------------------------------------------------
    local opn_mysteryroom = function ()

     

    end;
    cmn.AddSubscriber( "opn_mysteryroom", opn_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function opn_mysteryroom () end;
    --------------------------------------------------------------------------------------------
    local beg_levelscr = function ()

    --

    end;
    cmn.AddSubscriber( "beg_levelscr", beg_levelscr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_archive () end;
    --------------------------------------------------------------------------------------------
    local win_archive = function ()

      ObjSet( "anm_mysteryroom_morph", { frame = 220 });

    end;
    cmn.AddSubscriber( "win_archive", win_archive, private.room_objname );
    
    --------------------------------------------------------------------------------------------
    -- function win_mt_1_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_1_scr = function ()
      ObjSet( "spr_mysteryroom_mt_1_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_1_scr", win_mt_1_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_2_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_2_scr = function ()
      ObjSet( "spr_mysteryroom_mt_2_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_2_scr", win_mt_2_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_3_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_3_scr = function ()
      ObjSet( "spr_mysteryroom_mt_3_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_3_scr", win_mt_3_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_4_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_4_scr = function ()
      ObjSet( "spr_mysteryroom_mt_4_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_4_scr", win_mt_4_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_5_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_5_scr = function ()
      ObjSet( "spr_mysteryroom_mt_5_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_5_scr", win_mt_5_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_6_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_6_scr = function ()
      ObjSet( "spr_mysteryroom_mt_6_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_6_scr", win_mt_6_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_7_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_7_scr = function ()
      ObjSet( "spr_mysteryroom_mt_7_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_7_scr", win_mt_7_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_8_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_8_scr = function ()
      ObjSet( "spr_mysteryroom_mt_8_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_8_scr", win_mt_8_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_9_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_9_scr = function ()
      ObjSet( "spr_mysteryroom_mt_9_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_9_scr", win_mt_9_scr, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_mt_10_scr() end;
    --------------------------------------------------------------------------------------------
    local win_mt_10_scr = function ()
      ObjSet( "spr_mysteryroom_mt_10_stamp", { alp = 1 } );
    end;
    cmn.AddSubscriber( "win_mt_10_scr", win_mt_10_scr, private.room_objname );
    
  end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  function private.Init_Subroom()

    --

  end;
--*********************************************************************************************************************
-- function *** OPEN, CLOSE *** () end;
--*********************************************************************************************************************
  function public.Open()

    --common_impl.StopAllEnv();
    --common_impl.PlayAudio(  "env", "common/audio/aud_bonus_env", 1 );

  end;
  function public.PreOpen()
    
    common_impl.EnvPlay( { "common/audio/aud_bonus_env" }, "", 0.5 );

    if not cmn.IsEventDone( "opn_mysteryroom" ) then
  
      cmn.SetEventDone( "opn_mysteryroom" );

      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].current = { [ "mg" ] = 1, [ "ho" ] = 1 };
      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].mg_anim = { 0,0,0,0,0,0,0,0,0,0 };
      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].ho_anim = { 0,0,0,0,0,0,0,0,0,0 };
      
    end;

    private.current = ng_global.progress[ "scr" ][ "opn_mysteryroom" ].current;
  
    levelscr.InventoryDisable();
    
    if public.reset_name ~= "" then

      if _G[public.reset_name].Reset then

        _G[public.reset_name].Reset();

      end;

      public.reset_name = "";

    end; 
   
    local index = 0;
    for i = 1, 10  do
      
      if ( cmn.IsEventDone( "win_mg_"..i.."_scr" ) and cmn.IsEventDone( "win_ho_"..i.."_scr" ) and not cmn.IsEventDone( "win_archive" ) ) then
        index = index + 1;
      end;
      
    end;
    
    if ( index == 10 ) then
      
      if ( cmn.IsEventDone( "win_mg_"..private.open_mt.."_scr" ) and cmn.IsEventDone( "win_ho_"..private.open_mt.."_scr" ) and not cmn.IsEventDone( "win_mt_"..private.open_mt.."_scr" ) ) then
        
        local func_after = function()
          
            local func_end = function()
          
              common_impl.Lock( false );
              ObjSet( "anm_mysteryroom_mt_print", { alp = 0, pos_x = 0, pos_y = 0 });
              cmn.SetEventDone( "win_mt_"..private.open_mt.."_scr" );
              cmn.CallEventHandler( "win_mt_"..private.open_mt.."_scr" );
              cmn.SetEventDone( "win_archive" );
              cmn.CallEventHandler( "win_archive" );
              private.open_mt = 0;
              common.DialogWindowShow( "common", "secretwin" );
              
            end;
            
            AnimPlay( "anm_mysteryroom_morph", "DoAnim", func_end );
          
        end;
        
        common_impl.Lock( true );
        
        ObjSet( "obj_mysteryroom_mt_"..private.open_mt.."_big", { alp = 0, input = false, active = false, pos_x = 0, pos_y = 0 });
        for i = 1, 10  do
          ObjSet( "spr_mysteryroom_mt_"..i, { alp = 1 });  
        end;
        
        ObjAnimate( "spr_mysteryroom_mt_"..private.open_mt.."_stamp", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.3, 0, 0, 
          0.5, 0, 1 
        });
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_stamp", 0, "", 0 );
        ObjSet( "anm_mysteryroom_mt_print", { alp = 1, pos_x = private.stamp[private.open_mt][1], pos_y = private.stamp[private.open_mt][2] });
        AnimPlay( "anm_mysteryroom_mt_print", "DoAnim", func_after );
        
      end;
      
    end;
    
    if ( cmn.IsEventDone( "win_mg_"..private.open_mt.."_scr" ) and ng_global.progress[ "scr" ][ "opn_mysteryroom" ].mg_anim[private.open_mt] == 0 ) then
        
      local func_after = function()
                
        common_impl.Lock( false );
     
        cmn.SetEventDone( "win_mg_"..private.open_mt.."_scr" );
        cmn.CallEventHandler( "win_mg_"..private.open_mt.."_scr" );
        
        ng_global.progress[ "scr" ][ "opn_mysteryroom" ].mg_anim[private.open_mt] = 1;

      end;
      
      common_impl.Lock( true );
      
      --DbgTrace( "anm_mysteryroom_mt_check_mark_mg_"..private.open_mt );
 
      AnimPlay( "anm_mysteryroom_mt_check_mark_mg_"..private.open_mt, "DoAnim", func_after );
      
    end;
    
    if ( cmn.IsEventDone( "win_ho_"..private.open_mt.."_scr" ) and ng_global.progress[ "scr" ][ "opn_mysteryroom" ].ho_anim[private.open_mt] == 0 ) then
      
      local func_after = function()
                
        common_impl.Lock( false );
        
        cmn.SetEventDone( "win_ho_"..private.open_mt.."_scr" );
        cmn.CallEventHandler( "win_ho_"..private.open_mt.."_scr" );
        
        ng_global.progress[ "scr" ][ "opn_mysteryroom" ].ho_anim[private.open_mt] = 1;

      end;
      
      common_impl.Lock( true );
      
      --DbgTrace( "anm_mysteryroom_mt_check_mark_ho_"..private.open_mt );
 
      AnimPlay( "anm_mysteryroom_mt_check_mark_ho_"..private.open_mt, "DoAnim", func_after );
      
    end;

  end;

  function public.Close()
    
  end;
  
  function public.PreClose()

    levelscr.InventoryDisable();

    common_impl.StopAudio(  "env", "common/audio/aud_bonus_env", 0.5 );

  end;

--*********************************************************************************************************************
function private.ButtonDown( type, count )

  local gate = private.names[type][count];
  
  private.current[private.type] = count;
  
  cmn.GotoRoom( gate );
  
end;
--*********************************************************************************************************************  
function public.ExitRoom()

  if GetCurrentRoom() == "rm_mysteryroom" then
    
    SaveProfiles();
    SaveSettings();

    SetCursor( CURSOR_DEFAULT );
    
    ng_global.is_scr = true;

    common.LevelSwitch( "menu", "game" );
    
  else
    
    cmn.GotoRoom( "rm_mysteryroom" );
    
  end;

end;
--*********************************************************************************************************************  
function public.WinEnd( room )

  room = common.GetObjectName( room );

  cmn.SetEventStart( "win_"..room);
  cmn.MiniGameHide( room );
  ng_global.progress[ "scr" ][ "win_"..room ].done = 0;
  ng_global.progress[ "scr" ][ "win_"..room ].start = 0;
  
  cmn.GotoRoom( "rm_mysteryroom" );

  rm_mysteryroom.reset_name = "mg_"..room;
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );   

end;
--*********************************************************************************************************************  
function public.HoComplete( room )

  cmn.SetEventStart( "win_"..room );
  ng_global.progress[ "scr" ][ "opn_"..room ].done = 0;
  ng_global.progress[ "scr" ][ "win_"..room ].done = 0;
  ng_global.progress[ "scr" ][ "win_"..room ].start = 0;

  cmn.GotoRoom( "rm_mysteryroom" );

  rm_mysteryroom.reset_name = "ho_"..room;
 
end;
--*********************************************************************************************************************
--******************************************************************************************
--function --**Open Big**-- () end;
--******************************************************************************************
function private.NoteScale( event, number )

  local small_pic = "spr_mysteryroom_mt_"..number;
  local big_pic   = "obj_mysteryroom_mt_"..number.."_big";
  local pos_array  = {};

  pos_array.start  = {};
  pos_array.finish = {};

  pos_array.start.pos_x = 512 ;
  pos_array.start.pos_y = 384 ;
  pos_array.finish.pos_x = 0;
  pos_array.finish.pos_y = 0;

  local trg_after = function()

    common_impl.Lock( false );
    
    if event == "open" then
      ObjSet( big_pic, { input = true } );
      private.open_mt = number;
    else
      ObjSet( big_pic, { input = false, active = false, alp = 0, pos_x = pos_array.finish.pos_x, pos_y = pos_array.finish.pos_y } );
      
      if ( cmn.IsEventDone( "win_mg_"..private.open_mt.."_scr" ) and cmn.IsEventDone( "win_ho_"..private.open_mt.."_scr" ) and not cmn.IsEventDone( "win_mt_"..private.open_mt.."_scr" ) ) then
        
        local func_after = function()
        
          common_impl.Lock( false );
          
          ObjSet( "anm_mysteryroom_mt_print", { alp = 0, pos_x = 0, pos_y = 0 });

          cmn.SetEventDone( "win_mt_"..private.open_mt.."_scr" );
          cmn.CallEventHandler( "win_mt_"..private.open_mt.."_scr" );
          
          private.open_mt = 0;
          
        end;
        
        common_impl.Lock( true );
        
        ObjAnimate( "spr_mysteryroom_mt_"..private.open_mt.."_stamp", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.3, 0, 0, 
          0.5, 0, 1 
        });
        common_impl.PlayAudio( "sfx", "common/audio/levelscr/aud_stamp", 0, "", 0 );
        ObjSet( "anm_mysteryroom_mt_print", { alp = 1, pos_x = private.stamp[private.open_mt][1], pos_y = private.stamp[private.open_mt][2] });
        AnimPlay( "anm_mysteryroom_mt_print", "DoAnim", func_after );
        
      end;
      
    end;  

  end;

  if event == "open" then

    private.note_scale = {};
    common_impl.Lock( true );

    private.note_scale.pos_x = pos_array.start.pos_x;
    private.note_scale.pos_y = pos_array.start.pos_y;

    ObjAnimate( small_pic, "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

    ObjSet( big_pic, { alp = 1, active = true, input = true, inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, inputrect_w = 2000, inputrect_h = 2000  } );
    ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
    {
      0.0, 3, pos_array.start.pos_x, pos_array.start.pos_y,
      0.3, 3, pos_array.finish.pos_x, pos_array.finish.pos_y 
    } );

    ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
    { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1 
    } );

  else

    common_impl.Lock( true );
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_out", 0, "", 0 ); 

    ObjAnimate( small_pic, "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );

    ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
    { 
      0.0, 3, pos_array.finish.pos_x, pos_array.finish.pos_y,
      0.3, 3, private.note_scale.pos_x, private.note_scale.pos_y
    } );

    ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
    {
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
    } );

  end;

end;
