-- name=rm_achievements
--******************************************************************************************
function public.Init()

  private.updated = {};
  private.COUNT_LIST = 21;

  local table_multiset = {};
  for i = 1, private.COUNT_LIST do

    table.insert( table_multiset, {"spr_achievements_award_"..i, 
       {
         event_menter = function() private.PopupShow( i ); end ,
         event_mleave = function() private.PopupHide() end
       }
    } );

    table.insert( table_multiset, {"spr_achievements_award_"..i.."_big", 
       {
         event_mdown = function() private.NoteScale( "close", i ); end ,
         event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end ,
         event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end
       } 
    } );

  end;  

  table.insert( table_multiset, { "obj_achievements_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_achievements_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_achievements_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_achievements_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_achievements_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_achievements_btn_exit_focus" ) end; } } );

  
  ObjMultiSet( table_multiset );
  
  private.StartAnims();
  
end;
--******************************************************************************************
function public.PreOpen()
   
  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE

    if ng_global.currentprogress == "std" then

      common_impl.Tutorial_Click( 'empty' );

    end;

  end;
  private.Update();
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1 );
  
  --common_impl.PlayAudio( "env", "common/audio/aud_achievements_env", 1, "", 0 );
  
  common_impl.EnvPlay( { "common/audio/aud_achievements_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Close()

  ObjSet( "tmr_common_anm", { active = true } );
  
  common_impl.StopAudio(  "mus", "common/audio/aud_ho_mus", 1 );
  common_impl.StopAudio( "env", "common/audio/aud_achievements_env", 0.5 );
  
  local current_room = common.GetCurrentRoom();

  
  if ( current_room ) then

    common_impl.ExitBonusRm();
      
  end;

end;
--******************************************************************************************
function private.Update ()

  local table_multiset = {};

  for i = 1, private.COUNT_LIST do

    local event = common_impl.GetNameAchiev( i );

    if ( not private.updated[ event ] ) then

      if ( ng_global.achievements[ event ].done == 1 ) then

        ObjSet( "spr_achievements_award_"..i, { alp = 1 } );
        --ObjSet( "spr_achievements_award_"..i.."_fantom", { alp = 0 } );
        table.insert( table_multiset, {"spr_achievements_award_"..i, 
           {
             event_mdown = function() private.NoteScale( "open", i ); end ,
           }
        } );
        private.updated[ event ] = true;

      end;

    end;

  end;

  if #table_multiset > 0 then

    ObjMultiSet( table_multiset );

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
--port.
function public.Hide()
  private.BtnCloseMouseDown(); --  public. or private.
end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

 if common.GetCurrentRoom() then 
   
    common.GotoRoom( common.GetCurrentRoom() );

    common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_out", 0, "", 0 );
  
--    if int_map_impl.show == true then
--      
--      interface.WidgetSetVisible( InterfaceWidget_Map, true, true, 1.0 );   
--      interface.WidgetSetInput( InterfaceWidget_Map, true );  
--
--    else
--
--      interface.WidgetSetVisible( InterfaceWidget_Map, true );   
--      interface.WidgetSetInput( InterfaceWidget_Map, true );    
--
--    end;

  else

    common.GotoRoom( "rm_extra");

  end;

end;
--******************************************************************************************
--function --**POPUP**-- () end;
--******************************************************************************************

function private.PopupShow( number )

  SetCursor( CURSOR_LOUPE );

  local title = "str_achievements_name_"..common_impl.GetNameAchiev( number )
  local description = "str_achievements_description_"..common_impl.GetNameAchiev( number );
  
  local position = { 0, 0 };
  local obj_pos = ObjGet( "spr_achievements_award_"..number );
  
  position[ 1 ] = obj_pos.pos_x;
  position[ 2 ] = obj_pos.pos_y;

  private.WindowShow( title, description, position );  

end;
--------------------------------------------------------------------------------------------
function private.PopupHide() 

  private.WindowHide();  
  SetCursor( CURSOR_DEFAULT );

end;

--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

 --

end;
--******************************************************************************************
--function --**Dialog**-- () end;
--******************************************************************************************
function private.WindowShow( dialog_text_title, dialog_text, position )
    
  ObjSet( "txt_achievements_window_title", { text = dialog_text_title } );
  ObjSet( "txt_achievements_window", { text = dialog_text } );

  private.GRID_CORNER_W =  56;
  private.GRID_CORNER_H =  56;
  private.GRID_MID_W    =   8;
  private.GRID_MID_H    =   8;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 0;

  private.MIN_W = 380;
  private.MAX_W = 580;
  private.MIN_H = 180;
  private.MAX_H = 580;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_achievements_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_achievements_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;

  local dialog_pos_x = position[ 1 ] - dialog_w/2 - 90;

  if ( dialog_pos_x < 171 ) then

    dialog_pos_x = position[ 1 ] + dialog_w/2 + 90;
  
  end;
  
  local dialog_pos_y = position[ 2 ] - dialog_h/2;
  if ( dialog_pos_y - dialog_h < 0 ) then

    dialog_pos_y = dialog_h / 2;

  end;

  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "achievements_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_achievements_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

  local pos_x = - dialog_w / 2 + 19;
  local pos_y = dialog_h / 2 - 42;

  ObjSet( "spr_achievements_window_decor_left", { pos_x = pos_x, pos_y = pos_y } );
  ObjSet( "spr_achievements_window_decor_right", { pos_x = - pos_x, pos_y = pos_y } );


end;
--******************************************************************************************
function private.WindowHide( )
  
  ObjSet( "obj_achievements_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_achievements_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_achievements_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;
--******************************************************************************************
--function --**Open Big**-- () end;
--******************************************************************************************
function private.NoteScale( event, number )

  local small_pic = "spr_achievements_award_"..number;
  local big_pic   = "spr_achievements_award_"..number.."_big";
  local pos_array  = {};

  pos_array.start  = {};
  pos_array.finish = {};

  pos_array.start.pos_x = ObjGet( small_pic ).pos_x-512;
  pos_array.start.pos_y = ObjGet( small_pic ).pos_y-384;
  pos_array.finish.pos_x = 0;
  pos_array.finish.pos_y = 0;

  --if ( ObjGet(room).input == false ) then
    local trg_after = function()

      --local small_pic = source_name;
      --local big_pic   = "spr_"..common.GetObjectName( small_pic ).."_big";

      common_impl.Lock( false );
      if event == "open" then
        ObjSet( big_pic, { input = true } );
      else
        ObjAttach( big_pic, "obj_achievements_award_big_hub" );
        ObjSet( big_pic, { input = false, active = false, alp = 0, pos_x = pos_array.finish.pos_x, pos_y = pos_array.finish.pos_y } );
      end;  

    end;
  --end;
    if event == "open" then

      private.note_scale = {};
      ObjAttach( big_pic, "obj_achievements_award_big" );
      common_impl.Lock( true );

      private.note_scale.pos_x = pos_array.start.pos_x;
      private.note_scale.pos_y = pos_array.start.pos_y;

      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 1, 
      0.3, 0, 0 
      } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

      ObjSet( big_pic, { alp = 1, active = true, input = true, inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, inputrect_w = 2000, inputrect_h = 2000  } );
      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      {
      0.0, 3, pos_array.start.pos_x, pos_array.start.pos_y,
      0.3, 3, pos_array.finish.pos_x, pos_array.finish.pos_y 
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
      { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1 
      } );

    else

      common_impl.Lock( true );
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_out", 0, "", 0 ); 
  
      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 0, 
      0.3, 0, 1 
      } );

      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      { 
      0.0, 3, pos_array.finish.pos_x, pos_array.finish.pos_y,
      0.3, 3, private.note_scale.pos_x, private.note_scale.pos_y
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
      {
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
      } );

    end;

end;