-- name=rm_collectibles
--******************************************************************************************
function public.Init ()
-------------------------------------------------------------------------------------------- 
  private.ANIM_TIME = 0.2;
  private.count_item = 3;
  private.count_level = 4;
  private.count_mus = 12;
  
  private.mus_events = { "item_1_1", "item_1_3", "item_1_2", 
                         "item_3_3", "item_4_1", "item_4_2",
                         "item_2_3", "item_2_2", "item_4_3",
                         "item_3_2", "item_2_1", "item_3_1"
  
                       };
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  table.insert( table_multiset, { "obj_collectibles_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_collectibles_btn_exit_focus" ) end; } } );
      
  for i = 1, private.count_mus do
      
    table.insert( table_multiset, { "obj_collectibles_mus_"..i, { 
        event_mdown = function() private.SetSoundVolume( i, "off" ); end, 
        event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } } );
        
  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;
  -------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_collectibles = function ()

  local effects_table = 
  {
    "obj_collectibles_anims",                 
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_collectibles", update_performance_mode_collectibles, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--******************************************************************************************
function public.PreOpen ()

  cmn.CallEventHandler( "update_performance_mode_collectibles" );    
  --common_impl.PlayAudio( "env", "common/audio/aud_collectibles_1_env", 1, "", 0 );
  common_impl.EnvPlay( { "common/audio/aud_collectibles_1_env" }, "", 0.5 );
  common_impl.StopAllMus();
  
  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE 

    if ng_global.currentprogress == "std" then

      common_impl.Tutorial_Click( 'empty' );

    end;

  end;

  local table_multiset = {};

  for i = 1, private.count_level do

    local prg = "std";
    if ( i == private.count_level ) then
      prg = "ext";
    end;

    for j = 1, private.count_item do
    
      local event = "get_collect_item_"..i.."_"..j;
      if ( ng_global.collect[ event ] and not ng_global.collect[ event ].done )
      or ( not ng_global.collect[ event ] ) then
       
        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { visible = false } } );
         
        if private.IsVisible( i ) then
         
          table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_back", { visible = true } } );
          
        end;

      else

        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { visible = true } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_back", { visible = false } } );

      end;

    end;

  end;

  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter, -1 );

  if lvl == "t" or lvl == "r" then lvl = 4; end;

  lvl = tonumber( lvl );

  for i = 1, lvl do

    table.insert( table_multiset,  { "spr_collectibles_"..i.."_back", { visible = true } } );
    table.insert( table_multiset,  { "obj_collectibles_"..i, { visible = true } } );  

  end;
  
  for i = 1, private.count_mus do
  
    if ng_global.collect[ "get_collect_"..private.mus_events[i] ] and ng_global.collect[ "get_collect_"..private.mus_events[i] ].done then
     
      table.insert( table_multiset,  { "obj_collectibles_"..private.mus_events[i], { visible = true } } );
      table.insert( table_multiset,  { "spr_collectibles_"..private.mus_events[i].."_back", { visible = false } } );      
      table.insert( table_multiset,  { ObjGetRelations( "obj_collectibles_"..private.mus_events[i] ).parent, { visible = true } } );
       
    end;
   
  end;

  if( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset ); 
  end;

end;
--******************************************************************************************
function public.Open ()

   for i = 1, private.count_mus do
  
     if ng_global.collect[ "get_collect_"..private.mus_events[i] ] and ng_global.collect[ "get_collect_"..private.mus_events[i] ].done then
       
       private.SetSoundVolume( i, "on" );
       
       ObjSet( "obj_collectibles_mus_"..i, { input = true } );
        
       ObjSet( "anm_collectibles_"..private.mus_events[i], { frame = 0 } );
       
       AnimPlay( "anm_collectibles_"..private.mus_events[i], "DoAnim", "" );
       
     else
       
       private.SetSoundVolume( i, "off" );
       ObjSet( "obj_collectibles_mus_"..i, { input = false } );
       
     end;
     
       SndPlay( "assets/levels/common/audio/aud_mt_hymn_track_"..i.."_mus", "group_"..i, 1, 0, 0.5 );
    
   end; 
     
   private.SetSoundTimer();
 
end;
--******************************************************************************************
function public.Close ()

  common_impl.StopAudio( "env", "common/audio/aud_collectibles_1_env", 0.5 );
  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.ExitBonusRm();
    
  end;

  ObjSet( "tmr_common_anm", { active = true } );
  
  for i = 1, private.count_mus do
 
    SndStop( "assets/levels/common/audio/aud_mt_hymn_track_"..i.."_mus", "group_"..i, 0.5 );
    
  end;
 
 ObjSet( "tmr_collectibles_sound", { playing = false } ); 

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  if obj then

    common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

    local alp = ObjGet( obj ).alp;
    local time = 0.3;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,              0, alp, 
      time*( 1 - alp ), 0, 1
    } );

  end;

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  if obj then

    local alp = ObjGet( obj ).alp;
    local time = 0.3;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,        0, alp,
      time * alp, 0,   0 
    });

  end;

end;
--******************************************************************************************
--port.
function public.Hide()
  private.BtnCloseMouseDown(); --  public. or private.
end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

  if common.GetCurrentRoom() then 
   
    common.GotoRoom( common.GetCurrentRoom() );

  else

    common.GotoRoom( "rm_extra");

  end;

end;
--*********************************************************************************************************************
function private.SetSoundVolume( num, mode )

  local volume = GetSoundVolume( "soundtrack" );
  
  local time = 17.9833 - ObjGet( "tmr_collectibles_sound" ).time;
  
  if mode == "off" then
    
    volume = 0;
    
  end;
  
  SetSoundVolume( "group_"..num,  volume );
  
  local mode_new = "on";
  
  if mode == "on" then
    
    --DbgTrace( "time = "..time.."  frame = "..(time*60) );
    
    ObjSet( "anm_collectibles_"..private.mus_events[num], { frame = time*60, playing = true } );

    mode_new = "off";
    
  else
    
    ObjSet( "anm_collectibles_"..private.mus_events[num], { playing = false } );
 
  end;
  
  ObjSet( "obj_collectibles_mus_"..num, { event_mdown = function() private.SetSoundVolume( num, mode_new ); end } ); 

end;
--*********************************************************************************************************************
function private.SetSoundTimer()
  
  ObjSet( "tmr_collectibles_sound", { playing = true, time = 17.9833, endtrig = private.SetSoundTimer } );
  
end;
--*********************************************************************************************************************
function private.IsVisible( number )
  
  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter, -1 );

  if lvl == "t" or lvl == "r" then lvl = 4; end;

  lvl = tonumber( lvl );
  
  if tonumber(number) <= lvl then
    
    return true;
    
  else
    
    return false;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
ObjAnimate( "spr_collectibles_light_1", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------