-- name=rm_collectibles2
--******************************************************************************************
function public.Init()
-------------------------------------------------------------------------------------------- 
 private.fragments_count = 8;
 private.photos_count = 4;
--------------------------------------------------------------------------------------------
  local table_multiset = {};
  
  table.insert( table_multiset, {"obj_collectibles2_btn_exit", { 
    event_mdown = function () private.BtnCloseMouseDown() end, 
    event_menter = function () private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles2_btn_exit_focus" ) end, 
    event_mleave = function () private.BtnMouseLeave( "spr_collectibles2_btn_exit_focus" ) end } } );
    
    for i = 1, private.photos_count do
      
      table.insert( table_multiset, {"obj_collectibles2_clk_open_"..i, { 
        event_mdown = function () private.NoteScale( "open", i ) end, 
        event_menter = function () common_impl.SetCursor( CURSOR_LOUPE ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } } );
        
      table.insert( table_multiset, {"obj_collectibles2_photo_"..i.."_big", { 
        event_mdown = function () private.NoteScale( "close", i ) end, 
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } } );
 
      
    end;
  
  
  ObjMultiSet( table_multiset );

end;
--******************************************************************************************
function public.PreOpen()

  subroom.Close();
  common_impl.PlayAudio(  "mus", "common/audio/aud_ho_mus", 1 );
  --common_impl.PlayAudio( "env", "common/audio/aud_collectibles_2_env", 1, "", 0 );
  common_impl.EnvPlay( { "common/audio/aud_collectibles_2_env" }, "", 0.5 );
  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE

    if ng_global.currentprogress == "std" then

      common_impl.Tutorial_Click( 'empty' );

    end;
    
  end;
  
  private.SetFragmentsVisible();

end;
--******************************************************************************************
function public.PreClose()
  
end;
--******************************************************************************************
function public.Close()

  common_impl.StopAudio(  "mus", "common/audio/aud_ho_mus", 1 );
  common_impl.StopAudio( "env", "common/audio/aud_collectibles_2_env", 0.5 );
  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.ExitBonusRm();
    
  end;

  ObjSet( "tmr_common_anm", { active = true } );

end;
--******************************************************************************************
--******************************************************************************************
--******************************************************************************************
--port.
function public.Hide()
  private.BtnCloseMouseDown(); --  public. or private.
end;
--------------------------------------------------------------------------------------------
function private.BtnCloseMouseDown()

  if common.GetCurrentRoom() then 
   
    common.GotoRoom( common.GetCurrentRoom() );

--    if int_map_impl.show == true then
--
--      interface.WidgetSetVisible( InterfaceWidget_Map, true, true, 1.0 );   
--      interface.WidgetSetInput( InterfaceWidget_Map, true ); 
--
--    else
--
--      interface.WidgetSetVisible( InterfaceWidget_Map, true );   
--      interface.WidgetSetInput( InterfaceWidget_Map, true );   
--
--    end;  

  else

    common.GotoRoom( "rm_extra");

  end;

   
end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.SetFragmentsVisible()
  
  AnimPlay( "anm_collectibles2_photo_1_2", "DoAnim", "" );

  for i = 1, private.photos_count do
    
    local count = 0;
    
    for j = 1, private.fragments_count do
      
      if common_impl.IsGetCollect( "get_collect_2_"..i.."_"..j ) then
        
        ObjSet( "spr_collectibles2_photo_"..i.."_"..j, { visible = true } );
        ObjSet( "spr_collectibles2_photo_"..i.."_"..j.."_big", { visible = true } );
        ObjSet( "spr_collectibles2_photo_"..i.."_"..j.."_big_shadow", { visible = true } );
        
        count = count + 1;
        
        if ng_global.collectibles2.fragments_anim[i][j] == 0 then
          
          local func_after = function()
          
            common_impl.Lock( false );
    
            ObjSet( "spr_collectibles2_photo_"..i.."_"..j, { pos_z = 0 } );
          
            ng_global.collectibles2.fragments_anim[i][j] = 1;
            
            local params = ObjGet( "spr_collectibles2_photo_"..i.."_"..j );
            
            ObjClone( "anm_collectibles2_photo_find", "_"..i.."_"..j, 1, "obj_collectibles2_photo_"..i );
            
            ObjSet( "anm_collectibles2_photo_find_"..i.."_"..j, { alp = 1, playing = true, pos_x = params.pos_x, pos_y = params.pos_y,
                                                  endtrig = function() ObjDelete( "anm_collectibles2_photo_find_"..i.."_"..j ); end } );
                                                  
            if not common_impl.CheckSoundPlaying( "sfx", "common/audio/aud_collectibles_2_show_new" ) then
            
              common_impl.PlayAudio( "sfx", "common/audio/aud_collectibles_2_show_new", 0, "", 0 );
              common_impl.SetSoundTimer( 4, "sfx", "common/audio/aud_collectibles_2_show_new", 0.3 );
 
            end;
          
            
            if count == 8 then
      
              private.AnimFullPhoto( i );
      
            end;
          
          end;
          
          common_impl.Lock( true );
          
          local params = ObjGet( "spr_collectibles2_photo_"..i.."_"..j );
 
          ObjSet( "spr_collectibles2_photo_"..i.."_"..j, { pos_z = 5, pos_y = params.pos_y - 10 } );
           
          ObjAnimate( "spr_collectibles2_photo_"..i.."_"..j, "pos_y", 0, 0, func_after, { 0,0,( params.pos_y - 10 ), 0.5,0,params.pos_y } );
       
        else
          
          ObjSet( "spr_collectibles2_photo_"..i.."_"..j, { alp = 1 } );
          
          if count == 8 and ng_global.collectibles2.show_anim[i] then
            
            ObjSet( "spr_collectibles2_photo_"..i.."_full", { alp = 1 } );
            ObjSet( "anm_collectibles2_photo_"..i, { alp = 0 } );
            ObjSet( "spr_collectibles2_photo_"..i.."_big_full", { visible = true } );
            
          end;
 
        end;
      
      end;
      
    end;
    
  end;

end;
--******************************************************************************************
function private.AnimFullPhoto( i )
  
  if not ng_global.collectibles2.show_anim[i] then
      
    local func_after = function()
    
      common_impl.Lock( false );
      
      ng_global.collectibles2.show_anim[i] = true;

    end;
    
    common_impl.Lock( true );
    
    ObjSet( "anm_collectibles2_photo_"..i, { alp = 1 } );
    
    AnimPlay( "anm_collectibles2_photo_"..i, "DoAnim", func_after );
    
  else
    
    ObjSet( "spr_collectibles2_photo_"..i.."_full", { alp = 1 } );
    ObjSet( "anm_collectibles2_photo_"..i, { alp = 0 } );
    
  end;
  
  ObjSet( "spr_collectibles2_photo_"..i.."_big_full", { visible = true } );
  
end;
--******************************************************************************************
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--******************************************************************************************
--function --**Open Big**-- () end;
--******************************************************************************************
function private.NoteScale( event, number )

  local small_pic = "obj_collectibles2_photo_"..number;
  local big_pic   = "obj_collectibles2_photo_"..number.."_big";
  local pos_array  = {};

  pos_array.start  = {};
  pos_array.finish = {};

  --pos_array.start.pos_x = ObjGet( small_pic ).pos_x;
  --pos_array.start.pos_y = ObjGet( small_pic ).pos_y;
  
  pos_array.start.pos_x = GetObjPosByObj( "obj_collectibles2_clk_open_"..number )[1]-512;
  pos_array.start.pos_y = GetObjPosByObj( "obj_collectibles2_clk_open_"..number )[2]-384;
  pos_array.finish.pos_x = 0;
  pos_array.finish.pos_y = 0;

    local trg_after = function()

      common_impl.Lock( false );
      
      if event == "open" then
        ObjSet( big_pic, { input = true } );
      else
        ObjAttach( big_pic, "obj_collectibles2_photos_big" );
        ObjSet( big_pic, { input = false, active = false, alp = 0, pos_x = pos_array.finish.pos_x, pos_y = pos_array.finish.pos_y } );
      end;  

    end;
 
    if event == "open" then

      private.note_scale = {};
      ObjAttach( big_pic, "obj_collectibles2_photos_big" );
      common_impl.Lock( true );

      private.note_scale.pos_x = pos_array.start.pos_x;
      private.note_scale.pos_y = pos_array.start.pos_y;

      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 1, 
      0.3, 0, 0 
      } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

      ObjSet( big_pic, { alp = 1, active = true, input = true, inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, inputrect_w = 2000, inputrect_h = 2000  } );
      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      {
      0.0, 3, pos_array.start.pos_x, pos_array.start.pos_y,
      0.3, 3, pos_array.finish.pos_x, pos_array.finish.pos_y 
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
      { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1 
      } );

    else

      common_impl.Lock( true );
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_out", 0, "", 0 ); 
  
      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 0, 
      0.3, 0, 1 
      } );

      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      { 
      0.0, 3, pos_array.finish.pos_x, pos_array.finish.pos_y,
      0.3, 3, private.note_scale.pos_x, private.note_scale.pos_y
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, trg_after, 
      {
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
      } );

    end;

end;
--------------------------------------------------------------------------------------------
ObjAnimate( "spr_collectibles2_light", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );