-- name=rm_credits
--******************************************************************************************
function public.Init()

  private.room_objname="rm_credits";

  private.screen_current = 0;

  private.screen_max = 24;
  private.screen_countline = { 3, 7, 4, 5, 7, 6, 6, 4, 4, 3, 6, 6, 6, 6, 4, 4, 6, 3, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3 };

  SetCursor(CURSOR_DEFAULT);

  ObjSet("obj_credits_btn_quit", {
    event_mdown = function () private.QuitClk(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end
  }); 

end;
--******************************************************************************************
function public.PreOpen()

  private.screen_old = 0;
  private.screen_over = false;
  
  ObjSet( "rm_credits", { alp = 1 });

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );
  
  common_impl.PlayAudio( "env", "common/audio/aud_credits_env", 1, "", 0 );

  if IsCollectorsEdition() then

    ObjSet( "spr_credits_colectorsedition", { visible  = 1, alp = 1 } );

  else

    ObjSet( "spr_credits_colectorsedition", { visible = 0 } );

  end;

  ObjSet( "obj_credits_btn_quit", { alp = 0, input = 0 } );

  for i = 1, private.screen_max do

    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

  ObjSet( "txt_credits_title_1", { alp = 0 } );
  ObjSet( "txt_credits_title_2", { alp = 0 } );

end;
--******************************************************************************************
function public.Load()
end;
--******************************************************************************************
function public.Open()

  private.current_room = common.GetCurrentRoom();

  private.screen_current = 1;

  private.Screen();

  local func_end = function ()

    ObjSet( "obj_credits_btn_quit", { alp = 1, input = 1 } );

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,  0,  0, 
    0.5,  0,  0, 
    1.0,  0,  1 
  });

  common_impl.StopAllMus();
  common_impl.PlayAudio(  "mus", "common/audio/aud_credits_mus", 1 );

end;
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true );
  interface.InterfaceSetVisible( true );

  for i = 1, private.screen_max do

    ObjStopAnimate( "obj_credits_screen_"..i, "alp" );
    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

  common_impl.StopAudio( "mus", "common/audio/aud_credits_mus", 1 );
  common_impl.StopAudio( "env", "common/audio/aud_credits_env", 0.5 );

end;
--******************************************************************************************
function public.PreClose()

  --

end;
--******************************************************************************************
function private.Screen ()

  ObjSet( "rm_credits", { input = true } );

  local line_time = 1.7;
  local time = 0;

  local func_exit = function ()

    private.Exit();
  
  end;

  local func_continue = function ()

    private.Screen();
  
  end;

  if private.screen_current > 1 then

    ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, "", { 
      0,  0,  1, 
      1,  0,  0, 
    })

    private.screen_current = private.screen_current + 1;
    if private.screen_old == 7 and private.screen_current==8 then
      private.screen_current = 18;
      private.screen_old = 18;
      private.screen_over = true;
    elseif private.screen_current > private.screen_max then
      private.screen_current=8;
      private.screen_old = 8;
      private.screen_over = false;
    else
      private.screen_old = private.screen_current;
    end;

    if private.screen_current > 17 and private.screen_over == false then

      ObjAnimate( "rm_credits", "alp", 0, 0, func_exit, { 0,0,1, 2,0,0 });

    else

      time = private.screen_countline[ private.screen_current ] * line_time;

      ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
        0,     0,  0, 
        1,     0,  0, 
        1.5,   0,  1,
        time,  0,  1 
      });

    end;

    if private.screen_current == 8 then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,   0, 1,   
        0.5, 0, 0 
      });

      ObjAnimate( "txt_credits_title_2", "alp", 0, 0, "", { 
        0,   0, 0,   
        1.0, 0, 1 
      });

    elseif private.screen_current == 17 then

      ObjAnimate("txt_credits_title_2", "alp", 0, 0, "", { 
        0,0,1, 
        0.5,0,0 
      });

    end;

  else

    if private.screen_current == 1  then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,0,0, 
        1,0,1 
      });

    end;

    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, "", { 
      0,  0,  0, 
      1,  0,  1, 
      4,  0,  1, 
      5,  0,  0 
    });
    
    private.screen_current = private.screen_current + 1;

    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
      0,  0,  0, 
      5,  0,  0, 
      6,  0,  1, 
      9, 0,  1 
    });

  end;

end;
--******************************************************************************************
function private.ButtonMouseEnter ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_HAND );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,               0,    alp, 
    tme *( 1 - alp ),  0,    1
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_DEFAULT );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,       0,  alp, 
    tme * alp, 0,    0
  } );

end;
--******************************************************************************************
function private.QuitClk ()

  ObjSet( "rm_credits", { input = 0 } );

  ObjStopAnimate( "obj_credits_screen_"..private.screen_current, "alp" );

  local func_end = function ()

    private.Exit();

  end;

  ObjAnimate("obj_credits_screen_"..private.screen_current - 1, "alp", 0, 0, "", { 
    0,    0,  ObjGet( "obj_credits_screen_"..private.screen_current-1 ).alp, 
    0.5,  0,  0 
  });

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,    0,  1, 
    0.5,  0,  1, 
    0.8,  0,  0 
  });

  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu" );

end;
--******************************************************************************************
--port. fix 
function public.Exit()
  private.Exit();
end;
--******************************************************************************************
function private.Exit ()

  if not prg then

    prg = {};
    prg.current = ng_global.currentprogress;  

  end;

  local flag = true;

  if prg.current == "std" then 

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "std" ][ "vid_roof_final" ] and 
       cmn.IsEventDone( "vid_roof_final" )  then
        private.Skip();
        flag = false;

    end;

  elseif prg.current == "ext" then

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "ext" ][ "vid_secondroom_autro" ] and
       cmn.IsEventDone( "vid_secondroom_autro" ) then
        
      private.SkipExt();
      flag = false;
      
    end;

  end;

  common_impl.StopAllMus();

  if ( not private.current_room ) then

    private.current_room = "rm_menu";

  end;

  if ( flag ) then

    common.GotoRoom( private.current_room );

  end;

end;
--******************************************************************************************
function private.Skip ()

  if IsCollectorsEdition() then

    ng_global.progress[ "std" ].common.gamewin   = true; 
    ng_global.progress[ "std" ].common.gamestart = false;

  end;

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SkipExt ()

  ng_global.progress[ "ext" ].common.gamewin   = true; 
  ng_global.progress[ "ext" ].common.gamestart = false;

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
