-- name=rm_extra
--******************************************************************************************
function public.Init()

  ObjSet( "btn_extra_wallpapers", 
    {
      event_mdown =  function () private.ChangeScreen( "wallpapers" ); end
    } 
  );

  ObjSet( "btn_extra_conceptart", 
    {
      event_mdown =  function () private.ChangeScreen( "conceptart" ); end
    } 
  );

  ObjSet( "btn_extra_music", 
    {
      event_mdown =  function () private.ChangeScreen( "music" ); end
    } 
  );

  ObjSet( "btn_extra_bonus_chapter", 
    {
      event_mdown =  function () private.ChangeScreen( "bonus_chapter" ); end
    } 
  );

  ObjSet( "spr_extra_play_now", 
    {
      event_mdown =  function () private.BonusChapterPlay(); end
    } 
  );
  
  ObjSet( "btn_extra_mainmenu", 
    {
      event_mdown =  function () common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 ); common.GotoRoom( "rm_menu" ); end
    } 
  );
  
  ObjSet( "btn_extra_achievements", 
    {
      event_mdown =  function () common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 ); common.GotoRoom( "rm_achievements" ); end
    } 
  );
  
  ObjSet( "btn_extra_collectibles", 
    {
      event_mdown =  function () common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 ); common.GotoRoom( "rm_collectibles" ); end
    } 
  );
  ObjSet( "btn_extra_collectibles_2", 
    {
      event_mdown =  function () common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 ); common.GotoRoom( "rm_collectibles2" ); end
    } 
  );
  ObjSet( "btn_extra_change_lft", 
    {
      event_mdown =  function () private.ArrowClick( true ) end,
      event_menter = function () private.ButtonMouseEnter( "change_lft" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_lft" ); end
    } 
  );
  ObjSet( "btn_extra_change_rgt", 
    {
      event_mdown =  function () private.ArrowClick( false ) end,
      event_menter = function () private.ButtonMouseEnter( "change_rgt" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_rgt" ); end
    } 
  );

  --ObjSet( "btn_extra_set", 
  --  {
  --    event_mdown =  function () private.ButtonSetClick() end,
  --    event_menter = function () private.ButtonMouseEnter( "set" ); end,
  --    event_mleave = function () private.ButtonMouseLeave( "set" ); end
  --  } 
  --);

  ObjSet( "btn_extra_save", 
    {
      event_mdown =  function () private.ButtonSaveClick() end
    } 
  );

  ObjSet( "btn_extra_secretroom", 
    {
      --event_mdown =  function () private.ChangeScreen( "secretroom" ) end, 
      event_mdown =  function () private.SecretRoomPlay() end
    } 
  );

  --local saveart = { left = nil, center = { text = "ok", func = "save" }, right = nil };
  --local setwallpaper = 
  common.dialog.common.buttons[ "savemusic" ] = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "saveart" ] = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "setwallpaper" ] = { left = { text = "ok", func = "set" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "unlockextra" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
  common.dialog.common.buttons[ "unlocksecret" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
  common.dialog.common.buttons[ "demoextra" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };

  --table.insert ( common.dialog.common.buttons,
  --                setwallpaper
  --              )

  local set_table = {};

  for i = 1,6 do

    table.insert( set_table, {"btn_extra_music_"..i, 
      {
      event_mdown = function() private.BtnMusicPlay( i ); end
      } 
    } );

  end;

  ObjMultiSet( set_table );

  private.current_screen = "wallpapers";  
  private.wallpapers = {};
  private.wallpapers.current_number = 1;
  private.wallpapers.MAX_COUNT = 8;
  private.conceptart = {};
  private.conceptart.current_number = 1;
  private.conceptart.MAX_COUNT = 8;
  private.music = {};
  private.music.current_number = 1;
  private.music.MAX_COUNT = 6;
  private.music.is_playing = "";
  private.StartAnims();
  --private.music.light_pos = { -70, -8, 56, -70, -8, 56 }
  private.music.light_pos = { -23, 41, 108, -23, 41, 108 }
  ObjSet( "txt_extra_play_number_1", { text = "1" } );
  ObjSet( "txt_extra_play_number_2", { text = private.wallpapers.MAX_COUNT } );
  
  
  if port.ios_lang() == "ja" or port.ios_lang() == "ru" then
    ObjSet("txt_extra_music_1",{ fontsize = 20 });
    ObjSet("txt_extra_music_2",{ fontsize = 20 });
    ObjSet("txt_extra_music_3",{ fontsize = 20 });
    ObjSet("txt_extra_music_4",{ fontsize = 20 });
    ObjSet("txt_extra_music_5",{ fontsize = 20 });
    ObjSet("txt_extra_music_6",{ fontsize = 20 });
  end;
  
end;
--******************************************************************************************
function public.PreOpen()

  ObjSet( "obj_extra_screen", { alp = 1 } );

  common_impl.EnvPlay( { "common/audio/aud_bonus_env" }, "", 0.5 );
   
  --if ( ng_global.progress[ "std" ].common.gamewin ) then
  --  ObjSet( "btn_extra_bonus_chapter", { color_r = 1.0, color_g = 1.0, color_b = 1.0, input = true } );
  --else
  --  ObjSet( "btn_extra_bonus_chapter", { color_r = 0.5, color_g = 0.5, color_b = 0.5, input = false } );
  --end;
  
  --if not common_impl.CheckMusPlaying() then
  --  
  --  common_impl.PlayAudio(  "mus", "common/audio/aud_maintheme_mus", 1 );
  --  
  --end;

end;
--******************************************************************************************
function public.Open()

 

end;

function public.Close()

  private.SoundStop();
  ObjSet( "obj_extra_screen", { alp = 0} );
  ObjSet( "anm_extra_menu", { playing = false, alp = 0 } );
  ObjSet( "spr_extra_lamp", { active = false } ); 

end;
--******************************************************************************************

function private.SoundStop()

  if private.music.is_playing ~= "" then

    common_impl.StopAudio( "mus",  "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 )
    ObjMultiSet( {
                   { "spr_extra_stop_"..private.music.is_playing , { alp = 0 } };
                   { "spr_extra_play_"..private.music.is_playing , { alp = 1 } };                 
                 } );
    private.music.is_playing = "";

  end;

end;
--******************************************************************************************
function private.ChangeScreen ( new_screen )
  
  if ( private.current_screen == new_screen ) then
    return;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 );

  ------------------------------------

  if ( private.current_screen == "music" ) or ( new_screen == "music" ) then
    
    --ObjSet( "btn_extra_set", { input = true, alp = 1 });

      if private.current_screen ~= "music" then

        private.current_screen = new_screen;
        --ObjSet( "btn_extra_set", { input = false, alp = 0 });
        ObjSet( "btn_extra_save", { input = false, alp = 0 });
      end;  

      if private[new_screen] and private[new_screen].current_number then

        ObjMultiSet( {
                     { "obj_extra_music_list_"..( math.floor( private[new_screen].current_number/4 ) + 1 ), { visible = true, input = true } },
                     { "spr_extra_window_picture", { visible = false } }, 
                     { "obj_extra_music_list", { visible = true, input = true } }, 
                     { "txt_extra_play_number_1", { text = private[new_screen].current_number } },
                     { "txt_extra_play_number_2", { text = private[new_screen].MAX_COUNT } },
                     { "spr_extra_play_now", { input = false, alp = 0 } },
                     { "obj_extra_numbers", { visible = true, alp = 1 } },
                     { "btn_extra_change_lft", { input = true } },
                     { "btn_extra_change_rgt", { input = true } }                 
                   } );
      end;
 
  end;

  ------------------------------------

  if ( new_screen == "bonus_chapter" ) then

    if ng_global.progress[ "std" ].common.gamewin then

      local func_end = function ()

        private.current_screen = new_screen;

      end;

      local func_change = function ()

        if ( new_screen == "bonus_chapter" ) then
          
          ObjSet( "spr_extra_play_now", { input = true } );
          ObjSet( "spr_extra_window_picture", { visible = true,
                                              res = "assets/levels/menu/rm_extra/layers/bonus_level"
                                              } );
          ObjSet( "obj_extra_music_list", { input = false, visible = false } );
          ObjSet( "obj_extra_numbers", { visible = false } );
          ObjSet( "btn_extra_change_lft", { input = false } );
          ObjSet( "btn_extra_change_rgt", { input = false } );

          ObjAnimate( "spr_extra_play_now", "alp", 0, 0, func_end,
          {
            0.0, 0, 0,
            0.2, 0, 1
          } );

        else

          ObjSet( "spr_extra_play_now", { input = false, alp = 0 } );
      
        end;

        --ObjSet( "txt_extra_play_number_1", { res = "assets/levels/menu/rm_extra/layers/"..private[new_screen].current_number } );
      
        --ObjAnimate( "spr_extra_play_now", "alp", 0, 0, func_end,
        --{
        --  0.0, 0, 0,
        --  0.2, 0, 1
        --} );

      end;
    

      ObjAnimate( "obj_extra_numbers", "alp", 0, 0, func_change,
      {
        0.0, 0, 1,
        0.2, 0, 0
      } );

    else

      common.DialogWindowShow( "common", "unlockextra" );

    end;

  end;

  ------------------------------------

  if not ( private.current_screen == "wallpapers" ) and ( new_screen == "wallpapers" ) or
    not ( private.current_screen == "conceptart" ) and ( new_screen == "conceptart" ) then
      
    ObjSet( "btn_extra_save", { input = true, alp = 1 });
      
      private.SoundStop();

       ObjMultiSet( {
                   { "obj_extra_music_list_1", { input = false, visible = false } },
                   { "obj_extra_music_list_2", { input = false, visible = false } }, 
                   { "obj_extra_music_list", { visible = false, input = false } },
                   { "spr_extra_play_now", { input = false, alp = 0 } },
                   { "obj_extra_numbers", { visible = true, alp = 1 } },
                   { "txt_extra_play_number_2", { text = private[new_screen].MAX_COUNT } }, 
                   { "btn_extra_change_lft", { input = true } },
                   { "btn_extra_change_rgt", { input = true } }        
                  } );
                   

      common_impl.Lock( true );

      local anm_after = function ()

         local func_after = function ()

            common_impl.Lock( false );

         end; 

         ObjSet( "spr_extra_window_picture", 
         { 
            visible = true;
            res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number
         } );

       
          ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );

          if not ( new_screen == "bonus_chapter" ) then
            ObjSet( "txt_extra_play_number_1", { text = private[new_screen].current_number } );
            private.current_screen = new_screen;
          end;

      end;

      ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.2,0,0 } );

  end;

  
  ------------------------------------

  if ( new_screen == "secretroom" ) then

    private.ButtonSecretroom();

  end;

end;
--******************************************************************************************
function private.ArrowClick ( direction )

  local new_res = 1;

  if not direction then

    if private[private.current_screen].current_number < private[private.current_screen].MAX_COUNT then

      new_res = private[private.current_screen].current_number + 1;

    end;

  else 

    if private[private.current_screen].current_number == 1 then

      new_res = private[private.current_screen].MAX_COUNT;

    else

      new_res = private[private.current_screen].current_number - 1;      

    end;

  end;

  local func_after = function()

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_change", 0, "", 0 );

  if direction == true then

    --ObjAnimate( "spr_extra_change_lft", "ang", 0, 0, func_after, { 0,0,0, 0.2,0,0.24, 0.4,0,0 } );
     func_after();
  elseif direction == false then

     --ObjAnimate( "spr_extra_change_rgt", "ang", 0, 0, func_after, { 0,0,0, 0.2,0,-0.24, 0.4,0,0 } );
    func_after();
  end;

  if private.current_screen == "music" then

    private.BtnMusicPlay( new_res );
    
  else

    common_impl.Lock( true );

    local anm_after = function ()

      local func_after = function ()

        common_impl.Lock( false );
        private[private.current_screen].current_number = new_res;

      end;

      ObjSet( "spr_extra_window_picture",
      {
        res = "assets/levels/menu/rm_extra/layers/"..private.current_screen.."/mini/"..new_res
      } );
     
      ObjSet( "txt_extra_play_number_1", { text = new_res } );
     
      ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 });

    end;

    ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.2,0,0});

  end;

end;
--******************************************************************************************
function private.BtnMusicPlay( track_number )

    ObjMultiSet( {
                 { "obj_extra_music_list_"..( math.floor( track_number/4 ) + 1 ), { visible = true, input = true } },
                 { "obj_extra_music_list_"..( 2 - math.floor( track_number/4 ) ), { visible = false, input = false } }, 
                 { "txt_extra_play_number_1", { text = track_number } }
                } );
 
  if private.music.is_playing == "" then

      ObjMultiSet( {
                 { "spr_extra_stop_"..track_number , { alp = 1 } },
                 { "spr_extra_play_"..track_number , { alp = 0 } }               
                } );
     
      private.music.current_number = track_number;
      private.music.is_playing = track_number;
  
      common_impl.PlayAudio( "mus", "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 );
     
      ObjAnimate( "spr_extra_music_choise_light", "pos_y", 0, 0, function() common_impl.Lock( false ); end, {0, 0, private.music.light_pos[private.music.current_number], 
                                                                                                           0.6, 0, private.music.light_pos[track_number]});
      common_impl.Lock( true );

  else

    common_impl.StopAudio( "mus",  "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 )

    local func_after;

    if private.music.is_playing == track_number then

       func_after = function ()
   
       ObjMultiSet( {
               { "spr_extra_play_"..private.music.is_playing , { alp = 1 } },
               { "spr_extra_stop_"..private.music.is_playing , { alp = 0 } }               
              } );

       private.music.current_number = track_number;
       private.music.is_playing = "";

      end;

    else

      func_after = function ()

        ObjMultiSet( {
               { "spr_extra_play_"..private.music.is_playing , { alp = 1 } },
               { "spr_extra_stop_"..private.music.is_playing , { alp = 0 } }               
              } );
        private.music.is_playing = "";
        private.BtnMusicPlay( track_number )

      end;

    end;

    func_after();

  end;

end;
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_extra_"..but_name.."_focus";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_extra_"..but_name.."_focus";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.ButtonSetClick()

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 );

  if IsDemoEdition() then

    common.DialogWindowShow( "common", "demoextra" );

    PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  elseif private.current_screen == "conceptart" or private.current_screen == "wallpapers"  then

    common.DialogWindowShow( "common", "setwallpaper" );

    PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  end;

end;
--******************************************************************************************
function private.ButtonSaveClick()

   common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 );

  if IsDemoEdition() then

    common.DialogWindowShow( "common", "demoextra" );

    PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  elseif private.current_screen == "music" then

    common.DialogWindowShow( "common", "savemusic" );

    PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  elseif private.current_screen == "conceptart" or private.current_screen == "wallpapers"  then

    common.DialogWindowShow( "common", "saveart" );

    PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  else

  end;

end;
--******************************************************************************************
function private.ButtonSecretroom()

  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu" );
  SetCursor( CURSOR_DEFAULT );

--  if ng_global.progress[ "secretroom" ].common.gamewin == true  then
--    
--    common.DialogWindowShow( "common", "finishsecretroom", true )
--
--  elseif ng_global.progress[ "ext" ].common.gamewin == true then
--
--    private.SecretRoomPlay(); 
--
--  else
--
--    if IsDemoEdition() == 1 or IsSurveyEdition() == 1 then
--
--      common.DialogWindowShow( "common", "demoextra" );
--
--    else
--    
--      common.DialogWindowShow( "common", "unlocksecret" );
--
--    end;
--   
--  end;

end;
--******************************************************************************************
function private.SecretRoomPlay () 

  if not IsDemoEdition() then

    common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 );

    if ng_global.progress[ "ext" ].common.gamewin then

      local prg = "scr";
      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlocksecret" );

      PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

    end;

  else

      common.DialogWindowShow( "common", "demoextra" );

      PlaySfx( "assets/levels/common/audio/aud_hint_txt_sfx", 0, 0 );

  end;
 
end;
--******************************************************************************************
function private.BonusChapterPlay () 

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click", 0, "", 0 );

  ng_global.currentprogress = "ext";

  if ( not ng_global.progress[ "ext" ].common.gamestart ) then
    ng_global.progress[ "ext" ].common.gamestart = true;
  end;

  SetCursor( CURSOR_DEFAULT );
  local level = ng_global.progress[ "ext" ].common.chapter;
  cmn.is_inmenunow = false;
  common.LevelSwitch( level );

end;

--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

  ObjAnimate( "spr_extra_lamp", "alp", 1, 0, "",
  { 
    0.0, 0, 0,
    0.5, 0, 1.0,
    1.0, 0, 0
    
  } );

end;

function common.dialog.common.save() 

  if private.current_screen == "music" then

    
    --.port fix 
      if (port.isPortable() == 1) then
        CopySoundFileToMyDocs( "assets/levels/menu/rm_extra/layers/music/soundtrack_"..private[private.current_screen].current_number );
      else
        CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/music/soundtrack_"..private[private.current_screen].current_number..".mp3" );
      end;

  elseif private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/conceptart"..private[private.current_screen].current_number );

  else

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/wallpapers/wallpapers"..private[private.current_screen].current_number );

  end;

  common.DialogWindowHide( "common" );

end;

function common.dialog.common.set()

  if private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/conceptart"..private[private.current_screen].current_number );

  elseif private.current_screen == "wallpapers" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/wallpapers/wallpapers"..private[private.current_screen].current_number );

  end;

  common.DialogWindowHide( "common" );

end;