-- name=rm_intro
--******************************************************************************************
-- для добавления нового лого достаточно добавить его название в массив private.logo
--******************************************************************************************
private.counter = 0;
private.obj = {"bfg","eg","music"};
private.size_back = { { 256, 192 },{ 2,2 }, {1024,768} };
private.size_logo = { { 680, 636 },{ 624,241 }, {1024,768} };
private.activeLogo = 0;
private.w = 0;
private.h = 0;
--******************************************************************************************
function public.Init()

  --port. fix
  ObjCreate("empty_obj", "spr");
  ObjSet( "empty_obj", { res = "assets/levels/menu/rm_intro/ce" } );
  ObjAttach( "empty_obj", "ng_interface_internal"); 
  ObjSet( "empty_obj", { pos_y = -50 } );

  ObjSet( "obj_intro_logo", 
  { 
  inputrect_w = 1024,
  inputrect_h = 768
  } );
  
  if tostring(GetPlatform()) == "ios" then
    local appSize = GetAppSize();
    --DbgTrace("appSize w:"..tostring(appSize.w).." h:"..tostring(appSize.h));
    private.w = appSize.w;
    private.h = appSize.h;
  else
    private.w = GetScreenSize().w;
    private.h = GetScreenSize().h;
  end;
    
  room.Define( "rm_intro" );
  private.UpdateLogoToNextRes();
  
  MsgSend(Command_Level_Loaded);

end;
--******************************************************************************************
function public.Open()

  if tostring(GetPlatform()) == "ios" then
      if iOS_IsGameCanStart() == 1 then
          private.IntroLogoShow();
      else
          ObjSet("tmr_intro_gamecanstart", {endtrig = function() private.IsGameCanStartTimer(); end, time = 1, playing = 1 });
      end;
  else
      private.IntroLogoShow();
  end;

end;
--******************************************************************************************
  
function private.IsGameCanStartTimer()
    if iOS_IsGameCanStart() == 1 then
        private.IntroLogoShow();
    else
        ObjSet("tmr_intro_gamecanstart", {endtrig = function() private.IsGameCanStartTimer(); end, time = 1, playing = 1 });
    end;
end;
--******************************************************************************************
function private.UpdateLogoToNextRes()
  
  private.counter = private.counter + 1;
  ObjSet( "spr_intro_logo_back", 
  { 
    res = "assets/levels/menu/rm_intro/back_"..private.obj[private.counter],
    scale_x = (1024 / private.size_back[private.counter][1]), 
    scale_y = (768 / private.size_back[private.counter][2])
  } );
  
  ObjSet( "spr_intro_logo", { res = "assets/levels/menu/rm_intro/logo_"..private.obj[private.counter] } );
    
  if private.h>private.w then
    local t = private.w;
    private.w = private.h;
    private.h = t;
  end;  
  
  local ratio = private.size_logo[private.counter][1]/private.size_logo[private.counter][2];
  
  local sX = private.w/1024;
  local sY = private.h/768;
  
  local outSize = {};
  outSize[1] = sX * private.size_logo[private.counter][1];
  outSize[2] = sY * private.size_logo[private.counter][2];
  local outNeedSizeX = outSize[2] * ratio;
  local needScaleX = outNeedSizeX / outSize[1];
  
  DbgTrace("w:"..tostring(private.w).." h:"..tostring(private.h).." sX:"..tostring(sX).." sY:"..tostring(sY).." ScaleX:"..tostring(needScaleX));
  if (private.obj[private.counter] == "sound") or (private.obj[private.counter] == "music") then
    needScaleX = 1;
  end;
  ObjSet( "spr_intro_logo", 
    { 
    scale_x = needScaleX
    } );
  
  ObjSet("obj_intro_logo", {
    input = false,
    event_mdown = private.IntroLogoHide,
    alp = 0, 
    active = true
  });
  
end;
--******************************************************************************************
function private.IntroLogoShow()

  ObjAnimate( "obj_intro_logo", "alp", 0, 0 ,private.IntroLogoActivate, { 0,0,0, 0.8,0,1 } );

end;
--******************************************************************************************
function private.IntroLogoActivate()

  ObjSet( "obj_intro_logo", { input = true } );
  ObjStopAnimate( "obj_intro_logo", "alp" );
  ObjAnimate( "obj_intro_logo", "alp", 0, 0, private.IntroLogoHide, { 0,0,1, 1.5,0,1 } );
  
  
end;
--******************************************************************************************
function private.IntroLogoHide()

  local trg = function () 
    private.UpdateLogoToNextRes();
    private.IntroLogoShow(); 
  end;
  if private.counter == #private.obj then
    trg = private.IntroVideoPlay;
  end;
  ObjSet( "obj_intro_logo", { input = false } );
  ObjStopAnimate( "obj_intro_logo", "alp" );
  ObjAnimate( "obj_intro_logo", "alp",0 ,0, trg, { 0,0,1, 0.8,0,0 } );

end;
--******************************************************************************************
function private.IntroVideoPlay()

  interface.DialogVideoShow( "obj_intro_video", 1, function() private.IntroVideoEnd( 'skip' ); end );
  VidPlay( "vid_intro_video", function() private.IntroVideoEnd( nil ); end );
  
  
   common_impl.PlayAudio( "sfx", "common/audio/aud_preintro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_preintro_voc", 0, "", 0 );

  
end;--******************************************************************************************
function private.IntroVideoEnd( skip )

 
  

  interface.DialogVideoHide();
  ObjAttach( "tmr_intro_videoend", "cmn_timers" );

  if skip then  

     common_impl.StopAudio( "sfx", "common/audio/aud_preintro", 0, "", 0 );
    common_impl.StopAudio( "voc", "common/audio/aud_preintro_voc", 0, "", 0 );
    
  end;

  local funcVideoEnd = function () 
    cmn.GotoRoom('rm_menu'); 
    ObjDelete('tmr_intro_videoend'); 
  end; 
  ObjSet( "tmr_intro_videoend", 
  { 
    endtrig = funcVideoEnd, 
    time = 0.6, 
    playing = true
  } );
  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    MsgSend(Command_Level_CanShowLoading);
  end;

end;
--******************************************************************************************