-- name=rm_menu
--******************************************************************************************
function public.Init()

  private.room_objname="rm_menu";

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown
  });
  
  ObjSet("menu_but_extra", 
  {
    event_mdown = private.ExtraDown
  });
 
  ObjSet("menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  });

  ObjSet("spr_menu_man", 
  {
    event_mdown = private.clk_man
  });

    ObjSet("menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  });
    ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });

  -------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_menu = function ()

  local effects_table = 
  {
    "obj_menu_anim",
    "anm_menu_back_sky",         
    "anm_menu_add_lightning",
    "anm_menu_object",
    "anm_menu_pfx",
    "anm_menu_lightbulb"
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "snow" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_menu", update_performance_mode_menu, private.room_objname );
  --------------------------------------------------------------------------------------------

  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_gear", { event_mdown = private.GearClick });
  ObjSet("menu_but_forum", { event_mdown = private.ForumDown });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
    
    
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end });
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
   
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
  
end;
--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  private.ButMouseEnter("close_gear");
  port.TapDownTimer(0.5,
    function() 
    public.sub_menu_active = false;
    ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
    private.ButMouseLeave("close_gear");
    end
  );
end;
--******************************************************************************************
function public.openGearSubMenu()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  private.ButMouseEnter("gear");
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen()

  cmn.CallEventHandler( "update_performance_mode_menu" );    

  ObjSet( "menu_ce_buttons_left",  { active = false, visible = false, input = false } );
  ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition() ) then

    ObjSet( "menu_ce_buttons_left",  { active = true, visible = true, input = true } );
    ObjSet( "menu_ce_buttons_right", { active = true, visible = true, input = true } );
    ObjSet( "spr_menu_logo_ce",      { visible = true } );

  elseif ( IsSurveyEdition() ) then

    ObjSet( "menu_ce_buttons_left", { active = false, visible = false, input = false } );
    ObjSet( "menu_but_strguide", { active = false, visible = false, input = false } );

  else

    ObjSet( "menu_ce_buttons_left", { active = false, visible = false, input = false } );

  end;

  if GetPlatform()=="mac" then

    --ObjSet( "dialog_options_widescreen", { active = false, visible = false, input = false } );

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  common_impl.PlayAudio(  "mus", "common/audio/aud_maintheme_mus", 1 );

  private.AnimMenu();

  --common_impl.PlayAudio( "env", "common/audio/aud_menu_env", 1, "", 0 );
  common_impl.EnvPlay( { "common/audio/aud_menu_env" }, "", 0.5 );

  --=============================================================================
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();
  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
      
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if tostring(GetPlatform()) == "android" then  
      DbgTrace("SetPerformanceMode(1)");
      SetPerformanceMode(1);
    elseif tostring(GetPlatform()) == "ios" then
      ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
  --============================================================
  
end;
--******************************************************************************************
function private.PerformanceWarning()
  iOS_PerformanceWarning();
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function public.Open()

  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( IsCollectorsEdition() ) then

    if ( ng_global.progress[ "std" ].common.gamewin == true ) and
       ( ng_global.progress[ "std" ].common.gamestart == false ) and
         ( not ng_global.bonusunlock ) then

      common.DialogWindowShow( "common", "bonusunlock", false );
      ng_global.bonusunlock = true;

      SaveProfiles();

    elseif ( ng_global.progress[ "ext" ].common.gamewin == true ) and
       ( ng_global.progress[ "ext" ].common.gamestart == false ) and
         ( not ng_global.secretunlock ) then

      common.DialogWindowShow( "common", "secretunlock", false );
      ng_global.secretunlock = true;

      SaveProfiles();

    end;

  end;
  
end;
--***ios fix***************************************************************************************
function public.PreClose()
  ObjStopAnimate( "spr_menu_but_gear", "ang");
  ObjSet( "tmr_gear", { playing = 0 }); 
end;
--******************************************************************************************
function public.SetProfileText ( name )
  

--  local obj = "txt_menu_but_profile";
--  local profile_name = "";
--  if  ( name ~= "ng_noprofiles" )
--  and ( name ~= "ng_error" )
--  then
--  profile_name = name;
--  end;
--  ObjSet( obj, { text = profile_name } );
--
end;
--******************************************************************************************
function private.PlayDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
   private.ButMouseEnter("play");
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("play");
      common.MenuPlay();
      end
    ); 
end;
--******************************************************************************************
function private.OptionsDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuOptions();
end;
--******************************************************************************************
function private.QuitDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuQuit();  
end;
--******************************************************************************************
function private.ExtraDown()
  private.ButMouseEnter("extra");
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("extra");
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );end;
--******************************************************************************************
function private.AchDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuAchievements();
end;
--******************************************************************************************
function private.StrguideDown()

    if IsCollectorsEdition() then

      common_impl.ButtonGuide_Click();
      interface.StrategyGuideShow();

    else

      local guide_url = GetGuideUrl();
      OpenBrowser( guide_url );

    end;

end;
--******************************************************************************************
function private.ProfileDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuShop();
end;
--*****************************************************************************************
function private.MoreGamesDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  --common.MenuShop();
  --common.GotoRoom("rm_moregames");
  iOS_MoreGamesPressed();
end;
--*************************************ios*****************************************************
function private.Save50Down()
  common.button_click_sound();
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  common.button_click_sound();
  private.ButMouseEnter("unlock");
  port.TapDownTimer(0.5,
    function()
      common.MenuUnlock();
      private.ButMouseLeave("unlock");
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common.button_click_sound();
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  common.button_click_sound();
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name, type )

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );
  SetCursor( CURSOR_HAND );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name, type )

  SetCursor( CURSOR_DEFAULT );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.AnimMenu()

--  ObjAnimate( "spr_menu_light", "alp", 1, 0, "", 
--  { 
--    0.0, 0, 1, 
--    1.0, 0, 0.6,
--    2.0, 0, 1
--  } );
--
--  ObjAnimate( "spr_menu_branch7", "ang", 1, 0, "", 
--  { 
--    0.0, 3, 0.03, 
--    1.8, 3, -0.03,
--    3.6, 3, 0.03
--  } );
--
--  ObjAnimate( "spr_menu_branch2", "ang", 1, 0, "", 
--  { 
--    0.0, 3, 0.03, 
--    1.2, 3, -0.03,
--    2.4, 3, 0.03
--  } );
  
end;
--******************************************************************************************
function private.clk_man()

  local func_after = function()
    common_impl.Lock( false );
    ObjSet( "spr_menu_man", { input = false });
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio(  "sfx", "common/audio/aud_menu_click_owlman", 0 );

  ObjAnimate( "spr_menu_man", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.3, 0, 0.5,
    0.6, 0, 1,
    0.9, 0, 0
  } );

end;
--******************************************************************************************
function public.ButtonSetPos()

  local offwidth = 0.5 * ( GetAppWidth() - 1024 );

end;
--*****************************************************************************************
