-- name=rm_moregames
--******************************************************************************************
function public.Init()

  private.room_objname="rm_moregames";

  ObjAttach( "rm_moregames", "rooms_hub" );
  ObjAttach( "zz_mt1",       "room_hub" );
  ObjAttach( "zz_mt2",       "room_hub" );
  ObjAttach( "zz_mt3",       "room_hub" );
  ObjAttach( "zz_mt4",       "room_hub" );
  ObjAttach( "zz_mt5",       "room_hub" );
  ObjAttach( "zz_mt6",       "room_hub" );
  ObjAttach( "zz_mt7",       "room_hub" );
  ObjAttach( "zz_mt8",       "room_hub" );
  ObjAttach( "zz_mt9",       "room_hub" );
  
  local countOfScreens = 9

  local table_multiset = {};

  local visible = false;

  if IsCollectorsEdition() then

    visible = true;

  end;

  table.insert( table_multiset, 
                {
                  "obj_moregames_collectors_edition", 
                    { 
                      visible = visible;
                    }
                }
  );

  for i = 1,8 do

    table.insert( table_multiset, 
                  {
                    "spr_moregames_collectors_edition_zz"..i, 
                      { 
                        visible = visible;
                      }
                  }
    );

  end;

  for i = 1,countOfScreens do 
 
    table.insert( table_multiset, 
                  {
                    "btn_moregames_button_mt"..i, 
                      { 
                        event_mdown =  function () private.ChangeURL( i );          end,
                        event_menter = function () private.ButtonMouseEnter( "mt"..i ); end,
                        event_mleave = function () private.ButtonMouseLeave( "mt"..i ); end 
                      }
                } 
    );

    table.insert( table_multiset, 
                  {
                    "obj_moregames_game"..i, 
                      { 
                        event_mdown =  function () private.OpenZz( "zz_mt"..i ); end,
                        event_menter =  "*SetCursor( CURSOR_LOUPE )",
                        event_mleave =  "*SetCursor( CURSOR_DEFAULT )"; 
                      }
                }
    );

  end;

  table.insert( table_multiset, 
                {
                  "spr_moregames_button_main_menu", 
                    { 
                      event_mdown =  function () common.GotoRoom( "rm_menu" );            end,
                      event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
                      event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end 
                    }
                }
  );
  
  ObjMultiSet( table_multiset );

  ----------------------------------------------------------------------------------------
  private.Link = 
  {
    -- games_1 
    {
      mac_ce = "http://www.bigfishgames.com/download-games/10255/mac/mystery-trackers-the-void-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/10527/mac/mystery-trackers-the-void/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/9427/mystery-trackers-the-void-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/9854/mystery-trackers-the-void/index.html"
    },
    -- games_2 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/13009/mac/mystery-trackers-raincliff-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/13302/mac/mystery-trackers-raincliff/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/12259/mystery-trackers-raincliff-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/12779/mystery-trackers-raincliff/index.html"
    },
    -- games_3 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/16775/mac/mystery-trackers-the-black-isle-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/17191/mac/mystery-trackers-black-isle/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/16264/mystery-trackers-the-black-isle-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/16912/mystery-trackers-black-isle/index.html"
    },
    -- games_4 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/19545/mac/mystery-trackers-four-aces-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/20052/mac/mystery-trackers-four-aces/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/19280/mystery-trackers-four-aces-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/20050/mystery-trackers-four-aces/index.html"
    },
    -- games_5
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/23725/mac/mystery-trackers-silent-hollow-ce/index.htmll",
      mac_se = "http://www.bigfishgames.com/download-games/24447/mac/mystery-trackers-silent-hollow/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/23726/mystery-trackers-silent-hollow-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/23917/mystery-trackers-silent-hollow/index.html"
    },
    -- games_6
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/26044/mac/mystery-trackers-raincliff-phantoms-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/26371/mac/mystery-trackers-raincliff-phantoms/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/26043/mystery-trackers-raincliff-phantoms-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/26374/mystery-trackers-raincliff-phantoms/index.html"
    },
    -- games_7 (действительные ссылки)
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/27560/mac/mystery-trackers-blackrows-secret-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/27885/mac/mystery-trackers-blackrows-secret/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/27561/mystery-trackers-blackrows-secret-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/27886/mystery-trackers-blackrows-secret/index.html"
    },

    -- games_8 (действительные ссылки)

    { 
      mac_ce = "http://www.bigfishgames.com/games/8535/mystery-trackers-nightsville-horror-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8919/mystery-trackers-nightsville-horror/?mac",
      win_ce = "http://www.bigfishgames.com/games/8535/mystery-trackers-nightsville-horror-ce/?pc",
      win_se = "http://www.bigfishgames.com/games/8919/mystery-trackers-nightsville-horror/?pc"
    },
    
    -- games_9 (действительные ссылки)

    { 
      mac_ce = "http://www.bigfishgames.com/games/11241/mystery-trackers-winterpoint-tragedy-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8954/mystery-trackers-winterpoint-tragedy/?mac",
      win_ce = "http://www.bigfishgames.com/games/11241/mystery-trackers-winterpoint-tragedy-ce/?pc",
      win_se = "http://www.bigfishgames.com/games/8954/mystery-trackers-winterpoint-tragedy/?pc"
    }
  }

  -------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_moregames = function ()

  local effects_table = 
  {
    "anm_moregames_snow"                     , 
    "spr_moregames_wires_over"                     , 
    "spr_moregames_light"                     ,           
  }

  local active = true;
  local visible = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
    visible = false;
  end;

  for i = 1, #effects_table do

    ObjSet( effects_table[ i ], { active = active } )
    if string.find( effects_table[ i ], "snow" ) then

      ObjSet( effects_table[ i ], { visible = visible } )

    end;

  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_moregames", update_performance_mode_moregames, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--******************************************************************************************
function public.PreOpen()
  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
  --common_impl.PlayAudio( "env", "common/audio/aud_more_games_env", 1, "", 0 );
  common_impl.EnvPlay( { "common/audio/aud_more_games_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Open()
  
end;
--******************************************************************************************
function public.Close()
  
  common_impl.StopAudio( "env", "common/audio/aud_more_games_env", 0.5 );
  
end;
--******************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_mt1" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt2" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt3" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt4" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt5" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt6" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;
  --------------------------------
  subroom.Define( "zz_mt7" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;

  --------------------------------
  subroom.Define( "zz_mt8" );

  function zz_hut.Open()
  end;
  
  function zz_hut.PreOpen()
  end;
  
  function zz_hut.PreClose()
  end;
  
  function zz_hut.Close()
  end;

end;
--******************************************************************************************
function private.ChangeURL( but_name )
  
  local link = "";
  local mas_name = "Link";
  --local platform = GetPlatform();
-- -- local name = ne_params.sender;
-- -- local num_games = tonumber(  string.sub( name, string.len( name ) ,string.len( name ) ) );
-- 
  local num_games = tonumber(  string.sub( but_name, string.len( but_name ) ,string.len( but_name ) ) );
--
  if IsCollectorsEdition() then

--    if platform == "mac" then
    if GetPlatform()=="mac" then

      link = private[mas_name][ num_games ][ "mac_ce" ];

    else
     
      link = private[mas_name][ num_games ][ "win_ce" ];
  
    end;
--
  else
--
    --if platform == "mac" then
    if GetPlatform()=="mac" then
     
      link = private[mas_name][ num_games ][ "mac_se" ];      

    else
      
      link = private[mas_name][ num_games ][ "win_se" ];      
    
    end;

  end;
  

  OpenBrowser( link );

end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );


end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
function private.OpenZz ( zz_name )

  --SetCursor( CURSOR_DEFAULT );
  ObjSet( "subroom_input", { event_menter = "*SetCursor( CURSOR_DOWN )", event_mleave = "*SetCursor( CURSOR_DEFAULT )", active = 1, event_mdown = function () private.CloseZz( zz_name ); end;  } )

  cmn.GotoSubRoom( zz_name, nil, { 512, 384 } );

end;
function private.CloseZz ( zz_name )

  ObjSet( "subroom_input", { event_mdown = ""  } )

  common.CloseSubRoom( zz_name );

end;
--******************************************************************************************
  
  ObjAnimate( "spr_moregames_light", "alp", 1, 0, "", 
  { 0.0, 0, 0.5,
    1.5, 0, 1,
    2.3, 0, 0.4,
    3.0, 0, 0.7,
    3.6, 0, 0.5  
  } );

  ObjAnimate( "spr_moregames_wires_over", "pos_xy", 1, 0, "", 
  { 
    0.0,  3, 126, 238,
    4.0,  3, 136, 244,
    8.0,  3, 156, 237,
    12.0, 3, 136, 244,
    16.0, 3, 126, 238
  } );
