-- name=int_pause
--******************************************************************************************
function public.Init( pos_z )

  private.event_anim_end = {};

  interface.LoadImplementation( "pause" );
  ObjAttach( "int_pause", interface.originhub );
  ObjSet( "int_pause", { pos_z = pos_z } );

  MsgSubscribe( Command_Pause_Show, private.Show );
  MsgSubscribe( Command_Pause_Hide, private.Hide );

  --port. fix for android
  if tostring(GetPlatform()) == "android" then
    private.pause_active = false;
    MsgSubscribe( Event_Application_Paused, private.Show );
    MsgSubscribe( Command_Pause, private.Pause );
    ObjSet("obj_int_pause_pause",{ event_mdown = private.Hide });
  end;
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Pause_Show, private.Show );
  MsgUnsubscribe( Command_Pause_Hide, private.Hide );

  --port. fix for android
  if tostring(GetPlatform()) == "android" then
    MsgUnsubscribe( Event_Application_Paused, private.Show );
    MsgUnsubscribe( Command_Pause, private.Pause );
  end;
end;
--******************************************************************************************
function public.EventAnimEnd( event_id )

  local event_params = private.event_anim_end[ event_id ];
------------------------------------------------------------------------------------
  if ( event_id == "show" ) then

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  end;
------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Show()

  if IsEditor() then return; end;

  local event_id = "pause_show";
  private.event_anim_end[ event_id ] = {};
  int_pause_impl.ShowAnim( event_id );

  --port. fix android
  private.pause_active = true;
  
end;
--******************************************************************************************
function private.Hide()

  if IsEditor() then return; end;

  local event_id = "pause_hide";
  private.event_anim_end[ event_id ] = {};
  int_pause_impl.HideAnim( event_id );

  --port. fix for android
  if tostring(GetPlatform()) == "android" then
    PauseLevel(0);
    SndPauseAll( false );
    if int_dialog_video.GetDialogVideoActive() ~= nil then
      VidPause(int_dialog_video.GetDialogVideoActive(),0);
    end;
    ObjAttach("int_pause","ng_interface_internal");
    ObjSet("int_pause",{ scale_x = 1, scale_y = 1 });
    if (ObjGet("int_lock")) then
      --DbgTrace("input:"..tostring(ObjGet("obj_int_lock_timer").input));
      if (ObjGet("int_lock").input == false) then
        ObjSet("int_lock",{ input = true });
      end;
    end;
  end;
  
end;
--******************************************************************************************
---port. fix for android
function private.Pause(msg, params)
 
  DbgTrace("int_pause -> private.Pause msg:"..tostring(msg).." params.pause:"..tostring(params.pause).." private.pause_active:"..tostring(private.pause_active));
  if (params.pause == 0 and private.pause_active == true) then
    ObjSet("obj_int_pause_pause",{ input = true });
    PauseLevel(1);
    SndPauseAll( true );
    if int_dialog_video.GetDialogVideoActive() ~= nil then
      VidPause(int_dialog_video.GetDialogVideoActive(),1);
    end;
  DbgTrace("parent:"..tostring(ObjGetRelations("int_loading").parent));
  DbgTrace("scale_x:"..tostring(ObjGet("ng_interface_internal").scale_x));
    if ObjGetRelations("int_loading").parent == "ng_level" then
      ObjSet("int_loading",{ input = false });
      ObjAttach("int_pause","ng_level");
      local param = ObjGet("ng_interface_internal");
      ObjSet("int_pause",{ scale_x = param.scale_x, scale_y = param.scale_y });
      ObjSet("int_pause",{ pos_z = 9998 });
    end;
    if (ObjGet("obj_int_lock")) then
      --DbgTrace("input:"..tostring(ObjGet("obj_int_lock").input));
      if (ObjGet("obj_int_lock").input == true) then
        ObjSet("int_lock",{ input = false });
      end;
    end; 
    if (ObjGet("obj_int_lock_timer")) then
      --DbgTrace("input:"..tostring(ObjGet("obj_int_lock_timer").input));
      if (ObjGet("obj_int_lock_timer").input == true) then
        ObjSet("int_lock",{ input = false });
      end;
    end;
    
    private.pause_active = false;
  end;
end;
--******************************************************************************************